#ifndef BI_BIRCH_STANDARD_HPP
#define BI_BIRCH_STANDARD_HPP

#include "libbirch.hpp"


namespace birch {
  namespace type {
using Boolean = bool;
using Real64 = double;
using Real32 = float;
using Integer64 = std::int64_t;
using Integer32 = std::int32_t;
using Integer16 = std::int16_t;
using Integer8 = std::int8_t;
using String = std::string;
using File = FILE*;
using LLT = Eigen::LLT<libbirch::EigenMatrix<Real64>>;
  }
}

#include <yaml.h>

#include <yaml.h>

namespace birch {
namespace type {
class Object;
template<class Type>
class Array;
template<class Type>
class List;
template<class Type>
class ListNode;
template<class Type>
class RaggedArray;
template<class Type>
class Stack;
template<class Type>
class StackNode;
template<class Type>
class Tape;
template<class Type>
class TapeNode;
class ArrayValue;
class BooleanValue;
class BooleanVectorValue;
class Buffer;
class Entry;
class IntegerValue;
class IntegerVectorValue;
class NilValue;
class ObjectValue;
class RealValue;
class RealVectorValue;
class StringValue;
class Value;
class AddBoundedDiscrete;
class Bernoulli;
class Beta;
class BetaBernoulli;
class BetaBinomial;
class BetaNegativeBinomial;
class Binomial;
class BoundedDiscrete;
class Categorical;
class DelayDistribution;
class Delta;
class Dirichlet;
class DirichletCategorical;
class DirichletMultinomial;
class Discrete;
class DiscreteDelta;
template<class Value>
class Distribution;
class Exponential;
class Gamma;
class GammaExponential;
class GammaPoisson;
class Gaussian;
class GaussianGaussian;
class IdenticalGaussian;
class IndependentRowMatrixGaussian;
class IndependentUniform;
class IndependentUniformInteger;
class InverseGamma;
class InverseGammaGamma;
class InverseWishart;
class LinearBoundedDiscrete;
class LinearDiscrete;
class LinearGaussianGaussian;
class LinearMatrixNormalInverseWishartMatrixGaussian;
class LinearMatrixNormalInverseWishartMultivariateGaussian;
class LinearMultivariateGaussianGaussian;
class LinearMultivariateGaussianMultivariateGaussian;
class LinearMultivariateNormalInverseGammaGaussian;
class LinearMultivariateNormalInverseGammaMultivariateGaussian;
class LinearNormalInverseGammaGaussian;
class MatrixGaussian;
class MatrixNormalInverseWishart;
class MatrixNormalInverseWishartMatrixGaussian;
class Multinomial;
class MultivariateGaussian;
class MultivariateGaussianMultivariateGaussian;
class MultivariateNormalInverseGamma;
class MultivariateNormalInverseGammaMultivariateGaussian;
class NegativeBinomial;
class NormalInverseGamma;
class NormalInverseGammaGaussian;
class Poisson;
class Restaurant;
class RestaurantCategorical;
class ScalarGaussian;
class ScalarMultivariateGaussian;
class ScaledGammaExponential;
class ScaledGammaPoisson;
class Student;
class SubtractBoundedDiscrete;
class Uniform;
class UniformInteger;
class Weibull;
class Wishart;
template<class Value>
class AssumeEvent;
class Event;
class FactorEvent;
template<class Value>
class ObserveEvent;
template<class Value>
class SimulateEvent;
class Abs;
class Acos;
class Add;
class Asin;
class Atan;
template<class Value>
class Boxed;
template<class From,class To>
class Cast;
class CopySign;
class Cos;
class Cosh;
class DelayExpression;
class Diagonal;
class DiscreteAdd;
template<class From,class To>
class DiscreteCast;
class DiscreteMultiply;
class DiscreteNegate;
class DiscreteSubtract;
class Divide;
class Dot;
class Exp;
template<class Value>
class Expression;
class IfThenElse;
class LessThan;
class Log;
class Log1p;
class LogBeta;
class LogChoose;
template<class Argument,class ArgumentValue>
class LogDet;
class LogGamma;
class LogGammaP;
class MatrixAbs;
class MatrixAdd;
template<class Left,class Right,class LeftValue,class RightValue,class LeftGradient,class RightGradient,class Value>
class MatrixBinaryExpression;
template<class Argument,class ArgumentValue>
class MatrixCanonical;
class MatrixDiagonal;
template<class Value>
class MatrixElement;
template<class Value>
class MatrixExpression;
template<class Argument,class ArgumentValue,class Value>
class MatrixInv;
template<class Value>
class MatrixJoin;
class MatrixLLT;
class MatrixMultiply;
class MatrixNegate;
class MatrixPack;
template<class Right,class RightValue,class RightGradient>
class MatrixRankDowndate;
template<class Right,class RightValue,class RightGradient>
class MatrixRankUpdate;
class MatrixRectify;
class MatrixScalarMultiply;
template<class Left,class LeftValue>
class MatrixSolve;
class MatrixStack;
class MatrixSubtract;
class MatrixTranspose;
template<class Argument,class ArgumentValue,class ArgumentGradient,class Value>
class MatrixUnaryExpression;
class Multiply;
class MultivariateAbs;
class MultivariateAdd;
template<class Left,class Right,class LeftValue,class RightValue,class LeftGradient,class RightGradient,class Value>
class MultivariateBinaryExpression;
class MultivariateCanonical;
class MultivariateDiagonal;
class MultivariateDot;
template<class Value>
class MultivariateElement;
template<class Value>
class MultivariateExpression;
template<class Value>
class MultivariateJoin;
class MultivariateMultiply;
class MultivariateNegate;
class MultivariateRectify;
class MultivariateScalarMultiply;
template<class Left,class LeftValue>
class MultivariateSolve;
class MultivariateStack;
class MultivariateSubtract;
class MultivariateTranspose;
template<class Argument,class ArgumentValue,class ArgumentGradient,class Value>
class MultivariateUnaryExpression;
class Negate;
class Outer;
class Pow;
template<class Value>
class Random;
class Rectify;
template<class Left,class Right,class LeftValue,class RightValue,class LeftGradient,class RightGradient,class Value>
class ScalarBinaryExpression;
template<class Value>
class ScalarExpression;
template<class Value>
class ScalarMatrix;
template<class Value>
class ScalarMultivariate;
template<class Argument,class ArgumentValue,class ArgumentGradient,class Value>
class ScalarUnaryExpression;
class Sin;
class Sinh;
class Sqrt;
class Subtract;
class Tan;
class Tanh;
template<class Argument,class ArgumentValue>
class Trace;
class AliveParticleFilter;
class ConditionalParticleFilter;
class MoveParticleFilter;
class ParticleFilter;
class Handler;
class MoveHandler;
class PlayHandler;
class InputStream;
class JSONWriter;
class OutputStream;
class Reader;
class Writer;
class YAMLReader;
class YAMLWriter;
template<class Type>
class ArrayIterator;
template<class Type>
class EmptyIterator;
template<class Type>
class Iterator;
template<class Type>
class ListIterator;
template<class Type>
class RaggedArrayElementIterator;
template<class Type>
class RaggedArrayRowIterator;
template<class Type>
class StackIterator;
template<class Type>
class TapeIterator;
class Kernel;
class LangevinKernel;
template<class Parameter,class State,class Observation>
class HiddenMarkovModel;
template<class Parameter,class State>
class MarkovModel;
class Model;
class ConditionalParticle;
class MoveParticle;
class Particle;
template<class Value>
class AssumeRecord;
class FactorRecord;
template<class Value>
class ObserveRecord;
class Record;
template<class Value>
class SimulateRecord;
class ConditionalParticleSampler;
class MarginalizedParticleGibbsSampler;
class MarginalizedParticleImportanceSampler;
class ParticleGibbsSampler;
class ParticleSampler;
template<class Value>
class TransformDot;
template<class Value>
class TransformDotMultivariate;
template<class Value>
class TransformLinear;
template<class Value>
class TransformLinearMatrix;
template<class Value>
class TransformLinearMultivariate;
class ProgressBar;
class DeepCloneNode;
class TestAddBoundedDiscreteDelta;
class TestBetaBernoulli;
class TestBetaBinomial;
class TestBetaGeometric;
class TestBetaNegativeBinomial;
class TestChainGaussian;
class TestChainMultivariateGaussian;
class TestDirichletCategorical;
class TestDirichletMultinomial;
class TestGammaExponential;
class TestGammaPoisson;
class TestGaussianGaussian;
class TestInverseGammaGamma;
class TestLinearDiscreteDelta;
class TestLinearGaussianGaussian;
class TestLinearMatrixNormalInverseWishartMatrixGaussian;
class TestLinearMatrixNormalInverseWishartMultivariateGaussian;
class TestLinearMultivariateGaussianGaussian;
class TestLinearMultivariateGaussianMultivariateGaussian;
class TestLinearMultivariateNormalInverseGammaGaussian;
class TestLinearMultivariateNormalInverseGammaMultivariateGaussian;
class TestLinearNormalInverseGammaGaussian;
class TestMatrixNormalInverseWishartMatrixGaussian;
class TestMultivariateGaussianMultivariateGaussian;
class TestMultivariateNormalInverseGammaMultivariateGaussian;
class TestNormalInverseGamma;
class TestNormalInverseGammaGaussian;
class TestScaledGammaExponential;
class TestScaledGammaPoisson;
class TestSubtractBoundedDiscreteDelta;

using Integer = Integer64;
using Real = Real64;

using JSONReader = YAMLReader;
template<class Parameter,class State,class Observation>
using StateSpaceModel = HiddenMarkovModel<Parameter, State, Observation>;
#line 4 "src/basic/Object.birch"
class Object : public libbirch::Any {
public:
  #line 4 "src/basic/Object.birch"
  using class_type_ = Object;
  #line 4 "src/basic/Object.birch"
  using this_type_ = class_type_;
  #line 4 "src/basic/Object.birch"
  using super_type_ = libbirch::Any;

  #line 4 "src/basic/Object.birch"
  using super_type_::operator=;
  
  #line 4 "src/basic/Object.birch"
  Object(const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);

  #line 8 "src/basic/Object.birch"
  virtual void read(const libbirch::Lazy<libbirch::Shared<birch::type::Buffer>>& buffer, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
  #line 15 "src/basic/Object.birch"
  virtual void write(const libbirch::Lazy<libbirch::Shared<birch::type::Buffer>>& buffer, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
  
  #line 4 "src/basic/Object.birch"
  LIBBIRCH_ABSTRACT_CLASS(Object, libbirch::Any)
  #line 4 "src/basic/Object.birch"
  LIBBIRCH_MEMBERS()
};

template<class Type>
#line 6 "src/container/Array.birch"
class Array final : public Object {
public:
  #line 6 "src/container/Array.birch"
  using class_type_ = Array<Type>;
  #line 6 "src/container/Array.birch"
  using this_type_ = class_type_;
  #line 6 "src/container/Array.birch"
  using super_type_ = Object;

  #line 6 "src/container/Array.birch"
  using super_type_::operator=;
  
  #line 6 "src/container/Array.birch"
  Array(const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);

  libbirch::DefaultArray<Type,1> values;
  #line 15 "src/container/Array.birch"
  virtual birch::type::Integer size(const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
  #line 22 "src/container/Array.birch"
  virtual birch::type::Boolean empty(const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
  #line 29 "src/container/Array.birch"
  virtual void clear(const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
  #line 39 "src/container/Array.birch"
  virtual Type get(const birch::type::Integer& i, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
  #line 49 "src/container/Array.birch"
  virtual void set(const birch::type::Integer& i, const Type& x, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
  #line 56 "src/container/Array.birch"
  virtual Type front(const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
  #line 64 "src/container/Array.birch"
  virtual Type back(const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
  #line 74 "src/container/Array.birch"
  virtual void pushFront(const Type& x, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
  #line 81 "src/container/Array.birch"
  virtual Type pushFront(const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
  #line 96 "src/container/Array.birch"
  virtual void pushBack(const Type& x, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
  #line 103 "src/container/Array.birch"
  virtual Type pushBack(const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
  #line 116 "src/container/Array.birch"
  virtual void popFront(const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
  #line 123 "src/container/Array.birch"
  virtual void popBack(const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
  #line 137 "src/container/Array.birch"
  virtual void insert(const birch::type::Integer& i, const Type& x, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
  #line 151 "src/container/Array.birch"
  virtual void erase(const birch::type::Integer& i, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
  #line 166 "src/container/Array.birch"
  virtual void erase(const birch::type::Integer& i, const birch::type::Integer& n, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
  #line 179 "src/container/Array.birch"
  virtual libbirch::Lazy<libbirch::Shared<birch::type::Iterator<Type>>> walk(const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
  #line 186 "src/container/Array.birch"
  virtual libbirch::DefaultArray<Type,1> toArray(const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
  #line 193 "src/container/Array.birch"
  virtual void fromArray(const libbirch::DefaultArray<Type,1>& x, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
  #line 197 "src/container/Array.birch"
  virtual void read(const libbirch::Lazy<libbirch::Shared<birch::type::Buffer>>& buffer, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
  #line 210 "src/container/Array.birch"
  virtual void write(const libbirch::Lazy<libbirch::Shared<birch::type::Buffer>>& buffer, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
  
  #line 6 "src/container/Array.birch"
  LIBBIRCH_CLASS(Array, Object)
  #line 6 "src/container/Array.birch"
  LIBBIRCH_MEMBERS(values)
};

template<class Type>
#line 30 "src/container/List.birch"
class List final : public Object {
public:
  #line 30 "src/container/List.birch"
  using class_type_ = List<Type>;
  #line 30 "src/container/List.birch"
  using this_type_ = class_type_;
  #line 30 "src/container/List.birch"
  using super_type_ = Object;

  #line 30 "src/container/List.birch"
  using super_type_::operator=;
  
  #line 30 "src/container/List.birch"
  List(const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);

  libbirch::Optional<libbirch::Lazy<libbirch::Shared<birch::type::ListNode<Type>>>> head;
  libbirch::Optional<libbirch::Lazy<libbirch::Shared<birch::type::ListNode<Type>>>> tail;
  birch::type::Integer count;
  #line 38 "src/container/List.birch"
  virtual birch::type::Integer size(const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
  #line 45 "src/container/List.birch"
  virtual birch::type::Boolean empty(const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
  #line 52 "src/container/List.birch"
  virtual void clear(const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
  #line 61 "src/container/List.birch"
  virtual Type front(const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
  #line 69 "src/container/List.birch"
  virtual Type back(const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
  #line 80 "src/container/List.birch"
  virtual Type get(const birch::type::Integer& i, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
  #line 90 "src/container/List.birch"
  virtual void set(const birch::type::Integer& i, const Type& x, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
  #line 99 "src/container/List.birch"
  virtual void pushFront(const Type& x, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
  #line 117 "src/container/List.birch"
  virtual Type pushFront(const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
  #line 132 "src/container/List.birch"
  virtual void pushBack(const Type& x, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
  #line 151 "src/container/List.birch"
  virtual Type pushBack(const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
  #line 164 "src/container/List.birch"
  virtual void popFront(const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
  #line 180 "src/container/List.birch"
  virtual void popBack(const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
  #line 203 "src/container/List.birch"
  virtual void insert(const birch::type::Integer& i, const Type& x, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
  #line 224 "src/container/List.birch"
  virtual void erase(const birch::type::Integer& i, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
  #line 245 "src/container/List.birch"
  virtual libbirch::Lazy<libbirch::Shared<birch::type::Iterator<Type>>> walk(const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
  #line 254 "src/container/List.birch"
  virtual libbirch::Lazy<libbirch::Shared<birch::type::ListNode<Type>>> getNode(const birch::type::Integer& i, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
  #line 278 "src/container/List.birch"
  virtual void read(const libbirch::Lazy<libbirch::Shared<birch::type::Buffer>>& buffer, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
  #line 291 "src/container/List.birch"
  virtual void write(const libbirch::Lazy<libbirch::Shared<birch::type::Buffer>>& buffer, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
  
  #line 30 "src/container/List.birch"
  LIBBIRCH_CLASS(List, Object)
  #line 30 "src/container/List.birch"
  LIBBIRCH_MEMBERS(head, tail, count)
};

template<class Type>
#line 4 "src/container/ListNode.birch"
class ListNode final : public Object {
public:
  #line 4 "src/container/ListNode.birch"
  using class_type_ = ListNode<Type>;
  #line 4 "src/container/ListNode.birch"
  using this_type_ = class_type_;
  #line 4 "src/container/ListNode.birch"
  using super_type_ = Object;

  #line 4 "src/container/ListNode.birch"
  using super_type_::operator=;
  
  #line 4 "src/container/ListNode.birch"
  ListNode(const Type& x, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);

  libbirch::Optional<libbirch::Lazy<libbirch::Shared<birch::type::ListNode<Type>>>> prev;
  libbirch::Optional<libbirch::Lazy<libbirch::Shared<birch::type::ListNode<Type>>>> next;
  Type x;
  #line 14 "src/container/ListNode.birch"
  virtual void insert(const libbirch::Lazy<libbirch::Shared<birch::type::ListNode<Type>>>& node, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
  #line 25 "src/container/ListNode.birch"
  virtual void erase(const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
  #line 39 "src/container/ListNode.birch"
  virtual libbirch::Optional<libbirch::Lazy<libbirch::Shared<birch::type::ListNode<Type>>>> popFront(const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
  #line 54 "src/container/ListNode.birch"
  virtual libbirch::Optional<libbirch::Lazy<libbirch::Shared<birch::type::ListNode<Type>>>> popBack(const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
  
  #line 4 "src/container/ListNode.birch"
  LIBBIRCH_CLASS(ListNode, Object)
  #line 4 "src/container/ListNode.birch"
  LIBBIRCH_MEMBERS(prev, next, x)
};

template<class Type>
#line 7 "src/container/RaggedArray.birch"
class RaggedArray final : public Object {
public:
  #line 7 "src/container/RaggedArray.birch"
  using class_type_ = RaggedArray<Type>;
  #line 7 "src/container/RaggedArray.birch"
  using this_type_ = class_type_;
  #line 7 "src/container/RaggedArray.birch"
  using super_type_ = Object;

  #line 7 "src/container/RaggedArray.birch"
  using super_type_::operator=;
  
  #line 7 "src/container/RaggedArray.birch"
  RaggedArray(const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);

  libbirch::DefaultArray<Type,1> values;
  libbirch::DefaultArray<birch::type::Integer,1> offsets;
  libbirch::DefaultArray<birch::type::Integer,1> sizes;
  #line 28 "src/container/RaggedArray.birch"
  virtual birch::type::Boolean empty(const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
  #line 35 "src/container/RaggedArray.birch"
  virtual void clear(const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
  #line 48 "src/container/RaggedArray.birch"
  virtual birch::type::Integer count(const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
  #line 55 "src/container/RaggedArray.birch"
  virtual birch::type::Integer size(const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
  #line 64 "src/container/RaggedArray.birch"
  virtual birch::type::Integer size(const birch::type::Integer& i, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
  #line 74 "src/container/RaggedArray.birch"
  virtual Type get(const birch::type::Integer& i, const birch::type::Integer& j, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
  #line 83 "src/container/RaggedArray.birch"
  virtual libbirch::DefaultArray<Type,1> get(const birch::type::Integer& i, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
  #line 94 "src/container/RaggedArray.birch"
  virtual void set(const birch::type::Integer& i, const birch::type::Integer& j, const Type& x, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
  #line 107 "src/container/RaggedArray.birch"
  virtual void set(const birch::type::Integer& i, const libbirch::DefaultArray<Type,1>& x, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
  #line 114 "src/container/RaggedArray.birch"
  virtual void popFront(const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
  #line 140 "src/container/RaggedArray.birch"
  virtual void popFront(const birch::type::Integer& i, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
  #line 155 "src/container/RaggedArray.birch"
  virtual void pushBack(const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
  #line 170 "src/container/RaggedArray.birch"
  virtual void pushBack(const birch::type::Integer& i, const Type& x, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
  #line 185 "src/container/RaggedArray.birch"
  virtual Type pushBack(const birch::type::Integer& i, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
  #line 200 "src/container/RaggedArray.birch"
  virtual libbirch::Lazy<libbirch::Shared<birch::type::Iterator<libbirch::DefaultArray<Type,1>>>> walk(const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
  #line 212 "src/container/RaggedArray.birch"
  virtual libbirch::Lazy<libbirch::Shared<birch::type::Iterator<Type>>> walk(const birch::type::Integer& i, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
  #line 221 "src/container/RaggedArray.birch"
  virtual birch::type::Integer from(const birch::type::Integer& i, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
  #line 232 "src/container/RaggedArray.birch"
  virtual birch::type::Integer to(const birch::type::Integer& i, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
  #line 244 "src/container/RaggedArray.birch"
  virtual birch::type::Integer serial(const birch::type::Integer& i, const birch::type::Integer& j, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
  #line 250 "src/container/RaggedArray.birch"
  virtual void read(const libbirch::Lazy<libbirch::Shared<birch::type::Buffer>>& buffer, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
  #line 267 "src/container/RaggedArray.birch"
  virtual void write(const libbirch::Lazy<libbirch::Shared<birch::type::Buffer>>& buffer, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
  
  #line 7 "src/container/RaggedArray.birch"
  LIBBIRCH_CLASS(RaggedArray, Object)
  #line 7 "src/container/RaggedArray.birch"
  LIBBIRCH_MEMBERS(values, offsets, sizes)
};

template<class Type>
#line 28 "src/container/Stack.birch"
class Stack final : public Object {
public:
  #line 28 "src/container/Stack.birch"
  using class_type_ = Stack<Type>;
  #line 28 "src/container/Stack.birch"
  using this_type_ = class_type_;
  #line 28 "src/container/Stack.birch"
  using super_type_ = Object;

  #line 28 "src/container/Stack.birch"
  using super_type_::operator=;
  
  #line 28 "src/container/Stack.birch"
  Stack(const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);

  libbirch::Optional<libbirch::Lazy<libbirch::Shared<birch::type::StackNode<Type>>>> head;
  birch::type::Integer count;
  #line 35 "src/container/Stack.birch"
  virtual birch::type::Integer size(const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
  #line 42 "src/container/Stack.birch"
  virtual birch::type::Boolean empty(const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
  #line 49 "src/container/Stack.birch"
  virtual void clear(const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
  #line 57 "src/container/Stack.birch"
  virtual Type top(const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
  #line 67 "src/container/Stack.birch"
  virtual void push(const Type& x, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
  #line 77 "src/container/Stack.birch"
  virtual void push(const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
  #line 90 "src/container/Stack.birch"
  virtual void pop(const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
  #line 101 "src/container/Stack.birch"
  virtual libbirch::Lazy<libbirch::Shared<birch::type::Iterator<Type>>> walk(const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
  
  #line 28 "src/container/Stack.birch"
  LIBBIRCH_CLASS(Stack, Object)
  #line 28 "src/container/Stack.birch"
  LIBBIRCH_MEMBERS(head, count)
};

template<class Type>
#line 4 "src/container/StackNode.birch"
class StackNode final : public Object {
public:
  #line 4 "src/container/StackNode.birch"
  using class_type_ = StackNode<Type>;
  #line 4 "src/container/StackNode.birch"
  using this_type_ = class_type_;
  #line 4 "src/container/StackNode.birch"
  using super_type_ = Object;

  #line 4 "src/container/StackNode.birch"
  using super_type_::operator=;
  
  #line 4 "src/container/StackNode.birch"
  StackNode(const Type& x, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);

  libbirch::Optional<libbirch::Lazy<libbirch::Shared<birch::type::StackNode<Type>>>> next;
  Type x;
  
  #line 4 "src/container/StackNode.birch"
  LIBBIRCH_CLASS(StackNode, Object)
  #line 4 "src/container/StackNode.birch"
  LIBBIRCH_MEMBERS(next, x)
};

template<class Type>
#line 46 "src/container/Tape.birch"
class Tape final : public Object {
public:
  #line 46 "src/container/Tape.birch"
  using class_type_ = Tape<Type>;
  #line 46 "src/container/Tape.birch"
  using this_type_ = class_type_;
  #line 46 "src/container/Tape.birch"
  using super_type_ = Object;

  #line 46 "src/container/Tape.birch"
  using super_type_::operator=;
  
  #line 46 "src/container/Tape.birch"
  Tape(const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);

  libbirch::Optional<libbirch::Lazy<libbirch::Shared<birch::type::TapeNode<Type>>>> ahead;
  birch::type::Integer aheadCount;
  libbirch::Optional<libbirch::Lazy<libbirch::Shared<birch::type::TapeNode<Type>>>> behind;
  birch::type::Integer behindCount;
  #line 70 "src/container/Tape.birch"
  virtual birch::type::Integer size(const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
  #line 77 "src/container/Tape.birch"
  virtual birch::type::Boolean empty(const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
  #line 84 "src/container/Tape.birch"
  virtual void clear(const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
  #line 94 "src/container/Tape.birch"
  virtual Type front(const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
  #line 106 "src/container/Tape.birch"
  virtual Type back(const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
  #line 125 "src/container/Tape.birch"
  virtual void forward(const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
  #line 148 "src/container/Tape.birch"
  virtual void backward(const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
  #line 164 "src/container/Tape.birch"
  virtual void rewind(const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
  #line 173 "src/container/Tape.birch"
  virtual void fastForward(const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
  #line 188 "src/container/Tape.birch"
  virtual void seek(const birch::type::Integer& k, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
  #line 210 "src/container/Tape.birch"
  virtual Type current(const birch::type::Integer& k, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
  #line 229 "src/container/Tape.birch"
  virtual Type current(const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
  #line 240 "src/container/Tape.birch"
  virtual Type previous(const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
  #line 251 "src/container/Tape.birch"
  virtual Type next(const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
  #line 260 "src/container/Tape.birch"
  virtual void pushFront(const Type& x, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
  #line 272 "src/container/Tape.birch"
  virtual void pushFront(const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
  #line 286 "src/container/Tape.birch"
  virtual void pushBack(const Type& x, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
  #line 298 "src/container/Tape.birch"
  virtual void pushBack(const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
  #line 312 "src/container/Tape.birch"
  virtual void popFront(const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
  #line 331 "src/container/Tape.birch"
  virtual void popBack(const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
  #line 351 "src/container/Tape.birch"
  virtual void insert(const Type& x, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
  #line 362 "src/container/Tape.birch"
  virtual void insert(const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
  #line 375 "src/container/Tape.birch"
  virtual void insertBefore(const Type& x, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
  #line 386 "src/container/Tape.birch"
  virtual void insertBefore(const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
  #line 397 "src/container/Tape.birch"
  virtual void erase(const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
  #line 405 "src/container/Tape.birch"
  virtual void eraseBefore(const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
  #line 414 "src/container/Tape.birch"
  virtual libbirch::Lazy<libbirch::Shared<birch::type::Iterator<Type>>> walk(const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
  #line 419 "src/container/Tape.birch"
  virtual void read(const libbirch::Lazy<libbirch::Shared<birch::type::Buffer>>& buffer, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
  #line 434 "src/container/Tape.birch"
  virtual void write(const libbirch::Lazy<libbirch::Shared<birch::type::Buffer>>& buffer, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
  
  #line 46 "src/container/Tape.birch"
  LIBBIRCH_CLASS(Tape, Object)
  #line 46 "src/container/Tape.birch"
  LIBBIRCH_MEMBERS(ahead, aheadCount, behind, behindCount)
};

template<class Type>
#line 4 "src/container/TapeNode.birch"
class TapeNode final : public Object {
public:
  #line 4 "src/container/TapeNode.birch"
  using class_type_ = TapeNode<Type>;
  #line 4 "src/container/TapeNode.birch"
  using this_type_ = class_type_;
  #line 4 "src/container/TapeNode.birch"
  using super_type_ = Object;

  #line 4 "src/container/TapeNode.birch"
  using super_type_::operator=;
  
  #line 4 "src/container/TapeNode.birch"
  TapeNode(const Type& x, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);

  libbirch::Optional<libbirch::Lazy<libbirch::Shared<birch::type::TapeNode<Type>>>> next;
  Type x;
  #line 12 "src/container/TapeNode.birch"
  virtual libbirch::Lazy<libbirch::Shared<birch::type::TapeNode<Type>>> down(const birch::type::Integer& k, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
  #line 26 "src/container/TapeNode.birch"
  virtual libbirch::Lazy<libbirch::Shared<birch::type::TapeNode<Type>>> bottom(const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
  #line 37 "src/container/TapeNode.birch"
  virtual void popBottom(const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
  
  #line 4 "src/container/TapeNode.birch"
  LIBBIRCH_CLASS(TapeNode, Object)
  #line 4 "src/container/TapeNode.birch"
  LIBBIRCH_MEMBERS(next, x)
};

#line 23 "src/data/Buffer.birch"
class Buffer final : public Object {
public:
  #line 23 "src/data/Buffer.birch"
  using class_type_ = Buffer;
  #line 23 "src/data/Buffer.birch"
  using this_type_ = class_type_;
  #line 23 "src/data/Buffer.birch"
  using super_type_ = Object;

  #line 23 "src/data/Buffer.birch"
  using super_type_::operator=;
  
  #line 23 "src/data/Buffer.birch"
  Buffer(const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);

  libbirch::Optional<libbirch::Lazy<libbirch::Shared<birch::type::Value>>> content;
  #line 32 "src/data/Buffer.birch"
  virtual void accept(const libbirch::Lazy<libbirch::Shared<birch::type::Writer>>& writer, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
  #line 42 "src/data/Buffer.birch"
  virtual void clear(const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
  #line 49 "src/data/Buffer.birch"
  virtual libbirch::Optional<libbirch::Lazy<libbirch::Shared<birch::type::Buffer>>> find(const birch::type::String& key, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
  #line 60 "src/data/Buffer.birch"
  virtual void insert(const birch::type::String& key, const libbirch::Lazy<libbirch::Shared<birch::type::Buffer>>& value, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
  #line 70 "src/data/Buffer.birch"
  virtual void insert(const libbirch::Lazy<libbirch::Shared<birch::type::Buffer>>& value, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
  #line 82 "src/data/Buffer.birch"
  virtual libbirch::Optional<birch::type::Boolean> getBoolean(const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
  #line 95 "src/data/Buffer.birch"
  virtual libbirch::Optional<birch::type::Integer> getInteger(const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
  #line 108 "src/data/Buffer.birch"
  virtual libbirch::Optional<birch::type::Real> getReal(const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
  #line 121 "src/data/Buffer.birch"
  virtual libbirch::Optional<birch::type::String> getString(const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
  #line 135 "src/data/Buffer.birch"
  virtual libbirch::Optional<libbirch::DefaultArray<birch::type::Boolean,1>> getBooleanVector(const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
  #line 149 "src/data/Buffer.birch"
  virtual libbirch::Optional<libbirch::DefaultArray<birch::type::Integer,1>> getIntegerVector(const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
  #line 163 "src/data/Buffer.birch"
  virtual libbirch::Optional<libbirch::DefaultArray<birch::type::Real,1>> getRealVector(const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
  #line 177 "src/data/Buffer.birch"
  virtual libbirch::Optional<libbirch::DefaultArray<birch::type::Boolean,2>> getBooleanMatrix(const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
  #line 191 "src/data/Buffer.birch"
  virtual libbirch::Optional<libbirch::DefaultArray<birch::type::Integer,2>> getIntegerMatrix(const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
  #line 205 "src/data/Buffer.birch"
  virtual libbirch::Optional<libbirch::DefaultArray<birch::type::Real,2>> getRealMatrix(const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
  #line 219 "src/data/Buffer.birch"
  virtual libbirch::Optional<birch::type::LLT> getLLT(const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
  #line 236 "src/data/Buffer.birch"
  virtual libbirch::Optional<birch::type::Boolean> get(const libbirch::Optional<birch::type::Boolean>& value, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
  #line 247 "src/data/Buffer.birch"
  virtual libbirch::Optional<birch::type::Integer> get(const libbirch::Optional<birch::type::Integer>& value, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
  #line 258 "src/data/Buffer.birch"
  virtual libbirch::Optional<birch::type::Real> get(const libbirch::Optional<birch::type::Real>& value, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
  #line 269 "src/data/Buffer.birch"
  virtual libbirch::Optional<birch::type::String> get(const libbirch::Optional<birch::type::String>& value, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
  #line 280 "src/data/Buffer.birch"
  virtual libbirch::Optional<libbirch::Lazy<libbirch::Shared<birch::type::Object>>> get(const libbirch::Optional<libbirch::Lazy<libbirch::Shared<birch::type::Object>>>& value, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
  #line 295 "src/data/Buffer.birch"
  virtual libbirch::Optional<libbirch::DefaultArray<birch::type::Boolean,1>> get(const libbirch::Optional<libbirch::DefaultArray<birch::type::Boolean,1>>& value, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
  #line 307 "src/data/Buffer.birch"
  virtual libbirch::Optional<libbirch::DefaultArray<birch::type::Integer,1>> get(const libbirch::Optional<libbirch::DefaultArray<birch::type::Integer,1>>& value, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
  #line 319 "src/data/Buffer.birch"
  virtual libbirch::Optional<libbirch::DefaultArray<birch::type::Real,1>> get(const libbirch::Optional<libbirch::DefaultArray<birch::type::Real,1>>& value, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
  #line 331 "src/data/Buffer.birch"
  virtual libbirch::Optional<libbirch::DefaultArray<birch::type::Boolean,2>> get(const libbirch::Optional<libbirch::DefaultArray<birch::type::Boolean,2>>& value, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
  #line 343 "src/data/Buffer.birch"
  virtual libbirch::Optional<libbirch::DefaultArray<birch::type::Integer,2>> get(const libbirch::Optional<libbirch::DefaultArray<birch::type::Integer,2>>& value, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
  #line 355 "src/data/Buffer.birch"
  virtual libbirch::Optional<libbirch::DefaultArray<birch::type::Real,2>> get(const libbirch::Optional<libbirch::DefaultArray<birch::type::Real,2>>& value, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
  #line 367 "src/data/Buffer.birch"
  virtual libbirch::Optional<birch::type::LLT> get(const libbirch::Optional<birch::type::LLT>& value, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
  #line 374 "src/data/Buffer.birch"
  virtual void setNil(const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
  #line 381 "src/data/Buffer.birch"
  virtual void set(const birch::type::Boolean& value, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
  #line 388 "src/data/Buffer.birch"
  virtual void set(const birch::type::Integer& value, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
  #line 395 "src/data/Buffer.birch"
  virtual void set(const birch::type::Real& value, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
  #line 402 "src/data/Buffer.birch"
  virtual void set(const birch::type::String& value, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
  #line 409 "src/data/Buffer.birch"
  virtual void set(const libbirch::Lazy<libbirch::Shared<birch::type::Object>>& value, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
  #line 416 "src/data/Buffer.birch"
  virtual void set(const libbirch::DefaultArray<birch::type::Boolean,1>& value, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
  #line 423 "src/data/Buffer.birch"
  virtual void set(const libbirch::DefaultArray<birch::type::Integer,1>& value, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
  #line 430 "src/data/Buffer.birch"
  virtual void set(const libbirch::DefaultArray<birch::type::Real,1>& value, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
  #line 437 "src/data/Buffer.birch"
  virtual void set(const libbirch::DefaultArray<birch::type::String,1>& value, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
  #line 447 "src/data/Buffer.birch"
  virtual void set(const libbirch::DefaultArray<libbirch::Lazy<libbirch::Shared<birch::type::Object>>,1>& value, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
  #line 457 "src/data/Buffer.birch"
  virtual void set(const libbirch::DefaultArray<birch::type::Boolean,2>& value, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
  #line 467 "src/data/Buffer.birch"
  virtual void set(const libbirch::DefaultArray<birch::type::Integer,2>& value, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
  #line 477 "src/data/Buffer.birch"
  virtual void set(const libbirch::DefaultArray<birch::type::Real,2>& value, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
  #line 487 "src/data/Buffer.birch"
  virtual void set(const birch::type::LLT& value, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
  #line 499 "src/data/Buffer.birch"
  virtual libbirch::Optional<birch::type::Boolean> getBoolean(const birch::type::String& key, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
  #line 516 "src/data/Buffer.birch"
  virtual libbirch::Optional<birch::type::Integer> getInteger(const birch::type::String& key, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
  #line 533 "src/data/Buffer.birch"
  virtual libbirch::Optional<birch::type::Real> getReal(const birch::type::String& key, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
  #line 550 "src/data/Buffer.birch"
  virtual libbirch::Optional<birch::type::String> getString(const birch::type::String& key, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
  #line 567 "src/data/Buffer.birch"
  virtual libbirch::Optional<libbirch::DefaultArray<birch::type::Boolean,1>> getBooleanVector(const birch::type::String& key, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
  #line 584 "src/data/Buffer.birch"
  virtual libbirch::Optional<libbirch::DefaultArray<birch::type::Integer,1>> getIntegerVector(const birch::type::String& key, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
  #line 601 "src/data/Buffer.birch"
  virtual libbirch::Optional<libbirch::DefaultArray<birch::type::Real,1>> getRealVector(const birch::type::String& key, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
  #line 618 "src/data/Buffer.birch"
  virtual libbirch::Optional<libbirch::DefaultArray<birch::type::Boolean,2>> getBooleanMatrix(const birch::type::String& key, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
  #line 635 "src/data/Buffer.birch"
  virtual libbirch::Optional<libbirch::DefaultArray<birch::type::Integer,2>> getIntegerMatrix(const birch::type::String& key, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
  #line 652 "src/data/Buffer.birch"
  virtual libbirch::Optional<libbirch::DefaultArray<birch::type::Real,2>> getRealMatrix(const birch::type::String& key, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
  #line 669 "src/data/Buffer.birch"
  virtual libbirch::Optional<birch::type::LLT> getLLT(const birch::type::String& key, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
  #line 687 "src/data/Buffer.birch"
  virtual libbirch::Optional<birch::type::Boolean> get(const birch::type::String& key, const libbirch::Optional<birch::type::Boolean>& value, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
  #line 700 "src/data/Buffer.birch"
  virtual libbirch::Optional<birch::type::Integer> get(const birch::type::String& key, const libbirch::Optional<birch::type::Integer>& value, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
  #line 713 "src/data/Buffer.birch"
  virtual libbirch::Optional<birch::type::Real> get(const birch::type::String& key, const libbirch::Optional<birch::type::Real>& value, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
  #line 726 "src/data/Buffer.birch"
  virtual libbirch::Optional<birch::type::String> get(const birch::type::String& key, const libbirch::Optional<birch::type::String>& value, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
  #line 738 "src/data/Buffer.birch"
  virtual libbirch::Optional<libbirch::Lazy<libbirch::Shared<birch::type::Object>>> get(const birch::type::String& key, const libbirch::Optional<libbirch::Lazy<libbirch::Shared<birch::type::Object>>>& value, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
  #line 756 "src/data/Buffer.birch"
  virtual libbirch::Optional<libbirch::DefaultArray<birch::type::Boolean,1>> get(const birch::type::String& key, const libbirch::Optional<libbirch::DefaultArray<birch::type::Boolean,1>>& value, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
  #line 769 "src/data/Buffer.birch"
  virtual libbirch::Optional<libbirch::DefaultArray<birch::type::Integer,1>> get(const birch::type::String& key, const libbirch::Optional<libbirch::DefaultArray<birch::type::Integer,1>>& value, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
  #line 782 "src/data/Buffer.birch"
  virtual libbirch::Optional<libbirch::DefaultArray<birch::type::Real,1>> get(const birch::type::String& key, const libbirch::Optional<libbirch::DefaultArray<birch::type::Real,1>>& value, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
  #line 795 "src/data/Buffer.birch"
  virtual libbirch::Optional<libbirch::DefaultArray<birch::type::Boolean,2>> get(const birch::type::String& key, const libbirch::Optional<libbirch::DefaultArray<birch::type::Boolean,2>>& value, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
  #line 808 "src/data/Buffer.birch"
  virtual libbirch::Optional<libbirch::DefaultArray<birch::type::Integer,2>> get(const birch::type::String& key, const libbirch::Optional<libbirch::DefaultArray<birch::type::Integer,2>>& value, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
  #line 821 "src/data/Buffer.birch"
  virtual libbirch::Optional<libbirch::DefaultArray<birch::type::Real,2>> get(const birch::type::String& key, const libbirch::Optional<libbirch::DefaultArray<birch::type::Real,2>>& value, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
  #line 834 "src/data/Buffer.birch"
  virtual libbirch::Optional<birch::type::LLT> get(const birch::type::String& key, const libbirch::Optional<birch::type::LLT>& value, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
  #line 843 "src/data/Buffer.birch"
  virtual void setNil(const birch::type::String& key, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
  #line 853 "src/data/Buffer.birch"
  virtual void set(const birch::type::String& key, const birch::type::Boolean& value, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
  #line 863 "src/data/Buffer.birch"
  virtual void set(const birch::type::String& key, const birch::type::Integer& value, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
  #line 873 "src/data/Buffer.birch"
  virtual void set(const birch::type::String& key, const birch::type::Real& value, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
  #line 883 "src/data/Buffer.birch"
  virtual void set(const birch::type::String& key, const birch::type::String& value, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
  #line 893 "src/data/Buffer.birch"
  virtual void set(const birch::type::String& key, const libbirch::Lazy<libbirch::Shared<birch::type::Object>>& value, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
  #line 905 "src/data/Buffer.birch"
  virtual void set(const birch::type::String& key, const libbirch::DefaultArray<birch::type::Boolean,1>& value, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
  #line 915 "src/data/Buffer.birch"
  virtual void set(const birch::type::String& key, const libbirch::DefaultArray<birch::type::Integer,1>& value, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
  #line 925 "src/data/Buffer.birch"
  virtual void set(const birch::type::String& key, const libbirch::DefaultArray<birch::type::Real,1>& value, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
  #line 935 "src/data/Buffer.birch"
  virtual void set(const birch::type::String& key, const libbirch::DefaultArray<birch::type::String,1>& value, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
  #line 945 "src/data/Buffer.birch"
  virtual void set(const birch::type::String& key, const libbirch::DefaultArray<libbirch::Lazy<libbirch::Shared<birch::type::Object>>,1>& value, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
  #line 955 "src/data/Buffer.birch"
  virtual void set(const birch::type::String& key, const libbirch::DefaultArray<birch::type::Boolean,2>& value, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
  #line 965 "src/data/Buffer.birch"
  virtual void set(const birch::type::String& key, const libbirch::DefaultArray<birch::type::Integer,2>& value, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
  #line 975 "src/data/Buffer.birch"
  virtual void set(const birch::type::String& key, const libbirch::DefaultArray<birch::type::Real,2>& value, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
  #line 985 "src/data/Buffer.birch"
  virtual void set(const birch::type::String& key, const birch::type::LLT& value, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
  #line 993 "src/data/Buffer.birch"
  virtual birch::type::Integer size(const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
  #line 1007 "src/data/Buffer.birch"
  virtual birch::type::Integer size(const birch::type::String& key, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
  #line 1019 "src/data/Buffer.birch"
  virtual libbirch::Lazy<libbirch::Shared<birch::type::Iterator<libbirch::Lazy<libbirch::Shared<birch::type::Buffer>>>>> walk(const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
  #line 1032 "src/data/Buffer.birch"
  virtual libbirch::Lazy<libbirch::Shared<birch::type::Iterator<libbirch::Lazy<libbirch::Shared<birch::type::Buffer>>>>> walk(const birch::type::String& key, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
  #line 1044 "src/data/Buffer.birch"
  virtual void pushNil(const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
  #line 1056 "src/data/Buffer.birch"
  virtual void push(const birch::type::Boolean& value, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
  #line 1067 "src/data/Buffer.birch"
  virtual void push(const birch::type::Integer& value, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
  #line 1078 "src/data/Buffer.birch"
  virtual void push(const birch::type::Real& value, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
  #line 1089 "src/data/Buffer.birch"
  virtual void push(const birch::type::String& value, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
  #line 1100 "src/data/Buffer.birch"
  virtual void push(const libbirch::Lazy<libbirch::Shared<birch::type::Object>>& value, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
  #line 1111 "src/data/Buffer.birch"
  virtual void push(const libbirch::DefaultArray<birch::type::Boolean,1>& value, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
  #line 1123 "src/data/Buffer.birch"
  virtual void push(const libbirch::DefaultArray<birch::type::Integer,1>& value, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
  #line 1135 "src/data/Buffer.birch"
  virtual void push(const libbirch::DefaultArray<birch::type::Real,1>& value, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
  
  #line 23 "src/data/Buffer.birch"
  LIBBIRCH_CLASS(Buffer, Object)
  #line 23 "src/data/Buffer.birch"
  LIBBIRCH_MEMBERS(content)
};

#line 23 "src/data/Buffer.birch"
extern "C" birch::type::Buffer* make_Buffer_();

#line 4 "src/data/Entry.birch"
class Entry final : public Object {
public:
  #line 4 "src/data/Entry.birch"
  using class_type_ = Entry;
  #line 4 "src/data/Entry.birch"
  using this_type_ = class_type_;
  #line 4 "src/data/Entry.birch"
  using super_type_ = Object;

  #line 4 "src/data/Entry.birch"
  using super_type_::operator=;
  
  #line 4 "src/data/Entry.birch"
  Entry(const birch::type::String& key, const libbirch::Lazy<libbirch::Shared<birch::type::Buffer>>& value, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);

  birch::type::String key;
  libbirch::Lazy<libbirch::Shared<birch::type::Buffer>> value;
  
  #line 4 "src/data/Entry.birch"
  LIBBIRCH_CLASS(Entry, Object)
  #line 4 "src/data/Entry.birch"
  LIBBIRCH_MEMBERS(key, value)
};

#line 4 "src/data/Value.birch"
class Value : public Object {
public:
  #line 4 "src/data/Value.birch"
  using class_type_ = Value;
  #line 4 "src/data/Value.birch"
  using this_type_ = class_type_;
  #line 4 "src/data/Value.birch"
  using super_type_ = Object;

  #line 4 "src/data/Value.birch"
  using super_type_::operator=;
  
  #line 4 "src/data/Value.birch"
  Value(const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);

  #line 8 "src/data/Value.birch"
  virtual void accept(const libbirch::Lazy<libbirch::Shared<birch::type::Writer>>& writer, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr) = 0;
  #line 13 "src/data/Value.birch"
  virtual libbirch::Optional<libbirch::Lazy<libbirch::Shared<birch::type::Buffer>>> find(const birch::type::String& key, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
  #line 20 "src/data/Value.birch"
  virtual void insert(const birch::type::String& key, const libbirch::Lazy<libbirch::Shared<birch::type::Buffer>>& value, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
  #line 27 "src/data/Value.birch"
  virtual void insert(const libbirch::Lazy<libbirch::Shared<birch::type::Buffer>>& value, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
  #line 34 "src/data/Value.birch"
  virtual birch::type::Integer size(const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
  #line 41 "src/data/Value.birch"
  virtual libbirch::Lazy<libbirch::Shared<birch::type::Iterator<libbirch::Lazy<libbirch::Shared<birch::type::Buffer>>>>> walk(const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
  #line 51 "src/data/Value.birch"
  virtual libbirch::Lazy<libbirch::Shared<birch::type::Value>> pushNil(const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr) = 0;
  #line 61 "src/data/Value.birch"
  virtual libbirch::Lazy<libbirch::Shared<birch::type::Value>> push(const birch::type::Boolean& value, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr) = 0;
  #line 71 "src/data/Value.birch"
  virtual libbirch::Lazy<libbirch::Shared<birch::type::Value>> push(const birch::type::Integer& value, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr) = 0;
  #line 81 "src/data/Value.birch"
  virtual libbirch::Lazy<libbirch::Shared<birch::type::Value>> push(const birch::type::Real& value, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr) = 0;
  #line 91 "src/data/Value.birch"
  virtual libbirch::Lazy<libbirch::Shared<birch::type::Value>> push(const birch::type::String& value, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr) = 0;
  #line 101 "src/data/Value.birch"
  virtual libbirch::Lazy<libbirch::Shared<birch::type::Value>> push(const libbirch::Lazy<libbirch::Shared<birch::type::Object>>& value, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr) = 0;
  #line 111 "src/data/Value.birch"
  virtual libbirch::Lazy<libbirch::Shared<birch::type::Value>> push(const libbirch::DefaultArray<birch::type::Boolean,1>& value, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr) = 0;
  #line 121 "src/data/Value.birch"
  virtual libbirch::Lazy<libbirch::Shared<birch::type::Value>> push(const libbirch::DefaultArray<birch::type::Integer,1>& value, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr) = 0;
  #line 131 "src/data/Value.birch"
  virtual libbirch::Lazy<libbirch::Shared<birch::type::Value>> push(const libbirch::DefaultArray<birch::type::Real,1>& value, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr) = 0;
  #line 138 "src/data/Value.birch"
  virtual libbirch::Optional<birch::type::Boolean> getBoolean(const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
  #line 147 "src/data/Value.birch"
  virtual libbirch::Optional<birch::type::Integer> getInteger(const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
  #line 156 "src/data/Value.birch"
  virtual libbirch::Optional<birch::type::Real> getReal(const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
  #line 165 "src/data/Value.birch"
  virtual libbirch::Optional<birch::type::String> getString(const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
  #line 175 "src/data/Value.birch"
  virtual libbirch::Optional<libbirch::DefaultArray<birch::type::Boolean,1>> getBooleanVector(const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
  #line 185 "src/data/Value.birch"
  virtual libbirch::Optional<libbirch::DefaultArray<birch::type::Integer,1>> getIntegerVector(const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
  #line 195 "src/data/Value.birch"
  virtual libbirch::Optional<libbirch::DefaultArray<birch::type::Real,1>> getRealVector(const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
  #line 205 "src/data/Value.birch"
  virtual libbirch::Optional<libbirch::DefaultArray<birch::type::Boolean,2>> getBooleanMatrix(const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
  #line 215 "src/data/Value.birch"
  virtual libbirch::Optional<libbirch::DefaultArray<birch::type::Integer,2>> getIntegerMatrix(const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
  #line 225 "src/data/Value.birch"
  virtual libbirch::Optional<libbirch::DefaultArray<birch::type::Real,2>> getRealMatrix(const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
  
  #line 4 "src/data/Value.birch"
  LIBBIRCH_ABSTRACT_CLASS(Value, Object)
  #line 4 "src/data/Value.birch"
  LIBBIRCH_MEMBERS()
};

#line 4 "src/data/StringValue.birch"
class StringValue final : public Value {
public:
  #line 4 "src/data/StringValue.birch"
  using class_type_ = StringValue;
  #line 4 "src/data/StringValue.birch"
  using this_type_ = class_type_;
  #line 4 "src/data/StringValue.birch"
  using super_type_ = Value;

  #line 4 "src/data/StringValue.birch"
  using super_type_::operator=;
  #line 4 "src/data/StringValue.birch"
  using super_type_::accept;
  #line 4 "src/data/StringValue.birch"
  using super_type_::getString;
  #line 4 "src/data/StringValue.birch"
  using super_type_::push;
  #line 4 "src/data/StringValue.birch"
  using super_type_::pushNil;
  
  #line 4 "src/data/StringValue.birch"
  StringValue(const birch::type::String& value, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);

  birch::type::String value;
  #line 10 "src/data/StringValue.birch"
  virtual void accept(const libbirch::Lazy<libbirch::Shared<birch::type::Writer>>& writer, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr) override;
  #line 14 "src/data/StringValue.birch"
  virtual libbirch::Optional<birch::type::String> getString(const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr) override;
  #line 18 "src/data/StringValue.birch"
  virtual libbirch::Lazy<libbirch::Shared<birch::type::Value>> pushNil(const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr) override;
  #line 25 "src/data/StringValue.birch"
  virtual libbirch::Lazy<libbirch::Shared<birch::type::Value>> push(const birch::type::Boolean& x, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr) override;
  #line 32 "src/data/StringValue.birch"
  virtual libbirch::Lazy<libbirch::Shared<birch::type::Value>> push(const birch::type::Integer& x, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr) override;
  #line 39 "src/data/StringValue.birch"
  virtual libbirch::Lazy<libbirch::Shared<birch::type::Value>> push(const birch::type::Real& x, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr) override;
  #line 46 "src/data/StringValue.birch"
  virtual libbirch::Lazy<libbirch::Shared<birch::type::Value>> push(const birch::type::String& x, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr) override;
  #line 53 "src/data/StringValue.birch"
  virtual libbirch::Lazy<libbirch::Shared<birch::type::Value>> push(const libbirch::Lazy<libbirch::Shared<birch::type::Object>>& x, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr) override;
  #line 60 "src/data/StringValue.birch"
  virtual libbirch::Lazy<libbirch::Shared<birch::type::Value>> push(const libbirch::DefaultArray<birch::type::Boolean,1>& x, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr) override;
  #line 67 "src/data/StringValue.birch"
  virtual libbirch::Lazy<libbirch::Shared<birch::type::Value>> push(const libbirch::DefaultArray<birch::type::Integer,1>& x, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr) override;
  #line 74 "src/data/StringValue.birch"
  virtual libbirch::Lazy<libbirch::Shared<birch::type::Value>> push(const libbirch::DefaultArray<birch::type::Real,1>& x, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr) override;
  
  #line 4 "src/data/StringValue.birch"
  LIBBIRCH_CLASS(StringValue, Value)
  #line 4 "src/data/StringValue.birch"
  LIBBIRCH_MEMBERS(value)
};

#line 4 "src/data/RealVectorValue.birch"
class RealVectorValue final : public Value {
public:
  #line 4 "src/data/RealVectorValue.birch"
  using class_type_ = RealVectorValue;
  #line 4 "src/data/RealVectorValue.birch"
  using this_type_ = class_type_;
  #line 4 "src/data/RealVectorValue.birch"
  using super_type_ = Value;

  #line 4 "src/data/RealVectorValue.birch"
  using super_type_::operator=;
  #line 4 "src/data/RealVectorValue.birch"
  using super_type_::accept;
  #line 4 "src/data/RealVectorValue.birch"
  using super_type_::getRealMatrix;
  #line 4 "src/data/RealVectorValue.birch"
  using super_type_::getRealVector;
  #line 4 "src/data/RealVectorValue.birch"
  using super_type_::push;
  #line 4 "src/data/RealVectorValue.birch"
  using super_type_::pushNil;
  #line 4 "src/data/RealVectorValue.birch"
  using super_type_::size;
  
  #line 4 "src/data/RealVectorValue.birch"
  RealVectorValue(const libbirch::DefaultArray<birch::type::Real,1>& value, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);

  libbirch::DefaultArray<birch::type::Real,1> value;
  #line 10 "src/data/RealVectorValue.birch"
  virtual void accept(const libbirch::Lazy<libbirch::Shared<birch::type::Writer>>& writer, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr) override;
  #line 14 "src/data/RealVectorValue.birch"
  virtual birch::type::Integer size(const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr) override;
  #line 18 "src/data/RealVectorValue.birch"
  virtual libbirch::Optional<libbirch::DefaultArray<birch::type::Real,1>> getRealVector(const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr) override;
  #line 22 "src/data/RealVectorValue.birch"
  virtual libbirch::Optional<libbirch::DefaultArray<birch::type::Real,2>> getRealMatrix(const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr) override;
  #line 26 "src/data/RealVectorValue.birch"
  virtual libbirch::Lazy<libbirch::Shared<birch::type::Value>> pushNil(const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr) override;
  #line 35 "src/data/RealVectorValue.birch"
  virtual libbirch::Lazy<libbirch::Shared<birch::type::Value>> push(const birch::type::Boolean& x, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr) override;
  #line 39 "src/data/RealVectorValue.birch"
  virtual libbirch::Lazy<libbirch::Shared<birch::type::Value>> push(const birch::type::Integer& x, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr) override;
  #line 43 "src/data/RealVectorValue.birch"
  virtual libbirch::Lazy<libbirch::Shared<birch::type::Value>> push(const birch::type::Real& x, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr) override;
  #line 50 "src/data/RealVectorValue.birch"
  virtual libbirch::Lazy<libbirch::Shared<birch::type::Value>> push(const birch::type::String& x, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr) override;
  #line 59 "src/data/RealVectorValue.birch"
  virtual libbirch::Lazy<libbirch::Shared<birch::type::Value>> push(const libbirch::Lazy<libbirch::Shared<birch::type::Object>>& x, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr) override;
  #line 68 "src/data/RealVectorValue.birch"
  virtual libbirch::Lazy<libbirch::Shared<birch::type::Value>> push(const libbirch::DefaultArray<birch::type::Boolean,1>& x, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr) override;
  #line 75 "src/data/RealVectorValue.birch"
  virtual libbirch::Lazy<libbirch::Shared<birch::type::Value>> push(const libbirch::DefaultArray<birch::type::Integer,1>& x, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr) override;
  #line 82 "src/data/RealVectorValue.birch"
  virtual libbirch::Lazy<libbirch::Shared<birch::type::Value>> push(const libbirch::DefaultArray<birch::type::Real,1>& x, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr) override;
  
  #line 4 "src/data/RealVectorValue.birch"
  LIBBIRCH_CLASS(RealVectorValue, Value)
  #line 4 "src/data/RealVectorValue.birch"
  LIBBIRCH_MEMBERS(value)
};

#line 4 "src/data/RealValue.birch"
class RealValue final : public Value {
public:
  #line 4 "src/data/RealValue.birch"
  using class_type_ = RealValue;
  #line 4 "src/data/RealValue.birch"
  using this_type_ = class_type_;
  #line 4 "src/data/RealValue.birch"
  using super_type_ = Value;

  #line 4 "src/data/RealValue.birch"
  using super_type_::operator=;
  #line 4 "src/data/RealValue.birch"
  using super_type_::accept;
  #line 4 "src/data/RealValue.birch"
  using super_type_::getReal;
  #line 4 "src/data/RealValue.birch"
  using super_type_::getRealMatrix;
  #line 4 "src/data/RealValue.birch"
  using super_type_::getRealVector;
  #line 4 "src/data/RealValue.birch"
  using super_type_::push;
  #line 4 "src/data/RealValue.birch"
  using super_type_::pushNil;
  
  #line 4 "src/data/RealValue.birch"
  RealValue(const birch::type::Real& value, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);

  birch::type::Real value;
  #line 10 "src/data/RealValue.birch"
  virtual void accept(const libbirch::Lazy<libbirch::Shared<birch::type::Writer>>& writer, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr) override;
  #line 14 "src/data/RealValue.birch"
  virtual libbirch::Optional<birch::type::Real> getReal(const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr) override;
  #line 18 "src/data/RealValue.birch"
  virtual libbirch::Optional<libbirch::DefaultArray<birch::type::Real,1>> getRealVector(const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr) override;
  #line 22 "src/data/RealValue.birch"
  virtual libbirch::Optional<libbirch::DefaultArray<birch::type::Real,2>> getRealMatrix(const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr) override;
  #line 26 "src/data/RealValue.birch"
  virtual libbirch::Lazy<libbirch::Shared<birch::type::Value>> pushNil(const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr) override;
  #line 33 "src/data/RealValue.birch"
  virtual libbirch::Lazy<libbirch::Shared<birch::type::Value>> push(const birch::type::Boolean& x, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr) override;
  #line 37 "src/data/RealValue.birch"
  virtual libbirch::Lazy<libbirch::Shared<birch::type::Value>> push(const birch::type::Integer& x, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr) override;
  #line 41 "src/data/RealValue.birch"
  virtual libbirch::Lazy<libbirch::Shared<birch::type::Value>> push(const birch::type::Real& x, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr) override;
  #line 45 "src/data/RealValue.birch"
  virtual libbirch::Lazy<libbirch::Shared<birch::type::Value>> push(const birch::type::String& x, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr) override;
  #line 52 "src/data/RealValue.birch"
  virtual libbirch::Lazy<libbirch::Shared<birch::type::Value>> push(const libbirch::Lazy<libbirch::Shared<birch::type::Object>>& x, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr) override;
  #line 59 "src/data/RealValue.birch"
  virtual libbirch::Lazy<libbirch::Shared<birch::type::Value>> push(const libbirch::DefaultArray<birch::type::Boolean,1>& x, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr) override;
  #line 66 "src/data/RealValue.birch"
  virtual libbirch::Lazy<libbirch::Shared<birch::type::Value>> push(const libbirch::DefaultArray<birch::type::Integer,1>& x, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr) override;
  #line 73 "src/data/RealValue.birch"
  virtual libbirch::Lazy<libbirch::Shared<birch::type::Value>> push(const libbirch::DefaultArray<birch::type::Real,1>& x, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr) override;
  
  #line 4 "src/data/RealValue.birch"
  LIBBIRCH_CLASS(RealValue, Value)
  #line 4 "src/data/RealValue.birch"
  LIBBIRCH_MEMBERS(value)
};

#line 4 "src/data/ObjectValue.birch"
class ObjectValue final : public Value {
public:
  #line 4 "src/data/ObjectValue.birch"
  using class_type_ = ObjectValue;
  #line 4 "src/data/ObjectValue.birch"
  using this_type_ = class_type_;
  #line 4 "src/data/ObjectValue.birch"
  using super_type_ = Value;

  #line 4 "src/data/ObjectValue.birch"
  using super_type_::operator=;
  #line 4 "src/data/ObjectValue.birch"
  using super_type_::accept;
  #line 4 "src/data/ObjectValue.birch"
  using super_type_::find;
  #line 4 "src/data/ObjectValue.birch"
  using super_type_::insert;
  #line 4 "src/data/ObjectValue.birch"
  using super_type_::push;
  #line 4 "src/data/ObjectValue.birch"
  using super_type_::pushNil;
  
  #line 4 "src/data/ObjectValue.birch"
  ObjectValue(const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);

  libbirch::Lazy<libbirch::Shared<birch::type::Array<libbirch::Lazy<libbirch::Shared<birch::type::Entry>>>>> entries;
  #line 12 "src/data/ObjectValue.birch"
  virtual void accept(const libbirch::Lazy<libbirch::Shared<birch::type::Writer>>& writer, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr) override;
  #line 16 "src/data/ObjectValue.birch"
  virtual libbirch::Optional<libbirch::Lazy<libbirch::Shared<birch::type::Buffer>>> find(const birch::type::String& key, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr) override;
  #line 27 "src/data/ObjectValue.birch"
  virtual void insert(const birch::type::String& key, const libbirch::Lazy<libbirch::Shared<birch::type::Buffer>>& value, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr) override;
  #line 31 "src/data/ObjectValue.birch"
  virtual libbirch::Lazy<libbirch::Shared<birch::type::Value>> pushNil(const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr) override;
  #line 40 "src/data/ObjectValue.birch"
  virtual libbirch::Lazy<libbirch::Shared<birch::type::Value>> push(const birch::type::Boolean& x, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr) override;
  #line 49 "src/data/ObjectValue.birch"
  virtual libbirch::Lazy<libbirch::Shared<birch::type::Value>> push(const birch::type::Integer& x, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr) override;
  #line 58 "src/data/ObjectValue.birch"
  virtual libbirch::Lazy<libbirch::Shared<birch::type::Value>> push(const birch::type::Real& x, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr) override;
  #line 67 "src/data/ObjectValue.birch"
  virtual libbirch::Lazy<libbirch::Shared<birch::type::Value>> push(const birch::type::String& x, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr) override;
  #line 76 "src/data/ObjectValue.birch"
  virtual libbirch::Lazy<libbirch::Shared<birch::type::Value>> push(const libbirch::Lazy<libbirch::Shared<birch::type::Object>>& x, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr) override;
  #line 85 "src/data/ObjectValue.birch"
  virtual libbirch::Lazy<libbirch::Shared<birch::type::Value>> push(const libbirch::DefaultArray<birch::type::Boolean,1>& x, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr) override;
  #line 94 "src/data/ObjectValue.birch"
  virtual libbirch::Lazy<libbirch::Shared<birch::type::Value>> push(const libbirch::DefaultArray<birch::type::Integer,1>& x, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr) override;
  #line 103 "src/data/ObjectValue.birch"
  virtual libbirch::Lazy<libbirch::Shared<birch::type::Value>> push(const libbirch::DefaultArray<birch::type::Real,1>& x, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr) override;
  
  #line 4 "src/data/ObjectValue.birch"
  LIBBIRCH_CLASS(ObjectValue, Value)
  #line 4 "src/data/ObjectValue.birch"
  LIBBIRCH_MEMBERS(entries)
};

#line 4 "src/data/ObjectValue.birch"
extern "C" birch::type::ObjectValue* make_ObjectValue_();

#line 4 "src/data/NilValue.birch"
class NilValue final : public Value {
public:
  #line 4 "src/data/NilValue.birch"
  using class_type_ = NilValue;
  #line 4 "src/data/NilValue.birch"
  using this_type_ = class_type_;
  #line 4 "src/data/NilValue.birch"
  using super_type_ = Value;

  #line 4 "src/data/NilValue.birch"
  using super_type_::operator=;
  #line 4 "src/data/NilValue.birch"
  using super_type_::accept;
  #line 4 "src/data/NilValue.birch"
  using super_type_::push;
  #line 4 "src/data/NilValue.birch"
  using super_type_::pushNil;
  
  #line 4 "src/data/NilValue.birch"
  NilValue(const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);

  #line 5 "src/data/NilValue.birch"
  virtual void accept(const libbirch::Lazy<libbirch::Shared<birch::type::Writer>>& writer, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr) override;
  #line 9 "src/data/NilValue.birch"
  virtual libbirch::Lazy<libbirch::Shared<birch::type::Value>> pushNil(const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr) override;
  #line 16 "src/data/NilValue.birch"
  virtual libbirch::Lazy<libbirch::Shared<birch::type::Value>> push(const birch::type::Boolean& x, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr) override;
  #line 23 "src/data/NilValue.birch"
  virtual libbirch::Lazy<libbirch::Shared<birch::type::Value>> push(const birch::type::Integer& x, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr) override;
  #line 30 "src/data/NilValue.birch"
  virtual libbirch::Lazy<libbirch::Shared<birch::type::Value>> push(const birch::type::Real& x, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr) override;
  #line 37 "src/data/NilValue.birch"
  virtual libbirch::Lazy<libbirch::Shared<birch::type::Value>> push(const birch::type::String& x, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr) override;
  #line 44 "src/data/NilValue.birch"
  virtual libbirch::Lazy<libbirch::Shared<birch::type::Value>> push(const libbirch::Lazy<libbirch::Shared<birch::type::Object>>& x, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr) override;
  #line 51 "src/data/NilValue.birch"
  virtual libbirch::Lazy<libbirch::Shared<birch::type::Value>> push(const libbirch::DefaultArray<birch::type::Boolean,1>& x, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr) override;
  #line 58 "src/data/NilValue.birch"
  virtual libbirch::Lazy<libbirch::Shared<birch::type::Value>> push(const libbirch::DefaultArray<birch::type::Integer,1>& x, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr) override;
  #line 65 "src/data/NilValue.birch"
  virtual libbirch::Lazy<libbirch::Shared<birch::type::Value>> push(const libbirch::DefaultArray<birch::type::Real,1>& x, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr) override;
  
  #line 4 "src/data/NilValue.birch"
  LIBBIRCH_CLASS(NilValue, Value)
  #line 4 "src/data/NilValue.birch"
  LIBBIRCH_MEMBERS()
};

#line 4 "src/data/NilValue.birch"
extern "C" birch::type::NilValue* make_NilValue_();

#line 4 "src/data/IntegerVectorValue.birch"
class IntegerVectorValue final : public Value {
public:
  #line 4 "src/data/IntegerVectorValue.birch"
  using class_type_ = IntegerVectorValue;
  #line 4 "src/data/IntegerVectorValue.birch"
  using this_type_ = class_type_;
  #line 4 "src/data/IntegerVectorValue.birch"
  using super_type_ = Value;

  #line 4 "src/data/IntegerVectorValue.birch"
  using super_type_::operator=;
  #line 4 "src/data/IntegerVectorValue.birch"
  using super_type_::accept;
  #line 4 "src/data/IntegerVectorValue.birch"
  using super_type_::getIntegerMatrix;
  #line 4 "src/data/IntegerVectorValue.birch"
  using super_type_::getIntegerVector;
  #line 4 "src/data/IntegerVectorValue.birch"
  using super_type_::getRealMatrix;
  #line 4 "src/data/IntegerVectorValue.birch"
  using super_type_::getRealVector;
  #line 4 "src/data/IntegerVectorValue.birch"
  using super_type_::push;
  #line 4 "src/data/IntegerVectorValue.birch"
  using super_type_::pushNil;
  #line 4 "src/data/IntegerVectorValue.birch"
  using super_type_::size;
  
  #line 4 "src/data/IntegerVectorValue.birch"
  IntegerVectorValue(const libbirch::DefaultArray<birch::type::Integer,1>& value, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);

  libbirch::DefaultArray<birch::type::Integer,1> value;
  #line 10 "src/data/IntegerVectorValue.birch"
  virtual void accept(const libbirch::Lazy<libbirch::Shared<birch::type::Writer>>& writer, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr) override;
  #line 14 "src/data/IntegerVectorValue.birch"
  virtual birch::type::Integer size(const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr) override;
  #line 18 "src/data/IntegerVectorValue.birch"
  virtual libbirch::Optional<libbirch::DefaultArray<birch::type::Integer,1>> getIntegerVector(const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr) override;
  #line 22 "src/data/IntegerVectorValue.birch"
  virtual libbirch::Optional<libbirch::DefaultArray<birch::type::Integer,2>> getIntegerMatrix(const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr) override;
  #line 26 "src/data/IntegerVectorValue.birch"
  virtual libbirch::Optional<libbirch::DefaultArray<birch::type::Real,1>> getRealVector(const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr) override;
  #line 30 "src/data/IntegerVectorValue.birch"
  virtual libbirch::Optional<libbirch::DefaultArray<birch::type::Real,2>> getRealMatrix(const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr) override;
  #line 34 "src/data/IntegerVectorValue.birch"
  virtual libbirch::Lazy<libbirch::Shared<birch::type::Value>> pushNil(const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr) override;
  #line 43 "src/data/IntegerVectorValue.birch"
  virtual libbirch::Lazy<libbirch::Shared<birch::type::Value>> push(const birch::type::Boolean& x, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr) override;
  #line 47 "src/data/IntegerVectorValue.birch"
  virtual libbirch::Lazy<libbirch::Shared<birch::type::Value>> push(const birch::type::Integer& x, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr) override;
  #line 54 "src/data/IntegerVectorValue.birch"
  virtual libbirch::Lazy<libbirch::Shared<birch::type::Value>> push(const birch::type::Real& x, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr) override;
  #line 65 "src/data/IntegerVectorValue.birch"
  virtual libbirch::Lazy<libbirch::Shared<birch::type::Value>> push(const birch::type::String& x, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr) override;
  #line 74 "src/data/IntegerVectorValue.birch"
  virtual libbirch::Lazy<libbirch::Shared<birch::type::Value>> push(const libbirch::Lazy<libbirch::Shared<birch::type::Object>>& x, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr) override;
  #line 83 "src/data/IntegerVectorValue.birch"
  virtual libbirch::Lazy<libbirch::Shared<birch::type::Value>> push(const libbirch::DefaultArray<birch::type::Boolean,1>& x, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr) override;
  #line 90 "src/data/IntegerVectorValue.birch"
  virtual libbirch::Lazy<libbirch::Shared<birch::type::Value>> push(const libbirch::DefaultArray<birch::type::Integer,1>& x, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr) override;
  #line 97 "src/data/IntegerVectorValue.birch"
  virtual libbirch::Lazy<libbirch::Shared<birch::type::Value>> push(const libbirch::DefaultArray<birch::type::Real,1>& x, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr) override;
  
  #line 4 "src/data/IntegerVectorValue.birch"
  LIBBIRCH_CLASS(IntegerVectorValue, Value)
  #line 4 "src/data/IntegerVectorValue.birch"
  LIBBIRCH_MEMBERS(value)
};

#line 4 "src/data/IntegerValue.birch"
class IntegerValue final : public Value {
public:
  #line 4 "src/data/IntegerValue.birch"
  using class_type_ = IntegerValue;
  #line 4 "src/data/IntegerValue.birch"
  using this_type_ = class_type_;
  #line 4 "src/data/IntegerValue.birch"
  using super_type_ = Value;

  #line 4 "src/data/IntegerValue.birch"
  using super_type_::operator=;
  #line 4 "src/data/IntegerValue.birch"
  using super_type_::accept;
  #line 4 "src/data/IntegerValue.birch"
  using super_type_::getInteger;
  #line 4 "src/data/IntegerValue.birch"
  using super_type_::getIntegerMatrix;
  #line 4 "src/data/IntegerValue.birch"
  using super_type_::getIntegerVector;
  #line 4 "src/data/IntegerValue.birch"
  using super_type_::getReal;
  #line 4 "src/data/IntegerValue.birch"
  using super_type_::getRealMatrix;
  #line 4 "src/data/IntegerValue.birch"
  using super_type_::getRealVector;
  #line 4 "src/data/IntegerValue.birch"
  using super_type_::push;
  #line 4 "src/data/IntegerValue.birch"
  using super_type_::pushNil;
  
  #line 4 "src/data/IntegerValue.birch"
  IntegerValue(const birch::type::Integer& value, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);

  birch::type::Integer value;
  #line 10 "src/data/IntegerValue.birch"
  virtual void accept(const libbirch::Lazy<libbirch::Shared<birch::type::Writer>>& writer, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr) override;
  #line 14 "src/data/IntegerValue.birch"
  virtual libbirch::Optional<birch::type::Integer> getInteger(const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr) override;
  #line 18 "src/data/IntegerValue.birch"
  virtual libbirch::Optional<birch::type::Real> getReal(const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr) override;
  #line 22 "src/data/IntegerValue.birch"
  virtual libbirch::Optional<libbirch::DefaultArray<birch::type::Integer,1>> getIntegerVector(const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr) override;
  #line 26 "src/data/IntegerValue.birch"
  virtual libbirch::Optional<libbirch::DefaultArray<birch::type::Real,1>> getRealVector(const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr) override;
  #line 30 "src/data/IntegerValue.birch"
  virtual libbirch::Optional<libbirch::DefaultArray<birch::type::Integer,2>> getIntegerMatrix(const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr) override;
  #line 34 "src/data/IntegerValue.birch"
  virtual libbirch::Optional<libbirch::DefaultArray<birch::type::Real,2>> getRealMatrix(const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr) override;
  #line 38 "src/data/IntegerValue.birch"
  virtual libbirch::Lazy<libbirch::Shared<birch::type::Value>> pushNil(const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr) override;
  #line 45 "src/data/IntegerValue.birch"
  virtual libbirch::Lazy<libbirch::Shared<birch::type::Value>> push(const birch::type::Boolean& x, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr) override;
  #line 49 "src/data/IntegerValue.birch"
  virtual libbirch::Lazy<libbirch::Shared<birch::type::Value>> push(const birch::type::Integer& x, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr) override;
  #line 53 "src/data/IntegerValue.birch"
  virtual libbirch::Lazy<libbirch::Shared<birch::type::Value>> push(const birch::type::Real& x, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr) override;
  #line 57 "src/data/IntegerValue.birch"
  virtual libbirch::Lazy<libbirch::Shared<birch::type::Value>> push(const birch::type::String& x, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr) override;
  #line 64 "src/data/IntegerValue.birch"
  virtual libbirch::Lazy<libbirch::Shared<birch::type::Value>> push(const libbirch::Lazy<libbirch::Shared<birch::type::Object>>& x, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr) override;
  #line 71 "src/data/IntegerValue.birch"
  virtual libbirch::Lazy<libbirch::Shared<birch::type::Value>> push(const libbirch::DefaultArray<birch::type::Boolean,1>& x, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr) override;
  #line 78 "src/data/IntegerValue.birch"
  virtual libbirch::Lazy<libbirch::Shared<birch::type::Value>> push(const libbirch::DefaultArray<birch::type::Integer,1>& x, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr) override;
  #line 85 "src/data/IntegerValue.birch"
  virtual libbirch::Lazy<libbirch::Shared<birch::type::Value>> push(const libbirch::DefaultArray<birch::type::Real,1>& x, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr) override;
  
  #line 4 "src/data/IntegerValue.birch"
  LIBBIRCH_CLASS(IntegerValue, Value)
  #line 4 "src/data/IntegerValue.birch"
  LIBBIRCH_MEMBERS(value)
};

#line 4 "src/data/BooleanVectorValue.birch"
class BooleanVectorValue final : public Value {
public:
  #line 4 "src/data/BooleanVectorValue.birch"
  using class_type_ = BooleanVectorValue;
  #line 4 "src/data/BooleanVectorValue.birch"
  using this_type_ = class_type_;
  #line 4 "src/data/BooleanVectorValue.birch"
  using super_type_ = Value;

  #line 4 "src/data/BooleanVectorValue.birch"
  using super_type_::operator=;
  #line 4 "src/data/BooleanVectorValue.birch"
  using super_type_::accept;
  #line 4 "src/data/BooleanVectorValue.birch"
  using super_type_::getBooleanMatrix;
  #line 4 "src/data/BooleanVectorValue.birch"
  using super_type_::getBooleanVector;
  #line 4 "src/data/BooleanVectorValue.birch"
  using super_type_::getIntegerMatrix;
  #line 4 "src/data/BooleanVectorValue.birch"
  using super_type_::getIntegerVector;
  #line 4 "src/data/BooleanVectorValue.birch"
  using super_type_::getRealMatrix;
  #line 4 "src/data/BooleanVectorValue.birch"
  using super_type_::getRealVector;
  #line 4 "src/data/BooleanVectorValue.birch"
  using super_type_::push;
  #line 4 "src/data/BooleanVectorValue.birch"
  using super_type_::pushNil;
  #line 4 "src/data/BooleanVectorValue.birch"
  using super_type_::size;
  
  #line 4 "src/data/BooleanVectorValue.birch"
  BooleanVectorValue(const libbirch::DefaultArray<birch::type::Boolean,1>& value, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);

  libbirch::DefaultArray<birch::type::Boolean,1> value;
  #line 10 "src/data/BooleanVectorValue.birch"
  virtual void accept(const libbirch::Lazy<libbirch::Shared<birch::type::Writer>>& writer, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr) override;
  #line 14 "src/data/BooleanVectorValue.birch"
  virtual birch::type::Integer size(const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr) override;
  #line 18 "src/data/BooleanVectorValue.birch"
  virtual libbirch::Optional<libbirch::DefaultArray<birch::type::Boolean,1>> getBooleanVector(const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr) override;
  #line 22 "src/data/BooleanVectorValue.birch"
  virtual libbirch::Optional<libbirch::DefaultArray<birch::type::Integer,1>> getIntegerVector(const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr) override;
  #line 26 "src/data/BooleanVectorValue.birch"
  virtual libbirch::Optional<libbirch::DefaultArray<birch::type::Real,1>> getRealVector(const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr) override;
  #line 30 "src/data/BooleanVectorValue.birch"
  virtual libbirch::Optional<libbirch::DefaultArray<birch::type::Boolean,2>> getBooleanMatrix(const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr) override;
  #line 34 "src/data/BooleanVectorValue.birch"
  virtual libbirch::Optional<libbirch::DefaultArray<birch::type::Integer,2>> getIntegerMatrix(const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr) override;
  #line 38 "src/data/BooleanVectorValue.birch"
  virtual libbirch::Optional<libbirch::DefaultArray<birch::type::Real,2>> getRealMatrix(const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr) override;
  #line 42 "src/data/BooleanVectorValue.birch"
  virtual libbirch::Lazy<libbirch::Shared<birch::type::Value>> pushNil(const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr) override;
  #line 51 "src/data/BooleanVectorValue.birch"
  virtual libbirch::Lazy<libbirch::Shared<birch::type::Value>> push(const birch::type::Boolean& x, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr) override;
  #line 58 "src/data/BooleanVectorValue.birch"
  virtual libbirch::Lazy<libbirch::Shared<birch::type::Value>> push(const birch::type::Integer& x, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr) override;
  #line 69 "src/data/BooleanVectorValue.birch"
  virtual libbirch::Lazy<libbirch::Shared<birch::type::Value>> push(const birch::type::Real& x, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr) override;
  #line 80 "src/data/BooleanVectorValue.birch"
  virtual libbirch::Lazy<libbirch::Shared<birch::type::Value>> push(const birch::type::String& x, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr) override;
  #line 89 "src/data/BooleanVectorValue.birch"
  virtual libbirch::Lazy<libbirch::Shared<birch::type::Value>> push(const libbirch::Lazy<libbirch::Shared<birch::type::Object>>& x, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr) override;
  #line 98 "src/data/BooleanVectorValue.birch"
  virtual libbirch::Lazy<libbirch::Shared<birch::type::Value>> push(const libbirch::DefaultArray<birch::type::Boolean,1>& x, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr) override;
  #line 105 "src/data/BooleanVectorValue.birch"
  virtual libbirch::Lazy<libbirch::Shared<birch::type::Value>> push(const libbirch::DefaultArray<birch::type::Integer,1>& x, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr) override;
  #line 112 "src/data/BooleanVectorValue.birch"
  virtual libbirch::Lazy<libbirch::Shared<birch::type::Value>> push(const libbirch::DefaultArray<birch::type::Real,1>& x, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr) override;
  
  #line 4 "src/data/BooleanVectorValue.birch"
  LIBBIRCH_CLASS(BooleanVectorValue, Value)
  #line 4 "src/data/BooleanVectorValue.birch"
  LIBBIRCH_MEMBERS(value)
};

#line 4 "src/data/BooleanValue.birch"
class BooleanValue final : public Value {
public:
  #line 4 "src/data/BooleanValue.birch"
  using class_type_ = BooleanValue;
  #line 4 "src/data/BooleanValue.birch"
  using this_type_ = class_type_;
  #line 4 "src/data/BooleanValue.birch"
  using super_type_ = Value;

  #line 4 "src/data/BooleanValue.birch"
  using super_type_::operator=;
  #line 4 "src/data/BooleanValue.birch"
  using super_type_::accept;
  #line 4 "src/data/BooleanValue.birch"
  using super_type_::getBoolean;
  #line 4 "src/data/BooleanValue.birch"
  using super_type_::getBooleanMatrix;
  #line 4 "src/data/BooleanValue.birch"
  using super_type_::getBooleanVector;
  #line 4 "src/data/BooleanValue.birch"
  using super_type_::getInteger;
  #line 4 "src/data/BooleanValue.birch"
  using super_type_::getIntegerMatrix;
  #line 4 "src/data/BooleanValue.birch"
  using super_type_::getIntegerVector;
  #line 4 "src/data/BooleanValue.birch"
  using super_type_::getReal;
  #line 4 "src/data/BooleanValue.birch"
  using super_type_::getRealMatrix;
  #line 4 "src/data/BooleanValue.birch"
  using super_type_::getRealVector;
  #line 4 "src/data/BooleanValue.birch"
  using super_type_::push;
  #line 4 "src/data/BooleanValue.birch"
  using super_type_::pushNil;
  
  #line 4 "src/data/BooleanValue.birch"
  BooleanValue(const birch::type::Boolean& value, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);

  birch::type::Boolean value;
  #line 10 "src/data/BooleanValue.birch"
  virtual void accept(const libbirch::Lazy<libbirch::Shared<birch::type::Writer>>& writer, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr) override;
  #line 14 "src/data/BooleanValue.birch"
  virtual libbirch::Optional<birch::type::Boolean> getBoolean(const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr) override;
  #line 18 "src/data/BooleanValue.birch"
  virtual libbirch::Optional<birch::type::Integer> getInteger(const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr) override;
  #line 22 "src/data/BooleanValue.birch"
  virtual libbirch::Optional<birch::type::Real> getReal(const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr) override;
  #line 26 "src/data/BooleanValue.birch"
  virtual libbirch::Optional<libbirch::DefaultArray<birch::type::Boolean,1>> getBooleanVector(const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr) override;
  #line 30 "src/data/BooleanValue.birch"
  virtual libbirch::Optional<libbirch::DefaultArray<birch::type::Integer,1>> getIntegerVector(const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr) override;
  #line 34 "src/data/BooleanValue.birch"
  virtual libbirch::Optional<libbirch::DefaultArray<birch::type::Real,1>> getRealVector(const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr) override;
  #line 38 "src/data/BooleanValue.birch"
  virtual libbirch::Optional<libbirch::DefaultArray<birch::type::Boolean,2>> getBooleanMatrix(const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr) override;
  #line 42 "src/data/BooleanValue.birch"
  virtual libbirch::Optional<libbirch::DefaultArray<birch::type::Integer,2>> getIntegerMatrix(const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr) override;
  #line 46 "src/data/BooleanValue.birch"
  virtual libbirch::Optional<libbirch::DefaultArray<birch::type::Real,2>> getRealMatrix(const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr) override;
  #line 50 "src/data/BooleanValue.birch"
  virtual libbirch::Lazy<libbirch::Shared<birch::type::Value>> pushNil(const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr) override;
  #line 57 "src/data/BooleanValue.birch"
  virtual libbirch::Lazy<libbirch::Shared<birch::type::Value>> push(const birch::type::Boolean& x, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr) override;
  #line 61 "src/data/BooleanValue.birch"
  virtual libbirch::Lazy<libbirch::Shared<birch::type::Value>> push(const birch::type::Integer& x, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr) override;
  #line 65 "src/data/BooleanValue.birch"
  virtual libbirch::Lazy<libbirch::Shared<birch::type::Value>> push(const birch::type::Real& x, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr) override;
  #line 69 "src/data/BooleanValue.birch"
  virtual libbirch::Lazy<libbirch::Shared<birch::type::Value>> push(const birch::type::String& x, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr) override;
  #line 76 "src/data/BooleanValue.birch"
  virtual libbirch::Lazy<libbirch::Shared<birch::type::Value>> push(const libbirch::Lazy<libbirch::Shared<birch::type::Object>>& x, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr) override;
  #line 83 "src/data/BooleanValue.birch"
  virtual libbirch::Lazy<libbirch::Shared<birch::type::Value>> push(const libbirch::DefaultArray<birch::type::Boolean,1>& x, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr) override;
  #line 90 "src/data/BooleanValue.birch"
  virtual libbirch::Lazy<libbirch::Shared<birch::type::Value>> push(const libbirch::DefaultArray<birch::type::Integer,1>& x, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr) override;
  #line 97 "src/data/BooleanValue.birch"
  virtual libbirch::Lazy<libbirch::Shared<birch::type::Value>> push(const libbirch::DefaultArray<birch::type::Real,1>& x, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr) override;
  
  #line 4 "src/data/BooleanValue.birch"
  LIBBIRCH_CLASS(BooleanValue, Value)
  #line 4 "src/data/BooleanValue.birch"
  LIBBIRCH_MEMBERS(value)
};

#line 4 "src/data/ArrayValue.birch"
class ArrayValue final : public Value {
public:
  #line 4 "src/data/ArrayValue.birch"
  using class_type_ = ArrayValue;
  #line 4 "src/data/ArrayValue.birch"
  using this_type_ = class_type_;
  #line 4 "src/data/ArrayValue.birch"
  using super_type_ = Value;

  #line 4 "src/data/ArrayValue.birch"
  using super_type_::operator=;
  #line 4 "src/data/ArrayValue.birch"
  using super_type_::accept;
  #line 4 "src/data/ArrayValue.birch"
  using super_type_::getBooleanMatrix;
  #line 4 "src/data/ArrayValue.birch"
  using super_type_::getIntegerMatrix;
  #line 4 "src/data/ArrayValue.birch"
  using super_type_::getRealMatrix;
  #line 4 "src/data/ArrayValue.birch"
  using super_type_::insert;
  #line 4 "src/data/ArrayValue.birch"
  using super_type_::push;
  #line 4 "src/data/ArrayValue.birch"
  using super_type_::pushNil;
  #line 4 "src/data/ArrayValue.birch"
  using super_type_::size;
  #line 4 "src/data/ArrayValue.birch"
  using super_type_::walk;
  
  #line 4 "src/data/ArrayValue.birch"
  ArrayValue(const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);

  libbirch::Lazy<libbirch::Shared<birch::type::Array<libbirch::Lazy<libbirch::Shared<birch::type::Buffer>>>>> elements;
  #line 11 "src/data/ArrayValue.birch"
  virtual void accept(const libbirch::Lazy<libbirch::Shared<birch::type::Writer>>& writer, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr) override;
  #line 15 "src/data/ArrayValue.birch"
  virtual birch::type::Integer size(const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr) override;
  #line 19 "src/data/ArrayValue.birch"
  virtual libbirch::Lazy<libbirch::Shared<birch::type::Iterator<libbirch::Lazy<libbirch::Shared<birch::type::Buffer>>>>> walk(const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr) override;
  #line 23 "src/data/ArrayValue.birch"
  virtual void insert(const libbirch::Lazy<libbirch::Shared<birch::type::Buffer>>& value, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr) override;
  #line 27 "src/data/ArrayValue.birch"
  virtual libbirch::Lazy<libbirch::Shared<birch::type::Value>> pushNil(const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr) override;
  #line 34 "src/data/ArrayValue.birch"
  virtual libbirch::Lazy<libbirch::Shared<birch::type::Value>> push(const birch::type::Boolean& x, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr) override;
  #line 39 "src/data/ArrayValue.birch"
  virtual libbirch::Lazy<libbirch::Shared<birch::type::Value>> push(const birch::type::Integer& x, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr) override;
  #line 44 "src/data/ArrayValue.birch"
  virtual libbirch::Lazy<libbirch::Shared<birch::type::Value>> push(const birch::type::Real& x, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr) override;
  #line 49 "src/data/ArrayValue.birch"
  virtual libbirch::Lazy<libbirch::Shared<birch::type::Value>> push(const birch::type::String& x, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr) override;
  #line 54 "src/data/ArrayValue.birch"
  virtual libbirch::Lazy<libbirch::Shared<birch::type::Value>> push(const libbirch::Lazy<libbirch::Shared<birch::type::Object>>& x, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr) override;
  #line 59 "src/data/ArrayValue.birch"
  virtual libbirch::Lazy<libbirch::Shared<birch::type::Value>> push(const libbirch::DefaultArray<birch::type::Boolean,1>& x, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr) override;
  #line 64 "src/data/ArrayValue.birch"
  virtual libbirch::Lazy<libbirch::Shared<birch::type::Value>> push(const libbirch::DefaultArray<birch::type::Integer,1>& x, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr) override;
  #line 69 "src/data/ArrayValue.birch"
  virtual libbirch::Lazy<libbirch::Shared<birch::type::Value>> push(const libbirch::DefaultArray<birch::type::Real,1>& x, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr) override;
  #line 74 "src/data/ArrayValue.birch"
  virtual libbirch::Optional<libbirch::DefaultArray<birch::type::Boolean,2>> getBooleanMatrix(const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr) override;
  #line 114 "src/data/ArrayValue.birch"
  virtual libbirch::Optional<libbirch::DefaultArray<birch::type::Integer,2>> getIntegerMatrix(const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr) override;
  #line 154 "src/data/ArrayValue.birch"
  virtual libbirch::Optional<libbirch::DefaultArray<birch::type::Real,2>> getRealMatrix(const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr) override;
  
  #line 4 "src/data/ArrayValue.birch"
  LIBBIRCH_CLASS(ArrayValue, Value)
  #line 4 "src/data/ArrayValue.birch"
  LIBBIRCH_MEMBERS(elements)
};

#line 4 "src/data/ArrayValue.birch"
extern "C" birch::type::ArrayValue* make_ArrayValue_();

#line 7 "src/distribution/DelayDistribution.birch"
class DelayDistribution : public Object {
public:
  #line 7 "src/distribution/DelayDistribution.birch"
  using class_type_ = DelayDistribution;
  #line 7 "src/distribution/DelayDistribution.birch"
  using this_type_ = class_type_;
  #line 7 "src/distribution/DelayDistribution.birch"
  using super_type_ = Object;

  #line 7 "src/distribution/DelayDistribution.birch"
  using super_type_::operator=;
  
  #line 7 "src/distribution/DelayDistribution.birch"
  DelayDistribution(const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);

  libbirch::Optional<libbirch::Lazy<libbirch::Shared<birch::type::DelayDistribution>>> child;
  #line 16 "src/distribution/DelayDistribution.birch"
  virtual void realize(const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr) = 0;
  #line 21 "src/distribution/DelayDistribution.birch"
  virtual void prune(const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr) final;
  #line 34 "src/distribution/DelayDistribution.birch"
  virtual void setChild(const libbirch::Lazy<libbirch::Shared<birch::type::DelayDistribution>>& child, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr) final;
  #line 46 "src/distribution/DelayDistribution.birch"
  virtual void releaseChild(const libbirch::Lazy<libbirch::Shared<birch::type::DelayDistribution>>& child, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr) final;
  #line 54 "src/distribution/DelayDistribution.birch"
  virtual void link(const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
  #line 61 "src/distribution/DelayDistribution.birch"
  virtual void unlink(const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
  
  #line 7 "src/distribution/DelayDistribution.birch"
  LIBBIRCH_ABSTRACT_CLASS(DelayDistribution, Object)
  #line 7 "src/distribution/DelayDistribution.birch"
  LIBBIRCH_MEMBERS(child)
};

template<class Value>
#line 6 "src/distribution/Distribution.birch"
class Distribution : public DelayDistribution {
public:
  #line 6 "src/distribution/Distribution.birch"
  using class_type_ = Distribution<Value>;
  #line 6 "src/distribution/Distribution.birch"
  using this_type_ = class_type_;
  #line 6 "src/distribution/Distribution.birch"
  using super_type_ = DelayDistribution;

  #line 6 "src/distribution/Distribution.birch"
  using super_type_::operator=;
  #line 6 "src/distribution/Distribution.birch"
  using super_type_::realize;
  
  #line 6 "src/distribution/Distribution.birch"
  Distribution(const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);

  libbirch::Optional<libbirch::Lazy<libbirch::Shared<birch::type::Random<Value>>>> x;
  #line 16 "src/distribution/Distribution.birch"
  virtual birch::type::Integer rows(const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
  #line 23 "src/distribution/Distribution.birch"
  virtual birch::type::Integer columns(const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
  #line 30 "src/distribution/Distribution.birch"
  virtual birch::type::Boolean supportsLazy(const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
  #line 37 "src/distribution/Distribution.birch"
  virtual libbirch::Lazy<libbirch::Shared<birch::type::Distribution<Value>>> distribution(const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr) final;
  #line 44 "src/distribution/Distribution.birch"
  virtual void setRandom(const libbirch::Lazy<libbirch::Shared<birch::type::Random<Value>>>& x, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr) final;
  #line 52 "src/distribution/Distribution.birch"
  virtual void unsetRandom(const libbirch::Lazy<libbirch::Shared<birch::type::Random<Value>>>& x, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr) final;
  #line 60 "src/distribution/Distribution.birch"
  virtual void realize(const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr) final;
  #line 73 "src/distribution/Distribution.birch"
  virtual Value value(const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
  #line 86 "src/distribution/Distribution.birch"
  virtual birch::type::Real observe(const Value& x, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr) final;
  #line 102 "src/distribution/Distribution.birch"
  virtual libbirch::Optional<libbirch::Lazy<libbirch::Shared<birch::type::Expression<birch::type::Real>>>> observeLazy(const libbirch::Lazy<libbirch::Shared<birch::type::Expression<Value>>>& x, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr) final;
  #line 116 "src/distribution/Distribution.birch"
  virtual Value simulate(const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr) = 0;
  #line 123 "src/distribution/Distribution.birch"
  virtual libbirch::Optional<Value> simulateLazy(const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
  #line 134 "src/distribution/Distribution.birch"
  virtual birch::type::Real logpdf(const Value& x, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr) = 0;
  #line 143 "src/distribution/Distribution.birch"
  virtual libbirch::Optional<libbirch::Lazy<libbirch::Shared<birch::type::Expression<birch::type::Real>>>> logpdfLazy(const libbirch::Lazy<libbirch::Shared<birch::type::Expression<Value>>>& x, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
  #line 152 "src/distribution/Distribution.birch"
  virtual void update(const Value& x, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
  #line 161 "src/distribution/Distribution.birch"
  virtual void updateLazy(const libbirch::Lazy<libbirch::Shared<birch::type::Expression<Value>>>& x, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
  #line 172 "src/distribution/Distribution.birch"
  virtual birch::type::Real pdf(const Value& x, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
  #line 183 "src/distribution/Distribution.birch"
  virtual libbirch::Optional<birch::type::Real> cdf(const Value& x, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
  #line 194 "src/distribution/Distribution.birch"
  virtual libbirch::Optional<Value> quantile(const birch::type::Real& P, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
  #line 201 "src/distribution/Distribution.birch"
  virtual libbirch::Optional<Value> lower(const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
  #line 208 "src/distribution/Distribution.birch"
  virtual libbirch::Optional<Value> upper(const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
  #line 219 "src/distribution/Distribution.birch"
  virtual libbirch::Lazy<libbirch::Shared<birch::type::Distribution<Value>>> graft(const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
  #line 227 "src/distribution/Distribution.birch"
  virtual libbirch::Optional<libbirch::Lazy<libbirch::Shared<birch::type::Gaussian>>> graftGaussian(const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
  #line 234 "src/distribution/Distribution.birch"
  virtual libbirch::Optional<libbirch::Lazy<libbirch::Shared<birch::type::Beta>>> graftBeta(const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
  #line 241 "src/distribution/Distribution.birch"
  virtual libbirch::Optional<libbirch::Lazy<libbirch::Shared<birch::type::Gamma>>> graftGamma(const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
  #line 248 "src/distribution/Distribution.birch"
  virtual libbirch::Optional<libbirch::Lazy<libbirch::Shared<birch::type::InverseGamma>>> graftInverseGamma(const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
  #line 255 "src/distribution/Distribution.birch"
  virtual libbirch::Optional<libbirch::Lazy<libbirch::Shared<birch::type::InverseWishart>>> graftInverseWishart(const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
  #line 262 "src/distribution/Distribution.birch"
  virtual libbirch::Optional<libbirch::Lazy<libbirch::Shared<birch::type::NormalInverseGamma>>> graftNormalInverseGamma(const libbirch::Lazy<libbirch::Shared<birch::type::Distribution<birch::type::Real>>>& compare, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
  #line 269 "src/distribution/Distribution.birch"
  virtual libbirch::Optional<libbirch::Lazy<libbirch::Shared<birch::type::Dirichlet>>> graftDirichlet(const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
  #line 276 "src/distribution/Distribution.birch"
  virtual libbirch::Optional<libbirch::Lazy<libbirch::Shared<birch::type::Restaurant>>> graftRestaurant(const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
  #line 283 "src/distribution/Distribution.birch"
  virtual libbirch::Optional<libbirch::Lazy<libbirch::Shared<birch::type::MultivariateGaussian>>> graftMultivariateGaussian(const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
  #line 290 "src/distribution/Distribution.birch"
  virtual libbirch::Optional<libbirch::Lazy<libbirch::Shared<birch::type::MultivariateNormalInverseGamma>>> graftMultivariateNormalInverseGamma(const libbirch::Lazy<libbirch::Shared<birch::type::Distribution<birch::type::Real>>>& compare, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
  #line 298 "src/distribution/Distribution.birch"
  virtual libbirch::Optional<libbirch::Lazy<libbirch::Shared<birch::type::MatrixGaussian>>> graftMatrixGaussian(const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
  #line 305 "src/distribution/Distribution.birch"
  virtual libbirch::Optional<libbirch::Lazy<libbirch::Shared<birch::type::MatrixNormalInverseWishart>>> graftMatrixNormalInverseWishart(const libbirch::Lazy<libbirch::Shared<birch::type::Distribution<birch::type::LLT>>>& compare, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
  #line 313 "src/distribution/Distribution.birch"
  virtual libbirch::Optional<libbirch::Lazy<libbirch::Shared<birch::type::Discrete>>> graftDiscrete(const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
  #line 320 "src/distribution/Distribution.birch"
  virtual libbirch::Optional<libbirch::Lazy<libbirch::Shared<birch::type::BoundedDiscrete>>> graftBoundedDiscrete(const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
  
  #line 6 "src/distribution/Distribution.birch"
  LIBBIRCH_ABSTRACT_CLASS(Distribution, DelayDistribution)
  #line 6 "src/distribution/Distribution.birch"
  LIBBIRCH_MEMBERS(x)
};

#line 4 "src/distribution/Discrete.birch"
class Discrete : public Distribution<birch::type::Integer> {
public:
  #line 4 "src/distribution/Discrete.birch"
  using class_type_ = Discrete;
  #line 4 "src/distribution/Discrete.birch"
  using this_type_ = class_type_;
  #line 4 "src/distribution/Discrete.birch"
  using super_type_ = Distribution<birch::type::Integer>;

  #line 4 "src/distribution/Discrete.birch"
  using super_type_::operator=;
  #line 4 "src/distribution/Discrete.birch"
  using super_type_::graftDiscrete;
  
  #line 4 "src/distribution/Discrete.birch"
  Discrete(const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);

  libbirch::Optional<birch::type::Integer> value;
  #line 15 "src/distribution/Discrete.birch"
  virtual void clamp(const birch::type::Integer& x, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
  #line 20 "src/distribution/Discrete.birch"
  virtual libbirch::Optional<libbirch::Lazy<libbirch::Shared<birch::type::Discrete>>> graftDiscrete(const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
  
  #line 4 "src/distribution/Discrete.birch"
  LIBBIRCH_ABSTRACT_CLASS(Discrete, Distribution<birch::type::Integer>)
  #line 4 "src/distribution/Discrete.birch"
  LIBBIRCH_MEMBERS(value)
};

#line 1 "src/distribution/Delta.birch"
class Delta : public Discrete {
public:
  #line 1 "src/distribution/Delta.birch"
  using class_type_ = Delta;
  #line 1 "src/distribution/Delta.birch"
  using this_type_ = class_type_;
  #line 1 "src/distribution/Delta.birch"
  using super_type_ = Discrete;

  #line 1 "src/distribution/Delta.birch"
  using super_type_::operator=;
  #line 1 "src/distribution/Delta.birch"
  using super_type_::graft;
  #line 1 "src/distribution/Delta.birch"
  using super_type_::logpdf;
  #line 1 "src/distribution/Delta.birch"
  using super_type_::lower;
  #line 1 "src/distribution/Delta.birch"
  using super_type_::simulate;
  #line 1 "src/distribution/Delta.birch"
  using super_type_::supportsLazy;
  #line 1 "src/distribution/Delta.birch"
  using super_type_::upper;
  
  #line 1 "src/distribution/Delta.birch"
  Delta(const libbirch::Lazy<libbirch::Shared<birch::type::Expression<birch::type::Integer>>>& _u0956, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);

  libbirch::Lazy<libbirch::Shared<birch::type::Expression<birch::type::Integer>>> _u0956;
  #line 11 "src/distribution/Delta.birch"
  virtual birch::type::Boolean supportsLazy(const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
  #line 15 "src/distribution/Delta.birch"
  virtual birch::type::Integer simulate(const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
  #line 31 "src/distribution/Delta.birch"
  virtual birch::type::Real logpdf(const birch::type::Integer& x, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
  #line 39 "src/distribution/Delta.birch"
  virtual libbirch::Optional<birch::type::Integer> lower(const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
  #line 43 "src/distribution/Delta.birch"
  virtual libbirch::Optional<birch::type::Integer> upper(const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
  #line 47 "src/distribution/Delta.birch"
  virtual libbirch::Lazy<libbirch::Shared<birch::type::Distribution<birch::type::Integer>>> graft(const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
  #line 60 "src/distribution/Delta.birch"
  virtual void write(const libbirch::Lazy<libbirch::Shared<birch::type::Buffer>>& buffer, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
  
  #line 1 "src/distribution/Delta.birch"
  LIBBIRCH_CLASS(Delta, Discrete)
  #line 1 "src/distribution/Delta.birch"
  LIBBIRCH_MEMBERS(_u0956)
};

#line 4 "src/distribution/BoundedDiscrete.birch"
class BoundedDiscrete : public Discrete {
public:
  #line 4 "src/distribution/BoundedDiscrete.birch"
  using class_type_ = BoundedDiscrete;
  #line 4 "src/distribution/BoundedDiscrete.birch"
  using this_type_ = class_type_;
  #line 4 "src/distribution/BoundedDiscrete.birch"
  using super_type_ = Discrete;

  #line 4 "src/distribution/BoundedDiscrete.birch"
  using super_type_::operator=;
  #line 4 "src/distribution/BoundedDiscrete.birch"
  using super_type_::graftBoundedDiscrete;
  #line 4 "src/distribution/BoundedDiscrete.birch"
  using super_type_::lower;
  #line 4 "src/distribution/BoundedDiscrete.birch"
  using super_type_::upper;
  
  #line 4 "src/distribution/BoundedDiscrete.birch"
  BoundedDiscrete(const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);

  #line 5 "src/distribution/BoundedDiscrete.birch"
  virtual libbirch::Optional<birch::type::Integer> lower(const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr) = 0;
  #line 6 "src/distribution/BoundedDiscrete.birch"
  virtual libbirch::Optional<birch::type::Integer> upper(const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr) = 0;
  #line 8 "src/distribution/BoundedDiscrete.birch"
  virtual libbirch::Optional<libbirch::Lazy<libbirch::Shared<birch::type::BoundedDiscrete>>> graftBoundedDiscrete(const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
  
  #line 4 "src/distribution/BoundedDiscrete.birch"
  LIBBIRCH_ABSTRACT_CLASS(BoundedDiscrete, Discrete)
  #line 4 "src/distribution/BoundedDiscrete.birch"
  LIBBIRCH_MEMBERS()
};

#line 1 "src/distribution/Binomial.birch"
class Binomial : public BoundedDiscrete {
public:
  #line 1 "src/distribution/Binomial.birch"
  using class_type_ = Binomial;
  #line 1 "src/distribution/Binomial.birch"
  using this_type_ = class_type_;
  #line 1 "src/distribution/Binomial.birch"
  using super_type_ = BoundedDiscrete;

  #line 1 "src/distribution/Binomial.birch"
  using super_type_::operator=;
  #line 1 "src/distribution/Binomial.birch"
  using super_type_::cdf;
  #line 1 "src/distribution/Binomial.birch"
  using super_type_::graft;
  #line 1 "src/distribution/Binomial.birch"
  using super_type_::graftBoundedDiscrete;
  #line 1 "src/distribution/Binomial.birch"
  using super_type_::graftDiscrete;
  #line 1 "src/distribution/Binomial.birch"
  using super_type_::logpdf;
  #line 1 "src/distribution/Binomial.birch"
  using super_type_::logpdfLazy;
  #line 1 "src/distribution/Binomial.birch"
  using super_type_::lower;
  #line 1 "src/distribution/Binomial.birch"
  using super_type_::quantile;
  #line 1 "src/distribution/Binomial.birch"
  using super_type_::simulate;
  #line 1 "src/distribution/Binomial.birch"
  using super_type_::simulateLazy;
  #line 1 "src/distribution/Binomial.birch"
  using super_type_::supportsLazy;
  #line 1 "src/distribution/Binomial.birch"
  using super_type_::upper;
  
  #line 1 "src/distribution/Binomial.birch"
  Binomial(const libbirch::Lazy<libbirch::Shared<birch::type::Expression<birch::type::Integer>>>& n, const libbirch::Lazy<libbirch::Shared<birch::type::Expression<birch::type::Real>>>& _u0961, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);

  libbirch::Lazy<libbirch::Shared<birch::type::Expression<birch::type::Integer>>> n;
  libbirch::Lazy<libbirch::Shared<birch::type::Expression<birch::type::Real>>> _u0961;
  #line 15 "src/distribution/Binomial.birch"
  virtual birch::type::Boolean supportsLazy(const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
  #line 19 "src/distribution/Binomial.birch"
  virtual birch::type::Integer simulate(const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
  #line 27 "src/distribution/Binomial.birch"
  virtual libbirch::Optional<birch::type::Integer> simulateLazy(const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
  #line 35 "src/distribution/Binomial.birch"
  virtual birch::type::Real logpdf(const birch::type::Integer& x, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
  #line 39 "src/distribution/Binomial.birch"
  virtual libbirch::Optional<libbirch::Lazy<libbirch::Shared<birch::type::Expression<birch::type::Real>>>> logpdfLazy(const libbirch::Lazy<libbirch::Shared<birch::type::Expression<birch::type::Integer>>>& x, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
  #line 43 "src/distribution/Binomial.birch"
  virtual libbirch::Optional<birch::type::Real> cdf(const birch::type::Integer& x, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
  #line 47 "src/distribution/Binomial.birch"
  virtual libbirch::Optional<birch::type::Integer> quantile(const birch::type::Real& P, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
  #line 51 "src/distribution/Binomial.birch"
  virtual libbirch::Optional<birch::type::Integer> lower(const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
  #line 55 "src/distribution/Binomial.birch"
  virtual libbirch::Optional<birch::type::Integer> upper(const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
  #line 59 "src/distribution/Binomial.birch"
  virtual libbirch::Lazy<libbirch::Shared<birch::type::Distribution<birch::type::Integer>>> graft(const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
  #line 72 "src/distribution/Binomial.birch"
  virtual libbirch::Optional<libbirch::Lazy<libbirch::Shared<birch::type::Discrete>>> graftDiscrete(const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
  #line 76 "src/distribution/Binomial.birch"
  virtual libbirch::Optional<libbirch::Lazy<libbirch::Shared<birch::type::BoundedDiscrete>>> graftBoundedDiscrete(const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
  #line 80 "src/distribution/Binomial.birch"
  virtual void write(const libbirch::Lazy<libbirch::Shared<birch::type::Buffer>>& buffer, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
  
  #line 1 "src/distribution/Binomial.birch"
  LIBBIRCH_CLASS(Binomial, BoundedDiscrete)
  #line 1 "src/distribution/Binomial.birch"
  LIBBIRCH_MEMBERS(n, _u0961)
};

#line 4 "src/distribution/BetaBinomial.birch"
class BetaBinomial final : public BoundedDiscrete {
public:
  #line 4 "src/distribution/BetaBinomial.birch"
  using class_type_ = BetaBinomial;
  #line 4 "src/distribution/BetaBinomial.birch"
  using this_type_ = class_type_;
  #line 4 "src/distribution/BetaBinomial.birch"
  using super_type_ = BoundedDiscrete;

  #line 4 "src/distribution/BetaBinomial.birch"
  using super_type_::operator=;
  #line 4 "src/distribution/BetaBinomial.birch"
  using super_type_::cdf;
  #line 4 "src/distribution/BetaBinomial.birch"
  using super_type_::link;
  #line 4 "src/distribution/BetaBinomial.birch"
  using super_type_::logpdf;
  #line 4 "src/distribution/BetaBinomial.birch"
  using super_type_::logpdfLazy;
  #line 4 "src/distribution/BetaBinomial.birch"
  using super_type_::lower;
  #line 4 "src/distribution/BetaBinomial.birch"
  using super_type_::simulate;
  #line 4 "src/distribution/BetaBinomial.birch"
  using super_type_::simulateLazy;
  #line 4 "src/distribution/BetaBinomial.birch"
  using super_type_::supportsLazy;
  #line 4 "src/distribution/BetaBinomial.birch"
  using super_type_::unlink;
  #line 4 "src/distribution/BetaBinomial.birch"
  using super_type_::update;
  #line 4 "src/distribution/BetaBinomial.birch"
  using super_type_::updateLazy;
  #line 4 "src/distribution/BetaBinomial.birch"
  using super_type_::upper;
  
  #line 4 "src/distribution/BetaBinomial.birch"
  BetaBinomial(const libbirch::Lazy<libbirch::Shared<birch::type::Expression<birch::type::Integer>>>& n, const libbirch::Lazy<libbirch::Shared<birch::type::Beta>>& _u0961, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);

  libbirch::Lazy<libbirch::Shared<birch::type::Expression<birch::type::Integer>>> n;
  libbirch::Lazy<libbirch::Shared<birch::type::Beta>> _u0961;
  #line 15 "src/distribution/BetaBinomial.birch"
  virtual birch::type::Boolean supportsLazy(const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
  #line 19 "src/distribution/BetaBinomial.birch"
  virtual birch::type::Integer simulate(const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
  #line 27 "src/distribution/BetaBinomial.birch"
  virtual libbirch::Optional<birch::type::Integer> simulateLazy(const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
  #line 35 "src/distribution/BetaBinomial.birch"
  virtual birch::type::Real logpdf(const birch::type::Integer& x, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
  #line 39 "src/distribution/BetaBinomial.birch"
  virtual libbirch::Optional<libbirch::Lazy<libbirch::Shared<birch::type::Expression<birch::type::Real>>>> logpdfLazy(const libbirch::Lazy<libbirch::Shared<birch::type::Expression<birch::type::Integer>>>& x, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
  #line 43 "src/distribution/BetaBinomial.birch"
  virtual void update(const birch::type::Integer& x, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
  #line 47 "src/distribution/BetaBinomial.birch"
  virtual void updateLazy(const libbirch::Lazy<libbirch::Shared<birch::type::Expression<birch::type::Integer>>>& x, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
  #line 51 "src/distribution/BetaBinomial.birch"
  virtual libbirch::Optional<birch::type::Real> cdf(const birch::type::Integer& x, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
  #line 55 "src/distribution/BetaBinomial.birch"
  virtual libbirch::Optional<birch::type::Integer> lower(const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
  #line 59 "src/distribution/BetaBinomial.birch"
  virtual libbirch::Optional<birch::type::Integer> upper(const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
  #line 63 "src/distribution/BetaBinomial.birch"
  virtual void link(const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
  #line 67 "src/distribution/BetaBinomial.birch"
  virtual void unlink(const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
  
  #line 4 "src/distribution/BetaBinomial.birch"
  LIBBIRCH_CLASS(BetaBinomial, BoundedDiscrete)
  #line 4 "src/distribution/BetaBinomial.birch"
  LIBBIRCH_MEMBERS(n, _u0961)
};

#line 4 "src/distribution/AddBoundedDiscrete.birch"
class AddBoundedDiscrete final : public BoundedDiscrete {
public:
  #line 4 "src/distribution/AddBoundedDiscrete.birch"
  using class_type_ = AddBoundedDiscrete;
  #line 4 "src/distribution/AddBoundedDiscrete.birch"
  using this_type_ = class_type_;
  #line 4 "src/distribution/AddBoundedDiscrete.birch"
  using super_type_ = BoundedDiscrete;

  #line 4 "src/distribution/AddBoundedDiscrete.birch"
  using super_type_::operator=;
  #line 4 "src/distribution/AddBoundedDiscrete.birch"
  using super_type_::cdf;
  #line 4 "src/distribution/AddBoundedDiscrete.birch"
  using super_type_::link;
  #line 4 "src/distribution/AddBoundedDiscrete.birch"
  using super_type_::logpdf;
  #line 4 "src/distribution/AddBoundedDiscrete.birch"
  using super_type_::lower;
  #line 4 "src/distribution/AddBoundedDiscrete.birch"
  using super_type_::simulate;
  #line 4 "src/distribution/AddBoundedDiscrete.birch"
  using super_type_::unlink;
  #line 4 "src/distribution/AddBoundedDiscrete.birch"
  using super_type_::update;
  #line 4 "src/distribution/AddBoundedDiscrete.birch"
  using super_type_::upper;
  
  #line 4 "src/distribution/AddBoundedDiscrete.birch"
  AddBoundedDiscrete(const libbirch::Lazy<libbirch::Shared<birch::type::BoundedDiscrete>>& x1, const libbirch::Lazy<libbirch::Shared<birch::type::BoundedDiscrete>>& x2, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);

  libbirch::Lazy<libbirch::Shared<birch::type::BoundedDiscrete>> x1;
  libbirch::Lazy<libbirch::Shared<birch::type::BoundedDiscrete>> x2;
  libbirch::Optional<birch::type::Integer> x;
  birch::type::Integer x0;
  libbirch::DefaultArray<birch::type::Real,1> z;
  birch::type::Real Z;
  birch::type::Boolean alreadyUpdated;
  #line 45 "src/distribution/AddBoundedDiscrete.birch"
  virtual void enumerate(const birch::type::Integer& x, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
  #line 68 "src/distribution/AddBoundedDiscrete.birch"
  virtual birch::type::Integer simulate(const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
  #line 84 "src/distribution/AddBoundedDiscrete.birch"
  virtual birch::type::Real logpdf(const birch::type::Integer& x, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
  #line 102 "src/distribution/AddBoundedDiscrete.birch"
  virtual void update(const birch::type::Integer& x, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
  #line 117 "src/distribution/AddBoundedDiscrete.birch"
  virtual libbirch::Optional<birch::type::Real> cdf(const birch::type::Integer& x, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
  #line 125 "src/distribution/AddBoundedDiscrete.birch"
  virtual libbirch::Optional<birch::type::Integer> lower(const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
  #line 129 "src/distribution/AddBoundedDiscrete.birch"
  virtual libbirch::Optional<birch::type::Integer> upper(const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
  #line 133 "src/distribution/AddBoundedDiscrete.birch"
  virtual void link(const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
  #line 139 "src/distribution/AddBoundedDiscrete.birch"
  virtual void unlink(const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
  
  #line 4 "src/distribution/AddBoundedDiscrete.birch"
  LIBBIRCH_CLASS(AddBoundedDiscrete, BoundedDiscrete)
  #line 4 "src/distribution/AddBoundedDiscrete.birch"
  LIBBIRCH_MEMBERS(x1, x2, x, x0, z, Z, alreadyUpdated)
};

#line 5 "src/distribution/LinearBoundedDiscrete.birch"
class LinearBoundedDiscrete final : public BoundedDiscrete {
public:
  #line 5 "src/distribution/LinearBoundedDiscrete.birch"
  using class_type_ = LinearBoundedDiscrete;
  #line 5 "src/distribution/LinearBoundedDiscrete.birch"
  using this_type_ = class_type_;
  #line 5 "src/distribution/LinearBoundedDiscrete.birch"
  using super_type_ = BoundedDiscrete;

  #line 5 "src/distribution/LinearBoundedDiscrete.birch"
  using super_type_::operator=;
  #line 5 "src/distribution/LinearBoundedDiscrete.birch"
  using super_type_::cdf;
  #line 5 "src/distribution/LinearBoundedDiscrete.birch"
  using super_type_::link;
  #line 5 "src/distribution/LinearBoundedDiscrete.birch"
  using super_type_::logpdf;
  #line 5 "src/distribution/LinearBoundedDiscrete.birch"
  using super_type_::lower;
  #line 5 "src/distribution/LinearBoundedDiscrete.birch"
  using super_type_::simulate;
  #line 5 "src/distribution/LinearBoundedDiscrete.birch"
  using super_type_::supportsLazy;
  #line 5 "src/distribution/LinearBoundedDiscrete.birch"
  using super_type_::unlink;
  #line 5 "src/distribution/LinearBoundedDiscrete.birch"
  using super_type_::update;
  #line 5 "src/distribution/LinearBoundedDiscrete.birch"
  using super_type_::upper;
  
  #line 5 "src/distribution/LinearBoundedDiscrete.birch"
  LinearBoundedDiscrete(const libbirch::Lazy<libbirch::Shared<birch::type::Expression<birch::type::Integer>>>& a, const libbirch::Lazy<libbirch::Shared<birch::type::BoundedDiscrete>>& _u0956, const libbirch::Lazy<libbirch::Shared<birch::type::Expression<birch::type::Integer>>>& c, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);

  libbirch::Lazy<libbirch::Shared<birch::type::Expression<birch::type::Integer>>> a;
  libbirch::Lazy<libbirch::Shared<birch::type::BoundedDiscrete>> _u0956;
  libbirch::Lazy<libbirch::Shared<birch::type::Expression<birch::type::Integer>>> c;
  #line 22 "src/distribution/LinearBoundedDiscrete.birch"
  virtual birch::type::Boolean supportsLazy(const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
  #line 26 "src/distribution/LinearBoundedDiscrete.birch"
  virtual birch::type::Integer simulate(const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
  #line 42 "src/distribution/LinearBoundedDiscrete.birch"
  virtual birch::type::Real logpdf(const birch::type::Integer& x, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
  #line 58 "src/distribution/LinearBoundedDiscrete.birch"
  virtual void update(const birch::type::Integer& x, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
  #line 66 "src/distribution/LinearBoundedDiscrete.birch"
  virtual libbirch::Optional<birch::type::Real> cdf(const birch::type::Integer& x, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
  #line 70 "src/distribution/LinearBoundedDiscrete.birch"
  virtual libbirch::Optional<birch::type::Integer> lower(const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
  #line 79 "src/distribution/LinearBoundedDiscrete.birch"
  virtual libbirch::Optional<birch::type::Integer> upper(const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
  #line 88 "src/distribution/LinearBoundedDiscrete.birch"
  virtual void link(const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
  #line 93 "src/distribution/LinearBoundedDiscrete.birch"
  virtual void unlink(const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
  
  #line 5 "src/distribution/LinearBoundedDiscrete.birch"
  LIBBIRCH_CLASS(LinearBoundedDiscrete, BoundedDiscrete)
  #line 5 "src/distribution/LinearBoundedDiscrete.birch"
  LIBBIRCH_MEMBERS(a, _u0956, c)
};

#line 5 "src/distribution/SubtractBoundedDiscrete.birch"
class SubtractBoundedDiscrete final : public BoundedDiscrete {
public:
  #line 5 "src/distribution/SubtractBoundedDiscrete.birch"
  using class_type_ = SubtractBoundedDiscrete;
  #line 5 "src/distribution/SubtractBoundedDiscrete.birch"
  using this_type_ = class_type_;
  #line 5 "src/distribution/SubtractBoundedDiscrete.birch"
  using super_type_ = BoundedDiscrete;

  #line 5 "src/distribution/SubtractBoundedDiscrete.birch"
  using super_type_::operator=;
  #line 5 "src/distribution/SubtractBoundedDiscrete.birch"
  using super_type_::cdf;
  #line 5 "src/distribution/SubtractBoundedDiscrete.birch"
  using super_type_::link;
  #line 5 "src/distribution/SubtractBoundedDiscrete.birch"
  using super_type_::logpdf;
  #line 5 "src/distribution/SubtractBoundedDiscrete.birch"
  using super_type_::lower;
  #line 5 "src/distribution/SubtractBoundedDiscrete.birch"
  using super_type_::simulate;
  #line 5 "src/distribution/SubtractBoundedDiscrete.birch"
  using super_type_::supportsLazy;
  #line 5 "src/distribution/SubtractBoundedDiscrete.birch"
  using super_type_::unlink;
  #line 5 "src/distribution/SubtractBoundedDiscrete.birch"
  using super_type_::update;
  #line 5 "src/distribution/SubtractBoundedDiscrete.birch"
  using super_type_::upper;
  
  #line 5 "src/distribution/SubtractBoundedDiscrete.birch"
  SubtractBoundedDiscrete(const libbirch::Lazy<libbirch::Shared<birch::type::BoundedDiscrete>>& x1, const libbirch::Lazy<libbirch::Shared<birch::type::BoundedDiscrete>>& x2, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);

  libbirch::Lazy<libbirch::Shared<birch::type::BoundedDiscrete>> x1;
  libbirch::Lazy<libbirch::Shared<birch::type::BoundedDiscrete>> x2;
  libbirch::Optional<birch::type::Integer> x;
  birch::type::Integer x0;
  libbirch::DefaultArray<birch::type::Real,1> z;
  birch::type::Real Z;
  birch::type::Boolean alreadyUpdated;
  #line 45 "src/distribution/SubtractBoundedDiscrete.birch"
  virtual void enumerate(const birch::type::Integer& x, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
  #line 64 "src/distribution/SubtractBoundedDiscrete.birch"
  virtual birch::type::Boolean supportsLazy(const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
  #line 68 "src/distribution/SubtractBoundedDiscrete.birch"
  virtual birch::type::Integer simulate(const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
  #line 84 "src/distribution/SubtractBoundedDiscrete.birch"
  virtual birch::type::Real logpdf(const birch::type::Integer& x, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
  #line 102 "src/distribution/SubtractBoundedDiscrete.birch"
  virtual void update(const birch::type::Integer& x, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
  #line 117 "src/distribution/SubtractBoundedDiscrete.birch"
  virtual libbirch::Optional<birch::type::Real> cdf(const birch::type::Integer& x, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
  #line 125 "src/distribution/SubtractBoundedDiscrete.birch"
  virtual libbirch::Optional<birch::type::Integer> lower(const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
  #line 129 "src/distribution/SubtractBoundedDiscrete.birch"
  virtual libbirch::Optional<birch::type::Integer> upper(const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
  #line 133 "src/distribution/SubtractBoundedDiscrete.birch"
  virtual void link(const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
  #line 139 "src/distribution/SubtractBoundedDiscrete.birch"
  virtual void unlink(const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
  
  #line 5 "src/distribution/SubtractBoundedDiscrete.birch"
  LIBBIRCH_CLASS(SubtractBoundedDiscrete, BoundedDiscrete)
  #line 5 "src/distribution/SubtractBoundedDiscrete.birch"
  LIBBIRCH_MEMBERS(x1, x2, x, x0, z, Z, alreadyUpdated)
};

#line 4 "src/distribution/UniformInteger.birch"
class UniformInteger final : public BoundedDiscrete {
public:
  #line 4 "src/distribution/UniformInteger.birch"
  using class_type_ = UniformInteger;
  #line 4 "src/distribution/UniformInteger.birch"
  using this_type_ = class_type_;
  #line 4 "src/distribution/UniformInteger.birch"
  using super_type_ = BoundedDiscrete;

  #line 4 "src/distribution/UniformInteger.birch"
  using super_type_::operator=;
  #line 4 "src/distribution/UniformInteger.birch"
  using super_type_::cdf;
  #line 4 "src/distribution/UniformInteger.birch"
  using super_type_::logpdf;
  #line 4 "src/distribution/UniformInteger.birch"
  using super_type_::lower;
  #line 4 "src/distribution/UniformInteger.birch"
  using super_type_::quantile;
  #line 4 "src/distribution/UniformInteger.birch"
  using super_type_::simulate;
  #line 4 "src/distribution/UniformInteger.birch"
  using super_type_::supportsLazy;
  #line 4 "src/distribution/UniformInteger.birch"
  using super_type_::upper;
  
  #line 4 "src/distribution/UniformInteger.birch"
  UniformInteger(const libbirch::Lazy<libbirch::Shared<birch::type::Expression<birch::type::Integer>>>& l, const libbirch::Lazy<libbirch::Shared<birch::type::Expression<birch::type::Integer>>>& u, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);

  libbirch::Lazy<libbirch::Shared<birch::type::Expression<birch::type::Integer>>> l;
  libbirch::Lazy<libbirch::Shared<birch::type::Expression<birch::type::Integer>>> u;
  #line 16 "src/distribution/UniformInteger.birch"
  virtual birch::type::Boolean supportsLazy(const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
  #line 20 "src/distribution/UniformInteger.birch"
  virtual birch::type::Integer simulate(const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
  #line 36 "src/distribution/UniformInteger.birch"
  virtual birch::type::Real logpdf(const birch::type::Integer& x, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
  #line 44 "src/distribution/UniformInteger.birch"
  virtual libbirch::Optional<birch::type::Real> cdf(const birch::type::Integer& x, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
  #line 48 "src/distribution/UniformInteger.birch"
  virtual libbirch::Optional<birch::type::Integer> quantile(const birch::type::Real& P, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
  #line 52 "src/distribution/UniformInteger.birch"
  virtual libbirch::Optional<birch::type::Integer> lower(const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
  #line 56 "src/distribution/UniformInteger.birch"
  virtual libbirch::Optional<birch::type::Integer> upper(const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
  #line 60 "src/distribution/UniformInteger.birch"
  virtual void write(const libbirch::Lazy<libbirch::Shared<birch::type::Buffer>>& buffer, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
  
  #line 4 "src/distribution/UniformInteger.birch"
  LIBBIRCH_CLASS(UniformInteger, BoundedDiscrete)
  #line 4 "src/distribution/UniformInteger.birch"
  LIBBIRCH_MEMBERS(l, u)
};

#line 4 "src/distribution/BetaNegativeBinomial.birch"
class BetaNegativeBinomial final : public Discrete {
public:
  #line 4 "src/distribution/BetaNegativeBinomial.birch"
  using class_type_ = BetaNegativeBinomial;
  #line 4 "src/distribution/BetaNegativeBinomial.birch"
  using this_type_ = class_type_;
  #line 4 "src/distribution/BetaNegativeBinomial.birch"
  using super_type_ = Discrete;

  #line 4 "src/distribution/BetaNegativeBinomial.birch"
  using super_type_::operator=;
  #line 4 "src/distribution/BetaNegativeBinomial.birch"
  using super_type_::link;
  #line 4 "src/distribution/BetaNegativeBinomial.birch"
  using super_type_::logpdf;
  #line 4 "src/distribution/BetaNegativeBinomial.birch"
  using super_type_::logpdfLazy;
  #line 4 "src/distribution/BetaNegativeBinomial.birch"
  using super_type_::lower;
  #line 4 "src/distribution/BetaNegativeBinomial.birch"
  using super_type_::simulate;
  #line 4 "src/distribution/BetaNegativeBinomial.birch"
  using super_type_::simulateLazy;
  #line 4 "src/distribution/BetaNegativeBinomial.birch"
  using super_type_::supportsLazy;
  #line 4 "src/distribution/BetaNegativeBinomial.birch"
  using super_type_::unlink;
  #line 4 "src/distribution/BetaNegativeBinomial.birch"
  using super_type_::update;
  #line 4 "src/distribution/BetaNegativeBinomial.birch"
  using super_type_::updateLazy;
  
  #line 4 "src/distribution/BetaNegativeBinomial.birch"
  BetaNegativeBinomial(const libbirch::Lazy<libbirch::Shared<birch::type::Expression<birch::type::Integer>>>& k, const libbirch::Lazy<libbirch::Shared<birch::type::Beta>>& _u0961, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);

  libbirch::Lazy<libbirch::Shared<birch::type::Expression<birch::type::Integer>>> k;
  libbirch::Lazy<libbirch::Shared<birch::type::Beta>> _u0961;
  #line 15 "src/distribution/BetaNegativeBinomial.birch"
  virtual birch::type::Boolean supportsLazy(const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
  #line 19 "src/distribution/BetaNegativeBinomial.birch"
  virtual birch::type::Integer simulate(const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
  #line 27 "src/distribution/BetaNegativeBinomial.birch"
  virtual libbirch::Optional<birch::type::Integer> simulateLazy(const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
  #line 35 "src/distribution/BetaNegativeBinomial.birch"
  virtual birch::type::Real logpdf(const birch::type::Integer& x, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
  #line 39 "src/distribution/BetaNegativeBinomial.birch"
  virtual libbirch::Optional<libbirch::Lazy<libbirch::Shared<birch::type::Expression<birch::type::Real>>>> logpdfLazy(const libbirch::Lazy<libbirch::Shared<birch::type::Expression<birch::type::Integer>>>& x, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
  #line 43 "src/distribution/BetaNegativeBinomial.birch"
  virtual void update(const birch::type::Integer& x, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
  #line 47 "src/distribution/BetaNegativeBinomial.birch"
  virtual void updateLazy(const libbirch::Lazy<libbirch::Shared<birch::type::Expression<birch::type::Integer>>>& x, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
  #line 51 "src/distribution/BetaNegativeBinomial.birch"
  virtual libbirch::Optional<birch::type::Integer> lower(const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
  #line 55 "src/distribution/BetaNegativeBinomial.birch"
  virtual void link(const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
  #line 59 "src/distribution/BetaNegativeBinomial.birch"
  virtual void unlink(const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
  
  #line 4 "src/distribution/BetaNegativeBinomial.birch"
  LIBBIRCH_CLASS(BetaNegativeBinomial, Discrete)
  #line 4 "src/distribution/BetaNegativeBinomial.birch"
  LIBBIRCH_MEMBERS(k, _u0961)
};

#line 4 "src/distribution/DiscreteDelta.birch"
class DiscreteDelta final : public Discrete {
public:
  #line 4 "src/distribution/DiscreteDelta.birch"
  using class_type_ = DiscreteDelta;
  #line 4 "src/distribution/DiscreteDelta.birch"
  using this_type_ = class_type_;
  #line 4 "src/distribution/DiscreteDelta.birch"
  using super_type_ = Discrete;

  #line 4 "src/distribution/DiscreteDelta.birch"
  using super_type_::operator=;
  #line 4 "src/distribution/DiscreteDelta.birch"
  using super_type_::cdf;
  #line 4 "src/distribution/DiscreteDelta.birch"
  using super_type_::link;
  #line 4 "src/distribution/DiscreteDelta.birch"
  using super_type_::logpdf;
  #line 4 "src/distribution/DiscreteDelta.birch"
  using super_type_::lower;
  #line 4 "src/distribution/DiscreteDelta.birch"
  using super_type_::simulate;
  #line 4 "src/distribution/DiscreteDelta.birch"
  using super_type_::supportsLazy;
  #line 4 "src/distribution/DiscreteDelta.birch"
  using super_type_::unlink;
  #line 4 "src/distribution/DiscreteDelta.birch"
  using super_type_::update;
  #line 4 "src/distribution/DiscreteDelta.birch"
  using super_type_::upper;
  
  #line 4 "src/distribution/DiscreteDelta.birch"
  DiscreteDelta(const libbirch::Lazy<libbirch::Shared<birch::type::Discrete>>& _u0956, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);

  libbirch::Lazy<libbirch::Shared<birch::type::Discrete>> _u0956;
  #line 10 "src/distribution/DiscreteDelta.birch"
  virtual birch::type::Boolean supportsLazy(const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
  #line 14 "src/distribution/DiscreteDelta.birch"
  virtual birch::type::Integer simulate(const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
  #line 30 "src/distribution/DiscreteDelta.birch"
  virtual birch::type::Real logpdf(const birch::type::Integer& x, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
  #line 46 "src/distribution/DiscreteDelta.birch"
  virtual void update(const birch::type::Integer& x, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
  #line 54 "src/distribution/DiscreteDelta.birch"
  virtual libbirch::Optional<birch::type::Real> cdf(const birch::type::Integer& x, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
  #line 58 "src/distribution/DiscreteDelta.birch"
  virtual libbirch::Optional<birch::type::Integer> lower(const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
  #line 62 "src/distribution/DiscreteDelta.birch"
  virtual libbirch::Optional<birch::type::Integer> upper(const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
  #line 66 "src/distribution/DiscreteDelta.birch"
  virtual void link(const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
  #line 71 "src/distribution/DiscreteDelta.birch"
  virtual void unlink(const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
  
  #line 4 "src/distribution/DiscreteDelta.birch"
  LIBBIRCH_CLASS(DiscreteDelta, Discrete)
  #line 4 "src/distribution/DiscreteDelta.birch"
  LIBBIRCH_MEMBERS(_u0956)
};

#line 4 "src/distribution/GammaPoisson.birch"
class GammaPoisson final : public Discrete {
public:
  #line 4 "src/distribution/GammaPoisson.birch"
  using class_type_ = GammaPoisson;
  #line 4 "src/distribution/GammaPoisson.birch"
  using this_type_ = class_type_;
  #line 4 "src/distribution/GammaPoisson.birch"
  using super_type_ = Discrete;

  #line 4 "src/distribution/GammaPoisson.birch"
  using super_type_::operator=;
  #line 4 "src/distribution/GammaPoisson.birch"
  using super_type_::cdf;
  #line 4 "src/distribution/GammaPoisson.birch"
  using super_type_::link;
  #line 4 "src/distribution/GammaPoisson.birch"
  using super_type_::logpdf;
  #line 4 "src/distribution/GammaPoisson.birch"
  using super_type_::logpdfLazy;
  #line 4 "src/distribution/GammaPoisson.birch"
  using super_type_::lower;
  #line 4 "src/distribution/GammaPoisson.birch"
  using super_type_::quantile;
  #line 4 "src/distribution/GammaPoisson.birch"
  using super_type_::simulate;
  #line 4 "src/distribution/GammaPoisson.birch"
  using super_type_::simulateLazy;
  #line 4 "src/distribution/GammaPoisson.birch"
  using super_type_::supportsLazy;
  #line 4 "src/distribution/GammaPoisson.birch"
  using super_type_::unlink;
  #line 4 "src/distribution/GammaPoisson.birch"
  using super_type_::update;
  #line 4 "src/distribution/GammaPoisson.birch"
  using super_type_::updateLazy;
  
  #line 4 "src/distribution/GammaPoisson.birch"
  GammaPoisson(const libbirch::Lazy<libbirch::Shared<birch::type::Gamma>>& _u0955, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);

  libbirch::Lazy<libbirch::Shared<birch::type::Gamma>> _u0955;
  #line 10 "src/distribution/GammaPoisson.birch"
  virtual birch::type::Boolean supportsLazy(const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
  #line 14 "src/distribution/GammaPoisson.birch"
  virtual birch::type::Integer simulate(const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
  #line 22 "src/distribution/GammaPoisson.birch"
  virtual libbirch::Optional<birch::type::Integer> simulateLazy(const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
  #line 30 "src/distribution/GammaPoisson.birch"
  virtual birch::type::Real logpdf(const birch::type::Integer& x, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
  #line 34 "src/distribution/GammaPoisson.birch"
  virtual libbirch::Optional<libbirch::Lazy<libbirch::Shared<birch::type::Expression<birch::type::Real>>>> logpdfLazy(const libbirch::Lazy<libbirch::Shared<birch::type::Expression<birch::type::Integer>>>& x, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
  #line 38 "src/distribution/GammaPoisson.birch"
  virtual void update(const birch::type::Integer& x, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
  #line 42 "src/distribution/GammaPoisson.birch"
  virtual void updateLazy(const libbirch::Lazy<libbirch::Shared<birch::type::Expression<birch::type::Integer>>>& x, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
  #line 46 "src/distribution/GammaPoisson.birch"
  virtual libbirch::Optional<birch::type::Real> cdf(const birch::type::Integer& x, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
  #line 50 "src/distribution/GammaPoisson.birch"
  virtual libbirch::Optional<birch::type::Integer> quantile(const birch::type::Real& P, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
  #line 54 "src/distribution/GammaPoisson.birch"
  virtual libbirch::Optional<birch::type::Integer> lower(const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
  #line 58 "src/distribution/GammaPoisson.birch"
  virtual void link(const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
  #line 62 "src/distribution/GammaPoisson.birch"
  virtual void unlink(const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
  
  #line 4 "src/distribution/GammaPoisson.birch"
  LIBBIRCH_CLASS(GammaPoisson, Discrete)
  #line 4 "src/distribution/GammaPoisson.birch"
  LIBBIRCH_MEMBERS(_u0955)
};

#line 5 "src/distribution/LinearDiscrete.birch"
class LinearDiscrete final : public Discrete {
public:
  #line 5 "src/distribution/LinearDiscrete.birch"
  using class_type_ = LinearDiscrete;
  #line 5 "src/distribution/LinearDiscrete.birch"
  using this_type_ = class_type_;
  #line 5 "src/distribution/LinearDiscrete.birch"
  using super_type_ = Discrete;

  #line 5 "src/distribution/LinearDiscrete.birch"
  using super_type_::operator=;
  #line 5 "src/distribution/LinearDiscrete.birch"
  using super_type_::cdf;
  #line 5 "src/distribution/LinearDiscrete.birch"
  using super_type_::link;
  #line 5 "src/distribution/LinearDiscrete.birch"
  using super_type_::logpdf;
  #line 5 "src/distribution/LinearDiscrete.birch"
  using super_type_::lower;
  #line 5 "src/distribution/LinearDiscrete.birch"
  using super_type_::simulate;
  #line 5 "src/distribution/LinearDiscrete.birch"
  using super_type_::supportsLazy;
  #line 5 "src/distribution/LinearDiscrete.birch"
  using super_type_::unlink;
  #line 5 "src/distribution/LinearDiscrete.birch"
  using super_type_::update;
  #line 5 "src/distribution/LinearDiscrete.birch"
  using super_type_::upper;
  
  #line 5 "src/distribution/LinearDiscrete.birch"
  LinearDiscrete(const libbirch::Lazy<libbirch::Shared<birch::type::Expression<birch::type::Integer>>>& a, const libbirch::Lazy<libbirch::Shared<birch::type::Discrete>>& _u0956, const libbirch::Lazy<libbirch::Shared<birch::type::Expression<birch::type::Integer>>>& c, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);

  libbirch::Lazy<libbirch::Shared<birch::type::Expression<birch::type::Integer>>> a;
  libbirch::Lazy<libbirch::Shared<birch::type::Discrete>> _u0956;
  libbirch::Lazy<libbirch::Shared<birch::type::Expression<birch::type::Integer>>> c;
  #line 22 "src/distribution/LinearDiscrete.birch"
  virtual birch::type::Boolean supportsLazy(const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
  #line 26 "src/distribution/LinearDiscrete.birch"
  virtual birch::type::Integer simulate(const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
  #line 42 "src/distribution/LinearDiscrete.birch"
  virtual birch::type::Real logpdf(const birch::type::Integer& x, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
  #line 58 "src/distribution/LinearDiscrete.birch"
  virtual void update(const birch::type::Integer& x, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
  #line 66 "src/distribution/LinearDiscrete.birch"
  virtual libbirch::Optional<birch::type::Real> cdf(const birch::type::Integer& x, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
  #line 70 "src/distribution/LinearDiscrete.birch"
  virtual libbirch::Optional<birch::type::Integer> lower(const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
  #line 78 "src/distribution/LinearDiscrete.birch"
  virtual libbirch::Optional<birch::type::Integer> upper(const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
  #line 86 "src/distribution/LinearDiscrete.birch"
  virtual void link(const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
  #line 91 "src/distribution/LinearDiscrete.birch"
  virtual void unlink(const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
  
  #line 5 "src/distribution/LinearDiscrete.birch"
  LIBBIRCH_CLASS(LinearDiscrete, Discrete)
  #line 5 "src/distribution/LinearDiscrete.birch"
  LIBBIRCH_MEMBERS(a, _u0956, c)
};

#line 1 "src/distribution/NegativeBinomial.birch"
class NegativeBinomial : public Discrete {
public:
  #line 1 "src/distribution/NegativeBinomial.birch"
  using class_type_ = NegativeBinomial;
  #line 1 "src/distribution/NegativeBinomial.birch"
  using this_type_ = class_type_;
  #line 1 "src/distribution/NegativeBinomial.birch"
  using super_type_ = Discrete;

  #line 1 "src/distribution/NegativeBinomial.birch"
  using super_type_::operator=;
  #line 1 "src/distribution/NegativeBinomial.birch"
  using super_type_::cdf;
  #line 1 "src/distribution/NegativeBinomial.birch"
  using super_type_::graft;
  #line 1 "src/distribution/NegativeBinomial.birch"
  using super_type_::logpdf;
  #line 1 "src/distribution/NegativeBinomial.birch"
  using super_type_::logpdfLazy;
  #line 1 "src/distribution/NegativeBinomial.birch"
  using super_type_::lower;
  #line 1 "src/distribution/NegativeBinomial.birch"
  using super_type_::quantile;
  #line 1 "src/distribution/NegativeBinomial.birch"
  using super_type_::simulate;
  #line 1 "src/distribution/NegativeBinomial.birch"
  using super_type_::simulateLazy;
  #line 1 "src/distribution/NegativeBinomial.birch"
  using super_type_::supportsLazy;
  
  #line 1 "src/distribution/NegativeBinomial.birch"
  NegativeBinomial(const libbirch::Lazy<libbirch::Shared<birch::type::Expression<birch::type::Integer>>>& k, const libbirch::Lazy<libbirch::Shared<birch::type::Expression<birch::type::Real>>>& _u0961, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);

  libbirch::Lazy<libbirch::Shared<birch::type::Expression<birch::type::Integer>>> k;
  libbirch::Lazy<libbirch::Shared<birch::type::Expression<birch::type::Real>>> _u0961;
  #line 16 "src/distribution/NegativeBinomial.birch"
  virtual birch::type::Boolean supportsLazy(const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
  #line 20 "src/distribution/NegativeBinomial.birch"
  virtual birch::type::Integer simulate(const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
  #line 28 "src/distribution/NegativeBinomial.birch"
  virtual libbirch::Optional<birch::type::Integer> simulateLazy(const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
  #line 36 "src/distribution/NegativeBinomial.birch"
  virtual birch::type::Real logpdf(const birch::type::Integer& x, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
  #line 40 "src/distribution/NegativeBinomial.birch"
  virtual libbirch::Optional<libbirch::Lazy<libbirch::Shared<birch::type::Expression<birch::type::Real>>>> logpdfLazy(const libbirch::Lazy<libbirch::Shared<birch::type::Expression<birch::type::Integer>>>& x, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
  #line 44 "src/distribution/NegativeBinomial.birch"
  virtual libbirch::Optional<birch::type::Real> cdf(const birch::type::Integer& x, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
  #line 48 "src/distribution/NegativeBinomial.birch"
  virtual libbirch::Optional<birch::type::Integer> quantile(const birch::type::Real& P, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
  #line 52 "src/distribution/NegativeBinomial.birch"
  virtual libbirch::Optional<birch::type::Integer> lower(const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
  #line 56 "src/distribution/NegativeBinomial.birch"
  virtual libbirch::Lazy<libbirch::Shared<birch::type::Distribution<birch::type::Integer>>> graft(const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
  #line 69 "src/distribution/NegativeBinomial.birch"
  virtual void write(const libbirch::Lazy<libbirch::Shared<birch::type::Buffer>>& buffer, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
  
  #line 1 "src/distribution/NegativeBinomial.birch"
  LIBBIRCH_CLASS(NegativeBinomial, Discrete)
  #line 1 "src/distribution/NegativeBinomial.birch"
  LIBBIRCH_MEMBERS(k, _u0961)
};

#line 1 "src/distribution/Poisson.birch"
class Poisson : public Discrete {
public:
  #line 1 "src/distribution/Poisson.birch"
  using class_type_ = Poisson;
  #line 1 "src/distribution/Poisson.birch"
  using this_type_ = class_type_;
  #line 1 "src/distribution/Poisson.birch"
  using super_type_ = Discrete;

  #line 1 "src/distribution/Poisson.birch"
  using super_type_::operator=;
  #line 1 "src/distribution/Poisson.birch"
  using super_type_::cdf;
  #line 1 "src/distribution/Poisson.birch"
  using super_type_::graft;
  #line 1 "src/distribution/Poisson.birch"
  using super_type_::logpdf;
  #line 1 "src/distribution/Poisson.birch"
  using super_type_::logpdfLazy;
  #line 1 "src/distribution/Poisson.birch"
  using super_type_::lower;
  #line 1 "src/distribution/Poisson.birch"
  using super_type_::quantile;
  #line 1 "src/distribution/Poisson.birch"
  using super_type_::simulate;
  #line 1 "src/distribution/Poisson.birch"
  using super_type_::simulateLazy;
  #line 1 "src/distribution/Poisson.birch"
  using super_type_::supportsLazy;
  
  #line 1 "src/distribution/Poisson.birch"
  Poisson(const libbirch::Lazy<libbirch::Shared<birch::type::Expression<birch::type::Real>>>& _u0955, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);

  libbirch::Lazy<libbirch::Shared<birch::type::Expression<birch::type::Real>>> _u0955;
  #line 10 "src/distribution/Poisson.birch"
  virtual birch::type::Boolean supportsLazy(const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
  #line 14 "src/distribution/Poisson.birch"
  virtual birch::type::Integer simulate(const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
  #line 22 "src/distribution/Poisson.birch"
  virtual libbirch::Optional<birch::type::Integer> simulateLazy(const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
  #line 30 "src/distribution/Poisson.birch"
  virtual birch::type::Real logpdf(const birch::type::Integer& x, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
  #line 34 "src/distribution/Poisson.birch"
  virtual libbirch::Optional<libbirch::Lazy<libbirch::Shared<birch::type::Expression<birch::type::Real>>>> logpdfLazy(const libbirch::Lazy<libbirch::Shared<birch::type::Expression<birch::type::Integer>>>& x, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
  #line 38 "src/distribution/Poisson.birch"
  virtual libbirch::Optional<birch::type::Real> cdf(const birch::type::Integer& x, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
  #line 42 "src/distribution/Poisson.birch"
  virtual libbirch::Optional<birch::type::Integer> quantile(const birch::type::Real& P, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
  #line 46 "src/distribution/Poisson.birch"
  virtual libbirch::Optional<birch::type::Integer> lower(const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
  #line 50 "src/distribution/Poisson.birch"
  virtual libbirch::Lazy<libbirch::Shared<birch::type::Distribution<birch::type::Integer>>> graft(const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
  #line 66 "src/distribution/Poisson.birch"
  virtual void write(const libbirch::Lazy<libbirch::Shared<birch::type::Buffer>>& buffer, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
  
  #line 1 "src/distribution/Poisson.birch"
  LIBBIRCH_CLASS(Poisson, Discrete)
  #line 1 "src/distribution/Poisson.birch"
  LIBBIRCH_MEMBERS(_u0955)
};

#line 4 "src/distribution/ScaledGammaPoisson.birch"
class ScaledGammaPoisson final : public Discrete {
public:
  #line 4 "src/distribution/ScaledGammaPoisson.birch"
  using class_type_ = ScaledGammaPoisson;
  #line 4 "src/distribution/ScaledGammaPoisson.birch"
  using this_type_ = class_type_;
  #line 4 "src/distribution/ScaledGammaPoisson.birch"
  using super_type_ = Discrete;

  #line 4 "src/distribution/ScaledGammaPoisson.birch"
  using super_type_::operator=;
  #line 4 "src/distribution/ScaledGammaPoisson.birch"
  using super_type_::cdf;
  #line 4 "src/distribution/ScaledGammaPoisson.birch"
  using super_type_::link;
  #line 4 "src/distribution/ScaledGammaPoisson.birch"
  using super_type_::logpdf;
  #line 4 "src/distribution/ScaledGammaPoisson.birch"
  using super_type_::logpdfLazy;
  #line 4 "src/distribution/ScaledGammaPoisson.birch"
  using super_type_::lower;
  #line 4 "src/distribution/ScaledGammaPoisson.birch"
  using super_type_::quantile;
  #line 4 "src/distribution/ScaledGammaPoisson.birch"
  using super_type_::simulate;
  #line 4 "src/distribution/ScaledGammaPoisson.birch"
  using super_type_::simulateLazy;
  #line 4 "src/distribution/ScaledGammaPoisson.birch"
  using super_type_::supportsLazy;
  #line 4 "src/distribution/ScaledGammaPoisson.birch"
  using super_type_::unlink;
  #line 4 "src/distribution/ScaledGammaPoisson.birch"
  using super_type_::update;
  #line 4 "src/distribution/ScaledGammaPoisson.birch"
  using super_type_::updateLazy;
  
  #line 4 "src/distribution/ScaledGammaPoisson.birch"
  ScaledGammaPoisson(const libbirch::Lazy<libbirch::Shared<birch::type::Expression<birch::type::Real>>>& a, const libbirch::Lazy<libbirch::Shared<birch::type::Gamma>>& _u0955, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);

  libbirch::Lazy<libbirch::Shared<birch::type::Expression<birch::type::Real>>> a;
  libbirch::Lazy<libbirch::Shared<birch::type::Gamma>> _u0955;
  #line 15 "src/distribution/ScaledGammaPoisson.birch"
  virtual birch::type::Boolean supportsLazy(const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
  #line 19 "src/distribution/ScaledGammaPoisson.birch"
  virtual birch::type::Integer simulate(const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
  #line 27 "src/distribution/ScaledGammaPoisson.birch"
  virtual libbirch::Optional<birch::type::Integer> simulateLazy(const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
  #line 35 "src/distribution/ScaledGammaPoisson.birch"
  virtual birch::type::Real logpdf(const birch::type::Integer& x, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
  #line 39 "src/distribution/ScaledGammaPoisson.birch"
  virtual libbirch::Optional<libbirch::Lazy<libbirch::Shared<birch::type::Expression<birch::type::Real>>>> logpdfLazy(const libbirch::Lazy<libbirch::Shared<birch::type::Expression<birch::type::Integer>>>& x, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
  #line 43 "src/distribution/ScaledGammaPoisson.birch"
  virtual void update(const birch::type::Integer& x, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
  #line 48 "src/distribution/ScaledGammaPoisson.birch"
  virtual void updateLazy(const libbirch::Lazy<libbirch::Shared<birch::type::Expression<birch::type::Integer>>>& x, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
  #line 52 "src/distribution/ScaledGammaPoisson.birch"
  virtual libbirch::Optional<birch::type::Real> cdf(const birch::type::Integer& x, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
  #line 56 "src/distribution/ScaledGammaPoisson.birch"
  virtual libbirch::Optional<birch::type::Integer> quantile(const birch::type::Real& P, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
  #line 60 "src/distribution/ScaledGammaPoisson.birch"
  virtual libbirch::Optional<birch::type::Integer> lower(const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
  #line 64 "src/distribution/ScaledGammaPoisson.birch"
  virtual void link(const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
  #line 68 "src/distribution/ScaledGammaPoisson.birch"
  virtual void unlink(const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
  
  #line 4 "src/distribution/ScaledGammaPoisson.birch"
  LIBBIRCH_CLASS(ScaledGammaPoisson, Discrete)
  #line 4 "src/distribution/ScaledGammaPoisson.birch"
  LIBBIRCH_MEMBERS(a, _u0955)
};

#line 4 "src/distribution/DirichletMultinomial.birch"
class DirichletMultinomial final : public Distribution<libbirch::DefaultArray<birch::type::Integer,1>> {
public:
  #line 4 "src/distribution/DirichletMultinomial.birch"
  using class_type_ = DirichletMultinomial;
  #line 4 "src/distribution/DirichletMultinomial.birch"
  using this_type_ = class_type_;
  #line 4 "src/distribution/DirichletMultinomial.birch"
  using super_type_ = Distribution<libbirch::DefaultArray<birch::type::Integer,1>>;

  #line 4 "src/distribution/DirichletMultinomial.birch"
  using super_type_::operator=;
  #line 4 "src/distribution/DirichletMultinomial.birch"
  using super_type_::link;
  #line 4 "src/distribution/DirichletMultinomial.birch"
  using super_type_::logpdf;
  #line 4 "src/distribution/DirichletMultinomial.birch"
  using super_type_::simulate;
  #line 4 "src/distribution/DirichletMultinomial.birch"
  using super_type_::supportsLazy;
  #line 4 "src/distribution/DirichletMultinomial.birch"
  using super_type_::unlink;
  #line 4 "src/distribution/DirichletMultinomial.birch"
  using super_type_::update;
  
  #line 4 "src/distribution/DirichletMultinomial.birch"
  DirichletMultinomial(const libbirch::Lazy<libbirch::Shared<birch::type::Expression<birch::type::Integer>>>& n, const libbirch::Lazy<libbirch::Shared<birch::type::Dirichlet>>& _u0961, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);

  libbirch::Lazy<libbirch::Shared<birch::type::Expression<birch::type::Integer>>> n;
  libbirch::Lazy<libbirch::Shared<birch::type::Dirichlet>> _u0961;
  #line 16 "src/distribution/DirichletMultinomial.birch"
  virtual birch::type::Boolean supportsLazy(const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
  #line 20 "src/distribution/DirichletMultinomial.birch"
  virtual libbirch::DefaultArray<birch::type::Integer,1> simulate(const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
  #line 28 "src/distribution/DirichletMultinomial.birch"
  virtual birch::type::Real logpdf(const libbirch::DefaultArray<birch::type::Integer,1>& x, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
  #line 36 "src/distribution/DirichletMultinomial.birch"
  virtual void update(const libbirch::DefaultArray<birch::type::Integer,1>& x, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
  #line 44 "src/distribution/DirichletMultinomial.birch"
  virtual void link(const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
  #line 48 "src/distribution/DirichletMultinomial.birch"
  virtual void unlink(const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
  
  #line 4 "src/distribution/DirichletMultinomial.birch"
  LIBBIRCH_CLASS(DirichletMultinomial, Distribution<libbirch::DefaultArray<birch::type::Integer,1>>)
  #line 4 "src/distribution/DirichletMultinomial.birch"
  LIBBIRCH_MEMBERS(n, _u0961)
};

#line 4 "src/distribution/DirichletCategorical.birch"
class DirichletCategorical final : public Distribution<birch::type::Integer> {
public:
  #line 4 "src/distribution/DirichletCategorical.birch"
  using class_type_ = DirichletCategorical;
  #line 4 "src/distribution/DirichletCategorical.birch"
  using this_type_ = class_type_;
  #line 4 "src/distribution/DirichletCategorical.birch"
  using super_type_ = Distribution<birch::type::Integer>;

  #line 4 "src/distribution/DirichletCategorical.birch"
  using super_type_::operator=;
  #line 4 "src/distribution/DirichletCategorical.birch"
  using super_type_::link;
  #line 4 "src/distribution/DirichletCategorical.birch"
  using super_type_::logpdf;
  #line 4 "src/distribution/DirichletCategorical.birch"
  using super_type_::lower;
  #line 4 "src/distribution/DirichletCategorical.birch"
  using super_type_::simulate;
  #line 4 "src/distribution/DirichletCategorical.birch"
  using super_type_::supportsLazy;
  #line 4 "src/distribution/DirichletCategorical.birch"
  using super_type_::unlink;
  #line 4 "src/distribution/DirichletCategorical.birch"
  using super_type_::update;
  #line 4 "src/distribution/DirichletCategorical.birch"
  using super_type_::upper;
  
  #line 4 "src/distribution/DirichletCategorical.birch"
  DirichletCategorical(const libbirch::Lazy<libbirch::Shared<birch::type::Dirichlet>>& _u0961, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);

  libbirch::Lazy<libbirch::Shared<birch::type::Dirichlet>> _u0961;
  #line 10 "src/distribution/DirichletCategorical.birch"
  virtual birch::type::Boolean supportsLazy(const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
  #line 14 "src/distribution/DirichletCategorical.birch"
  virtual birch::type::Integer simulate(const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
  #line 22 "src/distribution/DirichletCategorical.birch"
  virtual birch::type::Real logpdf(const birch::type::Integer& x, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
  #line 30 "src/distribution/DirichletCategorical.birch"
  virtual void update(const birch::type::Integer& x, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
  #line 38 "src/distribution/DirichletCategorical.birch"
  virtual libbirch::Optional<birch::type::Integer> lower(const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
  #line 42 "src/distribution/DirichletCategorical.birch"
  virtual libbirch::Optional<birch::type::Integer> upper(const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
  #line 46 "src/distribution/DirichletCategorical.birch"
  virtual void link(const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
  #line 50 "src/distribution/DirichletCategorical.birch"
  virtual void unlink(const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
  
  #line 4 "src/distribution/DirichletCategorical.birch"
  LIBBIRCH_CLASS(DirichletCategorical, Distribution<birch::type::Integer>)
  #line 4 "src/distribution/DirichletCategorical.birch"
  LIBBIRCH_MEMBERS(_u0961)
};

#line 4 "src/distribution/Dirichlet.birch"
class Dirichlet final : public Distribution<libbirch::DefaultArray<birch::type::Real,1>> {
public:
  #line 4 "src/distribution/Dirichlet.birch"
  using class_type_ = Dirichlet;
  #line 4 "src/distribution/Dirichlet.birch"
  using this_type_ = class_type_;
  #line 4 "src/distribution/Dirichlet.birch"
  using super_type_ = Distribution<libbirch::DefaultArray<birch::type::Real,1>>;

  #line 4 "src/distribution/Dirichlet.birch"
  using super_type_::operator=;
  #line 4 "src/distribution/Dirichlet.birch"
  using super_type_::graftDirichlet;
  #line 4 "src/distribution/Dirichlet.birch"
  using super_type_::logpdf;
  #line 4 "src/distribution/Dirichlet.birch"
  using super_type_::simulate;
  #line 4 "src/distribution/Dirichlet.birch"
  using super_type_::supportsLazy;
  
  #line 4 "src/distribution/Dirichlet.birch"
  Dirichlet(const libbirch::Lazy<libbirch::Shared<birch::type::Expression<libbirch::DefaultArray<birch::type::Real,1>>>>& _u0945, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);

  libbirch::Lazy<libbirch::Shared<birch::type::Expression<libbirch::DefaultArray<birch::type::Real,1>>>> _u0945;
  #line 10 "src/distribution/Dirichlet.birch"
  virtual birch::type::Boolean supportsLazy(const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
  #line 14 "src/distribution/Dirichlet.birch"
  virtual libbirch::DefaultArray<birch::type::Real,1> simulate(const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
  #line 22 "src/distribution/Dirichlet.birch"
  virtual birch::type::Real logpdf(const libbirch::DefaultArray<birch::type::Real,1>& x, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
  #line 30 "src/distribution/Dirichlet.birch"
  virtual libbirch::Optional<libbirch::Lazy<libbirch::Shared<birch::type::Dirichlet>>> graftDirichlet(const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
  #line 35 "src/distribution/Dirichlet.birch"
  virtual void write(const libbirch::Lazy<libbirch::Shared<birch::type::Buffer>>& buffer, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
  
  #line 4 "src/distribution/Dirichlet.birch"
  LIBBIRCH_CLASS(Dirichlet, Distribution<libbirch::DefaultArray<birch::type::Real,1>>)
  #line 4 "src/distribution/Dirichlet.birch"
  LIBBIRCH_MEMBERS(_u0945)
};

#line 1 "src/distribution/Categorical.birch"
class Categorical : public Distribution<birch::type::Integer> {
public:
  #line 1 "src/distribution/Categorical.birch"
  using class_type_ = Categorical;
  #line 1 "src/distribution/Categorical.birch"
  using this_type_ = class_type_;
  #line 1 "src/distribution/Categorical.birch"
  using super_type_ = Distribution<birch::type::Integer>;

  #line 1 "src/distribution/Categorical.birch"
  using super_type_::operator=;
  #line 1 "src/distribution/Categorical.birch"
  using super_type_::cdf;
  #line 1 "src/distribution/Categorical.birch"
  using super_type_::graft;
  #line 1 "src/distribution/Categorical.birch"
  using super_type_::logpdf;
  #line 1 "src/distribution/Categorical.birch"
  using super_type_::lower;
  #line 1 "src/distribution/Categorical.birch"
  using super_type_::quantile;
  #line 1 "src/distribution/Categorical.birch"
  using super_type_::simulate;
  #line 1 "src/distribution/Categorical.birch"
  using super_type_::supportsLazy;
  #line 1 "src/distribution/Categorical.birch"
  using super_type_::upper;
  
  #line 1 "src/distribution/Categorical.birch"
  Categorical(const libbirch::Lazy<libbirch::Shared<birch::type::Expression<libbirch::DefaultArray<birch::type::Real,1>>>>& _u0961, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);

  libbirch::Lazy<libbirch::Shared<birch::type::Expression<libbirch::DefaultArray<birch::type::Real,1>>>> _u0961;
  #line 10 "src/distribution/Categorical.birch"
  virtual birch::type::Boolean supportsLazy(const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
  #line 14 "src/distribution/Categorical.birch"
  virtual birch::type::Integer simulate(const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
  #line 22 "src/distribution/Categorical.birch"
  virtual birch::type::Real logpdf(const birch::type::Integer& x, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
  #line 30 "src/distribution/Categorical.birch"
  virtual libbirch::Optional<birch::type::Real> cdf(const birch::type::Integer& x, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
  #line 34 "src/distribution/Categorical.birch"
  virtual libbirch::Optional<birch::type::Integer> quantile(const birch::type::Real& P, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
  #line 38 "src/distribution/Categorical.birch"
  virtual libbirch::Optional<birch::type::Integer> lower(const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
  #line 42 "src/distribution/Categorical.birch"
  virtual libbirch::Optional<birch::type::Integer> upper(const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
  #line 46 "src/distribution/Categorical.birch"
  virtual libbirch::Lazy<libbirch::Shared<birch::type::Distribution<birch::type::Integer>>> graft(const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
  #line 62 "src/distribution/Categorical.birch"
  virtual void write(const libbirch::Lazy<libbirch::Shared<birch::type::Buffer>>& buffer, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
  
  #line 1 "src/distribution/Categorical.birch"
  LIBBIRCH_CLASS(Categorical, Distribution<birch::type::Integer>)
  #line 1 "src/distribution/Categorical.birch"
  LIBBIRCH_MEMBERS(_u0961)
};

#line 4 "src/distribution/BetaBernoulli.birch"
class BetaBernoulli final : public Distribution<birch::type::Boolean> {
public:
  #line 4 "src/distribution/BetaBernoulli.birch"
  using class_type_ = BetaBernoulli;
  #line 4 "src/distribution/BetaBernoulli.birch"
  using this_type_ = class_type_;
  #line 4 "src/distribution/BetaBernoulli.birch"
  using super_type_ = Distribution<birch::type::Boolean>;

  #line 4 "src/distribution/BetaBernoulli.birch"
  using super_type_::operator=;
  #line 4 "src/distribution/BetaBernoulli.birch"
  using super_type_::link;
  #line 4 "src/distribution/BetaBernoulli.birch"
  using super_type_::logpdf;
  #line 4 "src/distribution/BetaBernoulli.birch"
  using super_type_::logpdfLazy;
  #line 4 "src/distribution/BetaBernoulli.birch"
  using super_type_::simulate;
  #line 4 "src/distribution/BetaBernoulli.birch"
  using super_type_::simulateLazy;
  #line 4 "src/distribution/BetaBernoulli.birch"
  using super_type_::supportsLazy;
  #line 4 "src/distribution/BetaBernoulli.birch"
  using super_type_::unlink;
  #line 4 "src/distribution/BetaBernoulli.birch"
  using super_type_::update;
  #line 4 "src/distribution/BetaBernoulli.birch"
  using super_type_::updateLazy;
  
  #line 4 "src/distribution/BetaBernoulli.birch"
  BetaBernoulli(const libbirch::Lazy<libbirch::Shared<birch::type::Beta>>& _u0961, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);

  libbirch::Lazy<libbirch::Shared<birch::type::Beta>> _u0961;
  #line 10 "src/distribution/BetaBernoulli.birch"
  virtual birch::type::Boolean supportsLazy(const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
  #line 14 "src/distribution/BetaBernoulli.birch"
  virtual birch::type::Boolean simulate(const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
  #line 18 "src/distribution/BetaBernoulli.birch"
  virtual libbirch::Optional<birch::type::Boolean> simulateLazy(const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
  #line 22 "src/distribution/BetaBernoulli.birch"
  virtual birch::type::Real logpdf(const birch::type::Boolean& x, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
  #line 26 "src/distribution/BetaBernoulli.birch"
  virtual libbirch::Optional<libbirch::Lazy<libbirch::Shared<birch::type::Expression<birch::type::Real>>>> logpdfLazy(const libbirch::Lazy<libbirch::Shared<birch::type::Expression<birch::type::Boolean>>>& x, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
  #line 30 "src/distribution/BetaBernoulli.birch"
  virtual void update(const birch::type::Boolean& x, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
  #line 34 "src/distribution/BetaBernoulli.birch"
  virtual void updateLazy(const libbirch::Lazy<libbirch::Shared<birch::type::Expression<birch::type::Boolean>>>& x, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
  #line 38 "src/distribution/BetaBernoulli.birch"
  virtual void link(const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
  #line 42 "src/distribution/BetaBernoulli.birch"
  virtual void unlink(const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
  
  #line 4 "src/distribution/BetaBernoulli.birch"
  LIBBIRCH_CLASS(BetaBernoulli, Distribution<birch::type::Boolean>)
  #line 4 "src/distribution/BetaBernoulli.birch"
  LIBBIRCH_MEMBERS(_u0961)
};

#line 4 "src/distribution/Beta.birch"
class Beta final : public Distribution<birch::type::Real> {
public:
  #line 4 "src/distribution/Beta.birch"
  using class_type_ = Beta;
  #line 4 "src/distribution/Beta.birch"
  using this_type_ = class_type_;
  #line 4 "src/distribution/Beta.birch"
  using super_type_ = Distribution<birch::type::Real>;

  #line 4 "src/distribution/Beta.birch"
  using super_type_::operator=;
  #line 4 "src/distribution/Beta.birch"
  using super_type_::cdf;
  #line 4 "src/distribution/Beta.birch"
  using super_type_::graftBeta;
  #line 4 "src/distribution/Beta.birch"
  using super_type_::logpdf;
  #line 4 "src/distribution/Beta.birch"
  using super_type_::logpdfLazy;
  #line 4 "src/distribution/Beta.birch"
  using super_type_::lower;
  #line 4 "src/distribution/Beta.birch"
  using super_type_::quantile;
  #line 4 "src/distribution/Beta.birch"
  using super_type_::simulate;
  #line 4 "src/distribution/Beta.birch"
  using super_type_::simulateLazy;
  #line 4 "src/distribution/Beta.birch"
  using super_type_::supportsLazy;
  #line 4 "src/distribution/Beta.birch"
  using super_type_::upper;
  
  #line 4 "src/distribution/Beta.birch"
  Beta(const libbirch::Lazy<libbirch::Shared<birch::type::Expression<birch::type::Real>>>& _u0945, const libbirch::Lazy<libbirch::Shared<birch::type::Expression<birch::type::Real>>>& _u0946, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);

  libbirch::Lazy<libbirch::Shared<birch::type::Expression<birch::type::Real>>> _u0945;
  libbirch::Lazy<libbirch::Shared<birch::type::Expression<birch::type::Real>>> _u0946;
  #line 16 "src/distribution/Beta.birch"
  virtual birch::type::Boolean supportsLazy(const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
  #line 20 "src/distribution/Beta.birch"
  virtual birch::type::Real simulate(const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
  #line 24 "src/distribution/Beta.birch"
  virtual libbirch::Optional<birch::type::Real> simulateLazy(const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
  #line 28 "src/distribution/Beta.birch"
  virtual birch::type::Real logpdf(const birch::type::Real& x, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
  #line 32 "src/distribution/Beta.birch"
  virtual libbirch::Optional<libbirch::Lazy<libbirch::Shared<birch::type::Expression<birch::type::Real>>>> logpdfLazy(const libbirch::Lazy<libbirch::Shared<birch::type::Expression<birch::type::Real>>>& x, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
  #line 36 "src/distribution/Beta.birch"
  virtual libbirch::Optional<birch::type::Real> cdf(const birch::type::Real& x, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
  #line 40 "src/distribution/Beta.birch"
  virtual libbirch::Optional<birch::type::Real> quantile(const birch::type::Real& P, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
  #line 44 "src/distribution/Beta.birch"
  virtual libbirch::Optional<birch::type::Real> lower(const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
  #line 48 "src/distribution/Beta.birch"
  virtual libbirch::Optional<birch::type::Real> upper(const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
  #line 52 "src/distribution/Beta.birch"
  virtual libbirch::Optional<libbirch::Lazy<libbirch::Shared<birch::type::Beta>>> graftBeta(const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
  #line 57 "src/distribution/Beta.birch"
  virtual void write(const libbirch::Lazy<libbirch::Shared<birch::type::Buffer>>& buffer, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
  
  #line 4 "src/distribution/Beta.birch"
  LIBBIRCH_CLASS(Beta, Distribution<birch::type::Real>)
  #line 4 "src/distribution/Beta.birch"
  LIBBIRCH_MEMBERS(_u0945, _u0946)
};

#line 1 "src/distribution/Bernoulli.birch"
class Bernoulli : public Distribution<birch::type::Boolean> {
public:
  #line 1 "src/distribution/Bernoulli.birch"
  using class_type_ = Bernoulli;
  #line 1 "src/distribution/Bernoulli.birch"
  using this_type_ = class_type_;
  #line 1 "src/distribution/Bernoulli.birch"
  using super_type_ = Distribution<birch::type::Boolean>;

  #line 1 "src/distribution/Bernoulli.birch"
  using super_type_::operator=;
  #line 1 "src/distribution/Bernoulli.birch"
  using super_type_::graft;
  #line 1 "src/distribution/Bernoulli.birch"
  using super_type_::logpdf;
  #line 1 "src/distribution/Bernoulli.birch"
  using super_type_::logpdfLazy;
  #line 1 "src/distribution/Bernoulli.birch"
  using super_type_::simulate;
  #line 1 "src/distribution/Bernoulli.birch"
  using super_type_::simulateLazy;
  #line 1 "src/distribution/Bernoulli.birch"
  using super_type_::supportsLazy;
  
  #line 1 "src/distribution/Bernoulli.birch"
  Bernoulli(const libbirch::Lazy<libbirch::Shared<birch::type::Expression<birch::type::Real>>>& _u0961, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);

  libbirch::Lazy<libbirch::Shared<birch::type::Expression<birch::type::Real>>> _u0961;
  #line 10 "src/distribution/Bernoulli.birch"
  virtual birch::type::Boolean supportsLazy(const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
  #line 14 "src/distribution/Bernoulli.birch"
  virtual birch::type::Boolean simulate(const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
  #line 18 "src/distribution/Bernoulli.birch"
  virtual libbirch::Optional<birch::type::Boolean> simulateLazy(const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
  #line 22 "src/distribution/Bernoulli.birch"
  virtual birch::type::Real logpdf(const birch::type::Boolean& x, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
  #line 26 "src/distribution/Bernoulli.birch"
  virtual libbirch::Optional<libbirch::Lazy<libbirch::Shared<birch::type::Expression<birch::type::Real>>>> logpdfLazy(const libbirch::Lazy<libbirch::Shared<birch::type::Expression<birch::type::Boolean>>>& x, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
  #line 30 "src/distribution/Bernoulli.birch"
  virtual libbirch::Lazy<libbirch::Shared<birch::type::Distribution<birch::type::Boolean>>> graft(const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
  #line 43 "src/distribution/Bernoulli.birch"
  virtual void write(const libbirch::Lazy<libbirch::Shared<birch::type::Buffer>>& buffer, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
  
  #line 1 "src/distribution/Bernoulli.birch"
  LIBBIRCH_CLASS(Bernoulli, Distribution<birch::type::Boolean>)
  #line 1 "src/distribution/Bernoulli.birch"
  LIBBIRCH_MEMBERS(_u0961)
};

#line 1 "src/distribution/Exponential.birch"
class Exponential : public Distribution<birch::type::Real> {
public:
  #line 1 "src/distribution/Exponential.birch"
  using class_type_ = Exponential;
  #line 1 "src/distribution/Exponential.birch"
  using this_type_ = class_type_;
  #line 1 "src/distribution/Exponential.birch"
  using super_type_ = Distribution<birch::type::Real>;

  #line 1 "src/distribution/Exponential.birch"
  using super_type_::operator=;
  #line 1 "src/distribution/Exponential.birch"
  using super_type_::cdf;
  #line 1 "src/distribution/Exponential.birch"
  using super_type_::graft;
  #line 1 "src/distribution/Exponential.birch"
  using super_type_::logpdf;
  #line 1 "src/distribution/Exponential.birch"
  using super_type_::logpdfLazy;
  #line 1 "src/distribution/Exponential.birch"
  using super_type_::lower;
  #line 1 "src/distribution/Exponential.birch"
  using super_type_::quantile;
  #line 1 "src/distribution/Exponential.birch"
  using super_type_::simulate;
  #line 1 "src/distribution/Exponential.birch"
  using super_type_::simulateLazy;
  #line 1 "src/distribution/Exponential.birch"
  using super_type_::supportsLazy;
  
  #line 1 "src/distribution/Exponential.birch"
  Exponential(const libbirch::Lazy<libbirch::Shared<birch::type::Expression<birch::type::Real>>>& _u0955, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);

  libbirch::Lazy<libbirch::Shared<birch::type::Expression<birch::type::Real>>> _u0955;
  #line 10 "src/distribution/Exponential.birch"
  virtual birch::type::Boolean supportsLazy(const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
  #line 14 "src/distribution/Exponential.birch"
  virtual birch::type::Real simulate(const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
  #line 18 "src/distribution/Exponential.birch"
  virtual libbirch::Optional<birch::type::Real> simulateLazy(const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
  #line 22 "src/distribution/Exponential.birch"
  virtual birch::type::Real logpdf(const birch::type::Real& x, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
  #line 26 "src/distribution/Exponential.birch"
  virtual libbirch::Optional<libbirch::Lazy<libbirch::Shared<birch::type::Expression<birch::type::Real>>>> logpdfLazy(const libbirch::Lazy<libbirch::Shared<birch::type::Expression<birch::type::Real>>>& x, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
  #line 30 "src/distribution/Exponential.birch"
  virtual libbirch::Optional<birch::type::Real> cdf(const birch::type::Real& x, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
  #line 34 "src/distribution/Exponential.birch"
  virtual libbirch::Optional<birch::type::Real> quantile(const birch::type::Real& P, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
  #line 38 "src/distribution/Exponential.birch"
  virtual libbirch::Optional<birch::type::Real> lower(const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
  #line 42 "src/distribution/Exponential.birch"
  virtual libbirch::Lazy<libbirch::Shared<birch::type::Distribution<birch::type::Real>>> graft(const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
  #line 58 "src/distribution/Exponential.birch"
  virtual void write(const libbirch::Lazy<libbirch::Shared<birch::type::Buffer>>& buffer, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
  
  #line 1 "src/distribution/Exponential.birch"
  LIBBIRCH_CLASS(Exponential, Distribution<birch::type::Real>)
  #line 1 "src/distribution/Exponential.birch"
  LIBBIRCH_MEMBERS(_u0955)
};

#line 1 "src/distribution/Gamma.birch"
class Gamma : public Distribution<birch::type::Real> {
public:
  #line 1 "src/distribution/Gamma.birch"
  using class_type_ = Gamma;
  #line 1 "src/distribution/Gamma.birch"
  using this_type_ = class_type_;
  #line 1 "src/distribution/Gamma.birch"
  using super_type_ = Distribution<birch::type::Real>;

  #line 1 "src/distribution/Gamma.birch"
  using super_type_::operator=;
  #line 1 "src/distribution/Gamma.birch"
  using super_type_::cdf;
  #line 1 "src/distribution/Gamma.birch"
  using super_type_::graft;
  #line 1 "src/distribution/Gamma.birch"
  using super_type_::graftGamma;
  #line 1 "src/distribution/Gamma.birch"
  using super_type_::logpdf;
  #line 1 "src/distribution/Gamma.birch"
  using super_type_::logpdfLazy;
  #line 1 "src/distribution/Gamma.birch"
  using super_type_::lower;
  #line 1 "src/distribution/Gamma.birch"
  using super_type_::quantile;
  #line 1 "src/distribution/Gamma.birch"
  using super_type_::simulate;
  #line 1 "src/distribution/Gamma.birch"
  using super_type_::simulateLazy;
  #line 1 "src/distribution/Gamma.birch"
  using super_type_::supportsLazy;
  
  #line 1 "src/distribution/Gamma.birch"
  Gamma(const libbirch::Lazy<libbirch::Shared<birch::type::Expression<birch::type::Real>>>& k, const libbirch::Lazy<libbirch::Shared<birch::type::Expression<birch::type::Real>>>& _u0952, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);

  libbirch::Lazy<libbirch::Shared<birch::type::Expression<birch::type::Real>>> k;
  libbirch::Lazy<libbirch::Shared<birch::type::Expression<birch::type::Real>>> _u0952;
  #line 15 "src/distribution/Gamma.birch"
  virtual birch::type::Boolean supportsLazy(const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
  #line 19 "src/distribution/Gamma.birch"
  virtual birch::type::Real simulate(const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
  #line 23 "src/distribution/Gamma.birch"
  virtual libbirch::Optional<birch::type::Real> simulateLazy(const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
  #line 27 "src/distribution/Gamma.birch"
  virtual birch::type::Real logpdf(const birch::type::Real& x, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
  #line 31 "src/distribution/Gamma.birch"
  virtual libbirch::Optional<libbirch::Lazy<libbirch::Shared<birch::type::Expression<birch::type::Real>>>> logpdfLazy(const libbirch::Lazy<libbirch::Shared<birch::type::Expression<birch::type::Real>>>& x, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
  #line 35 "src/distribution/Gamma.birch"
  virtual libbirch::Optional<birch::type::Real> cdf(const birch::type::Real& x, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
  #line 39 "src/distribution/Gamma.birch"
  virtual libbirch::Optional<birch::type::Real> quantile(const birch::type::Real& P, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
  #line 43 "src/distribution/Gamma.birch"
  virtual libbirch::Optional<birch::type::Real> lower(const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
  #line 47 "src/distribution/Gamma.birch"
  virtual libbirch::Lazy<libbirch::Shared<birch::type::Distribution<birch::type::Real>>> graft(const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
  #line 60 "src/distribution/Gamma.birch"
  virtual libbirch::Optional<libbirch::Lazy<libbirch::Shared<birch::type::Gamma>>> graftGamma(const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
  #line 65 "src/distribution/Gamma.birch"
  virtual void write(const libbirch::Lazy<libbirch::Shared<birch::type::Buffer>>& buffer, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
  
  #line 1 "src/distribution/Gamma.birch"
  LIBBIRCH_CLASS(Gamma, Distribution<birch::type::Real>)
  #line 1 "src/distribution/Gamma.birch"
  LIBBIRCH_MEMBERS(k, _u0952)
};

#line 4 "src/distribution/GammaExponential.birch"
class GammaExponential final : public Distribution<birch::type::Real> {
public:
  #line 4 "src/distribution/GammaExponential.birch"
  using class_type_ = GammaExponential;
  #line 4 "src/distribution/GammaExponential.birch"
  using this_type_ = class_type_;
  #line 4 "src/distribution/GammaExponential.birch"
  using super_type_ = Distribution<birch::type::Real>;

  #line 4 "src/distribution/GammaExponential.birch"
  using super_type_::operator=;
  #line 4 "src/distribution/GammaExponential.birch"
  using super_type_::cdf;
  #line 4 "src/distribution/GammaExponential.birch"
  using super_type_::link;
  #line 4 "src/distribution/GammaExponential.birch"
  using super_type_::logpdf;
  #line 4 "src/distribution/GammaExponential.birch"
  using super_type_::logpdfLazy;
  #line 4 "src/distribution/GammaExponential.birch"
  using super_type_::lower;
  #line 4 "src/distribution/GammaExponential.birch"
  using super_type_::quantile;
  #line 4 "src/distribution/GammaExponential.birch"
  using super_type_::simulate;
  #line 4 "src/distribution/GammaExponential.birch"
  using super_type_::simulateLazy;
  #line 4 "src/distribution/GammaExponential.birch"
  using super_type_::supportsLazy;
  #line 4 "src/distribution/GammaExponential.birch"
  using super_type_::unlink;
  #line 4 "src/distribution/GammaExponential.birch"
  using super_type_::update;
  #line 4 "src/distribution/GammaExponential.birch"
  using super_type_::updateLazy;
  
  #line 4 "src/distribution/GammaExponential.birch"
  GammaExponential(const libbirch::Lazy<libbirch::Shared<birch::type::Gamma>>& _u0955, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);

  libbirch::Lazy<libbirch::Shared<birch::type::Gamma>> _u0955;
  #line 10 "src/distribution/GammaExponential.birch"
  virtual birch::type::Boolean supportsLazy(const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
  #line 14 "src/distribution/GammaExponential.birch"
  virtual birch::type::Real simulate(const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
  #line 18 "src/distribution/GammaExponential.birch"
  virtual libbirch::Optional<birch::type::Real> simulateLazy(const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
  #line 22 "src/distribution/GammaExponential.birch"
  virtual birch::type::Real logpdf(const birch::type::Real& x, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
  #line 26 "src/distribution/GammaExponential.birch"
  virtual libbirch::Optional<libbirch::Lazy<libbirch::Shared<birch::type::Expression<birch::type::Real>>>> logpdfLazy(const libbirch::Lazy<libbirch::Shared<birch::type::Expression<birch::type::Real>>>& x, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
  #line 30 "src/distribution/GammaExponential.birch"
  virtual void update(const birch::type::Real& x, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
  #line 34 "src/distribution/GammaExponential.birch"
  virtual void updateLazy(const libbirch::Lazy<libbirch::Shared<birch::type::Expression<birch::type::Real>>>& x, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
  #line 38 "src/distribution/GammaExponential.birch"
  virtual libbirch::Optional<birch::type::Real> cdf(const birch::type::Real& x, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
  #line 42 "src/distribution/GammaExponential.birch"
  virtual libbirch::Optional<birch::type::Real> quantile(const birch::type::Real& P, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
  #line 46 "src/distribution/GammaExponential.birch"
  virtual libbirch::Optional<birch::type::Real> lower(const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
  #line 50 "src/distribution/GammaExponential.birch"
  virtual void link(const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
  #line 54 "src/distribution/GammaExponential.birch"
  virtual void unlink(const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
  
  #line 4 "src/distribution/GammaExponential.birch"
  LIBBIRCH_CLASS(GammaExponential, Distribution<birch::type::Real>)
  #line 4 "src/distribution/GammaExponential.birch"
  LIBBIRCH_MEMBERS(_u0955)
};

#line 1 "src/distribution/Gaussian.birch"
class Gaussian : public Distribution<birch::type::Real> {
public:
  #line 1 "src/distribution/Gaussian.birch"
  using class_type_ = Gaussian;
  #line 1 "src/distribution/Gaussian.birch"
  using this_type_ = class_type_;
  #line 1 "src/distribution/Gaussian.birch"
  using super_type_ = Distribution<birch::type::Real>;

  #line 1 "src/distribution/Gaussian.birch"
  using super_type_::operator=;
  #line 1 "src/distribution/Gaussian.birch"
  using super_type_::cdf;
  #line 1 "src/distribution/Gaussian.birch"
  using super_type_::graft;
  #line 1 "src/distribution/Gaussian.birch"
  using super_type_::graftGaussian;
  #line 1 "src/distribution/Gaussian.birch"
  using super_type_::graftNormalInverseGamma;
  #line 1 "src/distribution/Gaussian.birch"
  using super_type_::logpdf;
  #line 1 "src/distribution/Gaussian.birch"
  using super_type_::logpdfLazy;
  #line 1 "src/distribution/Gaussian.birch"
  using super_type_::quantile;
  #line 1 "src/distribution/Gaussian.birch"
  using super_type_::simulate;
  #line 1 "src/distribution/Gaussian.birch"
  using super_type_::simulateLazy;
  #line 1 "src/distribution/Gaussian.birch"
  using super_type_::supportsLazy;
  
  #line 1 "src/distribution/Gaussian.birch"
  Gaussian(const libbirch::Lazy<libbirch::Shared<birch::type::Expression<birch::type::Real>>>& _u0956, const libbirch::Lazy<libbirch::Shared<birch::type::Expression<birch::type::Real>>>& _u09632, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);

  libbirch::Lazy<libbirch::Shared<birch::type::Expression<birch::type::Real>>> _u0956;
  libbirch::Lazy<libbirch::Shared<birch::type::Expression<birch::type::Real>>> _u09632;
  #line 16 "src/distribution/Gaussian.birch"
  virtual birch::type::Boolean supportsLazy(const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
  #line 20 "src/distribution/Gaussian.birch"
  virtual birch::type::Real simulate(const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
  #line 24 "src/distribution/Gaussian.birch"
  virtual libbirch::Optional<birch::type::Real> simulateLazy(const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
  #line 28 "src/distribution/Gaussian.birch"
  virtual birch::type::Real logpdf(const birch::type::Real& x, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
  #line 32 "src/distribution/Gaussian.birch"
  virtual libbirch::Optional<libbirch::Lazy<libbirch::Shared<birch::type::Expression<birch::type::Real>>>> logpdfLazy(const libbirch::Lazy<libbirch::Shared<birch::type::Expression<birch::type::Real>>>& x, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
  #line 36 "src/distribution/Gaussian.birch"
  virtual libbirch::Optional<birch::type::Real> cdf(const birch::type::Real& x, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
  #line 40 "src/distribution/Gaussian.birch"
  virtual libbirch::Optional<birch::type::Real> quantile(const birch::type::Real& P, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
  #line 44 "src/distribution/Gaussian.birch"
  virtual libbirch::Lazy<libbirch::Shared<birch::type::Distribution<birch::type::Real>>> graft(const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
  #line 76 "src/distribution/Gaussian.birch"
  virtual libbirch::Optional<libbirch::Lazy<libbirch::Shared<birch::type::Gaussian>>> graftGaussian(const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
  #line 95 "src/distribution/Gaussian.birch"
  virtual libbirch::Optional<libbirch::Lazy<libbirch::Shared<birch::type::NormalInverseGamma>>> graftNormalInverseGamma(const libbirch::Lazy<libbirch::Shared<birch::type::Distribution<birch::type::Real>>>& compare, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
  #line 109 "src/distribution/Gaussian.birch"
  virtual void write(const libbirch::Lazy<libbirch::Shared<birch::type::Buffer>>& buffer, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
  
  #line 1 "src/distribution/Gaussian.birch"
  LIBBIRCH_CLASS(Gaussian, Distribution<birch::type::Real>)
  #line 1 "src/distribution/Gaussian.birch"
  LIBBIRCH_MEMBERS(_u0956, _u09632)
};

#line 4 "src/distribution/GaussianGaussian.birch"
class GaussianGaussian final : public Gaussian {
public:
  #line 4 "src/distribution/GaussianGaussian.birch"
  using class_type_ = GaussianGaussian;
  #line 4 "src/distribution/GaussianGaussian.birch"
  using this_type_ = class_type_;
  #line 4 "src/distribution/GaussianGaussian.birch"
  using super_type_ = Gaussian;

  #line 4 "src/distribution/GaussianGaussian.birch"
  using super_type_::operator=;
  #line 4 "src/distribution/GaussianGaussian.birch"
  using super_type_::link;
  #line 4 "src/distribution/GaussianGaussian.birch"
  using super_type_::unlink;
  #line 4 "src/distribution/GaussianGaussian.birch"
  using super_type_::update;
  #line 4 "src/distribution/GaussianGaussian.birch"
  using super_type_::updateLazy;
  
  #line 4 "src/distribution/GaussianGaussian.birch"
  GaussianGaussian(const libbirch::Lazy<libbirch::Shared<birch::type::Gaussian>>& m, const libbirch::Lazy<libbirch::Shared<birch::type::Expression<birch::type::Real>>>& s2, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);

  libbirch::Lazy<libbirch::Shared<birch::type::Gaussian>> m;
  libbirch::Lazy<libbirch::Shared<birch::type::Expression<birch::type::Real>>> s2;
  #line 16 "src/distribution/GaussianGaussian.birch"
  virtual void update(const birch::type::Real& x, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
  #line 20 "src/distribution/GaussianGaussian.birch"
  virtual void updateLazy(const libbirch::Lazy<libbirch::Shared<birch::type::Expression<birch::type::Real>>>& x, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
  #line 24 "src/distribution/GaussianGaussian.birch"
  virtual void link(const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
  #line 28 "src/distribution/GaussianGaussian.birch"
  virtual void unlink(const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
  
  #line 4 "src/distribution/GaussianGaussian.birch"
  LIBBIRCH_CLASS(GaussianGaussian, Gaussian)
  #line 4 "src/distribution/GaussianGaussian.birch"
  LIBBIRCH_MEMBERS(m, s2)
};

#line 4 "src/distribution/LinearGaussianGaussian.birch"
class LinearGaussianGaussian final : public Gaussian {
public:
  #line 4 "src/distribution/LinearGaussianGaussian.birch"
  using class_type_ = LinearGaussianGaussian;
  #line 4 "src/distribution/LinearGaussianGaussian.birch"
  using this_type_ = class_type_;
  #line 4 "src/distribution/LinearGaussianGaussian.birch"
  using super_type_ = Gaussian;

  #line 4 "src/distribution/LinearGaussianGaussian.birch"
  using super_type_::operator=;
  #line 4 "src/distribution/LinearGaussianGaussian.birch"
  using super_type_::link;
  #line 4 "src/distribution/LinearGaussianGaussian.birch"
  using super_type_::unlink;
  #line 4 "src/distribution/LinearGaussianGaussian.birch"
  using super_type_::update;
  #line 4 "src/distribution/LinearGaussianGaussian.birch"
  using super_type_::updateLazy;
  
  #line 4 "src/distribution/LinearGaussianGaussian.birch"
  LinearGaussianGaussian(const libbirch::Lazy<libbirch::Shared<birch::type::Expression<birch::type::Real>>>& a, const libbirch::Lazy<libbirch::Shared<birch::type::Gaussian>>& m, const libbirch::Lazy<libbirch::Shared<birch::type::Expression<birch::type::Real>>>& c, const libbirch::Lazy<libbirch::Shared<birch::type::Expression<birch::type::Real>>>& s2, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);

  libbirch::Lazy<libbirch::Shared<birch::type::Expression<birch::type::Real>>> a;
  libbirch::Lazy<libbirch::Shared<birch::type::Gaussian>> m;
  libbirch::Lazy<libbirch::Shared<birch::type::Expression<birch::type::Real>>> c;
  libbirch::Lazy<libbirch::Shared<birch::type::Expression<birch::type::Real>>> s2;
  #line 27 "src/distribution/LinearGaussianGaussian.birch"
  virtual void update(const birch::type::Real& x, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
  #line 31 "src/distribution/LinearGaussianGaussian.birch"
  virtual void updateLazy(const libbirch::Lazy<libbirch::Shared<birch::type::Expression<birch::type::Real>>>& x, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
  #line 35 "src/distribution/LinearGaussianGaussian.birch"
  virtual void link(const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
  #line 39 "src/distribution/LinearGaussianGaussian.birch"
  virtual void unlink(const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
  
  #line 4 "src/distribution/LinearGaussianGaussian.birch"
  LIBBIRCH_CLASS(LinearGaussianGaussian, Gaussian)
  #line 4 "src/distribution/LinearGaussianGaussian.birch"
  LIBBIRCH_MEMBERS(a, m, c, s2)
};

#line 4 "src/distribution/LinearMultivariateGaussianGaussian.birch"
class LinearMultivariateGaussianGaussian final : public Gaussian {
public:
  #line 4 "src/distribution/LinearMultivariateGaussianGaussian.birch"
  using class_type_ = LinearMultivariateGaussianGaussian;
  #line 4 "src/distribution/LinearMultivariateGaussianGaussian.birch"
  using this_type_ = class_type_;
  #line 4 "src/distribution/LinearMultivariateGaussianGaussian.birch"
  using super_type_ = Gaussian;

  #line 4 "src/distribution/LinearMultivariateGaussianGaussian.birch"
  using super_type_::operator=;
  #line 4 "src/distribution/LinearMultivariateGaussianGaussian.birch"
  using super_type_::link;
  #line 4 "src/distribution/LinearMultivariateGaussianGaussian.birch"
  using super_type_::unlink;
  #line 4 "src/distribution/LinearMultivariateGaussianGaussian.birch"
  using super_type_::update;
  #line 4 "src/distribution/LinearMultivariateGaussianGaussian.birch"
  using super_type_::updateLazy;
  
  #line 4 "src/distribution/LinearMultivariateGaussianGaussian.birch"
  LinearMultivariateGaussianGaussian(const libbirch::Lazy<libbirch::Shared<birch::type::Expression<libbirch::DefaultArray<birch::type::Real,1>>>>& a, const libbirch::Lazy<libbirch::Shared<birch::type::MultivariateGaussian>>& m, const libbirch::Lazy<libbirch::Shared<birch::type::Expression<birch::type::Real>>>& c, const libbirch::Lazy<libbirch::Shared<birch::type::Expression<birch::type::Real>>>& s2, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);

  libbirch::Lazy<libbirch::Shared<birch::type::Expression<libbirch::DefaultArray<birch::type::Real,1>>>> a;
  libbirch::Lazy<libbirch::Shared<birch::type::MultivariateGaussian>> m;
  libbirch::Lazy<libbirch::Shared<birch::type::Expression<birch::type::Real>>> c;
  libbirch::Lazy<libbirch::Shared<birch::type::Expression<birch::type::Real>>> s2;
  #line 27 "src/distribution/LinearMultivariateGaussianGaussian.birch"
  virtual void update(const birch::type::Real& x, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
  #line 32 "src/distribution/LinearMultivariateGaussianGaussian.birch"
  virtual void updateLazy(const libbirch::Lazy<libbirch::Shared<birch::type::Expression<birch::type::Real>>>& x, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
  #line 37 "src/distribution/LinearMultivariateGaussianGaussian.birch"
  virtual void link(const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
  #line 41 "src/distribution/LinearMultivariateGaussianGaussian.birch"
  virtual void unlink(const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
  
  #line 4 "src/distribution/LinearMultivariateGaussianGaussian.birch"
  LIBBIRCH_CLASS(LinearMultivariateGaussianGaussian, Gaussian)
  #line 4 "src/distribution/LinearMultivariateGaussianGaussian.birch"
  LIBBIRCH_MEMBERS(a, m, c, s2)
};

#line 5 "src/distribution/IdenticalGaussian.birch"
class IdenticalGaussian final : public Distribution<libbirch::DefaultArray<birch::type::Real,1>> {
public:
  #line 5 "src/distribution/IdenticalGaussian.birch"
  using class_type_ = IdenticalGaussian;
  #line 5 "src/distribution/IdenticalGaussian.birch"
  using this_type_ = class_type_;
  #line 5 "src/distribution/IdenticalGaussian.birch"
  using super_type_ = Distribution<libbirch::DefaultArray<birch::type::Real,1>>;

  #line 5 "src/distribution/IdenticalGaussian.birch"
  using super_type_::operator=;
  #line 5 "src/distribution/IdenticalGaussian.birch"
  using super_type_::graft;
  #line 5 "src/distribution/IdenticalGaussian.birch"
  using super_type_::graftMultivariateGaussian;
  #line 5 "src/distribution/IdenticalGaussian.birch"
  using super_type_::graftMultivariateNormalInverseGamma;
  #line 5 "src/distribution/IdenticalGaussian.birch"
  using super_type_::logpdf;
  #line 5 "src/distribution/IdenticalGaussian.birch"
  using super_type_::logpdfLazy;
  #line 5 "src/distribution/IdenticalGaussian.birch"
  using super_type_::rows;
  #line 5 "src/distribution/IdenticalGaussian.birch"
  using super_type_::simulate;
  #line 5 "src/distribution/IdenticalGaussian.birch"
  using super_type_::simulateLazy;
  #line 5 "src/distribution/IdenticalGaussian.birch"
  using super_type_::supportsLazy;
  
  #line 5 "src/distribution/IdenticalGaussian.birch"
  IdenticalGaussian(const libbirch::Lazy<libbirch::Shared<birch::type::Expression<libbirch::DefaultArray<birch::type::Real,1>>>>& _u0956, const libbirch::Lazy<libbirch::Shared<birch::type::Expression<birch::type::Real>>>& _u09632, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);

  libbirch::Lazy<libbirch::Shared<birch::type::Expression<libbirch::DefaultArray<birch::type::Real,1>>>> _u0956;
  libbirch::Lazy<libbirch::Shared<birch::type::Expression<birch::type::Real>>> _u09632;
  #line 17 "src/distribution/IdenticalGaussian.birch"
  virtual birch::type::Integer rows(const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
  #line 21 "src/distribution/IdenticalGaussian.birch"
  virtual birch::type::Boolean supportsLazy(const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
  #line 25 "src/distribution/IdenticalGaussian.birch"
  virtual libbirch::DefaultArray<birch::type::Real,1> simulate(const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
  #line 29 "src/distribution/IdenticalGaussian.birch"
  virtual libbirch::Optional<libbirch::DefaultArray<birch::type::Real,1>> simulateLazy(const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
  #line 33 "src/distribution/IdenticalGaussian.birch"
  virtual birch::type::Real logpdf(const libbirch::DefaultArray<birch::type::Real,1>& x, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
  #line 37 "src/distribution/IdenticalGaussian.birch"
  virtual libbirch::Optional<libbirch::Lazy<libbirch::Shared<birch::type::Expression<birch::type::Real>>>> logpdfLazy(const libbirch::Lazy<libbirch::Shared<birch::type::Expression<libbirch::DefaultArray<birch::type::Real,1>>>>& x, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
  #line 41 "src/distribution/IdenticalGaussian.birch"
  virtual libbirch::Lazy<libbirch::Shared<birch::type::Distribution<libbirch::DefaultArray<birch::type::Real,1>>>> graft(const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
  #line 69 "src/distribution/IdenticalGaussian.birch"
  virtual libbirch::Optional<libbirch::Lazy<libbirch::Shared<birch::type::MultivariateGaussian>>> graftMultivariateGaussian(const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
  #line 89 "src/distribution/IdenticalGaussian.birch"
  virtual libbirch::Optional<libbirch::Lazy<libbirch::Shared<birch::type::MultivariateNormalInverseGamma>>> graftMultivariateNormalInverseGamma(const libbirch::Lazy<libbirch::Shared<birch::type::Distribution<birch::type::Real>>>& compare, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
  
  #line 5 "src/distribution/IdenticalGaussian.birch"
  LIBBIRCH_CLASS(IdenticalGaussian, Distribution<libbirch::DefaultArray<birch::type::Real,1>>)
  #line 5 "src/distribution/IdenticalGaussian.birch"
  LIBBIRCH_MEMBERS(_u0956, _u09632)
};

#line 4 "src/distribution/IndependentRowMatrixGaussian.birch"
class IndependentRowMatrixGaussian final : public Distribution<libbirch::DefaultArray<birch::type::Real,2>> {
public:
  #line 4 "src/distribution/IndependentRowMatrixGaussian.birch"
  using class_type_ = IndependentRowMatrixGaussian;
  #line 4 "src/distribution/IndependentRowMatrixGaussian.birch"
  using this_type_ = class_type_;
  #line 4 "src/distribution/IndependentRowMatrixGaussian.birch"
  using super_type_ = Distribution<libbirch::DefaultArray<birch::type::Real,2>>;

  #line 4 "src/distribution/IndependentRowMatrixGaussian.birch"
  using super_type_::operator=;
  #line 4 "src/distribution/IndependentRowMatrixGaussian.birch"
  using super_type_::columns;
  #line 4 "src/distribution/IndependentRowMatrixGaussian.birch"
  using super_type_::graft;
  #line 4 "src/distribution/IndependentRowMatrixGaussian.birch"
  using super_type_::graftMatrixGaussian;
  #line 4 "src/distribution/IndependentRowMatrixGaussian.birch"
  using super_type_::graftMatrixNormalInverseWishart;
  #line 4 "src/distribution/IndependentRowMatrixGaussian.birch"
  using super_type_::logpdf;
  #line 4 "src/distribution/IndependentRowMatrixGaussian.birch"
  using super_type_::logpdfLazy;
  #line 4 "src/distribution/IndependentRowMatrixGaussian.birch"
  using super_type_::rows;
  #line 4 "src/distribution/IndependentRowMatrixGaussian.birch"
  using super_type_::simulate;
  #line 4 "src/distribution/IndependentRowMatrixGaussian.birch"
  using super_type_::simulateLazy;
  #line 4 "src/distribution/IndependentRowMatrixGaussian.birch"
  using super_type_::supportsLazy;
  
  #line 4 "src/distribution/IndependentRowMatrixGaussian.birch"
  IndependentRowMatrixGaussian(const libbirch::Lazy<libbirch::Shared<birch::type::Expression<libbirch::DefaultArray<birch::type::Real,2>>>>& M, const libbirch::Lazy<libbirch::Shared<birch::type::Expression<birch::type::LLT>>>& V, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);

  libbirch::Lazy<libbirch::Shared<birch::type::Expression<libbirch::DefaultArray<birch::type::Real,2>>>> M;
  libbirch::Lazy<libbirch::Shared<birch::type::Expression<birch::type::LLT>>> V;
  #line 16 "src/distribution/IndependentRowMatrixGaussian.birch"
  virtual birch::type::Integer rows(const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
  #line 20 "src/distribution/IndependentRowMatrixGaussian.birch"
  virtual birch::type::Integer columns(const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
  #line 24 "src/distribution/IndependentRowMatrixGaussian.birch"
  virtual birch::type::Boolean supportsLazy(const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
  #line 28 "src/distribution/IndependentRowMatrixGaussian.birch"
  virtual libbirch::DefaultArray<birch::type::Real,2> simulate(const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
  #line 32 "src/distribution/IndependentRowMatrixGaussian.birch"
  virtual libbirch::Optional<libbirch::DefaultArray<birch::type::Real,2>> simulateLazy(const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
  #line 36 "src/distribution/IndependentRowMatrixGaussian.birch"
  virtual birch::type::Real logpdf(const libbirch::DefaultArray<birch::type::Real,2>& x, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
  #line 40 "src/distribution/IndependentRowMatrixGaussian.birch"
  virtual libbirch::Optional<libbirch::Lazy<libbirch::Shared<birch::type::Expression<birch::type::Real>>>> logpdfLazy(const libbirch::Lazy<libbirch::Shared<birch::type::Expression<libbirch::DefaultArray<birch::type::Real,2>>>>& x, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
  #line 44 "src/distribution/IndependentRowMatrixGaussian.birch"
  virtual libbirch::Lazy<libbirch::Shared<birch::type::Distribution<libbirch::DefaultArray<birch::type::Real,2>>>> graft(const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
  #line 64 "src/distribution/IndependentRowMatrixGaussian.birch"
  virtual libbirch::Optional<libbirch::Lazy<libbirch::Shared<birch::type::MatrixGaussian>>> graftMatrixGaussian(const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
  #line 69 "src/distribution/IndependentRowMatrixGaussian.birch"
  virtual libbirch::Optional<libbirch::Lazy<libbirch::Shared<birch::type::MatrixNormalInverseWishart>>> graftMatrixNormalInverseWishart(const libbirch::Lazy<libbirch::Shared<birch::type::Distribution<birch::type::LLT>>>& compare, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
  
  #line 4 "src/distribution/IndependentRowMatrixGaussian.birch"
  LIBBIRCH_CLASS(IndependentRowMatrixGaussian, Distribution<libbirch::DefaultArray<birch::type::Real,2>>)
  #line 4 "src/distribution/IndependentRowMatrixGaussian.birch"
  LIBBIRCH_MEMBERS(M, V)
};

#line 4 "src/distribution/IndependentUniform.birch"
class IndependentUniform final : public Distribution<libbirch::DefaultArray<birch::type::Real,1>> {
public:
  #line 4 "src/distribution/IndependentUniform.birch"
  using class_type_ = IndependentUniform;
  #line 4 "src/distribution/IndependentUniform.birch"
  using this_type_ = class_type_;
  #line 4 "src/distribution/IndependentUniform.birch"
  using super_type_ = Distribution<libbirch::DefaultArray<birch::type::Real,1>>;

  #line 4 "src/distribution/IndependentUniform.birch"
  using super_type_::operator=;
  #line 4 "src/distribution/IndependentUniform.birch"
  using super_type_::logpdf;
  #line 4 "src/distribution/IndependentUniform.birch"
  using super_type_::rows;
  #line 4 "src/distribution/IndependentUniform.birch"
  using super_type_::simulate;
  #line 4 "src/distribution/IndependentUniform.birch"
  using super_type_::supportsLazy;
  
  #line 4 "src/distribution/IndependentUniform.birch"
  IndependentUniform(const libbirch::Lazy<libbirch::Shared<birch::type::Expression<libbirch::DefaultArray<birch::type::Real,1>>>>& l, const libbirch::Lazy<libbirch::Shared<birch::type::Expression<libbirch::DefaultArray<birch::type::Real,1>>>>& u, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);

  libbirch::Lazy<libbirch::Shared<birch::type::Expression<libbirch::DefaultArray<birch::type::Real,1>>>> l;
  libbirch::Lazy<libbirch::Shared<birch::type::Expression<libbirch::DefaultArray<birch::type::Real,1>>>> u;
  #line 16 "src/distribution/IndependentUniform.birch"
  virtual birch::type::Integer rows(const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
  #line 20 "src/distribution/IndependentUniform.birch"
  virtual birch::type::Boolean supportsLazy(const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
  #line 24 "src/distribution/IndependentUniform.birch"
  virtual libbirch::DefaultArray<birch::type::Real,1> simulate(const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
  #line 32 "src/distribution/IndependentUniform.birch"
  virtual birch::type::Real logpdf(const libbirch::DefaultArray<birch::type::Real,1>& x, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
  #line 40 "src/distribution/IndependentUniform.birch"
  virtual void write(const libbirch::Lazy<libbirch::Shared<birch::type::Buffer>>& buffer, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
  
  #line 4 "src/distribution/IndependentUniform.birch"
  LIBBIRCH_CLASS(IndependentUniform, Distribution<libbirch::DefaultArray<birch::type::Real,1>>)
  #line 4 "src/distribution/IndependentUniform.birch"
  LIBBIRCH_MEMBERS(l, u)
};

#line 5 "src/distribution/IndependentUniformInteger.birch"
class IndependentUniformInteger final : public Distribution<libbirch::DefaultArray<birch::type::Integer,1>> {
public:
  #line 5 "src/distribution/IndependentUniformInteger.birch"
  using class_type_ = IndependentUniformInteger;
  #line 5 "src/distribution/IndependentUniformInteger.birch"
  using this_type_ = class_type_;
  #line 5 "src/distribution/IndependentUniformInteger.birch"
  using super_type_ = Distribution<libbirch::DefaultArray<birch::type::Integer,1>>;

  #line 5 "src/distribution/IndependentUniformInteger.birch"
  using super_type_::operator=;
  #line 5 "src/distribution/IndependentUniformInteger.birch"
  using super_type_::logpdf;
  #line 5 "src/distribution/IndependentUniformInteger.birch"
  using super_type_::rows;
  #line 5 "src/distribution/IndependentUniformInteger.birch"
  using super_type_::simulate;
  #line 5 "src/distribution/IndependentUniformInteger.birch"
  using super_type_::supportsLazy;
  
  #line 5 "src/distribution/IndependentUniformInteger.birch"
  IndependentUniformInteger(const libbirch::Lazy<libbirch::Shared<birch::type::Expression<libbirch::DefaultArray<birch::type::Integer,1>>>>& l, const libbirch::Lazy<libbirch::Shared<birch::type::Expression<libbirch::DefaultArray<birch::type::Integer,1>>>>& u, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);

  libbirch::Lazy<libbirch::Shared<birch::type::Expression<libbirch::DefaultArray<birch::type::Integer,1>>>> l;
  libbirch::Lazy<libbirch::Shared<birch::type::Expression<libbirch::DefaultArray<birch::type::Integer,1>>>> u;
  #line 17 "src/distribution/IndependentUniformInteger.birch"
  virtual birch::type::Integer rows(const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
  #line 21 "src/distribution/IndependentUniformInteger.birch"
  virtual birch::type::Boolean supportsLazy(const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
  #line 25 "src/distribution/IndependentUniformInteger.birch"
  virtual libbirch::DefaultArray<birch::type::Integer,1> simulate(const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
  #line 33 "src/distribution/IndependentUniformInteger.birch"
  virtual birch::type::Real logpdf(const libbirch::DefaultArray<birch::type::Integer,1>& x, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
  #line 41 "src/distribution/IndependentUniformInteger.birch"
  virtual void write(const libbirch::Lazy<libbirch::Shared<birch::type::Buffer>>& buffer, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
  
  #line 5 "src/distribution/IndependentUniformInteger.birch"
  LIBBIRCH_CLASS(IndependentUniformInteger, Distribution<libbirch::DefaultArray<birch::type::Integer,1>>)
  #line 5 "src/distribution/IndependentUniformInteger.birch"
  LIBBIRCH_MEMBERS(l, u)
};

#line 4 "src/distribution/InverseGamma.birch"
class InverseGamma final : public Distribution<birch::type::Real> {
public:
  #line 4 "src/distribution/InverseGamma.birch"
  using class_type_ = InverseGamma;
  #line 4 "src/distribution/InverseGamma.birch"
  using this_type_ = class_type_;
  #line 4 "src/distribution/InverseGamma.birch"
  using super_type_ = Distribution<birch::type::Real>;

  #line 4 "src/distribution/InverseGamma.birch"
  using super_type_::operator=;
  #line 4 "src/distribution/InverseGamma.birch"
  using super_type_::cdf;
  #line 4 "src/distribution/InverseGamma.birch"
  using super_type_::graftInverseGamma;
  #line 4 "src/distribution/InverseGamma.birch"
  using super_type_::logpdf;
  #line 4 "src/distribution/InverseGamma.birch"
  using super_type_::logpdfLazy;
  #line 4 "src/distribution/InverseGamma.birch"
  using super_type_::lower;
  #line 4 "src/distribution/InverseGamma.birch"
  using super_type_::quantile;
  #line 4 "src/distribution/InverseGamma.birch"
  using super_type_::simulate;
  #line 4 "src/distribution/InverseGamma.birch"
  using super_type_::simulateLazy;
  #line 4 "src/distribution/InverseGamma.birch"
  using super_type_::supportsLazy;
  
  #line 4 "src/distribution/InverseGamma.birch"
  InverseGamma(const libbirch::Lazy<libbirch::Shared<birch::type::Expression<birch::type::Real>>>& _u0945, const libbirch::Lazy<libbirch::Shared<birch::type::Expression<birch::type::Real>>>& _u0946, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);

  libbirch::Lazy<libbirch::Shared<birch::type::Expression<birch::type::Real>>> _u0945;
  libbirch::Lazy<libbirch::Shared<birch::type::Expression<birch::type::Real>>> _u0946;
  #line 16 "src/distribution/InverseGamma.birch"
  virtual birch::type::Boolean supportsLazy(const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
  #line 20 "src/distribution/InverseGamma.birch"
  virtual birch::type::Real simulate(const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
  #line 24 "src/distribution/InverseGamma.birch"
  virtual libbirch::Optional<birch::type::Real> simulateLazy(const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
  #line 28 "src/distribution/InverseGamma.birch"
  virtual birch::type::Real logpdf(const birch::type::Real& x, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
  #line 32 "src/distribution/InverseGamma.birch"
  virtual libbirch::Optional<libbirch::Lazy<libbirch::Shared<birch::type::Expression<birch::type::Real>>>> logpdfLazy(const libbirch::Lazy<libbirch::Shared<birch::type::Expression<birch::type::Real>>>& x, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
  #line 36 "src/distribution/InverseGamma.birch"
  virtual libbirch::Optional<birch::type::Real> cdf(const birch::type::Real& x, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
  #line 40 "src/distribution/InverseGamma.birch"
  virtual libbirch::Optional<birch::type::Real> quantile(const birch::type::Real& P, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
  #line 44 "src/distribution/InverseGamma.birch"
  virtual libbirch::Optional<birch::type::Real> lower(const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
  #line 48 "src/distribution/InverseGamma.birch"
  virtual libbirch::Optional<libbirch::Lazy<libbirch::Shared<birch::type::InverseGamma>>> graftInverseGamma(const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
  #line 53 "src/distribution/InverseGamma.birch"
  virtual void write(const libbirch::Lazy<libbirch::Shared<birch::type::Buffer>>& buffer, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
  
  #line 4 "src/distribution/InverseGamma.birch"
  LIBBIRCH_CLASS(InverseGamma, Distribution<birch::type::Real>)
  #line 4 "src/distribution/InverseGamma.birch"
  LIBBIRCH_MEMBERS(_u0945, _u0946)
};

#line 4 "src/distribution/InverseGammaGamma.birch"
class InverseGammaGamma final : public Distribution<birch::type::Real> {
public:
  #line 4 "src/distribution/InverseGammaGamma.birch"
  using class_type_ = InverseGammaGamma;
  #line 4 "src/distribution/InverseGammaGamma.birch"
  using this_type_ = class_type_;
  #line 4 "src/distribution/InverseGammaGamma.birch"
  using super_type_ = Distribution<birch::type::Real>;

  #line 4 "src/distribution/InverseGammaGamma.birch"
  using super_type_::operator=;
  #line 4 "src/distribution/InverseGammaGamma.birch"
  using super_type_::cdf;
  #line 4 "src/distribution/InverseGammaGamma.birch"
  using super_type_::link;
  #line 4 "src/distribution/InverseGammaGamma.birch"
  using super_type_::logpdf;
  #line 4 "src/distribution/InverseGammaGamma.birch"
  using super_type_::logpdfLazy;
  #line 4 "src/distribution/InverseGammaGamma.birch"
  using super_type_::lower;
  #line 4 "src/distribution/InverseGammaGamma.birch"
  using super_type_::simulate;
  #line 4 "src/distribution/InverseGammaGamma.birch"
  using super_type_::simulateLazy;
  #line 4 "src/distribution/InverseGammaGamma.birch"
  using super_type_::supportsLazy;
  #line 4 "src/distribution/InverseGammaGamma.birch"
  using super_type_::unlink;
  #line 4 "src/distribution/InverseGammaGamma.birch"
  using super_type_::update;
  #line 4 "src/distribution/InverseGammaGamma.birch"
  using super_type_::updateLazy;
  
  #line 4 "src/distribution/InverseGammaGamma.birch"
  InverseGammaGamma(const libbirch::Lazy<libbirch::Shared<birch::type::Expression<birch::type::Real>>>& k, const libbirch::Lazy<libbirch::Shared<birch::type::InverseGamma>>& _u0952, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);

  libbirch::Lazy<libbirch::Shared<birch::type::Expression<birch::type::Real>>> k;
  libbirch::Lazy<libbirch::Shared<birch::type::InverseGamma>> _u0952;
  #line 16 "src/distribution/InverseGammaGamma.birch"
  virtual birch::type::Boolean supportsLazy(const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
  #line 20 "src/distribution/InverseGammaGamma.birch"
  virtual birch::type::Real simulate(const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
  #line 24 "src/distribution/InverseGammaGamma.birch"
  virtual libbirch::Optional<birch::type::Real> simulateLazy(const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
  #line 28 "src/distribution/InverseGammaGamma.birch"
  virtual birch::type::Real logpdf(const birch::type::Real& x, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
  #line 32 "src/distribution/InverseGammaGamma.birch"
  virtual libbirch::Optional<libbirch::Lazy<libbirch::Shared<birch::type::Expression<birch::type::Real>>>> logpdfLazy(const libbirch::Lazy<libbirch::Shared<birch::type::Expression<birch::type::Real>>>& x, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
  #line 36 "src/distribution/InverseGammaGamma.birch"
  virtual void update(const birch::type::Real& x, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
  #line 40 "src/distribution/InverseGammaGamma.birch"
  virtual void updateLazy(const libbirch::Lazy<libbirch::Shared<birch::type::Expression<birch::type::Real>>>& x, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
  #line 44 "src/distribution/InverseGammaGamma.birch"
  virtual libbirch::Optional<birch::type::Real> cdf(const birch::type::Real& x, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
  #line 48 "src/distribution/InverseGammaGamma.birch"
  virtual libbirch::Optional<birch::type::Real> lower(const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
  #line 52 "src/distribution/InverseGammaGamma.birch"
  virtual void link(const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
  #line 56 "src/distribution/InverseGammaGamma.birch"
  virtual void unlink(const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
  
  #line 4 "src/distribution/InverseGammaGamma.birch"
  LIBBIRCH_CLASS(InverseGammaGamma, Distribution<birch::type::Real>)
  #line 4 "src/distribution/InverseGammaGamma.birch"
  LIBBIRCH_MEMBERS(k, _u0952)
};

#line 30 "src/distribution/InverseWishart.birch"
class InverseWishart final : public Distribution<birch::type::LLT> {
public:
  #line 30 "src/distribution/InverseWishart.birch"
  using class_type_ = InverseWishart;
  #line 30 "src/distribution/InverseWishart.birch"
  using this_type_ = class_type_;
  #line 30 "src/distribution/InverseWishart.birch"
  using super_type_ = Distribution<birch::type::LLT>;

  #line 30 "src/distribution/InverseWishart.birch"
  using super_type_::operator=;
  #line 30 "src/distribution/InverseWishart.birch"
  using super_type_::columns;
  #line 30 "src/distribution/InverseWishart.birch"
  using super_type_::graftInverseWishart;
  #line 30 "src/distribution/InverseWishart.birch"
  using super_type_::logpdf;
  #line 30 "src/distribution/InverseWishart.birch"
  using super_type_::logpdfLazy;
  #line 30 "src/distribution/InverseWishart.birch"
  using super_type_::rows;
  #line 30 "src/distribution/InverseWishart.birch"
  using super_type_::simulate;
  #line 30 "src/distribution/InverseWishart.birch"
  using super_type_::simulateLazy;
  #line 30 "src/distribution/InverseWishart.birch"
  using super_type_::supportsLazy;
  
  #line 30 "src/distribution/InverseWishart.birch"
  InverseWishart(const libbirch::Lazy<libbirch::Shared<birch::type::Expression<birch::type::LLT>>>& _u0936, const libbirch::Lazy<libbirch::Shared<birch::type::Expression<birch::type::Real>>>& k, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);

  libbirch::Lazy<libbirch::Shared<birch::type::Expression<birch::type::LLT>>> _u0936;
  libbirch::Lazy<libbirch::Shared<birch::type::Expression<birch::type::Real>>> k;
  #line 42 "src/distribution/InverseWishart.birch"
  virtual birch::type::Integer rows(const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
  #line 46 "src/distribution/InverseWishart.birch"
  virtual birch::type::Integer columns(const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
  #line 50 "src/distribution/InverseWishart.birch"
  virtual birch::type::Boolean supportsLazy(const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
  #line 54 "src/distribution/InverseWishart.birch"
  virtual birch::type::LLT simulate(const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
  #line 58 "src/distribution/InverseWishart.birch"
  virtual libbirch::Optional<birch::type::LLT> simulateLazy(const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
  #line 62 "src/distribution/InverseWishart.birch"
  virtual birch::type::Real logpdf(const birch::type::LLT& X, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
  #line 66 "src/distribution/InverseWishart.birch"
  virtual libbirch::Optional<libbirch::Lazy<libbirch::Shared<birch::type::Expression<birch::type::Real>>>> logpdfLazy(const libbirch::Lazy<libbirch::Shared<birch::type::Expression<birch::type::LLT>>>& X, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
  #line 70 "src/distribution/InverseWishart.birch"
  virtual libbirch::Optional<libbirch::Lazy<libbirch::Shared<birch::type::InverseWishart>>> graftInverseWishart(const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
  #line 75 "src/distribution/InverseWishart.birch"
  virtual void write(const libbirch::Lazy<libbirch::Shared<birch::type::Buffer>>& buffer, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
  
  #line 30 "src/distribution/InverseWishart.birch"
  LIBBIRCH_CLASS(InverseWishart, Distribution<birch::type::LLT>)
  #line 30 "src/distribution/InverseWishart.birch"
  LIBBIRCH_MEMBERS(_u0936, k)
};

#line 5 "src/distribution/LinearMatrixNormalInverseWishartMatrixGaussian.birch"
class LinearMatrixNormalInverseWishartMatrixGaussian final : public Distribution<libbirch::DefaultArray<birch::type::Real,2>> {
public:
  #line 5 "src/distribution/LinearMatrixNormalInverseWishartMatrixGaussian.birch"
  using class_type_ = LinearMatrixNormalInverseWishartMatrixGaussian;
  #line 5 "src/distribution/LinearMatrixNormalInverseWishartMatrixGaussian.birch"
  using this_type_ = class_type_;
  #line 5 "src/distribution/LinearMatrixNormalInverseWishartMatrixGaussian.birch"
  using super_type_ = Distribution<libbirch::DefaultArray<birch::type::Real,2>>;

  #line 5 "src/distribution/LinearMatrixNormalInverseWishartMatrixGaussian.birch"
  using super_type_::operator=;
  #line 5 "src/distribution/LinearMatrixNormalInverseWishartMatrixGaussian.birch"
  using super_type_::columns;
  #line 5 "src/distribution/LinearMatrixNormalInverseWishartMatrixGaussian.birch"
  using super_type_::link;
  #line 5 "src/distribution/LinearMatrixNormalInverseWishartMatrixGaussian.birch"
  using super_type_::logpdf;
  #line 5 "src/distribution/LinearMatrixNormalInverseWishartMatrixGaussian.birch"
  using super_type_::logpdfLazy;
  #line 5 "src/distribution/LinearMatrixNormalInverseWishartMatrixGaussian.birch"
  using super_type_::rows;
  #line 5 "src/distribution/LinearMatrixNormalInverseWishartMatrixGaussian.birch"
  using super_type_::simulate;
  #line 5 "src/distribution/LinearMatrixNormalInverseWishartMatrixGaussian.birch"
  using super_type_::simulateLazy;
  #line 5 "src/distribution/LinearMatrixNormalInverseWishartMatrixGaussian.birch"
  using super_type_::supportsLazy;
  #line 5 "src/distribution/LinearMatrixNormalInverseWishartMatrixGaussian.birch"
  using super_type_::unlink;
  #line 5 "src/distribution/LinearMatrixNormalInverseWishartMatrixGaussian.birch"
  using super_type_::update;
  #line 5 "src/distribution/LinearMatrixNormalInverseWishartMatrixGaussian.birch"
  using super_type_::updateLazy;
  
  #line 5 "src/distribution/LinearMatrixNormalInverseWishartMatrixGaussian.birch"
  LinearMatrixNormalInverseWishartMatrixGaussian(const libbirch::Lazy<libbirch::Shared<birch::type::Expression<libbirch::DefaultArray<birch::type::Real,2>>>>& A, const libbirch::Lazy<libbirch::Shared<birch::type::MatrixNormalInverseWishart>>& M, const libbirch::Lazy<libbirch::Shared<birch::type::Expression<libbirch::DefaultArray<birch::type::Real,2>>>>& C, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);

  libbirch::Lazy<libbirch::Shared<birch::type::Expression<libbirch::DefaultArray<birch::type::Real,2>>>> A;
  libbirch::Lazy<libbirch::Shared<birch::type::MatrixNormalInverseWishart>> M;
  libbirch::Lazy<libbirch::Shared<birch::type::Expression<libbirch::DefaultArray<birch::type::Real,2>>>> C;
  #line 23 "src/distribution/LinearMatrixNormalInverseWishartMatrixGaussian.birch"
  virtual birch::type::Integer rows(const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
  #line 27 "src/distribution/LinearMatrixNormalInverseWishartMatrixGaussian.birch"
  virtual birch::type::Integer columns(const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
  #line 31 "src/distribution/LinearMatrixNormalInverseWishartMatrixGaussian.birch"
  virtual birch::type::Boolean supportsLazy(const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
  #line 35 "src/distribution/LinearMatrixNormalInverseWishartMatrixGaussian.birch"
  virtual libbirch::DefaultArray<birch::type::Real,2> simulate(const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
  #line 40 "src/distribution/LinearMatrixNormalInverseWishartMatrixGaussian.birch"
  virtual libbirch::Optional<libbirch::DefaultArray<birch::type::Real,2>> simulateLazy(const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
  #line 45 "src/distribution/LinearMatrixNormalInverseWishartMatrixGaussian.birch"
  virtual birch::type::Real logpdf(const libbirch::DefaultArray<birch::type::Real,2>& X, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
  #line 50 "src/distribution/LinearMatrixNormalInverseWishartMatrixGaussian.birch"
  virtual libbirch::Optional<libbirch::Lazy<libbirch::Shared<birch::type::Expression<birch::type::Real>>>> logpdfLazy(const libbirch::Lazy<libbirch::Shared<birch::type::Expression<libbirch::DefaultArray<birch::type::Real,2>>>>& X, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
  #line 55 "src/distribution/LinearMatrixNormalInverseWishartMatrixGaussian.birch"
  virtual void update(const libbirch::DefaultArray<birch::type::Real,2>& X, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
  #line 60 "src/distribution/LinearMatrixNormalInverseWishartMatrixGaussian.birch"
  virtual void updateLazy(const libbirch::Lazy<libbirch::Shared<birch::type::Expression<libbirch::DefaultArray<birch::type::Real,2>>>>& X, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
  #line 65 "src/distribution/LinearMatrixNormalInverseWishartMatrixGaussian.birch"
  virtual void link(const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
  #line 69 "src/distribution/LinearMatrixNormalInverseWishartMatrixGaussian.birch"
  virtual void unlink(const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
  
  #line 5 "src/distribution/LinearMatrixNormalInverseWishartMatrixGaussian.birch"
  LIBBIRCH_CLASS(LinearMatrixNormalInverseWishartMatrixGaussian, Distribution<libbirch::DefaultArray<birch::type::Real,2>>)
  #line 5 "src/distribution/LinearMatrixNormalInverseWishartMatrixGaussian.birch"
  LIBBIRCH_MEMBERS(A, M, C)
};

#line 5 "src/distribution/LinearMatrixNormalInverseWishartMultivariateGaussian.birch"
class LinearMatrixNormalInverseWishartMultivariateGaussian final : public Distribution<libbirch::DefaultArray<birch::type::Real,1>> {
public:
  #line 5 "src/distribution/LinearMatrixNormalInverseWishartMultivariateGaussian.birch"
  using class_type_ = LinearMatrixNormalInverseWishartMultivariateGaussian;
  #line 5 "src/distribution/LinearMatrixNormalInverseWishartMultivariateGaussian.birch"
  using this_type_ = class_type_;
  #line 5 "src/distribution/LinearMatrixNormalInverseWishartMultivariateGaussian.birch"
  using super_type_ = Distribution<libbirch::DefaultArray<birch::type::Real,1>>;

  #line 5 "src/distribution/LinearMatrixNormalInverseWishartMultivariateGaussian.birch"
  using super_type_::operator=;
  #line 5 "src/distribution/LinearMatrixNormalInverseWishartMultivariateGaussian.birch"
  using super_type_::link;
  #line 5 "src/distribution/LinearMatrixNormalInverseWishartMultivariateGaussian.birch"
  using super_type_::logpdf;
  #line 5 "src/distribution/LinearMatrixNormalInverseWishartMultivariateGaussian.birch"
  using super_type_::logpdfLazy;
  #line 5 "src/distribution/LinearMatrixNormalInverseWishartMultivariateGaussian.birch"
  using super_type_::rows;
  #line 5 "src/distribution/LinearMatrixNormalInverseWishartMultivariateGaussian.birch"
  using super_type_::simulate;
  #line 5 "src/distribution/LinearMatrixNormalInverseWishartMultivariateGaussian.birch"
  using super_type_::simulateLazy;
  #line 5 "src/distribution/LinearMatrixNormalInverseWishartMultivariateGaussian.birch"
  using super_type_::supportsLazy;
  #line 5 "src/distribution/LinearMatrixNormalInverseWishartMultivariateGaussian.birch"
  using super_type_::unlink;
  #line 5 "src/distribution/LinearMatrixNormalInverseWishartMultivariateGaussian.birch"
  using super_type_::update;
  #line 5 "src/distribution/LinearMatrixNormalInverseWishartMultivariateGaussian.birch"
  using super_type_::updateLazy;
  
  #line 5 "src/distribution/LinearMatrixNormalInverseWishartMultivariateGaussian.birch"
  LinearMatrixNormalInverseWishartMultivariateGaussian(const libbirch::Lazy<libbirch::Shared<birch::type::Expression<libbirch::DefaultArray<birch::type::Real,1>>>>& a, const libbirch::Lazy<libbirch::Shared<birch::type::MatrixNormalInverseWishart>>& M, const libbirch::Lazy<libbirch::Shared<birch::type::Expression<libbirch::DefaultArray<birch::type::Real,1>>>>& c, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);

  libbirch::Lazy<libbirch::Shared<birch::type::Expression<libbirch::DefaultArray<birch::type::Real,1>>>> a;
  libbirch::Lazy<libbirch::Shared<birch::type::MatrixNormalInverseWishart>> M;
  libbirch::Lazy<libbirch::Shared<birch::type::Expression<libbirch::DefaultArray<birch::type::Real,1>>>> c;
  #line 22 "src/distribution/LinearMatrixNormalInverseWishartMultivariateGaussian.birch"
  virtual birch::type::Integer rows(const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
  #line 26 "src/distribution/LinearMatrixNormalInverseWishartMultivariateGaussian.birch"
  virtual birch::type::Boolean supportsLazy(const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
  #line 30 "src/distribution/LinearMatrixNormalInverseWishartMultivariateGaussian.birch"
  virtual libbirch::DefaultArray<birch::type::Real,1> simulate(const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
  #line 36 "src/distribution/LinearMatrixNormalInverseWishartMultivariateGaussian.birch"
  virtual libbirch::Optional<libbirch::DefaultArray<birch::type::Real,1>> simulateLazy(const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
  #line 41 "src/distribution/LinearMatrixNormalInverseWishartMultivariateGaussian.birch"
  virtual birch::type::Real logpdf(const libbirch::DefaultArray<birch::type::Real,1>& x, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
  #line 47 "src/distribution/LinearMatrixNormalInverseWishartMultivariateGaussian.birch"
  virtual libbirch::Optional<libbirch::Lazy<libbirch::Shared<birch::type::Expression<birch::type::Real>>>> logpdfLazy(const libbirch::Lazy<libbirch::Shared<birch::type::Expression<libbirch::DefaultArray<birch::type::Real,1>>>>& x, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
  #line 52 "src/distribution/LinearMatrixNormalInverseWishartMultivariateGaussian.birch"
  virtual void update(const libbirch::DefaultArray<birch::type::Real,1>& x, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
  #line 58 "src/distribution/LinearMatrixNormalInverseWishartMultivariateGaussian.birch"
  virtual void updateLazy(const libbirch::Lazy<libbirch::Shared<birch::type::Expression<libbirch::DefaultArray<birch::type::Real,1>>>>& x, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
  #line 63 "src/distribution/LinearMatrixNormalInverseWishartMultivariateGaussian.birch"
  virtual void link(const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
  #line 67 "src/distribution/LinearMatrixNormalInverseWishartMultivariateGaussian.birch"
  virtual void unlink(const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
  
  #line 5 "src/distribution/LinearMatrixNormalInverseWishartMultivariateGaussian.birch"
  LIBBIRCH_CLASS(LinearMatrixNormalInverseWishartMultivariateGaussian, Distribution<libbirch::DefaultArray<birch::type::Real,1>>)
  #line 5 "src/distribution/LinearMatrixNormalInverseWishartMultivariateGaussian.birch"
  LIBBIRCH_MEMBERS(a, M, c)
};

#line 4 "src/distribution/LinearMultivariateNormalInverseGammaGaussian.birch"
class LinearMultivariateNormalInverseGammaGaussian final : public Distribution<birch::type::Real> {
public:
  #line 4 "src/distribution/LinearMultivariateNormalInverseGammaGaussian.birch"
  using class_type_ = LinearMultivariateNormalInverseGammaGaussian;
  #line 4 "src/distribution/LinearMultivariateNormalInverseGammaGaussian.birch"
  using this_type_ = class_type_;
  #line 4 "src/distribution/LinearMultivariateNormalInverseGammaGaussian.birch"
  using super_type_ = Distribution<birch::type::Real>;

  #line 4 "src/distribution/LinearMultivariateNormalInverseGammaGaussian.birch"
  using super_type_::operator=;
  #line 4 "src/distribution/LinearMultivariateNormalInverseGammaGaussian.birch"
  using super_type_::cdf;
  #line 4 "src/distribution/LinearMultivariateNormalInverseGammaGaussian.birch"
  using super_type_::link;
  #line 4 "src/distribution/LinearMultivariateNormalInverseGammaGaussian.birch"
  using super_type_::logpdf;
  #line 4 "src/distribution/LinearMultivariateNormalInverseGammaGaussian.birch"
  using super_type_::logpdfLazy;
  #line 4 "src/distribution/LinearMultivariateNormalInverseGammaGaussian.birch"
  using super_type_::quantile;
  #line 4 "src/distribution/LinearMultivariateNormalInverseGammaGaussian.birch"
  using super_type_::rows;
  #line 4 "src/distribution/LinearMultivariateNormalInverseGammaGaussian.birch"
  using super_type_::simulate;
  #line 4 "src/distribution/LinearMultivariateNormalInverseGammaGaussian.birch"
  using super_type_::simulateLazy;
  #line 4 "src/distribution/LinearMultivariateNormalInverseGammaGaussian.birch"
  using super_type_::supportsLazy;
  #line 4 "src/distribution/LinearMultivariateNormalInverseGammaGaussian.birch"
  using super_type_::unlink;
  #line 4 "src/distribution/LinearMultivariateNormalInverseGammaGaussian.birch"
  using super_type_::update;
  #line 4 "src/distribution/LinearMultivariateNormalInverseGammaGaussian.birch"
  using super_type_::updateLazy;
  
  #line 4 "src/distribution/LinearMultivariateNormalInverseGammaGaussian.birch"
  LinearMultivariateNormalInverseGammaGaussian(const libbirch::Lazy<libbirch::Shared<birch::type::Expression<libbirch::DefaultArray<birch::type::Real,1>>>>& a, const libbirch::Lazy<libbirch::Shared<birch::type::MultivariateNormalInverseGamma>>& _u0956, const libbirch::Lazy<libbirch::Shared<birch::type::Expression<birch::type::Real>>>& c, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);

  libbirch::Lazy<libbirch::Shared<birch::type::Expression<libbirch::DefaultArray<birch::type::Real,1>>>> a;
  libbirch::Lazy<libbirch::Shared<birch::type::MultivariateNormalInverseGamma>> _u0956;
  libbirch::Lazy<libbirch::Shared<birch::type::Expression<birch::type::Real>>> c;
  #line 22 "src/distribution/LinearMultivariateNormalInverseGammaGaussian.birch"
  virtual birch::type::Integer rows(const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
  #line 26 "src/distribution/LinearMultivariateNormalInverseGammaGaussian.birch"
  virtual birch::type::Boolean supportsLazy(const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
  #line 30 "src/distribution/LinearMultivariateNormalInverseGammaGaussian.birch"
  virtual birch::type::Real simulate(const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
  #line 36 "src/distribution/LinearMultivariateNormalInverseGammaGaussian.birch"
  virtual libbirch::Optional<birch::type::Real> simulateLazy(const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
  #line 42 "src/distribution/LinearMultivariateNormalInverseGammaGaussian.birch"
  virtual birch::type::Real logpdf(const birch::type::Real& x, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
  #line 48 "src/distribution/LinearMultivariateNormalInverseGammaGaussian.birch"
  virtual libbirch::Optional<libbirch::Lazy<libbirch::Shared<birch::type::Expression<birch::type::Real>>>> logpdfLazy(const libbirch::Lazy<libbirch::Shared<birch::type::Expression<birch::type::Real>>>& x, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
  #line 53 "src/distribution/LinearMultivariateNormalInverseGammaGaussian.birch"
  virtual void update(const birch::type::Real& x, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
  #line 59 "src/distribution/LinearMultivariateNormalInverseGammaGaussian.birch"
  virtual void updateLazy(const libbirch::Lazy<libbirch::Shared<birch::type::Expression<birch::type::Real>>>& x, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
  #line 64 "src/distribution/LinearMultivariateNormalInverseGammaGaussian.birch"
  virtual libbirch::Optional<birch::type::Real> cdf(const birch::type::Real& x, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
  #line 70 "src/distribution/LinearMultivariateNormalInverseGammaGaussian.birch"
  virtual libbirch::Optional<birch::type::Real> quantile(const birch::type::Real& P, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
  #line 76 "src/distribution/LinearMultivariateNormalInverseGammaGaussian.birch"
  virtual void link(const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
  #line 80 "src/distribution/LinearMultivariateNormalInverseGammaGaussian.birch"
  virtual void unlink(const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
  
  #line 4 "src/distribution/LinearMultivariateNormalInverseGammaGaussian.birch"
  LIBBIRCH_CLASS(LinearMultivariateNormalInverseGammaGaussian, Distribution<birch::type::Real>)
  #line 4 "src/distribution/LinearMultivariateNormalInverseGammaGaussian.birch"
  LIBBIRCH_MEMBERS(a, _u0956, c)
};

#line 5 "src/distribution/LinearMultivariateNormalInverseGammaMultivariateGaussian.birch"
class LinearMultivariateNormalInverseGammaMultivariateGaussian final : public Distribution<libbirch::DefaultArray<birch::type::Real,1>> {
public:
  #line 5 "src/distribution/LinearMultivariateNormalInverseGammaMultivariateGaussian.birch"
  using class_type_ = LinearMultivariateNormalInverseGammaMultivariateGaussian;
  #line 5 "src/distribution/LinearMultivariateNormalInverseGammaMultivariateGaussian.birch"
  using this_type_ = class_type_;
  #line 5 "src/distribution/LinearMultivariateNormalInverseGammaMultivariateGaussian.birch"
  using super_type_ = Distribution<libbirch::DefaultArray<birch::type::Real,1>>;

  #line 5 "src/distribution/LinearMultivariateNormalInverseGammaMultivariateGaussian.birch"
  using super_type_::operator=;
  #line 5 "src/distribution/LinearMultivariateNormalInverseGammaMultivariateGaussian.birch"
  using super_type_::link;
  #line 5 "src/distribution/LinearMultivariateNormalInverseGammaMultivariateGaussian.birch"
  using super_type_::logpdf;
  #line 5 "src/distribution/LinearMultivariateNormalInverseGammaMultivariateGaussian.birch"
  using super_type_::logpdfLazy;
  #line 5 "src/distribution/LinearMultivariateNormalInverseGammaMultivariateGaussian.birch"
  using super_type_::rows;
  #line 5 "src/distribution/LinearMultivariateNormalInverseGammaMultivariateGaussian.birch"
  using super_type_::simulate;
  #line 5 "src/distribution/LinearMultivariateNormalInverseGammaMultivariateGaussian.birch"
  using super_type_::simulateLazy;
  #line 5 "src/distribution/LinearMultivariateNormalInverseGammaMultivariateGaussian.birch"
  using super_type_::supportsLazy;
  #line 5 "src/distribution/LinearMultivariateNormalInverseGammaMultivariateGaussian.birch"
  using super_type_::unlink;
  #line 5 "src/distribution/LinearMultivariateNormalInverseGammaMultivariateGaussian.birch"
  using super_type_::update;
  #line 5 "src/distribution/LinearMultivariateNormalInverseGammaMultivariateGaussian.birch"
  using super_type_::updateLazy;
  
  #line 5 "src/distribution/LinearMultivariateNormalInverseGammaMultivariateGaussian.birch"
  LinearMultivariateNormalInverseGammaMultivariateGaussian(const libbirch::Lazy<libbirch::Shared<birch::type::Expression<libbirch::DefaultArray<birch::type::Real,2>>>>& A, const libbirch::Lazy<libbirch::Shared<birch::type::MultivariateNormalInverseGamma>>& _u0956, const libbirch::Lazy<libbirch::Shared<birch::type::Expression<libbirch::DefaultArray<birch::type::Real,1>>>>& c, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);

  libbirch::Lazy<libbirch::Shared<birch::type::Expression<libbirch::DefaultArray<birch::type::Real,2>>>> A;
  libbirch::Lazy<libbirch::Shared<birch::type::MultivariateNormalInverseGamma>> _u0956;
  libbirch::Lazy<libbirch::Shared<birch::type::Expression<libbirch::DefaultArray<birch::type::Real,1>>>> c;
  #line 23 "src/distribution/LinearMultivariateNormalInverseGammaMultivariateGaussian.birch"
  virtual birch::type::Integer rows(const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
  #line 27 "src/distribution/LinearMultivariateNormalInverseGammaMultivariateGaussian.birch"
  virtual birch::type::Boolean supportsLazy(const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
  #line 31 "src/distribution/LinearMultivariateNormalInverseGammaMultivariateGaussian.birch"
  virtual libbirch::DefaultArray<birch::type::Real,1> simulate(const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
  #line 36 "src/distribution/LinearMultivariateNormalInverseGammaMultivariateGaussian.birch"
  virtual libbirch::Optional<libbirch::DefaultArray<birch::type::Real,1>> simulateLazy(const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
  #line 41 "src/distribution/LinearMultivariateNormalInverseGammaMultivariateGaussian.birch"
  virtual birch::type::Real logpdf(const libbirch::DefaultArray<birch::type::Real,1>& x, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
  #line 46 "src/distribution/LinearMultivariateNormalInverseGammaMultivariateGaussian.birch"
  virtual libbirch::Optional<libbirch::Lazy<libbirch::Shared<birch::type::Expression<birch::type::Real>>>> logpdfLazy(const libbirch::Lazy<libbirch::Shared<birch::type::Expression<libbirch::DefaultArray<birch::type::Real,1>>>>& x, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
  #line 51 "src/distribution/LinearMultivariateNormalInverseGammaMultivariateGaussian.birch"
  virtual void update(const libbirch::DefaultArray<birch::type::Real,1>& x, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
  #line 56 "src/distribution/LinearMultivariateNormalInverseGammaMultivariateGaussian.birch"
  virtual void updateLazy(const libbirch::Lazy<libbirch::Shared<birch::type::Expression<libbirch::DefaultArray<birch::type::Real,1>>>>& x, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
  #line 61 "src/distribution/LinearMultivariateNormalInverseGammaMultivariateGaussian.birch"
  virtual void link(const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
  #line 65 "src/distribution/LinearMultivariateNormalInverseGammaMultivariateGaussian.birch"
  virtual void unlink(const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
  
  #line 5 "src/distribution/LinearMultivariateNormalInverseGammaMultivariateGaussian.birch"
  LIBBIRCH_CLASS(LinearMultivariateNormalInverseGammaMultivariateGaussian, Distribution<libbirch::DefaultArray<birch::type::Real,1>>)
  #line 5 "src/distribution/LinearMultivariateNormalInverseGammaMultivariateGaussian.birch"
  LIBBIRCH_MEMBERS(A, _u0956, c)
};

#line 4 "src/distribution/LinearNormalInverseGammaGaussian.birch"
class LinearNormalInverseGammaGaussian final : public Distribution<birch::type::Real> {
public:
  #line 4 "src/distribution/LinearNormalInverseGammaGaussian.birch"
  using class_type_ = LinearNormalInverseGammaGaussian;
  #line 4 "src/distribution/LinearNormalInverseGammaGaussian.birch"
  using this_type_ = class_type_;
  #line 4 "src/distribution/LinearNormalInverseGammaGaussian.birch"
  using super_type_ = Distribution<birch::type::Real>;

  #line 4 "src/distribution/LinearNormalInverseGammaGaussian.birch"
  using super_type_::operator=;
  #line 4 "src/distribution/LinearNormalInverseGammaGaussian.birch"
  using super_type_::cdf;
  #line 4 "src/distribution/LinearNormalInverseGammaGaussian.birch"
  using super_type_::link;
  #line 4 "src/distribution/LinearNormalInverseGammaGaussian.birch"
  using super_type_::logpdf;
  #line 4 "src/distribution/LinearNormalInverseGammaGaussian.birch"
  using super_type_::logpdfLazy;
  #line 4 "src/distribution/LinearNormalInverseGammaGaussian.birch"
  using super_type_::quantile;
  #line 4 "src/distribution/LinearNormalInverseGammaGaussian.birch"
  using super_type_::simulate;
  #line 4 "src/distribution/LinearNormalInverseGammaGaussian.birch"
  using super_type_::simulateLazy;
  #line 4 "src/distribution/LinearNormalInverseGammaGaussian.birch"
  using super_type_::supportsLazy;
  #line 4 "src/distribution/LinearNormalInverseGammaGaussian.birch"
  using super_type_::unlink;
  #line 4 "src/distribution/LinearNormalInverseGammaGaussian.birch"
  using super_type_::update;
  #line 4 "src/distribution/LinearNormalInverseGammaGaussian.birch"
  using super_type_::updateLazy;
  
  #line 4 "src/distribution/LinearNormalInverseGammaGaussian.birch"
  LinearNormalInverseGammaGaussian(const libbirch::Lazy<libbirch::Shared<birch::type::Expression<birch::type::Real>>>& a, const libbirch::Lazy<libbirch::Shared<birch::type::NormalInverseGamma>>& _u0956, const libbirch::Lazy<libbirch::Shared<birch::type::Expression<birch::type::Real>>>& c, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);

  libbirch::Lazy<libbirch::Shared<birch::type::Expression<birch::type::Real>>> a;
  libbirch::Lazy<libbirch::Shared<birch::type::NormalInverseGamma>> _u0956;
  libbirch::Lazy<libbirch::Shared<birch::type::Expression<birch::type::Real>>> c;
  #line 21 "src/distribution/LinearNormalInverseGammaGaussian.birch"
  virtual birch::type::Boolean supportsLazy(const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
  #line 25 "src/distribution/LinearNormalInverseGammaGaussian.birch"
  virtual birch::type::Real simulate(const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
  #line 31 "src/distribution/LinearNormalInverseGammaGaussian.birch"
  virtual libbirch::Optional<birch::type::Real> simulateLazy(const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
  #line 36 "src/distribution/LinearNormalInverseGammaGaussian.birch"
  virtual birch::type::Real logpdf(const birch::type::Real& x, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
  #line 42 "src/distribution/LinearNormalInverseGammaGaussian.birch"
  virtual libbirch::Optional<libbirch::Lazy<libbirch::Shared<birch::type::Expression<birch::type::Real>>>> logpdfLazy(const libbirch::Lazy<libbirch::Shared<birch::type::Expression<birch::type::Real>>>& x, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
  #line 47 "src/distribution/LinearNormalInverseGammaGaussian.birch"
  virtual void update(const birch::type::Real& x, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
  #line 53 "src/distribution/LinearNormalInverseGammaGaussian.birch"
  virtual void updateLazy(const libbirch::Lazy<libbirch::Shared<birch::type::Expression<birch::type::Real>>>& x, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
  #line 58 "src/distribution/LinearNormalInverseGammaGaussian.birch"
  virtual libbirch::Optional<birch::type::Real> cdf(const birch::type::Real& x, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
  #line 64 "src/distribution/LinearNormalInverseGammaGaussian.birch"
  virtual libbirch::Optional<birch::type::Real> quantile(const birch::type::Real& P, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
  #line 70 "src/distribution/LinearNormalInverseGammaGaussian.birch"
  virtual void link(const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
  #line 74 "src/distribution/LinearNormalInverseGammaGaussian.birch"
  virtual void unlink(const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
  
  #line 4 "src/distribution/LinearNormalInverseGammaGaussian.birch"
  LIBBIRCH_CLASS(LinearNormalInverseGammaGaussian, Distribution<birch::type::Real>)
  #line 4 "src/distribution/LinearNormalInverseGammaGaussian.birch"
  LIBBIRCH_MEMBERS(a, _u0956, c)
};

#line 1 "src/distribution/MatrixGaussian.birch"
class MatrixGaussian : public Distribution<libbirch::DefaultArray<birch::type::Real,2>> {
public:
  #line 1 "src/distribution/MatrixGaussian.birch"
  using class_type_ = MatrixGaussian;
  #line 1 "src/distribution/MatrixGaussian.birch"
  using this_type_ = class_type_;
  #line 1 "src/distribution/MatrixGaussian.birch"
  using super_type_ = Distribution<libbirch::DefaultArray<birch::type::Real,2>>;

  #line 1 "src/distribution/MatrixGaussian.birch"
  using super_type_::operator=;
  #line 1 "src/distribution/MatrixGaussian.birch"
  using super_type_::columns;
  #line 1 "src/distribution/MatrixGaussian.birch"
  using super_type_::graft;
  #line 1 "src/distribution/MatrixGaussian.birch"
  using super_type_::graftMatrixGaussian;
  #line 1 "src/distribution/MatrixGaussian.birch"
  using super_type_::graftMatrixNormalInverseWishart;
  #line 1 "src/distribution/MatrixGaussian.birch"
  using super_type_::logpdf;
  #line 1 "src/distribution/MatrixGaussian.birch"
  using super_type_::logpdfLazy;
  #line 1 "src/distribution/MatrixGaussian.birch"
  using super_type_::rows;
  #line 1 "src/distribution/MatrixGaussian.birch"
  using super_type_::simulate;
  #line 1 "src/distribution/MatrixGaussian.birch"
  using super_type_::simulateLazy;
  #line 1 "src/distribution/MatrixGaussian.birch"
  using super_type_::supportsLazy;
  
  #line 1 "src/distribution/MatrixGaussian.birch"
  MatrixGaussian(const libbirch::Lazy<libbirch::Shared<birch::type::Expression<libbirch::DefaultArray<birch::type::Real,2>>>>& M, const libbirch::Lazy<libbirch::Shared<birch::type::Expression<birch::type::LLT>>>& U, const libbirch::Lazy<libbirch::Shared<birch::type::Expression<birch::type::LLT>>>& V, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);

  libbirch::Lazy<libbirch::Shared<birch::type::Expression<libbirch::DefaultArray<birch::type::Real,2>>>> M;
  libbirch::Lazy<libbirch::Shared<birch::type::Expression<birch::type::LLT>>> U;
  libbirch::Lazy<libbirch::Shared<birch::type::Expression<birch::type::LLT>>> V;
  #line 25 "src/distribution/MatrixGaussian.birch"
  virtual birch::type::Integer rows(const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
  #line 29 "src/distribution/MatrixGaussian.birch"
  virtual birch::type::Integer columns(const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
  #line 33 "src/distribution/MatrixGaussian.birch"
  virtual birch::type::Boolean supportsLazy(const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
  #line 37 "src/distribution/MatrixGaussian.birch"
  virtual libbirch::DefaultArray<birch::type::Real,2> simulate(const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
  #line 41 "src/distribution/MatrixGaussian.birch"
  virtual libbirch::Optional<libbirch::DefaultArray<birch::type::Real,2>> simulateLazy(const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
  #line 45 "src/distribution/MatrixGaussian.birch"
  virtual birch::type::Real logpdf(const libbirch::DefaultArray<birch::type::Real,2>& X, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
  #line 49 "src/distribution/MatrixGaussian.birch"
  virtual libbirch::Optional<libbirch::Lazy<libbirch::Shared<birch::type::Expression<birch::type::Real>>>> logpdfLazy(const libbirch::Lazy<libbirch::Shared<birch::type::Expression<libbirch::DefaultArray<birch::type::Real,2>>>>& X, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
  #line 53 "src/distribution/MatrixGaussian.birch"
  virtual libbirch::Lazy<libbirch::Shared<birch::type::Distribution<libbirch::DefaultArray<birch::type::Real,2>>>> graft(const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
  #line 66 "src/distribution/MatrixGaussian.birch"
  virtual libbirch::Optional<libbirch::Lazy<libbirch::Shared<birch::type::MatrixGaussian>>> graftMatrixGaussian(const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
  #line 71 "src/distribution/MatrixGaussian.birch"
  virtual libbirch::Optional<libbirch::Lazy<libbirch::Shared<birch::type::MatrixNormalInverseWishart>>> graftMatrixNormalInverseWishart(const libbirch::Lazy<libbirch::Shared<birch::type::Distribution<birch::type::LLT>>>& compare, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
  #line 85 "src/distribution/MatrixGaussian.birch"
  virtual void write(const libbirch::Lazy<libbirch::Shared<birch::type::Buffer>>& buffer, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
  
  #line 1 "src/distribution/MatrixGaussian.birch"
  LIBBIRCH_CLASS(MatrixGaussian, Distribution<libbirch::DefaultArray<birch::type::Real,2>>)
  #line 1 "src/distribution/MatrixGaussian.birch"
  LIBBIRCH_MEMBERS(M, U, V)
};

#line 4 "src/distribution/MatrixNormalInverseWishart.birch"
class MatrixNormalInverseWishart final : public Distribution<libbirch::DefaultArray<birch::type::Real,2>> {
public:
  #line 4 "src/distribution/MatrixNormalInverseWishart.birch"
  using class_type_ = MatrixNormalInverseWishart;
  #line 4 "src/distribution/MatrixNormalInverseWishart.birch"
  using this_type_ = class_type_;
  #line 4 "src/distribution/MatrixNormalInverseWishart.birch"
  using super_type_ = Distribution<libbirch::DefaultArray<birch::type::Real,2>>;

  #line 4 "src/distribution/MatrixNormalInverseWishart.birch"
  using super_type_::operator=;
  #line 4 "src/distribution/MatrixNormalInverseWishart.birch"
  using super_type_::columns;
  #line 4 "src/distribution/MatrixNormalInverseWishart.birch"
  using super_type_::graftMatrixNormalInverseWishart;
  #line 4 "src/distribution/MatrixNormalInverseWishart.birch"
  using super_type_::link;
  #line 4 "src/distribution/MatrixNormalInverseWishart.birch"
  using super_type_::logpdf;
  #line 4 "src/distribution/MatrixNormalInverseWishart.birch"
  using super_type_::logpdfLazy;
  #line 4 "src/distribution/MatrixNormalInverseWishart.birch"
  using super_type_::rows;
  #line 4 "src/distribution/MatrixNormalInverseWishart.birch"
  using super_type_::simulate;
  #line 4 "src/distribution/MatrixNormalInverseWishart.birch"
  using super_type_::simulateLazy;
  #line 4 "src/distribution/MatrixNormalInverseWishart.birch"
  using super_type_::supportsLazy;
  #line 4 "src/distribution/MatrixNormalInverseWishart.birch"
  using super_type_::unlink;
  #line 4 "src/distribution/MatrixNormalInverseWishart.birch"
  using super_type_::update;
  #line 4 "src/distribution/MatrixNormalInverseWishart.birch"
  using super_type_::updateLazy;
  
  #line 4 "src/distribution/MatrixNormalInverseWishart.birch"
  MatrixNormalInverseWishart(const libbirch::Lazy<libbirch::Shared<birch::type::Expression<libbirch::DefaultArray<birch::type::Real,2>>>>& M, const libbirch::Lazy<libbirch::Shared<birch::type::Expression<birch::type::LLT>>>& U, const libbirch::Lazy<libbirch::Shared<birch::type::InverseWishart>>& V, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);

  libbirch::Lazy<libbirch::Shared<birch::type::Expression<birch::type::LLT>>> _u0923;
  libbirch::Lazy<libbirch::Shared<birch::type::Expression<libbirch::DefaultArray<birch::type::Real,2>>>> N;
  libbirch::Lazy<libbirch::Shared<birch::type::InverseWishart>> V;
  #line 21 "src/distribution/MatrixNormalInverseWishart.birch"
  virtual birch::type::Integer rows(const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
  #line 25 "src/distribution/MatrixNormalInverseWishart.birch"
  virtual birch::type::Integer columns(const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
  #line 29 "src/distribution/MatrixNormalInverseWishart.birch"
  virtual birch::type::Boolean supportsLazy(const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
  #line 33 "src/distribution/MatrixNormalInverseWishart.birch"
  virtual libbirch::DefaultArray<birch::type::Real,2> simulate(const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
  #line 37 "src/distribution/MatrixNormalInverseWishart.birch"
  virtual libbirch::Optional<libbirch::DefaultArray<birch::type::Real,2>> simulateLazy(const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
  #line 41 "src/distribution/MatrixNormalInverseWishart.birch"
  virtual birch::type::Real logpdf(const libbirch::DefaultArray<birch::type::Real,2>& X, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
  #line 45 "src/distribution/MatrixNormalInverseWishart.birch"
  virtual libbirch::Optional<libbirch::Lazy<libbirch::Shared<birch::type::Expression<birch::type::Real>>>> logpdfLazy(const libbirch::Lazy<libbirch::Shared<birch::type::Expression<libbirch::DefaultArray<birch::type::Real,2>>>>& X, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
  #line 49 "src/distribution/MatrixNormalInverseWishart.birch"
  virtual void update(const libbirch::DefaultArray<birch::type::Real,2>& X, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
  #line 53 "src/distribution/MatrixNormalInverseWishart.birch"
  virtual void updateLazy(const libbirch::Lazy<libbirch::Shared<birch::type::Expression<libbirch::DefaultArray<birch::type::Real,2>>>>& X, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
  #line 57 "src/distribution/MatrixNormalInverseWishart.birch"
  virtual libbirch::Optional<libbirch::Lazy<libbirch::Shared<birch::type::MatrixNormalInverseWishart>>> graftMatrixNormalInverseWishart(const libbirch::Lazy<libbirch::Shared<birch::type::Distribution<birch::type::LLT>>>& compare, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
  #line 67 "src/distribution/MatrixNormalInverseWishart.birch"
  virtual void link(const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
  #line 71 "src/distribution/MatrixNormalInverseWishart.birch"
  virtual void unlink(const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
  #line 75 "src/distribution/MatrixNormalInverseWishart.birch"
  virtual void write(const libbirch::Lazy<libbirch::Shared<birch::type::Buffer>>& buffer, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
  
  #line 4 "src/distribution/MatrixNormalInverseWishart.birch"
  LIBBIRCH_CLASS(MatrixNormalInverseWishart, Distribution<libbirch::DefaultArray<birch::type::Real,2>>)
  #line 4 "src/distribution/MatrixNormalInverseWishart.birch"
  LIBBIRCH_MEMBERS(_u0923, N, V)
};

#line 4 "src/distribution/MatrixNormalInverseWishartMatrixGaussian.birch"
class MatrixNormalInverseWishartMatrixGaussian final : public Distribution<libbirch::DefaultArray<birch::type::Real,2>> {
public:
  #line 4 "src/distribution/MatrixNormalInverseWishartMatrixGaussian.birch"
  using class_type_ = MatrixNormalInverseWishartMatrixGaussian;
  #line 4 "src/distribution/MatrixNormalInverseWishartMatrixGaussian.birch"
  using this_type_ = class_type_;
  #line 4 "src/distribution/MatrixNormalInverseWishartMatrixGaussian.birch"
  using super_type_ = Distribution<libbirch::DefaultArray<birch::type::Real,2>>;

  #line 4 "src/distribution/MatrixNormalInverseWishartMatrixGaussian.birch"
  using super_type_::operator=;
  #line 4 "src/distribution/MatrixNormalInverseWishartMatrixGaussian.birch"
  using super_type_::columns;
  #line 4 "src/distribution/MatrixNormalInverseWishartMatrixGaussian.birch"
  using super_type_::link;
  #line 4 "src/distribution/MatrixNormalInverseWishartMatrixGaussian.birch"
  using super_type_::logpdf;
  #line 4 "src/distribution/MatrixNormalInverseWishartMatrixGaussian.birch"
  using super_type_::logpdfLazy;
  #line 4 "src/distribution/MatrixNormalInverseWishartMatrixGaussian.birch"
  using super_type_::rows;
  #line 4 "src/distribution/MatrixNormalInverseWishartMatrixGaussian.birch"
  using super_type_::simulate;
  #line 4 "src/distribution/MatrixNormalInverseWishartMatrixGaussian.birch"
  using super_type_::simulateLazy;
  #line 4 "src/distribution/MatrixNormalInverseWishartMatrixGaussian.birch"
  using super_type_::supportsLazy;
  #line 4 "src/distribution/MatrixNormalInverseWishartMatrixGaussian.birch"
  using super_type_::unlink;
  #line 4 "src/distribution/MatrixNormalInverseWishartMatrixGaussian.birch"
  using super_type_::update;
  #line 4 "src/distribution/MatrixNormalInverseWishartMatrixGaussian.birch"
  using super_type_::updateLazy;
  
  #line 4 "src/distribution/MatrixNormalInverseWishartMatrixGaussian.birch"
  MatrixNormalInverseWishartMatrixGaussian(const libbirch::Lazy<libbirch::Shared<birch::type::MatrixNormalInverseWishart>>& M, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);

  libbirch::Lazy<libbirch::Shared<birch::type::MatrixNormalInverseWishart>> M;
  #line 11 "src/distribution/MatrixNormalInverseWishartMatrixGaussian.birch"
  virtual birch::type::Integer rows(const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
  #line 15 "src/distribution/MatrixNormalInverseWishartMatrixGaussian.birch"
  virtual birch::type::Integer columns(const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
  #line 19 "src/distribution/MatrixNormalInverseWishartMatrixGaussian.birch"
  virtual birch::type::Boolean supportsLazy(const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
  #line 23 "src/distribution/MatrixNormalInverseWishartMatrixGaussian.birch"
  virtual libbirch::DefaultArray<birch::type::Real,2> simulate(const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
  #line 28 "src/distribution/MatrixNormalInverseWishartMatrixGaussian.birch"
  virtual libbirch::Optional<libbirch::DefaultArray<birch::type::Real,2>> simulateLazy(const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
  #line 33 "src/distribution/MatrixNormalInverseWishartMatrixGaussian.birch"
  virtual birch::type::Real logpdf(const libbirch::DefaultArray<birch::type::Real,2>& X, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
  #line 38 "src/distribution/MatrixNormalInverseWishartMatrixGaussian.birch"
  virtual libbirch::Optional<libbirch::Lazy<libbirch::Shared<birch::type::Expression<birch::type::Real>>>> logpdfLazy(const libbirch::Lazy<libbirch::Shared<birch::type::Expression<libbirch::DefaultArray<birch::type::Real,2>>>>& X, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
  #line 43 "src/distribution/MatrixNormalInverseWishartMatrixGaussian.birch"
  virtual void update(const libbirch::DefaultArray<birch::type::Real,2>& X, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
  #line 48 "src/distribution/MatrixNormalInverseWishartMatrixGaussian.birch"
  virtual void updateLazy(const libbirch::Lazy<libbirch::Shared<birch::type::Expression<libbirch::DefaultArray<birch::type::Real,2>>>>& X, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
  #line 53 "src/distribution/MatrixNormalInverseWishartMatrixGaussian.birch"
  virtual void link(const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
  #line 57 "src/distribution/MatrixNormalInverseWishartMatrixGaussian.birch"
  virtual void unlink(const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
  
  #line 4 "src/distribution/MatrixNormalInverseWishartMatrixGaussian.birch"
  LIBBIRCH_CLASS(MatrixNormalInverseWishartMatrixGaussian, Distribution<libbirch::DefaultArray<birch::type::Real,2>>)
  #line 4 "src/distribution/MatrixNormalInverseWishartMatrixGaussian.birch"
  LIBBIRCH_MEMBERS(M)
};

#line 1 "src/distribution/Multinomial.birch"
class Multinomial : public Distribution<libbirch::DefaultArray<birch::type::Integer,1>> {
public:
  #line 1 "src/distribution/Multinomial.birch"
  using class_type_ = Multinomial;
  #line 1 "src/distribution/Multinomial.birch"
  using this_type_ = class_type_;
  #line 1 "src/distribution/Multinomial.birch"
  using super_type_ = Distribution<libbirch::DefaultArray<birch::type::Integer,1>>;

  #line 1 "src/distribution/Multinomial.birch"
  using super_type_::operator=;
  #line 1 "src/distribution/Multinomial.birch"
  using super_type_::graft;
  #line 1 "src/distribution/Multinomial.birch"
  using super_type_::logpdf;
  #line 1 "src/distribution/Multinomial.birch"
  using super_type_::rows;
  #line 1 "src/distribution/Multinomial.birch"
  using super_type_::simulate;
  #line 1 "src/distribution/Multinomial.birch"
  using super_type_::supportsLazy;
  
  #line 1 "src/distribution/Multinomial.birch"
  Multinomial(const libbirch::Lazy<libbirch::Shared<birch::type::Expression<birch::type::Integer>>>& n, const libbirch::Lazy<libbirch::Shared<birch::type::Expression<libbirch::DefaultArray<birch::type::Real,1>>>>& _u0961, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);

  libbirch::Lazy<libbirch::Shared<birch::type::Expression<birch::type::Integer>>> n;
  libbirch::Lazy<libbirch::Shared<birch::type::Expression<libbirch::DefaultArray<birch::type::Real,1>>>> _u0961;
  #line 16 "src/distribution/Multinomial.birch"
  virtual birch::type::Integer rows(const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
  #line 20 "src/distribution/Multinomial.birch"
  virtual birch::type::Boolean supportsLazy(const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
  #line 24 "src/distribution/Multinomial.birch"
  virtual libbirch::DefaultArray<birch::type::Integer,1> simulate(const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
  #line 32 "src/distribution/Multinomial.birch"
  virtual birch::type::Real logpdf(const libbirch::DefaultArray<birch::type::Integer,1>& x, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
  #line 40 "src/distribution/Multinomial.birch"
  virtual libbirch::Lazy<libbirch::Shared<birch::type::Distribution<libbirch::DefaultArray<birch::type::Integer,1>>>> graft(const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
  #line 53 "src/distribution/Multinomial.birch"
  virtual void write(const libbirch::Lazy<libbirch::Shared<birch::type::Buffer>>& buffer, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
  
  #line 1 "src/distribution/Multinomial.birch"
  LIBBIRCH_CLASS(Multinomial, Distribution<libbirch::DefaultArray<birch::type::Integer,1>>)
  #line 1 "src/distribution/Multinomial.birch"
  LIBBIRCH_MEMBERS(n, _u0961)
};

#line 1 "src/distribution/MultivariateGaussian.birch"
class MultivariateGaussian : public Distribution<libbirch::DefaultArray<birch::type::Real,1>> {
public:
  #line 1 "src/distribution/MultivariateGaussian.birch"
  using class_type_ = MultivariateGaussian;
  #line 1 "src/distribution/MultivariateGaussian.birch"
  using this_type_ = class_type_;
  #line 1 "src/distribution/MultivariateGaussian.birch"
  using super_type_ = Distribution<libbirch::DefaultArray<birch::type::Real,1>>;

  #line 1 "src/distribution/MultivariateGaussian.birch"
  using super_type_::operator=;
  #line 1 "src/distribution/MultivariateGaussian.birch"
  using super_type_::graft;
  #line 1 "src/distribution/MultivariateGaussian.birch"
  using super_type_::graftMultivariateGaussian;
  #line 1 "src/distribution/MultivariateGaussian.birch"
  using super_type_::logpdf;
  #line 1 "src/distribution/MultivariateGaussian.birch"
  using super_type_::logpdfLazy;
  #line 1 "src/distribution/MultivariateGaussian.birch"
  using super_type_::rows;
  #line 1 "src/distribution/MultivariateGaussian.birch"
  using super_type_::simulate;
  #line 1 "src/distribution/MultivariateGaussian.birch"
  using super_type_::simulateLazy;
  #line 1 "src/distribution/MultivariateGaussian.birch"
  using super_type_::supportsLazy;
  
  #line 1 "src/distribution/MultivariateGaussian.birch"
  MultivariateGaussian(const libbirch::Lazy<libbirch::Shared<birch::type::Expression<libbirch::DefaultArray<birch::type::Real,1>>>>& _u0956, const libbirch::Lazy<libbirch::Shared<birch::type::Expression<birch::type::LLT>>>& _u0931, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);

  libbirch::Lazy<libbirch::Shared<birch::type::Expression<libbirch::DefaultArray<birch::type::Real,1>>>> _u0956;
  libbirch::Lazy<libbirch::Shared<birch::type::Expression<birch::type::LLT>>> _u0931;
  #line 20 "src/distribution/MultivariateGaussian.birch"
  virtual birch::type::Integer rows(const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
  #line 24 "src/distribution/MultivariateGaussian.birch"
  virtual birch::type::Boolean supportsLazy(const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
  #line 28 "src/distribution/MultivariateGaussian.birch"
  virtual libbirch::DefaultArray<birch::type::Real,1> simulate(const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
  #line 32 "src/distribution/MultivariateGaussian.birch"
  virtual libbirch::Optional<libbirch::DefaultArray<birch::type::Real,1>> simulateLazy(const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
  #line 36 "src/distribution/MultivariateGaussian.birch"
  virtual birch::type::Real logpdf(const libbirch::DefaultArray<birch::type::Real,1>& x, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
  #line 40 "src/distribution/MultivariateGaussian.birch"
  virtual libbirch::Optional<libbirch::Lazy<libbirch::Shared<birch::type::Expression<birch::type::Real>>>> logpdfLazy(const libbirch::Lazy<libbirch::Shared<birch::type::Expression<libbirch::DefaultArray<birch::type::Real,1>>>>& x, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
  #line 44 "src/distribution/MultivariateGaussian.birch"
  virtual libbirch::Lazy<libbirch::Shared<birch::type::Distribution<libbirch::DefaultArray<birch::type::Real,1>>>> graft(const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
  #line 65 "src/distribution/MultivariateGaussian.birch"
  virtual libbirch::Optional<libbirch::Lazy<libbirch::Shared<birch::type::MultivariateGaussian>>> graftMultivariateGaussian(const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
  #line 81 "src/distribution/MultivariateGaussian.birch"
  virtual void write(const libbirch::Lazy<libbirch::Shared<birch::type::Buffer>>& buffer, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
  
  #line 1 "src/distribution/MultivariateGaussian.birch"
  LIBBIRCH_CLASS(MultivariateGaussian, Distribution<libbirch::DefaultArray<birch::type::Real,1>>)
  #line 1 "src/distribution/MultivariateGaussian.birch"
  LIBBIRCH_MEMBERS(_u0956, _u0931)
};

#line 4 "src/distribution/LinearMultivariateGaussianMultivariateGaussian.birch"
class LinearMultivariateGaussianMultivariateGaussian final : public MultivariateGaussian {
public:
  #line 4 "src/distribution/LinearMultivariateGaussianMultivariateGaussian.birch"
  using class_type_ = LinearMultivariateGaussianMultivariateGaussian;
  #line 4 "src/distribution/LinearMultivariateGaussianMultivariateGaussian.birch"
  using this_type_ = class_type_;
  #line 4 "src/distribution/LinearMultivariateGaussianMultivariateGaussian.birch"
  using super_type_ = MultivariateGaussian;

  #line 4 "src/distribution/LinearMultivariateGaussianMultivariateGaussian.birch"
  using super_type_::operator=;
  #line 4 "src/distribution/LinearMultivariateGaussianMultivariateGaussian.birch"
  using super_type_::link;
  #line 4 "src/distribution/LinearMultivariateGaussianMultivariateGaussian.birch"
  using super_type_::unlink;
  #line 4 "src/distribution/LinearMultivariateGaussianMultivariateGaussian.birch"
  using super_type_::update;
  #line 4 "src/distribution/LinearMultivariateGaussianMultivariateGaussian.birch"
  using super_type_::updateLazy;
  
  #line 4 "src/distribution/LinearMultivariateGaussianMultivariateGaussian.birch"
  LinearMultivariateGaussianMultivariateGaussian(const libbirch::Lazy<libbirch::Shared<birch::type::Expression<libbirch::DefaultArray<birch::type::Real,2>>>>& A, const libbirch::Lazy<libbirch::Shared<birch::type::MultivariateGaussian>>& m, const libbirch::Lazy<libbirch::Shared<birch::type::Expression<libbirch::DefaultArray<birch::type::Real,1>>>>& c, const libbirch::Lazy<libbirch::Shared<birch::type::Expression<birch::type::LLT>>>& S, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);

  libbirch::Lazy<libbirch::Shared<birch::type::Expression<libbirch::DefaultArray<birch::type::Real,2>>>> A;
  libbirch::Lazy<libbirch::Shared<birch::type::MultivariateGaussian>> m;
  libbirch::Lazy<libbirch::Shared<birch::type::Expression<libbirch::DefaultArray<birch::type::Real,1>>>> c;
  libbirch::Lazy<libbirch::Shared<birch::type::Expression<birch::type::LLT>>> S;
  #line 28 "src/distribution/LinearMultivariateGaussianMultivariateGaussian.birch"
  virtual void update(const libbirch::DefaultArray<birch::type::Real,1>& x, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
  #line 33 "src/distribution/LinearMultivariateGaussianMultivariateGaussian.birch"
  virtual void updateLazy(const libbirch::Lazy<libbirch::Shared<birch::type::Expression<libbirch::DefaultArray<birch::type::Real,1>>>>& x, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
  #line 38 "src/distribution/LinearMultivariateGaussianMultivariateGaussian.birch"
  virtual void link(const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
  #line 42 "src/distribution/LinearMultivariateGaussianMultivariateGaussian.birch"
  virtual void unlink(const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
  
  #line 4 "src/distribution/LinearMultivariateGaussianMultivariateGaussian.birch"
  LIBBIRCH_CLASS(LinearMultivariateGaussianMultivariateGaussian, MultivariateGaussian)
  #line 4 "src/distribution/LinearMultivariateGaussianMultivariateGaussian.birch"
  LIBBIRCH_MEMBERS(A, m, c, S)
};

#line 4 "src/distribution/MultivariateGaussianMultivariateGaussian.birch"
class MultivariateGaussianMultivariateGaussian final : public MultivariateGaussian {
public:
  #line 4 "src/distribution/MultivariateGaussianMultivariateGaussian.birch"
  using class_type_ = MultivariateGaussianMultivariateGaussian;
  #line 4 "src/distribution/MultivariateGaussianMultivariateGaussian.birch"
  using this_type_ = class_type_;
  #line 4 "src/distribution/MultivariateGaussianMultivariateGaussian.birch"
  using super_type_ = MultivariateGaussian;

  #line 4 "src/distribution/MultivariateGaussianMultivariateGaussian.birch"
  using super_type_::operator=;
  #line 4 "src/distribution/MultivariateGaussianMultivariateGaussian.birch"
  using super_type_::link;
  #line 4 "src/distribution/MultivariateGaussianMultivariateGaussian.birch"
  using super_type_::unlink;
  #line 4 "src/distribution/MultivariateGaussianMultivariateGaussian.birch"
  using super_type_::update;
  #line 4 "src/distribution/MultivariateGaussianMultivariateGaussian.birch"
  using super_type_::updateLazy;
  
  #line 4 "src/distribution/MultivariateGaussianMultivariateGaussian.birch"
  MultivariateGaussianMultivariateGaussian(const libbirch::Lazy<libbirch::Shared<birch::type::MultivariateGaussian>>& m, const libbirch::Lazy<libbirch::Shared<birch::type::Expression<birch::type::LLT>>>& S, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);

  libbirch::Lazy<libbirch::Shared<birch::type::MultivariateGaussian>> m;
  libbirch::Lazy<libbirch::Shared<birch::type::Expression<birch::type::LLT>>> S;
  #line 17 "src/distribution/MultivariateGaussianMultivariateGaussian.birch"
  virtual void update(const libbirch::DefaultArray<birch::type::Real,1>& x, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
  #line 21 "src/distribution/MultivariateGaussianMultivariateGaussian.birch"
  virtual void updateLazy(const libbirch::Lazy<libbirch::Shared<birch::type::Expression<libbirch::DefaultArray<birch::type::Real,1>>>>& x, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
  #line 25 "src/distribution/MultivariateGaussianMultivariateGaussian.birch"
  virtual void link(const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
  #line 29 "src/distribution/MultivariateGaussianMultivariateGaussian.birch"
  virtual void unlink(const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
  
  #line 4 "src/distribution/MultivariateGaussianMultivariateGaussian.birch"
  LIBBIRCH_CLASS(MultivariateGaussianMultivariateGaussian, MultivariateGaussian)
  #line 4 "src/distribution/MultivariateGaussianMultivariateGaussian.birch"
  LIBBIRCH_MEMBERS(m, S)
};

#line 35 "src/distribution/MultivariateNormalInverseGamma.birch"
class MultivariateNormalInverseGamma final : public Distribution<libbirch::DefaultArray<birch::type::Real,1>> {
public:
  #line 35 "src/distribution/MultivariateNormalInverseGamma.birch"
  using class_type_ = MultivariateNormalInverseGamma;
  #line 35 "src/distribution/MultivariateNormalInverseGamma.birch"
  using this_type_ = class_type_;
  #line 35 "src/distribution/MultivariateNormalInverseGamma.birch"
  using super_type_ = Distribution<libbirch::DefaultArray<birch::type::Real,1>>;

  #line 35 "src/distribution/MultivariateNormalInverseGamma.birch"
  using super_type_::operator=;
  #line 35 "src/distribution/MultivariateNormalInverseGamma.birch"
  using super_type_::graftMultivariateNormalInverseGamma;
  #line 35 "src/distribution/MultivariateNormalInverseGamma.birch"
  using super_type_::link;
  #line 35 "src/distribution/MultivariateNormalInverseGamma.birch"
  using super_type_::logpdf;
  #line 35 "src/distribution/MultivariateNormalInverseGamma.birch"
  using super_type_::logpdfLazy;
  #line 35 "src/distribution/MultivariateNormalInverseGamma.birch"
  using super_type_::rows;
  #line 35 "src/distribution/MultivariateNormalInverseGamma.birch"
  using super_type_::simulate;
  #line 35 "src/distribution/MultivariateNormalInverseGamma.birch"
  using super_type_::simulateLazy;
  #line 35 "src/distribution/MultivariateNormalInverseGamma.birch"
  using super_type_::supportsLazy;
  #line 35 "src/distribution/MultivariateNormalInverseGamma.birch"
  using super_type_::unlink;
  #line 35 "src/distribution/MultivariateNormalInverseGamma.birch"
  using super_type_::update;
  #line 35 "src/distribution/MultivariateNormalInverseGamma.birch"
  using super_type_::updateLazy;
  
  #line 35 "src/distribution/MultivariateNormalInverseGamma.birch"
  MultivariateNormalInverseGamma(const libbirch::Lazy<libbirch::Shared<birch::type::Expression<libbirch::DefaultArray<birch::type::Real,1>>>>& _u0956, const libbirch::Lazy<libbirch::Shared<birch::type::Expression<birch::type::LLT>>>& _u0931, const libbirch::Lazy<libbirch::Shared<birch::type::InverseGamma>>& _u09632, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);

  libbirch::Lazy<libbirch::Shared<birch::type::Expression<birch::type::LLT>>> _u0923;
  libbirch::Lazy<libbirch::Shared<birch::type::Expression<libbirch::DefaultArray<birch::type::Real,1>>>> _u0957;
  libbirch::Lazy<libbirch::Shared<birch::type::Expression<birch::type::Real>>> _u0945;
  libbirch::Lazy<libbirch::Shared<birch::type::Expression<birch::type::Real>>> _u0947;
  libbirch::Lazy<libbirch::Shared<birch::type::InverseGamma>> _u09632;
  #line 62 "src/distribution/MultivariateNormalInverseGamma.birch"
  virtual birch::type::Integer rows(const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
  #line 66 "src/distribution/MultivariateNormalInverseGamma.birch"
  virtual birch::type::Boolean supportsLazy(const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
  #line 70 "src/distribution/MultivariateNormalInverseGamma.birch"
  virtual libbirch::DefaultArray<birch::type::Real,1> simulate(const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
  #line 75 "src/distribution/MultivariateNormalInverseGamma.birch"
  virtual libbirch::Optional<libbirch::DefaultArray<birch::type::Real,1>> simulateLazy(const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
  #line 80 "src/distribution/MultivariateNormalInverseGamma.birch"
  virtual birch::type::Real logpdf(const libbirch::DefaultArray<birch::type::Real,1>& x, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
  #line 85 "src/distribution/MultivariateNormalInverseGamma.birch"
  virtual libbirch::Optional<libbirch::Lazy<libbirch::Shared<birch::type::Expression<birch::type::Real>>>> logpdfLazy(const libbirch::Lazy<libbirch::Shared<birch::type::Expression<libbirch::DefaultArray<birch::type::Real,1>>>>& x, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
  #line 90 "src/distribution/MultivariateNormalInverseGamma.birch"
  virtual void update(const libbirch::DefaultArray<birch::type::Real,1>& x, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
  #line 95 "src/distribution/MultivariateNormalInverseGamma.birch"
  virtual void updateLazy(const libbirch::Lazy<libbirch::Shared<birch::type::Expression<libbirch::DefaultArray<birch::type::Real,1>>>>& x, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
  #line 100 "src/distribution/MultivariateNormalInverseGamma.birch"
  virtual libbirch::Optional<libbirch::Lazy<libbirch::Shared<birch::type::MultivariateNormalInverseGamma>>> graftMultivariateNormalInverseGamma(const libbirch::Lazy<libbirch::Shared<birch::type::Distribution<birch::type::Real>>>& compare, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
  #line 110 "src/distribution/MultivariateNormalInverseGamma.birch"
  virtual void link(const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
  #line 114 "src/distribution/MultivariateNormalInverseGamma.birch"
  virtual void unlink(const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
  #line 118 "src/distribution/MultivariateNormalInverseGamma.birch"
  virtual void write(const libbirch::Lazy<libbirch::Shared<birch::type::Buffer>>& buffer, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
  
  #line 35 "src/distribution/MultivariateNormalInverseGamma.birch"
  LIBBIRCH_CLASS(MultivariateNormalInverseGamma, Distribution<libbirch::DefaultArray<birch::type::Real,1>>)
  #line 35 "src/distribution/MultivariateNormalInverseGamma.birch"
  LIBBIRCH_MEMBERS(_u0923, _u0957, _u0945, _u0947, _u09632)
};

#line 4 "src/distribution/MultivariateNormalInverseGammaMultivariateGaussian.birch"
class MultivariateNormalInverseGammaMultivariateGaussian final : public Distribution<libbirch::DefaultArray<birch::type::Real,1>> {
public:
  #line 4 "src/distribution/MultivariateNormalInverseGammaMultivariateGaussian.birch"
  using class_type_ = MultivariateNormalInverseGammaMultivariateGaussian;
  #line 4 "src/distribution/MultivariateNormalInverseGammaMultivariateGaussian.birch"
  using this_type_ = class_type_;
  #line 4 "src/distribution/MultivariateNormalInverseGammaMultivariateGaussian.birch"
  using super_type_ = Distribution<libbirch::DefaultArray<birch::type::Real,1>>;

  #line 4 "src/distribution/MultivariateNormalInverseGammaMultivariateGaussian.birch"
  using super_type_::operator=;
  #line 4 "src/distribution/MultivariateNormalInverseGammaMultivariateGaussian.birch"
  using super_type_::link;
  #line 4 "src/distribution/MultivariateNormalInverseGammaMultivariateGaussian.birch"
  using super_type_::logpdf;
  #line 4 "src/distribution/MultivariateNormalInverseGammaMultivariateGaussian.birch"
  using super_type_::logpdfLazy;
  #line 4 "src/distribution/MultivariateNormalInverseGammaMultivariateGaussian.birch"
  using super_type_::rows;
  #line 4 "src/distribution/MultivariateNormalInverseGammaMultivariateGaussian.birch"
  using super_type_::simulate;
  #line 4 "src/distribution/MultivariateNormalInverseGammaMultivariateGaussian.birch"
  using super_type_::simulateLazy;
  #line 4 "src/distribution/MultivariateNormalInverseGammaMultivariateGaussian.birch"
  using super_type_::supportsLazy;
  #line 4 "src/distribution/MultivariateNormalInverseGammaMultivariateGaussian.birch"
  using super_type_::unlink;
  #line 4 "src/distribution/MultivariateNormalInverseGammaMultivariateGaussian.birch"
  using super_type_::update;
  #line 4 "src/distribution/MultivariateNormalInverseGammaMultivariateGaussian.birch"
  using super_type_::updateLazy;
  
  #line 4 "src/distribution/MultivariateNormalInverseGammaMultivariateGaussian.birch"
  MultivariateNormalInverseGammaMultivariateGaussian(const libbirch::Lazy<libbirch::Shared<birch::type::MultivariateNormalInverseGamma>>& _u0956, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);

  libbirch::Lazy<libbirch::Shared<birch::type::MultivariateNormalInverseGamma>> _u0956;
  #line 11 "src/distribution/MultivariateNormalInverseGammaMultivariateGaussian.birch"
  virtual birch::type::Integer rows(const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
  #line 15 "src/distribution/MultivariateNormalInverseGammaMultivariateGaussian.birch"
  virtual birch::type::Boolean supportsLazy(const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
  #line 19 "src/distribution/MultivariateNormalInverseGammaMultivariateGaussian.birch"
  virtual libbirch::DefaultArray<birch::type::Real,1> simulate(const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
  #line 24 "src/distribution/MultivariateNormalInverseGammaMultivariateGaussian.birch"
  virtual libbirch::Optional<libbirch::DefaultArray<birch::type::Real,1>> simulateLazy(const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
  #line 29 "src/distribution/MultivariateNormalInverseGammaMultivariateGaussian.birch"
  virtual birch::type::Real logpdf(const libbirch::DefaultArray<birch::type::Real,1>& x, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
  #line 34 "src/distribution/MultivariateNormalInverseGammaMultivariateGaussian.birch"
  virtual libbirch::Optional<libbirch::Lazy<libbirch::Shared<birch::type::Expression<birch::type::Real>>>> logpdfLazy(const libbirch::Lazy<libbirch::Shared<birch::type::Expression<libbirch::DefaultArray<birch::type::Real,1>>>>& x, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
  #line 39 "src/distribution/MultivariateNormalInverseGammaMultivariateGaussian.birch"
  virtual void update(const libbirch::DefaultArray<birch::type::Real,1>& x, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
  #line 44 "src/distribution/MultivariateNormalInverseGammaMultivariateGaussian.birch"
  virtual void updateLazy(const libbirch::Lazy<libbirch::Shared<birch::type::Expression<libbirch::DefaultArray<birch::type::Real,1>>>>& x, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
  #line 49 "src/distribution/MultivariateNormalInverseGammaMultivariateGaussian.birch"
  virtual void link(const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
  #line 53 "src/distribution/MultivariateNormalInverseGammaMultivariateGaussian.birch"
  virtual void unlink(const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
  
  #line 4 "src/distribution/MultivariateNormalInverseGammaMultivariateGaussian.birch"
  LIBBIRCH_CLASS(MultivariateNormalInverseGammaMultivariateGaussian, Distribution<libbirch::DefaultArray<birch::type::Real,1>>)
  #line 4 "src/distribution/MultivariateNormalInverseGammaMultivariateGaussian.birch"
  LIBBIRCH_MEMBERS(_u0956)
};

#line 28 "src/distribution/NormalInverseGamma.birch"
class NormalInverseGamma final : public Distribution<birch::type::Real> {
public:
  #line 28 "src/distribution/NormalInverseGamma.birch"
  using class_type_ = NormalInverseGamma;
  #line 28 "src/distribution/NormalInverseGamma.birch"
  using this_type_ = class_type_;
  #line 28 "src/distribution/NormalInverseGamma.birch"
  using super_type_ = Distribution<birch::type::Real>;

  #line 28 "src/distribution/NormalInverseGamma.birch"
  using super_type_::operator=;
  #line 28 "src/distribution/NormalInverseGamma.birch"
  using super_type_::cdf;
  #line 28 "src/distribution/NormalInverseGamma.birch"
  using super_type_::graftNormalInverseGamma;
  #line 28 "src/distribution/NormalInverseGamma.birch"
  using super_type_::link;
  #line 28 "src/distribution/NormalInverseGamma.birch"
  using super_type_::logpdf;
  #line 28 "src/distribution/NormalInverseGamma.birch"
  using super_type_::logpdfLazy;
  #line 28 "src/distribution/NormalInverseGamma.birch"
  using super_type_::quantile;
  #line 28 "src/distribution/NormalInverseGamma.birch"
  using super_type_::simulate;
  #line 28 "src/distribution/NormalInverseGamma.birch"
  using super_type_::simulateLazy;
  #line 28 "src/distribution/NormalInverseGamma.birch"
  using super_type_::supportsLazy;
  #line 28 "src/distribution/NormalInverseGamma.birch"
  using super_type_::unlink;
  #line 28 "src/distribution/NormalInverseGamma.birch"
  using super_type_::update;
  #line 28 "src/distribution/NormalInverseGamma.birch"
  using super_type_::updateLazy;
  
  #line 28 "src/distribution/NormalInverseGamma.birch"
  NormalInverseGamma(const libbirch::Lazy<libbirch::Shared<birch::type::Expression<birch::type::Real>>>& _u0956, const libbirch::Lazy<libbirch::Shared<birch::type::Expression<birch::type::Real>>>& a2, const libbirch::Lazy<libbirch::Shared<birch::type::InverseGamma>>& _u09632, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);

  libbirch::Lazy<libbirch::Shared<birch::type::Expression<birch::type::Real>>> _u0956;
  libbirch::Lazy<libbirch::Shared<birch::type::Expression<birch::type::Real>>> _u0955;
  libbirch::Lazy<libbirch::Shared<birch::type::InverseGamma>> _u09632;
  #line 45 "src/distribution/NormalInverseGamma.birch"
  virtual birch::type::Boolean supportsLazy(const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
  #line 49 "src/distribution/NormalInverseGamma.birch"
  virtual birch::type::Real simulate(const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
  #line 53 "src/distribution/NormalInverseGamma.birch"
  virtual libbirch::Optional<birch::type::Real> simulateLazy(const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
  #line 57 "src/distribution/NormalInverseGamma.birch"
  virtual birch::type::Real logpdf(const birch::type::Real& x, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
  #line 61 "src/distribution/NormalInverseGamma.birch"
  virtual libbirch::Optional<libbirch::Lazy<libbirch::Shared<birch::type::Expression<birch::type::Real>>>> logpdfLazy(const libbirch::Lazy<libbirch::Shared<birch::type::Expression<birch::type::Real>>>& x, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
  #line 65 "src/distribution/NormalInverseGamma.birch"
  virtual void update(const birch::type::Real& x, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
  #line 69 "src/distribution/NormalInverseGamma.birch"
  virtual void updateLazy(const libbirch::Lazy<libbirch::Shared<birch::type::Expression<birch::type::Real>>>& x, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
  #line 73 "src/distribution/NormalInverseGamma.birch"
  virtual libbirch::Optional<birch::type::Real> cdf(const birch::type::Real& x, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
  #line 77 "src/distribution/NormalInverseGamma.birch"
  virtual libbirch::Optional<birch::type::Real> quantile(const birch::type::Real& P, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
  #line 81 "src/distribution/NormalInverseGamma.birch"
  virtual libbirch::Optional<libbirch::Lazy<libbirch::Shared<birch::type::NormalInverseGamma>>> graftNormalInverseGamma(const libbirch::Lazy<libbirch::Shared<birch::type::Distribution<birch::type::Real>>>& compare, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
  #line 91 "src/distribution/NormalInverseGamma.birch"
  virtual void link(const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
  #line 95 "src/distribution/NormalInverseGamma.birch"
  virtual void unlink(const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
  #line 99 "src/distribution/NormalInverseGamma.birch"
  virtual void write(const libbirch::Lazy<libbirch::Shared<birch::type::Buffer>>& buffer, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
  
  #line 28 "src/distribution/NormalInverseGamma.birch"
  LIBBIRCH_CLASS(NormalInverseGamma, Distribution<birch::type::Real>)
  #line 28 "src/distribution/NormalInverseGamma.birch"
  LIBBIRCH_MEMBERS(_u0956, _u0955, _u09632)
};

#line 4 "src/distribution/NormalInverseGammaGaussian.birch"
class NormalInverseGammaGaussian final : public Distribution<birch::type::Real> {
public:
  #line 4 "src/distribution/NormalInverseGammaGaussian.birch"
  using class_type_ = NormalInverseGammaGaussian;
  #line 4 "src/distribution/NormalInverseGammaGaussian.birch"
  using this_type_ = class_type_;
  #line 4 "src/distribution/NormalInverseGammaGaussian.birch"
  using super_type_ = Distribution<birch::type::Real>;

  #line 4 "src/distribution/NormalInverseGammaGaussian.birch"
  using super_type_::operator=;
  #line 4 "src/distribution/NormalInverseGammaGaussian.birch"
  using super_type_::cdf;
  #line 4 "src/distribution/NormalInverseGammaGaussian.birch"
  using super_type_::link;
  #line 4 "src/distribution/NormalInverseGammaGaussian.birch"
  using super_type_::logpdf;
  #line 4 "src/distribution/NormalInverseGammaGaussian.birch"
  using super_type_::logpdfLazy;
  #line 4 "src/distribution/NormalInverseGammaGaussian.birch"
  using super_type_::quantile;
  #line 4 "src/distribution/NormalInverseGammaGaussian.birch"
  using super_type_::simulate;
  #line 4 "src/distribution/NormalInverseGammaGaussian.birch"
  using super_type_::simulateLazy;
  #line 4 "src/distribution/NormalInverseGammaGaussian.birch"
  using super_type_::supportsLazy;
  #line 4 "src/distribution/NormalInverseGammaGaussian.birch"
  using super_type_::unlink;
  #line 4 "src/distribution/NormalInverseGammaGaussian.birch"
  using super_type_::update;
  #line 4 "src/distribution/NormalInverseGammaGaussian.birch"
  using super_type_::updateLazy;
  
  #line 4 "src/distribution/NormalInverseGammaGaussian.birch"
  NormalInverseGammaGaussian(const libbirch::Lazy<libbirch::Shared<birch::type::NormalInverseGamma>>& _u0956, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);

  libbirch::Lazy<libbirch::Shared<birch::type::NormalInverseGamma>> _u0956;
  #line 11 "src/distribution/NormalInverseGammaGaussian.birch"
  virtual birch::type::Boolean supportsLazy(const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
  #line 15 "src/distribution/NormalInverseGammaGaussian.birch"
  virtual birch::type::Real simulate(const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
  #line 20 "src/distribution/NormalInverseGammaGaussian.birch"
  virtual libbirch::Optional<birch::type::Real> simulateLazy(const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
  #line 25 "src/distribution/NormalInverseGammaGaussian.birch"
  virtual birch::type::Real logpdf(const birch::type::Real& x, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
  #line 30 "src/distribution/NormalInverseGammaGaussian.birch"
  virtual libbirch::Optional<libbirch::Lazy<libbirch::Shared<birch::type::Expression<birch::type::Real>>>> logpdfLazy(const libbirch::Lazy<libbirch::Shared<birch::type::Expression<birch::type::Real>>>& x, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
  #line 35 "src/distribution/NormalInverseGammaGaussian.birch"
  virtual void update(const birch::type::Real& x, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
  #line 40 "src/distribution/NormalInverseGammaGaussian.birch"
  virtual void updateLazy(const libbirch::Lazy<libbirch::Shared<birch::type::Expression<birch::type::Real>>>& x, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
  #line 45 "src/distribution/NormalInverseGammaGaussian.birch"
  virtual libbirch::Optional<birch::type::Real> cdf(const birch::type::Real& x, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
  #line 50 "src/distribution/NormalInverseGammaGaussian.birch"
  virtual libbirch::Optional<birch::type::Real> quantile(const birch::type::Real& P, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
  #line 55 "src/distribution/NormalInverseGammaGaussian.birch"
  virtual void link(const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
  #line 59 "src/distribution/NormalInverseGammaGaussian.birch"
  virtual void unlink(const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
  
  #line 4 "src/distribution/NormalInverseGammaGaussian.birch"
  LIBBIRCH_CLASS(NormalInverseGammaGaussian, Distribution<birch::type::Real>)
  #line 4 "src/distribution/NormalInverseGammaGaussian.birch"
  LIBBIRCH_MEMBERS(_u0956)
};

#line 8 "src/distribution/Restaurant.birch"
class Restaurant final : public Distribution<libbirch::DefaultArray<birch::type::Real,1>> {
public:
  #line 8 "src/distribution/Restaurant.birch"
  using class_type_ = Restaurant;
  #line 8 "src/distribution/Restaurant.birch"
  using this_type_ = class_type_;
  #line 8 "src/distribution/Restaurant.birch"
  using super_type_ = Distribution<libbirch::DefaultArray<birch::type::Real,1>>;

  #line 8 "src/distribution/Restaurant.birch"
  using super_type_::operator=;
  #line 8 "src/distribution/Restaurant.birch"
  using super_type_::graftRestaurant;
  #line 8 "src/distribution/Restaurant.birch"
  using super_type_::logpdf;
  #line 8 "src/distribution/Restaurant.birch"
  using super_type_::logpdfLazy;
  #line 8 "src/distribution/Restaurant.birch"
  using super_type_::simulate;
  #line 8 "src/distribution/Restaurant.birch"
  using super_type_::simulateLazy;
  #line 8 "src/distribution/Restaurant.birch"
  using super_type_::supportsLazy;
  
  #line 8 "src/distribution/Restaurant.birch"
  Restaurant(const libbirch::Lazy<libbirch::Shared<birch::type::Expression<birch::type::Real>>>& _u0945, const libbirch::Lazy<libbirch::Shared<birch::type::Expression<birch::type::Real>>>& _u0952, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);

  libbirch::Lazy<libbirch::Shared<birch::type::Expression<birch::type::Real>>> _u0945;
  libbirch::Lazy<libbirch::Shared<birch::type::Expression<birch::type::Real>>> _u0952;
  libbirch::DefaultArray<birch::type::Integer,1> n;
  birch::type::Integer K;
  birch::type::Integer N;
  #line 35 "src/distribution/Restaurant.birch"
  virtual birch::type::Boolean supportsLazy(const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
  #line 39 "src/distribution/Restaurant.birch"
  virtual libbirch::DefaultArray<birch::type::Real,1> simulate(const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
  #line 44 "src/distribution/Restaurant.birch"
  virtual libbirch::Optional<libbirch::DefaultArray<birch::type::Real,1>> simulateLazy(const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
  #line 49 "src/distribution/Restaurant.birch"
  virtual birch::type::Real logpdf(const libbirch::DefaultArray<birch::type::Real,1>& x, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
  #line 54 "src/distribution/Restaurant.birch"
  virtual libbirch::Optional<libbirch::Lazy<libbirch::Shared<birch::type::Expression<birch::type::Real>>>> logpdfLazy(const libbirch::Lazy<libbirch::Shared<birch::type::Expression<libbirch::DefaultArray<birch::type::Real,1>>>>& x, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
  #line 59 "src/distribution/Restaurant.birch"
  virtual libbirch::Optional<libbirch::Lazy<libbirch::Shared<birch::type::Restaurant>>> graftRestaurant(const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
  #line 64 "src/distribution/Restaurant.birch"
  virtual void write(const libbirch::Lazy<libbirch::Shared<birch::type::Buffer>>& buffer, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
  
  #line 8 "src/distribution/Restaurant.birch"
  LIBBIRCH_CLASS(Restaurant, Distribution<libbirch::DefaultArray<birch::type::Real,1>>)
  #line 8 "src/distribution/Restaurant.birch"
  LIBBIRCH_MEMBERS(_u0945, _u0952, n, K, N)
};

#line 4 "src/distribution/RestaurantCategorical.birch"
class RestaurantCategorical final : public Distribution<birch::type::Integer> {
public:
  #line 4 "src/distribution/RestaurantCategorical.birch"
  using class_type_ = RestaurantCategorical;
  #line 4 "src/distribution/RestaurantCategorical.birch"
  using this_type_ = class_type_;
  #line 4 "src/distribution/RestaurantCategorical.birch"
  using super_type_ = Distribution<birch::type::Integer>;

  #line 4 "src/distribution/RestaurantCategorical.birch"
  using super_type_::operator=;
  #line 4 "src/distribution/RestaurantCategorical.birch"
  using super_type_::link;
  #line 4 "src/distribution/RestaurantCategorical.birch"
  using super_type_::logpdf;
  #line 4 "src/distribution/RestaurantCategorical.birch"
  using super_type_::simulate;
  #line 4 "src/distribution/RestaurantCategorical.birch"
  using super_type_::supportsLazy;
  #line 4 "src/distribution/RestaurantCategorical.birch"
  using super_type_::unlink;
  #line 4 "src/distribution/RestaurantCategorical.birch"
  using super_type_::update;
  
  #line 4 "src/distribution/RestaurantCategorical.birch"
  RestaurantCategorical(const libbirch::Lazy<libbirch::Shared<birch::type::Restaurant>>& _u0961, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);

  libbirch::Lazy<libbirch::Shared<birch::type::Restaurant>> _u0961;
  #line 10 "src/distribution/RestaurantCategorical.birch"
  virtual birch::type::Boolean supportsLazy(const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
  #line 14 "src/distribution/RestaurantCategorical.birch"
  virtual birch::type::Integer simulate(const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
  #line 22 "src/distribution/RestaurantCategorical.birch"
  virtual birch::type::Real logpdf(const birch::type::Integer& x, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
  #line 30 "src/distribution/RestaurantCategorical.birch"
  virtual void update(const birch::type::Integer& x, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
  #line 49 "src/distribution/RestaurantCategorical.birch"
  virtual void link(const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
  #line 53 "src/distribution/RestaurantCategorical.birch"
  virtual void unlink(const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
  
  #line 4 "src/distribution/RestaurantCategorical.birch"
  LIBBIRCH_CLASS(RestaurantCategorical, Distribution<birch::type::Integer>)
  #line 4 "src/distribution/RestaurantCategorical.birch"
  LIBBIRCH_MEMBERS(_u0961)
};

#line 5 "src/distribution/ScalarGaussian.birch"
class ScalarGaussian final : public Distribution<birch::type::Real> {
public:
  #line 5 "src/distribution/ScalarGaussian.birch"
  using class_type_ = ScalarGaussian;
  #line 5 "src/distribution/ScalarGaussian.birch"
  using this_type_ = class_type_;
  #line 5 "src/distribution/ScalarGaussian.birch"
  using super_type_ = Distribution<birch::type::Real>;

  #line 5 "src/distribution/ScalarGaussian.birch"
  using super_type_::operator=;
  #line 5 "src/distribution/ScalarGaussian.birch"
  using super_type_::cdf;
  #line 5 "src/distribution/ScalarGaussian.birch"
  using super_type_::graft;
  #line 5 "src/distribution/ScalarGaussian.birch"
  using super_type_::graftGaussian;
  #line 5 "src/distribution/ScalarGaussian.birch"
  using super_type_::graftNormalInverseGamma;
  #line 5 "src/distribution/ScalarGaussian.birch"
  using super_type_::logpdf;
  #line 5 "src/distribution/ScalarGaussian.birch"
  using super_type_::logpdfLazy;
  #line 5 "src/distribution/ScalarGaussian.birch"
  using super_type_::quantile;
  #line 5 "src/distribution/ScalarGaussian.birch"
  using super_type_::simulate;
  #line 5 "src/distribution/ScalarGaussian.birch"
  using super_type_::simulateLazy;
  #line 5 "src/distribution/ScalarGaussian.birch"
  using super_type_::supportsLazy;
  
  #line 5 "src/distribution/ScalarGaussian.birch"
  ScalarGaussian(const libbirch::Lazy<libbirch::Shared<birch::type::Expression<birch::type::Real>>>& _u0956, const libbirch::Lazy<libbirch::Shared<birch::type::Expression<birch::type::Real>>>& _u09632, const libbirch::Lazy<libbirch::Shared<birch::type::Expression<birch::type::Real>>>& _u09642, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);

  libbirch::Lazy<libbirch::Shared<birch::type::Expression<birch::type::Real>>> _u0956;
  libbirch::Lazy<libbirch::Shared<birch::type::Expression<birch::type::Real>>> _u09632;
  libbirch::Lazy<libbirch::Shared<birch::type::Expression<birch::type::Real>>> _u09642;
  #line 22 "src/distribution/ScalarGaussian.birch"
  virtual birch::type::Boolean supportsLazy(const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
  #line 26 "src/distribution/ScalarGaussian.birch"
  virtual birch::type::Real simulate(const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
  #line 30 "src/distribution/ScalarGaussian.birch"
  virtual libbirch::Optional<birch::type::Real> simulateLazy(const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
  #line 34 "src/distribution/ScalarGaussian.birch"
  virtual birch::type::Real logpdf(const birch::type::Real& x, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
  #line 38 "src/distribution/ScalarGaussian.birch"
  virtual libbirch::Optional<libbirch::Lazy<libbirch::Shared<birch::type::Expression<birch::type::Real>>>> logpdfLazy(const libbirch::Lazy<libbirch::Shared<birch::type::Expression<birch::type::Real>>>& x, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
  #line 42 "src/distribution/ScalarGaussian.birch"
  virtual libbirch::Optional<birch::type::Real> cdf(const birch::type::Real& x, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
  #line 46 "src/distribution/ScalarGaussian.birch"
  virtual libbirch::Optional<birch::type::Real> quantile(const birch::type::Real& P, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
  #line 50 "src/distribution/ScalarGaussian.birch"
  virtual libbirch::Lazy<libbirch::Shared<birch::type::Distribution<birch::type::Real>>> graft(const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
  #line 65 "src/distribution/ScalarGaussian.birch"
  virtual libbirch::Optional<libbirch::Lazy<libbirch::Shared<birch::type::Gaussian>>> graftGaussian(const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
  #line 70 "src/distribution/ScalarGaussian.birch"
  virtual libbirch::Optional<libbirch::Lazy<libbirch::Shared<birch::type::NormalInverseGamma>>> graftNormalInverseGamma(const libbirch::Lazy<libbirch::Shared<birch::type::Distribution<birch::type::Real>>>& compare, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
  
  #line 5 "src/distribution/ScalarGaussian.birch"
  LIBBIRCH_CLASS(ScalarGaussian, Distribution<birch::type::Real>)
  #line 5 "src/distribution/ScalarGaussian.birch"
  LIBBIRCH_MEMBERS(_u0956, _u09632, _u09642)
};

#line 5 "src/distribution/ScalarMultivariateGaussian.birch"
class ScalarMultivariateGaussian final : public Distribution<libbirch::DefaultArray<birch::type::Real,1>> {
public:
  #line 5 "src/distribution/ScalarMultivariateGaussian.birch"
  using class_type_ = ScalarMultivariateGaussian;
  #line 5 "src/distribution/ScalarMultivariateGaussian.birch"
  using this_type_ = class_type_;
  #line 5 "src/distribution/ScalarMultivariateGaussian.birch"
  using super_type_ = Distribution<libbirch::DefaultArray<birch::type::Real,1>>;

  #line 5 "src/distribution/ScalarMultivariateGaussian.birch"
  using super_type_::operator=;
  #line 5 "src/distribution/ScalarMultivariateGaussian.birch"
  using super_type_::graft;
  #line 5 "src/distribution/ScalarMultivariateGaussian.birch"
  using super_type_::graftMultivariateGaussian;
  #line 5 "src/distribution/ScalarMultivariateGaussian.birch"
  using super_type_::graftMultivariateNormalInverseGamma;
  #line 5 "src/distribution/ScalarMultivariateGaussian.birch"
  using super_type_::logpdf;
  #line 5 "src/distribution/ScalarMultivariateGaussian.birch"
  using super_type_::logpdfLazy;
  #line 5 "src/distribution/ScalarMultivariateGaussian.birch"
  using super_type_::rows;
  #line 5 "src/distribution/ScalarMultivariateGaussian.birch"
  using super_type_::simulate;
  #line 5 "src/distribution/ScalarMultivariateGaussian.birch"
  using super_type_::simulateLazy;
  #line 5 "src/distribution/ScalarMultivariateGaussian.birch"
  using super_type_::supportsLazy;
  
  #line 5 "src/distribution/ScalarMultivariateGaussian.birch"
  ScalarMultivariateGaussian(const libbirch::Lazy<libbirch::Shared<birch::type::Expression<libbirch::DefaultArray<birch::type::Real,1>>>>& _u0956, const libbirch::Lazy<libbirch::Shared<birch::type::Expression<birch::type::LLT>>>& _u0931, const libbirch::Lazy<libbirch::Shared<birch::type::Expression<birch::type::Real>>>& _u09632, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);

  libbirch::Lazy<libbirch::Shared<birch::type::Expression<libbirch::DefaultArray<birch::type::Real,1>>>> _u0956;
  libbirch::Lazy<libbirch::Shared<birch::type::Expression<birch::type::LLT>>> _u0931;
  libbirch::Lazy<libbirch::Shared<birch::type::Expression<birch::type::Real>>> _u09632;
  #line 22 "src/distribution/ScalarMultivariateGaussian.birch"
  virtual birch::type::Integer rows(const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
  #line 26 "src/distribution/ScalarMultivariateGaussian.birch"
  virtual birch::type::Boolean supportsLazy(const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
  #line 30 "src/distribution/ScalarMultivariateGaussian.birch"
  virtual libbirch::DefaultArray<birch::type::Real,1> simulate(const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
  #line 34 "src/distribution/ScalarMultivariateGaussian.birch"
  virtual libbirch::Optional<libbirch::DefaultArray<birch::type::Real,1>> simulateLazy(const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
  #line 38 "src/distribution/ScalarMultivariateGaussian.birch"
  virtual birch::type::Real logpdf(const libbirch::DefaultArray<birch::type::Real,1>& x, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
  #line 42 "src/distribution/ScalarMultivariateGaussian.birch"
  virtual libbirch::Optional<libbirch::Lazy<libbirch::Shared<birch::type::Expression<birch::type::Real>>>> logpdfLazy(const libbirch::Lazy<libbirch::Shared<birch::type::Expression<libbirch::DefaultArray<birch::type::Real,1>>>>& x, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
  #line 46 "src/distribution/ScalarMultivariateGaussian.birch"
  virtual libbirch::Lazy<libbirch::Shared<birch::type::Distribution<libbirch::DefaultArray<birch::type::Real,1>>>> graft(const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
  #line 59 "src/distribution/ScalarMultivariateGaussian.birch"
  virtual libbirch::Optional<libbirch::Lazy<libbirch::Shared<birch::type::MultivariateGaussian>>> graftMultivariateGaussian(const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
  #line 64 "src/distribution/ScalarMultivariateGaussian.birch"
  virtual libbirch::Optional<libbirch::Lazy<libbirch::Shared<birch::type::MultivariateNormalInverseGamma>>> graftMultivariateNormalInverseGamma(const libbirch::Lazy<libbirch::Shared<birch::type::Distribution<birch::type::Real>>>& compare, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
  
  #line 5 "src/distribution/ScalarMultivariateGaussian.birch"
  LIBBIRCH_CLASS(ScalarMultivariateGaussian, Distribution<libbirch::DefaultArray<birch::type::Real,1>>)
  #line 5 "src/distribution/ScalarMultivariateGaussian.birch"
  LIBBIRCH_MEMBERS(_u0956, _u0931, _u09632)
};

#line 1 "src/distribution/ScaledGammaExponential.birch"
class ScaledGammaExponential : public Distribution<birch::type::Real> {
public:
  #line 1 "src/distribution/ScaledGammaExponential.birch"
  using class_type_ = ScaledGammaExponential;
  #line 1 "src/distribution/ScaledGammaExponential.birch"
  using this_type_ = class_type_;
  #line 1 "src/distribution/ScaledGammaExponential.birch"
  using super_type_ = Distribution<birch::type::Real>;

  #line 1 "src/distribution/ScaledGammaExponential.birch"
  using super_type_::operator=;
  #line 1 "src/distribution/ScaledGammaExponential.birch"
  using super_type_::cdf;
  #line 1 "src/distribution/ScaledGammaExponential.birch"
  using super_type_::link;
  #line 1 "src/distribution/ScaledGammaExponential.birch"
  using super_type_::logpdf;
  #line 1 "src/distribution/ScaledGammaExponential.birch"
  using super_type_::logpdfLazy;
  #line 1 "src/distribution/ScaledGammaExponential.birch"
  using super_type_::lower;
  #line 1 "src/distribution/ScaledGammaExponential.birch"
  using super_type_::quantile;
  #line 1 "src/distribution/ScaledGammaExponential.birch"
  using super_type_::simulate;
  #line 1 "src/distribution/ScaledGammaExponential.birch"
  using super_type_::simulateLazy;
  #line 1 "src/distribution/ScaledGammaExponential.birch"
  using super_type_::supportsLazy;
  #line 1 "src/distribution/ScaledGammaExponential.birch"
  using super_type_::unlink;
  #line 1 "src/distribution/ScaledGammaExponential.birch"
  using super_type_::update;
  #line 1 "src/distribution/ScaledGammaExponential.birch"
  using super_type_::updateLazy;
  
  #line 1 "src/distribution/ScaledGammaExponential.birch"
  ScaledGammaExponential(const libbirch::Lazy<libbirch::Shared<birch::type::Expression<birch::type::Real>>>& a, const libbirch::Lazy<libbirch::Shared<birch::type::Gamma>>& _u0955, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);

  libbirch::Lazy<libbirch::Shared<birch::type::Expression<birch::type::Real>>> a;
  libbirch::Lazy<libbirch::Shared<birch::type::Gamma>> _u0955;
  #line 16 "src/distribution/ScaledGammaExponential.birch"
  virtual birch::type::Boolean supportsLazy(const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
  #line 20 "src/distribution/ScaledGammaExponential.birch"
  virtual birch::type::Real simulate(const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
  #line 24 "src/distribution/ScaledGammaExponential.birch"
  virtual libbirch::Optional<birch::type::Real> simulateLazy(const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
  #line 28 "src/distribution/ScaledGammaExponential.birch"
  virtual birch::type::Real logpdf(const birch::type::Real& x, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
  #line 32 "src/distribution/ScaledGammaExponential.birch"
  virtual libbirch::Optional<libbirch::Lazy<libbirch::Shared<birch::type::Expression<birch::type::Real>>>> logpdfLazy(const libbirch::Lazy<libbirch::Shared<birch::type::Expression<birch::type::Real>>>& x, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
  #line 36 "src/distribution/ScaledGammaExponential.birch"
  virtual void update(const birch::type::Real& x, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
  #line 41 "src/distribution/ScaledGammaExponential.birch"
  virtual void updateLazy(const libbirch::Lazy<libbirch::Shared<birch::type::Expression<birch::type::Real>>>& x, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
  #line 45 "src/distribution/ScaledGammaExponential.birch"
  virtual libbirch::Optional<birch::type::Real> cdf(const birch::type::Real& x, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
  #line 49 "src/distribution/ScaledGammaExponential.birch"
  virtual libbirch::Optional<birch::type::Real> quantile(const birch::type::Real& P, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
  #line 53 "src/distribution/ScaledGammaExponential.birch"
  virtual libbirch::Optional<birch::type::Real> lower(const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
  #line 57 "src/distribution/ScaledGammaExponential.birch"
  virtual void link(const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
  #line 61 "src/distribution/ScaledGammaExponential.birch"
  virtual void unlink(const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
  
  #line 1 "src/distribution/ScaledGammaExponential.birch"
  LIBBIRCH_CLASS(ScaledGammaExponential, Distribution<birch::type::Real>)
  #line 1 "src/distribution/ScaledGammaExponential.birch"
  LIBBIRCH_MEMBERS(a, _u0955)
};

#line 4 "src/distribution/Student.birch"
class Student final : public Distribution<birch::type::Real> {
public:
  #line 4 "src/distribution/Student.birch"
  using class_type_ = Student;
  #line 4 "src/distribution/Student.birch"
  using this_type_ = class_type_;
  #line 4 "src/distribution/Student.birch"
  using super_type_ = Distribution<birch::type::Real>;

  #line 4 "src/distribution/Student.birch"
  using super_type_::operator=;
  #line 4 "src/distribution/Student.birch"
  using super_type_::cdf;
  #line 4 "src/distribution/Student.birch"
  using super_type_::logpdf;
  #line 4 "src/distribution/Student.birch"
  using super_type_::logpdfLazy;
  #line 4 "src/distribution/Student.birch"
  using super_type_::quantile;
  #line 4 "src/distribution/Student.birch"
  using super_type_::simulate;
  #line 4 "src/distribution/Student.birch"
  using super_type_::simulateLazy;
  #line 4 "src/distribution/Student.birch"
  using super_type_::supportsLazy;
  
  #line 4 "src/distribution/Student.birch"
  Student(const libbirch::Lazy<libbirch::Shared<birch::type::Expression<birch::type::Real>>>& _u0957, const libbirch::Lazy<libbirch::Shared<birch::type::Expression<birch::type::Real>>>& _u0956, const libbirch::Lazy<libbirch::Shared<birch::type::Expression<birch::type::Real>>>& _u09632, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);

  libbirch::Lazy<libbirch::Shared<birch::type::Expression<birch::type::Real>>> _u0957;
  libbirch::Lazy<libbirch::Shared<birch::type::Expression<birch::type::Real>>> _u0956;
  libbirch::Lazy<libbirch::Shared<birch::type::Expression<birch::type::Real>>> _u09632;
  #line 21 "src/distribution/Student.birch"
  virtual birch::type::Boolean supportsLazy(const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
  #line 25 "src/distribution/Student.birch"
  virtual birch::type::Real simulate(const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
  #line 29 "src/distribution/Student.birch"
  virtual libbirch::Optional<birch::type::Real> simulateLazy(const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
  #line 33 "src/distribution/Student.birch"
  virtual birch::type::Real logpdf(const birch::type::Real& x, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
  #line 37 "src/distribution/Student.birch"
  virtual libbirch::Optional<libbirch::Lazy<libbirch::Shared<birch::type::Expression<birch::type::Real>>>> logpdfLazy(const libbirch::Lazy<libbirch::Shared<birch::type::Expression<birch::type::Real>>>& x, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
  #line 41 "src/distribution/Student.birch"
  virtual libbirch::Optional<birch::type::Real> cdf(const birch::type::Real& x, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
  #line 45 "src/distribution/Student.birch"
  virtual libbirch::Optional<birch::type::Real> quantile(const birch::type::Real& P, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
  #line 49 "src/distribution/Student.birch"
  virtual void write(const libbirch::Lazy<libbirch::Shared<birch::type::Buffer>>& buffer, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
  
  #line 4 "src/distribution/Student.birch"
  LIBBIRCH_CLASS(Student, Distribution<birch::type::Real>)
  #line 4 "src/distribution/Student.birch"
  LIBBIRCH_MEMBERS(_u0957, _u0956, _u09632)
};

#line 4 "src/distribution/Uniform.birch"
class Uniform final : public Distribution<birch::type::Real> {
public:
  #line 4 "src/distribution/Uniform.birch"
  using class_type_ = Uniform;
  #line 4 "src/distribution/Uniform.birch"
  using this_type_ = class_type_;
  #line 4 "src/distribution/Uniform.birch"
  using super_type_ = Distribution<birch::type::Real>;

  #line 4 "src/distribution/Uniform.birch"
  using super_type_::operator=;
  #line 4 "src/distribution/Uniform.birch"
  using super_type_::cdf;
  #line 4 "src/distribution/Uniform.birch"
  using super_type_::logpdf;
  #line 4 "src/distribution/Uniform.birch"
  using super_type_::lower;
  #line 4 "src/distribution/Uniform.birch"
  using super_type_::quantile;
  #line 4 "src/distribution/Uniform.birch"
  using super_type_::simulate;
  #line 4 "src/distribution/Uniform.birch"
  using super_type_::supportsLazy;
  #line 4 "src/distribution/Uniform.birch"
  using super_type_::upper;
  
  #line 4 "src/distribution/Uniform.birch"
  Uniform(const libbirch::Lazy<libbirch::Shared<birch::type::Expression<birch::type::Real>>>& l, const libbirch::Lazy<libbirch::Shared<birch::type::Expression<birch::type::Real>>>& u, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);

  libbirch::Lazy<libbirch::Shared<birch::type::Expression<birch::type::Real>>> l;
  libbirch::Lazy<libbirch::Shared<birch::type::Expression<birch::type::Real>>> u;
  #line 16 "src/distribution/Uniform.birch"
  virtual birch::type::Boolean supportsLazy(const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
  #line 20 "src/distribution/Uniform.birch"
  virtual birch::type::Real simulate(const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
  #line 28 "src/distribution/Uniform.birch"
  virtual birch::type::Real logpdf(const birch::type::Real& x, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
  #line 36 "src/distribution/Uniform.birch"
  virtual libbirch::Optional<birch::type::Real> cdf(const birch::type::Real& x, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
  #line 40 "src/distribution/Uniform.birch"
  virtual libbirch::Optional<birch::type::Real> quantile(const birch::type::Real& P, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
  #line 44 "src/distribution/Uniform.birch"
  virtual libbirch::Optional<birch::type::Real> lower(const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
  #line 48 "src/distribution/Uniform.birch"
  virtual libbirch::Optional<birch::type::Real> upper(const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
  #line 52 "src/distribution/Uniform.birch"
  virtual void write(const libbirch::Lazy<libbirch::Shared<birch::type::Buffer>>& buffer, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
  
  #line 4 "src/distribution/Uniform.birch"
  LIBBIRCH_CLASS(Uniform, Distribution<birch::type::Real>)
  #line 4 "src/distribution/Uniform.birch"
  LIBBIRCH_MEMBERS(l, u)
};

#line 4 "src/distribution/Weibull.birch"
class Weibull final : public Distribution<birch::type::Real> {
public:
  #line 4 "src/distribution/Weibull.birch"
  using class_type_ = Weibull;
  #line 4 "src/distribution/Weibull.birch"
  using this_type_ = class_type_;
  #line 4 "src/distribution/Weibull.birch"
  using super_type_ = Distribution<birch::type::Real>;

  #line 4 "src/distribution/Weibull.birch"
  using super_type_::operator=;
  #line 4 "src/distribution/Weibull.birch"
  using super_type_::cdf;
  #line 4 "src/distribution/Weibull.birch"
  using super_type_::logpdf;
  #line 4 "src/distribution/Weibull.birch"
  using super_type_::logpdfLazy;
  #line 4 "src/distribution/Weibull.birch"
  using super_type_::lower;
  #line 4 "src/distribution/Weibull.birch"
  using super_type_::quantile;
  #line 4 "src/distribution/Weibull.birch"
  using super_type_::simulate;
  #line 4 "src/distribution/Weibull.birch"
  using super_type_::simulateLazy;
  #line 4 "src/distribution/Weibull.birch"
  using super_type_::supportsLazy;
  
  #line 4 "src/distribution/Weibull.birch"
  Weibull(const libbirch::Lazy<libbirch::Shared<birch::type::Expression<birch::type::Real>>>& k, const libbirch::Lazy<libbirch::Shared<birch::type::Expression<birch::type::Real>>>& _u0955, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);

  libbirch::Lazy<libbirch::Shared<birch::type::Expression<birch::type::Real>>> k;
  libbirch::Lazy<libbirch::Shared<birch::type::Expression<birch::type::Real>>> _u0955;
  #line 16 "src/distribution/Weibull.birch"
  virtual birch::type::Boolean supportsLazy(const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
  #line 20 "src/distribution/Weibull.birch"
  virtual birch::type::Real simulate(const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
  #line 24 "src/distribution/Weibull.birch"
  virtual libbirch::Optional<birch::type::Real> simulateLazy(const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
  #line 28 "src/distribution/Weibull.birch"
  virtual birch::type::Real logpdf(const birch::type::Real& x, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
  #line 32 "src/distribution/Weibull.birch"
  virtual libbirch::Optional<libbirch::Lazy<libbirch::Shared<birch::type::Expression<birch::type::Real>>>> logpdfLazy(const libbirch::Lazy<libbirch::Shared<birch::type::Expression<birch::type::Real>>>& x, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
  #line 36 "src/distribution/Weibull.birch"
  virtual libbirch::Optional<birch::type::Real> cdf(const birch::type::Real& x, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
  #line 40 "src/distribution/Weibull.birch"
  virtual libbirch::Optional<birch::type::Real> quantile(const birch::type::Real& P, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
  #line 44 "src/distribution/Weibull.birch"
  virtual libbirch::Optional<birch::type::Real> lower(const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
  #line 48 "src/distribution/Weibull.birch"
  virtual void write(const libbirch::Lazy<libbirch::Shared<birch::type::Buffer>>& buffer, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
  
  #line 4 "src/distribution/Weibull.birch"
  LIBBIRCH_CLASS(Weibull, Distribution<birch::type::Real>)
  #line 4 "src/distribution/Weibull.birch"
  LIBBIRCH_MEMBERS(k, _u0955)
};

#line 4 "src/distribution/Wishart.birch"
class Wishart final : public Distribution<birch::type::LLT> {
public:
  #line 4 "src/distribution/Wishart.birch"
  using class_type_ = Wishart;
  #line 4 "src/distribution/Wishart.birch"
  using this_type_ = class_type_;
  #line 4 "src/distribution/Wishart.birch"
  using super_type_ = Distribution<birch::type::LLT>;

  #line 4 "src/distribution/Wishart.birch"
  using super_type_::operator=;
  #line 4 "src/distribution/Wishart.birch"
  using super_type_::columns;
  #line 4 "src/distribution/Wishart.birch"
  using super_type_::logpdf;
  #line 4 "src/distribution/Wishart.birch"
  using super_type_::logpdfLazy;
  #line 4 "src/distribution/Wishart.birch"
  using super_type_::rows;
  #line 4 "src/distribution/Wishart.birch"
  using super_type_::simulate;
  #line 4 "src/distribution/Wishart.birch"
  using super_type_::simulateLazy;
  #line 4 "src/distribution/Wishart.birch"
  using super_type_::supportsLazy;
  
  #line 4 "src/distribution/Wishart.birch"
  Wishart(const libbirch::Lazy<libbirch::Shared<birch::type::Expression<birch::type::LLT>>>& _u0936, const libbirch::Lazy<libbirch::Shared<birch::type::Expression<birch::type::Real>>>& k, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);

  libbirch::Lazy<libbirch::Shared<birch::type::Expression<birch::type::LLT>>> _u0936;
  libbirch::Lazy<libbirch::Shared<birch::type::Expression<birch::type::Real>>> k;
  #line 16 "src/distribution/Wishart.birch"
  virtual birch::type::Integer rows(const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
  #line 20 "src/distribution/Wishart.birch"
  virtual birch::type::Integer columns(const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
  #line 24 "src/distribution/Wishart.birch"
  virtual birch::type::Boolean supportsLazy(const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
  #line 28 "src/distribution/Wishart.birch"
  virtual birch::type::LLT simulate(const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
  #line 32 "src/distribution/Wishart.birch"
  virtual libbirch::Optional<birch::type::LLT> simulateLazy(const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
  #line 36 "src/distribution/Wishart.birch"
  virtual birch::type::Real logpdf(const birch::type::LLT& X, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
  #line 40 "src/distribution/Wishart.birch"
  virtual libbirch::Optional<libbirch::Lazy<libbirch::Shared<birch::type::Expression<birch::type::Real>>>> logpdfLazy(const libbirch::Lazy<libbirch::Shared<birch::type::Expression<birch::type::LLT>>>& X, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
  #line 44 "src/distribution/Wishart.birch"
  virtual libbirch::Optional<libbirch::Lazy<libbirch::Shared<birch::type::Wishart>>> graftWishart(const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
  #line 49 "src/distribution/Wishart.birch"
  virtual void write(const libbirch::Lazy<libbirch::Shared<birch::type::Buffer>>& buffer, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
  
  #line 4 "src/distribution/Wishart.birch"
  LIBBIRCH_CLASS(Wishart, Distribution<birch::type::LLT>)
  #line 4 "src/distribution/Wishart.birch"
  LIBBIRCH_MEMBERS(_u0936, k)
};

#line 17 "src/event/Event.birch"
class Event : public Object {
public:
  #line 17 "src/event/Event.birch"
  using class_type_ = Event;
  #line 17 "src/event/Event.birch"
  using this_type_ = class_type_;
  #line 17 "src/event/Event.birch"
  using super_type_ = Object;

  #line 17 "src/event/Event.birch"
  using super_type_::operator=;
  
  #line 17 "src/event/Event.birch"
  Event(const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);

  #line 21 "src/event/Event.birch"
  virtual void accept(const libbirch::Lazy<libbirch::Shared<birch::type::PlayHandler>>& handler, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr) = 0;
  #line 26 "src/event/Event.birch"
  virtual void accept(const libbirch::Lazy<libbirch::Shared<birch::type::MoveHandler>>& handler, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr) = 0;
  #line 31 "src/event/Event.birch"
  virtual void accept(const libbirch::Lazy<libbirch::Shared<birch::type::Record>>& record, const libbirch::Lazy<libbirch::Shared<birch::type::PlayHandler>>& handler, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr) = 0;
  #line 36 "src/event/Event.birch"
  virtual void accept(const libbirch::Lazy<libbirch::Shared<birch::type::Record>>& record, const libbirch::Lazy<libbirch::Shared<birch::type::MoveHandler>>& handler, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr) = 0;
  #line 43 "src/event/Event.birch"
  virtual libbirch::Lazy<libbirch::Shared<birch::type::Record>> record(const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr) = 0;
  
  #line 17 "src/event/Event.birch"
  LIBBIRCH_ABSTRACT_CLASS(Event, Object)
  #line 17 "src/event/Event.birch"
  LIBBIRCH_MEMBERS()
};

template<class Value>
#line 21 "src/event/AssumeEvent.birch"
class AssumeEvent final : public Event {
public:
  #line 21 "src/event/AssumeEvent.birch"
  using class_type_ = AssumeEvent<Value>;
  #line 21 "src/event/AssumeEvent.birch"
  using this_type_ = class_type_;
  #line 21 "src/event/AssumeEvent.birch"
  using super_type_ = Event;

  #line 21 "src/event/AssumeEvent.birch"
  using super_type_::operator=;
  #line 21 "src/event/AssumeEvent.birch"
  using super_type_::accept;
  #line 21 "src/event/AssumeEvent.birch"
  using super_type_::record;
  
  #line 21 "src/event/AssumeEvent.birch"
  AssumeEvent(const libbirch::Lazy<libbirch::Shared<birch::type::Random<Value>>>& x, const libbirch::Lazy<libbirch::Shared<birch::type::Distribution<Value>>>& p, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);

  libbirch::Lazy<libbirch::Shared<birch::type::Random<Value>>> x;
  libbirch::Lazy<libbirch::Shared<birch::type::Distribution<Value>>> p;
  #line 33 "src/event/AssumeEvent.birch"
  virtual libbirch::Lazy<libbirch::Shared<birch::type::Record>> record(const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
  #line 37 "src/event/AssumeEvent.birch"
  virtual libbirch::Lazy<libbirch::Shared<birch::type::AssumeRecord<Value>>> coerce(const libbirch::Lazy<libbirch::Shared<birch::type::Record>>& record, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
  #line 45 "src/event/AssumeEvent.birch"
  virtual void accept(const libbirch::Lazy<libbirch::Shared<birch::type::PlayHandler>>& handler, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
  #line 49 "src/event/AssumeEvent.birch"
  virtual void accept(const libbirch::Lazy<libbirch::Shared<birch::type::MoveHandler>>& handler, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
  #line 53 "src/event/AssumeEvent.birch"
  virtual void accept(const libbirch::Lazy<libbirch::Shared<birch::type::Record>>& record, const libbirch::Lazy<libbirch::Shared<birch::type::PlayHandler>>& handler, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
  #line 57 "src/event/AssumeEvent.birch"
  virtual void accept(const libbirch::Lazy<libbirch::Shared<birch::type::Record>>& record, const libbirch::Lazy<libbirch::Shared<birch::type::MoveHandler>>& handler, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
  
  #line 21 "src/event/AssumeEvent.birch"
  LIBBIRCH_CLASS(AssumeEvent, Event)
  #line 21 "src/event/AssumeEvent.birch"
  LIBBIRCH_MEMBERS(x, p)
};

#line 19 "src/event/FactorEvent.birch"
class FactorEvent final : public Event {
public:
  #line 19 "src/event/FactorEvent.birch"
  using class_type_ = FactorEvent;
  #line 19 "src/event/FactorEvent.birch"
  using this_type_ = class_type_;
  #line 19 "src/event/FactorEvent.birch"
  using super_type_ = Event;

  #line 19 "src/event/FactorEvent.birch"
  using super_type_::operator=;
  #line 19 "src/event/FactorEvent.birch"
  using super_type_::accept;
  #line 19 "src/event/FactorEvent.birch"
  using super_type_::record;
  
  #line 19 "src/event/FactorEvent.birch"
  FactorEvent(const libbirch::Lazy<libbirch::Shared<birch::type::Expression<birch::type::Real>>>& w, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);

  libbirch::Lazy<libbirch::Shared<birch::type::Expression<birch::type::Real>>> w;
  #line 25 "src/event/FactorEvent.birch"
  virtual libbirch::Lazy<libbirch::Shared<birch::type::Record>> record(const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
  #line 29 "src/event/FactorEvent.birch"
  virtual libbirch::Lazy<libbirch::Shared<birch::type::FactorRecord>> coerce(const libbirch::Lazy<libbirch::Shared<birch::type::Record>>& record, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
  #line 37 "src/event/FactorEvent.birch"
  virtual void accept(const libbirch::Lazy<libbirch::Shared<birch::type::PlayHandler>>& handler, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
  #line 41 "src/event/FactorEvent.birch"
  virtual void accept(const libbirch::Lazy<libbirch::Shared<birch::type::MoveHandler>>& handler, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
  #line 45 "src/event/FactorEvent.birch"
  virtual void accept(const libbirch::Lazy<libbirch::Shared<birch::type::Record>>& record, const libbirch::Lazy<libbirch::Shared<birch::type::PlayHandler>>& handler, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
  #line 49 "src/event/FactorEvent.birch"
  virtual void accept(const libbirch::Lazy<libbirch::Shared<birch::type::Record>>& record, const libbirch::Lazy<libbirch::Shared<birch::type::MoveHandler>>& handler, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
  
  #line 19 "src/event/FactorEvent.birch"
  LIBBIRCH_CLASS(FactorEvent, Event)
  #line 19 "src/event/FactorEvent.birch"
  LIBBIRCH_MEMBERS(w)
};

template<class Value>
#line 20 "src/event/ObserveEvent.birch"
class ObserveEvent final : public Event {
public:
  #line 20 "src/event/ObserveEvent.birch"
  using class_type_ = ObserveEvent<Value>;
  #line 20 "src/event/ObserveEvent.birch"
  using this_type_ = class_type_;
  #line 20 "src/event/ObserveEvent.birch"
  using super_type_ = Event;

  #line 20 "src/event/ObserveEvent.birch"
  using super_type_::operator=;
  #line 20 "src/event/ObserveEvent.birch"
  using super_type_::accept;
  #line 20 "src/event/ObserveEvent.birch"
  using super_type_::record;
  
  #line 20 "src/event/ObserveEvent.birch"
  ObserveEvent(const Value& x, const libbirch::Lazy<libbirch::Shared<birch::type::Distribution<Value>>>& p, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);

  Value x;
  libbirch::Lazy<libbirch::Shared<birch::type::Distribution<Value>>> p;
  #line 31 "src/event/ObserveEvent.birch"
  virtual libbirch::Lazy<libbirch::Shared<birch::type::Record>> record(const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
  #line 35 "src/event/ObserveEvent.birch"
  virtual libbirch::Lazy<libbirch::Shared<birch::type::ObserveRecord<Value>>> coerce(const libbirch::Lazy<libbirch::Shared<birch::type::Record>>& record, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
  #line 43 "src/event/ObserveEvent.birch"
  virtual void accept(const libbirch::Lazy<libbirch::Shared<birch::type::PlayHandler>>& handler, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
  #line 47 "src/event/ObserveEvent.birch"
  virtual void accept(const libbirch::Lazy<libbirch::Shared<birch::type::MoveHandler>>& handler, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
  #line 51 "src/event/ObserveEvent.birch"
  virtual void accept(const libbirch::Lazy<libbirch::Shared<birch::type::Record>>& record, const libbirch::Lazy<libbirch::Shared<birch::type::PlayHandler>>& handler, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
  #line 55 "src/event/ObserveEvent.birch"
  virtual void accept(const libbirch::Lazy<libbirch::Shared<birch::type::Record>>& record, const libbirch::Lazy<libbirch::Shared<birch::type::MoveHandler>>& handler, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
  
  #line 20 "src/event/ObserveEvent.birch"
  LIBBIRCH_CLASS(ObserveEvent, Event)
  #line 20 "src/event/ObserveEvent.birch"
  LIBBIRCH_MEMBERS(x, p)
};

template<class Value>
#line 19 "src/event/SimulateEvent.birch"
class SimulateEvent final : public Event {
public:
  #line 19 "src/event/SimulateEvent.birch"
  using class_type_ = SimulateEvent<Value>;
  #line 19 "src/event/SimulateEvent.birch"
  using this_type_ = class_type_;
  #line 19 "src/event/SimulateEvent.birch"
  using super_type_ = Event;

  #line 19 "src/event/SimulateEvent.birch"
  using super_type_::operator=;
  #line 19 "src/event/SimulateEvent.birch"
  using super_type_::accept;
  #line 19 "src/event/SimulateEvent.birch"
  using super_type_::record;
  
  #line 19 "src/event/SimulateEvent.birch"
  SimulateEvent(const libbirch::Lazy<libbirch::Shared<birch::type::Distribution<Value>>>& p, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);

  libbirch::Optional<Value> x;
  libbirch::Lazy<libbirch::Shared<birch::type::Distribution<Value>>> p;
  #line 30 "src/event/SimulateEvent.birch"
  virtual Value value(const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
  #line 34 "src/event/SimulateEvent.birch"
  virtual libbirch::Lazy<libbirch::Shared<birch::type::Record>> record(const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
  #line 38 "src/event/SimulateEvent.birch"
  virtual libbirch::Lazy<libbirch::Shared<birch::type::SimulateRecord<Value>>> coerce(const libbirch::Lazy<libbirch::Shared<birch::type::Record>>& record, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
  #line 46 "src/event/SimulateEvent.birch"
  virtual void accept(const libbirch::Lazy<libbirch::Shared<birch::type::PlayHandler>>& handler, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
  #line 50 "src/event/SimulateEvent.birch"
  virtual void accept(const libbirch::Lazy<libbirch::Shared<birch::type::MoveHandler>>& handler, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
  #line 54 "src/event/SimulateEvent.birch"
  virtual void accept(const libbirch::Lazy<libbirch::Shared<birch::type::Record>>& record, const libbirch::Lazy<libbirch::Shared<birch::type::PlayHandler>>& handler, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
  #line 58 "src/event/SimulateEvent.birch"
  virtual void accept(const libbirch::Lazy<libbirch::Shared<birch::type::Record>>& record, const libbirch::Lazy<libbirch::Shared<birch::type::MoveHandler>>& handler, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
  
  #line 19 "src/event/SimulateEvent.birch"
  LIBBIRCH_CLASS(SimulateEvent, Event)
  #line 19 "src/event/SimulateEvent.birch"
  LIBBIRCH_MEMBERS(x, p)
};

#line 6 "src/expression/DelayExpression.birch"
class DelayExpression : public Object {
public:
  #line 6 "src/expression/DelayExpression.birch"
  using class_type_ = DelayExpression;
  #line 6 "src/expression/DelayExpression.birch"
  using this_type_ = class_type_;
  #line 6 "src/expression/DelayExpression.birch"
  using super_type_ = Object;

  #line 6 "src/expression/DelayExpression.birch"
  using super_type_::operator=;
  
  #line 6 "src/expression/DelayExpression.birch"
  DelayExpression(const birch::type::Boolean& isConstant, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);

  birch::type::Integer generation;
  birch::type::Integer16 pilotCount;
  birch::type::Integer16 gradCount;
  birch::type::Boolean flagConstant;
  birch::type::Boolean flagPrior;
  #line 44 "src/expression/DelayExpression.birch"
  virtual birch::type::Boolean isRandom(const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
  #line 51 "src/expression/DelayExpression.birch"
  virtual birch::type::Boolean isConstant(const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
  #line 58 "src/expression/DelayExpression.birch"
  virtual birch::type::Integer length(const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr) final;
  #line 65 "src/expression/DelayExpression.birch"
  virtual birch::type::Integer rows(const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr) = 0;
  #line 70 "src/expression/DelayExpression.birch"
  virtual birch::type::Integer columns(const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr) = 0;
  #line 75 "src/expression/DelayExpression.birch"
  virtual birch::type::Integer depth(const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr) = 0;
  #line 84 "src/expression/DelayExpression.birch"
  virtual libbirch::Optional<libbirch::Lazy<libbirch::Shared<birch::type::Expression<birch::type::Real>>>> prior(const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr) final;
  #line 93 "src/expression/DelayExpression.birch"
  virtual libbirch::Optional<libbirch::Lazy<libbirch::Shared<birch::type::Expression<birch::type::Real>>>> doPrior(const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr) = 0;
  
  #line 6 "src/expression/DelayExpression.birch"
  LIBBIRCH_ABSTRACT_CLASS(DelayExpression, Object)
  #line 6 "src/expression/DelayExpression.birch"
  LIBBIRCH_MEMBERS(generation, pilotCount, gradCount, flagConstant, flagPrior)
};

template<class Value>
#line 66 "src/expression/Expression.birch"
class Expression : public DelayExpression {
public:
  #line 66 "src/expression/Expression.birch"
  using class_type_ = Expression<Value>;
  #line 66 "src/expression/Expression.birch"
  using this_type_ = class_type_;
  #line 66 "src/expression/Expression.birch"
  using super_type_ = DelayExpression;

  #line 66 "src/expression/Expression.birch"
  using super_type_::operator=;
  #line 66 "src/expression/Expression.birch"
  using super_type_::columns;
  #line 66 "src/expression/Expression.birch"
  using super_type_::depth;
  #line 66 "src/expression/Expression.birch"
  using super_type_::rows;
  
  #line 66 "src/expression/Expression.birch"
  Expression(const libbirch::Optional<Value>& x, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);

  libbirch::Optional<Value> x;
  #line 81 "src/expression/Expression.birch"
  virtual birch::type::Boolean hasValue(const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
  #line 89 "src/expression/Expression.birch"
  virtual libbirch::Optional<libbirch::Lazy<libbirch::Shared<birch::type::Distribution<Value>>>> distribution(const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
  #line 93 "src/expression/Expression.birch"
  virtual birch::type::Integer rows(const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
  #line 101 "src/expression/Expression.birch"
  virtual birch::type::Integer doRows(const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr) = 0;
  #line 103 "src/expression/Expression.birch"
  virtual birch::type::Integer columns(const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
  #line 111 "src/expression/Expression.birch"
  virtual birch::type::Integer doColumns(const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr) = 0;
  #line 113 "src/expression/Expression.birch"
  virtual birch::type::Integer depth(const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
  #line 121 "src/expression/Expression.birch"
  virtual birch::type::Integer doDepth(const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr) = 0;
  #line 135 "src/expression/Expression.birch"
  virtual Value value(const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr) final;
  #line 153 "src/expression/Expression.birch"
  virtual Value doValue(const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr) = 0;
  #line 175 "src/expression/Expression.birch"
  virtual Value pilot(const birch::type::Integer& gen, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr) final;
  #line 191 "src/expression/Expression.birch"
  virtual Value doPilot(const birch::type::Integer& gen, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr) = 0;
  #line 203 "src/expression/Expression.birch"
  virtual Value get(const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr) final;
  #line 210 "src/expression/Expression.birch"
  virtual Value doGet(const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr) = 0;
  #line 225 "src/expression/Expression.birch"
  virtual Value move(const birch::type::Integer& gen, const libbirch::Lazy<libbirch::Shared<birch::type::Kernel>>& _u0954, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr) final;
  #line 240 "src/expression/Expression.birch"
  virtual Value doMove(const birch::type::Integer& gen, const libbirch::Lazy<libbirch::Shared<birch::type::Kernel>>& _u0954, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr) = 0;
  #line 256 "src/expression/Expression.birch"
  virtual birch::type::Real compare(const birch::type::Integer& gen, const libbirch::Lazy<libbirch::Shared<birch::type::DelayExpression>>& x, const libbirch::Lazy<libbirch::Shared<birch::type::Kernel>>& _u0954, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr) final;
  #line 271 "src/expression/Expression.birch"
  virtual birch::type::Real doCompare(const birch::type::Integer& gen, const libbirch::Lazy<libbirch::Shared<birch::type::DelayExpression>>& x, const libbirch::Lazy<libbirch::Shared<birch::type::Kernel>>& _u0954, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr) = 0;
  #line 278 "src/expression/Expression.birch"
  virtual void count(const birch::type::Integer& gen, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
  #line 289 "src/expression/Expression.birch"
  virtual void doCount(const birch::type::Integer& gen, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr) = 0;
  #line 295 "src/expression/Expression.birch"
  virtual void constant(const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
  #line 309 "src/expression/Expression.birch"
  virtual void doConstant(const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr) = 0;
  #line 314 "src/expression/Expression.birch"
  virtual void doDetach(const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr) = 0;
  template<class Gradient>
  #line 363 "src/expression/Expression.birch"
  void grad(const birch::type::Integer& gen, const Gradient& d, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
  #line 394 "src/expression/Expression.birch"
  virtual void grad(const birch::type::Integer& gen, const birch::type::Real& d, const birch::type::Integer& i, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr) final;
  #line 426 "src/expression/Expression.birch"
  virtual void grad(const birch::type::Integer& gen, const birch::type::Real& d, const birch::type::Integer& i, const birch::type::Integer& j, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr) final;
  #line 450 "src/expression/Expression.birch"
  virtual void doAccumulateGrad(const birch::type::Real& d, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
  #line 454 "src/expression/Expression.birch"
  virtual void doAccumulateGrad(const libbirch::DefaultArray<birch::type::Real,1>& d, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
  #line 458 "src/expression/Expression.birch"
  virtual void doAccumulateGrad(const libbirch::DefaultArray<birch::type::Real,2>& d, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
  #line 462 "src/expression/Expression.birch"
  virtual void doAccumulateGrad(const birch::type::Real& d, const birch::type::Integer& i, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
  #line 466 "src/expression/Expression.birch"
  virtual void doAccumulateGrad(const birch::type::Real& d, const birch::type::Integer& i, const birch::type::Integer& j, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
  #line 473 "src/expression/Expression.birch"
  virtual void doClearGrad(const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr) = 0;
  #line 478 "src/expression/Expression.birch"
  virtual void doGrad(const birch::type::Integer& gen, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr) = 0;
  #line 485 "src/expression/Expression.birch"
  virtual libbirch::Optional<libbirch::Lazy<libbirch::Shared<birch::type::Beta>>> graftBeta(const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
  #line 494 "src/expression/Expression.birch"
  virtual libbirch::Optional<libbirch::Lazy<libbirch::Shared<birch::type::Dirichlet>>> graftDirichlet(const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
  #line 503 "src/expression/Expression.birch"
  virtual libbirch::Optional<libbirch::Lazy<libbirch::Shared<birch::type::Restaurant>>> graftRestaurant(const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
  #line 512 "src/expression/Expression.birch"
  virtual libbirch::Optional<libbirch::Lazy<libbirch::Shared<birch::type::Gamma>>> graftGamma(const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
  #line 521 "src/expression/Expression.birch"
  virtual libbirch::Optional<libbirch::Lazy<libbirch::Shared<birch::type::TransformLinear<libbirch::Lazy<libbirch::Shared<birch::type::Gamma>>>>>> graftScaledGamma(const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
  #line 530 "src/expression/Expression.birch"
  virtual libbirch::Optional<libbirch::Lazy<libbirch::Shared<birch::type::InverseGamma>>> graftInverseGamma(const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
  #line 539 "src/expression/Expression.birch"
  virtual libbirch::Optional<libbirch::Lazy<libbirch::Shared<birch::type::InverseWishart>>> graftInverseWishart(const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
  #line 548 "src/expression/Expression.birch"
  virtual libbirch::Optional<libbirch::Lazy<libbirch::Shared<birch::type::Gaussian>>> graftGaussian(const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
  #line 557 "src/expression/Expression.birch"
  virtual libbirch::Optional<libbirch::Lazy<libbirch::Shared<birch::type::TransformLinear<libbirch::Lazy<libbirch::Shared<birch::type::Gaussian>>>>>> graftLinearGaussian(const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
  #line 566 "src/expression/Expression.birch"
  virtual libbirch::Optional<libbirch::Lazy<libbirch::Shared<birch::type::NormalInverseGamma>>> graftNormalInverseGamma(const libbirch::Lazy<libbirch::Shared<birch::type::Distribution<birch::type::Real>>>& compare, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
  #line 576 "src/expression/Expression.birch"
  virtual libbirch::Optional<libbirch::Lazy<libbirch::Shared<birch::type::TransformLinear<libbirch::Lazy<libbirch::Shared<birch::type::NormalInverseGamma>>>>>> graftLinearNormalInverseGamma(const libbirch::Lazy<libbirch::Shared<birch::type::Distribution<birch::type::Real>>>& compare, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
  #line 586 "src/expression/Expression.birch"
  virtual libbirch::Optional<libbirch::Lazy<libbirch::Shared<birch::type::MultivariateGaussian>>> graftMultivariateGaussian(const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
  #line 595 "src/expression/Expression.birch"
  virtual libbirch::Optional<libbirch::Lazy<libbirch::Shared<birch::type::TransformLinearMultivariate<libbirch::Lazy<libbirch::Shared<birch::type::MultivariateGaussian>>>>>> graftLinearMultivariateGaussian(const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
  #line 605 "src/expression/Expression.birch"
  virtual libbirch::Optional<libbirch::Lazy<libbirch::Shared<birch::type::TransformDot<libbirch::Lazy<libbirch::Shared<birch::type::MultivariateGaussian>>>>>> graftDotMultivariateGaussian(const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
  #line 615 "src/expression/Expression.birch"
  virtual libbirch::Optional<libbirch::Lazy<libbirch::Shared<birch::type::MultivariateNormalInverseGamma>>> graftMultivariateNormalInverseGamma(const libbirch::Lazy<libbirch::Shared<birch::type::Distribution<birch::type::Real>>>& compare, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
  #line 625 "src/expression/Expression.birch"
  virtual libbirch::Optional<libbirch::Lazy<libbirch::Shared<birch::type::TransformLinearMultivariate<libbirch::Lazy<libbirch::Shared<birch::type::MultivariateNormalInverseGamma>>>>>> graftLinearMultivariateNormalInverseGamma(const libbirch::Lazy<libbirch::Shared<birch::type::Distribution<birch::type::Real>>>& compare, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
  #line 635 "src/expression/Expression.birch"
  virtual libbirch::Optional<libbirch::Lazy<libbirch::Shared<birch::type::TransformDot<libbirch::Lazy<libbirch::Shared<birch::type::MultivariateNormalInverseGamma>>>>>> graftDotMultivariateNormalInverseGamma(const libbirch::Lazy<libbirch::Shared<birch::type::Distribution<birch::type::Real>>>& compare, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
  #line 645 "src/expression/Expression.birch"
  virtual libbirch::Optional<libbirch::Lazy<libbirch::Shared<birch::type::MatrixGaussian>>> graftMatrixGaussian(const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
  #line 654 "src/expression/Expression.birch"
  virtual libbirch::Optional<libbirch::Lazy<libbirch::Shared<birch::type::TransformLinearMatrix<libbirch::Lazy<libbirch::Shared<birch::type::MatrixGaussian>>>>>> graftLinearMatrixGaussian(const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
  #line 664 "src/expression/Expression.birch"
  virtual libbirch::Optional<libbirch::Lazy<libbirch::Shared<birch::type::TransformDotMultivariate<libbirch::Lazy<libbirch::Shared<birch::type::MatrixGaussian>>>>>> graftDotMatrixGaussian(const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
  #line 674 "src/expression/Expression.birch"
  virtual libbirch::Optional<libbirch::Lazy<libbirch::Shared<birch::type::MatrixNormalInverseWishart>>> graftMatrixNormalInverseWishart(const libbirch::Lazy<libbirch::Shared<birch::type::Distribution<birch::type::LLT>>>& compare, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
  #line 684 "src/expression/Expression.birch"
  virtual libbirch::Optional<libbirch::Lazy<libbirch::Shared<birch::type::TransformLinearMatrix<libbirch::Lazy<libbirch::Shared<birch::type::MatrixNormalInverseWishart>>>>>> graftLinearMatrixNormalInverseWishart(const libbirch::Lazy<libbirch::Shared<birch::type::Distribution<birch::type::LLT>>>& compare, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
  #line 694 "src/expression/Expression.birch"
  virtual libbirch::Optional<libbirch::Lazy<libbirch::Shared<birch::type::TransformDotMultivariate<libbirch::Lazy<libbirch::Shared<birch::type::MatrixNormalInverseWishart>>>>>> graftDotMatrixNormalInverseWishart(const libbirch::Lazy<libbirch::Shared<birch::type::Distribution<birch::type::LLT>>>& compare, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
  #line 704 "src/expression/Expression.birch"
  virtual libbirch::Optional<libbirch::Lazy<libbirch::Shared<birch::type::Discrete>>> graftDiscrete(const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
  #line 713 "src/expression/Expression.birch"
  virtual libbirch::Optional<libbirch::Lazy<libbirch::Shared<birch::type::BoundedDiscrete>>> graftBoundedDiscrete(const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
  #line 717 "src/expression/Expression.birch"
  virtual void write(const libbirch::Lazy<libbirch::Shared<birch::type::Buffer>>& buffer, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr) override;
  
  #line 66 "src/expression/Expression.birch"
  LIBBIRCH_ABSTRACT_CLASS(Expression, DelayExpression)
  #line 66 "src/expression/Expression.birch"
  LIBBIRCH_MEMBERS(x)
};

template<class Value>
#line 4 "src/expression/Boxed.birch"
class Boxed final : public Expression<Value> {
public:
  #line 4 "src/expression/Boxed.birch"
  using class_type_ = Boxed<Value>;
  #line 4 "src/expression/Boxed.birch"
  using this_type_ = class_type_;
  #line 4 "src/expression/Boxed.birch"
  using super_type_ = Expression<Value>;

  #line 4 "src/expression/Boxed.birch"
  using super_type_::operator=;
  #line 4 "src/expression/Boxed.birch"
  using super_type_::doClearGrad;
  #line 4 "src/expression/Boxed.birch"
  using super_type_::doColumns;
  #line 4 "src/expression/Boxed.birch"
  using super_type_::doCompare;
  #line 4 "src/expression/Boxed.birch"
  using super_type_::doConstant;
  #line 4 "src/expression/Boxed.birch"
  using super_type_::doCount;
  #line 4 "src/expression/Boxed.birch"
  using super_type_::doDepth;
  #line 4 "src/expression/Boxed.birch"
  using super_type_::doDetach;
  #line 4 "src/expression/Boxed.birch"
  using super_type_::doGet;
  #line 4 "src/expression/Boxed.birch"
  using super_type_::doGrad;
  #line 4 "src/expression/Boxed.birch"
  using super_type_::doMove;
  #line 4 "src/expression/Boxed.birch"
  using super_type_::doPilot;
  #line 4 "src/expression/Boxed.birch"
  using super_type_::doPrior;
  #line 4 "src/expression/Boxed.birch"
  using super_type_::doRows;
  #line 4 "src/expression/Boxed.birch"
  using super_type_::doValue;
  
  #line 4 "src/expression/Boxed.birch"
  Boxed(const Value& x, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);

  #line 5 "src/expression/Boxed.birch"
  virtual birch::type::Integer doRows(const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr) override;
  #line 9 "src/expression/Boxed.birch"
  virtual birch::type::Integer doColumns(const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr) override;
  #line 13 "src/expression/Boxed.birch"
  virtual birch::type::Integer doDepth(const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr) override;
  #line 17 "src/expression/Boxed.birch"
  virtual Value doValue(const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr) override;
  #line 21 "src/expression/Boxed.birch"
  virtual Value doPilot(const birch::type::Integer& gen, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr) override;
  #line 25 "src/expression/Boxed.birch"
  virtual Value doGet(const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr) override;
  #line 29 "src/expression/Boxed.birch"
  virtual Value doMove(const birch::type::Integer& gen, const libbirch::Lazy<libbirch::Shared<birch::type::Kernel>>& _u0954, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr) override;
  #line 33 "src/expression/Boxed.birch"
  virtual libbirch::Optional<libbirch::Lazy<libbirch::Shared<birch::type::Expression<birch::type::Real>>>> doPrior(const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr) override;
  #line 37 "src/expression/Boxed.birch"
  virtual birch::type::Real doCompare(const birch::type::Integer& gen, const libbirch::Lazy<libbirch::Shared<birch::type::DelayExpression>>& x, const libbirch::Lazy<libbirch::Shared<birch::type::Kernel>>& _u0954, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr) override;
  #line 42 "src/expression/Boxed.birch"
  virtual void doGrad(const birch::type::Integer& gen, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr) override;
  #line 46 "src/expression/Boxed.birch"
  virtual void doClearGrad(const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr) override;
  #line 50 "src/expression/Boxed.birch"
  virtual void doConstant(const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr) override;
  #line 54 "src/expression/Boxed.birch"
  virtual void doCount(const birch::type::Integer& gen, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr) override;
  #line 58 "src/expression/Boxed.birch"
  virtual void doDetach(const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr) override;
  
  #line 4 "src/expression/Boxed.birch"
  LIBBIRCH_CLASS(Boxed, Expression<Value>)
  #line 4 "src/expression/Boxed.birch"
  LIBBIRCH_MEMBERS()
};

template<class Value>
#line 6 "src/expression/MatrixExpression.birch"
class MatrixExpression : public Expression<Value> {
public:
  #line 6 "src/expression/MatrixExpression.birch"
  using class_type_ = MatrixExpression<Value>;
  #line 6 "src/expression/MatrixExpression.birch"
  using this_type_ = class_type_;
  #line 6 "src/expression/MatrixExpression.birch"
  using super_type_ = Expression<Value>;

  #line 6 "src/expression/MatrixExpression.birch"
  using super_type_::operator=;
  #line 6 "src/expression/MatrixExpression.birch"
  using super_type_::doAccumulateGrad;
  #line 6 "src/expression/MatrixExpression.birch"
  using super_type_::doClearGrad;
  
  #line 6 "src/expression/MatrixExpression.birch"
  MatrixExpression(const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);

  libbirch::Optional<libbirch::DefaultArray<birch::type::Real,2>> d;
  #line 12 "src/expression/MatrixExpression.birch"
  virtual void doAccumulateGrad(const libbirch::DefaultArray<birch::type::Real,2>& d, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr) final;
  #line 20 "src/expression/MatrixExpression.birch"
  virtual void doAccumulateGrad(const birch::type::Real& d, const birch::type::Integer& i, const birch::type::Integer& j, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr) final;
  #line 27 "src/expression/MatrixExpression.birch"
  virtual void doClearGrad(const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr) final;
  
  #line 6 "src/expression/MatrixExpression.birch"
  LIBBIRCH_ABSTRACT_CLASS(MatrixExpression, Expression<Value>)
  #line 6 "src/expression/MatrixExpression.birch"
  LIBBIRCH_MEMBERS(d)
};

template<class Left,class Right,class LeftValue,class RightValue,class LeftGradient,class RightGradient,class Value>
#line 18 "src/expression/MatrixBinaryExpression.birch"
class MatrixBinaryExpression : public MatrixExpression<Value> {
public:
  #line 18 "src/expression/MatrixBinaryExpression.birch"
  using class_type_ = MatrixBinaryExpression<Left, Right, LeftValue, RightValue, LeftGradient, RightGradient, Value>;
  #line 18 "src/expression/MatrixBinaryExpression.birch"
  using this_type_ = class_type_;
  #line 18 "src/expression/MatrixBinaryExpression.birch"
  using super_type_ = MatrixExpression<Value>;

  #line 18 "src/expression/MatrixBinaryExpression.birch"
  using super_type_::operator=;
  #line 18 "src/expression/MatrixBinaryExpression.birch"
  using super_type_::doCompare;
  #line 18 "src/expression/MatrixBinaryExpression.birch"
  using super_type_::doConstant;
  #line 18 "src/expression/MatrixBinaryExpression.birch"
  using super_type_::doCount;
  #line 18 "src/expression/MatrixBinaryExpression.birch"
  using super_type_::doDepth;
  #line 18 "src/expression/MatrixBinaryExpression.birch"
  using super_type_::doDetach;
  #line 18 "src/expression/MatrixBinaryExpression.birch"
  using super_type_::doGet;
  #line 18 "src/expression/MatrixBinaryExpression.birch"
  using super_type_::doGrad;
  #line 18 "src/expression/MatrixBinaryExpression.birch"
  using super_type_::doMove;
  #line 18 "src/expression/MatrixBinaryExpression.birch"
  using super_type_::doPilot;
  #line 18 "src/expression/MatrixBinaryExpression.birch"
  using super_type_::doPrior;
  #line 18 "src/expression/MatrixBinaryExpression.birch"
  using super_type_::doValue;
  
  #line 18 "src/expression/MatrixBinaryExpression.birch"
  MatrixBinaryExpression(const Left& y, const Right& z, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);

  libbirch::Optional<Left> y;
  libbirch::Optional<Right> z;
  #line 34 "src/expression/MatrixBinaryExpression.birch"
  virtual Value doEvaluate(const LeftValue& y, const RightValue& z, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr) = 0;
  #line 39 "src/expression/MatrixBinaryExpression.birch"
  virtual LeftGradient doEvaluateGradLeft(const libbirch::DefaultArray<birch::type::Real,2>& d, const Value& x, const LeftValue& y, const RightValue& z, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr) = 0;
  #line 45 "src/expression/MatrixBinaryExpression.birch"
  virtual RightGradient doEvaluateGradRight(const libbirch::DefaultArray<birch::type::Real,2>& d, const Value& x, const LeftValue& y, const RightValue& z, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr) = 0;
  #line 49 "src/expression/MatrixBinaryExpression.birch"
  virtual birch::type::Integer doDepth(const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr) final;
  #line 53 "src/expression/MatrixBinaryExpression.birch"
  virtual Value doValue(const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr) final;
  #line 57 "src/expression/MatrixBinaryExpression.birch"
  virtual Value doPilot(const birch::type::Integer& gen, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr) final;
  #line 61 "src/expression/MatrixBinaryExpression.birch"
  virtual Value doGet(const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr) final;
  #line 65 "src/expression/MatrixBinaryExpression.birch"
  virtual Value doMove(const birch::type::Integer& gen, const libbirch::Lazy<libbirch::Shared<birch::type::Kernel>>& _u0954, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr) final;
  #line 69 "src/expression/MatrixBinaryExpression.birch"
  virtual void doGrad(const birch::type::Integer& gen, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr) final;
  #line 74 "src/expression/MatrixBinaryExpression.birch"
  virtual libbirch::Optional<libbirch::Lazy<libbirch::Shared<birch::type::Expression<birch::type::Real>>>> doPrior(const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr) final;
  #line 88 "src/expression/MatrixBinaryExpression.birch"
  virtual birch::type::Real doCompare(const birch::type::Integer& gen, const libbirch::Lazy<libbirch::Shared<birch::type::DelayExpression>>& x, const libbirch::Lazy<libbirch::Shared<birch::type::Kernel>>& _u0954, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr) final;
  #line 95 "src/expression/MatrixBinaryExpression.birch"
  virtual void doConstant(const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr) final;
  #line 100 "src/expression/MatrixBinaryExpression.birch"
  virtual void doCount(const birch::type::Integer& gen, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr) final;
  #line 105 "src/expression/MatrixBinaryExpression.birch"
  virtual void doDetach(const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr) final;
  
  #line 18 "src/expression/MatrixBinaryExpression.birch"
  LIBBIRCH_ABSTRACT_CLASS(MatrixBinaryExpression, MatrixExpression<Value>)
  #line 18 "src/expression/MatrixBinaryExpression.birch"
  LIBBIRCH_MEMBERS(y, z)
};

#line 4 "src/expression/MatrixAdd.birch"
class MatrixAdd final : public MatrixBinaryExpression<libbirch::Lazy<libbirch::Shared<birch::type::Expression<libbirch::DefaultArray<birch::type::Real,2>>>>, libbirch::Lazy<libbirch::Shared<birch::type::Expression<libbirch::DefaultArray<birch::type::Real,2>>>>, libbirch::DefaultArray<birch::type::Real,2>, libbirch::DefaultArray<birch::type::Real,2>, libbirch::DefaultArray<birch::type::Real,2>, libbirch::DefaultArray<birch::type::Real,2>, libbirch::DefaultArray<birch::type::Real,2>> {
public:
  #line 4 "src/expression/MatrixAdd.birch"
  using class_type_ = MatrixAdd;
  #line 4 "src/expression/MatrixAdd.birch"
  using this_type_ = class_type_;
  #line 4 "src/expression/MatrixAdd.birch"
  using super_type_ = MatrixBinaryExpression<libbirch::Lazy<libbirch::Shared<birch::type::Expression<libbirch::DefaultArray<birch::type::Real,2>>>>, libbirch::Lazy<libbirch::Shared<birch::type::Expression<libbirch::DefaultArray<birch::type::Real,2>>>>, libbirch::DefaultArray<birch::type::Real,2>, libbirch::DefaultArray<birch::type::Real,2>, libbirch::DefaultArray<birch::type::Real,2>, libbirch::DefaultArray<birch::type::Real,2>, libbirch::DefaultArray<birch::type::Real,2>>;

  #line 4 "src/expression/MatrixAdd.birch"
  using super_type_::operator=;
  #line 4 "src/expression/MatrixAdd.birch"
  using super_type_::doColumns;
  #line 4 "src/expression/MatrixAdd.birch"
  using super_type_::doEvaluate;
  #line 4 "src/expression/MatrixAdd.birch"
  using super_type_::doEvaluateGradLeft;
  #line 4 "src/expression/MatrixAdd.birch"
  using super_type_::doEvaluateGradRight;
  #line 4 "src/expression/MatrixAdd.birch"
  using super_type_::doRows;
  #line 4 "src/expression/MatrixAdd.birch"
  using super_type_::graftLinearMatrixGaussian;
  #line 4 "src/expression/MatrixAdd.birch"
  using super_type_::graftLinearMatrixNormalInverseWishart;
  
  #line 4 "src/expression/MatrixAdd.birch"
  MatrixAdd(const libbirch::Lazy<libbirch::Shared<birch::type::Expression<libbirch::DefaultArray<birch::type::Real,2>>>>& y, const libbirch::Lazy<libbirch::Shared<birch::type::Expression<libbirch::DefaultArray<birch::type::Real,2>>>>& z, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);

  #line 7 "src/expression/MatrixAdd.birch"
  virtual birch::type::Integer doRows(const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr) override;
  #line 11 "src/expression/MatrixAdd.birch"
  virtual birch::type::Integer doColumns(const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr) override;
  #line 15 "src/expression/MatrixAdd.birch"
  virtual libbirch::DefaultArray<birch::type::Real,2> doEvaluate(const libbirch::DefaultArray<birch::type::Real,2>& y, const libbirch::DefaultArray<birch::type::Real,2>& z, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr) override;
  #line 19 "src/expression/MatrixAdd.birch"
  virtual libbirch::DefaultArray<birch::type::Real,2> doEvaluateGradLeft(const libbirch::DefaultArray<birch::type::Real,2>& d, const libbirch::DefaultArray<birch::type::Real,2>& x, const libbirch::DefaultArray<birch::type::Real,2>& y, const libbirch::DefaultArray<birch::type::Real,2>& z, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr) override;
  #line 23 "src/expression/MatrixAdd.birch"
  virtual libbirch::DefaultArray<birch::type::Real,2> doEvaluateGradRight(const libbirch::DefaultArray<birch::type::Real,2>& d, const libbirch::DefaultArray<birch::type::Real,2>& x, const libbirch::DefaultArray<birch::type::Real,2>& y, const libbirch::DefaultArray<birch::type::Real,2>& z, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr) override;
  #line 27 "src/expression/MatrixAdd.birch"
  virtual libbirch::Optional<libbirch::Lazy<libbirch::Shared<birch::type::TransformLinearMatrix<libbirch::Lazy<libbirch::Shared<birch::type::MatrixGaussian>>>>>> graftLinearMatrixGaussian(const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr) override;
  #line 46 "src/expression/MatrixAdd.birch"
  virtual libbirch::Optional<libbirch::Lazy<libbirch::Shared<birch::type::TransformLinearMatrix<libbirch::Lazy<libbirch::Shared<birch::type::MatrixNormalInverseWishart>>>>>> graftLinearMatrixNormalInverseWishart(const libbirch::Lazy<libbirch::Shared<birch::type::Distribution<birch::type::LLT>>>& compare, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr) override;
  
  #line 4 "src/expression/MatrixAdd.birch"
  LIBBIRCH_CLASS(MatrixAdd, MatrixBinaryExpression<libbirch::Lazy<libbirch::Shared<birch::type::Expression<libbirch::DefaultArray<birch::type::Real,2>>>>, libbirch::Lazy<libbirch::Shared<birch::type::Expression<libbirch::DefaultArray<birch::type::Real,2>>>>, libbirch::DefaultArray<birch::type::Real,2>, libbirch::DefaultArray<birch::type::Real,2>, libbirch::DefaultArray<birch::type::Real,2>, libbirch::DefaultArray<birch::type::Real,2>, libbirch::DefaultArray<birch::type::Real,2>>)
  #line 4 "src/expression/MatrixAdd.birch"
  LIBBIRCH_MEMBERS()
};

#line 4 "src/expression/MatrixMultiply.birch"
class MatrixMultiply final : public MatrixBinaryExpression<libbirch::Lazy<libbirch::Shared<birch::type::Expression<libbirch::DefaultArray<birch::type::Real,2>>>>, libbirch::Lazy<libbirch::Shared<birch::type::Expression<libbirch::DefaultArray<birch::type::Real,2>>>>, libbirch::DefaultArray<birch::type::Real,2>, libbirch::DefaultArray<birch::type::Real,2>, libbirch::DefaultArray<birch::type::Real,2>, libbirch::DefaultArray<birch::type::Real,2>, libbirch::DefaultArray<birch::type::Real,2>> {
public:
  #line 4 "src/expression/MatrixMultiply.birch"
  using class_type_ = MatrixMultiply;
  #line 4 "src/expression/MatrixMultiply.birch"
  using this_type_ = class_type_;
  #line 4 "src/expression/MatrixMultiply.birch"
  using super_type_ = MatrixBinaryExpression<libbirch::Lazy<libbirch::Shared<birch::type::Expression<libbirch::DefaultArray<birch::type::Real,2>>>>, libbirch::Lazy<libbirch::Shared<birch::type::Expression<libbirch::DefaultArray<birch::type::Real,2>>>>, libbirch::DefaultArray<birch::type::Real,2>, libbirch::DefaultArray<birch::type::Real,2>, libbirch::DefaultArray<birch::type::Real,2>, libbirch::DefaultArray<birch::type::Real,2>, libbirch::DefaultArray<birch::type::Real,2>>;

  #line 4 "src/expression/MatrixMultiply.birch"
  using super_type_::operator=;
  #line 4 "src/expression/MatrixMultiply.birch"
  using super_type_::doColumns;
  #line 4 "src/expression/MatrixMultiply.birch"
  using super_type_::doEvaluate;
  #line 4 "src/expression/MatrixMultiply.birch"
  using super_type_::doEvaluateGradLeft;
  #line 4 "src/expression/MatrixMultiply.birch"
  using super_type_::doEvaluateGradRight;
  #line 4 "src/expression/MatrixMultiply.birch"
  using super_type_::doRows;
  #line 4 "src/expression/MatrixMultiply.birch"
  using super_type_::graftLinearMatrixGaussian;
  #line 4 "src/expression/MatrixMultiply.birch"
  using super_type_::graftLinearMatrixNormalInverseWishart;
  
  #line 4 "src/expression/MatrixMultiply.birch"
  MatrixMultiply(const libbirch::Lazy<libbirch::Shared<birch::type::Expression<libbirch::DefaultArray<birch::type::Real,2>>>>& y, const libbirch::Lazy<libbirch::Shared<birch::type::Expression<libbirch::DefaultArray<birch::type::Real,2>>>>& z, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);

  #line 8 "src/expression/MatrixMultiply.birch"
  virtual birch::type::Integer doRows(const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr) override;
  #line 12 "src/expression/MatrixMultiply.birch"
  virtual birch::type::Integer doColumns(const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr) override;
  #line 16 "src/expression/MatrixMultiply.birch"
  virtual libbirch::DefaultArray<birch::type::Real,2> doEvaluate(const libbirch::DefaultArray<birch::type::Real,2>& y, const libbirch::DefaultArray<birch::type::Real,2>& z, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr) override;
  #line 20 "src/expression/MatrixMultiply.birch"
  virtual libbirch::DefaultArray<birch::type::Real,2> doEvaluateGradLeft(const libbirch::DefaultArray<birch::type::Real,2>& d, const libbirch::DefaultArray<birch::type::Real,2>& x, const libbirch::DefaultArray<birch::type::Real,2>& y, const libbirch::DefaultArray<birch::type::Real,2>& z, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr) override;
  #line 25 "src/expression/MatrixMultiply.birch"
  virtual libbirch::DefaultArray<birch::type::Real,2> doEvaluateGradRight(const libbirch::DefaultArray<birch::type::Real,2>& d, const libbirch::DefaultArray<birch::type::Real,2>& x, const libbirch::DefaultArray<birch::type::Real,2>& y, const libbirch::DefaultArray<birch::type::Real,2>& z, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr) override;
  #line 30 "src/expression/MatrixMultiply.birch"
  virtual libbirch::Optional<libbirch::Lazy<libbirch::Shared<birch::type::TransformLinearMatrix<libbirch::Lazy<libbirch::Shared<birch::type::MatrixGaussian>>>>>> graftLinearMatrixGaussian(const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr) override;
  #line 44 "src/expression/MatrixMultiply.birch"
  virtual libbirch::Optional<libbirch::Lazy<libbirch::Shared<birch::type::TransformLinearMatrix<libbirch::Lazy<libbirch::Shared<birch::type::MatrixNormalInverseWishart>>>>>> graftLinearMatrixNormalInverseWishart(const libbirch::Lazy<libbirch::Shared<birch::type::Distribution<birch::type::LLT>>>& compare, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr) override;
  
  #line 4 "src/expression/MatrixMultiply.birch"
  LIBBIRCH_CLASS(MatrixMultiply, MatrixBinaryExpression<libbirch::Lazy<libbirch::Shared<birch::type::Expression<libbirch::DefaultArray<birch::type::Real,2>>>>, libbirch::Lazy<libbirch::Shared<birch::type::Expression<libbirch::DefaultArray<birch::type::Real,2>>>>, libbirch::DefaultArray<birch::type::Real,2>, libbirch::DefaultArray<birch::type::Real,2>, libbirch::DefaultArray<birch::type::Real,2>, libbirch::DefaultArray<birch::type::Real,2>, libbirch::DefaultArray<birch::type::Real,2>>)
  #line 4 "src/expression/MatrixMultiply.birch"
  LIBBIRCH_MEMBERS()
};

#line 4 "src/expression/MatrixPack.birch"
class MatrixPack final : public MatrixBinaryExpression<libbirch::Lazy<libbirch::Shared<birch::type::Expression<libbirch::DefaultArray<birch::type::Real,2>>>>, libbirch::Lazy<libbirch::Shared<birch::type::Expression<libbirch::DefaultArray<birch::type::Real,2>>>>, libbirch::DefaultArray<birch::type::Real,2>, libbirch::DefaultArray<birch::type::Real,2>, libbirch::DefaultArray<birch::type::Real,2>, libbirch::DefaultArray<birch::type::Real,2>, libbirch::DefaultArray<birch::type::Real,2>> {
public:
  #line 4 "src/expression/MatrixPack.birch"
  using class_type_ = MatrixPack;
  #line 4 "src/expression/MatrixPack.birch"
  using this_type_ = class_type_;
  #line 4 "src/expression/MatrixPack.birch"
  using super_type_ = MatrixBinaryExpression<libbirch::Lazy<libbirch::Shared<birch::type::Expression<libbirch::DefaultArray<birch::type::Real,2>>>>, libbirch::Lazy<libbirch::Shared<birch::type::Expression<libbirch::DefaultArray<birch::type::Real,2>>>>, libbirch::DefaultArray<birch::type::Real,2>, libbirch::DefaultArray<birch::type::Real,2>, libbirch::DefaultArray<birch::type::Real,2>, libbirch::DefaultArray<birch::type::Real,2>, libbirch::DefaultArray<birch::type::Real,2>>;

  #line 4 "src/expression/MatrixPack.birch"
  using super_type_::operator=;
  #line 4 "src/expression/MatrixPack.birch"
  using super_type_::doColumns;
  #line 4 "src/expression/MatrixPack.birch"
  using super_type_::doEvaluate;
  #line 4 "src/expression/MatrixPack.birch"
  using super_type_::doEvaluateGradLeft;
  #line 4 "src/expression/MatrixPack.birch"
  using super_type_::doEvaluateGradRight;
  #line 4 "src/expression/MatrixPack.birch"
  using super_type_::doRows;
  
  #line 4 "src/expression/MatrixPack.birch"
  MatrixPack(const libbirch::Lazy<libbirch::Shared<birch::type::Expression<libbirch::DefaultArray<birch::type::Real,2>>>>& y, const libbirch::Lazy<libbirch::Shared<birch::type::Expression<libbirch::DefaultArray<birch::type::Real,2>>>>& z, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);

  #line 7 "src/expression/MatrixPack.birch"
  virtual birch::type::Integer doRows(const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr) override;
  #line 11 "src/expression/MatrixPack.birch"
  virtual birch::type::Integer doColumns(const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr) override;
  #line 15 "src/expression/MatrixPack.birch"
  virtual libbirch::DefaultArray<birch::type::Real,2> doEvaluate(const libbirch::DefaultArray<birch::type::Real,2>& y, const libbirch::DefaultArray<birch::type::Real,2>& z, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr) override;
  #line 19 "src/expression/MatrixPack.birch"
  virtual libbirch::DefaultArray<birch::type::Real,2> doEvaluateGradLeft(const libbirch::DefaultArray<birch::type::Real,2>& d, const libbirch::DefaultArray<birch::type::Real,2>& x, const libbirch::DefaultArray<birch::type::Real,2>& y, const libbirch::DefaultArray<birch::type::Real,2>& z, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr) override;
  #line 24 "src/expression/MatrixPack.birch"
  virtual libbirch::DefaultArray<birch::type::Real,2> doEvaluateGradRight(const libbirch::DefaultArray<birch::type::Real,2>& d, const libbirch::DefaultArray<birch::type::Real,2>& x, const libbirch::DefaultArray<birch::type::Real,2>& y, const libbirch::DefaultArray<birch::type::Real,2>& z, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr) override;
  
  #line 4 "src/expression/MatrixPack.birch"
  LIBBIRCH_CLASS(MatrixPack, MatrixBinaryExpression<libbirch::Lazy<libbirch::Shared<birch::type::Expression<libbirch::DefaultArray<birch::type::Real,2>>>>, libbirch::Lazy<libbirch::Shared<birch::type::Expression<libbirch::DefaultArray<birch::type::Real,2>>>>, libbirch::DefaultArray<birch::type::Real,2>, libbirch::DefaultArray<birch::type::Real,2>, libbirch::DefaultArray<birch::type::Real,2>, libbirch::DefaultArray<birch::type::Real,2>, libbirch::DefaultArray<birch::type::Real,2>>)
  #line 4 "src/expression/MatrixPack.birch"
  LIBBIRCH_MEMBERS()
};

template<class Right,class RightValue,class RightGradient>
#line 4 "src/expression/MatrixRankDowndate.birch"
class MatrixRankDowndate final : public MatrixBinaryExpression<libbirch::Lazy<libbirch::Shared<birch::type::Expression<birch::type::LLT>>>, Right, birch::type::LLT, RightValue, libbirch::DefaultArray<birch::type::Real,2>, RightGradient, birch::type::LLT> {
public:
  #line 4 "src/expression/MatrixRankDowndate.birch"
  using class_type_ = MatrixRankDowndate<Right, RightValue, RightGradient>;
  #line 4 "src/expression/MatrixRankDowndate.birch"
  using this_type_ = class_type_;
  #line 4 "src/expression/MatrixRankDowndate.birch"
  using super_type_ = MatrixBinaryExpression<libbirch::Lazy<libbirch::Shared<birch::type::Expression<birch::type::LLT>>>, Right, birch::type::LLT, RightValue, libbirch::DefaultArray<birch::type::Real,2>, RightGradient, birch::type::LLT>;

  #line 4 "src/expression/MatrixRankDowndate.birch"
  using super_type_::operator=;
  #line 4 "src/expression/MatrixRankDowndate.birch"
  using super_type_::doColumns;
  #line 4 "src/expression/MatrixRankDowndate.birch"
  using super_type_::doEvaluate;
  #line 4 "src/expression/MatrixRankDowndate.birch"
  using super_type_::doEvaluateGradLeft;
  #line 4 "src/expression/MatrixRankDowndate.birch"
  using super_type_::doEvaluateGradRight;
  #line 4 "src/expression/MatrixRankDowndate.birch"
  using super_type_::doRows;
  
  #line 4 "src/expression/MatrixRankDowndate.birch"
  MatrixRankDowndate(const libbirch::Lazy<libbirch::Shared<birch::type::Expression<birch::type::LLT>>>& y, const Right& z, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);

  #line 7 "src/expression/MatrixRankDowndate.birch"
  virtual birch::type::Integer doRows(const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr) override;
  #line 11 "src/expression/MatrixRankDowndate.birch"
  virtual birch::type::Integer doColumns(const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr) override;
  #line 15 "src/expression/MatrixRankDowndate.birch"
  virtual birch::type::LLT doEvaluate(const birch::type::LLT& y, const RightValue& z, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr) override;
  #line 19 "src/expression/MatrixRankDowndate.birch"
  virtual libbirch::DefaultArray<birch::type::Real,2> doEvaluateGradLeft(const libbirch::DefaultArray<birch::type::Real,2>& d, const birch::type::LLT& x, const birch::type::LLT& y, const RightValue& z, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr) override;
  #line 24 "src/expression/MatrixRankDowndate.birch"
  virtual RightGradient doEvaluateGradRight(const libbirch::DefaultArray<birch::type::Real,2>& d, const birch::type::LLT& x, const birch::type::LLT& y, const RightValue& z, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr) override;
  
  #line 4 "src/expression/MatrixRankDowndate.birch"
  LIBBIRCH_CLASS(MatrixRankDowndate, MatrixBinaryExpression<libbirch::Lazy<libbirch::Shared<birch::type::Expression<birch::type::LLT>>>, Right, birch::type::LLT, RightValue, libbirch::DefaultArray<birch::type::Real,2>, RightGradient, birch::type::LLT>)
  #line 4 "src/expression/MatrixRankDowndate.birch"
  LIBBIRCH_MEMBERS()
};

template<class Right,class RightValue,class RightGradient>
#line 4 "src/expression/MatrixRankUpdate.birch"
class MatrixRankUpdate final : public MatrixBinaryExpression<libbirch::Lazy<libbirch::Shared<birch::type::Expression<birch::type::LLT>>>, Right, birch::type::LLT, RightValue, libbirch::DefaultArray<birch::type::Real,2>, RightGradient, birch::type::LLT> {
public:
  #line 4 "src/expression/MatrixRankUpdate.birch"
  using class_type_ = MatrixRankUpdate<Right, RightValue, RightGradient>;
  #line 4 "src/expression/MatrixRankUpdate.birch"
  using this_type_ = class_type_;
  #line 4 "src/expression/MatrixRankUpdate.birch"
  using super_type_ = MatrixBinaryExpression<libbirch::Lazy<libbirch::Shared<birch::type::Expression<birch::type::LLT>>>, Right, birch::type::LLT, RightValue, libbirch::DefaultArray<birch::type::Real,2>, RightGradient, birch::type::LLT>;

  #line 4 "src/expression/MatrixRankUpdate.birch"
  using super_type_::operator=;
  #line 4 "src/expression/MatrixRankUpdate.birch"
  using super_type_::doColumns;
  #line 4 "src/expression/MatrixRankUpdate.birch"
  using super_type_::doEvaluate;
  #line 4 "src/expression/MatrixRankUpdate.birch"
  using super_type_::doEvaluateGradLeft;
  #line 4 "src/expression/MatrixRankUpdate.birch"
  using super_type_::doEvaluateGradRight;
  #line 4 "src/expression/MatrixRankUpdate.birch"
  using super_type_::doRows;
  
  #line 4 "src/expression/MatrixRankUpdate.birch"
  MatrixRankUpdate(const libbirch::Lazy<libbirch::Shared<birch::type::Expression<birch::type::LLT>>>& y, const Right& z, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);

  #line 7 "src/expression/MatrixRankUpdate.birch"
  virtual birch::type::Integer doRows(const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr) override;
  #line 11 "src/expression/MatrixRankUpdate.birch"
  virtual birch::type::Integer doColumns(const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr) override;
  #line 15 "src/expression/MatrixRankUpdate.birch"
  virtual birch::type::LLT doEvaluate(const birch::type::LLT& y, const RightValue& z, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr) override;
  #line 19 "src/expression/MatrixRankUpdate.birch"
  virtual libbirch::DefaultArray<birch::type::Real,2> doEvaluateGradLeft(const libbirch::DefaultArray<birch::type::Real,2>& d, const birch::type::LLT& x, const birch::type::LLT& y, const RightValue& z, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr) override;
  #line 24 "src/expression/MatrixRankUpdate.birch"
  virtual RightGradient doEvaluateGradRight(const libbirch::DefaultArray<birch::type::Real,2>& d, const birch::type::LLT& x, const birch::type::LLT& y, const RightValue& z, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr) override;
  
  #line 4 "src/expression/MatrixRankUpdate.birch"
  LIBBIRCH_CLASS(MatrixRankUpdate, MatrixBinaryExpression<libbirch::Lazy<libbirch::Shared<birch::type::Expression<birch::type::LLT>>>, Right, birch::type::LLT, RightValue, libbirch::DefaultArray<birch::type::Real,2>, RightGradient, birch::type::LLT>)
  #line 4 "src/expression/MatrixRankUpdate.birch"
  LIBBIRCH_MEMBERS()
};

#line 4 "src/expression/MatrixScalarMultiply.birch"
class MatrixScalarMultiply final : public MatrixBinaryExpression<libbirch::Lazy<libbirch::Shared<birch::type::Expression<birch::type::Real>>>, libbirch::Lazy<libbirch::Shared<birch::type::Expression<libbirch::DefaultArray<birch::type::Real,2>>>>, birch::type::Real, libbirch::DefaultArray<birch::type::Real,2>, birch::type::Real, libbirch::DefaultArray<birch::type::Real,2>, libbirch::DefaultArray<birch::type::Real,2>> {
public:
  #line 4 "src/expression/MatrixScalarMultiply.birch"
  using class_type_ = MatrixScalarMultiply;
  #line 4 "src/expression/MatrixScalarMultiply.birch"
  using this_type_ = class_type_;
  #line 4 "src/expression/MatrixScalarMultiply.birch"
  using super_type_ = MatrixBinaryExpression<libbirch::Lazy<libbirch::Shared<birch::type::Expression<birch::type::Real>>>, libbirch::Lazy<libbirch::Shared<birch::type::Expression<libbirch::DefaultArray<birch::type::Real,2>>>>, birch::type::Real, libbirch::DefaultArray<birch::type::Real,2>, birch::type::Real, libbirch::DefaultArray<birch::type::Real,2>, libbirch::DefaultArray<birch::type::Real,2>>;

  #line 4 "src/expression/MatrixScalarMultiply.birch"
  using super_type_::operator=;
  #line 4 "src/expression/MatrixScalarMultiply.birch"
  using super_type_::doColumns;
  #line 4 "src/expression/MatrixScalarMultiply.birch"
  using super_type_::doEvaluate;
  #line 4 "src/expression/MatrixScalarMultiply.birch"
  using super_type_::doEvaluateGradLeft;
  #line 4 "src/expression/MatrixScalarMultiply.birch"
  using super_type_::doEvaluateGradRight;
  #line 4 "src/expression/MatrixScalarMultiply.birch"
  using super_type_::doRows;
  #line 4 "src/expression/MatrixScalarMultiply.birch"
  using super_type_::graftLinearMatrixGaussian;
  #line 4 "src/expression/MatrixScalarMultiply.birch"
  using super_type_::graftLinearMatrixNormalInverseWishart;
  
  #line 4 "src/expression/MatrixScalarMultiply.birch"
  MatrixScalarMultiply(const libbirch::Lazy<libbirch::Shared<birch::type::Expression<birch::type::Real>>>& y, const libbirch::Lazy<libbirch::Shared<birch::type::Expression<libbirch::DefaultArray<birch::type::Real,2>>>>& z, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);

  #line 7 "src/expression/MatrixScalarMultiply.birch"
  virtual birch::type::Integer doRows(const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr) override;
  #line 11 "src/expression/MatrixScalarMultiply.birch"
  virtual birch::type::Integer doColumns(const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr) override;
  #line 15 "src/expression/MatrixScalarMultiply.birch"
  virtual libbirch::DefaultArray<birch::type::Real,2> doEvaluate(const birch::type::Real& y, const libbirch::DefaultArray<birch::type::Real,2>& z, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr) override;
  #line 19 "src/expression/MatrixScalarMultiply.birch"
  virtual birch::type::Real doEvaluateGradLeft(const libbirch::DefaultArray<birch::type::Real,2>& d, const libbirch::DefaultArray<birch::type::Real,2>& x, const birch::type::Real& y, const libbirch::DefaultArray<birch::type::Real,2>& z, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr) override;
  #line 24 "src/expression/MatrixScalarMultiply.birch"
  virtual libbirch::DefaultArray<birch::type::Real,2> doEvaluateGradRight(const libbirch::DefaultArray<birch::type::Real,2>& d, const libbirch::DefaultArray<birch::type::Real,2>& x, const birch::type::Real& y, const libbirch::DefaultArray<birch::type::Real,2>& z, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr) override;
  #line 29 "src/expression/MatrixScalarMultiply.birch"
  virtual libbirch::Optional<libbirch::Lazy<libbirch::Shared<birch::type::TransformLinearMatrix<libbirch::Lazy<libbirch::Shared<birch::type::MatrixGaussian>>>>>> graftLinearMatrixGaussian(const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr) override;
  #line 43 "src/expression/MatrixScalarMultiply.birch"
  virtual libbirch::Optional<libbirch::Lazy<libbirch::Shared<birch::type::TransformLinearMatrix<libbirch::Lazy<libbirch::Shared<birch::type::MatrixNormalInverseWishart>>>>>> graftLinearMatrixNormalInverseWishart(const libbirch::Lazy<libbirch::Shared<birch::type::Distribution<birch::type::LLT>>>& compare, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr) override;
  
  #line 4 "src/expression/MatrixScalarMultiply.birch"
  LIBBIRCH_CLASS(MatrixScalarMultiply, MatrixBinaryExpression<libbirch::Lazy<libbirch::Shared<birch::type::Expression<birch::type::Real>>>, libbirch::Lazy<libbirch::Shared<birch::type::Expression<libbirch::DefaultArray<birch::type::Real,2>>>>, birch::type::Real, libbirch::DefaultArray<birch::type::Real,2>, birch::type::Real, libbirch::DefaultArray<birch::type::Real,2>, libbirch::DefaultArray<birch::type::Real,2>>)
  #line 4 "src/expression/MatrixScalarMultiply.birch"
  LIBBIRCH_MEMBERS()
};

template<class Left,class LeftValue>
#line 4 "src/expression/MatrixSolve.birch"
class MatrixSolve final : public MatrixBinaryExpression<Left, libbirch::Lazy<libbirch::Shared<birch::type::Expression<libbirch::DefaultArray<birch::type::Real,2>>>>, LeftValue, libbirch::DefaultArray<birch::type::Real,2>, libbirch::DefaultArray<birch::type::Real,2>, libbirch::DefaultArray<birch::type::Real,2>, libbirch::DefaultArray<birch::type::Real,2>> {
public:
  #line 4 "src/expression/MatrixSolve.birch"
  using class_type_ = MatrixSolve<Left, LeftValue>;
  #line 4 "src/expression/MatrixSolve.birch"
  using this_type_ = class_type_;
  #line 4 "src/expression/MatrixSolve.birch"
  using super_type_ = MatrixBinaryExpression<Left, libbirch::Lazy<libbirch::Shared<birch::type::Expression<libbirch::DefaultArray<birch::type::Real,2>>>>, LeftValue, libbirch::DefaultArray<birch::type::Real,2>, libbirch::DefaultArray<birch::type::Real,2>, libbirch::DefaultArray<birch::type::Real,2>, libbirch::DefaultArray<birch::type::Real,2>>;

  #line 4 "src/expression/MatrixSolve.birch"
  using super_type_::operator=;
  #line 4 "src/expression/MatrixSolve.birch"
  using super_type_::doColumns;
  #line 4 "src/expression/MatrixSolve.birch"
  using super_type_::doEvaluate;
  #line 4 "src/expression/MatrixSolve.birch"
  using super_type_::doEvaluateGradLeft;
  #line 4 "src/expression/MatrixSolve.birch"
  using super_type_::doEvaluateGradRight;
  #line 4 "src/expression/MatrixSolve.birch"
  using super_type_::doRows;
  
  #line 4 "src/expression/MatrixSolve.birch"
  MatrixSolve(const Left& y, const libbirch::Lazy<libbirch::Shared<birch::type::Expression<libbirch::DefaultArray<birch::type::Real,2>>>>& z, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);

  #line 7 "src/expression/MatrixSolve.birch"
  virtual birch::type::Integer doRows(const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr) override;
  #line 11 "src/expression/MatrixSolve.birch"
  virtual birch::type::Integer doColumns(const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr) override;
  #line 15 "src/expression/MatrixSolve.birch"
  virtual libbirch::DefaultArray<birch::type::Real,2> doEvaluate(const LeftValue& y, const libbirch::DefaultArray<birch::type::Real,2>& z, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr) override;
  #line 19 "src/expression/MatrixSolve.birch"
  virtual libbirch::DefaultArray<birch::type::Real,2> doEvaluateGradLeft(const libbirch::DefaultArray<birch::type::Real,2>& d, const libbirch::DefaultArray<birch::type::Real,2>& x, const LeftValue& y, const libbirch::DefaultArray<birch::type::Real,2>& z, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr) override;
  #line 24 "src/expression/MatrixSolve.birch"
  virtual libbirch::DefaultArray<birch::type::Real,2> doEvaluateGradRight(const libbirch::DefaultArray<birch::type::Real,2>& d, const libbirch::DefaultArray<birch::type::Real,2>& x, const LeftValue& y, const libbirch::DefaultArray<birch::type::Real,2>& z, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr) override;
  
  #line 4 "src/expression/MatrixSolve.birch"
  LIBBIRCH_CLASS(MatrixSolve, MatrixBinaryExpression<Left, libbirch::Lazy<libbirch::Shared<birch::type::Expression<libbirch::DefaultArray<birch::type::Real,2>>>>, LeftValue, libbirch::DefaultArray<birch::type::Real,2>, libbirch::DefaultArray<birch::type::Real,2>, libbirch::DefaultArray<birch::type::Real,2>, libbirch::DefaultArray<birch::type::Real,2>>)
  #line 4 "src/expression/MatrixSolve.birch"
  LIBBIRCH_MEMBERS()
};

#line 4 "src/expression/MatrixStack.birch"
class MatrixStack final : public MatrixBinaryExpression<libbirch::Lazy<libbirch::Shared<birch::type::Expression<libbirch::DefaultArray<birch::type::Real,2>>>>, libbirch::Lazy<libbirch::Shared<birch::type::Expression<libbirch::DefaultArray<birch::type::Real,2>>>>, libbirch::DefaultArray<birch::type::Real,2>, libbirch::DefaultArray<birch::type::Real,2>, libbirch::DefaultArray<birch::type::Real,2>, libbirch::DefaultArray<birch::type::Real,2>, libbirch::DefaultArray<birch::type::Real,2>> {
public:
  #line 4 "src/expression/MatrixStack.birch"
  using class_type_ = MatrixStack;
  #line 4 "src/expression/MatrixStack.birch"
  using this_type_ = class_type_;
  #line 4 "src/expression/MatrixStack.birch"
  using super_type_ = MatrixBinaryExpression<libbirch::Lazy<libbirch::Shared<birch::type::Expression<libbirch::DefaultArray<birch::type::Real,2>>>>, libbirch::Lazy<libbirch::Shared<birch::type::Expression<libbirch::DefaultArray<birch::type::Real,2>>>>, libbirch::DefaultArray<birch::type::Real,2>, libbirch::DefaultArray<birch::type::Real,2>, libbirch::DefaultArray<birch::type::Real,2>, libbirch::DefaultArray<birch::type::Real,2>, libbirch::DefaultArray<birch::type::Real,2>>;

  #line 4 "src/expression/MatrixStack.birch"
  using super_type_::operator=;
  #line 4 "src/expression/MatrixStack.birch"
  using super_type_::doColumns;
  #line 4 "src/expression/MatrixStack.birch"
  using super_type_::doEvaluate;
  #line 4 "src/expression/MatrixStack.birch"
  using super_type_::doEvaluateGradLeft;
  #line 4 "src/expression/MatrixStack.birch"
  using super_type_::doEvaluateGradRight;
  #line 4 "src/expression/MatrixStack.birch"
  using super_type_::doRows;
  
  #line 4 "src/expression/MatrixStack.birch"
  MatrixStack(const libbirch::Lazy<libbirch::Shared<birch::type::Expression<libbirch::DefaultArray<birch::type::Real,2>>>>& y, const libbirch::Lazy<libbirch::Shared<birch::type::Expression<libbirch::DefaultArray<birch::type::Real,2>>>>& z, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);

  #line 7 "src/expression/MatrixStack.birch"
  virtual birch::type::Integer doRows(const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr) override;
  #line 11 "src/expression/MatrixStack.birch"
  virtual birch::type::Integer doColumns(const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr) override;
  #line 16 "src/expression/MatrixStack.birch"
  virtual libbirch::DefaultArray<birch::type::Real,2> doEvaluate(const libbirch::DefaultArray<birch::type::Real,2>& y, const libbirch::DefaultArray<birch::type::Real,2>& z, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr) override;
  #line 20 "src/expression/MatrixStack.birch"
  virtual libbirch::DefaultArray<birch::type::Real,2> doEvaluateGradLeft(const libbirch::DefaultArray<birch::type::Real,2>& d, const libbirch::DefaultArray<birch::type::Real,2>& x, const libbirch::DefaultArray<birch::type::Real,2>& y, const libbirch::DefaultArray<birch::type::Real,2>& z, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr) override;
  #line 25 "src/expression/MatrixStack.birch"
  virtual libbirch::DefaultArray<birch::type::Real,2> doEvaluateGradRight(const libbirch::DefaultArray<birch::type::Real,2>& d, const libbirch::DefaultArray<birch::type::Real,2>& x, const libbirch::DefaultArray<birch::type::Real,2>& y, const libbirch::DefaultArray<birch::type::Real,2>& z, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr) override;
  
  #line 4 "src/expression/MatrixStack.birch"
  LIBBIRCH_CLASS(MatrixStack, MatrixBinaryExpression<libbirch::Lazy<libbirch::Shared<birch::type::Expression<libbirch::DefaultArray<birch::type::Real,2>>>>, libbirch::Lazy<libbirch::Shared<birch::type::Expression<libbirch::DefaultArray<birch::type::Real,2>>>>, libbirch::DefaultArray<birch::type::Real,2>, libbirch::DefaultArray<birch::type::Real,2>, libbirch::DefaultArray<birch::type::Real,2>, libbirch::DefaultArray<birch::type::Real,2>, libbirch::DefaultArray<birch::type::Real,2>>)
  #line 4 "src/expression/MatrixStack.birch"
  LIBBIRCH_MEMBERS()
};

#line 4 "src/expression/MatrixSubtract.birch"
class MatrixSubtract final : public MatrixBinaryExpression<libbirch::Lazy<libbirch::Shared<birch::type::Expression<libbirch::DefaultArray<birch::type::Real,2>>>>, libbirch::Lazy<libbirch::Shared<birch::type::Expression<libbirch::DefaultArray<birch::type::Real,2>>>>, libbirch::DefaultArray<birch::type::Real,2>, libbirch::DefaultArray<birch::type::Real,2>, libbirch::DefaultArray<birch::type::Real,2>, libbirch::DefaultArray<birch::type::Real,2>, libbirch::DefaultArray<birch::type::Real,2>> {
public:
  #line 4 "src/expression/MatrixSubtract.birch"
  using class_type_ = MatrixSubtract;
  #line 4 "src/expression/MatrixSubtract.birch"
  using this_type_ = class_type_;
  #line 4 "src/expression/MatrixSubtract.birch"
  using super_type_ = MatrixBinaryExpression<libbirch::Lazy<libbirch::Shared<birch::type::Expression<libbirch::DefaultArray<birch::type::Real,2>>>>, libbirch::Lazy<libbirch::Shared<birch::type::Expression<libbirch::DefaultArray<birch::type::Real,2>>>>, libbirch::DefaultArray<birch::type::Real,2>, libbirch::DefaultArray<birch::type::Real,2>, libbirch::DefaultArray<birch::type::Real,2>, libbirch::DefaultArray<birch::type::Real,2>, libbirch::DefaultArray<birch::type::Real,2>>;

  #line 4 "src/expression/MatrixSubtract.birch"
  using super_type_::operator=;
  #line 4 "src/expression/MatrixSubtract.birch"
  using super_type_::doColumns;
  #line 4 "src/expression/MatrixSubtract.birch"
  using super_type_::doEvaluate;
  #line 4 "src/expression/MatrixSubtract.birch"
  using super_type_::doEvaluateGradLeft;
  #line 4 "src/expression/MatrixSubtract.birch"
  using super_type_::doEvaluateGradRight;
  #line 4 "src/expression/MatrixSubtract.birch"
  using super_type_::doRows;
  #line 4 "src/expression/MatrixSubtract.birch"
  using super_type_::graftLinearMatrixGaussian;
  #line 4 "src/expression/MatrixSubtract.birch"
  using super_type_::graftLinearMatrixNormalInverseWishart;
  
  #line 4 "src/expression/MatrixSubtract.birch"
  MatrixSubtract(const libbirch::Lazy<libbirch::Shared<birch::type::Expression<libbirch::DefaultArray<birch::type::Real,2>>>>& y, const libbirch::Lazy<libbirch::Shared<birch::type::Expression<libbirch::DefaultArray<birch::type::Real,2>>>>& z, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);

  #line 8 "src/expression/MatrixSubtract.birch"
  virtual birch::type::Integer doRows(const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr) override;
  #line 12 "src/expression/MatrixSubtract.birch"
  virtual birch::type::Integer doColumns(const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr) override;
  #line 16 "src/expression/MatrixSubtract.birch"
  virtual libbirch::DefaultArray<birch::type::Real,2> doEvaluate(const libbirch::DefaultArray<birch::type::Real,2>& y, const libbirch::DefaultArray<birch::type::Real,2>& z, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr) override;
  #line 20 "src/expression/MatrixSubtract.birch"
  virtual libbirch::DefaultArray<birch::type::Real,2> doEvaluateGradLeft(const libbirch::DefaultArray<birch::type::Real,2>& d, const libbirch::DefaultArray<birch::type::Real,2>& x, const libbirch::DefaultArray<birch::type::Real,2>& y, const libbirch::DefaultArray<birch::type::Real,2>& z, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr) override;
  #line 25 "src/expression/MatrixSubtract.birch"
  virtual libbirch::DefaultArray<birch::type::Real,2> doEvaluateGradRight(const libbirch::DefaultArray<birch::type::Real,2>& d, const libbirch::DefaultArray<birch::type::Real,2>& x, const libbirch::DefaultArray<birch::type::Real,2>& y, const libbirch::DefaultArray<birch::type::Real,2>& z, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr) override;
  #line 30 "src/expression/MatrixSubtract.birch"
  virtual libbirch::Optional<libbirch::Lazy<libbirch::Shared<birch::type::TransformLinearMatrix<libbirch::Lazy<libbirch::Shared<birch::type::MatrixGaussian>>>>>> graftLinearMatrixGaussian(const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr) override;
  #line 49 "src/expression/MatrixSubtract.birch"
  virtual libbirch::Optional<libbirch::Lazy<libbirch::Shared<birch::type::TransformLinearMatrix<libbirch::Lazy<libbirch::Shared<birch::type::MatrixNormalInverseWishart>>>>>> graftLinearMatrixNormalInverseWishart(const libbirch::Lazy<libbirch::Shared<birch::type::Distribution<birch::type::LLT>>>& compare, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr) override;
  
  #line 4 "src/expression/MatrixSubtract.birch"
  LIBBIRCH_CLASS(MatrixSubtract, MatrixBinaryExpression<libbirch::Lazy<libbirch::Shared<birch::type::Expression<libbirch::DefaultArray<birch::type::Real,2>>>>, libbirch::Lazy<libbirch::Shared<birch::type::Expression<libbirch::DefaultArray<birch::type::Real,2>>>>, libbirch::DefaultArray<birch::type::Real,2>, libbirch::DefaultArray<birch::type::Real,2>, libbirch::DefaultArray<birch::type::Real,2>, libbirch::DefaultArray<birch::type::Real,2>, libbirch::DefaultArray<birch::type::Real,2>>)
  #line 4 "src/expression/MatrixSubtract.birch"
  LIBBIRCH_MEMBERS()
};

#line 4 "src/expression/Outer.birch"
class Outer final : public MatrixBinaryExpression<libbirch::Lazy<libbirch::Shared<birch::type::Expression<libbirch::DefaultArray<birch::type::Real,1>>>>, libbirch::Lazy<libbirch::Shared<birch::type::Expression<libbirch::DefaultArray<birch::type::Real,1>>>>, libbirch::DefaultArray<birch::type::Real,1>, libbirch::DefaultArray<birch::type::Real,1>, libbirch::DefaultArray<birch::type::Real,1>, libbirch::DefaultArray<birch::type::Real,1>, libbirch::DefaultArray<birch::type::Real,2>> {
public:
  #line 4 "src/expression/Outer.birch"
  using class_type_ = Outer;
  #line 4 "src/expression/Outer.birch"
  using this_type_ = class_type_;
  #line 4 "src/expression/Outer.birch"
  using super_type_ = MatrixBinaryExpression<libbirch::Lazy<libbirch::Shared<birch::type::Expression<libbirch::DefaultArray<birch::type::Real,1>>>>, libbirch::Lazy<libbirch::Shared<birch::type::Expression<libbirch::DefaultArray<birch::type::Real,1>>>>, libbirch::DefaultArray<birch::type::Real,1>, libbirch::DefaultArray<birch::type::Real,1>, libbirch::DefaultArray<birch::type::Real,1>, libbirch::DefaultArray<birch::type::Real,1>, libbirch::DefaultArray<birch::type::Real,2>>;

  #line 4 "src/expression/Outer.birch"
  using super_type_::operator=;
  #line 4 "src/expression/Outer.birch"
  using super_type_::doColumns;
  #line 4 "src/expression/Outer.birch"
  using super_type_::doEvaluate;
  #line 4 "src/expression/Outer.birch"
  using super_type_::doEvaluateGradLeft;
  #line 4 "src/expression/Outer.birch"
  using super_type_::doEvaluateGradRight;
  #line 4 "src/expression/Outer.birch"
  using super_type_::doRows;
  
  #line 4 "src/expression/Outer.birch"
  Outer(const libbirch::Lazy<libbirch::Shared<birch::type::Expression<libbirch::DefaultArray<birch::type::Real,1>>>>& y, const libbirch::Lazy<libbirch::Shared<birch::type::Expression<libbirch::DefaultArray<birch::type::Real,1>>>>& z, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);

  #line 7 "src/expression/Outer.birch"
  virtual birch::type::Integer doRows(const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr) override;
  #line 11 "src/expression/Outer.birch"
  virtual birch::type::Integer doColumns(const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr) override;
  #line 15 "src/expression/Outer.birch"
  virtual libbirch::DefaultArray<birch::type::Real,2> doEvaluate(const libbirch::DefaultArray<birch::type::Real,1>& y, const libbirch::DefaultArray<birch::type::Real,1>& z, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr) override;
  #line 19 "src/expression/Outer.birch"
  virtual libbirch::DefaultArray<birch::type::Real,1> doEvaluateGradLeft(const libbirch::DefaultArray<birch::type::Real,2>& d, const libbirch::DefaultArray<birch::type::Real,2>& x, const libbirch::DefaultArray<birch::type::Real,1>& y, const libbirch::DefaultArray<birch::type::Real,1>& z, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr) override;
  #line 24 "src/expression/Outer.birch"
  virtual libbirch::DefaultArray<birch::type::Real,1> doEvaluateGradRight(const libbirch::DefaultArray<birch::type::Real,2>& d, const libbirch::DefaultArray<birch::type::Real,2>& x, const libbirch::DefaultArray<birch::type::Real,1>& y, const libbirch::DefaultArray<birch::type::Real,1>& z, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr) override;
  
  #line 4 "src/expression/Outer.birch"
  LIBBIRCH_CLASS(Outer, MatrixBinaryExpression<libbirch::Lazy<libbirch::Shared<birch::type::Expression<libbirch::DefaultArray<birch::type::Real,1>>>>, libbirch::Lazy<libbirch::Shared<birch::type::Expression<libbirch::DefaultArray<birch::type::Real,1>>>>, libbirch::DefaultArray<birch::type::Real,1>, libbirch::DefaultArray<birch::type::Real,1>, libbirch::DefaultArray<birch::type::Real,1>, libbirch::DefaultArray<birch::type::Real,1>, libbirch::DefaultArray<birch::type::Real,2>>)
  #line 4 "src/expression/Outer.birch"
  LIBBIRCH_MEMBERS()
};

template<class Value>
#line 4 "src/expression/MatrixJoin.birch"
class MatrixJoin final : public MatrixExpression<libbirch::DefaultArray<Value,2>> {
public:
  #line 4 "src/expression/MatrixJoin.birch"
  using class_type_ = MatrixJoin<Value>;
  #line 4 "src/expression/MatrixJoin.birch"
  using this_type_ = class_type_;
  #line 4 "src/expression/MatrixJoin.birch"
  using super_type_ = MatrixExpression<libbirch::DefaultArray<Value,2>>;

  #line 4 "src/expression/MatrixJoin.birch"
  using super_type_::operator=;
  #line 4 "src/expression/MatrixJoin.birch"
  using super_type_::doColumns;
  #line 4 "src/expression/MatrixJoin.birch"
  using super_type_::doCompare;
  #line 4 "src/expression/MatrixJoin.birch"
  using super_type_::doConstant;
  #line 4 "src/expression/MatrixJoin.birch"
  using super_type_::doCount;
  #line 4 "src/expression/MatrixJoin.birch"
  using super_type_::doDepth;
  #line 4 "src/expression/MatrixJoin.birch"
  using super_type_::doDetach;
  #line 4 "src/expression/MatrixJoin.birch"
  using super_type_::doGet;
  #line 4 "src/expression/MatrixJoin.birch"
  using super_type_::doGrad;
  #line 4 "src/expression/MatrixJoin.birch"
  using super_type_::doMove;
  #line 4 "src/expression/MatrixJoin.birch"
  using super_type_::doPilot;
  #line 4 "src/expression/MatrixJoin.birch"
  using super_type_::doPrior;
  #line 4 "src/expression/MatrixJoin.birch"
  using super_type_::doRows;
  #line 4 "src/expression/MatrixJoin.birch"
  using super_type_::doValue;
  
  #line 4 "src/expression/MatrixJoin.birch"
  MatrixJoin(const libbirch::DefaultArray<libbirch::Lazy<libbirch::Shared<birch::type::Expression<Value>>>,2>& y, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);

  libbirch::Optional<libbirch::DefaultArray<libbirch::Lazy<libbirch::Shared<birch::type::Expression<Value>>>,2>> y;
  #line 11 "src/expression/MatrixJoin.birch"
  virtual birch::type::Integer doDepth(const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr) override;
  #line 21 "src/expression/MatrixJoin.birch"
  virtual birch::type::Integer doRows(const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr) override;
  #line 25 "src/expression/MatrixJoin.birch"
  virtual birch::type::Integer doColumns(const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr) override;
  #line 29 "src/expression/MatrixJoin.birch"
  virtual libbirch::DefaultArray<Value,2> doValue(const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr) override;
  #line 35 "src/expression/MatrixJoin.birch"
  virtual libbirch::DefaultArray<Value,2> doPilot(const birch::type::Integer& gen, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr) override;
  #line 41 "src/expression/MatrixJoin.birch"
  virtual libbirch::DefaultArray<Value,2> doGet(const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr) override;
  #line 47 "src/expression/MatrixJoin.birch"
  virtual libbirch::DefaultArray<Value,2> doMove(const birch::type::Integer& gen, const libbirch::Lazy<libbirch::Shared<birch::type::Kernel>>& _u0954, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr) override;
  #line 53 "src/expression/MatrixJoin.birch"
  virtual void doGrad(const birch::type::Integer& gen, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr) override;
  #line 57 "src/expression/MatrixJoin.birch"
  virtual libbirch::Optional<libbirch::Lazy<libbirch::Shared<birch::type::Expression<birch::type::Real>>>> doPrior(const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr) override;
  #line 76 "src/expression/MatrixJoin.birch"
  virtual birch::type::Real doCompare(const birch::type::Integer& gen, const libbirch::Lazy<libbirch::Shared<birch::type::DelayExpression>>& x, const libbirch::Lazy<libbirch::Shared<birch::type::Kernel>>& _u0954, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr) override;
  #line 93 "src/expression/MatrixJoin.birch"
  virtual void doCount(const birch::type::Integer& gen, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr) override;
  #line 97 "src/expression/MatrixJoin.birch"
  virtual void doConstant(const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr) override;
  #line 101 "src/expression/MatrixJoin.birch"
  virtual void doDetach(const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr) override;
  
  #line 4 "src/expression/MatrixJoin.birch"
  LIBBIRCH_CLASS(MatrixJoin, MatrixExpression<libbirch::DefaultArray<Value,2>>)
  #line 4 "src/expression/MatrixJoin.birch"
  LIBBIRCH_MEMBERS(y)
};

template<class Argument,class ArgumentValue,class ArgumentGradient,class Value>
#line 12 "src/expression/MatrixUnaryExpression.birch"
class MatrixUnaryExpression : public MatrixExpression<Value> {
public:
  #line 12 "src/expression/MatrixUnaryExpression.birch"
  using class_type_ = MatrixUnaryExpression<Argument, ArgumentValue, ArgumentGradient, Value>;
  #line 12 "src/expression/MatrixUnaryExpression.birch"
  using this_type_ = class_type_;
  #line 12 "src/expression/MatrixUnaryExpression.birch"
  using super_type_ = MatrixExpression<Value>;

  #line 12 "src/expression/MatrixUnaryExpression.birch"
  using super_type_::operator=;
  #line 12 "src/expression/MatrixUnaryExpression.birch"
  using super_type_::doCompare;
  #line 12 "src/expression/MatrixUnaryExpression.birch"
  using super_type_::doConstant;
  #line 12 "src/expression/MatrixUnaryExpression.birch"
  using super_type_::doCount;
  #line 12 "src/expression/MatrixUnaryExpression.birch"
  using super_type_::doDepth;
  #line 12 "src/expression/MatrixUnaryExpression.birch"
  using super_type_::doDetach;
  #line 12 "src/expression/MatrixUnaryExpression.birch"
  using super_type_::doGet;
  #line 12 "src/expression/MatrixUnaryExpression.birch"
  using super_type_::doGrad;
  #line 12 "src/expression/MatrixUnaryExpression.birch"
  using super_type_::doMove;
  #line 12 "src/expression/MatrixUnaryExpression.birch"
  using super_type_::doPilot;
  #line 12 "src/expression/MatrixUnaryExpression.birch"
  using super_type_::doPrior;
  #line 12 "src/expression/MatrixUnaryExpression.birch"
  using super_type_::doValue;
  
  #line 12 "src/expression/MatrixUnaryExpression.birch"
  MatrixUnaryExpression(const Argument& y, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);

  libbirch::Optional<Argument> y;
  #line 22 "src/expression/MatrixUnaryExpression.birch"
  virtual Value doEvaluate(const ArgumentValue& y, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr) = 0;
  #line 27 "src/expression/MatrixUnaryExpression.birch"
  virtual ArgumentGradient doEvaluateGrad(const libbirch::DefaultArray<birch::type::Real,2>& d, const Value& x, const ArgumentValue& y, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr) = 0;
  #line 30 "src/expression/MatrixUnaryExpression.birch"
  virtual birch::type::Integer doDepth(const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr) final;
  #line 34 "src/expression/MatrixUnaryExpression.birch"
  virtual Value doValue(const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr) final;
  #line 38 "src/expression/MatrixUnaryExpression.birch"
  virtual Value doPilot(const birch::type::Integer& gen, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr) final;
  #line 42 "src/expression/MatrixUnaryExpression.birch"
  virtual Value doGet(const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr) final;
  #line 46 "src/expression/MatrixUnaryExpression.birch"
  virtual Value doMove(const birch::type::Integer& gen, const libbirch::Lazy<libbirch::Shared<birch::type::Kernel>>& _u0954, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr) final;
  #line 50 "src/expression/MatrixUnaryExpression.birch"
  virtual void doGrad(const birch::type::Integer& gen, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr) final;
  #line 54 "src/expression/MatrixUnaryExpression.birch"
  virtual libbirch::Optional<libbirch::Lazy<libbirch::Shared<birch::type::Expression<birch::type::Real>>>> doPrior(const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr) final;
  #line 58 "src/expression/MatrixUnaryExpression.birch"
  virtual birch::type::Real doCompare(const birch::type::Integer& gen, const libbirch::Lazy<libbirch::Shared<birch::type::DelayExpression>>& x, const libbirch::Lazy<libbirch::Shared<birch::type::Kernel>>& _u0954, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr) final;
  #line 65 "src/expression/MatrixUnaryExpression.birch"
  virtual void doConstant(const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr) final;
  #line 69 "src/expression/MatrixUnaryExpression.birch"
  virtual void doCount(const birch::type::Integer& gen, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr) final;
  #line 73 "src/expression/MatrixUnaryExpression.birch"
  virtual void doDetach(const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr) final;
  
  #line 12 "src/expression/MatrixUnaryExpression.birch"
  LIBBIRCH_ABSTRACT_CLASS(MatrixUnaryExpression, MatrixExpression<Value>)
  #line 12 "src/expression/MatrixUnaryExpression.birch"
  LIBBIRCH_MEMBERS(y)
};

#line 4 "src/expression/MatrixTranspose.birch"
class MatrixTranspose final : public MatrixUnaryExpression<libbirch::Lazy<libbirch::Shared<birch::type::Expression<libbirch::DefaultArray<birch::type::Real,2>>>>, libbirch::DefaultArray<birch::type::Real,2>, libbirch::DefaultArray<birch::type::Real,2>, libbirch::DefaultArray<birch::type::Real,2>> {
public:
  #line 4 "src/expression/MatrixTranspose.birch"
  using class_type_ = MatrixTranspose;
  #line 4 "src/expression/MatrixTranspose.birch"
  using this_type_ = class_type_;
  #line 4 "src/expression/MatrixTranspose.birch"
  using super_type_ = MatrixUnaryExpression<libbirch::Lazy<libbirch::Shared<birch::type::Expression<libbirch::DefaultArray<birch::type::Real,2>>>>, libbirch::DefaultArray<birch::type::Real,2>, libbirch::DefaultArray<birch::type::Real,2>, libbirch::DefaultArray<birch::type::Real,2>>;

  #line 4 "src/expression/MatrixTranspose.birch"
  using super_type_::operator=;
  #line 4 "src/expression/MatrixTranspose.birch"
  using super_type_::doColumns;
  #line 4 "src/expression/MatrixTranspose.birch"
  using super_type_::doEvaluate;
  #line 4 "src/expression/MatrixTranspose.birch"
  using super_type_::doEvaluateGrad;
  #line 4 "src/expression/MatrixTranspose.birch"
  using super_type_::doRows;
  
  #line 4 "src/expression/MatrixTranspose.birch"
  MatrixTranspose(const libbirch::Lazy<libbirch::Shared<birch::type::Expression<libbirch::DefaultArray<birch::type::Real,2>>>>& x, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);

  #line 7 "src/expression/MatrixTranspose.birch"
  virtual birch::type::Integer doRows(const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr) override;
  #line 11 "src/expression/MatrixTranspose.birch"
  virtual birch::type::Integer doColumns(const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr) override;
  #line 15 "src/expression/MatrixTranspose.birch"
  virtual libbirch::DefaultArray<birch::type::Real,2> doEvaluate(const libbirch::DefaultArray<birch::type::Real,2>& y, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr) override;
  #line 19 "src/expression/MatrixTranspose.birch"
  virtual libbirch::DefaultArray<birch::type::Real,2> doEvaluateGrad(const libbirch::DefaultArray<birch::type::Real,2>& d, const libbirch::DefaultArray<birch::type::Real,2>& x, const libbirch::DefaultArray<birch::type::Real,2>& y, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr) override;
  
  #line 4 "src/expression/MatrixTranspose.birch"
  LIBBIRCH_CLASS(MatrixTranspose, MatrixUnaryExpression<libbirch::Lazy<libbirch::Shared<birch::type::Expression<libbirch::DefaultArray<birch::type::Real,2>>>>, libbirch::DefaultArray<birch::type::Real,2>, libbirch::DefaultArray<birch::type::Real,2>, libbirch::DefaultArray<birch::type::Real,2>>)
  #line 4 "src/expression/MatrixTranspose.birch"
  LIBBIRCH_MEMBERS()
};

#line 4 "src/expression/MatrixRectify.birch"
class MatrixRectify final : public MatrixUnaryExpression<libbirch::Lazy<libbirch::Shared<birch::type::Expression<libbirch::DefaultArray<birch::type::Real,2>>>>, libbirch::DefaultArray<birch::type::Real,2>, libbirch::DefaultArray<birch::type::Real,2>, libbirch::DefaultArray<birch::type::Real,2>> {
public:
  #line 4 "src/expression/MatrixRectify.birch"
  using class_type_ = MatrixRectify;
  #line 4 "src/expression/MatrixRectify.birch"
  using this_type_ = class_type_;
  #line 4 "src/expression/MatrixRectify.birch"
  using super_type_ = MatrixUnaryExpression<libbirch::Lazy<libbirch::Shared<birch::type::Expression<libbirch::DefaultArray<birch::type::Real,2>>>>, libbirch::DefaultArray<birch::type::Real,2>, libbirch::DefaultArray<birch::type::Real,2>, libbirch::DefaultArray<birch::type::Real,2>>;

  #line 4 "src/expression/MatrixRectify.birch"
  using super_type_::operator=;
  #line 4 "src/expression/MatrixRectify.birch"
  using super_type_::doColumns;
  #line 4 "src/expression/MatrixRectify.birch"
  using super_type_::doEvaluate;
  #line 4 "src/expression/MatrixRectify.birch"
  using super_type_::doEvaluateGrad;
  #line 4 "src/expression/MatrixRectify.birch"
  using super_type_::doRows;
  
  #line 4 "src/expression/MatrixRectify.birch"
  MatrixRectify(const libbirch::Lazy<libbirch::Shared<birch::type::Expression<libbirch::DefaultArray<birch::type::Real,2>>>>& y, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);

  #line 7 "src/expression/MatrixRectify.birch"
  virtual birch::type::Integer doRows(const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr) override;
  #line 11 "src/expression/MatrixRectify.birch"
  virtual birch::type::Integer doColumns(const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr) override;
  #line 15 "src/expression/MatrixRectify.birch"
  virtual libbirch::DefaultArray<birch::type::Real,2> doEvaluate(const libbirch::DefaultArray<birch::type::Real,2>& y, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr) override;
  #line 19 "src/expression/MatrixRectify.birch"
  virtual libbirch::DefaultArray<birch::type::Real,2> doEvaluateGrad(const libbirch::DefaultArray<birch::type::Real,2>& d, const libbirch::DefaultArray<birch::type::Real,2>& x, const libbirch::DefaultArray<birch::type::Real,2>& y, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr) override;
  
  #line 4 "src/expression/MatrixRectify.birch"
  LIBBIRCH_CLASS(MatrixRectify, MatrixUnaryExpression<libbirch::Lazy<libbirch::Shared<birch::type::Expression<libbirch::DefaultArray<birch::type::Real,2>>>>, libbirch::DefaultArray<birch::type::Real,2>, libbirch::DefaultArray<birch::type::Real,2>, libbirch::DefaultArray<birch::type::Real,2>>)
  #line 4 "src/expression/MatrixRectify.birch"
  LIBBIRCH_MEMBERS()
};

#line 4 "src/expression/MatrixNegate.birch"
class MatrixNegate final : public MatrixUnaryExpression<libbirch::Lazy<libbirch::Shared<birch::type::Expression<libbirch::DefaultArray<birch::type::Real,2>>>>, libbirch::DefaultArray<birch::type::Real,2>, libbirch::DefaultArray<birch::type::Real,2>, libbirch::DefaultArray<birch::type::Real,2>> {
public:
  #line 4 "src/expression/MatrixNegate.birch"
  using class_type_ = MatrixNegate;
  #line 4 "src/expression/MatrixNegate.birch"
  using this_type_ = class_type_;
  #line 4 "src/expression/MatrixNegate.birch"
  using super_type_ = MatrixUnaryExpression<libbirch::Lazy<libbirch::Shared<birch::type::Expression<libbirch::DefaultArray<birch::type::Real,2>>>>, libbirch::DefaultArray<birch::type::Real,2>, libbirch::DefaultArray<birch::type::Real,2>, libbirch::DefaultArray<birch::type::Real,2>>;

  #line 4 "src/expression/MatrixNegate.birch"
  using super_type_::operator=;
  #line 4 "src/expression/MatrixNegate.birch"
  using super_type_::doColumns;
  #line 4 "src/expression/MatrixNegate.birch"
  using super_type_::doEvaluate;
  #line 4 "src/expression/MatrixNegate.birch"
  using super_type_::doEvaluateGrad;
  #line 4 "src/expression/MatrixNegate.birch"
  using super_type_::doRows;
  #line 4 "src/expression/MatrixNegate.birch"
  using super_type_::graftLinearMatrixGaussian;
  #line 4 "src/expression/MatrixNegate.birch"
  using super_type_::graftLinearMatrixNormalInverseWishart;
  
  #line 4 "src/expression/MatrixNegate.birch"
  MatrixNegate(const libbirch::Lazy<libbirch::Shared<birch::type::Expression<libbirch::DefaultArray<birch::type::Real,2>>>>& y, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);

  #line 7 "src/expression/MatrixNegate.birch"
  virtual birch::type::Integer doRows(const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr) override;
  #line 11 "src/expression/MatrixNegate.birch"
  virtual birch::type::Integer doColumns(const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr) override;
  #line 15 "src/expression/MatrixNegate.birch"
  virtual libbirch::DefaultArray<birch::type::Real,2> doEvaluate(const libbirch::DefaultArray<birch::type::Real,2>& y, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr) override;
  #line 19 "src/expression/MatrixNegate.birch"
  virtual libbirch::DefaultArray<birch::type::Real,2> doEvaluateGrad(const libbirch::DefaultArray<birch::type::Real,2>& d, const libbirch::DefaultArray<birch::type::Real,2>& x, const libbirch::DefaultArray<birch::type::Real,2>& y, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr) override;
  #line 24 "src/expression/MatrixNegate.birch"
  virtual libbirch::Optional<libbirch::Lazy<libbirch::Shared<birch::type::TransformLinearMatrix<libbirch::Lazy<libbirch::Shared<birch::type::MatrixGaussian>>>>>> graftLinearMatrixGaussian(const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr) override;
  #line 42 "src/expression/MatrixNegate.birch"
  virtual libbirch::Optional<libbirch::Lazy<libbirch::Shared<birch::type::TransformLinearMatrix<libbirch::Lazy<libbirch::Shared<birch::type::MatrixNormalInverseWishart>>>>>> graftLinearMatrixNormalInverseWishart(const libbirch::Lazy<libbirch::Shared<birch::type::Distribution<birch::type::LLT>>>& compare, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr) override;
  
  #line 4 "src/expression/MatrixNegate.birch"
  LIBBIRCH_CLASS(MatrixNegate, MatrixUnaryExpression<libbirch::Lazy<libbirch::Shared<birch::type::Expression<libbirch::DefaultArray<birch::type::Real,2>>>>, libbirch::DefaultArray<birch::type::Real,2>, libbirch::DefaultArray<birch::type::Real,2>, libbirch::DefaultArray<birch::type::Real,2>>)
  #line 4 "src/expression/MatrixNegate.birch"
  LIBBIRCH_MEMBERS()
};

#line 4 "src/expression/MatrixLLT.birch"
class MatrixLLT final : public MatrixUnaryExpression<libbirch::Lazy<libbirch::Shared<birch::type::Expression<libbirch::DefaultArray<birch::type::Real,2>>>>, libbirch::DefaultArray<birch::type::Real,2>, libbirch::DefaultArray<birch::type::Real,2>, birch::type::LLT> {
public:
  #line 4 "src/expression/MatrixLLT.birch"
  using class_type_ = MatrixLLT;
  #line 4 "src/expression/MatrixLLT.birch"
  using this_type_ = class_type_;
  #line 4 "src/expression/MatrixLLT.birch"
  using super_type_ = MatrixUnaryExpression<libbirch::Lazy<libbirch::Shared<birch::type::Expression<libbirch::DefaultArray<birch::type::Real,2>>>>, libbirch::DefaultArray<birch::type::Real,2>, libbirch::DefaultArray<birch::type::Real,2>, birch::type::LLT>;

  #line 4 "src/expression/MatrixLLT.birch"
  using super_type_::operator=;
  #line 4 "src/expression/MatrixLLT.birch"
  using super_type_::doColumns;
  #line 4 "src/expression/MatrixLLT.birch"
  using super_type_::doEvaluate;
  #line 4 "src/expression/MatrixLLT.birch"
  using super_type_::doEvaluateGrad;
  #line 4 "src/expression/MatrixLLT.birch"
  using super_type_::doRows;
  
  #line 4 "src/expression/MatrixLLT.birch"
  MatrixLLT(const libbirch::Lazy<libbirch::Shared<birch::type::Expression<libbirch::DefaultArray<birch::type::Real,2>>>>& y, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);

  #line 6 "src/expression/MatrixLLT.birch"
  virtual birch::type::Integer doRows(const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr) override;
  #line 10 "src/expression/MatrixLLT.birch"
  virtual birch::type::Integer doColumns(const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr) override;
  #line 14 "src/expression/MatrixLLT.birch"
  virtual birch::type::LLT doEvaluate(const libbirch::DefaultArray<birch::type::Real,2>& y, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr) override;
  #line 18 "src/expression/MatrixLLT.birch"
  virtual libbirch::DefaultArray<birch::type::Real,2> doEvaluateGrad(const libbirch::DefaultArray<birch::type::Real,2>& d, const birch::type::LLT& x, const libbirch::DefaultArray<birch::type::Real,2>& y, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr) override;
  
  #line 4 "src/expression/MatrixLLT.birch"
  LIBBIRCH_CLASS(MatrixLLT, MatrixUnaryExpression<libbirch::Lazy<libbirch::Shared<birch::type::Expression<libbirch::DefaultArray<birch::type::Real,2>>>>, libbirch::DefaultArray<birch::type::Real,2>, libbirch::DefaultArray<birch::type::Real,2>, birch::type::LLT>)
  #line 4 "src/expression/MatrixLLT.birch"
  LIBBIRCH_MEMBERS()
};

template<class Argument,class ArgumentValue,class Value>
#line 4 "src/expression/MatrixInv.birch"
class MatrixInv final : public MatrixUnaryExpression<Argument, ArgumentValue, libbirch::DefaultArray<birch::type::Real,2>, Value> {
public:
  #line 4 "src/expression/MatrixInv.birch"
  using class_type_ = MatrixInv<Argument, ArgumentValue, Value>;
  #line 4 "src/expression/MatrixInv.birch"
  using this_type_ = class_type_;
  #line 4 "src/expression/MatrixInv.birch"
  using super_type_ = MatrixUnaryExpression<Argument, ArgumentValue, libbirch::DefaultArray<birch::type::Real,2>, Value>;

  #line 4 "src/expression/MatrixInv.birch"
  using super_type_::operator=;
  #line 4 "src/expression/MatrixInv.birch"
  using super_type_::doColumns;
  #line 4 "src/expression/MatrixInv.birch"
  using super_type_::doEvaluate;
  #line 4 "src/expression/MatrixInv.birch"
  using super_type_::doEvaluateGrad;
  #line 4 "src/expression/MatrixInv.birch"
  using super_type_::doRows;
  
  #line 4 "src/expression/MatrixInv.birch"
  MatrixInv(const Argument& y, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);

  #line 6 "src/expression/MatrixInv.birch"
  virtual birch::type::Integer doRows(const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr) override;
  #line 10 "src/expression/MatrixInv.birch"
  virtual birch::type::Integer doColumns(const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr) override;
  #line 14 "src/expression/MatrixInv.birch"
  virtual Value doEvaluate(const ArgumentValue& y, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr) override;
  #line 18 "src/expression/MatrixInv.birch"
  virtual libbirch::DefaultArray<birch::type::Real,2> doEvaluateGrad(const libbirch::DefaultArray<birch::type::Real,2>& d, const Value& x, const ArgumentValue& y, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr) override;
  
  #line 4 "src/expression/MatrixInv.birch"
  LIBBIRCH_CLASS(MatrixInv, MatrixUnaryExpression<Argument, ArgumentValue, libbirch::DefaultArray<birch::type::Real,2>, Value>)
  #line 4 "src/expression/MatrixInv.birch"
  LIBBIRCH_MEMBERS()
};

#line 4 "src/expression/MatrixDiagonal.birch"
class MatrixDiagonal final : public MatrixUnaryExpression<libbirch::Lazy<libbirch::Shared<birch::type::Expression<libbirch::DefaultArray<birch::type::Real,1>>>>, libbirch::DefaultArray<birch::type::Real,1>, libbirch::DefaultArray<birch::type::Real,1>, libbirch::DefaultArray<birch::type::Real,2>> {
public:
  #line 4 "src/expression/MatrixDiagonal.birch"
  using class_type_ = MatrixDiagonal;
  #line 4 "src/expression/MatrixDiagonal.birch"
  using this_type_ = class_type_;
  #line 4 "src/expression/MatrixDiagonal.birch"
  using super_type_ = MatrixUnaryExpression<libbirch::Lazy<libbirch::Shared<birch::type::Expression<libbirch::DefaultArray<birch::type::Real,1>>>>, libbirch::DefaultArray<birch::type::Real,1>, libbirch::DefaultArray<birch::type::Real,1>, libbirch::DefaultArray<birch::type::Real,2>>;

  #line 4 "src/expression/MatrixDiagonal.birch"
  using super_type_::operator=;
  #line 4 "src/expression/MatrixDiagonal.birch"
  using super_type_::doColumns;
  #line 4 "src/expression/MatrixDiagonal.birch"
  using super_type_::doEvaluate;
  #line 4 "src/expression/MatrixDiagonal.birch"
  using super_type_::doEvaluateGrad;
  #line 4 "src/expression/MatrixDiagonal.birch"
  using super_type_::doRows;
  
  #line 4 "src/expression/MatrixDiagonal.birch"
  MatrixDiagonal(const libbirch::Lazy<libbirch::Shared<birch::type::Expression<libbirch::DefaultArray<birch::type::Real,1>>>>& y, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);

  #line 6 "src/expression/MatrixDiagonal.birch"
  virtual birch::type::Integer doRows(const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr) override;
  #line 10 "src/expression/MatrixDiagonal.birch"
  virtual birch::type::Integer doColumns(const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr) override;
  #line 14 "src/expression/MatrixDiagonal.birch"
  virtual libbirch::DefaultArray<birch::type::Real,2> doEvaluate(const libbirch::DefaultArray<birch::type::Real,1>& y, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr) override;
  #line 18 "src/expression/MatrixDiagonal.birch"
  virtual libbirch::DefaultArray<birch::type::Real,1> doEvaluateGrad(const libbirch::DefaultArray<birch::type::Real,2>& d, const libbirch::DefaultArray<birch::type::Real,2>& x, const libbirch::DefaultArray<birch::type::Real,1>& y, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr) override;
  
  #line 4 "src/expression/MatrixDiagonal.birch"
  LIBBIRCH_CLASS(MatrixDiagonal, MatrixUnaryExpression<libbirch::Lazy<libbirch::Shared<birch::type::Expression<libbirch::DefaultArray<birch::type::Real,1>>>>, libbirch::DefaultArray<birch::type::Real,1>, libbirch::DefaultArray<birch::type::Real,1>, libbirch::DefaultArray<birch::type::Real,2>>)
  #line 4 "src/expression/MatrixDiagonal.birch"
  LIBBIRCH_MEMBERS()
};

template<class Argument,class ArgumentValue>
#line 4 "src/expression/MatrixCanonical.birch"
class MatrixCanonical final : public MatrixUnaryExpression<Argument, ArgumentValue, libbirch::DefaultArray<birch::type::Real,2>, libbirch::DefaultArray<birch::type::Real,2>> {
public:
  #line 4 "src/expression/MatrixCanonical.birch"
  using class_type_ = MatrixCanonical<Argument, ArgumentValue>;
  #line 4 "src/expression/MatrixCanonical.birch"
  using this_type_ = class_type_;
  #line 4 "src/expression/MatrixCanonical.birch"
  using super_type_ = MatrixUnaryExpression<Argument, ArgumentValue, libbirch::DefaultArray<birch::type::Real,2>, libbirch::DefaultArray<birch::type::Real,2>>;

  #line 4 "src/expression/MatrixCanonical.birch"
  using super_type_::operator=;
  #line 4 "src/expression/MatrixCanonical.birch"
  using super_type_::doColumns;
  #line 4 "src/expression/MatrixCanonical.birch"
  using super_type_::doEvaluate;
  #line 4 "src/expression/MatrixCanonical.birch"
  using super_type_::doEvaluateGrad;
  #line 4 "src/expression/MatrixCanonical.birch"
  using super_type_::doRows;
  
  #line 4 "src/expression/MatrixCanonical.birch"
  MatrixCanonical(const Argument& y, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);

  #line 6 "src/expression/MatrixCanonical.birch"
  virtual birch::type::Integer doRows(const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr) override;
  #line 10 "src/expression/MatrixCanonical.birch"
  virtual birch::type::Integer doColumns(const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr) override;
  #line 14 "src/expression/MatrixCanonical.birch"
  virtual libbirch::DefaultArray<birch::type::Real,2> doEvaluate(const ArgumentValue& y, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr) override;
  #line 18 "src/expression/MatrixCanonical.birch"
  virtual libbirch::DefaultArray<birch::type::Real,2> doEvaluateGrad(const libbirch::DefaultArray<birch::type::Real,2>& d, const libbirch::DefaultArray<birch::type::Real,2>& x, const ArgumentValue& y, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr) override;
  
  #line 4 "src/expression/MatrixCanonical.birch"
  LIBBIRCH_CLASS(MatrixCanonical, MatrixUnaryExpression<Argument, ArgumentValue, libbirch::DefaultArray<birch::type::Real,2>, libbirch::DefaultArray<birch::type::Real,2>>)
  #line 4 "src/expression/MatrixCanonical.birch"
  LIBBIRCH_MEMBERS()
};

#line 4 "src/expression/MatrixAbs.birch"
class MatrixAbs final : public MatrixUnaryExpression<libbirch::Lazy<libbirch::Shared<birch::type::Expression<libbirch::DefaultArray<birch::type::Real,2>>>>, libbirch::DefaultArray<birch::type::Real,2>, libbirch::DefaultArray<birch::type::Real,2>, libbirch::DefaultArray<birch::type::Real,2>> {
public:
  #line 4 "src/expression/MatrixAbs.birch"
  using class_type_ = MatrixAbs;
  #line 4 "src/expression/MatrixAbs.birch"
  using this_type_ = class_type_;
  #line 4 "src/expression/MatrixAbs.birch"
  using super_type_ = MatrixUnaryExpression<libbirch::Lazy<libbirch::Shared<birch::type::Expression<libbirch::DefaultArray<birch::type::Real,2>>>>, libbirch::DefaultArray<birch::type::Real,2>, libbirch::DefaultArray<birch::type::Real,2>, libbirch::DefaultArray<birch::type::Real,2>>;

  #line 4 "src/expression/MatrixAbs.birch"
  using super_type_::operator=;
  #line 4 "src/expression/MatrixAbs.birch"
  using super_type_::doColumns;
  #line 4 "src/expression/MatrixAbs.birch"
  using super_type_::doEvaluate;
  #line 4 "src/expression/MatrixAbs.birch"
  using super_type_::doEvaluateGrad;
  #line 4 "src/expression/MatrixAbs.birch"
  using super_type_::doRows;
  
  #line 4 "src/expression/MatrixAbs.birch"
  MatrixAbs(const libbirch::Lazy<libbirch::Shared<birch::type::Expression<libbirch::DefaultArray<birch::type::Real,2>>>>& y, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);

  #line 7 "src/expression/MatrixAbs.birch"
  virtual birch::type::Integer doRows(const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr) override;
  #line 11 "src/expression/MatrixAbs.birch"
  virtual birch::type::Integer doColumns(const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr) override;
  #line 15 "src/expression/MatrixAbs.birch"
  virtual libbirch::DefaultArray<birch::type::Real,2> doEvaluate(const libbirch::DefaultArray<birch::type::Real,2>& y, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr) override;
  #line 19 "src/expression/MatrixAbs.birch"
  virtual libbirch::DefaultArray<birch::type::Real,2> doEvaluateGrad(const libbirch::DefaultArray<birch::type::Real,2>& d, const libbirch::DefaultArray<birch::type::Real,2>& x, const libbirch::DefaultArray<birch::type::Real,2>& y, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr) override;
  
  #line 4 "src/expression/MatrixAbs.birch"
  LIBBIRCH_CLASS(MatrixAbs, MatrixUnaryExpression<libbirch::Lazy<libbirch::Shared<birch::type::Expression<libbirch::DefaultArray<birch::type::Real,2>>>>, libbirch::DefaultArray<birch::type::Real,2>, libbirch::DefaultArray<birch::type::Real,2>, libbirch::DefaultArray<birch::type::Real,2>>)
  #line 4 "src/expression/MatrixAbs.birch"
  LIBBIRCH_MEMBERS()
};

#line 4 "src/expression/Diagonal.birch"
class Diagonal final : public MatrixUnaryExpression<libbirch::Lazy<libbirch::Shared<birch::type::Expression<birch::type::Real>>>, birch::type::Real, birch::type::Real, libbirch::DefaultArray<birch::type::Real,2>> {
public:
  #line 4 "src/expression/Diagonal.birch"
  using class_type_ = Diagonal;
  #line 4 "src/expression/Diagonal.birch"
  using this_type_ = class_type_;
  #line 4 "src/expression/Diagonal.birch"
  using super_type_ = MatrixUnaryExpression<libbirch::Lazy<libbirch::Shared<birch::type::Expression<birch::type::Real>>>, birch::type::Real, birch::type::Real, libbirch::DefaultArray<birch::type::Real,2>>;

  #line 4 "src/expression/Diagonal.birch"
  using super_type_::operator=;
  #line 4 "src/expression/Diagonal.birch"
  using super_type_::doColumns;
  #line 4 "src/expression/Diagonal.birch"
  using super_type_::doEvaluate;
  #line 4 "src/expression/Diagonal.birch"
  using super_type_::doEvaluateGrad;
  #line 4 "src/expression/Diagonal.birch"
  using super_type_::doRows;
  
  #line 4 "src/expression/Diagonal.birch"
  Diagonal(const libbirch::Lazy<libbirch::Shared<birch::type::Expression<birch::type::Real>>>& y, const birch::type::Integer& z, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);

  birch::type::Integer z;
  #line 11 "src/expression/Diagonal.birch"
  virtual birch::type::Integer doRows(const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr) override;
  #line 15 "src/expression/Diagonal.birch"
  virtual birch::type::Integer doColumns(const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr) override;
  #line 19 "src/expression/Diagonal.birch"
  virtual libbirch::DefaultArray<birch::type::Real,2> doEvaluate(const birch::type::Real& y, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr) override;
  #line 23 "src/expression/Diagonal.birch"
  virtual birch::type::Real doEvaluateGrad(const libbirch::DefaultArray<birch::type::Real,2>& d, const libbirch::DefaultArray<birch::type::Real,2>& x, const birch::type::Real& y, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr) override;
  
  #line 4 "src/expression/Diagonal.birch"
  LIBBIRCH_CLASS(Diagonal, MatrixUnaryExpression<libbirch::Lazy<libbirch::Shared<birch::type::Expression<birch::type::Real>>>, birch::type::Real, birch::type::Real, libbirch::DefaultArray<birch::type::Real,2>>)
  #line 4 "src/expression/Diagonal.birch"
  LIBBIRCH_MEMBERS(z)
};

#line 4 "src/expression/MultivariateTranspose.birch"
class MultivariateTranspose final : public MatrixUnaryExpression<libbirch::Lazy<libbirch::Shared<birch::type::Expression<libbirch::DefaultArray<birch::type::Real,1>>>>, libbirch::DefaultArray<birch::type::Real,1>, libbirch::DefaultArray<birch::type::Real,1>, libbirch::DefaultArray<birch::type::Real,2>> {
public:
  #line 4 "src/expression/MultivariateTranspose.birch"
  using class_type_ = MultivariateTranspose;
  #line 4 "src/expression/MultivariateTranspose.birch"
  using this_type_ = class_type_;
  #line 4 "src/expression/MultivariateTranspose.birch"
  using super_type_ = MatrixUnaryExpression<libbirch::Lazy<libbirch::Shared<birch::type::Expression<libbirch::DefaultArray<birch::type::Real,1>>>>, libbirch::DefaultArray<birch::type::Real,1>, libbirch::DefaultArray<birch::type::Real,1>, libbirch::DefaultArray<birch::type::Real,2>>;

  #line 4 "src/expression/MultivariateTranspose.birch"
  using super_type_::operator=;
  #line 4 "src/expression/MultivariateTranspose.birch"
  using super_type_::doColumns;
  #line 4 "src/expression/MultivariateTranspose.birch"
  using super_type_::doEvaluate;
  #line 4 "src/expression/MultivariateTranspose.birch"
  using super_type_::doEvaluateGrad;
  #line 4 "src/expression/MultivariateTranspose.birch"
  using super_type_::doRows;
  
  #line 4 "src/expression/MultivariateTranspose.birch"
  MultivariateTranspose(const libbirch::Lazy<libbirch::Shared<birch::type::Expression<libbirch::DefaultArray<birch::type::Real,1>>>>& x, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);

  #line 6 "src/expression/MultivariateTranspose.birch"
  virtual birch::type::Integer doRows(const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr) override;
  #line 10 "src/expression/MultivariateTranspose.birch"
  virtual birch::type::Integer doColumns(const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr) override;
  #line 14 "src/expression/MultivariateTranspose.birch"
  virtual libbirch::DefaultArray<birch::type::Real,2> doEvaluate(const libbirch::DefaultArray<birch::type::Real,1>& y, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr) override;
  #line 18 "src/expression/MultivariateTranspose.birch"
  virtual libbirch::DefaultArray<birch::type::Real,1> doEvaluateGrad(const libbirch::DefaultArray<birch::type::Real,2>& d, const libbirch::DefaultArray<birch::type::Real,2>& x, const libbirch::DefaultArray<birch::type::Real,1>& y, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr) override;
  
  #line 4 "src/expression/MultivariateTranspose.birch"
  LIBBIRCH_CLASS(MultivariateTranspose, MatrixUnaryExpression<libbirch::Lazy<libbirch::Shared<birch::type::Expression<libbirch::DefaultArray<birch::type::Real,1>>>>, libbirch::DefaultArray<birch::type::Real,1>, libbirch::DefaultArray<birch::type::Real,1>, libbirch::DefaultArray<birch::type::Real,2>>)
  #line 4 "src/expression/MultivariateTranspose.birch"
  LIBBIRCH_MEMBERS()
};

template<class Value>
#line 6 "src/expression/MultivariateExpression.birch"
class MultivariateExpression : public Expression<Value> {
public:
  #line 6 "src/expression/MultivariateExpression.birch"
  using class_type_ = MultivariateExpression<Value>;
  #line 6 "src/expression/MultivariateExpression.birch"
  using this_type_ = class_type_;
  #line 6 "src/expression/MultivariateExpression.birch"
  using super_type_ = Expression<Value>;

  #line 6 "src/expression/MultivariateExpression.birch"
  using super_type_::operator=;
  #line 6 "src/expression/MultivariateExpression.birch"
  using super_type_::doAccumulateGrad;
  #line 6 "src/expression/MultivariateExpression.birch"
  using super_type_::doClearGrad;
  #line 6 "src/expression/MultivariateExpression.birch"
  using super_type_::doColumns;
  
  #line 6 "src/expression/MultivariateExpression.birch"
  MultivariateExpression(const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);

  libbirch::Optional<libbirch::DefaultArray<birch::type::Real,1>> d;
  #line 12 "src/expression/MultivariateExpression.birch"
  virtual birch::type::Integer doColumns(const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr) final;
  #line 16 "src/expression/MultivariateExpression.birch"
  virtual void doAccumulateGrad(const libbirch::DefaultArray<birch::type::Real,1>& d, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr) final;
  #line 24 "src/expression/MultivariateExpression.birch"
  virtual void doAccumulateGrad(const birch::type::Real& d, const birch::type::Integer& i, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr) final;
  #line 31 "src/expression/MultivariateExpression.birch"
  virtual void doClearGrad(const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr) final;
  
  #line 6 "src/expression/MultivariateExpression.birch"
  LIBBIRCH_ABSTRACT_CLASS(MultivariateExpression, Expression<Value>)
  #line 6 "src/expression/MultivariateExpression.birch"
  LIBBIRCH_MEMBERS(d)
};

template<class Left,class Right,class LeftValue,class RightValue,class LeftGradient,class RightGradient,class Value>
#line 18 "src/expression/MultivariateBinaryExpression.birch"
class MultivariateBinaryExpression : public MultivariateExpression<Value> {
public:
  #line 18 "src/expression/MultivariateBinaryExpression.birch"
  using class_type_ = MultivariateBinaryExpression<Left, Right, LeftValue, RightValue, LeftGradient, RightGradient, Value>;
  #line 18 "src/expression/MultivariateBinaryExpression.birch"
  using this_type_ = class_type_;
  #line 18 "src/expression/MultivariateBinaryExpression.birch"
  using super_type_ = MultivariateExpression<Value>;

  #line 18 "src/expression/MultivariateBinaryExpression.birch"
  using super_type_::operator=;
  #line 18 "src/expression/MultivariateBinaryExpression.birch"
  using super_type_::doCompare;
  #line 18 "src/expression/MultivariateBinaryExpression.birch"
  using super_type_::doConstant;
  #line 18 "src/expression/MultivariateBinaryExpression.birch"
  using super_type_::doCount;
  #line 18 "src/expression/MultivariateBinaryExpression.birch"
  using super_type_::doDepth;
  #line 18 "src/expression/MultivariateBinaryExpression.birch"
  using super_type_::doDetach;
  #line 18 "src/expression/MultivariateBinaryExpression.birch"
  using super_type_::doGet;
  #line 18 "src/expression/MultivariateBinaryExpression.birch"
  using super_type_::doGrad;
  #line 18 "src/expression/MultivariateBinaryExpression.birch"
  using super_type_::doMove;
  #line 18 "src/expression/MultivariateBinaryExpression.birch"
  using super_type_::doPilot;
  #line 18 "src/expression/MultivariateBinaryExpression.birch"
  using super_type_::doPrior;
  #line 18 "src/expression/MultivariateBinaryExpression.birch"
  using super_type_::doValue;
  
  #line 18 "src/expression/MultivariateBinaryExpression.birch"
  MultivariateBinaryExpression(const Left& y, const Right& z, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);

  libbirch::Optional<Left> y;
  libbirch::Optional<Right> z;
  #line 34 "src/expression/MultivariateBinaryExpression.birch"
  virtual Value doEvaluate(const LeftValue& y, const RightValue& z, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr) = 0;
  #line 39 "src/expression/MultivariateBinaryExpression.birch"
  virtual LeftGradient doEvaluateGradLeft(const libbirch::DefaultArray<birch::type::Real,1>& d, const Value& x, const LeftValue& y, const RightValue& z, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr) = 0;
  #line 45 "src/expression/MultivariateBinaryExpression.birch"
  virtual RightGradient doEvaluateGradRight(const libbirch::DefaultArray<birch::type::Real,1>& d, const Value& x, const LeftValue& y, const RightValue& z, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr) = 0;
  #line 48 "src/expression/MultivariateBinaryExpression.birch"
  virtual birch::type::Integer doDepth(const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr) final;
  #line 52 "src/expression/MultivariateBinaryExpression.birch"
  virtual Value doValue(const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr) final;
  #line 56 "src/expression/MultivariateBinaryExpression.birch"
  virtual Value doPilot(const birch::type::Integer& gen, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr) final;
  #line 60 "src/expression/MultivariateBinaryExpression.birch"
  virtual Value doGet(const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr) final;
  #line 64 "src/expression/MultivariateBinaryExpression.birch"
  virtual Value doMove(const birch::type::Integer& gen, const libbirch::Lazy<libbirch::Shared<birch::type::Kernel>>& _u0954, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr) final;
  #line 68 "src/expression/MultivariateBinaryExpression.birch"
  virtual void doGrad(const birch::type::Integer& gen, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr) final;
  #line 73 "src/expression/MultivariateBinaryExpression.birch"
  virtual libbirch::Optional<libbirch::Lazy<libbirch::Shared<birch::type::Expression<birch::type::Real>>>> doPrior(const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr) final;
  #line 87 "src/expression/MultivariateBinaryExpression.birch"
  virtual birch::type::Real doCompare(const birch::type::Integer& gen, const libbirch::Lazy<libbirch::Shared<birch::type::DelayExpression>>& x, const libbirch::Lazy<libbirch::Shared<birch::type::Kernel>>& _u0954, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr) final;
  #line 94 "src/expression/MultivariateBinaryExpression.birch"
  virtual void doConstant(const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr) final;
  #line 99 "src/expression/MultivariateBinaryExpression.birch"
  virtual void doCount(const birch::type::Integer& gen, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr) final;
  #line 104 "src/expression/MultivariateBinaryExpression.birch"
  virtual void doDetach(const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr) final;
  
  #line 18 "src/expression/MultivariateBinaryExpression.birch"
  LIBBIRCH_ABSTRACT_CLASS(MultivariateBinaryExpression, MultivariateExpression<Value>)
  #line 18 "src/expression/MultivariateBinaryExpression.birch"
  LIBBIRCH_MEMBERS(y, z)
};

#line 4 "src/expression/MultivariateAdd.birch"
class MultivariateAdd final : public MultivariateBinaryExpression<libbirch::Lazy<libbirch::Shared<birch::type::Expression<libbirch::DefaultArray<birch::type::Real,1>>>>, libbirch::Lazy<libbirch::Shared<birch::type::Expression<libbirch::DefaultArray<birch::type::Real,1>>>>, libbirch::DefaultArray<birch::type::Real,1>, libbirch::DefaultArray<birch::type::Real,1>, libbirch::DefaultArray<birch::type::Real,1>, libbirch::DefaultArray<birch::type::Real,1>, libbirch::DefaultArray<birch::type::Real,1>> {
public:
  #line 4 "src/expression/MultivariateAdd.birch"
  using class_type_ = MultivariateAdd;
  #line 4 "src/expression/MultivariateAdd.birch"
  using this_type_ = class_type_;
  #line 4 "src/expression/MultivariateAdd.birch"
  using super_type_ = MultivariateBinaryExpression<libbirch::Lazy<libbirch::Shared<birch::type::Expression<libbirch::DefaultArray<birch::type::Real,1>>>>, libbirch::Lazy<libbirch::Shared<birch::type::Expression<libbirch::DefaultArray<birch::type::Real,1>>>>, libbirch::DefaultArray<birch::type::Real,1>, libbirch::DefaultArray<birch::type::Real,1>, libbirch::DefaultArray<birch::type::Real,1>, libbirch::DefaultArray<birch::type::Real,1>, libbirch::DefaultArray<birch::type::Real,1>>;

  #line 4 "src/expression/MultivariateAdd.birch"
  using super_type_::operator=;
  #line 4 "src/expression/MultivariateAdd.birch"
  using super_type_::doEvaluate;
  #line 4 "src/expression/MultivariateAdd.birch"
  using super_type_::doEvaluateGradLeft;
  #line 4 "src/expression/MultivariateAdd.birch"
  using super_type_::doEvaluateGradRight;
  #line 4 "src/expression/MultivariateAdd.birch"
  using super_type_::doRows;
  #line 4 "src/expression/MultivariateAdd.birch"
  using super_type_::graftDotMatrixNormalInverseWishart;
  #line 4 "src/expression/MultivariateAdd.birch"
  using super_type_::graftLinearMultivariateGaussian;
  #line 4 "src/expression/MultivariateAdd.birch"
  using super_type_::graftLinearMultivariateNormalInverseGamma;
  
  #line 4 "src/expression/MultivariateAdd.birch"
  MultivariateAdd(const libbirch::Lazy<libbirch::Shared<birch::type::Expression<libbirch::DefaultArray<birch::type::Real,1>>>>& y, const libbirch::Lazy<libbirch::Shared<birch::type::Expression<libbirch::DefaultArray<birch::type::Real,1>>>>& z, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);

  #line 7 "src/expression/MultivariateAdd.birch"
  virtual birch::type::Integer doRows(const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr) override;
  #line 11 "src/expression/MultivariateAdd.birch"
  virtual libbirch::DefaultArray<birch::type::Real,1> doEvaluate(const libbirch::DefaultArray<birch::type::Real,1>& y, const libbirch::DefaultArray<birch::type::Real,1>& z, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr) override;
  #line 15 "src/expression/MultivariateAdd.birch"
  virtual libbirch::DefaultArray<birch::type::Real,1> doEvaluateGradLeft(const libbirch::DefaultArray<birch::type::Real,1>& d, const libbirch::DefaultArray<birch::type::Real,1>& x, const libbirch::DefaultArray<birch::type::Real,1>& y, const libbirch::DefaultArray<birch::type::Real,1>& z, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr) override;
  #line 20 "src/expression/MultivariateAdd.birch"
  virtual libbirch::DefaultArray<birch::type::Real,1> doEvaluateGradRight(const libbirch::DefaultArray<birch::type::Real,1>& d, const libbirch::DefaultArray<birch::type::Real,1>& x, const libbirch::DefaultArray<birch::type::Real,1>& y, const libbirch::DefaultArray<birch::type::Real,1>& z, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr) override;
  #line 25 "src/expression/MultivariateAdd.birch"
  virtual libbirch::Optional<libbirch::Lazy<libbirch::Shared<birch::type::TransformLinearMultivariate<libbirch::Lazy<libbirch::Shared<birch::type::MultivariateGaussian>>>>>> graftLinearMultivariateGaussian(const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr) override;
  #line 46 "src/expression/MultivariateAdd.birch"
  virtual libbirch::Optional<libbirch::Lazy<libbirch::Shared<birch::type::TransformLinearMultivariate<libbirch::Lazy<libbirch::Shared<birch::type::MultivariateNormalInverseGamma>>>>>> graftLinearMultivariateNormalInverseGamma(const libbirch::Lazy<libbirch::Shared<birch::type::Distribution<birch::type::Real>>>& compare, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr) override;
  #line 67 "src/expression/MultivariateAdd.birch"
  virtual libbirch::Optional<libbirch::Lazy<libbirch::Shared<birch::type::TransformDotMultivariate<libbirch::Lazy<libbirch::Shared<birch::type::MatrixNormalInverseWishart>>>>>> graftDotMatrixNormalInverseWishart(const libbirch::Lazy<libbirch::Shared<birch::type::Distribution<birch::type::LLT>>>& compare, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr) override;
  
  #line 4 "src/expression/MultivariateAdd.birch"
  LIBBIRCH_CLASS(MultivariateAdd, MultivariateBinaryExpression<libbirch::Lazy<libbirch::Shared<birch::type::Expression<libbirch::DefaultArray<birch::type::Real,1>>>>, libbirch::Lazy<libbirch::Shared<birch::type::Expression<libbirch::DefaultArray<birch::type::Real,1>>>>, libbirch::DefaultArray<birch::type::Real,1>, libbirch::DefaultArray<birch::type::Real,1>, libbirch::DefaultArray<birch::type::Real,1>, libbirch::DefaultArray<birch::type::Real,1>, libbirch::DefaultArray<birch::type::Real,1>>)
  #line 4 "src/expression/MultivariateAdd.birch"
  LIBBIRCH_MEMBERS()
};

#line 4 "src/expression/MultivariateDot.birch"
class MultivariateDot final : public MultivariateBinaryExpression<libbirch::Lazy<libbirch::Shared<birch::type::Expression<libbirch::DefaultArray<birch::type::Real,1>>>>, libbirch::Lazy<libbirch::Shared<birch::type::Expression<libbirch::DefaultArray<birch::type::Real,2>>>>, libbirch::DefaultArray<birch::type::Real,1>, libbirch::DefaultArray<birch::type::Real,2>, libbirch::DefaultArray<birch::type::Real,1>, libbirch::DefaultArray<birch::type::Real,2>, libbirch::DefaultArray<birch::type::Real,1>> {
public:
  #line 4 "src/expression/MultivariateDot.birch"
  using class_type_ = MultivariateDot;
  #line 4 "src/expression/MultivariateDot.birch"
  using this_type_ = class_type_;
  #line 4 "src/expression/MultivariateDot.birch"
  using super_type_ = MultivariateBinaryExpression<libbirch::Lazy<libbirch::Shared<birch::type::Expression<libbirch::DefaultArray<birch::type::Real,1>>>>, libbirch::Lazy<libbirch::Shared<birch::type::Expression<libbirch::DefaultArray<birch::type::Real,2>>>>, libbirch::DefaultArray<birch::type::Real,1>, libbirch::DefaultArray<birch::type::Real,2>, libbirch::DefaultArray<birch::type::Real,1>, libbirch::DefaultArray<birch::type::Real,2>, libbirch::DefaultArray<birch::type::Real,1>>;

  #line 4 "src/expression/MultivariateDot.birch"
  using super_type_::operator=;
  #line 4 "src/expression/MultivariateDot.birch"
  using super_type_::doEvaluate;
  #line 4 "src/expression/MultivariateDot.birch"
  using super_type_::doEvaluateGradLeft;
  #line 4 "src/expression/MultivariateDot.birch"
  using super_type_::doEvaluateGradRight;
  #line 4 "src/expression/MultivariateDot.birch"
  using super_type_::doRows;
  #line 4 "src/expression/MultivariateDot.birch"
  using super_type_::graftDotMatrixGaussian;
  #line 4 "src/expression/MultivariateDot.birch"
  using super_type_::graftDotMatrixNormalInverseWishart;
  
  #line 4 "src/expression/MultivariateDot.birch"
  MultivariateDot(const libbirch::Lazy<libbirch::Shared<birch::type::Expression<libbirch::DefaultArray<birch::type::Real,1>>>>& y, const libbirch::Lazy<libbirch::Shared<birch::type::Expression<libbirch::DefaultArray<birch::type::Real,2>>>>& z, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);

  #line 7 "src/expression/MultivariateDot.birch"
  virtual birch::type::Integer doRows(const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr) override;
  #line 11 "src/expression/MultivariateDot.birch"
  virtual libbirch::DefaultArray<birch::type::Real,1> doEvaluate(const libbirch::DefaultArray<birch::type::Real,1>& y, const libbirch::DefaultArray<birch::type::Real,2>& z, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr) override;
  #line 15 "src/expression/MultivariateDot.birch"
  virtual libbirch::DefaultArray<birch::type::Real,1> doEvaluateGradLeft(const libbirch::DefaultArray<birch::type::Real,1>& d, const libbirch::DefaultArray<birch::type::Real,1>& x, const libbirch::DefaultArray<birch::type::Real,1>& y, const libbirch::DefaultArray<birch::type::Real,2>& z, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr) override;
  #line 20 "src/expression/MultivariateDot.birch"
  virtual libbirch::DefaultArray<birch::type::Real,2> doEvaluateGradRight(const libbirch::DefaultArray<birch::type::Real,1>& d, const libbirch::DefaultArray<birch::type::Real,1>& x, const libbirch::DefaultArray<birch::type::Real,1>& y, const libbirch::DefaultArray<birch::type::Real,2>& z, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr) override;
  #line 25 "src/expression/MultivariateDot.birch"
  virtual libbirch::Optional<libbirch::Lazy<libbirch::Shared<birch::type::TransformDotMultivariate<libbirch::Lazy<libbirch::Shared<birch::type::MatrixGaussian>>>>>> graftDotMatrixGaussian(const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr) override;
  #line 40 "src/expression/MultivariateDot.birch"
  virtual libbirch::Optional<libbirch::Lazy<libbirch::Shared<birch::type::TransformDotMultivariate<libbirch::Lazy<libbirch::Shared<birch::type::MatrixNormalInverseWishart>>>>>> graftDotMatrixNormalInverseWishart(const libbirch::Lazy<libbirch::Shared<birch::type::Distribution<birch::type::LLT>>>& compare, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr) override;
  
  #line 4 "src/expression/MultivariateDot.birch"
  LIBBIRCH_CLASS(MultivariateDot, MultivariateBinaryExpression<libbirch::Lazy<libbirch::Shared<birch::type::Expression<libbirch::DefaultArray<birch::type::Real,1>>>>, libbirch::Lazy<libbirch::Shared<birch::type::Expression<libbirch::DefaultArray<birch::type::Real,2>>>>, libbirch::DefaultArray<birch::type::Real,1>, libbirch::DefaultArray<birch::type::Real,2>, libbirch::DefaultArray<birch::type::Real,1>, libbirch::DefaultArray<birch::type::Real,2>, libbirch::DefaultArray<birch::type::Real,1>>)
  #line 4 "src/expression/MultivariateDot.birch"
  LIBBIRCH_MEMBERS()
};

#line 4 "src/expression/MultivariateMultiply.birch"
class MultivariateMultiply final : public MultivariateBinaryExpression<libbirch::Lazy<libbirch::Shared<birch::type::Expression<libbirch::DefaultArray<birch::type::Real,2>>>>, libbirch::Lazy<libbirch::Shared<birch::type::Expression<libbirch::DefaultArray<birch::type::Real,1>>>>, libbirch::DefaultArray<birch::type::Real,2>, libbirch::DefaultArray<birch::type::Real,1>, libbirch::DefaultArray<birch::type::Real,2>, libbirch::DefaultArray<birch::type::Real,1>, libbirch::DefaultArray<birch::type::Real,1>> {
public:
  #line 4 "src/expression/MultivariateMultiply.birch"
  using class_type_ = MultivariateMultiply;
  #line 4 "src/expression/MultivariateMultiply.birch"
  using this_type_ = class_type_;
  #line 4 "src/expression/MultivariateMultiply.birch"
  using super_type_ = MultivariateBinaryExpression<libbirch::Lazy<libbirch::Shared<birch::type::Expression<libbirch::DefaultArray<birch::type::Real,2>>>>, libbirch::Lazy<libbirch::Shared<birch::type::Expression<libbirch::DefaultArray<birch::type::Real,1>>>>, libbirch::DefaultArray<birch::type::Real,2>, libbirch::DefaultArray<birch::type::Real,1>, libbirch::DefaultArray<birch::type::Real,2>, libbirch::DefaultArray<birch::type::Real,1>, libbirch::DefaultArray<birch::type::Real,1>>;

  #line 4 "src/expression/MultivariateMultiply.birch"
  using super_type_::operator=;
  #line 4 "src/expression/MultivariateMultiply.birch"
  using super_type_::doEvaluate;
  #line 4 "src/expression/MultivariateMultiply.birch"
  using super_type_::doEvaluateGradLeft;
  #line 4 "src/expression/MultivariateMultiply.birch"
  using super_type_::doEvaluateGradRight;
  #line 4 "src/expression/MultivariateMultiply.birch"
  using super_type_::doRows;
  #line 4 "src/expression/MultivariateMultiply.birch"
  using super_type_::graftLinearMultivariateGaussian;
  #line 4 "src/expression/MultivariateMultiply.birch"
  using super_type_::graftLinearMultivariateNormalInverseGamma;
  
  #line 4 "src/expression/MultivariateMultiply.birch"
  MultivariateMultiply(const libbirch::Lazy<libbirch::Shared<birch::type::Expression<libbirch::DefaultArray<birch::type::Real,2>>>>& y, const libbirch::Lazy<libbirch::Shared<birch::type::Expression<libbirch::DefaultArray<birch::type::Real,1>>>>& z, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);

  #line 8 "src/expression/MultivariateMultiply.birch"
  virtual birch::type::Integer doRows(const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr) override;
  #line 12 "src/expression/MultivariateMultiply.birch"
  virtual libbirch::DefaultArray<birch::type::Real,1> doEvaluate(const libbirch::DefaultArray<birch::type::Real,2>& y, const libbirch::DefaultArray<birch::type::Real,1>& z, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr) override;
  #line 16 "src/expression/MultivariateMultiply.birch"
  virtual libbirch::DefaultArray<birch::type::Real,2> doEvaluateGradLeft(const libbirch::DefaultArray<birch::type::Real,1>& d, const libbirch::DefaultArray<birch::type::Real,1>& x, const libbirch::DefaultArray<birch::type::Real,2>& y, const libbirch::DefaultArray<birch::type::Real,1>& z, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr) override;
  #line 21 "src/expression/MultivariateMultiply.birch"
  virtual libbirch::DefaultArray<birch::type::Real,1> doEvaluateGradRight(const libbirch::DefaultArray<birch::type::Real,1>& d, const libbirch::DefaultArray<birch::type::Real,1>& x, const libbirch::DefaultArray<birch::type::Real,2>& y, const libbirch::DefaultArray<birch::type::Real,1>& z, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr) override;
  #line 26 "src/expression/MultivariateMultiply.birch"
  virtual libbirch::Optional<libbirch::Lazy<libbirch::Shared<birch::type::TransformLinearMultivariate<libbirch::Lazy<libbirch::Shared<birch::type::MultivariateGaussian>>>>>> graftLinearMultivariateGaussian(const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr) override;
  #line 40 "src/expression/MultivariateMultiply.birch"
  virtual libbirch::Optional<libbirch::Lazy<libbirch::Shared<birch::type::TransformLinearMultivariate<libbirch::Lazy<libbirch::Shared<birch::type::MultivariateNormalInverseGamma>>>>>> graftLinearMultivariateNormalInverseGamma(const libbirch::Lazy<libbirch::Shared<birch::type::Distribution<birch::type::Real>>>& compare, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr) override;
  
  #line 4 "src/expression/MultivariateMultiply.birch"
  LIBBIRCH_CLASS(MultivariateMultiply, MultivariateBinaryExpression<libbirch::Lazy<libbirch::Shared<birch::type::Expression<libbirch::DefaultArray<birch::type::Real,2>>>>, libbirch::Lazy<libbirch::Shared<birch::type::Expression<libbirch::DefaultArray<birch::type::Real,1>>>>, libbirch::DefaultArray<birch::type::Real,2>, libbirch::DefaultArray<birch::type::Real,1>, libbirch::DefaultArray<birch::type::Real,2>, libbirch::DefaultArray<birch::type::Real,1>, libbirch::DefaultArray<birch::type::Real,1>>)
  #line 4 "src/expression/MultivariateMultiply.birch"
  LIBBIRCH_MEMBERS()
};

#line 4 "src/expression/MultivariateScalarMultiply.birch"
class MultivariateScalarMultiply final : public MultivariateBinaryExpression<libbirch::Lazy<libbirch::Shared<birch::type::Expression<birch::type::Real>>>, libbirch::Lazy<libbirch::Shared<birch::type::Expression<libbirch::DefaultArray<birch::type::Real,1>>>>, birch::type::Real, libbirch::DefaultArray<birch::type::Real,1>, birch::type::Real, libbirch::DefaultArray<birch::type::Real,1>, libbirch::DefaultArray<birch::type::Real,1>> {
public:
  #line 4 "src/expression/MultivariateScalarMultiply.birch"
  using class_type_ = MultivariateScalarMultiply;
  #line 4 "src/expression/MultivariateScalarMultiply.birch"
  using this_type_ = class_type_;
  #line 4 "src/expression/MultivariateScalarMultiply.birch"
  using super_type_ = MultivariateBinaryExpression<libbirch::Lazy<libbirch::Shared<birch::type::Expression<birch::type::Real>>>, libbirch::Lazy<libbirch::Shared<birch::type::Expression<libbirch::DefaultArray<birch::type::Real,1>>>>, birch::type::Real, libbirch::DefaultArray<birch::type::Real,1>, birch::type::Real, libbirch::DefaultArray<birch::type::Real,1>, libbirch::DefaultArray<birch::type::Real,1>>;

  #line 4 "src/expression/MultivariateScalarMultiply.birch"
  using super_type_::operator=;
  #line 4 "src/expression/MultivariateScalarMultiply.birch"
  using super_type_::doEvaluate;
  #line 4 "src/expression/MultivariateScalarMultiply.birch"
  using super_type_::doEvaluateGradLeft;
  #line 4 "src/expression/MultivariateScalarMultiply.birch"
  using super_type_::doEvaluateGradRight;
  #line 4 "src/expression/MultivariateScalarMultiply.birch"
  using super_type_::doRows;
  #line 4 "src/expression/MultivariateScalarMultiply.birch"
  using super_type_::graftLinearMultivariateGaussian;
  #line 4 "src/expression/MultivariateScalarMultiply.birch"
  using super_type_::graftLinearMultivariateNormalInverseGamma;
  
  #line 4 "src/expression/MultivariateScalarMultiply.birch"
  MultivariateScalarMultiply(const libbirch::Lazy<libbirch::Shared<birch::type::Expression<birch::type::Real>>>& y, const libbirch::Lazy<libbirch::Shared<birch::type::Expression<libbirch::DefaultArray<birch::type::Real,1>>>>& z, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);

  #line 7 "src/expression/MultivariateScalarMultiply.birch"
  virtual birch::type::Integer doRows(const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr) override;
  #line 11 "src/expression/MultivariateScalarMultiply.birch"
  virtual libbirch::DefaultArray<birch::type::Real,1> doEvaluate(const birch::type::Real& y, const libbirch::DefaultArray<birch::type::Real,1>& z, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr) override;
  #line 15 "src/expression/MultivariateScalarMultiply.birch"
  virtual birch::type::Real doEvaluateGradLeft(const libbirch::DefaultArray<birch::type::Real,1>& d, const libbirch::DefaultArray<birch::type::Real,1>& x, const birch::type::Real& y, const libbirch::DefaultArray<birch::type::Real,1>& z, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr) override;
  #line 20 "src/expression/MultivariateScalarMultiply.birch"
  virtual libbirch::DefaultArray<birch::type::Real,1> doEvaluateGradRight(const libbirch::DefaultArray<birch::type::Real,1>& d, const libbirch::DefaultArray<birch::type::Real,1>& x, const birch::type::Real& y, const libbirch::DefaultArray<birch::type::Real,1>& z, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr) override;
  #line 25 "src/expression/MultivariateScalarMultiply.birch"
  virtual libbirch::Optional<libbirch::Lazy<libbirch::Shared<birch::type::TransformLinearMultivariate<libbirch::Lazy<libbirch::Shared<birch::type::MultivariateGaussian>>>>>> graftLinearMultivariateGaussian(const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr) override;
  #line 40 "src/expression/MultivariateScalarMultiply.birch"
  virtual libbirch::Optional<libbirch::Lazy<libbirch::Shared<birch::type::TransformLinearMultivariate<libbirch::Lazy<libbirch::Shared<birch::type::MultivariateNormalInverseGamma>>>>>> graftLinearMultivariateNormalInverseGamma(const libbirch::Lazy<libbirch::Shared<birch::type::Distribution<birch::type::Real>>>& compare, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr) override;
  
  #line 4 "src/expression/MultivariateScalarMultiply.birch"
  LIBBIRCH_CLASS(MultivariateScalarMultiply, MultivariateBinaryExpression<libbirch::Lazy<libbirch::Shared<birch::type::Expression<birch::type::Real>>>, libbirch::Lazy<libbirch::Shared<birch::type::Expression<libbirch::DefaultArray<birch::type::Real,1>>>>, birch::type::Real, libbirch::DefaultArray<birch::type::Real,1>, birch::type::Real, libbirch::DefaultArray<birch::type::Real,1>, libbirch::DefaultArray<birch::type::Real,1>>)
  #line 4 "src/expression/MultivariateScalarMultiply.birch"
  LIBBIRCH_MEMBERS()
};

template<class Left,class LeftValue>
#line 4 "src/expression/MultivariateSolve.birch"
class MultivariateSolve final : public MultivariateBinaryExpression<Left, libbirch::Lazy<libbirch::Shared<birch::type::Expression<libbirch::DefaultArray<birch::type::Real,1>>>>, LeftValue, libbirch::DefaultArray<birch::type::Real,1>, libbirch::DefaultArray<birch::type::Real,2>, libbirch::DefaultArray<birch::type::Real,1>, libbirch::DefaultArray<birch::type::Real,1>> {
public:
  #line 4 "src/expression/MultivariateSolve.birch"
  using class_type_ = MultivariateSolve<Left, LeftValue>;
  #line 4 "src/expression/MultivariateSolve.birch"
  using this_type_ = class_type_;
  #line 4 "src/expression/MultivariateSolve.birch"
  using super_type_ = MultivariateBinaryExpression<Left, libbirch::Lazy<libbirch::Shared<birch::type::Expression<libbirch::DefaultArray<birch::type::Real,1>>>>, LeftValue, libbirch::DefaultArray<birch::type::Real,1>, libbirch::DefaultArray<birch::type::Real,2>, libbirch::DefaultArray<birch::type::Real,1>, libbirch::DefaultArray<birch::type::Real,1>>;

  #line 4 "src/expression/MultivariateSolve.birch"
  using super_type_::operator=;
  #line 4 "src/expression/MultivariateSolve.birch"
  using super_type_::doEvaluate;
  #line 4 "src/expression/MultivariateSolve.birch"
  using super_type_::doEvaluateGradLeft;
  #line 4 "src/expression/MultivariateSolve.birch"
  using super_type_::doEvaluateGradRight;
  #line 4 "src/expression/MultivariateSolve.birch"
  using super_type_::doRows;
  
  #line 4 "src/expression/MultivariateSolve.birch"
  MultivariateSolve(const Left& y, const libbirch::Lazy<libbirch::Shared<birch::type::Expression<libbirch::DefaultArray<birch::type::Real,1>>>>& z, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);

  #line 7 "src/expression/MultivariateSolve.birch"
  virtual birch::type::Integer doRows(const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr) override;
  #line 11 "src/expression/MultivariateSolve.birch"
  virtual libbirch::DefaultArray<birch::type::Real,1> doEvaluate(const LeftValue& y, const libbirch::DefaultArray<birch::type::Real,1>& z, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr) override;
  #line 15 "src/expression/MultivariateSolve.birch"
  virtual libbirch::DefaultArray<birch::type::Real,2> doEvaluateGradLeft(const libbirch::DefaultArray<birch::type::Real,1>& d, const libbirch::DefaultArray<birch::type::Real,1>& x, const LeftValue& y, const libbirch::DefaultArray<birch::type::Real,1>& z, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr) override;
  #line 20 "src/expression/MultivariateSolve.birch"
  virtual libbirch::DefaultArray<birch::type::Real,1> doEvaluateGradRight(const libbirch::DefaultArray<birch::type::Real,1>& d, const libbirch::DefaultArray<birch::type::Real,1>& x, const LeftValue& y, const libbirch::DefaultArray<birch::type::Real,1>& z, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr) override;
  
  #line 4 "src/expression/MultivariateSolve.birch"
  LIBBIRCH_CLASS(MultivariateSolve, MultivariateBinaryExpression<Left, libbirch::Lazy<libbirch::Shared<birch::type::Expression<libbirch::DefaultArray<birch::type::Real,1>>>>, LeftValue, libbirch::DefaultArray<birch::type::Real,1>, libbirch::DefaultArray<birch::type::Real,2>, libbirch::DefaultArray<birch::type::Real,1>, libbirch::DefaultArray<birch::type::Real,1>>)
  #line 4 "src/expression/MultivariateSolve.birch"
  LIBBIRCH_MEMBERS()
};

#line 4 "src/expression/MultivariateStack.birch"
class MultivariateStack final : public MultivariateBinaryExpression<libbirch::Lazy<libbirch::Shared<birch::type::Expression<libbirch::DefaultArray<birch::type::Real,1>>>>, libbirch::Lazy<libbirch::Shared<birch::type::Expression<libbirch::DefaultArray<birch::type::Real,1>>>>, libbirch::DefaultArray<birch::type::Real,1>, libbirch::DefaultArray<birch::type::Real,1>, libbirch::DefaultArray<birch::type::Real,1>, libbirch::DefaultArray<birch::type::Real,1>, libbirch::DefaultArray<birch::type::Real,1>> {
public:
  #line 4 "src/expression/MultivariateStack.birch"
  using class_type_ = MultivariateStack;
  #line 4 "src/expression/MultivariateStack.birch"
  using this_type_ = class_type_;
  #line 4 "src/expression/MultivariateStack.birch"
  using super_type_ = MultivariateBinaryExpression<libbirch::Lazy<libbirch::Shared<birch::type::Expression<libbirch::DefaultArray<birch::type::Real,1>>>>, libbirch::Lazy<libbirch::Shared<birch::type::Expression<libbirch::DefaultArray<birch::type::Real,1>>>>, libbirch::DefaultArray<birch::type::Real,1>, libbirch::DefaultArray<birch::type::Real,1>, libbirch::DefaultArray<birch::type::Real,1>, libbirch::DefaultArray<birch::type::Real,1>, libbirch::DefaultArray<birch::type::Real,1>>;

  #line 4 "src/expression/MultivariateStack.birch"
  using super_type_::operator=;
  #line 4 "src/expression/MultivariateStack.birch"
  using super_type_::doEvaluate;
  #line 4 "src/expression/MultivariateStack.birch"
  using super_type_::doEvaluateGradLeft;
  #line 4 "src/expression/MultivariateStack.birch"
  using super_type_::doEvaluateGradRight;
  #line 4 "src/expression/MultivariateStack.birch"
  using super_type_::doRows;
  
  #line 4 "src/expression/MultivariateStack.birch"
  MultivariateStack(const libbirch::Lazy<libbirch::Shared<birch::type::Expression<libbirch::DefaultArray<birch::type::Real,1>>>>& y, const libbirch::Lazy<libbirch::Shared<birch::type::Expression<libbirch::DefaultArray<birch::type::Real,1>>>>& z, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);

  #line 7 "src/expression/MultivariateStack.birch"
  virtual birch::type::Integer doRows(const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr) override;
  #line 11 "src/expression/MultivariateStack.birch"
  virtual libbirch::DefaultArray<birch::type::Real,1> doEvaluate(const libbirch::DefaultArray<birch::type::Real,1>& y, const libbirch::DefaultArray<birch::type::Real,1>& z, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr) override;
  #line 15 "src/expression/MultivariateStack.birch"
  virtual libbirch::DefaultArray<birch::type::Real,1> doEvaluateGradLeft(const libbirch::DefaultArray<birch::type::Real,1>& d, const libbirch::DefaultArray<birch::type::Real,1>& x, const libbirch::DefaultArray<birch::type::Real,1>& y, const libbirch::DefaultArray<birch::type::Real,1>& z, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr) override;
  #line 20 "src/expression/MultivariateStack.birch"
  virtual libbirch::DefaultArray<birch::type::Real,1> doEvaluateGradRight(const libbirch::DefaultArray<birch::type::Real,1>& d, const libbirch::DefaultArray<birch::type::Real,1>& x, const libbirch::DefaultArray<birch::type::Real,1>& y, const libbirch::DefaultArray<birch::type::Real,1>& z, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr) override;
  
  #line 4 "src/expression/MultivariateStack.birch"
  LIBBIRCH_CLASS(MultivariateStack, MultivariateBinaryExpression<libbirch::Lazy<libbirch::Shared<birch::type::Expression<libbirch::DefaultArray<birch::type::Real,1>>>>, libbirch::Lazy<libbirch::Shared<birch::type::Expression<libbirch::DefaultArray<birch::type::Real,1>>>>, libbirch::DefaultArray<birch::type::Real,1>, libbirch::DefaultArray<birch::type::Real,1>, libbirch::DefaultArray<birch::type::Real,1>, libbirch::DefaultArray<birch::type::Real,1>, libbirch::DefaultArray<birch::type::Real,1>>)
  #line 4 "src/expression/MultivariateStack.birch"
  LIBBIRCH_MEMBERS()
};

#line 4 "src/expression/MultivariateSubtract.birch"
class MultivariateSubtract final : public MultivariateBinaryExpression<libbirch::Lazy<libbirch::Shared<birch::type::Expression<libbirch::DefaultArray<birch::type::Real,1>>>>, libbirch::Lazy<libbirch::Shared<birch::type::Expression<libbirch::DefaultArray<birch::type::Real,1>>>>, libbirch::DefaultArray<birch::type::Real,1>, libbirch::DefaultArray<birch::type::Real,1>, libbirch::DefaultArray<birch::type::Real,1>, libbirch::DefaultArray<birch::type::Real,1>, libbirch::DefaultArray<birch::type::Real,1>> {
public:
  #line 4 "src/expression/MultivariateSubtract.birch"
  using class_type_ = MultivariateSubtract;
  #line 4 "src/expression/MultivariateSubtract.birch"
  using this_type_ = class_type_;
  #line 4 "src/expression/MultivariateSubtract.birch"
  using super_type_ = MultivariateBinaryExpression<libbirch::Lazy<libbirch::Shared<birch::type::Expression<libbirch::DefaultArray<birch::type::Real,1>>>>, libbirch::Lazy<libbirch::Shared<birch::type::Expression<libbirch::DefaultArray<birch::type::Real,1>>>>, libbirch::DefaultArray<birch::type::Real,1>, libbirch::DefaultArray<birch::type::Real,1>, libbirch::DefaultArray<birch::type::Real,1>, libbirch::DefaultArray<birch::type::Real,1>, libbirch::DefaultArray<birch::type::Real,1>>;

  #line 4 "src/expression/MultivariateSubtract.birch"
  using super_type_::operator=;
  #line 4 "src/expression/MultivariateSubtract.birch"
  using super_type_::doEvaluate;
  #line 4 "src/expression/MultivariateSubtract.birch"
  using super_type_::doEvaluateGradLeft;
  #line 4 "src/expression/MultivariateSubtract.birch"
  using super_type_::doEvaluateGradRight;
  #line 4 "src/expression/MultivariateSubtract.birch"
  using super_type_::doRows;
  #line 4 "src/expression/MultivariateSubtract.birch"
  using super_type_::graftDotMatrixNormalInverseWishart;
  #line 4 "src/expression/MultivariateSubtract.birch"
  using super_type_::graftLinearMultivariateGaussian;
  #line 4 "src/expression/MultivariateSubtract.birch"
  using super_type_::graftLinearMultivariateNormalInverseGamma;
  
  #line 4 "src/expression/MultivariateSubtract.birch"
  MultivariateSubtract(const libbirch::Lazy<libbirch::Shared<birch::type::Expression<libbirch::DefaultArray<birch::type::Real,1>>>>& y, const libbirch::Lazy<libbirch::Shared<birch::type::Expression<libbirch::DefaultArray<birch::type::Real,1>>>>& z, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);

  #line 8 "src/expression/MultivariateSubtract.birch"
  virtual birch::type::Integer doRows(const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr) override;
  #line 12 "src/expression/MultivariateSubtract.birch"
  virtual libbirch::DefaultArray<birch::type::Real,1> doEvaluate(const libbirch::DefaultArray<birch::type::Real,1>& y, const libbirch::DefaultArray<birch::type::Real,1>& z, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr) override;
  #line 16 "src/expression/MultivariateSubtract.birch"
  virtual libbirch::DefaultArray<birch::type::Real,1> doEvaluateGradLeft(const libbirch::DefaultArray<birch::type::Real,1>& d, const libbirch::DefaultArray<birch::type::Real,1>& x, const libbirch::DefaultArray<birch::type::Real,1>& y, const libbirch::DefaultArray<birch::type::Real,1>& z, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr) override;
  #line 21 "src/expression/MultivariateSubtract.birch"
  virtual libbirch::DefaultArray<birch::type::Real,1> doEvaluateGradRight(const libbirch::DefaultArray<birch::type::Real,1>& d, const libbirch::DefaultArray<birch::type::Real,1>& x, const libbirch::DefaultArray<birch::type::Real,1>& y, const libbirch::DefaultArray<birch::type::Real,1>& z, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr) override;
  #line 26 "src/expression/MultivariateSubtract.birch"
  virtual libbirch::Optional<libbirch::Lazy<libbirch::Shared<birch::type::TransformLinearMultivariate<libbirch::Lazy<libbirch::Shared<birch::type::MultivariateGaussian>>>>>> graftLinearMultivariateGaussian(const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr) override;
  #line 45 "src/expression/MultivariateSubtract.birch"
  virtual libbirch::Optional<libbirch::Lazy<libbirch::Shared<birch::type::TransformLinearMultivariate<libbirch::Lazy<libbirch::Shared<birch::type::MultivariateNormalInverseGamma>>>>>> graftLinearMultivariateNormalInverseGamma(const libbirch::Lazy<libbirch::Shared<birch::type::Distribution<birch::type::Real>>>& compare, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr) override;
  #line 64 "src/expression/MultivariateSubtract.birch"
  virtual libbirch::Optional<libbirch::Lazy<libbirch::Shared<birch::type::TransformDotMultivariate<libbirch::Lazy<libbirch::Shared<birch::type::MatrixNormalInverseWishart>>>>>> graftDotMatrixNormalInverseWishart(const libbirch::Lazy<libbirch::Shared<birch::type::Distribution<birch::type::LLT>>>& compare, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr) override;
  
  #line 4 "src/expression/MultivariateSubtract.birch"
  LIBBIRCH_CLASS(MultivariateSubtract, MultivariateBinaryExpression<libbirch::Lazy<libbirch::Shared<birch::type::Expression<libbirch::DefaultArray<birch::type::Real,1>>>>, libbirch::Lazy<libbirch::Shared<birch::type::Expression<libbirch::DefaultArray<birch::type::Real,1>>>>, libbirch::DefaultArray<birch::type::Real,1>, libbirch::DefaultArray<birch::type::Real,1>, libbirch::DefaultArray<birch::type::Real,1>, libbirch::DefaultArray<birch::type::Real,1>, libbirch::DefaultArray<birch::type::Real,1>>)
  #line 4 "src/expression/MultivariateSubtract.birch"
  LIBBIRCH_MEMBERS()
};

template<class Value>
#line 4 "src/expression/MultivariateJoin.birch"
class MultivariateJoin final : public MultivariateExpression<libbirch::DefaultArray<Value,1>> {
public:
  #line 4 "src/expression/MultivariateJoin.birch"
  using class_type_ = MultivariateJoin<Value>;
  #line 4 "src/expression/MultivariateJoin.birch"
  using this_type_ = class_type_;
  #line 4 "src/expression/MultivariateJoin.birch"
  using super_type_ = MultivariateExpression<libbirch::DefaultArray<Value,1>>;

  #line 4 "src/expression/MultivariateJoin.birch"
  using super_type_::operator=;
  #line 4 "src/expression/MultivariateJoin.birch"
  using super_type_::doCompare;
  #line 4 "src/expression/MultivariateJoin.birch"
  using super_type_::doConstant;
  #line 4 "src/expression/MultivariateJoin.birch"
  using super_type_::doCount;
  #line 4 "src/expression/MultivariateJoin.birch"
  using super_type_::doDepth;
  #line 4 "src/expression/MultivariateJoin.birch"
  using super_type_::doDetach;
  #line 4 "src/expression/MultivariateJoin.birch"
  using super_type_::doGet;
  #line 4 "src/expression/MultivariateJoin.birch"
  using super_type_::doGrad;
  #line 4 "src/expression/MultivariateJoin.birch"
  using super_type_::doMove;
  #line 4 "src/expression/MultivariateJoin.birch"
  using super_type_::doPilot;
  #line 4 "src/expression/MultivariateJoin.birch"
  using super_type_::doPrior;
  #line 4 "src/expression/MultivariateJoin.birch"
  using super_type_::doRows;
  #line 4 "src/expression/MultivariateJoin.birch"
  using super_type_::doValue;
  
  #line 4 "src/expression/MultivariateJoin.birch"
  MultivariateJoin(const libbirch::DefaultArray<libbirch::Lazy<libbirch::Shared<birch::type::Expression<Value>>>,1>& x, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);

  libbirch::Optional<libbirch::DefaultArray<libbirch::Lazy<libbirch::Shared<birch::type::Expression<Value>>>,1>> y;
  #line 11 "src/expression/MultivariateJoin.birch"
  virtual birch::type::Integer doDepth(const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr) override;
  #line 19 "src/expression/MultivariateJoin.birch"
  virtual birch::type::Integer doRows(const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr) override;
  #line 23 "src/expression/MultivariateJoin.birch"
  virtual libbirch::DefaultArray<Value,1> doValue(const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr) override;
  #line 29 "src/expression/MultivariateJoin.birch"
  virtual libbirch::DefaultArray<Value,1> doPilot(const birch::type::Integer& gen, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr) override;
  #line 35 "src/expression/MultivariateJoin.birch"
  virtual libbirch::DefaultArray<Value,1> doGet(const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr) override;
  #line 41 "src/expression/MultivariateJoin.birch"
  virtual libbirch::DefaultArray<Value,1> doMove(const birch::type::Integer& gen, const libbirch::Lazy<libbirch::Shared<birch::type::Kernel>>& _u0954, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr) override;
  #line 47 "src/expression/MultivariateJoin.birch"
  virtual void doGrad(const birch::type::Integer& gen, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr) override;
  #line 51 "src/expression/MultivariateJoin.birch"
  virtual libbirch::Optional<libbirch::Lazy<libbirch::Shared<birch::type::Expression<birch::type::Real>>>> doPrior(const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr) override;
  #line 67 "src/expression/MultivariateJoin.birch"
  virtual birch::type::Real doCompare(const birch::type::Integer& gen, const libbirch::Lazy<libbirch::Shared<birch::type::DelayExpression>>& x, const libbirch::Lazy<libbirch::Shared<birch::type::Kernel>>& _u0954, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr) override;
  #line 84 "src/expression/MultivariateJoin.birch"
  virtual void doCount(const birch::type::Integer& gen, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr) override;
  #line 88 "src/expression/MultivariateJoin.birch"
  virtual void doConstant(const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr) override;
  #line 92 "src/expression/MultivariateJoin.birch"
  virtual void doDetach(const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr) override;
  
  #line 4 "src/expression/MultivariateJoin.birch"
  LIBBIRCH_CLASS(MultivariateJoin, MultivariateExpression<libbirch::DefaultArray<Value,1>>)
  #line 4 "src/expression/MultivariateJoin.birch"
  LIBBIRCH_MEMBERS(y)
};

template<class Argument,class ArgumentValue,class ArgumentGradient,class Value>
#line 12 "src/expression/MultivariateUnaryExpression.birch"
class MultivariateUnaryExpression : public MultivariateExpression<Value> {
public:
  #line 12 "src/expression/MultivariateUnaryExpression.birch"
  using class_type_ = MultivariateUnaryExpression<Argument, ArgumentValue, ArgumentGradient, Value>;
  #line 12 "src/expression/MultivariateUnaryExpression.birch"
  using this_type_ = class_type_;
  #line 12 "src/expression/MultivariateUnaryExpression.birch"
  using super_type_ = MultivariateExpression<Value>;

  #line 12 "src/expression/MultivariateUnaryExpression.birch"
  using super_type_::operator=;
  #line 12 "src/expression/MultivariateUnaryExpression.birch"
  using super_type_::doCompare;
  #line 12 "src/expression/MultivariateUnaryExpression.birch"
  using super_type_::doConstant;
  #line 12 "src/expression/MultivariateUnaryExpression.birch"
  using super_type_::doCount;
  #line 12 "src/expression/MultivariateUnaryExpression.birch"
  using super_type_::doDepth;
  #line 12 "src/expression/MultivariateUnaryExpression.birch"
  using super_type_::doDetach;
  #line 12 "src/expression/MultivariateUnaryExpression.birch"
  using super_type_::doGet;
  #line 12 "src/expression/MultivariateUnaryExpression.birch"
  using super_type_::doGrad;
  #line 12 "src/expression/MultivariateUnaryExpression.birch"
  using super_type_::doMove;
  #line 12 "src/expression/MultivariateUnaryExpression.birch"
  using super_type_::doPilot;
  #line 12 "src/expression/MultivariateUnaryExpression.birch"
  using super_type_::doPrior;
  #line 12 "src/expression/MultivariateUnaryExpression.birch"
  using super_type_::doValue;
  
  #line 12 "src/expression/MultivariateUnaryExpression.birch"
  MultivariateUnaryExpression(const Argument& y, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);

  libbirch::Optional<Argument> y;
  #line 22 "src/expression/MultivariateUnaryExpression.birch"
  virtual Value doEvaluate(const ArgumentValue& y, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr) = 0;
  #line 27 "src/expression/MultivariateUnaryExpression.birch"
  virtual ArgumentGradient doEvaluateGrad(const libbirch::DefaultArray<birch::type::Real,1>& d, const Value& x, const ArgumentValue& y, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr) = 0;
  #line 30 "src/expression/MultivariateUnaryExpression.birch"
  virtual birch::type::Integer doDepth(const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr) final;
  #line 34 "src/expression/MultivariateUnaryExpression.birch"
  virtual Value doValue(const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr) final;
  #line 38 "src/expression/MultivariateUnaryExpression.birch"
  virtual Value doPilot(const birch::type::Integer& gen, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr) final;
  #line 42 "src/expression/MultivariateUnaryExpression.birch"
  virtual Value doGet(const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr) final;
  #line 46 "src/expression/MultivariateUnaryExpression.birch"
  virtual Value doMove(const birch::type::Integer& gen, const libbirch::Lazy<libbirch::Shared<birch::type::Kernel>>& _u0954, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr) final;
  #line 50 "src/expression/MultivariateUnaryExpression.birch"
  virtual void doGrad(const birch::type::Integer& gen, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr) final;
  #line 54 "src/expression/MultivariateUnaryExpression.birch"
  virtual libbirch::Optional<libbirch::Lazy<libbirch::Shared<birch::type::Expression<birch::type::Real>>>> doPrior(const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr) final;
  #line 58 "src/expression/MultivariateUnaryExpression.birch"
  virtual birch::type::Real doCompare(const birch::type::Integer& gen, const libbirch::Lazy<libbirch::Shared<birch::type::DelayExpression>>& x, const libbirch::Lazy<libbirch::Shared<birch::type::Kernel>>& _u0954, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr) final;
  #line 65 "src/expression/MultivariateUnaryExpression.birch"
  virtual void doConstant(const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr) final;
  #line 69 "src/expression/MultivariateUnaryExpression.birch"
  virtual void doCount(const birch::type::Integer& gen, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr) final;
  #line 73 "src/expression/MultivariateUnaryExpression.birch"
  virtual void doDetach(const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr) final;
  
  #line 12 "src/expression/MultivariateUnaryExpression.birch"
  LIBBIRCH_ABSTRACT_CLASS(MultivariateUnaryExpression, MultivariateExpression<Value>)
  #line 12 "src/expression/MultivariateUnaryExpression.birch"
  LIBBIRCH_MEMBERS(y)
};

#line 4 "src/expression/MultivariateRectify.birch"
class MultivariateRectify final : public MultivariateUnaryExpression<libbirch::Lazy<libbirch::Shared<birch::type::Expression<libbirch::DefaultArray<birch::type::Real,1>>>>, libbirch::DefaultArray<birch::type::Real,1>, libbirch::DefaultArray<birch::type::Real,1>, libbirch::DefaultArray<birch::type::Real,1>> {
public:
  #line 4 "src/expression/MultivariateRectify.birch"
  using class_type_ = MultivariateRectify;
  #line 4 "src/expression/MultivariateRectify.birch"
  using this_type_ = class_type_;
  #line 4 "src/expression/MultivariateRectify.birch"
  using super_type_ = MultivariateUnaryExpression<libbirch::Lazy<libbirch::Shared<birch::type::Expression<libbirch::DefaultArray<birch::type::Real,1>>>>, libbirch::DefaultArray<birch::type::Real,1>, libbirch::DefaultArray<birch::type::Real,1>, libbirch::DefaultArray<birch::type::Real,1>>;

  #line 4 "src/expression/MultivariateRectify.birch"
  using super_type_::operator=;
  #line 4 "src/expression/MultivariateRectify.birch"
  using super_type_::doEvaluate;
  #line 4 "src/expression/MultivariateRectify.birch"
  using super_type_::doEvaluateGrad;
  #line 4 "src/expression/MultivariateRectify.birch"
  using super_type_::doRows;
  
  #line 4 "src/expression/MultivariateRectify.birch"
  MultivariateRectify(const libbirch::Lazy<libbirch::Shared<birch::type::Expression<libbirch::DefaultArray<birch::type::Real,1>>>>& y, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);

  #line 7 "src/expression/MultivariateRectify.birch"
  virtual birch::type::Integer doRows(const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr) override;
  #line 11 "src/expression/MultivariateRectify.birch"
  virtual libbirch::DefaultArray<birch::type::Real,1> doEvaluate(const libbirch::DefaultArray<birch::type::Real,1>& y, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr) override;
  #line 15 "src/expression/MultivariateRectify.birch"
  virtual libbirch::DefaultArray<birch::type::Real,1> doEvaluateGrad(const libbirch::DefaultArray<birch::type::Real,1>& d, const libbirch::DefaultArray<birch::type::Real,1>& x, const libbirch::DefaultArray<birch::type::Real,1>& y, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr) override;
  
  #line 4 "src/expression/MultivariateRectify.birch"
  LIBBIRCH_CLASS(MultivariateRectify, MultivariateUnaryExpression<libbirch::Lazy<libbirch::Shared<birch::type::Expression<libbirch::DefaultArray<birch::type::Real,1>>>>, libbirch::DefaultArray<birch::type::Real,1>, libbirch::DefaultArray<birch::type::Real,1>, libbirch::DefaultArray<birch::type::Real,1>>)
  #line 4 "src/expression/MultivariateRectify.birch"
  LIBBIRCH_MEMBERS()
};

#line 4 "src/expression/MultivariateNegate.birch"
class MultivariateNegate final : public MultivariateUnaryExpression<libbirch::Lazy<libbirch::Shared<birch::type::Expression<libbirch::DefaultArray<birch::type::Real,1>>>>, libbirch::DefaultArray<birch::type::Real,1>, libbirch::DefaultArray<birch::type::Real,1>, libbirch::DefaultArray<birch::type::Real,1>> {
public:
  #line 4 "src/expression/MultivariateNegate.birch"
  using class_type_ = MultivariateNegate;
  #line 4 "src/expression/MultivariateNegate.birch"
  using this_type_ = class_type_;
  #line 4 "src/expression/MultivariateNegate.birch"
  using super_type_ = MultivariateUnaryExpression<libbirch::Lazy<libbirch::Shared<birch::type::Expression<libbirch::DefaultArray<birch::type::Real,1>>>>, libbirch::DefaultArray<birch::type::Real,1>, libbirch::DefaultArray<birch::type::Real,1>, libbirch::DefaultArray<birch::type::Real,1>>;

  #line 4 "src/expression/MultivariateNegate.birch"
  using super_type_::operator=;
  #line 4 "src/expression/MultivariateNegate.birch"
  using super_type_::doEvaluate;
  #line 4 "src/expression/MultivariateNegate.birch"
  using super_type_::doEvaluateGrad;
  #line 4 "src/expression/MultivariateNegate.birch"
  using super_type_::doRows;
  #line 4 "src/expression/MultivariateNegate.birch"
  using super_type_::graftLinearMultivariateGaussian;
  #line 4 "src/expression/MultivariateNegate.birch"
  using super_type_::graftLinearMultivariateNormalInverseGamma;
  
  #line 4 "src/expression/MultivariateNegate.birch"
  MultivariateNegate(const libbirch::Lazy<libbirch::Shared<birch::type::Expression<libbirch::DefaultArray<birch::type::Real,1>>>>& y, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);

  #line 7 "src/expression/MultivariateNegate.birch"
  virtual birch::type::Integer doRows(const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr) override;
  #line 11 "src/expression/MultivariateNegate.birch"
  virtual libbirch::DefaultArray<birch::type::Real,1> doEvaluate(const libbirch::DefaultArray<birch::type::Real,1>& y, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr) override;
  #line 15 "src/expression/MultivariateNegate.birch"
  virtual libbirch::DefaultArray<birch::type::Real,1> doEvaluateGrad(const libbirch::DefaultArray<birch::type::Real,1>& d, const libbirch::DefaultArray<birch::type::Real,1>& x, const libbirch::DefaultArray<birch::type::Real,1>& y, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr) override;
  #line 20 "src/expression/MultivariateNegate.birch"
  virtual libbirch::Optional<libbirch::Lazy<libbirch::Shared<birch::type::TransformLinearMultivariate<libbirch::Lazy<libbirch::Shared<birch::type::MultivariateGaussian>>>>>> graftLinearMultivariateGaussian(const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr) override;
  #line 37 "src/expression/MultivariateNegate.birch"
  virtual libbirch::Optional<libbirch::Lazy<libbirch::Shared<birch::type::TransformLinearMultivariate<libbirch::Lazy<libbirch::Shared<birch::type::MultivariateNormalInverseGamma>>>>>> graftLinearMultivariateNormalInverseGamma(const libbirch::Lazy<libbirch::Shared<birch::type::Distribution<birch::type::Real>>>& compare, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr) override;
  
  #line 4 "src/expression/MultivariateNegate.birch"
  LIBBIRCH_CLASS(MultivariateNegate, MultivariateUnaryExpression<libbirch::Lazy<libbirch::Shared<birch::type::Expression<libbirch::DefaultArray<birch::type::Real,1>>>>, libbirch::DefaultArray<birch::type::Real,1>, libbirch::DefaultArray<birch::type::Real,1>, libbirch::DefaultArray<birch::type::Real,1>>)
  #line 4 "src/expression/MultivariateNegate.birch"
  LIBBIRCH_MEMBERS()
};

#line 4 "src/expression/MultivariateDiagonal.birch"
class MultivariateDiagonal final : public MultivariateUnaryExpression<libbirch::Lazy<libbirch::Shared<birch::type::Expression<libbirch::DefaultArray<birch::type::Real,2>>>>, libbirch::DefaultArray<birch::type::Real,2>, libbirch::DefaultArray<birch::type::Real,2>, libbirch::DefaultArray<birch::type::Real,1>> {
public:
  #line 4 "src/expression/MultivariateDiagonal.birch"
  using class_type_ = MultivariateDiagonal;
  #line 4 "src/expression/MultivariateDiagonal.birch"
  using this_type_ = class_type_;
  #line 4 "src/expression/MultivariateDiagonal.birch"
  using super_type_ = MultivariateUnaryExpression<libbirch::Lazy<libbirch::Shared<birch::type::Expression<libbirch::DefaultArray<birch::type::Real,2>>>>, libbirch::DefaultArray<birch::type::Real,2>, libbirch::DefaultArray<birch::type::Real,2>, libbirch::DefaultArray<birch::type::Real,1>>;

  #line 4 "src/expression/MultivariateDiagonal.birch"
  using super_type_::operator=;
  #line 4 "src/expression/MultivariateDiagonal.birch"
  using super_type_::doEvaluate;
  #line 4 "src/expression/MultivariateDiagonal.birch"
  using super_type_::doEvaluateGrad;
  #line 4 "src/expression/MultivariateDiagonal.birch"
  using super_type_::doRows;
  
  #line 4 "src/expression/MultivariateDiagonal.birch"
  MultivariateDiagonal(const libbirch::Lazy<libbirch::Shared<birch::type::Expression<libbirch::DefaultArray<birch::type::Real,2>>>>& y, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);

  #line 7 "src/expression/MultivariateDiagonal.birch"
  virtual birch::type::Integer doRows(const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr) override;
  #line 11 "src/expression/MultivariateDiagonal.birch"
  virtual libbirch::DefaultArray<birch::type::Real,1> doEvaluate(const libbirch::DefaultArray<birch::type::Real,2>& y, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr) override;
  #line 15 "src/expression/MultivariateDiagonal.birch"
  virtual libbirch::DefaultArray<birch::type::Real,2> doEvaluateGrad(const libbirch::DefaultArray<birch::type::Real,1>& d, const libbirch::DefaultArray<birch::type::Real,1>& x, const libbirch::DefaultArray<birch::type::Real,2>& y, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr) override;
  
  #line 4 "src/expression/MultivariateDiagonal.birch"
  LIBBIRCH_CLASS(MultivariateDiagonal, MultivariateUnaryExpression<libbirch::Lazy<libbirch::Shared<birch::type::Expression<libbirch::DefaultArray<birch::type::Real,2>>>>, libbirch::DefaultArray<birch::type::Real,2>, libbirch::DefaultArray<birch::type::Real,2>, libbirch::DefaultArray<birch::type::Real,1>>)
  #line 4 "src/expression/MultivariateDiagonal.birch"
  LIBBIRCH_MEMBERS()
};

#line 4 "src/expression/MultivariateCanonical.birch"
class MultivariateCanonical final : public MultivariateUnaryExpression<libbirch::Lazy<libbirch::Shared<birch::type::Expression<libbirch::DefaultArray<birch::type::Real,1>>>>, libbirch::DefaultArray<birch::type::Real,1>, libbirch::DefaultArray<birch::type::Real,1>, libbirch::DefaultArray<birch::type::Real,1>> {
public:
  #line 4 "src/expression/MultivariateCanonical.birch"
  using class_type_ = MultivariateCanonical;
  #line 4 "src/expression/MultivariateCanonical.birch"
  using this_type_ = class_type_;
  #line 4 "src/expression/MultivariateCanonical.birch"
  using super_type_ = MultivariateUnaryExpression<libbirch::Lazy<libbirch::Shared<birch::type::Expression<libbirch::DefaultArray<birch::type::Real,1>>>>, libbirch::DefaultArray<birch::type::Real,1>, libbirch::DefaultArray<birch::type::Real,1>, libbirch::DefaultArray<birch::type::Real,1>>;

  #line 4 "src/expression/MultivariateCanonical.birch"
  using super_type_::operator=;
  #line 4 "src/expression/MultivariateCanonical.birch"
  using super_type_::doEvaluate;
  #line 4 "src/expression/MultivariateCanonical.birch"
  using super_type_::doEvaluateGrad;
  #line 4 "src/expression/MultivariateCanonical.birch"
  using super_type_::doRows;
  
  #line 4 "src/expression/MultivariateCanonical.birch"
  MultivariateCanonical(const libbirch::Lazy<libbirch::Shared<birch::type::Expression<libbirch::DefaultArray<birch::type::Real,1>>>>& y, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);

  #line 7 "src/expression/MultivariateCanonical.birch"
  virtual birch::type::Integer doRows(const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr) override;
  #line 11 "src/expression/MultivariateCanonical.birch"
  virtual libbirch::DefaultArray<birch::type::Real,1> doEvaluate(const libbirch::DefaultArray<birch::type::Real,1>& y, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr) override;
  #line 15 "src/expression/MultivariateCanonical.birch"
  virtual libbirch::DefaultArray<birch::type::Real,1> doEvaluateGrad(const libbirch::DefaultArray<birch::type::Real,1>& d, const libbirch::DefaultArray<birch::type::Real,1>& x, const libbirch::DefaultArray<birch::type::Real,1>& y, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr) override;
  
  #line 4 "src/expression/MultivariateCanonical.birch"
  LIBBIRCH_CLASS(MultivariateCanonical, MultivariateUnaryExpression<libbirch::Lazy<libbirch::Shared<birch::type::Expression<libbirch::DefaultArray<birch::type::Real,1>>>>, libbirch::DefaultArray<birch::type::Real,1>, libbirch::DefaultArray<birch::type::Real,1>, libbirch::DefaultArray<birch::type::Real,1>>)
  #line 4 "src/expression/MultivariateCanonical.birch"
  LIBBIRCH_MEMBERS()
};

#line 4 "src/expression/MultivariateAbs.birch"
class MultivariateAbs final : public MultivariateUnaryExpression<libbirch::Lazy<libbirch::Shared<birch::type::Expression<libbirch::DefaultArray<birch::type::Real,1>>>>, libbirch::DefaultArray<birch::type::Real,1>, libbirch::DefaultArray<birch::type::Real,1>, libbirch::DefaultArray<birch::type::Real,1>> {
public:
  #line 4 "src/expression/MultivariateAbs.birch"
  using class_type_ = MultivariateAbs;
  #line 4 "src/expression/MultivariateAbs.birch"
  using this_type_ = class_type_;
  #line 4 "src/expression/MultivariateAbs.birch"
  using super_type_ = MultivariateUnaryExpression<libbirch::Lazy<libbirch::Shared<birch::type::Expression<libbirch::DefaultArray<birch::type::Real,1>>>>, libbirch::DefaultArray<birch::type::Real,1>, libbirch::DefaultArray<birch::type::Real,1>, libbirch::DefaultArray<birch::type::Real,1>>;

  #line 4 "src/expression/MultivariateAbs.birch"
  using super_type_::operator=;
  #line 4 "src/expression/MultivariateAbs.birch"
  using super_type_::doEvaluate;
  #line 4 "src/expression/MultivariateAbs.birch"
  using super_type_::doEvaluateGrad;
  #line 4 "src/expression/MultivariateAbs.birch"
  using super_type_::doRows;
  
  #line 4 "src/expression/MultivariateAbs.birch"
  MultivariateAbs(const libbirch::Lazy<libbirch::Shared<birch::type::Expression<libbirch::DefaultArray<birch::type::Real,1>>>>& y, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);

  #line 7 "src/expression/MultivariateAbs.birch"
  virtual birch::type::Integer doRows(const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr) override;
  #line 11 "src/expression/MultivariateAbs.birch"
  virtual libbirch::DefaultArray<birch::type::Real,1> doEvaluate(const libbirch::DefaultArray<birch::type::Real,1>& y, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr) override;
  #line 15 "src/expression/MultivariateAbs.birch"
  virtual libbirch::DefaultArray<birch::type::Real,1> doEvaluateGrad(const libbirch::DefaultArray<birch::type::Real,1>& d, const libbirch::DefaultArray<birch::type::Real,1>& x, const libbirch::DefaultArray<birch::type::Real,1>& y, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr) override;
  
  #line 4 "src/expression/MultivariateAbs.birch"
  LIBBIRCH_CLASS(MultivariateAbs, MultivariateUnaryExpression<libbirch::Lazy<libbirch::Shared<birch::type::Expression<libbirch::DefaultArray<birch::type::Real,1>>>>, libbirch::DefaultArray<birch::type::Real,1>, libbirch::DefaultArray<birch::type::Real,1>, libbirch::DefaultArray<birch::type::Real,1>>)
  #line 4 "src/expression/MultivariateAbs.birch"
  LIBBIRCH_MEMBERS()
};

template<class Value>
#line 13 "src/expression/Random.birch"
class Random final : public Expression<Value> {
public:
  #line 13 "src/expression/Random.birch"
  using class_type_ = Random<Value>;
  #line 13 "src/expression/Random.birch"
  using this_type_ = class_type_;
  #line 13 "src/expression/Random.birch"
  using super_type_ = Expression<Value>;

  #line 13 "src/expression/Random.birch"
  using super_type_::operator=;
  #line 13 "src/expression/Random.birch"
  using super_type_::distribution;
  #line 13 "src/expression/Random.birch"
  using super_type_::doAccumulateGrad;
  #line 13 "src/expression/Random.birch"
  using super_type_::doClearGrad;
  #line 13 "src/expression/Random.birch"
  using super_type_::doColumns;
  #line 13 "src/expression/Random.birch"
  using super_type_::doCompare;
  #line 13 "src/expression/Random.birch"
  using super_type_::doConstant;
  #line 13 "src/expression/Random.birch"
  using super_type_::doCount;
  #line 13 "src/expression/Random.birch"
  using super_type_::doDepth;
  #line 13 "src/expression/Random.birch"
  using super_type_::doDetach;
  #line 13 "src/expression/Random.birch"
  using super_type_::doGet;
  #line 13 "src/expression/Random.birch"
  using super_type_::doGrad;
  #line 13 "src/expression/Random.birch"
  using super_type_::doMove;
  #line 13 "src/expression/Random.birch"
  using super_type_::doPilot;
  #line 13 "src/expression/Random.birch"
  using super_type_::doPrior;
  #line 13 "src/expression/Random.birch"
  using super_type_::doRows;
  #line 13 "src/expression/Random.birch"
  using super_type_::doValue;
  #line 13 "src/expression/Random.birch"
  using super_type_::graftBeta;
  #line 13 "src/expression/Random.birch"
  using super_type_::graftBoundedDiscrete;
  #line 13 "src/expression/Random.birch"
  using super_type_::graftDirichlet;
  #line 13 "src/expression/Random.birch"
  using super_type_::graftDiscrete;
  #line 13 "src/expression/Random.birch"
  using super_type_::graftGamma;
  #line 13 "src/expression/Random.birch"
  using super_type_::graftGaussian;
  #line 13 "src/expression/Random.birch"
  using super_type_::graftInverseGamma;
  #line 13 "src/expression/Random.birch"
  using super_type_::graftInverseWishart;
  #line 13 "src/expression/Random.birch"
  using super_type_::graftMatrixGaussian;
  #line 13 "src/expression/Random.birch"
  using super_type_::graftMatrixNormalInverseWishart;
  #line 13 "src/expression/Random.birch"
  using super_type_::graftMultivariateGaussian;
  #line 13 "src/expression/Random.birch"
  using super_type_::graftMultivariateNormalInverseGamma;
  #line 13 "src/expression/Random.birch"
  using super_type_::graftNormalInverseGamma;
  #line 13 "src/expression/Random.birch"
  using super_type_::graftRestaurant;
  #line 13 "src/expression/Random.birch"
  using super_type_::isRandom;
  #line 13 "src/expression/Random.birch"
  using super_type_::write;
  
  #line 13 "src/expression/Random.birch"
  Random(const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);

  libbirch::Optional<libbirch::Lazy<libbirch::Shared<birch::type::Distribution<Value>>>> p;
  libbirch::Optional<Value> d;
  #line 27 "src/expression/Random.birch"
  virtual Random<Value>& operator=(const Value& x);
  #line 37 "src/expression/Random.birch"
  virtual Random<Value>& operator=(const libbirch::Optional<Value>& x);
  #line 43 "src/expression/Random.birch"
  virtual libbirch::Optional<libbirch::Lazy<libbirch::Shared<birch::type::Distribution<Value>>>> distribution(const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr) override;
  #line 47 "src/expression/Random.birch"
  virtual birch::type::Boolean isRandom(const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr) override;
  #line 54 "src/expression/Random.birch"
  virtual birch::type::Boolean hasDistribution(const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
  #line 61 "src/expression/Random.birch"
  virtual libbirch::Lazy<libbirch::Shared<birch::type::Distribution<Value>>> getDistribution(const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
  #line 68 "src/expression/Random.birch"
  virtual birch::type::Boolean hasGradient(const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
  #line 76 "src/expression/Random.birch"
  virtual Value getGradient(const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
  #line 87 "src/expression/Random.birch"
  virtual void assume(const libbirch::Lazy<libbirch::Shared<birch::type::Distribution<Value>>>& p, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
  #line 99 "src/expression/Random.birch"
  virtual void setPilot(const birch::type::Integer& gen, const Value& x, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
  #line 108 "src/expression/Random.birch"
  virtual birch::type::Integer doDepth(const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr) override;
  #line 112 "src/expression/Random.birch"
  virtual birch::type::Integer doRows(const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr) override;
  #line 116 "src/expression/Random.birch"
  virtual birch::type::Integer doColumns(const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr) override;
  #line 120 "src/expression/Random.birch"
  virtual Value doValue(const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr) override;
  #line 130 "src/expression/Random.birch"
  virtual Value doPilot(const birch::type::Integer& gen, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr) override;
  #line 134 "src/expression/Random.birch"
  virtual Value doGet(const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr) override;
  #line 155 "src/expression/Random.birch"
  virtual Value doMove(const birch::type::Integer& gen, const libbirch::Lazy<libbirch::Shared<birch::type::Kernel>>& _u0954, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr) override;
  #line 159 "src/expression/Random.birch"
  virtual libbirch::Optional<libbirch::Lazy<libbirch::Shared<birch::type::Expression<birch::type::Real>>>> doPrior(const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr) override;
  #line 175 "src/expression/Random.birch"
  virtual birch::type::Real doCompare(const birch::type::Integer& gen, const libbirch::Lazy<libbirch::Shared<birch::type::DelayExpression>>& x, const libbirch::Lazy<libbirch::Shared<birch::type::Kernel>>& _u0954, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr) override;
  #line 181 "src/expression/Random.birch"
  virtual void doAccumulateGrad(const Value& d, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
  #line 192 "src/expression/Random.birch"
  virtual void doGrad(const birch::type::Integer& gen, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr) override;
  #line 196 "src/expression/Random.birch"
  virtual void doClearGrad(const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr) override;
  #line 200 "src/expression/Random.birch"
  virtual void doCount(const birch::type::Integer& gen, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr) override;
  #line 204 "src/expression/Random.birch"
  virtual void doConstant(const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr) override;
  #line 208 "src/expression/Random.birch"
  virtual void doDetach(const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr) override;
  #line 212 "src/expression/Random.birch"
  virtual libbirch::Optional<libbirch::Lazy<libbirch::Shared<birch::type::Gaussian>>> graftGaussian(const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr) override;
  #line 221 "src/expression/Random.birch"
  virtual libbirch::Optional<libbirch::Lazy<libbirch::Shared<birch::type::Beta>>> graftBeta(const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr) override;
  #line 230 "src/expression/Random.birch"
  virtual libbirch::Optional<libbirch::Lazy<libbirch::Shared<birch::type::Gamma>>> graftGamma(const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr) override;
  #line 239 "src/expression/Random.birch"
  virtual libbirch::Optional<libbirch::Lazy<libbirch::Shared<birch::type::InverseGamma>>> graftInverseGamma(const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr) override;
  #line 248 "src/expression/Random.birch"
  virtual libbirch::Optional<libbirch::Lazy<libbirch::Shared<birch::type::InverseWishart>>> graftInverseWishart(const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr) override;
  #line 257 "src/expression/Random.birch"
  virtual libbirch::Optional<libbirch::Lazy<libbirch::Shared<birch::type::NormalInverseGamma>>> graftNormalInverseGamma(const libbirch::Lazy<libbirch::Shared<birch::type::Distribution<birch::type::Real>>>& compare, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr) override;
  #line 266 "src/expression/Random.birch"
  virtual libbirch::Optional<libbirch::Lazy<libbirch::Shared<birch::type::Dirichlet>>> graftDirichlet(const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr) override;
  #line 275 "src/expression/Random.birch"
  virtual libbirch::Optional<libbirch::Lazy<libbirch::Shared<birch::type::Restaurant>>> graftRestaurant(const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr) override;
  #line 284 "src/expression/Random.birch"
  virtual libbirch::Optional<libbirch::Lazy<libbirch::Shared<birch::type::MultivariateGaussian>>> graftMultivariateGaussian(const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr) override;
  #line 293 "src/expression/Random.birch"
  virtual libbirch::Optional<libbirch::Lazy<libbirch::Shared<birch::type::MultivariateNormalInverseGamma>>> graftMultivariateNormalInverseGamma(const libbirch::Lazy<libbirch::Shared<birch::type::Distribution<birch::type::Real>>>& compare, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr) override;
  #line 303 "src/expression/Random.birch"
  virtual libbirch::Optional<libbirch::Lazy<libbirch::Shared<birch::type::MatrixGaussian>>> graftMatrixGaussian(const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr) override;
  #line 312 "src/expression/Random.birch"
  virtual libbirch::Optional<libbirch::Lazy<libbirch::Shared<birch::type::MatrixNormalInverseWishart>>> graftMatrixNormalInverseWishart(const libbirch::Lazy<libbirch::Shared<birch::type::Distribution<birch::type::LLT>>>& compare, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr) override;
  #line 322 "src/expression/Random.birch"
  virtual libbirch::Optional<libbirch::Lazy<libbirch::Shared<birch::type::Discrete>>> graftDiscrete(const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr) override;
  #line 331 "src/expression/Random.birch"
  virtual libbirch::Optional<libbirch::Lazy<libbirch::Shared<birch::type::BoundedDiscrete>>> graftBoundedDiscrete(const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr) override;
  #line 340 "src/expression/Random.birch"
  virtual void read(const libbirch::Lazy<libbirch::Shared<birch::type::Buffer>>& buffer, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
  #line 344 "src/expression/Random.birch"
  virtual void write(const libbirch::Lazy<libbirch::Shared<birch::type::Buffer>>& buffer, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
  
  #line 13 "src/expression/Random.birch"
  LIBBIRCH_CLASS(Random, Expression<Value>)
  #line 13 "src/expression/Random.birch"
  LIBBIRCH_MEMBERS(p, d)
};

template<class Value>
#line 6 "src/expression/ScalarExpression.birch"
class ScalarExpression : public Expression<Value> {
public:
  #line 6 "src/expression/ScalarExpression.birch"
  using class_type_ = ScalarExpression<Value>;
  #line 6 "src/expression/ScalarExpression.birch"
  using this_type_ = class_type_;
  #line 6 "src/expression/ScalarExpression.birch"
  using super_type_ = Expression<Value>;

  #line 6 "src/expression/ScalarExpression.birch"
  using super_type_::operator=;
  #line 6 "src/expression/ScalarExpression.birch"
  using super_type_::doAccumulateGrad;
  #line 6 "src/expression/ScalarExpression.birch"
  using super_type_::doClearGrad;
  #line 6 "src/expression/ScalarExpression.birch"
  using super_type_::doColumns;
  #line 6 "src/expression/ScalarExpression.birch"
  using super_type_::doRows;
  
  #line 6 "src/expression/ScalarExpression.birch"
  ScalarExpression(const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);

  libbirch::Optional<birch::type::Real> d;
  #line 12 "src/expression/ScalarExpression.birch"
  virtual birch::type::Integer doRows(const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr) final;
  #line 16 "src/expression/ScalarExpression.birch"
  virtual birch::type::Integer doColumns(const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr) final;
  #line 20 "src/expression/ScalarExpression.birch"
  virtual void doAccumulateGrad(const birch::type::Real& d, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr) final;
  #line 28 "src/expression/ScalarExpression.birch"
  virtual void doClearGrad(const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr) final;
  
  #line 6 "src/expression/ScalarExpression.birch"
  LIBBIRCH_ABSTRACT_CLASS(ScalarExpression, Expression<Value>)
  #line 6 "src/expression/ScalarExpression.birch"
  LIBBIRCH_MEMBERS(d)
};

template<class Left,class Right,class LeftValue,class RightValue,class LeftGradient,class RightGradient,class Value>
#line 18 "src/expression/ScalarBinaryExpression.birch"
class ScalarBinaryExpression : public ScalarExpression<Value> {
public:
  #line 18 "src/expression/ScalarBinaryExpression.birch"
  using class_type_ = ScalarBinaryExpression<Left, Right, LeftValue, RightValue, LeftGradient, RightGradient, Value>;
  #line 18 "src/expression/ScalarBinaryExpression.birch"
  using this_type_ = class_type_;
  #line 18 "src/expression/ScalarBinaryExpression.birch"
  using super_type_ = ScalarExpression<Value>;

  #line 18 "src/expression/ScalarBinaryExpression.birch"
  using super_type_::operator=;
  #line 18 "src/expression/ScalarBinaryExpression.birch"
  using super_type_::doCompare;
  #line 18 "src/expression/ScalarBinaryExpression.birch"
  using super_type_::doConstant;
  #line 18 "src/expression/ScalarBinaryExpression.birch"
  using super_type_::doCount;
  #line 18 "src/expression/ScalarBinaryExpression.birch"
  using super_type_::doDepth;
  #line 18 "src/expression/ScalarBinaryExpression.birch"
  using super_type_::doDetach;
  #line 18 "src/expression/ScalarBinaryExpression.birch"
  using super_type_::doGet;
  #line 18 "src/expression/ScalarBinaryExpression.birch"
  using super_type_::doGrad;
  #line 18 "src/expression/ScalarBinaryExpression.birch"
  using super_type_::doMove;
  #line 18 "src/expression/ScalarBinaryExpression.birch"
  using super_type_::doPilot;
  #line 18 "src/expression/ScalarBinaryExpression.birch"
  using super_type_::doPrior;
  #line 18 "src/expression/ScalarBinaryExpression.birch"
  using super_type_::doValue;
  
  #line 18 "src/expression/ScalarBinaryExpression.birch"
  ScalarBinaryExpression(const Left& y, const Right& z, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);

  libbirch::Optional<Left> y;
  libbirch::Optional<Right> z;
  #line 34 "src/expression/ScalarBinaryExpression.birch"
  virtual Value doEvaluate(const LeftValue& y, const RightValue& z, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr) = 0;
  #line 39 "src/expression/ScalarBinaryExpression.birch"
  virtual LeftGradient doEvaluateGradLeft(const birch::type::Real& d, const Value& x, const LeftValue& y, const RightValue& z, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr) = 0;
  #line 45 "src/expression/ScalarBinaryExpression.birch"
  virtual RightGradient doEvaluateGradRight(const birch::type::Real& d, const Value& x, const LeftValue& y, const RightValue& z, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr) = 0;
  #line 49 "src/expression/ScalarBinaryExpression.birch"
  virtual birch::type::Integer doDepth(const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr) final;
  #line 53 "src/expression/ScalarBinaryExpression.birch"
  virtual Value doValue(const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr) final;
  #line 57 "src/expression/ScalarBinaryExpression.birch"
  virtual Value doPilot(const birch::type::Integer& gen, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr) final;
  #line 61 "src/expression/ScalarBinaryExpression.birch"
  virtual Value doGet(const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr) final;
  #line 65 "src/expression/ScalarBinaryExpression.birch"
  virtual Value doMove(const birch::type::Integer& gen, const libbirch::Lazy<libbirch::Shared<birch::type::Kernel>>& _u0954, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr) final;
  #line 69 "src/expression/ScalarBinaryExpression.birch"
  virtual void doGrad(const birch::type::Integer& gen, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr) final;
  #line 74 "src/expression/ScalarBinaryExpression.birch"
  virtual libbirch::Optional<libbirch::Lazy<libbirch::Shared<birch::type::Expression<birch::type::Real>>>> doPrior(const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr) final;
  #line 88 "src/expression/ScalarBinaryExpression.birch"
  virtual birch::type::Real doCompare(const birch::type::Integer& gen, const libbirch::Lazy<libbirch::Shared<birch::type::DelayExpression>>& x, const libbirch::Lazy<libbirch::Shared<birch::type::Kernel>>& _u0954, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr) final;
  #line 95 "src/expression/ScalarBinaryExpression.birch"
  virtual void doConstant(const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr) final;
  #line 100 "src/expression/ScalarBinaryExpression.birch"
  virtual void doCount(const birch::type::Integer& gen, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr) final;
  #line 105 "src/expression/ScalarBinaryExpression.birch"
  virtual void doDetach(const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr) final;
  
  #line 18 "src/expression/ScalarBinaryExpression.birch"
  LIBBIRCH_ABSTRACT_CLASS(ScalarBinaryExpression, ScalarExpression<Value>)
  #line 18 "src/expression/ScalarBinaryExpression.birch"
  LIBBIRCH_MEMBERS(y, z)
};

#line 4 "src/expression/Pow.birch"
class Pow final : public ScalarBinaryExpression<libbirch::Lazy<libbirch::Shared<birch::type::Expression<birch::type::Real>>>, libbirch::Lazy<libbirch::Shared<birch::type::Expression<birch::type::Real>>>, birch::type::Real, birch::type::Real, birch::type::Real, birch::type::Real, birch::type::Real> {
public:
  #line 4 "src/expression/Pow.birch"
  using class_type_ = Pow;
  #line 4 "src/expression/Pow.birch"
  using this_type_ = class_type_;
  #line 4 "src/expression/Pow.birch"
  using super_type_ = ScalarBinaryExpression<libbirch::Lazy<libbirch::Shared<birch::type::Expression<birch::type::Real>>>, libbirch::Lazy<libbirch::Shared<birch::type::Expression<birch::type::Real>>>, birch::type::Real, birch::type::Real, birch::type::Real, birch::type::Real, birch::type::Real>;

  #line 4 "src/expression/Pow.birch"
  using super_type_::operator=;
  #line 4 "src/expression/Pow.birch"
  using super_type_::doEvaluate;
  #line 4 "src/expression/Pow.birch"
  using super_type_::doEvaluateGradLeft;
  #line 4 "src/expression/Pow.birch"
  using super_type_::doEvaluateGradRight;
  
  #line 4 "src/expression/Pow.birch"
  Pow(const libbirch::Lazy<libbirch::Shared<birch::type::Expression<birch::type::Real>>>& y, const libbirch::Lazy<libbirch::Shared<birch::type::Expression<birch::type::Real>>>& z, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);

  #line 7 "src/expression/Pow.birch"
  virtual birch::type::Real doEvaluate(const birch::type::Real& y, const birch::type::Real& z, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr) override;
  #line 11 "src/expression/Pow.birch"
  virtual birch::type::Real doEvaluateGradLeft(const birch::type::Real& d, const birch::type::Real& x, const birch::type::Real& y, const birch::type::Real& z, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr) override;
  #line 15 "src/expression/Pow.birch"
  virtual birch::type::Real doEvaluateGradRight(const birch::type::Real& d, const birch::type::Real& x, const birch::type::Real& y, const birch::type::Real& z, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr) override;
  
  #line 4 "src/expression/Pow.birch"
  LIBBIRCH_CLASS(Pow, ScalarBinaryExpression<libbirch::Lazy<libbirch::Shared<birch::type::Expression<birch::type::Real>>>, libbirch::Lazy<libbirch::Shared<birch::type::Expression<birch::type::Real>>>, birch::type::Real, birch::type::Real, birch::type::Real, birch::type::Real, birch::type::Real>)
  #line 4 "src/expression/Pow.birch"
  LIBBIRCH_MEMBERS()
};

#line 4 "src/expression/Multiply.birch"
class Multiply final : public ScalarBinaryExpression<libbirch::Lazy<libbirch::Shared<birch::type::Expression<birch::type::Real>>>, libbirch::Lazy<libbirch::Shared<birch::type::Expression<birch::type::Real>>>, birch::type::Real, birch::type::Real, birch::type::Real, birch::type::Real, birch::type::Real> {
public:
  #line 4 "src/expression/Multiply.birch"
  using class_type_ = Multiply;
  #line 4 "src/expression/Multiply.birch"
  using this_type_ = class_type_;
  #line 4 "src/expression/Multiply.birch"
  using super_type_ = ScalarBinaryExpression<libbirch::Lazy<libbirch::Shared<birch::type::Expression<birch::type::Real>>>, libbirch::Lazy<libbirch::Shared<birch::type::Expression<birch::type::Real>>>, birch::type::Real, birch::type::Real, birch::type::Real, birch::type::Real, birch::type::Real>;

  #line 4 "src/expression/Multiply.birch"
  using super_type_::operator=;
  #line 4 "src/expression/Multiply.birch"
  using super_type_::doEvaluate;
  #line 4 "src/expression/Multiply.birch"
  using super_type_::doEvaluateGradLeft;
  #line 4 "src/expression/Multiply.birch"
  using super_type_::doEvaluateGradRight;
  #line 4 "src/expression/Multiply.birch"
  using super_type_::graftDotMultivariateGaussian;
  #line 4 "src/expression/Multiply.birch"
  using super_type_::graftDotMultivariateNormalInverseGamma;
  #line 4 "src/expression/Multiply.birch"
  using super_type_::graftLinearGaussian;
  #line 4 "src/expression/Multiply.birch"
  using super_type_::graftLinearNormalInverseGamma;
  #line 4 "src/expression/Multiply.birch"
  using super_type_::graftScaledGamma;
  
  #line 4 "src/expression/Multiply.birch"
  Multiply(const libbirch::Lazy<libbirch::Shared<birch::type::Expression<birch::type::Real>>>& y, const libbirch::Lazy<libbirch::Shared<birch::type::Expression<birch::type::Real>>>& z, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);

  #line 7 "src/expression/Multiply.birch"
  virtual birch::type::Real doEvaluate(const birch::type::Real& y, const birch::type::Real& z, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr) override;
  #line 11 "src/expression/Multiply.birch"
  virtual birch::type::Real doEvaluateGradLeft(const birch::type::Real& d, const birch::type::Real& x, const birch::type::Real& y, const birch::type::Real& z, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr) override;
  #line 15 "src/expression/Multiply.birch"
  virtual birch::type::Real doEvaluateGradRight(const birch::type::Real& d, const birch::type::Real& x, const birch::type::Real& y, const birch::type::Real& z, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr) override;
  #line 19 "src/expression/Multiply.birch"
  virtual libbirch::Optional<libbirch::Lazy<libbirch::Shared<birch::type::TransformLinear<libbirch::Lazy<libbirch::Shared<birch::type::Gamma>>>>>> graftScaledGamma(const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr) override;
  #line 37 "src/expression/Multiply.birch"
  virtual libbirch::Optional<libbirch::Lazy<libbirch::Shared<birch::type::TransformLinear<libbirch::Lazy<libbirch::Shared<birch::type::Gaussian>>>>>> graftLinearGaussian(const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr) override;
  #line 55 "src/expression/Multiply.birch"
  virtual libbirch::Optional<libbirch::Lazy<libbirch::Shared<birch::type::TransformDot<libbirch::Lazy<libbirch::Shared<birch::type::MultivariateGaussian>>>>>> graftDotMultivariateGaussian(const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr) override;
  #line 68 "src/expression/Multiply.birch"
  virtual libbirch::Optional<libbirch::Lazy<libbirch::Shared<birch::type::TransformLinear<libbirch::Lazy<libbirch::Shared<birch::type::NormalInverseGamma>>>>>> graftLinearNormalInverseGamma(const libbirch::Lazy<libbirch::Shared<birch::type::Distribution<birch::type::Real>>>& compare, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr) override;
  #line 87 "src/expression/Multiply.birch"
  virtual libbirch::Optional<libbirch::Lazy<libbirch::Shared<birch::type::TransformDot<libbirch::Lazy<libbirch::Shared<birch::type::MultivariateNormalInverseGamma>>>>>> graftDotMultivariateNormalInverseGamma(const libbirch::Lazy<libbirch::Shared<birch::type::Distribution<birch::type::Real>>>& compare, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr) override;
  
  #line 4 "src/expression/Multiply.birch"
  LIBBIRCH_CLASS(Multiply, ScalarBinaryExpression<libbirch::Lazy<libbirch::Shared<birch::type::Expression<birch::type::Real>>>, libbirch::Lazy<libbirch::Shared<birch::type::Expression<birch::type::Real>>>, birch::type::Real, birch::type::Real, birch::type::Real, birch::type::Real, birch::type::Real>)
  #line 4 "src/expression/Multiply.birch"
  LIBBIRCH_MEMBERS()
};

#line 4 "src/expression/LogChoose.birch"
class LogChoose final : public ScalarBinaryExpression<libbirch::Lazy<libbirch::Shared<birch::type::Expression<birch::type::Integer>>>, libbirch::Lazy<libbirch::Shared<birch::type::Expression<birch::type::Integer>>>, birch::type::Integer, birch::type::Integer, birch::type::Real, birch::type::Real, birch::type::Real> {
public:
  #line 4 "src/expression/LogChoose.birch"
  using class_type_ = LogChoose;
  #line 4 "src/expression/LogChoose.birch"
  using this_type_ = class_type_;
  #line 4 "src/expression/LogChoose.birch"
  using super_type_ = ScalarBinaryExpression<libbirch::Lazy<libbirch::Shared<birch::type::Expression<birch::type::Integer>>>, libbirch::Lazy<libbirch::Shared<birch::type::Expression<birch::type::Integer>>>, birch::type::Integer, birch::type::Integer, birch::type::Real, birch::type::Real, birch::type::Real>;

  #line 4 "src/expression/LogChoose.birch"
  using super_type_::operator=;
  #line 4 "src/expression/LogChoose.birch"
  using super_type_::doEvaluate;
  #line 4 "src/expression/LogChoose.birch"
  using super_type_::doEvaluateGradLeft;
  #line 4 "src/expression/LogChoose.birch"
  using super_type_::doEvaluateGradRight;
  
  #line 4 "src/expression/LogChoose.birch"
  LogChoose(const libbirch::Lazy<libbirch::Shared<birch::type::Expression<birch::type::Integer>>>& y, const libbirch::Lazy<libbirch::Shared<birch::type::Expression<birch::type::Integer>>>& z, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);

  #line 7 "src/expression/LogChoose.birch"
  virtual birch::type::Real doEvaluate(const birch::type::Integer& y, const birch::type::Integer& z, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr) override;
  #line 11 "src/expression/LogChoose.birch"
  virtual birch::type::Real doEvaluateGradLeft(const birch::type::Real& d, const birch::type::Real& x, const birch::type::Integer& y, const birch::type::Integer& z, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr) override;
  #line 16 "src/expression/LogChoose.birch"
  virtual birch::type::Real doEvaluateGradRight(const birch::type::Real& d, const birch::type::Real& x, const birch::type::Integer& y, const birch::type::Integer& z, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr) override;
  
  #line 4 "src/expression/LogChoose.birch"
  LIBBIRCH_CLASS(LogChoose, ScalarBinaryExpression<libbirch::Lazy<libbirch::Shared<birch::type::Expression<birch::type::Integer>>>, libbirch::Lazy<libbirch::Shared<birch::type::Expression<birch::type::Integer>>>, birch::type::Integer, birch::type::Integer, birch::type::Real, birch::type::Real, birch::type::Real>)
  #line 4 "src/expression/LogChoose.birch"
  LIBBIRCH_MEMBERS()
};

#line 4 "src/expression/LogBeta.birch"
class LogBeta final : public ScalarBinaryExpression<libbirch::Lazy<libbirch::Shared<birch::type::Expression<birch::type::Real>>>, libbirch::Lazy<libbirch::Shared<birch::type::Expression<birch::type::Real>>>, birch::type::Real, birch::type::Real, birch::type::Real, birch::type::Real, birch::type::Real> {
public:
  #line 4 "src/expression/LogBeta.birch"
  using class_type_ = LogBeta;
  #line 4 "src/expression/LogBeta.birch"
  using this_type_ = class_type_;
  #line 4 "src/expression/LogBeta.birch"
  using super_type_ = ScalarBinaryExpression<libbirch::Lazy<libbirch::Shared<birch::type::Expression<birch::type::Real>>>, libbirch::Lazy<libbirch::Shared<birch::type::Expression<birch::type::Real>>>, birch::type::Real, birch::type::Real, birch::type::Real, birch::type::Real, birch::type::Real>;

  #line 4 "src/expression/LogBeta.birch"
  using super_type_::operator=;
  #line 4 "src/expression/LogBeta.birch"
  using super_type_::doEvaluate;
  #line 4 "src/expression/LogBeta.birch"
  using super_type_::doEvaluateGradLeft;
  #line 4 "src/expression/LogBeta.birch"
  using super_type_::doEvaluateGradRight;
  
  #line 4 "src/expression/LogBeta.birch"
  LogBeta(const libbirch::Lazy<libbirch::Shared<birch::type::Expression<birch::type::Real>>>& y, const libbirch::Lazy<libbirch::Shared<birch::type::Expression<birch::type::Real>>>& z, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);

  #line 7 "src/expression/LogBeta.birch"
  virtual birch::type::Real doEvaluate(const birch::type::Real& y, const birch::type::Real& z, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr) override;
  #line 11 "src/expression/LogBeta.birch"
  virtual birch::type::Real doEvaluateGradLeft(const birch::type::Real& d, const birch::type::Real& x, const birch::type::Real& y, const birch::type::Real& z, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr) override;
  #line 15 "src/expression/LogBeta.birch"
  virtual birch::type::Real doEvaluateGradRight(const birch::type::Real& d, const birch::type::Real& x, const birch::type::Real& y, const birch::type::Real& z, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr) override;
  
  #line 4 "src/expression/LogBeta.birch"
  LIBBIRCH_CLASS(LogBeta, ScalarBinaryExpression<libbirch::Lazy<libbirch::Shared<birch::type::Expression<birch::type::Real>>>, libbirch::Lazy<libbirch::Shared<birch::type::Expression<birch::type::Real>>>, birch::type::Real, birch::type::Real, birch::type::Real, birch::type::Real, birch::type::Real>)
  #line 4 "src/expression/LogBeta.birch"
  LIBBIRCH_MEMBERS()
};

#line 4 "src/expression/LessThan.birch"
class LessThan final : public ScalarBinaryExpression<libbirch::Lazy<libbirch::Shared<birch::type::Expression<birch::type::Real>>>, libbirch::Lazy<libbirch::Shared<birch::type::Expression<birch::type::Real>>>, birch::type::Real, birch::type::Real, birch::type::Real, birch::type::Real, birch::type::Boolean> {
public:
  #line 4 "src/expression/LessThan.birch"
  using class_type_ = LessThan;
  #line 4 "src/expression/LessThan.birch"
  using this_type_ = class_type_;
  #line 4 "src/expression/LessThan.birch"
  using super_type_ = ScalarBinaryExpression<libbirch::Lazy<libbirch::Shared<birch::type::Expression<birch::type::Real>>>, libbirch::Lazy<libbirch::Shared<birch::type::Expression<birch::type::Real>>>, birch::type::Real, birch::type::Real, birch::type::Real, birch::type::Real, birch::type::Boolean>;

  #line 4 "src/expression/LessThan.birch"
  using super_type_::operator=;
  #line 4 "src/expression/LessThan.birch"
  using super_type_::doEvaluate;
  #line 4 "src/expression/LessThan.birch"
  using super_type_::doEvaluateGradLeft;
  #line 4 "src/expression/LessThan.birch"
  using super_type_::doEvaluateGradRight;
  
  #line 4 "src/expression/LessThan.birch"
  LessThan(const libbirch::Lazy<libbirch::Shared<birch::type::Expression<birch::type::Real>>>& y, const libbirch::Lazy<libbirch::Shared<birch::type::Expression<birch::type::Real>>>& z, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);

  #line 7 "src/expression/LessThan.birch"
  virtual birch::type::Boolean doEvaluate(const birch::type::Real& y, const birch::type::Real& z, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr) override;
  #line 11 "src/expression/LessThan.birch"
  virtual birch::type::Real doEvaluateGradLeft(const birch::type::Real& d, const birch::type::Boolean& x, const birch::type::Real& y, const birch::type::Real& z, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr) override;
  #line 16 "src/expression/LessThan.birch"
  virtual birch::type::Real doEvaluateGradRight(const birch::type::Real& d, const birch::type::Boolean& x, const birch::type::Real& y, const birch::type::Real& z, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr) override;
  
  #line 4 "src/expression/LessThan.birch"
  LIBBIRCH_CLASS(LessThan, ScalarBinaryExpression<libbirch::Lazy<libbirch::Shared<birch::type::Expression<birch::type::Real>>>, libbirch::Lazy<libbirch::Shared<birch::type::Expression<birch::type::Real>>>, birch::type::Real, birch::type::Real, birch::type::Real, birch::type::Real, birch::type::Boolean>)
  #line 4 "src/expression/LessThan.birch"
  LIBBIRCH_MEMBERS()
};

#line 4 "src/expression/Dot.birch"
class Dot final : public ScalarBinaryExpression<libbirch::Lazy<libbirch::Shared<birch::type::Expression<libbirch::DefaultArray<birch::type::Real,1>>>>, libbirch::Lazy<libbirch::Shared<birch::type::Expression<libbirch::DefaultArray<birch::type::Real,1>>>>, libbirch::DefaultArray<birch::type::Real,1>, libbirch::DefaultArray<birch::type::Real,1>, libbirch::DefaultArray<birch::type::Real,1>, libbirch::DefaultArray<birch::type::Real,1>, birch::type::Real> {
public:
  #line 4 "src/expression/Dot.birch"
  using class_type_ = Dot;
  #line 4 "src/expression/Dot.birch"
  using this_type_ = class_type_;
  #line 4 "src/expression/Dot.birch"
  using super_type_ = ScalarBinaryExpression<libbirch::Lazy<libbirch::Shared<birch::type::Expression<libbirch::DefaultArray<birch::type::Real,1>>>>, libbirch::Lazy<libbirch::Shared<birch::type::Expression<libbirch::DefaultArray<birch::type::Real,1>>>>, libbirch::DefaultArray<birch::type::Real,1>, libbirch::DefaultArray<birch::type::Real,1>, libbirch::DefaultArray<birch::type::Real,1>, libbirch::DefaultArray<birch::type::Real,1>, birch::type::Real>;

  #line 4 "src/expression/Dot.birch"
  using super_type_::operator=;
  #line 4 "src/expression/Dot.birch"
  using super_type_::doEvaluate;
  #line 4 "src/expression/Dot.birch"
  using super_type_::doEvaluateGradLeft;
  #line 4 "src/expression/Dot.birch"
  using super_type_::doEvaluateGradRight;
  #line 4 "src/expression/Dot.birch"
  using super_type_::graftDotMultivariateGaussian;
  #line 4 "src/expression/Dot.birch"
  using super_type_::graftDotMultivariateNormalInverseGamma;
  
  #line 4 "src/expression/Dot.birch"
  Dot(const libbirch::Lazy<libbirch::Shared<birch::type::Expression<libbirch::DefaultArray<birch::type::Real,1>>>>& y, const libbirch::Lazy<libbirch::Shared<birch::type::Expression<libbirch::DefaultArray<birch::type::Real,1>>>>& z, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);

  #line 7 "src/expression/Dot.birch"
  virtual birch::type::Real doEvaluate(const libbirch::DefaultArray<birch::type::Real,1>& y, const libbirch::DefaultArray<birch::type::Real,1>& z, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr) override;
  #line 11 "src/expression/Dot.birch"
  virtual libbirch::DefaultArray<birch::type::Real,1> doEvaluateGradLeft(const birch::type::Real& d, const birch::type::Real& x, const libbirch::DefaultArray<birch::type::Real,1>& y, const libbirch::DefaultArray<birch::type::Real,1>& z, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr) override;
  #line 16 "src/expression/Dot.birch"
  virtual libbirch::DefaultArray<birch::type::Real,1> doEvaluateGradRight(const birch::type::Real& d, const birch::type::Real& x, const libbirch::DefaultArray<birch::type::Real,1>& y, const libbirch::DefaultArray<birch::type::Real,1>& z, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr) override;
  #line 21 "src/expression/Dot.birch"
  virtual libbirch::Optional<libbirch::Lazy<libbirch::Shared<birch::type::TransformDot<libbirch::Lazy<libbirch::Shared<birch::type::MultivariateGaussian>>>>>> graftDotMultivariateGaussian(const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr) override;
  #line 40 "src/expression/Dot.birch"
  virtual libbirch::Optional<libbirch::Lazy<libbirch::Shared<birch::type::TransformDot<libbirch::Lazy<libbirch::Shared<birch::type::MultivariateNormalInverseGamma>>>>>> graftDotMultivariateNormalInverseGamma(const libbirch::Lazy<libbirch::Shared<birch::type::Distribution<birch::type::Real>>>& compare, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr) override;
  
  #line 4 "src/expression/Dot.birch"
  LIBBIRCH_CLASS(Dot, ScalarBinaryExpression<libbirch::Lazy<libbirch::Shared<birch::type::Expression<libbirch::DefaultArray<birch::type::Real,1>>>>, libbirch::Lazy<libbirch::Shared<birch::type::Expression<libbirch::DefaultArray<birch::type::Real,1>>>>, libbirch::DefaultArray<birch::type::Real,1>, libbirch::DefaultArray<birch::type::Real,1>, libbirch::DefaultArray<birch::type::Real,1>, libbirch::DefaultArray<birch::type::Real,1>, birch::type::Real>)
  #line 4 "src/expression/Dot.birch"
  LIBBIRCH_MEMBERS()
};

#line 4 "src/expression/Divide.birch"
class Divide final : public ScalarBinaryExpression<libbirch::Lazy<libbirch::Shared<birch::type::Expression<birch::type::Real>>>, libbirch::Lazy<libbirch::Shared<birch::type::Expression<birch::type::Real>>>, birch::type::Real, birch::type::Real, birch::type::Real, birch::type::Real, birch::type::Real> {
public:
  #line 4 "src/expression/Divide.birch"
  using class_type_ = Divide;
  #line 4 "src/expression/Divide.birch"
  using this_type_ = class_type_;
  #line 4 "src/expression/Divide.birch"
  using super_type_ = ScalarBinaryExpression<libbirch::Lazy<libbirch::Shared<birch::type::Expression<birch::type::Real>>>, libbirch::Lazy<libbirch::Shared<birch::type::Expression<birch::type::Real>>>, birch::type::Real, birch::type::Real, birch::type::Real, birch::type::Real, birch::type::Real>;

  #line 4 "src/expression/Divide.birch"
  using super_type_::operator=;
  #line 4 "src/expression/Divide.birch"
  using super_type_::doEvaluate;
  #line 4 "src/expression/Divide.birch"
  using super_type_::doEvaluateGradLeft;
  #line 4 "src/expression/Divide.birch"
  using super_type_::doEvaluateGradRight;
  #line 4 "src/expression/Divide.birch"
  using super_type_::graftDotMultivariateGaussian;
  #line 4 "src/expression/Divide.birch"
  using super_type_::graftDotMultivariateNormalInverseGamma;
  #line 4 "src/expression/Divide.birch"
  using super_type_::graftLinearGaussian;
  #line 4 "src/expression/Divide.birch"
  using super_type_::graftLinearNormalInverseGamma;
  #line 4 "src/expression/Divide.birch"
  using super_type_::graftScaledGamma;
  
  #line 4 "src/expression/Divide.birch"
  Divide(const libbirch::Lazy<libbirch::Shared<birch::type::Expression<birch::type::Real>>>& y, const libbirch::Lazy<libbirch::Shared<birch::type::Expression<birch::type::Real>>>& z, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);

  #line 7 "src/expression/Divide.birch"
  virtual birch::type::Real doEvaluate(const birch::type::Real& y, const birch::type::Real& z, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr) override;
  #line 11 "src/expression/Divide.birch"
  virtual birch::type::Real doEvaluateGradLeft(const birch::type::Real& d, const birch::type::Real& x, const birch::type::Real& y, const birch::type::Real& z, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr) override;
  #line 15 "src/expression/Divide.birch"
  virtual birch::type::Real doEvaluateGradRight(const birch::type::Real& d, const birch::type::Real& x, const birch::type::Real& y, const birch::type::Real& z, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr) override;
  #line 19 "src/expression/Divide.birch"
  virtual libbirch::Optional<libbirch::Lazy<libbirch::Shared<birch::type::TransformLinear<libbirch::Lazy<libbirch::Shared<birch::type::Gaussian>>>>>> graftLinearGaussian(const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr) override;
  #line 32 "src/expression/Divide.birch"
  virtual libbirch::Optional<libbirch::Lazy<libbirch::Shared<birch::type::TransformDot<libbirch::Lazy<libbirch::Shared<birch::type::MultivariateGaussian>>>>>> graftDotMultivariateGaussian(const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr) override;
  #line 43 "src/expression/Divide.birch"
  virtual libbirch::Optional<libbirch::Lazy<libbirch::Shared<birch::type::TransformLinear<libbirch::Lazy<libbirch::Shared<birch::type::NormalInverseGamma>>>>>> graftLinearNormalInverseGamma(const libbirch::Lazy<libbirch::Shared<birch::type::Distribution<birch::type::Real>>>& compare, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr) override;
  #line 57 "src/expression/Divide.birch"
  virtual libbirch::Optional<libbirch::Lazy<libbirch::Shared<birch::type::TransformDot<libbirch::Lazy<libbirch::Shared<birch::type::MultivariateNormalInverseGamma>>>>>> graftDotMultivariateNormalInverseGamma(const libbirch::Lazy<libbirch::Shared<birch::type::Distribution<birch::type::Real>>>& compare, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr) override;
  #line 68 "src/expression/Divide.birch"
  virtual libbirch::Optional<libbirch::Lazy<libbirch::Shared<birch::type::TransformLinear<libbirch::Lazy<libbirch::Shared<birch::type::Gamma>>>>>> graftScaledGamma(const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr) override;
  
  #line 4 "src/expression/Divide.birch"
  LIBBIRCH_CLASS(Divide, ScalarBinaryExpression<libbirch::Lazy<libbirch::Shared<birch::type::Expression<birch::type::Real>>>, libbirch::Lazy<libbirch::Shared<birch::type::Expression<birch::type::Real>>>, birch::type::Real, birch::type::Real, birch::type::Real, birch::type::Real, birch::type::Real>)
  #line 4 "src/expression/Divide.birch"
  LIBBIRCH_MEMBERS()
};

#line 4 "src/expression/DiscreteSubtract.birch"
class DiscreteSubtract final : public ScalarBinaryExpression<libbirch::Lazy<libbirch::Shared<birch::type::Expression<birch::type::Integer>>>, libbirch::Lazy<libbirch::Shared<birch::type::Expression<birch::type::Integer>>>, birch::type::Integer, birch::type::Integer, birch::type::Real, birch::type::Real, birch::type::Integer> {
public:
  #line 4 "src/expression/DiscreteSubtract.birch"
  using class_type_ = DiscreteSubtract;
  #line 4 "src/expression/DiscreteSubtract.birch"
  using this_type_ = class_type_;
  #line 4 "src/expression/DiscreteSubtract.birch"
  using super_type_ = ScalarBinaryExpression<libbirch::Lazy<libbirch::Shared<birch::type::Expression<birch::type::Integer>>>, libbirch::Lazy<libbirch::Shared<birch::type::Expression<birch::type::Integer>>>, birch::type::Integer, birch::type::Integer, birch::type::Real, birch::type::Real, birch::type::Integer>;

  #line 4 "src/expression/DiscreteSubtract.birch"
  using super_type_::operator=;
  #line 4 "src/expression/DiscreteSubtract.birch"
  using super_type_::doEvaluate;
  #line 4 "src/expression/DiscreteSubtract.birch"
  using super_type_::doEvaluateGradLeft;
  #line 4 "src/expression/DiscreteSubtract.birch"
  using super_type_::doEvaluateGradRight;
  #line 4 "src/expression/DiscreteSubtract.birch"
  using super_type_::graftBoundedDiscrete;
  #line 4 "src/expression/DiscreteSubtract.birch"
  using super_type_::graftDiscrete;
  
  #line 4 "src/expression/DiscreteSubtract.birch"
  DiscreteSubtract(const libbirch::Lazy<libbirch::Shared<birch::type::Expression<birch::type::Integer>>>& y, const libbirch::Lazy<libbirch::Shared<birch::type::Expression<birch::type::Integer>>>& z, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);

  #line 7 "src/expression/DiscreteSubtract.birch"
  virtual birch::type::Integer doEvaluate(const birch::type::Integer& y, const birch::type::Integer& z, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr) override;
  #line 11 "src/expression/DiscreteSubtract.birch"
  virtual birch::type::Real doEvaluateGradLeft(const birch::type::Real& d, const birch::type::Integer& x, const birch::type::Integer& y, const birch::type::Integer& z, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr) override;
  #line 16 "src/expression/DiscreteSubtract.birch"
  virtual birch::type::Real doEvaluateGradRight(const birch::type::Real& d, const birch::type::Integer& x, const birch::type::Integer& y, const birch::type::Integer& z, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr) override;
  #line 21 "src/expression/DiscreteSubtract.birch"
  virtual libbirch::Optional<libbirch::Lazy<libbirch::Shared<birch::type::Discrete>>> graftDiscrete(const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr) override;
  #line 37 "src/expression/DiscreteSubtract.birch"
  virtual libbirch::Optional<libbirch::Lazy<libbirch::Shared<birch::type::BoundedDiscrete>>> graftBoundedDiscrete(const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr) override;
  
  #line 4 "src/expression/DiscreteSubtract.birch"
  LIBBIRCH_CLASS(DiscreteSubtract, ScalarBinaryExpression<libbirch::Lazy<libbirch::Shared<birch::type::Expression<birch::type::Integer>>>, libbirch::Lazy<libbirch::Shared<birch::type::Expression<birch::type::Integer>>>, birch::type::Integer, birch::type::Integer, birch::type::Real, birch::type::Real, birch::type::Integer>)
  #line 4 "src/expression/DiscreteSubtract.birch"
  LIBBIRCH_MEMBERS()
};

#line 4 "src/expression/DiscreteMultiply.birch"
class DiscreteMultiply final : public ScalarBinaryExpression<libbirch::Lazy<libbirch::Shared<birch::type::Expression<birch::type::Integer>>>, libbirch::Lazy<libbirch::Shared<birch::type::Expression<birch::type::Integer>>>, birch::type::Integer, birch::type::Integer, birch::type::Real, birch::type::Real, birch::type::Integer> {
public:
  #line 4 "src/expression/DiscreteMultiply.birch"
  using class_type_ = DiscreteMultiply;
  #line 4 "src/expression/DiscreteMultiply.birch"
  using this_type_ = class_type_;
  #line 4 "src/expression/DiscreteMultiply.birch"
  using super_type_ = ScalarBinaryExpression<libbirch::Lazy<libbirch::Shared<birch::type::Expression<birch::type::Integer>>>, libbirch::Lazy<libbirch::Shared<birch::type::Expression<birch::type::Integer>>>, birch::type::Integer, birch::type::Integer, birch::type::Real, birch::type::Real, birch::type::Integer>;

  #line 4 "src/expression/DiscreteMultiply.birch"
  using super_type_::operator=;
  #line 4 "src/expression/DiscreteMultiply.birch"
  using super_type_::doEvaluate;
  #line 4 "src/expression/DiscreteMultiply.birch"
  using super_type_::doEvaluateGradLeft;
  #line 4 "src/expression/DiscreteMultiply.birch"
  using super_type_::doEvaluateGradRight;
  #line 4 "src/expression/DiscreteMultiply.birch"
  using super_type_::graftBoundedDiscrete;
  #line 4 "src/expression/DiscreteMultiply.birch"
  using super_type_::graftDiscrete;
  
  #line 4 "src/expression/DiscreteMultiply.birch"
  DiscreteMultiply(const libbirch::Lazy<libbirch::Shared<birch::type::Expression<birch::type::Integer>>>& y, const libbirch::Lazy<libbirch::Shared<birch::type::Expression<birch::type::Integer>>>& z, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);

  #line 7 "src/expression/DiscreteMultiply.birch"
  virtual birch::type::Integer doEvaluate(const birch::type::Integer& y, const birch::type::Integer& z, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr) override;
  #line 11 "src/expression/DiscreteMultiply.birch"
  virtual birch::type::Real doEvaluateGradLeft(const birch::type::Real& d, const birch::type::Integer& x, const birch::type::Integer& y, const birch::type::Integer& z, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr) override;
  #line 16 "src/expression/DiscreteMultiply.birch"
  virtual birch::type::Real doEvaluateGradRight(const birch::type::Real& d, const birch::type::Integer& x, const birch::type::Integer& y, const birch::type::Integer& z, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr) override;
  #line 21 "src/expression/DiscreteMultiply.birch"
  virtual libbirch::Optional<libbirch::Lazy<libbirch::Shared<birch::type::Discrete>>> graftDiscrete(const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr) override;
  #line 37 "src/expression/DiscreteMultiply.birch"
  virtual libbirch::Optional<libbirch::Lazy<libbirch::Shared<birch::type::BoundedDiscrete>>> graftBoundedDiscrete(const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr) override;
  
  #line 4 "src/expression/DiscreteMultiply.birch"
  LIBBIRCH_CLASS(DiscreteMultiply, ScalarBinaryExpression<libbirch::Lazy<libbirch::Shared<birch::type::Expression<birch::type::Integer>>>, libbirch::Lazy<libbirch::Shared<birch::type::Expression<birch::type::Integer>>>, birch::type::Integer, birch::type::Integer, birch::type::Real, birch::type::Real, birch::type::Integer>)
  #line 4 "src/expression/DiscreteMultiply.birch"
  LIBBIRCH_MEMBERS()
};

#line 4 "src/expression/DiscreteAdd.birch"
class DiscreteAdd final : public ScalarBinaryExpression<libbirch::Lazy<libbirch::Shared<birch::type::Expression<birch::type::Integer>>>, libbirch::Lazy<libbirch::Shared<birch::type::Expression<birch::type::Integer>>>, birch::type::Integer, birch::type::Integer, birch::type::Real, birch::type::Real, birch::type::Integer> {
public:
  #line 4 "src/expression/DiscreteAdd.birch"
  using class_type_ = DiscreteAdd;
  #line 4 "src/expression/DiscreteAdd.birch"
  using this_type_ = class_type_;
  #line 4 "src/expression/DiscreteAdd.birch"
  using super_type_ = ScalarBinaryExpression<libbirch::Lazy<libbirch::Shared<birch::type::Expression<birch::type::Integer>>>, libbirch::Lazy<libbirch::Shared<birch::type::Expression<birch::type::Integer>>>, birch::type::Integer, birch::type::Integer, birch::type::Real, birch::type::Real, birch::type::Integer>;

  #line 4 "src/expression/DiscreteAdd.birch"
  using super_type_::operator=;
  #line 4 "src/expression/DiscreteAdd.birch"
  using super_type_::doEvaluate;
  #line 4 "src/expression/DiscreteAdd.birch"
  using super_type_::doEvaluateGradLeft;
  #line 4 "src/expression/DiscreteAdd.birch"
  using super_type_::doEvaluateGradRight;
  #line 4 "src/expression/DiscreteAdd.birch"
  using super_type_::graftBoundedDiscrete;
  #line 4 "src/expression/DiscreteAdd.birch"
  using super_type_::graftDiscrete;
  
  #line 4 "src/expression/DiscreteAdd.birch"
  DiscreteAdd(const libbirch::Lazy<libbirch::Shared<birch::type::Expression<birch::type::Integer>>>& y, const libbirch::Lazy<libbirch::Shared<birch::type::Expression<birch::type::Integer>>>& z, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);

  #line 7 "src/expression/DiscreteAdd.birch"
  virtual birch::type::Integer doEvaluate(const birch::type::Integer& y, const birch::type::Integer& z, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr) override;
  #line 11 "src/expression/DiscreteAdd.birch"
  virtual birch::type::Real doEvaluateGradLeft(const birch::type::Real& d, const birch::type::Integer& x, const birch::type::Integer& y, const birch::type::Integer& z, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr) override;
  #line 16 "src/expression/DiscreteAdd.birch"
  virtual birch::type::Real doEvaluateGradRight(const birch::type::Real& d, const birch::type::Integer& x, const birch::type::Integer& y, const birch::type::Integer& z, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr) override;
  #line 21 "src/expression/DiscreteAdd.birch"
  virtual libbirch::Optional<libbirch::Lazy<libbirch::Shared<birch::type::Discrete>>> graftDiscrete(const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr) override;
  #line 37 "src/expression/DiscreteAdd.birch"
  virtual libbirch::Optional<libbirch::Lazy<libbirch::Shared<birch::type::BoundedDiscrete>>> graftBoundedDiscrete(const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr) override;
  
  #line 4 "src/expression/DiscreteAdd.birch"
  LIBBIRCH_CLASS(DiscreteAdd, ScalarBinaryExpression<libbirch::Lazy<libbirch::Shared<birch::type::Expression<birch::type::Integer>>>, libbirch::Lazy<libbirch::Shared<birch::type::Expression<birch::type::Integer>>>, birch::type::Integer, birch::type::Integer, birch::type::Real, birch::type::Real, birch::type::Integer>)
  #line 4 "src/expression/DiscreteAdd.birch"
  LIBBIRCH_MEMBERS()
};

#line 4 "src/expression/CopySign.birch"
class CopySign final : public ScalarBinaryExpression<libbirch::Lazy<libbirch::Shared<birch::type::Expression<birch::type::Real>>>, libbirch::Lazy<libbirch::Shared<birch::type::Expression<birch::type::Real>>>, birch::type::Real, birch::type::Real, birch::type::Real, birch::type::Real, birch::type::Real> {
public:
  #line 4 "src/expression/CopySign.birch"
  using class_type_ = CopySign;
  #line 4 "src/expression/CopySign.birch"
  using this_type_ = class_type_;
  #line 4 "src/expression/CopySign.birch"
  using super_type_ = ScalarBinaryExpression<libbirch::Lazy<libbirch::Shared<birch::type::Expression<birch::type::Real>>>, libbirch::Lazy<libbirch::Shared<birch::type::Expression<birch::type::Real>>>, birch::type::Real, birch::type::Real, birch::type::Real, birch::type::Real, birch::type::Real>;

  #line 4 "src/expression/CopySign.birch"
  using super_type_::operator=;
  #line 4 "src/expression/CopySign.birch"
  using super_type_::doEvaluate;
  #line 4 "src/expression/CopySign.birch"
  using super_type_::doEvaluateGradLeft;
  #line 4 "src/expression/CopySign.birch"
  using super_type_::doEvaluateGradRight;
  
  #line 4 "src/expression/CopySign.birch"
  CopySign(const libbirch::Lazy<libbirch::Shared<birch::type::Expression<birch::type::Real>>>& y, const libbirch::Lazy<libbirch::Shared<birch::type::Expression<birch::type::Real>>>& z, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);

  #line 7 "src/expression/CopySign.birch"
  virtual birch::type::Real doEvaluate(const birch::type::Real& y, const birch::type::Real& z, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr) override;
  #line 11 "src/expression/CopySign.birch"
  virtual birch::type::Real doEvaluateGradLeft(const birch::type::Real& d, const birch::type::Real& x, const birch::type::Real& y, const birch::type::Real& z, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr) override;
  #line 20 "src/expression/CopySign.birch"
  virtual birch::type::Real doEvaluateGradRight(const birch::type::Real& d, const birch::type::Real& x, const birch::type::Real& y, const birch::type::Real& z, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr) override;
  
  #line 4 "src/expression/CopySign.birch"
  LIBBIRCH_CLASS(CopySign, ScalarBinaryExpression<libbirch::Lazy<libbirch::Shared<birch::type::Expression<birch::type::Real>>>, libbirch::Lazy<libbirch::Shared<birch::type::Expression<birch::type::Real>>>, birch::type::Real, birch::type::Real, birch::type::Real, birch::type::Real, birch::type::Real>)
  #line 4 "src/expression/CopySign.birch"
  LIBBIRCH_MEMBERS()
};

#line 4 "src/expression/Add.birch"
class Add final : public ScalarBinaryExpression<libbirch::Lazy<libbirch::Shared<birch::type::Expression<birch::type::Real>>>, libbirch::Lazy<libbirch::Shared<birch::type::Expression<birch::type::Real>>>, birch::type::Real, birch::type::Real, birch::type::Real, birch::type::Real, birch::type::Real> {
public:
  #line 4 "src/expression/Add.birch"
  using class_type_ = Add;
  #line 4 "src/expression/Add.birch"
  using this_type_ = class_type_;
  #line 4 "src/expression/Add.birch"
  using super_type_ = ScalarBinaryExpression<libbirch::Lazy<libbirch::Shared<birch::type::Expression<birch::type::Real>>>, libbirch::Lazy<libbirch::Shared<birch::type::Expression<birch::type::Real>>>, birch::type::Real, birch::type::Real, birch::type::Real, birch::type::Real, birch::type::Real>;

  #line 4 "src/expression/Add.birch"
  using super_type_::operator=;
  #line 4 "src/expression/Add.birch"
  using super_type_::doEvaluate;
  #line 4 "src/expression/Add.birch"
  using super_type_::doEvaluateGradLeft;
  #line 4 "src/expression/Add.birch"
  using super_type_::doEvaluateGradRight;
  #line 4 "src/expression/Add.birch"
  using super_type_::graftDotMultivariateGaussian;
  #line 4 "src/expression/Add.birch"
  using super_type_::graftDotMultivariateNormalInverseGamma;
  #line 4 "src/expression/Add.birch"
  using super_type_::graftLinearGaussian;
  #line 4 "src/expression/Add.birch"
  using super_type_::graftLinearNormalInverseGamma;
  
  #line 4 "src/expression/Add.birch"
  Add(const libbirch::Lazy<libbirch::Shared<birch::type::Expression<birch::type::Real>>>& y, const libbirch::Lazy<libbirch::Shared<birch::type::Expression<birch::type::Real>>>& z, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);

  #line 7 "src/expression/Add.birch"
  virtual birch::type::Real doEvaluate(const birch::type::Real& y, const birch::type::Real& z, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr) override;
  #line 11 "src/expression/Add.birch"
  virtual birch::type::Real doEvaluateGradLeft(const birch::type::Real& d, const birch::type::Real& x, const birch::type::Real& y, const birch::type::Real& z, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr) override;
  #line 16 "src/expression/Add.birch"
  virtual birch::type::Real doEvaluateGradRight(const birch::type::Real& d, const birch::type::Real& x, const birch::type::Real& y, const birch::type::Real& z, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr) override;
  #line 21 "src/expression/Add.birch"
  virtual libbirch::Optional<libbirch::Lazy<libbirch::Shared<birch::type::TransformLinear<libbirch::Lazy<libbirch::Shared<birch::type::Gaussian>>>>>> graftLinearGaussian(const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr) override;
  #line 39 "src/expression/Add.birch"
  virtual libbirch::Optional<libbirch::Lazy<libbirch::Shared<birch::type::TransformDot<libbirch::Lazy<libbirch::Shared<birch::type::MultivariateGaussian>>>>>> graftDotMultivariateGaussian(const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr) override;
  #line 52 "src/expression/Add.birch"
  virtual libbirch::Optional<libbirch::Lazy<libbirch::Shared<birch::type::TransformLinear<libbirch::Lazy<libbirch::Shared<birch::type::NormalInverseGamma>>>>>> graftLinearNormalInverseGamma(const libbirch::Lazy<libbirch::Shared<birch::type::Distribution<birch::type::Real>>>& compare, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr) override;
  #line 70 "src/expression/Add.birch"
  virtual libbirch::Optional<libbirch::Lazy<libbirch::Shared<birch::type::TransformDot<libbirch::Lazy<libbirch::Shared<birch::type::MultivariateNormalInverseGamma>>>>>> graftDotMultivariateNormalInverseGamma(const libbirch::Lazy<libbirch::Shared<birch::type::Distribution<birch::type::Real>>>& compare, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr) override;
  
  #line 4 "src/expression/Add.birch"
  LIBBIRCH_CLASS(Add, ScalarBinaryExpression<libbirch::Lazy<libbirch::Shared<birch::type::Expression<birch::type::Real>>>, libbirch::Lazy<libbirch::Shared<birch::type::Expression<birch::type::Real>>>, birch::type::Real, birch::type::Real, birch::type::Real, birch::type::Real, birch::type::Real>)
  #line 4 "src/expression/Add.birch"
  LIBBIRCH_MEMBERS()
};

#line 4 "src/expression/Subtract.birch"
class Subtract final : public ScalarBinaryExpression<libbirch::Lazy<libbirch::Shared<birch::type::Expression<birch::type::Real>>>, libbirch::Lazy<libbirch::Shared<birch::type::Expression<birch::type::Real>>>, birch::type::Real, birch::type::Real, birch::type::Real, birch::type::Real, birch::type::Real> {
public:
  #line 4 "src/expression/Subtract.birch"
  using class_type_ = Subtract;
  #line 4 "src/expression/Subtract.birch"
  using this_type_ = class_type_;
  #line 4 "src/expression/Subtract.birch"
  using super_type_ = ScalarBinaryExpression<libbirch::Lazy<libbirch::Shared<birch::type::Expression<birch::type::Real>>>, libbirch::Lazy<libbirch::Shared<birch::type::Expression<birch::type::Real>>>, birch::type::Real, birch::type::Real, birch::type::Real, birch::type::Real, birch::type::Real>;

  #line 4 "src/expression/Subtract.birch"
  using super_type_::operator=;
  #line 4 "src/expression/Subtract.birch"
  using super_type_::doEvaluate;
  #line 4 "src/expression/Subtract.birch"
  using super_type_::doEvaluateGradLeft;
  #line 4 "src/expression/Subtract.birch"
  using super_type_::doEvaluateGradRight;
  #line 4 "src/expression/Subtract.birch"
  using super_type_::graftDotMultivariateGaussian;
  #line 4 "src/expression/Subtract.birch"
  using super_type_::graftDotMultivariateNormalInverseGamma;
  #line 4 "src/expression/Subtract.birch"
  using super_type_::graftLinearGaussian;
  #line 4 "src/expression/Subtract.birch"
  using super_type_::graftLinearNormalInverseGamma;
  
  #line 4 "src/expression/Subtract.birch"
  Subtract(const libbirch::Lazy<libbirch::Shared<birch::type::Expression<birch::type::Real>>>& y, const libbirch::Lazy<libbirch::Shared<birch::type::Expression<birch::type::Real>>>& z, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);

  #line 7 "src/expression/Subtract.birch"
  virtual birch::type::Real doEvaluate(const birch::type::Real& y, const birch::type::Real& z, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr) override;
  #line 11 "src/expression/Subtract.birch"
  virtual birch::type::Real doEvaluateGradLeft(const birch::type::Real& d, const birch::type::Real& x, const birch::type::Real& y, const birch::type::Real& z, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr) override;
  #line 15 "src/expression/Subtract.birch"
  virtual birch::type::Real doEvaluateGradRight(const birch::type::Real& d, const birch::type::Real& x, const birch::type::Real& y, const birch::type::Real& z, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr) override;
  #line 19 "src/expression/Subtract.birch"
  virtual libbirch::Optional<libbirch::Lazy<libbirch::Shared<birch::type::TransformLinear<libbirch::Lazy<libbirch::Shared<birch::type::Gaussian>>>>>> graftLinearGaussian(const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr) override;
  #line 37 "src/expression/Subtract.birch"
  virtual libbirch::Optional<libbirch::Lazy<libbirch::Shared<birch::type::TransformDot<libbirch::Lazy<libbirch::Shared<birch::type::MultivariateGaussian>>>>>> graftDotMultivariateGaussian(const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr) override;
  #line 50 "src/expression/Subtract.birch"
  virtual libbirch::Optional<libbirch::Lazy<libbirch::Shared<birch::type::TransformLinear<libbirch::Lazy<libbirch::Shared<birch::type::NormalInverseGamma>>>>>> graftLinearNormalInverseGamma(const libbirch::Lazy<libbirch::Shared<birch::type::Distribution<birch::type::Real>>>& compare, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr) override;
  #line 70 "src/expression/Subtract.birch"
  virtual libbirch::Optional<libbirch::Lazy<libbirch::Shared<birch::type::TransformDot<libbirch::Lazy<libbirch::Shared<birch::type::MultivariateNormalInverseGamma>>>>>> graftDotMultivariateNormalInverseGamma(const libbirch::Lazy<libbirch::Shared<birch::type::Distribution<birch::type::Real>>>& compare, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr) override;
  
  #line 4 "src/expression/Subtract.birch"
  LIBBIRCH_CLASS(Subtract, ScalarBinaryExpression<libbirch::Lazy<libbirch::Shared<birch::type::Expression<birch::type::Real>>>, libbirch::Lazy<libbirch::Shared<birch::type::Expression<birch::type::Real>>>, birch::type::Real, birch::type::Real, birch::type::Real, birch::type::Real, birch::type::Real>)
  #line 4 "src/expression/Subtract.birch"
  LIBBIRCH_MEMBERS()
};

template<class Value>
#line 4 "src/expression/MultivariateElement.birch"
class MultivariateElement final : public ScalarExpression<Value> {
public:
  #line 4 "src/expression/MultivariateElement.birch"
  using class_type_ = MultivariateElement<Value>;
  #line 4 "src/expression/MultivariateElement.birch"
  using this_type_ = class_type_;
  #line 4 "src/expression/MultivariateElement.birch"
  using super_type_ = ScalarExpression<Value>;

  #line 4 "src/expression/MultivariateElement.birch"
  using super_type_::operator=;
  #line 4 "src/expression/MultivariateElement.birch"
  using super_type_::doCompare;
  #line 4 "src/expression/MultivariateElement.birch"
  using super_type_::doConstant;
  #line 4 "src/expression/MultivariateElement.birch"
  using super_type_::doCount;
  #line 4 "src/expression/MultivariateElement.birch"
  using super_type_::doDepth;
  #line 4 "src/expression/MultivariateElement.birch"
  using super_type_::doDetach;
  #line 4 "src/expression/MultivariateElement.birch"
  using super_type_::doGet;
  #line 4 "src/expression/MultivariateElement.birch"
  using super_type_::doGrad;
  #line 4 "src/expression/MultivariateElement.birch"
  using super_type_::doMove;
  #line 4 "src/expression/MultivariateElement.birch"
  using super_type_::doPilot;
  #line 4 "src/expression/MultivariateElement.birch"
  using super_type_::doPrior;
  #line 4 "src/expression/MultivariateElement.birch"
  using super_type_::doValue;
  
  #line 4 "src/expression/MultivariateElement.birch"
  MultivariateElement(const libbirch::Lazy<libbirch::Shared<birch::type::Expression<libbirch::DefaultArray<Value,1>>>>& y, const birch::type::Integer& i, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);

  libbirch::Optional<libbirch::Lazy<libbirch::Shared<birch::type::Expression<libbirch::DefaultArray<Value,1>>>>> y;
  birch::type::Integer i;
  #line 16 "src/expression/MultivariateElement.birch"
  virtual birch::type::Integer doDepth(const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr) override;
  #line 20 "src/expression/MultivariateElement.birch"
  virtual Value doValue(const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr) override;
  #line 24 "src/expression/MultivariateElement.birch"
  virtual Value doPilot(const birch::type::Integer& gen, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr) override;
  #line 28 "src/expression/MultivariateElement.birch"
  virtual Value doGet(const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr) override;
  #line 32 "src/expression/MultivariateElement.birch"
  virtual Value doMove(const birch::type::Integer& gen, const libbirch::Lazy<libbirch::Shared<birch::type::Kernel>>& _u0954, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr) override;
  #line 36 "src/expression/MultivariateElement.birch"
  virtual void doGrad(const birch::type::Integer& gen, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr) override;
  #line 40 "src/expression/MultivariateElement.birch"
  virtual libbirch::Optional<libbirch::Lazy<libbirch::Shared<birch::type::Expression<birch::type::Real>>>> doPrior(const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr) override;
  #line 44 "src/expression/MultivariateElement.birch"
  virtual birch::type::Real doCompare(const birch::type::Integer& gen, const libbirch::Lazy<libbirch::Shared<birch::type::DelayExpression>>& x, const libbirch::Lazy<libbirch::Shared<birch::type::Kernel>>& _u0954, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr) override;
  #line 50 "src/expression/MultivariateElement.birch"
  virtual void doConstant(const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr) override;
  #line 54 "src/expression/MultivariateElement.birch"
  virtual void doCount(const birch::type::Integer& gen, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr) override;
  #line 58 "src/expression/MultivariateElement.birch"
  virtual void doDetach(const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr) override;
  
  #line 4 "src/expression/MultivariateElement.birch"
  LIBBIRCH_CLASS(MultivariateElement, ScalarExpression<Value>)
  #line 4 "src/expression/MultivariateElement.birch"
  LIBBIRCH_MEMBERS(y, i)
};

template<class Value>
#line 4 "src/expression/MatrixElement.birch"
class MatrixElement final : public ScalarExpression<Value> {
public:
  #line 4 "src/expression/MatrixElement.birch"
  using class_type_ = MatrixElement<Value>;
  #line 4 "src/expression/MatrixElement.birch"
  using this_type_ = class_type_;
  #line 4 "src/expression/MatrixElement.birch"
  using super_type_ = ScalarExpression<Value>;

  #line 4 "src/expression/MatrixElement.birch"
  using super_type_::operator=;
  #line 4 "src/expression/MatrixElement.birch"
  using super_type_::doCompare;
  #line 4 "src/expression/MatrixElement.birch"
  using super_type_::doConstant;
  #line 4 "src/expression/MatrixElement.birch"
  using super_type_::doCount;
  #line 4 "src/expression/MatrixElement.birch"
  using super_type_::doDepth;
  #line 4 "src/expression/MatrixElement.birch"
  using super_type_::doDetach;
  #line 4 "src/expression/MatrixElement.birch"
  using super_type_::doGet;
  #line 4 "src/expression/MatrixElement.birch"
  using super_type_::doGrad;
  #line 4 "src/expression/MatrixElement.birch"
  using super_type_::doMove;
  #line 4 "src/expression/MatrixElement.birch"
  using super_type_::doPilot;
  #line 4 "src/expression/MatrixElement.birch"
  using super_type_::doPrior;
  #line 4 "src/expression/MatrixElement.birch"
  using super_type_::doValue;
  
  #line 4 "src/expression/MatrixElement.birch"
  MatrixElement(const libbirch::Lazy<libbirch::Shared<birch::type::Expression<libbirch::DefaultArray<Value,2>>>>& y, const birch::type::Integer& i, const birch::type::Integer& j, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);

  libbirch::Optional<libbirch::Lazy<libbirch::Shared<birch::type::Expression<libbirch::DefaultArray<Value,2>>>>> y;
  birch::type::Integer i;
  birch::type::Integer j;
  #line 21 "src/expression/MatrixElement.birch"
  virtual birch::type::Integer doDepth(const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr) override;
  #line 25 "src/expression/MatrixElement.birch"
  virtual Value doValue(const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr) override;
  #line 29 "src/expression/MatrixElement.birch"
  virtual Value doPilot(const birch::type::Integer& gen, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr) override;
  #line 33 "src/expression/MatrixElement.birch"
  virtual Value doGet(const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr) override;
  #line 37 "src/expression/MatrixElement.birch"
  virtual Value doMove(const birch::type::Integer& gen, const libbirch::Lazy<libbirch::Shared<birch::type::Kernel>>& _u0954, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr) override;
  #line 41 "src/expression/MatrixElement.birch"
  virtual void doGrad(const birch::type::Integer& gen, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr) override;
  #line 45 "src/expression/MatrixElement.birch"
  virtual libbirch::Optional<libbirch::Lazy<libbirch::Shared<birch::type::Expression<birch::type::Real>>>> doPrior(const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr) override;
  #line 49 "src/expression/MatrixElement.birch"
  virtual birch::type::Real doCompare(const birch::type::Integer& gen, const libbirch::Lazy<libbirch::Shared<birch::type::DelayExpression>>& x, const libbirch::Lazy<libbirch::Shared<birch::type::Kernel>>& _u0954, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr) override;
  #line 55 "src/expression/MatrixElement.birch"
  virtual void doConstant(const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr) override;
  #line 59 "src/expression/MatrixElement.birch"
  virtual void doCount(const birch::type::Integer& gen, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr) override;
  #line 63 "src/expression/MatrixElement.birch"
  virtual void doDetach(const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr) override;
  
  #line 4 "src/expression/MatrixElement.birch"
  LIBBIRCH_CLASS(MatrixElement, ScalarExpression<Value>)
  #line 4 "src/expression/MatrixElement.birch"
  LIBBIRCH_MEMBERS(y, i, j)
};

#line 4 "src/expression/IfThenElse.birch"
class IfThenElse final : public ScalarExpression<birch::type::Real> {
public:
  #line 4 "src/expression/IfThenElse.birch"
  using class_type_ = IfThenElse;
  #line 4 "src/expression/IfThenElse.birch"
  using this_type_ = class_type_;
  #line 4 "src/expression/IfThenElse.birch"
  using super_type_ = ScalarExpression<birch::type::Real>;

  #line 4 "src/expression/IfThenElse.birch"
  using super_type_::operator=;
  #line 4 "src/expression/IfThenElse.birch"
  using super_type_::doCompare;
  #line 4 "src/expression/IfThenElse.birch"
  using super_type_::doConstant;
  #line 4 "src/expression/IfThenElse.birch"
  using super_type_::doCount;
  #line 4 "src/expression/IfThenElse.birch"
  using super_type_::doDepth;
  #line 4 "src/expression/IfThenElse.birch"
  using super_type_::doDetach;
  #line 4 "src/expression/IfThenElse.birch"
  using super_type_::doGet;
  #line 4 "src/expression/IfThenElse.birch"
  using super_type_::doGrad;
  #line 4 "src/expression/IfThenElse.birch"
  using super_type_::doMove;
  #line 4 "src/expression/IfThenElse.birch"
  using super_type_::doPilot;
  #line 4 "src/expression/IfThenElse.birch"
  using super_type_::doPrior;
  #line 4 "src/expression/IfThenElse.birch"
  using super_type_::doValue;
  
  #line 4 "src/expression/IfThenElse.birch"
  IfThenElse(const libbirch::Lazy<libbirch::Shared<birch::type::Expression<birch::type::Boolean>>>& cond, const libbirch::Lazy<libbirch::Shared<birch::type::Expression<birch::type::Real>>>& y, const libbirch::Lazy<libbirch::Shared<birch::type::Expression<birch::type::Real>>>& z, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);

  libbirch::Optional<libbirch::Lazy<libbirch::Shared<birch::type::Expression<birch::type::Boolean>>>> cond;
  libbirch::Optional<libbirch::Lazy<libbirch::Shared<birch::type::Expression<birch::type::Real>>>> y;
  libbirch::Optional<libbirch::Lazy<libbirch::Shared<birch::type::Expression<birch::type::Real>>>> z;
  #line 21 "src/expression/IfThenElse.birch"
  virtual birch::type::Integer doDepth(const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr) override;
  #line 25 "src/expression/IfThenElse.birch"
  virtual birch::type::Real doValue(const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr) override;
  #line 29 "src/expression/IfThenElse.birch"
  virtual birch::type::Real doPilot(const birch::type::Integer& gen, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr) override;
  #line 33 "src/expression/IfThenElse.birch"
  virtual birch::type::Real doGet(const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr) override;
  #line 37 "src/expression/IfThenElse.birch"
  virtual birch::type::Real doMove(const birch::type::Integer& gen, const libbirch::Lazy<libbirch::Shared<birch::type::Kernel>>& _u0954, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr) override;
  #line 41 "src/expression/IfThenElse.birch"
  virtual void doGrad(const birch::type::Integer& gen, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr) override;
  #line 52 "src/expression/IfThenElse.birch"
  virtual libbirch::Optional<libbirch::Lazy<libbirch::Shared<birch::type::Expression<birch::type::Real>>>> doPrior(const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr) override;
  #line 75 "src/expression/IfThenElse.birch"
  virtual birch::type::Real doCompare(const birch::type::Integer& gen, const libbirch::Lazy<libbirch::Shared<birch::type::DelayExpression>>& x, const libbirch::Lazy<libbirch::Shared<birch::type::Kernel>>& _u0954, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr) final;
  #line 82 "src/expression/IfThenElse.birch"
  virtual void doConstant(const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr) final;
  #line 88 "src/expression/IfThenElse.birch"
  virtual void doCount(const birch::type::Integer& gen, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr) final;
  #line 94 "src/expression/IfThenElse.birch"
  virtual void doDetach(const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr) final;
  
  #line 4 "src/expression/IfThenElse.birch"
  LIBBIRCH_CLASS(IfThenElse, ScalarExpression<birch::type::Real>)
  #line 4 "src/expression/IfThenElse.birch"
  LIBBIRCH_MEMBERS(cond, y, z)
};

template<class Argument,class ArgumentValue,class ArgumentGradient,class Value>
#line 12 "src/expression/ScalarUnaryExpression.birch"
class ScalarUnaryExpression : public ScalarExpression<Value> {
public:
  #line 12 "src/expression/ScalarUnaryExpression.birch"
  using class_type_ = ScalarUnaryExpression<Argument, ArgumentValue, ArgumentGradient, Value>;
  #line 12 "src/expression/ScalarUnaryExpression.birch"
  using this_type_ = class_type_;
  #line 12 "src/expression/ScalarUnaryExpression.birch"
  using super_type_ = ScalarExpression<Value>;

  #line 12 "src/expression/ScalarUnaryExpression.birch"
  using super_type_::operator=;
  #line 12 "src/expression/ScalarUnaryExpression.birch"
  using super_type_::doCompare;
  #line 12 "src/expression/ScalarUnaryExpression.birch"
  using super_type_::doConstant;
  #line 12 "src/expression/ScalarUnaryExpression.birch"
  using super_type_::doCount;
  #line 12 "src/expression/ScalarUnaryExpression.birch"
  using super_type_::doDepth;
  #line 12 "src/expression/ScalarUnaryExpression.birch"
  using super_type_::doDetach;
  #line 12 "src/expression/ScalarUnaryExpression.birch"
  using super_type_::doGet;
  #line 12 "src/expression/ScalarUnaryExpression.birch"
  using super_type_::doGrad;
  #line 12 "src/expression/ScalarUnaryExpression.birch"
  using super_type_::doMove;
  #line 12 "src/expression/ScalarUnaryExpression.birch"
  using super_type_::doPilot;
  #line 12 "src/expression/ScalarUnaryExpression.birch"
  using super_type_::doPrior;
  #line 12 "src/expression/ScalarUnaryExpression.birch"
  using super_type_::doValue;
  
  #line 12 "src/expression/ScalarUnaryExpression.birch"
  ScalarUnaryExpression(const Argument& y, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);

  libbirch::Optional<Argument> y;
  #line 22 "src/expression/ScalarUnaryExpression.birch"
  virtual Value doEvaluate(const ArgumentValue& y, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr) = 0;
  #line 27 "src/expression/ScalarUnaryExpression.birch"
  virtual ArgumentGradient doEvaluateGrad(const birch::type::Real& d, const Value& x, const ArgumentValue& y, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr) = 0;
  #line 30 "src/expression/ScalarUnaryExpression.birch"
  virtual birch::type::Integer doDepth(const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr) final;
  #line 34 "src/expression/ScalarUnaryExpression.birch"
  virtual Value doValue(const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr) final;
  #line 38 "src/expression/ScalarUnaryExpression.birch"
  virtual Value doPilot(const birch::type::Integer& gen, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr) final;
  #line 42 "src/expression/ScalarUnaryExpression.birch"
  virtual Value doGet(const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr) final;
  #line 46 "src/expression/ScalarUnaryExpression.birch"
  virtual Value doMove(const birch::type::Integer& gen, const libbirch::Lazy<libbirch::Shared<birch::type::Kernel>>& _u0954, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr) final;
  #line 50 "src/expression/ScalarUnaryExpression.birch"
  virtual void doGrad(const birch::type::Integer& gen, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr) final;
  #line 54 "src/expression/ScalarUnaryExpression.birch"
  virtual libbirch::Optional<libbirch::Lazy<libbirch::Shared<birch::type::Expression<birch::type::Real>>>> doPrior(const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr) final;
  #line 58 "src/expression/ScalarUnaryExpression.birch"
  virtual birch::type::Real doCompare(const birch::type::Integer& gen, const libbirch::Lazy<libbirch::Shared<birch::type::DelayExpression>>& x, const libbirch::Lazy<libbirch::Shared<birch::type::Kernel>>& _u0954, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr) final;
  #line 65 "src/expression/ScalarUnaryExpression.birch"
  virtual void doConstant(const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr) final;
  #line 69 "src/expression/ScalarUnaryExpression.birch"
  virtual void doCount(const birch::type::Integer& gen, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr) final;
  #line 73 "src/expression/ScalarUnaryExpression.birch"
  virtual void doDetach(const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr) final;
  
  #line 12 "src/expression/ScalarUnaryExpression.birch"
  LIBBIRCH_ABSTRACT_CLASS(ScalarUnaryExpression, ScalarExpression<Value>)
  #line 12 "src/expression/ScalarUnaryExpression.birch"
  LIBBIRCH_MEMBERS(y)
};

template<class Value>
#line 4 "src/expression/ScalarMultivariate.birch"
class ScalarMultivariate final : public ScalarUnaryExpression<libbirch::Lazy<libbirch::Shared<birch::type::Expression<libbirch::DefaultArray<Value,1>>>>, libbirch::DefaultArray<Value,1>, libbirch::DefaultArray<birch::type::Real,1>, Value> {
public:
  #line 4 "src/expression/ScalarMultivariate.birch"
  using class_type_ = ScalarMultivariate<Value>;
  #line 4 "src/expression/ScalarMultivariate.birch"
  using this_type_ = class_type_;
  #line 4 "src/expression/ScalarMultivariate.birch"
  using super_type_ = ScalarUnaryExpression<libbirch::Lazy<libbirch::Shared<birch::type::Expression<libbirch::DefaultArray<Value,1>>>>, libbirch::DefaultArray<Value,1>, libbirch::DefaultArray<birch::type::Real,1>, Value>;

  #line 4 "src/expression/ScalarMultivariate.birch"
  using super_type_::operator=;
  #line 4 "src/expression/ScalarMultivariate.birch"
  using super_type_::doEvaluate;
  #line 4 "src/expression/ScalarMultivariate.birch"
  using super_type_::doEvaluateGrad;
  
  #line 4 "src/expression/ScalarMultivariate.birch"
  ScalarMultivariate(const libbirch::Lazy<libbirch::Shared<birch::type::Expression<libbirch::DefaultArray<Value,1>>>>& y, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);

  #line 6 "src/expression/ScalarMultivariate.birch"
  virtual Value doEvaluate(const libbirch::DefaultArray<Value,1>& y, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr) override;
  #line 10 "src/expression/ScalarMultivariate.birch"
  virtual libbirch::DefaultArray<Value,1> doEvaluateGrad(const birch::type::Real& d, const Value& x, const libbirch::DefaultArray<Value,1>& y, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr) override;
  
  #line 4 "src/expression/ScalarMultivariate.birch"
  LIBBIRCH_CLASS(ScalarMultivariate, ScalarUnaryExpression<libbirch::Lazy<libbirch::Shared<birch::type::Expression<libbirch::DefaultArray<Value,1>>>>, libbirch::DefaultArray<Value,1>, libbirch::DefaultArray<birch::type::Real,1>, Value>)
  #line 4 "src/expression/ScalarMultivariate.birch"
  LIBBIRCH_MEMBERS()
};

template<class Value>
#line 4 "src/expression/ScalarMatrix.birch"
class ScalarMatrix final : public ScalarUnaryExpression<libbirch::Lazy<libbirch::Shared<birch::type::Expression<libbirch::DefaultArray<Value,2>>>>, libbirch::DefaultArray<Value,2>, libbirch::DefaultArray<birch::type::Real,2>, Value> {
public:
  #line 4 "src/expression/ScalarMatrix.birch"
  using class_type_ = ScalarMatrix<Value>;
  #line 4 "src/expression/ScalarMatrix.birch"
  using this_type_ = class_type_;
  #line 4 "src/expression/ScalarMatrix.birch"
  using super_type_ = ScalarUnaryExpression<libbirch::Lazy<libbirch::Shared<birch::type::Expression<libbirch::DefaultArray<Value,2>>>>, libbirch::DefaultArray<Value,2>, libbirch::DefaultArray<birch::type::Real,2>, Value>;

  #line 4 "src/expression/ScalarMatrix.birch"
  using super_type_::operator=;
  #line 4 "src/expression/ScalarMatrix.birch"
  using super_type_::doEvaluate;
  #line 4 "src/expression/ScalarMatrix.birch"
  using super_type_::doEvaluateGrad;
  
  #line 4 "src/expression/ScalarMatrix.birch"
  ScalarMatrix(const libbirch::Lazy<libbirch::Shared<birch::type::Expression<libbirch::DefaultArray<Value,2>>>>& y, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);

  #line 7 "src/expression/ScalarMatrix.birch"
  virtual Value doEvaluate(const libbirch::DefaultArray<Value,2>& y, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr) override;
  #line 11 "src/expression/ScalarMatrix.birch"
  virtual libbirch::DefaultArray<birch::type::Real,2> doEvaluateGrad(const birch::type::Real& d, const Value& x, const libbirch::DefaultArray<Value,2>& y, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr) override;
  
  #line 4 "src/expression/ScalarMatrix.birch"
  LIBBIRCH_CLASS(ScalarMatrix, ScalarUnaryExpression<libbirch::Lazy<libbirch::Shared<birch::type::Expression<libbirch::DefaultArray<Value,2>>>>, libbirch::DefaultArray<Value,2>, libbirch::DefaultArray<birch::type::Real,2>, Value>)
  #line 4 "src/expression/ScalarMatrix.birch"
  LIBBIRCH_MEMBERS()
};

#line 4 "src/expression/Rectify.birch"
class Rectify final : public ScalarUnaryExpression<libbirch::Lazy<libbirch::Shared<birch::type::Expression<birch::type::Real>>>, birch::type::Real, birch::type::Real, birch::type::Real> {
public:
  #line 4 "src/expression/Rectify.birch"
  using class_type_ = Rectify;
  #line 4 "src/expression/Rectify.birch"
  using this_type_ = class_type_;
  #line 4 "src/expression/Rectify.birch"
  using super_type_ = ScalarUnaryExpression<libbirch::Lazy<libbirch::Shared<birch::type::Expression<birch::type::Real>>>, birch::type::Real, birch::type::Real, birch::type::Real>;

  #line 4 "src/expression/Rectify.birch"
  using super_type_::operator=;
  #line 4 "src/expression/Rectify.birch"
  using super_type_::doEvaluate;
  #line 4 "src/expression/Rectify.birch"
  using super_type_::doEvaluateGrad;
  
  #line 4 "src/expression/Rectify.birch"
  Rectify(const libbirch::Lazy<libbirch::Shared<birch::type::Expression<birch::type::Real>>>& y, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);

  #line 6 "src/expression/Rectify.birch"
  virtual birch::type::Real doEvaluate(const birch::type::Real& y, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr) override;
  #line 10 "src/expression/Rectify.birch"
  virtual birch::type::Real doEvaluateGrad(const birch::type::Real& d, const birch::type::Real& x, const birch::type::Real& y, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr) override;
  
  #line 4 "src/expression/Rectify.birch"
  LIBBIRCH_CLASS(Rectify, ScalarUnaryExpression<libbirch::Lazy<libbirch::Shared<birch::type::Expression<birch::type::Real>>>, birch::type::Real, birch::type::Real, birch::type::Real>)
  #line 4 "src/expression/Rectify.birch"
  LIBBIRCH_MEMBERS()
};

#line 4 "src/expression/Negate.birch"
class Negate final : public ScalarUnaryExpression<libbirch::Lazy<libbirch::Shared<birch::type::Expression<birch::type::Real>>>, birch::type::Real, birch::type::Real, birch::type::Real> {
public:
  #line 4 "src/expression/Negate.birch"
  using class_type_ = Negate;
  #line 4 "src/expression/Negate.birch"
  using this_type_ = class_type_;
  #line 4 "src/expression/Negate.birch"
  using super_type_ = ScalarUnaryExpression<libbirch::Lazy<libbirch::Shared<birch::type::Expression<birch::type::Real>>>, birch::type::Real, birch::type::Real, birch::type::Real>;

  #line 4 "src/expression/Negate.birch"
  using super_type_::operator=;
  #line 4 "src/expression/Negate.birch"
  using super_type_::doEvaluate;
  #line 4 "src/expression/Negate.birch"
  using super_type_::doEvaluateGrad;
  #line 4 "src/expression/Negate.birch"
  using super_type_::graftDotMultivariateGaussian;
  #line 4 "src/expression/Negate.birch"
  using super_type_::graftDotMultivariateNormalInverseGamma;
  #line 4 "src/expression/Negate.birch"
  using super_type_::graftLinearGaussian;
  #line 4 "src/expression/Negate.birch"
  using super_type_::graftLinearNormalInverseGamma;
  
  #line 4 "src/expression/Negate.birch"
  Negate(const libbirch::Lazy<libbirch::Shared<birch::type::Expression<birch::type::Real>>>& y, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);

  #line 6 "src/expression/Negate.birch"
  virtual birch::type::Real doEvaluate(const birch::type::Real& y, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr) override;
  #line 10 "src/expression/Negate.birch"
  virtual birch::type::Real doEvaluateGrad(const birch::type::Real& d, const birch::type::Real& x, const birch::type::Real& y, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr) override;
  #line 14 "src/expression/Negate.birch"
  virtual libbirch::Optional<libbirch::Lazy<libbirch::Shared<birch::type::TransformLinear<libbirch::Lazy<libbirch::Shared<birch::type::Gaussian>>>>>> graftLinearGaussian(const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr) override;
  #line 27 "src/expression/Negate.birch"
  virtual libbirch::Optional<libbirch::Lazy<libbirch::Shared<birch::type::TransformDot<libbirch::Lazy<libbirch::Shared<birch::type::MultivariateGaussian>>>>>> graftDotMultivariateGaussian(const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr) override;
  #line 38 "src/expression/Negate.birch"
  virtual libbirch::Optional<libbirch::Lazy<libbirch::Shared<birch::type::TransformLinear<libbirch::Lazy<libbirch::Shared<birch::type::NormalInverseGamma>>>>>> graftLinearNormalInverseGamma(const libbirch::Lazy<libbirch::Shared<birch::type::Distribution<birch::type::Real>>>& compare, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr) override;
  #line 52 "src/expression/Negate.birch"
  virtual libbirch::Optional<libbirch::Lazy<libbirch::Shared<birch::type::TransformDot<libbirch::Lazy<libbirch::Shared<birch::type::MultivariateNormalInverseGamma>>>>>> graftDotMultivariateNormalInverseGamma(const libbirch::Lazy<libbirch::Shared<birch::type::Distribution<birch::type::Real>>>& compare, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr) override;
  
  #line 4 "src/expression/Negate.birch"
  LIBBIRCH_CLASS(Negate, ScalarUnaryExpression<libbirch::Lazy<libbirch::Shared<birch::type::Expression<birch::type::Real>>>, birch::type::Real, birch::type::Real, birch::type::Real>)
  #line 4 "src/expression/Negate.birch"
  LIBBIRCH_MEMBERS()
};

#line 4 "src/expression/LogGammaP.birch"
class LogGammaP final : public ScalarUnaryExpression<libbirch::Lazy<libbirch::Shared<birch::type::Expression<birch::type::Real>>>, birch::type::Real, birch::type::Real, birch::type::Real> {
public:
  #line 4 "src/expression/LogGammaP.birch"
  using class_type_ = LogGammaP;
  #line 4 "src/expression/LogGammaP.birch"
  using this_type_ = class_type_;
  #line 4 "src/expression/LogGammaP.birch"
  using super_type_ = ScalarUnaryExpression<libbirch::Lazy<libbirch::Shared<birch::type::Expression<birch::type::Real>>>, birch::type::Real, birch::type::Real, birch::type::Real>;

  #line 4 "src/expression/LogGammaP.birch"
  using super_type_::operator=;
  #line 4 "src/expression/LogGammaP.birch"
  using super_type_::doEvaluate;
  #line 4 "src/expression/LogGammaP.birch"
  using super_type_::doEvaluateGrad;
  
  #line 4 "src/expression/LogGammaP.birch"
  LogGammaP(const libbirch::Lazy<libbirch::Shared<birch::type::Expression<birch::type::Real>>>& y, const birch::type::Integer& z, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);

  birch::type::Integer z;
  #line 11 "src/expression/LogGammaP.birch"
  virtual birch::type::Real doEvaluate(const birch::type::Real& y, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr) override;
  #line 15 "src/expression/LogGammaP.birch"
  virtual birch::type::Real doEvaluateGrad(const birch::type::Real& d, const birch::type::Real& x, const birch::type::Real& y, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr) override;
  
  #line 4 "src/expression/LogGammaP.birch"
  LIBBIRCH_CLASS(LogGammaP, ScalarUnaryExpression<libbirch::Lazy<libbirch::Shared<birch::type::Expression<birch::type::Real>>>, birch::type::Real, birch::type::Real, birch::type::Real>)
  #line 4 "src/expression/LogGammaP.birch"
  LIBBIRCH_MEMBERS(z)
};

#line 4 "src/expression/LogGamma.birch"
class LogGamma final : public ScalarUnaryExpression<libbirch::Lazy<libbirch::Shared<birch::type::Expression<birch::type::Real>>>, birch::type::Real, birch::type::Real, birch::type::Real> {
public:
  #line 4 "src/expression/LogGamma.birch"
  using class_type_ = LogGamma;
  #line 4 "src/expression/LogGamma.birch"
  using this_type_ = class_type_;
  #line 4 "src/expression/LogGamma.birch"
  using super_type_ = ScalarUnaryExpression<libbirch::Lazy<libbirch::Shared<birch::type::Expression<birch::type::Real>>>, birch::type::Real, birch::type::Real, birch::type::Real>;

  #line 4 "src/expression/LogGamma.birch"
  using super_type_::operator=;
  #line 4 "src/expression/LogGamma.birch"
  using super_type_::doEvaluate;
  #line 4 "src/expression/LogGamma.birch"
  using super_type_::doEvaluateGrad;
  
  #line 4 "src/expression/LogGamma.birch"
  LogGamma(const libbirch::Lazy<libbirch::Shared<birch::type::Expression<birch::type::Real>>>& x, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);

  #line 6 "src/expression/LogGamma.birch"
  virtual birch::type::Real doEvaluate(const birch::type::Real& y, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr) override;
  #line 10 "src/expression/LogGamma.birch"
  virtual birch::type::Real doEvaluateGrad(const birch::type::Real& d, const birch::type::Real& x, const birch::type::Real& y, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr) override;
  
  #line 4 "src/expression/LogGamma.birch"
  LIBBIRCH_CLASS(LogGamma, ScalarUnaryExpression<libbirch::Lazy<libbirch::Shared<birch::type::Expression<birch::type::Real>>>, birch::type::Real, birch::type::Real, birch::type::Real>)
  #line 4 "src/expression/LogGamma.birch"
  LIBBIRCH_MEMBERS()
};

template<class Argument,class ArgumentValue>
#line 4 "src/expression/LogDet.birch"
class LogDet final : public ScalarUnaryExpression<Argument, ArgumentValue, libbirch::DefaultArray<birch::type::Real,2>, birch::type::Real> {
public:
  #line 4 "src/expression/LogDet.birch"
  using class_type_ = LogDet<Argument, ArgumentValue>;
  #line 4 "src/expression/LogDet.birch"
  using this_type_ = class_type_;
  #line 4 "src/expression/LogDet.birch"
  using super_type_ = ScalarUnaryExpression<Argument, ArgumentValue, libbirch::DefaultArray<birch::type::Real,2>, birch::type::Real>;

  #line 4 "src/expression/LogDet.birch"
  using super_type_::operator=;
  #line 4 "src/expression/LogDet.birch"
  using super_type_::doEvaluate;
  #line 4 "src/expression/LogDet.birch"
  using super_type_::doEvaluateGrad;
  
  #line 4 "src/expression/LogDet.birch"
  LogDet(const Argument& y, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);

  #line 6 "src/expression/LogDet.birch"
  virtual birch::type::Real doEvaluate(const ArgumentValue& y, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr) override;
  #line 10 "src/expression/LogDet.birch"
  virtual libbirch::DefaultArray<birch::type::Real,2> doEvaluateGrad(const birch::type::Real& d, const birch::type::Real& x, const ArgumentValue& y, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr) override;
  
  #line 4 "src/expression/LogDet.birch"
  LIBBIRCH_CLASS(LogDet, ScalarUnaryExpression<Argument, ArgumentValue, libbirch::DefaultArray<birch::type::Real,2>, birch::type::Real>)
  #line 4 "src/expression/LogDet.birch"
  LIBBIRCH_MEMBERS()
};

#line 4 "src/expression/Log1p.birch"
class Log1p final : public ScalarUnaryExpression<libbirch::Lazy<libbirch::Shared<birch::type::Expression<birch::type::Real>>>, birch::type::Real, birch::type::Real, birch::type::Real> {
public:
  #line 4 "src/expression/Log1p.birch"
  using class_type_ = Log1p;
  #line 4 "src/expression/Log1p.birch"
  using this_type_ = class_type_;
  #line 4 "src/expression/Log1p.birch"
  using super_type_ = ScalarUnaryExpression<libbirch::Lazy<libbirch::Shared<birch::type::Expression<birch::type::Real>>>, birch::type::Real, birch::type::Real, birch::type::Real>;

  #line 4 "src/expression/Log1p.birch"
  using super_type_::operator=;
  #line 4 "src/expression/Log1p.birch"
  using super_type_::doEvaluate;
  #line 4 "src/expression/Log1p.birch"
  using super_type_::doEvaluateGrad;
  
  #line 4 "src/expression/Log1p.birch"
  Log1p(const libbirch::Lazy<libbirch::Shared<birch::type::Expression<birch::type::Real>>>& y, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);

  #line 6 "src/expression/Log1p.birch"
  virtual birch::type::Real doEvaluate(const birch::type::Real& y, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr) override;
  #line 10 "src/expression/Log1p.birch"
  virtual birch::type::Real doEvaluateGrad(const birch::type::Real& d, const birch::type::Real& x, const birch::type::Real& y, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr) override;
  
  #line 4 "src/expression/Log1p.birch"
  LIBBIRCH_CLASS(Log1p, ScalarUnaryExpression<libbirch::Lazy<libbirch::Shared<birch::type::Expression<birch::type::Real>>>, birch::type::Real, birch::type::Real, birch::type::Real>)
  #line 4 "src/expression/Log1p.birch"
  LIBBIRCH_MEMBERS()
};

#line 4 "src/expression/Log.birch"
class Log final : public ScalarUnaryExpression<libbirch::Lazy<libbirch::Shared<birch::type::Expression<birch::type::Real>>>, birch::type::Real, birch::type::Real, birch::type::Real> {
public:
  #line 4 "src/expression/Log.birch"
  using class_type_ = Log;
  #line 4 "src/expression/Log.birch"
  using this_type_ = class_type_;
  #line 4 "src/expression/Log.birch"
  using super_type_ = ScalarUnaryExpression<libbirch::Lazy<libbirch::Shared<birch::type::Expression<birch::type::Real>>>, birch::type::Real, birch::type::Real, birch::type::Real>;

  #line 4 "src/expression/Log.birch"
  using super_type_::operator=;
  #line 4 "src/expression/Log.birch"
  using super_type_::doEvaluate;
  #line 4 "src/expression/Log.birch"
  using super_type_::doEvaluateGrad;
  
  #line 4 "src/expression/Log.birch"
  Log(const libbirch::Lazy<libbirch::Shared<birch::type::Expression<birch::type::Real>>>& y, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);

  #line 6 "src/expression/Log.birch"
  virtual birch::type::Real doEvaluate(const birch::type::Real& y, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr) override;
  #line 10 "src/expression/Log.birch"
  virtual birch::type::Real doEvaluateGrad(const birch::type::Real& d, const birch::type::Real& x, const birch::type::Real& y, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr) override;
  
  #line 4 "src/expression/Log.birch"
  LIBBIRCH_CLASS(Log, ScalarUnaryExpression<libbirch::Lazy<libbirch::Shared<birch::type::Expression<birch::type::Real>>>, birch::type::Real, birch::type::Real, birch::type::Real>)
  #line 4 "src/expression/Log.birch"
  LIBBIRCH_MEMBERS()
};

#line 4 "src/expression/Exp.birch"
class Exp final : public ScalarUnaryExpression<libbirch::Lazy<libbirch::Shared<birch::type::Expression<birch::type::Real>>>, birch::type::Real, birch::type::Real, birch::type::Real> {
public:
  #line 4 "src/expression/Exp.birch"
  using class_type_ = Exp;
  #line 4 "src/expression/Exp.birch"
  using this_type_ = class_type_;
  #line 4 "src/expression/Exp.birch"
  using super_type_ = ScalarUnaryExpression<libbirch::Lazy<libbirch::Shared<birch::type::Expression<birch::type::Real>>>, birch::type::Real, birch::type::Real, birch::type::Real>;

  #line 4 "src/expression/Exp.birch"
  using super_type_::operator=;
  #line 4 "src/expression/Exp.birch"
  using super_type_::doEvaluate;
  #line 4 "src/expression/Exp.birch"
  using super_type_::doEvaluateGrad;
  
  #line 4 "src/expression/Exp.birch"
  Exp(const libbirch::Lazy<libbirch::Shared<birch::type::Expression<birch::type::Real>>>& y, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);

  #line 6 "src/expression/Exp.birch"
  virtual birch::type::Real doEvaluate(const birch::type::Real& y, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr) override;
  #line 10 "src/expression/Exp.birch"
  virtual birch::type::Real doEvaluateGrad(const birch::type::Real& d, const birch::type::Real& x, const birch::type::Real& y, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr) override;
  
  #line 4 "src/expression/Exp.birch"
  LIBBIRCH_CLASS(Exp, ScalarUnaryExpression<libbirch::Lazy<libbirch::Shared<birch::type::Expression<birch::type::Real>>>, birch::type::Real, birch::type::Real, birch::type::Real>)
  #line 4 "src/expression/Exp.birch"
  LIBBIRCH_MEMBERS()
};

#line 4 "src/expression/DiscreteNegate.birch"
class DiscreteNegate final : public ScalarUnaryExpression<libbirch::Lazy<libbirch::Shared<birch::type::Expression<birch::type::Integer>>>, birch::type::Integer, birch::type::Real, birch::type::Integer> {
public:
  #line 4 "src/expression/DiscreteNegate.birch"
  using class_type_ = DiscreteNegate;
  #line 4 "src/expression/DiscreteNegate.birch"
  using this_type_ = class_type_;
  #line 4 "src/expression/DiscreteNegate.birch"
  using super_type_ = ScalarUnaryExpression<libbirch::Lazy<libbirch::Shared<birch::type::Expression<birch::type::Integer>>>, birch::type::Integer, birch::type::Real, birch::type::Integer>;

  #line 4 "src/expression/DiscreteNegate.birch"
  using super_type_::operator=;
  #line 4 "src/expression/DiscreteNegate.birch"
  using super_type_::doEvaluate;
  #line 4 "src/expression/DiscreteNegate.birch"
  using super_type_::doEvaluateGrad;
  #line 4 "src/expression/DiscreteNegate.birch"
  using super_type_::graftBoundedDiscrete;
  #line 4 "src/expression/DiscreteNegate.birch"
  using super_type_::graftDiscrete;
  
  #line 4 "src/expression/DiscreteNegate.birch"
  DiscreteNegate(const libbirch::Lazy<libbirch::Shared<birch::type::Expression<birch::type::Integer>>>& y, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);

  #line 6 "src/expression/DiscreteNegate.birch"
  virtual birch::type::Integer doEvaluate(const birch::type::Integer& y, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr) override;
  #line 10 "src/expression/DiscreteNegate.birch"
  virtual birch::type::Real doEvaluateGrad(const birch::type::Real& d, const birch::type::Integer& x, const birch::type::Integer& y, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr) override;
  #line 14 "src/expression/DiscreteNegate.birch"
  virtual libbirch::Optional<libbirch::Lazy<libbirch::Shared<birch::type::Discrete>>> graftDiscrete(const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr) override;
  #line 28 "src/expression/DiscreteNegate.birch"
  virtual libbirch::Optional<libbirch::Lazy<libbirch::Shared<birch::type::BoundedDiscrete>>> graftBoundedDiscrete(const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr) override;
  
  #line 4 "src/expression/DiscreteNegate.birch"
  LIBBIRCH_CLASS(DiscreteNegate, ScalarUnaryExpression<libbirch::Lazy<libbirch::Shared<birch::type::Expression<birch::type::Integer>>>, birch::type::Integer, birch::type::Real, birch::type::Integer>)
  #line 4 "src/expression/DiscreteNegate.birch"
  LIBBIRCH_MEMBERS()
};

template<class From,class To>
#line 4 "src/expression/DiscreteCast.birch"
class DiscreteCast final : public ScalarUnaryExpression<libbirch::Lazy<libbirch::Shared<birch::type::Expression<From>>>, From, birch::type::Real, To> {
public:
  #line 4 "src/expression/DiscreteCast.birch"
  using class_type_ = DiscreteCast<From, To>;
  #line 4 "src/expression/DiscreteCast.birch"
  using this_type_ = class_type_;
  #line 4 "src/expression/DiscreteCast.birch"
  using super_type_ = ScalarUnaryExpression<libbirch::Lazy<libbirch::Shared<birch::type::Expression<From>>>, From, birch::type::Real, To>;

  #line 4 "src/expression/DiscreteCast.birch"
  using super_type_::operator=;
  #line 4 "src/expression/DiscreteCast.birch"
  using super_type_::doEvaluate;
  #line 4 "src/expression/DiscreteCast.birch"
  using super_type_::doEvaluateGrad;
  
  #line 4 "src/expression/DiscreteCast.birch"
  DiscreteCast(const libbirch::Lazy<libbirch::Shared<birch::type::Expression<From>>>& y, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);

  #line 6 "src/expression/DiscreteCast.birch"
  virtual To doEvaluate(const From& y, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr) override;
  #line 10 "src/expression/DiscreteCast.birch"
  virtual birch::type::Real doEvaluateGrad(const birch::type::Real& d, const To& x, const From& y, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr) override;
  
  #line 4 "src/expression/DiscreteCast.birch"
  LIBBIRCH_CLASS(DiscreteCast, ScalarUnaryExpression<libbirch::Lazy<libbirch::Shared<birch::type::Expression<From>>>, From, birch::type::Real, To>)
  #line 4 "src/expression/DiscreteCast.birch"
  LIBBIRCH_MEMBERS()
};

#line 4 "src/expression/Cosh.birch"
class Cosh final : public ScalarUnaryExpression<libbirch::Lazy<libbirch::Shared<birch::type::Expression<birch::type::Real>>>, birch::type::Real, birch::type::Real, birch::type::Real> {
public:
  #line 4 "src/expression/Cosh.birch"
  using class_type_ = Cosh;
  #line 4 "src/expression/Cosh.birch"
  using this_type_ = class_type_;
  #line 4 "src/expression/Cosh.birch"
  using super_type_ = ScalarUnaryExpression<libbirch::Lazy<libbirch::Shared<birch::type::Expression<birch::type::Real>>>, birch::type::Real, birch::type::Real, birch::type::Real>;

  #line 4 "src/expression/Cosh.birch"
  using super_type_::operator=;
  #line 4 "src/expression/Cosh.birch"
  using super_type_::doEvaluate;
  #line 4 "src/expression/Cosh.birch"
  using super_type_::doEvaluateGrad;
  
  #line 4 "src/expression/Cosh.birch"
  Cosh(const libbirch::Lazy<libbirch::Shared<birch::type::Expression<birch::type::Real>>>& y, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);

  #line 6 "src/expression/Cosh.birch"
  virtual birch::type::Real doEvaluate(const birch::type::Real& y, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr) override;
  #line 10 "src/expression/Cosh.birch"
  virtual birch::type::Real doEvaluateGrad(const birch::type::Real& d, const birch::type::Real& x, const birch::type::Real& y, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr) override;
  
  #line 4 "src/expression/Cosh.birch"
  LIBBIRCH_CLASS(Cosh, ScalarUnaryExpression<libbirch::Lazy<libbirch::Shared<birch::type::Expression<birch::type::Real>>>, birch::type::Real, birch::type::Real, birch::type::Real>)
  #line 4 "src/expression/Cosh.birch"
  LIBBIRCH_MEMBERS()
};

#line 4 "src/expression/Cos.birch"
class Cos final : public ScalarUnaryExpression<libbirch::Lazy<libbirch::Shared<birch::type::Expression<birch::type::Real>>>, birch::type::Real, birch::type::Real, birch::type::Real> {
public:
  #line 4 "src/expression/Cos.birch"
  using class_type_ = Cos;
  #line 4 "src/expression/Cos.birch"
  using this_type_ = class_type_;
  #line 4 "src/expression/Cos.birch"
  using super_type_ = ScalarUnaryExpression<libbirch::Lazy<libbirch::Shared<birch::type::Expression<birch::type::Real>>>, birch::type::Real, birch::type::Real, birch::type::Real>;

  #line 4 "src/expression/Cos.birch"
  using super_type_::operator=;
  #line 4 "src/expression/Cos.birch"
  using super_type_::doEvaluate;
  #line 4 "src/expression/Cos.birch"
  using super_type_::doEvaluateGrad;
  
  #line 4 "src/expression/Cos.birch"
  Cos(const libbirch::Lazy<libbirch::Shared<birch::type::Expression<birch::type::Real>>>& y, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);

  #line 6 "src/expression/Cos.birch"
  virtual birch::type::Real doEvaluate(const birch::type::Real& y, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr) override;
  #line 10 "src/expression/Cos.birch"
  virtual birch::type::Real doEvaluateGrad(const birch::type::Real& d, const birch::type::Real& x, const birch::type::Real& y, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr) override;
  
  #line 4 "src/expression/Cos.birch"
  LIBBIRCH_CLASS(Cos, ScalarUnaryExpression<libbirch::Lazy<libbirch::Shared<birch::type::Expression<birch::type::Real>>>, birch::type::Real, birch::type::Real, birch::type::Real>)
  #line 4 "src/expression/Cos.birch"
  LIBBIRCH_MEMBERS()
};

template<class From,class To>
#line 4 "src/expression/Cast.birch"
class Cast final : public ScalarUnaryExpression<libbirch::Lazy<libbirch::Shared<birch::type::Expression<From>>>, From, birch::type::Real, To> {
public:
  #line 4 "src/expression/Cast.birch"
  using class_type_ = Cast<From, To>;
  #line 4 "src/expression/Cast.birch"
  using this_type_ = class_type_;
  #line 4 "src/expression/Cast.birch"
  using super_type_ = ScalarUnaryExpression<libbirch::Lazy<libbirch::Shared<birch::type::Expression<From>>>, From, birch::type::Real, To>;

  #line 4 "src/expression/Cast.birch"
  using super_type_::operator=;
  #line 4 "src/expression/Cast.birch"
  using super_type_::doEvaluate;
  #line 4 "src/expression/Cast.birch"
  using super_type_::doEvaluateGrad;
  
  #line 4 "src/expression/Cast.birch"
  Cast(const libbirch::Lazy<libbirch::Shared<birch::type::Expression<From>>>& y, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);

  #line 6 "src/expression/Cast.birch"
  virtual To doEvaluate(const From& y, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr) override;
  #line 10 "src/expression/Cast.birch"
  virtual birch::type::Real doEvaluateGrad(const birch::type::Real& d, const To& x, const From& y, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr) override;
  
  #line 4 "src/expression/Cast.birch"
  LIBBIRCH_CLASS(Cast, ScalarUnaryExpression<libbirch::Lazy<libbirch::Shared<birch::type::Expression<From>>>, From, birch::type::Real, To>)
  #line 4 "src/expression/Cast.birch"
  LIBBIRCH_MEMBERS()
};

#line 4 "src/expression/Atan.birch"
class Atan final : public ScalarUnaryExpression<libbirch::Lazy<libbirch::Shared<birch::type::Expression<birch::type::Real>>>, birch::type::Real, birch::type::Real, birch::type::Real> {
public:
  #line 4 "src/expression/Atan.birch"
  using class_type_ = Atan;
  #line 4 "src/expression/Atan.birch"
  using this_type_ = class_type_;
  #line 4 "src/expression/Atan.birch"
  using super_type_ = ScalarUnaryExpression<libbirch::Lazy<libbirch::Shared<birch::type::Expression<birch::type::Real>>>, birch::type::Real, birch::type::Real, birch::type::Real>;

  #line 4 "src/expression/Atan.birch"
  using super_type_::operator=;
  #line 4 "src/expression/Atan.birch"
  using super_type_::doEvaluate;
  #line 4 "src/expression/Atan.birch"
  using super_type_::doEvaluateGrad;
  
  #line 4 "src/expression/Atan.birch"
  Atan(const libbirch::Lazy<libbirch::Shared<birch::type::Expression<birch::type::Real>>>& y, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);

  #line 6 "src/expression/Atan.birch"
  virtual birch::type::Real doEvaluate(const birch::type::Real& y, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr) override;
  #line 10 "src/expression/Atan.birch"
  virtual birch::type::Real doEvaluateGrad(const birch::type::Real& d, const birch::type::Real& x, const birch::type::Real& y, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr) override;
  
  #line 4 "src/expression/Atan.birch"
  LIBBIRCH_CLASS(Atan, ScalarUnaryExpression<libbirch::Lazy<libbirch::Shared<birch::type::Expression<birch::type::Real>>>, birch::type::Real, birch::type::Real, birch::type::Real>)
  #line 4 "src/expression/Atan.birch"
  LIBBIRCH_MEMBERS()
};

#line 4 "src/expression/Asin.birch"
class Asin final : public ScalarUnaryExpression<libbirch::Lazy<libbirch::Shared<birch::type::Expression<birch::type::Real>>>, birch::type::Real, birch::type::Real, birch::type::Real> {
public:
  #line 4 "src/expression/Asin.birch"
  using class_type_ = Asin;
  #line 4 "src/expression/Asin.birch"
  using this_type_ = class_type_;
  #line 4 "src/expression/Asin.birch"
  using super_type_ = ScalarUnaryExpression<libbirch::Lazy<libbirch::Shared<birch::type::Expression<birch::type::Real>>>, birch::type::Real, birch::type::Real, birch::type::Real>;

  #line 4 "src/expression/Asin.birch"
  using super_type_::operator=;
  #line 4 "src/expression/Asin.birch"
  using super_type_::doEvaluate;
  #line 4 "src/expression/Asin.birch"
  using super_type_::doEvaluateGrad;
  
  #line 4 "src/expression/Asin.birch"
  Asin(const libbirch::Lazy<libbirch::Shared<birch::type::Expression<birch::type::Real>>>& y, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);

  #line 6 "src/expression/Asin.birch"
  virtual birch::type::Real doEvaluate(const birch::type::Real& y, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr) override;
  #line 10 "src/expression/Asin.birch"
  virtual birch::type::Real doEvaluateGrad(const birch::type::Real& d, const birch::type::Real& x, const birch::type::Real& y, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr) override;
  
  #line 4 "src/expression/Asin.birch"
  LIBBIRCH_CLASS(Asin, ScalarUnaryExpression<libbirch::Lazy<libbirch::Shared<birch::type::Expression<birch::type::Real>>>, birch::type::Real, birch::type::Real, birch::type::Real>)
  #line 4 "src/expression/Asin.birch"
  LIBBIRCH_MEMBERS()
};

#line 4 "src/expression/Acos.birch"
class Acos final : public ScalarUnaryExpression<libbirch::Lazy<libbirch::Shared<birch::type::Expression<birch::type::Real>>>, birch::type::Real, birch::type::Real, birch::type::Real> {
public:
  #line 4 "src/expression/Acos.birch"
  using class_type_ = Acos;
  #line 4 "src/expression/Acos.birch"
  using this_type_ = class_type_;
  #line 4 "src/expression/Acos.birch"
  using super_type_ = ScalarUnaryExpression<libbirch::Lazy<libbirch::Shared<birch::type::Expression<birch::type::Real>>>, birch::type::Real, birch::type::Real, birch::type::Real>;

  #line 4 "src/expression/Acos.birch"
  using super_type_::operator=;
  #line 4 "src/expression/Acos.birch"
  using super_type_::doEvaluate;
  #line 4 "src/expression/Acos.birch"
  using super_type_::doEvaluateGrad;
  
  #line 4 "src/expression/Acos.birch"
  Acos(const libbirch::Lazy<libbirch::Shared<birch::type::Expression<birch::type::Real>>>& y, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);

  #line 6 "src/expression/Acos.birch"
  virtual birch::type::Real doEvaluate(const birch::type::Real& y, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr) override;
  #line 10 "src/expression/Acos.birch"
  virtual birch::type::Real doEvaluateGrad(const birch::type::Real& d, const birch::type::Real& x, const birch::type::Real& y, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr) override;
  
  #line 4 "src/expression/Acos.birch"
  LIBBIRCH_CLASS(Acos, ScalarUnaryExpression<libbirch::Lazy<libbirch::Shared<birch::type::Expression<birch::type::Real>>>, birch::type::Real, birch::type::Real, birch::type::Real>)
  #line 4 "src/expression/Acos.birch"
  LIBBIRCH_MEMBERS()
};

#line 4 "src/expression/Abs.birch"
class Abs final : public ScalarUnaryExpression<libbirch::Lazy<libbirch::Shared<birch::type::Expression<birch::type::Real>>>, birch::type::Real, birch::type::Real, birch::type::Real> {
public:
  #line 4 "src/expression/Abs.birch"
  using class_type_ = Abs;
  #line 4 "src/expression/Abs.birch"
  using this_type_ = class_type_;
  #line 4 "src/expression/Abs.birch"
  using super_type_ = ScalarUnaryExpression<libbirch::Lazy<libbirch::Shared<birch::type::Expression<birch::type::Real>>>, birch::type::Real, birch::type::Real, birch::type::Real>;

  #line 4 "src/expression/Abs.birch"
  using super_type_::operator=;
  #line 4 "src/expression/Abs.birch"
  using super_type_::doEvaluate;
  #line 4 "src/expression/Abs.birch"
  using super_type_::doEvaluateGrad;
  
  #line 4 "src/expression/Abs.birch"
  Abs(const libbirch::Lazy<libbirch::Shared<birch::type::Expression<birch::type::Real>>>& y, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);

  #line 6 "src/expression/Abs.birch"
  virtual birch::type::Real doEvaluate(const birch::type::Real& y, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr) override;
  #line 10 "src/expression/Abs.birch"
  virtual birch::type::Real doEvaluateGrad(const birch::type::Real& d, const birch::type::Real& x, const birch::type::Real& y, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr) override;
  
  #line 4 "src/expression/Abs.birch"
  LIBBIRCH_CLASS(Abs, ScalarUnaryExpression<libbirch::Lazy<libbirch::Shared<birch::type::Expression<birch::type::Real>>>, birch::type::Real, birch::type::Real, birch::type::Real>)
  #line 4 "src/expression/Abs.birch"
  LIBBIRCH_MEMBERS()
};

#line 4 "src/expression/Sin.birch"
class Sin final : public ScalarUnaryExpression<libbirch::Lazy<libbirch::Shared<birch::type::Expression<birch::type::Real>>>, birch::type::Real, birch::type::Real, birch::type::Real> {
public:
  #line 4 "src/expression/Sin.birch"
  using class_type_ = Sin;
  #line 4 "src/expression/Sin.birch"
  using this_type_ = class_type_;
  #line 4 "src/expression/Sin.birch"
  using super_type_ = ScalarUnaryExpression<libbirch::Lazy<libbirch::Shared<birch::type::Expression<birch::type::Real>>>, birch::type::Real, birch::type::Real, birch::type::Real>;

  #line 4 "src/expression/Sin.birch"
  using super_type_::operator=;
  #line 4 "src/expression/Sin.birch"
  using super_type_::doEvaluate;
  #line 4 "src/expression/Sin.birch"
  using super_type_::doEvaluateGrad;
  
  #line 4 "src/expression/Sin.birch"
  Sin(const libbirch::Lazy<libbirch::Shared<birch::type::Expression<birch::type::Real>>>& y, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);

  #line 6 "src/expression/Sin.birch"
  virtual birch::type::Real doEvaluate(const birch::type::Real& y, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr) override;
  #line 10 "src/expression/Sin.birch"
  virtual birch::type::Real doEvaluateGrad(const birch::type::Real& d, const birch::type::Real& x, const birch::type::Real& y, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr) override;
  
  #line 4 "src/expression/Sin.birch"
  LIBBIRCH_CLASS(Sin, ScalarUnaryExpression<libbirch::Lazy<libbirch::Shared<birch::type::Expression<birch::type::Real>>>, birch::type::Real, birch::type::Real, birch::type::Real>)
  #line 4 "src/expression/Sin.birch"
  LIBBIRCH_MEMBERS()
};

#line 4 "src/expression/Sinh.birch"
class Sinh final : public ScalarUnaryExpression<libbirch::Lazy<libbirch::Shared<birch::type::Expression<birch::type::Real>>>, birch::type::Real, birch::type::Real, birch::type::Real> {
public:
  #line 4 "src/expression/Sinh.birch"
  using class_type_ = Sinh;
  #line 4 "src/expression/Sinh.birch"
  using this_type_ = class_type_;
  #line 4 "src/expression/Sinh.birch"
  using super_type_ = ScalarUnaryExpression<libbirch::Lazy<libbirch::Shared<birch::type::Expression<birch::type::Real>>>, birch::type::Real, birch::type::Real, birch::type::Real>;

  #line 4 "src/expression/Sinh.birch"
  using super_type_::operator=;
  #line 4 "src/expression/Sinh.birch"
  using super_type_::doEvaluate;
  #line 4 "src/expression/Sinh.birch"
  using super_type_::doEvaluateGrad;
  
  #line 4 "src/expression/Sinh.birch"
  Sinh(const libbirch::Lazy<libbirch::Shared<birch::type::Expression<birch::type::Real>>>& y, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);

  #line 6 "src/expression/Sinh.birch"
  virtual birch::type::Real doEvaluate(const birch::type::Real& y, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr) override;
  #line 10 "src/expression/Sinh.birch"
  virtual birch::type::Real doEvaluateGrad(const birch::type::Real& d, const birch::type::Real& x, const birch::type::Real& y, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr) override;
  
  #line 4 "src/expression/Sinh.birch"
  LIBBIRCH_CLASS(Sinh, ScalarUnaryExpression<libbirch::Lazy<libbirch::Shared<birch::type::Expression<birch::type::Real>>>, birch::type::Real, birch::type::Real, birch::type::Real>)
  #line 4 "src/expression/Sinh.birch"
  LIBBIRCH_MEMBERS()
};

#line 4 "src/expression/Sqrt.birch"
class Sqrt final : public ScalarUnaryExpression<libbirch::Lazy<libbirch::Shared<birch::type::Expression<birch::type::Real>>>, birch::type::Real, birch::type::Real, birch::type::Real> {
public:
  #line 4 "src/expression/Sqrt.birch"
  using class_type_ = Sqrt;
  #line 4 "src/expression/Sqrt.birch"
  using this_type_ = class_type_;
  #line 4 "src/expression/Sqrt.birch"
  using super_type_ = ScalarUnaryExpression<libbirch::Lazy<libbirch::Shared<birch::type::Expression<birch::type::Real>>>, birch::type::Real, birch::type::Real, birch::type::Real>;

  #line 4 "src/expression/Sqrt.birch"
  using super_type_::operator=;
  #line 4 "src/expression/Sqrt.birch"
  using super_type_::doEvaluate;
  #line 4 "src/expression/Sqrt.birch"
  using super_type_::doEvaluateGrad;
  
  #line 4 "src/expression/Sqrt.birch"
  Sqrt(const libbirch::Lazy<libbirch::Shared<birch::type::Expression<birch::type::Real>>>& y, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);

  #line 6 "src/expression/Sqrt.birch"
  virtual birch::type::Real doEvaluate(const birch::type::Real& y, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr) override;
  #line 10 "src/expression/Sqrt.birch"
  virtual birch::type::Real doEvaluateGrad(const birch::type::Real& d, const birch::type::Real& x, const birch::type::Real& y, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr) override;
  
  #line 4 "src/expression/Sqrt.birch"
  LIBBIRCH_CLASS(Sqrt, ScalarUnaryExpression<libbirch::Lazy<libbirch::Shared<birch::type::Expression<birch::type::Real>>>, birch::type::Real, birch::type::Real, birch::type::Real>)
  #line 4 "src/expression/Sqrt.birch"
  LIBBIRCH_MEMBERS()
};

#line 4 "src/expression/Tan.birch"
class Tan final : public ScalarUnaryExpression<libbirch::Lazy<libbirch::Shared<birch::type::Expression<birch::type::Real>>>, birch::type::Real, birch::type::Real, birch::type::Real> {
public:
  #line 4 "src/expression/Tan.birch"
  using class_type_ = Tan;
  #line 4 "src/expression/Tan.birch"
  using this_type_ = class_type_;
  #line 4 "src/expression/Tan.birch"
  using super_type_ = ScalarUnaryExpression<libbirch::Lazy<libbirch::Shared<birch::type::Expression<birch::type::Real>>>, birch::type::Real, birch::type::Real, birch::type::Real>;

  #line 4 "src/expression/Tan.birch"
  using super_type_::operator=;
  #line 4 "src/expression/Tan.birch"
  using super_type_::doEvaluate;
  #line 4 "src/expression/Tan.birch"
  using super_type_::doEvaluateGrad;
  
  #line 4 "src/expression/Tan.birch"
  Tan(const libbirch::Lazy<libbirch::Shared<birch::type::Expression<birch::type::Real>>>& y, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);

  #line 6 "src/expression/Tan.birch"
  virtual birch::type::Real doEvaluate(const birch::type::Real& y, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr) override;
  #line 10 "src/expression/Tan.birch"
  virtual birch::type::Real doEvaluateGrad(const birch::type::Real& d, const birch::type::Real& x, const birch::type::Real& y, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr) override;
  
  #line 4 "src/expression/Tan.birch"
  LIBBIRCH_CLASS(Tan, ScalarUnaryExpression<libbirch::Lazy<libbirch::Shared<birch::type::Expression<birch::type::Real>>>, birch::type::Real, birch::type::Real, birch::type::Real>)
  #line 4 "src/expression/Tan.birch"
  LIBBIRCH_MEMBERS()
};

#line 4 "src/expression/Tanh.birch"
class Tanh final : public ScalarUnaryExpression<libbirch::Lazy<libbirch::Shared<birch::type::Expression<birch::type::Real>>>, birch::type::Real, birch::type::Real, birch::type::Real> {
public:
  #line 4 "src/expression/Tanh.birch"
  using class_type_ = Tanh;
  #line 4 "src/expression/Tanh.birch"
  using this_type_ = class_type_;
  #line 4 "src/expression/Tanh.birch"
  using super_type_ = ScalarUnaryExpression<libbirch::Lazy<libbirch::Shared<birch::type::Expression<birch::type::Real>>>, birch::type::Real, birch::type::Real, birch::type::Real>;

  #line 4 "src/expression/Tanh.birch"
  using super_type_::operator=;
  #line 4 "src/expression/Tanh.birch"
  using super_type_::doEvaluate;
  #line 4 "src/expression/Tanh.birch"
  using super_type_::doEvaluateGrad;
  
  #line 4 "src/expression/Tanh.birch"
  Tanh(const libbirch::Lazy<libbirch::Shared<birch::type::Expression<birch::type::Real>>>& y, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);

  #line 6 "src/expression/Tanh.birch"
  virtual birch::type::Real doEvaluate(const birch::type::Real& y, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr) override;
  #line 10 "src/expression/Tanh.birch"
  virtual birch::type::Real doEvaluateGrad(const birch::type::Real& d, const birch::type::Real& x, const birch::type::Real& y, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr) override;
  
  #line 4 "src/expression/Tanh.birch"
  LIBBIRCH_CLASS(Tanh, ScalarUnaryExpression<libbirch::Lazy<libbirch::Shared<birch::type::Expression<birch::type::Real>>>, birch::type::Real, birch::type::Real, birch::type::Real>)
  #line 4 "src/expression/Tanh.birch"
  LIBBIRCH_MEMBERS()
};

template<class Argument,class ArgumentValue>
#line 4 "src/expression/Trace.birch"
class Trace final : public ScalarUnaryExpression<Argument, ArgumentValue, libbirch::DefaultArray<birch::type::Real,2>, birch::type::Real> {
public:
  #line 4 "src/expression/Trace.birch"
  using class_type_ = Trace<Argument, ArgumentValue>;
  #line 4 "src/expression/Trace.birch"
  using this_type_ = class_type_;
  #line 4 "src/expression/Trace.birch"
  using super_type_ = ScalarUnaryExpression<Argument, ArgumentValue, libbirch::DefaultArray<birch::type::Real,2>, birch::type::Real>;

  #line 4 "src/expression/Trace.birch"
  using super_type_::operator=;
  #line 4 "src/expression/Trace.birch"
  using super_type_::doEvaluate;
  #line 4 "src/expression/Trace.birch"
  using super_type_::doEvaluateGrad;
  
  #line 4 "src/expression/Trace.birch"
  Trace(const Argument& y, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);

  #line 6 "src/expression/Trace.birch"
  virtual birch::type::Real doEvaluate(const ArgumentValue& y, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr) override;
  #line 10 "src/expression/Trace.birch"
  virtual libbirch::DefaultArray<birch::type::Real,2> doEvaluateGrad(const birch::type::Real& d, const birch::type::Real& x, const ArgumentValue& y, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr) override;
  
  #line 4 "src/expression/Trace.birch"
  LIBBIRCH_CLASS(Trace, ScalarUnaryExpression<Argument, ArgumentValue, libbirch::DefaultArray<birch::type::Real,2>, birch::type::Real>)
  #line 4 "src/expression/Trace.birch"
  LIBBIRCH_MEMBERS()
};

#line 1 "src/filter/ParticleFilter.birch"
class ParticleFilter : public Object {
public:
  #line 1 "src/filter/ParticleFilter.birch"
  using class_type_ = ParticleFilter;
  #line 1 "src/filter/ParticleFilter.birch"
  using this_type_ = class_type_;
  #line 1 "src/filter/ParticleFilter.birch"
  using super_type_ = Object;

  #line 1 "src/filter/ParticleFilter.birch"
  using super_type_::operator=;
  
  #line 1 "src/filter/ParticleFilter.birch"
  ParticleFilter(const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);

  libbirch::DefaultArray<libbirch::Lazy<libbirch::Shared<birch::type::Particle>>,1> x;
  libbirch::DefaultArray<birch::type::Real,1> w;
  libbirch::DefaultArray<birch::type::Integer,1> a;
  birch::type::Real ess;
  birch::type::Real lsum;
  birch::type::Real lnormalize;
  birch::type::Integer npropagations;
  birch::type::Real raccept;
  libbirch::Optional<birch::type::Integer> nsteps;
  birch::type::Integer nforecasts;
  birch::type::Integer nparticles;
  birch::type::Real trigger;
  birch::type::Boolean delayed;
  #line 92 "src/filter/ParticleFilter.birch"
  virtual birch::type::Integer size(const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
  #line 100 "src/filter/ParticleFilter.birch"
  virtual libbirch::Lazy<libbirch::Shared<birch::type::Particle>> particle(const libbirch::Lazy<libbirch::Shared<birch::type::Model>>& archetype, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
  #line 111 "src/filter/ParticleFilter.birch"
  virtual void initialize(const libbirch::Lazy<libbirch::Shared<birch::type::Model>>& archetype, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
  #line 128 "src/filter/ParticleFilter.birch"
  virtual void filter(const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
  #line 138 "src/filter/ParticleFilter.birch"
  virtual void filter(const birch::type::Integer& t, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
  #line 147 "src/filter/ParticleFilter.birch"
  virtual void propagate(const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
  #line 160 "src/filter/ParticleFilter.birch"
  virtual void propagate(const birch::type::Integer& t, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
  #line 173 "src/filter/ParticleFilter.birch"
  virtual void forecast(const birch::type::Integer& t, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
  #line 187 "src/filter/ParticleFilter.birch"
  virtual void reduce(const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
  #line 195 "src/filter/ParticleFilter.birch"
  virtual void resample(const birch::type::Integer& t, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
  #line 214 "src/filter/ParticleFilter.birch"
  virtual void write(const libbirch::Lazy<libbirch::Shared<birch::type::Buffer>>& buffer, const birch::type::Integer& t, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
  #line 223 "src/filter/ParticleFilter.birch"
  virtual void read(const libbirch::Lazy<libbirch::Shared<birch::type::Buffer>>& buffer, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr) override;
  #line 232 "src/filter/ParticleFilter.birch"
  virtual void write(const libbirch::Lazy<libbirch::Shared<birch::type::Buffer>>& buffer, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr) override;
  
  #line 1 "src/filter/ParticleFilter.birch"
  LIBBIRCH_CLASS(ParticleFilter, Object)
  #line 1 "src/filter/ParticleFilter.birch"
  LIBBIRCH_MEMBERS(x, w, a, ess, lsum, lnormalize, npropagations, raccept, nsteps, nforecasts, nparticles, trigger, delayed)
};

#line 1 "src/filter/ParticleFilter.birch"
extern "C" birch::type::ParticleFilter* make_ParticleFilter_();

#line 1 "src/filter/MoveParticleFilter.birch"
class MoveParticleFilter : public ParticleFilter {
public:
  #line 1 "src/filter/MoveParticleFilter.birch"
  using class_type_ = MoveParticleFilter;
  #line 1 "src/filter/MoveParticleFilter.birch"
  using this_type_ = class_type_;
  #line 1 "src/filter/MoveParticleFilter.birch"
  using super_type_ = ParticleFilter;

  #line 1 "src/filter/MoveParticleFilter.birch"
  using super_type_::operator=;
  #line 1 "src/filter/MoveParticleFilter.birch"
  using super_type_::filter;
  #line 1 "src/filter/MoveParticleFilter.birch"
  using super_type_::particle;
  #line 1 "src/filter/MoveParticleFilter.birch"
  using super_type_::propagate;
  #line 1 "src/filter/MoveParticleFilter.birch"
  using super_type_::read;
  #line 1 "src/filter/MoveParticleFilter.birch"
  using super_type_::reduce;
  #line 1 "src/filter/MoveParticleFilter.birch"
  using super_type_::write;
  
  #line 1 "src/filter/MoveParticleFilter.birch"
  MoveParticleFilter(const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);

  libbirch::DefaultArray<birch::type::Integer,1> naccepts;
  birch::type::Real scale;
  birch::type::Integer nmoves;
  birch::type::Integer nlags;
  #line 36 "src/filter/MoveParticleFilter.birch"
  virtual libbirch::Lazy<libbirch::Shared<birch::type::Particle>> particle(const libbirch::Lazy<libbirch::Shared<birch::type::Model>>& archetype, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
  #line 40 "src/filter/MoveParticleFilter.birch"
  virtual void filter(const birch::type::Integer& t, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr) override;
  #line 47 "src/filter/MoveParticleFilter.birch"
  virtual void propagate(const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr) override;
  #line 62 "src/filter/MoveParticleFilter.birch"
  virtual void propagate(const birch::type::Integer& t, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr) override;
  #line 77 "src/filter/MoveParticleFilter.birch"
  virtual void move(const birch::type::Integer& t, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
  #line 101 "src/filter/MoveParticleFilter.birch"
  virtual void reduce(const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr) override;
  #line 106 "src/filter/MoveParticleFilter.birch"
  virtual void read(const libbirch::Lazy<libbirch::Shared<birch::type::Buffer>>& buffer, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr) override;
  #line 113 "src/filter/MoveParticleFilter.birch"
  virtual void write(const libbirch::Lazy<libbirch::Shared<birch::type::Buffer>>& buffer, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr) override;
  
  #line 1 "src/filter/MoveParticleFilter.birch"
  LIBBIRCH_CLASS(MoveParticleFilter, ParticleFilter)
  #line 1 "src/filter/MoveParticleFilter.birch"
  LIBBIRCH_MEMBERS(naccepts, scale, nmoves, nlags)
};

#line 1 "src/filter/MoveParticleFilter.birch"
extern "C" birch::type::MoveParticleFilter* make_MoveParticleFilter_();

#line 1 "src/filter/ConditionalParticleFilter.birch"
class ConditionalParticleFilter : public ParticleFilter {
public:
  #line 1 "src/filter/ConditionalParticleFilter.birch"
  using class_type_ = ConditionalParticleFilter;
  #line 1 "src/filter/ConditionalParticleFilter.birch"
  using this_type_ = class_type_;
  #line 1 "src/filter/ConditionalParticleFilter.birch"
  using super_type_ = ParticleFilter;

  #line 1 "src/filter/ConditionalParticleFilter.birch"
  using super_type_::operator=;
  #line 1 "src/filter/ConditionalParticleFilter.birch"
  using super_type_::filter;
  #line 1 "src/filter/ConditionalParticleFilter.birch"
  using super_type_::initialize;
  #line 1 "src/filter/ConditionalParticleFilter.birch"
  using super_type_::particle;
  #line 1 "src/filter/ConditionalParticleFilter.birch"
  using super_type_::propagate;
  #line 1 "src/filter/ConditionalParticleFilter.birch"
  using super_type_::read;
  #line 1 "src/filter/ConditionalParticleFilter.birch"
  using super_type_::resample;
  #line 1 "src/filter/ConditionalParticleFilter.birch"
  using super_type_::write;
  
  #line 1 "src/filter/ConditionalParticleFilter.birch"
  ConditionalParticleFilter(const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);

  libbirch::Optional<libbirch::Lazy<libbirch::Shared<birch::type::Tape<libbirch::Lazy<libbirch::Shared<birch::type::Record>>>>>> r;
  birch::type::Integer b;
  birch::type::Boolean ancestor;
  birch::type::Boolean alreadyInitialized;
  #line 44 "src/filter/ConditionalParticleFilter.birch"
  virtual libbirch::Lazy<libbirch::Shared<birch::type::Particle>> particle(const libbirch::Lazy<libbirch::Shared<birch::type::Model>>& archetype, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
  #line 48 "src/filter/ConditionalParticleFilter.birch"
  virtual void initialize(const libbirch::Lazy<libbirch::Shared<birch::type::Model>>& archetype, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr) override;
  #line 53 "src/filter/ConditionalParticleFilter.birch"
  virtual void filter(const birch::type::Integer& t, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr) override;
  #line 62 "src/filter/ConditionalParticleFilter.birch"
  virtual void ancestorSample(const birch::type::Integer& t, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
  #line 78 "src/filter/ConditionalParticleFilter.birch"
  virtual void propagate(const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr) override;
  #line 95 "src/filter/ConditionalParticleFilter.birch"
  virtual void propagate(const birch::type::Integer& t, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr) override;
  #line 110 "src/filter/ConditionalParticleFilter.birch"
  virtual void resample(const birch::type::Integer& t, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr) override;
  #line 130 "src/filter/ConditionalParticleFilter.birch"
  virtual void read(const libbirch::Lazy<libbirch::Shared<birch::type::Buffer>>& buffer, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr) override;
  #line 135 "src/filter/ConditionalParticleFilter.birch"
  virtual void write(const libbirch::Lazy<libbirch::Shared<birch::type::Buffer>>& buffer, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr) override;
  
  #line 1 "src/filter/ConditionalParticleFilter.birch"
  LIBBIRCH_CLASS(ConditionalParticleFilter, ParticleFilter)
  #line 1 "src/filter/ConditionalParticleFilter.birch"
  LIBBIRCH_MEMBERS(r, b, ancestor, alreadyInitialized)
};

#line 1 "src/filter/ConditionalParticleFilter.birch"
extern "C" birch::type::ConditionalParticleFilter* make_ConditionalParticleFilter_();

#line 1 "src/filter/AliveParticleFilter.birch"
class AliveParticleFilter : public ParticleFilter {
public:
  #line 1 "src/filter/AliveParticleFilter.birch"
  using class_type_ = AliveParticleFilter;
  #line 1 "src/filter/AliveParticleFilter.birch"
  using this_type_ = class_type_;
  #line 1 "src/filter/AliveParticleFilter.birch"
  using super_type_ = ParticleFilter;

  #line 1 "src/filter/AliveParticleFilter.birch"
  using super_type_::operator=;
  #line 1 "src/filter/AliveParticleFilter.birch"
  using super_type_::propagate;
  #line 1 "src/filter/AliveParticleFilter.birch"
  using super_type_::reduce;
  #line 1 "src/filter/AliveParticleFilter.birch"
  using super_type_::resample;
  
  #line 1 "src/filter/AliveParticleFilter.birch"
  AliveParticleFilter(const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);

  libbirch::DefaultArray<birch::type::Integer,1> p;
  #line 24 "src/filter/AliveParticleFilter.birch"
  virtual void propagate(const birch::type::Integer& t, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr) override;
  #line 69 "src/filter/AliveParticleFilter.birch"
  virtual void resample(const birch::type::Integer& t, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr) override;
  #line 80 "src/filter/AliveParticleFilter.birch"
  virtual void reduce(const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr) override;
  
  #line 1 "src/filter/AliveParticleFilter.birch"
  LIBBIRCH_CLASS(AliveParticleFilter, ParticleFilter)
  #line 1 "src/filter/AliveParticleFilter.birch"
  LIBBIRCH_MEMBERS(p)
};

#line 1 "src/filter/AliveParticleFilter.birch"
extern "C" birch::type::AliveParticleFilter* make_AliveParticleFilter_();

#line 13 "src/handler/Handler.birch"
class Handler : public Object {
public:
  #line 13 "src/handler/Handler.birch"
  using class_type_ = Handler;
  #line 13 "src/handler/Handler.birch"
  using this_type_ = class_type_;
  #line 13 "src/handler/Handler.birch"
  using super_type_ = Object;

  #line 13 "src/handler/Handler.birch"
  using super_type_::operator=;
  
  #line 13 "src/handler/Handler.birch"
  Handler(const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);

  libbirch::Optional<libbirch::Lazy<libbirch::Shared<birch::type::Tape<libbirch::Lazy<libbirch::Shared<birch::type::Record>>>>>> input;
  libbirch::Optional<libbirch::Lazy<libbirch::Shared<birch::type::Tape<libbirch::Lazy<libbirch::Shared<birch::type::Record>>>>>> output;
  birch::type::Real w;
  #line 37 "src/handler/Handler.birch"
  virtual void handle(const libbirch::Lazy<libbirch::Shared<birch::type::Event>>& event, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr) final;
  #line 54 "src/handler/Handler.birch"
  virtual void doHandle(const libbirch::Lazy<libbirch::Shared<birch::type::Event>>& event, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr) = 0;
  #line 62 "src/handler/Handler.birch"
  virtual void doHandle(const libbirch::Lazy<libbirch::Shared<birch::type::Record>>& record, const libbirch::Lazy<libbirch::Shared<birch::type::Event>>& event, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr) = 0;
  
  #line 13 "src/handler/Handler.birch"
  LIBBIRCH_ABSTRACT_CLASS(Handler, Object)
  #line 13 "src/handler/Handler.birch"
  LIBBIRCH_MEMBERS(input, output, w)
};

#line 1 "src/handler/MoveHandler.birch"
class MoveHandler : public Handler {
public:
  #line 1 "src/handler/MoveHandler.birch"
  using class_type_ = MoveHandler;
  #line 1 "src/handler/MoveHandler.birch"
  using this_type_ = class_type_;
  #line 1 "src/handler/MoveHandler.birch"
  using super_type_ = Handler;

  #line 1 "src/handler/MoveHandler.birch"
  using super_type_::operator=;
  #line 1 "src/handler/MoveHandler.birch"
  using super_type_::doHandle;
  
  #line 1 "src/handler/MoveHandler.birch"
  MoveHandler(const birch::type::Boolean& delayed, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);

  birch::type::Boolean delayed;
  libbirch::Optional<libbirch::Lazy<libbirch::Shared<birch::type::Expression<birch::type::Real>>>> z;
  #line 26 "src/handler/MoveHandler.birch"
  virtual void doHandle(const libbirch::Lazy<libbirch::Shared<birch::type::Event>>& event, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr) final;
  #line 31 "src/handler/MoveHandler.birch"
  virtual void doHandle(const libbirch::Lazy<libbirch::Shared<birch::type::Record>>& record, const libbirch::Lazy<libbirch::Shared<birch::type::Event>>& event, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr) final;
  template<class Value>
  #line 36 "src/handler/MoveHandler.birch"
  void doHandle(const libbirch::Lazy<libbirch::Shared<birch::type::SimulateEvent<Value>>>& event, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
  template<class Value>
  #line 43 "src/handler/MoveHandler.birch"
  void doHandle(const libbirch::Lazy<libbirch::Shared<birch::type::ObserveEvent<Value>>>& event, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
  template<class Value>
  #line 60 "src/handler/MoveHandler.birch"
  void doHandle(const libbirch::Lazy<libbirch::Shared<birch::type::AssumeEvent<Value>>>& event, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
  #line 81 "src/handler/MoveHandler.birch"
  virtual void doHandle(const libbirch::Lazy<libbirch::Shared<birch::type::FactorEvent>>& event, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
  template<class Value>
  #line 89 "src/handler/MoveHandler.birch"
  void doHandle(const libbirch::Lazy<libbirch::Shared<birch::type::SimulateRecord<Value>>>& record, const libbirch::Lazy<libbirch::Shared<birch::type::SimulateEvent<Value>>>& event, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
  template<class Value>
  #line 97 "src/handler/MoveHandler.birch"
  void doHandle(const libbirch::Lazy<libbirch::Shared<birch::type::ObserveRecord<Value>>>& record, const libbirch::Lazy<libbirch::Shared<birch::type::ObserveEvent<Value>>>& event, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
  template<class Value>
  #line 105 "src/handler/MoveHandler.birch"
  void doHandle(const libbirch::Lazy<libbirch::Shared<birch::type::AssumeRecord<Value>>>& record, const libbirch::Lazy<libbirch::Shared<birch::type::AssumeEvent<Value>>>& event, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
  #line 137 "src/handler/MoveHandler.birch"
  virtual void doHandle(const libbirch::Lazy<libbirch::Shared<birch::type::FactorRecord>>& record, const libbirch::Lazy<libbirch::Shared<birch::type::FactorEvent>>& event, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
  
  #line 1 "src/handler/MoveHandler.birch"
  LIBBIRCH_CLASS(MoveHandler, Handler)
  #line 1 "src/handler/MoveHandler.birch"
  LIBBIRCH_MEMBERS(delayed, z)
};

#line 1 "src/handler/PlayHandler.birch"
class PlayHandler : public Handler {
public:
  #line 1 "src/handler/PlayHandler.birch"
  using class_type_ = PlayHandler;
  #line 1 "src/handler/PlayHandler.birch"
  using this_type_ = class_type_;
  #line 1 "src/handler/PlayHandler.birch"
  using super_type_ = Handler;

  #line 1 "src/handler/PlayHandler.birch"
  using super_type_::operator=;
  #line 1 "src/handler/PlayHandler.birch"
  using super_type_::doHandle;
  
  #line 1 "src/handler/PlayHandler.birch"
  PlayHandler(const birch::type::Boolean& delayed, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);

  birch::type::Boolean delayed;
  #line 21 "src/handler/PlayHandler.birch"
  virtual void doHandle(const libbirch::Lazy<libbirch::Shared<birch::type::Event>>& event, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr) final;
  #line 26 "src/handler/PlayHandler.birch"
  virtual void doHandle(const libbirch::Lazy<libbirch::Shared<birch::type::Record>>& record, const libbirch::Lazy<libbirch::Shared<birch::type::Event>>& event, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr) final;
  template<class Value>
  #line 31 "src/handler/PlayHandler.birch"
  void doHandle(const libbirch::Lazy<libbirch::Shared<birch::type::SimulateEvent<Value>>>& event, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
  template<class Value>
  #line 38 "src/handler/PlayHandler.birch"
  void doHandle(const libbirch::Lazy<libbirch::Shared<birch::type::ObserveEvent<Value>>>& event, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
  template<class Value>
  #line 45 "src/handler/PlayHandler.birch"
  void doHandle(const libbirch::Lazy<libbirch::Shared<birch::type::AssumeEvent<Value>>>& event, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
  #line 56 "src/handler/PlayHandler.birch"
  virtual void doHandle(const libbirch::Lazy<libbirch::Shared<birch::type::FactorEvent>>& event, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
  template<class Value>
  #line 60 "src/handler/PlayHandler.birch"
  void doHandle(const libbirch::Lazy<libbirch::Shared<birch::type::SimulateRecord<Value>>>& record, const libbirch::Lazy<libbirch::Shared<birch::type::SimulateEvent<Value>>>& event, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
  template<class Value>
  #line 68 "src/handler/PlayHandler.birch"
  void doHandle(const libbirch::Lazy<libbirch::Shared<birch::type::ObserveRecord<Value>>>& record, const libbirch::Lazy<libbirch::Shared<birch::type::ObserveEvent<Value>>>& event, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
  template<class Value>
  #line 76 "src/handler/PlayHandler.birch"
  void doHandle(const libbirch::Lazy<libbirch::Shared<birch::type::AssumeRecord<Value>>>& record, const libbirch::Lazy<libbirch::Shared<birch::type::AssumeEvent<Value>>>& event, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
  #line 98 "src/handler/PlayHandler.birch"
  virtual void doHandle(const libbirch::Lazy<libbirch::Shared<birch::type::FactorRecord>>& record, const libbirch::Lazy<libbirch::Shared<birch::type::FactorEvent>>& event, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
  
  #line 1 "src/handler/PlayHandler.birch"
  LIBBIRCH_CLASS(PlayHandler, Handler)
  #line 1 "src/handler/PlayHandler.birch"
  LIBBIRCH_MEMBERS(delayed)
};

#line 1 "src/io/InputStream.birch"
class InputStream : public Object {
public:
  #line 1 "src/io/InputStream.birch"
  using class_type_ = InputStream;
  #line 1 "src/io/InputStream.birch"
  using this_type_ = class_type_;
  #line 1 "src/io/InputStream.birch"
  using super_type_ = Object;

  #line 1 "src/io/InputStream.birch"
  using super_type_::operator=;
  
  #line 1 "src/io/InputStream.birch"
  InputStream(const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);

  libbirch::Optional<birch::type::File> file;
  #line 16 "src/io/InputStream.birch"
  virtual void open(const birch::type::String& path, const birch::type::Integer& mode, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
  #line 26 "src/io/InputStream.birch"
  virtual void open(const birch::type::String& path, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
  #line 33 "src/io/InputStream.birch"
  virtual void close(const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
  #line 42 "src/io/InputStream.birch"
  virtual birch::type::Boolean eof(const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
  #line 52 "src/io/InputStream.birch"
  virtual libbirch::Optional<birch::type::Integer> scanInteger(const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
  #line 68 "src/io/InputStream.birch"
  virtual libbirch::Optional<birch::type::Real> scanReal(const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
  
  #line 1 "src/io/InputStream.birch"
  LIBBIRCH_CLASS(InputStream, Object)
  #line 1 "src/io/InputStream.birch"
  LIBBIRCH_MEMBERS(file)
};

#line 1 "src/io/InputStream.birch"
extern "C" birch::type::InputStream* make_InputStream_();

#line 1 "src/io/OutputStream.birch"
class OutputStream : public Object {
public:
  #line 1 "src/io/OutputStream.birch"
  using class_type_ = OutputStream;
  #line 1 "src/io/OutputStream.birch"
  using this_type_ = class_type_;
  #line 1 "src/io/OutputStream.birch"
  using super_type_ = Object;

  #line 1 "src/io/OutputStream.birch"
  using super_type_::operator=;
  
  #line 1 "src/io/OutputStream.birch"
  OutputStream(const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);

  libbirch::Optional<birch::type::File> file;
  #line 16 "src/io/OutputStream.birch"
  virtual void open(const birch::type::String& path, const birch::type::Integer& mode, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
  #line 25 "src/io/OutputStream.birch"
  virtual void open(const birch::type::String& path, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
  #line 32 "src/io/OutputStream.birch"
  virtual void close(const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
  #line 41 "src/io/OutputStream.birch"
  virtual void flush(const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
  #line 49 "src/io/OutputStream.birch"
  virtual void print(const birch::type::String& value, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
  #line 59 "src/io/OutputStream.birch"
  virtual void print(const birch::type::Boolean& value, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
  #line 66 "src/io/OutputStream.birch"
  virtual void print(const birch::type::Integer& value, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
  #line 73 "src/io/OutputStream.birch"
  virtual void print(const birch::type::Real& value, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
  #line 80 "src/io/OutputStream.birch"
  virtual void print(const libbirch::DefaultArray<birch::type::Boolean,1>& value, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
  #line 87 "src/io/OutputStream.birch"
  virtual void print(const libbirch::DefaultArray<birch::type::Integer,1>& value, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
  #line 94 "src/io/OutputStream.birch"
  virtual void print(const libbirch::DefaultArray<birch::type::Real,1>& value, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
  #line 101 "src/io/OutputStream.birch"
  virtual void print(const libbirch::DefaultArray<birch::type::Boolean,2>& value, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
  #line 108 "src/io/OutputStream.birch"
  virtual void print(const libbirch::DefaultArray<birch::type::Integer,2>& value, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
  #line 115 "src/io/OutputStream.birch"
  virtual void print(const libbirch::DefaultArray<birch::type::Real,2>& value, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
  #line 122 "src/io/OutputStream.birch"
  virtual void print(const birch::type::LLT& value, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
  
  #line 1 "src/io/OutputStream.birch"
  LIBBIRCH_CLASS(OutputStream, Object)
  #line 1 "src/io/OutputStream.birch"
  LIBBIRCH_MEMBERS(file)
};

#line 1 "src/io/OutputStream.birch"
extern "C" birch::type::OutputStream* make_OutputStream_();

#line 37 "src/io/Writer.birch"
class Writer : public Object {
public:
  #line 37 "src/io/Writer.birch"
  using class_type_ = Writer;
  #line 37 "src/io/Writer.birch"
  using this_type_ = class_type_;
  #line 37 "src/io/Writer.birch"
  using super_type_ = Object;

  #line 37 "src/io/Writer.birch"
  using super_type_::operator=;
  
  #line 37 "src/io/Writer.birch"
  Writer(const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);

  #line 43 "src/io/Writer.birch"
  virtual void open(const birch::type::String& path, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr) = 0;
  #line 50 "src/io/Writer.birch"
  virtual void dump(const libbirch::Lazy<libbirch::Shared<birch::type::Buffer>>& buffer, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr) = 0;
  #line 59 "src/io/Writer.birch"
  virtual void push(const libbirch::Lazy<libbirch::Shared<birch::type::Buffer>>& buffer, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr) = 0;
  #line 64 "src/io/Writer.birch"
  virtual void flush(const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr) = 0;
  #line 69 "src/io/Writer.birch"
  virtual void close(const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr) = 0;
  #line 71 "src/io/Writer.birch"
  virtual void visit(const libbirch::Lazy<libbirch::Shared<birch::type::ObjectValue>>& value, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr) = 0;
  #line 72 "src/io/Writer.birch"
  virtual void visit(const libbirch::Lazy<libbirch::Shared<birch::type::ArrayValue>>& value, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr) = 0;
  #line 73 "src/io/Writer.birch"
  virtual void visit(const libbirch::Lazy<libbirch::Shared<birch::type::NilValue>>& value, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr) = 0;
  #line 74 "src/io/Writer.birch"
  virtual void visit(const libbirch::Lazy<libbirch::Shared<birch::type::BooleanValue>>& value, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr) = 0;
  #line 75 "src/io/Writer.birch"
  virtual void visit(const libbirch::Lazy<libbirch::Shared<birch::type::IntegerValue>>& value, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr) = 0;
  #line 76 "src/io/Writer.birch"
  virtual void visit(const libbirch::Lazy<libbirch::Shared<birch::type::RealValue>>& value, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr) = 0;
  #line 77 "src/io/Writer.birch"
  virtual void visit(const libbirch::Lazy<libbirch::Shared<birch::type::StringValue>>& value, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr) = 0;
  #line 78 "src/io/Writer.birch"
  virtual void visit(const libbirch::Lazy<libbirch::Shared<birch::type::BooleanVectorValue>>& value, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr) = 0;
  #line 79 "src/io/Writer.birch"
  virtual void visit(const libbirch::Lazy<libbirch::Shared<birch::type::IntegerVectorValue>>& value, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr) = 0;
  #line 80 "src/io/Writer.birch"
  virtual void visit(const libbirch::Lazy<libbirch::Shared<birch::type::RealVectorValue>>& value, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr) = 0;
  
  #line 37 "src/io/Writer.birch"
  LIBBIRCH_ABSTRACT_CLASS(Writer, Object)
  #line 37 "src/io/Writer.birch"
  LIBBIRCH_MEMBERS()
};

#line 3 "src/io/YAMLWriter.birch"
class YAMLWriter : public Writer {
public:
  #line 3 "src/io/YAMLWriter.birch"
  using class_type_ = YAMLWriter;
  #line 3 "src/io/YAMLWriter.birch"
  using this_type_ = class_type_;
  #line 3 "src/io/YAMLWriter.birch"
  using super_type_ = Writer;

  #line 3 "src/io/YAMLWriter.birch"
  using super_type_::operator=;
  #line 3 "src/io/YAMLWriter.birch"
  using super_type_::close;
  #line 3 "src/io/YAMLWriter.birch"
  using super_type_::dump;
  #line 3 "src/io/YAMLWriter.birch"
  using super_type_::flush;
  #line 3 "src/io/YAMLWriter.birch"
  using super_type_::open;
  #line 3 "src/io/YAMLWriter.birch"
  using super_type_::push;
  #line 3 "src/io/YAMLWriter.birch"
  using super_type_::visit;
  
  #line 3 "src/io/YAMLWriter.birch"
  YAMLWriter(const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);

  birch::type::File file;
  birch::type::Boolean sequential;

  yaml_emitter_t emitter;
  yaml_event_t event;
    #line 33 "src/io/YAMLWriter.birch"
  virtual void open(const birch::type::String& path, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr) override;
  #line 46 "src/io/YAMLWriter.birch"
  virtual void dump(const libbirch::Lazy<libbirch::Shared<birch::type::Buffer>>& buffer, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr) override;
  #line 50 "src/io/YAMLWriter.birch"
  virtual void push(const libbirch::Lazy<libbirch::Shared<birch::type::Buffer>>& buffer, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr) override;
  #line 58 "src/io/YAMLWriter.birch"
  virtual void flush(const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr) override;
  #line 65 "src/io/YAMLWriter.birch"
  virtual void close(const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr) override;
  #line 79 "src/io/YAMLWriter.birch"
  virtual void visit(const libbirch::Lazy<libbirch::Shared<birch::type::ObjectValue>>& value, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr) override;
  #line 90 "src/io/YAMLWriter.birch"
  virtual void visit(const libbirch::Lazy<libbirch::Shared<birch::type::ArrayValue>>& value, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr) override;
  #line 99 "src/io/YAMLWriter.birch"
  virtual void visit(const libbirch::Lazy<libbirch::Shared<birch::type::StringValue>>& value, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr) override;
  #line 103 "src/io/YAMLWriter.birch"
  virtual void visit(const libbirch::Lazy<libbirch::Shared<birch::type::RealValue>>& value, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr) override;
  #line 107 "src/io/YAMLWriter.birch"
  virtual void visit(const libbirch::Lazy<libbirch::Shared<birch::type::IntegerValue>>& value, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr) override;
  #line 111 "src/io/YAMLWriter.birch"
  virtual void visit(const libbirch::Lazy<libbirch::Shared<birch::type::BooleanValue>>& value, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr) override;
  #line 115 "src/io/YAMLWriter.birch"
  virtual void visit(const libbirch::Lazy<libbirch::Shared<birch::type::NilValue>>& value, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr) override;
  #line 119 "src/io/YAMLWriter.birch"
  virtual void visit(const libbirch::Lazy<libbirch::Shared<birch::type::BooleanVectorValue>>& value, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr) override;
  #line 128 "src/io/YAMLWriter.birch"
  virtual void visit(const libbirch::Lazy<libbirch::Shared<birch::type::IntegerVectorValue>>& value, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr) override;
  #line 137 "src/io/YAMLWriter.birch"
  virtual void visit(const libbirch::Lazy<libbirch::Shared<birch::type::RealVectorValue>>& value, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr) override;
  #line 146 "src/io/YAMLWriter.birch"
  virtual void startMapping(const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
  #line 154 "src/io/YAMLWriter.birch"
  virtual void endMapping(const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
  #line 161 "src/io/YAMLWriter.birch"
  virtual void startSequence(const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
  #line 169 "src/io/YAMLWriter.birch"
  virtual void endSequence(const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
  #line 176 "src/io/YAMLWriter.birch"
  virtual void scalar(const birch::type::Boolean& x, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
  #line 186 "src/io/YAMLWriter.birch"
  virtual void scalar(const birch::type::Integer& x, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
  #line 196 "src/io/YAMLWriter.birch"
  virtual void scalar(const birch::type::Real& x, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
  #line 218 "src/io/YAMLWriter.birch"
  virtual void scalar(const birch::type::String& value, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
  #line 227 "src/io/YAMLWriter.birch"
  virtual void null(const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
  
  #line 3 "src/io/YAMLWriter.birch"
  LIBBIRCH_CLASS(YAMLWriter, Writer)
  #line 3 "src/io/YAMLWriter.birch"
  LIBBIRCH_MEMBERS(file, sequential)
};

#line 3 "src/io/YAMLWriter.birch"
extern "C" birch::type::YAMLWriter* make_YAMLWriter_();

#line 1 "src/io/JSONWriter.birch"
class JSONWriter : public YAMLWriter {
public:
  #line 1 "src/io/JSONWriter.birch"
  using class_type_ = JSONWriter;
  #line 1 "src/io/JSONWriter.birch"
  using this_type_ = class_type_;
  #line 1 "src/io/JSONWriter.birch"
  using super_type_ = YAMLWriter;

  #line 1 "src/io/JSONWriter.birch"
  using super_type_::operator=;
  #line 1 "src/io/JSONWriter.birch"
  using super_type_::scalar;
  #line 1 "src/io/JSONWriter.birch"
  using super_type_::startMapping;
  #line 1 "src/io/JSONWriter.birch"
  using super_type_::startSequence;
  
  #line 1 "src/io/JSONWriter.birch"
  JSONWriter(const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);

  #line 14 "src/io/JSONWriter.birch"
  virtual void startMapping(const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr) override;
  #line 22 "src/io/JSONWriter.birch"
  virtual void startSequence(const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr) override;
  #line 30 "src/io/JSONWriter.birch"
  virtual void scalar(const birch::type::String& value, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr) override;
  
  #line 1 "src/io/JSONWriter.birch"
  LIBBIRCH_CLASS(JSONWriter, YAMLWriter)
  #line 1 "src/io/JSONWriter.birch"
  LIBBIRCH_MEMBERS()
};

#line 1 "src/io/JSONWriter.birch"
extern "C" birch::type::JSONWriter* make_JSONWriter_();

template<class Type>
#line 4 "src/iterator/Iterator.birch"
class Iterator : public Object {
public:
  #line 4 "src/iterator/Iterator.birch"
  using class_type_ = Iterator<Type>;
  #line 4 "src/iterator/Iterator.birch"
  using this_type_ = class_type_;
  #line 4 "src/iterator/Iterator.birch"
  using super_type_ = Object;

  #line 4 "src/iterator/Iterator.birch"
  using super_type_::operator=;
  
  #line 4 "src/iterator/Iterator.birch"
  Iterator(const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);

  #line 8 "src/iterator/Iterator.birch"
  virtual birch::type::Boolean hasNext(const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr) = 0;
  #line 13 "src/iterator/Iterator.birch"
  virtual Type next(const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr) = 0;
  
  #line 4 "src/iterator/Iterator.birch"
  LIBBIRCH_ABSTRACT_CLASS(Iterator, Object)
  #line 4 "src/iterator/Iterator.birch"
  LIBBIRCH_MEMBERS()
};

template<class Type>
#line 4 "src/iterator/EmptyIterator.birch"
class EmptyIterator final : public Iterator<Type> {
public:
  #line 4 "src/iterator/EmptyIterator.birch"
  using class_type_ = EmptyIterator<Type>;
  #line 4 "src/iterator/EmptyIterator.birch"
  using this_type_ = class_type_;
  #line 4 "src/iterator/EmptyIterator.birch"
  using super_type_ = Iterator<Type>;

  #line 4 "src/iterator/EmptyIterator.birch"
  using super_type_::operator=;
  #line 4 "src/iterator/EmptyIterator.birch"
  using super_type_::hasNext;
  #line 4 "src/iterator/EmptyIterator.birch"
  using super_type_::next;
  
  #line 4 "src/iterator/EmptyIterator.birch"
  EmptyIterator(const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);

  #line 8 "src/iterator/EmptyIterator.birch"
  virtual birch::type::Boolean hasNext(const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
  #line 15 "src/iterator/EmptyIterator.birch"
  virtual Type next(const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
  
  #line 4 "src/iterator/EmptyIterator.birch"
  LIBBIRCH_CLASS(EmptyIterator, Iterator<Type>)
  #line 4 "src/iterator/EmptyIterator.birch"
  LIBBIRCH_MEMBERS()
};

template<class Type>
#line 6 "src/iterator/ArrayIterator.birch"
class ArrayIterator final : public Iterator<Type> {
public:
  #line 6 "src/iterator/ArrayIterator.birch"
  using class_type_ = ArrayIterator<Type>;
  #line 6 "src/iterator/ArrayIterator.birch"
  using this_type_ = class_type_;
  #line 6 "src/iterator/ArrayIterator.birch"
  using super_type_ = Iterator<Type>;

  #line 6 "src/iterator/ArrayIterator.birch"
  using super_type_::operator=;
  #line 6 "src/iterator/ArrayIterator.birch"
  using super_type_::hasNext;
  #line 6 "src/iterator/ArrayIterator.birch"
  using super_type_::next;
  
  #line 6 "src/iterator/ArrayIterator.birch"
  ArrayIterator(const libbirch::Lazy<libbirch::Shared<birch::type::Array<Type>>>& o, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);

  libbirch::Lazy<libbirch::Shared<birch::type::Array<Type>>> o;
  birch::type::Integer i;
  #line 20 "src/iterator/ArrayIterator.birch"
  virtual birch::type::Boolean hasNext(const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
  #line 27 "src/iterator/ArrayIterator.birch"
  virtual Type next(const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
  
  #line 6 "src/iterator/ArrayIterator.birch"
  LIBBIRCH_CLASS(ArrayIterator, Iterator<Type>)
  #line 6 "src/iterator/ArrayIterator.birch"
  LIBBIRCH_MEMBERS(o, i)
};

#line 38 "src/io/Reader.birch"
class Reader : public Iterator<libbirch::Lazy<libbirch::Shared<birch::type::Buffer>>> {
public:
  #line 38 "src/io/Reader.birch"
  using class_type_ = Reader;
  #line 38 "src/io/Reader.birch"
  using this_type_ = class_type_;
  #line 38 "src/io/Reader.birch"
  using super_type_ = Iterator<libbirch::Lazy<libbirch::Shared<birch::type::Buffer>>>;

  #line 38 "src/io/Reader.birch"
  using super_type_::operator=;
  
  #line 38 "src/io/Reader.birch"
  Reader(const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);

  #line 44 "src/io/Reader.birch"
  virtual void open(const birch::type::String& path, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr) = 0;
  #line 51 "src/io/Reader.birch"
  virtual libbirch::Lazy<libbirch::Shared<birch::type::Buffer>> slurp(const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr) = 0;
  #line 56 "src/io/Reader.birch"
  virtual void close(const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr) = 0;
  
  #line 38 "src/io/Reader.birch"
  LIBBIRCH_ABSTRACT_CLASS(Reader, Iterator<libbirch::Lazy<libbirch::Shared<birch::type::Buffer>>>)
  #line 38 "src/io/Reader.birch"
  LIBBIRCH_MEMBERS()
};

#line 3 "src/io/YAMLReader.birch"
class YAMLReader : public Reader {
public:
  #line 3 "src/io/YAMLReader.birch"
  using class_type_ = YAMLReader;
  #line 3 "src/io/YAMLReader.birch"
  using this_type_ = class_type_;
  #line 3 "src/io/YAMLReader.birch"
  using super_type_ = Reader;

  #line 3 "src/io/YAMLReader.birch"
  using super_type_::operator=;
  #line 3 "src/io/YAMLReader.birch"
  using super_type_::close;
  #line 3 "src/io/YAMLReader.birch"
  using super_type_::hasNext;
  #line 3 "src/io/YAMLReader.birch"
  using super_type_::next;
  #line 3 "src/io/YAMLReader.birch"
  using super_type_::open;
  #line 3 "src/io/YAMLReader.birch"
  using super_type_::slurp;
  
  #line 3 "src/io/YAMLReader.birch"
  YAMLReader(const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);

  birch::type::File file;

  yaml_parser_t parser;
  yaml_event_t event;
    #line 35 "src/io/YAMLReader.birch"
  virtual void open(const birch::type::String& path, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr) override;
  #line 43 "src/io/YAMLReader.birch"
  virtual libbirch::Lazy<libbirch::Shared<birch::type::Buffer>> slurp(const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr) override;
  #line 65 "src/io/YAMLReader.birch"
  virtual birch::type::Boolean hasNext(const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr) override;
  #line 90 "src/io/YAMLReader.birch"
  virtual libbirch::Lazy<libbirch::Shared<birch::type::Buffer>> next(const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr) override;
  #line 111 "src/io/YAMLReader.birch"
  virtual void close(const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr) override;
  #line 115 "src/io/YAMLReader.birch"
  virtual void parseMapping(const libbirch::Lazy<libbirch::Shared<birch::type::Buffer>>& buffer, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
  #line 154 "src/io/YAMLReader.birch"
  virtual void parseSequence(const libbirch::Lazy<libbirch::Shared<birch::type::Buffer>>& buffer, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
  #line 180 "src/io/YAMLReader.birch"
  virtual void parseValue(const libbirch::Lazy<libbirch::Shared<birch::type::Buffer>>& buffer, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
  #line 212 "src/io/YAMLReader.birch"
  virtual void parseElement(const libbirch::Lazy<libbirch::Shared<birch::type::Buffer>>& buffer, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
  
  #line 3 "src/io/YAMLReader.birch"
  LIBBIRCH_CLASS(YAMLReader, Reader)
  #line 3 "src/io/YAMLReader.birch"
  LIBBIRCH_MEMBERS(file)
};

#line 3 "src/io/YAMLReader.birch"
extern "C" birch::type::YAMLReader* make_YAMLReader_();

template<class Type>
#line 6 "src/iterator/ListIterator.birch"
class ListIterator final : public Iterator<Type> {
public:
  #line 6 "src/iterator/ListIterator.birch"
  using class_type_ = ListIterator<Type>;
  #line 6 "src/iterator/ListIterator.birch"
  using this_type_ = class_type_;
  #line 6 "src/iterator/ListIterator.birch"
  using super_type_ = Iterator<Type>;

  #line 6 "src/iterator/ListIterator.birch"
  using super_type_::operator=;
  #line 6 "src/iterator/ListIterator.birch"
  using super_type_::hasNext;
  #line 6 "src/iterator/ListIterator.birch"
  using super_type_::next;
  
  #line 6 "src/iterator/ListIterator.birch"
  ListIterator(const libbirch::Optional<libbirch::Lazy<libbirch::Shared<birch::type::ListNode<Type>>>>& head, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);

  libbirch::Optional<libbirch::Lazy<libbirch::Shared<birch::type::ListNode<Type>>>> node;
  #line 15 "src/iterator/ListIterator.birch"
  virtual birch::type::Boolean hasNext(const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
  #line 22 "src/iterator/ListIterator.birch"
  virtual Type next(const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
  
  #line 6 "src/iterator/ListIterator.birch"
  LIBBIRCH_CLASS(ListIterator, Iterator<Type>)
  #line 6 "src/iterator/ListIterator.birch"
  LIBBIRCH_MEMBERS(node)
};

template<class Type>
#line 7 "src/iterator/RaggedArrayElementIterator.birch"
class RaggedArrayElementIterator final : public Iterator<Type> {
public:
  #line 7 "src/iterator/RaggedArrayElementIterator.birch"
  using class_type_ = RaggedArrayElementIterator<Type>;
  #line 7 "src/iterator/RaggedArrayElementIterator.birch"
  using this_type_ = class_type_;
  #line 7 "src/iterator/RaggedArrayElementIterator.birch"
  using super_type_ = Iterator<Type>;

  #line 7 "src/iterator/RaggedArrayElementIterator.birch"
  using super_type_::operator=;
  #line 7 "src/iterator/RaggedArrayElementIterator.birch"
  using super_type_::hasNext;
  #line 7 "src/iterator/RaggedArrayElementIterator.birch"
  using super_type_::next;
  
  #line 7 "src/iterator/RaggedArrayElementIterator.birch"
  RaggedArrayElementIterator(const libbirch::Lazy<libbirch::Shared<birch::type::RaggedArray<Type>>>& o, const birch::type::Integer& i, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);

  libbirch::Lazy<libbirch::Shared<birch::type::RaggedArray<Type>>> o;
  birch::type::Integer i;
  birch::type::Integer j;
  #line 27 "src/iterator/RaggedArrayElementIterator.birch"
  virtual birch::type::Boolean hasNext(const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
  #line 34 "src/iterator/RaggedArrayElementIterator.birch"
  virtual Type next(const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
  
  #line 7 "src/iterator/RaggedArrayElementIterator.birch"
  LIBBIRCH_CLASS(RaggedArrayElementIterator, Iterator<Type>)
  #line 7 "src/iterator/RaggedArrayElementIterator.birch"
  LIBBIRCH_MEMBERS(o, i, j)
};

template<class Type>
#line 6 "src/iterator/RaggedArrayRowIterator.birch"
class RaggedArrayRowIterator final : public Iterator<libbirch::DefaultArray<Type,1>> {
public:
  #line 6 "src/iterator/RaggedArrayRowIterator.birch"
  using class_type_ = RaggedArrayRowIterator<Type>;
  #line 6 "src/iterator/RaggedArrayRowIterator.birch"
  using this_type_ = class_type_;
  #line 6 "src/iterator/RaggedArrayRowIterator.birch"
  using super_type_ = Iterator<libbirch::DefaultArray<Type,1>>;

  #line 6 "src/iterator/RaggedArrayRowIterator.birch"
  using super_type_::operator=;
  #line 6 "src/iterator/RaggedArrayRowIterator.birch"
  using super_type_::hasNext;
  #line 6 "src/iterator/RaggedArrayRowIterator.birch"
  using super_type_::next;
  
  #line 6 "src/iterator/RaggedArrayRowIterator.birch"
  RaggedArrayRowIterator(const libbirch::Lazy<libbirch::Shared<birch::type::RaggedArray<Type>>>& o, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);

  libbirch::Lazy<libbirch::Shared<birch::type::RaggedArray<Type>>> o;
  birch::type::Integer i;
  #line 21 "src/iterator/RaggedArrayRowIterator.birch"
  virtual birch::type::Boolean hasNext(const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
  #line 28 "src/iterator/RaggedArrayRowIterator.birch"
  virtual libbirch::DefaultArray<Type,1> next(const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
  
  #line 6 "src/iterator/RaggedArrayRowIterator.birch"
  LIBBIRCH_CLASS(RaggedArrayRowIterator, Iterator<libbirch::DefaultArray<Type,1>>)
  #line 6 "src/iterator/RaggedArrayRowIterator.birch"
  LIBBIRCH_MEMBERS(o, i)
};

template<class Type>
#line 6 "src/iterator/StackIterator.birch"
class StackIterator final : public Iterator<Type> {
public:
  #line 6 "src/iterator/StackIterator.birch"
  using class_type_ = StackIterator<Type>;
  #line 6 "src/iterator/StackIterator.birch"
  using this_type_ = class_type_;
  #line 6 "src/iterator/StackIterator.birch"
  using super_type_ = Iterator<Type>;

  #line 6 "src/iterator/StackIterator.birch"
  using super_type_::operator=;
  #line 6 "src/iterator/StackIterator.birch"
  using super_type_::hasNext;
  #line 6 "src/iterator/StackIterator.birch"
  using super_type_::next;
  
  #line 6 "src/iterator/StackIterator.birch"
  StackIterator(const libbirch::Optional<libbirch::Lazy<libbirch::Shared<birch::type::StackNode<Type>>>>& head, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);

  libbirch::Optional<libbirch::Lazy<libbirch::Shared<birch::type::StackNode<Type>>>> node;
  #line 15 "src/iterator/StackIterator.birch"
  virtual birch::type::Boolean hasNext(const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
  #line 22 "src/iterator/StackIterator.birch"
  virtual Type next(const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
  
  #line 6 "src/iterator/StackIterator.birch"
  LIBBIRCH_CLASS(StackIterator, Iterator<Type>)
  #line 6 "src/iterator/StackIterator.birch"
  LIBBIRCH_MEMBERS(node)
};

template<class Type>
#line 6 "src/iterator/TapeIterator.birch"
class TapeIterator final : public Iterator<Type> {
public:
  #line 6 "src/iterator/TapeIterator.birch"
  using class_type_ = TapeIterator<Type>;
  #line 6 "src/iterator/TapeIterator.birch"
  using this_type_ = class_type_;
  #line 6 "src/iterator/TapeIterator.birch"
  using super_type_ = Iterator<Type>;

  #line 6 "src/iterator/TapeIterator.birch"
  using super_type_::operator=;
  #line 6 "src/iterator/TapeIterator.birch"
  using super_type_::hasNext;
  #line 6 "src/iterator/TapeIterator.birch"
  using super_type_::next;
  
  #line 6 "src/iterator/TapeIterator.birch"
  TapeIterator(const libbirch::Optional<libbirch::Lazy<libbirch::Shared<birch::type::TapeNode<Type>>>>& head, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);

  libbirch::Optional<libbirch::Lazy<libbirch::Shared<birch::type::TapeNode<Type>>>> node;
  #line 15 "src/iterator/TapeIterator.birch"
  virtual birch::type::Boolean hasNext(const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
  #line 22 "src/iterator/TapeIterator.birch"
  virtual Type next(const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
  
  #line 6 "src/iterator/TapeIterator.birch"
  LIBBIRCH_CLASS(TapeIterator, Iterator<Type>)
  #line 6 "src/iterator/TapeIterator.birch"
  LIBBIRCH_MEMBERS(node)
};

#line 1 "src/kernel/Kernel.birch"
class Kernel : public Object {
public:
  #line 1 "src/kernel/Kernel.birch"
  using class_type_ = Kernel;
  #line 1 "src/kernel/Kernel.birch"
  using this_type_ = class_type_;
  #line 1 "src/kernel/Kernel.birch"
  using super_type_ = Object;

  #line 1 "src/kernel/Kernel.birch"
  using super_type_::operator=;
  
  #line 1 "src/kernel/Kernel.birch"
  Kernel(const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);

  #line 55 "src/kernel/Kernel.birch"
  virtual birch::type::Real move(const libbirch::Lazy<libbirch::Shared<birch::type::Random<birch::type::Real>>>& x, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
  #line 66 "src/kernel/Kernel.birch"
  virtual libbirch::DefaultArray<birch::type::Real,1> move(const libbirch::Lazy<libbirch::Shared<birch::type::Random<libbirch::DefaultArray<birch::type::Real,1>>>>& x, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
  #line 77 "src/kernel/Kernel.birch"
  virtual libbirch::DefaultArray<birch::type::Real,2> move(const libbirch::Lazy<libbirch::Shared<birch::type::Random<libbirch::DefaultArray<birch::type::Real,2>>>>& x, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
  #line 88 "src/kernel/Kernel.birch"
  virtual birch::type::LLT move(const libbirch::Lazy<libbirch::Shared<birch::type::Random<birch::type::LLT>>>& x, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
  #line 99 "src/kernel/Kernel.birch"
  virtual birch::type::Integer move(const libbirch::Lazy<libbirch::Shared<birch::type::Random<birch::type::Integer>>>& x, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
  #line 110 "src/kernel/Kernel.birch"
  virtual libbirch::DefaultArray<birch::type::Integer,1> move(const libbirch::Lazy<libbirch::Shared<birch::type::Random<libbirch::DefaultArray<birch::type::Integer,1>>>>& x, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
  #line 121 "src/kernel/Kernel.birch"
  virtual birch::type::Boolean move(const libbirch::Lazy<libbirch::Shared<birch::type::Random<birch::type::Boolean>>>& x, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
  #line 133 "src/kernel/Kernel.birch"
  virtual birch::type::Real logpdf(const libbirch::Lazy<libbirch::Shared<birch::type::Random<birch::type::Real>>>& x_prime_, const libbirch::Lazy<libbirch::Shared<birch::type::Random<birch::type::Real>>>& x, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
  #line 145 "src/kernel/Kernel.birch"
  virtual birch::type::Real logpdf(const libbirch::Lazy<libbirch::Shared<birch::type::Random<libbirch::DefaultArray<birch::type::Real,1>>>>& x_prime_, const libbirch::Lazy<libbirch::Shared<birch::type::Random<libbirch::DefaultArray<birch::type::Real,1>>>>& x, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
  #line 157 "src/kernel/Kernel.birch"
  virtual birch::type::Real logpdf(const libbirch::Lazy<libbirch::Shared<birch::type::Random<libbirch::DefaultArray<birch::type::Real,2>>>>& x_prime_, const libbirch::Lazy<libbirch::Shared<birch::type::Random<libbirch::DefaultArray<birch::type::Real,2>>>>& x, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
  #line 169 "src/kernel/Kernel.birch"
  virtual birch::type::Real logpdf(const libbirch::Lazy<libbirch::Shared<birch::type::Random<birch::type::LLT>>>& x_prime_, const libbirch::Lazy<libbirch::Shared<birch::type::Random<birch::type::LLT>>>& x, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
  #line 181 "src/kernel/Kernel.birch"
  virtual birch::type::Real logpdf(const libbirch::Lazy<libbirch::Shared<birch::type::Random<birch::type::Integer>>>& x_prime_, const libbirch::Lazy<libbirch::Shared<birch::type::Random<birch::type::Integer>>>& x, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
  #line 193 "src/kernel/Kernel.birch"
  virtual birch::type::Real logpdf(const libbirch::Lazy<libbirch::Shared<birch::type::Random<libbirch::DefaultArray<birch::type::Integer,1>>>>& x_prime_, const libbirch::Lazy<libbirch::Shared<birch::type::Random<libbirch::DefaultArray<birch::type::Integer,1>>>>& x, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
  #line 205 "src/kernel/Kernel.birch"
  virtual birch::type::Real logpdf(const libbirch::Lazy<libbirch::Shared<birch::type::Random<birch::type::Boolean>>>& x_prime_, const libbirch::Lazy<libbirch::Shared<birch::type::Random<birch::type::Boolean>>>& x, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
  
  #line 1 "src/kernel/Kernel.birch"
  LIBBIRCH_CLASS(Kernel, Object)
  #line 1 "src/kernel/Kernel.birch"
  LIBBIRCH_MEMBERS()
};

#line 1 "src/kernel/Kernel.birch"
extern "C" birch::type::Kernel* make_Kernel_();

#line 1 "src/kernel/LangevinKernel.birch"
class LangevinKernel : public Kernel {
public:
  #line 1 "src/kernel/LangevinKernel.birch"
  using class_type_ = LangevinKernel;
  #line 1 "src/kernel/LangevinKernel.birch"
  using this_type_ = class_type_;
  #line 1 "src/kernel/LangevinKernel.birch"
  using super_type_ = Kernel;

  #line 1 "src/kernel/LangevinKernel.birch"
  using super_type_::operator=;
  #line 1 "src/kernel/LangevinKernel.birch"
  using super_type_::logpdf;
  #line 1 "src/kernel/LangevinKernel.birch"
  using super_type_::move;
  
  #line 1 "src/kernel/LangevinKernel.birch"
  LangevinKernel(const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);

  birch::type::Real scale;
  #line 17 "src/kernel/LangevinKernel.birch"
  virtual birch::type::Real move(const libbirch::Lazy<libbirch::Shared<birch::type::Random<birch::type::Real>>>& x, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr) override;
  #line 21 "src/kernel/LangevinKernel.birch"
  virtual libbirch::DefaultArray<birch::type::Real,1> move(const libbirch::Lazy<libbirch::Shared<birch::type::Random<libbirch::DefaultArray<birch::type::Real,1>>>>& x, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr) override;
  #line 25 "src/kernel/LangevinKernel.birch"
  virtual libbirch::DefaultArray<birch::type::Real,2> move(const libbirch::Lazy<libbirch::Shared<birch::type::Random<libbirch::DefaultArray<birch::type::Real,2>>>>& x, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr) override;
  #line 29 "src/kernel/LangevinKernel.birch"
  virtual birch::type::Real logpdf(const libbirch::Lazy<libbirch::Shared<birch::type::Random<birch::type::Real>>>& x_prime_, const libbirch::Lazy<libbirch::Shared<birch::type::Random<birch::type::Real>>>& x, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr) override;
  #line 33 "src/kernel/LangevinKernel.birch"
  virtual birch::type::Real logpdf(const libbirch::Lazy<libbirch::Shared<birch::type::Random<libbirch::DefaultArray<birch::type::Real,1>>>>& x_prime_, const libbirch::Lazy<libbirch::Shared<birch::type::Random<libbirch::DefaultArray<birch::type::Real,1>>>>& x, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr) override;
  #line 37 "src/kernel/LangevinKernel.birch"
  virtual birch::type::Real logpdf(const libbirch::Lazy<libbirch::Shared<birch::type::Random<libbirch::DefaultArray<birch::type::Real,2>>>>& x_prime_, const libbirch::Lazy<libbirch::Shared<birch::type::Random<libbirch::DefaultArray<birch::type::Real,2>>>>& x, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr) override;
  #line 41 "src/kernel/LangevinKernel.birch"
  virtual void read(const libbirch::Lazy<libbirch::Shared<birch::type::Buffer>>& buffer, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr) override;
  #line 46 "src/kernel/LangevinKernel.birch"
  virtual void write(const libbirch::Lazy<libbirch::Shared<birch::type::Buffer>>& buffer, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr) override;
  
  #line 1 "src/kernel/LangevinKernel.birch"
  LIBBIRCH_CLASS(LangevinKernel, Kernel)
  #line 1 "src/kernel/LangevinKernel.birch"
  LIBBIRCH_MEMBERS(scale)
};

#line 1 "src/kernel/LangevinKernel.birch"
extern "C" birch::type::LangevinKernel* make_LangevinKernel_();

#line 15 "src/model/Model.birch"
class Model : public Object {
public:
  #line 15 "src/model/Model.birch"
  using class_type_ = Model;
  #line 15 "src/model/Model.birch"
  using this_type_ = class_type_;
  #line 15 "src/model/Model.birch"
  using super_type_ = Object;

  #line 15 "src/model/Model.birch"
  using super_type_::operator=;
  
  #line 15 "src/model/Model.birch"
  Model(const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);

  #line 19 "src/model/Model.birch"
  virtual void simulate(const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
  #line 26 "src/model/Model.birch"
  virtual void simulate(const birch::type::Integer& t, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
  #line 33 "src/model/Model.birch"
  virtual void forecast(const birch::type::Integer& t, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
  #line 41 "src/model/Model.birch"
  virtual birch::type::Integer size(const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
  
  #line 15 "src/model/Model.birch"
  LIBBIRCH_ABSTRACT_CLASS(Model, Object)
  #line 15 "src/model/Model.birch"
  LIBBIRCH_MEMBERS()
};

template<class Parameter,class State>
#line 29 "src/model/MarkovModel.birch"
class MarkovModel : public Model {
public:
  #line 29 "src/model/MarkovModel.birch"
  using class_type_ = MarkovModel<Parameter, State>;
  #line 29 "src/model/MarkovModel.birch"
  using this_type_ = class_type_;
  #line 29 "src/model/MarkovModel.birch"
  using super_type_ = Model;

  #line 29 "src/model/MarkovModel.birch"
  using super_type_::operator=;
  #line 29 "src/model/MarkovModel.birch"
  using super_type_::simulate;
  #line 29 "src/model/MarkovModel.birch"
  using super_type_::size;
  
  #line 29 "src/model/MarkovModel.birch"
  MarkovModel(const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);

  Parameter _u0952;
  libbirch::Lazy<libbirch::Shared<birch::type::Tape<State>>> x;
  #line 40 "src/model/MarkovModel.birch"
  virtual birch::type::Integer size(const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr) override;
  #line 44 "src/model/MarkovModel.birch"
  virtual void simulate(const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr) override;
  #line 48 "src/model/MarkovModel.birch"
  virtual void simulate(const birch::type::Integer& t, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr) override;
  #line 62 "src/model/MarkovModel.birch"
  virtual void parameter(const Parameter& _u0952, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
  #line 72 "src/model/MarkovModel.birch"
  virtual void initial(const State& x, const Parameter& _u0952, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
  #line 83 "src/model/MarkovModel.birch"
  virtual void transition(const State& x, const State& u, const Parameter& _u0952, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
  #line 87 "src/model/MarkovModel.birch"
  virtual void read(const libbirch::Lazy<libbirch::Shared<birch::type::Buffer>>& buffer, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr) override;
  #line 93 "src/model/MarkovModel.birch"
  virtual void write(const libbirch::Lazy<libbirch::Shared<birch::type::Buffer>>& buffer, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr) override;
  
  #line 29 "src/model/MarkovModel.birch"
  LIBBIRCH_ABSTRACT_CLASS(MarkovModel, Model)
  #line 29 "src/model/MarkovModel.birch"
  LIBBIRCH_MEMBERS(_u0952, x)
};

template<class Parameter,class State,class Observation>
#line 41 "src/model/HiddenMarkovModel.birch"
class HiddenMarkovModel : public MarkovModel<Parameter, State> {
public:
  #line 41 "src/model/HiddenMarkovModel.birch"
  using class_type_ = HiddenMarkovModel<Parameter, State, Observation>;
  #line 41 "src/model/HiddenMarkovModel.birch"
  using this_type_ = class_type_;
  #line 41 "src/model/HiddenMarkovModel.birch"
  using super_type_ = MarkovModel<Parameter, State>;

  #line 41 "src/model/HiddenMarkovModel.birch"
  using super_type_::operator=;
  #line 41 "src/model/HiddenMarkovModel.birch"
  using super_type_::read;
  #line 41 "src/model/HiddenMarkovModel.birch"
  using super_type_::simulate;
  #line 41 "src/model/HiddenMarkovModel.birch"
  using super_type_::size;
  #line 41 "src/model/HiddenMarkovModel.birch"
  using super_type_::write;
  
  #line 41 "src/model/HiddenMarkovModel.birch"
  HiddenMarkovModel(const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);

  libbirch::Lazy<libbirch::Shared<birch::type::Tape<Observation>>> y;
  #line 48 "src/model/HiddenMarkovModel.birch"
  virtual birch::type::Integer size(const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr) override;
  #line 52 "src/model/HiddenMarkovModel.birch"
  virtual void simulate(const birch::type::Integer& t, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr) override;
  #line 67 "src/model/HiddenMarkovModel.birch"
  virtual void observation(const Observation& y, const State& x, const Parameter& _u0952, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
  #line 71 "src/model/HiddenMarkovModel.birch"
  virtual void read(const libbirch::Lazy<libbirch::Shared<birch::type::Buffer>>& buffer, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr) override;
  #line 76 "src/model/HiddenMarkovModel.birch"
  virtual void write(const libbirch::Lazy<libbirch::Shared<birch::type::Buffer>>& buffer, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr) override;
  
  #line 41 "src/model/HiddenMarkovModel.birch"
  LIBBIRCH_ABSTRACT_CLASS(HiddenMarkovModel, MarkovModel<Parameter, State>)
  #line 41 "src/model/HiddenMarkovModel.birch"
  LIBBIRCH_MEMBERS(y)
};

#line 1 "src/test/model/TestAddBoundedDiscreteDelta.birch"
class TestAddBoundedDiscreteDelta : public Model {
public:
  #line 1 "src/test/model/TestAddBoundedDiscreteDelta.birch"
  using class_type_ = TestAddBoundedDiscreteDelta;
  #line 1 "src/test/model/TestAddBoundedDiscreteDelta.birch"
  using this_type_ = class_type_;
  #line 1 "src/test/model/TestAddBoundedDiscreteDelta.birch"
  using super_type_ = Model;

  #line 1 "src/test/model/TestAddBoundedDiscreteDelta.birch"
  using super_type_::operator=;
  #line 1 "src/test/model/TestAddBoundedDiscreteDelta.birch"
  using super_type_::simulate;
  
  #line 1 "src/test/model/TestAddBoundedDiscreteDelta.birch"
  TestAddBoundedDiscreteDelta(const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);

  libbirch::Lazy<libbirch::Shared<birch::type::Random<birch::type::Integer>>> x1;
  libbirch::Lazy<libbirch::Shared<birch::type::Random<birch::type::Integer>>> x2;
  libbirch::Lazy<libbirch::Shared<birch::type::Random<birch::type::Integer>>> s;
  #line 6 "src/test/model/TestAddBoundedDiscreteDelta.birch"
  virtual void initialize(const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
  #line 10 "src/test/model/TestAddBoundedDiscreteDelta.birch"
  virtual void simulate(const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
  #line 16 "src/test/model/TestAddBoundedDiscreteDelta.birch"
  virtual libbirch::DefaultArray<birch::type::Real,1> forward(const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
  #line 25 "src/test/model/TestAddBoundedDiscreteDelta.birch"
  virtual libbirch::DefaultArray<birch::type::Real,1> backward(const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
  #line 33 "src/test/model/TestAddBoundedDiscreteDelta.birch"
  virtual libbirch::DefaultArray<birch::type::Real,1> forwardLazy(const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
  #line 42 "src/test/model/TestAddBoundedDiscreteDelta.birch"
  virtual libbirch::DefaultArray<birch::type::Real,1> backwardLazy(const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
  
  #line 1 "src/test/model/TestAddBoundedDiscreteDelta.birch"
  LIBBIRCH_CLASS(TestAddBoundedDiscreteDelta, Model)
  #line 1 "src/test/model/TestAddBoundedDiscreteDelta.birch"
  LIBBIRCH_MEMBERS(x1, x2, s)
};

#line 1 "src/test/model/TestAddBoundedDiscreteDelta.birch"
extern "C" birch::type::TestAddBoundedDiscreteDelta* make_TestAddBoundedDiscreteDelta_();

#line 1 "src/test/model/TestBetaBernoulli.birch"
class TestBetaBernoulli : public Model {
public:
  #line 1 "src/test/model/TestBetaBernoulli.birch"
  using class_type_ = TestBetaBernoulli;
  #line 1 "src/test/model/TestBetaBernoulli.birch"
  using this_type_ = class_type_;
  #line 1 "src/test/model/TestBetaBernoulli.birch"
  using super_type_ = Model;

  #line 1 "src/test/model/TestBetaBernoulli.birch"
  using super_type_::operator=;
  #line 1 "src/test/model/TestBetaBernoulli.birch"
  using super_type_::simulate;
  
  #line 1 "src/test/model/TestBetaBernoulli.birch"
  TestBetaBernoulli(const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);

  libbirch::Lazy<libbirch::Shared<birch::type::Random<birch::type::Real>>> _u0961;
  libbirch::Lazy<libbirch::Shared<birch::type::Random<birch::type::Boolean>>> x;
  #line 5 "src/test/model/TestBetaBernoulli.birch"
  virtual void initialize(const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
  #line 9 "src/test/model/TestBetaBernoulli.birch"
  virtual void simulate(const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
  #line 16 "src/test/model/TestBetaBernoulli.birch"
  virtual libbirch::DefaultArray<birch::type::Real,1> forward(const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
  #line 29 "src/test/model/TestBetaBernoulli.birch"
  virtual libbirch::DefaultArray<birch::type::Real,1> backward(const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
  #line 42 "src/test/model/TestBetaBernoulli.birch"
  virtual libbirch::DefaultArray<birch::type::Real,1> forwardLazy(const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
  #line 55 "src/test/model/TestBetaBernoulli.birch"
  virtual libbirch::DefaultArray<birch::type::Real,1> backwardLazy(const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
  #line 68 "src/test/model/TestBetaBernoulli.birch"
  virtual libbirch::Lazy<libbirch::Shared<birch::type::Distribution<birch::type::Boolean>>> marginal(const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
  
  #line 1 "src/test/model/TestBetaBernoulli.birch"
  LIBBIRCH_CLASS(TestBetaBernoulli, Model)
  #line 1 "src/test/model/TestBetaBernoulli.birch"
  LIBBIRCH_MEMBERS(_u0961, x)
};

#line 1 "src/test/model/TestBetaBernoulli.birch"
extern "C" birch::type::TestBetaBernoulli* make_TestBetaBernoulli_();

#line 1 "src/test/model/TestBetaBinomial.birch"
class TestBetaBinomial : public Model {
public:
  #line 1 "src/test/model/TestBetaBinomial.birch"
  using class_type_ = TestBetaBinomial;
  #line 1 "src/test/model/TestBetaBinomial.birch"
  using this_type_ = class_type_;
  #line 1 "src/test/model/TestBetaBinomial.birch"
  using super_type_ = Model;

  #line 1 "src/test/model/TestBetaBinomial.birch"
  using super_type_::operator=;
  #line 1 "src/test/model/TestBetaBinomial.birch"
  using super_type_::simulate;
  
  #line 1 "src/test/model/TestBetaBinomial.birch"
  TestBetaBinomial(const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);

  libbirch::Lazy<libbirch::Shared<birch::type::Random<birch::type::Real>>> _u0961;
  libbirch::Lazy<libbirch::Shared<birch::type::Random<birch::type::Integer>>> x;
  birch::type::Integer n;
  birch::type::Real _u0945;
  birch::type::Real _u0946;
  #line 8 "src/test/model/TestBetaBinomial.birch"
  virtual void initialize(const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
  #line 14 "src/test/model/TestBetaBinomial.birch"
  virtual void simulate(const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
  #line 19 "src/test/model/TestBetaBinomial.birch"
  virtual libbirch::DefaultArray<birch::type::Real,1> forward(const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
  #line 27 "src/test/model/TestBetaBinomial.birch"
  virtual libbirch::DefaultArray<birch::type::Real,1> backward(const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
  #line 35 "src/test/model/TestBetaBinomial.birch"
  virtual libbirch::DefaultArray<birch::type::Real,1> forwardLazy(const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
  #line 43 "src/test/model/TestBetaBinomial.birch"
  virtual libbirch::DefaultArray<birch::type::Real,1> backwardLazy(const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
  #line 51 "src/test/model/TestBetaBinomial.birch"
  virtual libbirch::Lazy<libbirch::Shared<birch::type::Distribution<birch::type::Integer>>> marginal(const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
  
  #line 1 "src/test/model/TestBetaBinomial.birch"
  LIBBIRCH_CLASS(TestBetaBinomial, Model)
  #line 1 "src/test/model/TestBetaBinomial.birch"
  LIBBIRCH_MEMBERS(_u0961, x, n, _u0945, _u0946)
};

#line 1 "src/test/model/TestBetaBinomial.birch"
extern "C" birch::type::TestBetaBinomial* make_TestBetaBinomial_();

#line 1 "src/test/model/TestBetaGeometric.birch"
class TestBetaGeometric : public Model {
public:
  #line 1 "src/test/model/TestBetaGeometric.birch"
  using class_type_ = TestBetaGeometric;
  #line 1 "src/test/model/TestBetaGeometric.birch"
  using this_type_ = class_type_;
  #line 1 "src/test/model/TestBetaGeometric.birch"
  using super_type_ = Model;

  #line 1 "src/test/model/TestBetaGeometric.birch"
  using super_type_::operator=;
  #line 1 "src/test/model/TestBetaGeometric.birch"
  using super_type_::simulate;
  
  #line 1 "src/test/model/TestBetaGeometric.birch"
  TestBetaGeometric(const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);

  libbirch::Lazy<libbirch::Shared<birch::type::Random<birch::type::Real>>> _u0961;
  libbirch::Lazy<libbirch::Shared<birch::type::Random<birch::type::Integer>>> x;
  birch::type::Real _u0945;
  birch::type::Real _u0946;
  #line 7 "src/test/model/TestBetaGeometric.birch"
  virtual void initialize(const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
  #line 12 "src/test/model/TestBetaGeometric.birch"
  virtual void simulate(const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
  #line 17 "src/test/model/TestBetaGeometric.birch"
  virtual libbirch::DefaultArray<birch::type::Real,1> forward(const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
  #line 25 "src/test/model/TestBetaGeometric.birch"
  virtual libbirch::DefaultArray<birch::type::Real,1> backward(const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
  #line 33 "src/test/model/TestBetaGeometric.birch"
  virtual libbirch::DefaultArray<birch::type::Real,1> forwardLazy(const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
  #line 41 "src/test/model/TestBetaGeometric.birch"
  virtual libbirch::DefaultArray<birch::type::Real,1> backwardLazy(const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
  
  #line 1 "src/test/model/TestBetaGeometric.birch"
  LIBBIRCH_CLASS(TestBetaGeometric, Model)
  #line 1 "src/test/model/TestBetaGeometric.birch"
  LIBBIRCH_MEMBERS(_u0961, x, _u0945, _u0946)
};

#line 1 "src/test/model/TestBetaGeometric.birch"
extern "C" birch::type::TestBetaGeometric* make_TestBetaGeometric_();

#line 1 "src/test/model/TestBetaNegativeBinomial.birch"
class TestBetaNegativeBinomial : public Model {
public:
  #line 1 "src/test/model/TestBetaNegativeBinomial.birch"
  using class_type_ = TestBetaNegativeBinomial;
  #line 1 "src/test/model/TestBetaNegativeBinomial.birch"
  using this_type_ = class_type_;
  #line 1 "src/test/model/TestBetaNegativeBinomial.birch"
  using super_type_ = Model;

  #line 1 "src/test/model/TestBetaNegativeBinomial.birch"
  using super_type_::operator=;
  #line 1 "src/test/model/TestBetaNegativeBinomial.birch"
  using super_type_::simulate;
  
  #line 1 "src/test/model/TestBetaNegativeBinomial.birch"
  TestBetaNegativeBinomial(const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);

  birch::type::Integer k;
  birch::type::Real _u0945;
  birch::type::Real _u0946;
  libbirch::Lazy<libbirch::Shared<birch::type::Random<birch::type::Real>>> _u0961;
  libbirch::Lazy<libbirch::Shared<birch::type::Random<birch::type::Integer>>> x;
  #line 8 "src/test/model/TestBetaNegativeBinomial.birch"
  virtual void initialize(const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
  #line 14 "src/test/model/TestBetaNegativeBinomial.birch"
  virtual void simulate(const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
  #line 19 "src/test/model/TestBetaNegativeBinomial.birch"
  virtual libbirch::DefaultArray<birch::type::Real,1> forward(const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
  #line 27 "src/test/model/TestBetaNegativeBinomial.birch"
  virtual libbirch::DefaultArray<birch::type::Real,1> backward(const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
  #line 35 "src/test/model/TestBetaNegativeBinomial.birch"
  virtual libbirch::DefaultArray<birch::type::Real,1> forwardLazy(const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
  #line 43 "src/test/model/TestBetaNegativeBinomial.birch"
  virtual libbirch::DefaultArray<birch::type::Real,1> backwardLazy(const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
  #line 51 "src/test/model/TestBetaNegativeBinomial.birch"
  virtual libbirch::Lazy<libbirch::Shared<birch::type::Distribution<birch::type::Integer>>> marginal(const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
  
  #line 1 "src/test/model/TestBetaNegativeBinomial.birch"
  LIBBIRCH_CLASS(TestBetaNegativeBinomial, Model)
  #line 1 "src/test/model/TestBetaNegativeBinomial.birch"
  LIBBIRCH_MEMBERS(k, _u0945, _u0946, _u0961, x)
};

#line 1 "src/test/model/TestBetaNegativeBinomial.birch"
extern "C" birch::type::TestBetaNegativeBinomial* make_TestBetaNegativeBinomial_();

#line 1 "src/test/model/TestChainGaussian.birch"
class TestChainGaussian : public Model {
public:
  #line 1 "src/test/model/TestChainGaussian.birch"
  using class_type_ = TestChainGaussian;
  #line 1 "src/test/model/TestChainGaussian.birch"
  using this_type_ = class_type_;
  #line 1 "src/test/model/TestChainGaussian.birch"
  using super_type_ = Model;

  #line 1 "src/test/model/TestChainGaussian.birch"
  using super_type_::operator=;
  #line 1 "src/test/model/TestChainGaussian.birch"
  using super_type_::simulate;
  
  #line 1 "src/test/model/TestChainGaussian.birch"
  TestChainGaussian(const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);

  libbirch::DefaultArray<libbirch::Lazy<libbirch::Shared<birch::type::Random<birch::type::Real>>>,1> x;
  birch::type::Real _u0956;
  libbirch::DefaultArray<birch::type::Real,1> _u09632;
  #line 6 "src/test/model/TestChainGaussian.birch"
  virtual void initialize(const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
  #line 17 "src/test/model/TestChainGaussian.birch"
  virtual void simulate(const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
  #line 25 "src/test/model/TestChainGaussian.birch"
  virtual libbirch::DefaultArray<birch::type::Real,1> forward(const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
  #line 34 "src/test/model/TestChainGaussian.birch"
  virtual libbirch::DefaultArray<birch::type::Real,1> backward(const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
  #line 43 "src/test/model/TestChainGaussian.birch"
  virtual libbirch::DefaultArray<birch::type::Real,1> forwardLazy(const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
  #line 52 "src/test/model/TestChainGaussian.birch"
  virtual libbirch::DefaultArray<birch::type::Real,1> backwardLazy(const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
  
  #line 1 "src/test/model/TestChainGaussian.birch"
  LIBBIRCH_CLASS(TestChainGaussian, Model)
  #line 1 "src/test/model/TestChainGaussian.birch"
  LIBBIRCH_MEMBERS(x, _u0956, _u09632)
};

#line 1 "src/test/model/TestChainGaussian.birch"
extern "C" birch::type::TestChainGaussian* make_TestChainGaussian_();

#line 1 "src/test/model/TestChainMultivariateGaussian.birch"
class TestChainMultivariateGaussian : public Model {
public:
  #line 1 "src/test/model/TestChainMultivariateGaussian.birch"
  using class_type_ = TestChainMultivariateGaussian;
  #line 1 "src/test/model/TestChainMultivariateGaussian.birch"
  using this_type_ = class_type_;
  #line 1 "src/test/model/TestChainMultivariateGaussian.birch"
  using super_type_ = Model;

  #line 1 "src/test/model/TestChainMultivariateGaussian.birch"
  using super_type_::operator=;
  #line 1 "src/test/model/TestChainMultivariateGaussian.birch"
  using super_type_::simulate;
  
  #line 1 "src/test/model/TestChainMultivariateGaussian.birch"
  TestChainMultivariateGaussian(const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);

  libbirch::DefaultArray<libbirch::Lazy<libbirch::Shared<birch::type::Random<libbirch::DefaultArray<birch::type::Real,1>>>>,1> x;
  libbirch::DefaultArray<birch::type::Real,1> _u0956;
  libbirch::DefaultArray<birch::type::Real,2> _u0931;
  #line 6 "src/test/model/TestChainMultivariateGaussian.birch"
  virtual void initialize(const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
  #line 16 "src/test/model/TestChainMultivariateGaussian.birch"
  virtual void simulate(const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
  #line 24 "src/test/model/TestChainMultivariateGaussian.birch"
  virtual libbirch::DefaultArray<birch::type::Real,1> forward(const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
  #line 33 "src/test/model/TestChainMultivariateGaussian.birch"
  virtual libbirch::DefaultArray<birch::type::Real,1> backward(const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
  #line 42 "src/test/model/TestChainMultivariateGaussian.birch"
  virtual libbirch::DefaultArray<birch::type::Real,1> forwardLazy(const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
  #line 51 "src/test/model/TestChainMultivariateGaussian.birch"
  virtual libbirch::DefaultArray<birch::type::Real,1> backwardLazy(const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
  
  #line 1 "src/test/model/TestChainMultivariateGaussian.birch"
  LIBBIRCH_CLASS(TestChainMultivariateGaussian, Model)
  #line 1 "src/test/model/TestChainMultivariateGaussian.birch"
  LIBBIRCH_MEMBERS(x, _u0956, _u0931)
};

#line 1 "src/test/model/TestChainMultivariateGaussian.birch"
extern "C" birch::type::TestChainMultivariateGaussian* make_TestChainMultivariateGaussian_();

#line 1 "src/test/model/TestDirichletCategorical.birch"
class TestDirichletCategorical : public Model {
public:
  #line 1 "src/test/model/TestDirichletCategorical.birch"
  using class_type_ = TestDirichletCategorical;
  #line 1 "src/test/model/TestDirichletCategorical.birch"
  using this_type_ = class_type_;
  #line 1 "src/test/model/TestDirichletCategorical.birch"
  using super_type_ = Model;

  #line 1 "src/test/model/TestDirichletCategorical.birch"
  using super_type_::operator=;
  #line 1 "src/test/model/TestDirichletCategorical.birch"
  using super_type_::simulate;
  
  #line 1 "src/test/model/TestDirichletCategorical.birch"
  TestDirichletCategorical(const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);

  libbirch::Lazy<libbirch::Shared<birch::type::Random<libbirch::DefaultArray<birch::type::Real,1>>>> _u0961;
  libbirch::Lazy<libbirch::Shared<birch::type::Random<birch::type::Integer>>> x;
  libbirch::DefaultArray<birch::type::Real,1> _u0945;
  #line 6 "src/test/model/TestDirichletCategorical.birch"
  virtual void initialize(const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
  #line 12 "src/test/model/TestDirichletCategorical.birch"
  virtual void simulate(const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
  #line 17 "src/test/model/TestDirichletCategorical.birch"
  virtual libbirch::DefaultArray<birch::type::Real,1> forward(const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
  #line 25 "src/test/model/TestDirichletCategorical.birch"
  virtual libbirch::DefaultArray<birch::type::Real,1> backward(const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
  #line 33 "src/test/model/TestDirichletCategorical.birch"
  virtual libbirch::DefaultArray<birch::type::Real,1> forwardLazy(const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
  #line 41 "src/test/model/TestDirichletCategorical.birch"
  virtual libbirch::DefaultArray<birch::type::Real,1> backwardLazy(const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
  #line 49 "src/test/model/TestDirichletCategorical.birch"
  virtual libbirch::Lazy<libbirch::Shared<birch::type::Distribution<birch::type::Integer>>> marginal(const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
  
  #line 1 "src/test/model/TestDirichletCategorical.birch"
  LIBBIRCH_CLASS(TestDirichletCategorical, Model)
  #line 1 "src/test/model/TestDirichletCategorical.birch"
  LIBBIRCH_MEMBERS(_u0961, x, _u0945)
};

#line 1 "src/test/model/TestDirichletCategorical.birch"
extern "C" birch::type::TestDirichletCategorical* make_TestDirichletCategorical_();

#line 1 "src/test/model/TestDirichletMultinomial.birch"
class TestDirichletMultinomial : public Model {
public:
  #line 1 "src/test/model/TestDirichletMultinomial.birch"
  using class_type_ = TestDirichletMultinomial;
  #line 1 "src/test/model/TestDirichletMultinomial.birch"
  using this_type_ = class_type_;
  #line 1 "src/test/model/TestDirichletMultinomial.birch"
  using super_type_ = Model;

  #line 1 "src/test/model/TestDirichletMultinomial.birch"
  using super_type_::operator=;
  #line 1 "src/test/model/TestDirichletMultinomial.birch"
  using super_type_::simulate;
  
  #line 1 "src/test/model/TestDirichletMultinomial.birch"
  TestDirichletMultinomial(const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);

  birch::type::Integer n;
  libbirch::DefaultArray<birch::type::Real,1> _u0945;
  libbirch::Lazy<libbirch::Shared<birch::type::Random<libbirch::DefaultArray<birch::type::Real,1>>>> _u0961;
  libbirch::Lazy<libbirch::Shared<birch::type::Random<libbirch::DefaultArray<birch::type::Integer,1>>>> x;
  #line 7 "src/test/model/TestDirichletMultinomial.birch"
  virtual void initialize(const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
  #line 14 "src/test/model/TestDirichletMultinomial.birch"
  virtual void simulate(const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
  #line 19 "src/test/model/TestDirichletMultinomial.birch"
  virtual libbirch::DefaultArray<birch::type::Real,1> forward(const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
  #line 28 "src/test/model/TestDirichletMultinomial.birch"
  virtual libbirch::DefaultArray<birch::type::Real,1> backward(const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
  #line 37 "src/test/model/TestDirichletMultinomial.birch"
  virtual libbirch::DefaultArray<birch::type::Real,1> forwardLazy(const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
  #line 46 "src/test/model/TestDirichletMultinomial.birch"
  virtual libbirch::DefaultArray<birch::type::Real,1> backwardLazy(const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
  
  #line 1 "src/test/model/TestDirichletMultinomial.birch"
  LIBBIRCH_CLASS(TestDirichletMultinomial, Model)
  #line 1 "src/test/model/TestDirichletMultinomial.birch"
  LIBBIRCH_MEMBERS(n, _u0945, _u0961, x)
};

#line 1 "src/test/model/TestDirichletMultinomial.birch"
extern "C" birch::type::TestDirichletMultinomial* make_TestDirichletMultinomial_();

#line 1 "src/test/model/TestGammaExponential.birch"
class TestGammaExponential : public Model {
public:
  #line 1 "src/test/model/TestGammaExponential.birch"
  using class_type_ = TestGammaExponential;
  #line 1 "src/test/model/TestGammaExponential.birch"
  using this_type_ = class_type_;
  #line 1 "src/test/model/TestGammaExponential.birch"
  using super_type_ = Model;

  #line 1 "src/test/model/TestGammaExponential.birch"
  using super_type_::operator=;
  #line 1 "src/test/model/TestGammaExponential.birch"
  using super_type_::simulate;
  
  #line 1 "src/test/model/TestGammaExponential.birch"
  TestGammaExponential(const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);

  birch::type::Real k;
  birch::type::Real _u0952;
  libbirch::Lazy<libbirch::Shared<birch::type::Random<birch::type::Real>>> _u0955;
  libbirch::Lazy<libbirch::Shared<birch::type::Random<birch::type::Real>>> x;
  #line 7 "src/test/model/TestGammaExponential.birch"
  virtual void initialize(const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
  #line 12 "src/test/model/TestGammaExponential.birch"
  virtual void simulate(const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
  #line 17 "src/test/model/TestGammaExponential.birch"
  virtual libbirch::DefaultArray<birch::type::Real,1> forward(const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
  #line 25 "src/test/model/TestGammaExponential.birch"
  virtual libbirch::DefaultArray<birch::type::Real,1> backward(const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
  #line 33 "src/test/model/TestGammaExponential.birch"
  virtual libbirch::DefaultArray<birch::type::Real,1> forwardLazy(const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
  #line 41 "src/test/model/TestGammaExponential.birch"
  virtual libbirch::DefaultArray<birch::type::Real,1> backwardLazy(const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
  #line 49 "src/test/model/TestGammaExponential.birch"
  virtual libbirch::Lazy<libbirch::Shared<birch::type::Distribution<birch::type::Real>>> marginal(const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
  
  #line 1 "src/test/model/TestGammaExponential.birch"
  LIBBIRCH_CLASS(TestGammaExponential, Model)
  #line 1 "src/test/model/TestGammaExponential.birch"
  LIBBIRCH_MEMBERS(k, _u0952, _u0955, x)
};

#line 1 "src/test/model/TestGammaExponential.birch"
extern "C" birch::type::TestGammaExponential* make_TestGammaExponential_();

#line 1 "src/test/model/TestGammaPoisson.birch"
class TestGammaPoisson : public Model {
public:
  #line 1 "src/test/model/TestGammaPoisson.birch"
  using class_type_ = TestGammaPoisson;
  #line 1 "src/test/model/TestGammaPoisson.birch"
  using this_type_ = class_type_;
  #line 1 "src/test/model/TestGammaPoisson.birch"
  using super_type_ = Model;

  #line 1 "src/test/model/TestGammaPoisson.birch"
  using super_type_::operator=;
  #line 1 "src/test/model/TestGammaPoisson.birch"
  using super_type_::simulate;
  
  #line 1 "src/test/model/TestGammaPoisson.birch"
  TestGammaPoisson(const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);

  libbirch::Lazy<libbirch::Shared<birch::type::Random<birch::type::Real>>> _u0955;
  libbirch::Lazy<libbirch::Shared<birch::type::Random<birch::type::Integer>>> x;
  birch::type::Real k;
  birch::type::Real _u0952;
  #line 7 "src/test/model/TestGammaPoisson.birch"
  virtual void initialize(const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
  #line 12 "src/test/model/TestGammaPoisson.birch"
  virtual void simulate(const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
  #line 17 "src/test/model/TestGammaPoisson.birch"
  virtual libbirch::DefaultArray<birch::type::Real,1> forward(const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
  #line 25 "src/test/model/TestGammaPoisson.birch"
  virtual libbirch::DefaultArray<birch::type::Real,1> backward(const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
  #line 33 "src/test/model/TestGammaPoisson.birch"
  virtual libbirch::DefaultArray<birch::type::Real,1> forwardLazy(const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
  #line 41 "src/test/model/TestGammaPoisson.birch"
  virtual libbirch::DefaultArray<birch::type::Real,1> backwardLazy(const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
  #line 49 "src/test/model/TestGammaPoisson.birch"
  virtual libbirch::Lazy<libbirch::Shared<birch::type::Distribution<birch::type::Integer>>> marginal(const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
  
  #line 1 "src/test/model/TestGammaPoisson.birch"
  LIBBIRCH_CLASS(TestGammaPoisson, Model)
  #line 1 "src/test/model/TestGammaPoisson.birch"
  LIBBIRCH_MEMBERS(_u0955, x, k, _u0952)
};

#line 1 "src/test/model/TestGammaPoisson.birch"
extern "C" birch::type::TestGammaPoisson* make_TestGammaPoisson_();

#line 1 "src/test/model/TestGaussianGaussian.birch"
class TestGaussianGaussian : public Model {
public:
  #line 1 "src/test/model/TestGaussianGaussian.birch"
  using class_type_ = TestGaussianGaussian;
  #line 1 "src/test/model/TestGaussianGaussian.birch"
  using this_type_ = class_type_;
  #line 1 "src/test/model/TestGaussianGaussian.birch"
  using super_type_ = Model;

  #line 1 "src/test/model/TestGaussianGaussian.birch"
  using super_type_::operator=;
  #line 1 "src/test/model/TestGaussianGaussian.birch"
  using super_type_::simulate;
  
  #line 1 "src/test/model/TestGaussianGaussian.birch"
  TestGaussianGaussian(const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);

  libbirch::Lazy<libbirch::Shared<birch::type::Random<birch::type::Real>>> _u0956_1;
  libbirch::Lazy<libbirch::Shared<birch::type::Random<birch::type::Real>>> x;
  birch::type::Real _u0956_0;
  birch::type::Real _u09632_0;
  birch::type::Real _u09632_1;
  #line 8 "src/test/model/TestGaussianGaussian.birch"
  virtual void initialize(const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
  #line 14 "src/test/model/TestGaussianGaussian.birch"
  virtual void simulate(const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
  #line 19 "src/test/model/TestGaussianGaussian.birch"
  virtual libbirch::DefaultArray<birch::type::Real,1> forward(const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
  #line 27 "src/test/model/TestGaussianGaussian.birch"
  virtual libbirch::DefaultArray<birch::type::Real,1> backward(const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
  #line 35 "src/test/model/TestGaussianGaussian.birch"
  virtual libbirch::DefaultArray<birch::type::Real,1> forwardLazy(const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
  #line 43 "src/test/model/TestGaussianGaussian.birch"
  virtual libbirch::DefaultArray<birch::type::Real,1> backwardLazy(const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
  
  #line 1 "src/test/model/TestGaussianGaussian.birch"
  LIBBIRCH_CLASS(TestGaussianGaussian, Model)
  #line 1 "src/test/model/TestGaussianGaussian.birch"
  LIBBIRCH_MEMBERS(_u0956_1, x, _u0956_0, _u09632_0, _u09632_1)
};

#line 1 "src/test/model/TestGaussianGaussian.birch"
extern "C" birch::type::TestGaussianGaussian* make_TestGaussianGaussian_();

#line 1 "src/test/model/TestInverseGammaGamma.birch"
class TestInverseGammaGamma : public Model {
public:
  #line 1 "src/test/model/TestInverseGammaGamma.birch"
  using class_type_ = TestInverseGammaGamma;
  #line 1 "src/test/model/TestInverseGammaGamma.birch"
  using this_type_ = class_type_;
  #line 1 "src/test/model/TestInverseGammaGamma.birch"
  using super_type_ = Model;

  #line 1 "src/test/model/TestInverseGammaGamma.birch"
  using super_type_::operator=;
  #line 1 "src/test/model/TestInverseGammaGamma.birch"
  using super_type_::simulate;
  
  #line 1 "src/test/model/TestInverseGammaGamma.birch"
  TestInverseGammaGamma(const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);

  libbirch::Lazy<libbirch::Shared<birch::type::Random<birch::type::Real>>> _u0952;
  libbirch::Lazy<libbirch::Shared<birch::type::Random<birch::type::Real>>> x;
  birch::type::Real k;
  birch::type::Real _u0945;
  birch::type::Real _u0946;
  #line 8 "src/test/model/TestInverseGammaGamma.birch"
  virtual void initialize(const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
  #line 14 "src/test/model/TestInverseGammaGamma.birch"
  virtual void simulate(const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
  #line 19 "src/test/model/TestInverseGammaGamma.birch"
  virtual libbirch::DefaultArray<birch::type::Real,1> forward(const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
  #line 27 "src/test/model/TestInverseGammaGamma.birch"
  virtual libbirch::DefaultArray<birch::type::Real,1> backward(const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
  #line 35 "src/test/model/TestInverseGammaGamma.birch"
  virtual libbirch::DefaultArray<birch::type::Real,1> forwardLazy(const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
  #line 43 "src/test/model/TestInverseGammaGamma.birch"
  virtual libbirch::DefaultArray<birch::type::Real,1> backwardLazy(const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
  #line 51 "src/test/model/TestInverseGammaGamma.birch"
  virtual libbirch::Lazy<libbirch::Shared<birch::type::Distribution<birch::type::Real>>> marginal(const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
  
  #line 1 "src/test/model/TestInverseGammaGamma.birch"
  LIBBIRCH_CLASS(TestInverseGammaGamma, Model)
  #line 1 "src/test/model/TestInverseGammaGamma.birch"
  LIBBIRCH_MEMBERS(_u0952, x, k, _u0945, _u0946)
};

#line 1 "src/test/model/TestInverseGammaGamma.birch"
extern "C" birch::type::TestInverseGammaGamma* make_TestInverseGammaGamma_();

#line 1 "src/test/model/TestLinearDiscreteDelta.birch"
class TestLinearDiscreteDelta : public Model {
public:
  #line 1 "src/test/model/TestLinearDiscreteDelta.birch"
  using class_type_ = TestLinearDiscreteDelta;
  #line 1 "src/test/model/TestLinearDiscreteDelta.birch"
  using this_type_ = class_type_;
  #line 1 "src/test/model/TestLinearDiscreteDelta.birch"
  using super_type_ = Model;

  #line 1 "src/test/model/TestLinearDiscreteDelta.birch"
  using super_type_::operator=;
  #line 1 "src/test/model/TestLinearDiscreteDelta.birch"
  using super_type_::simulate;
  
  #line 1 "src/test/model/TestLinearDiscreteDelta.birch"
  TestLinearDiscreteDelta(const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);

  libbirch::Lazy<libbirch::Shared<birch::type::Random<birch::type::Real>>> _u0961;
  libbirch::Lazy<libbirch::Shared<birch::type::Random<birch::type::Integer>>> x;
  libbirch::Lazy<libbirch::Shared<birch::type::Random<birch::type::Integer>>> y;
  birch::type::Integer a;
  birch::type::Integer n;
  birch::type::Real _u0945;
  birch::type::Real _u0946;
  birch::type::Integer c;
  birch::type::Boolean neg;
  #line 12 "src/test/model/TestLinearDiscreteDelta.birch"
  virtual void initialize(const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
  #line 21 "src/test/model/TestLinearDiscreteDelta.birch"
  virtual void simulate(const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
  #line 31 "src/test/model/TestLinearDiscreteDelta.birch"
  virtual libbirch::DefaultArray<birch::type::Real,1> forward(const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
  #line 40 "src/test/model/TestLinearDiscreteDelta.birch"
  virtual libbirch::DefaultArray<birch::type::Real,1> backward(const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
  #line 49 "src/test/model/TestLinearDiscreteDelta.birch"
  virtual libbirch::DefaultArray<birch::type::Real,1> forwardLazy(const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
  #line 58 "src/test/model/TestLinearDiscreteDelta.birch"
  virtual libbirch::DefaultArray<birch::type::Real,1> backwardLazy(const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
  #line 67 "src/test/model/TestLinearDiscreteDelta.birch"
  virtual libbirch::Lazy<libbirch::Shared<birch::type::Distribution<birch::type::Integer>>> marginal(const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
  
  #line 1 "src/test/model/TestLinearDiscreteDelta.birch"
  LIBBIRCH_CLASS(TestLinearDiscreteDelta, Model)
  #line 1 "src/test/model/TestLinearDiscreteDelta.birch"
  LIBBIRCH_MEMBERS(_u0961, x, y, a, n, _u0945, _u0946, c, neg)
};

#line 1 "src/test/model/TestLinearDiscreteDelta.birch"
extern "C" birch::type::TestLinearDiscreteDelta* make_TestLinearDiscreteDelta_();

#line 1 "src/test/model/TestLinearGaussianGaussian.birch"
class TestLinearGaussianGaussian : public Model {
public:
  #line 1 "src/test/model/TestLinearGaussianGaussian.birch"
  using class_type_ = TestLinearGaussianGaussian;
  #line 1 "src/test/model/TestLinearGaussianGaussian.birch"
  using this_type_ = class_type_;
  #line 1 "src/test/model/TestLinearGaussianGaussian.birch"
  using super_type_ = Model;

  #line 1 "src/test/model/TestLinearGaussianGaussian.birch"
  using super_type_::operator=;
  #line 1 "src/test/model/TestLinearGaussianGaussian.birch"
  using super_type_::simulate;
  
  #line 1 "src/test/model/TestLinearGaussianGaussian.birch"
  TestLinearGaussianGaussian(const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);

  libbirch::Lazy<libbirch::Shared<birch::type::Random<birch::type::Real>>> _u0956_1;
  libbirch::Lazy<libbirch::Shared<birch::type::Random<birch::type::Real>>> x;
  birch::type::Real a;
  birch::type::Real c;
  birch::type::Real _u0956_0;
  birch::type::Real _u09632_0;
  birch::type::Real _u09632_1;
  birch::type::Boolean neg;
  #line 11 "src/test/model/TestLinearGaussianGaussian.birch"
  virtual void initialize(const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
  #line 20 "src/test/model/TestLinearGaussianGaussian.birch"
  virtual void simulate(const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
  #line 29 "src/test/model/TestLinearGaussianGaussian.birch"
  virtual libbirch::DefaultArray<birch::type::Real,1> forward(const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
  #line 37 "src/test/model/TestLinearGaussianGaussian.birch"
  virtual libbirch::DefaultArray<birch::type::Real,1> backward(const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
  #line 45 "src/test/model/TestLinearGaussianGaussian.birch"
  virtual libbirch::DefaultArray<birch::type::Real,1> forwardLazy(const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
  #line 53 "src/test/model/TestLinearGaussianGaussian.birch"
  virtual libbirch::DefaultArray<birch::type::Real,1> backwardLazy(const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
  #line 61 "src/test/model/TestLinearGaussianGaussian.birch"
  virtual libbirch::Lazy<libbirch::Shared<birch::type::Distribution<birch::type::Real>>> marginal(const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
  
  #line 1 "src/test/model/TestLinearGaussianGaussian.birch"
  LIBBIRCH_CLASS(TestLinearGaussianGaussian, Model)
  #line 1 "src/test/model/TestLinearGaussianGaussian.birch"
  LIBBIRCH_MEMBERS(_u0956_1, x, a, c, _u0956_0, _u09632_0, _u09632_1, neg)
};

#line 1 "src/test/model/TestLinearGaussianGaussian.birch"
extern "C" birch::type::TestLinearGaussianGaussian* make_TestLinearGaussianGaussian_();

#line 1 "src/test/model/TestLinearMatrixNormalInverseWishartMatrixGaussian.birch"
class TestLinearMatrixNormalInverseWishartMatrixGaussian : public Model {
public:
  #line 1 "src/test/model/TestLinearMatrixNormalInverseWishartMatrixGaussian.birch"
  using class_type_ = TestLinearMatrixNormalInverseWishartMatrixGaussian;
  #line 1 "src/test/model/TestLinearMatrixNormalInverseWishartMatrixGaussian.birch"
  using this_type_ = class_type_;
  #line 1 "src/test/model/TestLinearMatrixNormalInverseWishartMatrixGaussian.birch"
  using super_type_ = Model;

  #line 1 "src/test/model/TestLinearMatrixNormalInverseWishartMatrixGaussian.birch"
  using super_type_::operator=;
  #line 1 "src/test/model/TestLinearMatrixNormalInverseWishartMatrixGaussian.birch"
  using super_type_::simulate;
  #line 1 "src/test/model/TestLinearMatrixNormalInverseWishartMatrixGaussian.birch"
  using super_type_::size;
  
  #line 1 "src/test/model/TestLinearMatrixNormalInverseWishartMatrixGaussian.birch"
  TestLinearMatrixNormalInverseWishartMatrixGaussian(const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);

  libbirch::Lazy<libbirch::Shared<birch::type::Random<birch::type::LLT>>> V;
  libbirch::Lazy<libbirch::Shared<birch::type::Random<libbirch::DefaultArray<birch::type::Real,2>>>> X;
  libbirch::Lazy<libbirch::Shared<birch::type::Random<libbirch::DefaultArray<birch::type::Real,2>>>> Y;
  birch::type::Integer n;
  birch::type::Integer p;
  libbirch::DefaultArray<birch::type::Real,2> A;
  libbirch::DefaultArray<birch::type::Real,2> M;
  libbirch::DefaultArray<birch::type::Real,2> U;
  libbirch::DefaultArray<birch::type::Real,2> C;
  birch::type::Real k;
  libbirch::DefaultArray<birch::type::Real,2> _u0936;
  birch::type::Boolean neg;
  #line 16 "src/test/model/TestLinearMatrixNormalInverseWishartMatrixGaussian.birch"
  virtual void initialize(const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
  #line 38 "src/test/model/TestLinearMatrixNormalInverseWishartMatrixGaussian.birch"
  virtual void simulate(const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
  #line 48 "src/test/model/TestLinearMatrixNormalInverseWishartMatrixGaussian.birch"
  virtual libbirch::DefaultArray<birch::type::Real,1> forward(const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
  #line 58 "src/test/model/TestLinearMatrixNormalInverseWishartMatrixGaussian.birch"
  virtual libbirch::DefaultArray<birch::type::Real,1> backward(const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
  #line 68 "src/test/model/TestLinearMatrixNormalInverseWishartMatrixGaussian.birch"
  virtual libbirch::DefaultArray<birch::type::Real,1> forwardLazy(const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
  #line 78 "src/test/model/TestLinearMatrixNormalInverseWishartMatrixGaussian.birch"
  virtual libbirch::DefaultArray<birch::type::Real,1> backwardLazy(const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
  #line 88 "src/test/model/TestLinearMatrixNormalInverseWishartMatrixGaussian.birch"
  virtual libbirch::Lazy<libbirch::Shared<birch::type::Distribution<libbirch::DefaultArray<birch::type::Real,2>>>> marginal(const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
  #line 92 "src/test/model/TestLinearMatrixNormalInverseWishartMatrixGaussian.birch"
  virtual libbirch::DefaultArray<birch::type::Real,1> vectorize(const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
  #line 110 "src/test/model/TestLinearMatrixNormalInverseWishartMatrixGaussian.birch"
  virtual birch::type::Integer size(const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
  
  #line 1 "src/test/model/TestLinearMatrixNormalInverseWishartMatrixGaussian.birch"
  LIBBIRCH_CLASS(TestLinearMatrixNormalInverseWishartMatrixGaussian, Model)
  #line 1 "src/test/model/TestLinearMatrixNormalInverseWishartMatrixGaussian.birch"
  LIBBIRCH_MEMBERS(V, X, Y, n, p, A, M, U, C, k, _u0936, neg)
};

#line 1 "src/test/model/TestLinearMatrixNormalInverseWishartMatrixGaussian.birch"
extern "C" birch::type::TestLinearMatrixNormalInverseWishartMatrixGaussian* make_TestLinearMatrixNormalInverseWishartMatrixGaussian_();

#line 1 "src/test/model/TestLinearMatrixNormalInverseWishartMultivariateGaussian.birch"
class TestLinearMatrixNormalInverseWishartMultivariateGaussian : public Model {
public:
  #line 1 "src/test/model/TestLinearMatrixNormalInverseWishartMultivariateGaussian.birch"
  using class_type_ = TestLinearMatrixNormalInverseWishartMultivariateGaussian;
  #line 1 "src/test/model/TestLinearMatrixNormalInverseWishartMultivariateGaussian.birch"
  using this_type_ = class_type_;
  #line 1 "src/test/model/TestLinearMatrixNormalInverseWishartMultivariateGaussian.birch"
  using super_type_ = Model;

  #line 1 "src/test/model/TestLinearMatrixNormalInverseWishartMultivariateGaussian.birch"
  using super_type_::operator=;
  #line 1 "src/test/model/TestLinearMatrixNormalInverseWishartMultivariateGaussian.birch"
  using super_type_::simulate;
  #line 1 "src/test/model/TestLinearMatrixNormalInverseWishartMultivariateGaussian.birch"
  using super_type_::size;
  
  #line 1 "src/test/model/TestLinearMatrixNormalInverseWishartMultivariateGaussian.birch"
  TestLinearMatrixNormalInverseWishartMultivariateGaussian(const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);

  libbirch::Lazy<libbirch::Shared<birch::type::Random<birch::type::LLT>>> V;
  libbirch::Lazy<libbirch::Shared<birch::type::Random<libbirch::DefaultArray<birch::type::Real,2>>>> X;
  libbirch::Lazy<libbirch::Shared<birch::type::Random<libbirch::DefaultArray<birch::type::Real,1>>>> y;
  birch::type::Integer n;
  birch::type::Integer p;
  libbirch::DefaultArray<birch::type::Real,1> a;
  libbirch::DefaultArray<birch::type::Real,2> M;
  libbirch::DefaultArray<birch::type::Real,2> U;
  libbirch::DefaultArray<birch::type::Real,1> c;
  birch::type::Real k;
  libbirch::DefaultArray<birch::type::Real,2> _u0936;
  birch::type::Boolean neg;
  #line 16 "src/test/model/TestLinearMatrixNormalInverseWishartMultivariateGaussian.birch"
  virtual void initialize(const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
  #line 38 "src/test/model/TestLinearMatrixNormalInverseWishartMultivariateGaussian.birch"
  virtual void simulate(const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
  #line 48 "src/test/model/TestLinearMatrixNormalInverseWishartMultivariateGaussian.birch"
  virtual libbirch::DefaultArray<birch::type::Real,1> forward(const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
  #line 58 "src/test/model/TestLinearMatrixNormalInverseWishartMultivariateGaussian.birch"
  virtual libbirch::DefaultArray<birch::type::Real,1> backward(const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
  #line 68 "src/test/model/TestLinearMatrixNormalInverseWishartMultivariateGaussian.birch"
  virtual libbirch::DefaultArray<birch::type::Real,1> forwardLazy(const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
  #line 78 "src/test/model/TestLinearMatrixNormalInverseWishartMultivariateGaussian.birch"
  virtual libbirch::DefaultArray<birch::type::Real,1> backwardLazy(const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
  #line 88 "src/test/model/TestLinearMatrixNormalInverseWishartMultivariateGaussian.birch"
  virtual libbirch::Lazy<libbirch::Shared<birch::type::Distribution<libbirch::DefaultArray<birch::type::Real,1>>>> marginal(const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
  #line 92 "src/test/model/TestLinearMatrixNormalInverseWishartMultivariateGaussian.birch"
  virtual libbirch::DefaultArray<birch::type::Real,1> vectorize(const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
  #line 103 "src/test/model/TestLinearMatrixNormalInverseWishartMultivariateGaussian.birch"
  virtual birch::type::Integer size(const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
  
  #line 1 "src/test/model/TestLinearMatrixNormalInverseWishartMultivariateGaussian.birch"
  LIBBIRCH_CLASS(TestLinearMatrixNormalInverseWishartMultivariateGaussian, Model)
  #line 1 "src/test/model/TestLinearMatrixNormalInverseWishartMultivariateGaussian.birch"
  LIBBIRCH_MEMBERS(V, X, y, n, p, a, M, U, c, k, _u0936, neg)
};

#line 1 "src/test/model/TestLinearMatrixNormalInverseWishartMultivariateGaussian.birch"
extern "C" birch::type::TestLinearMatrixNormalInverseWishartMultivariateGaussian* make_TestLinearMatrixNormalInverseWishartMultivariateGaussian_();

#line 1 "src/test/model/TestLinearMultivariateGaussianGaussian.birch"
class TestLinearMultivariateGaussianGaussian : public Model {
public:
  #line 1 "src/test/model/TestLinearMultivariateGaussianGaussian.birch"
  using class_type_ = TestLinearMultivariateGaussianGaussian;
  #line 1 "src/test/model/TestLinearMultivariateGaussianGaussian.birch"
  using this_type_ = class_type_;
  #line 1 "src/test/model/TestLinearMultivariateGaussianGaussian.birch"
  using super_type_ = Model;

  #line 1 "src/test/model/TestLinearMultivariateGaussianGaussian.birch"
  using super_type_::operator=;
  #line 1 "src/test/model/TestLinearMultivariateGaussianGaussian.birch"
  using super_type_::simulate;
  
  #line 1 "src/test/model/TestLinearMultivariateGaussianGaussian.birch"
  TestLinearMultivariateGaussianGaussian(const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);

  libbirch::Lazy<libbirch::Shared<birch::type::Random<libbirch::DefaultArray<birch::type::Real,1>>>> _u0956;
  libbirch::Lazy<libbirch::Shared<birch::type::Random<birch::type::Real>>> x;
  libbirch::DefaultArray<birch::type::Real,1> a;
  libbirch::DefaultArray<birch::type::Real,1> _u0956_0;
  libbirch::DefaultArray<birch::type::Real,2> _u0931_0;
  birch::type::Real c;
  birch::type::Real _u09632_1;
  #line 11 "src/test/model/TestLinearMultivariateGaussianGaussian.birch"
  virtual void initialize(const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
  #line 24 "src/test/model/TestLinearMultivariateGaussianGaussian.birch"
  virtual void simulate(const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
  #line 29 "src/test/model/TestLinearMultivariateGaussianGaussian.birch"
  virtual libbirch::DefaultArray<birch::type::Real,1> forward(const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
  #line 37 "src/test/model/TestLinearMultivariateGaussianGaussian.birch"
  virtual libbirch::DefaultArray<birch::type::Real,1> backward(const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
  #line 45 "src/test/model/TestLinearMultivariateGaussianGaussian.birch"
  virtual libbirch::DefaultArray<birch::type::Real,1> forwardLazy(const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
  #line 53 "src/test/model/TestLinearMultivariateGaussianGaussian.birch"
  virtual libbirch::DefaultArray<birch::type::Real,1> backwardLazy(const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
  #line 61 "src/test/model/TestLinearMultivariateGaussianGaussian.birch"
  virtual libbirch::Lazy<libbirch::Shared<birch::type::Distribution<birch::type::Real>>> marginal(const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
  
  #line 1 "src/test/model/TestLinearMultivariateGaussianGaussian.birch"
  LIBBIRCH_CLASS(TestLinearMultivariateGaussianGaussian, Model)
  #line 1 "src/test/model/TestLinearMultivariateGaussianGaussian.birch"
  LIBBIRCH_MEMBERS(_u0956, x, a, _u0956_0, _u0931_0, c, _u09632_1)
};

#line 1 "src/test/model/TestLinearMultivariateGaussianGaussian.birch"
extern "C" birch::type::TestLinearMultivariateGaussianGaussian* make_TestLinearMultivariateGaussianGaussian_();

#line 1 "src/test/model/TestLinearMultivariateGaussianMultivariateGaussian.birch"
class TestLinearMultivariateGaussianMultivariateGaussian : public Model {
public:
  #line 1 "src/test/model/TestLinearMultivariateGaussianMultivariateGaussian.birch"
  using class_type_ = TestLinearMultivariateGaussianMultivariateGaussian;
  #line 1 "src/test/model/TestLinearMultivariateGaussianMultivariateGaussian.birch"
  using this_type_ = class_type_;
  #line 1 "src/test/model/TestLinearMultivariateGaussianMultivariateGaussian.birch"
  using super_type_ = Model;

  #line 1 "src/test/model/TestLinearMultivariateGaussianMultivariateGaussian.birch"
  using super_type_::operator=;
  #line 1 "src/test/model/TestLinearMultivariateGaussianMultivariateGaussian.birch"
  using super_type_::simulate;
  
  #line 1 "src/test/model/TestLinearMultivariateGaussianMultivariateGaussian.birch"
  TestLinearMultivariateGaussianMultivariateGaussian(const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);

  libbirch::Lazy<libbirch::Shared<birch::type::Random<libbirch::DefaultArray<birch::type::Real,1>>>> _u0956;
  libbirch::Lazy<libbirch::Shared<birch::type::Random<libbirch::DefaultArray<birch::type::Real,1>>>> x;
  libbirch::DefaultArray<birch::type::Real,2> A;
  libbirch::DefaultArray<birch::type::Real,1> _u0956_0;
  libbirch::DefaultArray<birch::type::Real,2> _u0931_0;
  libbirch::DefaultArray<birch::type::Real,1> c;
  libbirch::DefaultArray<birch::type::Real,2> _u0931_1;
  birch::type::Boolean neg;
  #line 12 "src/test/model/TestLinearMultivariateGaussianMultivariateGaussian.birch"
  virtual void initialize(const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
  #line 27 "src/test/model/TestLinearMultivariateGaussianMultivariateGaussian.birch"
  virtual void simulate(const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
  #line 36 "src/test/model/TestLinearMultivariateGaussianMultivariateGaussian.birch"
  virtual libbirch::DefaultArray<birch::type::Real,1> forward(const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
  #line 44 "src/test/model/TestLinearMultivariateGaussianMultivariateGaussian.birch"
  virtual libbirch::DefaultArray<birch::type::Real,1> backward(const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
  #line 52 "src/test/model/TestLinearMultivariateGaussianMultivariateGaussian.birch"
  virtual libbirch::DefaultArray<birch::type::Real,1> forwardLazy(const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
  #line 60 "src/test/model/TestLinearMultivariateGaussianMultivariateGaussian.birch"
  virtual libbirch::DefaultArray<birch::type::Real,1> backwardLazy(const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
  #line 68 "src/test/model/TestLinearMultivariateGaussianMultivariateGaussian.birch"
  virtual libbirch::Lazy<libbirch::Shared<birch::type::Distribution<libbirch::DefaultArray<birch::type::Real,1>>>> marginal(const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
  
  #line 1 "src/test/model/TestLinearMultivariateGaussianMultivariateGaussian.birch"
  LIBBIRCH_CLASS(TestLinearMultivariateGaussianMultivariateGaussian, Model)
  #line 1 "src/test/model/TestLinearMultivariateGaussianMultivariateGaussian.birch"
  LIBBIRCH_MEMBERS(_u0956, x, A, _u0956_0, _u0931_0, c, _u0931_1, neg)
};

#line 1 "src/test/model/TestLinearMultivariateGaussianMultivariateGaussian.birch"
extern "C" birch::type::TestLinearMultivariateGaussianMultivariateGaussian* make_TestLinearMultivariateGaussianMultivariateGaussian_();

#line 1 "src/test/model/TestLinearMultivariateNormalInverseGammaGaussian.birch"
class TestLinearMultivariateNormalInverseGammaGaussian : public Model {
public:
  #line 1 "src/test/model/TestLinearMultivariateNormalInverseGammaGaussian.birch"
  using class_type_ = TestLinearMultivariateNormalInverseGammaGaussian;
  #line 1 "src/test/model/TestLinearMultivariateNormalInverseGammaGaussian.birch"
  using this_type_ = class_type_;
  #line 1 "src/test/model/TestLinearMultivariateNormalInverseGammaGaussian.birch"
  using super_type_ = Model;

  #line 1 "src/test/model/TestLinearMultivariateNormalInverseGammaGaussian.birch"
  using super_type_::operator=;
  #line 1 "src/test/model/TestLinearMultivariateNormalInverseGammaGaussian.birch"
  using super_type_::simulate;
  
  #line 1 "src/test/model/TestLinearMultivariateNormalInverseGammaGaussian.birch"
  TestLinearMultivariateNormalInverseGammaGaussian(const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);

  libbirch::Lazy<libbirch::Shared<birch::type::Random<birch::type::Real>>> _u09632;
  libbirch::Lazy<libbirch::Shared<birch::type::Random<libbirch::DefaultArray<birch::type::Real,1>>>> _u0956;
  libbirch::Lazy<libbirch::Shared<birch::type::Random<birch::type::Real>>> x;
  libbirch::DefaultArray<birch::type::Real,1> a;
  libbirch::DefaultArray<birch::type::Real,1> _u0956_0;
  libbirch::DefaultArray<birch::type::Real,2> _u0931;
  birch::type::Real c;
  birch::type::Real _u0945;
  birch::type::Real _u0946;
  #line 13 "src/test/model/TestLinearMultivariateNormalInverseGammaGaussian.birch"
  virtual void initialize(const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
  #line 27 "src/test/model/TestLinearMultivariateNormalInverseGammaGaussian.birch"
  virtual void simulate(const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
  #line 33 "src/test/model/TestLinearMultivariateNormalInverseGammaGaussian.birch"
  virtual libbirch::DefaultArray<birch::type::Real,1> forward(const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
  #line 43 "src/test/model/TestLinearMultivariateNormalInverseGammaGaussian.birch"
  virtual libbirch::DefaultArray<birch::type::Real,1> backward(const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
  #line 53 "src/test/model/TestLinearMultivariateNormalInverseGammaGaussian.birch"
  virtual libbirch::DefaultArray<birch::type::Real,1> forwardLazy(const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
  #line 63 "src/test/model/TestLinearMultivariateNormalInverseGammaGaussian.birch"
  virtual libbirch::DefaultArray<birch::type::Real,1> backwardLazy(const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
  #line 73 "src/test/model/TestLinearMultivariateNormalInverseGammaGaussian.birch"
  virtual libbirch::Lazy<libbirch::Shared<birch::type::Distribution<birch::type::Real>>> marginal(const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
  
  #line 1 "src/test/model/TestLinearMultivariateNormalInverseGammaGaussian.birch"
  LIBBIRCH_CLASS(TestLinearMultivariateNormalInverseGammaGaussian, Model)
  #line 1 "src/test/model/TestLinearMultivariateNormalInverseGammaGaussian.birch"
  LIBBIRCH_MEMBERS(_u09632, _u0956, x, a, _u0956_0, _u0931, c, _u0945, _u0946)
};

#line 1 "src/test/model/TestLinearMultivariateNormalInverseGammaGaussian.birch"
extern "C" birch::type::TestLinearMultivariateNormalInverseGammaGaussian* make_TestLinearMultivariateNormalInverseGammaGaussian_();

#line 1 "src/test/model/TestLinearMultivariateNormalInverseGammaMultivariateGaussian.birch"
class TestLinearMultivariateNormalInverseGammaMultivariateGaussian : public Model {
public:
  #line 1 "src/test/model/TestLinearMultivariateNormalInverseGammaMultivariateGaussian.birch"
  using class_type_ = TestLinearMultivariateNormalInverseGammaMultivariateGaussian;
  #line 1 "src/test/model/TestLinearMultivariateNormalInverseGammaMultivariateGaussian.birch"
  using this_type_ = class_type_;
  #line 1 "src/test/model/TestLinearMultivariateNormalInverseGammaMultivariateGaussian.birch"
  using super_type_ = Model;

  #line 1 "src/test/model/TestLinearMultivariateNormalInverseGammaMultivariateGaussian.birch"
  using super_type_::operator=;
  #line 1 "src/test/model/TestLinearMultivariateNormalInverseGammaMultivariateGaussian.birch"
  using super_type_::simulate;
  
  #line 1 "src/test/model/TestLinearMultivariateNormalInverseGammaMultivariateGaussian.birch"
  TestLinearMultivariateNormalInverseGammaMultivariateGaussian(const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);

  libbirch::Lazy<libbirch::Shared<birch::type::Random<birch::type::Real>>> _u09632;
  libbirch::Lazy<libbirch::Shared<birch::type::Random<libbirch::DefaultArray<birch::type::Real,1>>>> _u0956;
  libbirch::Lazy<libbirch::Shared<birch::type::Random<libbirch::DefaultArray<birch::type::Real,1>>>> x;
  libbirch::DefaultArray<birch::type::Real,2> A;
  libbirch::DefaultArray<birch::type::Real,1> _u0956_0;
  libbirch::DefaultArray<birch::type::Real,2> _u0931;
  libbirch::DefaultArray<birch::type::Real,1> c;
  birch::type::Real _u0945;
  birch::type::Real _u0946;
  birch::type::Boolean neg;
  #line 14 "src/test/model/TestLinearMultivariateNormalInverseGammaMultivariateGaussian.birch"
  virtual void initialize(const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
  #line 33 "src/test/model/TestLinearMultivariateNormalInverseGammaMultivariateGaussian.birch"
  virtual void simulate(const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
  #line 43 "src/test/model/TestLinearMultivariateNormalInverseGammaMultivariateGaussian.birch"
  virtual libbirch::DefaultArray<birch::type::Real,1> forward(const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
  #line 53 "src/test/model/TestLinearMultivariateNormalInverseGammaMultivariateGaussian.birch"
  virtual libbirch::DefaultArray<birch::type::Real,1> backward(const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
  #line 63 "src/test/model/TestLinearMultivariateNormalInverseGammaMultivariateGaussian.birch"
  virtual libbirch::DefaultArray<birch::type::Real,1> forwardLazy(const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
  #line 73 "src/test/model/TestLinearMultivariateNormalInverseGammaMultivariateGaussian.birch"
  virtual libbirch::DefaultArray<birch::type::Real,1> backwardLazy(const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
  #line 83 "src/test/model/TestLinearMultivariateNormalInverseGammaMultivariateGaussian.birch"
  virtual libbirch::Lazy<libbirch::Shared<birch::type::Distribution<libbirch::DefaultArray<birch::type::Real,1>>>> marginal(const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
  
  #line 1 "src/test/model/TestLinearMultivariateNormalInverseGammaMultivariateGaussian.birch"
  LIBBIRCH_CLASS(TestLinearMultivariateNormalInverseGammaMultivariateGaussian, Model)
  #line 1 "src/test/model/TestLinearMultivariateNormalInverseGammaMultivariateGaussian.birch"
  LIBBIRCH_MEMBERS(_u09632, _u0956, x, A, _u0956_0, _u0931, c, _u0945, _u0946, neg)
};

#line 1 "src/test/model/TestLinearMultivariateNormalInverseGammaMultivariateGaussian.birch"
extern "C" birch::type::TestLinearMultivariateNormalInverseGammaMultivariateGaussian* make_TestLinearMultivariateNormalInverseGammaMultivariateGaussian_();

#line 1 "src/test/model/TestLinearNormalInverseGammaGaussian.birch"
class TestLinearNormalInverseGammaGaussian : public Model {
public:
  #line 1 "src/test/model/TestLinearNormalInverseGammaGaussian.birch"
  using class_type_ = TestLinearNormalInverseGammaGaussian;
  #line 1 "src/test/model/TestLinearNormalInverseGammaGaussian.birch"
  using this_type_ = class_type_;
  #line 1 "src/test/model/TestLinearNormalInverseGammaGaussian.birch"
  using super_type_ = Model;

  #line 1 "src/test/model/TestLinearNormalInverseGammaGaussian.birch"
  using super_type_::operator=;
  #line 1 "src/test/model/TestLinearNormalInverseGammaGaussian.birch"
  using super_type_::simulate;
  
  #line 1 "src/test/model/TestLinearNormalInverseGammaGaussian.birch"
  TestLinearNormalInverseGammaGaussian(const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);

  libbirch::Lazy<libbirch::Shared<birch::type::Random<birch::type::Real>>> _u09632;
  libbirch::Lazy<libbirch::Shared<birch::type::Random<birch::type::Real>>> _u0956;
  libbirch::Lazy<libbirch::Shared<birch::type::Random<birch::type::Real>>> x;
  birch::type::Real a;
  birch::type::Real _u0956_0;
  birch::type::Real a2;
  birch::type::Real c;
  birch::type::Real _u0945;
  birch::type::Real _u0946;
  birch::type::Boolean neg;
  #line 14 "src/test/model/TestLinearNormalInverseGammaGaussian.birch"
  virtual void initialize(const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
  #line 24 "src/test/model/TestLinearNormalInverseGammaGaussian.birch"
  virtual void simulate(const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
  #line 34 "src/test/model/TestLinearNormalInverseGammaGaussian.birch"
  virtual libbirch::DefaultArray<birch::type::Real,1> forward(const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
  #line 45 "src/test/model/TestLinearNormalInverseGammaGaussian.birch"
  virtual libbirch::DefaultArray<birch::type::Real,1> backward(const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
  #line 56 "src/test/model/TestLinearNormalInverseGammaGaussian.birch"
  virtual libbirch::DefaultArray<birch::type::Real,1> forwardLazy(const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
  #line 67 "src/test/model/TestLinearNormalInverseGammaGaussian.birch"
  virtual libbirch::DefaultArray<birch::type::Real,1> backwardLazy(const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
  #line 78 "src/test/model/TestLinearNormalInverseGammaGaussian.birch"
  virtual libbirch::Lazy<libbirch::Shared<birch::type::Distribution<birch::type::Real>>> marginal(const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
  
  #line 1 "src/test/model/TestLinearNormalInverseGammaGaussian.birch"
  LIBBIRCH_CLASS(TestLinearNormalInverseGammaGaussian, Model)
  #line 1 "src/test/model/TestLinearNormalInverseGammaGaussian.birch"
  LIBBIRCH_MEMBERS(_u09632, _u0956, x, a, _u0956_0, a2, c, _u0945, _u0946, neg)
};

#line 1 "src/test/model/TestLinearNormalInverseGammaGaussian.birch"
extern "C" birch::type::TestLinearNormalInverseGammaGaussian* make_TestLinearNormalInverseGammaGaussian_();

#line 1 "src/test/model/TestMatrixNormalInverseWishartMatrixGaussian.birch"
class TestMatrixNormalInverseWishartMatrixGaussian : public Model {
public:
  #line 1 "src/test/model/TestMatrixNormalInverseWishartMatrixGaussian.birch"
  using class_type_ = TestMatrixNormalInverseWishartMatrixGaussian;
  #line 1 "src/test/model/TestMatrixNormalInverseWishartMatrixGaussian.birch"
  using this_type_ = class_type_;
  #line 1 "src/test/model/TestMatrixNormalInverseWishartMatrixGaussian.birch"
  using super_type_ = Model;

  #line 1 "src/test/model/TestMatrixNormalInverseWishartMatrixGaussian.birch"
  using super_type_::operator=;
  #line 1 "src/test/model/TestMatrixNormalInverseWishartMatrixGaussian.birch"
  using super_type_::simulate;
  #line 1 "src/test/model/TestMatrixNormalInverseWishartMatrixGaussian.birch"
  using super_type_::size;
  
  #line 1 "src/test/model/TestMatrixNormalInverseWishartMatrixGaussian.birch"
  TestMatrixNormalInverseWishartMatrixGaussian(const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);

  libbirch::Lazy<libbirch::Shared<birch::type::Random<birch::type::LLT>>> V;
  libbirch::Lazy<libbirch::Shared<birch::type::Random<libbirch::DefaultArray<birch::type::Real,2>>>> X;
  libbirch::Lazy<libbirch::Shared<birch::type::Random<libbirch::DefaultArray<birch::type::Real,2>>>> Y;
  birch::type::Real n;
  birch::type::Real p;
  libbirch::DefaultArray<birch::type::Real,2> M;
  libbirch::DefaultArray<birch::type::Real,2> U;
  birch::type::Real k;
  libbirch::DefaultArray<birch::type::Real,2> _u0936;
  #line 14 "src/test/model/TestMatrixNormalInverseWishartMatrixGaussian.birch"
  virtual void initialize(const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
  #line 33 "src/test/model/TestMatrixNormalInverseWishartMatrixGaussian.birch"
  virtual void simulate(const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
  #line 39 "src/test/model/TestMatrixNormalInverseWishartMatrixGaussian.birch"
  virtual libbirch::DefaultArray<birch::type::Real,1> forward(const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
  #line 49 "src/test/model/TestMatrixNormalInverseWishartMatrixGaussian.birch"
  virtual libbirch::DefaultArray<birch::type::Real,1> backward(const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
  #line 59 "src/test/model/TestMatrixNormalInverseWishartMatrixGaussian.birch"
  virtual libbirch::DefaultArray<birch::type::Real,1> forwardLazy(const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
  #line 69 "src/test/model/TestMatrixNormalInverseWishartMatrixGaussian.birch"
  virtual libbirch::DefaultArray<birch::type::Real,1> backwardLazy(const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
  #line 79 "src/test/model/TestMatrixNormalInverseWishartMatrixGaussian.birch"
  virtual libbirch::Lazy<libbirch::Shared<birch::type::Distribution<libbirch::DefaultArray<birch::type::Real,2>>>> marginal(const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
  #line 83 "src/test/model/TestMatrixNormalInverseWishartMatrixGaussian.birch"
  virtual libbirch::DefaultArray<birch::type::Real,1> vectorize(const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
  #line 101 "src/test/model/TestMatrixNormalInverseWishartMatrixGaussian.birch"
  virtual birch::type::Integer size(const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
  
  #line 1 "src/test/model/TestMatrixNormalInverseWishartMatrixGaussian.birch"
  LIBBIRCH_CLASS(TestMatrixNormalInverseWishartMatrixGaussian, Model)
  #line 1 "src/test/model/TestMatrixNormalInverseWishartMatrixGaussian.birch"
  LIBBIRCH_MEMBERS(V, X, Y, n, p, M, U, k, _u0936)
};

#line 1 "src/test/model/TestMatrixNormalInverseWishartMatrixGaussian.birch"
extern "C" birch::type::TestMatrixNormalInverseWishartMatrixGaussian* make_TestMatrixNormalInverseWishartMatrixGaussian_();

#line 1 "src/test/model/TestMultivariateGaussianMultivariateGaussian.birch"
class TestMultivariateGaussianMultivariateGaussian : public Model {
public:
  #line 1 "src/test/model/TestMultivariateGaussianMultivariateGaussian.birch"
  using class_type_ = TestMultivariateGaussianMultivariateGaussian;
  #line 1 "src/test/model/TestMultivariateGaussianMultivariateGaussian.birch"
  using this_type_ = class_type_;
  #line 1 "src/test/model/TestMultivariateGaussianMultivariateGaussian.birch"
  using super_type_ = Model;

  #line 1 "src/test/model/TestMultivariateGaussianMultivariateGaussian.birch"
  using super_type_::operator=;
  #line 1 "src/test/model/TestMultivariateGaussianMultivariateGaussian.birch"
  using super_type_::simulate;
  
  #line 1 "src/test/model/TestMultivariateGaussianMultivariateGaussian.birch"
  TestMultivariateGaussianMultivariateGaussian(const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);

  libbirch::Lazy<libbirch::Shared<birch::type::Random<libbirch::DefaultArray<birch::type::Real,1>>>> _u0956_1;
  libbirch::Lazy<libbirch::Shared<birch::type::Random<libbirch::DefaultArray<birch::type::Real,1>>>> x;
  libbirch::DefaultArray<birch::type::Real,1> _u0956_0;
  libbirch::DefaultArray<birch::type::Real,2> _u0931_0;
  libbirch::DefaultArray<birch::type::Real,2> _u0931_1;
  #line 9 "src/test/model/TestMultivariateGaussianMultivariateGaussian.birch"
  virtual void initialize(const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
  #line 21 "src/test/model/TestMultivariateGaussianMultivariateGaussian.birch"
  virtual void simulate(const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
  #line 26 "src/test/model/TestMultivariateGaussianMultivariateGaussian.birch"
  virtual libbirch::DefaultArray<birch::type::Real,1> forward(const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
  #line 34 "src/test/model/TestMultivariateGaussianMultivariateGaussian.birch"
  virtual libbirch::DefaultArray<birch::type::Real,1> backward(const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
  #line 42 "src/test/model/TestMultivariateGaussianMultivariateGaussian.birch"
  virtual libbirch::DefaultArray<birch::type::Real,1> forwardLazy(const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
  #line 50 "src/test/model/TestMultivariateGaussianMultivariateGaussian.birch"
  virtual libbirch::DefaultArray<birch::type::Real,1> backwardLazy(const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
  #line 58 "src/test/model/TestMultivariateGaussianMultivariateGaussian.birch"
  virtual libbirch::Lazy<libbirch::Shared<birch::type::Distribution<libbirch::DefaultArray<birch::type::Real,1>>>> marginal(const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
  
  #line 1 "src/test/model/TestMultivariateGaussianMultivariateGaussian.birch"
  LIBBIRCH_CLASS(TestMultivariateGaussianMultivariateGaussian, Model)
  #line 1 "src/test/model/TestMultivariateGaussianMultivariateGaussian.birch"
  LIBBIRCH_MEMBERS(_u0956_1, x, _u0956_0, _u0931_0, _u0931_1)
};

#line 1 "src/test/model/TestMultivariateGaussianMultivariateGaussian.birch"
extern "C" birch::type::TestMultivariateGaussianMultivariateGaussian* make_TestMultivariateGaussianMultivariateGaussian_();

#line 1 "src/test/model/TestMultivariateNormalInverseGammaMultivariateGaussian.birch"
class TestMultivariateNormalInverseGammaMultivariateGaussian : public Model {
public:
  #line 1 "src/test/model/TestMultivariateNormalInverseGammaMultivariateGaussian.birch"
  using class_type_ = TestMultivariateNormalInverseGammaMultivariateGaussian;
  #line 1 "src/test/model/TestMultivariateNormalInverseGammaMultivariateGaussian.birch"
  using this_type_ = class_type_;
  #line 1 "src/test/model/TestMultivariateNormalInverseGammaMultivariateGaussian.birch"
  using super_type_ = Model;

  #line 1 "src/test/model/TestMultivariateNormalInverseGammaMultivariateGaussian.birch"
  using super_type_::operator=;
  #line 1 "src/test/model/TestMultivariateNormalInverseGammaMultivariateGaussian.birch"
  using super_type_::simulate;
  
  #line 1 "src/test/model/TestMultivariateNormalInverseGammaMultivariateGaussian.birch"
  TestMultivariateNormalInverseGammaMultivariateGaussian(const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);

  libbirch::Lazy<libbirch::Shared<birch::type::Random<birch::type::Real>>> _u09632;
  libbirch::Lazy<libbirch::Shared<birch::type::Random<libbirch::DefaultArray<birch::type::Real,1>>>> _u0956;
  libbirch::Lazy<libbirch::Shared<birch::type::Random<libbirch::DefaultArray<birch::type::Real,1>>>> x;
  libbirch::DefaultArray<birch::type::Real,1> _u0956_0;
  libbirch::DefaultArray<birch::type::Real,2> A;
  birch::type::Real _u0945;
  birch::type::Real _u0946;
  #line 11 "src/test/model/TestMultivariateNormalInverseGammaMultivariateGaussian.birch"
  virtual void initialize(const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
  #line 23 "src/test/model/TestMultivariateNormalInverseGammaMultivariateGaussian.birch"
  virtual void simulate(const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
  #line 29 "src/test/model/TestMultivariateNormalInverseGammaMultivariateGaussian.birch"
  virtual libbirch::DefaultArray<birch::type::Real,1> forward(const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
  #line 39 "src/test/model/TestMultivariateNormalInverseGammaMultivariateGaussian.birch"
  virtual libbirch::DefaultArray<birch::type::Real,1> backward(const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
  #line 49 "src/test/model/TestMultivariateNormalInverseGammaMultivariateGaussian.birch"
  virtual libbirch::DefaultArray<birch::type::Real,1> forwardLazy(const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
  #line 59 "src/test/model/TestMultivariateNormalInverseGammaMultivariateGaussian.birch"
  virtual libbirch::DefaultArray<birch::type::Real,1> backwardLazy(const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
  #line 69 "src/test/model/TestMultivariateNormalInverseGammaMultivariateGaussian.birch"
  virtual libbirch::Lazy<libbirch::Shared<birch::type::Distribution<libbirch::DefaultArray<birch::type::Real,1>>>> marginal(const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
  
  #line 1 "src/test/model/TestMultivariateNormalInverseGammaMultivariateGaussian.birch"
  LIBBIRCH_CLASS(TestMultivariateNormalInverseGammaMultivariateGaussian, Model)
  #line 1 "src/test/model/TestMultivariateNormalInverseGammaMultivariateGaussian.birch"
  LIBBIRCH_MEMBERS(_u09632, _u0956, x, _u0956_0, A, _u0945, _u0946)
};

#line 1 "src/test/model/TestMultivariateNormalInverseGammaMultivariateGaussian.birch"
extern "C" birch::type::TestMultivariateNormalInverseGammaMultivariateGaussian* make_TestMultivariateNormalInverseGammaMultivariateGaussian_();

#line 1 "src/test/model/TestNormalInverseGamma.birch"
class TestNormalInverseGamma : public Model {
public:
  #line 1 "src/test/model/TestNormalInverseGamma.birch"
  using class_type_ = TestNormalInverseGamma;
  #line 1 "src/test/model/TestNormalInverseGamma.birch"
  using this_type_ = class_type_;
  #line 1 "src/test/model/TestNormalInverseGamma.birch"
  using super_type_ = Model;

  #line 1 "src/test/model/TestNormalInverseGamma.birch"
  using super_type_::operator=;
  #line 1 "src/test/model/TestNormalInverseGamma.birch"
  using super_type_::simulate;
  
  #line 1 "src/test/model/TestNormalInverseGamma.birch"
  TestNormalInverseGamma(const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);

  libbirch::Lazy<libbirch::Shared<birch::type::Random<birch::type::Real>>> _u09632;
  libbirch::Lazy<libbirch::Shared<birch::type::Random<birch::type::Real>>> x;
  birch::type::Real _u0956;
  birch::type::Real a2;
  birch::type::Real _u0945;
  birch::type::Real _u0946;
  #line 10 "src/test/model/TestNormalInverseGamma.birch"
  virtual void initialize(const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
  #line 17 "src/test/model/TestNormalInverseGamma.birch"
  virtual void simulate(const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
  #line 22 "src/test/model/TestNormalInverseGamma.birch"
  virtual libbirch::DefaultArray<birch::type::Real,1> forward(const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
  #line 31 "src/test/model/TestNormalInverseGamma.birch"
  virtual libbirch::DefaultArray<birch::type::Real,1> backward(const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
  #line 40 "src/test/model/TestNormalInverseGamma.birch"
  virtual libbirch::DefaultArray<birch::type::Real,1> forwardLazy(const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
  #line 49 "src/test/model/TestNormalInverseGamma.birch"
  virtual libbirch::DefaultArray<birch::type::Real,1> backwardLazy(const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
  #line 58 "src/test/model/TestNormalInverseGamma.birch"
  virtual libbirch::Lazy<libbirch::Shared<birch::type::Distribution<birch::type::Real>>> marginal(const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
  
  #line 1 "src/test/model/TestNormalInverseGamma.birch"
  LIBBIRCH_CLASS(TestNormalInverseGamma, Model)
  #line 1 "src/test/model/TestNormalInverseGamma.birch"
  LIBBIRCH_MEMBERS(_u09632, x, _u0956, a2, _u0945, _u0946)
};

#line 1 "src/test/model/TestNormalInverseGamma.birch"
extern "C" birch::type::TestNormalInverseGamma* make_TestNormalInverseGamma_();

#line 1 "src/test/model/TestNormalInverseGammaGaussian.birch"
class TestNormalInverseGammaGaussian : public Model {
public:
  #line 1 "src/test/model/TestNormalInverseGammaGaussian.birch"
  using class_type_ = TestNormalInverseGammaGaussian;
  #line 1 "src/test/model/TestNormalInverseGammaGaussian.birch"
  using this_type_ = class_type_;
  #line 1 "src/test/model/TestNormalInverseGammaGaussian.birch"
  using super_type_ = Model;

  #line 1 "src/test/model/TestNormalInverseGammaGaussian.birch"
  using super_type_::operator=;
  #line 1 "src/test/model/TestNormalInverseGammaGaussian.birch"
  using super_type_::simulate;
  
  #line 1 "src/test/model/TestNormalInverseGammaGaussian.birch"
  TestNormalInverseGammaGaussian(const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);

  libbirch::Lazy<libbirch::Shared<birch::type::Random<birch::type::Real>>> _u09632;
  libbirch::Lazy<libbirch::Shared<birch::type::Random<birch::type::Real>>> _u0956;
  libbirch::Lazy<libbirch::Shared<birch::type::Random<birch::type::Real>>> x;
  birch::type::Real _u0956_0;
  birch::type::Real a2;
  birch::type::Real _u0945;
  birch::type::Real _u0946;
  #line 11 "src/test/model/TestNormalInverseGammaGaussian.birch"
  virtual void initialize(const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
  #line 18 "src/test/model/TestNormalInverseGammaGaussian.birch"
  virtual void simulate(const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
  #line 24 "src/test/model/TestNormalInverseGammaGaussian.birch"
  virtual libbirch::DefaultArray<birch::type::Real,1> forward(const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
  #line 34 "src/test/model/TestNormalInverseGammaGaussian.birch"
  virtual libbirch::DefaultArray<birch::type::Real,1> backward(const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
  #line 44 "src/test/model/TestNormalInverseGammaGaussian.birch"
  virtual libbirch::DefaultArray<birch::type::Real,1> forwardLazy(const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
  #line 54 "src/test/model/TestNormalInverseGammaGaussian.birch"
  virtual libbirch::DefaultArray<birch::type::Real,1> backwardLazy(const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
  #line 64 "src/test/model/TestNormalInverseGammaGaussian.birch"
  virtual libbirch::Lazy<libbirch::Shared<birch::type::Distribution<birch::type::Real>>> marginal(const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
  
  #line 1 "src/test/model/TestNormalInverseGammaGaussian.birch"
  LIBBIRCH_CLASS(TestNormalInverseGammaGaussian, Model)
  #line 1 "src/test/model/TestNormalInverseGammaGaussian.birch"
  LIBBIRCH_MEMBERS(_u09632, _u0956, x, _u0956_0, a2, _u0945, _u0946)
};

#line 1 "src/test/model/TestNormalInverseGammaGaussian.birch"
extern "C" birch::type::TestNormalInverseGammaGaussian* make_TestNormalInverseGammaGaussian_();

#line 1 "src/test/model/TestScaledGammaExponential.birch"
class TestScaledGammaExponential : public Model {
public:
  #line 1 "src/test/model/TestScaledGammaExponential.birch"
  using class_type_ = TestScaledGammaExponential;
  #line 1 "src/test/model/TestScaledGammaExponential.birch"
  using this_type_ = class_type_;
  #line 1 "src/test/model/TestScaledGammaExponential.birch"
  using super_type_ = Model;

  #line 1 "src/test/model/TestScaledGammaExponential.birch"
  using super_type_::operator=;
  #line 1 "src/test/model/TestScaledGammaExponential.birch"
  using super_type_::simulate;
  
  #line 1 "src/test/model/TestScaledGammaExponential.birch"
  TestScaledGammaExponential(const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);

  libbirch::Lazy<libbirch::Shared<birch::type::Random<birch::type::Real>>> _u0955;
  libbirch::Lazy<libbirch::Shared<birch::type::Random<birch::type::Real>>> x;
  birch::type::Real a;
  birch::type::Real k;
  birch::type::Real _u0952;
  birch::type::Boolean neg;
  #line 10 "src/test/model/TestScaledGammaExponential.birch"
  virtual void initialize(const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
  #line 17 "src/test/model/TestScaledGammaExponential.birch"
  virtual void simulate(const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
  #line 26 "src/test/model/TestScaledGammaExponential.birch"
  virtual libbirch::DefaultArray<birch::type::Real,1> forward(const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
  #line 34 "src/test/model/TestScaledGammaExponential.birch"
  virtual libbirch::DefaultArray<birch::type::Real,1> backward(const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
  #line 42 "src/test/model/TestScaledGammaExponential.birch"
  virtual libbirch::DefaultArray<birch::type::Real,1> forwardLazy(const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
  #line 50 "src/test/model/TestScaledGammaExponential.birch"
  virtual libbirch::DefaultArray<birch::type::Real,1> backwardLazy(const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
  #line 58 "src/test/model/TestScaledGammaExponential.birch"
  virtual libbirch::Lazy<libbirch::Shared<birch::type::Distribution<birch::type::Real>>> marginal(const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
  
  #line 1 "src/test/model/TestScaledGammaExponential.birch"
  LIBBIRCH_CLASS(TestScaledGammaExponential, Model)
  #line 1 "src/test/model/TestScaledGammaExponential.birch"
  LIBBIRCH_MEMBERS(_u0955, x, a, k, _u0952, neg)
};

#line 1 "src/test/model/TestScaledGammaExponential.birch"
extern "C" birch::type::TestScaledGammaExponential* make_TestScaledGammaExponential_();

#line 1 "src/test/model/TestScaledGammaPoisson.birch"
class TestScaledGammaPoisson : public Model {
public:
  #line 1 "src/test/model/TestScaledGammaPoisson.birch"
  using class_type_ = TestScaledGammaPoisson;
  #line 1 "src/test/model/TestScaledGammaPoisson.birch"
  using this_type_ = class_type_;
  #line 1 "src/test/model/TestScaledGammaPoisson.birch"
  using super_type_ = Model;

  #line 1 "src/test/model/TestScaledGammaPoisson.birch"
  using super_type_::operator=;
  #line 1 "src/test/model/TestScaledGammaPoisson.birch"
  using super_type_::simulate;
  
  #line 1 "src/test/model/TestScaledGammaPoisson.birch"
  TestScaledGammaPoisson(const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);

  libbirch::Lazy<libbirch::Shared<birch::type::Random<birch::type::Real>>> _u0955;
  libbirch::Lazy<libbirch::Shared<birch::type::Random<birch::type::Integer>>> x;
  birch::type::Real a;
  birch::type::Real k;
  birch::type::Real _u0952;
  birch::type::Boolean neg;
  #line 10 "src/test/model/TestScaledGammaPoisson.birch"
  virtual void initialize(const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
  #line 17 "src/test/model/TestScaledGammaPoisson.birch"
  virtual void simulate(const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
  #line 26 "src/test/model/TestScaledGammaPoisson.birch"
  virtual libbirch::DefaultArray<birch::type::Real,1> forward(const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
  #line 34 "src/test/model/TestScaledGammaPoisson.birch"
  virtual libbirch::DefaultArray<birch::type::Real,1> backward(const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
  #line 42 "src/test/model/TestScaledGammaPoisson.birch"
  virtual libbirch::DefaultArray<birch::type::Real,1> forwardLazy(const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
  #line 50 "src/test/model/TestScaledGammaPoisson.birch"
  virtual libbirch::DefaultArray<birch::type::Real,1> backwardLazy(const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
  #line 58 "src/test/model/TestScaledGammaPoisson.birch"
  virtual libbirch::Lazy<libbirch::Shared<birch::type::Distribution<birch::type::Integer>>> marginal(const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
  
  #line 1 "src/test/model/TestScaledGammaPoisson.birch"
  LIBBIRCH_CLASS(TestScaledGammaPoisson, Model)
  #line 1 "src/test/model/TestScaledGammaPoisson.birch"
  LIBBIRCH_MEMBERS(_u0955, x, a, k, _u0952, neg)
};

#line 1 "src/test/model/TestScaledGammaPoisson.birch"
extern "C" birch::type::TestScaledGammaPoisson* make_TestScaledGammaPoisson_();

#line 1 "src/test/model/TestSubtractBoundedDiscreteDelta.birch"
class TestSubtractBoundedDiscreteDelta : public Model {
public:
  #line 1 "src/test/model/TestSubtractBoundedDiscreteDelta.birch"
  using class_type_ = TestSubtractBoundedDiscreteDelta;
  #line 1 "src/test/model/TestSubtractBoundedDiscreteDelta.birch"
  using this_type_ = class_type_;
  #line 1 "src/test/model/TestSubtractBoundedDiscreteDelta.birch"
  using super_type_ = Model;

  #line 1 "src/test/model/TestSubtractBoundedDiscreteDelta.birch"
  using super_type_::operator=;
  #line 1 "src/test/model/TestSubtractBoundedDiscreteDelta.birch"
  using super_type_::simulate;
  
  #line 1 "src/test/model/TestSubtractBoundedDiscreteDelta.birch"
  TestSubtractBoundedDiscreteDelta(const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);

  libbirch::Lazy<libbirch::Shared<birch::type::Random<birch::type::Integer>>> x1;
  libbirch::Lazy<libbirch::Shared<birch::type::Random<birch::type::Integer>>> x2;
  libbirch::Lazy<libbirch::Shared<birch::type::Random<birch::type::Integer>>> s;
  #line 6 "src/test/model/TestSubtractBoundedDiscreteDelta.birch"
  virtual void initialize(const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
  #line 10 "src/test/model/TestSubtractBoundedDiscreteDelta.birch"
  virtual void simulate(const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
  #line 16 "src/test/model/TestSubtractBoundedDiscreteDelta.birch"
  virtual libbirch::DefaultArray<birch::type::Real,1> forward(const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
  #line 25 "src/test/model/TestSubtractBoundedDiscreteDelta.birch"
  virtual libbirch::DefaultArray<birch::type::Real,1> backward(const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
  #line 33 "src/test/model/TestSubtractBoundedDiscreteDelta.birch"
  virtual libbirch::DefaultArray<birch::type::Real,1> forwardLazy(const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
  #line 42 "src/test/model/TestSubtractBoundedDiscreteDelta.birch"
  virtual libbirch::DefaultArray<birch::type::Real,1> backwardLazy(const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
  
  #line 1 "src/test/model/TestSubtractBoundedDiscreteDelta.birch"
  LIBBIRCH_CLASS(TestSubtractBoundedDiscreteDelta, Model)
  #line 1 "src/test/model/TestSubtractBoundedDiscreteDelta.birch"
  LIBBIRCH_MEMBERS(x1, x2, s)
};

#line 1 "src/test/model/TestSubtractBoundedDiscreteDelta.birch"
extern "C" birch::type::TestSubtractBoundedDiscreteDelta* make_TestSubtractBoundedDiscreteDelta_();

#line 1 "src/particle/Particle.birch"
class Particle : public Object {
public:
  #line 1 "src/particle/Particle.birch"
  using class_type_ = Particle;
  #line 1 "src/particle/Particle.birch"
  using this_type_ = class_type_;
  #line 1 "src/particle/Particle.birch"
  using super_type_ = Object;

  #line 1 "src/particle/Particle.birch"
  using super_type_::operator=;
  
  #line 1 "src/particle/Particle.birch"
  Particle(const libbirch::Lazy<libbirch::Shared<birch::type::Model>>& m, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);

  libbirch::Lazy<libbirch::Shared<birch::type::Model>> m;
  #line 21 "src/particle/Particle.birch"
  virtual void write(const libbirch::Lazy<libbirch::Shared<birch::type::Buffer>>& buffer, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr) override;
  
  #line 1 "src/particle/Particle.birch"
  LIBBIRCH_CLASS(Particle, Object)
  #line 1 "src/particle/Particle.birch"
  LIBBIRCH_MEMBERS(m)
};

#line 1 "src/particle/MoveParticle.birch"
class MoveParticle : public Particle {
public:
  #line 1 "src/particle/MoveParticle.birch"
  using class_type_ = MoveParticle;
  #line 1 "src/particle/MoveParticle.birch"
  using this_type_ = class_type_;
  #line 1 "src/particle/MoveParticle.birch"
  using super_type_ = Particle;

  #line 1 "src/particle/MoveParticle.birch"
  using super_type_::operator=;
  
  #line 1 "src/particle/MoveParticle.birch"
  MoveParticle(const libbirch::Lazy<libbirch::Shared<birch::type::Model>>& m, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);

  libbirch::Lazy<libbirch::Shared<birch::type::Array<libbirch::Lazy<libbirch::Shared<birch::type::Expression<birch::type::Real>>>>>> zs;
  libbirch::Lazy<libbirch::Shared<birch::type::Array<libbirch::Lazy<libbirch::Shared<birch::type::Expression<birch::type::Real>>>>>> ps;
  birch::type::Real _u0960;
  #line 36 "src/particle/MoveParticle.birch"
  virtual birch::type::Integer size(const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
  #line 48 "src/particle/MoveParticle.birch"
  virtual birch::type::Real augment(const birch::type::Integer& t, const libbirch::Optional<libbirch::Lazy<libbirch::Shared<birch::type::Expression<birch::type::Real>>>>& z, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
  #line 72 "src/particle/MoveParticle.birch"
  virtual void truncate(const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
  #line 89 "src/particle/MoveParticle.birch"
  virtual void grad(const birch::type::Integer& gen, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
  #line 103 "src/particle/MoveParticle.birch"
  virtual void move(const birch::type::Integer& gen, const libbirch::Lazy<libbirch::Shared<birch::type::Kernel>>& _u0954, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
  #line 122 "src/particle/MoveParticle.birch"
  virtual birch::type::Real compare(const birch::type::Integer& gen, const libbirch::Lazy<libbirch::Shared<birch::type::MoveParticle>>& x, const libbirch::Lazy<libbirch::Shared<birch::type::Kernel>>& _u0954, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
  
  #line 1 "src/particle/MoveParticle.birch"
  LIBBIRCH_CLASS(MoveParticle, Particle)
  #line 1 "src/particle/MoveParticle.birch"
  LIBBIRCH_MEMBERS(zs, ps, _u0960)
};

#line 1 "src/particle/ConditionalParticle.birch"
class ConditionalParticle : public Particle {
public:
  #line 1 "src/particle/ConditionalParticle.birch"
  using class_type_ = ConditionalParticle;
  #line 1 "src/particle/ConditionalParticle.birch"
  using this_type_ = class_type_;
  #line 1 "src/particle/ConditionalParticle.birch"
  using super_type_ = Particle;

  #line 1 "src/particle/ConditionalParticle.birch"
  using super_type_::operator=;
  
  #line 1 "src/particle/ConditionalParticle.birch"
  ConditionalParticle(const libbirch::Lazy<libbirch::Shared<birch::type::Model>>& m, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);

  libbirch::Lazy<libbirch::Shared<birch::type::Tape<libbirch::Lazy<libbirch::Shared<birch::type::Record>>>>> trace;
  
  #line 1 "src/particle/ConditionalParticle.birch"
  LIBBIRCH_CLASS(ConditionalParticle, Particle)
  #line 1 "src/particle/ConditionalParticle.birch"
  LIBBIRCH_MEMBERS(trace)
};

#line 9 "src/record/Record.birch"
class Record : public Object {
public:
  #line 9 "src/record/Record.birch"
  using class_type_ = Record;
  #line 9 "src/record/Record.birch"
  using this_type_ = class_type_;
  #line 9 "src/record/Record.birch"
  using super_type_ = Object;

  #line 9 "src/record/Record.birch"
  using super_type_::operator=;
  
  #line 9 "src/record/Record.birch"
  Record(const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);

  #line 17 "src/record/Record.birch"
  virtual birch::type::Real ratio(const libbirch::Lazy<libbirch::Shared<birch::type::Record>>& record, const birch::type::Real& scale, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
  
  #line 9 "src/record/Record.birch"
  LIBBIRCH_ABSTRACT_CLASS(Record, Object)
  #line 9 "src/record/Record.birch"
  LIBBIRCH_MEMBERS()
};

template<class Value>
#line 6 "src/record/ObserveRecord.birch"
class ObserveRecord final : public Record {
public:
  #line 6 "src/record/ObserveRecord.birch"
  using class_type_ = ObserveRecord<Value>;
  #line 6 "src/record/ObserveRecord.birch"
  using this_type_ = class_type_;
  #line 6 "src/record/ObserveRecord.birch"
  using super_type_ = Record;

  #line 6 "src/record/ObserveRecord.birch"
  using super_type_::operator=;
  
  #line 6 "src/record/ObserveRecord.birch"
  ObserveRecord(const Value& x, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);

  Value x;
  
  #line 6 "src/record/ObserveRecord.birch"
  LIBBIRCH_CLASS(ObserveRecord, Record)
  #line 6 "src/record/ObserveRecord.birch"
  LIBBIRCH_MEMBERS(x)
};

#line 4 "src/record/FactorRecord.birch"
class FactorRecord final : public Record {
public:
  #line 4 "src/record/FactorRecord.birch"
  using class_type_ = FactorRecord;
  #line 4 "src/record/FactorRecord.birch"
  using this_type_ = class_type_;
  #line 4 "src/record/FactorRecord.birch"
  using super_type_ = Record;

  #line 4 "src/record/FactorRecord.birch"
  using super_type_::operator=;
  
  #line 4 "src/record/FactorRecord.birch"
  FactorRecord(const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);

  
  #line 4 "src/record/FactorRecord.birch"
  LIBBIRCH_CLASS(FactorRecord, Record)
  #line 4 "src/record/FactorRecord.birch"
  LIBBIRCH_MEMBERS()
};

#line 4 "src/record/FactorRecord.birch"
extern "C" birch::type::FactorRecord* make_FactorRecord_();

template<class Value>
#line 6 "src/record/AssumeRecord.birch"
class AssumeRecord final : public Record {
public:
  #line 6 "src/record/AssumeRecord.birch"
  using class_type_ = AssumeRecord<Value>;
  #line 6 "src/record/AssumeRecord.birch"
  using this_type_ = class_type_;
  #line 6 "src/record/AssumeRecord.birch"
  using super_type_ = Record;

  #line 6 "src/record/AssumeRecord.birch"
  using super_type_::operator=;
  
  #line 6 "src/record/AssumeRecord.birch"
  AssumeRecord(const libbirch::Lazy<libbirch::Shared<birch::type::Random<Value>>>& x, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);

  libbirch::Lazy<libbirch::Shared<birch::type::Random<Value>>> x;
  
  #line 6 "src/record/AssumeRecord.birch"
  LIBBIRCH_CLASS(AssumeRecord, Record)
  #line 6 "src/record/AssumeRecord.birch"
  LIBBIRCH_MEMBERS(x)
};

template<class Value>
#line 6 "src/record/SimulateRecord.birch"
class SimulateRecord final : public Record {
public:
  #line 6 "src/record/SimulateRecord.birch"
  using class_type_ = SimulateRecord<Value>;
  #line 6 "src/record/SimulateRecord.birch"
  using this_type_ = class_type_;
  #line 6 "src/record/SimulateRecord.birch"
  using super_type_ = Record;

  #line 6 "src/record/SimulateRecord.birch"
  using super_type_::operator=;
  
  #line 6 "src/record/SimulateRecord.birch"
  SimulateRecord(const Value& x, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);

  Value x;
  
  #line 6 "src/record/SimulateRecord.birch"
  LIBBIRCH_CLASS(SimulateRecord, Record)
  #line 6 "src/record/SimulateRecord.birch"
  LIBBIRCH_MEMBERS(x)
};

#line 17 "src/sampler/ParticleSampler.birch"
class ParticleSampler : public Object {
public:
  #line 17 "src/sampler/ParticleSampler.birch"
  using class_type_ = ParticleSampler;
  #line 17 "src/sampler/ParticleSampler.birch"
  using this_type_ = class_type_;
  #line 17 "src/sampler/ParticleSampler.birch"
  using super_type_ = Object;

  #line 17 "src/sampler/ParticleSampler.birch"
  using super_type_::operator=;
  
  #line 17 "src/sampler/ParticleSampler.birch"
  ParticleSampler(const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);

  libbirch::Optional<libbirch::Lazy<libbirch::Shared<birch::type::Model>>> x;
  birch::type::Real w;
  libbirch::Lazy<libbirch::Shared<birch::type::Array<birch::type::Real>>> lnormalize;
  libbirch::Lazy<libbirch::Shared<birch::type::Array<birch::type::Real>>> ess;
  libbirch::Lazy<libbirch::Shared<birch::type::Array<birch::type::Real>>> npropagations;
  libbirch::Lazy<libbirch::Shared<birch::type::Array<birch::type::Real>>> raccepts;
  birch::type::Integer nsamples;
  #line 57 "src/sampler/ParticleSampler.birch"
  virtual birch::type::Integer size(const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
  #line 69 "src/sampler/ParticleSampler.birch"
  virtual void sample(const libbirch::Lazy<libbirch::Shared<birch::type::ParticleFilter>>& filter, const libbirch::Lazy<libbirch::Shared<birch::type::Model>>& archetype, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
  #line 82 "src/sampler/ParticleSampler.birch"
  virtual void sample(const libbirch::Lazy<libbirch::Shared<birch::type::ParticleFilter>>& filter, const libbirch::Lazy<libbirch::Shared<birch::type::Model>>& archetype, const birch::type::Integer& n, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr) = 0;
  #line 88 "src/sampler/ParticleSampler.birch"
  virtual void clearDiagnostics(const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
  #line 98 "src/sampler/ParticleSampler.birch"
  virtual void pushDiagnostics(const libbirch::Lazy<libbirch::Shared<birch::type::ParticleFilter>>& filter, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
  #line 108 "src/sampler/ParticleSampler.birch"
  virtual void write(const libbirch::Lazy<libbirch::Shared<birch::type::Buffer>>& buffer, const birch::type::Integer& n, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
  #line 117 "src/sampler/ParticleSampler.birch"
  virtual void read(const libbirch::Lazy<libbirch::Shared<birch::type::Buffer>>& buffer, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
  #line 122 "src/sampler/ParticleSampler.birch"
  virtual void write(const libbirch::Lazy<libbirch::Shared<birch::type::Buffer>>& buffer, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
  
  #line 17 "src/sampler/ParticleSampler.birch"
  LIBBIRCH_ABSTRACT_CLASS(ParticleSampler, Object)
  #line 17 "src/sampler/ParticleSampler.birch"
  LIBBIRCH_MEMBERS(x, w, lnormalize, ess, npropagations, raccepts, nsamples)
};

#line 1 "src/sampler/MarginalizedParticleImportanceSampler.birch"
class MarginalizedParticleImportanceSampler : public ParticleSampler {
public:
  #line 1 "src/sampler/MarginalizedParticleImportanceSampler.birch"
  using class_type_ = MarginalizedParticleImportanceSampler;
  #line 1 "src/sampler/MarginalizedParticleImportanceSampler.birch"
  using this_type_ = class_type_;
  #line 1 "src/sampler/MarginalizedParticleImportanceSampler.birch"
  using super_type_ = ParticleSampler;

  #line 1 "src/sampler/MarginalizedParticleImportanceSampler.birch"
  using super_type_::operator=;
  #line 1 "src/sampler/MarginalizedParticleImportanceSampler.birch"
  using super_type_::sample;
  
  #line 1 "src/sampler/MarginalizedParticleImportanceSampler.birch"
  MarginalizedParticleImportanceSampler(const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);

  #line 18 "src/sampler/MarginalizedParticleImportanceSampler.birch"
  virtual void sample(const libbirch::Lazy<libbirch::Shared<birch::type::ParticleFilter>>& filter, const libbirch::Lazy<libbirch::Shared<birch::type::Model>>& archetype, const birch::type::Integer& n, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr) override;
  
  #line 1 "src/sampler/MarginalizedParticleImportanceSampler.birch"
  LIBBIRCH_CLASS(MarginalizedParticleImportanceSampler, ParticleSampler)
  #line 1 "src/sampler/MarginalizedParticleImportanceSampler.birch"
  LIBBIRCH_MEMBERS()
};

#line 1 "src/sampler/MarginalizedParticleImportanceSampler.birch"
extern "C" birch::type::MarginalizedParticleImportanceSampler* make_MarginalizedParticleImportanceSampler_();

#line 17 "src/sampler/ConditionalParticleSampler.birch"
class ConditionalParticleSampler : public ParticleSampler {
public:
  #line 17 "src/sampler/ConditionalParticleSampler.birch"
  using class_type_ = ConditionalParticleSampler;
  #line 17 "src/sampler/ConditionalParticleSampler.birch"
  using this_type_ = class_type_;
  #line 17 "src/sampler/ConditionalParticleSampler.birch"
  using super_type_ = ParticleSampler;

  #line 17 "src/sampler/ConditionalParticleSampler.birch"
  using super_type_::operator=;
  #line 17 "src/sampler/ConditionalParticleSampler.birch"
  using super_type_::sample;
  
  #line 17 "src/sampler/ConditionalParticleSampler.birch"
  ConditionalParticleSampler(const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);

  #line 18 "src/sampler/ConditionalParticleSampler.birch"
  virtual void sample(const libbirch::Lazy<libbirch::Shared<birch::type::ParticleFilter>>& filter, const libbirch::Lazy<libbirch::Shared<birch::type::Model>>& archetype, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr) final;
  #line 27 "src/sampler/ConditionalParticleSampler.birch"
  virtual void sample(const libbirch::Lazy<libbirch::Shared<birch::type::ParticleFilter>>& filter, const libbirch::Lazy<libbirch::Shared<birch::type::Model>>& archetype, const birch::type::Integer& t, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr) final;
  #line 40 "src/sampler/ConditionalParticleSampler.birch"
  virtual void sample(const libbirch::Lazy<libbirch::Shared<birch::type::ConditionalParticleFilter>>& filter, const libbirch::Lazy<libbirch::Shared<birch::type::Model>>& archetype, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr) = 0;
  #line 46 "src/sampler/ConditionalParticleSampler.birch"
  virtual void sample(const libbirch::Lazy<libbirch::Shared<birch::type::ConditionalParticleFilter>>& filter, const libbirch::Lazy<libbirch::Shared<birch::type::Model>>& archetype, const birch::type::Integer& t, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr) = 0;
  
  #line 17 "src/sampler/ConditionalParticleSampler.birch"
  LIBBIRCH_ABSTRACT_CLASS(ConditionalParticleSampler, ParticleSampler)
  #line 17 "src/sampler/ConditionalParticleSampler.birch"
  LIBBIRCH_MEMBERS()
};

#line 1 "src/sampler/MarginalizedParticleGibbsSampler.birch"
class MarginalizedParticleGibbsSampler : public ConditionalParticleSampler {
public:
  #line 1 "src/sampler/MarginalizedParticleGibbsSampler.birch"
  using class_type_ = MarginalizedParticleGibbsSampler;
  #line 1 "src/sampler/MarginalizedParticleGibbsSampler.birch"
  using this_type_ = class_type_;
  #line 1 "src/sampler/MarginalizedParticleGibbsSampler.birch"
  using super_type_ = ConditionalParticleSampler;

  #line 1 "src/sampler/MarginalizedParticleGibbsSampler.birch"
  using super_type_::operator=;
  #line 1 "src/sampler/MarginalizedParticleGibbsSampler.birch"
  using super_type_::sample;
  
  #line 1 "src/sampler/MarginalizedParticleGibbsSampler.birch"
  MarginalizedParticleGibbsSampler(const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);

  #line 18 "src/sampler/MarginalizedParticleGibbsSampler.birch"
  virtual void sample(const libbirch::Lazy<libbirch::Shared<birch::type::ConditionalParticleFilter>>& filter, const libbirch::Lazy<libbirch::Shared<birch::type::Model>>& archetype, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr) override;
  #line 23 "src/sampler/MarginalizedParticleGibbsSampler.birch"
  virtual void sample(const libbirch::Lazy<libbirch::Shared<birch::type::ConditionalParticleFilter>>& filter, const libbirch::Lazy<libbirch::Shared<birch::type::Model>>& archetype, const birch::type::Integer& n, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr) override;
  
  #line 1 "src/sampler/MarginalizedParticleGibbsSampler.birch"
  LIBBIRCH_CLASS(MarginalizedParticleGibbsSampler, ConditionalParticleSampler)
  #line 1 "src/sampler/MarginalizedParticleGibbsSampler.birch"
  LIBBIRCH_MEMBERS()
};

#line 1 "src/sampler/MarginalizedParticleGibbsSampler.birch"
extern "C" birch::type::MarginalizedParticleGibbsSampler* make_MarginalizedParticleGibbsSampler_();

#line 1 "src/sampler/ParticleGibbsSampler.birch"
class ParticleGibbsSampler : public ConditionalParticleSampler {
public:
  #line 1 "src/sampler/ParticleGibbsSampler.birch"
  using class_type_ = ParticleGibbsSampler;
  #line 1 "src/sampler/ParticleGibbsSampler.birch"
  using this_type_ = class_type_;
  #line 1 "src/sampler/ParticleGibbsSampler.birch"
  using super_type_ = ConditionalParticleSampler;

  #line 1 "src/sampler/ParticleGibbsSampler.birch"
  using super_type_::operator=;
  #line 1 "src/sampler/ParticleGibbsSampler.birch"
  using super_type_::sample;
  
  #line 1 "src/sampler/ParticleGibbsSampler.birch"
  ParticleGibbsSampler(const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);

  #line 18 "src/sampler/ParticleGibbsSampler.birch"
  virtual void sample(const libbirch::Lazy<libbirch::Shared<birch::type::ConditionalParticleFilter>>& filter, const libbirch::Lazy<libbirch::Shared<birch::type::Model>>& archetype, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr) override;
  #line 23 "src/sampler/ParticleGibbsSampler.birch"
  virtual void sample(const libbirch::Lazy<libbirch::Shared<birch::type::ConditionalParticleFilter>>& filter, const libbirch::Lazy<libbirch::Shared<birch::type::Model>>& archetype, const birch::type::Integer& n, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr) override;
  
  #line 1 "src/sampler/ParticleGibbsSampler.birch"
  LIBBIRCH_CLASS(ParticleGibbsSampler, ConditionalParticleSampler)
  #line 1 "src/sampler/ParticleGibbsSampler.birch"
  LIBBIRCH_MEMBERS()
};

#line 1 "src/sampler/ParticleGibbsSampler.birch"
extern "C" birch::type::ParticleGibbsSampler* make_ParticleGibbsSampler_();

template<class Value>
#line 1 "src/transform/TransformDot.birch"
class TransformDot : public Object {
public:
  #line 1 "src/transform/TransformDot.birch"
  using class_type_ = TransformDot<Value>;
  #line 1 "src/transform/TransformDot.birch"
  using this_type_ = class_type_;
  #line 1 "src/transform/TransformDot.birch"
  using super_type_ = Object;

  #line 1 "src/transform/TransformDot.birch"
  using super_type_::operator=;
  
  #line 1 "src/transform/TransformDot.birch"
  TransformDot(const libbirch::Lazy<libbirch::Shared<birch::type::Expression<libbirch::DefaultArray<birch::type::Real,1>>>>& a, const Value& x, const libbirch::Lazy<libbirch::Shared<birch::type::Expression<birch::type::Real>>>& c, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);

  libbirch::Lazy<libbirch::Shared<birch::type::Expression<libbirch::DefaultArray<birch::type::Real,1>>>> a;
  Value x;
  libbirch::Lazy<libbirch::Shared<birch::type::Expression<birch::type::Real>>> c;
  #line 24 "src/transform/TransformDot.birch"
  virtual void multiply(const libbirch::Lazy<libbirch::Shared<birch::type::Expression<birch::type::Real>>>& y, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
  #line 29 "src/transform/TransformDot.birch"
  virtual void divide(const libbirch::Lazy<libbirch::Shared<birch::type::Expression<birch::type::Real>>>& y, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
  #line 34 "src/transform/TransformDot.birch"
  virtual void add(const libbirch::Lazy<libbirch::Shared<birch::type::Expression<birch::type::Real>>>& y, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
  #line 38 "src/transform/TransformDot.birch"
  virtual void subtract(const libbirch::Lazy<libbirch::Shared<birch::type::Expression<birch::type::Real>>>& y, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
  #line 42 "src/transform/TransformDot.birch"
  virtual void negate(const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
  #line 47 "src/transform/TransformDot.birch"
  virtual void negateAndAdd(const libbirch::Lazy<libbirch::Shared<birch::type::Expression<birch::type::Real>>>& y, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
  
  #line 1 "src/transform/TransformDot.birch"
  LIBBIRCH_CLASS(TransformDot, Object)
  #line 1 "src/transform/TransformDot.birch"
  LIBBIRCH_MEMBERS(a, x, c)
};

template<class Value>
#line 1 "src/transform/TransformDotMultivariate.birch"
class TransformDotMultivariate : public Object {
public:
  #line 1 "src/transform/TransformDotMultivariate.birch"
  using class_type_ = TransformDotMultivariate<Value>;
  #line 1 "src/transform/TransformDotMultivariate.birch"
  using this_type_ = class_type_;
  #line 1 "src/transform/TransformDotMultivariate.birch"
  using super_type_ = Object;

  #line 1 "src/transform/TransformDotMultivariate.birch"
  using super_type_::operator=;
  
  #line 1 "src/transform/TransformDotMultivariate.birch"
  TransformDotMultivariate(const libbirch::Lazy<libbirch::Shared<birch::type::Expression<libbirch::DefaultArray<birch::type::Real,1>>>>& a, const Value& X, const libbirch::Lazy<libbirch::Shared<birch::type::Expression<libbirch::DefaultArray<birch::type::Real,1>>>>& c, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);

  libbirch::Lazy<libbirch::Shared<birch::type::Expression<libbirch::DefaultArray<birch::type::Real,1>>>> a;
  Value X;
  libbirch::Lazy<libbirch::Shared<birch::type::Expression<libbirch::DefaultArray<birch::type::Real,1>>>> c;
  #line 24 "src/transform/TransformDotMultivariate.birch"
  virtual void multiply(const libbirch::Lazy<libbirch::Shared<birch::type::Expression<birch::type::Real>>>& y, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
  #line 29 "src/transform/TransformDotMultivariate.birch"
  virtual void divide(const libbirch::Lazy<libbirch::Shared<birch::type::Expression<birch::type::Real>>>& y, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
  #line 34 "src/transform/TransformDotMultivariate.birch"
  virtual void add(const libbirch::Lazy<libbirch::Shared<birch::type::Expression<libbirch::DefaultArray<birch::type::Real,1>>>>& y, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
  #line 38 "src/transform/TransformDotMultivariate.birch"
  virtual void subtract(const libbirch::Lazy<libbirch::Shared<birch::type::Expression<libbirch::DefaultArray<birch::type::Real,1>>>>& y, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
  #line 42 "src/transform/TransformDotMultivariate.birch"
  virtual void negate(const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
  #line 47 "src/transform/TransformDotMultivariate.birch"
  virtual void negateAndAdd(const libbirch::Lazy<libbirch::Shared<birch::type::Expression<libbirch::DefaultArray<birch::type::Real,1>>>>& y, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
  
  #line 1 "src/transform/TransformDotMultivariate.birch"
  LIBBIRCH_CLASS(TransformDotMultivariate, Object)
  #line 1 "src/transform/TransformDotMultivariate.birch"
  LIBBIRCH_MEMBERS(a, X, c)
};

template<class Value>
#line 1 "src/transform/TransformLinear.birch"
class TransformLinear : public Object {
public:
  #line 1 "src/transform/TransformLinear.birch"
  using class_type_ = TransformLinear<Value>;
  #line 1 "src/transform/TransformLinear.birch"
  using this_type_ = class_type_;
  #line 1 "src/transform/TransformLinear.birch"
  using super_type_ = Object;

  #line 1 "src/transform/TransformLinear.birch"
  using super_type_::operator=;
  
  #line 1 "src/transform/TransformLinear.birch"
  TransformLinear(const libbirch::Lazy<libbirch::Shared<birch::type::Expression<birch::type::Real>>>& a, const Value& x, const libbirch::Lazy<libbirch::Shared<birch::type::Expression<birch::type::Real>>>& c, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);

  libbirch::Lazy<libbirch::Shared<birch::type::Expression<birch::type::Real>>> a;
  Value x;
  libbirch::Lazy<libbirch::Shared<birch::type::Expression<birch::type::Real>>> c;
  #line 24 "src/transform/TransformLinear.birch"
  virtual void multiply(const libbirch::Lazy<libbirch::Shared<birch::type::Expression<birch::type::Real>>>& y, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
  #line 29 "src/transform/TransformLinear.birch"
  virtual void divide(const libbirch::Lazy<libbirch::Shared<birch::type::Expression<birch::type::Real>>>& y, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
  #line 34 "src/transform/TransformLinear.birch"
  virtual void add(const libbirch::Lazy<libbirch::Shared<birch::type::Expression<birch::type::Real>>>& y, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
  #line 38 "src/transform/TransformLinear.birch"
  virtual void subtract(const libbirch::Lazy<libbirch::Shared<birch::type::Expression<birch::type::Real>>>& y, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
  #line 42 "src/transform/TransformLinear.birch"
  virtual void negate(const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
  #line 47 "src/transform/TransformLinear.birch"
  virtual void negateAndAdd(const libbirch::Lazy<libbirch::Shared<birch::type::Expression<birch::type::Real>>>& y, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
  
  #line 1 "src/transform/TransformLinear.birch"
  LIBBIRCH_CLASS(TransformLinear, Object)
  #line 1 "src/transform/TransformLinear.birch"
  LIBBIRCH_MEMBERS(a, x, c)
};

template<class Value>
#line 1 "src/transform/TransformLinearMatrix.birch"
class TransformLinearMatrix : public Object {
public:
  #line 1 "src/transform/TransformLinearMatrix.birch"
  using class_type_ = TransformLinearMatrix<Value>;
  #line 1 "src/transform/TransformLinearMatrix.birch"
  using this_type_ = class_type_;
  #line 1 "src/transform/TransformLinearMatrix.birch"
  using super_type_ = Object;

  #line 1 "src/transform/TransformLinearMatrix.birch"
  using super_type_::operator=;
  
  #line 1 "src/transform/TransformLinearMatrix.birch"
  TransformLinearMatrix(const libbirch::Lazy<libbirch::Shared<birch::type::Expression<libbirch::DefaultArray<birch::type::Real,2>>>>& A, const Value& X, const libbirch::Lazy<libbirch::Shared<birch::type::Expression<libbirch::DefaultArray<birch::type::Real,2>>>>& C, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);

  libbirch::Lazy<libbirch::Shared<birch::type::Expression<libbirch::DefaultArray<birch::type::Real,2>>>> A;
  Value X;
  libbirch::Lazy<libbirch::Shared<birch::type::Expression<libbirch::DefaultArray<birch::type::Real,2>>>> C;
  #line 24 "src/transform/TransformLinearMatrix.birch"
  virtual birch::type::Integer rows(const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
  #line 28 "src/transform/TransformLinearMatrix.birch"
  virtual birch::type::Integer columns(const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
  #line 32 "src/transform/TransformLinearMatrix.birch"
  virtual void leftMultiply(const libbirch::Lazy<libbirch::Shared<birch::type::Expression<libbirch::DefaultArray<birch::type::Real,2>>>>& Y, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
  #line 37 "src/transform/TransformLinearMatrix.birch"
  virtual void leftMultiply(const libbirch::Lazy<libbirch::Shared<birch::type::Expression<birch::type::Real>>>& y, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
  #line 42 "src/transform/TransformLinearMatrix.birch"
  virtual void add(const libbirch::Lazy<libbirch::Shared<birch::type::Expression<libbirch::DefaultArray<birch::type::Real,2>>>>& Y, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
  #line 46 "src/transform/TransformLinearMatrix.birch"
  virtual void subtract(const libbirch::Lazy<libbirch::Shared<birch::type::Expression<libbirch::DefaultArray<birch::type::Real,2>>>>& Y, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
  #line 50 "src/transform/TransformLinearMatrix.birch"
  virtual void multiply(const libbirch::Lazy<libbirch::Shared<birch::type::Expression<birch::type::Real>>>& y, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
  #line 55 "src/transform/TransformLinearMatrix.birch"
  virtual void divide(const libbirch::Lazy<libbirch::Shared<birch::type::Expression<birch::type::Real>>>& y, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
  #line 60 "src/transform/TransformLinearMatrix.birch"
  virtual void negate(const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
  #line 65 "src/transform/TransformLinearMatrix.birch"
  virtual void negateAndAdd(const libbirch::Lazy<libbirch::Shared<birch::type::Expression<libbirch::DefaultArray<birch::type::Real,2>>>>& Y, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
  
  #line 1 "src/transform/TransformLinearMatrix.birch"
  LIBBIRCH_CLASS(TransformLinearMatrix, Object)
  #line 1 "src/transform/TransformLinearMatrix.birch"
  LIBBIRCH_MEMBERS(A, X, C)
};

template<class Value>
#line 1 "src/transform/TransformLinearMultivariate.birch"
class TransformLinearMultivariate : public Object {
public:
  #line 1 "src/transform/TransformLinearMultivariate.birch"
  using class_type_ = TransformLinearMultivariate<Value>;
  #line 1 "src/transform/TransformLinearMultivariate.birch"
  using this_type_ = class_type_;
  #line 1 "src/transform/TransformLinearMultivariate.birch"
  using super_type_ = Object;

  #line 1 "src/transform/TransformLinearMultivariate.birch"
  using super_type_::operator=;
  
  #line 1 "src/transform/TransformLinearMultivariate.birch"
  TransformLinearMultivariate(const libbirch::Lazy<libbirch::Shared<birch::type::Expression<libbirch::DefaultArray<birch::type::Real,2>>>>& A, const Value& x, const libbirch::Lazy<libbirch::Shared<birch::type::Expression<libbirch::DefaultArray<birch::type::Real,1>>>>& c, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);

  libbirch::Lazy<libbirch::Shared<birch::type::Expression<libbirch::DefaultArray<birch::type::Real,2>>>> A;
  Value x;
  libbirch::Lazy<libbirch::Shared<birch::type::Expression<libbirch::DefaultArray<birch::type::Real,1>>>> c;
  #line 24 "src/transform/TransformLinearMultivariate.birch"
  virtual birch::type::Integer rows(const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
  #line 28 "src/transform/TransformLinearMultivariate.birch"
  virtual void leftMultiply(const libbirch::Lazy<libbirch::Shared<birch::type::Expression<libbirch::DefaultArray<birch::type::Real,2>>>>& Y, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
  #line 33 "src/transform/TransformLinearMultivariate.birch"
  virtual void leftMultiply(const libbirch::Lazy<libbirch::Shared<birch::type::Expression<birch::type::Real>>>& y, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
  #line 38 "src/transform/TransformLinearMultivariate.birch"
  virtual void add(const libbirch::Lazy<libbirch::Shared<birch::type::Expression<libbirch::DefaultArray<birch::type::Real,1>>>>& y, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
  #line 42 "src/transform/TransformLinearMultivariate.birch"
  virtual void subtract(const libbirch::Lazy<libbirch::Shared<birch::type::Expression<libbirch::DefaultArray<birch::type::Real,1>>>>& y, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
  #line 46 "src/transform/TransformLinearMultivariate.birch"
  virtual void multiply(const libbirch::Lazy<libbirch::Shared<birch::type::Expression<birch::type::Real>>>& y, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
  #line 51 "src/transform/TransformLinearMultivariate.birch"
  virtual void divide(const libbirch::Lazy<libbirch::Shared<birch::type::Expression<birch::type::Real>>>& y, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
  #line 56 "src/transform/TransformLinearMultivariate.birch"
  virtual void negate(const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
  #line 61 "src/transform/TransformLinearMultivariate.birch"
  virtual void negateAndAdd(const libbirch::Lazy<libbirch::Shared<birch::type::Expression<libbirch::DefaultArray<birch::type::Real,1>>>>& y, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
  
  #line 1 "src/transform/TransformLinearMultivariate.birch"
  LIBBIRCH_CLASS(TransformLinearMultivariate, Object)
  #line 1 "src/transform/TransformLinearMultivariate.birch"
  LIBBIRCH_MEMBERS(A, x, c)
};

#line 1 "src/utility/ProgressBar.birch"
class ProgressBar : public Object {
public:
  #line 1 "src/utility/ProgressBar.birch"
  using class_type_ = ProgressBar;
  #line 1 "src/utility/ProgressBar.birch"
  using this_type_ = class_type_;
  #line 1 "src/utility/ProgressBar.birch"
  using super_type_ = Object;

  #line 1 "src/utility/ProgressBar.birch"
  using super_type_::operator=;
  
  #line 1 "src/utility/ProgressBar.birch"
  ProgressBar(const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);

  libbirch::Lazy<libbirch::Shared<birch::type::OutputStream>> out;
  birch::type::Integer current;
  birch::type::Integer maximum;
  #line 30 "src/utility/ProgressBar.birch"
  virtual void update(const birch::type::Real& progress, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
  
  #line 1 "src/utility/ProgressBar.birch"
  LIBBIRCH_CLASS(ProgressBar, Object)
  #line 1 "src/utility/ProgressBar.birch"
  LIBBIRCH_MEMBERS(out, current, maximum)
};

#line 1 "src/utility/ProgressBar.birch"
extern "C" birch::type::ProgressBar* make_ProgressBar_();

#line 23 "src/test/basic/test_deep_clone_chain.birch"
class DeepCloneNode : public Object {
public:
  #line 23 "src/test/basic/test_deep_clone_chain.birch"
  using class_type_ = DeepCloneNode;
  #line 23 "src/test/basic/test_deep_clone_chain.birch"
  using this_type_ = class_type_;
  #line 23 "src/test/basic/test_deep_clone_chain.birch"
  using super_type_ = Object;

  #line 23 "src/test/basic/test_deep_clone_chain.birch"
  using super_type_::operator=;
  
  #line 23 "src/test/basic/test_deep_clone_chain.birch"
  DeepCloneNode(const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);

  birch::type::Integer a;
  
  #line 23 "src/test/basic/test_deep_clone_chain.birch"
  LIBBIRCH_CLASS(DeepCloneNode, Object)
  #line 23 "src/test/basic/test_deep_clone_chain.birch"
  LIBBIRCH_MEMBERS(a)
};

#line 23 "src/test/basic/test_deep_clone_chain.birch"
extern "C" birch::type::DeepCloneNode* make_DeepCloneNode_();


}

#line 5 "src/math/constant.birch"
birch::type::Real64& _u0960();
#line 10 "src/math/constant.birch"
birch::type::Real64& inf();
#line 15 "src/math/constant.birch"
birch::type::Real64& nan();
#line 19 "src/math/constant.birch"
birch::type::Real64& MACHEP();
#line 23 "src/math/constant.birch"
libbirch::DefaultArray<birch::type::Real64,2>& IGAM_ASYMPTOTIC_SERIES_D();
#line 49 "src/math/constant.birch"
libbirch::DefaultArray<birch::type::Real64,1>& lanczos_sum_expg_scaled_num();
#line 65 "src/math/constant.birch"
libbirch::DefaultArray<birch::type::Real64,1>& lanczos_sum_expg_scaled_denom();
#line 5 "src/system/filesystem.birch"
birch::type::Integer& READ();
#line 6 "src/system/filesystem.birch"
birch::type::Integer& WRITE();
#line 7 "src/system/filesystem.birch"
birch::type::Integer& APPEND();
#line 31 "src/system/stdio.birch"
libbirch::Lazy<libbirch::Shared<birch::type::InputStream>>& stdin();
#line 36 "src/system/stdio.birch"
libbirch::Lazy<libbirch::Shared<birch::type::OutputStream>>& stdout();
#line 41 "src/system/stdio.birch"
libbirch::Lazy<libbirch::Shared<birch::type::OutputStream>>& stderr();
#line 9 "src/basic/Boolean.birch"
birch::type::Boolean Boolean(const birch::type::Boolean& x, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
#line 16 "src/basic/Boolean.birch"
birch::type::Boolean Boolean(const birch::type::String& x, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
#line 23 "src/basic/Boolean.birch"
libbirch::Optional<birch::type::Boolean> Boolean(const libbirch::Optional<birch::type::Boolean>& x, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
#line 30 "src/basic/Boolean.birch"
libbirch::Optional<birch::type::Boolean> Boolean(const libbirch::Optional<birch::type::String>& x, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
#line 52 "src/basic/Boolean.birch"
birch::type::Boolean max(const birch::type::Boolean& x, const birch::type::Boolean& y, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
#line 59 "src/basic/Boolean.birch"
birch::type::Boolean min(const birch::type::Boolean& x, const birch::type::Boolean& y, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
#line 9 "src/basic/Integer.birch"
birch::type::Integer Integer(const birch::type::Real64& x, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
#line 16 "src/basic/Integer.birch"
birch::type::Integer Integer(const birch::type::Real32& x, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
#line 23 "src/basic/Integer.birch"
birch::type::Integer Integer(const birch::type::Integer64& x, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
#line 30 "src/basic/Integer.birch"
birch::type::Integer Integer(const birch::type::Integer32& x, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
#line 37 "src/basic/Integer.birch"
birch::type::Integer Integer(const birch::type::Integer16& x, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
#line 44 "src/basic/Integer.birch"
birch::type::Integer Integer(const birch::type::Integer8& x, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
#line 51 "src/basic/Integer.birch"
birch::type::Integer Integer(const birch::type::Boolean& x, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
#line 62 "src/basic/Integer.birch"
birch::type::Integer Integer(const birch::type::String& x, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
#line 69 "src/basic/Integer.birch"
libbirch::Optional<birch::type::Integer> Integer(const libbirch::Optional<birch::type::Real64>& x, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
#line 76 "src/basic/Integer.birch"
libbirch::Optional<birch::type::Integer> Integer(const libbirch::Optional<birch::type::Real32>& x, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
#line 83 "src/basic/Integer.birch"
libbirch::Optional<birch::type::Integer> Integer(const libbirch::Optional<birch::type::Integer64>& x, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
#line 90 "src/basic/Integer.birch"
libbirch::Optional<birch::type::Integer> Integer(const libbirch::Optional<birch::type::Integer32>& x, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
#line 97 "src/basic/Integer.birch"
libbirch::Optional<birch::type::Integer> Integer(const libbirch::Optional<birch::type::Integer16>& x, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
#line 104 "src/basic/Integer.birch"
libbirch::Optional<birch::type::Integer> Integer(const libbirch::Optional<birch::type::Integer8>& x, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
#line 111 "src/basic/Integer.birch"
libbirch::Optional<birch::type::Integer> Integer(const libbirch::Optional<birch::type::String>& x, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
#line 9 "src/basic/Integer16.birch"
birch::type::Integer16 Integer16(const birch::type::Real64& x, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
#line 18 "src/basic/Integer16.birch"
birch::type::Integer16 Integer16(const birch::type::Real32& x, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
#line 27 "src/basic/Integer16.birch"
birch::type::Integer16 Integer16(const birch::type::Integer64& x, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
#line 36 "src/basic/Integer16.birch"
birch::type::Integer16 Integer16(const birch::type::Integer32& x, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
#line 45 "src/basic/Integer16.birch"
birch::type::Integer16 Integer16(const birch::type::Integer16& x, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
#line 52 "src/basic/Integer16.birch"
birch::type::Integer16 Integer16(const birch::type::Integer8& x, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
#line 61 "src/basic/Integer16.birch"
birch::type::Integer16 Integer16(const birch::type::Boolean& x, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
#line 72 "src/basic/Integer16.birch"
birch::type::Integer16 Integer16(const birch::type::String& x, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
#line 81 "src/basic/Integer16.birch"
libbirch::Optional<birch::type::Integer16> Integer16(const libbirch::Optional<birch::type::Real64>& x, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
#line 92 "src/basic/Integer16.birch"
libbirch::Optional<birch::type::Integer16> Integer16(const libbirch::Optional<birch::type::Real32>& x, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
#line 103 "src/basic/Integer16.birch"
libbirch::Optional<birch::type::Integer16> Integer16(const libbirch::Optional<birch::type::Integer64>& x, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
#line 114 "src/basic/Integer16.birch"
libbirch::Optional<birch::type::Integer16> Integer16(const libbirch::Optional<birch::type::Integer32>& x, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
#line 125 "src/basic/Integer16.birch"
libbirch::Optional<birch::type::Integer16> Integer16(const libbirch::Optional<birch::type::Integer16>& x, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
#line 132 "src/basic/Integer16.birch"
libbirch::Optional<birch::type::Integer16> Integer16(const libbirch::Optional<birch::type::Integer8>& x, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
#line 143 "src/basic/Integer16.birch"
libbirch::Optional<birch::type::Integer16> Integer16(const libbirch::Optional<birch::type::String>& x, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
#line 170 "src/basic/Integer16.birch"
birch::type::Integer16 abs(const birch::type::Integer16& x, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
#line 179 "src/basic/Integer16.birch"
birch::type::Integer16 pow(const birch::type::Integer16& x, const birch::type::Integer16& y, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
#line 188 "src/basic/Integer16.birch"
birch::type::Integer16 mod(const birch::type::Integer16& x, const birch::type::Integer16& y, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
#line 197 "src/basic/Integer16.birch"
birch::type::Integer16 max(const birch::type::Integer16& x, const birch::type::Integer16& y, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
#line 206 "src/basic/Integer16.birch"
birch::type::Integer16 min(const birch::type::Integer16& x, const birch::type::Integer16& y, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
#line 9 "src/basic/Integer32.birch"
birch::type::Integer32 Integer32(const birch::type::Real64& x, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
#line 18 "src/basic/Integer32.birch"
birch::type::Integer32 Integer32(const birch::type::Real32& x, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
#line 27 "src/basic/Integer32.birch"
birch::type::Integer32 Integer32(const birch::type::Integer64& x, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
#line 36 "src/basic/Integer32.birch"
birch::type::Integer32 Integer32(const birch::type::Integer32& x, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
#line 43 "src/basic/Integer32.birch"
birch::type::Integer32 Integer32(const birch::type::Integer16& x, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
#line 52 "src/basic/Integer32.birch"
birch::type::Integer32 Integer32(const birch::type::Integer8& x, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
#line 61 "src/basic/Integer32.birch"
birch::type::Integer32 Integer32(const birch::type::Boolean& x, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
#line 72 "src/basic/Integer32.birch"
birch::type::Integer32 Integer32(const birch::type::String& x, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
#line 81 "src/basic/Integer32.birch"
libbirch::Optional<birch::type::Integer32> Integer32(const libbirch::Optional<birch::type::Real64>& x, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
#line 92 "src/basic/Integer32.birch"
libbirch::Optional<birch::type::Integer32> Integer32(const libbirch::Optional<birch::type::Real32>& x, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
#line 103 "src/basic/Integer32.birch"
libbirch::Optional<birch::type::Integer32> Integer32(const libbirch::Optional<birch::type::Integer64>& x, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
#line 114 "src/basic/Integer32.birch"
libbirch::Optional<birch::type::Integer32> Integer32(const libbirch::Optional<birch::type::Integer32>& x, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
#line 121 "src/basic/Integer32.birch"
libbirch::Optional<birch::type::Integer32> Integer32(const libbirch::Optional<birch::type::Integer16>& x, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
#line 132 "src/basic/Integer32.birch"
libbirch::Optional<birch::type::Integer32> Integer32(const libbirch::Optional<birch::type::Integer8>& x, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
#line 143 "src/basic/Integer32.birch"
libbirch::Optional<birch::type::Integer32> Integer32(const libbirch::Optional<birch::type::String>& x, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
#line 170 "src/basic/Integer32.birch"
birch::type::Integer32 abs(const birch::type::Integer32& x, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
#line 179 "src/basic/Integer32.birch"
birch::type::Integer32 pow(const birch::type::Integer32& x, const birch::type::Integer32& y, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
#line 188 "src/basic/Integer32.birch"
birch::type::Integer32 mod(const birch::type::Integer32& x, const birch::type::Integer32& y, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
#line 197 "src/basic/Integer32.birch"
birch::type::Integer32 max(const birch::type::Integer32& x, const birch::type::Integer32& y, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
#line 206 "src/basic/Integer32.birch"
birch::type::Integer32 min(const birch::type::Integer32& x, const birch::type::Integer32& y, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
#line 9 "src/basic/Integer64.birch"
birch::type::Integer64 Integer64(const birch::type::Integer64& x, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
#line 16 "src/basic/Integer64.birch"
birch::type::Integer64 Integer64(const birch::type::Real64& x, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
#line 25 "src/basic/Integer64.birch"
birch::type::Integer64 Integer64(const birch::type::Real32& x, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
#line 34 "src/basic/Integer64.birch"
birch::type::Integer64 Integer64(const birch::type::Integer32& x, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
#line 43 "src/basic/Integer64.birch"
birch::type::Integer64 Integer64(const birch::type::Integer16& x, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
#line 52 "src/basic/Integer64.birch"
birch::type::Integer64 Integer64(const birch::type::Integer8& x, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
#line 61 "src/basic/Integer64.birch"
birch::type::Integer64 Integer64(const birch::type::Boolean& x, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
#line 72 "src/basic/Integer64.birch"
birch::type::Integer64 Integer64(const birch::type::String& x, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
#line 81 "src/basic/Integer64.birch"
libbirch::Optional<birch::type::Integer64> Integer64(const libbirch::Optional<birch::type::Integer64>& x, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
#line 88 "src/basic/Integer64.birch"
libbirch::Optional<birch::type::Integer64> Integer64(const libbirch::Optional<birch::type::Real64>& x, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
#line 99 "src/basic/Integer64.birch"
libbirch::Optional<birch::type::Integer64> Integer64(const libbirch::Optional<birch::type::Real32>& x, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
#line 110 "src/basic/Integer64.birch"
libbirch::Optional<birch::type::Integer64> Integer64(const libbirch::Optional<birch::type::Integer32>& x, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
#line 121 "src/basic/Integer64.birch"
libbirch::Optional<birch::type::Integer64> Integer64(const libbirch::Optional<birch::type::Integer16>& x, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
#line 132 "src/basic/Integer64.birch"
libbirch::Optional<birch::type::Integer64> Integer64(const libbirch::Optional<birch::type::Integer8>& x, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
#line 143 "src/basic/Integer64.birch"
libbirch::Optional<birch::type::Integer64> Integer64(const libbirch::Optional<birch::type::String>& x, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
#line 170 "src/basic/Integer64.birch"
birch::type::Integer64 abs(const birch::type::Integer64& x, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
#line 179 "src/basic/Integer64.birch"
birch::type::Integer64 pow(const birch::type::Integer64& x, const birch::type::Integer64& y, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
#line 188 "src/basic/Integer64.birch"
birch::type::Integer64 mod(const birch::type::Integer64& x, const birch::type::Integer64& y, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
#line 197 "src/basic/Integer64.birch"
birch::type::Integer64 max(const birch::type::Integer64& x, const birch::type::Integer64& y, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
#line 206 "src/basic/Integer64.birch"
birch::type::Integer64 min(const birch::type::Integer64& x, const birch::type::Integer64& y, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
#line 9 "src/basic/Integer8.birch"
birch::type::Integer8 Integer8(const birch::type::Real64& x, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
#line 18 "src/basic/Integer8.birch"
birch::type::Integer8 Integer8(const birch::type::Real32& x, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
#line 27 "src/basic/Integer8.birch"
birch::type::Integer8 Integer8(const birch::type::Integer64& x, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
#line 36 "src/basic/Integer8.birch"
birch::type::Integer8 Integer8(const birch::type::Integer32& x, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
#line 45 "src/basic/Integer8.birch"
birch::type::Integer8 Integer8(const birch::type::Integer16& x, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
#line 54 "src/basic/Integer8.birch"
birch::type::Integer8 Integer8(const birch::type::Integer8& x, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
#line 61 "src/basic/Integer8.birch"
birch::type::Integer8 Integer8(const birch::type::Boolean& x, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
#line 72 "src/basic/Integer8.birch"
birch::type::Integer8 Integer8(const birch::type::String& x, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
#line 81 "src/basic/Integer8.birch"
libbirch::Optional<birch::type::Integer8> Integer8(const libbirch::Optional<birch::type::Real64>& x, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
#line 92 "src/basic/Integer8.birch"
libbirch::Optional<birch::type::Integer8> Integer8(const libbirch::Optional<birch::type::Real32>& x, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
#line 103 "src/basic/Integer8.birch"
libbirch::Optional<birch::type::Integer8> Integer8(const libbirch::Optional<birch::type::Integer64>& x, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
#line 114 "src/basic/Integer8.birch"
libbirch::Optional<birch::type::Integer8> Integer8(const libbirch::Optional<birch::type::Integer32>& x, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
#line 125 "src/basic/Integer8.birch"
libbirch::Optional<birch::type::Integer8> Integer8(const libbirch::Optional<birch::type::Integer16>& x, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
#line 136 "src/basic/Integer8.birch"
libbirch::Optional<birch::type::Integer8> Integer8(const libbirch::Optional<birch::type::Integer8>& x, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
#line 143 "src/basic/Integer8.birch"
libbirch::Optional<birch::type::Integer8> Integer8(const libbirch::Optional<birch::type::String>& x, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
#line 170 "src/basic/Integer8.birch"
birch::type::Integer8 abs(const birch::type::Integer8& x, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
#line 179 "src/basic/Integer8.birch"
birch::type::Integer8 pow(const birch::type::Integer8& x, const birch::type::Integer8& y, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
#line 188 "src/basic/Integer8.birch"
birch::type::Integer8 mod(const birch::type::Integer8& x, const birch::type::Integer8& y, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
#line 197 "src/basic/Integer8.birch"
birch::type::Integer8 max(const birch::type::Integer8& x, const birch::type::Integer8& y, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
#line 206 "src/basic/Integer8.birch"
birch::type::Integer8 min(const birch::type::Integer8& x, const birch::type::Integer8& y, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
#line 9 "src/basic/LLT.birch"
birch::type::Integer64 rows(const birch::type::LLT& X, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
#line 18 "src/basic/LLT.birch"
birch::type::Integer64 columns(const birch::type::LLT& X, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
#line 58 "src/basic/LLT.birch"
birch::type::LLT llt(const libbirch::DefaultArray<birch::type::Real,2>& S, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
#line 70 "src/basic/LLT.birch"
birch::type::LLT llt(const birch::type::LLT& S, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
#line 84 "src/basic/LLT.birch"
birch::type::LLT rank_update(const birch::type::LLT& S, const libbirch::DefaultArray<birch::type::Real,1>& x, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
#line 106 "src/basic/LLT.birch"
birch::type::LLT rank_update(const birch::type::LLT& S, const libbirch::DefaultArray<birch::type::Real,2>& X, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
#line 133 "src/basic/LLT.birch"
birch::type::LLT rank_downdate(const birch::type::LLT& S, const libbirch::DefaultArray<birch::type::Real,1>& x, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
#line 155 "src/basic/LLT.birch"
birch::type::LLT rank_downdate(const birch::type::LLT& S, const libbirch::DefaultArray<birch::type::Real,2>& X, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
#line 39 "src/basic/Object.birch"
libbirch::Lazy<libbirch::Shared<birch::type::Object>> Object(const libbirch::Lazy<libbirch::Shared<birch::type::Object>>& o, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
#line 9 "src/basic/Real.birch"
birch::type::Real Real(const birch::type::Real64& x, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
#line 16 "src/basic/Real.birch"
birch::type::Real Real(const birch::type::Real32& x, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
#line 23 "src/basic/Real.birch"
birch::type::Real Real(const birch::type::Integer64& x, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
#line 30 "src/basic/Real.birch"
birch::type::Real Real(const birch::type::Integer32& x, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
#line 37 "src/basic/Real.birch"
birch::type::Real Real(const birch::type::Integer16& x, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
#line 44 "src/basic/Real.birch"
birch::type::Real Real(const birch::type::Integer8& x, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
#line 51 "src/basic/Real.birch"
birch::type::Real Real(const birch::type::Boolean& x, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
#line 58 "src/basic/Real.birch"
birch::type::Real Real(const birch::type::String& x, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
#line 65 "src/basic/Real.birch"
libbirch::Optional<birch::type::Real> Real(const libbirch::Optional<birch::type::Real64>& x, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
#line 72 "src/basic/Real.birch"
libbirch::Optional<birch::type::Real> Real(const libbirch::Optional<birch::type::Real32>& x, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
#line 79 "src/basic/Real.birch"
libbirch::Optional<birch::type::Real> Real(const libbirch::Optional<birch::type::Integer64>& x, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
#line 86 "src/basic/Real.birch"
libbirch::Optional<birch::type::Real> Real(const libbirch::Optional<birch::type::Integer32>& x, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
#line 93 "src/basic/Real.birch"
libbirch::Optional<birch::type::Real> Real(const libbirch::Optional<birch::type::Integer16>& x, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
#line 100 "src/basic/Real.birch"
libbirch::Optional<birch::type::Real> Real(const libbirch::Optional<birch::type::Integer8>& x, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
#line 107 "src/basic/Real.birch"
libbirch::Optional<birch::type::Real> Real(const libbirch::Optional<birch::type::String>& x, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
#line 9 "src/basic/Real32.birch"
birch::type::Real32 Real32(const birch::type::Real64& x, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
#line 18 "src/basic/Real32.birch"
birch::type::Real32 Real32(const birch::type::Real32& x, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
#line 25 "src/basic/Real32.birch"
birch::type::Real32 Real32(const birch::type::Integer64& x, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
#line 34 "src/basic/Real32.birch"
birch::type::Real32 Real32(const birch::type::Integer32& x, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
#line 43 "src/basic/Real32.birch"
birch::type::Real32 Real32(const birch::type::Integer16& x, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
#line 52 "src/basic/Real32.birch"
birch::type::Real32 Real32(const birch::type::Integer8& x, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
#line 61 "src/basic/Real32.birch"
birch::type::Real32 Real32(const birch::type::Boolean& x, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
#line 72 "src/basic/Real32.birch"
birch::type::Real32 Real32(const birch::type::String& x, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
#line 81 "src/basic/Real32.birch"
libbirch::Optional<birch::type::Real32> Real32(const libbirch::Optional<birch::type::Real64>& x, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
#line 92 "src/basic/Real32.birch"
libbirch::Optional<birch::type::Real32> Real32(const libbirch::Optional<birch::type::Real32>& x, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
#line 99 "src/basic/Real32.birch"
libbirch::Optional<birch::type::Real32> Real32(const libbirch::Optional<birch::type::Integer64>& x, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
#line 110 "src/basic/Real32.birch"
libbirch::Optional<birch::type::Real32> Real32(const libbirch::Optional<birch::type::Integer32>& x, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
#line 121 "src/basic/Real32.birch"
libbirch::Optional<birch::type::Real32> Real32(const libbirch::Optional<birch::type::Integer16>& x, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
#line 132 "src/basic/Real32.birch"
libbirch::Optional<birch::type::Real32> Real32(const libbirch::Optional<birch::type::Integer8>& x, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
#line 143 "src/basic/Real32.birch"
libbirch::Optional<birch::type::Real32> Real32(const libbirch::Optional<birch::type::String>& x, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
#line 170 "src/basic/Real32.birch"
birch::type::Real32 abs(const birch::type::Real32& x, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
#line 179 "src/basic/Real32.birch"
birch::type::Real32 pow(const birch::type::Real32& x, const birch::type::Real32& y, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
#line 188 "src/basic/Real32.birch"
birch::type::Real32 mod(const birch::type::Real32& x, const birch::type::Real32& y, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
#line 197 "src/basic/Real32.birch"
birch::type::Real32 max(const birch::type::Real32& x, const birch::type::Real32& y, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
#line 206 "src/basic/Real32.birch"
birch::type::Real32 min(const birch::type::Real32& x, const birch::type::Real32& y, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
#line 215 "src/basic/Real32.birch"
birch::type::Boolean isinf(const birch::type::Real32& x, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
#line 224 "src/basic/Real32.birch"
birch::type::Boolean isnan(const birch::type::Real32& x, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
#line 233 "src/basic/Real32.birch"
birch::type::Boolean isfinite(const birch::type::Real32& x, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
#line 9 "src/basic/Real64.birch"
birch::type::Real64 Real64(const birch::type::Real64& x, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
#line 16 "src/basic/Real64.birch"
birch::type::Real64 Real64(const birch::type::Real32& x, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
#line 25 "src/basic/Real64.birch"
birch::type::Real64 Real64(const birch::type::Integer64& x, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
#line 34 "src/basic/Real64.birch"
birch::type::Real64 Real64(const birch::type::Integer32& x, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
#line 43 "src/basic/Real64.birch"
birch::type::Real64 Real64(const birch::type::Integer16& x, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
#line 52 "src/basic/Real64.birch"
birch::type::Real64 Real64(const birch::type::Integer8& x, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
#line 61 "src/basic/Real64.birch"
birch::type::Real64 Real64(const birch::type::Boolean& x, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
#line 72 "src/basic/Real64.birch"
birch::type::Real64 Real64(const birch::type::String& x, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
#line 81 "src/basic/Real64.birch"
libbirch::Optional<birch::type::Real64> Real64(const libbirch::Optional<birch::type::Real64>& x, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
#line 88 "src/basic/Real64.birch"
libbirch::Optional<birch::type::Real64> Real64(const libbirch::Optional<birch::type::Real32>& x, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
#line 99 "src/basic/Real64.birch"
libbirch::Optional<birch::type::Real64> Real64(const libbirch::Optional<birch::type::Integer64>& x, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
#line 110 "src/basic/Real64.birch"
libbirch::Optional<birch::type::Real64> Real64(const libbirch::Optional<birch::type::Integer32>& x, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
#line 121 "src/basic/Real64.birch"
libbirch::Optional<birch::type::Real64> Real64(const libbirch::Optional<birch::type::Integer16>& x, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
#line 132 "src/basic/Real64.birch"
libbirch::Optional<birch::type::Real64> Real64(const libbirch::Optional<birch::type::Integer8>& x, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
#line 143 "src/basic/Real64.birch"
libbirch::Optional<birch::type::Real64> Real64(const libbirch::Optional<birch::type::String>& x, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
#line 170 "src/basic/Real64.birch"
birch::type::Real64 abs(const birch::type::Real64& x, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
#line 179 "src/basic/Real64.birch"
birch::type::Real64 pow(const birch::type::Real64& x, const birch::type::Real64& y, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
#line 188 "src/basic/Real64.birch"
birch::type::Real64 mod(const birch::type::Real64& x, const birch::type::Real64& y, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
#line 197 "src/basic/Real64.birch"
birch::type::Real64 max(const birch::type::Real64& x, const birch::type::Real64& y, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
#line 206 "src/basic/Real64.birch"
birch::type::Real64 min(const birch::type::Real64& x, const birch::type::Real64& y, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
#line 215 "src/basic/Real64.birch"
birch::type::Boolean isinf(const birch::type::Real64& x, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
#line 224 "src/basic/Real64.birch"
birch::type::Boolean isnan(const birch::type::Real64& x, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
#line 233 "src/basic/Real64.birch"
birch::type::Boolean isfinite(const birch::type::Real64& x, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
#line 9 "src/basic/String.birch"
birch::type::String String(const birch::type::Boolean& x, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
#line 20 "src/basic/String.birch"
birch::type::String String(const birch::type::Real64& x, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
#line 35 "src/basic/String.birch"
birch::type::String String(const birch::type::Real32& x, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
#line 50 "src/basic/String.birch"
birch::type::String String(const birch::type::Integer64& x, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
#line 59 "src/basic/String.birch"
birch::type::String String(const birch::type::Integer32& x, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
#line 68 "src/basic/String.birch"
birch::type::String String(const birch::type::Integer16& x, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
#line 77 "src/basic/String.birch"
birch::type::String String(const birch::type::Integer8& x, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
#line 86 "src/basic/String.birch"
birch::type::String String(const birch::type::String& x, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
#line 93 "src/basic/String.birch"
libbirch::Optional<birch::type::String> String(const libbirch::Optional<birch::type::Boolean>& x, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
#line 104 "src/basic/String.birch"
libbirch::Optional<birch::type::String> String(const libbirch::Optional<birch::type::Real64>& x, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
#line 115 "src/basic/String.birch"
libbirch::Optional<birch::type::String> String(const libbirch::Optional<birch::type::Real32>& x, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
#line 126 "src/basic/String.birch"
libbirch::Optional<birch::type::String> String(const libbirch::Optional<birch::type::Integer64>& x, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
#line 137 "src/basic/String.birch"
libbirch::Optional<birch::type::String> String(const libbirch::Optional<birch::type::Integer32>& x, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
#line 148 "src/basic/String.birch"
libbirch::Optional<birch::type::String> String(const libbirch::Optional<birch::type::Integer16>& x, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
#line 159 "src/basic/String.birch"
libbirch::Optional<birch::type::String> String(const libbirch::Optional<birch::type::Integer8>& x, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
#line 170 "src/basic/String.birch"
libbirch::Optional<birch::type::String> String(const libbirch::Optional<birch::type::String>& x, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
#line 362 "src/basic/String.birch"
birch::type::Integer length(const birch::type::String& x, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
#line 371 "src/basic/String.birch"
birch::type::Integer length(const libbirch::DefaultArray<birch::type::String,1>& x, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
template<class Type>
#line 50 "src/container/TapeNode.birch"
libbirch::Lazy<libbirch::Shared<birch::type::TapeNode<Type>>> TapeNode(const Type& x, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
template<class Type>
#line 58 "src/container/TapeNode.birch"
libbirch::Lazy<libbirch::Shared<birch::type::TapeNode<Type>>> TapeNode(const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
#line 198 "src/data/ArrayValue.birch"
libbirch::Lazy<libbirch::Shared<birch::type::ArrayValue>> ArrayValue(const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
#line 108 "src/data/BooleanValue.birch"
libbirch::Lazy<libbirch::Shared<birch::type::BooleanValue>> BooleanValue(const birch::type::Boolean& value, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
#line 123 "src/data/BooleanVectorValue.birch"
libbirch::Lazy<libbirch::Shared<birch::type::BooleanVectorValue>> BooleanVectorValue(const libbirch::DefaultArray<birch::type::Boolean,1>& value, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
template<class Type>
#line 1150 "src/data/Buffer.birch"
libbirch::Lazy<libbirch::Shared<birch::type::Buffer>> Buffer(const Type& root, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
#line 1159 "src/data/Buffer.birch"
libbirch::Lazy<libbirch::Shared<birch::type::Buffer>> Buffer(const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
#line 19 "src/data/Entry.birch"
libbirch::Lazy<libbirch::Shared<birch::type::Entry>> Entry(const birch::type::String& key, const libbirch::Lazy<libbirch::Shared<birch::type::Buffer>>& value, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
#line 96 "src/data/IntegerValue.birch"
libbirch::Lazy<libbirch::Shared<birch::type::IntegerValue>> IntegerValue(const birch::type::Integer& value, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
#line 108 "src/data/IntegerVectorValue.birch"
libbirch::Lazy<libbirch::Shared<birch::type::IntegerVectorValue>> IntegerVectorValue(const libbirch::DefaultArray<birch::type::Integer,1>& value, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
#line 76 "src/data/NilValue.birch"
libbirch::Lazy<libbirch::Shared<birch::type::NilValue>> NilValue(const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
#line 116 "src/data/ObjectValue.birch"
libbirch::Lazy<libbirch::Shared<birch::type::ObjectValue>> ObjectValue(const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
#line 84 "src/data/RealValue.birch"
libbirch::Lazy<libbirch::Shared<birch::type::RealValue>> RealValue(const birch::type::Real& value, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
#line 93 "src/data/RealVectorValue.birch"
libbirch::Lazy<libbirch::Shared<birch::type::RealVectorValue>> RealVectorValue(const libbirch::DefaultArray<birch::type::Real,1>& value, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
#line 85 "src/data/StringValue.birch"
libbirch::Lazy<libbirch::Shared<birch::type::StringValue>> StringValue(const birch::type::String& value, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
#line 146 "src/distribution/AddBoundedDiscrete.birch"
libbirch::Lazy<libbirch::Shared<birch::type::AddBoundedDiscrete>> AddBoundedDiscrete(const libbirch::Lazy<libbirch::Shared<birch::type::BoundedDiscrete>>& x1, const libbirch::Lazy<libbirch::Shared<birch::type::BoundedDiscrete>>& x2, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
#line 53 "src/distribution/Bernoulli.birch"
libbirch::Lazy<libbirch::Shared<birch::type::Bernoulli>> Bernoulli(const libbirch::Lazy<libbirch::Shared<birch::type::Expression<birch::type::Real>>>& _u0961, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
#line 60 "src/distribution/Bernoulli.birch"
libbirch::Lazy<libbirch::Shared<birch::type::Bernoulli>> Bernoulli(const birch::type::Real& _u0961, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
#line 68 "src/distribution/Beta.birch"
libbirch::Lazy<libbirch::Shared<birch::type::Beta>> Beta(const libbirch::Lazy<libbirch::Shared<birch::type::Expression<birch::type::Real>>>& _u0945, const libbirch::Lazy<libbirch::Shared<birch::type::Expression<birch::type::Real>>>& _u0946, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
#line 75 "src/distribution/Beta.birch"
libbirch::Lazy<libbirch::Shared<birch::type::Beta>> Beta(const libbirch::Lazy<libbirch::Shared<birch::type::Expression<birch::type::Real>>>& _u0945, const birch::type::Real& _u0946, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
#line 82 "src/distribution/Beta.birch"
libbirch::Lazy<libbirch::Shared<birch::type::Beta>> Beta(const birch::type::Real& _u0945, const libbirch::Lazy<libbirch::Shared<birch::type::Expression<birch::type::Real>>>& _u0946, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
#line 89 "src/distribution/Beta.birch"
libbirch::Lazy<libbirch::Shared<birch::type::Beta>> Beta(const birch::type::Real& _u0945, const birch::type::Real& _u0946, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
#line 47 "src/distribution/BetaBernoulli.birch"
libbirch::Lazy<libbirch::Shared<birch::type::BetaBernoulli>> BetaBernoulli(const libbirch::Lazy<libbirch::Shared<birch::type::Beta>>& _u0961, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
#line 72 "src/distribution/BetaBinomial.birch"
libbirch::Lazy<libbirch::Shared<birch::type::BetaBinomial>> BetaBinomial(const libbirch::Lazy<libbirch::Shared<birch::type::Expression<birch::type::Integer>>>& n, const libbirch::Lazy<libbirch::Shared<birch::type::Beta>>& _u0961, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
#line 64 "src/distribution/BetaNegativeBinomial.birch"
libbirch::Lazy<libbirch::Shared<birch::type::BetaNegativeBinomial>> BetaNegativeBinomial(const libbirch::Lazy<libbirch::Shared<birch::type::Expression<birch::type::Integer>>>& k, const libbirch::Lazy<libbirch::Shared<birch::type::Beta>>& _u0961, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
#line 91 "src/distribution/Binomial.birch"
libbirch::Lazy<libbirch::Shared<birch::type::Binomial>> Binomial(const libbirch::Lazy<libbirch::Shared<birch::type::Expression<birch::type::Integer>>>& n, const libbirch::Lazy<libbirch::Shared<birch::type::Expression<birch::type::Real>>>& _u0961, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
#line 98 "src/distribution/Binomial.birch"
libbirch::Lazy<libbirch::Shared<birch::type::Binomial>> Binomial(const libbirch::Lazy<libbirch::Shared<birch::type::Expression<birch::type::Integer>>>& n, const birch::type::Real& _u0961, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
#line 105 "src/distribution/Binomial.birch"
libbirch::Lazy<libbirch::Shared<birch::type::Binomial>> Binomial(const birch::type::Integer& n, const libbirch::Lazy<libbirch::Shared<birch::type::Expression<birch::type::Real>>>& _u0961, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
#line 112 "src/distribution/Binomial.birch"
libbirch::Lazy<libbirch::Shared<birch::type::Binomial>> Binomial(const birch::type::Integer& n, const birch::type::Real& _u0961, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
#line 72 "src/distribution/Categorical.birch"
libbirch::Lazy<libbirch::Shared<birch::type::Categorical>> Categorical(const libbirch::Lazy<libbirch::Shared<birch::type::Expression<libbirch::DefaultArray<birch::type::Real,1>>>>& _u0961, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
#line 79 "src/distribution/Categorical.birch"
libbirch::Lazy<libbirch::Shared<birch::type::Categorical>> Categorical(const libbirch::DefaultArray<birch::type::Real,1>& _u0961, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
#line 72 "src/distribution/Delta.birch"
libbirch::Lazy<libbirch::Shared<birch::type::Delta>> Delta(const libbirch::Lazy<libbirch::Shared<birch::type::Expression<birch::type::Integer>>>& _u0956, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
#line 81 "src/distribution/Delta.birch"
libbirch::Lazy<libbirch::Shared<birch::type::Delta>> Delta(const birch::type::Integer& _u0956, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
#line 45 "src/distribution/Dirichlet.birch"
libbirch::Lazy<libbirch::Shared<birch::type::Dirichlet>> Dirichlet(const libbirch::Lazy<libbirch::Shared<birch::type::Expression<libbirch::DefaultArray<birch::type::Real,1>>>>& _u0945, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
#line 52 "src/distribution/Dirichlet.birch"
libbirch::Lazy<libbirch::Shared<birch::type::Dirichlet>> Dirichlet(const libbirch::DefaultArray<birch::type::Real,1>& _u0945, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
#line 55 "src/distribution/DirichletCategorical.birch"
libbirch::Lazy<libbirch::Shared<birch::type::DirichletCategorical>> DirichletCategorical(const libbirch::Lazy<libbirch::Shared<birch::type::Dirichlet>>& _u0961, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
#line 53 "src/distribution/DirichletMultinomial.birch"
libbirch::Lazy<libbirch::Shared<birch::type::DirichletMultinomial>> DirichletMultinomial(const libbirch::Lazy<libbirch::Shared<birch::type::Expression<birch::type::Integer>>>& n, const libbirch::Lazy<libbirch::Shared<birch::type::Dirichlet>>& _u0961, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
#line 77 "src/distribution/DiscreteDelta.birch"
libbirch::Lazy<libbirch::Shared<birch::type::DiscreteDelta>> DiscreteDelta(const libbirch::Lazy<libbirch::Shared<birch::type::Discrete>>& _u0956, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
#line 68 "src/distribution/Exponential.birch"
libbirch::Lazy<libbirch::Shared<birch::type::Exponential>> Exponential(const libbirch::Lazy<libbirch::Shared<birch::type::Expression<birch::type::Real>>>& _u0955, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
#line 75 "src/distribution/Exponential.birch"
libbirch::Lazy<libbirch::Shared<birch::type::Exponential>> Exponential(const birch::type::Real& _u0955, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
#line 76 "src/distribution/Gamma.birch"
libbirch::Lazy<libbirch::Shared<birch::type::Gamma>> Gamma(const libbirch::Lazy<libbirch::Shared<birch::type::Expression<birch::type::Real>>>& k, const libbirch::Lazy<libbirch::Shared<birch::type::Expression<birch::type::Real>>>& _u0952, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
#line 83 "src/distribution/Gamma.birch"
libbirch::Lazy<libbirch::Shared<birch::type::Gamma>> Gamma(const libbirch::Lazy<libbirch::Shared<birch::type::Expression<birch::type::Real>>>& k, const birch::type::Real& _u0952, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
#line 90 "src/distribution/Gamma.birch"
libbirch::Lazy<libbirch::Shared<birch::type::Gamma>> Gamma(const birch::type::Real& k, const libbirch::Lazy<libbirch::Shared<birch::type::Expression<birch::type::Real>>>& _u0952, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
#line 97 "src/distribution/Gamma.birch"
libbirch::Lazy<libbirch::Shared<birch::type::Gamma>> Gamma(const birch::type::Real& k, const birch::type::Real& _u0952, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
#line 59 "src/distribution/GammaExponential.birch"
libbirch::Lazy<libbirch::Shared<birch::type::GammaExponential>> GammaExponential(const libbirch::Lazy<libbirch::Shared<birch::type::Gamma>>& _u0955, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
#line 67 "src/distribution/GammaPoisson.birch"
libbirch::Lazy<libbirch::Shared<birch::type::GammaPoisson>> GammaPoisson(const libbirch::Lazy<libbirch::Shared<birch::type::Gamma>>& _u0955, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
#line 120 "src/distribution/Gaussian.birch"
libbirch::Lazy<libbirch::Shared<birch::type::Gaussian>> Gaussian(const libbirch::Lazy<libbirch::Shared<birch::type::Expression<birch::type::Real>>>& _u0956, const libbirch::Lazy<libbirch::Shared<birch::type::Expression<birch::type::Real>>>& _u09632, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
#line 127 "src/distribution/Gaussian.birch"
libbirch::Lazy<libbirch::Shared<birch::type::Gaussian>> Gaussian(const libbirch::Lazy<libbirch::Shared<birch::type::Expression<birch::type::Real>>>& _u0956, const birch::type::Real& _u09632, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
#line 134 "src/distribution/Gaussian.birch"
libbirch::Lazy<libbirch::Shared<birch::type::Gaussian>> Gaussian(const birch::type::Real& _u0956, const libbirch::Lazy<libbirch::Shared<birch::type::Expression<birch::type::Real>>>& _u09632, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
#line 141 "src/distribution/Gaussian.birch"
libbirch::Lazy<libbirch::Shared<birch::type::Gaussian>> Gaussian(const birch::type::Real& _u0956, const birch::type::Real& _u09632, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
#line 33 "src/distribution/GaussianGaussian.birch"
libbirch::Lazy<libbirch::Shared<birch::type::GaussianGaussian>> GaussianGaussian(const libbirch::Lazy<libbirch::Shared<birch::type::Gaussian>>& _u0956, const libbirch::Lazy<libbirch::Shared<birch::type::Expression<birch::type::Real>>>& _u09632, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
#line 4 "src/distribution/Geometric.birch"
libbirch::Lazy<libbirch::Shared<birch::type::NegativeBinomial>> Geometric(const libbirch::Lazy<libbirch::Shared<birch::type::Expression<birch::type::Real>>>& _u0961, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
#line 11 "src/distribution/Geometric.birch"
libbirch::Lazy<libbirch::Shared<birch::type::NegativeBinomial>> Geometric(const birch::type::Real& _u0961, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
#line 107 "src/distribution/IdenticalGaussian.birch"
libbirch::Lazy<libbirch::Shared<birch::type::IdenticalGaussian>> Gaussian(const libbirch::Lazy<libbirch::Shared<birch::type::Expression<libbirch::DefaultArray<birch::type::Real,1>>>>& _u0956, const libbirch::Lazy<libbirch::Shared<birch::type::Expression<birch::type::Real>>>& _u09632, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
#line 116 "src/distribution/IdenticalGaussian.birch"
libbirch::Lazy<libbirch::Shared<birch::type::IdenticalGaussian>> Gaussian(const libbirch::Lazy<libbirch::Shared<birch::type::Expression<libbirch::DefaultArray<birch::type::Real,1>>>>& _u0956, const birch::type::Real& _u09632, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
#line 124 "src/distribution/IdenticalGaussian.birch"
libbirch::Lazy<libbirch::Shared<birch::type::IdenticalGaussian>> Gaussian(const libbirch::DefaultArray<birch::type::Real,1>& _u0956, const libbirch::Lazy<libbirch::Shared<birch::type::Expression<birch::type::Real>>>& _u09632, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
#line 132 "src/distribution/IdenticalGaussian.birch"
libbirch::Lazy<libbirch::Shared<birch::type::IdenticalGaussian>> Gaussian(const libbirch::DefaultArray<birch::type::Real,1>& _u0956, const birch::type::Real& _u09632, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
#line 87 "src/distribution/IndependentRowMatrixGaussian.birch"
libbirch::Lazy<libbirch::Shared<birch::type::IndependentRowMatrixGaussian>> Gaussian(const libbirch::Lazy<libbirch::Shared<birch::type::Expression<libbirch::DefaultArray<birch::type::Real,2>>>>& M, const libbirch::Lazy<libbirch::Shared<birch::type::Expression<birch::type::LLT>>>& V, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
#line 95 "src/distribution/IndependentRowMatrixGaussian.birch"
libbirch::Lazy<libbirch::Shared<birch::type::IndependentRowMatrixGaussian>> Gaussian(const libbirch::Lazy<libbirch::Shared<birch::type::Expression<libbirch::DefaultArray<birch::type::Real,2>>>>& M, const birch::type::LLT& V, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
#line 103 "src/distribution/IndependentRowMatrixGaussian.birch"
libbirch::Lazy<libbirch::Shared<birch::type::IndependentRowMatrixGaussian>> Gaussian(const libbirch::DefaultArray<birch::type::Real,2>& M, const libbirch::Lazy<libbirch::Shared<birch::type::Expression<birch::type::LLT>>>& V, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
#line 111 "src/distribution/IndependentRowMatrixGaussian.birch"
libbirch::Lazy<libbirch::Shared<birch::type::IndependentRowMatrixGaussian>> Gaussian(const libbirch::Lazy<libbirch::Shared<birch::type::Expression<libbirch::DefaultArray<birch::type::Real,2>>>>& M, const libbirch::Lazy<libbirch::Shared<birch::type::Expression<libbirch::DefaultArray<birch::type::Real,2>>>>& V, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
#line 119 "src/distribution/IndependentRowMatrixGaussian.birch"
libbirch::Lazy<libbirch::Shared<birch::type::IndependentRowMatrixGaussian>> Gaussian(const libbirch::Lazy<libbirch::Shared<birch::type::Expression<libbirch::DefaultArray<birch::type::Real,2>>>>& M, const libbirch::DefaultArray<birch::type::Real,2>& V, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
#line 127 "src/distribution/IndependentRowMatrixGaussian.birch"
libbirch::Lazy<libbirch::Shared<birch::type::IndependentRowMatrixGaussian>> Gaussian(const libbirch::DefaultArray<birch::type::Real,2>& M, const libbirch::Lazy<libbirch::Shared<birch::type::Expression<libbirch::DefaultArray<birch::type::Real,2>>>>& V, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
#line 52 "src/distribution/IndependentUniform.birch"
libbirch::Lazy<libbirch::Shared<birch::type::IndependentUniform>> Uniform(const libbirch::Lazy<libbirch::Shared<birch::type::Expression<libbirch::DefaultArray<birch::type::Real,1>>>>& l, const libbirch::Lazy<libbirch::Shared<birch::type::Expression<libbirch::DefaultArray<birch::type::Real,1>>>>& u, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
#line 61 "src/distribution/IndependentUniform.birch"
libbirch::Lazy<libbirch::Shared<birch::type::IndependentUniform>> Uniform(const libbirch::Lazy<libbirch::Shared<birch::type::Expression<libbirch::DefaultArray<birch::type::Real,1>>>>& l, const libbirch::DefaultArray<birch::type::Real,1>& u, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
#line 69 "src/distribution/IndependentUniform.birch"
libbirch::Lazy<libbirch::Shared<birch::type::IndependentUniform>> Uniform(const libbirch::DefaultArray<birch::type::Real,1>& l, const libbirch::Lazy<libbirch::Shared<birch::type::Expression<libbirch::DefaultArray<birch::type::Real,1>>>>& u, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
#line 77 "src/distribution/IndependentUniform.birch"
libbirch::Lazy<libbirch::Shared<birch::type::IndependentUniform>> Uniform(const libbirch::DefaultArray<birch::type::Real,1>& l, const libbirch::DefaultArray<birch::type::Real,1>& u, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
#line 53 "src/distribution/IndependentUniformInteger.birch"
libbirch::Lazy<libbirch::Shared<birch::type::IndependentUniformInteger>> Uniform(const libbirch::Lazy<libbirch::Shared<birch::type::Expression<libbirch::DefaultArray<birch::type::Integer,1>>>>& l, const libbirch::Lazy<libbirch::Shared<birch::type::Expression<libbirch::DefaultArray<birch::type::Integer,1>>>>& u, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
#line 62 "src/distribution/IndependentUniformInteger.birch"
libbirch::Lazy<libbirch::Shared<birch::type::IndependentUniformInteger>> Uniform(const libbirch::Lazy<libbirch::Shared<birch::type::Expression<libbirch::DefaultArray<birch::type::Integer,1>>>>& l, const libbirch::DefaultArray<birch::type::Integer,1>& u, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
#line 71 "src/distribution/IndependentUniformInteger.birch"
libbirch::Lazy<libbirch::Shared<birch::type::IndependentUniformInteger>> Uniform(const libbirch::DefaultArray<birch::type::Integer,1>& l, const libbirch::Lazy<libbirch::Shared<birch::type::Expression<libbirch::DefaultArray<birch::type::Integer,1>>>>& u, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
#line 80 "src/distribution/IndependentUniformInteger.birch"
libbirch::Lazy<libbirch::Shared<birch::type::IndependentUniformInteger>> Uniform(const libbirch::DefaultArray<birch::type::Integer,1>& l, const libbirch::DefaultArray<birch::type::Integer,1>& u, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
#line 64 "src/distribution/InverseGamma.birch"
libbirch::Lazy<libbirch::Shared<birch::type::InverseGamma>> InverseGamma(const libbirch::Lazy<libbirch::Shared<birch::type::Expression<birch::type::Real>>>& _u0945, const libbirch::Lazy<libbirch::Shared<birch::type::Expression<birch::type::Real>>>& _u0946, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
#line 72 "src/distribution/InverseGamma.birch"
libbirch::Lazy<libbirch::Shared<birch::type::InverseGamma>> InverseGamma(const libbirch::Lazy<libbirch::Shared<birch::type::Expression<birch::type::Real>>>& _u0945, const birch::type::Real& _u0946, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
#line 79 "src/distribution/InverseGamma.birch"
libbirch::Lazy<libbirch::Shared<birch::type::InverseGamma>> InverseGamma(const birch::type::Real& _u0945, const libbirch::Lazy<libbirch::Shared<birch::type::Expression<birch::type::Real>>>& _u0946, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
#line 86 "src/distribution/InverseGamma.birch"
libbirch::Lazy<libbirch::Shared<birch::type::InverseGamma>> InverseGamma(const birch::type::Real& _u0945, const birch::type::Real& _u0946, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
#line 61 "src/distribution/InverseGammaGamma.birch"
libbirch::Lazy<libbirch::Shared<birch::type::InverseGammaGamma>> InverseGammaGamma(const libbirch::Lazy<libbirch::Shared<birch::type::Expression<birch::type::Real>>>& k, const libbirch::Lazy<libbirch::Shared<birch::type::InverseGamma>>& _u0952, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
#line 86 "src/distribution/InverseWishart.birch"
libbirch::Lazy<libbirch::Shared<birch::type::InverseWishart>> InverseWishart(const libbirch::Lazy<libbirch::Shared<birch::type::Expression<birch::type::LLT>>>& _u0936, const libbirch::Lazy<libbirch::Shared<birch::type::Expression<birch::type::Real>>>& k, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
#line 94 "src/distribution/InverseWishart.birch"
libbirch::Lazy<libbirch::Shared<birch::type::InverseWishart>> InverseWishart(const libbirch::Lazy<libbirch::Shared<birch::type::Expression<birch::type::LLT>>>& _u0936, const birch::type::Real& k, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
#line 101 "src/distribution/InverseWishart.birch"
libbirch::Lazy<libbirch::Shared<birch::type::InverseWishart>> InverseWishart(const birch::type::LLT& _u0936, const libbirch::Lazy<libbirch::Shared<birch::type::Expression<birch::type::Real>>>& k, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
#line 108 "src/distribution/InverseWishart.birch"
libbirch::Lazy<libbirch::Shared<birch::type::InverseWishart>> InverseWishart(const birch::type::LLT& _u0936, const birch::type::Real& k, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
#line 115 "src/distribution/InverseWishart.birch"
libbirch::Lazy<libbirch::Shared<birch::type::InverseWishart>> InverseWishart(const libbirch::Lazy<libbirch::Shared<birch::type::Expression<libbirch::DefaultArray<birch::type::Real,2>>>>& _u0936, const libbirch::Lazy<libbirch::Shared<birch::type::Expression<birch::type::Real>>>& k, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
#line 123 "src/distribution/InverseWishart.birch"
libbirch::Lazy<libbirch::Shared<birch::type::InverseWishart>> InverseWishart(const libbirch::Lazy<libbirch::Shared<birch::type::Expression<libbirch::DefaultArray<birch::type::Real,2>>>>& _u0936, const birch::type::Real& k, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
#line 130 "src/distribution/InverseWishart.birch"
libbirch::Lazy<libbirch::Shared<birch::type::InverseWishart>> InverseWishart(const libbirch::DefaultArray<birch::type::Real,2>& _u0936, const libbirch::Lazy<libbirch::Shared<birch::type::Expression<birch::type::Real>>>& k, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
#line 137 "src/distribution/InverseWishart.birch"
libbirch::Lazy<libbirch::Shared<birch::type::InverseWishart>> InverseWishart(const libbirch::DefaultArray<birch::type::Real,2>& _u0936, const birch::type::Real& k, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
#line 99 "src/distribution/LinearBoundedDiscrete.birch"
libbirch::Lazy<libbirch::Shared<birch::type::LinearBoundedDiscrete>> LinearBoundedDiscrete(const libbirch::Lazy<libbirch::Shared<birch::type::Expression<birch::type::Integer>>>& a, const libbirch::Lazy<libbirch::Shared<birch::type::BoundedDiscrete>>& _u0956, const libbirch::Lazy<libbirch::Shared<birch::type::Expression<birch::type::Integer>>>& c, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
#line 97 "src/distribution/LinearDiscrete.birch"
libbirch::Lazy<libbirch::Shared<birch::type::LinearDiscrete>> LinearDiscrete(const libbirch::Lazy<libbirch::Shared<birch::type::Expression<birch::type::Integer>>>& a, const libbirch::Lazy<libbirch::Shared<birch::type::Discrete>>& _u0956, const libbirch::Lazy<libbirch::Shared<birch::type::Expression<birch::type::Integer>>>& c, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
#line 44 "src/distribution/LinearGaussianGaussian.birch"
libbirch::Lazy<libbirch::Shared<birch::type::LinearGaussianGaussian>> LinearGaussianGaussian(const libbirch::Lazy<libbirch::Shared<birch::type::Expression<birch::type::Real>>>& a, const libbirch::Lazy<libbirch::Shared<birch::type::Gaussian>>& _u0956, const libbirch::Lazy<libbirch::Shared<birch::type::Expression<birch::type::Real>>>& c, const libbirch::Lazy<libbirch::Shared<birch::type::Expression<birch::type::Real>>>& _u09632, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
#line 74 "src/distribution/LinearMatrixNormalInverseWishartMatrixGaussian.birch"
libbirch::Lazy<libbirch::Shared<birch::type::LinearMatrixNormalInverseWishartMatrixGaussian>> LinearMatrixNormalInverseWishartMatrixGaussian(const libbirch::Lazy<libbirch::Shared<birch::type::Expression<libbirch::DefaultArray<birch::type::Real,2>>>>& A, const libbirch::Lazy<libbirch::Shared<birch::type::MatrixNormalInverseWishart>>& M, const libbirch::Lazy<libbirch::Shared<birch::type::Expression<libbirch::DefaultArray<birch::type::Real,2>>>>& C, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
#line 72 "src/distribution/LinearMatrixNormalInverseWishartMultivariateGaussian.birch"
libbirch::Lazy<libbirch::Shared<birch::type::LinearMatrixNormalInverseWishartMultivariateGaussian>> LinearMatrixNormalInverseWishartMultivariateGaussian(const libbirch::Lazy<libbirch::Shared<birch::type::Expression<libbirch::DefaultArray<birch::type::Real,1>>>>& a, const libbirch::Lazy<libbirch::Shared<birch::type::MatrixNormalInverseWishart>>& M, const libbirch::Lazy<libbirch::Shared<birch::type::Expression<libbirch::DefaultArray<birch::type::Real,1>>>>& c, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
#line 46 "src/distribution/LinearMultivariateGaussianGaussian.birch"
libbirch::Lazy<libbirch::Shared<birch::type::LinearMultivariateGaussianGaussian>> LinearMultivariateGaussianGaussian(const libbirch::Lazy<libbirch::Shared<birch::type::Expression<libbirch::DefaultArray<birch::type::Real,1>>>>& a, const libbirch::Lazy<libbirch::Shared<birch::type::MultivariateGaussian>>& _u0956, const libbirch::Lazy<libbirch::Shared<birch::type::Expression<birch::type::Real>>>& c, const libbirch::Lazy<libbirch::Shared<birch::type::Expression<birch::type::Real>>>& _u09632, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
#line 47 "src/distribution/LinearMultivariateGaussianMultivariateGaussian.birch"
libbirch::Lazy<libbirch::Shared<birch::type::LinearMultivariateGaussianMultivariateGaussian>> LinearMultivariateGaussianMultivariateGaussian(const libbirch::Lazy<libbirch::Shared<birch::type::Expression<libbirch::DefaultArray<birch::type::Real,2>>>>& A, const libbirch::Lazy<libbirch::Shared<birch::type::MultivariateGaussian>>& _u0956, const libbirch::Lazy<libbirch::Shared<birch::type::Expression<libbirch::DefaultArray<birch::type::Real,1>>>>& c, const libbirch::Lazy<libbirch::Shared<birch::type::Expression<birch::type::LLT>>>& _u0931, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
#line 85 "src/distribution/LinearMultivariateNormalInverseGammaGaussian.birch"
libbirch::Lazy<libbirch::Shared<birch::type::LinearMultivariateNormalInverseGammaGaussian>> LinearMultivariateNormalInverseGammaGaussian(const libbirch::Lazy<libbirch::Shared<birch::type::Expression<libbirch::DefaultArray<birch::type::Real,1>>>>& a, const libbirch::Lazy<libbirch::Shared<birch::type::MultivariateNormalInverseGamma>>& _u0956, const libbirch::Lazy<libbirch::Shared<birch::type::Expression<birch::type::Real>>>& c, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
#line 70 "src/distribution/LinearMultivariateNormalInverseGammaMultivariateGaussian.birch"
libbirch::Lazy<libbirch::Shared<birch::type::LinearMultivariateNormalInverseGammaMultivariateGaussian>> LinearMultivariateNormalInverseGammaMultivariateGaussian(const libbirch::Lazy<libbirch::Shared<birch::type::Expression<libbirch::DefaultArray<birch::type::Real,2>>>>& A, const libbirch::Lazy<libbirch::Shared<birch::type::MultivariateNormalInverseGamma>>& _u0956, const libbirch::Lazy<libbirch::Shared<birch::type::Expression<libbirch::DefaultArray<birch::type::Real,1>>>>& c, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
#line 79 "src/distribution/LinearNormalInverseGammaGaussian.birch"
libbirch::Lazy<libbirch::Shared<birch::type::LinearNormalInverseGammaGaussian>> LinearNormalInverseGammaGaussian(const libbirch::Lazy<libbirch::Shared<birch::type::Expression<birch::type::Real>>>& a, const libbirch::Lazy<libbirch::Shared<birch::type::NormalInverseGamma>>& _u0956, const libbirch::Lazy<libbirch::Shared<birch::type::Expression<birch::type::Real>>>& c, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
#line 97 "src/distribution/MatrixGaussian.birch"
libbirch::Lazy<libbirch::Shared<birch::type::MatrixGaussian>> Gaussian(const libbirch::Lazy<libbirch::Shared<birch::type::Expression<libbirch::DefaultArray<birch::type::Real,2>>>>& M, const libbirch::Lazy<libbirch::Shared<birch::type::Expression<birch::type::LLT>>>& U, const libbirch::Lazy<libbirch::Shared<birch::type::Expression<birch::type::LLT>>>& V, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
#line 105 "src/distribution/MatrixGaussian.birch"
libbirch::Lazy<libbirch::Shared<birch::type::MatrixGaussian>> Gaussian(const libbirch::Lazy<libbirch::Shared<birch::type::Expression<libbirch::DefaultArray<birch::type::Real,2>>>>& M, const libbirch::Lazy<libbirch::Shared<birch::type::Expression<birch::type::LLT>>>& U, const birch::type::LLT& V, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
#line 113 "src/distribution/MatrixGaussian.birch"
libbirch::Lazy<libbirch::Shared<birch::type::MatrixGaussian>> Gaussian(const libbirch::Lazy<libbirch::Shared<birch::type::Expression<libbirch::DefaultArray<birch::type::Real,2>>>>& M, const birch::type::LLT& U, const libbirch::Lazy<libbirch::Shared<birch::type::Expression<birch::type::LLT>>>& V, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
#line 121 "src/distribution/MatrixGaussian.birch"
libbirch::Lazy<libbirch::Shared<birch::type::MatrixGaussian>> Gaussian(const libbirch::Lazy<libbirch::Shared<birch::type::Expression<libbirch::DefaultArray<birch::type::Real,2>>>>& M, const birch::type::LLT& U, const birch::type::LLT& V, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
#line 129 "src/distribution/MatrixGaussian.birch"
libbirch::Lazy<libbirch::Shared<birch::type::MatrixGaussian>> Gaussian(const libbirch::DefaultArray<birch::type::Real,2>& M, const libbirch::Lazy<libbirch::Shared<birch::type::Expression<birch::type::LLT>>>& U, const libbirch::Lazy<libbirch::Shared<birch::type::Expression<birch::type::LLT>>>& V, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
#line 137 "src/distribution/MatrixGaussian.birch"
libbirch::Lazy<libbirch::Shared<birch::type::MatrixGaussian>> Gaussian(const libbirch::DefaultArray<birch::type::Real,2>& M, const libbirch::Lazy<libbirch::Shared<birch::type::Expression<birch::type::LLT>>>& U, const birch::type::LLT& V, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
#line 144 "src/distribution/MatrixGaussian.birch"
libbirch::Lazy<libbirch::Shared<birch::type::MatrixGaussian>> Gaussian(const libbirch::DefaultArray<birch::type::Real,2>& M, const birch::type::LLT& U, const libbirch::Lazy<libbirch::Shared<birch::type::Expression<birch::type::LLT>>>& V, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
#line 151 "src/distribution/MatrixGaussian.birch"
libbirch::Lazy<libbirch::Shared<birch::type::MatrixGaussian>> Gaussian(const libbirch::DefaultArray<birch::type::Real,2>& M, const birch::type::LLT& U, const birch::type::LLT& V, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
#line 158 "src/distribution/MatrixGaussian.birch"
libbirch::Lazy<libbirch::Shared<birch::type::MatrixGaussian>> Gaussian(const libbirch::Lazy<libbirch::Shared<birch::type::Expression<libbirch::DefaultArray<birch::type::Real,2>>>>& M, const libbirch::Lazy<libbirch::Shared<birch::type::Expression<libbirch::DefaultArray<birch::type::Real,2>>>>& U, const libbirch::Lazy<libbirch::Shared<birch::type::Expression<birch::type::LLT>>>& V, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
#line 166 "src/distribution/MatrixGaussian.birch"
libbirch::Lazy<libbirch::Shared<birch::type::MatrixGaussian>> Gaussian(const libbirch::Lazy<libbirch::Shared<birch::type::Expression<libbirch::DefaultArray<birch::type::Real,2>>>>& M, const libbirch::Lazy<libbirch::Shared<birch::type::Expression<libbirch::DefaultArray<birch::type::Real,2>>>>& U, const birch::type::LLT& V, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
#line 174 "src/distribution/MatrixGaussian.birch"
libbirch::Lazy<libbirch::Shared<birch::type::MatrixGaussian>> Gaussian(const libbirch::Lazy<libbirch::Shared<birch::type::Expression<libbirch::DefaultArray<birch::type::Real,2>>>>& M, const libbirch::DefaultArray<birch::type::Real,2>& U, const libbirch::Lazy<libbirch::Shared<birch::type::Expression<birch::type::LLT>>>& V, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
#line 182 "src/distribution/MatrixGaussian.birch"
libbirch::Lazy<libbirch::Shared<birch::type::MatrixGaussian>> Gaussian(const libbirch::Lazy<libbirch::Shared<birch::type::Expression<libbirch::DefaultArray<birch::type::Real,2>>>>& M, const libbirch::DefaultArray<birch::type::Real,2>& U, const birch::type::LLT& V, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
#line 190 "src/distribution/MatrixGaussian.birch"
libbirch::Lazy<libbirch::Shared<birch::type::MatrixGaussian>> Gaussian(const libbirch::DefaultArray<birch::type::Real,2>& M, const libbirch::Lazy<libbirch::Shared<birch::type::Expression<libbirch::DefaultArray<birch::type::Real,2>>>>& U, const libbirch::Lazy<libbirch::Shared<birch::type::Expression<birch::type::LLT>>>& V, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
#line 198 "src/distribution/MatrixGaussian.birch"
libbirch::Lazy<libbirch::Shared<birch::type::MatrixGaussian>> Gaussian(const libbirch::DefaultArray<birch::type::Real,2>& M, const libbirch::Lazy<libbirch::Shared<birch::type::Expression<libbirch::DefaultArray<birch::type::Real,2>>>>& U, const birch::type::LLT& V, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
#line 205 "src/distribution/MatrixGaussian.birch"
libbirch::Lazy<libbirch::Shared<birch::type::MatrixGaussian>> Gaussian(const libbirch::DefaultArray<birch::type::Real,2>& M, const libbirch::DefaultArray<birch::type::Real,2>& U, const libbirch::Lazy<libbirch::Shared<birch::type::Expression<birch::type::LLT>>>& V, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
#line 212 "src/distribution/MatrixGaussian.birch"
libbirch::Lazy<libbirch::Shared<birch::type::MatrixGaussian>> Gaussian(const libbirch::DefaultArray<birch::type::Real,2>& M, const libbirch::DefaultArray<birch::type::Real,2>& U, const birch::type::LLT& V, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
#line 219 "src/distribution/MatrixGaussian.birch"
libbirch::Lazy<libbirch::Shared<birch::type::MatrixGaussian>> Gaussian(const libbirch::Lazy<libbirch::Shared<birch::type::Expression<libbirch::DefaultArray<birch::type::Real,2>>>>& M, const libbirch::Lazy<libbirch::Shared<birch::type::Expression<birch::type::LLT>>>& U, const libbirch::Lazy<libbirch::Shared<birch::type::Expression<libbirch::DefaultArray<birch::type::Real,2>>>>& V, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
#line 227 "src/distribution/MatrixGaussian.birch"
libbirch::Lazy<libbirch::Shared<birch::type::MatrixGaussian>> Gaussian(const libbirch::Lazy<libbirch::Shared<birch::type::Expression<libbirch::DefaultArray<birch::type::Real,2>>>>& M, const libbirch::Lazy<libbirch::Shared<birch::type::Expression<birch::type::LLT>>>& U, const libbirch::DefaultArray<birch::type::Real,2>& V, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
#line 235 "src/distribution/MatrixGaussian.birch"
libbirch::Lazy<libbirch::Shared<birch::type::MatrixGaussian>> Gaussian(const libbirch::Lazy<libbirch::Shared<birch::type::Expression<libbirch::DefaultArray<birch::type::Real,2>>>>& M, const birch::type::LLT& U, const libbirch::Lazy<libbirch::Shared<birch::type::Expression<libbirch::DefaultArray<birch::type::Real,2>>>>& V, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
#line 243 "src/distribution/MatrixGaussian.birch"
libbirch::Lazy<libbirch::Shared<birch::type::MatrixGaussian>> Gaussian(const libbirch::Lazy<libbirch::Shared<birch::type::Expression<libbirch::DefaultArray<birch::type::Real,2>>>>& M, const birch::type::LLT& U, const libbirch::DefaultArray<birch::type::Real,2>& V, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
#line 251 "src/distribution/MatrixGaussian.birch"
libbirch::Lazy<libbirch::Shared<birch::type::MatrixGaussian>> Gaussian(const libbirch::DefaultArray<birch::type::Real,2>& M, const libbirch::Lazy<libbirch::Shared<birch::type::Expression<birch::type::LLT>>>& U, const libbirch::Lazy<libbirch::Shared<birch::type::Expression<libbirch::DefaultArray<birch::type::Real,2>>>>& V, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
#line 259 "src/distribution/MatrixGaussian.birch"
libbirch::Lazy<libbirch::Shared<birch::type::MatrixGaussian>> Gaussian(const libbirch::DefaultArray<birch::type::Real,2>& M, const libbirch::Lazy<libbirch::Shared<birch::type::Expression<birch::type::LLT>>>& U, const libbirch::DefaultArray<birch::type::Real,2>& V, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
#line 267 "src/distribution/MatrixGaussian.birch"
libbirch::Lazy<libbirch::Shared<birch::type::MatrixGaussian>> Gaussian(const libbirch::DefaultArray<birch::type::Real,2>& M, const birch::type::LLT& U, const libbirch::Lazy<libbirch::Shared<birch::type::Expression<libbirch::DefaultArray<birch::type::Real,2>>>>& V, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
#line 275 "src/distribution/MatrixGaussian.birch"
libbirch::Lazy<libbirch::Shared<birch::type::MatrixGaussian>> Gaussian(const libbirch::DefaultArray<birch::type::Real,2>& M, const birch::type::LLT& U, const libbirch::DefaultArray<birch::type::Real,2>& V, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
#line 282 "src/distribution/MatrixGaussian.birch"
libbirch::Lazy<libbirch::Shared<birch::type::MatrixGaussian>> Gaussian(const libbirch::Lazy<libbirch::Shared<birch::type::Expression<libbirch::DefaultArray<birch::type::Real,2>>>>& M, const libbirch::Lazy<libbirch::Shared<birch::type::Expression<libbirch::DefaultArray<birch::type::Real,2>>>>& U, const libbirch::Lazy<libbirch::Shared<birch::type::Expression<libbirch::DefaultArray<birch::type::Real,2>>>>& V, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
#line 290 "src/distribution/MatrixGaussian.birch"
libbirch::Lazy<libbirch::Shared<birch::type::MatrixGaussian>> Gaussian(const libbirch::Lazy<libbirch::Shared<birch::type::Expression<libbirch::DefaultArray<birch::type::Real,2>>>>& M, const libbirch::Lazy<libbirch::Shared<birch::type::Expression<libbirch::DefaultArray<birch::type::Real,2>>>>& U, const libbirch::DefaultArray<birch::type::Real,2>& V, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
#line 298 "src/distribution/MatrixGaussian.birch"
libbirch::Lazy<libbirch::Shared<birch::type::MatrixGaussian>> Gaussian(const libbirch::Lazy<libbirch::Shared<birch::type::Expression<libbirch::DefaultArray<birch::type::Real,2>>>>& M, const libbirch::DefaultArray<birch::type::Real,2>& U, const libbirch::Lazy<libbirch::Shared<birch::type::Expression<libbirch::DefaultArray<birch::type::Real,2>>>>& V, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
#line 306 "src/distribution/MatrixGaussian.birch"
libbirch::Lazy<libbirch::Shared<birch::type::MatrixGaussian>> Gaussian(const libbirch::Lazy<libbirch::Shared<birch::type::Expression<libbirch::DefaultArray<birch::type::Real,2>>>>& M, const libbirch::DefaultArray<birch::type::Real,2>& U, const libbirch::DefaultArray<birch::type::Real,2>& V, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
#line 314 "src/distribution/MatrixGaussian.birch"
libbirch::Lazy<libbirch::Shared<birch::type::MatrixGaussian>> Gaussian(const libbirch::DefaultArray<birch::type::Real,2>& M, const libbirch::Lazy<libbirch::Shared<birch::type::Expression<libbirch::DefaultArray<birch::type::Real,2>>>>& U, const libbirch::Lazy<libbirch::Shared<birch::type::Expression<libbirch::DefaultArray<birch::type::Real,2>>>>& V, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
#line 322 "src/distribution/MatrixGaussian.birch"
libbirch::Lazy<libbirch::Shared<birch::type::MatrixGaussian>> Gaussian(const libbirch::DefaultArray<birch::type::Real,2>& M, const libbirch::Lazy<libbirch::Shared<birch::type::Expression<libbirch::DefaultArray<birch::type::Real,2>>>>& U, const libbirch::DefaultArray<birch::type::Real,2>& V, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
#line 330 "src/distribution/MatrixGaussian.birch"
libbirch::Lazy<libbirch::Shared<birch::type::MatrixGaussian>> Gaussian(const libbirch::DefaultArray<birch::type::Real,2>& M, const libbirch::DefaultArray<birch::type::Real,2>& U, const libbirch::Lazy<libbirch::Shared<birch::type::Expression<libbirch::DefaultArray<birch::type::Real,2>>>>& V, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
#line 338 "src/distribution/MatrixGaussian.birch"
libbirch::Lazy<libbirch::Shared<birch::type::MatrixGaussian>> Gaussian(const libbirch::DefaultArray<birch::type::Real,2>& M, const libbirch::DefaultArray<birch::type::Real,2>& U, const libbirch::DefaultArray<birch::type::Real,2>& V, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
#line 85 "src/distribution/MatrixNormalInverseWishart.birch"
libbirch::Lazy<libbirch::Shared<birch::type::MatrixNormalInverseWishart>> MatrixNormalInverseWishart(const libbirch::Lazy<libbirch::Shared<birch::type::Expression<libbirch::DefaultArray<birch::type::Real,2>>>>& M, const libbirch::Lazy<libbirch::Shared<birch::type::Expression<birch::type::LLT>>>& U, const libbirch::Lazy<libbirch::Shared<birch::type::InverseWishart>>& V, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
#line 62 "src/distribution/MatrixNormalInverseWishartMatrixGaussian.birch"
libbirch::Lazy<libbirch::Shared<birch::type::MatrixNormalInverseWishartMatrixGaussian>> MatrixNormalInverseWishartMatrixGaussian(const libbirch::Lazy<libbirch::Shared<birch::type::MatrixNormalInverseWishart>>& M, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
#line 64 "src/distribution/Multinomial.birch"
libbirch::Lazy<libbirch::Shared<birch::type::Multinomial>> Multinomial(const libbirch::Lazy<libbirch::Shared<birch::type::Expression<birch::type::Integer>>>& n, const libbirch::Lazy<libbirch::Shared<birch::type::Expression<libbirch::DefaultArray<birch::type::Real,1>>>>& _u0961, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
#line 72 "src/distribution/Multinomial.birch"
libbirch::Lazy<libbirch::Shared<birch::type::Multinomial>> Multinomial(const libbirch::Lazy<libbirch::Shared<birch::type::Expression<birch::type::Integer>>>& n, const libbirch::DefaultArray<birch::type::Real,1>& _u0961, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
#line 79 "src/distribution/Multinomial.birch"
libbirch::Lazy<libbirch::Shared<birch::type::Multinomial>> Multinomial(const birch::type::Integer& n, const libbirch::Lazy<libbirch::Shared<birch::type::Expression<libbirch::DefaultArray<birch::type::Real,1>>>>& _u0961, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
#line 86 "src/distribution/Multinomial.birch"
libbirch::Lazy<libbirch::Shared<birch::type::Multinomial>> Multinomial(const birch::type::Integer& n, const libbirch::DefaultArray<birch::type::Real,1>& _u0961, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
#line 92 "src/distribution/MultivariateGaussian.birch"
libbirch::Lazy<libbirch::Shared<birch::type::MultivariateGaussian>> Gaussian(const libbirch::Lazy<libbirch::Shared<birch::type::Expression<libbirch::DefaultArray<birch::type::Real,1>>>>& _u0956, const libbirch::Lazy<libbirch::Shared<birch::type::Expression<birch::type::LLT>>>& _u0931, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
#line 100 "src/distribution/MultivariateGaussian.birch"
libbirch::Lazy<libbirch::Shared<birch::type::MultivariateGaussian>> Gaussian(const libbirch::Lazy<libbirch::Shared<birch::type::Expression<libbirch::DefaultArray<birch::type::Real,1>>>>& _u0956, const birch::type::LLT& _u0931, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
#line 107 "src/distribution/MultivariateGaussian.birch"
libbirch::Lazy<libbirch::Shared<birch::type::MultivariateGaussian>> Gaussian(const libbirch::DefaultArray<birch::type::Real,1>& _u0956, const libbirch::Lazy<libbirch::Shared<birch::type::Expression<birch::type::LLT>>>& _u0931, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
#line 114 "src/distribution/MultivariateGaussian.birch"
libbirch::Lazy<libbirch::Shared<birch::type::MultivariateGaussian>> Gaussian(const libbirch::DefaultArray<birch::type::Real,1>& _u0956, const birch::type::LLT& _u0931, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
#line 121 "src/distribution/MultivariateGaussian.birch"
libbirch::Lazy<libbirch::Shared<birch::type::MultivariateGaussian>> Gaussian(const libbirch::Lazy<libbirch::Shared<birch::type::Expression<libbirch::DefaultArray<birch::type::Real,1>>>>& _u0956, const libbirch::Lazy<libbirch::Shared<birch::type::Expression<libbirch::DefaultArray<birch::type::Real,2>>>>& _u0931, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
#line 129 "src/distribution/MultivariateGaussian.birch"
libbirch::Lazy<libbirch::Shared<birch::type::MultivariateGaussian>> Gaussian(const libbirch::Lazy<libbirch::Shared<birch::type::Expression<libbirch::DefaultArray<birch::type::Real,1>>>>& _u0956, const libbirch::DefaultArray<birch::type::Real,2>& _u0931, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
#line 137 "src/distribution/MultivariateGaussian.birch"
libbirch::Lazy<libbirch::Shared<birch::type::MultivariateGaussian>> Gaussian(const libbirch::DefaultArray<birch::type::Real,1>& _u0956, const libbirch::Lazy<libbirch::Shared<birch::type::Expression<libbirch::DefaultArray<birch::type::Real,2>>>>& _u0931, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
#line 145 "src/distribution/MultivariateGaussian.birch"
libbirch::Lazy<libbirch::Shared<birch::type::MultivariateGaussian>> Gaussian(const libbirch::DefaultArray<birch::type::Real,1>& _u0956, const libbirch::DefaultArray<birch::type::Real,2>& _u0931, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
#line 34 "src/distribution/MultivariateGaussianMultivariateGaussian.birch"
libbirch::Lazy<libbirch::Shared<birch::type::MultivariateGaussianMultivariateGaussian>> MultivariateGaussianMultivariateGaussian(const libbirch::Lazy<libbirch::Shared<birch::type::MultivariateGaussian>>& _u0956, const libbirch::Lazy<libbirch::Shared<birch::type::Expression<birch::type::LLT>>>& _u0931, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
#line 128 "src/distribution/MultivariateNormalInverseGamma.birch"
libbirch::Lazy<libbirch::Shared<birch::type::MultivariateNormalInverseGamma>> MultivariateNormalInverseGamma(const libbirch::Lazy<libbirch::Shared<birch::type::Expression<libbirch::DefaultArray<birch::type::Real,1>>>>& _u0956, const libbirch::Lazy<libbirch::Shared<birch::type::Expression<birch::type::LLT>>>& _u0931, const libbirch::Lazy<libbirch::Shared<birch::type::InverseGamma>>& _u09632, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
#line 139 "src/distribution/MultivariateNormalInverseGamma.birch"
birch::type::Real gamma_to_beta(const birch::type::Real& _u0947, const libbirch::DefaultArray<birch::type::Real,1>& _u0957, const birch::type::LLT& _u0923, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
#line 147 "src/distribution/MultivariateNormalInverseGamma.birch"
libbirch::Lazy<libbirch::Shared<birch::type::Expression<birch::type::Real>>> gamma_to_beta(const libbirch::Lazy<libbirch::Shared<birch::type::Expression<birch::type::Real>>>& _u0947, const libbirch::Lazy<libbirch::Shared<birch::type::Expression<libbirch::DefaultArray<birch::type::Real,1>>>>& _u0957, const libbirch::Lazy<libbirch::Shared<birch::type::Expression<birch::type::LLT>>>& _u0923, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
#line 58 "src/distribution/MultivariateNormalInverseGammaMultivariateGaussian.birch"
libbirch::Lazy<libbirch::Shared<birch::type::MultivariateNormalInverseGammaMultivariateGaussian>> MultivariateNormalInverseGammaMultivariateGaussian(const libbirch::Lazy<libbirch::Shared<birch::type::MultivariateNormalInverseGamma>>& _u0956, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
#line 80 "src/distribution/NegativeBinomial.birch"
libbirch::Lazy<libbirch::Shared<birch::type::NegativeBinomial>> NegativeBinomial(const libbirch::Lazy<libbirch::Shared<birch::type::Expression<birch::type::Integer>>>& k, const libbirch::Lazy<libbirch::Shared<birch::type::Expression<birch::type::Real>>>& _u0961, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
#line 88 "src/distribution/NegativeBinomial.birch"
libbirch::Lazy<libbirch::Shared<birch::type::NegativeBinomial>> NegativeBinomial(const libbirch::Lazy<libbirch::Shared<birch::type::Expression<birch::type::Integer>>>& k, const birch::type::Real& _u0961, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
#line 95 "src/distribution/NegativeBinomial.birch"
libbirch::Lazy<libbirch::Shared<birch::type::NegativeBinomial>> NegativeBinomial(const birch::type::Integer& k, const libbirch::Lazy<libbirch::Shared<birch::type::Expression<birch::type::Real>>>& _u0961, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
#line 102 "src/distribution/NegativeBinomial.birch"
libbirch::Lazy<libbirch::Shared<birch::type::NegativeBinomial>> NegativeBinomial(const birch::type::Integer& k, const birch::type::Real& _u0961, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
#line 109 "src/distribution/NormalInverseGamma.birch"
libbirch::Lazy<libbirch::Shared<birch::type::NormalInverseGamma>> NormalInverseGamma(const libbirch::Lazy<libbirch::Shared<birch::type::Expression<birch::type::Real>>>& _u0956, const libbirch::Lazy<libbirch::Shared<birch::type::Expression<birch::type::Real>>>& a2, const libbirch::Lazy<libbirch::Shared<birch::type::InverseGamma>>& _u09632, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
#line 64 "src/distribution/NormalInverseGammaGaussian.birch"
libbirch::Lazy<libbirch::Shared<birch::type::NormalInverseGammaGaussian>> NormalInverseGammaGaussian(const libbirch::Lazy<libbirch::Shared<birch::type::NormalInverseGamma>>& _u0956, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
#line 76 "src/distribution/Poisson.birch"
libbirch::Lazy<libbirch::Shared<birch::type::Poisson>> Poisson(const libbirch::Lazy<libbirch::Shared<birch::type::Expression<birch::type::Real>>>& _u0955, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
#line 83 "src/distribution/Poisson.birch"
libbirch::Lazy<libbirch::Shared<birch::type::Poisson>> Poisson(const birch::type::Real& _u0955, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
#line 76 "src/distribution/Restaurant.birch"
libbirch::Lazy<libbirch::Shared<birch::type::Restaurant>> Restaurant(const libbirch::Lazy<libbirch::Shared<birch::type::Expression<birch::type::Real>>>& _u0945, const libbirch::Lazy<libbirch::Shared<birch::type::Expression<birch::type::Real>>>& _u0952, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
#line 83 "src/distribution/Restaurant.birch"
libbirch::Lazy<libbirch::Shared<birch::type::Restaurant>> Restaurant(const libbirch::Lazy<libbirch::Shared<birch::type::Expression<birch::type::Real>>>& _u0945, const birch::type::Real& _u0952, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
#line 90 "src/distribution/Restaurant.birch"
libbirch::Lazy<libbirch::Shared<birch::type::Restaurant>> Restaurant(const birch::type::Real& _u0945, const libbirch::Lazy<libbirch::Shared<birch::type::Expression<birch::type::Real>>>& _u0952, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
#line 97 "src/distribution/Restaurant.birch"
libbirch::Lazy<libbirch::Shared<birch::type::Restaurant>> Restaurant(const birch::type::Real& _u0945, const birch::type::Real& _u0952, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
#line 58 "src/distribution/RestaurantCategorical.birch"
libbirch::Lazy<libbirch::Shared<birch::type::RestaurantCategorical>> RestaurantCategorical(const libbirch::Lazy<libbirch::Shared<birch::type::Restaurant>>& _u0961, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
#line 92 "src/distribution/ScalarGaussian.birch"
libbirch::Lazy<libbirch::Shared<birch::type::ScalarGaussian>> Gaussian(const libbirch::Lazy<libbirch::Shared<birch::type::Expression<birch::type::Real>>>& _u0956, const libbirch::Lazy<libbirch::Shared<birch::type::Expression<birch::type::Real>>>& _u09632, const libbirch::Lazy<libbirch::Shared<birch::type::Expression<birch::type::Real>>>& _u09642, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
#line 102 "src/distribution/ScalarGaussian.birch"
libbirch::Lazy<libbirch::Shared<birch::type::ScalarGaussian>> Gaussian(const libbirch::Lazy<libbirch::Shared<birch::type::Expression<birch::type::Real>>>& _u0956, const libbirch::Lazy<libbirch::Shared<birch::type::Expression<birch::type::Real>>>& _u09632, const birch::type::Real& _u09642, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
#line 112 "src/distribution/ScalarGaussian.birch"
libbirch::Lazy<libbirch::Shared<birch::type::ScalarGaussian>> Gaussian(const libbirch::Lazy<libbirch::Shared<birch::type::Expression<birch::type::Real>>>& _u0956, const birch::type::Real& _u09632, const libbirch::Lazy<libbirch::Shared<birch::type::Expression<birch::type::Real>>>& _u09642, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
#line 122 "src/distribution/ScalarGaussian.birch"
libbirch::Lazy<libbirch::Shared<birch::type::ScalarGaussian>> Gaussian(const libbirch::Lazy<libbirch::Shared<birch::type::Expression<birch::type::Real>>>& _u0956, const birch::type::Real& _u09632, const birch::type::Real& _u09642, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
#line 132 "src/distribution/ScalarGaussian.birch"
libbirch::Lazy<libbirch::Shared<birch::type::ScalarGaussian>> Gaussian(const birch::type::Real& _u0956, const libbirch::Lazy<libbirch::Shared<birch::type::Expression<birch::type::Real>>>& _u09632, const libbirch::Lazy<libbirch::Shared<birch::type::Expression<birch::type::Real>>>& _u09642, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
#line 142 "src/distribution/ScalarGaussian.birch"
libbirch::Lazy<libbirch::Shared<birch::type::ScalarGaussian>> Gaussian(const birch::type::Real& _u0956, const libbirch::Lazy<libbirch::Shared<birch::type::Expression<birch::type::Real>>>& _u09632, const birch::type::Real& _u09642, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
#line 152 "src/distribution/ScalarGaussian.birch"
libbirch::Lazy<libbirch::Shared<birch::type::ScalarGaussian>> Gaussian(const birch::type::Real& _u0956, const birch::type::Real& _u09632, const libbirch::Lazy<libbirch::Shared<birch::type::Expression<birch::type::Real>>>& _u09642, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
#line 162 "src/distribution/ScalarGaussian.birch"
libbirch::Lazy<libbirch::Shared<birch::type::ScalarGaussian>> Gaussian(const birch::type::Real& _u0956, const birch::type::Real& _u09632, const birch::type::Real& _u09642, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
#line 85 "src/distribution/ScalarMultivariateGaussian.birch"
libbirch::Lazy<libbirch::Shared<birch::type::ScalarMultivariateGaussian>> Gaussian(const libbirch::Lazy<libbirch::Shared<birch::type::Expression<libbirch::DefaultArray<birch::type::Real,1>>>>& _u0956, const libbirch::Lazy<libbirch::Shared<birch::type::Expression<birch::type::LLT>>>& _u0931, const libbirch::Lazy<libbirch::Shared<birch::type::Expression<birch::type::Real>>>& _u09632, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
#line 96 "src/distribution/ScalarMultivariateGaussian.birch"
libbirch::Lazy<libbirch::Shared<birch::type::ScalarMultivariateGaussian>> Gaussian(const libbirch::Lazy<libbirch::Shared<birch::type::Expression<libbirch::DefaultArray<birch::type::Real,1>>>>& _u0956, const libbirch::Lazy<libbirch::Shared<birch::type::Expression<birch::type::LLT>>>& _u0931, const birch::type::Real& _u09632, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
#line 107 "src/distribution/ScalarMultivariateGaussian.birch"
libbirch::Lazy<libbirch::Shared<birch::type::ScalarMultivariateGaussian>> Gaussian(const libbirch::Lazy<libbirch::Shared<birch::type::Expression<libbirch::DefaultArray<birch::type::Real,1>>>>& _u0956, const birch::type::LLT& _u0931, const libbirch::Lazy<libbirch::Shared<birch::type::Expression<birch::type::Real>>>& _u09632, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
#line 118 "src/distribution/ScalarMultivariateGaussian.birch"
libbirch::Lazy<libbirch::Shared<birch::type::ScalarMultivariateGaussian>> Gaussian(const libbirch::Lazy<libbirch::Shared<birch::type::Expression<libbirch::DefaultArray<birch::type::Real,1>>>>& _u0956, const birch::type::LLT& _u0931, const birch::type::Real& _u09632, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
#line 129 "src/distribution/ScalarMultivariateGaussian.birch"
libbirch::Lazy<libbirch::Shared<birch::type::ScalarMultivariateGaussian>> Gaussian(const libbirch::DefaultArray<birch::type::Real,1>& _u0956, const libbirch::Lazy<libbirch::Shared<birch::type::Expression<birch::type::LLT>>>& _u0931, const libbirch::Lazy<libbirch::Shared<birch::type::Expression<birch::type::Real>>>& _u09632, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
#line 140 "src/distribution/ScalarMultivariateGaussian.birch"
libbirch::Lazy<libbirch::Shared<birch::type::ScalarMultivariateGaussian>> Gaussian(const libbirch::DefaultArray<birch::type::Real,1>& _u0956, const libbirch::Lazy<libbirch::Shared<birch::type::Expression<birch::type::LLT>>>& _u0931, const birch::type::Real& _u09632, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
#line 151 "src/distribution/ScalarMultivariateGaussian.birch"
libbirch::Lazy<libbirch::Shared<birch::type::ScalarMultivariateGaussian>> Gaussian(const libbirch::DefaultArray<birch::type::Real,1>& _u0956, const birch::type::LLT& _u0931, const libbirch::Lazy<libbirch::Shared<birch::type::Expression<birch::type::Real>>>& _u09632, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
#line 162 "src/distribution/ScalarMultivariateGaussian.birch"
libbirch::Lazy<libbirch::Shared<birch::type::ScalarMultivariateGaussian>> Gaussian(const libbirch::DefaultArray<birch::type::Real,1>& _u0956, const birch::type::LLT& _u0931, const birch::type::Real& _u09632, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
#line 172 "src/distribution/ScalarMultivariateGaussian.birch"
libbirch::Lazy<libbirch::Shared<birch::type::ScalarMultivariateGaussian>> Gaussian(const libbirch::Lazy<libbirch::Shared<birch::type::Expression<libbirch::DefaultArray<birch::type::Real,1>>>>& _u0956, const libbirch::Lazy<libbirch::Shared<birch::type::Expression<libbirch::DefaultArray<birch::type::Real,2>>>>& _u0931, const libbirch::Lazy<libbirch::Shared<birch::type::Expression<birch::type::Real>>>& _u09632, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
#line 184 "src/distribution/ScalarMultivariateGaussian.birch"
libbirch::Lazy<libbirch::Shared<birch::type::ScalarMultivariateGaussian>> Gaussian(const libbirch::Lazy<libbirch::Shared<birch::type::Expression<libbirch::DefaultArray<birch::type::Real,1>>>>& _u0956, const libbirch::Lazy<libbirch::Shared<birch::type::Expression<libbirch::DefaultArray<birch::type::Real,2>>>>& _u0931, const birch::type::Real& _u09632, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
#line 195 "src/distribution/ScalarMultivariateGaussian.birch"
libbirch::Lazy<libbirch::Shared<birch::type::ScalarMultivariateGaussian>> Gaussian(const libbirch::Lazy<libbirch::Shared<birch::type::Expression<libbirch::DefaultArray<birch::type::Real,1>>>>& _u0956, const libbirch::DefaultArray<birch::type::Real,2>& _u0931, const libbirch::Lazy<libbirch::Shared<birch::type::Expression<birch::type::Real>>>& _u09632, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
#line 206 "src/distribution/ScalarMultivariateGaussian.birch"
libbirch::Lazy<libbirch::Shared<birch::type::ScalarMultivariateGaussian>> Gaussian(const libbirch::Lazy<libbirch::Shared<birch::type::Expression<libbirch::DefaultArray<birch::type::Real,1>>>>& _u0956, const libbirch::DefaultArray<birch::type::Real,2>& _u0931, const birch::type::Real& _u09632, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
#line 217 "src/distribution/ScalarMultivariateGaussian.birch"
libbirch::Lazy<libbirch::Shared<birch::type::ScalarMultivariateGaussian>> Gaussian(const libbirch::DefaultArray<birch::type::Real,1>& _u0956, const libbirch::Lazy<libbirch::Shared<birch::type::Expression<libbirch::DefaultArray<birch::type::Real,2>>>>& _u0931, const libbirch::Lazy<libbirch::Shared<birch::type::Expression<birch::type::Real>>>& _u09632, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
#line 228 "src/distribution/ScalarMultivariateGaussian.birch"
libbirch::Lazy<libbirch::Shared<birch::type::ScalarMultivariateGaussian>> Gaussian(const libbirch::DefaultArray<birch::type::Real,1>& _u0956, const libbirch::Lazy<libbirch::Shared<birch::type::Expression<libbirch::DefaultArray<birch::type::Real,2>>>>& _u0931, const birch::type::Real& _u09632, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
#line 239 "src/distribution/ScalarMultivariateGaussian.birch"
libbirch::Lazy<libbirch::Shared<birch::type::ScalarMultivariateGaussian>> Gaussian(const libbirch::DefaultArray<birch::type::Real,1>& _u0956, const libbirch::DefaultArray<birch::type::Real,2>& _u0931, const libbirch::Lazy<libbirch::Shared<birch::type::Expression<birch::type::Real>>>& _u09632, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
#line 250 "src/distribution/ScalarMultivariateGaussian.birch"
libbirch::Lazy<libbirch::Shared<birch::type::ScalarMultivariateGaussian>> Gaussian(const libbirch::DefaultArray<birch::type::Real,1>& _u0956, const libbirch::DefaultArray<birch::type::Real,2>& _u0931, const birch::type::Real& _u09632, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
#line 66 "src/distribution/ScaledGammaExponential.birch"
libbirch::Lazy<libbirch::Shared<birch::type::ScaledGammaExponential>> ScaledGammaExponential(const libbirch::Lazy<libbirch::Shared<birch::type::Expression<birch::type::Real>>>& a, const libbirch::Lazy<libbirch::Shared<birch::type::Gamma>>& _u0955, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
#line 73 "src/distribution/ScaledGammaPoisson.birch"
libbirch::Lazy<libbirch::Shared<birch::type::ScaledGammaPoisson>> ScaledGammaPoisson(const libbirch::Lazy<libbirch::Shared<birch::type::Expression<birch::type::Real>>>& a, const libbirch::Lazy<libbirch::Shared<birch::type::Gamma>>& _u0955, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
#line 61 "src/distribution/Student.birch"
libbirch::Lazy<libbirch::Shared<birch::type::Student>> Student(const libbirch::Lazy<libbirch::Shared<birch::type::Expression<birch::type::Real>>>& _u0957, const libbirch::Lazy<libbirch::Shared<birch::type::Expression<birch::type::Real>>>& _u0956, const libbirch::Lazy<libbirch::Shared<birch::type::Expression<birch::type::Real>>>& _u09632, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
#line 69 "src/distribution/Student.birch"
libbirch::Lazy<libbirch::Shared<birch::type::Student>> Student(const libbirch::Lazy<libbirch::Shared<birch::type::Expression<birch::type::Real>>>& _u0957, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
#line 76 "src/distribution/Student.birch"
libbirch::Lazy<libbirch::Shared<birch::type::Student>> Student(const birch::type::Real& _u0957, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
#line 83 "src/distribution/Student.birch"
libbirch::Lazy<libbirch::Shared<birch::type::Student>> Student(const birch::type::Real& _u0957, const libbirch::Lazy<libbirch::Shared<birch::type::Expression<birch::type::Real>>>& _u0956, const libbirch::Lazy<libbirch::Shared<birch::type::Expression<birch::type::Real>>>& _u09632, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
#line 90 "src/distribution/Student.birch"
libbirch::Lazy<libbirch::Shared<birch::type::Student>> Student(const libbirch::Lazy<libbirch::Shared<birch::type::Expression<birch::type::Real>>>& _u0957, const birch::type::Real& _u0956, const libbirch::Lazy<libbirch::Shared<birch::type::Expression<birch::type::Real>>>& _u09632, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
#line 97 "src/distribution/Student.birch"
libbirch::Lazy<libbirch::Shared<birch::type::Student>> Student(const libbirch::Lazy<libbirch::Shared<birch::type::Expression<birch::type::Real>>>& _u0957, const libbirch::Lazy<libbirch::Shared<birch::type::Expression<birch::type::Real>>>& _u0956, const birch::type::Real& _u09632, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
#line 104 "src/distribution/Student.birch"
libbirch::Lazy<libbirch::Shared<birch::type::Student>> Student(const birch::type::Real& _u0957, const birch::type::Real& _u0956, const libbirch::Lazy<libbirch::Shared<birch::type::Expression<birch::type::Real>>>& _u09632, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
#line 111 "src/distribution/Student.birch"
libbirch::Lazy<libbirch::Shared<birch::type::Student>> Student(const birch::type::Real& _u0957, const libbirch::Lazy<libbirch::Shared<birch::type::Expression<birch::type::Real>>>& _u0956, const birch::type::Real& _u09632, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
#line 118 "src/distribution/Student.birch"
libbirch::Lazy<libbirch::Shared<birch::type::Student>> Student(const libbirch::Lazy<libbirch::Shared<birch::type::Expression<birch::type::Real>>>& _u0957, const birch::type::Real& _u0956, const birch::type::Real& _u09632, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
#line 125 "src/distribution/Student.birch"
libbirch::Lazy<libbirch::Shared<birch::type::Student>> Student(const birch::type::Real& _u0957, const birch::type::Real& _u0956, const birch::type::Real& _u09632, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
#line 146 "src/distribution/SubtractBoundedDiscrete.birch"
libbirch::Lazy<libbirch::Shared<birch::type::SubtractBoundedDiscrete>> SubtractBoundedDiscrete(const libbirch::Lazy<libbirch::Shared<birch::type::BoundedDiscrete>>& x1, const libbirch::Lazy<libbirch::Shared<birch::type::BoundedDiscrete>>& x2, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
#line 63 "src/distribution/Uniform.birch"
libbirch::Lazy<libbirch::Shared<birch::type::Uniform>> Uniform(const libbirch::Lazy<libbirch::Shared<birch::type::Expression<birch::type::Real>>>& l, const libbirch::Lazy<libbirch::Shared<birch::type::Expression<birch::type::Real>>>& u, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
#line 70 "src/distribution/Uniform.birch"
libbirch::Lazy<libbirch::Shared<birch::type::Uniform>> Uniform(const libbirch::Lazy<libbirch::Shared<birch::type::Expression<birch::type::Real>>>& l, const birch::type::Real& u, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
#line 77 "src/distribution/Uniform.birch"
libbirch::Lazy<libbirch::Shared<birch::type::Uniform>> Uniform(const birch::type::Real& l, const libbirch::Lazy<libbirch::Shared<birch::type::Expression<birch::type::Real>>>& u, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
#line 84 "src/distribution/Uniform.birch"
libbirch::Lazy<libbirch::Shared<birch::type::Uniform>> Uniform(const birch::type::Real& l, const birch::type::Real& u, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
#line 71 "src/distribution/UniformInteger.birch"
libbirch::Lazy<libbirch::Shared<birch::type::UniformInteger>> Uniform(const libbirch::Lazy<libbirch::Shared<birch::type::Expression<birch::type::Integer>>>& l, const libbirch::Lazy<libbirch::Shared<birch::type::Expression<birch::type::Integer>>>& u, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
#line 79 "src/distribution/UniformInteger.birch"
libbirch::Lazy<libbirch::Shared<birch::type::UniformInteger>> Uniform(const libbirch::Lazy<libbirch::Shared<birch::type::Expression<birch::type::Integer>>>& l, const birch::type::Integer& u, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
#line 86 "src/distribution/UniformInteger.birch"
libbirch::Lazy<libbirch::Shared<birch::type::UniformInteger>> Uniform(const birch::type::Integer& l, const libbirch::Lazy<libbirch::Shared<birch::type::Expression<birch::type::Integer>>>& u, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
#line 93 "src/distribution/UniformInteger.birch"
libbirch::Lazy<libbirch::Shared<birch::type::UniformInteger>> Uniform(const birch::type::Integer& l, const birch::type::Integer& u, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
#line 59 "src/distribution/Weibull.birch"
libbirch::Lazy<libbirch::Shared<birch::type::Weibull>> Weibull(const libbirch::Lazy<libbirch::Shared<birch::type::Expression<birch::type::Real>>>& k, const libbirch::Lazy<libbirch::Shared<birch::type::Expression<birch::type::Real>>>& _u0955, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
#line 66 "src/distribution/Weibull.birch"
libbirch::Lazy<libbirch::Shared<birch::type::Weibull>> Weibull(const libbirch::Lazy<libbirch::Shared<birch::type::Expression<birch::type::Real>>>& k, const birch::type::Real& _u0955, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
#line 73 "src/distribution/Weibull.birch"
libbirch::Lazy<libbirch::Shared<birch::type::Weibull>> Weibull(const birch::type::Real& k, const libbirch::Lazy<libbirch::Shared<birch::type::Expression<birch::type::Real>>>& _u0955, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
#line 80 "src/distribution/Weibull.birch"
libbirch::Lazy<libbirch::Shared<birch::type::Weibull>> Weibull(const birch::type::Real& k, const birch::type::Real& _u0955, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
#line 60 "src/distribution/Wishart.birch"
libbirch::Lazy<libbirch::Shared<birch::type::Wishart>> Wishart(const libbirch::Lazy<libbirch::Shared<birch::type::Expression<birch::type::LLT>>>& _u0936, const libbirch::Lazy<libbirch::Shared<birch::type::Expression<birch::type::Real>>>& k, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
#line 67 "src/distribution/Wishart.birch"
libbirch::Lazy<libbirch::Shared<birch::type::Wishart>> Wishart(const libbirch::Lazy<libbirch::Shared<birch::type::Expression<birch::type::LLT>>>& _u0936, const birch::type::Real& k, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
#line 74 "src/distribution/Wishart.birch"
libbirch::Lazy<libbirch::Shared<birch::type::Wishart>> Wishart(const birch::type::LLT& _u0936, const libbirch::Lazy<libbirch::Shared<birch::type::Expression<birch::type::Real>>>& k, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
#line 81 "src/distribution/Wishart.birch"
libbirch::Lazy<libbirch::Shared<birch::type::Wishart>> Wishart(const birch::type::LLT& _u0936, const birch::type::Real& k, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
#line 88 "src/distribution/Wishart.birch"
libbirch::Lazy<libbirch::Shared<birch::type::Wishart>> Wishart(const libbirch::Lazy<libbirch::Shared<birch::type::Expression<libbirch::DefaultArray<birch::type::Real,2>>>>& _u0936, const libbirch::Lazy<libbirch::Shared<birch::type::Expression<birch::type::Real>>>& k, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
#line 95 "src/distribution/Wishart.birch"
libbirch::Lazy<libbirch::Shared<birch::type::Wishart>> Wishart(const libbirch::Lazy<libbirch::Shared<birch::type::Expression<libbirch::DefaultArray<birch::type::Real,2>>>>& _u0936, const birch::type::Real& k, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
#line 102 "src/distribution/Wishart.birch"
libbirch::Lazy<libbirch::Shared<birch::type::Wishart>> Wishart(const libbirch::DefaultArray<birch::type::Real,2>& _u0936, const libbirch::Lazy<libbirch::Shared<birch::type::Expression<birch::type::Real>>>& k, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
#line 109 "src/distribution/Wishart.birch"
libbirch::Lazy<libbirch::Shared<birch::type::Wishart>> Wishart(const libbirch::DefaultArray<birch::type::Real,2>& _u0936, const birch::type::Real& k, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
template<class Value>
#line 65 "src/event/AssumeEvent.birch"
libbirch::Lazy<libbirch::Shared<birch::type::AssumeEvent<Value>>> AssumeEvent(const libbirch::Lazy<libbirch::Shared<birch::type::Random<Value>>>& x, const libbirch::Lazy<libbirch::Shared<birch::type::Distribution<Value>>>& p, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
#line 57 "src/event/FactorEvent.birch"
libbirch::Lazy<libbirch::Shared<birch::type::FactorEvent>> FactorEvent(const libbirch::Lazy<libbirch::Shared<birch::type::Expression<birch::type::Real>>>& w, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
#line 64 "src/event/FactorEvent.birch"
libbirch::Lazy<libbirch::Shared<birch::type::FactorEvent>> FactorEvent(const birch::type::Real& w, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
template<class Value>
#line 63 "src/event/ObserveEvent.birch"
libbirch::Lazy<libbirch::Shared<birch::type::ObserveEvent<Value>>> ObserveEvent(const Value& x, const libbirch::Lazy<libbirch::Shared<birch::type::Distribution<Value>>>& p, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
template<class Value>
#line 66 "src/event/SimulateEvent.birch"
libbirch::Lazy<libbirch::Shared<birch::type::SimulateEvent<Value>>> SimulateEvent(const libbirch::Lazy<libbirch::Shared<birch::type::Distribution<Value>>>& p, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
#line 22 "src/expression/Abs.birch"
libbirch::Lazy<libbirch::Shared<birch::type::Abs>> abs(const libbirch::Lazy<libbirch::Shared<birch::type::Expression<birch::type::Real>>>& y, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
#line 18 "src/expression/Acos.birch"
libbirch::Lazy<libbirch::Shared<birch::type::Acos>> acos(const libbirch::Lazy<libbirch::Shared<birch::type::Expression<birch::type::Real>>>& y, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
#line 18 "src/expression/Asin.birch"
libbirch::Lazy<libbirch::Shared<birch::type::Asin>> asin(const libbirch::Lazy<libbirch::Shared<birch::type::Expression<birch::type::Real>>>& y, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
#line 18 "src/expression/Atan.birch"
libbirch::Lazy<libbirch::Shared<birch::type::Atan>> atan(const libbirch::Lazy<libbirch::Shared<birch::type::Expression<birch::type::Real>>>& y, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
template<class Value>
#line 66 "src/expression/Boxed.birch"
libbirch::Lazy<libbirch::Shared<birch::type::Expression<Value>>> Boxed(const Value& x, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
template<class Value>
#line 73 "src/expression/Boxed.birch"
libbirch::Lazy<libbirch::Shared<birch::type::Expression<Value>>> box(const Value& x, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
template<class Value1,class Value2>
#line 80 "src/expression/Boxed.birch"
libbirch::Tuple<libbirch::Lazy<libbirch::Shared<birch::type::Expression<Value1>>>, libbirch::Lazy<libbirch::Shared<birch::type::Expression<Value2>>>> box(const libbirch::Tuple<Value1, Value2>& x, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
template<class Value1,class Value2,class Value3>
#line 91 "src/expression/Boxed.birch"
libbirch::Tuple<libbirch::Lazy<libbirch::Shared<birch::type::Expression<Value1>>>, libbirch::Lazy<libbirch::Shared<birch::type::Expression<Value2>>>, libbirch::Lazy<libbirch::Shared<birch::type::Expression<Value3>>>> box(const libbirch::Tuple<Value1, Value2, Value3>& x, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
template<class Value1,class Value2,class Value3,class Value4>
#line 103 "src/expression/Boxed.birch"
libbirch::Tuple<libbirch::Lazy<libbirch::Shared<birch::type::Expression<Value1>>>, libbirch::Lazy<libbirch::Shared<birch::type::Expression<Value2>>>, libbirch::Lazy<libbirch::Shared<birch::type::Expression<Value3>>>, libbirch::Lazy<libbirch::Shared<birch::type::Expression<Value4>>>> box(const libbirch::Tuple<Value1, Value2, Value3, Value4>& x, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
template<class Value1,class Value2,class Value3,class Value4,class Value5>
#line 116 "src/expression/Boxed.birch"
libbirch::Tuple<libbirch::Lazy<libbirch::Shared<birch::type::Expression<Value1>>>, libbirch::Lazy<libbirch::Shared<birch::type::Expression<Value2>>>, libbirch::Lazy<libbirch::Shared<birch::type::Expression<Value3>>>, libbirch::Lazy<libbirch::Shared<birch::type::Expression<Value4>>>, libbirch::Lazy<libbirch::Shared<birch::type::Expression<Value5>>>> box(const libbirch::Tuple<Value1, Value2, Value3, Value4, Value5>& x, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
template<class Value1,class Value2,class Value3,class Value4,class Value5,class Value6>
#line 130 "src/expression/Boxed.birch"
libbirch::Tuple<libbirch::Lazy<libbirch::Shared<birch::type::Expression<Value1>>>, libbirch::Lazy<libbirch::Shared<birch::type::Expression<Value2>>>, libbirch::Lazy<libbirch::Shared<birch::type::Expression<Value3>>>, libbirch::Lazy<libbirch::Shared<birch::type::Expression<Value4>>>, libbirch::Lazy<libbirch::Shared<birch::type::Expression<Value5>>>, libbirch::Lazy<libbirch::Shared<birch::type::Expression<Value6>>>> box(const libbirch::Tuple<Value1, Value2, Value3, Value4, Value5, Value6>& x, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
template<class Value1,class Value2,class Value3,class Value4,class Value5,class Value6,class Value7>
#line 145 "src/expression/Boxed.birch"
libbirch::Tuple<libbirch::Lazy<libbirch::Shared<birch::type::Expression<Value1>>>, libbirch::Lazy<libbirch::Shared<birch::type::Expression<Value2>>>, libbirch::Lazy<libbirch::Shared<birch::type::Expression<Value3>>>, libbirch::Lazy<libbirch::Shared<birch::type::Expression<Value4>>>, libbirch::Lazy<libbirch::Shared<birch::type::Expression<Value5>>>, libbirch::Lazy<libbirch::Shared<birch::type::Expression<Value6>>>, libbirch::Lazy<libbirch::Shared<birch::type::Expression<Value7>>>> box(const libbirch::Tuple<Value1, Value2, Value3, Value4, Value5, Value6, Value7>& x, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
template<class Value1,class Value2,class Value3,class Value4,class Value5,class Value6,class Value7,class Value8>
#line 161 "src/expression/Boxed.birch"
libbirch::Tuple<libbirch::Lazy<libbirch::Shared<birch::type::Expression<Value1>>>, libbirch::Lazy<libbirch::Shared<birch::type::Expression<Value2>>>, libbirch::Lazy<libbirch::Shared<birch::type::Expression<Value3>>>, libbirch::Lazy<libbirch::Shared<birch::type::Expression<Value4>>>, libbirch::Lazy<libbirch::Shared<birch::type::Expression<Value5>>>, libbirch::Lazy<libbirch::Shared<birch::type::Expression<Value6>>>, libbirch::Lazy<libbirch::Shared<birch::type::Expression<Value7>>>, libbirch::Lazy<libbirch::Shared<birch::type::Expression<Value8>>>> box(const libbirch::Tuple<Value1, Value2, Value3, Value4, Value5, Value6, Value7, Value8>& x, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
#line 18 "src/expression/Cast.birch"
libbirch::Lazy<libbirch::Shared<birch::type::Expression<birch::type::Real>>> Real(const libbirch::Lazy<libbirch::Shared<birch::type::Expression<birch::type::Real>>>& y, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
#line 25 "src/expression/Cast.birch"
libbirch::Lazy<libbirch::Shared<birch::type::Cast<birch::type::Integer, birch::type::Real>>> Real(const libbirch::Lazy<libbirch::Shared<birch::type::Expression<birch::type::Integer>>>& y, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
#line 32 "src/expression/Cast.birch"
libbirch::Lazy<libbirch::Shared<birch::type::Cast<birch::type::Boolean, birch::type::Real>>> Real(const libbirch::Lazy<libbirch::Shared<birch::type::Expression<birch::type::Boolean>>>& y, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
#line 29 "src/expression/CopySign.birch"
libbirch::Lazy<libbirch::Shared<birch::type::CopySign>> copysign(const libbirch::Lazy<libbirch::Shared<birch::type::Expression<birch::type::Real>>>& y, const libbirch::Lazy<libbirch::Shared<birch::type::Expression<birch::type::Real>>>& z, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
#line 36 "src/expression/CopySign.birch"
libbirch::Lazy<libbirch::Shared<birch::type::CopySign>> copysign(const birch::type::Real& y, const libbirch::Lazy<libbirch::Shared<birch::type::Expression<birch::type::Real>>>& z, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
#line 43 "src/expression/CopySign.birch"
libbirch::Lazy<libbirch::Shared<birch::type::CopySign>> copysign(const libbirch::Lazy<libbirch::Shared<birch::type::Expression<birch::type::Real>>>& y, const birch::type::Real& z, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
#line 18 "src/expression/Cos.birch"
libbirch::Lazy<libbirch::Shared<birch::type::Cos>> cos(const libbirch::Lazy<libbirch::Shared<birch::type::Expression<birch::type::Real>>>& y, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
#line 18 "src/expression/Cosh.birch"
libbirch::Lazy<libbirch::Shared<birch::type::Cosh>> cosh(const libbirch::Lazy<libbirch::Shared<birch::type::Expression<birch::type::Real>>>& x, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
#line 99 "src/expression/DelayExpression.birch"
birch::type::Integer length(const libbirch::Lazy<libbirch::Shared<birch::type::DelayExpression>>& x, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
#line 106 "src/expression/DelayExpression.birch"
birch::type::Integer rows(const libbirch::Lazy<libbirch::Shared<birch::type::DelayExpression>>& x, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
#line 113 "src/expression/DelayExpression.birch"
birch::type::Integer columns(const libbirch::Lazy<libbirch::Shared<birch::type::DelayExpression>>& x, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
#line 31 "src/expression/Diagonal.birch"
libbirch::Lazy<libbirch::Shared<birch::type::Diagonal>> diagonal(const libbirch::Lazy<libbirch::Shared<birch::type::Expression<birch::type::Real>>>& y, const birch::type::Integer& z, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
#line 18 "src/expression/DiscreteCast.birch"
libbirch::Lazy<libbirch::Shared<birch::type::DiscreteCast<birch::type::Real, birch::type::Integer>>> Integer(const libbirch::Lazy<libbirch::Shared<birch::type::Expression<birch::type::Real>>>& y, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
#line 25 "src/expression/DiscreteCast.birch"
libbirch::Lazy<libbirch::Shared<birch::type::Expression<birch::type::Integer>>> Integer(const libbirch::Lazy<libbirch::Shared<birch::type::Expression<birch::type::Integer>>>& y, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
#line 32 "src/expression/DiscreteCast.birch"
libbirch::Lazy<libbirch::Shared<birch::type::DiscreteCast<birch::type::Boolean, birch::type::Integer>>> Integer(const libbirch::Lazy<libbirch::Shared<birch::type::Expression<birch::type::Boolean>>>& y, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
#line 39 "src/expression/DiscreteCast.birch"
libbirch::Lazy<libbirch::Shared<birch::type::DiscreteCast<birch::type::Real, birch::type::Boolean>>> Boolean(const libbirch::Lazy<libbirch::Shared<birch::type::Expression<birch::type::Real>>>& y, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
#line 46 "src/expression/DiscreteCast.birch"
libbirch::Lazy<libbirch::Shared<birch::type::DiscreteCast<birch::type::Integer, birch::type::Boolean>>> Boolean(const libbirch::Lazy<libbirch::Shared<birch::type::Expression<birch::type::Integer>>>& y, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
#line 53 "src/expression/DiscreteCast.birch"
libbirch::Lazy<libbirch::Shared<birch::type::Expression<birch::type::Boolean>>> Boolean(const libbirch::Lazy<libbirch::Shared<birch::type::Expression<birch::type::Boolean>>>& y, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
#line 64 "src/expression/Dot.birch"
libbirch::Lazy<libbirch::Shared<birch::type::Dot>> dot(const libbirch::Lazy<libbirch::Shared<birch::type::Expression<libbirch::DefaultArray<birch::type::Real,1>>>>& y, const libbirch::Lazy<libbirch::Shared<birch::type::Expression<libbirch::DefaultArray<birch::type::Real,1>>>>& z, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
#line 72 "src/expression/Dot.birch"
libbirch::Lazy<libbirch::Shared<birch::type::Dot>> dot(const libbirch::DefaultArray<birch::type::Real,1>& y, const libbirch::Lazy<libbirch::Shared<birch::type::Expression<libbirch::DefaultArray<birch::type::Real,1>>>>& z, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
#line 79 "src/expression/Dot.birch"
libbirch::Lazy<libbirch::Shared<birch::type::Dot>> dot(const libbirch::Lazy<libbirch::Shared<birch::type::Expression<libbirch::DefaultArray<birch::type::Real,1>>>>& y, const libbirch::DefaultArray<birch::type::Real,1>& z, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
#line 86 "src/expression/Dot.birch"
libbirch::Lazy<libbirch::Shared<birch::type::Dot>> dot(const libbirch::Lazy<libbirch::Shared<birch::type::Expression<libbirch::DefaultArray<birch::type::Real,1>>>>& y, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
#line 18 "src/expression/Exp.birch"
libbirch::Lazy<libbirch::Shared<birch::type::Exp>> exp(const libbirch::Lazy<libbirch::Shared<birch::type::Expression<birch::type::Real>>>& y, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
#line 104 "src/expression/IfThenElse.birch"
libbirch::Lazy<libbirch::Shared<birch::type::IfThenElse>> if_then_else(const libbirch::Lazy<libbirch::Shared<birch::type::Expression<birch::type::Boolean>>>& cond, const libbirch::Lazy<libbirch::Shared<birch::type::Expression<birch::type::Real>>>& y, const libbirch::Lazy<libbirch::Shared<birch::type::Expression<birch::type::Real>>>& z, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
#line 112 "src/expression/IfThenElse.birch"
libbirch::Lazy<libbirch::Shared<birch::type::IfThenElse>> if_then_else(const libbirch::Lazy<libbirch::Shared<birch::type::Expression<birch::type::Boolean>>>& cond, const libbirch::Lazy<libbirch::Shared<birch::type::Expression<birch::type::Real>>>& y, const birch::type::Real& z, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
#line 120 "src/expression/IfThenElse.birch"
libbirch::Lazy<libbirch::Shared<birch::type::IfThenElse>> if_then_else(const libbirch::Lazy<libbirch::Shared<birch::type::Expression<birch::type::Boolean>>>& cond, const birch::type::Real& y, const libbirch::Lazy<libbirch::Shared<birch::type::Expression<birch::type::Real>>>& z, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
#line 128 "src/expression/IfThenElse.birch"
libbirch::Lazy<libbirch::Shared<birch::type::IfThenElse>> if_then_else(const libbirch::Lazy<libbirch::Shared<birch::type::Expression<birch::type::Boolean>>>& cond, const birch::type::Real& y, const birch::type::Real& z, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
#line 136 "src/expression/IfThenElse.birch"
libbirch::Lazy<libbirch::Shared<birch::type::IfThenElse>> if_then_else(const birch::type::Boolean& cond, const libbirch::Lazy<libbirch::Shared<birch::type::Expression<birch::type::Real>>>& y, const libbirch::Lazy<libbirch::Shared<birch::type::Expression<birch::type::Real>>>& z, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
#line 144 "src/expression/IfThenElse.birch"
libbirch::Lazy<libbirch::Shared<birch::type::IfThenElse>> if_then_else(const birch::type::Boolean& cond, const libbirch::Lazy<libbirch::Shared<birch::type::Expression<birch::type::Real>>>& y, const birch::type::Real& z, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
#line 152 "src/expression/IfThenElse.birch"
libbirch::Lazy<libbirch::Shared<birch::type::IfThenElse>> if_then_else(const birch::type::Boolean& cond, const birch::type::Real& y, const libbirch::Lazy<libbirch::Shared<birch::type::Expression<birch::type::Real>>>& z, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
#line 18 "src/expression/Log.birch"
libbirch::Lazy<libbirch::Shared<birch::type::Log>> log(const libbirch::Lazy<libbirch::Shared<birch::type::Expression<birch::type::Real>>>& y, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
#line 18 "src/expression/Log1p.birch"
libbirch::Lazy<libbirch::Shared<birch::type::Log1p>> log1p(const libbirch::Lazy<libbirch::Shared<birch::type::Expression<birch::type::Real>>>& y, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
#line 23 "src/expression/LogBeta.birch"
libbirch::Lazy<libbirch::Shared<birch::type::LogBeta>> lbeta(const libbirch::Lazy<libbirch::Shared<birch::type::Expression<birch::type::Real>>>& x, const libbirch::Lazy<libbirch::Shared<birch::type::Expression<birch::type::Real>>>& y, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
#line 30 "src/expression/LogBeta.birch"
libbirch::Lazy<libbirch::Shared<birch::type::LogBeta>> lbeta(const birch::type::Real& x, const libbirch::Lazy<libbirch::Shared<birch::type::Expression<birch::type::Real>>>& y, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
#line 37 "src/expression/LogBeta.birch"
libbirch::Lazy<libbirch::Shared<birch::type::LogBeta>> lbeta(const libbirch::Lazy<libbirch::Shared<birch::type::Expression<birch::type::Real>>>& x, const birch::type::Real& y, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
#line 25 "src/expression/LogChoose.birch"
libbirch::Lazy<libbirch::Shared<birch::type::LogChoose>> lchoose(const libbirch::Lazy<libbirch::Shared<birch::type::Expression<birch::type::Integer>>>& y, const libbirch::Lazy<libbirch::Shared<birch::type::Expression<birch::type::Integer>>>& z, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
#line 32 "src/expression/LogChoose.birch"
libbirch::Lazy<libbirch::Shared<birch::type::LogChoose>> lchoose(const birch::type::Integer& y, const libbirch::Lazy<libbirch::Shared<birch::type::Expression<birch::type::Integer>>>& z, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
#line 39 "src/expression/LogChoose.birch"
libbirch::Lazy<libbirch::Shared<birch::type::LogChoose>> lchoose(const libbirch::Lazy<libbirch::Shared<birch::type::Expression<birch::type::Integer>>>& y, const birch::type::Integer& z, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
#line 19 "src/expression/LogDet.birch"
libbirch::Lazy<libbirch::Shared<birch::type::LogDet<libbirch::Lazy<libbirch::Shared<birch::type::Expression<birch::type::LLT>>>, birch::type::LLT>>> ldet(const libbirch::Lazy<libbirch::Shared<birch::type::Expression<birch::type::LLT>>>& y, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
#line 26 "src/expression/LogDet.birch"
libbirch::Lazy<libbirch::Shared<birch::type::LogDet<libbirch::Lazy<libbirch::Shared<birch::type::Expression<libbirch::DefaultArray<birch::type::Real,2>>>>, libbirch::DefaultArray<birch::type::Real,2>>>> ldet(const libbirch::Lazy<libbirch::Shared<birch::type::Expression<libbirch::DefaultArray<birch::type::Real,2>>>>& y, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
#line 18 "src/expression/LogGamma.birch"
libbirch::Lazy<libbirch::Shared<birch::type::LogGamma>> lgamma(const libbirch::Lazy<libbirch::Shared<birch::type::Expression<birch::type::Real>>>& x, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
#line 27 "src/expression/LogGammaP.birch"
libbirch::Lazy<libbirch::Shared<birch::type::LogGammaP>> lgamma(const libbirch::Lazy<libbirch::Shared<birch::type::Expression<birch::type::Real>>>& y, const birch::type::Integer& z, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
#line 34 "src/expression/MatrixAbs.birch"
libbirch::Lazy<libbirch::Shared<birch::type::MatrixAbs>> abs(const libbirch::Lazy<libbirch::Shared<birch::type::Expression<libbirch::DefaultArray<birch::type::Real,2>>>>& y, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
#line 27 "src/expression/MatrixCanonical.birch"
libbirch::Lazy<libbirch::Shared<birch::type::Expression<libbirch::DefaultArray<birch::type::Real,2>>>> canonical(const libbirch::Lazy<libbirch::Shared<birch::type::Expression<birch::type::LLT>>>& y, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
#line 34 "src/expression/MatrixCanonical.birch"
libbirch::Lazy<libbirch::Shared<birch::type::Expression<libbirch::DefaultArray<birch::type::Real,2>>>> canonical(const libbirch::Lazy<libbirch::Shared<birch::type::Expression<libbirch::DefaultArray<birch::type::Real,2>>>>& y, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
#line 27 "src/expression/MatrixDiagonal.birch"
libbirch::Lazy<libbirch::Shared<birch::type::MatrixDiagonal>> diagonal(const libbirch::Lazy<libbirch::Shared<birch::type::Expression<libbirch::DefaultArray<birch::type::Real,1>>>>& x, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
#line 71 "src/expression/MatrixElement.birch"
libbirch::Lazy<libbirch::Shared<birch::type::MatrixElement<birch::type::Real>>> MatrixElement(const libbirch::Lazy<libbirch::Shared<birch::type::Expression<libbirch::DefaultArray<birch::type::Real,2>>>>& y, const birch::type::Integer& i, const birch::type::Integer& j, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
#line 79 "src/expression/MatrixElement.birch"
libbirch::Lazy<libbirch::Shared<birch::type::MatrixElement<birch::type::Integer>>> MatrixElement(const libbirch::Lazy<libbirch::Shared<birch::type::Expression<libbirch::DefaultArray<birch::type::Integer,2>>>>& y, const birch::type::Integer& i, const birch::type::Integer& j, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
#line 87 "src/expression/MatrixElement.birch"
libbirch::Lazy<libbirch::Shared<birch::type::MatrixElement<birch::type::Boolean>>> MatrixElement(const libbirch::Lazy<libbirch::Shared<birch::type::Expression<libbirch::DefaultArray<birch::type::Boolean,2>>>>& y, const birch::type::Integer& i, const birch::type::Integer& j, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
#line 28 "src/expression/MatrixInv.birch"
libbirch::Lazy<libbirch::Shared<birch::type::MatrixInv<libbirch::Lazy<libbirch::Shared<birch::type::Expression<libbirch::DefaultArray<birch::type::Real,2>>>>, libbirch::DefaultArray<birch::type::Real,2>, libbirch::DefaultArray<birch::type::Real,2>>>> inv(const libbirch::Lazy<libbirch::Shared<birch::type::Expression<libbirch::DefaultArray<birch::type::Real,2>>>>& x, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
#line 36 "src/expression/MatrixInv.birch"
libbirch::Lazy<libbirch::Shared<birch::type::MatrixInv<libbirch::Lazy<libbirch::Shared<birch::type::Expression<birch::type::LLT>>>, birch::type::LLT, birch::type::LLT>>> inv(const libbirch::Lazy<libbirch::Shared<birch::type::Expression<birch::type::LLT>>>& x, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
template<class Value>
#line 110 "src/expression/MatrixJoin.birch"
libbirch::Lazy<libbirch::Shared<birch::type::MatrixJoin<Value>>> join(const libbirch::DefaultArray<libbirch::Lazy<libbirch::Shared<birch::type::Expression<Value>>>,2>& y, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
template<class Value>
#line 118 "src/expression/MatrixJoin.birch"
libbirch::DefaultArray<libbirch::Lazy<libbirch::Shared<birch::type::Expression<Value>>>,2> split(const libbirch::Lazy<libbirch::Shared<birch::type::Expression<libbirch::DefaultArray<Value,2>>>>& y, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
#line 27 "src/expression/MatrixLLT.birch"
libbirch::Lazy<libbirch::Shared<birch::type::MatrixLLT>> llt(const libbirch::Lazy<libbirch::Shared<birch::type::Expression<libbirch::DefaultArray<birch::type::Real,2>>>>& y, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
#line 33 "src/expression/MatrixPack.birch"
libbirch::Lazy<libbirch::Shared<birch::type::MatrixPack>> pack(const libbirch::Lazy<libbirch::Shared<birch::type::Expression<libbirch::DefaultArray<birch::type::Real,2>>>>& y, const libbirch::Lazy<libbirch::Shared<birch::type::Expression<libbirch::DefaultArray<birch::type::Real,2>>>>& z, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
#line 41 "src/expression/MatrixPack.birch"
libbirch::Lazy<libbirch::Shared<birch::type::MatrixPack>> pack(const libbirch::DefaultArray<birch::type::Real,2>& y, const libbirch::Lazy<libbirch::Shared<birch::type::Expression<libbirch::DefaultArray<birch::type::Real,2>>>>& z, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
#line 48 "src/expression/MatrixPack.birch"
libbirch::Lazy<libbirch::Shared<birch::type::MatrixPack>> pack(const libbirch::Lazy<libbirch::Shared<birch::type::Expression<libbirch::DefaultArray<birch::type::Real,2>>>>& y, const libbirch::DefaultArray<birch::type::Real,2>& z, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
#line 33 "src/expression/MatrixRankDowndate.birch"
libbirch::Lazy<libbirch::Shared<birch::type::MatrixRankDowndate<libbirch::Lazy<libbirch::Shared<birch::type::Expression<libbirch::DefaultArray<birch::type::Real,1>>>>, libbirch::DefaultArray<birch::type::Real,1>, libbirch::DefaultArray<birch::type::Real,1>>>> rank_downdate(const libbirch::Lazy<libbirch::Shared<birch::type::Expression<birch::type::LLT>>>& y, const libbirch::Lazy<libbirch::Shared<birch::type::Expression<libbirch::DefaultArray<birch::type::Real,1>>>>& z, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
#line 42 "src/expression/MatrixRankDowndate.birch"
libbirch::Lazy<libbirch::Shared<birch::type::MatrixRankDowndate<libbirch::Lazy<libbirch::Shared<birch::type::Expression<libbirch::DefaultArray<birch::type::Real,1>>>>, libbirch::DefaultArray<birch::type::Real,1>, libbirch::DefaultArray<birch::type::Real,1>>>> rank_downdate(const birch::type::LLT& y, const libbirch::Lazy<libbirch::Shared<birch::type::Expression<libbirch::DefaultArray<birch::type::Real,1>>>>& z, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
#line 50 "src/expression/MatrixRankDowndate.birch"
libbirch::Lazy<libbirch::Shared<birch::type::MatrixRankDowndate<libbirch::Lazy<libbirch::Shared<birch::type::Expression<libbirch::DefaultArray<birch::type::Real,1>>>>, libbirch::DefaultArray<birch::type::Real,1>, libbirch::DefaultArray<birch::type::Real,1>>>> rank_downdate(const libbirch::Lazy<libbirch::Shared<birch::type::Expression<birch::type::LLT>>>& y, const libbirch::DefaultArray<birch::type::Real,1>& z, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
#line 58 "src/expression/MatrixRankDowndate.birch"
libbirch::Lazy<libbirch::Shared<birch::type::MatrixRankDowndate<libbirch::Lazy<libbirch::Shared<birch::type::Expression<libbirch::DefaultArray<birch::type::Real,2>>>>, libbirch::DefaultArray<birch::type::Real,2>, libbirch::DefaultArray<birch::type::Real,2>>>> rank_downdate(const libbirch::Lazy<libbirch::Shared<birch::type::Expression<birch::type::LLT>>>& y, const libbirch::Lazy<libbirch::Shared<birch::type::Expression<libbirch::DefaultArray<birch::type::Real,2>>>>& z, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
#line 67 "src/expression/MatrixRankDowndate.birch"
libbirch::Lazy<libbirch::Shared<birch::type::MatrixRankDowndate<libbirch::Lazy<libbirch::Shared<birch::type::Expression<libbirch::DefaultArray<birch::type::Real,2>>>>, libbirch::DefaultArray<birch::type::Real,2>, libbirch::DefaultArray<birch::type::Real,2>>>> rank_downdate(const birch::type::LLT& y, const libbirch::Lazy<libbirch::Shared<birch::type::Expression<libbirch::DefaultArray<birch::type::Real,2>>>>& z, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
#line 75 "src/expression/MatrixRankDowndate.birch"
libbirch::Lazy<libbirch::Shared<birch::type::MatrixRankDowndate<libbirch::Lazy<libbirch::Shared<birch::type::Expression<libbirch::DefaultArray<birch::type::Real,2>>>>, libbirch::DefaultArray<birch::type::Real,2>, libbirch::DefaultArray<birch::type::Real,2>>>> rank_downdate(const libbirch::Lazy<libbirch::Shared<birch::type::Expression<birch::type::LLT>>>& y, const libbirch::DefaultArray<birch::type::Real,2>& z, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
#line 33 "src/expression/MatrixRankUpdate.birch"
libbirch::Lazy<libbirch::Shared<birch::type::MatrixRankUpdate<libbirch::Lazy<libbirch::Shared<birch::type::Expression<libbirch::DefaultArray<birch::type::Real,1>>>>, libbirch::DefaultArray<birch::type::Real,1>, libbirch::DefaultArray<birch::type::Real,1>>>> rank_update(const libbirch::Lazy<libbirch::Shared<birch::type::Expression<birch::type::LLT>>>& y, const libbirch::Lazy<libbirch::Shared<birch::type::Expression<libbirch::DefaultArray<birch::type::Real,1>>>>& z, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
#line 42 "src/expression/MatrixRankUpdate.birch"
libbirch::Lazy<libbirch::Shared<birch::type::MatrixRankUpdate<libbirch::Lazy<libbirch::Shared<birch::type::Expression<libbirch::DefaultArray<birch::type::Real,1>>>>, libbirch::DefaultArray<birch::type::Real,1>, libbirch::DefaultArray<birch::type::Real,1>>>> rank_update(const birch::type::LLT& y, const libbirch::Lazy<libbirch::Shared<birch::type::Expression<libbirch::DefaultArray<birch::type::Real,1>>>>& z, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
#line 50 "src/expression/MatrixRankUpdate.birch"
libbirch::Lazy<libbirch::Shared<birch::type::MatrixRankUpdate<libbirch::Lazy<libbirch::Shared<birch::type::Expression<libbirch::DefaultArray<birch::type::Real,1>>>>, libbirch::DefaultArray<birch::type::Real,1>, libbirch::DefaultArray<birch::type::Real,1>>>> rank_update(const libbirch::Lazy<libbirch::Shared<birch::type::Expression<birch::type::LLT>>>& y, const libbirch::DefaultArray<birch::type::Real,1>& z, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
#line 58 "src/expression/MatrixRankUpdate.birch"
libbirch::Lazy<libbirch::Shared<birch::type::MatrixRankUpdate<libbirch::Lazy<libbirch::Shared<birch::type::Expression<libbirch::DefaultArray<birch::type::Real,2>>>>, libbirch::DefaultArray<birch::type::Real,2>, libbirch::DefaultArray<birch::type::Real,2>>>> rank_update(const libbirch::Lazy<libbirch::Shared<birch::type::Expression<birch::type::LLT>>>& y, const libbirch::Lazy<libbirch::Shared<birch::type::Expression<libbirch::DefaultArray<birch::type::Real,2>>>>& z, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
#line 68 "src/expression/MatrixRankUpdate.birch"
libbirch::Lazy<libbirch::Shared<birch::type::MatrixRankUpdate<libbirch::Lazy<libbirch::Shared<birch::type::Expression<libbirch::DefaultArray<birch::type::Real,2>>>>, libbirch::DefaultArray<birch::type::Real,2>, libbirch::DefaultArray<birch::type::Real,2>>>> rank_update(const birch::type::LLT& y, const libbirch::Lazy<libbirch::Shared<birch::type::Expression<libbirch::DefaultArray<birch::type::Real,2>>>>& z, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
#line 76 "src/expression/MatrixRankUpdate.birch"
libbirch::Lazy<libbirch::Shared<birch::type::MatrixRankUpdate<libbirch::Lazy<libbirch::Shared<birch::type::Expression<libbirch::DefaultArray<birch::type::Real,2>>>>, libbirch::DefaultArray<birch::type::Real,2>, libbirch::DefaultArray<birch::type::Real,2>>>> rank_update(const libbirch::Lazy<libbirch::Shared<birch::type::Expression<birch::type::LLT>>>& y, const libbirch::DefaultArray<birch::type::Real,2>& z, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
#line 34 "src/expression/MatrixRectify.birch"
libbirch::Lazy<libbirch::Shared<birch::type::MatrixRectify>> rectify(const libbirch::Lazy<libbirch::Shared<birch::type::Expression<libbirch::DefaultArray<birch::type::Real,2>>>>& y, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
#line 33 "src/expression/MatrixSolve.birch"
libbirch::Lazy<libbirch::Shared<birch::type::MatrixSolve<libbirch::Lazy<libbirch::Shared<birch::type::Expression<libbirch::DefaultArray<birch::type::Real,2>>>>, libbirch::DefaultArray<birch::type::Real,2>>>> solve(const libbirch::Lazy<libbirch::Shared<birch::type::Expression<libbirch::DefaultArray<birch::type::Real,2>>>>& y, const libbirch::Lazy<libbirch::Shared<birch::type::Expression<libbirch::DefaultArray<birch::type::Real,2>>>>& z, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
#line 42 "src/expression/MatrixSolve.birch"
libbirch::Lazy<libbirch::Shared<birch::type::MatrixSolve<libbirch::Lazy<libbirch::Shared<birch::type::Expression<libbirch::DefaultArray<birch::type::Real,2>>>>, libbirch::DefaultArray<birch::type::Real,2>>>> solve(const libbirch::DefaultArray<birch::type::Real,2>& y, const libbirch::Lazy<libbirch::Shared<birch::type::Expression<libbirch::DefaultArray<birch::type::Real,2>>>>& z, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
#line 50 "src/expression/MatrixSolve.birch"
libbirch::Lazy<libbirch::Shared<birch::type::MatrixSolve<libbirch::Lazy<libbirch::Shared<birch::type::Expression<libbirch::DefaultArray<birch::type::Real,2>>>>, libbirch::DefaultArray<birch::type::Real,2>>>> solve(const libbirch::Lazy<libbirch::Shared<birch::type::Expression<libbirch::DefaultArray<birch::type::Real,2>>>>& y, const libbirch::DefaultArray<birch::type::Real,2>& z, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
#line 58 "src/expression/MatrixSolve.birch"
libbirch::Lazy<libbirch::Shared<birch::type::MatrixSolve<libbirch::Lazy<libbirch::Shared<birch::type::Expression<birch::type::LLT>>>, birch::type::LLT>>> solve(const libbirch::Lazy<libbirch::Shared<birch::type::Expression<birch::type::LLT>>>& y, const libbirch::Lazy<libbirch::Shared<birch::type::Expression<libbirch::DefaultArray<birch::type::Real,2>>>>& z, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
#line 67 "src/expression/MatrixSolve.birch"
libbirch::Lazy<libbirch::Shared<birch::type::MatrixSolve<libbirch::Lazy<libbirch::Shared<birch::type::Expression<birch::type::LLT>>>, birch::type::LLT>>> solve(const birch::type::LLT& y, const libbirch::Lazy<libbirch::Shared<birch::type::Expression<libbirch::DefaultArray<birch::type::Real,2>>>>& z, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
#line 75 "src/expression/MatrixSolve.birch"
libbirch::Lazy<libbirch::Shared<birch::type::MatrixSolve<libbirch::Lazy<libbirch::Shared<birch::type::Expression<birch::type::LLT>>>, birch::type::LLT>>> solve(const libbirch::Lazy<libbirch::Shared<birch::type::Expression<birch::type::LLT>>>& y, const libbirch::DefaultArray<birch::type::Real,2>& z, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
#line 34 "src/expression/MatrixStack.birch"
libbirch::Lazy<libbirch::Shared<birch::type::MatrixStack>> stack(const libbirch::Lazy<libbirch::Shared<birch::type::Expression<libbirch::DefaultArray<birch::type::Real,2>>>>& y, const libbirch::Lazy<libbirch::Shared<birch::type::Expression<libbirch::DefaultArray<birch::type::Real,2>>>>& z, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
#line 43 "src/expression/MatrixStack.birch"
libbirch::Lazy<libbirch::Shared<birch::type::MatrixStack>> stack(const libbirch::DefaultArray<birch::type::Real,2>& y, const libbirch::Lazy<libbirch::Shared<birch::type::Expression<libbirch::DefaultArray<birch::type::Real,2>>>>& z, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
#line 50 "src/expression/MatrixStack.birch"
libbirch::Lazy<libbirch::Shared<birch::type::MatrixStack>> stack(const libbirch::Lazy<libbirch::Shared<birch::type::Expression<libbirch::DefaultArray<birch::type::Real,2>>>>& y, const libbirch::DefaultArray<birch::type::Real,2>& z, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
#line 28 "src/expression/MatrixTranspose.birch"
libbirch::Lazy<libbirch::Shared<birch::type::MatrixTranspose>> transpose(const libbirch::Lazy<libbirch::Shared<birch::type::Expression<libbirch::DefaultArray<birch::type::Real,2>>>>& y, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
#line 35 "src/expression/MatrixTranspose.birch"
libbirch::Lazy<libbirch::Shared<birch::type::Expression<birch::type::LLT>>> transpose(const libbirch::Lazy<libbirch::Shared<birch::type::Expression<birch::type::LLT>>>& y, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
#line 30 "src/expression/MultivariateAbs.birch"
libbirch::Lazy<libbirch::Shared<birch::type::MultivariateAbs>> abs(const libbirch::Lazy<libbirch::Shared<birch::type::Expression<libbirch::DefaultArray<birch::type::Real,1>>>>& x, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
#line 24 "src/expression/MultivariateCanonical.birch"
libbirch::Lazy<libbirch::Shared<birch::type::Expression<libbirch::DefaultArray<birch::type::Real,1>>>> canonical(const libbirch::Lazy<libbirch::Shared<birch::type::Expression<libbirch::DefaultArray<birch::type::Real,1>>>>& y, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
#line 24 "src/expression/MultivariateDiagonal.birch"
libbirch::Lazy<libbirch::Shared<birch::type::MultivariateDiagonal>> diagonal(const libbirch::Lazy<libbirch::Shared<birch::type::Expression<libbirch::DefaultArray<birch::type::Real,2>>>>& y, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
#line 59 "src/expression/MultivariateDot.birch"
libbirch::Lazy<libbirch::Shared<birch::type::MultivariateDot>> dot(const libbirch::Lazy<libbirch::Shared<birch::type::Expression<libbirch::DefaultArray<birch::type::Real,1>>>>& y, const libbirch::Lazy<libbirch::Shared<birch::type::Expression<libbirch::DefaultArray<birch::type::Real,2>>>>& z, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
#line 68 "src/expression/MultivariateDot.birch"
libbirch::Lazy<libbirch::Shared<birch::type::MultivariateDot>> dot(const libbirch::DefaultArray<birch::type::Real,1>& y, const libbirch::Lazy<libbirch::Shared<birch::type::Expression<libbirch::DefaultArray<birch::type::Real,2>>>>& z, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
#line 75 "src/expression/MultivariateDot.birch"
libbirch::Lazy<libbirch::Shared<birch::type::MultivariateDot>> dot(const libbirch::Lazy<libbirch::Shared<birch::type::Expression<libbirch::DefaultArray<birch::type::Real,1>>>>& y, const libbirch::DefaultArray<birch::type::Real,2>& z, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
#line 66 "src/expression/MultivariateElement.birch"
libbirch::Lazy<libbirch::Shared<birch::type::MultivariateElement<birch::type::Real>>> MultivariateElement(const libbirch::Lazy<libbirch::Shared<birch::type::Expression<libbirch::DefaultArray<birch::type::Real,1>>>>& y, const birch::type::Integer& i, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
#line 74 "src/expression/MultivariateElement.birch"
libbirch::Lazy<libbirch::Shared<birch::type::MultivariateElement<birch::type::Integer>>> MultivariateElement(const libbirch::Lazy<libbirch::Shared<birch::type::Expression<libbirch::DefaultArray<birch::type::Integer,1>>>>& y, const birch::type::Integer& i, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
#line 82 "src/expression/MultivariateElement.birch"
libbirch::Lazy<libbirch::Shared<birch::type::MultivariateElement<birch::type::Boolean>>> MultivariateElement(const libbirch::Lazy<libbirch::Shared<birch::type::Expression<libbirch::DefaultArray<birch::type::Boolean,1>>>>& y, const birch::type::Integer& i, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
template<class Value>
#line 101 "src/expression/MultivariateJoin.birch"
libbirch::Lazy<libbirch::Shared<birch::type::MultivariateJoin<Value>>> join(const libbirch::DefaultArray<libbirch::Lazy<libbirch::Shared<birch::type::Expression<Value>>>,1>& y, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
template<class Value>
#line 109 "src/expression/MultivariateJoin.birch"
libbirch::DefaultArray<libbirch::Lazy<libbirch::Shared<birch::type::Expression<Value>>>,1> split(const libbirch::Lazy<libbirch::Shared<birch::type::Expression<libbirch::DefaultArray<Value,1>>>>& y, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
#line 30 "src/expression/MultivariateRectify.birch"
libbirch::Lazy<libbirch::Shared<birch::type::MultivariateRectify>> rectify(const libbirch::Lazy<libbirch::Shared<birch::type::Expression<libbirch::DefaultArray<birch::type::Real,1>>>>& x, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
#line 29 "src/expression/MultivariateSolve.birch"
libbirch::Lazy<libbirch::Shared<birch::type::MultivariateSolve<libbirch::Lazy<libbirch::Shared<birch::type::Expression<libbirch::DefaultArray<birch::type::Real,2>>>>, libbirch::DefaultArray<birch::type::Real,2>>>> solve(const libbirch::Lazy<libbirch::Shared<birch::type::Expression<libbirch::DefaultArray<birch::type::Real,2>>>>& y, const libbirch::Lazy<libbirch::Shared<birch::type::Expression<libbirch::DefaultArray<birch::type::Real,1>>>>& z, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
#line 38 "src/expression/MultivariateSolve.birch"
libbirch::Lazy<libbirch::Shared<birch::type::MultivariateSolve<libbirch::Lazy<libbirch::Shared<birch::type::Expression<libbirch::DefaultArray<birch::type::Real,2>>>>, libbirch::DefaultArray<birch::type::Real,2>>>> solve(const libbirch::DefaultArray<birch::type::Real,2>& y, const libbirch::Lazy<libbirch::Shared<birch::type::Expression<libbirch::DefaultArray<birch::type::Real,1>>>>& z, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
#line 46 "src/expression/MultivariateSolve.birch"
libbirch::Lazy<libbirch::Shared<birch::type::MultivariateSolve<libbirch::Lazy<libbirch::Shared<birch::type::Expression<libbirch::DefaultArray<birch::type::Real,2>>>>, libbirch::DefaultArray<birch::type::Real,2>>>> solve(const libbirch::Lazy<libbirch::Shared<birch::type::Expression<libbirch::DefaultArray<birch::type::Real,2>>>>& y, const libbirch::DefaultArray<birch::type::Real,1>& z, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
#line 54 "src/expression/MultivariateSolve.birch"
libbirch::Lazy<libbirch::Shared<birch::type::MultivariateSolve<libbirch::Lazy<libbirch::Shared<birch::type::Expression<birch::type::LLT>>>, birch::type::LLT>>> solve(const libbirch::Lazy<libbirch::Shared<birch::type::Expression<birch::type::LLT>>>& y, const libbirch::Lazy<libbirch::Shared<birch::type::Expression<libbirch::DefaultArray<birch::type::Real,1>>>>& z, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
#line 63 "src/expression/MultivariateSolve.birch"
libbirch::Lazy<libbirch::Shared<birch::type::MultivariateSolve<libbirch::Lazy<libbirch::Shared<birch::type::Expression<birch::type::LLT>>>, birch::type::LLT>>> solve(const birch::type::LLT& y, const libbirch::Lazy<libbirch::Shared<birch::type::Expression<libbirch::DefaultArray<birch::type::Real,1>>>>& z, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
#line 71 "src/expression/MultivariateSolve.birch"
libbirch::Lazy<libbirch::Shared<birch::type::MultivariateSolve<libbirch::Lazy<libbirch::Shared<birch::type::Expression<birch::type::LLT>>>, birch::type::LLT>>> solve(const libbirch::Lazy<libbirch::Shared<birch::type::Expression<birch::type::LLT>>>& y, const libbirch::DefaultArray<birch::type::Real,1>& z, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
#line 29 "src/expression/MultivariateStack.birch"
libbirch::Lazy<libbirch::Shared<birch::type::MultivariateStack>> stack(const libbirch::Lazy<libbirch::Shared<birch::type::Expression<libbirch::DefaultArray<birch::type::Real,1>>>>& y, const libbirch::Lazy<libbirch::Shared<birch::type::Expression<libbirch::DefaultArray<birch::type::Real,1>>>>& z, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
#line 37 "src/expression/MultivariateStack.birch"
libbirch::Lazy<libbirch::Shared<birch::type::MultivariateStack>> stack(const libbirch::DefaultArray<birch::type::Real,1>& y, const libbirch::Lazy<libbirch::Shared<birch::type::Expression<libbirch::DefaultArray<birch::type::Real,1>>>>& z, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
#line 44 "src/expression/MultivariateStack.birch"
libbirch::Lazy<libbirch::Shared<birch::type::MultivariateStack>> stack(const libbirch::Lazy<libbirch::Shared<birch::type::Expression<libbirch::DefaultArray<birch::type::Real,1>>>>& y, const libbirch::DefaultArray<birch::type::Real,1>& z, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
#line 27 "src/expression/MultivariateTranspose.birch"
libbirch::Lazy<libbirch::Shared<birch::type::MultivariateTranspose>> transpose(const libbirch::Lazy<libbirch::Shared<birch::type::Expression<libbirch::DefaultArray<birch::type::Real,1>>>>& y, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
#line 34 "src/expression/Outer.birch"
libbirch::Lazy<libbirch::Shared<birch::type::Outer>> outer(const libbirch::Lazy<libbirch::Shared<birch::type::Expression<libbirch::DefaultArray<birch::type::Real,1>>>>& y, const libbirch::Lazy<libbirch::Shared<birch::type::Expression<libbirch::DefaultArray<birch::type::Real,1>>>>& z, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
#line 41 "src/expression/Outer.birch"
libbirch::Lazy<libbirch::Shared<birch::type::Outer>> outer(const libbirch::DefaultArray<birch::type::Real,1>& y, const libbirch::Lazy<libbirch::Shared<birch::type::Expression<libbirch::DefaultArray<birch::type::Real,1>>>>& z, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
#line 48 "src/expression/Outer.birch"
libbirch::Lazy<libbirch::Shared<birch::type::Outer>> outer(const libbirch::Lazy<libbirch::Shared<birch::type::Expression<libbirch::DefaultArray<birch::type::Real,1>>>>& y, const libbirch::DefaultArray<birch::type::Real,1>& z, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
#line 55 "src/expression/Outer.birch"
libbirch::Lazy<libbirch::Shared<birch::type::Outer>> outer(const libbirch::Lazy<libbirch::Shared<birch::type::Expression<libbirch::DefaultArray<birch::type::Real,1>>>>& y, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
#line 27 "src/expression/Pow.birch"
libbirch::Lazy<libbirch::Shared<birch::type::Pow>> pow(const libbirch::Lazy<libbirch::Shared<birch::type::Expression<birch::type::Real>>>& y, const libbirch::Lazy<libbirch::Shared<birch::type::Expression<birch::type::Real>>>& z, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
#line 34 "src/expression/Pow.birch"
libbirch::Lazy<libbirch::Shared<birch::type::Pow>> pow(const birch::type::Real& y, const libbirch::Lazy<libbirch::Shared<birch::type::Expression<birch::type::Real>>>& z, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
#line 41 "src/expression/Pow.birch"
libbirch::Lazy<libbirch::Shared<birch::type::Pow>> pow(const libbirch::Lazy<libbirch::Shared<birch::type::Expression<birch::type::Real>>>& y, const birch::type::Real& z, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
template<class Value>
#line 356 "src/expression/Random.birch"
libbirch::Lazy<libbirch::Shared<birch::type::Random<Value>>> Random(const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
#line 22 "src/expression/Rectify.birch"
libbirch::Lazy<libbirch::Shared<birch::type::Rectify>> rectify(const libbirch::Lazy<libbirch::Shared<birch::type::Expression<birch::type::Real>>>& y, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
template<class Value>
#line 20 "src/expression/ScalarMatrix.birch"
libbirch::Lazy<libbirch::Shared<birch::type::ScalarMatrix<Value>>> scalar(const libbirch::Lazy<libbirch::Shared<birch::type::Expression<libbirch::DefaultArray<Value,2>>>>& y, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
template<class Value>
#line 18 "src/expression/ScalarMultivariate.birch"
libbirch::Lazy<libbirch::Shared<birch::type::ScalarMultivariate<Value>>> scalar(const libbirch::Lazy<libbirch::Shared<birch::type::Expression<libbirch::DefaultArray<Value,1>>>>& y, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
#line 18 "src/expression/Sin.birch"
libbirch::Lazy<libbirch::Shared<birch::type::Sin>> sin(const libbirch::Lazy<libbirch::Shared<birch::type::Expression<birch::type::Real>>>& y, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
#line 18 "src/expression/Sinh.birch"
libbirch::Lazy<libbirch::Shared<birch::type::Sinh>> sinh(const libbirch::Lazy<libbirch::Shared<birch::type::Expression<birch::type::Real>>>& y, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
#line 18 "src/expression/Sqrt.birch"
libbirch::Lazy<libbirch::Shared<birch::type::Sqrt>> sqrt(const libbirch::Lazy<libbirch::Shared<birch::type::Expression<birch::type::Real>>>& x, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
#line 18 "src/expression/Tan.birch"
libbirch::Lazy<libbirch::Shared<birch::type::Tan>> tan(const libbirch::Lazy<libbirch::Shared<birch::type::Expression<birch::type::Real>>>& y, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
#line 18 "src/expression/Tanh.birch"
libbirch::Lazy<libbirch::Shared<birch::type::Tanh>> tanh(const libbirch::Lazy<libbirch::Shared<birch::type::Expression<birch::type::Real>>>& x, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
#line 19 "src/expression/Trace.birch"
libbirch::Lazy<libbirch::Shared<birch::type::Trace<libbirch::Lazy<libbirch::Shared<birch::type::Expression<birch::type::LLT>>>, birch::type::LLT>>> trace(const libbirch::Lazy<libbirch::Shared<birch::type::Expression<birch::type::LLT>>>& y, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
#line 26 "src/expression/Trace.birch"
libbirch::Lazy<libbirch::Shared<birch::type::Trace<libbirch::Lazy<libbirch::Shared<birch::type::Expression<libbirch::DefaultArray<birch::type::Real,2>>>>, libbirch::DefaultArray<birch::type::Real,2>>>> trace(const libbirch::Lazy<libbirch::Shared<birch::type::Expression<libbirch::DefaultArray<birch::type::Real,2>>>>& y, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
#line 146 "src/handler/MoveHandler.birch"
libbirch::Lazy<libbirch::Shared<birch::type::MoveHandler>> MoveHandler(const birch::type::Boolean& delayed, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
#line 107 "src/handler/PlayHandler.birch"
libbirch::Lazy<libbirch::Shared<birch::type::PlayHandler>> PlayHandler(const birch::type::Boolean& delayed, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
#line 85 "src/io/InputStream.birch"
libbirch::Lazy<libbirch::Shared<birch::type::InputStream>> InputStream(const birch::type::File& file, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
#line 130 "src/io/OutputStream.birch"
libbirch::Lazy<libbirch::Shared<birch::type::OutputStream>> OutputStream(const birch::type::File& file, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
#line 69 "src/io/Reader.birch"
libbirch::Lazy<libbirch::Shared<birch::type::Reader>> Reader(const birch::type::String& path, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
#line 93 "src/io/Writer.birch"
libbirch::Lazy<libbirch::Shared<birch::type::Writer>> Writer(const birch::type::String& path, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
template<class Type>
#line 36 "src/iterator/ArrayIterator.birch"
libbirch::Lazy<libbirch::Shared<birch::type::ArrayIterator<Type>>> ArrayIterator(const libbirch::Lazy<libbirch::Shared<birch::type::Array<Type>>>& o, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
template<class Type>
#line 24 "src/iterator/EmptyIterator.birch"
libbirch::Lazy<libbirch::Shared<birch::type::EmptyIterator<Type>>> EmptyIterator(const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
template<class Type>
#line 32 "src/iterator/ListIterator.birch"
libbirch::Lazy<libbirch::Shared<birch::type::ListIterator<Type>>> ListIterator(const libbirch::Optional<libbirch::Lazy<libbirch::Shared<birch::type::ListNode<Type>>>>& head, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
template<class Type>
#line 43 "src/iterator/RaggedArrayElementIterator.birch"
libbirch::Lazy<libbirch::Shared<birch::type::RaggedArrayElementIterator<Type>>> RaggedArrayElementIterator(const libbirch::Lazy<libbirch::Shared<birch::type::RaggedArray<Type>>>& o, const birch::type::Integer& i, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
template<class Type>
#line 37 "src/iterator/RaggedArrayRowIterator.birch"
libbirch::Lazy<libbirch::Shared<birch::type::RaggedArrayRowIterator<Type>>> RaggedArrayRowIterator(const libbirch::Lazy<libbirch::Shared<birch::type::RaggedArray<Type>>>& o, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
template<class Type>
#line 32 "src/iterator/StackIterator.birch"
libbirch::Lazy<libbirch::Shared<birch::type::StackIterator<Type>>> StackIterator(const libbirch::Optional<libbirch::Lazy<libbirch::Shared<birch::type::StackNode<Type>>>>& head, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
template<class Type>
#line 32 "src/iterator/TapeIterator.birch"
libbirch::Lazy<libbirch::Shared<birch::type::TapeIterator<Type>>> TapeIterator(const libbirch::Optional<libbirch::Lazy<libbirch::Shared<birch::type::TapeNode<Type>>>>& head, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
#line 14 "src/math/cdf.birch"
birch::type::Real cdf_binomial(const birch::type::Integer& x, const birch::type::Integer& n, const birch::type::Real& _u0961, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
#line 36 "src/math/cdf.birch"
birch::type::Real cdf_negative_binomial(const birch::type::Integer& x, const birch::type::Integer& k, const birch::type::Real& _u0961, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
#line 55 "src/math/cdf.birch"
birch::type::Real cdf_poisson(const birch::type::Integer& x, const birch::type::Real& _u0955, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
#line 75 "src/math/cdf.birch"
birch::type::Real cdf_uniform_int(const birch::type::Integer& x, const birch::type::Integer& l, const birch::type::Integer& u, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
#line 93 "src/math/cdf.birch"
birch::type::Real cdf_categorical(const birch::type::Integer& x, const libbirch::DefaultArray<birch::type::Real,1>& _u0961, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
#line 110 "src/math/cdf.birch"
birch::type::Real cdf_uniform(const birch::type::Real& x, const birch::type::Real& l, const birch::type::Real& u, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
#line 132 "src/math/cdf.birch"
birch::type::Real cdf_inverse_gamma_gamma(const birch::type::Real& x, const birch::type::Real& k, const birch::type::Real& _u0945, const birch::type::Real& _u0946, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
#line 148 "src/math/cdf.birch"
birch::type::Real cdf_exponential(const birch::type::Real& x, const birch::type::Real& _u0955, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
#line 167 "src/math/cdf.birch"
birch::type::Real cdf_weibull(const birch::type::Real& x, const birch::type::Real& k, const birch::type::Real& _u0955, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
#line 186 "src/math/cdf.birch"
birch::type::Real cdf_gaussian(const birch::type::Real& x, const birch::type::Real& _u0956, const birch::type::Real& _u09632, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
#line 199 "src/math/cdf.birch"
birch::type::Real cdf_student_t(const birch::type::Real& x, const birch::type::Real& _u0957, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
#line 217 "src/math/cdf.birch"
birch::type::Real cdf_student_t(const birch::type::Real& x, const birch::type::Real& k, const birch::type::Real& _u0956, const birch::type::Real& _u09632, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
#line 231 "src/math/cdf.birch"
birch::type::Real cdf_beta(const birch::type::Real& x, const birch::type::Real& _u0945, const birch::type::Real& _u0946, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
#line 252 "src/math/cdf.birch"
birch::type::Real cdf_chi_squared(const birch::type::Real& x, const birch::type::Real& _u0957, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
#line 266 "src/math/cdf.birch"
birch::type::Real cdf_gamma(const birch::type::Real& x, const birch::type::Real& k, const birch::type::Real& _u0952, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
#line 286 "src/math/cdf.birch"
birch::type::Real cdf_inverse_gamma(const birch::type::Real& x, const birch::type::Real& _u0945, const birch::type::Real& _u0946, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
#line 308 "src/math/cdf.birch"
birch::type::Real cdf_normal_inverse_gamma(const birch::type::Real& x, const birch::type::Real& _u0956, const birch::type::Real& _u09632, const birch::type::Real& _u0945, const birch::type::Real& _u0946, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
#line 323 "src/math/cdf.birch"
birch::type::Real cdf_beta_binomial(const birch::type::Integer& x, const birch::type::Integer& n, const birch::type::Real& _u0945, const birch::type::Real& _u0946, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
#line 340 "src/math/cdf.birch"
birch::type::Real cdf_gamma_poisson(const birch::type::Integer& x, const birch::type::Real& k, const birch::type::Real& _u0952, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
#line 357 "src/math/cdf.birch"
birch::type::Real cdf_lomax(const birch::type::Real& x, const birch::type::Real& _u0955, const birch::type::Real& _u0945, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
#line 379 "src/math/cdf.birch"
birch::type::Real cdf_normal_inverse_gamma_gaussian(const birch::type::Real& x, const birch::type::Real& _u0956, const birch::type::Real& a2, const birch::type::Real& _u0945, const birch::type::Real& _u0946, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
#line 398 "src/math/cdf.birch"
birch::type::Real cdf_linear_normal_inverse_gamma_gaussian(const birch::type::Real& x, const birch::type::Real& a, const birch::type::Real& _u0956, const birch::type::Real& a2, const birch::type::Real& c, const birch::type::Real& _u0945, const birch::type::Real& _u0946, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
#line 417 "src/math/cdf.birch"
birch::type::Real cdf_linear_multivariate_normal_inverse_gamma_gaussian(const birch::type::Real& x, const libbirch::DefaultArray<birch::type::Real,1>& a, const libbirch::DefaultArray<birch::type::Real,1>& _u0957, const birch::type::LLT& _u0923, const birch::type::Real& c, const birch::type::Real& _u0945, const birch::type::Real& _u0947, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
#line 10 "src/math/distance.birch"
birch::type::Real wasserstein(const libbirch::DefaultArray<birch::type::Real,1>& x1, const libbirch::DefaultArray<birch::type::Real,1>& x2, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
#line 269 "src/math/eigen.birch"
birch::type::Real dot(const libbirch::DefaultArray<birch::type::Real,1>& x, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
#line 278 "src/math/eigen.birch"
birch::type::Real dot(const libbirch::DefaultArray<birch::type::Real,1>& x, const libbirch::DefaultArray<birch::type::Real,1>& y, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
#line 288 "src/math/eigen.birch"
libbirch::DefaultArray<birch::type::Real,1> dot(const libbirch::DefaultArray<birch::type::Real,1>& x, const libbirch::DefaultArray<birch::type::Real,2>& Y, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
#line 297 "src/math/eigen.birch"
libbirch::DefaultArray<birch::type::Real,2> outer(const libbirch::DefaultArray<birch::type::Real,1>& x, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
#line 307 "src/math/eigen.birch"
libbirch::DefaultArray<birch::type::Real,2> outer(const libbirch::DefaultArray<birch::type::Real,1>& x, const libbirch::DefaultArray<birch::type::Real,1>& y, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
#line 316 "src/math/eigen.birch"
libbirch::DefaultArray<birch::type::Real,2> outer(const libbirch::DefaultArray<birch::type::Real,2>& X, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
#line 326 "src/math/eigen.birch"
libbirch::DefaultArray<birch::type::Real,2> outer(const libbirch::DefaultArray<birch::type::Real,2>& X, const libbirch::DefaultArray<birch::type::Real,2>& Y, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
#line 335 "src/math/eigen.birch"
birch::type::Real norm(const libbirch::DefaultArray<birch::type::Real,1>& x, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
#line 344 "src/math/eigen.birch"
libbirch::DefaultArray<birch::type::Real,1> sqrt(const libbirch::DefaultArray<birch::type::Real,1>& x, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
#line 353 "src/math/eigen.birch"
libbirch::DefaultArray<birch::type::Real,2> transpose(const libbirch::DefaultArray<birch::type::Real,2>& X, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
#line 362 "src/math/eigen.birch"
birch::type::LLT transpose(const birch::type::LLT& S, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
#line 369 "src/math/eigen.birch"
libbirch::DefaultArray<birch::type::Real,2> transpose(const libbirch::DefaultArray<birch::type::Real,1>& x, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
#line 378 "src/math/eigen.birch"
libbirch::DefaultArray<birch::type::Real,2> diagonal(const libbirch::DefaultArray<birch::type::Real,1>& x, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
#line 387 "src/math/eigen.birch"
libbirch::DefaultArray<birch::type::Real,1> diagonal(const libbirch::DefaultArray<birch::type::Real,2>& X, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
#line 396 "src/math/eigen.birch"
birch::type::Real trace(const libbirch::DefaultArray<birch::type::Real,2>& X, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
#line 405 "src/math/eigen.birch"
birch::type::Real trace(const birch::type::LLT& S, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
#line 414 "src/math/eigen.birch"
birch::type::Real det(const libbirch::DefaultArray<birch::type::Real,2>& X, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
#line 423 "src/math/eigen.birch"
birch::type::Real ldet(const libbirch::DefaultArray<birch::type::Real,2>& X, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
#line 432 "src/math/eigen.birch"
birch::type::Real det(const birch::type::LLT& S, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
#line 442 "src/math/eigen.birch"
birch::type::Real ldet(const birch::type::LLT& S, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
#line 451 "src/math/eigen.birch"
libbirch::DefaultArray<birch::type::Real,2> inv(const libbirch::DefaultArray<birch::type::Real,2>& X, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
#line 460 "src/math/eigen.birch"
birch::type::LLT inv(const birch::type::LLT& S, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
#line 470 "src/math/eigen.birch"
libbirch::DefaultArray<birch::type::Real,1> solve(const libbirch::DefaultArray<birch::type::Real,2>& X, const libbirch::DefaultArray<birch::type::Real,1>& y, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
#line 479 "src/math/eigen.birch"
libbirch::DefaultArray<birch::type::Real,1> solve(const birch::type::LLT& S, const libbirch::DefaultArray<birch::type::Real,1>& y, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
#line 488 "src/math/eigen.birch"
libbirch::DefaultArray<birch::type::Real,2> solve(const libbirch::DefaultArray<birch::type::Real,2>& X, const libbirch::DefaultArray<birch::type::Real,2>& Y, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
#line 497 "src/math/eigen.birch"
libbirch::DefaultArray<birch::type::Real,2> solve(const birch::type::LLT& S, const libbirch::DefaultArray<birch::type::Real,2>& Y, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
#line 508 "src/math/eigen.birch"
libbirch::DefaultArray<birch::type::Real,2> cholesky(const birch::type::LLT& S, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
#line 517 "src/math/eigen.birch"
libbirch::DefaultArray<birch::type::Real,1> hadamard(const libbirch::DefaultArray<birch::type::Real,1>& x, const libbirch::DefaultArray<birch::type::Real,1>& y, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
#line 526 "src/math/eigen.birch"
libbirch::DefaultArray<birch::type::Real,2> hadamard(const libbirch::DefaultArray<birch::type::Real,2>& X, const libbirch::DefaultArray<birch::type::Real,2>& Y, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
#line 535 "src/math/eigen.birch"
birch::type::Real canonical(const birch::type::Real& x, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
#line 542 "src/math/eigen.birch"
birch::type::Integer canonical(const birch::type::Integer& x, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
#line 549 "src/math/eigen.birch"
birch::type::Boolean canonical(const birch::type::Boolean& x, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
#line 556 "src/math/eigen.birch"
libbirch::DefaultArray<birch::type::Real,1> canonical(const libbirch::DefaultArray<birch::type::Real,1>& x, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
#line 563 "src/math/eigen.birch"
libbirch::DefaultArray<birch::type::Integer,1> canonical(const libbirch::DefaultArray<birch::type::Integer,1>& x, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
#line 569 "src/math/eigen.birch"
libbirch::DefaultArray<birch::type::Boolean,1> canonical(const libbirch::DefaultArray<birch::type::Boolean,1>& x, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
#line 576 "src/math/eigen.birch"
libbirch::DefaultArray<birch::type::Real,2> canonical(const libbirch::DefaultArray<birch::type::Real,2>& X, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
#line 583 "src/math/eigen.birch"
libbirch::DefaultArray<birch::type::Integer,2> canonical(const libbirch::DefaultArray<birch::type::Integer,2>& X, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
#line 590 "src/math/eigen.birch"
libbirch::DefaultArray<birch::type::Boolean,2> canonical(const libbirch::DefaultArray<birch::type::Boolean,2>& X, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
#line 597 "src/math/eigen.birch"
libbirch::DefaultArray<birch::type::Real,2> canonical(const birch::type::LLT& X, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
template<class Type>
#line 8 "src/math/iterator.birch"
Type reduce(const libbirch::Lazy<libbirch::Shared<birch::type::Iterator<Type>>>& iter, const Type& init, const std::function<Type(Type, Type, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>&)>& op, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
template<class Type>
#line 20 "src/math/iterator.birch"
Type sum(const libbirch::Lazy<libbirch::Shared<birch::type::Iterator<Type>>>& iter, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
template<class Type>
#line 30 "src/math/iterator.birch"
Type product(const libbirch::Lazy<libbirch::Shared<birch::type::Iterator<Type>>>& iter, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
template<class Type>
#line 40 "src/math/iterator.birch"
Type max(const libbirch::Lazy<libbirch::Shared<birch::type::Iterator<Type>>>& iter, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
template<class Type>
#line 50 "src/math/iterator.birch"
Type min(const libbirch::Lazy<libbirch::Shared<birch::type::Iterator<Type>>>& iter, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
#line 9 "src/math/logpdf.birch"
birch::type::Real logpdf_bernoulli(const birch::type::Boolean& x, const birch::type::Real& _u0961, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
#line 26 "src/math/logpdf.birch"
birch::type::Real logpdf_delta(const birch::type::Integer& x, const birch::type::Integer& _u0956, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
#line 43 "src/math/logpdf.birch"
birch::type::Real logpdf_binomial(const birch::type::Integer& x, const birch::type::Integer& n, const birch::type::Real& _u0961, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
#line 69 "src/math/logpdf.birch"
birch::type::Real logpdf_negative_binomial(const birch::type::Integer& x, const birch::type::Integer& k, const birch::type::Real& _u0961, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
#line 88 "src/math/logpdf.birch"
birch::type::Real logpdf_poisson(const birch::type::Integer& x, const birch::type::Real& _u0955, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
#line 115 "src/math/logpdf.birch"
birch::type::Real logpdf_uniform_int(const birch::type::Integer& x, const birch::type::Integer& l, const birch::type::Integer& u, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
#line 131 "src/math/logpdf.birch"
birch::type::Real logpdf_categorical(const birch::type::Integer& x, const libbirch::DefaultArray<birch::type::Real,1>& _u0961, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
#line 149 "src/math/logpdf.birch"
birch::type::Real logpdf_multinomial(const libbirch::DefaultArray<birch::type::Integer,1>& x, const birch::type::Integer& n, const libbirch::DefaultArray<birch::type::Real,1>& _u0961, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
#line 175 "src/math/logpdf.birch"
birch::type::Real logpdf_dirichlet(const libbirch::DefaultArray<birch::type::Real,1>& x, const libbirch::DefaultArray<birch::type::Real,1>& _u0945, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
#line 199 "src/math/logpdf.birch"
birch::type::Real logpdf_uniform(const birch::type::Real& x, const birch::type::Real& l, const birch::type::Real& u, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
#line 217 "src/math/logpdf.birch"
birch::type::Real logpdf_exponential(const birch::type::Real& x, const birch::type::Real& _u0955, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
#line 231 "src/math/logpdf.birch"
birch::type::Real logpdf_weibull(const birch::type::Real& x, const birch::type::Real& k, const birch::type::Real& _u0955, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
#line 246 "src/math/logpdf.birch"
birch::type::Real logpdf_gaussian(const birch::type::Real& x, const birch::type::Real& _u0956, const birch::type::Real& _u09632, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
#line 259 "src/math/logpdf.birch"
birch::type::Real logpdf_student_t(const birch::type::Real& x, const birch::type::Real& k, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
#line 276 "src/math/logpdf.birch"
birch::type::Real logpdf_student_t(const birch::type::Real& x, const birch::type::Real& k, const birch::type::Real& _u0956, const birch::type::Real& v, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
#line 294 "src/math/logpdf.birch"
birch::type::Real logpdf_beta(const birch::type::Real& x, const birch::type::Real& _u0945, const birch::type::Real& _u0946, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
#line 313 "src/math/logpdf.birch"
birch::type::Real logpdf_chi_squared(const birch::type::Real& x, const birch::type::Real& _u0957, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
#line 332 "src/math/logpdf.birch"
birch::type::Real logpdf_gamma(const birch::type::Real& x, const birch::type::Real& k, const birch::type::Real& _u0952, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
#line 348 "src/math/logpdf.birch"
birch::type::Real logpdf_wishart(const birch::type::LLT& X, const birch::type::LLT& _u0936, const birch::type::Real& _u0957, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
#line 364 "src/math/logpdf.birch"
birch::type::Real logpdf_inverse_gamma(const birch::type::Real& x, const birch::type::Real& _u0945, const birch::type::Real& _u0946, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
#line 380 "src/math/logpdf.birch"
birch::type::Real logpdf_inverse_wishart(const birch::type::LLT& X, const birch::type::LLT& _u0936, const birch::type::Real& _u0957, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
#line 397 "src/math/logpdf.birch"
birch::type::Real logpdf_inverse_gamma_gamma(const birch::type::Real& x, const birch::type::Real& k, const birch::type::Real& _u0945, const birch::type::Real& _u0946, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
#line 416 "src/math/logpdf.birch"
birch::type::Real logpdf_normal_inverse_gamma(const birch::type::Real& x, const birch::type::Real& _u0956, const birch::type::Real& a2, const birch::type::Real& _u0945, const birch::type::Real& _u0946, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
#line 430 "src/math/logpdf.birch"
birch::type::Real logpdf_beta_bernoulli(const birch::type::Boolean& x, const birch::type::Real& _u0945, const birch::type::Real& _u0946, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
#line 451 "src/math/logpdf.birch"
birch::type::Real logpdf_beta_binomial(const birch::type::Integer& x, const birch::type::Integer& n, const birch::type::Real& _u0945, const birch::type::Real& _u0946, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
#line 473 "src/math/logpdf.birch"
birch::type::Real logpdf_beta_negative_binomial(const birch::type::Integer& x, const birch::type::Integer& k, const birch::type::Real& _u0945, const birch::type::Real& _u0946, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
#line 493 "src/math/logpdf.birch"
birch::type::Real logpdf_gamma_poisson(const birch::type::Integer& x, const birch::type::Real& k, const birch::type::Real& _u0952, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
#line 510 "src/math/logpdf.birch"
birch::type::Real logpdf_lomax(const birch::type::Real& x, const birch::type::Real& _u0955, const birch::type::Real& _u0945, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
#line 525 "src/math/logpdf.birch"
birch::type::Real logpdf_dirichlet_categorical(const birch::type::Integer& x, const libbirch::DefaultArray<birch::type::Real,1>& _u0945, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
#line 543 "src/math/logpdf.birch"
birch::type::Real logpdf_dirichlet_multinomial(const libbirch::DefaultArray<birch::type::Integer,1>& x, const birch::type::Integer& n, const libbirch::DefaultArray<birch::type::Real,1>& _u0945, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
#line 571 "src/math/logpdf.birch"
birch::type::Real logpdf_crp_categorical(const birch::type::Integer& k, const birch::type::Real& _u0945, const birch::type::Real& _u0952, const libbirch::DefaultArray<birch::type::Integer,1>& n, const birch::type::Integer& N, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
#line 594 "src/math/logpdf.birch"
birch::type::Real logpdf_normal_inverse_gamma_gaussian(const birch::type::Real& x, const birch::type::Real& _u0956, const birch::type::Real& a2, const birch::type::Real& _u0945, const birch::type::Real& _u0946, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
#line 613 "src/math/logpdf.birch"
birch::type::Real logpdf_linear_normal_inverse_gamma_gaussian(const birch::type::Real& x, const birch::type::Real& a, const birch::type::Real& _u0956, const birch::type::Real& a2, const birch::type::Real& c, const birch::type::Real& _u0945, const birch::type::Real& _u0946, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
#line 627 "src/math/logpdf.birch"
birch::type::Real logpdf_multivariate_gaussian(const libbirch::DefaultArray<birch::type::Real,1>& x, const libbirch::DefaultArray<birch::type::Real,1>& _u0956, const birch::type::LLT& _u0931, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
#line 641 "src/math/logpdf.birch"
birch::type::Real logpdf_multivariate_gaussian(const libbirch::DefaultArray<birch::type::Real,1>& x, const libbirch::DefaultArray<birch::type::Real,1>& _u0956, const libbirch::DefaultArray<birch::type::Real,1>& _u09632, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
#line 660 "src/math/logpdf.birch"
birch::type::Real logpdf_multivariate_gaussian(const libbirch::DefaultArray<birch::type::Real,1>& x, const libbirch::DefaultArray<birch::type::Real,1>& _u0956, const birch::type::Real& _u09632, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
#line 676 "src/math/logpdf.birch"
birch::type::Real logpdf_multivariate_normal_inverse_gamma(const libbirch::DefaultArray<birch::type::Real,1>& x, const libbirch::DefaultArray<birch::type::Real,1>& _u0957, const birch::type::LLT& _u0923, const birch::type::Real& _u0945, const birch::type::Real& _u0946, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
#line 693 "src/math/logpdf.birch"
birch::type::Real logpdf_multivariate_normal_inverse_gamma_multivariate_gaussian(const libbirch::DefaultArray<birch::type::Real,1>& x, const libbirch::DefaultArray<birch::type::Real,1>& _u0957, const birch::type::LLT& _u0923, const birch::type::Real& _u0945, const birch::type::Real& _u0947, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
#line 716 "src/math/logpdf.birch"
birch::type::Real logpdf_linear_multivariate_normal_inverse_gamma_multivariate_gaussian(const libbirch::DefaultArray<birch::type::Real,1>& x, const libbirch::DefaultArray<birch::type::Real,2>& A, const libbirch::DefaultArray<birch::type::Real,1>& _u0957, const birch::type::LLT& _u0923, const libbirch::DefaultArray<birch::type::Real,1>& c, const birch::type::Real& _u0945, const birch::type::Real& _u0947, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
#line 740 "src/math/logpdf.birch"
birch::type::Real logpdf_linear_multivariate_normal_inverse_gamma_gaussian(const birch::type::Real& x, const libbirch::DefaultArray<birch::type::Real,1>& a, const libbirch::DefaultArray<birch::type::Real,1>& _u0957, const birch::type::LLT& _u0923, const birch::type::Real& c, const birch::type::Real& _u0945, const birch::type::Real& _u0947, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
#line 758 "src/math/logpdf.birch"
birch::type::Real logpdf_matrix_gaussian(const libbirch::DefaultArray<birch::type::Real,2>& X, const libbirch::DefaultArray<birch::type::Real,2>& M, const birch::type::LLT& U, const birch::type::LLT& V, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
#line 776 "src/math/logpdf.birch"
birch::type::Real logpdf_matrix_gaussian(const libbirch::DefaultArray<birch::type::Real,2>& X, const libbirch::DefaultArray<birch::type::Real,2>& M, const birch::type::LLT& U, const libbirch::DefaultArray<birch::type::Real,1>& _u09632, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
#line 793 "src/math/logpdf.birch"
birch::type::Real logpdf_matrix_gaussian(const libbirch::DefaultArray<birch::type::Real,2>& X, const libbirch::DefaultArray<birch::type::Real,2>& M, const birch::type::LLT& V, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
#line 809 "src/math/logpdf.birch"
birch::type::Real logpdf_matrix_gaussian(const libbirch::DefaultArray<birch::type::Real,2>& X, const libbirch::DefaultArray<birch::type::Real,2>& M, const libbirch::DefaultArray<birch::type::Real,1>& _u09632, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
#line 827 "src/math/logpdf.birch"
birch::type::Real logpdf_matrix_gaussian(const libbirch::DefaultArray<birch::type::Real,2>& X, const libbirch::DefaultArray<birch::type::Real,2>& M, const birch::type::Real& _u09632, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
#line 845 "src/math/logpdf.birch"
birch::type::Real logpdf_matrix_normal_inverse_wishart(const libbirch::DefaultArray<birch::type::Real,2>& X, const libbirch::DefaultArray<birch::type::Real,2>& N, const birch::type::LLT& _u0923, const birch::type::LLT& _u0936, const birch::type::Real& k, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
#line 865 "src/math/logpdf.birch"
birch::type::Real logpdf_matrix_normal_inverse_wishart_matrix_gaussian(const libbirch::DefaultArray<birch::type::Real,2>& X, const libbirch::DefaultArray<birch::type::Real,2>& N, const birch::type::LLT& _u0923, const birch::type::LLT& _u0936, const birch::type::Real& k, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
#line 888 "src/math/logpdf.birch"
birch::type::Real logpdf_linear_matrix_normal_inverse_wishart_matrix_gaussian(const libbirch::DefaultArray<birch::type::Real,2>& X, const libbirch::DefaultArray<birch::type::Real,2>& A, const libbirch::DefaultArray<birch::type::Real,2>& N, const birch::type::LLT& _u0923, const libbirch::DefaultArray<birch::type::Real,2>& C, const birch::type::LLT& _u0936, const birch::type::Real& k, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
#line 912 "src/math/logpdf.birch"
birch::type::Real logpdf_linear_matrix_normal_inverse_wishart_multivariate_gaussian(const libbirch::DefaultArray<birch::type::Real,1>& x, const libbirch::DefaultArray<birch::type::Real,1>& a, const libbirch::DefaultArray<birch::type::Real,2>& N, const birch::type::LLT& _u0923, const libbirch::DefaultArray<birch::type::Real,1>& c, const birch::type::LLT& _u0936, const birch::type::Real& k, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
#line 933 "src/math/logpdf.birch"
birch::type::Real logpdf_multivariate_student_t(const libbirch::DefaultArray<birch::type::Real,1>& x, const birch::type::Real& k, const libbirch::DefaultArray<birch::type::Real,1>& _u0956, const birch::type::LLT& U, const birch::type::Real& v, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
#line 950 "src/math/logpdf.birch"
birch::type::Real logpdf_multivariate_student_t(const libbirch::DefaultArray<birch::type::Real,1>& x, const birch::type::Real& k, const libbirch::DefaultArray<birch::type::Real,1>& _u0956, const birch::type::Real& u, const birch::type::LLT& V, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
#line 972 "src/math/logpdf.birch"
birch::type::Real logpdf_matrix_student_t(const libbirch::DefaultArray<birch::type::Real,2>& X, const birch::type::Real& k, const libbirch::DefaultArray<birch::type::Real,2>& M, const birch::type::LLT& U, const birch::type::LLT& V, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
#line 993 "src/math/logpdf.birch"
birch::type::Real logpdf_independent_uniform(const libbirch::DefaultArray<birch::type::Real,1>& x, const libbirch::DefaultArray<birch::type::Real,1>& l, const libbirch::DefaultArray<birch::type::Real,1>& u, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
#line 1015 "src/math/logpdf.birch"
birch::type::Real logpdf_independent_uniform_int(const libbirch::DefaultArray<birch::type::Integer,1>& x, const libbirch::DefaultArray<birch::type::Integer,1>& l, const libbirch::DefaultArray<birch::type::Integer,1>& u, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
#line 9 "src/math/logpdf_lazy.birch"
libbirch::Lazy<libbirch::Shared<birch::type::Expression<birch::type::Real>>> logpdf_lazy_bernoulli(const libbirch::Lazy<libbirch::Shared<birch::type::Expression<birch::type::Boolean>>>& x, const libbirch::Lazy<libbirch::Shared<birch::type::Expression<birch::type::Real>>>& _u0961, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
#line 22 "src/math/logpdf_lazy.birch"
libbirch::Lazy<libbirch::Shared<birch::type::Expression<birch::type::Real>>> logpdf_lazy_binomial(const libbirch::Lazy<libbirch::Shared<birch::type::Expression<birch::type::Integer>>>& x, const libbirch::Lazy<libbirch::Shared<birch::type::Expression<birch::type::Integer>>>& n, const libbirch::Lazy<libbirch::Shared<birch::type::Expression<birch::type::Real>>>& _u0961, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
#line 35 "src/math/logpdf_lazy.birch"
libbirch::Lazy<libbirch::Shared<birch::type::Expression<birch::type::Real>>> logpdf_lazy_negative_binomial(const libbirch::Lazy<libbirch::Shared<birch::type::Expression<birch::type::Integer>>>& x, const libbirch::Lazy<libbirch::Shared<birch::type::Expression<birch::type::Integer>>>& k, const libbirch::Lazy<libbirch::Shared<birch::type::Expression<birch::type::Real>>>& _u0961, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
#line 47 "src/math/logpdf_lazy.birch"
libbirch::Lazy<libbirch::Shared<birch::type::Expression<birch::type::Real>>> logpdf_lazy_poisson(const libbirch::Lazy<libbirch::Shared<birch::type::Expression<birch::type::Integer>>>& x, const libbirch::Lazy<libbirch::Shared<birch::type::Expression<birch::type::Real>>>& _u0955, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
#line 122 "src/math/logpdf_lazy.birch"
libbirch::Lazy<libbirch::Shared<birch::type::Expression<birch::type::Real>>> logpdf_lazy_exponential(const libbirch::Lazy<libbirch::Shared<birch::type::Expression<birch::type::Real>>>& x, const libbirch::Lazy<libbirch::Shared<birch::type::Expression<birch::type::Real>>>& _u0955, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
#line 135 "src/math/logpdf_lazy.birch"
libbirch::Lazy<libbirch::Shared<birch::type::Expression<birch::type::Real>>> logpdf_lazy_weibull(const libbirch::Lazy<libbirch::Shared<birch::type::Expression<birch::type::Real>>>& x, const libbirch::Lazy<libbirch::Shared<birch::type::Expression<birch::type::Real>>>& k, const libbirch::Lazy<libbirch::Shared<birch::type::Expression<birch::type::Real>>>& _u0955, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
#line 149 "src/math/logpdf_lazy.birch"
libbirch::Lazy<libbirch::Shared<birch::type::Expression<birch::type::Real>>> logpdf_lazy_gaussian(const libbirch::Lazy<libbirch::Shared<birch::type::Expression<birch::type::Real>>>& x, const libbirch::Lazy<libbirch::Shared<birch::type::Expression<birch::type::Real>>>& _u0956, const libbirch::Lazy<libbirch::Shared<birch::type::Expression<birch::type::Real>>>& _u09632, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
#line 161 "src/math/logpdf_lazy.birch"
libbirch::Lazy<libbirch::Shared<birch::type::Expression<birch::type::Real>>> logpdf_lazy_student_t(const libbirch::Lazy<libbirch::Shared<birch::type::Expression<birch::type::Real>>>& x, const libbirch::Lazy<libbirch::Shared<birch::type::Expression<birch::type::Real>>>& k, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
#line 177 "src/math/logpdf_lazy.birch"
libbirch::Lazy<libbirch::Shared<birch::type::Expression<birch::type::Real>>> logpdf_lazy_student_t(const libbirch::Lazy<libbirch::Shared<birch::type::Expression<birch::type::Real>>>& x, const libbirch::Lazy<libbirch::Shared<birch::type::Expression<birch::type::Real>>>& k, const libbirch::Lazy<libbirch::Shared<birch::type::Expression<birch::type::Real>>>& _u0956, const libbirch::Lazy<libbirch::Shared<birch::type::Expression<birch::type::Real>>>& v, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
#line 193 "src/math/logpdf_lazy.birch"
libbirch::Lazy<libbirch::Shared<birch::type::Expression<birch::type::Real>>> logpdf_lazy_beta(const libbirch::Lazy<libbirch::Shared<birch::type::Expression<birch::type::Real>>>& x, const libbirch::Lazy<libbirch::Shared<birch::type::Expression<birch::type::Real>>>& _u0945, const libbirch::Lazy<libbirch::Shared<birch::type::Expression<birch::type::Real>>>& _u0946, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
#line 205 "src/math/logpdf_lazy.birch"
libbirch::Lazy<libbirch::Shared<birch::type::Expression<birch::type::Real>>> logpdf_lazy_chi_squared(const libbirch::Lazy<libbirch::Shared<birch::type::Expression<birch::type::Real>>>& x, const libbirch::Lazy<libbirch::Shared<birch::type::Expression<birch::type::Real>>>& _u0957, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
#line 219 "src/math/logpdf_lazy.birch"
libbirch::Lazy<libbirch::Shared<birch::type::Expression<birch::type::Real>>> logpdf_lazy_gamma(const libbirch::Lazy<libbirch::Shared<birch::type::Expression<birch::type::Real>>>& x, const libbirch::Lazy<libbirch::Shared<birch::type::Expression<birch::type::Real>>>& k, const libbirch::Lazy<libbirch::Shared<birch::type::Expression<birch::type::Real>>>& _u0952, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
#line 233 "src/math/logpdf_lazy.birch"
libbirch::Lazy<libbirch::Shared<birch::type::Expression<birch::type::Real>>> logpdf_lazy_wishart(const libbirch::Lazy<libbirch::Shared<birch::type::Expression<birch::type::LLT>>>& X, const libbirch::Lazy<libbirch::Shared<birch::type::Expression<birch::type::LLT>>>& _u0936, const libbirch::Lazy<libbirch::Shared<birch::type::Expression<birch::type::Real>>>& _u0957, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
#line 248 "src/math/logpdf_lazy.birch"
libbirch::Lazy<libbirch::Shared<birch::type::Expression<birch::type::Real>>> logpdf_lazy_inverse_gamma(const libbirch::Lazy<libbirch::Shared<birch::type::Expression<birch::type::Real>>>& x, const libbirch::Lazy<libbirch::Shared<birch::type::Expression<birch::type::Real>>>& _u0945, const libbirch::Lazy<libbirch::Shared<birch::type::Expression<birch::type::Real>>>& _u0946, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
#line 262 "src/math/logpdf_lazy.birch"
libbirch::Lazy<libbirch::Shared<birch::type::Expression<birch::type::Real>>> logpdf_lazy_inverse_wishart(const libbirch::Lazy<libbirch::Shared<birch::type::Expression<birch::type::LLT>>>& X, const libbirch::Lazy<libbirch::Shared<birch::type::Expression<birch::type::LLT>>>& _u0936, const libbirch::Lazy<libbirch::Shared<birch::type::Expression<birch::type::Real>>>& _u0957, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
#line 278 "src/math/logpdf_lazy.birch"
libbirch::Lazy<libbirch::Shared<birch::type::Expression<birch::type::Real>>> logpdf_lazy_inverse_gamma_gamma(const libbirch::Lazy<libbirch::Shared<birch::type::Expression<birch::type::Real>>>& x, const libbirch::Lazy<libbirch::Shared<birch::type::Expression<birch::type::Real>>>& k, const libbirch::Lazy<libbirch::Shared<birch::type::Expression<birch::type::Real>>>& _u0945, const libbirch::Lazy<libbirch::Shared<birch::type::Expression<birch::type::Real>>>& _u0946, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
#line 293 "src/math/logpdf_lazy.birch"
libbirch::Lazy<libbirch::Shared<birch::type::Expression<birch::type::Real>>> logpdf_lazy_normal_inverse_gamma(const libbirch::Lazy<libbirch::Shared<birch::type::Expression<birch::type::Real>>>& x, const libbirch::Lazy<libbirch::Shared<birch::type::Expression<birch::type::Real>>>& _u0956, const libbirch::Lazy<libbirch::Shared<birch::type::Expression<birch::type::Real>>>& a2, const libbirch::Lazy<libbirch::Shared<birch::type::Expression<birch::type::Real>>>& _u0945, const libbirch::Lazy<libbirch::Shared<birch::type::Expression<birch::type::Real>>>& _u0946, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
#line 307 "src/math/logpdf_lazy.birch"
libbirch::Lazy<libbirch::Shared<birch::type::Expression<birch::type::Real>>> logpdf_lazy_beta_bernoulli(const libbirch::Lazy<libbirch::Shared<birch::type::Expression<birch::type::Boolean>>>& x, const libbirch::Lazy<libbirch::Shared<birch::type::Expression<birch::type::Real>>>& _u0945, const libbirch::Lazy<libbirch::Shared<birch::type::Expression<birch::type::Real>>>& _u0946, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
#line 321 "src/math/logpdf_lazy.birch"
libbirch::Lazy<libbirch::Shared<birch::type::Expression<birch::type::Real>>> logpdf_lazy_beta_binomial(const libbirch::Lazy<libbirch::Shared<birch::type::Expression<birch::type::Integer>>>& x, const libbirch::Lazy<libbirch::Shared<birch::type::Expression<birch::type::Integer>>>& n, const libbirch::Lazy<libbirch::Shared<birch::type::Expression<birch::type::Real>>>& _u0945, const libbirch::Lazy<libbirch::Shared<birch::type::Expression<birch::type::Real>>>& _u0946, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
#line 335 "src/math/logpdf_lazy.birch"
libbirch::Lazy<libbirch::Shared<birch::type::Expression<birch::type::Real>>> logpdf_lazy_beta_negative_binomial(const libbirch::Lazy<libbirch::Shared<birch::type::Expression<birch::type::Integer>>>& x, const libbirch::Lazy<libbirch::Shared<birch::type::Expression<birch::type::Integer>>>& k, const libbirch::Lazy<libbirch::Shared<birch::type::Expression<birch::type::Real>>>& _u0945, const libbirch::Lazy<libbirch::Shared<birch::type::Expression<birch::type::Real>>>& _u0946, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
#line 348 "src/math/logpdf_lazy.birch"
libbirch::Lazy<libbirch::Shared<birch::type::Expression<birch::type::Real>>> logpdf_lazy_gamma_poisson(const libbirch::Lazy<libbirch::Shared<birch::type::Expression<birch::type::Integer>>>& x, const libbirch::Lazy<libbirch::Shared<birch::type::Expression<birch::type::Real>>>& k, const libbirch::Lazy<libbirch::Shared<birch::type::Expression<birch::type::Real>>>& _u0952, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
#line 361 "src/math/logpdf_lazy.birch"
libbirch::Lazy<libbirch::Shared<birch::type::Expression<birch::type::Real>>> logpdf_lazy_lomax(const libbirch::Lazy<libbirch::Shared<birch::type::Expression<birch::type::Real>>>& x, const libbirch::Lazy<libbirch::Shared<birch::type::Expression<birch::type::Real>>>& _u0955, const libbirch::Lazy<libbirch::Shared<birch::type::Expression<birch::type::Real>>>& _u0945, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
#line 416 "src/math/logpdf_lazy.birch"
libbirch::Lazy<libbirch::Shared<birch::type::Expression<birch::type::Real>>> logpdf_lazy_normal_inverse_gamma_gaussian(const libbirch::Lazy<libbirch::Shared<birch::type::Expression<birch::type::Real>>>& x, const libbirch::Lazy<libbirch::Shared<birch::type::Expression<birch::type::Real>>>& _u0956, const libbirch::Lazy<libbirch::Shared<birch::type::Expression<birch::type::Real>>>& a2, const libbirch::Lazy<libbirch::Shared<birch::type::Expression<birch::type::Real>>>& _u0945, const libbirch::Lazy<libbirch::Shared<birch::type::Expression<birch::type::Real>>>& _u0946, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
#line 435 "src/math/logpdf_lazy.birch"
libbirch::Lazy<libbirch::Shared<birch::type::Expression<birch::type::Real>>> logpdf_lazy_linear_normal_inverse_gamma_gaussian(const libbirch::Lazy<libbirch::Shared<birch::type::Expression<birch::type::Real>>>& x, const libbirch::Lazy<libbirch::Shared<birch::type::Expression<birch::type::Real>>>& a, const libbirch::Lazy<libbirch::Shared<birch::type::Expression<birch::type::Real>>>& _u0956, const libbirch::Lazy<libbirch::Shared<birch::type::Expression<birch::type::Real>>>& a2, const libbirch::Lazy<libbirch::Shared<birch::type::Expression<birch::type::Real>>>& c, const libbirch::Lazy<libbirch::Shared<birch::type::Expression<birch::type::Real>>>& _u0945, const libbirch::Lazy<libbirch::Shared<birch::type::Expression<birch::type::Real>>>& _u0946, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
#line 449 "src/math/logpdf_lazy.birch"
libbirch::Lazy<libbirch::Shared<birch::type::Expression<birch::type::Real>>> logpdf_lazy_multivariate_gaussian(const libbirch::Lazy<libbirch::Shared<birch::type::Expression<libbirch::DefaultArray<birch::type::Real,1>>>>& x, const libbirch::Lazy<libbirch::Shared<birch::type::Expression<libbirch::DefaultArray<birch::type::Real,1>>>>& _u0956, const libbirch::Lazy<libbirch::Shared<birch::type::Expression<birch::type::LLT>>>& _u0931, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
#line 463 "src/math/logpdf_lazy.birch"
libbirch::Lazy<libbirch::Shared<birch::type::Expression<birch::type::Real>>> logpdf_lazy_multivariate_gaussian(const libbirch::Lazy<libbirch::Shared<birch::type::Expression<libbirch::DefaultArray<birch::type::Real,1>>>>& x, const libbirch::Lazy<libbirch::Shared<birch::type::Expression<libbirch::DefaultArray<birch::type::Real,1>>>>& _u0956, const libbirch::Lazy<libbirch::Shared<birch::type::Expression<libbirch::DefaultArray<birch::type::Real,1>>>>& _u09632, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
#line 478 "src/math/logpdf_lazy.birch"
libbirch::Lazy<libbirch::Shared<birch::type::Expression<birch::type::Real>>> logpdf_lazy_multivariate_gaussian(const libbirch::Lazy<libbirch::Shared<birch::type::Expression<libbirch::DefaultArray<birch::type::Real,1>>>>& x, const libbirch::Lazy<libbirch::Shared<birch::type::Expression<libbirch::DefaultArray<birch::type::Real,1>>>>& _u0956, const libbirch::Lazy<libbirch::Shared<birch::type::Expression<birch::type::Real>>>& _u09632, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
#line 494 "src/math/logpdf_lazy.birch"
libbirch::Lazy<libbirch::Shared<birch::type::Expression<birch::type::Real>>> logpdf_lazy_multivariate_normal_inverse_gamma(const libbirch::Lazy<libbirch::Shared<birch::type::Expression<libbirch::DefaultArray<birch::type::Real,1>>>>& x, const libbirch::Lazy<libbirch::Shared<birch::type::Expression<libbirch::DefaultArray<birch::type::Real,1>>>>& _u0957, const libbirch::Lazy<libbirch::Shared<birch::type::Expression<birch::type::LLT>>>& _u0923, const libbirch::Lazy<libbirch::Shared<birch::type::Expression<birch::type::Real>>>& _u0945, const libbirch::Lazy<libbirch::Shared<birch::type::Expression<birch::type::Real>>>& _u0946, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
#line 511 "src/math/logpdf_lazy.birch"
libbirch::Lazy<libbirch::Shared<birch::type::Expression<birch::type::Real>>> logpdf_lazy_multivariate_normal_inverse_gamma_multivariate_gaussian(const libbirch::Lazy<libbirch::Shared<birch::type::Expression<libbirch::DefaultArray<birch::type::Real,1>>>>& x, const libbirch::Lazy<libbirch::Shared<birch::type::Expression<libbirch::DefaultArray<birch::type::Real,1>>>>& _u0957, const libbirch::Lazy<libbirch::Shared<birch::type::Expression<birch::type::LLT>>>& _u0923, const libbirch::Lazy<libbirch::Shared<birch::type::Expression<birch::type::Real>>>& _u0945, const libbirch::Lazy<libbirch::Shared<birch::type::Expression<birch::type::Real>>>& _u0947, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
#line 534 "src/math/logpdf_lazy.birch"
libbirch::Lazy<libbirch::Shared<birch::type::Expression<birch::type::Real>>> logpdf_lazy_linear_multivariate_normal_inverse_gamma_multivariate_gaussian(const libbirch::Lazy<libbirch::Shared<birch::type::Expression<libbirch::DefaultArray<birch::type::Real,1>>>>& x, const libbirch::Lazy<libbirch::Shared<birch::type::Expression<libbirch::DefaultArray<birch::type::Real,2>>>>& A, const libbirch::Lazy<libbirch::Shared<birch::type::Expression<libbirch::DefaultArray<birch::type::Real,1>>>>& _u0957, const libbirch::Lazy<libbirch::Shared<birch::type::Expression<birch::type::LLT>>>& _u0923, const libbirch::Lazy<libbirch::Shared<birch::type::Expression<libbirch::DefaultArray<birch::type::Real,1>>>>& c, const libbirch::Lazy<libbirch::Shared<birch::type::Expression<birch::type::Real>>>& _u0945, const libbirch::Lazy<libbirch::Shared<birch::type::Expression<birch::type::Real>>>& _u0947, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
#line 558 "src/math/logpdf_lazy.birch"
libbirch::Lazy<libbirch::Shared<birch::type::Expression<birch::type::Real>>> logpdf_lazy_linear_multivariate_normal_inverse_gamma_gaussian(const libbirch::Lazy<libbirch::Shared<birch::type::Expression<birch::type::Real>>>& x, const libbirch::Lazy<libbirch::Shared<birch::type::Expression<libbirch::DefaultArray<birch::type::Real,1>>>>& a, const libbirch::Lazy<libbirch::Shared<birch::type::Expression<libbirch::DefaultArray<birch::type::Real,1>>>>& _u0957, const libbirch::Lazy<libbirch::Shared<birch::type::Expression<birch::type::LLT>>>& _u0923, const libbirch::Lazy<libbirch::Shared<birch::type::Expression<birch::type::Real>>>& c, const libbirch::Lazy<libbirch::Shared<birch::type::Expression<birch::type::Real>>>& _u0945, const libbirch::Lazy<libbirch::Shared<birch::type::Expression<birch::type::Real>>>& _u0947, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
#line 576 "src/math/logpdf_lazy.birch"
libbirch::Lazy<libbirch::Shared<birch::type::Expression<birch::type::Real>>> logpdf_lazy_matrix_gaussian(const libbirch::Lazy<libbirch::Shared<birch::type::Expression<libbirch::DefaultArray<birch::type::Real,2>>>>& X, const libbirch::Lazy<libbirch::Shared<birch::type::Expression<libbirch::DefaultArray<birch::type::Real,2>>>>& M, const libbirch::Lazy<libbirch::Shared<birch::type::Expression<birch::type::LLT>>>& U, const libbirch::Lazy<libbirch::Shared<birch::type::Expression<birch::type::LLT>>>& V, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
#line 594 "src/math/logpdf_lazy.birch"
libbirch::Lazy<libbirch::Shared<birch::type::Expression<birch::type::Real>>> logpdf_lazy_matrix_gaussian(const libbirch::Lazy<libbirch::Shared<birch::type::Expression<libbirch::DefaultArray<birch::type::Real,2>>>>& X, const libbirch::Lazy<libbirch::Shared<birch::type::Expression<libbirch::DefaultArray<birch::type::Real,2>>>>& M, const libbirch::Lazy<libbirch::Shared<birch::type::Expression<birch::type::LLT>>>& U, const libbirch::Lazy<libbirch::Shared<birch::type::Expression<libbirch::DefaultArray<birch::type::Real,1>>>>& _u09632, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
#line 612 "src/math/logpdf_lazy.birch"
libbirch::Lazy<libbirch::Shared<birch::type::Expression<birch::type::Real>>> logpdf_lazy_matrix_gaussian(const libbirch::Lazy<libbirch::Shared<birch::type::Expression<libbirch::DefaultArray<birch::type::Real,2>>>>& X, const libbirch::Lazy<libbirch::Shared<birch::type::Expression<libbirch::DefaultArray<birch::type::Real,2>>>>& M, const libbirch::Lazy<libbirch::Shared<birch::type::Expression<birch::type::LLT>>>& V, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
#line 628 "src/math/logpdf_lazy.birch"
libbirch::Lazy<libbirch::Shared<birch::type::Expression<birch::type::Real>>> logpdf_lazy_matrix_gaussian(const libbirch::Lazy<libbirch::Shared<birch::type::Expression<libbirch::DefaultArray<birch::type::Real,2>>>>& X, const libbirch::Lazy<libbirch::Shared<birch::type::Expression<libbirch::DefaultArray<birch::type::Real,2>>>>& M, const libbirch::Lazy<libbirch::Shared<birch::type::Expression<libbirch::DefaultArray<birch::type::Real,1>>>>& _u09632, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
#line 646 "src/math/logpdf_lazy.birch"
libbirch::Lazy<libbirch::Shared<birch::type::Expression<birch::type::Real>>> logpdf_lazy_matrix_gaussian(const libbirch::Lazy<libbirch::Shared<birch::type::Expression<libbirch::DefaultArray<birch::type::Real,2>>>>& X, const libbirch::Lazy<libbirch::Shared<birch::type::Expression<libbirch::DefaultArray<birch::type::Real,2>>>>& M, const libbirch::Lazy<libbirch::Shared<birch::type::Expression<birch::type::Real>>>& _u09632, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
#line 664 "src/math/logpdf_lazy.birch"
libbirch::Lazy<libbirch::Shared<birch::type::Expression<birch::type::Real>>> logpdf_lazy_matrix_normal_inverse_wishart(const libbirch::Lazy<libbirch::Shared<birch::type::Expression<libbirch::DefaultArray<birch::type::Real,2>>>>& X, const libbirch::Lazy<libbirch::Shared<birch::type::Expression<libbirch::DefaultArray<birch::type::Real,2>>>>& N, const libbirch::Lazy<libbirch::Shared<birch::type::Expression<birch::type::LLT>>>& _u0923, const libbirch::Lazy<libbirch::Shared<birch::type::Expression<birch::type::LLT>>>& _u0936, const libbirch::Lazy<libbirch::Shared<birch::type::Expression<birch::type::Real>>>& k, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
#line 683 "src/math/logpdf_lazy.birch"
libbirch::Lazy<libbirch::Shared<birch::type::Expression<birch::type::Real>>> logpdf_lazy_matrix_normal_inverse_wishart_matrix_gaussian(const libbirch::Lazy<libbirch::Shared<birch::type::Expression<libbirch::DefaultArray<birch::type::Real,2>>>>& X, const libbirch::Lazy<libbirch::Shared<birch::type::Expression<libbirch::DefaultArray<birch::type::Real,2>>>>& N, const libbirch::Lazy<libbirch::Shared<birch::type::Expression<birch::type::LLT>>>& _u0923, const libbirch::Lazy<libbirch::Shared<birch::type::Expression<birch::type::LLT>>>& _u0936, const libbirch::Lazy<libbirch::Shared<birch::type::Expression<birch::type::Real>>>& k, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
#line 706 "src/math/logpdf_lazy.birch"
libbirch::Lazy<libbirch::Shared<birch::type::Expression<birch::type::Real>>> logpdf_lazy_linear_matrix_normal_inverse_wishart_matrix_gaussian(const libbirch::Lazy<libbirch::Shared<birch::type::Expression<libbirch::DefaultArray<birch::type::Real,2>>>>& X, const libbirch::Lazy<libbirch::Shared<birch::type::Expression<libbirch::DefaultArray<birch::type::Real,2>>>>& A, const libbirch::Lazy<libbirch::Shared<birch::type::Expression<libbirch::DefaultArray<birch::type::Real,2>>>>& N, const libbirch::Lazy<libbirch::Shared<birch::type::Expression<birch::type::LLT>>>& _u0923, const libbirch::Lazy<libbirch::Shared<birch::type::Expression<libbirch::DefaultArray<birch::type::Real,2>>>>& C, const libbirch::Lazy<libbirch::Shared<birch::type::Expression<birch::type::LLT>>>& _u0936, const libbirch::Lazy<libbirch::Shared<birch::type::Expression<birch::type::Real>>>& k, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
#line 730 "src/math/logpdf_lazy.birch"
libbirch::Lazy<libbirch::Shared<birch::type::Expression<birch::type::Real>>> logpdf_lazy_linear_matrix_normal_inverse_wishart_multivariate_gaussian(const libbirch::Lazy<libbirch::Shared<birch::type::Expression<libbirch::DefaultArray<birch::type::Real,1>>>>& x, const libbirch::Lazy<libbirch::Shared<birch::type::Expression<libbirch::DefaultArray<birch::type::Real,1>>>>& a, const libbirch::Lazy<libbirch::Shared<birch::type::Expression<libbirch::DefaultArray<birch::type::Real,2>>>>& N, const libbirch::Lazy<libbirch::Shared<birch::type::Expression<birch::type::LLT>>>& _u0923, const libbirch::Lazy<libbirch::Shared<birch::type::Expression<libbirch::DefaultArray<birch::type::Real,1>>>>& c, const libbirch::Lazy<libbirch::Shared<birch::type::Expression<birch::type::LLT>>>& _u0936, const libbirch::Lazy<libbirch::Shared<birch::type::Expression<birch::type::Real>>>& k, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
#line 752 "src/math/logpdf_lazy.birch"
libbirch::Lazy<libbirch::Shared<birch::type::Expression<birch::type::Real>>> logpdf_lazy_multivariate_student_t(const libbirch::Lazy<libbirch::Shared<birch::type::Expression<libbirch::DefaultArray<birch::type::Real,1>>>>& x, const libbirch::Lazy<libbirch::Shared<birch::type::Expression<birch::type::Real>>>& k, const libbirch::Lazy<libbirch::Shared<birch::type::Expression<libbirch::DefaultArray<birch::type::Real,1>>>>& _u0956, const libbirch::Lazy<libbirch::Shared<birch::type::Expression<birch::type::LLT>>>& U, const libbirch::Lazy<libbirch::Shared<birch::type::Expression<birch::type::Real>>>& v, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
#line 770 "src/math/logpdf_lazy.birch"
libbirch::Lazy<libbirch::Shared<birch::type::Expression<birch::type::Real>>> logpdf_lazy_multivariate_student_t(const libbirch::Lazy<libbirch::Shared<birch::type::Expression<libbirch::DefaultArray<birch::type::Real,1>>>>& x, const libbirch::Lazy<libbirch::Shared<birch::type::Expression<birch::type::Real>>>& k, const libbirch::Lazy<libbirch::Shared<birch::type::Expression<libbirch::DefaultArray<birch::type::Real,1>>>>& _u0956, const libbirch::Lazy<libbirch::Shared<birch::type::Expression<birch::type::Real>>>& u, const libbirch::Lazy<libbirch::Shared<birch::type::Expression<birch::type::LLT>>>& V, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
#line 793 "src/math/logpdf_lazy.birch"
libbirch::Lazy<libbirch::Shared<birch::type::Expression<birch::type::Real>>> logpdf_lazy_matrix_student_t(const libbirch::Lazy<libbirch::Shared<birch::type::Expression<libbirch::DefaultArray<birch::type::Real,2>>>>& X, const libbirch::Lazy<libbirch::Shared<birch::type::Expression<birch::type::Real>>>& k, const libbirch::Lazy<libbirch::Shared<birch::type::Expression<libbirch::DefaultArray<birch::type::Real,2>>>>& M, const libbirch::Lazy<libbirch::Shared<birch::type::Expression<birch::type::LLT>>>& U, const libbirch::Lazy<libbirch::Shared<birch::type::Expression<birch::type::LLT>>>& V, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
template<class Value>
#line 4 "src/math/matrix.birch"
birch::type::Integer length(const libbirch::DefaultArray<Value,2>& X, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
template<class Value>
#line 13 "src/math/matrix.birch"
birch::type::Integer rows(const libbirch::DefaultArray<Value,2>& X, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
template<class Value>
#line 22 "src/math/matrix.birch"
birch::type::Integer columns(const libbirch::DefaultArray<Value,2>& X, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
template<class Type>
#line 31 "src/math/matrix.birch"
Type scalar(const libbirch::DefaultArray<Type,2>& X, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
template<class Type>
#line 40 "src/math/matrix.birch"
libbirch::DefaultArray<Type,2> row(const libbirch::DefaultArray<Type,1>& x, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
template<class Type>
#line 48 "src/math/matrix.birch"
libbirch::DefaultArray<Type,1> row(const libbirch::DefaultArray<Type,2>& X, const birch::type::Integer& i, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
template<class Type>
#line 55 "src/math/matrix.birch"
libbirch::DefaultArray<Type,2> column(const libbirch::DefaultArray<Type,1>& x, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
template<class Type>
#line 64 "src/math/matrix.birch"
libbirch::DefaultArray<Type,1> column(const libbirch::DefaultArray<Type,2>& X, const birch::type::Integer& j, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
template<class Type>
#line 74 "src/math/matrix.birch"
libbirch::DefaultArray<Type,1> vec(const libbirch::DefaultArray<Type,2>& X, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
template<class Type>
#line 89 "src/math/matrix.birch"
libbirch::DefaultArray<Type,2> mat(const libbirch::DefaultArray<Type,1>& x, const birch::type::Integer& columns, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
template<class Type>
#line 102 "src/math/matrix.birch"
libbirch::DefaultArray<Type,2> stack(const libbirch::DefaultArray<Type,2>& X, const libbirch::DefaultArray<Type,2>& Y, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
template<class Type>
#line 122 "src/math/matrix.birch"
libbirch::DefaultArray<Type,2> pack(const libbirch::DefaultArray<Type,2>& X, const libbirch::DefaultArray<Type,2>& Y, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
#line 144 "src/math/matrix.birch"
libbirch::DefaultArray<birch::type::Real,2> diagonal(const birch::type::Real& x, const birch::type::Integer& length, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
#line 160 "src/math/matrix.birch"
libbirch::DefaultArray<birch::type::Integer,2> diagonal(const birch::type::Integer& x, const birch::type::Integer& length, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
#line 176 "src/math/matrix.birch"
libbirch::DefaultArray<birch::type::Boolean,2> diagonal(const birch::type::Boolean& x, const birch::type::Integer& length, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
#line 192 "src/math/matrix.birch"
libbirch::DefaultArray<birch::type::Real,2> identity(const birch::type::Integer& length, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
template<class Type>
#line 209 "src/math/matrix.birch"
libbirch::DefaultArray<Type,2> matrix(const std::function<Type(birch::type::Integer, birch::type::Integer, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>&)>& _u0955, const birch::type::Integer& rows, const birch::type::Integer& columns, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
template<class Type>
#line 227 "src/math/matrix.birch"
libbirch::DefaultArray<Type,2> matrix(const Type& x, const birch::type::Integer& rows, const birch::type::Integer& columns, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
template<class Type>
#line 236 "src/math/matrix.birch"
libbirch::DefaultArray<birch::type::Boolean,2> Boolean(const libbirch::DefaultArray<Type,2>& X, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
template<class Type>
#line 245 "src/math/matrix.birch"
libbirch::DefaultArray<birch::type::Integer,2> Integer(const libbirch::DefaultArray<Type,2>& X, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
template<class Type>
#line 254 "src/math/matrix.birch"
libbirch::DefaultArray<birch::type::Real,2> Real(const libbirch::DefaultArray<Type,2>& X, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
#line 263 "src/math/matrix.birch"
birch::type::String String(const libbirch::DefaultArray<birch::type::Real,2>& X, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
#line 297 "src/math/matrix.birch"
birch::type::String String(const libbirch::DefaultArray<birch::type::Integer,2>& X, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
#line 327 "src/math/matrix.birch"
birch::type::String String(const libbirch::DefaultArray<birch::type::Boolean,2>& X, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
#line 361 "src/math/matrix.birch"
birch::type::String String(const birch::type::LLT& X, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
template<class Type>
#line 9 "src/math/primitive.birch"
void for_each(const libbirch::DefaultArray<Type,1>& x, const std::function<void(Type, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>&)>& f, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
template<class Type>
#line 23 "src/math/primitive.birch"
void for_each(const libbirch::DefaultArray<Type,2>& X, const std::function<void(Type, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>&)>& f, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
template<class Input1,class Input2>
#line 38 "src/math/primitive.birch"
void for_each(const libbirch::DefaultArray<Input1,1>& x, const libbirch::DefaultArray<Input2,1>& y, const std::function<void(Input1, Input2, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>&)>& f, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
template<class Input1,class Input2>
#line 53 "src/math/primitive.birch"
void for_each(const libbirch::DefaultArray<Input1,2>& X, const libbirch::DefaultArray<Input2,2>& Y, const std::function<void(Input1, Input2, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>&)>& f, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
template<class Input1,class Input2,class Input3>
#line 72 "src/math/primitive.birch"
void for_each(const libbirch::DefaultArray<Input1,1>& x, const libbirch::DefaultArray<Input2,1>& y, const libbirch::DefaultArray<Input3,1>& z, const std::function<void(Input1, Input2, Input3, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>&)>& f, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
template<class Input1,class Input2,class Input3>
#line 89 "src/math/primitive.birch"
void for_each(const libbirch::DefaultArray<Input1,2>& X, const libbirch::DefaultArray<Input2,2>& Y, const libbirch::DefaultArray<Input3,2>& Z, const std::function<void(Input1, Input2, Input3, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>&)>& f, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
template<class Input,class Output>
#line 108 "src/math/primitive.birch"
libbirch::DefaultArray<Output,1> transform(const libbirch::DefaultArray<Input,1>& x, const std::function<Output(Input, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>&)>& f, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
template<class Input,class Output>
#line 121 "src/math/primitive.birch"
libbirch::DefaultArray<Output,2> transform(const libbirch::DefaultArray<Input,2>& X, const std::function<Output(Input, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>&)>& f, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
template<class Input1,class Input2,class Output>
#line 135 "src/math/primitive.birch"
libbirch::DefaultArray<Output,1> transform(const libbirch::DefaultArray<Input1,1>& x, const libbirch::DefaultArray<Input2,1>& y, const std::function<Output(Input1, Input1, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>&)>& f, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
template<class Input1,class Input2,class Output>
#line 150 "src/math/primitive.birch"
libbirch::DefaultArray<Output,2> transform(const libbirch::DefaultArray<Input1,2>& X, const libbirch::DefaultArray<Input2,2>& Y, const std::function<Output(Input1, Input2, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>&)>& f, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
template<class Input1,class Input2,class Input3,class Output>
#line 167 "src/math/primitive.birch"
libbirch::DefaultArray<Output,1> transform(const libbirch::DefaultArray<Input1,1>& x, const libbirch::DefaultArray<Input2,1>& y, const libbirch::DefaultArray<Input3,1>& z, const std::function<Output(Input1, Input2, Input3, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>&)>& f, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
template<class Input1,class Input2,class Input3,class Output>
#line 184 "src/math/primitive.birch"
libbirch::DefaultArray<Output,2> transform(const libbirch::DefaultArray<Input1,2>& X, const libbirch::DefaultArray<Input2,2>& Y, const libbirch::DefaultArray<Input3,2>& Z, const std::function<Output(Input1, Input2, Input3, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>&)>& f, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
template<class Type>
#line 202 "src/math/primitive.birch"
Type reduce(const libbirch::DefaultArray<Type,1>& x, const Type& init, const std::function<Type(Type, Type, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>&)>& op, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
template<class Input,class Output>
#line 224 "src/math/primitive.birch"
Output transform_reduce(const libbirch::DefaultArray<Input,1>& x, const Output& init, const std::function<Output(Output, Output, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>&)>& op1, const std::function<Output(Input, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>&)>& op2, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
template<class Input1,class Input2,class Output>
#line 242 "src/math/primitive.birch"
Output transform_reduce(const libbirch::DefaultArray<Input1,1>& x, const libbirch::DefaultArray<Input2,1>& y, const Output& init, const std::function<Output(Output, Output, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>&)>& op1, const std::function<Output(Input1, Input2, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>&)>& op2, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
template<class Input1,class Input2,class Input3,class Output>
#line 263 "src/math/primitive.birch"
Output transform_reduce(const libbirch::DefaultArray<Input1,1>& x, const libbirch::DefaultArray<Input2,1>& y, const libbirch::DefaultArray<Input3,1>& z, const Output& init, const std::function<Output(Output, Output, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>&)>& op1, const std::function<Output(Input1, Input2, Input3, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>&)>& op2, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
template<class Type>
#line 281 "src/math/primitive.birch"
libbirch::DefaultArray<Type,1> inclusive_scan(const libbirch::DefaultArray<Type,1>& x, const std::function<Type(Type, Type, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>&)>& op, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
template<class Type>
#line 301 "src/math/primitive.birch"
libbirch::DefaultArray<Type,1> exclusive_scan(const libbirch::DefaultArray<Type,1>& x, const Type& init, const std::function<Type(Type, Type, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>&)>& op, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
template<class Type>
#line 322 "src/math/primitive.birch"
libbirch::DefaultArray<Type,1> adjacent_difference(const libbirch::DefaultArray<Type,1>& x, const std::function<Type(Type, Type, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>&)>& op, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
template<class Type>
#line 341 "src/math/primitive.birch"
libbirch::DefaultArray<Type,1> sort(const libbirch::DefaultArray<Type,1>& x, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
template<class Type>
#line 359 "src/math/primitive.birch"
libbirch::DefaultArray<birch::type::Integer,1> sort_index(const libbirch::DefaultArray<Type,1>& x, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
template<class Type>
#line 379 "src/math/primitive.birch"
libbirch::DefaultArray<Type,1> gather(const libbirch::DefaultArray<birch::type::Integer,1>& a, const libbirch::DefaultArray<Type,1>& x, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
template<class Type>
#line 393 "src/math/primitive.birch"
libbirch::DefaultArray<Type,1> scatter(const libbirch::DefaultArray<birch::type::Integer,1>& a, const libbirch::DefaultArray<Type,1>& x, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
#line 14 "src/math/quantile.birch"
birch::type::Integer quantile_binomial(const birch::type::Real& P, const birch::type::Integer& n, const birch::type::Real& _u0961, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
#line 31 "src/math/quantile.birch"
birch::type::Integer quantile_negative_binomial(const birch::type::Real& P, const birch::type::Integer& k, const birch::type::Real& _u0961, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
#line 47 "src/math/quantile.birch"
birch::type::Integer quantile_poisson(const birch::type::Real& P, const birch::type::Real& _u0955, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
#line 63 "src/math/quantile.birch"
birch::type::Integer quantile_uniform_int(const birch::type::Real& P, const birch::type::Integer& l, const birch::type::Integer& u, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
#line 76 "src/math/quantile.birch"
birch::type::Integer quantile_categorical(const birch::type::Real& P, const libbirch::DefaultArray<birch::type::Real,1>& _u0961, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
#line 95 "src/math/quantile.birch"
birch::type::Real quantile_uniform(const birch::type::Real& P, const birch::type::Real& l, const birch::type::Real& u, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
#line 108 "src/math/quantile.birch"
birch::type::Real quantile_exponential(const birch::type::Real& P, const birch::type::Real& _u0955, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
#line 124 "src/math/quantile.birch"
birch::type::Real quantile_weibull(const birch::type::Real& P, const birch::type::Real& k, const birch::type::Real& _u0955, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
#line 141 "src/math/quantile.birch"
birch::type::Real quantile_gaussian(const birch::type::Real& P, const birch::type::Real& _u0956, const birch::type::Real& _u09632, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
#line 156 "src/math/quantile.birch"
birch::type::Real quantile_student_t(const birch::type::Real& P, const birch::type::Real& _u0957, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
#line 173 "src/math/quantile.birch"
birch::type::Real quantile_student_t(const birch::type::Real& P, const birch::type::Real& _u0957, const birch::type::Real& _u0956, const birch::type::Real& _u09632, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
#line 187 "src/math/quantile.birch"
birch::type::Real quantile_beta(const birch::type::Real& P, const birch::type::Real& _u0945, const birch::type::Real& _u0946, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
#line 203 "src/math/quantile.birch"
birch::type::Real quantile_chi_squared(const birch::type::Real& P, const birch::type::Real& _u0957, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
#line 219 "src/math/quantile.birch"
birch::type::Real quantile_gamma(const birch::type::Real& P, const birch::type::Real& k, const birch::type::Real& _u0952, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
#line 236 "src/math/quantile.birch"
birch::type::Real quantile_inverse_gamma(const birch::type::Real& P, const birch::type::Real& _u0945, const birch::type::Real& _u0946, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
#line 259 "src/math/quantile.birch"
birch::type::Real quantile_normal_inverse_gamma(const birch::type::Real& P, const birch::type::Real& _u0956, const birch::type::Real& a2, const birch::type::Real& _u0945, const birch::type::Real& _u0946, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
#line 273 "src/math/quantile.birch"
birch::type::Integer quantile_gamma_poisson(const birch::type::Real& P, const birch::type::Real& k, const birch::type::Real& _u0952, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
#line 289 "src/math/quantile.birch"
birch::type::Real quantile_lomax(const birch::type::Real& P, const birch::type::Real& _u0955, const birch::type::Real& _u0945, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
#line 308 "src/math/quantile.birch"
birch::type::Real quantile_normal_inverse_gamma_gaussian(const birch::type::Real& P, const birch::type::Real& _u0956, const birch::type::Real& a2, const birch::type::Real& _u0945, const birch::type::Real& _u0946, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
#line 327 "src/math/quantile.birch"
birch::type::Real quantile_linear_normal_inverse_gamma_gaussian(const birch::type::Real& P, const birch::type::Real& a, const birch::type::Real& _u0956, const birch::type::Real& a2, const birch::type::Real& c, const birch::type::Real& _u0945, const birch::type::Real& _u0946, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
#line 346 "src/math/quantile.birch"
birch::type::Real quantile_linear_multivariate_normal_inverse_gamma_gaussian(const birch::type::Real& P, const libbirch::DefaultArray<birch::type::Real,1>& a, const libbirch::DefaultArray<birch::type::Real,1>& _u0957, const birch::type::LLT& _u0923, const birch::type::Real& c, const birch::type::Real& _u0945, const birch::type::Real& _u0947, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
#line 8 "src/math/resample.birch"
libbirch::DefaultArray<birch::type::Integer,1> resample_systematic(const libbirch::DefaultArray<birch::type::Real,1>& w, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
#line 20 "src/math/resample.birch"
libbirch::DefaultArray<birch::type::Integer,1> resample_multinomial(const libbirch::DefaultArray<birch::type::Real,1>& w, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
#line 34 "src/math/resample.birch"
libbirch::Tuple<libbirch::DefaultArray<birch::type::Integer,1>, birch::type::Integer> conditional_resample_multinomial(const libbirch::DefaultArray<birch::type::Real,1>& w, const birch::type::Integer& b, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
#line 47 "src/math/resample.birch"
birch::type::Real log_sum_exp(const libbirch::DefaultArray<birch::type::Real,1>& x, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
#line 60 "src/math/resample.birch"
birch::type::Real log_sum(const libbirch::DefaultArray<birch::type::Real,1>& x, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
#line 68 "src/math/resample.birch"
birch::type::Real nan_exp(const birch::type::Real& x, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
#line 81 "src/math/resample.birch"
libbirch::DefaultArray<birch::type::Real,1> norm_exp(const libbirch::DefaultArray<birch::type::Real,1>& x, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
#line 95 "src/math/resample.birch"
birch::type::Integer cumulative_ancestor(const libbirch::DefaultArray<birch::type::Real,1>& W, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
#line 110 "src/math/resample.birch"
birch::type::Integer ancestor(const libbirch::DefaultArray<birch::type::Real,1>& w, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
#line 123 "src/math/resample.birch"
libbirch::DefaultArray<birch::type::Integer,1> systematic_cumulative_offspring(const libbirch::DefaultArray<birch::type::Real,1>& W, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
#line 138 "src/math/resample.birch"
libbirch::DefaultArray<birch::type::Integer,1> offspring_to_ancestors(const libbirch::DefaultArray<birch::type::Integer,1>& o, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
#line 155 "src/math/resample.birch"
libbirch::DefaultArray<birch::type::Integer,1> offspring_to_ancestors_permute(const libbirch::DefaultArray<birch::type::Integer,1>& o, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
#line 185 "src/math/resample.birch"
libbirch::DefaultArray<birch::type::Integer,1> cumulative_offspring_to_ancestors(const libbirch::DefaultArray<birch::type::Integer,1>& O, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
#line 207 "src/math/resample.birch"
libbirch::DefaultArray<birch::type::Integer,1> cumulative_offspring_to_ancestors_permute(const libbirch::DefaultArray<birch::type::Integer,1>& O, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
#line 240 "src/math/resample.birch"
libbirch::DefaultArray<birch::type::Integer,1> cumulative_offspring_to_offspring(const libbirch::DefaultArray<birch::type::Integer,1>& O, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
#line 249 "src/math/resample.birch"
libbirch::DefaultArray<birch::type::Integer,1> permute_ancestors(const libbirch::DefaultArray<birch::type::Integer,1>& a, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
#line 268 "src/math/resample.birch"
libbirch::DefaultArray<birch::type::Real,1> cumulative_weights(const libbirch::DefaultArray<birch::type::Real,1>& w, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
#line 289 "src/math/resample.birch"
libbirch::Tuple<birch::type::Real, birch::type::Real> resample_reduce(const libbirch::DefaultArray<birch::type::Real,1>& w, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
#line 4 "src/math/scalar.birch"
birch::type::Integer length(const birch::type::Real& x, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
#line 11 "src/math/scalar.birch"
birch::type::Integer length(const birch::type::Integer& x, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
#line 18 "src/math/scalar.birch"
birch::type::Integer length(const birch::type::Boolean& x, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
#line 25 "src/math/scalar.birch"
birch::type::Integer rows(const birch::type::Real& x, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
#line 32 "src/math/scalar.birch"
birch::type::Integer rows(const birch::type::Integer& x, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
#line 39 "src/math/scalar.birch"
birch::type::Integer rows(const birch::type::Boolean& x, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
#line 46 "src/math/scalar.birch"
birch::type::Integer columns(const birch::type::Real& x, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
#line 53 "src/math/scalar.birch"
birch::type::Integer columns(const birch::type::Integer& x, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
#line 60 "src/math/scalar.birch"
birch::type::Integer columns(const birch::type::Boolean& x, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
#line 67 "src/math/scalar.birch"
birch::type::Real transpose(const birch::type::Real& x, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
#line 74 "src/math/scalar.birch"
birch::type::Integer transpose(const birch::type::Integer& x, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
#line 81 "src/math/scalar.birch"
birch::type::Boolean transpose(const birch::type::Boolean& x, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
#line 26 "src/math/simulate.birch"
void seed(const birch::type::Integer& s, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
#line 38 "src/math/simulate.birch"
void seed(const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
#line 54 "src/math/simulate.birch"
birch::type::Boolean simulate_bernoulli(const birch::type::Real& _u0961, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
#line 66 "src/math/simulate.birch"
birch::type::Integer simulate_delta(const birch::type::Integer& _u0956, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
#line 76 "src/math/simulate.birch"
birch::type::Integer simulate_binomial(const birch::type::Integer& n, const birch::type::Real& _u0961, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
#line 92 "src/math/simulate.birch"
birch::type::Integer simulate_negative_binomial(const birch::type::Integer& k, const birch::type::Real& _u0961, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
#line 105 "src/math/simulate.birch"
birch::type::Integer simulate_poisson(const birch::type::Real& _u0955, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
#line 121 "src/math/simulate.birch"
birch::type::Integer simulate_categorical(const libbirch::DefaultArray<birch::type::Real,1>& _u0961, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
#line 131 "src/math/simulate.birch"
birch::type::Integer simulate_categorical(const libbirch::DefaultArray<birch::type::Real,1>& _u0961, const birch::type::Real& Z, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
#line 160 "src/math/simulate.birch"
libbirch::DefaultArray<birch::type::Integer,1> simulate_multinomial(const birch::type::Integer& n, const libbirch::DefaultArray<birch::type::Real,1>& _u0961, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
#line 172 "src/math/simulate.birch"
birch::type::Real simulate_inverse_gamma_gamma(const birch::type::Real& k, const birch::type::Real& _u0945, const birch::type::Real& _u0946, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
#line 189 "src/math/simulate.birch"
libbirch::DefaultArray<birch::type::Integer,1> simulate_multinomial(const birch::type::Integer& n, const libbirch::DefaultArray<birch::type::Real,1>& _u0961, const birch::type::Real& Z, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
#line 224 "src/math/simulate.birch"
libbirch::DefaultArray<birch::type::Real,1> simulate_dirichlet(const libbirch::DefaultArray<birch::type::Real,1>& _u0945, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
#line 246 "src/math/simulate.birch"
libbirch::DefaultArray<birch::type::Real,1> simulate_dirichlet(const birch::type::Real& _u0945, const birch::type::Integer& D, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
#line 268 "src/math/simulate.birch"
birch::type::Real simulate_uniform(const birch::type::Real& l, const birch::type::Real& u, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
#line 281 "src/math/simulate.birch"
birch::type::Integer simulate_uniform_int(const birch::type::Integer& l, const birch::type::Integer& u, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
#line 293 "src/math/simulate.birch"
libbirch::DefaultArray<birch::type::Real,1> simulate_uniform_unit_vector(const birch::type::Integer& D, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
#line 306 "src/math/simulate.birch"
birch::type::Real simulate_exponential(const birch::type::Real& _u0955, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
#line 319 "src/math/simulate.birch"
birch::type::Real simulate_weibull(const birch::type::Real& k, const birch::type::Real& _u0955, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
#line 333 "src/math/simulate.birch"
birch::type::Real simulate_gaussian(const birch::type::Real& _u0956, const birch::type::Real& _u09632, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
#line 349 "src/math/simulate.birch"
birch::type::Real simulate_student_t(const birch::type::Real& k, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
#line 363 "src/math/simulate.birch"
birch::type::Real simulate_student_t(const birch::type::Real& k, const birch::type::Real& _u0956, const birch::type::Real& v, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
#line 380 "src/math/simulate.birch"
libbirch::DefaultArray<birch::type::Real,1> simulate_multivariate_student_t(const birch::type::Real& k, const libbirch::DefaultArray<birch::type::Real,1>& _u0956, const birch::type::LLT& U, const birch::type::Real& v, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
#line 401 "src/math/simulate.birch"
libbirch::DefaultArray<birch::type::Real,1> simulate_multivariate_student_t(const birch::type::Real& k, const libbirch::DefaultArray<birch::type::Real,1>& _u0956, const birch::type::Real& u, const birch::type::LLT& V, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
#line 416 "src/math/simulate.birch"
libbirch::DefaultArray<birch::type::Real,2> simulate_matrix_student_t(const birch::type::Real& k, const libbirch::DefaultArray<birch::type::Real,2>& M, const birch::type::LLT& U, const birch::type::LLT& _u0936, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
#line 429 "src/math/simulate.birch"
birch::type::Real simulate_beta(const birch::type::Real& _u0945, const birch::type::Real& _u0946, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
#line 444 "src/math/simulate.birch"
birch::type::Real simulate_chi_squared(const birch::type::Real& _u0957, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
#line 457 "src/math/simulate.birch"
birch::type::Real simulate_gamma(const birch::type::Real& k, const birch::type::Real& _u0952, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
#line 471 "src/math/simulate.birch"
birch::type::LLT simulate_wishart(const birch::type::LLT& _u0936, const birch::type::Real& k, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
#line 501 "src/math/simulate.birch"
birch::type::Real simulate_inverse_gamma(const birch::type::Real& _u0945, const birch::type::Real& _u0946, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
#line 511 "src/math/simulate.birch"
birch::type::LLT simulate_inverse_wishart(const birch::type::LLT& _u0936, const birch::type::Real& k, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
#line 523 "src/math/simulate.birch"
birch::type::Real simulate_normal_inverse_gamma(const birch::type::Real& _u0956, const birch::type::Real& a2, const birch::type::Real& _u0945, const birch::type::Real& _u0946, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
#line 534 "src/math/simulate.birch"
birch::type::Boolean simulate_beta_bernoulli(const birch::type::Real& _u0945, const birch::type::Real& _u0946, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
#line 548 "src/math/simulate.birch"
birch::type::Integer simulate_beta_binomial(const birch::type::Integer& n, const birch::type::Real& _u0945, const birch::type::Real& _u0946, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
#line 563 "src/math/simulate.birch"
birch::type::Integer simulate_beta_negative_binomial(const birch::type::Integer& k, const birch::type::Real& _u0945, const birch::type::Real& _u0946, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
#line 578 "src/math/simulate.birch"
birch::type::Integer simulate_gamma_poisson(const birch::type::Real& k, const birch::type::Real& _u0952, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
#line 592 "src/math/simulate.birch"
birch::type::Real simulate_lomax(const birch::type::Real& _u0955, const birch::type::Real& _u0945, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
#line 605 "src/math/simulate.birch"
birch::type::Integer simulate_dirichlet_categorical(const libbirch::DefaultArray<birch::type::Real,1>& _u0945, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
#line 615 "src/math/simulate.birch"
libbirch::DefaultArray<birch::type::Integer,1> simulate_dirichlet_multinomial(const birch::type::Integer& n, const libbirch::DefaultArray<birch::type::Real,1>& _u0945, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
#line 628 "src/math/simulate.birch"
birch::type::Integer simulate_crp_categorical(const birch::type::Real& _u0945, const birch::type::Real& _u0952, const libbirch::DefaultArray<birch::type::Integer,1>& n, const birch::type::Integer& N, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
#line 663 "src/math/simulate.birch"
birch::type::Real simulate_normal_inverse_gamma_gaussian(const birch::type::Real& _u0956, const birch::type::Real& a2, const birch::type::Real& _u0945, const birch::type::Real& _u0946, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
#line 678 "src/math/simulate.birch"
birch::type::Real simulate_linear_normal_inverse_gamma_gaussian(const birch::type::Real& a, const birch::type::Real& _u0956, const birch::type::Real& a2, const birch::type::Real& c, const birch::type::Real& _u0945, const birch::type::Real& _u0946, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
#line 689 "src/math/simulate.birch"
libbirch::DefaultArray<birch::type::Real,1> simulate_multivariate_gaussian(const libbirch::DefaultArray<birch::type::Real,1>& _u0956, const birch::type::LLT& _u0931, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
#line 704 "src/math/simulate.birch"
libbirch::DefaultArray<birch::type::Real,1> simulate_multivariate_gaussian(const libbirch::DefaultArray<birch::type::Real,1>& _u0956, const libbirch::DefaultArray<birch::type::Real,1>& _u09632, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
#line 720 "src/math/simulate.birch"
libbirch::DefaultArray<birch::type::Real,1> simulate_multivariate_gaussian(const libbirch::DefaultArray<birch::type::Real,1>& _u0956, const birch::type::Real& _u09632, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
#line 738 "src/math/simulate.birch"
libbirch::DefaultArray<birch::type::Real,1> simulate_multivariate_normal_inverse_gamma(const libbirch::DefaultArray<birch::type::Real,1>& _u0957, const birch::type::LLT& _u0923, const birch::type::Real& _u0945, const birch::type::Real& _u0946, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
#line 753 "src/math/simulate.birch"
libbirch::DefaultArray<birch::type::Real,1> simulate_multivariate_normal_inverse_gamma_multivariate_gaussian(const libbirch::DefaultArray<birch::type::Real,1>& _u0957, const birch::type::LLT& _u0923, const birch::type::Real& _u0945, const birch::type::Real& _u0947, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
#line 774 "src/math/simulate.birch"
libbirch::DefaultArray<birch::type::Real,1> simulate_linear_multivariate_normal_inverse_gamma_multivariate_gaussian(const libbirch::DefaultArray<birch::type::Real,2>& A, const libbirch::DefaultArray<birch::type::Real,1>& _u0957, const birch::type::LLT& _u0923, const libbirch::DefaultArray<birch::type::Real,1>& c, const birch::type::Real& _u0945, const birch::type::Real& _u0947, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
#line 794 "src/math/simulate.birch"
birch::type::Real simulate_linear_multivariate_normal_inverse_gamma_gaussian(const libbirch::DefaultArray<birch::type::Real,1>& a, const libbirch::DefaultArray<birch::type::Real,1>& _u0957, const birch::type::LLT& _u0923, const birch::type::Real& c, const birch::type::Real& _u0945, const birch::type::Real& _u0947, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
#line 809 "src/math/simulate.birch"
libbirch::DefaultArray<birch::type::Real,2> simulate_matrix_gaussian(const libbirch::DefaultArray<birch::type::Real,2>& M, const birch::type::LLT& U, const birch::type::LLT& V, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
#line 833 "src/math/simulate.birch"
libbirch::DefaultArray<birch::type::Real,2> simulate_matrix_gaussian(const libbirch::DefaultArray<birch::type::Real,2>& M, const birch::type::LLT& U, const libbirch::DefaultArray<birch::type::Real,1>& _u09632, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
#line 856 "src/math/simulate.birch"
libbirch::DefaultArray<birch::type::Real,2> simulate_matrix_gaussian(const libbirch::DefaultArray<birch::type::Real,2>& M, const birch::type::LLT& V, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
#line 877 "src/math/simulate.birch"
libbirch::DefaultArray<birch::type::Real,2> simulate_matrix_gaussian(const libbirch::DefaultArray<birch::type::Real,2>& M, const libbirch::DefaultArray<birch::type::Real,1>& _u09632, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
#line 898 "src/math/simulate.birch"
libbirch::DefaultArray<birch::type::Real,2> simulate_matrix_gaussian(const libbirch::DefaultArray<birch::type::Real,2>& M, const birch::type::Real& _u09632, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
#line 918 "src/math/simulate.birch"
libbirch::DefaultArray<birch::type::Real,2> simulate_matrix_normal_inverse_wishart(const libbirch::DefaultArray<birch::type::Real,2>& N, const birch::type::LLT& _u0923, const birch::type::LLT& _u0936, const birch::type::Real& k, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
#line 933 "src/math/simulate.birch"
libbirch::DefaultArray<birch::type::Real,2> simulate_matrix_normal_inverse_wishart_matrix_gaussian(const libbirch::DefaultArray<birch::type::Real,2>& N, const birch::type::LLT& _u0923, const birch::type::LLT& _u0936, const birch::type::Real& k, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
#line 953 "src/math/simulate.birch"
libbirch::DefaultArray<birch::type::Real,2> simulate_linear_matrix_normal_inverse_wishart_matrix_gaussian(const libbirch::DefaultArray<birch::type::Real,2>& A, const libbirch::DefaultArray<birch::type::Real,2>& N, const birch::type::LLT& _u0923, const libbirch::DefaultArray<birch::type::Real,2>& C, const birch::type::LLT& _u0936, const birch::type::Real& k, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
#line 974 "src/math/simulate.birch"
libbirch::DefaultArray<birch::type::Real,1> simulate_linear_matrix_normal_inverse_wishart_multivariate_gaussian(const libbirch::DefaultArray<birch::type::Real,1>& a, const libbirch::DefaultArray<birch::type::Real,2>& N, const birch::type::LLT& _u0923, const libbirch::DefaultArray<birch::type::Real,1>& c, const birch::type::LLT& _u0936, const birch::type::Real& k, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
#line 988 "src/math/simulate.birch"
libbirch::DefaultArray<birch::type::Real,1> simulate_independent_uniform(const libbirch::DefaultArray<birch::type::Real,1>& l, const libbirch::DefaultArray<birch::type::Real,1>& u, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
#line 1004 "src/math/simulate.birch"
libbirch::DefaultArray<birch::type::Integer,1> simulate_independent_uniform_int(const libbirch::DefaultArray<birch::type::Integer,1>& l, const libbirch::DefaultArray<birch::type::Integer,1>& u, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
#line 8 "src/math/special.birch"
birch::type::Real64 gamma(const birch::type::Real64& x, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
#line 17 "src/math/special.birch"
birch::type::Real32 gamma(const birch::type::Real32& x, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
#line 26 "src/math/special.birch"
birch::type::Real64 lgamma(const birch::type::Real64& x, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
#line 35 "src/math/special.birch"
birch::type::Real32 lgamma(const birch::type::Real32& x, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
#line 44 "src/math/special.birch"
birch::type::Real64 gamma(const birch::type::Real64& x, const birch::type::Integer& p, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
#line 54 "src/math/special.birch"
birch::type::Real64 expm1(const birch::type::Real64& x, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
#line 60 "src/math/special.birch"
birch::type::Real32 expm1(const birch::type::Real32& x, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
#line 70 "src/math/special.birch"
birch::type::Real32 gamma(const birch::type::Real32& x, const birch::type::Integer& p, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
#line 82 "src/math/special.birch"
birch::type::Real64 lgamma(const birch::type::Real64& x, const birch::type::Integer& p, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
#line 94 "src/math/special.birch"
birch::type::Real32 lgamma(const birch::type::Real32& x, const birch::type::Integer& p, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
#line 106 "src/math/special.birch"
birch::type::Real64 beta(const birch::type::Real64& x, const birch::type::Real64& y, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
#line 113 "src/math/special.birch"
birch::type::Real32 beta(const birch::type::Real32& x, const birch::type::Real32& y, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
#line 122 "src/math/special.birch"
birch::type::Real ibeta(const birch::type::Real& a, const birch::type::Real& b, const birch::type::Real& x, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
#line 185 "src/math/special.birch"
birch::type::Real64 lbeta(const birch::type::Real64& x, const birch::type::Real64& y, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
#line 192 "src/math/special.birch"
birch::type::Real32 lbeta(const birch::type::Real32& x, const birch::type::Real32& y, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
#line 199 "src/math/special.birch"
birch::type::Real64 digamma(const birch::type::Real64& x, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
#line 208 "src/math/special.birch"
birch::type::Real32 digamma(const birch::type::Real32& x, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
#line 217 "src/math/special.birch"
birch::type::Real64 choose(const birch::type::Integer& x, const birch::type::Integer& y, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
#line 233 "src/math/special.birch"
birch::type::Real64 choose(const birch::type::Real64& x, const birch::type::Real64& y, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
#line 249 "src/math/special.birch"
birch::type::Real32 choose(const birch::type::Real32& x, const birch::type::Real32& y, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
#line 265 "src/math/special.birch"
birch::type::Real64 lchoose(const birch::type::Integer& x, const birch::type::Integer& y, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
#line 281 "src/math/special.birch"
birch::type::Real64 lchoose(const birch::type::Real64& x, const birch::type::Real64& y, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
#line 297 "src/math/special.birch"
birch::type::Real32 lchoose(const birch::type::Real32& x, const birch::type::Real32& y, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
template<class Type>
#line 312 "src/math/special.birch"
Type if_then_else(const birch::type::Boolean& cond, const Type& x, const Type& y, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
#line 319 "src/math/special.birch"
birch::type::Real lower_inc_gamma(const birch::type::Real& a, const birch::type::Real& x, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
#line 365 "src/math/special.birch"
birch::type::Real upper_inc_gamma(const birch::type::Real& a, const birch::type::Real& x, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
#line 427 "src/math/special.birch"
birch::type::Real igam_fac(const birch::type::Real& a, const birch::type::Real& x, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
#line 453 "src/math/special.birch"
birch::type::Real igamc_continued_fraction(const birch::type::Real& a, const birch::type::Real& x, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
#line 510 "src/math/special.birch"
birch::type::Real igam_series(const birch::type::Real& a, const birch::type::Real& x, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
#line 535 "src/math/special.birch"
birch::type::Real igamc_series(const birch::type::Real& a, const birch::type::Real& x, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
#line 559 "src/math/special.birch"
birch::type::Real asymptotic_series(const birch::type::Real& a, const birch::type::Real& x, const birch::type::Integer& func, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
#line 629 "src/math/special.birch"
birch::type::Real lanczos_sum_expg_scaled(const birch::type::Real& x, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
#line 635 "src/math/special.birch"
birch::type::Real ratevl(const birch::type::Real& x, const libbirch::DefaultArray<birch::type::Real,1>& num, const birch::type::Integer& M, const libbirch::DefaultArray<birch::type::Real,1>& denom, const birch::type::Integer& N, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
#line 5 "src/math/standard.birch"
birch::type::Real64 log(const birch::type::Real64& x, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
#line 14 "src/math/standard.birch"
birch::type::Real32 log(const birch::type::Real32& x, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
#line 23 "src/math/standard.birch"
birch::type::Real64 log1p(const birch::type::Real64& x, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
#line 32 "src/math/standard.birch"
birch::type::Real32 log1p(const birch::type::Real32& x, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
#line 41 "src/math/standard.birch"
birch::type::Real64 log2(const birch::type::Real64& x, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
#line 50 "src/math/standard.birch"
birch::type::Real32 log2(const birch::type::Real32& x, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
#line 59 "src/math/standard.birch"
birch::type::Real64 log10(const birch::type::Real64& x, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
#line 68 "src/math/standard.birch"
birch::type::Real32 log10(const birch::type::Real32& x, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
#line 77 "src/math/standard.birch"
birch::type::Real64 exp(const birch::type::Real64& x, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
#line 86 "src/math/standard.birch"
birch::type::Real32 exp(const birch::type::Real32& x, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
#line 95 "src/math/standard.birch"
birch::type::Real64 sqrt(const birch::type::Real64& x, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
#line 104 "src/math/standard.birch"
birch::type::Real32 sqrt(const birch::type::Real32& x, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
#line 113 "src/math/standard.birch"
birch::type::Real64 ceil(const birch::type::Real64& x, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
#line 122 "src/math/standard.birch"
birch::type::Real32 ceil(const birch::type::Real32& x, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
#line 131 "src/math/standard.birch"
birch::type::Real64 floor(const birch::type::Real64& x, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
#line 140 "src/math/standard.birch"
birch::type::Real32 floor(const birch::type::Real32& x, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
#line 149 "src/math/standard.birch"
birch::type::Real64 round(const birch::type::Real64& x, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
#line 158 "src/math/standard.birch"
birch::type::Real32 round(const birch::type::Real32& x, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
#line 167 "src/math/standard.birch"
birch::type::Real64 sin(const birch::type::Real64& x, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
#line 176 "src/math/standard.birch"
birch::type::Real32 sin(const birch::type::Real32& x, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
#line 185 "src/math/standard.birch"
birch::type::Real64 cos(const birch::type::Real64& x, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
#line 194 "src/math/standard.birch"
birch::type::Real32 cos(const birch::type::Real32& x, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
#line 203 "src/math/standard.birch"
birch::type::Real64 tan(const birch::type::Real64& x, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
#line 212 "src/math/standard.birch"
birch::type::Real32 tan(const birch::type::Real32& x, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
#line 221 "src/math/standard.birch"
birch::type::Real64 asin(const birch::type::Real64& x, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
#line 230 "src/math/standard.birch"
birch::type::Real32 asin(const birch::type::Real32& x, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
#line 239 "src/math/standard.birch"
birch::type::Real64 acos(const birch::type::Real64& x, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
#line 248 "src/math/standard.birch"
birch::type::Real32 acos(const birch::type::Real32& x, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
#line 257 "src/math/standard.birch"
birch::type::Real64 atan(const birch::type::Real64& x, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
#line 266 "src/math/standard.birch"
birch::type::Real32 atan(const birch::type::Real32& x, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
#line 275 "src/math/standard.birch"
birch::type::Real64 atan2(const birch::type::Real64& x, const birch::type::Real64& y, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
#line 284 "src/math/standard.birch"
birch::type::Real32 atan2(const birch::type::Real32& x, const birch::type::Real32& y, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
#line 293 "src/math/standard.birch"
birch::type::Real64 sinh(const birch::type::Real64& x, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
#line 302 "src/math/standard.birch"
birch::type::Real32 sinh(const birch::type::Real32& x, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
#line 311 "src/math/standard.birch"
birch::type::Real64 cosh(const birch::type::Real64& x, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
#line 320 "src/math/standard.birch"
birch::type::Real32 cosh(const birch::type::Real32& x, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
#line 329 "src/math/standard.birch"
birch::type::Real64 tanh(const birch::type::Real64& x, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
#line 338 "src/math/standard.birch"
birch::type::Real32 tanh(const birch::type::Real32& x, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
#line 347 "src/math/standard.birch"
birch::type::Real64 asinh(const birch::type::Real64& x, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
#line 356 "src/math/standard.birch"
birch::type::Real32 asinh(const birch::type::Real32& x, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
#line 365 "src/math/standard.birch"
birch::type::Real64 acosh(const birch::type::Real64& x, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
#line 374 "src/math/standard.birch"
birch::type::Real32 acosh(const birch::type::Real32& x, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
#line 383 "src/math/standard.birch"
birch::type::Real64 atanh(const birch::type::Real64& x, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
#line 392 "src/math/standard.birch"
birch::type::Real32 atanh(const birch::type::Real32& x, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
#line 401 "src/math/standard.birch"
birch::type::Real64 erf(const birch::type::Real64& x, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
#line 410 "src/math/standard.birch"
birch::type::Real32 erf(const birch::type::Real32& x, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
#line 419 "src/math/standard.birch"
birch::type::Real64 erfc(const birch::type::Real64& x, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
#line 428 "src/math/standard.birch"
birch::type::Real32 erfc(const birch::type::Real32& x, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
#line 437 "src/math/standard.birch"
birch::type::Real64 copysign(const birch::type::Real64& x, const birch::type::Real64& y, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
#line 446 "src/math/standard.birch"
birch::type::Real32 copysign(const birch::type::Real32& x, const birch::type::Real32& y, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
#line 455 "src/math/standard.birch"
birch::type::Real64 rectify(const birch::type::Real64& x, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
#line 462 "src/math/standard.birch"
birch::type::Real32 rectify(const birch::type::Real32& x, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
#line 10 "src/math/update.birch"
libbirch::Tuple<birch::type::Real, birch::type::Real> update_beta_bernoulli(const birch::type::Boolean& x, const birch::type::Real& _u0945, const birch::type::Real& _u0946, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
#line 28 "src/math/update.birch"
libbirch::Tuple<birch::type::Real, birch::type::Real> update_beta_binomial(const birch::type::Integer& x, const birch::type::Integer& n, const birch::type::Real& _u0945, const birch::type::Real& _u0946, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
#line 47 "src/math/update.birch"
libbirch::Tuple<birch::type::Real, birch::type::Real> update_beta_negative_binomial(const birch::type::Integer& x, const birch::type::Integer& k, const birch::type::Real& _u0945, const birch::type::Real& _u0946, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
#line 61 "src/math/update.birch"
libbirch::Tuple<birch::type::Real, birch::type::Real> update_gamma_poisson(const birch::type::Integer& x, const birch::type::Real& k, const birch::type::Real& _u0952, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
#line 76 "src/math/update.birch"
libbirch::Tuple<birch::type::Real, birch::type::Real> update_scaled_gamma_poisson(const birch::type::Integer& x, const birch::type::Real& a, const birch::type::Real& k, const birch::type::Real& _u0952, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
#line 91 "src/math/update.birch"
libbirch::Tuple<birch::type::Real, birch::type::Real> update_gamma_exponential(const birch::type::Real& x, const birch::type::Real& k, const birch::type::Real& _u0952, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
#line 106 "src/math/update.birch"
libbirch::Tuple<birch::type::Real, birch::type::Real> update_scaled_gamma_exponential(const birch::type::Real& x, const birch::type::Real& a, const birch::type::Real& k, const birch::type::Real& _u0952, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
#line 121 "src/math/update.birch"
libbirch::Tuple<birch::type::Real, birch::type::Real> update_inverse_gamma_weibull(const birch::type::Real& x, const birch::type::Real& k, const birch::type::Real& _u0945, const birch::type::Real& _u0946, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
#line 137 "src/math/update.birch"
libbirch::Tuple<birch::type::Real, birch::type::Real> update_scaled_inverse_gamma_weibull(const birch::type::Real& x, const birch::type::Real& k, const birch::type::Real& a, const birch::type::Real& _u0945, const birch::type::Real& _u0946, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
#line 150 "src/math/update.birch"
libbirch::DefaultArray<birch::type::Real,1> update_dirichlet_categorical(const birch::type::Integer& x, const libbirch::DefaultArray<birch::type::Real,1>& _u0945, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
#line 166 "src/math/update.birch"
libbirch::DefaultArray<birch::type::Real,1> update_dirichlet_multinomial(const libbirch::DefaultArray<birch::type::Integer,1>& x, const birch::type::Integer& n, const libbirch::DefaultArray<birch::type::Real,1>& _u0945, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
#line 189 "src/math/update.birch"
libbirch::Tuple<birch::type::Real, birch::type::Real> update_gaussian_gaussian(const birch::type::Real& x, const birch::type::Real& _u0956, const birch::type::Real& _u09632, const birch::type::Real& s2, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
#line 211 "src/math/update.birch"
libbirch::Tuple<birch::type::Real, birch::type::Real> update_linear_gaussian_gaussian(const birch::type::Real& x, const birch::type::Real& a, const birch::type::Real& _u0956, const birch::type::Real& _u09632, const birch::type::Real& c, const birch::type::Real& s2, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
#line 232 "src/math/update.birch"
libbirch::Tuple<birch::type::Real, birch::type::Real> update_normal_inverse_gamma(const birch::type::Real& x, const birch::type::Real& _u0956, const birch::type::Real& _u0955, const birch::type::Real& _u0945, const birch::type::Real& _u0946, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
#line 249 "src/math/update.birch"
libbirch::Tuple<birch::type::Real, birch::type::Real, birch::type::Real, birch::type::Real> update_normal_inverse_gamma_gaussian(const birch::type::Real& x, const birch::type::Real& _u0956, const birch::type::Real& _u0955, const birch::type::Real& _u0945, const birch::type::Real& _u0946, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
#line 273 "src/math/update.birch"
libbirch::Tuple<birch::type::Real, birch::type::Real, birch::type::Real, birch::type::Real> update_linear_normal_inverse_gamma_gaussian(const birch::type::Real& x, const birch::type::Real& a, const birch::type::Real& _u0956, const birch::type::Real& _u0955, const birch::type::Real& c, const birch::type::Real& _u0945, const birch::type::Real& _u0946, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
#line 295 "src/math/update.birch"
libbirch::Tuple<birch::type::Real, birch::type::Real> update_inverse_gamma_gamma(const birch::type::Real& x, const birch::type::Real& k, const birch::type::Real& _u0945, const birch::type::Real& _u0946, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
#line 311 "src/math/update.birch"
libbirch::Tuple<libbirch::DefaultArray<birch::type::Real,1>, birch::type::LLT> update_multivariate_gaussian_multivariate_gaussian(const libbirch::DefaultArray<birch::type::Real,1>& x, const libbirch::DefaultArray<birch::type::Real,1>& _u0956, const birch::type::LLT& _u0931, const birch::type::LLT& S, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
#line 334 "src/math/update.birch"
libbirch::Tuple<libbirch::DefaultArray<birch::type::Real,1>, birch::type::LLT> update_linear_multivariate_gaussian_multivariate_gaussian(const libbirch::DefaultArray<birch::type::Real,1>& x, const libbirch::DefaultArray<birch::type::Real,2>& A, const libbirch::DefaultArray<birch::type::Real,1>& _u0956, const birch::type::LLT& _u0931, const libbirch::DefaultArray<birch::type::Real,1>& c, const birch::type::LLT& S, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
#line 358 "src/math/update.birch"
libbirch::Tuple<libbirch::DefaultArray<birch::type::Real,1>, birch::type::LLT> update_linear_multivariate_gaussian_gaussian(const birch::type::Real& x, const libbirch::DefaultArray<birch::type::Real,1>& a, const libbirch::DefaultArray<birch::type::Real,1>& _u0956, const birch::type::LLT& _u0931, const birch::type::Real& c, const birch::type::Real& s2, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
#line 379 "src/math/update.birch"
libbirch::Tuple<birch::type::Real, birch::type::Real> update_multivariate_normal_inverse_gamma(const libbirch::DefaultArray<birch::type::Real,1>& x, const libbirch::DefaultArray<birch::type::Real,1>& _u0957, const birch::type::LLT& _u0923, const birch::type::Real& _u0945, const birch::type::Real& _u0946, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
#line 398 "src/math/update.birch"
libbirch::Tuple<libbirch::DefaultArray<birch::type::Real,1>, birch::type::LLT, birch::type::Real, birch::type::Real> update_multivariate_normal_inverse_gamma_multivariate_gaussian(const libbirch::DefaultArray<birch::type::Real,1>& x, const libbirch::DefaultArray<birch::type::Real,1>& _u0957, const birch::type::LLT& _u0923, const birch::type::Real& _u0945, const birch::type::Real& _u0947, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
#line 423 "src/math/update.birch"
libbirch::Tuple<libbirch::DefaultArray<birch::type::Real,1>, birch::type::LLT, birch::type::Real, birch::type::Real> update_linear_multivariate_normal_inverse_gamma_multivariate_gaussian(const libbirch::DefaultArray<birch::type::Real,1>& x, const libbirch::DefaultArray<birch::type::Real,2>& A, const libbirch::DefaultArray<birch::type::Real,1>& _u0957, const birch::type::LLT& _u0923, const libbirch::DefaultArray<birch::type::Real,1>& c, const birch::type::Real& _u0945, const birch::type::Real& _u0947, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
#line 448 "src/math/update.birch"
libbirch::Tuple<libbirch::DefaultArray<birch::type::Real,1>, birch::type::LLT, birch::type::Real, birch::type::Real> update_linear_multivariate_normal_inverse_gamma_gaussian(const birch::type::Real& x, const libbirch::DefaultArray<birch::type::Real,1>& a, const libbirch::DefaultArray<birch::type::Real,1>& _u0957, const birch::type::LLT& _u0923, const birch::type::Real& c, const birch::type::Real& _u0945, const birch::type::Real& _u0947, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
#line 469 "src/math/update.birch"
libbirch::Tuple<birch::type::LLT, birch::type::Real> update_matrix_normal_inverse_wishart(const libbirch::DefaultArray<birch::type::Real,2>& X, const libbirch::DefaultArray<birch::type::Real,2>& N, const birch::type::LLT& _u0923, const birch::type::LLT& V, const birch::type::Real& k, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
#line 490 "src/math/update.birch"
libbirch::Tuple<libbirch::DefaultArray<birch::type::Real,2>, birch::type::LLT, birch::type::LLT, birch::type::Real> update_matrix_normal_inverse_wishart_matrix_gaussian(const libbirch::DefaultArray<birch::type::Real,2>& X, const libbirch::DefaultArray<birch::type::Real,2>& N, const birch::type::LLT& _u0923, const birch::type::LLT& V, const birch::type::Real& k, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
#line 517 "src/math/update.birch"
libbirch::Tuple<libbirch::DefaultArray<birch::type::Real,2>, birch::type::LLT, birch::type::LLT, birch::type::Real> update_linear_matrix_normal_inverse_wishart_matrix_gaussian(const libbirch::DefaultArray<birch::type::Real,2>& X, const libbirch::DefaultArray<birch::type::Real,2>& A, const libbirch::DefaultArray<birch::type::Real,2>& N, const birch::type::LLT& _u0923, const libbirch::DefaultArray<birch::type::Real,2>& C, const birch::type::LLT& V, const birch::type::Real& k, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
#line 545 "src/math/update.birch"
libbirch::Tuple<libbirch::DefaultArray<birch::type::Real,2>, birch::type::LLT, birch::type::LLT, birch::type::Real> update_linear_matrix_normal_inverse_wishart_multivariate_gaussian(const libbirch::DefaultArray<birch::type::Real,1>& x, const libbirch::DefaultArray<birch::type::Real,1>& a, const libbirch::DefaultArray<birch::type::Real,2>& N, const birch::type::LLT& _u0923, const libbirch::DefaultArray<birch::type::Real,1>& c, const birch::type::LLT& V, const birch::type::Real& k, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
#line 10 "src/math/update_lazy.birch"
libbirch::Tuple<libbirch::Lazy<libbirch::Shared<birch::type::Expression<birch::type::Real>>>, libbirch::Lazy<libbirch::Shared<birch::type::Expression<birch::type::Real>>>> update_lazy_beta_bernoulli(const libbirch::Lazy<libbirch::Shared<birch::type::Expression<birch::type::Boolean>>>& x, const libbirch::Lazy<libbirch::Shared<birch::type::Expression<birch::type::Real>>>& _u0945, const libbirch::Lazy<libbirch::Shared<birch::type::Expression<birch::type::Real>>>& _u0946, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
#line 26 "src/math/update_lazy.birch"
libbirch::Tuple<libbirch::Lazy<libbirch::Shared<birch::type::Expression<birch::type::Real>>>, libbirch::Lazy<libbirch::Shared<birch::type::Expression<birch::type::Real>>>> update_lazy_beta_binomial(const libbirch::Lazy<libbirch::Shared<birch::type::Expression<birch::type::Integer>>>& x, const libbirch::Lazy<libbirch::Shared<birch::type::Expression<birch::type::Integer>>>& n, const libbirch::Lazy<libbirch::Shared<birch::type::Expression<birch::type::Real>>>& _u0945, const libbirch::Lazy<libbirch::Shared<birch::type::Expression<birch::type::Real>>>& _u0946, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
#line 42 "src/math/update_lazy.birch"
libbirch::Tuple<libbirch::Lazy<libbirch::Shared<birch::type::Expression<birch::type::Real>>>, libbirch::Lazy<libbirch::Shared<birch::type::Expression<birch::type::Real>>>> update_lazy_beta_negative_binomial(const libbirch::Lazy<libbirch::Shared<birch::type::Expression<birch::type::Integer>>>& x, const libbirch::Lazy<libbirch::Shared<birch::type::Expression<birch::type::Integer>>>& k, const libbirch::Lazy<libbirch::Shared<birch::type::Expression<birch::type::Real>>>& _u0945, const libbirch::Lazy<libbirch::Shared<birch::type::Expression<birch::type::Real>>>& _u0946, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
#line 57 "src/math/update_lazy.birch"
libbirch::Tuple<libbirch::Lazy<libbirch::Shared<birch::type::Expression<birch::type::Real>>>, libbirch::Lazy<libbirch::Shared<birch::type::Expression<birch::type::Real>>>> update_lazy_gamma_poisson(const libbirch::Lazy<libbirch::Shared<birch::type::Expression<birch::type::Integer>>>& x, const libbirch::Lazy<libbirch::Shared<birch::type::Expression<birch::type::Real>>>& k, const libbirch::Lazy<libbirch::Shared<birch::type::Expression<birch::type::Real>>>& _u0952, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
#line 73 "src/math/update_lazy.birch"
libbirch::Tuple<libbirch::Lazy<libbirch::Shared<birch::type::Expression<birch::type::Real>>>, libbirch::Lazy<libbirch::Shared<birch::type::Expression<birch::type::Real>>>> update_lazy_scaled_gamma_poisson(const libbirch::Lazy<libbirch::Shared<birch::type::Expression<birch::type::Integer>>>& x, const libbirch::Lazy<libbirch::Shared<birch::type::Expression<birch::type::Real>>>& a, const libbirch::Lazy<libbirch::Shared<birch::type::Expression<birch::type::Real>>>& k, const libbirch::Lazy<libbirch::Shared<birch::type::Expression<birch::type::Real>>>& _u0952, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
#line 89 "src/math/update_lazy.birch"
libbirch::Tuple<libbirch::Lazy<libbirch::Shared<birch::type::Expression<birch::type::Real>>>, libbirch::Lazy<libbirch::Shared<birch::type::Expression<birch::type::Real>>>> update_lazy_gamma_exponential(const libbirch::Lazy<libbirch::Shared<birch::type::Expression<birch::type::Real>>>& x, const libbirch::Lazy<libbirch::Shared<birch::type::Expression<birch::type::Real>>>& k, const libbirch::Lazy<libbirch::Shared<birch::type::Expression<birch::type::Real>>>& _u0952, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
#line 106 "src/math/update_lazy.birch"
libbirch::Tuple<libbirch::Lazy<libbirch::Shared<birch::type::Expression<birch::type::Real>>>, libbirch::Lazy<libbirch::Shared<birch::type::Expression<birch::type::Real>>>> update_lazy_scaled_gamma_exponential(const libbirch::Lazy<libbirch::Shared<birch::type::Expression<birch::type::Real>>>& x, const libbirch::Lazy<libbirch::Shared<birch::type::Expression<birch::type::Real>>>& a, const libbirch::Lazy<libbirch::Shared<birch::type::Expression<birch::type::Real>>>& k, const libbirch::Lazy<libbirch::Shared<birch::type::Expression<birch::type::Real>>>& _u0952, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
#line 123 "src/math/update_lazy.birch"
libbirch::Tuple<libbirch::Lazy<libbirch::Shared<birch::type::Expression<birch::type::Real>>>, libbirch::Lazy<libbirch::Shared<birch::type::Expression<birch::type::Real>>>> update_lazy_inverse_gamma_weibull(const libbirch::Lazy<libbirch::Shared<birch::type::Expression<birch::type::Real>>>& x, const libbirch::Lazy<libbirch::Shared<birch::type::Expression<birch::type::Real>>>& k, const libbirch::Lazy<libbirch::Shared<birch::type::Expression<birch::type::Real>>>& _u0945, const libbirch::Lazy<libbirch::Shared<birch::type::Expression<birch::type::Real>>>& _u0946, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
#line 141 "src/math/update_lazy.birch"
libbirch::Tuple<libbirch::Lazy<libbirch::Shared<birch::type::Expression<birch::type::Real>>>, libbirch::Lazy<libbirch::Shared<birch::type::Expression<birch::type::Real>>>> update_lazy_scaled_inverse_gamma_weibull(const libbirch::Lazy<libbirch::Shared<birch::type::Expression<birch::type::Real>>>& x, const libbirch::Lazy<libbirch::Shared<birch::type::Expression<birch::type::Real>>>& k, const libbirch::Lazy<libbirch::Shared<birch::type::Expression<birch::type::Real>>>& a, const libbirch::Lazy<libbirch::Shared<birch::type::Expression<birch::type::Real>>>& _u0945, const libbirch::Lazy<libbirch::Shared<birch::type::Expression<birch::type::Real>>>& _u0946, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
#line 187 "src/math/update_lazy.birch"
libbirch::Tuple<libbirch::Lazy<libbirch::Shared<birch::type::Expression<birch::type::Real>>>, libbirch::Lazy<libbirch::Shared<birch::type::Expression<birch::type::Real>>>> update_lazy_gaussian_gaussian(const libbirch::Lazy<libbirch::Shared<birch::type::Expression<birch::type::Real>>>& x, const libbirch::Lazy<libbirch::Shared<birch::type::Expression<birch::type::Real>>>& _u0956, const libbirch::Lazy<libbirch::Shared<birch::type::Expression<birch::type::Real>>>& _u09632, const libbirch::Lazy<libbirch::Shared<birch::type::Expression<birch::type::Real>>>& s2, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
#line 210 "src/math/update_lazy.birch"
libbirch::Tuple<libbirch::Lazy<libbirch::Shared<birch::type::Expression<birch::type::Real>>>, libbirch::Lazy<libbirch::Shared<birch::type::Expression<birch::type::Real>>>> update_lazy_linear_gaussian_gaussian(const libbirch::Lazy<libbirch::Shared<birch::type::Expression<birch::type::Real>>>& x, const libbirch::Lazy<libbirch::Shared<birch::type::Expression<birch::type::Real>>>& a, const libbirch::Lazy<libbirch::Shared<birch::type::Expression<birch::type::Real>>>& _u0956, const libbirch::Lazy<libbirch::Shared<birch::type::Expression<birch::type::Real>>>& _u09632, const libbirch::Lazy<libbirch::Shared<birch::type::Expression<birch::type::Real>>>& c, const libbirch::Lazy<libbirch::Shared<birch::type::Expression<birch::type::Real>>>& s2, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
#line 232 "src/math/update_lazy.birch"
libbirch::Tuple<libbirch::Lazy<libbirch::Shared<birch::type::Expression<birch::type::Real>>>, libbirch::Lazy<libbirch::Shared<birch::type::Expression<birch::type::Real>>>> update_lazy_normal_inverse_gamma(const libbirch::Lazy<libbirch::Shared<birch::type::Expression<birch::type::Real>>>& x, const libbirch::Lazy<libbirch::Shared<birch::type::Expression<birch::type::Real>>>& _u0956, const libbirch::Lazy<libbirch::Shared<birch::type::Expression<birch::type::Real>>>& _u0955, const libbirch::Lazy<libbirch::Shared<birch::type::Expression<birch::type::Real>>>& _u0945, const libbirch::Lazy<libbirch::Shared<birch::type::Expression<birch::type::Real>>>& _u0946, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
#line 250 "src/math/update_lazy.birch"
libbirch::Tuple<libbirch::Lazy<libbirch::Shared<birch::type::Expression<birch::type::Real>>>, libbirch::Lazy<libbirch::Shared<birch::type::Expression<birch::type::Real>>>, libbirch::Lazy<libbirch::Shared<birch::type::Expression<birch::type::Real>>>, libbirch::Lazy<libbirch::Shared<birch::type::Expression<birch::type::Real>>>> update_lazy_normal_inverse_gamma_gaussian(const libbirch::Lazy<libbirch::Shared<birch::type::Expression<birch::type::Real>>>& x, const libbirch::Lazy<libbirch::Shared<birch::type::Expression<birch::type::Real>>>& _u0956, const libbirch::Lazy<libbirch::Shared<birch::type::Expression<birch::type::Real>>>& _u0955, const libbirch::Lazy<libbirch::Shared<birch::type::Expression<birch::type::Real>>>& _u0945, const libbirch::Lazy<libbirch::Shared<birch::type::Expression<birch::type::Real>>>& _u0946, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
#line 275 "src/math/update_lazy.birch"
libbirch::Tuple<libbirch::Lazy<libbirch::Shared<birch::type::Expression<birch::type::Real>>>, libbirch::Lazy<libbirch::Shared<birch::type::Expression<birch::type::Real>>>, libbirch::Lazy<libbirch::Shared<birch::type::Expression<birch::type::Real>>>, libbirch::Lazy<libbirch::Shared<birch::type::Expression<birch::type::Real>>>> update_lazy_linear_normal_inverse_gamma_gaussian(const libbirch::Lazy<libbirch::Shared<birch::type::Expression<birch::type::Real>>>& x, const libbirch::Lazy<libbirch::Shared<birch::type::Expression<birch::type::Real>>>& a, const libbirch::Lazy<libbirch::Shared<birch::type::Expression<birch::type::Real>>>& _u0956, const libbirch::Lazy<libbirch::Shared<birch::type::Expression<birch::type::Real>>>& _u0955, const libbirch::Lazy<libbirch::Shared<birch::type::Expression<birch::type::Real>>>& c, const libbirch::Lazy<libbirch::Shared<birch::type::Expression<birch::type::Real>>>& _u0945, const libbirch::Lazy<libbirch::Shared<birch::type::Expression<birch::type::Real>>>& _u0946, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
#line 298 "src/math/update_lazy.birch"
libbirch::Tuple<libbirch::Lazy<libbirch::Shared<birch::type::Expression<birch::type::Real>>>, libbirch::Lazy<libbirch::Shared<birch::type::Expression<birch::type::Real>>>> update_lazy_inverse_gamma_gamma(const libbirch::Lazy<libbirch::Shared<birch::type::Expression<birch::type::Real>>>& x, const libbirch::Lazy<libbirch::Shared<birch::type::Expression<birch::type::Real>>>& k, const libbirch::Lazy<libbirch::Shared<birch::type::Expression<birch::type::Real>>>& _u0945, const libbirch::Lazy<libbirch::Shared<birch::type::Expression<birch::type::Real>>>& _u0946, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
#line 315 "src/math/update_lazy.birch"
libbirch::Tuple<libbirch::Lazy<libbirch::Shared<birch::type::Expression<libbirch::DefaultArray<birch::type::Real,1>>>>, libbirch::Lazy<libbirch::Shared<birch::type::Expression<birch::type::LLT>>>> update_lazy_multivariate_gaussian_multivariate_gaussian(const libbirch::Lazy<libbirch::Shared<birch::type::Expression<libbirch::DefaultArray<birch::type::Real,1>>>>& x, const libbirch::Lazy<libbirch::Shared<birch::type::Expression<libbirch::DefaultArray<birch::type::Real,1>>>>& _u0956, const libbirch::Lazy<libbirch::Shared<birch::type::Expression<birch::type::LLT>>>& _u0931, const libbirch::Lazy<libbirch::Shared<birch::type::Expression<birch::type::LLT>>>& S, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
#line 339 "src/math/update_lazy.birch"
libbirch::Tuple<libbirch::Lazy<libbirch::Shared<birch::type::Expression<libbirch::DefaultArray<birch::type::Real,1>>>>, libbirch::Lazy<libbirch::Shared<birch::type::Expression<birch::type::LLT>>>> update_lazy_linear_multivariate_gaussian_multivariate_gaussian(const libbirch::Lazy<libbirch::Shared<birch::type::Expression<libbirch::DefaultArray<birch::type::Real,1>>>>& x, const libbirch::Lazy<libbirch::Shared<birch::type::Expression<libbirch::DefaultArray<birch::type::Real,2>>>>& A, const libbirch::Lazy<libbirch::Shared<birch::type::Expression<libbirch::DefaultArray<birch::type::Real,1>>>>& _u0956, const libbirch::Lazy<libbirch::Shared<birch::type::Expression<birch::type::LLT>>>& _u0931, const libbirch::Lazy<libbirch::Shared<birch::type::Expression<libbirch::DefaultArray<birch::type::Real,1>>>>& c, const libbirch::Lazy<libbirch::Shared<birch::type::Expression<birch::type::LLT>>>& S, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
#line 365 "src/math/update_lazy.birch"
libbirch::Tuple<libbirch::Lazy<libbirch::Shared<birch::type::Expression<libbirch::DefaultArray<birch::type::Real,1>>>>, libbirch::Lazy<libbirch::Shared<birch::type::Expression<birch::type::LLT>>>> update_lazy_linear_multivariate_gaussian_gaussian(const libbirch::Lazy<libbirch::Shared<birch::type::Expression<birch::type::Real>>>& x, const libbirch::Lazy<libbirch::Shared<birch::type::Expression<libbirch::DefaultArray<birch::type::Real,1>>>>& a, const libbirch::Lazy<libbirch::Shared<birch::type::Expression<libbirch::DefaultArray<birch::type::Real,1>>>>& _u0956, const libbirch::Lazy<libbirch::Shared<birch::type::Expression<birch::type::LLT>>>& _u0931, const libbirch::Lazy<libbirch::Shared<birch::type::Expression<birch::type::Real>>>& c, const libbirch::Lazy<libbirch::Shared<birch::type::Expression<birch::type::Real>>>& s2, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
#line 388 "src/math/update_lazy.birch"
libbirch::Tuple<libbirch::Lazy<libbirch::Shared<birch::type::Expression<birch::type::Real>>>, libbirch::Lazy<libbirch::Shared<birch::type::Expression<birch::type::Real>>>> update_lazy_multivariate_normal_inverse_gamma(const libbirch::Lazy<libbirch::Shared<birch::type::Expression<libbirch::DefaultArray<birch::type::Real,1>>>>& x, const libbirch::Lazy<libbirch::Shared<birch::type::Expression<libbirch::DefaultArray<birch::type::Real,1>>>>& _u0957, const libbirch::Lazy<libbirch::Shared<birch::type::Expression<birch::type::LLT>>>& _u0923, const libbirch::Lazy<libbirch::Shared<birch::type::Expression<birch::type::Real>>>& _u0945, const libbirch::Lazy<libbirch::Shared<birch::type::Expression<birch::type::Real>>>& _u0946, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
#line 408 "src/math/update_lazy.birch"
libbirch::Tuple<libbirch::Lazy<libbirch::Shared<birch::type::Expression<libbirch::DefaultArray<birch::type::Real,1>>>>, libbirch::Lazy<libbirch::Shared<birch::type::Expression<birch::type::LLT>>>, libbirch::Lazy<libbirch::Shared<birch::type::Expression<birch::type::Real>>>, libbirch::Lazy<libbirch::Shared<birch::type::Expression<birch::type::Real>>>> update_lazy_multivariate_normal_inverse_gamma_multivariate_gaussian(const libbirch::Lazy<libbirch::Shared<birch::type::Expression<libbirch::DefaultArray<birch::type::Real,1>>>>& x, const libbirch::Lazy<libbirch::Shared<birch::type::Expression<libbirch::DefaultArray<birch::type::Real,1>>>>& _u0957, const libbirch::Lazy<libbirch::Shared<birch::type::Expression<birch::type::LLT>>>& _u0923, const libbirch::Lazy<libbirch::Shared<birch::type::Expression<birch::type::Real>>>& _u0945, const libbirch::Lazy<libbirch::Shared<birch::type::Expression<birch::type::Real>>>& _u0947, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
#line 434 "src/math/update_lazy.birch"
libbirch::Tuple<libbirch::Lazy<libbirch::Shared<birch::type::Expression<libbirch::DefaultArray<birch::type::Real,1>>>>, libbirch::Lazy<libbirch::Shared<birch::type::Expression<birch::type::LLT>>>, libbirch::Lazy<libbirch::Shared<birch::type::Expression<birch::type::Real>>>, libbirch::Lazy<libbirch::Shared<birch::type::Expression<birch::type::Real>>>> update_lazy_linear_multivariate_normal_inverse_gamma_multivariate_gaussian(const libbirch::Lazy<libbirch::Shared<birch::type::Expression<libbirch::DefaultArray<birch::type::Real,1>>>>& x, const libbirch::Lazy<libbirch::Shared<birch::type::Expression<libbirch::DefaultArray<birch::type::Real,2>>>>& A, const libbirch::Lazy<libbirch::Shared<birch::type::Expression<libbirch::DefaultArray<birch::type::Real,1>>>>& _u0957, const libbirch::Lazy<libbirch::Shared<birch::type::Expression<birch::type::LLT>>>& _u0923, const libbirch::Lazy<libbirch::Shared<birch::type::Expression<libbirch::DefaultArray<birch::type::Real,1>>>>& c, const libbirch::Lazy<libbirch::Shared<birch::type::Expression<birch::type::Real>>>& _u0945, const libbirch::Lazy<libbirch::Shared<birch::type::Expression<birch::type::Real>>>& _u0947, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
#line 461 "src/math/update_lazy.birch"
libbirch::Tuple<libbirch::Lazy<libbirch::Shared<birch::type::Expression<libbirch::DefaultArray<birch::type::Real,1>>>>, libbirch::Lazy<libbirch::Shared<birch::type::Expression<birch::type::LLT>>>, libbirch::Lazy<libbirch::Shared<birch::type::Expression<birch::type::Real>>>, libbirch::Lazy<libbirch::Shared<birch::type::Expression<birch::type::Real>>>> update_lazy_linear_multivariate_normal_inverse_gamma_gaussian(const libbirch::Lazy<libbirch::Shared<birch::type::Expression<birch::type::Real>>>& x, const libbirch::Lazy<libbirch::Shared<birch::type::Expression<libbirch::DefaultArray<birch::type::Real,1>>>>& a, const libbirch::Lazy<libbirch::Shared<birch::type::Expression<libbirch::DefaultArray<birch::type::Real,1>>>>& _u0957, const libbirch::Lazy<libbirch::Shared<birch::type::Expression<birch::type::LLT>>>& _u0923, const libbirch::Lazy<libbirch::Shared<birch::type::Expression<birch::type::Real>>>& c, const libbirch::Lazy<libbirch::Shared<birch::type::Expression<birch::type::Real>>>& _u0945, const libbirch::Lazy<libbirch::Shared<birch::type::Expression<birch::type::Real>>>& _u0947, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
#line 484 "src/math/update_lazy.birch"
libbirch::Tuple<libbirch::Lazy<libbirch::Shared<birch::type::Expression<birch::type::LLT>>>, libbirch::Lazy<libbirch::Shared<birch::type::Expression<birch::type::Real>>>> update_lazy_matrix_normal_inverse_wishart(const libbirch::Lazy<libbirch::Shared<birch::type::Expression<libbirch::DefaultArray<birch::type::Real,2>>>>& X, const libbirch::Lazy<libbirch::Shared<birch::type::Expression<libbirch::DefaultArray<birch::type::Real,2>>>>& N, const libbirch::Lazy<libbirch::Shared<birch::type::Expression<birch::type::LLT>>>& _u0923, const libbirch::Lazy<libbirch::Shared<birch::type::Expression<birch::type::LLT>>>& V, const libbirch::Lazy<libbirch::Shared<birch::type::Expression<birch::type::Real>>>& k, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
#line 506 "src/math/update_lazy.birch"
libbirch::Tuple<libbirch::Lazy<libbirch::Shared<birch::type::Expression<libbirch::DefaultArray<birch::type::Real,2>>>>, libbirch::Lazy<libbirch::Shared<birch::type::Expression<birch::type::LLT>>>, libbirch::Lazy<libbirch::Shared<birch::type::Expression<birch::type::LLT>>>, libbirch::Lazy<libbirch::Shared<birch::type::Expression<birch::type::Real>>>> update_lazy_matrix_normal_inverse_wishart_matrix_gaussian(const libbirch::Lazy<libbirch::Shared<birch::type::Expression<libbirch::DefaultArray<birch::type::Real,2>>>>& X, const libbirch::Lazy<libbirch::Shared<birch::type::Expression<libbirch::DefaultArray<birch::type::Real,2>>>>& N, const libbirch::Lazy<libbirch::Shared<birch::type::Expression<birch::type::LLT>>>& _u0923, const libbirch::Lazy<libbirch::Shared<birch::type::Expression<birch::type::LLT>>>& V, const libbirch::Lazy<libbirch::Shared<birch::type::Expression<birch::type::Real>>>& k, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
#line 535 "src/math/update_lazy.birch"
libbirch::Tuple<libbirch::Lazy<libbirch::Shared<birch::type::Expression<libbirch::DefaultArray<birch::type::Real,2>>>>, libbirch::Lazy<libbirch::Shared<birch::type::Expression<birch::type::LLT>>>, libbirch::Lazy<libbirch::Shared<birch::type::Expression<birch::type::LLT>>>, libbirch::Lazy<libbirch::Shared<birch::type::Expression<birch::type::Real>>>> update_lazy_linear_matrix_normal_inverse_wishart_matrix_gaussian(const libbirch::Lazy<libbirch::Shared<birch::type::Expression<libbirch::DefaultArray<birch::type::Real,2>>>>& X, const libbirch::Lazy<libbirch::Shared<birch::type::Expression<libbirch::DefaultArray<birch::type::Real,2>>>>& A, const libbirch::Lazy<libbirch::Shared<birch::type::Expression<libbirch::DefaultArray<birch::type::Real,2>>>>& N, const libbirch::Lazy<libbirch::Shared<birch::type::Expression<birch::type::LLT>>>& _u0923, const libbirch::Lazy<libbirch::Shared<birch::type::Expression<libbirch::DefaultArray<birch::type::Real,2>>>>& C, const libbirch::Lazy<libbirch::Shared<birch::type::Expression<birch::type::LLT>>>& V, const libbirch::Lazy<libbirch::Shared<birch::type::Expression<birch::type::Real>>>& k, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
#line 565 "src/math/update_lazy.birch"
libbirch::Tuple<libbirch::Lazy<libbirch::Shared<birch::type::Expression<libbirch::DefaultArray<birch::type::Real,2>>>>, libbirch::Lazy<libbirch::Shared<birch::type::Expression<birch::type::LLT>>>, libbirch::Lazy<libbirch::Shared<birch::type::Expression<birch::type::LLT>>>, libbirch::Lazy<libbirch::Shared<birch::type::Expression<birch::type::Real>>>> update_lazy_linear_matrix_normal_inverse_wishart_multivariate_gaussian(const libbirch::Lazy<libbirch::Shared<birch::type::Expression<libbirch::DefaultArray<birch::type::Real,1>>>>& x, const libbirch::Lazy<libbirch::Shared<birch::type::Expression<libbirch::DefaultArray<birch::type::Real,1>>>>& a, const libbirch::Lazy<libbirch::Shared<birch::type::Expression<libbirch::DefaultArray<birch::type::Real,2>>>>& N, const libbirch::Lazy<libbirch::Shared<birch::type::Expression<birch::type::LLT>>>& _u0923, const libbirch::Lazy<libbirch::Shared<birch::type::Expression<libbirch::DefaultArray<birch::type::Real,1>>>>& c, const libbirch::Lazy<libbirch::Shared<birch::type::Expression<birch::type::LLT>>>& V, const libbirch::Lazy<libbirch::Shared<birch::type::Expression<birch::type::Real>>>& k, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
template<class Type>
#line 4 "src/math/vector.birch"
birch::type::Integer length(const libbirch::DefaultArray<Type,1>& x, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
template<class Type>
#line 13 "src/math/vector.birch"
birch::type::Integer rows(const libbirch::DefaultArray<Type,1>& x, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
template<class Type>
#line 22 "src/math/vector.birch"
birch::type::Integer columns(const libbirch::DefaultArray<Type,1>& x, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
template<class Type>
#line 29 "src/math/vector.birch"
Type scalar(const libbirch::DefaultArray<Type,1>& x, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
template<class Type>
#line 46 "src/math/vector.birch"
libbirch::DefaultArray<Type,1> vector(const std::function<Type(birch::type::Integer, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>&)>& _u0955, const birch::type::Integer& length, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
template<class Type>
#line 58 "src/math/vector.birch"
libbirch::DefaultArray<Type,1> vector(const Type& x, const birch::type::Integer& length, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
template<class Type>
#line 68 "src/math/vector.birch"
libbirch::DefaultArray<Type,1> stack(const libbirch::DefaultArray<Type,1>& x, const libbirch::DefaultArray<Type,1>& y, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
template<class Type>
#line 86 "src/math/vector.birch"
libbirch::DefaultArray<birch::type::Real,1> iota(const Type& x, const birch::type::Integer& length, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
template<class Type>
#line 95 "src/math/vector.birch"
Type sum(const libbirch::DefaultArray<Type,1>& x, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
template<class Type>
#line 110 "src/math/vector.birch"
Type product(const libbirch::DefaultArray<Type,1>& x, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
template<class Type>
#line 124 "src/math/vector.birch"
Type max(const libbirch::DefaultArray<Type,1>& x, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
template<class Type>
#line 138 "src/math/vector.birch"
Type min(const libbirch::DefaultArray<Type,1>& x, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
template<class Type>
#line 152 "src/math/vector.birch"
libbirch::DefaultArray<Type,1> inclusive_scan_sum(const libbirch::DefaultArray<Type,1>& x, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
template<class Type>
#line 159 "src/math/vector.birch"
libbirch::DefaultArray<Type,1> exclusive_scan_sum(const libbirch::DefaultArray<Type,1>& x, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
template<class Type>
#line 168 "src/math/vector.birch"
libbirch::DefaultArray<birch::type::Boolean,1> Boolean(const libbirch::DefaultArray<Type,1>& x, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
template<class Type>
#line 177 "src/math/vector.birch"
libbirch::DefaultArray<birch::type::Integer,1> Integer(const libbirch::DefaultArray<Type,1>& x, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
template<class Type>
#line 186 "src/math/vector.birch"
libbirch::DefaultArray<birch::type::Real,1> Real(const libbirch::DefaultArray<Type,1>& x, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
#line 195 "src/math/vector.birch"
birch::type::String String(const libbirch::DefaultArray<birch::type::Real,1>& x, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
#line 222 "src/math/vector.birch"
birch::type::String String(const libbirch::DefaultArray<birch::type::Integer,1>& x, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
#line 245 "src/math/vector.birch"
birch::type::String String(const libbirch::DefaultArray<birch::type::Boolean,1>& x, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
#line 26 "src/particle/ConditionalParticle.birch"
libbirch::Lazy<libbirch::Shared<birch::type::ConditionalParticle>> ConditionalParticle(const libbirch::Lazy<libbirch::Shared<birch::type::Model>>& m, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
#line 137 "src/particle/MoveParticle.birch"
libbirch::Lazy<libbirch::Shared<birch::type::MoveParticle>> MoveParticle(const libbirch::Lazy<libbirch::Shared<birch::type::Model>>& m, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
#line 29 "src/particle/Particle.birch"
libbirch::Lazy<libbirch::Shared<birch::type::Particle>> Particle(const libbirch::Lazy<libbirch::Shared<birch::type::Model>>& m, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
template<class Value>
#line 16 "src/record/AssumeRecord.birch"
libbirch::Lazy<libbirch::Shared<birch::type::AssumeRecord<Value>>> AssumeRecord(const libbirch::Lazy<libbirch::Shared<birch::type::Random<Value>>>& v, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
#line 11 "src/record/FactorRecord.birch"
libbirch::Lazy<libbirch::Shared<birch::type::FactorRecord>> FactorRecord(const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
template<class Value>
#line 16 "src/record/ObserveRecord.birch"
libbirch::Lazy<libbirch::Shared<birch::type::ObserveRecord<Value>>> ObserveRecord(const Value& x, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
template<class Value>
#line 16 "src/record/SimulateRecord.birch"
libbirch::Lazy<libbirch::Shared<birch::type::SimulateRecord<Value>>> SimulateRecord(const Value& v, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
#line 14 "src/system/filesystem.birch"
void mkdir(const birch::type::String& path, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
#line 34 "src/system/filesystem.birch"
birch::type::File fopen(const birch::type::String& path, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
#line 50 "src/system/filesystem.birch"
birch::type::File fopen(const birch::type::String& path, const birch::type::Integer& mode, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
#line 79 "src/system/filesystem.birch"
void fflush(const birch::type::File& file, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
#line 88 "src/system/filesystem.birch"
void fclose(const birch::type::File& file, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
#line 97 "src/system/filesystem.birch"
birch::type::String extension(const birch::type::String& path, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
#line 4 "src/system/stdio.birch"
birch::type::File getStdIn(const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
#line 13 "src/system/stdio.birch"
birch::type::File getStdOut(const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
#line 22 "src/system/stdio.birch"
birch::type::File getStdErr(const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
#line 14 "src/system/system.birch"
birch::type::Integer system(const birch::type::String& cmd, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
#line 36 "src/system/system.birch"
void exit(const birch::type::Integer& code, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
#line 9 "src/test/test.birch"
birch::type::Boolean pass(const libbirch::DefaultArray<birch::type::Real,1>& x1, const libbirch::DefaultArray<birch::type::Real,1>& x2, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
#line 38 "src/test/test.birch"
birch::type::Boolean pass(const libbirch::DefaultArray<birch::type::Real,2>& X1, const libbirch::DefaultArray<birch::type::Real,2>& X2, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
#line 7 "src/test/test_cdf.birch"
void test_cdf(const libbirch::Lazy<libbirch::Shared<birch::type::Distribution<birch::type::Real>>>& q, const birch::type::Integer& N, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
#line 73 "src/test/test_cdf.birch"
void test_cdf(const libbirch::Lazy<libbirch::Shared<birch::type::Distribution<birch::type::Integer>>>& q, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
template<class Conjugate>
#line 9 "src/test/test_conjugacy.birch"
void test_conjugacy(const Conjugate& m, const birch::type::Integer& N, const birch::type::Integer& D, const birch::type::Boolean& lazy, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
#line 7 "src/test/test_grad.birch"
void test_grad(const libbirch::Lazy<libbirch::Shared<birch::type::Distribution<birch::type::Real>>>& _u0960, const birch::type::Integer& N, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
#line 51 "src/test/test_grad.birch"
void test_grad(const libbirch::Lazy<libbirch::Shared<birch::type::Distribution<libbirch::DefaultArray<birch::type::Real,1>>>>& _u0960, const birch::type::Integer& N, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
#line 98 "src/test/test_grad.birch"
void test_grad(const libbirch::Lazy<libbirch::Shared<birch::type::Distribution<libbirch::DefaultArray<birch::type::Real,2>>>>& _u0960, const birch::type::Integer& N, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
#line 8 "src/test/test_pdf.birch"
void test_pdf(const libbirch::Lazy<libbirch::Shared<birch::type::Distribution<birch::type::Boolean>>>& _u0960, const birch::type::Integer& N, const birch::type::Boolean& lazy, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
#line 55 "src/test/test_pdf.birch"
void test_pdf(const libbirch::Lazy<libbirch::Shared<birch::type::Distribution<birch::type::Integer>>>& _u0960, const birch::type::Integer& N, const birch::type::Boolean& lazy, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
#line 131 "src/test/test_pdf.birch"
void test_pdf(const libbirch::Lazy<libbirch::Shared<birch::type::Distribution<birch::type::Real>>>& _u0960, const birch::type::Integer& N, const birch::type::Integer& B, const birch::type::Integer& S, const birch::type::Boolean& lazy, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
#line 243 "src/test/test_pdf.birch"
void test_pdf(const libbirch::Lazy<libbirch::Shared<birch::type::Distribution<libbirch::DefaultArray<birch::type::Real,1>>>>& _u0960, const birch::type::Integer& D, const birch::type::Integer& N, const birch::type::Integer& B, const birch::type::Integer& S, const birch::type::Boolean& lazy, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
#line 366 "src/test/test_pdf.birch"
void test_pdf(const libbirch::Lazy<libbirch::Shared<birch::type::Distribution<libbirch::DefaultArray<birch::type::Real,2>>>>& _u0960, const birch::type::Integer& R, const birch::type::Integer& C, const birch::type::Integer& N, const birch::type::Integer& B, const birch::type::Integer& S, const birch::type::Boolean& lazy, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
template<class Value>
#line 53 "src/transform/TransformDot.birch"
libbirch::Lazy<libbirch::Shared<birch::type::TransformDot<Value>>> TransformDot(const libbirch::Lazy<libbirch::Shared<birch::type::Expression<libbirch::DefaultArray<birch::type::Real,1>>>>& a, const Value& x, const libbirch::Lazy<libbirch::Shared<birch::type::Expression<birch::type::Real>>>& c, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
template<class Value>
#line 58 "src/transform/TransformDot.birch"
libbirch::Lazy<libbirch::Shared<birch::type::TransformDot<Value>>> TransformDot(const libbirch::Lazy<libbirch::Shared<birch::type::Expression<libbirch::DefaultArray<birch::type::Real,1>>>>& a, const Value& x, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
template<class Value>
#line 53 "src/transform/TransformDotMultivariate.birch"
libbirch::Lazy<libbirch::Shared<birch::type::TransformDotMultivariate<Value>>> TransformDotMultivariate(const libbirch::Lazy<libbirch::Shared<birch::type::Expression<libbirch::DefaultArray<birch::type::Real,1>>>>& a, const Value& X, const libbirch::Lazy<libbirch::Shared<birch::type::Expression<libbirch::DefaultArray<birch::type::Real,1>>>>& c, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
template<class Value>
#line 58 "src/transform/TransformDotMultivariate.birch"
libbirch::Lazy<libbirch::Shared<birch::type::TransformDotMultivariate<Value>>> TransformDotMultivariate(const libbirch::Lazy<libbirch::Shared<birch::type::Expression<libbirch::DefaultArray<birch::type::Real,1>>>>& a, const Value& X, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
template<class Value>
#line 53 "src/transform/TransformLinear.birch"
libbirch::Lazy<libbirch::Shared<birch::type::TransformLinear<Value>>> TransformLinear(const libbirch::Lazy<libbirch::Shared<birch::type::Expression<birch::type::Real>>>& a, const Value& x, const libbirch::Lazy<libbirch::Shared<birch::type::Expression<birch::type::Real>>>& c, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
template<class Value>
#line 58 "src/transform/TransformLinear.birch"
libbirch::Lazy<libbirch::Shared<birch::type::TransformLinear<Value>>> TransformLinear(const libbirch::Lazy<libbirch::Shared<birch::type::Expression<birch::type::Real>>>& a, const Value& x, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
template<class Value>
#line 71 "src/transform/TransformLinearMatrix.birch"
libbirch::Lazy<libbirch::Shared<birch::type::TransformLinearMatrix<Value>>> TransformLinearMatrix(const libbirch::Lazy<libbirch::Shared<birch::type::Expression<libbirch::DefaultArray<birch::type::Real,2>>>>& A, const Value& X, const libbirch::Lazy<libbirch::Shared<birch::type::Expression<libbirch::DefaultArray<birch::type::Real,2>>>>& C, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
template<class Value>
#line 76 "src/transform/TransformLinearMatrix.birch"
libbirch::Lazy<libbirch::Shared<birch::type::TransformLinearMatrix<Value>>> TransformLinearMatrix(const libbirch::Lazy<libbirch::Shared<birch::type::Expression<libbirch::DefaultArray<birch::type::Real,2>>>>& A, const Value& X, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
template<class Value>
#line 67 "src/transform/TransformLinearMultivariate.birch"
libbirch::Lazy<libbirch::Shared<birch::type::TransformLinearMultivariate<Value>>> TransformLinearMultivariate(const libbirch::Lazy<libbirch::Shared<birch::type::Expression<libbirch::DefaultArray<birch::type::Real,2>>>>& A, const Value& x, const libbirch::Lazy<libbirch::Shared<birch::type::Expression<libbirch::DefaultArray<birch::type::Real,1>>>>& c, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
template<class Value>
#line 73 "src/transform/TransformLinearMultivariate.birch"
libbirch::Lazy<libbirch::Shared<birch::type::TransformLinearMultivariate<Value>>> TransformLinearMultivariate(const libbirch::Lazy<libbirch::Shared<birch::type::Expression<libbirch::DefaultArray<birch::type::Real,2>>>>& A, const Value& x, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
#line 10 "src/utility/chrono.birch"
void tic(const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
#line 19 "src/utility/chrono.birch"
birch::type::Real toc(const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
template<class Type>
#line 4 "src/utility/clone.birch"
Type clone(const Type& o, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
template<class Type>
#line 15 "src/utility/clone.birch"
libbirch::DefaultArray<Type,1> clone(const libbirch::DefaultArray<Type,1>& o, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
template<class Type>
#line 35 "src/utility/clone.birch"
libbirch::DefaultArray<Type,1> clone(const Type& o, const birch::type::Integer& length, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
#line 4 "src/utility/collect.birch"
void collect(const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
template<class Type>
#line 10 "src/utility/construct.birch"
Type construct(const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
template<class Type,class Arg1>
#line 25 "src/utility/construct.birch"
Type construct(const Arg1& arg1, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
template<class Type,class Arg1,class Arg2>
#line 40 "src/utility/construct.birch"
Type construct(const Arg1& arg1, const Arg2& arg2, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
template<class Type,class Arg1,class Arg2,class Arg3>
#line 55 "src/utility/construct.birch"
Type construct(const Arg1& arg1, const Arg2& arg2, const Arg3& arg3, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
template<class Type,class Arg1,class Arg2,class Arg3,class Arg4>
#line 71 "src/utility/construct.birch"
Type construct(const Arg1& arg1, const Arg2& arg2, const Arg3& arg3, const Arg4& arg4, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
template<class Type,class Arg1,class Arg2,class Arg3,class Arg4,class Arg5>
#line 87 "src/utility/construct.birch"
Type construct(const Arg1& arg1, const Arg2& arg2, const Arg3& arg3, const Arg4& arg4, const Arg5& arg5, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
template<class Type,class Arg1,class Arg2,class Arg3,class Arg4,class Arg5,class Arg6>
#line 103 "src/utility/construct.birch"
Type construct(const Arg1& arg1, const Arg2& arg2, const Arg3& arg3, const Arg4& arg4, const Arg5& arg5, const Arg6& arg6, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
template<class Type,class Arg1,class Arg2,class Arg3,class Arg4,class Arg5,class Arg6,class Arg7>
#line 119 "src/utility/construct.birch"
Type construct(const Arg1& arg1, const Arg2& arg2, const Arg3& arg3, const Arg4& arg4, const Arg5& arg5, const Arg6& arg6, const Arg7& arg7, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
template<class Type,class Arg1,class Arg2,class Arg3,class Arg4,class Arg5,class Arg6,class Arg7,class Arg8>
#line 137 "src/utility/construct.birch"
Type construct(const Arg1& arg1, const Arg2& arg2, const Arg3& arg3, const Arg4& arg4, const Arg5& arg5, const Arg6& arg6, const Arg7& arg7, const Arg8& arg8, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
#line 4 "src/utility/error.birch"
void error(const birch::type::String& msg, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
#line 13 "src/utility/error.birch"
void warn(const birch::type::String& msg, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
template<class Type>
#line 12 "src/utility/make.birch"
libbirch::Optional<Type> make(const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
#line 28 "src/utility/make.birch"
libbirch::Optional<libbirch::Lazy<libbirch::Shared<birch::type::Object>>> make(const birch::type::String& name, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
#line 53 "src/utility/make.birch"
libbirch::Optional<libbirch::Lazy<libbirch::Shared<birch::type::Object>>> make(const libbirch::Optional<birch::type::String>& name, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
#line 75 "src/utility/make.birch"
libbirch::Optional<libbirch::Lazy<libbirch::Shared<birch::type::Object>>> make(const libbirch::Lazy<libbirch::Shared<birch::type::Buffer>>& buffer, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
#line 95 "src/utility/make.birch"
libbirch::Optional<libbirch::Lazy<libbirch::Shared<birch::type::Object>>> make(const libbirch::Optional<libbirch::Lazy<libbirch::Shared<birch::type::Buffer>>>& buffer, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
#line 34 "src/test/basic/test_array.birch"
birch::type::Boolean check_array(const libbirch::Lazy<libbirch::Shared<birch::type::Array<birch::type::Integer>>>& o, const libbirch::DefaultArray<birch::type::Integer,1>& values, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
#line 25 "src/test/basic/test_ragged_array.birch"
birch::type::Boolean check_ragged_array(const libbirch::Lazy<libbirch::Shared<birch::type::RaggedArray<birch::type::Integer>>>& o, const libbirch::DefaultArray<birch::type::Integer,1>& sizes, const libbirch::DefaultArray<birch::type::Integer,1>& values, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr);
#line 175 "src/basic/LLT.birch"
birch::type::LLT operator+(const birch::type::LLT& x, const birch::type::LLT& y);
#line 23 "src/basic/Object.birch"
birch::type::Boolean operator==(const libbirch::Lazy<libbirch::Shared<birch::type::Object>>& x, const libbirch::Lazy<libbirch::Shared<birch::type::Object>>& y);
#line 32 "src/basic/Object.birch"
birch::type::Boolean operator!=(const libbirch::Lazy<libbirch::Shared<birch::type::Object>>& x, const libbirch::Lazy<libbirch::Shared<birch::type::Object>>& y);
#line 177 "src/basic/String.birch"
birch::type::Boolean operator>(const birch::type::String& x, const birch::type::String& y);
#line 186 "src/basic/String.birch"
birch::type::Boolean operator<(const birch::type::String& x, const birch::type::String& y);
#line 195 "src/basic/String.birch"
birch::type::Boolean operator>=(const birch::type::String& x, const birch::type::String& y);
#line 204 "src/basic/String.birch"
birch::type::Boolean operator<=(const birch::type::String& x, const birch::type::String& y);
#line 213 "src/basic/String.birch"
birch::type::Boolean operator==(const birch::type::String& x, const birch::type::String& y);
#line 222 "src/basic/String.birch"
birch::type::Boolean operator!=(const birch::type::String& x, const birch::type::String& y);
#line 236 "src/basic/String.birch"
birch::type::String operator+(const birch::type::String& x, const birch::type::Boolean& y);
#line 243 "src/basic/String.birch"
birch::type::String operator+(const birch::type::String& x, const birch::type::Real& y);
#line 250 "src/basic/String.birch"
birch::type::String operator+(const birch::type::String& x, const birch::type::Integer& y);
#line 257 "src/basic/String.birch"
birch::type::String operator+(const birch::type::String& x, const libbirch::DefaultArray<birch::type::Boolean,1>& y);
#line 264 "src/basic/String.birch"
birch::type::String operator+(const birch::type::String& x, const libbirch::DefaultArray<birch::type::Real,1>& y);
#line 271 "src/basic/String.birch"
birch::type::String operator+(const birch::type::String& x, const libbirch::DefaultArray<birch::type::Integer,1>& y);
#line 278 "src/basic/String.birch"
birch::type::String operator+(const birch::type::String& x, const libbirch::DefaultArray<birch::type::Boolean,2>& y);
#line 285 "src/basic/String.birch"
birch::type::String operator+(const birch::type::String& x, const libbirch::DefaultArray<birch::type::Real,2>& y);
#line 292 "src/basic/String.birch"
birch::type::String operator+(const birch::type::String& x, const libbirch::DefaultArray<birch::type::Integer,2>& y);
#line 299 "src/basic/String.birch"
birch::type::String operator+(const birch::type::Boolean& x, const birch::type::String& y);
#line 306 "src/basic/String.birch"
birch::type::String operator+(const birch::type::Real& x, const birch::type::String& y);
#line 313 "src/basic/String.birch"
birch::type::String operator+(const birch::type::Integer& x, const birch::type::String& y);
#line 320 "src/basic/String.birch"
birch::type::String operator+(const libbirch::DefaultArray<birch::type::Boolean,1>& x, const birch::type::String& y);
#line 327 "src/basic/String.birch"
birch::type::String operator+(const libbirch::DefaultArray<birch::type::Real,1>& x, const birch::type::String& y);
#line 334 "src/basic/String.birch"
birch::type::String operator+(const libbirch::DefaultArray<birch::type::Integer,1>& x, const birch::type::String& y);
#line 341 "src/basic/String.birch"
birch::type::String operator+(const libbirch::DefaultArray<birch::type::Boolean,2>& x, const birch::type::String& y);
#line 348 "src/basic/String.birch"
birch::type::String operator+(const libbirch::DefaultArray<birch::type::Real,2>& x, const birch::type::String& y);
#line 355 "src/basic/String.birch"
birch::type::String operator+(const libbirch::DefaultArray<birch::type::Integer,2>& x, const birch::type::String& y);
#line 87 "src/expression/Add.birch"
libbirch::Lazy<libbirch::Shared<birch::type::Add>> operator+(const libbirch::Lazy<libbirch::Shared<birch::type::Expression<birch::type::Real>>>& y, const libbirch::Lazy<libbirch::Shared<birch::type::Expression<birch::type::Real>>>& z);
#line 94 "src/expression/Add.birch"
libbirch::Lazy<libbirch::Shared<birch::type::Add>> operator+(const birch::type::Real& y, const libbirch::Lazy<libbirch::Shared<birch::type::Expression<birch::type::Real>>>& z);
#line 101 "src/expression/Add.birch"
libbirch::Lazy<libbirch::Shared<birch::type::Add>> operator+(const libbirch::Lazy<libbirch::Shared<birch::type::Expression<birch::type::Real>>>& y, const birch::type::Real& z);
#line 57 "src/expression/DiscreteAdd.birch"
libbirch::Lazy<libbirch::Shared<birch::type::DiscreteAdd>> operator+(const libbirch::Lazy<libbirch::Shared<birch::type::Expression<birch::type::Integer>>>& y, const libbirch::Lazy<libbirch::Shared<birch::type::Expression<birch::type::Integer>>>& z);
#line 64 "src/expression/DiscreteAdd.birch"
libbirch::Lazy<libbirch::Shared<birch::type::DiscreteAdd>> operator+(const birch::type::Integer& y, const libbirch::Lazy<libbirch::Shared<birch::type::Expression<birch::type::Integer>>>& z);
#line 71 "src/expression/DiscreteAdd.birch"
libbirch::Lazy<libbirch::Shared<birch::type::DiscreteAdd>> operator+(const libbirch::Lazy<libbirch::Shared<birch::type::Expression<birch::type::Integer>>>& y, const birch::type::Integer& z);
#line 55 "src/expression/DiscreteMultiply.birch"
libbirch::Lazy<libbirch::Shared<birch::type::DiscreteMultiply>> operator*(const libbirch::Lazy<libbirch::Shared<birch::type::Expression<birch::type::Integer>>>& y, const libbirch::Lazy<libbirch::Shared<birch::type::Expression<birch::type::Integer>>>& z);
#line 62 "src/expression/DiscreteMultiply.birch"
libbirch::Lazy<libbirch::Shared<birch::type::DiscreteMultiply>> operator*(const birch::type::Integer& y, const libbirch::Lazy<libbirch::Shared<birch::type::Expression<birch::type::Integer>>>& z);
#line 69 "src/expression/DiscreteMultiply.birch"
libbirch::Lazy<libbirch::Shared<birch::type::DiscreteMultiply>> operator*(const libbirch::Lazy<libbirch::Shared<birch::type::Expression<birch::type::Integer>>>& y, const birch::type::Integer& z);
#line 57 "src/expression/DiscreteSubtract.birch"
libbirch::Lazy<libbirch::Shared<birch::type::DiscreteSubtract>> operator-(const libbirch::Lazy<libbirch::Shared<birch::type::Expression<birch::type::Integer>>>& y, const libbirch::Lazy<libbirch::Shared<birch::type::Expression<birch::type::Integer>>>& z);
#line 65 "src/expression/DiscreteSubtract.birch"
libbirch::Lazy<libbirch::Shared<birch::type::DiscreteSubtract>> operator-(const birch::type::Integer& y, const libbirch::Lazy<libbirch::Shared<birch::type::Expression<birch::type::Integer>>>& z);
#line 72 "src/expression/DiscreteSubtract.birch"
libbirch::Lazy<libbirch::Shared<birch::type::DiscreteSubtract>> operator-(const libbirch::Lazy<libbirch::Shared<birch::type::Expression<birch::type::Integer>>>& y, const birch::type::Integer& z);
#line 85 "src/expression/Divide.birch"
libbirch::Lazy<libbirch::Shared<birch::type::Divide>> operator/(const libbirch::Lazy<libbirch::Shared<birch::type::Expression<birch::type::Real>>>& y, const libbirch::Lazy<libbirch::Shared<birch::type::Expression<birch::type::Real>>>& z);
#line 92 "src/expression/Divide.birch"
libbirch::Lazy<libbirch::Shared<birch::type::Divide>> operator/(const birch::type::Real& y, const libbirch::Lazy<libbirch::Shared<birch::type::Expression<birch::type::Real>>>& z);
#line 99 "src/expression/Divide.birch"
libbirch::Lazy<libbirch::Shared<birch::type::Divide>> operator/(const libbirch::Lazy<libbirch::Shared<birch::type::Expression<birch::type::Real>>>& y, const birch::type::Real& z);
#line 25 "src/expression/LessThan.birch"
libbirch::Lazy<libbirch::Shared<birch::type::LessThan>> operator<(const libbirch::Lazy<libbirch::Shared<birch::type::Expression<birch::type::Real>>>& y, const libbirch::Lazy<libbirch::Shared<birch::type::Expression<birch::type::Real>>>& z);
#line 32 "src/expression/LessThan.birch"
libbirch::Lazy<libbirch::Shared<birch::type::LessThan>> operator<(const birch::type::Real& y, const libbirch::Lazy<libbirch::Shared<birch::type::Expression<birch::type::Real>>>& z);
#line 39 "src/expression/LessThan.birch"
libbirch::Lazy<libbirch::Shared<birch::type::LessThan>> operator<(const libbirch::Lazy<libbirch::Shared<birch::type::Expression<birch::type::Real>>>& y, const birch::type::Real& z);
#line 69 "src/expression/MatrixAdd.birch"
libbirch::Lazy<libbirch::Shared<birch::type::MatrixAdd>> operator+(const libbirch::Lazy<libbirch::Shared<birch::type::Expression<libbirch::DefaultArray<birch::type::Real,2>>>>& y, const libbirch::Lazy<libbirch::Shared<birch::type::Expression<libbirch::DefaultArray<birch::type::Real,2>>>>& z);
#line 78 "src/expression/MatrixAdd.birch"
libbirch::Lazy<libbirch::Shared<birch::type::MatrixAdd>> operator+(const libbirch::DefaultArray<birch::type::Real,2>& y, const libbirch::Lazy<libbirch::Shared<birch::type::Expression<libbirch::DefaultArray<birch::type::Real,2>>>>& z);
#line 85 "src/expression/MatrixAdd.birch"
libbirch::Lazy<libbirch::Shared<birch::type::MatrixAdd>> operator+(const libbirch::Lazy<libbirch::Shared<birch::type::Expression<libbirch::DefaultArray<birch::type::Real,2>>>>& y, const libbirch::DefaultArray<birch::type::Real,2>& z);
#line 63 "src/expression/MatrixMultiply.birch"
libbirch::Lazy<libbirch::Shared<birch::type::MatrixMultiply>> operator*(const libbirch::Lazy<libbirch::Shared<birch::type::Expression<libbirch::DefaultArray<birch::type::Real,2>>>>& y, const libbirch::Lazy<libbirch::Shared<birch::type::Expression<libbirch::DefaultArray<birch::type::Real,2>>>>& z);
#line 71 "src/expression/MatrixMultiply.birch"
libbirch::Lazy<libbirch::Shared<birch::type::MatrixMultiply>> operator*(const libbirch::DefaultArray<birch::type::Real,2>& y, const libbirch::Lazy<libbirch::Shared<birch::type::Expression<libbirch::DefaultArray<birch::type::Real,2>>>>& z);
#line 78 "src/expression/MatrixMultiply.birch"
libbirch::Lazy<libbirch::Shared<birch::type::MatrixMultiply>> operator*(const libbirch::Lazy<libbirch::Shared<birch::type::Expression<libbirch::DefaultArray<birch::type::Real,2>>>>& y, const libbirch::DefaultArray<birch::type::Real,2>& z);
#line 4 "src/expression/MatrixScalarDivide.birch"
libbirch::Lazy<libbirch::Shared<birch::type::Expression<libbirch::DefaultArray<birch::type::Real,2>>>> operator/(const libbirch::Lazy<libbirch::Shared<birch::type::Expression<libbirch::DefaultArray<birch::type::Real,2>>>>& y, const libbirch::Lazy<libbirch::Shared<birch::type::Expression<birch::type::Real>>>& z);
#line 12 "src/expression/MatrixScalarDivide.birch"
libbirch::Lazy<libbirch::Shared<birch::type::Expression<libbirch::DefaultArray<birch::type::Real,2>>>> operator/(const libbirch::DefaultArray<birch::type::Real,2>& y, const libbirch::Lazy<libbirch::Shared<birch::type::Expression<birch::type::Real>>>& z);
#line 19 "src/expression/MatrixScalarDivide.birch"
libbirch::Lazy<libbirch::Shared<birch::type::Expression<libbirch::DefaultArray<birch::type::Real,2>>>> operator/(const libbirch::Lazy<libbirch::Shared<birch::type::Expression<libbirch::DefaultArray<birch::type::Real,2>>>>& y, const birch::type::Real& z);
#line 62 "src/expression/MatrixScalarMultiply.birch"
libbirch::Lazy<libbirch::Shared<birch::type::MatrixScalarMultiply>> operator*(const libbirch::Lazy<libbirch::Shared<birch::type::Expression<birch::type::Real>>>& y, const libbirch::Lazy<libbirch::Shared<birch::type::Expression<libbirch::DefaultArray<birch::type::Real,2>>>>& z);
#line 70 "src/expression/MatrixScalarMultiply.birch"
libbirch::Lazy<libbirch::Shared<birch::type::MatrixScalarMultiply>> operator*(const birch::type::Real& y, const libbirch::Lazy<libbirch::Shared<birch::type::Expression<libbirch::DefaultArray<birch::type::Real,2>>>>& z);
#line 77 "src/expression/MatrixScalarMultiply.birch"
libbirch::Lazy<libbirch::Shared<birch::type::MatrixScalarMultiply>> operator*(const libbirch::Lazy<libbirch::Shared<birch::type::Expression<birch::type::Real>>>& y, const libbirch::DefaultArray<birch::type::Real,2>& z);
#line 84 "src/expression/MatrixScalarMultiply.birch"
libbirch::Lazy<libbirch::Shared<birch::type::MatrixScalarMultiply>> operator*(const libbirch::Lazy<libbirch::Shared<birch::type::Expression<libbirch::DefaultArray<birch::type::Real,2>>>>& y, const libbirch::Lazy<libbirch::Shared<birch::type::Expression<birch::type::Real>>>& z);
#line 91 "src/expression/MatrixScalarMultiply.birch"
libbirch::Lazy<libbirch::Shared<birch::type::MatrixScalarMultiply>> operator*(const libbirch::DefaultArray<birch::type::Real,2>& y, const libbirch::Lazy<libbirch::Shared<birch::type::Expression<birch::type::Real>>>& z);
#line 98 "src/expression/MatrixScalarMultiply.birch"
libbirch::Lazy<libbirch::Shared<birch::type::MatrixScalarMultiply>> operator*(const libbirch::Lazy<libbirch::Shared<birch::type::Expression<libbirch::DefaultArray<birch::type::Real,2>>>>& y, const birch::type::Real& z);
#line 72 "src/expression/MatrixSubtract.birch"
libbirch::Lazy<libbirch::Shared<birch::type::MatrixSubtract>> operator-(const libbirch::Lazy<libbirch::Shared<birch::type::Expression<libbirch::DefaultArray<birch::type::Real,2>>>>& y, const libbirch::Lazy<libbirch::Shared<birch::type::Expression<libbirch::DefaultArray<birch::type::Real,2>>>>& z);
#line 82 "src/expression/MatrixSubtract.birch"
libbirch::Lazy<libbirch::Shared<birch::type::MatrixSubtract>> operator-(const libbirch::DefaultArray<birch::type::Real,2>& y, const libbirch::Lazy<libbirch::Shared<birch::type::Expression<libbirch::DefaultArray<birch::type::Real,2>>>>& z);
#line 89 "src/expression/MatrixSubtract.birch"
libbirch::Lazy<libbirch::Shared<birch::type::MatrixSubtract>> operator-(const libbirch::Lazy<libbirch::Shared<birch::type::Expression<libbirch::DefaultArray<birch::type::Real,2>>>>& y, const libbirch::DefaultArray<birch::type::Real,2>& z);
#line 104 "src/expression/Multiply.birch"
libbirch::Lazy<libbirch::Shared<birch::type::Multiply>> operator*(const libbirch::Lazy<libbirch::Shared<birch::type::Expression<birch::type::Real>>>& y, const libbirch::Lazy<libbirch::Shared<birch::type::Expression<birch::type::Real>>>& z);
#line 111 "src/expression/Multiply.birch"
libbirch::Lazy<libbirch::Shared<birch::type::Multiply>> operator*(const birch::type::Real& y, const libbirch::Lazy<libbirch::Shared<birch::type::Expression<birch::type::Real>>>& z);
#line 118 "src/expression/Multiply.birch"
libbirch::Lazy<libbirch::Shared<birch::type::Multiply>> operator*(const libbirch::Lazy<libbirch::Shared<birch::type::Expression<birch::type::Real>>>& y, const birch::type::Real& z);
#line 84 "src/expression/MultivariateAdd.birch"
libbirch::Lazy<libbirch::Shared<birch::type::MultivariateAdd>> operator+(const libbirch::Lazy<libbirch::Shared<birch::type::Expression<libbirch::DefaultArray<birch::type::Real,1>>>>& y, const libbirch::Lazy<libbirch::Shared<birch::type::Expression<libbirch::DefaultArray<birch::type::Real,1>>>>& z);
#line 92 "src/expression/MultivariateAdd.birch"
libbirch::Lazy<libbirch::Shared<birch::type::MultivariateAdd>> operator+(const libbirch::DefaultArray<birch::type::Real,1>& y, const libbirch::Lazy<libbirch::Shared<birch::type::Expression<libbirch::DefaultArray<birch::type::Real,1>>>>& z);
#line 99 "src/expression/MultivariateAdd.birch"
libbirch::Lazy<libbirch::Shared<birch::type::MultivariateAdd>> operator+(const libbirch::Lazy<libbirch::Shared<birch::type::Expression<libbirch::DefaultArray<birch::type::Real,1>>>>& y, const libbirch::DefaultArray<birch::type::Real,1>& z);
#line 59 "src/expression/MultivariateMultiply.birch"
libbirch::Lazy<libbirch::Shared<birch::type::MultivariateMultiply>> operator*(const libbirch::Lazy<libbirch::Shared<birch::type::Expression<libbirch::DefaultArray<birch::type::Real,2>>>>& y, const libbirch::Lazy<libbirch::Shared<birch::type::Expression<libbirch::DefaultArray<birch::type::Real,1>>>>& z);
#line 68 "src/expression/MultivariateMultiply.birch"
libbirch::Lazy<libbirch::Shared<birch::type::MultivariateMultiply>> operator*(const libbirch::DefaultArray<birch::type::Real,2>& y, const libbirch::Lazy<libbirch::Shared<birch::type::Expression<libbirch::DefaultArray<birch::type::Real,1>>>>& z);
#line 75 "src/expression/MultivariateMultiply.birch"
libbirch::Lazy<libbirch::Shared<birch::type::MultivariateMultiply>> operator*(const libbirch::Lazy<libbirch::Shared<birch::type::Expression<libbirch::DefaultArray<birch::type::Real,2>>>>& y, const libbirch::DefaultArray<birch::type::Real,1>& z);
#line 4 "src/expression/MultivariateScalarDivide.birch"
libbirch::Lazy<libbirch::Shared<birch::type::Expression<libbirch::DefaultArray<birch::type::Real,1>>>> operator/(const libbirch::Lazy<libbirch::Shared<birch::type::Expression<libbirch::DefaultArray<birch::type::Real,1>>>>& y, const libbirch::Lazy<libbirch::Shared<birch::type::Expression<birch::type::Real>>>& z);
#line 12 "src/expression/MultivariateScalarDivide.birch"
libbirch::Lazy<libbirch::Shared<birch::type::Expression<libbirch::DefaultArray<birch::type::Real,1>>>> operator/(const libbirch::DefaultArray<birch::type::Real,1>& y, const libbirch::Lazy<libbirch::Shared<birch::type::Expression<birch::type::Real>>>& z);
#line 19 "src/expression/MultivariateScalarDivide.birch"
libbirch::Lazy<libbirch::Shared<birch::type::Expression<libbirch::DefaultArray<birch::type::Real,1>>>> operator/(const libbirch::Lazy<libbirch::Shared<birch::type::Expression<libbirch::DefaultArray<birch::type::Real,1>>>>& y, const birch::type::Real& z);
#line 59 "src/expression/MultivariateScalarMultiply.birch"
libbirch::Lazy<libbirch::Shared<birch::type::MultivariateScalarMultiply>> operator*(const libbirch::Lazy<libbirch::Shared<birch::type::Expression<birch::type::Real>>>& y, const libbirch::Lazy<libbirch::Shared<birch::type::Expression<libbirch::DefaultArray<birch::type::Real,1>>>>& z);
#line 67 "src/expression/MultivariateScalarMultiply.birch"
libbirch::Lazy<libbirch::Shared<birch::type::MultivariateScalarMultiply>> operator*(const birch::type::Real& y, const libbirch::Lazy<libbirch::Shared<birch::type::Expression<libbirch::DefaultArray<birch::type::Real,1>>>>& z);
#line 74 "src/expression/MultivariateScalarMultiply.birch"
libbirch::Lazy<libbirch::Shared<birch::type::MultivariateScalarMultiply>> operator*(const libbirch::Lazy<libbirch::Shared<birch::type::Expression<birch::type::Real>>>& y, const libbirch::DefaultArray<birch::type::Real,1>& z);
#line 81 "src/expression/MultivariateScalarMultiply.birch"
libbirch::Lazy<libbirch::Shared<birch::type::MultivariateScalarMultiply>> operator*(const libbirch::Lazy<libbirch::Shared<birch::type::Expression<libbirch::DefaultArray<birch::type::Real,1>>>>& y, const libbirch::Lazy<libbirch::Shared<birch::type::Expression<birch::type::Real>>>& z);
#line 89 "src/expression/MultivariateScalarMultiply.birch"
libbirch::Lazy<libbirch::Shared<birch::type::MultivariateScalarMultiply>> operator*(const libbirch::DefaultArray<birch::type::Real,1>& y, const libbirch::Lazy<libbirch::Shared<birch::type::Expression<birch::type::Real>>>& z);
#line 96 "src/expression/MultivariateScalarMultiply.birch"
libbirch::Lazy<libbirch::Shared<birch::type::MultivariateScalarMultiply>> operator*(const libbirch::Lazy<libbirch::Shared<birch::type::Expression<libbirch::DefaultArray<birch::type::Real,1>>>>& y, const birch::type::Real& z);
#line 81 "src/expression/MultivariateSubtract.birch"
libbirch::Lazy<libbirch::Shared<birch::type::MultivariateSubtract>> operator-(const libbirch::Lazy<libbirch::Shared<birch::type::Expression<libbirch::DefaultArray<birch::type::Real,1>>>>& y, const libbirch::Lazy<libbirch::Shared<birch::type::Expression<libbirch::DefaultArray<birch::type::Real,1>>>>& z);
#line 90 "src/expression/MultivariateSubtract.birch"
libbirch::Lazy<libbirch::Shared<birch::type::MultivariateSubtract>> operator-(const libbirch::DefaultArray<birch::type::Real,1>& y, const libbirch::Lazy<libbirch::Shared<birch::type::Expression<libbirch::DefaultArray<birch::type::Real,1>>>>& z);
#line 97 "src/expression/MultivariateSubtract.birch"
libbirch::Lazy<libbirch::Shared<birch::type::MultivariateSubtract>> operator-(const libbirch::Lazy<libbirch::Shared<birch::type::Expression<libbirch::DefaultArray<birch::type::Real,1>>>>& y, const libbirch::DefaultArray<birch::type::Real,1>& z);
#line 88 "src/expression/Subtract.birch"
libbirch::Lazy<libbirch::Shared<birch::type::Subtract>> operator-(const libbirch::Lazy<libbirch::Shared<birch::type::Expression<birch::type::Real>>>& y, const libbirch::Lazy<libbirch::Shared<birch::type::Expression<birch::type::Real>>>& z);
#line 95 "src/expression/Subtract.birch"
libbirch::Lazy<libbirch::Shared<birch::type::Subtract>> operator-(const birch::type::Real& y, const libbirch::Lazy<libbirch::Shared<birch::type::Expression<birch::type::Real>>>& z);
#line 102 "src/expression/Subtract.birch"
libbirch::Lazy<libbirch::Shared<birch::type::Subtract>> operator-(const libbirch::Lazy<libbirch::Shared<birch::type::Expression<birch::type::Real>>>& y, const birch::type::Real& z);
#line 10 "src/math/eigen.birch"
libbirch::DefaultArray<birch::type::Real,1> operator*(const birch::type::Real& x, const libbirch::DefaultArray<birch::type::Real,1>& y);
#line 16 "src/math/eigen.birch"
libbirch::DefaultArray<birch::type::Real,1> operator*(const libbirch::DefaultArray<birch::type::Real,1>& x, const birch::type::Real& y);
#line 22 "src/math/eigen.birch"
libbirch::DefaultArray<birch::type::Real,2> operator*(const birch::type::Real& x, const libbirch::DefaultArray<birch::type::Real,2>& Y);
#line 28 "src/math/eigen.birch"
libbirch::DefaultArray<birch::type::Real,2> operator*(const libbirch::DefaultArray<birch::type::Real,2>& X, const birch::type::Real& y);
#line 34 "src/math/eigen.birch"
libbirch::DefaultArray<birch::type::Real,1> operator/(const libbirch::DefaultArray<birch::type::Real,1>& x, const birch::type::Real& y);
#line 40 "src/math/eigen.birch"
libbirch::DefaultArray<birch::type::Real,2> operator/(const libbirch::DefaultArray<birch::type::Real,2>& X, const birch::type::Real& y);
#line 46 "src/math/eigen.birch"
birch::type::Boolean operator==(const libbirch::DefaultArray<birch::type::Real,1>& x, const libbirch::DefaultArray<birch::type::Real,1>& y);
#line 52 "src/math/eigen.birch"
birch::type::Boolean operator!=(const libbirch::DefaultArray<birch::type::Real,1>& x, const libbirch::DefaultArray<birch::type::Real,1>& y);
#line 58 "src/math/eigen.birch"
birch::type::Boolean operator==(const libbirch::DefaultArray<birch::type::Real,2>& X, const libbirch::DefaultArray<birch::type::Real,2>& Y);
#line 64 "src/math/eigen.birch"
birch::type::Boolean operator!=(const libbirch::DefaultArray<birch::type::Real,2>& X, const libbirch::DefaultArray<birch::type::Real,2>& Y);
#line 90 "src/math/eigen.birch"
libbirch::DefaultArray<birch::type::Real,1> operator+(const libbirch::DefaultArray<birch::type::Real,1>& x, const libbirch::DefaultArray<birch::type::Real,1>& y);
#line 96 "src/math/eigen.birch"
libbirch::DefaultArray<birch::type::Real,1> operator-(const libbirch::DefaultArray<birch::type::Real,1>& x, const libbirch::DefaultArray<birch::type::Real,1>& y);
#line 102 "src/math/eigen.birch"
libbirch::DefaultArray<birch::type::Real,2> operator+(const libbirch::DefaultArray<birch::type::Real,2>& X, const libbirch::DefaultArray<birch::type::Real,2>& Y);
#line 108 "src/math/eigen.birch"
libbirch::DefaultArray<birch::type::Real,2> operator-(const libbirch::DefaultArray<birch::type::Real,2>& X, const libbirch::DefaultArray<birch::type::Real,2>& Y);
#line 114 "src/math/eigen.birch"
libbirch::DefaultArray<birch::type::Real,1> operator*(const libbirch::DefaultArray<birch::type::Real,2>& X, const libbirch::DefaultArray<birch::type::Real,1>& y);
#line 120 "src/math/eigen.birch"
libbirch::DefaultArray<birch::type::Real,2> operator*(const libbirch::DefaultArray<birch::type::Real,1>& X, const libbirch::DefaultArray<birch::type::Real,2>& y);
#line 126 "src/math/eigen.birch"
libbirch::DefaultArray<birch::type::Real,2> operator*(const libbirch::DefaultArray<birch::type::Real,2>& X, const libbirch::DefaultArray<birch::type::Real,2>& Y);
#line 132 "src/math/eigen.birch"
libbirch::DefaultArray<birch::type::Integer,1> operator*(const birch::type::Integer& x, const libbirch::DefaultArray<birch::type::Integer,1>& y);
#line 138 "src/math/eigen.birch"
libbirch::DefaultArray<birch::type::Integer,1> operator*(const libbirch::DefaultArray<birch::type::Integer,1>& x, const birch::type::Integer& y);
#line 144 "src/math/eigen.birch"
libbirch::DefaultArray<birch::type::Integer,2> operator*(const birch::type::Integer& x, const libbirch::DefaultArray<birch::type::Integer,2>& Y);
#line 150 "src/math/eigen.birch"
libbirch::DefaultArray<birch::type::Integer,2> operator*(const libbirch::DefaultArray<birch::type::Integer,2>& X, const birch::type::Integer& y);
#line 156 "src/math/eigen.birch"
libbirch::DefaultArray<birch::type::Integer,1> operator/(const libbirch::DefaultArray<birch::type::Integer,1>& x, const birch::type::Integer& y);
#line 162 "src/math/eigen.birch"
libbirch::DefaultArray<birch::type::Integer,2> operator/(const libbirch::DefaultArray<birch::type::Integer,2>& X, const birch::type::Integer& y);
#line 168 "src/math/eigen.birch"
birch::type::Boolean operator==(const libbirch::DefaultArray<birch::type::Integer,1>& x, const libbirch::DefaultArray<birch::type::Integer,1>& y);
#line 174 "src/math/eigen.birch"
birch::type::Boolean operator!=(const libbirch::DefaultArray<birch::type::Integer,1>& x, const libbirch::DefaultArray<birch::type::Integer,1>& y);
#line 180 "src/math/eigen.birch"
birch::type::Boolean operator==(const libbirch::DefaultArray<birch::type::Integer,2>& X, const libbirch::DefaultArray<birch::type::Integer,2>& Y);
#line 186 "src/math/eigen.birch"
birch::type::Boolean operator!=(const libbirch::DefaultArray<birch::type::Integer,2>& X, const libbirch::DefaultArray<birch::type::Integer,2>& Y);
#line 192 "src/math/eigen.birch"
birch::type::Boolean operator==(const birch::type::LLT& X, const birch::type::LLT& Y);
#line 198 "src/math/eigen.birch"
birch::type::Boolean operator!=(const birch::type::LLT& X, const birch::type::LLT& Y);
#line 224 "src/math/eigen.birch"
libbirch::DefaultArray<birch::type::Integer,1> operator+(const libbirch::DefaultArray<birch::type::Integer,1>& x, const libbirch::DefaultArray<birch::type::Integer,1>& y);
#line 230 "src/math/eigen.birch"
libbirch::DefaultArray<birch::type::Integer,1> operator-(const libbirch::DefaultArray<birch::type::Integer,1>& x, const libbirch::DefaultArray<birch::type::Integer,1>& y);
#line 236 "src/math/eigen.birch"
libbirch::DefaultArray<birch::type::Integer,2> operator+(const libbirch::DefaultArray<birch::type::Integer,2>& X, const libbirch::DefaultArray<birch::type::Integer,2>& Y);
#line 242 "src/math/eigen.birch"
libbirch::DefaultArray<birch::type::Integer,2> operator-(const libbirch::DefaultArray<birch::type::Integer,2>& X, const libbirch::DefaultArray<birch::type::Integer,2>& Y);
#line 248 "src/math/eigen.birch"
libbirch::DefaultArray<birch::type::Integer,1> operator*(const libbirch::DefaultArray<birch::type::Integer,2>& X, const libbirch::DefaultArray<birch::type::Integer,1>& y);
#line 254 "src/math/eigen.birch"
libbirch::DefaultArray<birch::type::Integer,2> operator*(const libbirch::DefaultArray<birch::type::Integer,1>& X, const libbirch::DefaultArray<birch::type::Integer,2>& y);
#line 260 "src/math/eigen.birch"
libbirch::DefaultArray<birch::type::Integer,2> operator*(const libbirch::DefaultArray<birch::type::Integer,2>& X, const libbirch::DefaultArray<birch::type::Integer,2>& Y);
#line 43 "src/expression/DiscreteNegate.birch"
libbirch::Lazy<libbirch::Shared<birch::type::DiscreteNegate>> operator-(const libbirch::Lazy<libbirch::Shared<birch::type::Expression<birch::type::Integer>>>& x);
#line 62 "src/expression/MatrixNegate.birch"
libbirch::Lazy<libbirch::Shared<birch::type::MatrixNegate>> operator-(const libbirch::Lazy<libbirch::Shared<birch::type::Expression<libbirch::DefaultArray<birch::type::Real,2>>>>& y);
#line 58 "src/expression/MultivariateNegate.birch"
libbirch::Lazy<libbirch::Shared<birch::type::MultivariateNegate>> operator-(const libbirch::Lazy<libbirch::Shared<birch::type::Expression<libbirch::DefaultArray<birch::type::Real,1>>>>& y);
#line 67 "src/expression/Negate.birch"
libbirch::Lazy<libbirch::Shared<birch::type::Negate>> operator-(const libbirch::Lazy<libbirch::Shared<birch::type::Expression<birch::type::Real>>>& y);
#line 70 "src/math/eigen.birch"
libbirch::DefaultArray<birch::type::Real,1> operator-(const libbirch::DefaultArray<birch::type::Real,1>& x);
#line 76 "src/math/eigen.birch"
libbirch::DefaultArray<birch::type::Real,1> operator+(const libbirch::DefaultArray<birch::type::Real,1>& x);
#line 80 "src/math/eigen.birch"
libbirch::DefaultArray<birch::type::Real,2> operator-(const libbirch::DefaultArray<birch::type::Real,2>& X);
#line 86 "src/math/eigen.birch"
libbirch::DefaultArray<birch::type::Real,2> operator+(const libbirch::DefaultArray<birch::type::Real,2>& X);
#line 204 "src/math/eigen.birch"
libbirch::DefaultArray<birch::type::Integer,1> operator-(const libbirch::DefaultArray<birch::type::Integer,1>& x);
#line 210 "src/math/eigen.birch"
libbirch::DefaultArray<birch::type::Integer,1> operator+(const libbirch::DefaultArray<birch::type::Integer,1>& x);
#line 214 "src/math/eigen.birch"
libbirch::DefaultArray<birch::type::Integer,2> operator-(const libbirch::DefaultArray<birch::type::Integer,2>& X);
#line 220 "src/math/eigen.birch"
libbirch::DefaultArray<birch::type::Integer,2> operator+(const libbirch::DefaultArray<birch::type::Integer,2>& X);
#line 22 "src/filter.birch"
extern "C" int filter(int, char**);
#line 22 "src/sample.birch"
extern "C" int sample(int, char**);
#line 4 "src/test/basic/test_array.birch"
extern "C" int test_array(int, char**);
#line 5 "src/test/basic/test_deep_clone_alias.birch"
extern "C" int test_deep_clone_alias(int, char**);
#line 4 "src/test/basic/test_deep_clone_chain.birch"
extern "C" int test_deep_clone_chain(int, char**);
#line 5 "src/test/basic/test_deep_clone_modify_dst.birch"
extern "C" int test_deep_clone_modify_dst(int, char**);
#line 5 "src/test/basic/test_deep_clone_modify_src.birch"
extern "C" int test_deep_clone_modify_src(int, char**);
#line 4 "src/test/basic/test_ragged_array.birch"
extern "C" int test_ragged_array(int, char**);
#line 4 "src/test/cdf/test_cdf_beta.birch"
extern "C" int test_cdf_beta(int, char**);
#line 4 "src/test/cdf/test_cdf_beta_binomial.birch"
extern "C" int test_cdf_beta_binomial(int, char**);
#line 4 "src/test/cdf/test_cdf_binomial.birch"
extern "C" int test_cdf_binomial(int, char**);
#line 4 "src/test/cdf/test_cdf_categorical.birch"
extern "C" int test_cdf_categorical(int, char**);
#line 4 "src/test/cdf/test_cdf_exponential.birch"
extern "C" int test_cdf_exponential(int, char**);
#line 4 "src/test/cdf/test_cdf_gamma.birch"
extern "C" int test_cdf_gamma(int, char**);
#line 4 "src/test/cdf/test_cdf_gamma_exponential.birch"
extern "C" int test_cdf_gamma_exponential(int, char**);
#line 4 "src/test/cdf/test_cdf_gamma_poisson.birch"
extern "C" int test_cdf_gamma_poisson(int, char**);
#line 4 "src/test/cdf/test_cdf_gaussian.birch"
extern "C" int test_cdf_gaussian(int, char**);
#line 4 "src/test/cdf/test_cdf_geometric.birch"
extern "C" int test_cdf_geometric(int, char**);
#line 4 "src/test/cdf/test_cdf_inverse_gamma.birch"
extern "C" int test_cdf_inverse_gamma(int, char**);
#line 4 "src/test/cdf/test_cdf_inverse_gamma_gamma.birch"
extern "C" int test_cdf_inverse_gamma_gamma(int, char**);
#line 4 "src/test/cdf/test_cdf_linear_gaussian_gaussian.birch"
extern "C" int test_cdf_linear_gaussian_gaussian(int, char**);
#line 4 "src/test/cdf/test_cdf_linear_multivariate_gaussian_gaussian.birch"
extern "C" int test_cdf_linear_multivariate_gaussian_gaussian(int, char**);
#line 4 "src/test/cdf/test_cdf_linear_multivariate_normal_inverse_gamma_gaussian.birch"
extern "C" int test_cdf_linear_multivariate_normal_inverse_gamma_gaussian(int, char**);
#line 4 "src/test/cdf/test_cdf_linear_normal_inverse_gamma_gaussian.birch"
extern "C" int test_cdf_linear_normal_inverse_gamma_gaussian(int, char**);
#line 4 "src/test/cdf/test_cdf_negative_binomial.birch"
extern "C" int test_cdf_negative_binomial(int, char**);
#line 4 "src/test/cdf/test_cdf_normal_inverse_gamma.birch"
extern "C" int test_cdf_normal_inverse_gamma(int, char**);
#line 4 "src/test/cdf/test_cdf_normal_inverse_gamma_gaussian.birch"
extern "C" int test_cdf_normal_inverse_gamma_gaussian(int, char**);
#line 4 "src/test/cdf/test_cdf_poisson.birch"
extern "C" int test_cdf_poisson(int, char**);
#line 4 "src/test/cdf/test_cdf_scaled_gamma_exponential.birch"
extern "C" int test_cdf_scaled_gamma_exponential(int, char**);
#line 4 "src/test/cdf/test_cdf_scaled_gamma_poisson.birch"
extern "C" int test_cdf_scaled_gamma_poisson(int, char**);
#line 4 "src/test/cdf/test_cdf_student_t.birch"
extern "C" int test_cdf_student_t(int, char**);
#line 4 "src/test/cdf/test_cdf_uniform.birch"
extern "C" int test_cdf_uniform(int, char**);
#line 4 "src/test/cdf/test_cdf_uniform_int.birch"
extern "C" int test_cdf_uniform_int(int, char**);
#line 4 "src/test/cdf/test_cdf_weibull.birch"
extern "C" int test_cdf_weibull(int, char**);
#line 4 "src/test/conjugacy/test_add_bounded_discrete_delta.birch"
extern "C" int test_add_bounded_discrete_delta(int, char**);
#line 4 "src/test/conjugacy/test_beta_bernoulli.birch"
extern "C" int test_beta_bernoulli(int, char**);
#line 4 "src/test/conjugacy/test_beta_binomial.birch"
extern "C" int test_beta_binomial(int, char**);
#line 4 "src/test/conjugacy/test_beta_geometric.birch"
extern "C" int test_beta_geometric(int, char**);
#line 4 "src/test/conjugacy/test_beta_negative_binomial.birch"
extern "C" int test_beta_negative_binomial(int, char**);
#line 4 "src/test/conjugacy/test_chain_gaussian.birch"
extern "C" int test_chain_gaussian(int, char**);
#line 4 "src/test/conjugacy/test_chain_multivariate_gaussian.birch"
extern "C" int test_chain_multivariate_gaussian(int, char**);
#line 4 "src/test/conjugacy/test_dirichlet_categorical.birch"
extern "C" int test_dirichlet_categorical(int, char**);
#line 4 "src/test/conjugacy/test_dirichlet_multinomial.birch"
extern "C" int test_dirichlet_multinomial(int, char**);
#line 4 "src/test/conjugacy/test_gamma_exponential.birch"
extern "C" int test_gamma_exponential(int, char**);
#line 4 "src/test/conjugacy/test_gamma_poisson.birch"
extern "C" int test_gamma_poisson(int, char**);
#line 4 "src/test/conjugacy/test_gaussian_gaussian.birch"
extern "C" int test_gaussian_gaussian(int, char**);
#line 4 "src/test/conjugacy/test_inverse_gamma_gamma.birch"
extern "C" int test_inverse_gamma_gamma(int, char**);
#line 4 "src/test/conjugacy/test_linear_discrete_delta.birch"
extern "C" int test_linear_discrete_delta(int, char**);
#line 4 "src/test/conjugacy/test_linear_gaussian_gaussian.birch"
extern "C" int test_linear_gaussian_gaussian(int, char**);
#line 4 "src/test/conjugacy/test_linear_matrix_normal_inverse_wishart_matrix_gaussian.birch"
extern "C" int test_linear_matrix_normal_inverse_wishart_matrix_gaussian(int, char**);
#line 4 "src/test/conjugacy/test_linear_matrix_normal_inverse_wishart_multivariate_gaussian.birch"
extern "C" int test_linear_matrix_normal_inverse_wishart_multivariate_gaussian(int, char**);
#line 4 "src/test/conjugacy/test_linear_multivariate_gaussian_gaussian.birch"
extern "C" int test_linear_multivariate_gaussian_gaussian(int, char**);
#line 4 "src/test/conjugacy/test_linear_multivariate_gaussian_multivariate_gaussian.birch"
extern "C" int test_linear_multivariate_gaussian_multivariate_gaussian(int, char**);
#line 4 "src/test/conjugacy/test_linear_multivariate_normal_inverse_gamma_gaussian.birch"
extern "C" int test_linear_multivariate_normal_inverse_gamma_gaussian(int, char**);
#line 4 "src/test/conjugacy/test_linear_multivariate_normal_inverse_gamma_multivariate_gaussian.birch"
extern "C" int test_linear_multivariate_normal_inverse_gamma_multivariate_gaussian(int, char**);
#line 4 "src/test/conjugacy/test_linear_normal_inverse_gamma_gaussian.birch"
extern "C" int test_linear_normal_inverse_gamma_gaussian(int, char**);
#line 4 "src/test/conjugacy/test_matrix_normal_inverse_wishart_matrix_gaussian.birch"
extern "C" int test_matrix_normal_inverse_wishart_matrix_gaussian(int, char**);
#line 4 "src/test/conjugacy/test_multivariate_gaussian_multivariate_gaussian.birch"
extern "C" int test_multivariate_gaussian_multivariate_gaussian(int, char**);
#line 4 "src/test/conjugacy/test_multivariate_normal_inverse_gamma_multivariate_gaussian.birch"
extern "C" int test_multivariate_normal_inverse_gamma_multivariate_gaussian(int, char**);
#line 4 "src/test/conjugacy/test_normal_inverse_gamma.birch"
extern "C" int test_normal_inverse_gamma(int, char**);
#line 4 "src/test/conjugacy/test_normal_inverse_gamma_gaussian.birch"
extern "C" int test_normal_inverse_gamma_gaussian(int, char**);
#line 4 "src/test/conjugacy/test_scaled_gamma_exponential.birch"
extern "C" int test_scaled_gamma_exponential(int, char**);
#line 4 "src/test/conjugacy/test_scaled_gamma_poisson.birch"
extern "C" int test_scaled_gamma_poisson(int, char**);
#line 5 "src/test/conjugacy/test_subtract_bounded_discrete_delta.birch"
extern "C" int test_subtract_bounded_discrete_delta(int, char**);
#line 4 "src/test/grad/test_grad_beta.birch"
extern "C" int test_grad_beta(int, char**);
#line 4 "src/test/grad/test_grad_exponential.birch"
extern "C" int test_grad_exponential(int, char**);
#line 4 "src/test/grad/test_grad_gamma.birch"
extern "C" int test_grad_gamma(int, char**);
#line 4 "src/test/grad/test_grad_gamma_exponential.birch"
extern "C" int test_grad_gamma_exponential(int, char**);
#line 4 "src/test/grad/test_grad_gaussian.birch"
extern "C" int test_grad_gaussian(int, char**);
#line 4 "src/test/grad/test_grad_inverse_gamma.birch"
extern "C" int test_grad_inverse_gamma(int, char**);
#line 4 "src/test/grad/test_grad_inverse_gamma_gamma.birch"
extern "C" int test_grad_inverse_gamma_gamma(int, char**);
#line 4 "src/test/grad/test_grad_linear_gaussian_gaussian.birch"
extern "C" int test_grad_linear_gaussian_gaussian(int, char**);
#line 4 "src/test/grad/test_grad_linear_matrix_normal_inverse_wishart_matrix_gaussian.birch"
extern "C" int test_grad_linear_matrix_normal_inverse_wishart_matrix_gaussian(int, char**);
#line 4 "src/test/grad/test_grad_linear_matrix_normal_inverse_wishart_multivariate_gaussian.birch"
extern "C" int test_grad_linear_matrix_normal_inverse_wishart_multivariate_gaussian(int, char**);
#line 4 "src/test/grad/test_grad_linear_multivariate_gaussian_gaussian.birch"
extern "C" int test_grad_linear_multivariate_gaussian_gaussian(int, char**);
#line 4 "src/test/grad/test_grad_linear_multivariate_gaussian_multivariate_gaussian.birch"
extern "C" int test_grad_linear_multivariate_gaussian_multivariate_gaussian(int, char**);
#line 4 "src/test/grad/test_grad_linear_multivariate_normal_inverse_gamma_gaussian.birch"
extern "C" int test_grad_linear_multivariate_normal_inverse_gamma_gaussian(int, char**);
#line 4 "src/test/grad/test_grad_linear_multivariate_normal_inverse_gamma_multivariate_gaussian.birch"
extern "C" int test_grad_linear_multivariate_normal_inverse_gamma_multivariate_gaussian(int, char**);
#line 4 "src/test/grad/test_grad_linear_normal_inverse_gamma_gaussian.birch"
extern "C" int test_grad_linear_normal_inverse_gamma_gaussian(int, char**);
#line 4 "src/test/grad/test_grad_matrix_gaussian.birch"
extern "C" int test_grad_matrix_gaussian(int, char**);
#line 4 "src/test/grad/test_grad_matrix_normal_inverse_wishart.birch"
extern "C" int test_grad_matrix_normal_inverse_wishart(int, char**);
#line 4 "src/test/grad/test_grad_matrix_normal_inverse_wishart_matrix_gaussian.birch"
extern "C" int test_grad_matrix_normal_inverse_wishart_matrix_gaussian(int, char**);
#line 4 "src/test/grad/test_grad_multivariate_gaussian_multivariate_gaussian.birch"
extern "C" int test_grad_multivariate_gaussian_multivariate_gaussian(int, char**);
#line 4 "src/test/grad/test_grad_multivariate_normal_inverse_gamma_multivariate_gaussian.birch"
extern "C" int test_grad_multivariate_normal_inverse_gamma_multivariate_gaussian(int, char**);
#line 4 "src/test/grad/test_grad_normal_inverse_gamma.birch"
extern "C" int test_grad_normal_inverse_gamma(int, char**);
#line 4 "src/test/grad/test_grad_normal_inverse_gamma_gaussian.birch"
extern "C" int test_grad_normal_inverse_gamma_gaussian(int, char**);
#line 4 "src/test/grad/test_grad_scaled_gamma_exponential.birch"
extern "C" int test_grad_scaled_gamma_exponential(int, char**);
#line 4 "src/test/grad/test_grad_student_t.birch"
extern "C" int test_grad_student_t(int, char**);
#line 4 "src/test/grad/test_grad_weibull.birch"
extern "C" int test_grad_weibull(int, char**);
#line 4 "src/test/pdf/test_pdf_bernoulli.birch"
extern "C" int test_pdf_bernoulli(int, char**);
#line 4 "src/test/pdf/test_pdf_beta.birch"
extern "C" int test_pdf_beta(int, char**);
#line 4 "src/test/pdf/test_pdf_beta_bernoulli.birch"
extern "C" int test_pdf_beta_bernoulli(int, char**);
#line 4 "src/test/pdf/test_pdf_beta_binomial.birch"
extern "C" int test_pdf_beta_binomial(int, char**);
#line 4 "src/test/pdf/test_pdf_beta_negative_binomial.birch"
extern "C" int test_pdf_beta_negative_binomial(int, char**);
#line 4 "src/test/pdf/test_pdf_binomial.birch"
extern "C" int test_pdf_binomial(int, char**);
#line 4 "src/test/pdf/test_pdf_categorical.birch"
extern "C" int test_pdf_categorical(int, char**);
#line 4 "src/test/pdf/test_pdf_dirichlet_categorical.birch"
extern "C" int test_pdf_dirichlet_categorical(int, char**);
#line 4 "src/test/pdf/test_pdf_exponential.birch"
extern "C" int test_pdf_exponential(int, char**);
#line 4 "src/test/pdf/test_pdf_gamma.birch"
extern "C" int test_pdf_gamma(int, char**);
#line 4 "src/test/pdf/test_pdf_gamma_exponential.birch"
extern "C" int test_pdf_gamma_exponential(int, char**);
#line 4 "src/test/pdf/test_pdf_gamma_poisson.birch"
extern "C" int test_pdf_gamma_poisson(int, char**);
#line 4 "src/test/pdf/test_pdf_gaussian.birch"
extern "C" int test_pdf_gaussian(int, char**);
#line 4 "src/test/pdf/test_pdf_geometric.birch"
extern "C" int test_pdf_geometric(int, char**);
#line 4 "src/test/pdf/test_pdf_inverse_gamma.birch"
extern "C" int test_pdf_inverse_gamma(int, char**);
#line 4 "src/test/pdf/test_pdf_inverse_gamma_gamma.birch"
extern "C" int test_pdf_inverse_gamma_gamma(int, char**);
#line 4 "src/test/pdf/test_pdf_linear_discrete_delta.birch"
extern "C" int test_pdf_linear_discrete_delta(int, char**);
#line 4 "src/test/pdf/test_pdf_linear_gaussian_gaussian.birch"
extern "C" int test_pdf_linear_gaussian_gaussian(int, char**);
#line 4 "src/test/pdf/test_pdf_linear_matrix_normal_inverse_wishart_matrix_gaussian.birch"
extern "C" int test_pdf_linear_matrix_normal_inverse_wishart_matrix_gaussian(int, char**);
#line 4 "src/test/pdf/test_pdf_linear_matrix_normal_inverse_wishart_multivariate_gaussian.birch"
extern "C" int test_pdf_linear_matrix_normal_inverse_wishart_multivariate_gaussian(int, char**);
#line 4 "src/test/pdf/test_pdf_linear_multivariate_gaussian_gaussian.birch"
extern "C" int test_pdf_linear_multivariate_gaussian_gaussian(int, char**);
#line 4 "src/test/pdf/test_pdf_linear_multivariate_gaussian_multivariate_gaussian.birch"
extern "C" int test_pdf_linear_multivariate_gaussian_multivariate_gaussian(int, char**);
#line 4 "src/test/pdf/test_pdf_linear_multivariate_normal_inverse_gamma_gaussian.birch"
extern "C" int test_pdf_linear_multivariate_normal_inverse_gamma_gaussian(int, char**);
#line 4 "src/test/pdf/test_pdf_linear_multivariate_normal_inverse_gamma_multivariate_gaussian.birch"
extern "C" int test_pdf_linear_multivariate_normal_inverse_gamma_multivariate_gaussian(int, char**);
#line 4 "src/test/pdf/test_pdf_linear_normal_inverse_gamma_gaussian.birch"
extern "C" int test_pdf_linear_normal_inverse_gamma_gaussian(int, char**);
#line 4 "src/test/pdf/test_pdf_matrix_gaussian.birch"
extern "C" int test_pdf_matrix_gaussian(int, char**);
#line 4 "src/test/pdf/test_pdf_matrix_normal_inverse_wishart.birch"
extern "C" int test_pdf_matrix_normal_inverse_wishart(int, char**);
#line 4 "src/test/pdf/test_pdf_matrix_normal_inverse_wishart_matrix_gaussian.birch"
extern "C" int test_pdf_matrix_normal_inverse_wishart_matrix_gaussian(int, char**);
#line 4 "src/test/pdf/test_pdf_multivariate_gaussian.birch"
extern "C" int test_pdf_multivariate_gaussian(int, char**);
#line 4 "src/test/pdf/test_pdf_multivariate_gaussian_multivariate_gaussian.birch"
extern "C" int test_pdf_multivariate_gaussian_multivariate_gaussian(int, char**);
#line 4 "src/test/pdf/test_pdf_multivariate_normal_inverse_gamma_multivariate_gaussian.birch"
extern "C" int test_pdf_multivariate_normal_inverse_gamma_multivariate_gaussian(int, char**);
#line 4 "src/test/pdf/test_pdf_multivariate_uniform.birch"
extern "C" int test_pdf_multivariate_uniform(int, char**);
#line 4 "src/test/pdf/test_pdf_negative_binomial.birch"
extern "C" int test_pdf_negative_binomial(int, char**);
#line 4 "src/test/pdf/test_pdf_normal_inverse_gamma.birch"
extern "C" int test_pdf_normal_inverse_gamma(int, char**);
#line 4 "src/test/pdf/test_pdf_normal_inverse_gamma_gaussian.birch"
extern "C" int test_pdf_normal_inverse_gamma_gaussian(int, char**);
#line 4 "src/test/pdf/test_pdf_poisson.birch"
extern "C" int test_pdf_poisson(int, char**);
#line 4 "src/test/pdf/test_pdf_scaled_gamma_exponential.birch"
extern "C" int test_pdf_scaled_gamma_exponential(int, char**);
#line 4 "src/test/pdf/test_pdf_scaled_gamma_poisson.birch"
extern "C" int test_pdf_scaled_gamma_poisson(int, char**);
#line 4 "src/test/pdf/test_pdf_student_t.birch"
extern "C" int test_pdf_student_t(int, char**);
#line 4 "src/test/pdf/test_pdf_uniform.birch"
extern "C" int test_pdf_uniform(int, char**);
#line 4 "src/test/pdf/test_pdf_uniform_int.birch"
extern "C" int test_pdf_uniform_int(int, char**);
#line 4 "src/test/pdf/test_pdf_weibull.birch"
extern "C" int test_pdf_weibull(int, char**);
}

#line 6 "src/container/Array.birch"
template<class Type>
#line 6 "src/container/Array.birch"
birch::type::Array<Type>::Array(const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_) :
    #line 6 "src/container/Array.birch"
    super_type_(),
    #line 10 "src/container/Array.birch"
    values() {
  //
}

#line 6 "src/container/Array.birch"
template<class Type>
#line 15 "src/container/Array.birch"
birch::type::Integer birch::type::Array<Type>::size(const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_) {
  #line 15 "src/container/Array.birch"
  libbirch_function_("size", "src/container/Array.birch", 15);
  #line 16 "src/container/Array.birch"
  libbirch_line_(16);
  #line 16 "src/container/Array.birch"
  return birch::length(this_()->values, handler_);
}

#line 6 "src/container/Array.birch"
template<class Type>
#line 22 "src/container/Array.birch"
birch::type::Boolean birch::type::Array<Type>::empty(const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_) {
  #line 22 "src/container/Array.birch"
  libbirch_function_("empty", "src/container/Array.birch", 22);
  #line 23 "src/container/Array.birch"
  libbirch_line_(23);
  #line 23 "src/container/Array.birch"
  return this_()->size(handler_) == birch::type::Integer(0);
}

#line 6 "src/container/Array.birch"
template<class Type>
#line 29 "src/container/Array.birch"
void birch::type::Array<Type>::clear(const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_) {
  #line 29 "src/container/Array.birch"
  libbirch_function_("clear", "src/container/Array.birch", 29);
  #line 30 "src/container/Array.birch"
  libbirch_line_(30);
  #line 30 "src/container/Array.birch"
  libbirch::DefaultArray<Type,1> values;
  #line 31 "src/container/Array.birch"
  libbirch_line_(31);
  #line 31 "src/container/Array.birch"
  this_()->values = values;
}

#line 6 "src/container/Array.birch"
template<class Type>
#line 39 "src/container/Array.birch"
Type birch::type::Array<Type>::get(const birch::type::Integer& i, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_) {
  #line 39 "src/container/Array.birch"
  libbirch_function_("get", "src/container/Array.birch", 39);
  #line 40 "src/container/Array.birch"
  libbirch_line_(40);
  #line 40 "src/container/Array.birch"
  return this_()->values.get(libbirch::make_slice(i - 1));
}

#line 6 "src/container/Array.birch"
template<class Type>
#line 49 "src/container/Array.birch"
void birch::type::Array<Type>::set(const birch::type::Integer& i, const Type& x, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_) {
  #line 49 "src/container/Array.birch"
  libbirch_function_("set", "src/container/Array.birch", 49);
  #line 50 "src/container/Array.birch"
  libbirch_line_(50);
  #line 50 "src/container/Array.birch"
  this_()->values.set(libbirch::make_slice(i - 1), x);
}

#line 6 "src/container/Array.birch"
template<class Type>
#line 56 "src/container/Array.birch"
Type birch::type::Array<Type>::front(const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_) {
  #line 56 "src/container/Array.birch"
  libbirch_function_("front", "src/container/Array.birch", 56);
  #line 57 "src/container/Array.birch"
  libbirch_line_(57);
  #line 57 "src/container/Array.birch"
  libbirch_assert_(this_()->size(handler_) > birch::type::Integer(0));
  #line 58 "src/container/Array.birch"
  libbirch_line_(58);
  #line 58 "src/container/Array.birch"
  return this_()->values.get(libbirch::make_slice(birch::type::Integer(1) - 1));
}

#line 6 "src/container/Array.birch"
template<class Type>
#line 64 "src/container/Array.birch"
Type birch::type::Array<Type>::back(const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_) {
  #line 64 "src/container/Array.birch"
  libbirch_function_("back", "src/container/Array.birch", 64);
  #line 65 "src/container/Array.birch"
  libbirch_line_(65);
  #line 65 "src/container/Array.birch"
  libbirch_assert_(this_()->size(handler_) > birch::type::Integer(0));
  #line 66 "src/container/Array.birch"
  libbirch_line_(66);
  #line 66 "src/container/Array.birch"
  return this_()->values.get(libbirch::make_slice(this_()->size(handler_) - 1));
}

#line 6 "src/container/Array.birch"
template<class Type>
#line 74 "src/container/Array.birch"
void birch::type::Array<Type>::pushFront(const Type& x, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_) {
  #line 74 "src/container/Array.birch"
  libbirch_function_("pushFront", "src/container/Array.birch", 74);
  #line 75 "src/container/Array.birch"
  libbirch_line_(75);
  #line 75 "src/container/Array.birch"
  this_()->insert(birch::type::Integer(1), x, handler_);
}

#line 6 "src/container/Array.birch"
template<class Type>
#line 81 "src/container/Array.birch"
Type birch::type::Array<Type>::pushFront(const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_) {
  #line 81 "src/container/Array.birch"
  libbirch_function_("pushFront", "src/container/Array.birch", 81);
  #line 82 "src/container/Array.birch"
  libbirch_line_(82);
  #line 82 "src/container/Array.birch"
  auto x = birch::make<Type>(handler_);
  #line 83 "src/container/Array.birch"
  libbirch_line_(83);
  #line 83 "src/container/Array.birch"
  if (x.query()) {
    #line 84 "src/container/Array.birch"
    libbirch_line_(84);
    #line 84 "src/container/Array.birch"
    this_()->pushFront(x.get(), handler_);
  } else {
    #line 86 "src/container/Array.birch"
    libbirch_line_(86);
    #line 86 "src/container/Array.birch"
    birch::error(birch::type::String("not default constructible"), handler_);
  }
  #line 88 "src/container/Array.birch"
  libbirch_line_(88);
  #line 88 "src/container/Array.birch"
  return x.get();
}

#line 6 "src/container/Array.birch"
template<class Type>
#line 96 "src/container/Array.birch"
void birch::type::Array<Type>::pushBack(const Type& x, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_) {
  #line 96 "src/container/Array.birch"
  libbirch_function_("pushBack", "src/container/Array.birch", 96);
  #line 97 "src/container/Array.birch"
  libbirch_line_(97);
  #line 97 "src/container/Array.birch"
  this_()->insert(this_()->size(handler_) + birch::type::Integer(1), x, handler_);
}

#line 6 "src/container/Array.birch"
template<class Type>
#line 103 "src/container/Array.birch"
Type birch::type::Array<Type>::pushBack(const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_) {
  #line 103 "src/container/Array.birch"
  libbirch_function_("pushBack", "src/container/Array.birch", 103);
  #line 104 "src/container/Array.birch"
  libbirch_line_(104);
  #line 104 "src/container/Array.birch"
  auto x = birch::make<Type>(handler_);
  #line 105 "src/container/Array.birch"
  libbirch_line_(105);
  #line 105 "src/container/Array.birch"
  if (x.query()) {
    #line 106 "src/container/Array.birch"
    libbirch_line_(106);
    #line 106 "src/container/Array.birch"
    this_()->pushBack(x.get(), handler_);
  } else {
    #line 108 "src/container/Array.birch"
    libbirch_line_(108);
    #line 108 "src/container/Array.birch"
    birch::error(birch::type::String("not default constructible"), handler_);
  }
  #line 110 "src/container/Array.birch"
  libbirch_line_(110);
  #line 110 "src/container/Array.birch"
  return x.get();
}

#line 6 "src/container/Array.birch"
template<class Type>
#line 116 "src/container/Array.birch"
void birch::type::Array<Type>::popFront(const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_) {
  #line 116 "src/container/Array.birch"
  libbirch_function_("popFront", "src/container/Array.birch", 116);
  #line 117 "src/container/Array.birch"
  libbirch_line_(117);
  #line 117 "src/container/Array.birch"
  this_()->erase(birch::type::Integer(1), handler_);
}

#line 6 "src/container/Array.birch"
template<class Type>
#line 123 "src/container/Array.birch"
void birch::type::Array<Type>::popBack(const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_) {
  #line 123 "src/container/Array.birch"
  libbirch_function_("popBack", "src/container/Array.birch", 123);
  #line 124 "src/container/Array.birch"
  libbirch_line_(124);
  #line 124 "src/container/Array.birch"
  this_()->erase(this_()->size(handler_), handler_);
}

#line 6 "src/container/Array.birch"
template<class Type>
#line 137 "src/container/Array.birch"
void birch::type::Array<Type>::insert(const birch::type::Integer& i, const Type& x, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_) {
  #line 137 "src/container/Array.birch"
  libbirch_function_("insert", "src/container/Array.birch", 137);
  #line 138 "src/container/Array.birch"
  libbirch_line_(138);
  #line 138 "src/container/Array.birch"
  libbirch_assert_(birch::type::Integer(1) <= i && i <= this_()->size(handler_) + birch::type::Integer(1));
  #line 139 "src/container/Array.birch"

    this->values.insert(i - 1, x);
    }

#line 6 "src/container/Array.birch"
template<class Type>
#line 151 "src/container/Array.birch"
void birch::type::Array<Type>::erase(const birch::type::Integer& i, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_) {
  #line 151 "src/container/Array.birch"
  libbirch_function_("erase", "src/container/Array.birch", 151);
  #line 152 "src/container/Array.birch"
  libbirch_line_(152);
  #line 152 "src/container/Array.birch"
  libbirch_assert_(birch::type::Integer(1) <= i && i <= this_()->size(handler_));
  #line 153 "src/container/Array.birch"

    this->values.erase(i - 1);
    }

#line 6 "src/container/Array.birch"
template<class Type>
#line 166 "src/container/Array.birch"
void birch::type::Array<Type>::erase(const birch::type::Integer& i, const birch::type::Integer& n, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_) {
  #line 166 "src/container/Array.birch"
  libbirch_function_("erase", "src/container/Array.birch", 166);
  #line 167 "src/container/Array.birch"
  libbirch_line_(167);
  #line 167 "src/container/Array.birch"
  libbirch_assert_(birch::type::Integer(1) <= i && i <= this_()->size(handler_));
  #line 168 "src/container/Array.birch"
  libbirch_line_(168);
  #line 168 "src/container/Array.birch"
  libbirch_assert_(birch::type::Integer(1) <= n && n <= this_()->size(handler_) - i + birch::type::Integer(1));
  #line 169 "src/container/Array.birch"

    this->values.erase(i - 1, n);
    }

#line 6 "src/container/Array.birch"
template<class Type>
#line 179 "src/container/Array.birch"
libbirch::Lazy<libbirch::Shared<birch::type::Iterator<Type>>> birch::type::Array<Type>::walk(const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_) {
  #line 179 "src/container/Array.birch"
  libbirch_function_("walk", "src/container/Array.birch", 179);
  #line 180 "src/container/Array.birch"
  libbirch_line_(180);
  #line 180 "src/container/Array.birch"
  return birch::ArrayIterator<Type>(shared_from_this_(), handler_);
}

#line 6 "src/container/Array.birch"
template<class Type>
#line 186 "src/container/Array.birch"
libbirch::DefaultArray<Type,1> birch::type::Array<Type>::toArray(const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_) {
  #line 186 "src/container/Array.birch"
  libbirch_function_("toArray", "src/container/Array.birch", 186);
  #line 187 "src/container/Array.birch"
  libbirch_line_(187);
  #line 187 "src/container/Array.birch"
  return this_()->values;
}

#line 6 "src/container/Array.birch"
template<class Type>
#line 193 "src/container/Array.birch"
void birch::type::Array<Type>::fromArray(const libbirch::DefaultArray<Type,1>& x, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_) {
  #line 193 "src/container/Array.birch"
  libbirch_function_("fromArray", "src/container/Array.birch", 193);
  #line 194 "src/container/Array.birch"
  libbirch_line_(194);
  #line 194 "src/container/Array.birch"
  this_()->values = x;
}

#line 6 "src/container/Array.birch"
template<class Type>
#line 197 "src/container/Array.birch"
void birch::type::Array<Type>::read(const libbirch::Lazy<libbirch::Shared<birch::type::Buffer>>& buffer, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_) {
  #line 197 "src/container/Array.birch"
  libbirch_function_("read", "src/container/Array.birch", 197);
  #line 198 "src/container/Array.birch"
  libbirch_line_(198);
  #line 198 "src/container/Array.birch"
  auto f = buffer->walk(handler_);
  #line 199 "src/container/Array.birch"
  libbirch_line_(199);
  #line 199 "src/container/Array.birch"
  while (f->hasNext(handler_)) {
    #line 201 "src/container/Array.birch"
    libbirch_line_(201);
    #line 201 "src/container/Array.birch"
    auto x = birch::make<Type>(handler_);
    #line 202 "src/container/Array.birch"
    libbirch_line_(202);
    #line 202 "src/container/Array.birch"
    auto y = f->next(handler_)->get(x, handler_);
    #line 203 "src/container/Array.birch"
    libbirch_line_(203);
    #line 203 "src/container/Array.birch"
    if (y.query()) {
      #line 204 "src/container/Array.birch"
      libbirch_line_(204);
      #line 204 "src/container/Array.birch"
      x = libbirch::cast<Type>(y);
      #line 205 "src/container/Array.birch"
      libbirch_line_(205);
      #line 205 "src/container/Array.birch"
      this_()->pushBack(x.get(), handler_);
    }
  }
}

#line 6 "src/container/Array.birch"
template<class Type>
#line 210 "src/container/Array.birch"
void birch::type::Array<Type>::write(const libbirch::Lazy<libbirch::Shared<birch::type::Buffer>>& buffer, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_) {
  #line 210 "src/container/Array.birch"
  libbirch_function_("write", "src/container/Array.birch", 210);
  #line 211 "src/container/Array.birch"
  libbirch_line_(211);
  #line 211 "src/container/Array.birch"
  auto f = this_()->walk(handler_);
  #line 212 "src/container/Array.birch"
  libbirch_line_(212);
  #line 212 "src/container/Array.birch"
  while (f->hasNext(handler_)) {
    #line 213 "src/container/Array.birch"
    libbirch_line_(213);
    #line 213 "src/container/Array.birch"
    buffer->push(f->next(handler_), handler_);
  }
}

#line 30 "src/container/List.birch"
template<class Type>
#line 30 "src/container/List.birch"
birch::type::List<Type>::List(const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_) :
    #line 30 "src/container/List.birch"
    super_type_(),
    #line 31 "src/container/List.birch"
    head(),
    #line 32 "src/container/List.birch"
    tail(),
    #line 33 "src/container/List.birch"
    count(birch::type::Integer(0)) {
  //
}

#line 30 "src/container/List.birch"
template<class Type>
#line 38 "src/container/List.birch"
birch::type::Integer birch::type::List<Type>::size(const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_) {
  #line 38 "src/container/List.birch"
  libbirch_function_("size", "src/container/List.birch", 38);
  #line 39 "src/container/List.birch"
  libbirch_line_(39);
  #line 39 "src/container/List.birch"
  return this_()->count;
}

#line 30 "src/container/List.birch"
template<class Type>
#line 45 "src/container/List.birch"
birch::type::Boolean birch::type::List<Type>::empty(const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_) {
  #line 45 "src/container/List.birch"
  libbirch_function_("empty", "src/container/List.birch", 45);
  #line 46 "src/container/List.birch"
  libbirch_line_(46);
  #line 46 "src/container/List.birch"
  return this_()->count == birch::type::Integer(0);
}

#line 30 "src/container/List.birch"
template<class Type>
#line 52 "src/container/List.birch"
void birch::type::List<Type>::clear(const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_) {
  #line 52 "src/container/List.birch"
  libbirch_function_("clear", "src/container/List.birch", 52);
  #line 53 "src/container/List.birch"
  libbirch_line_(53);
  #line 53 "src/container/List.birch"
  this_()->head = libbirch::nil;
  #line 54 "src/container/List.birch"
  libbirch_line_(54);
  #line 54 "src/container/List.birch"
  this_()->tail = libbirch::nil;
  #line 55 "src/container/List.birch"
  libbirch_line_(55);
  #line 55 "src/container/List.birch"
  this_()->count = birch::type::Integer(0);
}

#line 30 "src/container/List.birch"
template<class Type>
#line 61 "src/container/List.birch"
Type birch::type::List<Type>::front(const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_) {
  #line 61 "src/container/List.birch"
  libbirch_function_("front", "src/container/List.birch", 61);
  #line 62 "src/container/List.birch"
  libbirch_line_(62);
  #line 62 "src/container/List.birch"
  libbirch_assert_(this_()->head.query());
  #line 63 "src/container/List.birch"
  libbirch_line_(63);
  #line 63 "src/container/List.birch"
  return this_()->head.get()->x;
}

#line 30 "src/container/List.birch"
template<class Type>
#line 69 "src/container/List.birch"
Type birch::type::List<Type>::back(const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_) {
  #line 69 "src/container/List.birch"
  libbirch_function_("back", "src/container/List.birch", 69);
  #line 70 "src/container/List.birch"
  libbirch_line_(70);
  #line 70 "src/container/List.birch"
  libbirch_assert_(this_()->tail.query());
  #line 71 "src/container/List.birch"
  libbirch_line_(71);
  #line 71 "src/container/List.birch"
  auto tail = this_()->tail.get();
  #line 72 "src/container/List.birch"
  libbirch_line_(72);
  #line 72 "src/container/List.birch"
  return tail->x;
}

#line 30 "src/container/List.birch"
template<class Type>
#line 80 "src/container/List.birch"
Type birch::type::List<Type>::get(const birch::type::Integer& i, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_) {
  #line 80 "src/container/List.birch"
  libbirch_function_("get", "src/container/List.birch", 80);
  #line 81 "src/container/List.birch"
  libbirch_line_(81);
  #line 81 "src/container/List.birch"
  return this_()->getNode(i, handler_)->x;
}

#line 30 "src/container/List.birch"
template<class Type>
#line 90 "src/container/List.birch"
void birch::type::List<Type>::set(const birch::type::Integer& i, const Type& x, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_) {
  #line 90 "src/container/List.birch"
  libbirch_function_("set", "src/container/List.birch", 90);
  #line 91 "src/container/List.birch"
  libbirch_line_(91);
  #line 91 "src/container/List.birch"
  this_()->getNode(i, handler_)->x = x;
}

#line 30 "src/container/List.birch"
template<class Type>
#line 99 "src/container/List.birch"
void birch::type::List<Type>::pushFront(const Type& x, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_) {
  #line 99 "src/container/List.birch"
  libbirch_function_("pushFront", "src/container/List.birch", 99);
  #line 100 "src/container/List.birch"
  libbirch_line_(100);
  #line 100 "src/container/List.birch"
  libbirch::Lazy<libbirch::Shared<birch::type::ListNode<Type>>> node(x);
  #line 101 "src/container/List.birch"
  libbirch_line_(101);
  #line 101 "src/container/List.birch"
  if (this_()->empty(handler_)) {
    #line 102 "src/container/List.birch"
    libbirch_line_(102);
    #line 102 "src/container/List.birch"
    this_()->tail = node;
  } else {
    #line 104 "src/container/List.birch"
    libbirch_line_(104);
    #line 104 "src/container/List.birch"
    libbirch_assert_(this_()->head.query());
    #line 105 "src/container/List.birch"
    libbirch_line_(105);
    #line 105 "src/container/List.birch"
    this_()->head.get()->prev = node;
    #line 106 "src/container/List.birch"
    libbirch_line_(106);
    #line 106 "src/container/List.birch"
    node->next = this_()->head;
  }
  #line 108 "src/container/List.birch"
  libbirch_line_(108);
  #line 108 "src/container/List.birch"
  this_()->head = node;
  #line 109 "src/container/List.birch"
  libbirch_line_(109);
  #line 109 "src/container/List.birch"
  this_()->count = this_()->count + birch::type::Integer(1);
  #line 111 "src/container/List.birch"
  libbirch_line_(111);
  #line 111 "src/container/List.birch"
  libbirch_assert_(this_()->head.query() && this_()->tail.query());
}

#line 30 "src/container/List.birch"
template<class Type>
#line 117 "src/container/List.birch"
Type birch::type::List<Type>::pushFront(const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_) {
  #line 117 "src/container/List.birch"
  libbirch_function_("pushFront", "src/container/List.birch", 117);
  #line 118 "src/container/List.birch"
  libbirch_line_(118);
  #line 118 "src/container/List.birch"
  auto x = birch::make<Type>(handler_);
  #line 119 "src/container/List.birch"
  libbirch_line_(119);
  #line 119 "src/container/List.birch"
  if (x.query()) {
    #line 120 "src/container/List.birch"
    libbirch_line_(120);
    #line 120 "src/container/List.birch"
    this_()->pushFront(x.get(), handler_);
  } else {
    #line 122 "src/container/List.birch"
    libbirch_line_(122);
    #line 122 "src/container/List.birch"
    birch::error(birch::type::String("not default constructible"), handler_);
  }
  #line 124 "src/container/List.birch"
  libbirch_line_(124);
  #line 124 "src/container/List.birch"
  return x.get();
}

#line 30 "src/container/List.birch"
template<class Type>
#line 132 "src/container/List.birch"
void birch::type::List<Type>::pushBack(const Type& x, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_) {
  #line 132 "src/container/List.birch"
  libbirch_function_("pushBack", "src/container/List.birch", 132);
  #line 133 "src/container/List.birch"
  libbirch_line_(133);
  #line 133 "src/container/List.birch"
  libbirch::Lazy<libbirch::Shared<birch::type::ListNode<Type>>> node(x);
  #line 134 "src/container/List.birch"
  libbirch_line_(134);
  #line 134 "src/container/List.birch"
  if (this_()->empty(handler_)) {
    #line 135 "src/container/List.birch"
    libbirch_line_(135);
    #line 135 "src/container/List.birch"
    this_()->head = node;
  } else {
    #line 137 "src/container/List.birch"
    libbirch_line_(137);
    #line 137 "src/container/List.birch"
    libbirch_assert_(this_()->tail.query());
    #line 138 "src/container/List.birch"
    libbirch_line_(138);
    #line 138 "src/container/List.birch"
    auto tail = this_()->tail.get();
    #line 139 "src/container/List.birch"
    libbirch_line_(139);
    #line 139 "src/container/List.birch"
    tail->next = node;
    #line 140 "src/container/List.birch"
    libbirch_line_(140);
    #line 140 "src/container/List.birch"
    node->prev = tail;
  }
  #line 142 "src/container/List.birch"
  libbirch_line_(142);
  #line 142 "src/container/List.birch"
  this_()->tail = node;
  #line 143 "src/container/List.birch"
  libbirch_line_(143);
  #line 143 "src/container/List.birch"
  this_()->count = this_()->count + birch::type::Integer(1);
  #line 145 "src/container/List.birch"
  libbirch_line_(145);
  #line 145 "src/container/List.birch"
  libbirch_assert_(this_()->head.query() && this_()->tail.query());
}

#line 30 "src/container/List.birch"
template<class Type>
#line 151 "src/container/List.birch"
Type birch::type::List<Type>::pushBack(const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_) {
  #line 151 "src/container/List.birch"
  libbirch_function_("pushBack", "src/container/List.birch", 151);
  #line 152 "src/container/List.birch"
  libbirch_line_(152);
  #line 152 "src/container/List.birch"
  auto x = birch::make<Type>(handler_);
  #line 153 "src/container/List.birch"
  libbirch_line_(153);
  #line 153 "src/container/List.birch"
  if (x.query()) {
    #line 154 "src/container/List.birch"
    libbirch_line_(154);
    #line 154 "src/container/List.birch"
    this_()->pushBack(x.get(), handler_);
  } else {
    #line 156 "src/container/List.birch"
    libbirch_line_(156);
    #line 156 "src/container/List.birch"
    birch::error(birch::type::String("not default constructible"), handler_);
  }
  #line 158 "src/container/List.birch"
  libbirch_line_(158);
  #line 158 "src/container/List.birch"
  return x.get();
}

#line 30 "src/container/List.birch"
template<class Type>
#line 164 "src/container/List.birch"
void birch::type::List<Type>::popFront(const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_) {
  #line 164 "src/container/List.birch"
  libbirch_function_("popFront", "src/container/List.birch", 164);
  #line 165 "src/container/List.birch"
  libbirch_line_(165);
  #line 165 "src/container/List.birch"
  libbirch_assert_(!this_()->empty(handler_));
  #line 166 "src/container/List.birch"
  libbirch_line_(166);
  #line 166 "src/container/List.birch"
  libbirch_assert_(this_()->head.query());
  #line 167 "src/container/List.birch"
  libbirch_line_(167);
  #line 167 "src/container/List.birch"
  this_()->head = this_()->head.get()->popFront(handler_);
  #line 168 "src/container/List.birch"
  libbirch_line_(168);
  #line 168 "src/container/List.birch"
  this_()->count = this_()->count - birch::type::Integer(1);
  #line 169 "src/container/List.birch"
  libbirch_line_(169);
  #line 169 "src/container/List.birch"
  if (this_()->count <= birch::type::Integer(1)) {
    #line 170 "src/container/List.birch"
    libbirch_line_(170);
    #line 170 "src/container/List.birch"
    this_()->tail = this_()->head;
  }
  #line 173 "src/container/List.birch"
  libbirch_line_(173);
  #line 173 "src/container/List.birch"
  libbirch_assert_(this_()->count == birch::type::Integer(0) || (this_()->head.query() && this_()->tail.query()));
  #line 174 "src/container/List.birch"
  libbirch_line_(174);
  #line 174 "src/container/List.birch"
  libbirch_assert_(this_()->count > birch::type::Integer(0) || (!this_()->head.query() && !this_()->tail.query()));
}

#line 30 "src/container/List.birch"
template<class Type>
#line 180 "src/container/List.birch"
void birch::type::List<Type>::popBack(const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_) {
  #line 180 "src/container/List.birch"
  libbirch_function_("popBack", "src/container/List.birch", 180);
  #line 181 "src/container/List.birch"
  libbirch_line_(181);
  #line 181 "src/container/List.birch"
  libbirch_assert_(!this_()->empty(handler_));
  #line 182 "src/container/List.birch"
  libbirch_line_(182);
  #line 182 "src/container/List.birch"
  libbirch_assert_(this_()->tail.query());
  #line 183 "src/container/List.birch"
  libbirch_line_(183);
  #line 183 "src/container/List.birch"
  this_()->tail = this_()->tail.get()->popBack(handler_);
  #line 184 "src/container/List.birch"
  libbirch_line_(184);
  #line 184 "src/container/List.birch"
  this_()->count = this_()->count - birch::type::Integer(1);
  #line 185 "src/container/List.birch"
  libbirch_line_(185);
  #line 185 "src/container/List.birch"
  if (this_()->count <= birch::type::Integer(1)) {
    #line 186 "src/container/List.birch"
    libbirch_line_(186);
    #line 186 "src/container/List.birch"
    this_()->head = this_()->tail;
  }
  #line 189 "src/container/List.birch"
  libbirch_line_(189);
  #line 189 "src/container/List.birch"
  libbirch_assert_(this_()->count == birch::type::Integer(0) || (this_()->head.query() && this_()->tail.query()));
  #line 190 "src/container/List.birch"
  libbirch_line_(190);
  #line 190 "src/container/List.birch"
  libbirch_assert_(this_()->count > birch::type::Integer(0) || (!this_()->head.query() && !this_()->tail.query()));
}

#line 30 "src/container/List.birch"
template<class Type>
#line 203 "src/container/List.birch"
void birch::type::List<Type>::insert(const birch::type::Integer& i, const Type& x, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_) {
  #line 203 "src/container/List.birch"
  libbirch_function_("insert", "src/container/List.birch", 203);
  #line 204 "src/container/List.birch"
  libbirch_line_(204);
  #line 204 "src/container/List.birch"
  libbirch_assert_(birch::type::Integer(1) <= i && i <= this_()->count + birch::type::Integer(1));
  #line 206 "src/container/List.birch"
  libbirch_line_(206);
  #line 206 "src/container/List.birch"
  if (i == birch::type::Integer(1)) {
    #line 207 "src/container/List.birch"
    libbirch_line_(207);
    #line 207 "src/container/List.birch"
    this_()->pushFront(x, handler_);
  } else {
    #line 208 "src/container/List.birch"
    libbirch_line_(208);
    #line 208 "src/container/List.birch"
    if (i == this_()->count + birch::type::Integer(1)) {
      #line 209 "src/container/List.birch"
      libbirch_line_(209);
      #line 209 "src/container/List.birch"
      this_()->pushBack(x, handler_);
    } else {
      #line 211 "src/container/List.birch"
      libbirch_line_(211);
      #line 211 "src/container/List.birch"
      libbirch::Lazy<libbirch::Shared<birch::type::ListNode<Type>>> node(x);
      #line 212 "src/container/List.birch"
      libbirch_line_(212);
      #line 212 "src/container/List.birch"
      this_()->getNode(i, handler_)->insert(node, handler_);
      #line 213 "src/container/List.birch"
      libbirch_line_(213);
      #line 213 "src/container/List.birch"
      this_()->count = this_()->count + birch::type::Integer(1);
    }
  }
  #line 216 "src/container/List.birch"
  libbirch_line_(216);
  #line 216 "src/container/List.birch"
  libbirch_assert_(this_()->head.query() && this_()->tail.query());
}

#line 30 "src/container/List.birch"
template<class Type>
#line 224 "src/container/List.birch"
void birch::type::List<Type>::erase(const birch::type::Integer& i, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_) {
  #line 224 "src/container/List.birch"
  libbirch_function_("erase", "src/container/List.birch", 224);
  #line 225 "src/container/List.birch"
  libbirch_line_(225);
  #line 225 "src/container/List.birch"
  libbirch_assert_(birch::type::Integer(1) <= i && i <= this_()->count);
  #line 227 "src/container/List.birch"
  libbirch_line_(227);
  #line 227 "src/container/List.birch"
  if (i == birch::type::Integer(1)) {
    #line 228 "src/container/List.birch"
    libbirch_line_(228);
    #line 228 "src/container/List.birch"
    this_()->popFront(handler_);
  } else {
    #line 229 "src/container/List.birch"
    libbirch_line_(229);
    #line 229 "src/container/List.birch"
    if (i == this_()->count) {
      #line 230 "src/container/List.birch"
      libbirch_line_(230);
      #line 230 "src/container/List.birch"
      this_()->popBack(handler_);
    } else {
      #line 232 "src/container/List.birch"
      libbirch_line_(232);
      #line 232 "src/container/List.birch"
      this_()->getNode(i, handler_)->erase(handler_);
      #line 233 "src/container/List.birch"
      libbirch_line_(233);
      #line 233 "src/container/List.birch"
      this_()->count = this_()->count - birch::type::Integer(1);
    }
  }
  #line 236 "src/container/List.birch"
  libbirch_line_(236);
  #line 236 "src/container/List.birch"
  libbirch_assert_(this_()->count == birch::type::Integer(0) || (this_()->head.query() && this_()->tail.query()));
  #line 237 "src/container/List.birch"
  libbirch_line_(237);
  #line 237 "src/container/List.birch"
  libbirch_assert_(this_()->count > birch::type::Integer(0) || (!this_()->head.query() && !this_()->tail.query()));
}

#line 30 "src/container/List.birch"
template<class Type>
#line 245 "src/container/List.birch"
libbirch::Lazy<libbirch::Shared<birch::type::Iterator<Type>>> birch::type::List<Type>::walk(const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_) {
  #line 245 "src/container/List.birch"
  libbirch_function_("walk", "src/container/List.birch", 245);
  #line 246 "src/container/List.birch"
  libbirch_line_(246);
  #line 246 "src/container/List.birch"
  return birch::ListIterator<Type>(this_()->head, handler_);
}

#line 30 "src/container/List.birch"
template<class Type>
#line 254 "src/container/List.birch"
libbirch::Lazy<libbirch::Shared<birch::type::ListNode<Type>>> birch::type::List<Type>::getNode(const birch::type::Integer& i, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_) {
  #line 254 "src/container/List.birch"
  libbirch_function_("getNode", "src/container/List.birch", 254);
  #line 255 "src/container/List.birch"
  libbirch_line_(255);
  #line 255 "src/container/List.birch"
  libbirch_assert_(birch::type::Integer(1) <= i && i <= this_()->count);
  #line 257 "src/container/List.birch"
  libbirch_line_(257);
  #line 257 "src/container/List.birch"
  libbirch::Optional<libbirch::Lazy<libbirch::Shared<birch::type::ListNode<Type>>>> node;
  #line 258 "src/container/List.birch"
  libbirch_line_(258);
  #line 258 "src/container/List.birch"
  if (birch::type::Integer(2) * i <= this_()->count) {
    #line 260 "src/container/List.birch"
    libbirch_line_(260);
    #line 260 "src/container/List.birch"
    node = this_()->head;
    #line 261 "src/container/List.birch"
    libbirch_line_(261);
    #line 261 "src/container/List.birch"
    for (auto j = birch::type::Integer(1); j <= i - birch::type::Integer(1); ++j) {
      #line 262 "src/container/List.birch"
      libbirch_line_(262);
      #line 262 "src/container/List.birch"
      libbirch_assert_(node.query());
      #line 263 "src/container/List.birch"
      libbirch_line_(263);
      #line 263 "src/container/List.birch"
      node = node.get()->next;
    }
  } else {
    #line 267 "src/container/List.birch"
    libbirch_line_(267);
    #line 267 "src/container/List.birch"
    node = this_()->tail;
    #line 268 "src/container/List.birch"
    libbirch_line_(268);
    #line 268 "src/container/List.birch"
    for (auto j = birch::type::Integer(1); j <= this_()->count - i; ++j) {
      #line 269 "src/container/List.birch"
      libbirch_line_(269);
      #line 269 "src/container/List.birch"
      libbirch_assert_(node.query());
      #line 270 "src/container/List.birch"
      libbirch_line_(270);
      #line 270 "src/container/List.birch"
      node = node.get()->prev;
    }
  }
  #line 274 "src/container/List.birch"
  libbirch_line_(274);
  #line 274 "src/container/List.birch"
  libbirch_assert_(node.query());
  #line 275 "src/container/List.birch"
  libbirch_line_(275);
  #line 275 "src/container/List.birch"
  return node.get();
}

#line 30 "src/container/List.birch"
template<class Type>
#line 278 "src/container/List.birch"
void birch::type::List<Type>::read(const libbirch::Lazy<libbirch::Shared<birch::type::Buffer>>& buffer, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_) {
  #line 278 "src/container/List.birch"
  libbirch_function_("read", "src/container/List.birch", 278);
  #line 279 "src/container/List.birch"
  libbirch_line_(279);
  #line 279 "src/container/List.birch"
  auto f = buffer->walk(handler_);
  #line 280 "src/container/List.birch"
  libbirch_line_(280);
  #line 280 "src/container/List.birch"
  while (f->hasNext(handler_)) {
    #line 282 "src/container/List.birch"
    libbirch_line_(282);
    #line 282 "src/container/List.birch"
    auto x = birch::make<Type>(handler_);
    #line 283 "src/container/List.birch"
    libbirch_line_(283);
    #line 283 "src/container/List.birch"
    auto y = f->next(handler_)->get(x, handler_);
    #line 284 "src/container/List.birch"
    libbirch_line_(284);
    #line 284 "src/container/List.birch"
    if (y.query()) {
      #line 285 "src/container/List.birch"
      libbirch_line_(285);
      #line 285 "src/container/List.birch"
      x = libbirch::cast<Type>(y);
      #line 286 "src/container/List.birch"
      libbirch_line_(286);
      #line 286 "src/container/List.birch"
      this_()->pushBack(x.get(), handler_);
    }
  }
}

#line 30 "src/container/List.birch"
template<class Type>
#line 291 "src/container/List.birch"
void birch::type::List<Type>::write(const libbirch::Lazy<libbirch::Shared<birch::type::Buffer>>& buffer, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_) {
  #line 291 "src/container/List.birch"
  libbirch_function_("write", "src/container/List.birch", 291);
  #line 292 "src/container/List.birch"
  libbirch_line_(292);
  #line 292 "src/container/List.birch"
  auto f = this_()->walk(handler_);
  #line 293 "src/container/List.birch"
  libbirch_line_(293);
  #line 293 "src/container/List.birch"
  while (f->hasNext(handler_)) {
    #line 294 "src/container/List.birch"
    libbirch_line_(294);
    #line 294 "src/container/List.birch"
    buffer->push(f->next(handler_), handler_);
  }
}

#line 4 "src/container/ListNode.birch"
template<class Type>
#line 4 "src/container/ListNode.birch"
birch::type::ListNode<Type>::ListNode(const Type& x, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_) :
    #line 4 "src/container/ListNode.birch"
    super_type_(),
    #line 5 "src/container/ListNode.birch"
    prev(),
    #line 6 "src/container/ListNode.birch"
    next(),
    #line 7 "src/container/ListNode.birch"
    x(x) {
  //
}

#line 4 "src/container/ListNode.birch"
template<class Type>
#line 14 "src/container/ListNode.birch"
void birch::type::ListNode<Type>::insert(const libbirch::Lazy<libbirch::Shared<birch::type::ListNode<Type>>>& node, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_) {
  #line 14 "src/container/ListNode.birch"
  libbirch_function_("insert", "src/container/ListNode.birch", 14);
  #line 15 "src/container/ListNode.birch"
  libbirch_line_(15);
  #line 15 "src/container/ListNode.birch"
  libbirch_assert_(this_()->prev.query());
  #line 16 "src/container/ListNode.birch"
  libbirch_line_(16);
  #line 16 "src/container/ListNode.birch"
  node->prev = this_()->prev;
  #line 17 "src/container/ListNode.birch"
  libbirch_line_(17);
  #line 17 "src/container/ListNode.birch"
  node->next = shared_from_this_();
  #line 18 "src/container/ListNode.birch"
  libbirch_line_(18);
  #line 18 "src/container/ListNode.birch"
  this_()->prev.get()->next = node;
  #line 19 "src/container/ListNode.birch"
  libbirch_line_(19);
  #line 19 "src/container/ListNode.birch"
  this_()->prev = node;
}

#line 4 "src/container/ListNode.birch"
template<class Type>
#line 25 "src/container/ListNode.birch"
void birch::type::ListNode<Type>::erase(const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_) {
  #line 25 "src/container/ListNode.birch"
  libbirch_function_("erase", "src/container/ListNode.birch", 25);
  #line 26 "src/container/ListNode.birch"
  libbirch_line_(26);
  #line 26 "src/container/ListNode.birch"
  libbirch_assert_(this_()->prev.query());
  #line 27 "src/container/ListNode.birch"
  libbirch_line_(27);
  #line 27 "src/container/ListNode.birch"
  libbirch_assert_(this_()->next.query());
  #line 28 "src/container/ListNode.birch"
  libbirch_line_(28);
  #line 28 "src/container/ListNode.birch"
  this_()->next.get()->prev = this_()->prev;
  #line 29 "src/container/ListNode.birch"
  libbirch_line_(29);
  #line 29 "src/container/ListNode.birch"
  this_()->prev.get()->next = this_()->next;
  #line 30 "src/container/ListNode.birch"
  libbirch_line_(30);
  #line 30 "src/container/ListNode.birch"
  this_()->next = libbirch::nil;
  #line 31 "src/container/ListNode.birch"
  libbirch_line_(31);
  #line 31 "src/container/ListNode.birch"
  this_()->prev = libbirch::nil;
}

#line 4 "src/container/ListNode.birch"
template<class Type>
#line 39 "src/container/ListNode.birch"
libbirch::Optional<libbirch::Lazy<libbirch::Shared<birch::type::ListNode<Type>>>> birch::type::ListNode<Type>::popFront(const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_) {
  #line 39 "src/container/ListNode.birch"
  libbirch_function_("popFront", "src/container/ListNode.birch", 39);
  #line 40 "src/container/ListNode.birch"
  libbirch_line_(40);
  #line 40 "src/container/ListNode.birch"
  auto node = this_()->next;
  #line 41 "src/container/ListNode.birch"
  libbirch_line_(41);
  #line 41 "src/container/ListNode.birch"
  if (node.query()) {
    #line 42 "src/container/ListNode.birch"
    libbirch_line_(42);
    #line 42 "src/container/ListNode.birch"
    node.get()->prev = libbirch::nil;
  }
  #line 44 "src/container/ListNode.birch"
  libbirch_line_(44);
  #line 44 "src/container/ListNode.birch"
  this_()->next = libbirch::nil;
  #line 45 "src/container/ListNode.birch"
  libbirch_line_(45);
  #line 45 "src/container/ListNode.birch"
  this_()->prev = libbirch::nil;
  #line 46 "src/container/ListNode.birch"
  libbirch_line_(46);
  #line 46 "src/container/ListNode.birch"
  return node;
}

#line 4 "src/container/ListNode.birch"
template<class Type>
#line 54 "src/container/ListNode.birch"
libbirch::Optional<libbirch::Lazy<libbirch::Shared<birch::type::ListNode<Type>>>> birch::type::ListNode<Type>::popBack(const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_) {
  #line 54 "src/container/ListNode.birch"
  libbirch_function_("popBack", "src/container/ListNode.birch", 54);
  #line 55 "src/container/ListNode.birch"
  libbirch_line_(55);
  #line 55 "src/container/ListNode.birch"
  auto node = this_()->prev;
  #line 56 "src/container/ListNode.birch"
  libbirch_line_(56);
  #line 56 "src/container/ListNode.birch"
  if (node.query()) {
    #line 57 "src/container/ListNode.birch"
    libbirch_line_(57);
    #line 57 "src/container/ListNode.birch"
    node.get()->next = libbirch::nil;
  }
  #line 59 "src/container/ListNode.birch"
  libbirch_line_(59);
  #line 59 "src/container/ListNode.birch"
  this_()->next = libbirch::nil;
  #line 60 "src/container/ListNode.birch"
  libbirch_line_(60);
  #line 60 "src/container/ListNode.birch"
  this_()->prev = libbirch::nil;
  #line 61 "src/container/ListNode.birch"
  libbirch_line_(61);
  #line 61 "src/container/ListNode.birch"
  return node;
}

#line 7 "src/container/RaggedArray.birch"
template<class Type>
#line 7 "src/container/RaggedArray.birch"
birch::type::RaggedArray<Type>::RaggedArray(const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_) :
    #line 7 "src/container/RaggedArray.birch"
    super_type_(),
    #line 11 "src/container/RaggedArray.birch"
    values(),
    #line 16 "src/container/RaggedArray.birch"
    offsets(),
    #line 21 "src/container/RaggedArray.birch"
    sizes() {
  //
}

#line 7 "src/container/RaggedArray.birch"
template<class Type>
#line 28 "src/container/RaggedArray.birch"
birch::type::Boolean birch::type::RaggedArray<Type>::empty(const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_) {
  #line 28 "src/container/RaggedArray.birch"
  libbirch_function_("empty", "src/container/RaggedArray.birch", 28);
  #line 29 "src/container/RaggedArray.birch"
  libbirch_line_(29);
  #line 29 "src/container/RaggedArray.birch"
  return birch::length(this_()->offsets, handler_) == birch::type::Integer(0);
}

#line 7 "src/container/RaggedArray.birch"
template<class Type>
#line 35 "src/container/RaggedArray.birch"
void birch::type::RaggedArray<Type>::clear(const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_) {
  #line 35 "src/container/RaggedArray.birch"
  libbirch_function_("clear", "src/container/RaggedArray.birch", 35);
  #line 36 "src/container/RaggedArray.birch"
  libbirch_line_(36);
  #line 36 "src/container/RaggedArray.birch"
  libbirch::DefaultArray<Type,1> values;
  #line 37 "src/container/RaggedArray.birch"
  libbirch_line_(37);
  #line 37 "src/container/RaggedArray.birch"
  libbirch::DefaultArray<birch::type::Integer,1> offsets;
  #line 38 "src/container/RaggedArray.birch"
  libbirch_line_(38);
  #line 38 "src/container/RaggedArray.birch"
  libbirch::DefaultArray<birch::type::Integer,1> sizes;
  #line 40 "src/container/RaggedArray.birch"
  libbirch_line_(40);
  #line 40 "src/container/RaggedArray.birch"
  this_()->values = values;
  #line 41 "src/container/RaggedArray.birch"
  libbirch_line_(41);
  #line 41 "src/container/RaggedArray.birch"
  this_()->offsets = offsets;
  #line 42 "src/container/RaggedArray.birch"
  libbirch_line_(42);
  #line 42 "src/container/RaggedArray.birch"
  this_()->sizes = sizes;
}

#line 7 "src/container/RaggedArray.birch"
template<class Type>
#line 48 "src/container/RaggedArray.birch"
birch::type::Integer birch::type::RaggedArray<Type>::count(const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_) {
  #line 48 "src/container/RaggedArray.birch"
  libbirch_function_("count", "src/container/RaggedArray.birch", 48);
  #line 49 "src/container/RaggedArray.birch"
  libbirch_line_(49);
  #line 49 "src/container/RaggedArray.birch"
  return birch::length(this_()->values, handler_);
}

#line 7 "src/container/RaggedArray.birch"
template<class Type>
#line 55 "src/container/RaggedArray.birch"
birch::type::Integer birch::type::RaggedArray<Type>::size(const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_) {
  #line 55 "src/container/RaggedArray.birch"
  libbirch_function_("size", "src/container/RaggedArray.birch", 55);
  #line 56 "src/container/RaggedArray.birch"
  libbirch_line_(56);
  #line 56 "src/container/RaggedArray.birch"
  return birch::length(this_()->offsets, handler_);
}

#line 7 "src/container/RaggedArray.birch"
template<class Type>
#line 64 "src/container/RaggedArray.birch"
birch::type::Integer birch::type::RaggedArray<Type>::size(const birch::type::Integer& i, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_) {
  #line 64 "src/container/RaggedArray.birch"
  libbirch_function_("size", "src/container/RaggedArray.birch", 64);
  #line 65 "src/container/RaggedArray.birch"
  libbirch_line_(65);
  #line 65 "src/container/RaggedArray.birch"
  return this_()->sizes.get(libbirch::make_slice(i - 1));
}

#line 7 "src/container/RaggedArray.birch"
template<class Type>
#line 74 "src/container/RaggedArray.birch"
Type birch::type::RaggedArray<Type>::get(const birch::type::Integer& i, const birch::type::Integer& j, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_) {
  #line 74 "src/container/RaggedArray.birch"
  libbirch_function_("get", "src/container/RaggedArray.birch", 74);
  #line 75 "src/container/RaggedArray.birch"
  libbirch_line_(75);
  #line 75 "src/container/RaggedArray.birch"
  return this_()->values.get(libbirch::make_slice(this_()->serial(i, j, handler_) - 1));
}

#line 7 "src/container/RaggedArray.birch"
template<class Type>
#line 83 "src/container/RaggedArray.birch"
libbirch::DefaultArray<Type,1> birch::type::RaggedArray<Type>::get(const birch::type::Integer& i, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_) {
  #line 83 "src/container/RaggedArray.birch"
  libbirch_function_("get", "src/container/RaggedArray.birch", 83);
  #line 84 "src/container/RaggedArray.birch"
  libbirch_line_(84);
  #line 84 "src/container/RaggedArray.birch"
  return this_()->values.get(libbirch::make_slice(libbirch::make_range(this_()->from(i, handler_) - 1, this_()->to(i, handler_) - 1)));
}

#line 7 "src/container/RaggedArray.birch"
template<class Type>
#line 94 "src/container/RaggedArray.birch"
void birch::type::RaggedArray<Type>::set(const birch::type::Integer& i, const birch::type::Integer& j, const Type& x, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_) {
  #line 94 "src/container/RaggedArray.birch"
  libbirch_function_("set", "src/container/RaggedArray.birch", 94);
  #line 95 "src/container/RaggedArray.birch"
  libbirch_line_(95);
  #line 95 "src/container/RaggedArray.birch"
  this_()->values.set(libbirch::make_slice(this_()->serial(i, j, handler_) - 1), x);
}

#line 7 "src/container/RaggedArray.birch"
template<class Type>
#line 107 "src/container/RaggedArray.birch"
void birch::type::RaggedArray<Type>::set(const birch::type::Integer& i, const libbirch::DefaultArray<Type,1>& x, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_) {
  #line 107 "src/container/RaggedArray.birch"
  libbirch_function_("set", "src/container/RaggedArray.birch", 107);
  #line 108 "src/container/RaggedArray.birch"
  libbirch_line_(108);
  #line 108 "src/container/RaggedArray.birch"
  this_()->values.set(libbirch::make_slice(libbirch::make_range(this_()->from(i, handler_) - 1, this_()->to(i, handler_) - 1)), x);
}

#line 7 "src/container/RaggedArray.birch"
template<class Type>
#line 114 "src/container/RaggedArray.birch"
void birch::type::RaggedArray<Type>::popFront(const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_) {
  #line 114 "src/container/RaggedArray.birch"
  libbirch_function_("popFront", "src/container/RaggedArray.birch", 114);
  #line 115 "src/container/RaggedArray.birch"
  libbirch_line_(115);
  #line 115 "src/container/RaggedArray.birch"
  libbirch_assert_(this_()->size(handler_) > birch::type::Integer(0));
  #line 116 "src/container/RaggedArray.birch"
  libbirch_line_(116);
  #line 116 "src/container/RaggedArray.birch"
  if (this_()->size(handler_) == birch::type::Integer(1)) {
    #line 117 "src/container/RaggedArray.birch"
    libbirch_line_(117);
    #line 117 "src/container/RaggedArray.birch"
    this_()->clear(handler_);
  } else {
    #line 119 "src/container/RaggedArray.birch"
    libbirch_line_(119);
    #line 119 "src/container/RaggedArray.birch"
    auto ncols = this_()->sizes.get(libbirch::make_slice(birch::type::Integer(1) - 1));
    #line 120 "src/container/RaggedArray.birch"

      this->offsets.erase(0);
      this->sizes.erase(0);
          #line 124 "src/container/RaggedArray.birch"
    libbirch_line_(124);
    #line 124 "src/container/RaggedArray.birch"
    if (ncols > birch::type::Integer(0)) {
      #line 125 "src/container/RaggedArray.birch"

        this->values.erase(0, ncols);
              #line 128 "src/container/RaggedArray.birch"
      libbirch_line_(128);
      #line 128 "src/container/RaggedArray.birch"
      for (auto k = birch::type::Integer(1); k <= birch::length(this_()->offsets, handler_); ++k) {
        #line 129 "src/container/RaggedArray.birch"
        libbirch_line_(129);
        #line 129 "src/container/RaggedArray.birch"
        this_()->offsets.set(libbirch::make_slice(k - 1), this_()->offsets.get(libbirch::make_slice(k - 1)) - ncols);
      }
    }
  }
}

#line 7 "src/container/RaggedArray.birch"
template<class Type>
#line 140 "src/container/RaggedArray.birch"
void birch::type::RaggedArray<Type>::popFront(const birch::type::Integer& i, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_) {
  #line 140 "src/container/RaggedArray.birch"
  libbirch_function_("popFront", "src/container/RaggedArray.birch", 140);
  #line 141 "src/container/RaggedArray.birch"
  libbirch_line_(141);
  #line 141 "src/container/RaggedArray.birch"
  libbirch_assert_(this_()->size(i, handler_) > birch::type::Integer(0));
  #line 142 "src/container/RaggedArray.birch"
  libbirch_line_(142);
  #line 142 "src/container/RaggedArray.birch"
  auto j = this_()->offsets.get(libbirch::make_slice(i - 1));
  #line 143 "src/container/RaggedArray.birch"

    this->values.erase(j - 1);
      #line 146 "src/container/RaggedArray.birch"
  libbirch_line_(146);
  #line 146 "src/container/RaggedArray.birch"
  for (auto k = (i + birch::type::Integer(1)); k <= birch::length(this_()->offsets, handler_); ++k) {
    #line 147 "src/container/RaggedArray.birch"
    libbirch_line_(147);
    #line 147 "src/container/RaggedArray.birch"
    this_()->offsets.set(libbirch::make_slice(k - 1), this_()->offsets.get(libbirch::make_slice(k - 1)) - birch::type::Integer(1));
  }
  #line 149 "src/container/RaggedArray.birch"
  libbirch_line_(149);
  #line 149 "src/container/RaggedArray.birch"
  this_()->sizes.set(libbirch::make_slice(i - 1), this_()->sizes.get(libbirch::make_slice(i - 1)) - birch::type::Integer(1));
}

#line 7 "src/container/RaggedArray.birch"
template<class Type>
#line 155 "src/container/RaggedArray.birch"
void birch::type::RaggedArray<Type>::pushBack(const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_) {
  #line 155 "src/container/RaggedArray.birch"
  libbirch_function_("pushBack", "src/container/RaggedArray.birch", 155);
  #line 156 "src/container/RaggedArray.birch"
  libbirch_line_(156);
  #line 156 "src/container/RaggedArray.birch"
  auto nrows = birch::length(this_()->offsets, handler_);
  #line 157 "src/container/RaggedArray.birch"
  libbirch_line_(157);
  #line 157 "src/container/RaggedArray.birch"
  auto nvalues = birch::length(this_()->values, handler_);
  #line 158 "src/container/RaggedArray.birch"
    
    this->offsets.insert(nrows, nvalues + 1);
    this->sizes.insert(nrows, 0);
    }

#line 7 "src/container/RaggedArray.birch"
template<class Type>
#line 170 "src/container/RaggedArray.birch"
void birch::type::RaggedArray<Type>::pushBack(const birch::type::Integer& i, const Type& x, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_) {
  #line 170 "src/container/RaggedArray.birch"
  libbirch_function_("pushBack", "src/container/RaggedArray.birch", 170);
  #line 171 "src/container/RaggedArray.birch"
  libbirch_line_(171);
  #line 171 "src/container/RaggedArray.birch"
  auto j = this_()->offsets.get(libbirch::make_slice(i - 1)) + this_()->sizes.get(libbirch::make_slice(i - 1));
  #line 172 "src/container/RaggedArray.birch"

    this->values.insert(j - 1, x);
      #line 175 "src/container/RaggedArray.birch"
  libbirch_line_(175);
  #line 175 "src/container/RaggedArray.birch"
  for (auto k = (i + birch::type::Integer(1)); k <= this_()->size(handler_); ++k) {
    #line 176 "src/container/RaggedArray.birch"
    libbirch_line_(176);
    #line 176 "src/container/RaggedArray.birch"
    this_()->offsets.set(libbirch::make_slice(k - 1), this_()->offsets.get(libbirch::make_slice(k - 1)) + birch::type::Integer(1));
  }
  #line 178 "src/container/RaggedArray.birch"
  libbirch_line_(178);
  #line 178 "src/container/RaggedArray.birch"
  this_()->sizes.set(libbirch::make_slice(i - 1), this_()->sizes.get(libbirch::make_slice(i - 1)) + birch::type::Integer(1));
}

#line 7 "src/container/RaggedArray.birch"
template<class Type>
#line 185 "src/container/RaggedArray.birch"
Type birch::type::RaggedArray<Type>::pushBack(const birch::type::Integer& i, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_) {
  #line 185 "src/container/RaggedArray.birch"
  libbirch_function_("pushBack", "src/container/RaggedArray.birch", 185);
  #line 186 "src/container/RaggedArray.birch"
  libbirch_line_(186);
  #line 186 "src/container/RaggedArray.birch"
  auto x = birch::make<Type>(handler_);
  #line 187 "src/container/RaggedArray.birch"
  libbirch_line_(187);
  #line 187 "src/container/RaggedArray.birch"
  if (x.query()) {
    #line 188 "src/container/RaggedArray.birch"
    libbirch_line_(188);
    #line 188 "src/container/RaggedArray.birch"
    this_()->pushBack(i, x.get(), handler_);
  } else {
    #line 190 "src/container/RaggedArray.birch"
    libbirch_line_(190);
    #line 190 "src/container/RaggedArray.birch"
    birch::error(birch::type::String("not default constructible"), handler_);
  }
  #line 192 "src/container/RaggedArray.birch"
  libbirch_line_(192);
  #line 192 "src/container/RaggedArray.birch"
  return x.get();
}

#line 7 "src/container/RaggedArray.birch"
template<class Type>
#line 200 "src/container/RaggedArray.birch"
libbirch::Lazy<libbirch::Shared<birch::type::Iterator<libbirch::DefaultArray<Type,1>>>> birch::type::RaggedArray<Type>::walk(const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_) {
  #line 200 "src/container/RaggedArray.birch"
  libbirch_function_("walk", "src/container/RaggedArray.birch", 200);
  #line 201 "src/container/RaggedArray.birch"
  libbirch_line_(201);
  #line 201 "src/container/RaggedArray.birch"
  return birch::RaggedArrayRowIterator<Type>(shared_from_this_(), handler_);
}

#line 7 "src/container/RaggedArray.birch"
template<class Type>
#line 212 "src/container/RaggedArray.birch"
libbirch::Lazy<libbirch::Shared<birch::type::Iterator<Type>>> birch::type::RaggedArray<Type>::walk(const birch::type::Integer& i, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_) {
  #line 212 "src/container/RaggedArray.birch"
  libbirch_function_("walk", "src/container/RaggedArray.birch", 212);
  #line 213 "src/container/RaggedArray.birch"
  libbirch_line_(213);
  #line 213 "src/container/RaggedArray.birch"
  return birch::RaggedArrayElementIterator<Type>(shared_from_this_(), i, handler_);
}

#line 7 "src/container/RaggedArray.birch"
template<class Type>
#line 221 "src/container/RaggedArray.birch"
birch::type::Integer birch::type::RaggedArray<Type>::from(const birch::type::Integer& i, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_) {
  #line 221 "src/container/RaggedArray.birch"
  libbirch_function_("from", "src/container/RaggedArray.birch", 221);
  #line 222 "src/container/RaggedArray.birch"
  libbirch_line_(222);
  #line 222 "src/container/RaggedArray.birch"
  libbirch_assert_(birch::type::Integer(1) <= i && i <= this_()->size(handler_));
  #line 223 "src/container/RaggedArray.birch"
  libbirch_line_(223);
  #line 223 "src/container/RaggedArray.birch"
  libbirch_assert_(this_()->offsets.get(libbirch::make_slice(i - 1)) != birch::type::Integer(0));
  #line 224 "src/container/RaggedArray.birch"
  libbirch_line_(224);
  #line 224 "src/container/RaggedArray.birch"
  return this_()->offsets.get(libbirch::make_slice(i - 1));
}

#line 7 "src/container/RaggedArray.birch"
template<class Type>
#line 232 "src/container/RaggedArray.birch"
birch::type::Integer birch::type::RaggedArray<Type>::to(const birch::type::Integer& i, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_) {
  #line 232 "src/container/RaggedArray.birch"
  libbirch_function_("to", "src/container/RaggedArray.birch", 232);
  #line 233 "src/container/RaggedArray.birch"
  libbirch_line_(233);
  #line 233 "src/container/RaggedArray.birch"
  libbirch_assert_(birch::type::Integer(1) <= i && i <= this_()->size(handler_));
  #line 234 "src/container/RaggedArray.birch"
  libbirch_line_(234);
  #line 234 "src/container/RaggedArray.birch"
  libbirch_assert_(this_()->offsets.get(libbirch::make_slice(i - 1)) != birch::type::Integer(0));
  #line 235 "src/container/RaggedArray.birch"
  libbirch_line_(235);
  #line 235 "src/container/RaggedArray.birch"
  return this_()->offsets.get(libbirch::make_slice(i - 1)) + this_()->sizes.get(libbirch::make_slice(i - 1)) - birch::type::Integer(1);
}

#line 7 "src/container/RaggedArray.birch"
template<class Type>
#line 244 "src/container/RaggedArray.birch"
birch::type::Integer birch::type::RaggedArray<Type>::serial(const birch::type::Integer& i, const birch::type::Integer& j, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_) {
  #line 244 "src/container/RaggedArray.birch"
  libbirch_function_("serial", "src/container/RaggedArray.birch", 244);
  #line 245 "src/container/RaggedArray.birch"
  libbirch_line_(245);
  #line 245 "src/container/RaggedArray.birch"
  libbirch_assert_(birch::type::Integer(1) <= i && i <= this_()->size(handler_));
  #line 246 "src/container/RaggedArray.birch"
  libbirch_line_(246);
  #line 246 "src/container/RaggedArray.birch"
  libbirch_assert_(birch::type::Integer(1) <= j && j <= this_()->sizes.get(libbirch::make_slice(i - 1)));
  #line 247 "src/container/RaggedArray.birch"
  libbirch_line_(247);
  #line 247 "src/container/RaggedArray.birch"
  return this_()->from(i, handler_) + j - birch::type::Integer(1);
}

#line 7 "src/container/RaggedArray.birch"
template<class Type>
#line 250 "src/container/RaggedArray.birch"
void birch::type::RaggedArray<Type>::read(const libbirch::Lazy<libbirch::Shared<birch::type::Buffer>>& buffer, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_) {
  #line 250 "src/container/RaggedArray.birch"
  libbirch_function_("read", "src/container/RaggedArray.birch", 250);
  #line 251 "src/container/RaggedArray.birch"
  libbirch_line_(251);
  #line 251 "src/container/RaggedArray.birch"
  auto row = buffer->walk(handler_);
  #line 252 "src/container/RaggedArray.birch"
  libbirch_line_(252);
  #line 252 "src/container/RaggedArray.birch"
  while (row->hasNext(handler_)) {
    #line 253 "src/container/RaggedArray.birch"
    libbirch_line_(253);
    #line 253 "src/container/RaggedArray.birch"
    this_()->pushBack(handler_);
    #line 254 "src/container/RaggedArray.birch"
    libbirch_line_(254);
    #line 254 "src/container/RaggedArray.birch"
    auto col = row->next(handler_)->walk(handler_);
    #line 255 "src/container/RaggedArray.birch"
    libbirch_line_(255);
    #line 255 "src/container/RaggedArray.birch"
    while (col->hasNext(handler_)) {
      #line 257 "src/container/RaggedArray.birch"
      libbirch_line_(257);
      #line 257 "src/container/RaggedArray.birch"
      auto x = birch::make<Type>(handler_);
      #line 258 "src/container/RaggedArray.birch"
      libbirch_line_(258);
      #line 258 "src/container/RaggedArray.birch"
      auto y = col->next(handler_)->get(x, handler_);
      #line 259 "src/container/RaggedArray.birch"
      libbirch_line_(259);
      #line 259 "src/container/RaggedArray.birch"
      if (y.query()) {
        #line 260 "src/container/RaggedArray.birch"
        libbirch_line_(260);
        #line 260 "src/container/RaggedArray.birch"
        x = libbirch::cast<Type>(y);
        #line 261 "src/container/RaggedArray.birch"
        libbirch_line_(261);
        #line 261 "src/container/RaggedArray.birch"
        this_()->pushBack(this_()->size(handler_), x.get(), handler_);
      }
    }
  }
}

#line 7 "src/container/RaggedArray.birch"
template<class Type>
#line 267 "src/container/RaggedArray.birch"
void birch::type::RaggedArray<Type>::write(const libbirch::Lazy<libbirch::Shared<birch::type::Buffer>>& buffer, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_) {
  #line 267 "src/container/RaggedArray.birch"
  libbirch_function_("write", "src/container/RaggedArray.birch", 267);
  #line 268 "src/container/RaggedArray.birch"
  libbirch_line_(268);
  #line 268 "src/container/RaggedArray.birch"
  for (auto i = birch::type::Integer(1); i <= this_()->size(handler_); ++i) {
    #line 269 "src/container/RaggedArray.birch"
    libbirch_line_(269);
    #line 269 "src/container/RaggedArray.birch"
    buffer->push(this_()->get(i, handler_), handler_);
  }
}

#line 28 "src/container/Stack.birch"
template<class Type>
#line 28 "src/container/Stack.birch"
birch::type::Stack<Type>::Stack(const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_) :
    #line 28 "src/container/Stack.birch"
    super_type_(),
    #line 29 "src/container/Stack.birch"
    head(),
    #line 30 "src/container/Stack.birch"
    count(birch::type::Integer(0)) {
  //
}

#line 28 "src/container/Stack.birch"
template<class Type>
#line 35 "src/container/Stack.birch"
birch::type::Integer birch::type::Stack<Type>::size(const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_) {
  #line 35 "src/container/Stack.birch"
  libbirch_function_("size", "src/container/Stack.birch", 35);
  #line 36 "src/container/Stack.birch"
  libbirch_line_(36);
  #line 36 "src/container/Stack.birch"
  return this_()->count;
}

#line 28 "src/container/Stack.birch"
template<class Type>
#line 42 "src/container/Stack.birch"
birch::type::Boolean birch::type::Stack<Type>::empty(const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_) {
  #line 42 "src/container/Stack.birch"
  libbirch_function_("empty", "src/container/Stack.birch", 42);
  #line 43 "src/container/Stack.birch"
  libbirch_line_(43);
  #line 43 "src/container/Stack.birch"
  return this_()->count == birch::type::Integer(0);
}

#line 28 "src/container/Stack.birch"
template<class Type>
#line 49 "src/container/Stack.birch"
void birch::type::Stack<Type>::clear(const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_) {
  #line 49 "src/container/Stack.birch"
  libbirch_function_("clear", "src/container/Stack.birch", 49);
  #line 50 "src/container/Stack.birch"
  libbirch_line_(50);
  #line 50 "src/container/Stack.birch"
  this_()->head = libbirch::nil;
  #line 51 "src/container/Stack.birch"
  libbirch_line_(51);
  #line 51 "src/container/Stack.birch"
  this_()->count = birch::type::Integer(0);
}

#line 28 "src/container/Stack.birch"
template<class Type>
#line 57 "src/container/Stack.birch"
Type birch::type::Stack<Type>::top(const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_) {
  #line 57 "src/container/Stack.birch"
  libbirch_function_("top", "src/container/Stack.birch", 57);
  #line 58 "src/container/Stack.birch"
  libbirch_line_(58);
  #line 58 "src/container/Stack.birch"
  libbirch_assert_(this_()->head.query());
  #line 59 "src/container/Stack.birch"
  libbirch_line_(59);
  #line 59 "src/container/Stack.birch"
  return this_()->head.get()->x;
}

#line 28 "src/container/Stack.birch"
template<class Type>
#line 67 "src/container/Stack.birch"
void birch::type::Stack<Type>::push(const Type& x, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_) {
  #line 67 "src/container/Stack.birch"
  libbirch_function_("push", "src/container/Stack.birch", 67);
  #line 68 "src/container/Stack.birch"
  libbirch_line_(68);
  #line 68 "src/container/Stack.birch"
  libbirch::Lazy<libbirch::Shared<birch::type::StackNode<Type>>> node(x);
  #line 69 "src/container/Stack.birch"
  libbirch_line_(69);
  #line 69 "src/container/Stack.birch"
  node->next = this_()->head;
  #line 70 "src/container/Stack.birch"
  libbirch_line_(70);
  #line 70 "src/container/Stack.birch"
  this_()->head = node;
  #line 71 "src/container/Stack.birch"
  libbirch_line_(71);
  #line 71 "src/container/Stack.birch"
  this_()->count = this_()->count + birch::type::Integer(1);
}

#line 28 "src/container/Stack.birch"
template<class Type>
#line 77 "src/container/Stack.birch"
void birch::type::Stack<Type>::push(const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_) {
  #line 77 "src/container/Stack.birch"
  libbirch_function_("push", "src/container/Stack.birch", 77);
  #line 78 "src/container/Stack.birch"
  libbirch_line_(78);
  #line 78 "src/container/Stack.birch"
  auto x = birch::make<Type>(handler_);
  #line 79 "src/container/Stack.birch"
  libbirch_line_(79);
  #line 79 "src/container/Stack.birch"
  if (x.query()) {
    #line 80 "src/container/Stack.birch"
    libbirch_line_(80);
    #line 80 "src/container/Stack.birch"
    this_()->push(x.get(), handler_);
  } else {
    #line 82 "src/container/Stack.birch"
    libbirch_line_(82);
    #line 82 "src/container/Stack.birch"
    birch::error(birch::type::String("not default constructible"), handler_);
  }
  #line 84 "src/container/Stack.birch"
  libbirch_line_(84);
  #line 84 "src/container/Stack.birch"
  return x.get();
}

#line 28 "src/container/Stack.birch"
template<class Type>
#line 90 "src/container/Stack.birch"
void birch::type::Stack<Type>::pop(const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_) {
  #line 90 "src/container/Stack.birch"
  libbirch_function_("pop", "src/container/Stack.birch", 90);
  #line 91 "src/container/Stack.birch"
  libbirch_line_(91);
  #line 91 "src/container/Stack.birch"
  libbirch_assert_(this_()->head.query());
  #line 92 "src/container/Stack.birch"
  libbirch_line_(92);
  #line 92 "src/container/Stack.birch"
  this_()->head = this_()->head.get()->next;
  #line 93 "src/container/Stack.birch"
  libbirch_line_(93);
  #line 93 "src/container/Stack.birch"
  this_()->count = this_()->count - birch::type::Integer(1);
}

#line 28 "src/container/Stack.birch"
template<class Type>
#line 101 "src/container/Stack.birch"
libbirch::Lazy<libbirch::Shared<birch::type::Iterator<Type>>> birch::type::Stack<Type>::walk(const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_) {
  #line 101 "src/container/Stack.birch"
  libbirch_function_("walk", "src/container/Stack.birch", 101);
  #line 102 "src/container/Stack.birch"
  libbirch_line_(102);
  #line 102 "src/container/Stack.birch"
  return birch::StackIterator<Type>(this_()->head, handler_);
}

#line 4 "src/container/StackNode.birch"
template<class Type>
#line 4 "src/container/StackNode.birch"
birch::type::StackNode<Type>::StackNode(const Type& x, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_) :
    #line 4 "src/container/StackNode.birch"
    super_type_(),
    #line 5 "src/container/StackNode.birch"
    next(),
    #line 6 "src/container/StackNode.birch"
    x(x) {
  //
}

#line 46 "src/container/Tape.birch"
template<class Type>
#line 46 "src/container/Tape.birch"
birch::type::Tape<Type>::Tape(const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_) :
    #line 46 "src/container/Tape.birch"
    super_type_(),
    #line 50 "src/container/Tape.birch"
    ahead(),
    #line 55 "src/container/Tape.birch"
    aheadCount(birch::type::Integer(0)),
    #line 60 "src/container/Tape.birch"
    behind(),
    #line 65 "src/container/Tape.birch"
    behindCount(birch::type::Integer(0)) {
  //
}

#line 46 "src/container/Tape.birch"
template<class Type>
#line 70 "src/container/Tape.birch"
birch::type::Integer birch::type::Tape<Type>::size(const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_) {
  #line 70 "src/container/Tape.birch"
  libbirch_function_("size", "src/container/Tape.birch", 70);
  #line 71 "src/container/Tape.birch"
  libbirch_line_(71);
  #line 71 "src/container/Tape.birch"
  return this_()->aheadCount + this_()->behindCount;
}

#line 46 "src/container/Tape.birch"
template<class Type>
#line 77 "src/container/Tape.birch"
birch::type::Boolean birch::type::Tape<Type>::empty(const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_) {
  #line 77 "src/container/Tape.birch"
  libbirch_function_("empty", "src/container/Tape.birch", 77);
  #line 78 "src/container/Tape.birch"
  libbirch_line_(78);
  #line 78 "src/container/Tape.birch"
  return this_()->aheadCount == birch::type::Integer(0) && this_()->behindCount == birch::type::Integer(0);
}

#line 46 "src/container/Tape.birch"
template<class Type>
#line 84 "src/container/Tape.birch"
void birch::type::Tape<Type>::clear(const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_) {
  #line 84 "src/container/Tape.birch"
  libbirch_function_("clear", "src/container/Tape.birch", 84);
  #line 85 "src/container/Tape.birch"
  libbirch_line_(85);
  #line 85 "src/container/Tape.birch"
  this_()->ahead = libbirch::nil;
  #line 86 "src/container/Tape.birch"
  libbirch_line_(86);
  #line 86 "src/container/Tape.birch"
  this_()->behind = libbirch::nil;
  #line 87 "src/container/Tape.birch"
  libbirch_line_(87);
  #line 87 "src/container/Tape.birch"
  this_()->aheadCount = birch::type::Integer(0);
  #line 88 "src/container/Tape.birch"
  libbirch_line_(88);
  #line 88 "src/container/Tape.birch"
  this_()->behindCount = birch::type::Integer(0);
}

#line 46 "src/container/Tape.birch"
template<class Type>
#line 94 "src/container/Tape.birch"
Type birch::type::Tape<Type>::front(const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_) {
  #line 94 "src/container/Tape.birch"
  libbirch_function_("front", "src/container/Tape.birch", 94);
  #line 95 "src/container/Tape.birch"
  libbirch_line_(95);
  #line 95 "src/container/Tape.birch"
  libbirch_assert_(!this_()->empty(handler_));
  #line 96 "src/container/Tape.birch"
  libbirch_line_(96);
  #line 96 "src/container/Tape.birch"
  if (this_()->behind.query()) {
    #line 97 "src/container/Tape.birch"
    libbirch_line_(97);
    #line 97 "src/container/Tape.birch"
    return this_()->behind.get()->bottom(handler_)->x;
  } else {
    #line 99 "src/container/Tape.birch"
    libbirch_line_(99);
    #line 99 "src/container/Tape.birch"
    return this_()->ahead.get()->x;
  }
}

#line 46 "src/container/Tape.birch"
template<class Type>
#line 106 "src/container/Tape.birch"
Type birch::type::Tape<Type>::back(const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_) {
  #line 106 "src/container/Tape.birch"
  libbirch_function_("back", "src/container/Tape.birch", 106);
  #line 107 "src/container/Tape.birch"
  libbirch_line_(107);
  #line 107 "src/container/Tape.birch"
  libbirch_assert_(!this_()->empty(handler_));
  #line 108 "src/container/Tape.birch"
  libbirch_line_(108);
  #line 108 "src/container/Tape.birch"
  if (this_()->ahead.query()) {
    #line 109 "src/container/Tape.birch"
    libbirch_line_(109);
    #line 109 "src/container/Tape.birch"
    return this_()->ahead.get()->bottom(handler_)->x;
  } else {
    #line 111 "src/container/Tape.birch"
    libbirch_line_(111);
    #line 111 "src/container/Tape.birch"
    return this_()->behind.get()->x;
  }
}

#line 46 "src/container/Tape.birch"
template<class Type>
#line 125 "src/container/Tape.birch"
void birch::type::Tape<Type>::forward(const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_) {
  #line 125 "src/container/Tape.birch"
  libbirch_function_("forward", "src/container/Tape.birch", 125);
  #line 126 "src/container/Tape.birch"
  libbirch_line_(126);
  #line 126 "src/container/Tape.birch"
  if (!this_()->ahead.query()) {
    #line 127 "src/container/Tape.birch"
    libbirch_line_(127);
    #line 127 "src/container/Tape.birch"
    this_()->ahead = birch::TapeNode<Type>(handler_);
    #line 128 "src/container/Tape.birch"
    libbirch_line_(128);
    #line 128 "src/container/Tape.birch"
    this_()->aheadCount = this_()->aheadCount + birch::type::Integer(1);
  }
  #line 130 "src/container/Tape.birch"
  libbirch_line_(130);
  #line 130 "src/container/Tape.birch"
  auto node = this_()->ahead.get();
  #line 131 "src/container/Tape.birch"
  libbirch_line_(131);
  #line 131 "src/container/Tape.birch"
  this_()->ahead = node->next;
  #line 132 "src/container/Tape.birch"
  libbirch_line_(132);
  #line 132 "src/container/Tape.birch"
  node->next = this_()->behind;
  #line 133 "src/container/Tape.birch"
  libbirch_line_(133);
  #line 133 "src/container/Tape.birch"
  this_()->behind = node;
  #line 134 "src/container/Tape.birch"
  libbirch_line_(134);
  #line 134 "src/container/Tape.birch"
  this_()->aheadCount = this_()->aheadCount - birch::type::Integer(1);
  #line 135 "src/container/Tape.birch"
  libbirch_line_(135);
  #line 135 "src/container/Tape.birch"
  this_()->behindCount = this_()->behindCount + birch::type::Integer(1);
}

#line 46 "src/container/Tape.birch"
template<class Type>
#line 148 "src/container/Tape.birch"
void birch::type::Tape<Type>::backward(const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_) {
  #line 148 "src/container/Tape.birch"
  libbirch_function_("backward", "src/container/Tape.birch", 148);
  #line 149 "src/container/Tape.birch"
  libbirch_line_(149);
  #line 149 "src/container/Tape.birch"
  if (!this_()->behind.query()) {
    #line 150 "src/container/Tape.birch"
    libbirch_line_(150);
    #line 150 "src/container/Tape.birch"
    this_()->behind = birch::TapeNode<Type>(handler_);
    #line 151 "src/container/Tape.birch"
    libbirch_line_(151);
    #line 151 "src/container/Tape.birch"
    this_()->behindCount = this_()->behindCount + birch::type::Integer(1);
  }
  #line 153 "src/container/Tape.birch"
  libbirch_line_(153);
  #line 153 "src/container/Tape.birch"
  auto node = this_()->behind.get();
  #line 154 "src/container/Tape.birch"
  libbirch_line_(154);
  #line 154 "src/container/Tape.birch"
  this_()->behind = node->next;
  #line 155 "src/container/Tape.birch"
  libbirch_line_(155);
  #line 155 "src/container/Tape.birch"
  node->next = this_()->ahead;
  #line 156 "src/container/Tape.birch"
  libbirch_line_(156);
  #line 156 "src/container/Tape.birch"
  this_()->ahead = node;
  #line 157 "src/container/Tape.birch"
  libbirch_line_(157);
  #line 157 "src/container/Tape.birch"
  this_()->aheadCount = this_()->aheadCount + birch::type::Integer(1);
  #line 158 "src/container/Tape.birch"
  libbirch_line_(158);
  #line 158 "src/container/Tape.birch"
  this_()->behindCount = this_()->behindCount - birch::type::Integer(1);
}

#line 46 "src/container/Tape.birch"
template<class Type>
#line 164 "src/container/Tape.birch"
void birch::type::Tape<Type>::rewind(const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_) {
  #line 164 "src/container/Tape.birch"
  libbirch_function_("rewind", "src/container/Tape.birch", 164);
  #line 165 "src/container/Tape.birch"
  libbirch_line_(165);
  #line 165 "src/container/Tape.birch"
  while (this_()->behind.query()) {
    #line 166 "src/container/Tape.birch"
    libbirch_line_(166);
    #line 166 "src/container/Tape.birch"
    this_()->backward(handler_);
  }
}

#line 46 "src/container/Tape.birch"
template<class Type>
#line 173 "src/container/Tape.birch"
void birch::type::Tape<Type>::fastForward(const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_) {
  #line 173 "src/container/Tape.birch"
  libbirch_function_("fastForward", "src/container/Tape.birch", 173);
  #line 174 "src/container/Tape.birch"
  libbirch_line_(174);
  #line 174 "src/container/Tape.birch"
  while (this_()->ahead.query()) {
    #line 175 "src/container/Tape.birch"
    libbirch_line_(175);
    #line 175 "src/container/Tape.birch"
    this_()->forward(handler_);
  }
}

#line 46 "src/container/Tape.birch"
template<class Type>
#line 188 "src/container/Tape.birch"
void birch::type::Tape<Type>::seek(const birch::type::Integer& k, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_) {
  #line 188 "src/container/Tape.birch"
  libbirch_function_("seek", "src/container/Tape.birch", 188);
  #line 189 "src/container/Tape.birch"
  libbirch_line_(189);
  #line 189 "src/container/Tape.birch"
  if (k > birch::type::Integer(0)) {
    #line 190 "src/container/Tape.birch"
    libbirch_line_(190);
    #line 190 "src/container/Tape.birch"
    for (auto i = birch::type::Integer(1); i <= k; ++i) {
      #line 191 "src/container/Tape.birch"
      libbirch_line_(191);
      #line 191 "src/container/Tape.birch"
      this_()->forward(handler_);
    }
  } else {
    #line 193 "src/container/Tape.birch"
    libbirch_line_(193);
    #line 193 "src/container/Tape.birch"
    if (k < birch::type::Integer(0)) {
      #line 194 "src/container/Tape.birch"
      libbirch_line_(194);
      #line 194 "src/container/Tape.birch"
      for (auto i = birch::type::Integer(1); i <= birch::abs(k, handler_); ++i) {
        #line 195 "src/container/Tape.birch"
        libbirch_line_(195);
        #line 195 "src/container/Tape.birch"
        this_()->backward(handler_);
      }
    }
  }
}

#line 46 "src/container/Tape.birch"
template<class Type>
#line 210 "src/container/Tape.birch"
Type birch::type::Tape<Type>::current(const birch::type::Integer& k, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_) {
  #line 210 "src/container/Tape.birch"
  libbirch_function_("current", "src/container/Tape.birch", 210);
  #line 211 "src/container/Tape.birch"
  libbirch_line_(211);
  #line 211 "src/container/Tape.birch"
  if (k >= birch::type::Integer(0)) {
    #line 212 "src/container/Tape.birch"
    libbirch_line_(212);
    #line 212 "src/container/Tape.birch"
    if (!this_()->ahead.query()) {
      #line 213 "src/container/Tape.birch"
      libbirch_line_(213);
      #line 213 "src/container/Tape.birch"
      this_()->ahead = birch::TapeNode<Type>(handler_);
      #line 214 "src/container/Tape.birch"
      libbirch_line_(214);
      #line 214 "src/container/Tape.birch"
      this_()->aheadCount = this_()->aheadCount + birch::type::Integer(1);
    }
    #line 216 "src/container/Tape.birch"
    libbirch_line_(216);
    #line 216 "src/container/Tape.birch"
    return this_()->ahead.get()->down(k, handler_)->x;
  } else {
    #line 218 "src/container/Tape.birch"
    libbirch_line_(218);
    #line 218 "src/container/Tape.birch"
    if (!this_()->behind.query()) {
      #line 219 "src/container/Tape.birch"
      libbirch_line_(219);
      #line 219 "src/container/Tape.birch"
      this_()->behind = birch::TapeNode<Type>(handler_);
      #line 220 "src/container/Tape.birch"
      libbirch_line_(220);
      #line 220 "src/container/Tape.birch"
      this_()->behindCount = this_()->behindCount + birch::type::Integer(1);
    }
    #line 222 "src/container/Tape.birch"
    libbirch_line_(222);
    #line 222 "src/container/Tape.birch"
    return this_()->behind.get()->down(birch::abs(k, handler_) - birch::type::Integer(1), handler_)->x;
  }
}

#line 46 "src/container/Tape.birch"
template<class Type>
#line 229 "src/container/Tape.birch"
Type birch::type::Tape<Type>::current(const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_) {
  #line 229 "src/container/Tape.birch"
  libbirch_function_("current", "src/container/Tape.birch", 229);
  #line 230 "src/container/Tape.birch"
  libbirch_line_(230);
  #line 230 "src/container/Tape.birch"
  if (!this_()->ahead.query()) {
    #line 231 "src/container/Tape.birch"
    libbirch_line_(231);
    #line 231 "src/container/Tape.birch"
    this_()->ahead = birch::TapeNode<Type>(handler_);
    #line 232 "src/container/Tape.birch"
    libbirch_line_(232);
    #line 232 "src/container/Tape.birch"
    this_()->aheadCount = this_()->aheadCount + birch::type::Integer(1);
  }
  #line 234 "src/container/Tape.birch"
  libbirch_line_(234);
  #line 234 "src/container/Tape.birch"
  return this_()->ahead.get()->x;
}

#line 46 "src/container/Tape.birch"
template<class Type>
#line 240 "src/container/Tape.birch"
Type birch::type::Tape<Type>::previous(const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_) {
  #line 240 "src/container/Tape.birch"
  libbirch_function_("previous", "src/container/Tape.birch", 240);
  #line 241 "src/container/Tape.birch"
  libbirch_line_(241);
  #line 241 "src/container/Tape.birch"
  if (!this_()->behind.query()) {
    #line 242 "src/container/Tape.birch"
    libbirch_line_(242);
    #line 242 "src/container/Tape.birch"
    this_()->behind = birch::TapeNode<Type>(handler_);
    #line 243 "src/container/Tape.birch"
    libbirch_line_(243);
    #line 243 "src/container/Tape.birch"
    this_()->behindCount = this_()->behindCount + birch::type::Integer(1);
  }
  #line 245 "src/container/Tape.birch"
  libbirch_line_(245);
  #line 245 "src/container/Tape.birch"
  return this_()->behind.get()->x;
}

#line 46 "src/container/Tape.birch"
template<class Type>
#line 251 "src/container/Tape.birch"
Type birch::type::Tape<Type>::next(const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_) {
  #line 251 "src/container/Tape.birch"
  libbirch_function_("next", "src/container/Tape.birch", 251);
  #line 252 "src/container/Tape.birch"
  libbirch_line_(252);
  #line 252 "src/container/Tape.birch"
  return this_()->current(+birch::type::Integer(1), handler_);
}

#line 46 "src/container/Tape.birch"
template<class Type>
#line 260 "src/container/Tape.birch"
void birch::type::Tape<Type>::pushFront(const Type& x, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_) {
  #line 260 "src/container/Tape.birch"
  libbirch_function_("pushFront", "src/container/Tape.birch", 260);
  #line 261 "src/container/Tape.birch"
  libbirch_line_(261);
  #line 261 "src/container/Tape.birch"
  if (this_()->behind.query()) {
    #line 262 "src/container/Tape.birch"
    libbirch_line_(262);
    #line 262 "src/container/Tape.birch"
    this_()->behind.get()->bottom(handler_)->next = birch::TapeNode<Type>(x, handler_);
  } else {
    #line 264 "src/container/Tape.birch"
    libbirch_line_(264);
    #line 264 "src/container/Tape.birch"
    this_()->behind = birch::TapeNode<Type>(x, handler_);
  }
  #line 266 "src/container/Tape.birch"
  libbirch_line_(266);
  #line 266 "src/container/Tape.birch"
  this_()->behindCount = this_()->behindCount + birch::type::Integer(1);
}

#line 46 "src/container/Tape.birch"
template<class Type>
#line 272 "src/container/Tape.birch"
void birch::type::Tape<Type>::pushFront(const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_) {
  #line 272 "src/container/Tape.birch"
  libbirch_function_("pushFront", "src/container/Tape.birch", 272);
  #line 273 "src/container/Tape.birch"
  libbirch_line_(273);
  #line 273 "src/container/Tape.birch"
  if (this_()->behind.query()) {
    #line 274 "src/container/Tape.birch"
    libbirch_line_(274);
    #line 274 "src/container/Tape.birch"
    this_()->behind.get()->bottom(handler_)->next = birch::TapeNode<Type>(handler_);
  } else {
    #line 276 "src/container/Tape.birch"
    libbirch_line_(276);
    #line 276 "src/container/Tape.birch"
    this_()->behind = birch::TapeNode<Type>(handler_);
  }
  #line 278 "src/container/Tape.birch"
  libbirch_line_(278);
  #line 278 "src/container/Tape.birch"
  this_()->behindCount = this_()->behindCount + birch::type::Integer(1);
}

#line 46 "src/container/Tape.birch"
template<class Type>
#line 286 "src/container/Tape.birch"
void birch::type::Tape<Type>::pushBack(const Type& x, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_) {
  #line 286 "src/container/Tape.birch"
  libbirch_function_("pushBack", "src/container/Tape.birch", 286);
  #line 287 "src/container/Tape.birch"
  libbirch_line_(287);
  #line 287 "src/container/Tape.birch"
  if (this_()->ahead.query()) {
    #line 288 "src/container/Tape.birch"
    libbirch_line_(288);
    #line 288 "src/container/Tape.birch"
    this_()->ahead.get()->bottom(handler_)->next = birch::TapeNode<Type>(x, handler_);
  } else {
    #line 290 "src/container/Tape.birch"
    libbirch_line_(290);
    #line 290 "src/container/Tape.birch"
    this_()->ahead = birch::TapeNode<Type>(x, handler_);
  }
  #line 292 "src/container/Tape.birch"
  libbirch_line_(292);
  #line 292 "src/container/Tape.birch"
  this_()->aheadCount = this_()->aheadCount + birch::type::Integer(1);
}

#line 46 "src/container/Tape.birch"
template<class Type>
#line 298 "src/container/Tape.birch"
void birch::type::Tape<Type>::pushBack(const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_) {
  #line 298 "src/container/Tape.birch"
  libbirch_function_("pushBack", "src/container/Tape.birch", 298);
  #line 299 "src/container/Tape.birch"
  libbirch_line_(299);
  #line 299 "src/container/Tape.birch"
  if (this_()->ahead.query()) {
    #line 300 "src/container/Tape.birch"
    libbirch_line_(300);
    #line 300 "src/container/Tape.birch"
    this_()->ahead.get()->bottom(handler_)->next = birch::TapeNode<Type>(handler_);
  } else {
    #line 302 "src/container/Tape.birch"
    libbirch_line_(302);
    #line 302 "src/container/Tape.birch"
    this_()->ahead = birch::TapeNode<Type>(handler_);
  }
  #line 304 "src/container/Tape.birch"
  libbirch_line_(304);
  #line 304 "src/container/Tape.birch"
  this_()->aheadCount = this_()->aheadCount + birch::type::Integer(1);
}

#line 46 "src/container/Tape.birch"
template<class Type>
#line 312 "src/container/Tape.birch"
void birch::type::Tape<Type>::popFront(const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_) {
  #line 312 "src/container/Tape.birch"
  libbirch_function_("popFront", "src/container/Tape.birch", 312);
  #line 313 "src/container/Tape.birch"
  libbirch_line_(313);
  #line 313 "src/container/Tape.birch"
  libbirch_assert_(!this_()->empty(handler_));
  #line 314 "src/container/Tape.birch"
  libbirch_line_(314);
  #line 314 "src/container/Tape.birch"
  if (this_()->behind.query()) {
    #line 315 "src/container/Tape.birch"
    libbirch_line_(315);
    #line 315 "src/container/Tape.birch"
    if (this_()->behind.get()->next.query()) {
      #line 316 "src/container/Tape.birch"
      libbirch_line_(316);
      #line 316 "src/container/Tape.birch"
      this_()->behind.get()->popBottom(handler_);
    } else {
      #line 318 "src/container/Tape.birch"
      libbirch_line_(318);
      #line 318 "src/container/Tape.birch"
      this_()->behind = libbirch::nil;
    }
    #line 320 "src/container/Tape.birch"
    libbirch_line_(320);
    #line 320 "src/container/Tape.birch"
    this_()->behindCount = this_()->behindCount - birch::type::Integer(1);
  } else {
    #line 322 "src/container/Tape.birch"
    libbirch_line_(322);
    #line 322 "src/container/Tape.birch"
    this_()->erase(handler_);
  }
}

#line 46 "src/container/Tape.birch"
template<class Type>
#line 331 "src/container/Tape.birch"
void birch::type::Tape<Type>::popBack(const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_) {
  #line 331 "src/container/Tape.birch"
  libbirch_function_("popBack", "src/container/Tape.birch", 331);
  #line 332 "src/container/Tape.birch"
  libbirch_line_(332);
  #line 332 "src/container/Tape.birch"
  libbirch_assert_(!this_()->empty(handler_));
  #line 333 "src/container/Tape.birch"
  libbirch_line_(333);
  #line 333 "src/container/Tape.birch"
  if (this_()->ahead.query()) {
    #line 334 "src/container/Tape.birch"
    libbirch_line_(334);
    #line 334 "src/container/Tape.birch"
    if (this_()->ahead.get()->next.query()) {
      #line 335 "src/container/Tape.birch"
      libbirch_line_(335);
      #line 335 "src/container/Tape.birch"
      this_()->ahead.get()->popBottom(handler_);
    } else {
      #line 337 "src/container/Tape.birch"
      libbirch_line_(337);
      #line 337 "src/container/Tape.birch"
      this_()->ahead = libbirch::nil;
    }
    #line 339 "src/container/Tape.birch"
    libbirch_line_(339);
    #line 339 "src/container/Tape.birch"
    this_()->aheadCount = this_()->aheadCount - birch::type::Integer(1);
  } else {
    #line 341 "src/container/Tape.birch"
    libbirch_line_(341);
    #line 341 "src/container/Tape.birch"
    this_()->eraseBefore(handler_);
  }
}

#line 46 "src/container/Tape.birch"
template<class Type>
#line 351 "src/container/Tape.birch"
void birch::type::Tape<Type>::insert(const Type& x, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_) {
  #line 351 "src/container/Tape.birch"
  libbirch_function_("insert", "src/container/Tape.birch", 351);
  #line 352 "src/container/Tape.birch"
  libbirch_line_(352);
  #line 352 "src/container/Tape.birch"
  auto node = birch::TapeNode<Type>(x, handler_);
  #line 353 "src/container/Tape.birch"
  libbirch_line_(353);
  #line 353 "src/container/Tape.birch"
  node->next = this_()->ahead;
  #line 354 "src/container/Tape.birch"
  libbirch_line_(354);
  #line 354 "src/container/Tape.birch"
  this_()->ahead = node;
  #line 355 "src/container/Tape.birch"
  libbirch_line_(355);
  #line 355 "src/container/Tape.birch"
  this_()->aheadCount = this_()->aheadCount + birch::type::Integer(1);
}

#line 46 "src/container/Tape.birch"
template<class Type>
#line 362 "src/container/Tape.birch"
void birch::type::Tape<Type>::insert(const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_) {
  #line 362 "src/container/Tape.birch"
  libbirch_function_("insert", "src/container/Tape.birch", 362);
  #line 363 "src/container/Tape.birch"
  libbirch_line_(363);
  #line 363 "src/container/Tape.birch"
  auto node = birch::TapeNode<Type>(handler_);
  #line 364 "src/container/Tape.birch"
  libbirch_line_(364);
  #line 364 "src/container/Tape.birch"
  node->next = this_()->ahead;
  #line 365 "src/container/Tape.birch"
  libbirch_line_(365);
  #line 365 "src/container/Tape.birch"
  this_()->ahead = node;
  #line 366 "src/container/Tape.birch"
  libbirch_line_(366);
  #line 366 "src/container/Tape.birch"
  this_()->aheadCount = this_()->aheadCount + birch::type::Integer(1);
}

#line 46 "src/container/Tape.birch"
template<class Type>
#line 375 "src/container/Tape.birch"
void birch::type::Tape<Type>::insertBefore(const Type& x, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_) {
  #line 375 "src/container/Tape.birch"
  libbirch_function_("insertBefore", "src/container/Tape.birch", 375);
  #line 376 "src/container/Tape.birch"
  libbirch_line_(376);
  #line 376 "src/container/Tape.birch"
  auto node = birch::TapeNode<Type>(x, handler_);
  #line 377 "src/container/Tape.birch"
  libbirch_line_(377);
  #line 377 "src/container/Tape.birch"
  node->next = this_()->behind;
  #line 378 "src/container/Tape.birch"
  libbirch_line_(378);
  #line 378 "src/container/Tape.birch"
  this_()->behind = node;
  #line 379 "src/container/Tape.birch"
  libbirch_line_(379);
  #line 379 "src/container/Tape.birch"
  this_()->behindCount = this_()->behindCount + birch::type::Integer(1);
}

#line 46 "src/container/Tape.birch"
template<class Type>
#line 386 "src/container/Tape.birch"
void birch::type::Tape<Type>::insertBefore(const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_) {
  #line 386 "src/container/Tape.birch"
  libbirch_function_("insertBefore", "src/container/Tape.birch", 386);
  #line 387 "src/container/Tape.birch"
  libbirch_line_(387);
  #line 387 "src/container/Tape.birch"
  auto node = birch::TapeNode<Type>(handler_);
  #line 388 "src/container/Tape.birch"
  libbirch_line_(388);
  #line 388 "src/container/Tape.birch"
  node->next = this_()->behind;
  #line 389 "src/container/Tape.birch"
  libbirch_line_(389);
  #line 389 "src/container/Tape.birch"
  this_()->behind = node;
  #line 390 "src/container/Tape.birch"
  libbirch_line_(390);
  #line 390 "src/container/Tape.birch"
  this_()->behindCount = this_()->behindCount + birch::type::Integer(1);
}

#line 46 "src/container/Tape.birch"
template<class Type>
#line 397 "src/container/Tape.birch"
void birch::type::Tape<Type>::erase(const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_) {
  #line 397 "src/container/Tape.birch"
  libbirch_function_("erase", "src/container/Tape.birch", 397);
  #line 398 "src/container/Tape.birch"
  libbirch_line_(398);
  #line 398 "src/container/Tape.birch"
  this_()->ahead = this_()->ahead.get()->next;
}

#line 46 "src/container/Tape.birch"
template<class Type>
#line 405 "src/container/Tape.birch"
void birch::type::Tape<Type>::eraseBefore(const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_) {
  #line 405 "src/container/Tape.birch"
  libbirch_function_("eraseBefore", "src/container/Tape.birch", 405);
  #line 406 "src/container/Tape.birch"
  libbirch_line_(406);
  #line 406 "src/container/Tape.birch"
  this_()->behind = this_()->behind.get()->next;
}

#line 46 "src/container/Tape.birch"
template<class Type>
#line 414 "src/container/Tape.birch"
libbirch::Lazy<libbirch::Shared<birch::type::Iterator<Type>>> birch::type::Tape<Type>::walk(const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_) {
  #line 414 "src/container/Tape.birch"
  libbirch_function_("walk", "src/container/Tape.birch", 414);
  #line 415 "src/container/Tape.birch"
  libbirch_line_(415);
  #line 415 "src/container/Tape.birch"
  this_()->rewind(handler_);
  #line 416 "src/container/Tape.birch"
  libbirch_line_(416);
  #line 416 "src/container/Tape.birch"
  return birch::TapeIterator<Type>(this_()->ahead, handler_);
}

#line 46 "src/container/Tape.birch"
template<class Type>
#line 419 "src/container/Tape.birch"
void birch::type::Tape<Type>::read(const libbirch::Lazy<libbirch::Shared<birch::type::Buffer>>& buffer, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_) {
  #line 419 "src/container/Tape.birch"
  libbirch_function_("read", "src/container/Tape.birch", 419);
  #line 420 "src/container/Tape.birch"
  libbirch_line_(420);
  #line 420 "src/container/Tape.birch"
  this_()->clear(handler_);
  #line 421 "src/container/Tape.birch"
  libbirch_line_(421);
  #line 421 "src/container/Tape.birch"
  auto iter = buffer->walk(handler_);
  #line 422 "src/container/Tape.birch"
  libbirch_line_(422);
  #line 422 "src/container/Tape.birch"
  while (iter->hasNext(handler_)) {
    #line 424 "src/container/Tape.birch"
    libbirch_line_(424);
    #line 424 "src/container/Tape.birch"
    auto x = birch::make<Type>(handler_);
    #line 425 "src/container/Tape.birch"
    libbirch_line_(425);
    #line 425 "src/container/Tape.birch"
    auto y = iter->next(handler_)->get(x, handler_);
    #line 426 "src/container/Tape.birch"
    libbirch_line_(426);
    #line 426 "src/container/Tape.birch"
    if (y.query()) {
      #line 427 "src/container/Tape.birch"
      libbirch_line_(427);
      #line 427 "src/container/Tape.birch"
      x = libbirch::cast<Type>(y);
      #line 428 "src/container/Tape.birch"
      libbirch_line_(428);
      #line 428 "src/container/Tape.birch"
      this_()->pushBack(x.get(), handler_);
    }
  }
  #line 431 "src/container/Tape.birch"
  libbirch_line_(431);
  #line 431 "src/container/Tape.birch"
  this_()->rewind(handler_);
}

#line 46 "src/container/Tape.birch"
template<class Type>
#line 434 "src/container/Tape.birch"
void birch::type::Tape<Type>::write(const libbirch::Lazy<libbirch::Shared<birch::type::Buffer>>& buffer, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_) {
  #line 434 "src/container/Tape.birch"
  libbirch_function_("write", "src/container/Tape.birch", 434);
  #line 435 "src/container/Tape.birch"
  libbirch_line_(435);
  #line 435 "src/container/Tape.birch"
  auto iter = this_()->walk(handler_);
  #line 436 "src/container/Tape.birch"
  libbirch_line_(436);
  #line 436 "src/container/Tape.birch"
  while (iter->hasNext(handler_)) {
    #line 437 "src/container/Tape.birch"
    libbirch_line_(437);
    #line 437 "src/container/Tape.birch"
    buffer->push(iter->next(handler_), handler_);
  }
}

#line 4 "src/container/TapeNode.birch"
template<class Type>
#line 4 "src/container/TapeNode.birch"
birch::type::TapeNode<Type>::TapeNode(const Type& x, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_) :
    #line 4 "src/container/TapeNode.birch"
    super_type_(),
    #line 5 "src/container/TapeNode.birch"
    next(),
    #line 6 "src/container/TapeNode.birch"
    x(x) {
  //
}

#line 4 "src/container/TapeNode.birch"
template<class Type>
#line 12 "src/container/TapeNode.birch"
libbirch::Lazy<libbirch::Shared<birch::type::TapeNode<Type>>> birch::type::TapeNode<Type>::down(const birch::type::Integer& k, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_) {
  #line 12 "src/container/TapeNode.birch"
  libbirch_function_("down", "src/container/TapeNode.birch", 12);
  #line 13 "src/container/TapeNode.birch"
  libbirch_line_(13);
  #line 13 "src/container/TapeNode.birch"
  auto node = shared_from_this_();
  #line 14 "src/container/TapeNode.birch"
  libbirch_line_(14);
  #line 14 "src/container/TapeNode.birch"
  for (auto i = birch::type::Integer(1); i <= k; ++i) {
    #line 15 "src/container/TapeNode.birch"
    libbirch_line_(15);
    #line 15 "src/container/TapeNode.birch"
    if (!node->next.query()) {
      #line 16 "src/container/TapeNode.birch"
      libbirch_line_(16);
      #line 16 "src/container/TapeNode.birch"
      node->next = birch::TapeNode<Type>(handler_);
    }
    #line 18 "src/container/TapeNode.birch"
    libbirch_line_(18);
    #line 18 "src/container/TapeNode.birch"
    node = node->next.get();
  }
  #line 20 "src/container/TapeNode.birch"
  libbirch_line_(20);
  #line 20 "src/container/TapeNode.birch"
  return node;
}

#line 4 "src/container/TapeNode.birch"
template<class Type>
#line 26 "src/container/TapeNode.birch"
libbirch::Lazy<libbirch::Shared<birch::type::TapeNode<Type>>> birch::type::TapeNode<Type>::bottom(const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_) {
  #line 26 "src/container/TapeNode.birch"
  libbirch_function_("bottom", "src/container/TapeNode.birch", 26);
  #line 27 "src/container/TapeNode.birch"
  libbirch_line_(27);
  #line 27 "src/container/TapeNode.birch"
  auto node = shared_from_this_();
  #line 28 "src/container/TapeNode.birch"
  libbirch_line_(28);
  #line 28 "src/container/TapeNode.birch"
  while (node->next.query()) {
    #line 29 "src/container/TapeNode.birch"
    libbirch_line_(29);
    #line 29 "src/container/TapeNode.birch"
    node = node->next.get();
  }
  #line 31 "src/container/TapeNode.birch"
  libbirch_line_(31);
  #line 31 "src/container/TapeNode.birch"
  return node;
}

#line 4 "src/container/TapeNode.birch"
template<class Type>
#line 37 "src/container/TapeNode.birch"
void birch::type::TapeNode<Type>::popBottom(const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_) {
  #line 37 "src/container/TapeNode.birch"
  libbirch_function_("popBottom", "src/container/TapeNode.birch", 37);
  #line 38 "src/container/TapeNode.birch"
  libbirch_line_(38);
  #line 38 "src/container/TapeNode.birch"
  libbirch_assert_(this_()->next.query());
  #line 39 "src/container/TapeNode.birch"
  libbirch_line_(39);
  #line 39 "src/container/TapeNode.birch"
  auto node = shared_from_this_();
  #line 40 "src/container/TapeNode.birch"
  libbirch_line_(40);
  #line 40 "src/container/TapeNode.birch"
  while (node->next.get()->next.query()) {
    #line 41 "src/container/TapeNode.birch"
    libbirch_line_(41);
    #line 41 "src/container/TapeNode.birch"
    node = node->next.get();
  }
  #line 43 "src/container/TapeNode.birch"
  libbirch_line_(43);
  #line 43 "src/container/TapeNode.birch"
  node->next = libbirch::nil;
}

#line 6 "src/distribution/Distribution.birch"
template<class Value>
#line 6 "src/distribution/Distribution.birch"
birch::type::Distribution<Value>::Distribution(const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_) :
    #line 6 "src/distribution/Distribution.birch"
    super_type_(),
    #line 11 "src/distribution/Distribution.birch"
    x() {
  //
}

#line 6 "src/distribution/Distribution.birch"
template<class Value>
#line 16 "src/distribution/Distribution.birch"
birch::type::Integer birch::type::Distribution<Value>::rows(const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_) {
  #line 16 "src/distribution/Distribution.birch"
  libbirch_function_("rows", "src/distribution/Distribution.birch", 16);
  #line 17 "src/distribution/Distribution.birch"
  libbirch_line_(17);
  #line 17 "src/distribution/Distribution.birch"
  return birch::type::Integer(1);
}

#line 6 "src/distribution/Distribution.birch"
template<class Value>
#line 23 "src/distribution/Distribution.birch"
birch::type::Integer birch::type::Distribution<Value>::columns(const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_) {
  #line 23 "src/distribution/Distribution.birch"
  libbirch_function_("columns", "src/distribution/Distribution.birch", 23);
  #line 24 "src/distribution/Distribution.birch"
  libbirch_line_(24);
  #line 24 "src/distribution/Distribution.birch"
  return birch::type::Integer(1);
}

#line 6 "src/distribution/Distribution.birch"
template<class Value>
#line 30 "src/distribution/Distribution.birch"
birch::type::Boolean birch::type::Distribution<Value>::supportsLazy(const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_) {
  #line 30 "src/distribution/Distribution.birch"
  libbirch_function_("supportsLazy", "src/distribution/Distribution.birch", 30);
  #line 31 "src/distribution/Distribution.birch"
  libbirch_line_(31);
  #line 31 "src/distribution/Distribution.birch"
  return false;
}

#line 6 "src/distribution/Distribution.birch"
template<class Value>
#line 37 "src/distribution/Distribution.birch"
libbirch::Lazy<libbirch::Shared<birch::type::Distribution<Value>>> birch::type::Distribution<Value>::distribution(const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_) {
  #line 37 "src/distribution/Distribution.birch"
  libbirch_function_("distribution", "src/distribution/Distribution.birch", 37);
  #line 38 "src/distribution/Distribution.birch"
  libbirch_line_(38);
  #line 38 "src/distribution/Distribution.birch"
  return shared_from_this_();
}

#line 6 "src/distribution/Distribution.birch"
template<class Value>
#line 44 "src/distribution/Distribution.birch"
void birch::type::Distribution<Value>::setRandom(const libbirch::Lazy<libbirch::Shared<birch::type::Random<Value>>>& x, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_) {
  #line 44 "src/distribution/Distribution.birch"
  libbirch_function_("setRandom", "src/distribution/Distribution.birch", 44);
  #line 45 "src/distribution/Distribution.birch"
  libbirch_line_(45);
  #line 45 "src/distribution/Distribution.birch"
  libbirch_assert_(!this_()->x.query());
  #line 46 "src/distribution/Distribution.birch"
  libbirch_line_(46);
  #line 46 "src/distribution/Distribution.birch"
  this_()->x = x;
}

#line 6 "src/distribution/Distribution.birch"
template<class Value>
#line 52 "src/distribution/Distribution.birch"
void birch::type::Distribution<Value>::unsetRandom(const libbirch::Lazy<libbirch::Shared<birch::type::Random<Value>>>& x, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_) {
  #line 52 "src/distribution/Distribution.birch"
  libbirch_function_("unsetRandom", "src/distribution/Distribution.birch", 52);
  #line 53 "src/distribution/Distribution.birch"
  libbirch_line_(53);
  #line 53 "src/distribution/Distribution.birch"
  libbirch_assert_(this_()->x.query() && this_()->x.get() == x);
  #line 54 "src/distribution/Distribution.birch"
  libbirch_line_(54);
  #line 54 "src/distribution/Distribution.birch"
  this_()->x = libbirch::nil;
}

#line 6 "src/distribution/Distribution.birch"
template<class Value>
#line 60 "src/distribution/Distribution.birch"
void birch::type::Distribution<Value>::realize(const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_) {
  #line 60 "src/distribution/Distribution.birch"
  libbirch_function_("realize", "src/distribution/Distribution.birch", 60);
  #line 61 "src/distribution/Distribution.birch"
  libbirch_line_(61);
  #line 61 "src/distribution/Distribution.birch"
  if (this_()->supportsLazy(handler_)) {
    #line 62 "src/distribution/Distribution.birch"
    libbirch_line_(62);
    #line 62 "src/distribution/Distribution.birch"
    this_()->x.get()->get(handler_);
  } else {
    #line 64 "src/distribution/Distribution.birch"
    libbirch_line_(64);
    #line 64 "src/distribution/Distribution.birch"
    this_()->x.get()->value(handler_);
  }
}

#line 6 "src/distribution/Distribution.birch"
template<class Value>
#line 73 "src/distribution/Distribution.birch"
Value birch::type::Distribution<Value>::value(const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_) {
  #line 73 "src/distribution/Distribution.birch"
  libbirch_function_("value", "src/distribution/Distribution.birch", 73);
  #line 74 "src/distribution/Distribution.birch"
  libbirch_line_(74);
  #line 74 "src/distribution/Distribution.birch"
  this_()->prune(handler_);
  #line 75 "src/distribution/Distribution.birch"
  libbirch_line_(75);
  #line 75 "src/distribution/Distribution.birch"
  auto x = this_()->simulate(handler_);
  #line 76 "src/distribution/Distribution.birch"
  libbirch_line_(76);
  #line 76 "src/distribution/Distribution.birch"
  this_()->update(x, handler_);
  #line 77 "src/distribution/Distribution.birch"
  libbirch_line_(77);
  #line 77 "src/distribution/Distribution.birch"
  this_()->unlink(handler_);
  #line 78 "src/distribution/Distribution.birch"
  libbirch_line_(78);
  #line 78 "src/distribution/Distribution.birch"
  return x;
}

#line 6 "src/distribution/Distribution.birch"
template<class Value>
#line 86 "src/distribution/Distribution.birch"
birch::type::Real birch::type::Distribution<Value>::observe(const Value& x, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_) {
  #line 86 "src/distribution/Distribution.birch"
  libbirch_function_("observe", "src/distribution/Distribution.birch", 86);
  #line 87 "src/distribution/Distribution.birch"
  libbirch_line_(87);
  #line 87 "src/distribution/Distribution.birch"
  this_()->prune(handler_);
  #line 88 "src/distribution/Distribution.birch"
  libbirch_line_(88);
  #line 88 "src/distribution/Distribution.birch"
  auto w = this_()->logpdf(x, handler_);
  #line 89 "src/distribution/Distribution.birch"
  libbirch_line_(89);
  #line 89 "src/distribution/Distribution.birch"
  if (w > -birch::inf()) {
    #line 90 "src/distribution/Distribution.birch"
    libbirch_line_(90);
    #line 90 "src/distribution/Distribution.birch"
    this_()->update(x, handler_);
  }
  #line 92 "src/distribution/Distribution.birch"
  libbirch_line_(92);
  #line 92 "src/distribution/Distribution.birch"
  this_()->unlink(handler_);
  #line 93 "src/distribution/Distribution.birch"
  libbirch_line_(93);
  #line 93 "src/distribution/Distribution.birch"
  return w;
}

#line 6 "src/distribution/Distribution.birch"
template<class Value>
#line 102 "src/distribution/Distribution.birch"
libbirch::Optional<libbirch::Lazy<libbirch::Shared<birch::type::Expression<birch::type::Real>>>> birch::type::Distribution<Value>::observeLazy(const libbirch::Lazy<libbirch::Shared<birch::type::Expression<Value>>>& x, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_) {
  #line 102 "src/distribution/Distribution.birch"
  libbirch_function_("observeLazy", "src/distribution/Distribution.birch", 102);
  #line 103 "src/distribution/Distribution.birch"
  libbirch_line_(103);
  #line 103 "src/distribution/Distribution.birch"
  libbirch_assert_(this_()->supportsLazy(handler_));
  #line 104 "src/distribution/Distribution.birch"
  libbirch_line_(104);
  #line 104 "src/distribution/Distribution.birch"
  this_()->prune(handler_);
  #line 105 "src/distribution/Distribution.birch"
  libbirch_line_(105);
  #line 105 "src/distribution/Distribution.birch"
  auto w = this_()->logpdfLazy(x, handler_);
  #line 106 "src/distribution/Distribution.birch"
  libbirch_line_(106);
  #line 106 "src/distribution/Distribution.birch"
  this_()->updateLazy(x, handler_);
  #line 107 "src/distribution/Distribution.birch"
  libbirch_line_(107);
  #line 107 "src/distribution/Distribution.birch"
  this_()->unlink(handler_);
  #line 108 "src/distribution/Distribution.birch"
  libbirch_line_(108);
  #line 108 "src/distribution/Distribution.birch"
  return w;
}

#line 6 "src/distribution/Distribution.birch"
template<class Value>
#line 123 "src/distribution/Distribution.birch"
libbirch::Optional<Value> birch::type::Distribution<Value>::simulateLazy(const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_) {
  #line 123 "src/distribution/Distribution.birch"
  libbirch_function_("simulateLazy", "src/distribution/Distribution.birch", 123);
  #line 124 "src/distribution/Distribution.birch"
  libbirch_line_(124);
  #line 124 "src/distribution/Distribution.birch"
  return libbirch::nil;
}

#line 6 "src/distribution/Distribution.birch"
template<class Value>
#line 143 "src/distribution/Distribution.birch"
libbirch::Optional<libbirch::Lazy<libbirch::Shared<birch::type::Expression<birch::type::Real>>>> birch::type::Distribution<Value>::logpdfLazy(const libbirch::Lazy<libbirch::Shared<birch::type::Expression<Value>>>& x, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_) {
  #line 143 "src/distribution/Distribution.birch"
  libbirch_function_("logpdfLazy", "src/distribution/Distribution.birch", 143);
  #line 144 "src/distribution/Distribution.birch"
  libbirch_line_(144);
  #line 144 "src/distribution/Distribution.birch"
  return libbirch::nil;
}

#line 6 "src/distribution/Distribution.birch"
template<class Value>
#line 152 "src/distribution/Distribution.birch"
void birch::type::Distribution<Value>::update(const Value& x, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_) {
  #line 152 "src/distribution/Distribution.birch"
  libbirch_function_("update", "src/distribution/Distribution.birch", 152);
}

#line 6 "src/distribution/Distribution.birch"
template<class Value>
#line 161 "src/distribution/Distribution.birch"
void birch::type::Distribution<Value>::updateLazy(const libbirch::Lazy<libbirch::Shared<birch::type::Expression<Value>>>& x, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_) {
  #line 161 "src/distribution/Distribution.birch"
  libbirch_function_("updateLazy", "src/distribution/Distribution.birch", 161);
}

#line 6 "src/distribution/Distribution.birch"
template<class Value>
#line 172 "src/distribution/Distribution.birch"
birch::type::Real birch::type::Distribution<Value>::pdf(const Value& x, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_) {
  #line 172 "src/distribution/Distribution.birch"
  libbirch_function_("pdf", "src/distribution/Distribution.birch", 172);
  #line 173 "src/distribution/Distribution.birch"
  libbirch_line_(173);
  #line 173 "src/distribution/Distribution.birch"
  return birch::exp(this_()->logpdf(x, handler_), handler_);
}

#line 6 "src/distribution/Distribution.birch"
template<class Value>
#line 183 "src/distribution/Distribution.birch"
libbirch::Optional<birch::type::Real> birch::type::Distribution<Value>::cdf(const Value& x, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_) {
  #line 183 "src/distribution/Distribution.birch"
  libbirch_function_("cdf", "src/distribution/Distribution.birch", 183);
  #line 184 "src/distribution/Distribution.birch"
  libbirch_line_(184);
  #line 184 "src/distribution/Distribution.birch"
  return libbirch::nil;
}

#line 6 "src/distribution/Distribution.birch"
template<class Value>
#line 194 "src/distribution/Distribution.birch"
libbirch::Optional<Value> birch::type::Distribution<Value>::quantile(const birch::type::Real& P, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_) {
  #line 194 "src/distribution/Distribution.birch"
  libbirch_function_("quantile", "src/distribution/Distribution.birch", 194);
  #line 195 "src/distribution/Distribution.birch"
  libbirch_line_(195);
  #line 195 "src/distribution/Distribution.birch"
  return libbirch::nil;
}

#line 6 "src/distribution/Distribution.birch"
template<class Value>
#line 201 "src/distribution/Distribution.birch"
libbirch::Optional<Value> birch::type::Distribution<Value>::lower(const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_) {
  #line 201 "src/distribution/Distribution.birch"
  libbirch_function_("lower", "src/distribution/Distribution.birch", 201);
  #line 202 "src/distribution/Distribution.birch"
  libbirch_line_(202);
  #line 202 "src/distribution/Distribution.birch"
  return libbirch::nil;
}

#line 6 "src/distribution/Distribution.birch"
template<class Value>
#line 208 "src/distribution/Distribution.birch"
libbirch::Optional<Value> birch::type::Distribution<Value>::upper(const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_) {
  #line 208 "src/distribution/Distribution.birch"
  libbirch_function_("upper", "src/distribution/Distribution.birch", 208);
  #line 209 "src/distribution/Distribution.birch"
  libbirch_line_(209);
  #line 209 "src/distribution/Distribution.birch"
  return libbirch::nil;
}

#line 6 "src/distribution/Distribution.birch"
template<class Value>
#line 219 "src/distribution/Distribution.birch"
libbirch::Lazy<libbirch::Shared<birch::type::Distribution<Value>>> birch::type::Distribution<Value>::graft(const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_) {
  #line 219 "src/distribution/Distribution.birch"
  libbirch_function_("graft", "src/distribution/Distribution.birch", 219);
  #line 220 "src/distribution/Distribution.birch"
  libbirch_line_(220);
  #line 220 "src/distribution/Distribution.birch"
  this_()->prune(handler_);
  #line 221 "src/distribution/Distribution.birch"
  libbirch_line_(221);
  #line 221 "src/distribution/Distribution.birch"
  return shared_from_this_();
}

#line 6 "src/distribution/Distribution.birch"
template<class Value>
#line 227 "src/distribution/Distribution.birch"
libbirch::Optional<libbirch::Lazy<libbirch::Shared<birch::type::Gaussian>>> birch::type::Distribution<Value>::graftGaussian(const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_) {
  #line 227 "src/distribution/Distribution.birch"
  libbirch_function_("graftGaussian", "src/distribution/Distribution.birch", 227);
  #line 228 "src/distribution/Distribution.birch"
  libbirch_line_(228);
  #line 228 "src/distribution/Distribution.birch"
  return libbirch::nil;
}

#line 6 "src/distribution/Distribution.birch"
template<class Value>
#line 234 "src/distribution/Distribution.birch"
libbirch::Optional<libbirch::Lazy<libbirch::Shared<birch::type::Beta>>> birch::type::Distribution<Value>::graftBeta(const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_) {
  #line 234 "src/distribution/Distribution.birch"
  libbirch_function_("graftBeta", "src/distribution/Distribution.birch", 234);
  #line 235 "src/distribution/Distribution.birch"
  libbirch_line_(235);
  #line 235 "src/distribution/Distribution.birch"
  return libbirch::nil;
}

#line 6 "src/distribution/Distribution.birch"
template<class Value>
#line 241 "src/distribution/Distribution.birch"
libbirch::Optional<libbirch::Lazy<libbirch::Shared<birch::type::Gamma>>> birch::type::Distribution<Value>::graftGamma(const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_) {
  #line 241 "src/distribution/Distribution.birch"
  libbirch_function_("graftGamma", "src/distribution/Distribution.birch", 241);
  #line 242 "src/distribution/Distribution.birch"
  libbirch_line_(242);
  #line 242 "src/distribution/Distribution.birch"
  return libbirch::nil;
}

#line 6 "src/distribution/Distribution.birch"
template<class Value>
#line 248 "src/distribution/Distribution.birch"
libbirch::Optional<libbirch::Lazy<libbirch::Shared<birch::type::InverseGamma>>> birch::type::Distribution<Value>::graftInverseGamma(const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_) {
  #line 248 "src/distribution/Distribution.birch"
  libbirch_function_("graftInverseGamma", "src/distribution/Distribution.birch", 248);
  #line 249 "src/distribution/Distribution.birch"
  libbirch_line_(249);
  #line 249 "src/distribution/Distribution.birch"
  return libbirch::nil;
}

#line 6 "src/distribution/Distribution.birch"
template<class Value>
#line 255 "src/distribution/Distribution.birch"
libbirch::Optional<libbirch::Lazy<libbirch::Shared<birch::type::InverseWishart>>> birch::type::Distribution<Value>::graftInverseWishart(const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_) {
  #line 255 "src/distribution/Distribution.birch"
  libbirch_function_("graftInverseWishart", "src/distribution/Distribution.birch", 255);
  #line 256 "src/distribution/Distribution.birch"
  libbirch_line_(256);
  #line 256 "src/distribution/Distribution.birch"
  return libbirch::nil;
}

#line 6 "src/distribution/Distribution.birch"
template<class Value>
#line 262 "src/distribution/Distribution.birch"
libbirch::Optional<libbirch::Lazy<libbirch::Shared<birch::type::NormalInverseGamma>>> birch::type::Distribution<Value>::graftNormalInverseGamma(const libbirch::Lazy<libbirch::Shared<birch::type::Distribution<birch::type::Real>>>& compare, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_) {
  #line 262 "src/distribution/Distribution.birch"
  libbirch_function_("graftNormalInverseGamma", "src/distribution/Distribution.birch", 262);
  #line 263 "src/distribution/Distribution.birch"
  libbirch_line_(263);
  #line 263 "src/distribution/Distribution.birch"
  return libbirch::nil;
}

#line 6 "src/distribution/Distribution.birch"
template<class Value>
#line 269 "src/distribution/Distribution.birch"
libbirch::Optional<libbirch::Lazy<libbirch::Shared<birch::type::Dirichlet>>> birch::type::Distribution<Value>::graftDirichlet(const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_) {
  #line 269 "src/distribution/Distribution.birch"
  libbirch_function_("graftDirichlet", "src/distribution/Distribution.birch", 269);
  #line 270 "src/distribution/Distribution.birch"
  libbirch_line_(270);
  #line 270 "src/distribution/Distribution.birch"
  return libbirch::nil;
}

#line 6 "src/distribution/Distribution.birch"
template<class Value>
#line 276 "src/distribution/Distribution.birch"
libbirch::Optional<libbirch::Lazy<libbirch::Shared<birch::type::Restaurant>>> birch::type::Distribution<Value>::graftRestaurant(const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_) {
  #line 276 "src/distribution/Distribution.birch"
  libbirch_function_("graftRestaurant", "src/distribution/Distribution.birch", 276);
  #line 277 "src/distribution/Distribution.birch"
  libbirch_line_(277);
  #line 277 "src/distribution/Distribution.birch"
  return libbirch::nil;
}

#line 6 "src/distribution/Distribution.birch"
template<class Value>
#line 283 "src/distribution/Distribution.birch"
libbirch::Optional<libbirch::Lazy<libbirch::Shared<birch::type::MultivariateGaussian>>> birch::type::Distribution<Value>::graftMultivariateGaussian(const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_) {
  #line 283 "src/distribution/Distribution.birch"
  libbirch_function_("graftMultivariateGaussian", "src/distribution/Distribution.birch", 283);
  #line 284 "src/distribution/Distribution.birch"
  libbirch_line_(284);
  #line 284 "src/distribution/Distribution.birch"
  return libbirch::nil;
}

#line 6 "src/distribution/Distribution.birch"
template<class Value>
#line 290 "src/distribution/Distribution.birch"
libbirch::Optional<libbirch::Lazy<libbirch::Shared<birch::type::MultivariateNormalInverseGamma>>> birch::type::Distribution<Value>::graftMultivariateNormalInverseGamma(const libbirch::Lazy<libbirch::Shared<birch::type::Distribution<birch::type::Real>>>& compare, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_) {
  #line 290 "src/distribution/Distribution.birch"
  libbirch_function_("graftMultivariateNormalInverseGamma", "src/distribution/Distribution.birch", 290);
  #line 292 "src/distribution/Distribution.birch"
  libbirch_line_(292);
  #line 292 "src/distribution/Distribution.birch"
  return libbirch::nil;
}

#line 6 "src/distribution/Distribution.birch"
template<class Value>
#line 298 "src/distribution/Distribution.birch"
libbirch::Optional<libbirch::Lazy<libbirch::Shared<birch::type::MatrixGaussian>>> birch::type::Distribution<Value>::graftMatrixGaussian(const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_) {
  #line 298 "src/distribution/Distribution.birch"
  libbirch_function_("graftMatrixGaussian", "src/distribution/Distribution.birch", 298);
  #line 299 "src/distribution/Distribution.birch"
  libbirch_line_(299);
  #line 299 "src/distribution/Distribution.birch"
  return libbirch::nil;
}

#line 6 "src/distribution/Distribution.birch"
template<class Value>
#line 305 "src/distribution/Distribution.birch"
libbirch::Optional<libbirch::Lazy<libbirch::Shared<birch::type::MatrixNormalInverseWishart>>> birch::type::Distribution<Value>::graftMatrixNormalInverseWishart(const libbirch::Lazy<libbirch::Shared<birch::type::Distribution<birch::type::LLT>>>& compare, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_) {
  #line 305 "src/distribution/Distribution.birch"
  libbirch_function_("graftMatrixNormalInverseWishart", "src/distribution/Distribution.birch", 305);
  #line 307 "src/distribution/Distribution.birch"
  libbirch_line_(307);
  #line 307 "src/distribution/Distribution.birch"
  return libbirch::nil;
}

#line 6 "src/distribution/Distribution.birch"
template<class Value>
#line 313 "src/distribution/Distribution.birch"
libbirch::Optional<libbirch::Lazy<libbirch::Shared<birch::type::Discrete>>> birch::type::Distribution<Value>::graftDiscrete(const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_) {
  #line 313 "src/distribution/Distribution.birch"
  libbirch_function_("graftDiscrete", "src/distribution/Distribution.birch", 313);
  #line 314 "src/distribution/Distribution.birch"
  libbirch_line_(314);
  #line 314 "src/distribution/Distribution.birch"
  return libbirch::nil;
}

#line 6 "src/distribution/Distribution.birch"
template<class Value>
#line 320 "src/distribution/Distribution.birch"
libbirch::Optional<libbirch::Lazy<libbirch::Shared<birch::type::BoundedDiscrete>>> birch::type::Distribution<Value>::graftBoundedDiscrete(const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_) {
  #line 320 "src/distribution/Distribution.birch"
  libbirch_function_("graftBoundedDiscrete", "src/distribution/Distribution.birch", 320);
  #line 321 "src/distribution/Distribution.birch"
  libbirch_line_(321);
  #line 321 "src/distribution/Distribution.birch"
  return libbirch::nil;
}

#line 21 "src/event/AssumeEvent.birch"
template<class Value>
#line 21 "src/event/AssumeEvent.birch"
birch::type::AssumeEvent<Value>::AssumeEvent(const libbirch::Lazy<libbirch::Shared<birch::type::Random<Value>>>& x, const libbirch::Lazy<libbirch::Shared<birch::type::Distribution<Value>>>& p, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_) :
    #line 21 "src/event/AssumeEvent.birch"
    super_type_(),
    #line 26 "src/event/AssumeEvent.birch"
    x(x),
    #line 31 "src/event/AssumeEvent.birch"
    p(p) {
  //
}

#line 21 "src/event/AssumeEvent.birch"
template<class Value>
#line 33 "src/event/AssumeEvent.birch"
libbirch::Lazy<libbirch::Shared<birch::type::Record>> birch::type::AssumeEvent<Value>::record(const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_) {
  #line 33 "src/event/AssumeEvent.birch"
  libbirch_function_("record", "src/event/AssumeEvent.birch", 33);
  #line 34 "src/event/AssumeEvent.birch"
  libbirch_line_(34);
  #line 34 "src/event/AssumeEvent.birch"
  return birch::AssumeRecord(this_()->x, handler_);
}

#line 21 "src/event/AssumeEvent.birch"
template<class Value>
#line 37 "src/event/AssumeEvent.birch"
libbirch::Lazy<libbirch::Shared<birch::type::AssumeRecord<Value>>> birch::type::AssumeEvent<Value>::coerce(const libbirch::Lazy<libbirch::Shared<birch::type::Record>>& record, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_) {
  #line 37 "src/event/AssumeEvent.birch"
  libbirch_function_("coerce", "src/event/AssumeEvent.birch", 37);
  #line 38 "src/event/AssumeEvent.birch"
  libbirch_line_(38);
  #line 38 "src/event/AssumeEvent.birch"
  auto r = libbirch::cast<libbirch::Lazy<libbirch::Shared<birch::type::AssumeRecord<Value>>>>(record);
  #line 39 "src/event/AssumeEvent.birch"
  libbirch_line_(39);
  #line 39 "src/event/AssumeEvent.birch"
  if (!r.query()) {
    #line 40 "src/event/AssumeEvent.birch"
    libbirch_line_(40);
    #line 40 "src/event/AssumeEvent.birch"
    birch::error(birch::type::String("incompatible trace"), handler_);
  }
  #line 42 "src/event/AssumeEvent.birch"
  libbirch_line_(42);
  #line 42 "src/event/AssumeEvent.birch"
  return r.get();
}

#line 21 "src/event/AssumeEvent.birch"
template<class Value>
#line 45 "src/event/AssumeEvent.birch"
void birch::type::AssumeEvent<Value>::accept(const libbirch::Lazy<libbirch::Shared<birch::type::PlayHandler>>& handler, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_) {
  #line 45 "src/event/AssumeEvent.birch"
  libbirch_function_("accept", "src/event/AssumeEvent.birch", 45);
  #line 46 "src/event/AssumeEvent.birch"
  libbirch_line_(46);
  #line 46 "src/event/AssumeEvent.birch"
  handler->doHandle(shared_from_this_(), handler_);
}

#line 21 "src/event/AssumeEvent.birch"
template<class Value>
#line 49 "src/event/AssumeEvent.birch"
void birch::type::AssumeEvent<Value>::accept(const libbirch::Lazy<libbirch::Shared<birch::type::MoveHandler>>& handler, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_) {
  #line 49 "src/event/AssumeEvent.birch"
  libbirch_function_("accept", "src/event/AssumeEvent.birch", 49);
  #line 50 "src/event/AssumeEvent.birch"
  libbirch_line_(50);
  #line 50 "src/event/AssumeEvent.birch"
  handler->doHandle(shared_from_this_(), handler_);
}

#line 21 "src/event/AssumeEvent.birch"
template<class Value>
#line 53 "src/event/AssumeEvent.birch"
void birch::type::AssumeEvent<Value>::accept(const libbirch::Lazy<libbirch::Shared<birch::type::Record>>& record, const libbirch::Lazy<libbirch::Shared<birch::type::PlayHandler>>& handler, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_) {
  #line 53 "src/event/AssumeEvent.birch"
  libbirch_function_("accept", "src/event/AssumeEvent.birch", 53);
  #line 54 "src/event/AssumeEvent.birch"
  libbirch_line_(54);
  #line 54 "src/event/AssumeEvent.birch"
  handler->doHandle(this_()->coerce(record, handler_), shared_from_this_(), handler_);
}

#line 21 "src/event/AssumeEvent.birch"
template<class Value>
#line 57 "src/event/AssumeEvent.birch"
void birch::type::AssumeEvent<Value>::accept(const libbirch::Lazy<libbirch::Shared<birch::type::Record>>& record, const libbirch::Lazy<libbirch::Shared<birch::type::MoveHandler>>& handler, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_) {
  #line 57 "src/event/AssumeEvent.birch"
  libbirch_function_("accept", "src/event/AssumeEvent.birch", 57);
  #line 58 "src/event/AssumeEvent.birch"
  libbirch_line_(58);
  #line 58 "src/event/AssumeEvent.birch"
  handler->doHandle(this_()->coerce(record, handler_), shared_from_this_(), handler_);
}

#line 20 "src/event/ObserveEvent.birch"
template<class Value>
#line 20 "src/event/ObserveEvent.birch"
birch::type::ObserveEvent<Value>::ObserveEvent(const Value& x, const libbirch::Lazy<libbirch::Shared<birch::type::Distribution<Value>>>& p, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_) :
    #line 20 "src/event/ObserveEvent.birch"
    super_type_(),
    #line 24 "src/event/ObserveEvent.birch"
    x(x),
    #line 29 "src/event/ObserveEvent.birch"
    p(p) {
  //
}

#line 20 "src/event/ObserveEvent.birch"
template<class Value>
#line 31 "src/event/ObserveEvent.birch"
libbirch::Lazy<libbirch::Shared<birch::type::Record>> birch::type::ObserveEvent<Value>::record(const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_) {
  #line 31 "src/event/ObserveEvent.birch"
  libbirch_function_("record", "src/event/ObserveEvent.birch", 31);
  #line 32 "src/event/ObserveEvent.birch"
  libbirch_line_(32);
  #line 32 "src/event/ObserveEvent.birch"
  return birch::ObserveRecord(this_()->x, handler_);
}

#line 20 "src/event/ObserveEvent.birch"
template<class Value>
#line 35 "src/event/ObserveEvent.birch"
libbirch::Lazy<libbirch::Shared<birch::type::ObserveRecord<Value>>> birch::type::ObserveEvent<Value>::coerce(const libbirch::Lazy<libbirch::Shared<birch::type::Record>>& record, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_) {
  #line 35 "src/event/ObserveEvent.birch"
  libbirch_function_("coerce", "src/event/ObserveEvent.birch", 35);
  #line 36 "src/event/ObserveEvent.birch"
  libbirch_line_(36);
  #line 36 "src/event/ObserveEvent.birch"
  auto r = libbirch::cast<libbirch::Lazy<libbirch::Shared<birch::type::ObserveRecord<Value>>>>(record);
  #line 37 "src/event/ObserveEvent.birch"
  libbirch_line_(37);
  #line 37 "src/event/ObserveEvent.birch"
  if (!r.query()) {
    #line 38 "src/event/ObserveEvent.birch"
    libbirch_line_(38);
    #line 38 "src/event/ObserveEvent.birch"
    birch::error(birch::type::String("incompatible trace"), handler_);
  }
  #line 40 "src/event/ObserveEvent.birch"
  libbirch_line_(40);
  #line 40 "src/event/ObserveEvent.birch"
  return r.get();
}

#line 20 "src/event/ObserveEvent.birch"
template<class Value>
#line 43 "src/event/ObserveEvent.birch"
void birch::type::ObserveEvent<Value>::accept(const libbirch::Lazy<libbirch::Shared<birch::type::PlayHandler>>& handler, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_) {
  #line 43 "src/event/ObserveEvent.birch"
  libbirch_function_("accept", "src/event/ObserveEvent.birch", 43);
  #line 44 "src/event/ObserveEvent.birch"
  libbirch_line_(44);
  #line 44 "src/event/ObserveEvent.birch"
  handler->doHandle(shared_from_this_(), handler_);
}

#line 20 "src/event/ObserveEvent.birch"
template<class Value>
#line 47 "src/event/ObserveEvent.birch"
void birch::type::ObserveEvent<Value>::accept(const libbirch::Lazy<libbirch::Shared<birch::type::MoveHandler>>& handler, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_) {
  #line 47 "src/event/ObserveEvent.birch"
  libbirch_function_("accept", "src/event/ObserveEvent.birch", 47);
  #line 48 "src/event/ObserveEvent.birch"
  libbirch_line_(48);
  #line 48 "src/event/ObserveEvent.birch"
  handler->doHandle(shared_from_this_(), handler_);
}

#line 20 "src/event/ObserveEvent.birch"
template<class Value>
#line 51 "src/event/ObserveEvent.birch"
void birch::type::ObserveEvent<Value>::accept(const libbirch::Lazy<libbirch::Shared<birch::type::Record>>& record, const libbirch::Lazy<libbirch::Shared<birch::type::PlayHandler>>& handler, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_) {
  #line 51 "src/event/ObserveEvent.birch"
  libbirch_function_("accept", "src/event/ObserveEvent.birch", 51);
  #line 52 "src/event/ObserveEvent.birch"
  libbirch_line_(52);
  #line 52 "src/event/ObserveEvent.birch"
  handler->doHandle(this_()->coerce(record, handler_), shared_from_this_(), handler_);
}

#line 20 "src/event/ObserveEvent.birch"
template<class Value>
#line 55 "src/event/ObserveEvent.birch"
void birch::type::ObserveEvent<Value>::accept(const libbirch::Lazy<libbirch::Shared<birch::type::Record>>& record, const libbirch::Lazy<libbirch::Shared<birch::type::MoveHandler>>& handler, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_) {
  #line 55 "src/event/ObserveEvent.birch"
  libbirch_function_("accept", "src/event/ObserveEvent.birch", 55);
  #line 56 "src/event/ObserveEvent.birch"
  libbirch_line_(56);
  #line 56 "src/event/ObserveEvent.birch"
  handler->doHandle(this_()->coerce(record, handler_), shared_from_this_(), handler_);
}

#line 19 "src/event/SimulateEvent.birch"
template<class Value>
#line 19 "src/event/SimulateEvent.birch"
birch::type::SimulateEvent<Value>::SimulateEvent(const libbirch::Lazy<libbirch::Shared<birch::type::Distribution<Value>>>& p, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_) :
    #line 19 "src/event/SimulateEvent.birch"
    super_type_(),
    #line 23 "src/event/SimulateEvent.birch"
    x(),
    #line 28 "src/event/SimulateEvent.birch"
    p(p) {
  //
}

#line 19 "src/event/SimulateEvent.birch"
template<class Value>
#line 30 "src/event/SimulateEvent.birch"
Value birch::type::SimulateEvent<Value>::value(const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_) {
  #line 30 "src/event/SimulateEvent.birch"
  libbirch_function_("value", "src/event/SimulateEvent.birch", 30);
  #line 31 "src/event/SimulateEvent.birch"
  libbirch_line_(31);
  #line 31 "src/event/SimulateEvent.birch"
  return this_()->x.get();
}

#line 19 "src/event/SimulateEvent.birch"
template<class Value>
#line 34 "src/event/SimulateEvent.birch"
libbirch::Lazy<libbirch::Shared<birch::type::Record>> birch::type::SimulateEvent<Value>::record(const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_) {
  #line 34 "src/event/SimulateEvent.birch"
  libbirch_function_("record", "src/event/SimulateEvent.birch", 34);
  #line 35 "src/event/SimulateEvent.birch"
  libbirch_line_(35);
  #line 35 "src/event/SimulateEvent.birch"
  return birch::SimulateRecord(this_()->x.get(), handler_);
}

#line 19 "src/event/SimulateEvent.birch"
template<class Value>
#line 38 "src/event/SimulateEvent.birch"
libbirch::Lazy<libbirch::Shared<birch::type::SimulateRecord<Value>>> birch::type::SimulateEvent<Value>::coerce(const libbirch::Lazy<libbirch::Shared<birch::type::Record>>& record, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_) {
  #line 38 "src/event/SimulateEvent.birch"
  libbirch_function_("coerce", "src/event/SimulateEvent.birch", 38);
  #line 39 "src/event/SimulateEvent.birch"
  libbirch_line_(39);
  #line 39 "src/event/SimulateEvent.birch"
  auto r = libbirch::cast<libbirch::Lazy<libbirch::Shared<birch::type::SimulateRecord<Value>>>>(record);
  #line 40 "src/event/SimulateEvent.birch"
  libbirch_line_(40);
  #line 40 "src/event/SimulateEvent.birch"
  if (!r.query()) {
    #line 41 "src/event/SimulateEvent.birch"
    libbirch_line_(41);
    #line 41 "src/event/SimulateEvent.birch"
    birch::error(birch::type::String("incompatible trace"), handler_);
  }
  #line 43 "src/event/SimulateEvent.birch"
  libbirch_line_(43);
  #line 43 "src/event/SimulateEvent.birch"
  return r.get();
}

#line 19 "src/event/SimulateEvent.birch"
template<class Value>
#line 46 "src/event/SimulateEvent.birch"
void birch::type::SimulateEvent<Value>::accept(const libbirch::Lazy<libbirch::Shared<birch::type::PlayHandler>>& handler, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_) {
  #line 46 "src/event/SimulateEvent.birch"
  libbirch_function_("accept", "src/event/SimulateEvent.birch", 46);
  #line 47 "src/event/SimulateEvent.birch"
  libbirch_line_(47);
  #line 47 "src/event/SimulateEvent.birch"
  handler->doHandle(shared_from_this_(), handler_);
}

#line 19 "src/event/SimulateEvent.birch"
template<class Value>
#line 50 "src/event/SimulateEvent.birch"
void birch::type::SimulateEvent<Value>::accept(const libbirch::Lazy<libbirch::Shared<birch::type::MoveHandler>>& handler, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_) {
  #line 50 "src/event/SimulateEvent.birch"
  libbirch_function_("accept", "src/event/SimulateEvent.birch", 50);
  #line 51 "src/event/SimulateEvent.birch"
  libbirch_line_(51);
  #line 51 "src/event/SimulateEvent.birch"
  handler->doHandle(shared_from_this_(), handler_);
}

#line 19 "src/event/SimulateEvent.birch"
template<class Value>
#line 54 "src/event/SimulateEvent.birch"
void birch::type::SimulateEvent<Value>::accept(const libbirch::Lazy<libbirch::Shared<birch::type::Record>>& record, const libbirch::Lazy<libbirch::Shared<birch::type::PlayHandler>>& handler, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_) {
  #line 54 "src/event/SimulateEvent.birch"
  libbirch_function_("accept", "src/event/SimulateEvent.birch", 54);
  #line 55 "src/event/SimulateEvent.birch"
  libbirch_line_(55);
  #line 55 "src/event/SimulateEvent.birch"
  handler->doHandle(this_()->coerce(record, handler_), shared_from_this_(), handler_);
}

#line 19 "src/event/SimulateEvent.birch"
template<class Value>
#line 58 "src/event/SimulateEvent.birch"
void birch::type::SimulateEvent<Value>::accept(const libbirch::Lazy<libbirch::Shared<birch::type::Record>>& record, const libbirch::Lazy<libbirch::Shared<birch::type::MoveHandler>>& handler, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_) {
  #line 58 "src/event/SimulateEvent.birch"
  libbirch_function_("accept", "src/event/SimulateEvent.birch", 58);
  #line 59 "src/event/SimulateEvent.birch"
  libbirch_line_(59);
  #line 59 "src/event/SimulateEvent.birch"
  handler->doHandle(this_()->coerce(record, handler_), shared_from_this_(), handler_);
}

#line 4 "src/expression/Boxed.birch"
template<class Value>
#line 4 "src/expression/Boxed.birch"
birch::type::Boxed<Value>::Boxed(const Value& x, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_) :
    #line 4 "src/expression/Boxed.birch"
    super_type_(x) {
  //
}

#line 4 "src/expression/Boxed.birch"
template<class Value>
#line 5 "src/expression/Boxed.birch"
birch::type::Integer birch::type::Boxed<Value>::doRows(const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_) {
  #line 5 "src/expression/Boxed.birch"
  libbirch_function_("doRows", "src/expression/Boxed.birch", 5);
  #line 6 "src/expression/Boxed.birch"
  libbirch_line_(6);
  #line 6 "src/expression/Boxed.birch"
  return birch::rows(this_()->x.get(), handler_);
}

#line 4 "src/expression/Boxed.birch"
template<class Value>
#line 9 "src/expression/Boxed.birch"
birch::type::Integer birch::type::Boxed<Value>::doColumns(const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_) {
  #line 9 "src/expression/Boxed.birch"
  libbirch_function_("doColumns", "src/expression/Boxed.birch", 9);
  #line 10 "src/expression/Boxed.birch"
  libbirch_line_(10);
  #line 10 "src/expression/Boxed.birch"
  return birch::columns(this_()->x.get(), handler_);
}

#line 4 "src/expression/Boxed.birch"
template<class Value>
#line 13 "src/expression/Boxed.birch"
birch::type::Integer birch::type::Boxed<Value>::doDepth(const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_) {
  #line 13 "src/expression/Boxed.birch"
  libbirch_function_("doDepth", "src/expression/Boxed.birch", 13);
  #line 14 "src/expression/Boxed.birch"
  libbirch_line_(14);
  #line 14 "src/expression/Boxed.birch"
  return birch::type::Integer(1);
}

#line 4 "src/expression/Boxed.birch"
template<class Value>
#line 17 "src/expression/Boxed.birch"
Value birch::type::Boxed<Value>::doValue(const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_) {
  #line 17 "src/expression/Boxed.birch"
  libbirch_function_("doValue", "src/expression/Boxed.birch", 17);
  #line 18 "src/expression/Boxed.birch"
  libbirch_line_(18);
  #line 18 "src/expression/Boxed.birch"
  return this_()->x.get();
}

#line 4 "src/expression/Boxed.birch"
template<class Value>
#line 21 "src/expression/Boxed.birch"
Value birch::type::Boxed<Value>::doPilot(const birch::type::Integer& gen, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_) {
  #line 21 "src/expression/Boxed.birch"
  libbirch_function_("doPilot", "src/expression/Boxed.birch", 21);
  #line 22 "src/expression/Boxed.birch"
  libbirch_line_(22);
  #line 22 "src/expression/Boxed.birch"
  return this_()->x.get();
}

#line 4 "src/expression/Boxed.birch"
template<class Value>
#line 25 "src/expression/Boxed.birch"
Value birch::type::Boxed<Value>::doGet(const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_) {
  #line 25 "src/expression/Boxed.birch"
  libbirch_function_("doGet", "src/expression/Boxed.birch", 25);
  #line 26 "src/expression/Boxed.birch"
  libbirch_line_(26);
  #line 26 "src/expression/Boxed.birch"
  return this_()->x.get();
}

#line 4 "src/expression/Boxed.birch"
template<class Value>
#line 29 "src/expression/Boxed.birch"
Value birch::type::Boxed<Value>::doMove(const birch::type::Integer& gen, const libbirch::Lazy<libbirch::Shared<birch::type::Kernel>>& _u0954, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_) {
  #line 29 "src/expression/Boxed.birch"
  libbirch_function_("doMove", "src/expression/Boxed.birch", 29);
  #line 30 "src/expression/Boxed.birch"
  libbirch_line_(30);
  #line 30 "src/expression/Boxed.birch"
  return this_()->x.get();
}

#line 4 "src/expression/Boxed.birch"
template<class Value>
#line 33 "src/expression/Boxed.birch"
libbirch::Optional<libbirch::Lazy<libbirch::Shared<birch::type::Expression<birch::type::Real>>>> birch::type::Boxed<Value>::doPrior(const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_) {
  #line 33 "src/expression/Boxed.birch"
  libbirch_function_("doPrior", "src/expression/Boxed.birch", 33);
  #line 34 "src/expression/Boxed.birch"
  libbirch_line_(34);
  #line 34 "src/expression/Boxed.birch"
  return libbirch::nil;
}

#line 4 "src/expression/Boxed.birch"
template<class Value>
#line 37 "src/expression/Boxed.birch"
birch::type::Real birch::type::Boxed<Value>::doCompare(const birch::type::Integer& gen, const libbirch::Lazy<libbirch::Shared<birch::type::DelayExpression>>& x, const libbirch::Lazy<libbirch::Shared<birch::type::Kernel>>& _u0954, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_) {
  #line 37 "src/expression/Boxed.birch"
  libbirch_function_("doCompare", "src/expression/Boxed.birch", 37);
  #line 39 "src/expression/Boxed.birch"
  libbirch_line_(39);
  #line 39 "src/expression/Boxed.birch"
  return 0.0;
}

#line 4 "src/expression/Boxed.birch"
template<class Value>
#line 42 "src/expression/Boxed.birch"
void birch::type::Boxed<Value>::doGrad(const birch::type::Integer& gen, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_) {
  #line 42 "src/expression/Boxed.birch"
  libbirch_function_("doGrad", "src/expression/Boxed.birch", 42);
}

#line 4 "src/expression/Boxed.birch"
template<class Value>
#line 46 "src/expression/Boxed.birch"
void birch::type::Boxed<Value>::doClearGrad(const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_) {
  #line 46 "src/expression/Boxed.birch"
  libbirch_function_("doClearGrad", "src/expression/Boxed.birch", 46);
}

#line 4 "src/expression/Boxed.birch"
template<class Value>
#line 50 "src/expression/Boxed.birch"
void birch::type::Boxed<Value>::doConstant(const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_) {
  #line 50 "src/expression/Boxed.birch"
  libbirch_function_("doConstant", "src/expression/Boxed.birch", 50);
}

#line 4 "src/expression/Boxed.birch"
template<class Value>
#line 54 "src/expression/Boxed.birch"
void birch::type::Boxed<Value>::doCount(const birch::type::Integer& gen, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_) {
  #line 54 "src/expression/Boxed.birch"
  libbirch_function_("doCount", "src/expression/Boxed.birch", 54);
}

#line 4 "src/expression/Boxed.birch"
template<class Value>
#line 58 "src/expression/Boxed.birch"
void birch::type::Boxed<Value>::doDetach(const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_) {
  #line 58 "src/expression/Boxed.birch"
  libbirch_function_("doDetach", "src/expression/Boxed.birch", 58);
}

#line 4 "src/expression/Cast.birch"
template<class From,class To>
#line 4 "src/expression/Cast.birch"
birch::type::Cast<From, To>::Cast(const libbirch::Lazy<libbirch::Shared<birch::type::Expression<From>>>& y, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_) :
    #line 4 "src/expression/Cast.birch"
    super_type_(y) {
  //
}

#line 4 "src/expression/Cast.birch"
template<class From,class To>
#line 6 "src/expression/Cast.birch"
To birch::type::Cast<From, To>::doEvaluate(const From& y, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_) {
  #line 6 "src/expression/Cast.birch"
  libbirch_function_("doEvaluate", "src/expression/Cast.birch", 6);
  #line 7 "src/expression/Cast.birch"
  libbirch_line_(7);
  #line 7 "src/expression/Cast.birch"
  return libbirch::cast<To>(y).get();
}

#line 4 "src/expression/Cast.birch"
template<class From,class To>
#line 10 "src/expression/Cast.birch"
birch::type::Real birch::type::Cast<From, To>::doEvaluateGrad(const birch::type::Real& d, const To& x, const From& y, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_) {
  #line 10 "src/expression/Cast.birch"
  libbirch_function_("doEvaluateGrad", "src/expression/Cast.birch", 10);
  #line 11 "src/expression/Cast.birch"
  libbirch_line_(11);
  #line 11 "src/expression/Cast.birch"
  return d;
}

#line 4 "src/expression/DiscreteCast.birch"
template<class From,class To>
#line 4 "src/expression/DiscreteCast.birch"
birch::type::DiscreteCast<From, To>::DiscreteCast(const libbirch::Lazy<libbirch::Shared<birch::type::Expression<From>>>& y, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_) :
    #line 4 "src/expression/DiscreteCast.birch"
    super_type_(y) {
  //
}

#line 4 "src/expression/DiscreteCast.birch"
template<class From,class To>
#line 6 "src/expression/DiscreteCast.birch"
To birch::type::DiscreteCast<From, To>::doEvaluate(const From& y, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_) {
  #line 6 "src/expression/DiscreteCast.birch"
  libbirch_function_("doEvaluate", "src/expression/DiscreteCast.birch", 6);
  #line 7 "src/expression/DiscreteCast.birch"
  libbirch_line_(7);
  #line 7 "src/expression/DiscreteCast.birch"
  return libbirch::cast<To>(y).get();
}

#line 4 "src/expression/DiscreteCast.birch"
template<class From,class To>
#line 10 "src/expression/DiscreteCast.birch"
birch::type::Real birch::type::DiscreteCast<From, To>::doEvaluateGrad(const birch::type::Real& d, const To& x, const From& y, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_) {
  #line 10 "src/expression/DiscreteCast.birch"
  libbirch_function_("doEvaluateGrad", "src/expression/DiscreteCast.birch", 10);
  #line 11 "src/expression/DiscreteCast.birch"
  libbirch_line_(11);
  #line 11 "src/expression/DiscreteCast.birch"
  return d;
}

#line 66 "src/expression/Expression.birch"
template<class Value>
#line 66 "src/expression/Expression.birch"
birch::type::Expression<Value>::Expression(const libbirch::Optional<Value>& x, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_) :
    #line 66 "src/expression/Expression.birch"
    super_type_(x.query()),
    #line 70 "src/expression/Expression.birch"
    x(x) {
  //
}

#line 66 "src/expression/Expression.birch"
template<class Value>
#line 81 "src/expression/Expression.birch"
birch::type::Boolean birch::type::Expression<Value>::hasValue(const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_) {
  #line 81 "src/expression/Expression.birch"
  libbirch_function_("hasValue", "src/expression/Expression.birch", 81);
  #line 82 "src/expression/Expression.birch"
  libbirch_line_(82);
  #line 82 "src/expression/Expression.birch"
  return this_()->x.query();
}

#line 66 "src/expression/Expression.birch"
template<class Value>
#line 89 "src/expression/Expression.birch"
libbirch::Optional<libbirch::Lazy<libbirch::Shared<birch::type::Distribution<Value>>>> birch::type::Expression<Value>::distribution(const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_) {
  #line 89 "src/expression/Expression.birch"
  libbirch_function_("distribution", "src/expression/Expression.birch", 89);
  #line 90 "src/expression/Expression.birch"
  libbirch_line_(90);
  #line 90 "src/expression/Expression.birch"
  return libbirch::nil;
}

#line 66 "src/expression/Expression.birch"
template<class Value>
#line 93 "src/expression/Expression.birch"
birch::type::Integer birch::type::Expression<Value>::rows(const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_) {
  #line 93 "src/expression/Expression.birch"
  libbirch_function_("rows", "src/expression/Expression.birch", 93);
  #line 94 "src/expression/Expression.birch"
  libbirch_line_(94);
  #line 94 "src/expression/Expression.birch"
  if (this_()->x.query()) {
    #line 95 "src/expression/Expression.birch"
    libbirch_line_(95);
    #line 95 "src/expression/Expression.birch"
    return birch::rows(this_()->x.get(), handler_);
  } else {
    #line 97 "src/expression/Expression.birch"
    libbirch_line_(97);
    #line 97 "src/expression/Expression.birch"
    return this_()->doRows(handler_);
  }
}

#line 66 "src/expression/Expression.birch"
template<class Value>
#line 103 "src/expression/Expression.birch"
birch::type::Integer birch::type::Expression<Value>::columns(const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_) {
  #line 103 "src/expression/Expression.birch"
  libbirch_function_("columns", "src/expression/Expression.birch", 103);
  #line 104 "src/expression/Expression.birch"
  libbirch_line_(104);
  #line 104 "src/expression/Expression.birch"
  if (this_()->x.query()) {
    #line 105 "src/expression/Expression.birch"
    libbirch_line_(105);
    #line 105 "src/expression/Expression.birch"
    return birch::columns(this_()->x.get(), handler_);
  } else {
    #line 107 "src/expression/Expression.birch"
    libbirch_line_(107);
    #line 107 "src/expression/Expression.birch"
    return this_()->doColumns(handler_);
  }
}

#line 66 "src/expression/Expression.birch"
template<class Value>
#line 113 "src/expression/Expression.birch"
birch::type::Integer birch::type::Expression<Value>::depth(const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_) {
  #line 113 "src/expression/Expression.birch"
  libbirch_function_("depth", "src/expression/Expression.birch", 113);
  #line 114 "src/expression/Expression.birch"
  libbirch_line_(114);
  #line 114 "src/expression/Expression.birch"
  if (this_()->isConstant(handler_)) {
    #line 115 "src/expression/Expression.birch"
    libbirch_line_(115);
    #line 115 "src/expression/Expression.birch"
    return birch::type::Integer(1);
  } else {
    #line 117 "src/expression/Expression.birch"
    libbirch_line_(117);
    #line 117 "src/expression/Expression.birch"
    return this_()->doDepth(handler_);
  }
}

#line 66 "src/expression/Expression.birch"
template<class Value>
#line 135 "src/expression/Expression.birch"
Value birch::type::Expression<Value>::value(const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_) {
  #line 135 "src/expression/Expression.birch"
  libbirch_function_("value", "src/expression/Expression.birch", 135);
  #line 136 "src/expression/Expression.birch"
  libbirch_line_(136);
  #line 136 "src/expression/Expression.birch"
  if (!this_()->isConstant(handler_)) {
    #line 137 "src/expression/Expression.birch"
    libbirch_line_(137);
    #line 137 "src/expression/Expression.birch"
    if (!this_()->hasValue(handler_)) {
      #line 138 "src/expression/Expression.birch"
      libbirch_line_(138);
      #line 138 "src/expression/Expression.birch"
      this_()->x = this_()->doValue(handler_);
    } else {
      #line 140 "src/expression/Expression.birch"
      libbirch_line_(140);
      #line 140 "src/expression/Expression.birch"
      this_()->doConstant(handler_);
    }
    #line 142 "src/expression/Expression.birch"
    libbirch_line_(142);
    #line 142 "src/expression/Expression.birch"
    this_()->doClearGrad(handler_);
    #line 143 "src/expression/Expression.birch"
    libbirch_line_(143);
    #line 143 "src/expression/Expression.birch"
    this_()->doDetach(handler_);
    #line 144 "src/expression/Expression.birch"
    libbirch_line_(144);
    #line 144 "src/expression/Expression.birch"
    this_()->generation = birch::type::Integer(0);
    #line 145 "src/expression/Expression.birch"
    libbirch_line_(145);
    #line 145 "src/expression/Expression.birch"
    this_()->pilotCount = birch::type::Integer(0);
    #line 146 "src/expression/Expression.birch"
    libbirch_line_(146);
    #line 146 "src/expression/Expression.birch"
    this_()->gradCount = birch::type::Integer(0);
    #line 147 "src/expression/Expression.birch"
    libbirch_line_(147);
    #line 147 "src/expression/Expression.birch"
    this_()->flagConstant = true;
    #line 148 "src/expression/Expression.birch"
    libbirch_line_(148);
    #line 148 "src/expression/Expression.birch"
    this_()->flagPrior = true;
  }
  #line 150 "src/expression/Expression.birch"
  libbirch_line_(150);
  #line 150 "src/expression/Expression.birch"
  return this_()->x.get();
}

#line 66 "src/expression/Expression.birch"
template<class Value>
#line 175 "src/expression/Expression.birch"
Value birch::type::Expression<Value>::pilot(const birch::type::Integer& gen, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_) {
  #line 175 "src/expression/Expression.birch"
  libbirch_function_("pilot", "src/expression/Expression.birch", 175);
  #line 176 "src/expression/Expression.birch"
  libbirch_line_(176);
  #line 176 "src/expression/Expression.birch"
  if (!this_()->isConstant(handler_)) {
    #line 177 "src/expression/Expression.birch"
    libbirch_line_(177);
    #line 177 "src/expression/Expression.birch"
    if (this_()->pilotCount == birch::type::Integer(0)) {
      #line 178 "src/expression/Expression.birch"
      libbirch_line_(178);
      #line 178 "src/expression/Expression.birch"
      if (!this_()->hasValue(handler_)) {
        #line 179 "src/expression/Expression.birch"
        libbirch_line_(179);
        #line 179 "src/expression/Expression.birch"
        this_()->x = this_()->doPilot(gen, handler_);
      } else {
        #line 182 "src/expression/Expression.birch"
        libbirch_line_(182);
        #line 182 "src/expression/Expression.birch"
        this_()->doCount(gen, handler_);
      }
      #line 184 "src/expression/Expression.birch"
      libbirch_line_(184);
      #line 184 "src/expression/Expression.birch"
      this_()->generation = gen;
    }
    #line 186 "src/expression/Expression.birch"
    libbirch_line_(186);
    #line 186 "src/expression/Expression.birch"
    this_()->pilotCount = this_()->pilotCount + birch::type::Integer(1);
  }
  #line 188 "src/expression/Expression.birch"
  libbirch_line_(188);
  #line 188 "src/expression/Expression.birch"
  return this_()->x.get();
}

#line 66 "src/expression/Expression.birch"
template<class Value>
#line 203 "src/expression/Expression.birch"
Value birch::type::Expression<Value>::get(const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_) {
  #line 203 "src/expression/Expression.birch"
  libbirch_function_("get", "src/expression/Expression.birch", 203);
  #line 204 "src/expression/Expression.birch"
  libbirch_line_(204);
  #line 204 "src/expression/Expression.birch"
  if (!this_()->x.query()) {
    #line 205 "src/expression/Expression.birch"
    libbirch_line_(205);
    #line 205 "src/expression/Expression.birch"
    this_()->x = this_()->doGet(handler_);
  }
  #line 207 "src/expression/Expression.birch"
  libbirch_line_(207);
  #line 207 "src/expression/Expression.birch"
  return this_()->x.get();
}

#line 66 "src/expression/Expression.birch"
template<class Value>
#line 225 "src/expression/Expression.birch"
Value birch::type::Expression<Value>::move(const birch::type::Integer& gen, const libbirch::Lazy<libbirch::Shared<birch::type::Kernel>>& _u0954, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_) {
  #line 225 "src/expression/Expression.birch"
  libbirch_function_("move", "src/expression/Expression.birch", 225);
  #line 226 "src/expression/Expression.birch"
  libbirch_line_(226);
  #line 226 "src/expression/Expression.birch"
  if (!this_()->isConstant(handler_) && this_()->generation >= gen) {
    #line 227 "src/expression/Expression.birch"
    libbirch_line_(227);
    #line 227 "src/expression/Expression.birch"
    libbirch_assert_(this_()->pilotCount > birch::type::Integer(0));
    #line 228 "src/expression/Expression.birch"
    libbirch_line_(228);
    #line 228 "src/expression/Expression.birch"
    if (this_()->gradCount == birch::type::Integer(0)) {
      #line 229 "src/expression/Expression.birch"
      libbirch_line_(229);
      #line 229 "src/expression/Expression.birch"
      this_()->x = this_()->doMove(gen, _u0954, handler_);
      #line 230 "src/expression/Expression.birch"
      libbirch_line_(230);
      #line 230 "src/expression/Expression.birch"
      this_()->doClearGrad(handler_);
    }
    #line 232 "src/expression/Expression.birch"
    libbirch_line_(232);
    #line 232 "src/expression/Expression.birch"
    this_()->gradCount = this_()->gradCount + birch::type::Integer(1);
    #line 233 "src/expression/Expression.birch"
    libbirch_line_(233);
    #line 233 "src/expression/Expression.birch"
    if (this_()->gradCount == this_()->pilotCount) {
      #line 234 "src/expression/Expression.birch"
      libbirch_line_(234);
      #line 234 "src/expression/Expression.birch"
      this_()->gradCount = birch::type::Integer(0);
    }
  }
  #line 237 "src/expression/Expression.birch"
  libbirch_line_(237);
  #line 237 "src/expression/Expression.birch"
  return this_()->x.get();
}

#line 66 "src/expression/Expression.birch"
template<class Value>
#line 256 "src/expression/Expression.birch"
birch::type::Real birch::type::Expression<Value>::compare(const birch::type::Integer& gen, const libbirch::Lazy<libbirch::Shared<birch::type::DelayExpression>>& x, const libbirch::Lazy<libbirch::Shared<birch::type::Kernel>>& _u0954, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_) {
  #line 256 "src/expression/Expression.birch"
  libbirch_function_("compare", "src/expression/Expression.birch", 256);
  #line 257 "src/expression/Expression.birch"
  libbirch_line_(257);
  #line 257 "src/expression/Expression.birch"
  auto w = 0.0;
  #line 258 "src/expression/Expression.birch"
  libbirch_line_(258);
  #line 258 "src/expression/Expression.birch"
  if (!this_()->isConstant(handler_) && this_()->generation >= gen) {
    #line 259 "src/expression/Expression.birch"
    libbirch_line_(259);
    #line 259 "src/expression/Expression.birch"
    libbirch_assert_(this_()->pilotCount > birch::type::Integer(0));
    #line 260 "src/expression/Expression.birch"
    libbirch_line_(260);
    #line 260 "src/expression/Expression.birch"
    if (this_()->gradCount == birch::type::Integer(0)) {
      #line 261 "src/expression/Expression.birch"
      libbirch_line_(261);
      #line 261 "src/expression/Expression.birch"
      w = this_()->doCompare(gen, x, _u0954, handler_);
    }
    #line 263 "src/expression/Expression.birch"
    libbirch_line_(263);
    #line 263 "src/expression/Expression.birch"
    this_()->gradCount = this_()->gradCount + birch::type::Integer(1);
    #line 264 "src/expression/Expression.birch"
    libbirch_line_(264);
    #line 264 "src/expression/Expression.birch"
    if (this_()->gradCount == this_()->pilotCount) {
      #line 265 "src/expression/Expression.birch"
      libbirch_line_(265);
      #line 265 "src/expression/Expression.birch"
      this_()->gradCount = birch::type::Integer(0);
    }
  }
  #line 268 "src/expression/Expression.birch"
  libbirch_line_(268);
  #line 268 "src/expression/Expression.birch"
  return w;
}

#line 66 "src/expression/Expression.birch"
template<class Value>
#line 278 "src/expression/Expression.birch"
void birch::type::Expression<Value>::count(const birch::type::Integer& gen, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_) {
  #line 278 "src/expression/Expression.birch"
  libbirch_function_("count", "src/expression/Expression.birch", 278);
  #line 279 "src/expression/Expression.birch"
  libbirch_line_(279);
  #line 279 "src/expression/Expression.birch"
  if (!this_()->isConstant(handler_)) {
    #line 280 "src/expression/Expression.birch"
    libbirch_line_(280);
    #line 280 "src/expression/Expression.birch"
    if (this_()->pilotCount == birch::type::Integer(0)) {
      #line 281 "src/expression/Expression.birch"
      libbirch_line_(281);
      #line 281 "src/expression/Expression.birch"
      libbirch_assert_(this_()->hasValue(handler_));
      #line 282 "src/expression/Expression.birch"
      libbirch_line_(282);
      #line 282 "src/expression/Expression.birch"
      this_()->doCount(gen, handler_);
      #line 283 "src/expression/Expression.birch"
      libbirch_line_(283);
      #line 283 "src/expression/Expression.birch"
      this_()->generation = gen;
    }
    #line 285 "src/expression/Expression.birch"
    libbirch_line_(285);
    #line 285 "src/expression/Expression.birch"
    this_()->pilotCount = this_()->pilotCount + birch::type::Integer(1);
  }
}

#line 66 "src/expression/Expression.birch"
template<class Value>
#line 295 "src/expression/Expression.birch"
void birch::type::Expression<Value>::constant(const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_) {
  #line 295 "src/expression/Expression.birch"
  libbirch_function_("constant", "src/expression/Expression.birch", 295);
  #line 296 "src/expression/Expression.birch"
  libbirch_line_(296);
  #line 296 "src/expression/Expression.birch"
  if (!this_()->isConstant(handler_)) {
    #line 297 "src/expression/Expression.birch"
    libbirch_line_(297);
    #line 297 "src/expression/Expression.birch"
    libbirch_assert_(this_()->hasValue(handler_));
    #line 298 "src/expression/Expression.birch"
    libbirch_line_(298);
    #line 298 "src/expression/Expression.birch"
    this_()->doConstant(handler_);
    #line 299 "src/expression/Expression.birch"
    libbirch_line_(299);
    #line 299 "src/expression/Expression.birch"
    this_()->doClearGrad(handler_);
    #line 300 "src/expression/Expression.birch"
    libbirch_line_(300);
    #line 300 "src/expression/Expression.birch"
    this_()->doDetach(handler_);
    #line 301 "src/expression/Expression.birch"
    libbirch_line_(301);
    #line 301 "src/expression/Expression.birch"
    this_()->generation = birch::type::Integer(0);
    #line 302 "src/expression/Expression.birch"
    libbirch_line_(302);
    #line 302 "src/expression/Expression.birch"
    this_()->pilotCount = birch::type::Integer(0);
    #line 303 "src/expression/Expression.birch"
    libbirch_line_(303);
    #line 303 "src/expression/Expression.birch"
    this_()->gradCount = birch::type::Integer(0);
    #line 304 "src/expression/Expression.birch"
    libbirch_line_(304);
    #line 304 "src/expression/Expression.birch"
    this_()->flagConstant = true;
    #line 305 "src/expression/Expression.birch"
    libbirch_line_(305);
    #line 305 "src/expression/Expression.birch"
    this_()->flagPrior = true;
  }
}

#line 66 "src/expression/Expression.birch"
template<class Value>
#line 363 "src/expression/Expression.birch"
template<class Gradient>
#line 363 "src/expression/Expression.birch"
void birch::type::Expression<Value>::grad(const birch::type::Integer& gen, const Gradient& d, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_) {
  #line 363 "src/expression/Expression.birch"
  libbirch_function_("grad", "src/expression/Expression.birch", 363);
  #line 364 "src/expression/Expression.birch"
  libbirch_line_(364);
  #line 364 "src/expression/Expression.birch"
  if (this_()->generation < gen) {
    #line 365 "src/expression/Expression.birch"
    libbirch_line_(365);
    #line 365 "src/expression/Expression.birch"
    this_()->constant(handler_);
  } else {
    #line 366 "src/expression/Expression.birch"
    libbirch_line_(366);
    #line 366 "src/expression/Expression.birch"
    if (!this_()->isConstant(handler_)) {
      #line 367 "src/expression/Expression.birch"
      libbirch_line_(367);
      #line 367 "src/expression/Expression.birch"
      libbirch_assert_(this_()->pilotCount > birch::type::Integer(0));
      #line 369 "src/expression/Expression.birch"
      libbirch_line_(369);
      #line 369 "src/expression/Expression.birch"
      if (this_()->gradCount == birch::type::Integer(0)) {
        #line 370 "src/expression/Expression.birch"
        libbirch_line_(370);
        #line 370 "src/expression/Expression.birch"
        this_()->doClearGrad(handler_);
      }
      #line 372 "src/expression/Expression.birch"
      libbirch_line_(372);
      #line 372 "src/expression/Expression.birch"
      this_()->doAccumulateGrad(d, handler_);
      #line 374 "src/expression/Expression.birch"
      libbirch_line_(374);
      #line 374 "src/expression/Expression.birch"
      this_()->gradCount = this_()->gradCount + birch::type::Integer(1);
      #line 375 "src/expression/Expression.birch"
      libbirch_line_(375);
      #line 375 "src/expression/Expression.birch"
      if (this_()->gradCount == this_()->pilotCount) {
        #line 378 "src/expression/Expression.birch"
        libbirch_line_(378);
        #line 378 "src/expression/Expression.birch"
        this_()->doGrad(gen, handler_);
        #line 379 "src/expression/Expression.birch"
        libbirch_line_(379);
        #line 379 "src/expression/Expression.birch"
        this_()->gradCount = birch::type::Integer(0);
        #line 380 "src/expression/Expression.birch"
        libbirch_line_(380);
        #line 380 "src/expression/Expression.birch"
        if (!this_()->isRandom(handler_)) {
          #line 381 "src/expression/Expression.birch"
          libbirch_line_(381);
          #line 381 "src/expression/Expression.birch"
          this_()->doClearGrad(handler_);
        }
      }
    }
  }
}

#line 66 "src/expression/Expression.birch"
template<class Value>
#line 394 "src/expression/Expression.birch"
void birch::type::Expression<Value>::grad(const birch::type::Integer& gen, const birch::type::Real& d, const birch::type::Integer& i, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_) {
  #line 394 "src/expression/Expression.birch"
  libbirch_function_("grad", "src/expression/Expression.birch", 394);
  #line 395 "src/expression/Expression.birch"
  libbirch_line_(395);
  #line 395 "src/expression/Expression.birch"
  if (this_()->generation < gen) {
    #line 396 "src/expression/Expression.birch"
    libbirch_line_(396);
    #line 396 "src/expression/Expression.birch"
    this_()->constant(handler_);
  } else {
    #line 397 "src/expression/Expression.birch"
    libbirch_line_(397);
    #line 397 "src/expression/Expression.birch"
    if (!this_()->isConstant(handler_)) {
      #line 398 "src/expression/Expression.birch"
      libbirch_line_(398);
      #line 398 "src/expression/Expression.birch"
      libbirch_assert_(this_()->pilotCount > birch::type::Integer(0));
      #line 400 "src/expression/Expression.birch"
      libbirch_line_(400);
      #line 400 "src/expression/Expression.birch"
      if (this_()->gradCount == birch::type::Integer(0)) {
        #line 401 "src/expression/Expression.birch"
        libbirch_line_(401);
        #line 401 "src/expression/Expression.birch"
        this_()->doClearGrad(handler_);
      }
      #line 403 "src/expression/Expression.birch"
      libbirch_line_(403);
      #line 403 "src/expression/Expression.birch"
      this_()->doAccumulateGrad(d, i, handler_);
      #line 405 "src/expression/Expression.birch"
      libbirch_line_(405);
      #line 405 "src/expression/Expression.birch"
      this_()->gradCount = this_()->gradCount + birch::type::Integer(1);
      #line 406 "src/expression/Expression.birch"
      libbirch_line_(406);
      #line 406 "src/expression/Expression.birch"
      if (this_()->gradCount == this_()->pilotCount) {
        #line 409 "src/expression/Expression.birch"
        libbirch_line_(409);
        #line 409 "src/expression/Expression.birch"
        this_()->doGrad(gen, handler_);
        #line 410 "src/expression/Expression.birch"
        libbirch_line_(410);
        #line 410 "src/expression/Expression.birch"
        this_()->gradCount = birch::type::Integer(0);
        #line 411 "src/expression/Expression.birch"
        libbirch_line_(411);
        #line 411 "src/expression/Expression.birch"
        if (!this_()->isRandom(handler_)) {
          #line 412 "src/expression/Expression.birch"
          libbirch_line_(412);
          #line 412 "src/expression/Expression.birch"
          this_()->doClearGrad(handler_);
        }
      }
    }
  }
}

#line 66 "src/expression/Expression.birch"
template<class Value>
#line 426 "src/expression/Expression.birch"
void birch::type::Expression<Value>::grad(const birch::type::Integer& gen, const birch::type::Real& d, const birch::type::Integer& i, const birch::type::Integer& j, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_) {
  #line 426 "src/expression/Expression.birch"
  libbirch_function_("grad", "src/expression/Expression.birch", 426);
  #line 427 "src/expression/Expression.birch"
  libbirch_line_(427);
  #line 427 "src/expression/Expression.birch"
  if (this_()->generation < gen) {
    #line 428 "src/expression/Expression.birch"
    libbirch_line_(428);
    #line 428 "src/expression/Expression.birch"
    this_()->constant(handler_);
  } else {
    #line 429 "src/expression/Expression.birch"
    libbirch_line_(429);
    #line 429 "src/expression/Expression.birch"
    if (!this_()->isConstant(handler_)) {
      #line 430 "src/expression/Expression.birch"
      libbirch_line_(430);
      #line 430 "src/expression/Expression.birch"
      libbirch_assert_(this_()->pilotCount > birch::type::Integer(0));
      #line 432 "src/expression/Expression.birch"
      libbirch_line_(432);
      #line 432 "src/expression/Expression.birch"
      if (this_()->gradCount == birch::type::Integer(0)) {
        #line 433 "src/expression/Expression.birch"
        libbirch_line_(433);
        #line 433 "src/expression/Expression.birch"
        this_()->doClearGrad(handler_);
      }
      #line 435 "src/expression/Expression.birch"
      libbirch_line_(435);
      #line 435 "src/expression/Expression.birch"
      this_()->doAccumulateGrad(d, i, j, handler_);
      #line 437 "src/expression/Expression.birch"
      libbirch_line_(437);
      #line 437 "src/expression/Expression.birch"
      this_()->gradCount = this_()->gradCount + birch::type::Integer(1);
      #line 438 "src/expression/Expression.birch"
      libbirch_line_(438);
      #line 438 "src/expression/Expression.birch"
      if (this_()->gradCount == this_()->pilotCount) {
        #line 441 "src/expression/Expression.birch"
        libbirch_line_(441);
        #line 441 "src/expression/Expression.birch"
        this_()->doGrad(gen, handler_);
        #line 442 "src/expression/Expression.birch"
        libbirch_line_(442);
        #line 442 "src/expression/Expression.birch"
        this_()->gradCount = birch::type::Integer(0);
        #line 443 "src/expression/Expression.birch"
        libbirch_line_(443);
        #line 443 "src/expression/Expression.birch"
        if (!this_()->isRandom(handler_)) {
          #line 444 "src/expression/Expression.birch"
          libbirch_line_(444);
          #line 444 "src/expression/Expression.birch"
          this_()->doClearGrad(handler_);
        }
      }
    }
  }
}

#line 66 "src/expression/Expression.birch"
template<class Value>
#line 450 "src/expression/Expression.birch"
void birch::type::Expression<Value>::doAccumulateGrad(const birch::type::Real& d, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_) {
  #line 450 "src/expression/Expression.birch"
  libbirch_function_("doAccumulateGrad", "src/expression/Expression.birch", 450);
  #line 451 "src/expression/Expression.birch"
  libbirch_line_(451);
  #line 451 "src/expression/Expression.birch"
  libbirch_assert_(false);
}

#line 66 "src/expression/Expression.birch"
template<class Value>
#line 454 "src/expression/Expression.birch"
void birch::type::Expression<Value>::doAccumulateGrad(const libbirch::DefaultArray<birch::type::Real,1>& d, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_) {
  #line 454 "src/expression/Expression.birch"
  libbirch_function_("doAccumulateGrad", "src/expression/Expression.birch", 454);
  #line 455 "src/expression/Expression.birch"
  libbirch_line_(455);
  #line 455 "src/expression/Expression.birch"
  libbirch_assert_(false);
}

#line 66 "src/expression/Expression.birch"
template<class Value>
#line 458 "src/expression/Expression.birch"
void birch::type::Expression<Value>::doAccumulateGrad(const libbirch::DefaultArray<birch::type::Real,2>& d, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_) {
  #line 458 "src/expression/Expression.birch"
  libbirch_function_("doAccumulateGrad", "src/expression/Expression.birch", 458);
  #line 459 "src/expression/Expression.birch"
  libbirch_line_(459);
  #line 459 "src/expression/Expression.birch"
  libbirch_assert_(false);
}

#line 66 "src/expression/Expression.birch"
template<class Value>
#line 462 "src/expression/Expression.birch"
void birch::type::Expression<Value>::doAccumulateGrad(const birch::type::Real& d, const birch::type::Integer& i, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_) {
  #line 462 "src/expression/Expression.birch"
  libbirch_function_("doAccumulateGrad", "src/expression/Expression.birch", 462);
  #line 463 "src/expression/Expression.birch"
  libbirch_line_(463);
  #line 463 "src/expression/Expression.birch"
  libbirch_assert_(false);
}

#line 66 "src/expression/Expression.birch"
template<class Value>
#line 466 "src/expression/Expression.birch"
void birch::type::Expression<Value>::doAccumulateGrad(const birch::type::Real& d, const birch::type::Integer& i, const birch::type::Integer& j, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_) {
  #line 466 "src/expression/Expression.birch"
  libbirch_function_("doAccumulateGrad", "src/expression/Expression.birch", 466);
  #line 467 "src/expression/Expression.birch"
  libbirch_line_(467);
  #line 467 "src/expression/Expression.birch"
  libbirch_assert_(false);
}

#line 66 "src/expression/Expression.birch"
template<class Value>
#line 485 "src/expression/Expression.birch"
libbirch::Optional<libbirch::Lazy<libbirch::Shared<birch::type::Beta>>> birch::type::Expression<Value>::graftBeta(const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_) {
  #line 485 "src/expression/Expression.birch"
  libbirch_function_("graftBeta", "src/expression/Expression.birch", 485);
  #line 486 "src/expression/Expression.birch"
  libbirch_line_(486);
  #line 486 "src/expression/Expression.birch"
  return libbirch::nil;
}

#line 66 "src/expression/Expression.birch"
template<class Value>
#line 494 "src/expression/Expression.birch"
libbirch::Optional<libbirch::Lazy<libbirch::Shared<birch::type::Dirichlet>>> birch::type::Expression<Value>::graftDirichlet(const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_) {
  #line 494 "src/expression/Expression.birch"
  libbirch_function_("graftDirichlet", "src/expression/Expression.birch", 494);
  #line 495 "src/expression/Expression.birch"
  libbirch_line_(495);
  #line 495 "src/expression/Expression.birch"
  return libbirch::nil;
}

#line 66 "src/expression/Expression.birch"
template<class Value>
#line 503 "src/expression/Expression.birch"
libbirch::Optional<libbirch::Lazy<libbirch::Shared<birch::type::Restaurant>>> birch::type::Expression<Value>::graftRestaurant(const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_) {
  #line 503 "src/expression/Expression.birch"
  libbirch_function_("graftRestaurant", "src/expression/Expression.birch", 503);
  #line 504 "src/expression/Expression.birch"
  libbirch_line_(504);
  #line 504 "src/expression/Expression.birch"
  return libbirch::nil;
}

#line 66 "src/expression/Expression.birch"
template<class Value>
#line 512 "src/expression/Expression.birch"
libbirch::Optional<libbirch::Lazy<libbirch::Shared<birch::type::Gamma>>> birch::type::Expression<Value>::graftGamma(const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_) {
  #line 512 "src/expression/Expression.birch"
  libbirch_function_("graftGamma", "src/expression/Expression.birch", 512);
  #line 513 "src/expression/Expression.birch"
  libbirch_line_(513);
  #line 513 "src/expression/Expression.birch"
  return libbirch::nil;
}

#line 66 "src/expression/Expression.birch"
template<class Value>
#line 521 "src/expression/Expression.birch"
libbirch::Optional<libbirch::Lazy<libbirch::Shared<birch::type::TransformLinear<libbirch::Lazy<libbirch::Shared<birch::type::Gamma>>>>>> birch::type::Expression<Value>::graftScaledGamma(const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_) {
  #line 521 "src/expression/Expression.birch"
  libbirch_function_("graftScaledGamma", "src/expression/Expression.birch", 521);
  #line 522 "src/expression/Expression.birch"
  libbirch_line_(522);
  #line 522 "src/expression/Expression.birch"
  return libbirch::nil;
}

#line 66 "src/expression/Expression.birch"
template<class Value>
#line 530 "src/expression/Expression.birch"
libbirch::Optional<libbirch::Lazy<libbirch::Shared<birch::type::InverseGamma>>> birch::type::Expression<Value>::graftInverseGamma(const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_) {
  #line 530 "src/expression/Expression.birch"
  libbirch_function_("graftInverseGamma", "src/expression/Expression.birch", 530);
  #line 531 "src/expression/Expression.birch"
  libbirch_line_(531);
  #line 531 "src/expression/Expression.birch"
  return libbirch::nil;
}

#line 66 "src/expression/Expression.birch"
template<class Value>
#line 539 "src/expression/Expression.birch"
libbirch::Optional<libbirch::Lazy<libbirch::Shared<birch::type::InverseWishart>>> birch::type::Expression<Value>::graftInverseWishart(const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_) {
  #line 539 "src/expression/Expression.birch"
  libbirch_function_("graftInverseWishart", "src/expression/Expression.birch", 539);
  #line 540 "src/expression/Expression.birch"
  libbirch_line_(540);
  #line 540 "src/expression/Expression.birch"
  return libbirch::nil;
}

#line 66 "src/expression/Expression.birch"
template<class Value>
#line 548 "src/expression/Expression.birch"
libbirch::Optional<libbirch::Lazy<libbirch::Shared<birch::type::Gaussian>>> birch::type::Expression<Value>::graftGaussian(const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_) {
  #line 548 "src/expression/Expression.birch"
  libbirch_function_("graftGaussian", "src/expression/Expression.birch", 548);
  #line 549 "src/expression/Expression.birch"
  libbirch_line_(549);
  #line 549 "src/expression/Expression.birch"
  return libbirch::nil;
}

#line 66 "src/expression/Expression.birch"
template<class Value>
#line 557 "src/expression/Expression.birch"
libbirch::Optional<libbirch::Lazy<libbirch::Shared<birch::type::TransformLinear<libbirch::Lazy<libbirch::Shared<birch::type::Gaussian>>>>>> birch::type::Expression<Value>::graftLinearGaussian(const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_) {
  #line 557 "src/expression/Expression.birch"
  libbirch_function_("graftLinearGaussian", "src/expression/Expression.birch", 557);
  #line 558 "src/expression/Expression.birch"
  libbirch_line_(558);
  #line 558 "src/expression/Expression.birch"
  return libbirch::nil;
}

#line 66 "src/expression/Expression.birch"
template<class Value>
#line 566 "src/expression/Expression.birch"
libbirch::Optional<libbirch::Lazy<libbirch::Shared<birch::type::NormalInverseGamma>>> birch::type::Expression<Value>::graftNormalInverseGamma(const libbirch::Lazy<libbirch::Shared<birch::type::Distribution<birch::type::Real>>>& compare, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_) {
  #line 566 "src/expression/Expression.birch"
  libbirch_function_("graftNormalInverseGamma", "src/expression/Expression.birch", 566);
  #line 568 "src/expression/Expression.birch"
  libbirch_line_(568);
  #line 568 "src/expression/Expression.birch"
  return libbirch::nil;
}

#line 66 "src/expression/Expression.birch"
template<class Value>
#line 576 "src/expression/Expression.birch"
libbirch::Optional<libbirch::Lazy<libbirch::Shared<birch::type::TransformLinear<libbirch::Lazy<libbirch::Shared<birch::type::NormalInverseGamma>>>>>> birch::type::Expression<Value>::graftLinearNormalInverseGamma(const libbirch::Lazy<libbirch::Shared<birch::type::Distribution<birch::type::Real>>>& compare, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_) {
  #line 576 "src/expression/Expression.birch"
  libbirch_function_("graftLinearNormalInverseGamma", "src/expression/Expression.birch", 576);
  #line 578 "src/expression/Expression.birch"
  libbirch_line_(578);
  #line 578 "src/expression/Expression.birch"
  return libbirch::nil;
}

#line 66 "src/expression/Expression.birch"
template<class Value>
#line 586 "src/expression/Expression.birch"
libbirch::Optional<libbirch::Lazy<libbirch::Shared<birch::type::MultivariateGaussian>>> birch::type::Expression<Value>::graftMultivariateGaussian(const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_) {
  #line 586 "src/expression/Expression.birch"
  libbirch_function_("graftMultivariateGaussian", "src/expression/Expression.birch", 586);
  #line 587 "src/expression/Expression.birch"
  libbirch_line_(587);
  #line 587 "src/expression/Expression.birch"
  return libbirch::nil;
}

#line 66 "src/expression/Expression.birch"
template<class Value>
#line 595 "src/expression/Expression.birch"
libbirch::Optional<libbirch::Lazy<libbirch::Shared<birch::type::TransformLinearMultivariate<libbirch::Lazy<libbirch::Shared<birch::type::MultivariateGaussian>>>>>> birch::type::Expression<Value>::graftLinearMultivariateGaussian(const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_) {
  #line 595 "src/expression/Expression.birch"
  libbirch_function_("graftLinearMultivariateGaussian", "src/expression/Expression.birch", 595);
  #line 597 "src/expression/Expression.birch"
  libbirch_line_(597);
  #line 597 "src/expression/Expression.birch"
  return libbirch::nil;
}

#line 66 "src/expression/Expression.birch"
template<class Value>
#line 605 "src/expression/Expression.birch"
libbirch::Optional<libbirch::Lazy<libbirch::Shared<birch::type::TransformDot<libbirch::Lazy<libbirch::Shared<birch::type::MultivariateGaussian>>>>>> birch::type::Expression<Value>::graftDotMultivariateGaussian(const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_) {
  #line 605 "src/expression/Expression.birch"
  libbirch_function_("graftDotMultivariateGaussian", "src/expression/Expression.birch", 605);
  #line 607 "src/expression/Expression.birch"
  libbirch_line_(607);
  #line 607 "src/expression/Expression.birch"
  return libbirch::nil;
}

#line 66 "src/expression/Expression.birch"
template<class Value>
#line 615 "src/expression/Expression.birch"
libbirch::Optional<libbirch::Lazy<libbirch::Shared<birch::type::MultivariateNormalInverseGamma>>> birch::type::Expression<Value>::graftMultivariateNormalInverseGamma(const libbirch::Lazy<libbirch::Shared<birch::type::Distribution<birch::type::Real>>>& compare, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_) {
  #line 615 "src/expression/Expression.birch"
  libbirch_function_("graftMultivariateNormalInverseGamma", "src/expression/Expression.birch", 615);
  #line 617 "src/expression/Expression.birch"
  libbirch_line_(617);
  #line 617 "src/expression/Expression.birch"
  return libbirch::nil;
}

#line 66 "src/expression/Expression.birch"
template<class Value>
#line 625 "src/expression/Expression.birch"
libbirch::Optional<libbirch::Lazy<libbirch::Shared<birch::type::TransformLinearMultivariate<libbirch::Lazy<libbirch::Shared<birch::type::MultivariateNormalInverseGamma>>>>>> birch::type::Expression<Value>::graftLinearMultivariateNormalInverseGamma(const libbirch::Lazy<libbirch::Shared<birch::type::Distribution<birch::type::Real>>>& compare, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_) {
  #line 625 "src/expression/Expression.birch"
  libbirch_function_("graftLinearMultivariateNormalInverseGamma", "src/expression/Expression.birch", 625);
  #line 627 "src/expression/Expression.birch"
  libbirch_line_(627);
  #line 627 "src/expression/Expression.birch"
  return libbirch::nil;
}

#line 66 "src/expression/Expression.birch"
template<class Value>
#line 635 "src/expression/Expression.birch"
libbirch::Optional<libbirch::Lazy<libbirch::Shared<birch::type::TransformDot<libbirch::Lazy<libbirch::Shared<birch::type::MultivariateNormalInverseGamma>>>>>> birch::type::Expression<Value>::graftDotMultivariateNormalInverseGamma(const libbirch::Lazy<libbirch::Shared<birch::type::Distribution<birch::type::Real>>>& compare, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_) {
  #line 635 "src/expression/Expression.birch"
  libbirch_function_("graftDotMultivariateNormalInverseGamma", "src/expression/Expression.birch", 635);
  #line 637 "src/expression/Expression.birch"
  libbirch_line_(637);
  #line 637 "src/expression/Expression.birch"
  return libbirch::nil;
}

#line 66 "src/expression/Expression.birch"
template<class Value>
#line 645 "src/expression/Expression.birch"
libbirch::Optional<libbirch::Lazy<libbirch::Shared<birch::type::MatrixGaussian>>> birch::type::Expression<Value>::graftMatrixGaussian(const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_) {
  #line 645 "src/expression/Expression.birch"
  libbirch_function_("graftMatrixGaussian", "src/expression/Expression.birch", 645);
  #line 646 "src/expression/Expression.birch"
  libbirch_line_(646);
  #line 646 "src/expression/Expression.birch"
  return libbirch::nil;
}

#line 66 "src/expression/Expression.birch"
template<class Value>
#line 654 "src/expression/Expression.birch"
libbirch::Optional<libbirch::Lazy<libbirch::Shared<birch::type::TransformLinearMatrix<libbirch::Lazy<libbirch::Shared<birch::type::MatrixGaussian>>>>>> birch::type::Expression<Value>::graftLinearMatrixGaussian(const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_) {
  #line 654 "src/expression/Expression.birch"
  libbirch_function_("graftLinearMatrixGaussian", "src/expression/Expression.birch", 654);
  #line 656 "src/expression/Expression.birch"
  libbirch_line_(656);
  #line 656 "src/expression/Expression.birch"
  return libbirch::nil;
}

#line 66 "src/expression/Expression.birch"
template<class Value>
#line 664 "src/expression/Expression.birch"
libbirch::Optional<libbirch::Lazy<libbirch::Shared<birch::type::TransformDotMultivariate<libbirch::Lazy<libbirch::Shared<birch::type::MatrixGaussian>>>>>> birch::type::Expression<Value>::graftDotMatrixGaussian(const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_) {
  #line 664 "src/expression/Expression.birch"
  libbirch_function_("graftDotMatrixGaussian", "src/expression/Expression.birch", 664);
  #line 666 "src/expression/Expression.birch"
  libbirch_line_(666);
  #line 666 "src/expression/Expression.birch"
  return libbirch::nil;
}

#line 66 "src/expression/Expression.birch"
template<class Value>
#line 674 "src/expression/Expression.birch"
libbirch::Optional<libbirch::Lazy<libbirch::Shared<birch::type::MatrixNormalInverseWishart>>> birch::type::Expression<Value>::graftMatrixNormalInverseWishart(const libbirch::Lazy<libbirch::Shared<birch::type::Distribution<birch::type::LLT>>>& compare, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_) {
  #line 674 "src/expression/Expression.birch"
  libbirch_function_("graftMatrixNormalInverseWishart", "src/expression/Expression.birch", 674);
  #line 676 "src/expression/Expression.birch"
  libbirch_line_(676);
  #line 676 "src/expression/Expression.birch"
  return libbirch::nil;
}

#line 66 "src/expression/Expression.birch"
template<class Value>
#line 684 "src/expression/Expression.birch"
libbirch::Optional<libbirch::Lazy<libbirch::Shared<birch::type::TransformLinearMatrix<libbirch::Lazy<libbirch::Shared<birch::type::MatrixNormalInverseWishart>>>>>> birch::type::Expression<Value>::graftLinearMatrixNormalInverseWishart(const libbirch::Lazy<libbirch::Shared<birch::type::Distribution<birch::type::LLT>>>& compare, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_) {
  #line 684 "src/expression/Expression.birch"
  libbirch_function_("graftLinearMatrixNormalInverseWishart", "src/expression/Expression.birch", 684);
  #line 686 "src/expression/Expression.birch"
  libbirch_line_(686);
  #line 686 "src/expression/Expression.birch"
  return libbirch::nil;
}

#line 66 "src/expression/Expression.birch"
template<class Value>
#line 694 "src/expression/Expression.birch"
libbirch::Optional<libbirch::Lazy<libbirch::Shared<birch::type::TransformDotMultivariate<libbirch::Lazy<libbirch::Shared<birch::type::MatrixNormalInverseWishart>>>>>> birch::type::Expression<Value>::graftDotMatrixNormalInverseWishart(const libbirch::Lazy<libbirch::Shared<birch::type::Distribution<birch::type::LLT>>>& compare, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_) {
  #line 694 "src/expression/Expression.birch"
  libbirch_function_("graftDotMatrixNormalInverseWishart", "src/expression/Expression.birch", 694);
  #line 696 "src/expression/Expression.birch"
  libbirch_line_(696);
  #line 696 "src/expression/Expression.birch"
  return libbirch::nil;
}

#line 66 "src/expression/Expression.birch"
template<class Value>
#line 704 "src/expression/Expression.birch"
libbirch::Optional<libbirch::Lazy<libbirch::Shared<birch::type::Discrete>>> birch::type::Expression<Value>::graftDiscrete(const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_) {
  #line 704 "src/expression/Expression.birch"
  libbirch_function_("graftDiscrete", "src/expression/Expression.birch", 704);
  #line 705 "src/expression/Expression.birch"
  libbirch_line_(705);
  #line 705 "src/expression/Expression.birch"
  return libbirch::nil;
}

#line 66 "src/expression/Expression.birch"
template<class Value>
#line 713 "src/expression/Expression.birch"
libbirch::Optional<libbirch::Lazy<libbirch::Shared<birch::type::BoundedDiscrete>>> birch::type::Expression<Value>::graftBoundedDiscrete(const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_) {
  #line 713 "src/expression/Expression.birch"
  libbirch_function_("graftBoundedDiscrete", "src/expression/Expression.birch", 713);
  #line 714 "src/expression/Expression.birch"
  libbirch_line_(714);
  #line 714 "src/expression/Expression.birch"
  return libbirch::nil;
}

#line 66 "src/expression/Expression.birch"
template<class Value>
#line 717 "src/expression/Expression.birch"
void birch::type::Expression<Value>::write(const libbirch::Lazy<libbirch::Shared<birch::type::Buffer>>& buffer, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_) {
  #line 717 "src/expression/Expression.birch"
  libbirch_function_("write", "src/expression/Expression.birch", 717);
  #line 718 "src/expression/Expression.birch"
  libbirch_line_(718);
  #line 718 "src/expression/Expression.birch"
  buffer->set(this_()->value(handler_), handler_);
}

#line 4 "src/expression/LogDet.birch"
template<class Argument,class ArgumentValue>
#line 4 "src/expression/LogDet.birch"
birch::type::LogDet<Argument, ArgumentValue>::LogDet(const Argument& y, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_) :
    #line 4 "src/expression/LogDet.birch"
    super_type_(y) {
  //
}

#line 4 "src/expression/LogDet.birch"
template<class Argument,class ArgumentValue>
#line 6 "src/expression/LogDet.birch"
birch::type::Real birch::type::LogDet<Argument, ArgumentValue>::doEvaluate(const ArgumentValue& y, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_) {
  #line 6 "src/expression/LogDet.birch"
  libbirch_function_("doEvaluate", "src/expression/LogDet.birch", 6);
  #line 7 "src/expression/LogDet.birch"
  libbirch_line_(7);
  #line 7 "src/expression/LogDet.birch"
  return birch::ldet(y, handler_);
}

#line 4 "src/expression/LogDet.birch"
template<class Argument,class ArgumentValue>
#line 10 "src/expression/LogDet.birch"
libbirch::DefaultArray<birch::type::Real,2> birch::type::LogDet<Argument, ArgumentValue>::doEvaluateGrad(const birch::type::Real& d, const birch::type::Real& x, const ArgumentValue& y, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_) {
  #line 10 "src/expression/LogDet.birch"
  libbirch_function_("doEvaluateGrad", "src/expression/LogDet.birch", 10);
  #line 12 "src/expression/LogDet.birch"
  libbirch_line_(12);
  #line 12 "src/expression/LogDet.birch"
  return d * birch::canonical(birch::inv(birch::transpose(y, handler_), handler_), handler_);
}

#line 18 "src/expression/MatrixBinaryExpression.birch"
template<class Left,class Right,class LeftValue,class RightValue,class LeftGradient,class RightGradient,class Value>
#line 18 "src/expression/MatrixBinaryExpression.birch"
birch::type::MatrixBinaryExpression<Left, Right, LeftValue, RightValue, LeftGradient, RightGradient, Value>::MatrixBinaryExpression(const Left& y, const Right& z, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_) :
    #line 18 "src/expression/MatrixBinaryExpression.birch"
    super_type_(),
    #line 24 "src/expression/MatrixBinaryExpression.birch"
    y(y),
    #line 29 "src/expression/MatrixBinaryExpression.birch"
    z(z) {
  //
}

#line 18 "src/expression/MatrixBinaryExpression.birch"
template<class Left,class Right,class LeftValue,class RightValue,class LeftGradient,class RightGradient,class Value>
#line 49 "src/expression/MatrixBinaryExpression.birch"
birch::type::Integer birch::type::MatrixBinaryExpression<Left, Right, LeftValue, RightValue, LeftGradient, RightGradient, Value>::doDepth(const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_) {
  #line 49 "src/expression/MatrixBinaryExpression.birch"
  libbirch_function_("doDepth", "src/expression/MatrixBinaryExpression.birch", 49);
  #line 50 "src/expression/MatrixBinaryExpression.birch"
  libbirch_line_(50);
  #line 50 "src/expression/MatrixBinaryExpression.birch"
  return birch::max(this_()->y.get()->depth(handler_), this_()->z.get()->depth(handler_), handler_) + birch::type::Integer(1);
}

#line 18 "src/expression/MatrixBinaryExpression.birch"
template<class Left,class Right,class LeftValue,class RightValue,class LeftGradient,class RightGradient,class Value>
#line 53 "src/expression/MatrixBinaryExpression.birch"
Value birch::type::MatrixBinaryExpression<Left, Right, LeftValue, RightValue, LeftGradient, RightGradient, Value>::doValue(const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_) {
  #line 53 "src/expression/MatrixBinaryExpression.birch"
  libbirch_function_("doValue", "src/expression/MatrixBinaryExpression.birch", 53);
  #line 54 "src/expression/MatrixBinaryExpression.birch"
  libbirch_line_(54);
  #line 54 "src/expression/MatrixBinaryExpression.birch"
  return this_()->doEvaluate(this_()->y.get()->value(handler_), this_()->z.get()->value(handler_), handler_);
}

#line 18 "src/expression/MatrixBinaryExpression.birch"
template<class Left,class Right,class LeftValue,class RightValue,class LeftGradient,class RightGradient,class Value>
#line 57 "src/expression/MatrixBinaryExpression.birch"
Value birch::type::MatrixBinaryExpression<Left, Right, LeftValue, RightValue, LeftGradient, RightGradient, Value>::doPilot(const birch::type::Integer& gen, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_) {
  #line 57 "src/expression/MatrixBinaryExpression.birch"
  libbirch_function_("doPilot", "src/expression/MatrixBinaryExpression.birch", 57);
  #line 58 "src/expression/MatrixBinaryExpression.birch"
  libbirch_line_(58);
  #line 58 "src/expression/MatrixBinaryExpression.birch"
  return this_()->doEvaluate(this_()->y.get()->pilot(gen, handler_), this_()->z.get()->pilot(gen, handler_), handler_);
}

#line 18 "src/expression/MatrixBinaryExpression.birch"
template<class Left,class Right,class LeftValue,class RightValue,class LeftGradient,class RightGradient,class Value>
#line 61 "src/expression/MatrixBinaryExpression.birch"
Value birch::type::MatrixBinaryExpression<Left, Right, LeftValue, RightValue, LeftGradient, RightGradient, Value>::doGet(const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_) {
  #line 61 "src/expression/MatrixBinaryExpression.birch"
  libbirch_function_("doGet", "src/expression/MatrixBinaryExpression.birch", 61);
  #line 62 "src/expression/MatrixBinaryExpression.birch"
  libbirch_line_(62);
  #line 62 "src/expression/MatrixBinaryExpression.birch"
  return this_()->doEvaluate(this_()->y.get()->get(handler_), this_()->z.get()->get(handler_), handler_);
}

#line 18 "src/expression/MatrixBinaryExpression.birch"
template<class Left,class Right,class LeftValue,class RightValue,class LeftGradient,class RightGradient,class Value>
#line 65 "src/expression/MatrixBinaryExpression.birch"
Value birch::type::MatrixBinaryExpression<Left, Right, LeftValue, RightValue, LeftGradient, RightGradient, Value>::doMove(const birch::type::Integer& gen, const libbirch::Lazy<libbirch::Shared<birch::type::Kernel>>& _u0954, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_) {
  #line 65 "src/expression/MatrixBinaryExpression.birch"
  libbirch_function_("doMove", "src/expression/MatrixBinaryExpression.birch", 65);
  #line 66 "src/expression/MatrixBinaryExpression.birch"
  libbirch_line_(66);
  #line 66 "src/expression/MatrixBinaryExpression.birch"
  return this_()->doEvaluate(this_()->y.get()->move(gen, _u0954, handler_), this_()->z.get()->move(gen, _u0954, handler_), handler_);
}

#line 18 "src/expression/MatrixBinaryExpression.birch"
template<class Left,class Right,class LeftValue,class RightValue,class LeftGradient,class RightGradient,class Value>
#line 69 "src/expression/MatrixBinaryExpression.birch"
void birch::type::MatrixBinaryExpression<Left, Right, LeftValue, RightValue, LeftGradient, RightGradient, Value>::doGrad(const birch::type::Integer& gen, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_) {
  #line 69 "src/expression/MatrixBinaryExpression.birch"
  libbirch_function_("doGrad", "src/expression/MatrixBinaryExpression.birch", 69);
  #line 70 "src/expression/MatrixBinaryExpression.birch"
  libbirch_line_(70);
  #line 70 "src/expression/MatrixBinaryExpression.birch"
  this_()->y.get()->grad(gen, this_()->doEvaluateGradLeft(this_()->d.get(), this_()->x.get(), this_()->y.get()->get(handler_), this_()->z.get()->get(handler_), handler_), handler_);
  #line 71 "src/expression/MatrixBinaryExpression.birch"
  libbirch_line_(71);
  #line 71 "src/expression/MatrixBinaryExpression.birch"
  this_()->z.get()->grad(gen, this_()->doEvaluateGradRight(this_()->d.get(), this_()->x.get(), this_()->y.get()->get(handler_), this_()->z.get()->get(handler_), handler_), handler_);
}

#line 18 "src/expression/MatrixBinaryExpression.birch"
template<class Left,class Right,class LeftValue,class RightValue,class LeftGradient,class RightGradient,class Value>
#line 74 "src/expression/MatrixBinaryExpression.birch"
libbirch::Optional<libbirch::Lazy<libbirch::Shared<birch::type::Expression<birch::type::Real>>>> birch::type::MatrixBinaryExpression<Left, Right, LeftValue, RightValue, LeftGradient, RightGradient, Value>::doPrior(const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_) {
  #line 74 "src/expression/MatrixBinaryExpression.birch"
  libbirch_function_("doPrior", "src/expression/MatrixBinaryExpression.birch", 74);
  #line 75 "src/expression/MatrixBinaryExpression.birch"
  libbirch_line_(75);
  #line 75 "src/expression/MatrixBinaryExpression.birch"
  auto l = this_()->y.get()->prior(handler_);
  #line 76 "src/expression/MatrixBinaryExpression.birch"
  libbirch_line_(76);
  #line 76 "src/expression/MatrixBinaryExpression.birch"
  auto r = this_()->z.get()->prior(handler_);
  #line 77 "src/expression/MatrixBinaryExpression.birch"
  libbirch_line_(77);
  #line 77 "src/expression/MatrixBinaryExpression.birch"
  if (l.query() && r.query()) {
    #line 78 "src/expression/MatrixBinaryExpression.birch"
    libbirch_line_(78);
    #line 78 "src/expression/MatrixBinaryExpression.birch"
    return l.get() + r.get();
  } else {
    #line 79 "src/expression/MatrixBinaryExpression.birch"
    libbirch_line_(79);
    #line 79 "src/expression/MatrixBinaryExpression.birch"
    if (l.query()) {
      #line 80 "src/expression/MatrixBinaryExpression.birch"
      libbirch_line_(80);
      #line 80 "src/expression/MatrixBinaryExpression.birch"
      return l.get();
    } else {
      #line 81 "src/expression/MatrixBinaryExpression.birch"
      libbirch_line_(81);
      #line 81 "src/expression/MatrixBinaryExpression.birch"
      if (r.query()) {
        #line 82 "src/expression/MatrixBinaryExpression.birch"
        libbirch_line_(82);
        #line 82 "src/expression/MatrixBinaryExpression.birch"
        return r.get();
      } else {
        #line 84 "src/expression/MatrixBinaryExpression.birch"
        libbirch_line_(84);
        #line 84 "src/expression/MatrixBinaryExpression.birch"
        return libbirch::nil;
      }
    }
  }
}

#line 18 "src/expression/MatrixBinaryExpression.birch"
template<class Left,class Right,class LeftValue,class RightValue,class LeftGradient,class RightGradient,class Value>
#line 88 "src/expression/MatrixBinaryExpression.birch"
birch::type::Real birch::type::MatrixBinaryExpression<Left, Right, LeftValue, RightValue, LeftGradient, RightGradient, Value>::doCompare(const birch::type::Integer& gen, const libbirch::Lazy<libbirch::Shared<birch::type::DelayExpression>>& x, const libbirch::Lazy<libbirch::Shared<birch::type::Kernel>>& _u0954, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_) {
  #line 88 "src/expression/MatrixBinaryExpression.birch"
  libbirch_function_("doCompare", "src/expression/MatrixBinaryExpression.birch", 88);
  #line 90 "src/expression/MatrixBinaryExpression.birch"
  libbirch_line_(90);
  #line 90 "src/expression/MatrixBinaryExpression.birch"
  auto o = libbirch::cast<libbirch::Lazy<libbirch::Shared<birch::type::MatrixBinaryExpression<Left, Right, LeftValue, RightValue, LeftGradient, RightGradient, Value>>>>(x).get();
  #line 92 "src/expression/MatrixBinaryExpression.birch"
  libbirch_line_(92);
  #line 92 "src/expression/MatrixBinaryExpression.birch"
  return this_()->y.get()->compare(gen, o->y.get(), _u0954, handler_) + this_()->z.get()->compare(gen, o->z.get(), _u0954, handler_);
}

#line 18 "src/expression/MatrixBinaryExpression.birch"
template<class Left,class Right,class LeftValue,class RightValue,class LeftGradient,class RightGradient,class Value>
#line 95 "src/expression/MatrixBinaryExpression.birch"
void birch::type::MatrixBinaryExpression<Left, Right, LeftValue, RightValue, LeftGradient, RightGradient, Value>::doConstant(const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_) {
  #line 95 "src/expression/MatrixBinaryExpression.birch"
  libbirch_function_("doConstant", "src/expression/MatrixBinaryExpression.birch", 95);
  #line 96 "src/expression/MatrixBinaryExpression.birch"
  libbirch_line_(96);
  #line 96 "src/expression/MatrixBinaryExpression.birch"
  this_()->y.get()->constant(handler_);
  #line 97 "src/expression/MatrixBinaryExpression.birch"
  libbirch_line_(97);
  #line 97 "src/expression/MatrixBinaryExpression.birch"
  this_()->z.get()->constant(handler_);
}

#line 18 "src/expression/MatrixBinaryExpression.birch"
template<class Left,class Right,class LeftValue,class RightValue,class LeftGradient,class RightGradient,class Value>
#line 100 "src/expression/MatrixBinaryExpression.birch"
void birch::type::MatrixBinaryExpression<Left, Right, LeftValue, RightValue, LeftGradient, RightGradient, Value>::doCount(const birch::type::Integer& gen, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_) {
  #line 100 "src/expression/MatrixBinaryExpression.birch"
  libbirch_function_("doCount", "src/expression/MatrixBinaryExpression.birch", 100);
  #line 101 "src/expression/MatrixBinaryExpression.birch"
  libbirch_line_(101);
  #line 101 "src/expression/MatrixBinaryExpression.birch"
  this_()->y.get()->count(gen, handler_);
  #line 102 "src/expression/MatrixBinaryExpression.birch"
  libbirch_line_(102);
  #line 102 "src/expression/MatrixBinaryExpression.birch"
  this_()->z.get()->count(gen, handler_);
}

#line 18 "src/expression/MatrixBinaryExpression.birch"
template<class Left,class Right,class LeftValue,class RightValue,class LeftGradient,class RightGradient,class Value>
#line 105 "src/expression/MatrixBinaryExpression.birch"
void birch::type::MatrixBinaryExpression<Left, Right, LeftValue, RightValue, LeftGradient, RightGradient, Value>::doDetach(const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_) {
  #line 105 "src/expression/MatrixBinaryExpression.birch"
  libbirch_function_("doDetach", "src/expression/MatrixBinaryExpression.birch", 105);
  #line 106 "src/expression/MatrixBinaryExpression.birch"
  libbirch_line_(106);
  #line 106 "src/expression/MatrixBinaryExpression.birch"
  this_()->y = libbirch::nil;
  #line 107 "src/expression/MatrixBinaryExpression.birch"
  libbirch_line_(107);
  #line 107 "src/expression/MatrixBinaryExpression.birch"
  this_()->z = libbirch::nil;
}

#line 4 "src/expression/MatrixCanonical.birch"
template<class Argument,class ArgumentValue>
#line 4 "src/expression/MatrixCanonical.birch"
birch::type::MatrixCanonical<Argument, ArgumentValue>::MatrixCanonical(const Argument& y, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_) :
    #line 4 "src/expression/MatrixCanonical.birch"
    super_type_(y) {
  //
}

#line 4 "src/expression/MatrixCanonical.birch"
template<class Argument,class ArgumentValue>
#line 6 "src/expression/MatrixCanonical.birch"
birch::type::Integer birch::type::MatrixCanonical<Argument, ArgumentValue>::doRows(const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_) {
  #line 6 "src/expression/MatrixCanonical.birch"
  libbirch_function_("doRows", "src/expression/MatrixCanonical.birch", 6);
  #line 7 "src/expression/MatrixCanonical.birch"
  libbirch_line_(7);
  #line 7 "src/expression/MatrixCanonical.birch"
  return this_()->y.get()->rows(handler_);
}

#line 4 "src/expression/MatrixCanonical.birch"
template<class Argument,class ArgumentValue>
#line 10 "src/expression/MatrixCanonical.birch"
birch::type::Integer birch::type::MatrixCanonical<Argument, ArgumentValue>::doColumns(const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_) {
  #line 10 "src/expression/MatrixCanonical.birch"
  libbirch_function_("doColumns", "src/expression/MatrixCanonical.birch", 10);
  #line 11 "src/expression/MatrixCanonical.birch"
  libbirch_line_(11);
  #line 11 "src/expression/MatrixCanonical.birch"
  return this_()->y.get()->columns(handler_);
}

#line 4 "src/expression/MatrixCanonical.birch"
template<class Argument,class ArgumentValue>
#line 14 "src/expression/MatrixCanonical.birch"
libbirch::DefaultArray<birch::type::Real,2> birch::type::MatrixCanonical<Argument, ArgumentValue>::doEvaluate(const ArgumentValue& y, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_) {
  #line 14 "src/expression/MatrixCanonical.birch"
  libbirch_function_("doEvaluate", "src/expression/MatrixCanonical.birch", 14);
  #line 15 "src/expression/MatrixCanonical.birch"
  libbirch_line_(15);
  #line 15 "src/expression/MatrixCanonical.birch"
  return birch::canonical(y, handler_);
}

#line 4 "src/expression/MatrixCanonical.birch"
template<class Argument,class ArgumentValue>
#line 18 "src/expression/MatrixCanonical.birch"
libbirch::DefaultArray<birch::type::Real,2> birch::type::MatrixCanonical<Argument, ArgumentValue>::doEvaluateGrad(const libbirch::DefaultArray<birch::type::Real,2>& d, const libbirch::DefaultArray<birch::type::Real,2>& x, const ArgumentValue& y, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_) {
  #line 18 "src/expression/MatrixCanonical.birch"
  libbirch_function_("doEvaluateGrad", "src/expression/MatrixCanonical.birch", 18);
  #line 20 "src/expression/MatrixCanonical.birch"
  libbirch_line_(20);
  #line 20 "src/expression/MatrixCanonical.birch"
  return d;
}

#line 4 "src/expression/MatrixElement.birch"
template<class Value>
#line 4 "src/expression/MatrixElement.birch"
birch::type::MatrixElement<Value>::MatrixElement(const libbirch::Lazy<libbirch::Shared<birch::type::Expression<libbirch::DefaultArray<Value,2>>>>& y, const birch::type::Integer& i, const birch::type::Integer& j, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_) :
    #line 4 "src/expression/MatrixElement.birch"
    super_type_(),
    #line 9 "src/expression/MatrixElement.birch"
    y(y),
    #line 14 "src/expression/MatrixElement.birch"
    i(i),
    #line 19 "src/expression/MatrixElement.birch"
    j(j) {
  //
}

#line 4 "src/expression/MatrixElement.birch"
template<class Value>
#line 21 "src/expression/MatrixElement.birch"
birch::type::Integer birch::type::MatrixElement<Value>::doDepth(const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_) {
  #line 21 "src/expression/MatrixElement.birch"
  libbirch_function_("doDepth", "src/expression/MatrixElement.birch", 21);
  #line 22 "src/expression/MatrixElement.birch"
  libbirch_line_(22);
  #line 22 "src/expression/MatrixElement.birch"
  return this_()->y.get()->depth(handler_) + birch::type::Integer(1);
}

#line 4 "src/expression/MatrixElement.birch"
template<class Value>
#line 25 "src/expression/MatrixElement.birch"
Value birch::type::MatrixElement<Value>::doValue(const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_) {
  #line 25 "src/expression/MatrixElement.birch"
  libbirch_function_("doValue", "src/expression/MatrixElement.birch", 25);
  #line 26 "src/expression/MatrixElement.birch"
  libbirch_line_(26);
  #line 26 "src/expression/MatrixElement.birch"
  return this_()->y.get()->value(handler_).get(libbirch::make_slice(this_()->i - 1, this_()->j - 1));
}

#line 4 "src/expression/MatrixElement.birch"
template<class Value>
#line 29 "src/expression/MatrixElement.birch"
Value birch::type::MatrixElement<Value>::doPilot(const birch::type::Integer& gen, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_) {
  #line 29 "src/expression/MatrixElement.birch"
  libbirch_function_("doPilot", "src/expression/MatrixElement.birch", 29);
  #line 30 "src/expression/MatrixElement.birch"
  libbirch_line_(30);
  #line 30 "src/expression/MatrixElement.birch"
  return this_()->y.get()->pilot(gen, handler_).get(libbirch::make_slice(this_()->i - 1, this_()->j - 1));
}

#line 4 "src/expression/MatrixElement.birch"
template<class Value>
#line 33 "src/expression/MatrixElement.birch"
Value birch::type::MatrixElement<Value>::doGet(const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_) {
  #line 33 "src/expression/MatrixElement.birch"
  libbirch_function_("doGet", "src/expression/MatrixElement.birch", 33);
  #line 34 "src/expression/MatrixElement.birch"
  libbirch_line_(34);
  #line 34 "src/expression/MatrixElement.birch"
  return this_()->y.get()->get(handler_).get(libbirch::make_slice(this_()->i - 1, this_()->j - 1));
}

#line 4 "src/expression/MatrixElement.birch"
template<class Value>
#line 37 "src/expression/MatrixElement.birch"
Value birch::type::MatrixElement<Value>::doMove(const birch::type::Integer& gen, const libbirch::Lazy<libbirch::Shared<birch::type::Kernel>>& _u0954, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_) {
  #line 37 "src/expression/MatrixElement.birch"
  libbirch_function_("doMove", "src/expression/MatrixElement.birch", 37);
  #line 38 "src/expression/MatrixElement.birch"
  libbirch_line_(38);
  #line 38 "src/expression/MatrixElement.birch"
  return this_()->y.get()->move(gen, _u0954, handler_).get(libbirch::make_slice(this_()->i - 1, this_()->j - 1));
}

#line 4 "src/expression/MatrixElement.birch"
template<class Value>
#line 41 "src/expression/MatrixElement.birch"
void birch::type::MatrixElement<Value>::doGrad(const birch::type::Integer& gen, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_) {
  #line 41 "src/expression/MatrixElement.birch"
  libbirch_function_("doGrad", "src/expression/MatrixElement.birch", 41);
  #line 42 "src/expression/MatrixElement.birch"
  libbirch_line_(42);
  #line 42 "src/expression/MatrixElement.birch"
  this_()->y.get()->grad(gen, this_()->d.get(), this_()->i, this_()->j, handler_);
}

#line 4 "src/expression/MatrixElement.birch"
template<class Value>
#line 45 "src/expression/MatrixElement.birch"
libbirch::Optional<libbirch::Lazy<libbirch::Shared<birch::type::Expression<birch::type::Real>>>> birch::type::MatrixElement<Value>::doPrior(const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_) {
  #line 45 "src/expression/MatrixElement.birch"
  libbirch_function_("doPrior", "src/expression/MatrixElement.birch", 45);
  #line 46 "src/expression/MatrixElement.birch"
  libbirch_line_(46);
  #line 46 "src/expression/MatrixElement.birch"
  return this_()->y.get()->prior(handler_);
}

#line 4 "src/expression/MatrixElement.birch"
template<class Value>
#line 49 "src/expression/MatrixElement.birch"
birch::type::Real birch::type::MatrixElement<Value>::doCompare(const birch::type::Integer& gen, const libbirch::Lazy<libbirch::Shared<birch::type::DelayExpression>>& x, const libbirch::Lazy<libbirch::Shared<birch::type::Kernel>>& _u0954, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_) {
  #line 49 "src/expression/MatrixElement.birch"
  libbirch_function_("doCompare", "src/expression/MatrixElement.birch", 49);
  #line 51 "src/expression/MatrixElement.birch"
  libbirch_line_(51);
  #line 51 "src/expression/MatrixElement.birch"
  auto o = libbirch::cast<libbirch::Lazy<libbirch::Shared<birch::type::MatrixElement<Value>>>>(x).get();
  #line 52 "src/expression/MatrixElement.birch"
  libbirch_line_(52);
  #line 52 "src/expression/MatrixElement.birch"
  return this_()->y.get()->compare(gen, o->y.get(), _u0954, handler_);
}

#line 4 "src/expression/MatrixElement.birch"
template<class Value>
#line 55 "src/expression/MatrixElement.birch"
void birch::type::MatrixElement<Value>::doConstant(const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_) {
  #line 55 "src/expression/MatrixElement.birch"
  libbirch_function_("doConstant", "src/expression/MatrixElement.birch", 55);
  #line 56 "src/expression/MatrixElement.birch"
  libbirch_line_(56);
  #line 56 "src/expression/MatrixElement.birch"
  this_()->y.get()->constant(handler_);
}

#line 4 "src/expression/MatrixElement.birch"
template<class Value>
#line 59 "src/expression/MatrixElement.birch"
void birch::type::MatrixElement<Value>::doCount(const birch::type::Integer& gen, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_) {
  #line 59 "src/expression/MatrixElement.birch"
  libbirch_function_("doCount", "src/expression/MatrixElement.birch", 59);
  #line 60 "src/expression/MatrixElement.birch"
  libbirch_line_(60);
  #line 60 "src/expression/MatrixElement.birch"
  this_()->y.get()->count(gen, handler_);
}

#line 4 "src/expression/MatrixElement.birch"
template<class Value>
#line 63 "src/expression/MatrixElement.birch"
void birch::type::MatrixElement<Value>::doDetach(const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_) {
  #line 63 "src/expression/MatrixElement.birch"
  libbirch_function_("doDetach", "src/expression/MatrixElement.birch", 63);
  #line 64 "src/expression/MatrixElement.birch"
  libbirch_line_(64);
  #line 64 "src/expression/MatrixElement.birch"
  this_()->y = libbirch::nil;
}

#line 6 "src/expression/MatrixExpression.birch"
template<class Value>
#line 6 "src/expression/MatrixExpression.birch"
birch::type::MatrixExpression<Value>::MatrixExpression(const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_) :
    #line 6 "src/expression/MatrixExpression.birch"
    super_type_(libbirch::nil),
    #line 10 "src/expression/MatrixExpression.birch"
    d() {
  //
}

#line 6 "src/expression/MatrixExpression.birch"
template<class Value>
#line 12 "src/expression/MatrixExpression.birch"
void birch::type::MatrixExpression<Value>::doAccumulateGrad(const libbirch::DefaultArray<birch::type::Real,2>& d, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_) {
  #line 12 "src/expression/MatrixExpression.birch"
  libbirch_function_("doAccumulateGrad", "src/expression/MatrixExpression.birch", 12);
  #line 13 "src/expression/MatrixExpression.birch"
  libbirch_line_(13);
  #line 13 "src/expression/MatrixExpression.birch"
  if (this_()->d.query()) {
    #line 14 "src/expression/MatrixExpression.birch"
    libbirch_line_(14);
    #line 14 "src/expression/MatrixExpression.birch"
    this_()->d = this_()->d.get() + d;
  } else {
    #line 16 "src/expression/MatrixExpression.birch"
    libbirch_line_(16);
    #line 16 "src/expression/MatrixExpression.birch"
    this_()->d = d;
  }
}

#line 6 "src/expression/MatrixExpression.birch"
template<class Value>
#line 20 "src/expression/MatrixExpression.birch"
void birch::type::MatrixExpression<Value>::doAccumulateGrad(const birch::type::Real& d, const birch::type::Integer& i, const birch::type::Integer& j, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_) {
  #line 20 "src/expression/MatrixExpression.birch"
  libbirch_function_("doAccumulateGrad", "src/expression/MatrixExpression.birch", 20);
  #line 21 "src/expression/MatrixExpression.birch"
  libbirch_line_(21);
  #line 21 "src/expression/MatrixExpression.birch"
  if (!this_()->d.query()) {
    #line 22 "src/expression/MatrixExpression.birch"
    libbirch_line_(22);
    #line 22 "src/expression/MatrixExpression.birch"
    this_()->d = birch::matrix(0.0, this_()->rows(handler_), this_()->columns(handler_), handler_);
  }
  #line 24 "src/expression/MatrixExpression.birch"
  libbirch_line_(24);
  #line 24 "src/expression/MatrixExpression.birch"
  this_()->d.get().set(libbirch::make_slice(i - 1, j - 1), this_()->d.get().get(libbirch::make_slice(i - 1, j - 1)) + d);
}

#line 6 "src/expression/MatrixExpression.birch"
template<class Value>
#line 27 "src/expression/MatrixExpression.birch"
void birch::type::MatrixExpression<Value>::doClearGrad(const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_) {
  #line 27 "src/expression/MatrixExpression.birch"
  libbirch_function_("doClearGrad", "src/expression/MatrixExpression.birch", 27);
  #line 28 "src/expression/MatrixExpression.birch"
  libbirch_line_(28);
  #line 28 "src/expression/MatrixExpression.birch"
  this_()->d = libbirch::nil;
}

#line 4 "src/expression/MatrixInv.birch"
template<class Argument,class ArgumentValue,class Value>
#line 4 "src/expression/MatrixInv.birch"
birch::type::MatrixInv<Argument, ArgumentValue, Value>::MatrixInv(const Argument& y, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_) :
    #line 4 "src/expression/MatrixInv.birch"
    super_type_(y) {
  //
}

#line 4 "src/expression/MatrixInv.birch"
template<class Argument,class ArgumentValue,class Value>
#line 6 "src/expression/MatrixInv.birch"
birch::type::Integer birch::type::MatrixInv<Argument, ArgumentValue, Value>::doRows(const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_) {
  #line 6 "src/expression/MatrixInv.birch"
  libbirch_function_("doRows", "src/expression/MatrixInv.birch", 6);
  #line 7 "src/expression/MatrixInv.birch"
  libbirch_line_(7);
  #line 7 "src/expression/MatrixInv.birch"
  return this_()->y.get()->rows(handler_);
}

#line 4 "src/expression/MatrixInv.birch"
template<class Argument,class ArgumentValue,class Value>
#line 10 "src/expression/MatrixInv.birch"
birch::type::Integer birch::type::MatrixInv<Argument, ArgumentValue, Value>::doColumns(const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_) {
  #line 10 "src/expression/MatrixInv.birch"
  libbirch_function_("doColumns", "src/expression/MatrixInv.birch", 10);
  #line 11 "src/expression/MatrixInv.birch"
  libbirch_line_(11);
  #line 11 "src/expression/MatrixInv.birch"
  return this_()->y.get()->columns(handler_);
}

#line 4 "src/expression/MatrixInv.birch"
template<class Argument,class ArgumentValue,class Value>
#line 14 "src/expression/MatrixInv.birch"
Value birch::type::MatrixInv<Argument, ArgumentValue, Value>::doEvaluate(const ArgumentValue& y, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_) {
  #line 14 "src/expression/MatrixInv.birch"
  libbirch_function_("doEvaluate", "src/expression/MatrixInv.birch", 14);
  #line 15 "src/expression/MatrixInv.birch"
  libbirch_line_(15);
  #line 15 "src/expression/MatrixInv.birch"
  return birch::inv(y, handler_);
}

#line 4 "src/expression/MatrixInv.birch"
template<class Argument,class ArgumentValue,class Value>
#line 18 "src/expression/MatrixInv.birch"
libbirch::DefaultArray<birch::type::Real,2> birch::type::MatrixInv<Argument, ArgumentValue, Value>::doEvaluateGrad(const libbirch::DefaultArray<birch::type::Real,2>& d, const Value& x, const ArgumentValue& y, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_) {
  #line 18 "src/expression/MatrixInv.birch"
  libbirch_function_("doEvaluateGrad", "src/expression/MatrixInv.birch", 18);
  #line 20 "src/expression/MatrixInv.birch"
  libbirch_line_(20);
  #line 20 "src/expression/MatrixInv.birch"
  auto x_prime_ = birch::canonical(birch::transpose(x, handler_), handler_);
  #line 21 "src/expression/MatrixInv.birch"
  libbirch_line_(21);
  #line 21 "src/expression/MatrixInv.birch"
  return -x_prime_ * d * x_prime_;
}

#line 4 "src/expression/MatrixJoin.birch"
template<class Value>
#line 4 "src/expression/MatrixJoin.birch"
birch::type::MatrixJoin<Value>::MatrixJoin(const libbirch::DefaultArray<libbirch::Lazy<libbirch::Shared<birch::type::Expression<Value>>>,2>& y, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_) :
    #line 4 "src/expression/MatrixJoin.birch"
    super_type_(),
    #line 9 "src/expression/MatrixJoin.birch"
    y(y) {
  //
}

#line 4 "src/expression/MatrixJoin.birch"
template<class Value>
#line 11 "src/expression/MatrixJoin.birch"
birch::type::Integer birch::type::MatrixJoin<Value>::doDepth(const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_) {
  #line 11 "src/expression/MatrixJoin.birch"
  libbirch_function_("doDepth", "src/expression/MatrixJoin.birch", 11);
  #line 12 "src/expression/MatrixJoin.birch"
  libbirch_line_(12);
  #line 12 "src/expression/MatrixJoin.birch"
  auto depth = birch::type::Integer(0);
  #line 13 "src/expression/MatrixJoin.birch"
  libbirch_line_(13);
  #line 13 "src/expression/MatrixJoin.birch"
  for (auto i = birch::type::Integer(1); i <= this_()->rows(handler_); ++i) {
    #line 14 "src/expression/MatrixJoin.birch"
    libbirch_line_(14);
    #line 14 "src/expression/MatrixJoin.birch"
    for (auto j = birch::type::Integer(1); j <= this_()->columns(handler_); ++j) {
      #line 15 "src/expression/MatrixJoin.birch"
      libbirch_line_(15);
      #line 15 "src/expression/MatrixJoin.birch"
      depth = birch::max(depth, this_()->y.get().get(libbirch::make_slice(i - 1, j - 1))->depth(handler_), handler_);
    }
  }
  #line 18 "src/expression/MatrixJoin.birch"
  libbirch_line_(18);
  #line 18 "src/expression/MatrixJoin.birch"
  return depth + birch::type::Integer(1);
}

#line 4 "src/expression/MatrixJoin.birch"
template<class Value>
#line 21 "src/expression/MatrixJoin.birch"
birch::type::Integer birch::type::MatrixJoin<Value>::doRows(const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_) {
  #line 21 "src/expression/MatrixJoin.birch"
  libbirch_function_("doRows", "src/expression/MatrixJoin.birch", 21);
  #line 22 "src/expression/MatrixJoin.birch"
  libbirch_line_(22);
  #line 22 "src/expression/MatrixJoin.birch"
  return birch::rows(this_()->y.get(), handler_);
}

#line 4 "src/expression/MatrixJoin.birch"
template<class Value>
#line 25 "src/expression/MatrixJoin.birch"
birch::type::Integer birch::type::MatrixJoin<Value>::doColumns(const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_) {
  #line 25 "src/expression/MatrixJoin.birch"
  libbirch_function_("doColumns", "src/expression/MatrixJoin.birch", 25);
  #line 26 "src/expression/MatrixJoin.birch"
  libbirch_line_(26);
  #line 26 "src/expression/MatrixJoin.birch"
  return birch::columns(this_()->y.get(), handler_);
}

#line 4 "src/expression/MatrixJoin.birch"
template<class Value>
#line 29 "src/expression/MatrixJoin.birch"
libbirch::DefaultArray<Value,2> birch::type::MatrixJoin<Value>::doValue(const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_) {
  #line 29 "src/expression/MatrixJoin.birch"
  libbirch_function_("doValue", "src/expression/MatrixJoin.birch", 29);
  #line 30 "src/expression/MatrixJoin.birch"
  libbirch_line_(30);
  #line 30 "src/expression/MatrixJoin.birch"
  return birch::transform(this_()->y.get(), std::function<Value(libbirch::Lazy<libbirch::Shared<birch::type::Expression<Value>>>,const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_
)>([=](const libbirch::Lazy<libbirch::Shared<birch::type::Expression<Value>>>& x, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr) {
    #line 31 "src/expression/MatrixJoin.birch"
    libbirch_line_(31);
    #line 31 "src/expression/MatrixJoin.birch"
    return x->value(handler_);
  }), handler_);
}

#line 4 "src/expression/MatrixJoin.birch"
template<class Value>
#line 35 "src/expression/MatrixJoin.birch"
libbirch::DefaultArray<Value,2> birch::type::MatrixJoin<Value>::doPilot(const birch::type::Integer& gen, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_) {
  #line 35 "src/expression/MatrixJoin.birch"
  libbirch_function_("doPilot", "src/expression/MatrixJoin.birch", 35);
  #line 36 "src/expression/MatrixJoin.birch"
  libbirch_line_(36);
  #line 36 "src/expression/MatrixJoin.birch"
  return birch::transform(this_()->y.get(), std::function<Value(libbirch::Lazy<libbirch::Shared<birch::type::Expression<Value>>>,const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_
)>([=](const libbirch::Lazy<libbirch::Shared<birch::type::Expression<Value>>>& x, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr) {
    #line 37 "src/expression/MatrixJoin.birch"
    libbirch_line_(37);
    #line 37 "src/expression/MatrixJoin.birch"
    return x->pilot(gen, handler_);
  }), handler_);
}

#line 4 "src/expression/MatrixJoin.birch"
template<class Value>
#line 41 "src/expression/MatrixJoin.birch"
libbirch::DefaultArray<Value,2> birch::type::MatrixJoin<Value>::doGet(const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_) {
  #line 41 "src/expression/MatrixJoin.birch"
  libbirch_function_("doGet", "src/expression/MatrixJoin.birch", 41);
  #line 42 "src/expression/MatrixJoin.birch"
  libbirch_line_(42);
  #line 42 "src/expression/MatrixJoin.birch"
  return birch::transform(this_()->y.get(), std::function<Value(libbirch::Lazy<libbirch::Shared<birch::type::Expression<Value>>>,const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_
)>([=](const libbirch::Lazy<libbirch::Shared<birch::type::Expression<Value>>>& x, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr) {
    #line 43 "src/expression/MatrixJoin.birch"
    libbirch_line_(43);
    #line 43 "src/expression/MatrixJoin.birch"
    return x->get(handler_);
  }), handler_);
}

#line 4 "src/expression/MatrixJoin.birch"
template<class Value>
#line 47 "src/expression/MatrixJoin.birch"
libbirch::DefaultArray<Value,2> birch::type::MatrixJoin<Value>::doMove(const birch::type::Integer& gen, const libbirch::Lazy<libbirch::Shared<birch::type::Kernel>>& _u0954, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_) {
  #line 47 "src/expression/MatrixJoin.birch"
  libbirch_function_("doMove", "src/expression/MatrixJoin.birch", 47);
  #line 48 "src/expression/MatrixJoin.birch"
  libbirch_line_(48);
  #line 48 "src/expression/MatrixJoin.birch"
  return birch::transform(this_()->y.get(), std::function<Value(libbirch::Lazy<libbirch::Shared<birch::type::Expression<Value>>>,const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_
)>([=](const libbirch::Lazy<libbirch::Shared<birch::type::Expression<Value>>>& x, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr) {
    #line 49 "src/expression/MatrixJoin.birch"
    libbirch_line_(49);
    #line 49 "src/expression/MatrixJoin.birch"
    return x->move(gen, _u0954, handler_);
  }), handler_);
}

#line 4 "src/expression/MatrixJoin.birch"
template<class Value>
#line 53 "src/expression/MatrixJoin.birch"
void birch::type::MatrixJoin<Value>::doGrad(const birch::type::Integer& gen, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_) {
  #line 53 "src/expression/MatrixJoin.birch"
  libbirch_function_("doGrad", "src/expression/MatrixJoin.birch", 53);
  #line 54 "src/expression/MatrixJoin.birch"
  libbirch_line_(54);
  #line 54 "src/expression/MatrixJoin.birch"
  birch::for_each(this_()->y.get(), this_()->d.get(), std::function<void(libbirch::Lazy<libbirch::Shared<birch::type::Expression<Value>>>,Value,const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_
)>([=](const libbirch::Lazy<libbirch::Shared<birch::type::Expression<Value>>>& x, const Value& d, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr) {
    #line 54 "src/expression/MatrixJoin.birch"
    libbirch_line_(54);
    #line 54 "src/expression/MatrixJoin.birch"
    x->grad(gen, d, handler_);
  }), handler_);
}

#line 4 "src/expression/MatrixJoin.birch"
template<class Value>
#line 57 "src/expression/MatrixJoin.birch"
libbirch::Optional<libbirch::Lazy<libbirch::Shared<birch::type::Expression<birch::type::Real>>>> birch::type::MatrixJoin<Value>::doPrior(const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_) {
  #line 57 "src/expression/MatrixJoin.birch"
  libbirch_function_("doPrior", "src/expression/MatrixJoin.birch", 57);
  #line 58 "src/expression/MatrixJoin.birch"
  libbirch_line_(58);
  #line 58 "src/expression/MatrixJoin.birch"
  libbirch::Optional<libbirch::Lazy<libbirch::Shared<birch::type::Expression<birch::type::Real>>>> p;
  #line 59 "src/expression/MatrixJoin.birch"
  libbirch_line_(59);
  #line 59 "src/expression/MatrixJoin.birch"
  auto R = this_()->rows(handler_);
  #line 60 "src/expression/MatrixJoin.birch"
  libbirch_line_(60);
  #line 60 "src/expression/MatrixJoin.birch"
  auto C = this_()->columns(handler_);
  #line 61 "src/expression/MatrixJoin.birch"
  libbirch_line_(61);
  #line 61 "src/expression/MatrixJoin.birch"
  for (auto i = birch::type::Integer(1); i <= R; ++i) {
    #line 62 "src/expression/MatrixJoin.birch"
    libbirch_line_(62);
    #line 62 "src/expression/MatrixJoin.birch"
    for (auto j = birch::type::Integer(1); j <= C; ++j) {
      #line 63 "src/expression/MatrixJoin.birch"
      libbirch_line_(63);
      #line 63 "src/expression/MatrixJoin.birch"
      auto q = this_()->y.get().get(libbirch::make_slice(i - 1, j - 1))->prior(handler_);
      #line 64 "src/expression/MatrixJoin.birch"
      libbirch_line_(64);
      #line 64 "src/expression/MatrixJoin.birch"
      if (q.query()) {
        #line 65 "src/expression/MatrixJoin.birch"
        libbirch_line_(65);
        #line 65 "src/expression/MatrixJoin.birch"
        if (p.query()) {
          #line 66 "src/expression/MatrixJoin.birch"
          libbirch_line_(66);
          #line 66 "src/expression/MatrixJoin.birch"
          p = p.get() + q.get();
        } else {
          #line 68 "src/expression/MatrixJoin.birch"
          libbirch_line_(68);
          #line 68 "src/expression/MatrixJoin.birch"
          p = q;
        }
      }
    }
  }
  #line 73 "src/expression/MatrixJoin.birch"
  libbirch_line_(73);
  #line 73 "src/expression/MatrixJoin.birch"
  return p;
}

#line 4 "src/expression/MatrixJoin.birch"
template<class Value>
#line 76 "src/expression/MatrixJoin.birch"
birch::type::Real birch::type::MatrixJoin<Value>::doCompare(const birch::type::Integer& gen, const libbirch::Lazy<libbirch::Shared<birch::type::DelayExpression>>& x, const libbirch::Lazy<libbirch::Shared<birch::type::Kernel>>& _u0954, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_) {
  #line 76 "src/expression/MatrixJoin.birch"
  libbirch_function_("doCompare", "src/expression/MatrixJoin.birch", 76);
  #line 78 "src/expression/MatrixJoin.birch"
  libbirch_line_(78);
  #line 78 "src/expression/MatrixJoin.birch"
  libbirch_assert_(this_()->rows(handler_) == x->rows(handler_));
  #line 79 "src/expression/MatrixJoin.birch"
  libbirch_line_(79);
  #line 79 "src/expression/MatrixJoin.birch"
  libbirch_assert_(this_()->columns(handler_) == x->columns(handler_));
  #line 81 "src/expression/MatrixJoin.birch"
  libbirch_line_(81);
  #line 81 "src/expression/MatrixJoin.birch"
  auto o = libbirch::cast<libbirch::Lazy<libbirch::Shared<birch::type::MatrixJoin<Value>>>>(x).get();
  #line 82 "src/expression/MatrixJoin.birch"
  libbirch_line_(82);
  #line 82 "src/expression/MatrixJoin.birch"
  auto w = 0.0;
  #line 83 "src/expression/MatrixJoin.birch"
  libbirch_line_(83);
  #line 83 "src/expression/MatrixJoin.birch"
  auto R = this_()->rows(handler_);
  #line 84 "src/expression/MatrixJoin.birch"
  libbirch_line_(84);
  #line 84 "src/expression/MatrixJoin.birch"
  auto C = this_()->columns(handler_);
  #line 85 "src/expression/MatrixJoin.birch"
  libbirch_line_(85);
  #line 85 "src/expression/MatrixJoin.birch"
  for (auto i = birch::type::Integer(1); i <= R; ++i) {
    #line 86 "src/expression/MatrixJoin.birch"
    libbirch_line_(86);
    #line 86 "src/expression/MatrixJoin.birch"
    for (auto j = birch::type::Integer(1); j <= C; ++j) {
      #line 87 "src/expression/MatrixJoin.birch"
      libbirch_line_(87);
      #line 87 "src/expression/MatrixJoin.birch"
      w = w + this_()->y.get().get(libbirch::make_slice(i - 1, j - 1))->compare(gen, o->y.get().get(libbirch::make_slice(i - 1, j - 1)), _u0954, handler_);
    }
  }
  #line 90 "src/expression/MatrixJoin.birch"
  libbirch_line_(90);
  #line 90 "src/expression/MatrixJoin.birch"
  return w;
}

#line 4 "src/expression/MatrixJoin.birch"
template<class Value>
#line 93 "src/expression/MatrixJoin.birch"
void birch::type::MatrixJoin<Value>::doCount(const birch::type::Integer& gen, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_) {
  #line 93 "src/expression/MatrixJoin.birch"
  libbirch_function_("doCount", "src/expression/MatrixJoin.birch", 93);
  #line 94 "src/expression/MatrixJoin.birch"
  libbirch_line_(94);
  #line 94 "src/expression/MatrixJoin.birch"
  birch::for_each(this_()->y.get(), std::function<void(libbirch::Lazy<libbirch::Shared<birch::type::Expression<Value>>>,const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_
)>([=](const libbirch::Lazy<libbirch::Shared<birch::type::Expression<Value>>>& x, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr) {
    #line 94 "src/expression/MatrixJoin.birch"
    libbirch_line_(94);
    #line 94 "src/expression/MatrixJoin.birch"
    x->count(gen, handler_);
  }), handler_);
}

#line 4 "src/expression/MatrixJoin.birch"
template<class Value>
#line 97 "src/expression/MatrixJoin.birch"
void birch::type::MatrixJoin<Value>::doConstant(const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_) {
  #line 97 "src/expression/MatrixJoin.birch"
  libbirch_function_("doConstant", "src/expression/MatrixJoin.birch", 97);
  #line 98 "src/expression/MatrixJoin.birch"
  libbirch_line_(98);
  #line 98 "src/expression/MatrixJoin.birch"
  birch::for_each(this_()->y.get(), std::function<void(libbirch::Lazy<libbirch::Shared<birch::type::Expression<Value>>>,const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_
)>([=](const libbirch::Lazy<libbirch::Shared<birch::type::Expression<Value>>>& x, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr) {
    #line 98 "src/expression/MatrixJoin.birch"
    libbirch_line_(98);
    #line 98 "src/expression/MatrixJoin.birch"
    x->constant(handler_);
  }), handler_);
}

#line 4 "src/expression/MatrixJoin.birch"
template<class Value>
#line 101 "src/expression/MatrixJoin.birch"
void birch::type::MatrixJoin<Value>::doDetach(const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_) {
  #line 101 "src/expression/MatrixJoin.birch"
  libbirch_function_("doDetach", "src/expression/MatrixJoin.birch", 101);
  #line 102 "src/expression/MatrixJoin.birch"
  libbirch_line_(102);
  #line 102 "src/expression/MatrixJoin.birch"
  this_()->y = libbirch::nil;
}

#line 4 "src/expression/MatrixRankDowndate.birch"
template<class Right,class RightValue,class RightGradient>
#line 4 "src/expression/MatrixRankDowndate.birch"
birch::type::MatrixRankDowndate<Right, RightValue, RightGradient>::MatrixRankDowndate(const libbirch::Lazy<libbirch::Shared<birch::type::Expression<birch::type::LLT>>>& y, const Right& z, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_) :
    #line 4 "src/expression/MatrixRankDowndate.birch"
    super_type_(y, z) {
  //
}

#line 4 "src/expression/MatrixRankDowndate.birch"
template<class Right,class RightValue,class RightGradient>
#line 7 "src/expression/MatrixRankDowndate.birch"
birch::type::Integer birch::type::MatrixRankDowndate<Right, RightValue, RightGradient>::doRows(const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_) {
  #line 7 "src/expression/MatrixRankDowndate.birch"
  libbirch_function_("doRows", "src/expression/MatrixRankDowndate.birch", 7);
  #line 8 "src/expression/MatrixRankDowndate.birch"
  libbirch_line_(8);
  #line 8 "src/expression/MatrixRankDowndate.birch"
  return this_()->y.get()->rows(handler_);
}

#line 4 "src/expression/MatrixRankDowndate.birch"
template<class Right,class RightValue,class RightGradient>
#line 11 "src/expression/MatrixRankDowndate.birch"
birch::type::Integer birch::type::MatrixRankDowndate<Right, RightValue, RightGradient>::doColumns(const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_) {
  #line 11 "src/expression/MatrixRankDowndate.birch"
  libbirch_function_("doColumns", "src/expression/MatrixRankDowndate.birch", 11);
  #line 12 "src/expression/MatrixRankDowndate.birch"
  libbirch_line_(12);
  #line 12 "src/expression/MatrixRankDowndate.birch"
  return this_()->y.get()->columns(handler_);
}

#line 4 "src/expression/MatrixRankDowndate.birch"
template<class Right,class RightValue,class RightGradient>
#line 15 "src/expression/MatrixRankDowndate.birch"
birch::type::LLT birch::type::MatrixRankDowndate<Right, RightValue, RightGradient>::doEvaluate(const birch::type::LLT& y, const RightValue& z, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_) {
  #line 15 "src/expression/MatrixRankDowndate.birch"
  libbirch_function_("doEvaluate", "src/expression/MatrixRankDowndate.birch", 15);
  #line 16 "src/expression/MatrixRankDowndate.birch"
  libbirch_line_(16);
  #line 16 "src/expression/MatrixRankDowndate.birch"
  return birch::rank_downdate(y, z, handler_);
}

#line 4 "src/expression/MatrixRankDowndate.birch"
template<class Right,class RightValue,class RightGradient>
#line 19 "src/expression/MatrixRankDowndate.birch"
libbirch::DefaultArray<birch::type::Real,2> birch::type::MatrixRankDowndate<Right, RightValue, RightGradient>::doEvaluateGradLeft(const libbirch::DefaultArray<birch::type::Real,2>& d, const birch::type::LLT& x, const birch::type::LLT& y, const RightValue& z, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_) {
  #line 19 "src/expression/MatrixRankDowndate.birch"
  libbirch_function_("doEvaluateGradLeft", "src/expression/MatrixRankDowndate.birch", 19);
  #line 21 "src/expression/MatrixRankDowndate.birch"
  libbirch_line_(21);
  #line 21 "src/expression/MatrixRankDowndate.birch"
  return d;
}

#line 4 "src/expression/MatrixRankDowndate.birch"
template<class Right,class RightValue,class RightGradient>
#line 24 "src/expression/MatrixRankDowndate.birch"
RightGradient birch::type::MatrixRankDowndate<Right, RightValue, RightGradient>::doEvaluateGradRight(const libbirch::DefaultArray<birch::type::Real,2>& d, const birch::type::LLT& x, const birch::type::LLT& y, const RightValue& z, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_) {
  #line 24 "src/expression/MatrixRankDowndate.birch"
  libbirch_function_("doEvaluateGradRight", "src/expression/MatrixRankDowndate.birch", 24);
  #line 26 "src/expression/MatrixRankDowndate.birch"
  libbirch_line_(26);
  #line 26 "src/expression/MatrixRankDowndate.birch"
  return -(d + birch::transpose(d, handler_)) * z;
}

#line 4 "src/expression/MatrixRankUpdate.birch"
template<class Right,class RightValue,class RightGradient>
#line 4 "src/expression/MatrixRankUpdate.birch"
birch::type::MatrixRankUpdate<Right, RightValue, RightGradient>::MatrixRankUpdate(const libbirch::Lazy<libbirch::Shared<birch::type::Expression<birch::type::LLT>>>& y, const Right& z, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_) :
    #line 4 "src/expression/MatrixRankUpdate.birch"
    super_type_(y, z) {
  //
}

#line 4 "src/expression/MatrixRankUpdate.birch"
template<class Right,class RightValue,class RightGradient>
#line 7 "src/expression/MatrixRankUpdate.birch"
birch::type::Integer birch::type::MatrixRankUpdate<Right, RightValue, RightGradient>::doRows(const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_) {
  #line 7 "src/expression/MatrixRankUpdate.birch"
  libbirch_function_("doRows", "src/expression/MatrixRankUpdate.birch", 7);
  #line 8 "src/expression/MatrixRankUpdate.birch"
  libbirch_line_(8);
  #line 8 "src/expression/MatrixRankUpdate.birch"
  return this_()->y.get()->rows(handler_);
}

#line 4 "src/expression/MatrixRankUpdate.birch"
template<class Right,class RightValue,class RightGradient>
#line 11 "src/expression/MatrixRankUpdate.birch"
birch::type::Integer birch::type::MatrixRankUpdate<Right, RightValue, RightGradient>::doColumns(const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_) {
  #line 11 "src/expression/MatrixRankUpdate.birch"
  libbirch_function_("doColumns", "src/expression/MatrixRankUpdate.birch", 11);
  #line 12 "src/expression/MatrixRankUpdate.birch"
  libbirch_line_(12);
  #line 12 "src/expression/MatrixRankUpdate.birch"
  return this_()->y.get()->columns(handler_);
}

#line 4 "src/expression/MatrixRankUpdate.birch"
template<class Right,class RightValue,class RightGradient>
#line 15 "src/expression/MatrixRankUpdate.birch"
birch::type::LLT birch::type::MatrixRankUpdate<Right, RightValue, RightGradient>::doEvaluate(const birch::type::LLT& y, const RightValue& z, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_) {
  #line 15 "src/expression/MatrixRankUpdate.birch"
  libbirch_function_("doEvaluate", "src/expression/MatrixRankUpdate.birch", 15);
  #line 16 "src/expression/MatrixRankUpdate.birch"
  libbirch_line_(16);
  #line 16 "src/expression/MatrixRankUpdate.birch"
  return birch::rank_update(y, z, handler_);
}

#line 4 "src/expression/MatrixRankUpdate.birch"
template<class Right,class RightValue,class RightGradient>
#line 19 "src/expression/MatrixRankUpdate.birch"
libbirch::DefaultArray<birch::type::Real,2> birch::type::MatrixRankUpdate<Right, RightValue, RightGradient>::doEvaluateGradLeft(const libbirch::DefaultArray<birch::type::Real,2>& d, const birch::type::LLT& x, const birch::type::LLT& y, const RightValue& z, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_) {
  #line 19 "src/expression/MatrixRankUpdate.birch"
  libbirch_function_("doEvaluateGradLeft", "src/expression/MatrixRankUpdate.birch", 19);
  #line 21 "src/expression/MatrixRankUpdate.birch"
  libbirch_line_(21);
  #line 21 "src/expression/MatrixRankUpdate.birch"
  return d;
}

#line 4 "src/expression/MatrixRankUpdate.birch"
template<class Right,class RightValue,class RightGradient>
#line 24 "src/expression/MatrixRankUpdate.birch"
RightGradient birch::type::MatrixRankUpdate<Right, RightValue, RightGradient>::doEvaluateGradRight(const libbirch::DefaultArray<birch::type::Real,2>& d, const birch::type::LLT& x, const birch::type::LLT& y, const RightValue& z, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_) {
  #line 24 "src/expression/MatrixRankUpdate.birch"
  libbirch_function_("doEvaluateGradRight", "src/expression/MatrixRankUpdate.birch", 24);
  #line 26 "src/expression/MatrixRankUpdate.birch"
  libbirch_line_(26);
  #line 26 "src/expression/MatrixRankUpdate.birch"
  return (d + birch::transpose(d, handler_)) * z;
}

#line 4 "src/expression/MatrixSolve.birch"
template<class Left,class LeftValue>
#line 4 "src/expression/MatrixSolve.birch"
birch::type::MatrixSolve<Left, LeftValue>::MatrixSolve(const Left& y, const libbirch::Lazy<libbirch::Shared<birch::type::Expression<libbirch::DefaultArray<birch::type::Real,2>>>>& z, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_) :
    #line 4 "src/expression/MatrixSolve.birch"
    super_type_(y, z) {
  //
}

#line 4 "src/expression/MatrixSolve.birch"
template<class Left,class LeftValue>
#line 7 "src/expression/MatrixSolve.birch"
birch::type::Integer birch::type::MatrixSolve<Left, LeftValue>::doRows(const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_) {
  #line 7 "src/expression/MatrixSolve.birch"
  libbirch_function_("doRows", "src/expression/MatrixSolve.birch", 7);
  #line 8 "src/expression/MatrixSolve.birch"
  libbirch_line_(8);
  #line 8 "src/expression/MatrixSolve.birch"
  return this_()->y.get()->rows(handler_);
}

#line 4 "src/expression/MatrixSolve.birch"
template<class Left,class LeftValue>
#line 11 "src/expression/MatrixSolve.birch"
birch::type::Integer birch::type::MatrixSolve<Left, LeftValue>::doColumns(const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_) {
  #line 11 "src/expression/MatrixSolve.birch"
  libbirch_function_("doColumns", "src/expression/MatrixSolve.birch", 11);
  #line 12 "src/expression/MatrixSolve.birch"
  libbirch_line_(12);
  #line 12 "src/expression/MatrixSolve.birch"
  return this_()->z.get()->columns(handler_);
}

#line 4 "src/expression/MatrixSolve.birch"
template<class Left,class LeftValue>
#line 15 "src/expression/MatrixSolve.birch"
libbirch::DefaultArray<birch::type::Real,2> birch::type::MatrixSolve<Left, LeftValue>::doEvaluate(const LeftValue& y, const libbirch::DefaultArray<birch::type::Real,2>& z, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_) {
  #line 15 "src/expression/MatrixSolve.birch"
  libbirch_function_("doEvaluate", "src/expression/MatrixSolve.birch", 15);
  #line 16 "src/expression/MatrixSolve.birch"
  libbirch_line_(16);
  #line 16 "src/expression/MatrixSolve.birch"
  return birch::solve(y, z, handler_);
}

#line 4 "src/expression/MatrixSolve.birch"
template<class Left,class LeftValue>
#line 19 "src/expression/MatrixSolve.birch"
libbirch::DefaultArray<birch::type::Real,2> birch::type::MatrixSolve<Left, LeftValue>::doEvaluateGradLeft(const libbirch::DefaultArray<birch::type::Real,2>& d, const libbirch::DefaultArray<birch::type::Real,2>& x, const LeftValue& y, const libbirch::DefaultArray<birch::type::Real,2>& z, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_) {
  #line 19 "src/expression/MatrixSolve.birch"
  libbirch_function_("doEvaluateGradLeft", "src/expression/MatrixSolve.birch", 19);
  #line 21 "src/expression/MatrixSolve.birch"
  libbirch_line_(21);
  #line 21 "src/expression/MatrixSolve.birch"
  return -birch::solve(birch::transpose(y, handler_), d, handler_) * birch::transpose(birch::solve(y, z, handler_), handler_);
}

#line 4 "src/expression/MatrixSolve.birch"
template<class Left,class LeftValue>
#line 24 "src/expression/MatrixSolve.birch"
libbirch::DefaultArray<birch::type::Real,2> birch::type::MatrixSolve<Left, LeftValue>::doEvaluateGradRight(const libbirch::DefaultArray<birch::type::Real,2>& d, const libbirch::DefaultArray<birch::type::Real,2>& x, const LeftValue& y, const libbirch::DefaultArray<birch::type::Real,2>& z, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_) {
  #line 24 "src/expression/MatrixSolve.birch"
  libbirch_function_("doEvaluateGradRight", "src/expression/MatrixSolve.birch", 24);
  #line 26 "src/expression/MatrixSolve.birch"
  libbirch_line_(26);
  #line 26 "src/expression/MatrixSolve.birch"
  return birch::solve(birch::transpose(y, handler_), d, handler_);
}

#line 12 "src/expression/MatrixUnaryExpression.birch"
template<class Argument,class ArgumentValue,class ArgumentGradient,class Value>
#line 12 "src/expression/MatrixUnaryExpression.birch"
birch::type::MatrixUnaryExpression<Argument, ArgumentValue, ArgumentGradient, Value>::MatrixUnaryExpression(const Argument& y, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_) :
    #line 12 "src/expression/MatrixUnaryExpression.birch"
    super_type_(),
    #line 17 "src/expression/MatrixUnaryExpression.birch"
    y(y) {
  //
}

#line 12 "src/expression/MatrixUnaryExpression.birch"
template<class Argument,class ArgumentValue,class ArgumentGradient,class Value>
#line 30 "src/expression/MatrixUnaryExpression.birch"
birch::type::Integer birch::type::MatrixUnaryExpression<Argument, ArgumentValue, ArgumentGradient, Value>::doDepth(const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_) {
  #line 30 "src/expression/MatrixUnaryExpression.birch"
  libbirch_function_("doDepth", "src/expression/MatrixUnaryExpression.birch", 30);
  #line 31 "src/expression/MatrixUnaryExpression.birch"
  libbirch_line_(31);
  #line 31 "src/expression/MatrixUnaryExpression.birch"
  return this_()->y.get()->depth(handler_) + birch::type::Integer(1);
}

#line 12 "src/expression/MatrixUnaryExpression.birch"
template<class Argument,class ArgumentValue,class ArgumentGradient,class Value>
#line 34 "src/expression/MatrixUnaryExpression.birch"
Value birch::type::MatrixUnaryExpression<Argument, ArgumentValue, ArgumentGradient, Value>::doValue(const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_) {
  #line 34 "src/expression/MatrixUnaryExpression.birch"
  libbirch_function_("doValue", "src/expression/MatrixUnaryExpression.birch", 34);
  #line 35 "src/expression/MatrixUnaryExpression.birch"
  libbirch_line_(35);
  #line 35 "src/expression/MatrixUnaryExpression.birch"
  return this_()->doEvaluate(this_()->y.get()->value(handler_), handler_);
}

#line 12 "src/expression/MatrixUnaryExpression.birch"
template<class Argument,class ArgumentValue,class ArgumentGradient,class Value>
#line 38 "src/expression/MatrixUnaryExpression.birch"
Value birch::type::MatrixUnaryExpression<Argument, ArgumentValue, ArgumentGradient, Value>::doPilot(const birch::type::Integer& gen, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_) {
  #line 38 "src/expression/MatrixUnaryExpression.birch"
  libbirch_function_("doPilot", "src/expression/MatrixUnaryExpression.birch", 38);
  #line 39 "src/expression/MatrixUnaryExpression.birch"
  libbirch_line_(39);
  #line 39 "src/expression/MatrixUnaryExpression.birch"
  return this_()->doEvaluate(this_()->y.get()->pilot(gen, handler_), handler_);
}

#line 12 "src/expression/MatrixUnaryExpression.birch"
template<class Argument,class ArgumentValue,class ArgumentGradient,class Value>
#line 42 "src/expression/MatrixUnaryExpression.birch"
Value birch::type::MatrixUnaryExpression<Argument, ArgumentValue, ArgumentGradient, Value>::doGet(const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_) {
  #line 42 "src/expression/MatrixUnaryExpression.birch"
  libbirch_function_("doGet", "src/expression/MatrixUnaryExpression.birch", 42);
  #line 43 "src/expression/MatrixUnaryExpression.birch"
  libbirch_line_(43);
  #line 43 "src/expression/MatrixUnaryExpression.birch"
  return this_()->doEvaluate(this_()->y.get()->get(handler_), handler_);
}

#line 12 "src/expression/MatrixUnaryExpression.birch"
template<class Argument,class ArgumentValue,class ArgumentGradient,class Value>
#line 46 "src/expression/MatrixUnaryExpression.birch"
Value birch::type::MatrixUnaryExpression<Argument, ArgumentValue, ArgumentGradient, Value>::doMove(const birch::type::Integer& gen, const libbirch::Lazy<libbirch::Shared<birch::type::Kernel>>& _u0954, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_) {
  #line 46 "src/expression/MatrixUnaryExpression.birch"
  libbirch_function_("doMove", "src/expression/MatrixUnaryExpression.birch", 46);
  #line 47 "src/expression/MatrixUnaryExpression.birch"
  libbirch_line_(47);
  #line 47 "src/expression/MatrixUnaryExpression.birch"
  return this_()->doEvaluate(this_()->y.get()->move(gen, _u0954, handler_), handler_);
}

#line 12 "src/expression/MatrixUnaryExpression.birch"
template<class Argument,class ArgumentValue,class ArgumentGradient,class Value>
#line 50 "src/expression/MatrixUnaryExpression.birch"
void birch::type::MatrixUnaryExpression<Argument, ArgumentValue, ArgumentGradient, Value>::doGrad(const birch::type::Integer& gen, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_) {
  #line 50 "src/expression/MatrixUnaryExpression.birch"
  libbirch_function_("doGrad", "src/expression/MatrixUnaryExpression.birch", 50);
  #line 51 "src/expression/MatrixUnaryExpression.birch"
  libbirch_line_(51);
  #line 51 "src/expression/MatrixUnaryExpression.birch"
  this_()->y.get()->grad(gen, this_()->doEvaluateGrad(this_()->d.get(), this_()->x.get(), this_()->y.get()->get(handler_), handler_), handler_);
}

#line 12 "src/expression/MatrixUnaryExpression.birch"
template<class Argument,class ArgumentValue,class ArgumentGradient,class Value>
#line 54 "src/expression/MatrixUnaryExpression.birch"
libbirch::Optional<libbirch::Lazy<libbirch::Shared<birch::type::Expression<birch::type::Real>>>> birch::type::MatrixUnaryExpression<Argument, ArgumentValue, ArgumentGradient, Value>::doPrior(const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_) {
  #line 54 "src/expression/MatrixUnaryExpression.birch"
  libbirch_function_("doPrior", "src/expression/MatrixUnaryExpression.birch", 54);
  #line 55 "src/expression/MatrixUnaryExpression.birch"
  libbirch_line_(55);
  #line 55 "src/expression/MatrixUnaryExpression.birch"
  return this_()->y.get()->prior(handler_);
}

#line 12 "src/expression/MatrixUnaryExpression.birch"
template<class Argument,class ArgumentValue,class ArgumentGradient,class Value>
#line 58 "src/expression/MatrixUnaryExpression.birch"
birch::type::Real birch::type::MatrixUnaryExpression<Argument, ArgumentValue, ArgumentGradient, Value>::doCompare(const birch::type::Integer& gen, const libbirch::Lazy<libbirch::Shared<birch::type::DelayExpression>>& x, const libbirch::Lazy<libbirch::Shared<birch::type::Kernel>>& _u0954, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_) {
  #line 58 "src/expression/MatrixUnaryExpression.birch"
  libbirch_function_("doCompare", "src/expression/MatrixUnaryExpression.birch", 58);
  #line 60 "src/expression/MatrixUnaryExpression.birch"
  libbirch_line_(60);
  #line 60 "src/expression/MatrixUnaryExpression.birch"
  auto o = libbirch::cast<libbirch::Lazy<libbirch::Shared<birch::type::MatrixUnaryExpression<Argument, ArgumentValue, ArgumentGradient, Value>>>>(x).get();
  #line 62 "src/expression/MatrixUnaryExpression.birch"
  libbirch_line_(62);
  #line 62 "src/expression/MatrixUnaryExpression.birch"
  return this_()->y.get()->compare(gen, o->y.get(), _u0954, handler_);
}

#line 12 "src/expression/MatrixUnaryExpression.birch"
template<class Argument,class ArgumentValue,class ArgumentGradient,class Value>
#line 65 "src/expression/MatrixUnaryExpression.birch"
void birch::type::MatrixUnaryExpression<Argument, ArgumentValue, ArgumentGradient, Value>::doConstant(const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_) {
  #line 65 "src/expression/MatrixUnaryExpression.birch"
  libbirch_function_("doConstant", "src/expression/MatrixUnaryExpression.birch", 65);
  #line 66 "src/expression/MatrixUnaryExpression.birch"
  libbirch_line_(66);
  #line 66 "src/expression/MatrixUnaryExpression.birch"
  this_()->y.get()->constant(handler_);
}

#line 12 "src/expression/MatrixUnaryExpression.birch"
template<class Argument,class ArgumentValue,class ArgumentGradient,class Value>
#line 69 "src/expression/MatrixUnaryExpression.birch"
void birch::type::MatrixUnaryExpression<Argument, ArgumentValue, ArgumentGradient, Value>::doCount(const birch::type::Integer& gen, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_) {
  #line 69 "src/expression/MatrixUnaryExpression.birch"
  libbirch_function_("doCount", "src/expression/MatrixUnaryExpression.birch", 69);
  #line 70 "src/expression/MatrixUnaryExpression.birch"
  libbirch_line_(70);
  #line 70 "src/expression/MatrixUnaryExpression.birch"
  this_()->y.get()->count(gen, handler_);
}

#line 12 "src/expression/MatrixUnaryExpression.birch"
template<class Argument,class ArgumentValue,class ArgumentGradient,class Value>
#line 73 "src/expression/MatrixUnaryExpression.birch"
void birch::type::MatrixUnaryExpression<Argument, ArgumentValue, ArgumentGradient, Value>::doDetach(const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_) {
  #line 73 "src/expression/MatrixUnaryExpression.birch"
  libbirch_function_("doDetach", "src/expression/MatrixUnaryExpression.birch", 73);
  #line 74 "src/expression/MatrixUnaryExpression.birch"
  libbirch_line_(74);
  #line 74 "src/expression/MatrixUnaryExpression.birch"
  this_()->y = libbirch::nil;
}

#line 18 "src/expression/MultivariateBinaryExpression.birch"
template<class Left,class Right,class LeftValue,class RightValue,class LeftGradient,class RightGradient,class Value>
#line 18 "src/expression/MultivariateBinaryExpression.birch"
birch::type::MultivariateBinaryExpression<Left, Right, LeftValue, RightValue, LeftGradient, RightGradient, Value>::MultivariateBinaryExpression(const Left& y, const Right& z, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_) :
    #line 18 "src/expression/MultivariateBinaryExpression.birch"
    super_type_(),
    #line 24 "src/expression/MultivariateBinaryExpression.birch"
    y(y),
    #line 29 "src/expression/MultivariateBinaryExpression.birch"
    z(z) {
  //
}

#line 18 "src/expression/MultivariateBinaryExpression.birch"
template<class Left,class Right,class LeftValue,class RightValue,class LeftGradient,class RightGradient,class Value>
#line 48 "src/expression/MultivariateBinaryExpression.birch"
birch::type::Integer birch::type::MultivariateBinaryExpression<Left, Right, LeftValue, RightValue, LeftGradient, RightGradient, Value>::doDepth(const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_) {
  #line 48 "src/expression/MultivariateBinaryExpression.birch"
  libbirch_function_("doDepth", "src/expression/MultivariateBinaryExpression.birch", 48);
  #line 49 "src/expression/MultivariateBinaryExpression.birch"
  libbirch_line_(49);
  #line 49 "src/expression/MultivariateBinaryExpression.birch"
  return birch::max(this_()->y.get()->depth(handler_), this_()->z.get()->depth(handler_), handler_) + birch::type::Integer(1);
}

#line 18 "src/expression/MultivariateBinaryExpression.birch"
template<class Left,class Right,class LeftValue,class RightValue,class LeftGradient,class RightGradient,class Value>
#line 52 "src/expression/MultivariateBinaryExpression.birch"
Value birch::type::MultivariateBinaryExpression<Left, Right, LeftValue, RightValue, LeftGradient, RightGradient, Value>::doValue(const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_) {
  #line 52 "src/expression/MultivariateBinaryExpression.birch"
  libbirch_function_("doValue", "src/expression/MultivariateBinaryExpression.birch", 52);
  #line 53 "src/expression/MultivariateBinaryExpression.birch"
  libbirch_line_(53);
  #line 53 "src/expression/MultivariateBinaryExpression.birch"
  return this_()->doEvaluate(this_()->y.get()->value(handler_), this_()->z.get()->value(handler_), handler_);
}

#line 18 "src/expression/MultivariateBinaryExpression.birch"
template<class Left,class Right,class LeftValue,class RightValue,class LeftGradient,class RightGradient,class Value>
#line 56 "src/expression/MultivariateBinaryExpression.birch"
Value birch::type::MultivariateBinaryExpression<Left, Right, LeftValue, RightValue, LeftGradient, RightGradient, Value>::doPilot(const birch::type::Integer& gen, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_) {
  #line 56 "src/expression/MultivariateBinaryExpression.birch"
  libbirch_function_("doPilot", "src/expression/MultivariateBinaryExpression.birch", 56);
  #line 57 "src/expression/MultivariateBinaryExpression.birch"
  libbirch_line_(57);
  #line 57 "src/expression/MultivariateBinaryExpression.birch"
  return this_()->doEvaluate(this_()->y.get()->pilot(gen, handler_), this_()->z.get()->pilot(gen, handler_), handler_);
}

#line 18 "src/expression/MultivariateBinaryExpression.birch"
template<class Left,class Right,class LeftValue,class RightValue,class LeftGradient,class RightGradient,class Value>
#line 60 "src/expression/MultivariateBinaryExpression.birch"
Value birch::type::MultivariateBinaryExpression<Left, Right, LeftValue, RightValue, LeftGradient, RightGradient, Value>::doGet(const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_) {
  #line 60 "src/expression/MultivariateBinaryExpression.birch"
  libbirch_function_("doGet", "src/expression/MultivariateBinaryExpression.birch", 60);
  #line 61 "src/expression/MultivariateBinaryExpression.birch"
  libbirch_line_(61);
  #line 61 "src/expression/MultivariateBinaryExpression.birch"
  return this_()->doEvaluate(this_()->y.get()->get(handler_), this_()->z.get()->get(handler_), handler_);
}

#line 18 "src/expression/MultivariateBinaryExpression.birch"
template<class Left,class Right,class LeftValue,class RightValue,class LeftGradient,class RightGradient,class Value>
#line 64 "src/expression/MultivariateBinaryExpression.birch"
Value birch::type::MultivariateBinaryExpression<Left, Right, LeftValue, RightValue, LeftGradient, RightGradient, Value>::doMove(const birch::type::Integer& gen, const libbirch::Lazy<libbirch::Shared<birch::type::Kernel>>& _u0954, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_) {
  #line 64 "src/expression/MultivariateBinaryExpression.birch"
  libbirch_function_("doMove", "src/expression/MultivariateBinaryExpression.birch", 64);
  #line 65 "src/expression/MultivariateBinaryExpression.birch"
  libbirch_line_(65);
  #line 65 "src/expression/MultivariateBinaryExpression.birch"
  return this_()->doEvaluate(this_()->y.get()->move(gen, _u0954, handler_), this_()->z.get()->move(gen, _u0954, handler_), handler_);
}

#line 18 "src/expression/MultivariateBinaryExpression.birch"
template<class Left,class Right,class LeftValue,class RightValue,class LeftGradient,class RightGradient,class Value>
#line 68 "src/expression/MultivariateBinaryExpression.birch"
void birch::type::MultivariateBinaryExpression<Left, Right, LeftValue, RightValue, LeftGradient, RightGradient, Value>::doGrad(const birch::type::Integer& gen, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_) {
  #line 68 "src/expression/MultivariateBinaryExpression.birch"
  libbirch_function_("doGrad", "src/expression/MultivariateBinaryExpression.birch", 68);
  #line 69 "src/expression/MultivariateBinaryExpression.birch"
  libbirch_line_(69);
  #line 69 "src/expression/MultivariateBinaryExpression.birch"
  this_()->y.get()->grad(gen, this_()->doEvaluateGradLeft(this_()->d.get(), this_()->x.get(), this_()->y.get()->get(handler_), this_()->z.get()->get(handler_), handler_), handler_);
  #line 70 "src/expression/MultivariateBinaryExpression.birch"
  libbirch_line_(70);
  #line 70 "src/expression/MultivariateBinaryExpression.birch"
  this_()->z.get()->grad(gen, this_()->doEvaluateGradRight(this_()->d.get(), this_()->x.get(), this_()->y.get()->get(handler_), this_()->z.get()->get(handler_), handler_), handler_);
}

#line 18 "src/expression/MultivariateBinaryExpression.birch"
template<class Left,class Right,class LeftValue,class RightValue,class LeftGradient,class RightGradient,class Value>
#line 73 "src/expression/MultivariateBinaryExpression.birch"
libbirch::Optional<libbirch::Lazy<libbirch::Shared<birch::type::Expression<birch::type::Real>>>> birch::type::MultivariateBinaryExpression<Left, Right, LeftValue, RightValue, LeftGradient, RightGradient, Value>::doPrior(const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_) {
  #line 73 "src/expression/MultivariateBinaryExpression.birch"
  libbirch_function_("doPrior", "src/expression/MultivariateBinaryExpression.birch", 73);
  #line 74 "src/expression/MultivariateBinaryExpression.birch"
  libbirch_line_(74);
  #line 74 "src/expression/MultivariateBinaryExpression.birch"
  auto l = this_()->y.get()->prior(handler_);
  #line 75 "src/expression/MultivariateBinaryExpression.birch"
  libbirch_line_(75);
  #line 75 "src/expression/MultivariateBinaryExpression.birch"
  auto r = this_()->z.get()->prior(handler_);
  #line 76 "src/expression/MultivariateBinaryExpression.birch"
  libbirch_line_(76);
  #line 76 "src/expression/MultivariateBinaryExpression.birch"
  if (l.query() && r.query()) {
    #line 77 "src/expression/MultivariateBinaryExpression.birch"
    libbirch_line_(77);
    #line 77 "src/expression/MultivariateBinaryExpression.birch"
    return l.get() + r.get();
  } else {
    #line 78 "src/expression/MultivariateBinaryExpression.birch"
    libbirch_line_(78);
    #line 78 "src/expression/MultivariateBinaryExpression.birch"
    if (l.query()) {
      #line 79 "src/expression/MultivariateBinaryExpression.birch"
      libbirch_line_(79);
      #line 79 "src/expression/MultivariateBinaryExpression.birch"
      return l.get();
    } else {
      #line 80 "src/expression/MultivariateBinaryExpression.birch"
      libbirch_line_(80);
      #line 80 "src/expression/MultivariateBinaryExpression.birch"
      if (r.query()) {
        #line 81 "src/expression/MultivariateBinaryExpression.birch"
        libbirch_line_(81);
        #line 81 "src/expression/MultivariateBinaryExpression.birch"
        return r.get();
      } else {
        #line 83 "src/expression/MultivariateBinaryExpression.birch"
        libbirch_line_(83);
        #line 83 "src/expression/MultivariateBinaryExpression.birch"
        return libbirch::nil;
      }
    }
  }
}

#line 18 "src/expression/MultivariateBinaryExpression.birch"
template<class Left,class Right,class LeftValue,class RightValue,class LeftGradient,class RightGradient,class Value>
#line 87 "src/expression/MultivariateBinaryExpression.birch"
birch::type::Real birch::type::MultivariateBinaryExpression<Left, Right, LeftValue, RightValue, LeftGradient, RightGradient, Value>::doCompare(const birch::type::Integer& gen, const libbirch::Lazy<libbirch::Shared<birch::type::DelayExpression>>& x, const libbirch::Lazy<libbirch::Shared<birch::type::Kernel>>& _u0954, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_) {
  #line 87 "src/expression/MultivariateBinaryExpression.birch"
  libbirch_function_("doCompare", "src/expression/MultivariateBinaryExpression.birch", 87);
  #line 89 "src/expression/MultivariateBinaryExpression.birch"
  libbirch_line_(89);
  #line 89 "src/expression/MultivariateBinaryExpression.birch"
  auto o = libbirch::cast<libbirch::Lazy<libbirch::Shared<birch::type::MultivariateBinaryExpression<Left, Right, LeftValue, RightValue, LeftGradient, RightGradient, Value>>>>(x).get();
  #line 91 "src/expression/MultivariateBinaryExpression.birch"
  libbirch_line_(91);
  #line 91 "src/expression/MultivariateBinaryExpression.birch"
  return this_()->y.get()->compare(gen, o->y.get(), _u0954, handler_) + this_()->z.get()->compare(gen, o->z.get(), _u0954, handler_);
}

#line 18 "src/expression/MultivariateBinaryExpression.birch"
template<class Left,class Right,class LeftValue,class RightValue,class LeftGradient,class RightGradient,class Value>
#line 94 "src/expression/MultivariateBinaryExpression.birch"
void birch::type::MultivariateBinaryExpression<Left, Right, LeftValue, RightValue, LeftGradient, RightGradient, Value>::doConstant(const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_) {
  #line 94 "src/expression/MultivariateBinaryExpression.birch"
  libbirch_function_("doConstant", "src/expression/MultivariateBinaryExpression.birch", 94);
  #line 95 "src/expression/MultivariateBinaryExpression.birch"
  libbirch_line_(95);
  #line 95 "src/expression/MultivariateBinaryExpression.birch"
  this_()->y.get()->constant(handler_);
  #line 96 "src/expression/MultivariateBinaryExpression.birch"
  libbirch_line_(96);
  #line 96 "src/expression/MultivariateBinaryExpression.birch"
  this_()->z.get()->constant(handler_);
}

#line 18 "src/expression/MultivariateBinaryExpression.birch"
template<class Left,class Right,class LeftValue,class RightValue,class LeftGradient,class RightGradient,class Value>
#line 99 "src/expression/MultivariateBinaryExpression.birch"
void birch::type::MultivariateBinaryExpression<Left, Right, LeftValue, RightValue, LeftGradient, RightGradient, Value>::doCount(const birch::type::Integer& gen, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_) {
  #line 99 "src/expression/MultivariateBinaryExpression.birch"
  libbirch_function_("doCount", "src/expression/MultivariateBinaryExpression.birch", 99);
  #line 100 "src/expression/MultivariateBinaryExpression.birch"
  libbirch_line_(100);
  #line 100 "src/expression/MultivariateBinaryExpression.birch"
  this_()->y.get()->count(gen, handler_);
  #line 101 "src/expression/MultivariateBinaryExpression.birch"
  libbirch_line_(101);
  #line 101 "src/expression/MultivariateBinaryExpression.birch"
  this_()->z.get()->count(gen, handler_);
}

#line 18 "src/expression/MultivariateBinaryExpression.birch"
template<class Left,class Right,class LeftValue,class RightValue,class LeftGradient,class RightGradient,class Value>
#line 104 "src/expression/MultivariateBinaryExpression.birch"
void birch::type::MultivariateBinaryExpression<Left, Right, LeftValue, RightValue, LeftGradient, RightGradient, Value>::doDetach(const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_) {
  #line 104 "src/expression/MultivariateBinaryExpression.birch"
  libbirch_function_("doDetach", "src/expression/MultivariateBinaryExpression.birch", 104);
  #line 105 "src/expression/MultivariateBinaryExpression.birch"
  libbirch_line_(105);
  #line 105 "src/expression/MultivariateBinaryExpression.birch"
  this_()->y = libbirch::nil;
  #line 106 "src/expression/MultivariateBinaryExpression.birch"
  libbirch_line_(106);
  #line 106 "src/expression/MultivariateBinaryExpression.birch"
  this_()->z = libbirch::nil;
}

#line 4 "src/expression/MultivariateElement.birch"
template<class Value>
#line 4 "src/expression/MultivariateElement.birch"
birch::type::MultivariateElement<Value>::MultivariateElement(const libbirch::Lazy<libbirch::Shared<birch::type::Expression<libbirch::DefaultArray<Value,1>>>>& y, const birch::type::Integer& i, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_) :
    #line 4 "src/expression/MultivariateElement.birch"
    super_type_(),
    #line 9 "src/expression/MultivariateElement.birch"
    y(y),
    #line 14 "src/expression/MultivariateElement.birch"
    i(i) {
  //
}

#line 4 "src/expression/MultivariateElement.birch"
template<class Value>
#line 16 "src/expression/MultivariateElement.birch"
birch::type::Integer birch::type::MultivariateElement<Value>::doDepth(const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_) {
  #line 16 "src/expression/MultivariateElement.birch"
  libbirch_function_("doDepth", "src/expression/MultivariateElement.birch", 16);
  #line 17 "src/expression/MultivariateElement.birch"
  libbirch_line_(17);
  #line 17 "src/expression/MultivariateElement.birch"
  return this_()->y.get()->depth(handler_) + birch::type::Integer(1);
}

#line 4 "src/expression/MultivariateElement.birch"
template<class Value>
#line 20 "src/expression/MultivariateElement.birch"
Value birch::type::MultivariateElement<Value>::doValue(const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_) {
  #line 20 "src/expression/MultivariateElement.birch"
  libbirch_function_("doValue", "src/expression/MultivariateElement.birch", 20);
  #line 21 "src/expression/MultivariateElement.birch"
  libbirch_line_(21);
  #line 21 "src/expression/MultivariateElement.birch"
  return this_()->y.get()->value(handler_).get(libbirch::make_slice(this_()->i - 1));
}

#line 4 "src/expression/MultivariateElement.birch"
template<class Value>
#line 24 "src/expression/MultivariateElement.birch"
Value birch::type::MultivariateElement<Value>::doPilot(const birch::type::Integer& gen, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_) {
  #line 24 "src/expression/MultivariateElement.birch"
  libbirch_function_("doPilot", "src/expression/MultivariateElement.birch", 24);
  #line 25 "src/expression/MultivariateElement.birch"
  libbirch_line_(25);
  #line 25 "src/expression/MultivariateElement.birch"
  return this_()->y.get()->pilot(gen, handler_).get(libbirch::make_slice(this_()->i - 1));
}

#line 4 "src/expression/MultivariateElement.birch"
template<class Value>
#line 28 "src/expression/MultivariateElement.birch"
Value birch::type::MultivariateElement<Value>::doGet(const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_) {
  #line 28 "src/expression/MultivariateElement.birch"
  libbirch_function_("doGet", "src/expression/MultivariateElement.birch", 28);
  #line 29 "src/expression/MultivariateElement.birch"
  libbirch_line_(29);
  #line 29 "src/expression/MultivariateElement.birch"
  return this_()->y.get()->get(handler_).get(libbirch::make_slice(this_()->i - 1));
}

#line 4 "src/expression/MultivariateElement.birch"
template<class Value>
#line 32 "src/expression/MultivariateElement.birch"
Value birch::type::MultivariateElement<Value>::doMove(const birch::type::Integer& gen, const libbirch::Lazy<libbirch::Shared<birch::type::Kernel>>& _u0954, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_) {
  #line 32 "src/expression/MultivariateElement.birch"
  libbirch_function_("doMove", "src/expression/MultivariateElement.birch", 32);
  #line 33 "src/expression/MultivariateElement.birch"
  libbirch_line_(33);
  #line 33 "src/expression/MultivariateElement.birch"
  return this_()->y.get()->move(gen, _u0954, handler_).get(libbirch::make_slice(this_()->i - 1));
}

#line 4 "src/expression/MultivariateElement.birch"
template<class Value>
#line 36 "src/expression/MultivariateElement.birch"
void birch::type::MultivariateElement<Value>::doGrad(const birch::type::Integer& gen, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_) {
  #line 36 "src/expression/MultivariateElement.birch"
  libbirch_function_("doGrad", "src/expression/MultivariateElement.birch", 36);
  #line 37 "src/expression/MultivariateElement.birch"
  libbirch_line_(37);
  #line 37 "src/expression/MultivariateElement.birch"
  this_()->y.get()->grad(gen, this_()->d.get(), this_()->i, handler_);
}

#line 4 "src/expression/MultivariateElement.birch"
template<class Value>
#line 40 "src/expression/MultivariateElement.birch"
libbirch::Optional<libbirch::Lazy<libbirch::Shared<birch::type::Expression<birch::type::Real>>>> birch::type::MultivariateElement<Value>::doPrior(const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_) {
  #line 40 "src/expression/MultivariateElement.birch"
  libbirch_function_("doPrior", "src/expression/MultivariateElement.birch", 40);
  #line 41 "src/expression/MultivariateElement.birch"
  libbirch_line_(41);
  #line 41 "src/expression/MultivariateElement.birch"
  return this_()->y.get()->prior(handler_);
}

#line 4 "src/expression/MultivariateElement.birch"
template<class Value>
#line 44 "src/expression/MultivariateElement.birch"
birch::type::Real birch::type::MultivariateElement<Value>::doCompare(const birch::type::Integer& gen, const libbirch::Lazy<libbirch::Shared<birch::type::DelayExpression>>& x, const libbirch::Lazy<libbirch::Shared<birch::type::Kernel>>& _u0954, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_) {
  #line 44 "src/expression/MultivariateElement.birch"
  libbirch_function_("doCompare", "src/expression/MultivariateElement.birch", 44);
  #line 46 "src/expression/MultivariateElement.birch"
  libbirch_line_(46);
  #line 46 "src/expression/MultivariateElement.birch"
  auto o = libbirch::cast<libbirch::Lazy<libbirch::Shared<birch::type::MatrixElement<Value>>>>(x).get();
  #line 47 "src/expression/MultivariateElement.birch"
  libbirch_line_(47);
  #line 47 "src/expression/MultivariateElement.birch"
  return this_()->y.get()->compare(gen, o->y.get(), _u0954, handler_);
}

#line 4 "src/expression/MultivariateElement.birch"
template<class Value>
#line 50 "src/expression/MultivariateElement.birch"
void birch::type::MultivariateElement<Value>::doConstant(const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_) {
  #line 50 "src/expression/MultivariateElement.birch"
  libbirch_function_("doConstant", "src/expression/MultivariateElement.birch", 50);
  #line 51 "src/expression/MultivariateElement.birch"
  libbirch_line_(51);
  #line 51 "src/expression/MultivariateElement.birch"
  this_()->y.get()->constant(handler_);
}

#line 4 "src/expression/MultivariateElement.birch"
template<class Value>
#line 54 "src/expression/MultivariateElement.birch"
void birch::type::MultivariateElement<Value>::doCount(const birch::type::Integer& gen, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_) {
  #line 54 "src/expression/MultivariateElement.birch"
  libbirch_function_("doCount", "src/expression/MultivariateElement.birch", 54);
  #line 55 "src/expression/MultivariateElement.birch"
  libbirch_line_(55);
  #line 55 "src/expression/MultivariateElement.birch"
  this_()->y.get()->count(gen, handler_);
}

#line 4 "src/expression/MultivariateElement.birch"
template<class Value>
#line 58 "src/expression/MultivariateElement.birch"
void birch::type::MultivariateElement<Value>::doDetach(const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_) {
  #line 58 "src/expression/MultivariateElement.birch"
  libbirch_function_("doDetach", "src/expression/MultivariateElement.birch", 58);
  #line 59 "src/expression/MultivariateElement.birch"
  libbirch_line_(59);
  #line 59 "src/expression/MultivariateElement.birch"
  this_()->y = libbirch::nil;
}

#line 6 "src/expression/MultivariateExpression.birch"
template<class Value>
#line 6 "src/expression/MultivariateExpression.birch"
birch::type::MultivariateExpression<Value>::MultivariateExpression(const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_) :
    #line 6 "src/expression/MultivariateExpression.birch"
    super_type_(libbirch::nil),
    #line 10 "src/expression/MultivariateExpression.birch"
    d() {
  //
}

#line 6 "src/expression/MultivariateExpression.birch"
template<class Value>
#line 12 "src/expression/MultivariateExpression.birch"
birch::type::Integer birch::type::MultivariateExpression<Value>::doColumns(const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_) {
  #line 12 "src/expression/MultivariateExpression.birch"
  libbirch_function_("doColumns", "src/expression/MultivariateExpression.birch", 12);
  #line 13 "src/expression/MultivariateExpression.birch"
  libbirch_line_(13);
  #line 13 "src/expression/MultivariateExpression.birch"
  return birch::type::Integer(1);
}

#line 6 "src/expression/MultivariateExpression.birch"
template<class Value>
#line 16 "src/expression/MultivariateExpression.birch"
void birch::type::MultivariateExpression<Value>::doAccumulateGrad(const libbirch::DefaultArray<birch::type::Real,1>& d, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_) {
  #line 16 "src/expression/MultivariateExpression.birch"
  libbirch_function_("doAccumulateGrad", "src/expression/MultivariateExpression.birch", 16);
  #line 17 "src/expression/MultivariateExpression.birch"
  libbirch_line_(17);
  #line 17 "src/expression/MultivariateExpression.birch"
  if (this_()->d.query()) {
    #line 18 "src/expression/MultivariateExpression.birch"
    libbirch_line_(18);
    #line 18 "src/expression/MultivariateExpression.birch"
    this_()->d = this_()->d.get() + d;
  } else {
    #line 20 "src/expression/MultivariateExpression.birch"
    libbirch_line_(20);
    #line 20 "src/expression/MultivariateExpression.birch"
    this_()->d = d;
  }
}

#line 6 "src/expression/MultivariateExpression.birch"
template<class Value>
#line 24 "src/expression/MultivariateExpression.birch"
void birch::type::MultivariateExpression<Value>::doAccumulateGrad(const birch::type::Real& d, const birch::type::Integer& i, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_) {
  #line 24 "src/expression/MultivariateExpression.birch"
  libbirch_function_("doAccumulateGrad", "src/expression/MultivariateExpression.birch", 24);
  #line 25 "src/expression/MultivariateExpression.birch"
  libbirch_line_(25);
  #line 25 "src/expression/MultivariateExpression.birch"
  if (!this_()->d.query()) {
    #line 26 "src/expression/MultivariateExpression.birch"
    libbirch_line_(26);
    #line 26 "src/expression/MultivariateExpression.birch"
    this_()->d = birch::vector(0.0, this_()->length(handler_), handler_);
  }
  #line 28 "src/expression/MultivariateExpression.birch"
  libbirch_line_(28);
  #line 28 "src/expression/MultivariateExpression.birch"
  this_()->d.get().set(libbirch::make_slice(i - 1), this_()->d.get().get(libbirch::make_slice(i - 1)) + d);
}

#line 6 "src/expression/MultivariateExpression.birch"
template<class Value>
#line 31 "src/expression/MultivariateExpression.birch"
void birch::type::MultivariateExpression<Value>::doClearGrad(const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_) {
  #line 31 "src/expression/MultivariateExpression.birch"
  libbirch_function_("doClearGrad", "src/expression/MultivariateExpression.birch", 31);
  #line 32 "src/expression/MultivariateExpression.birch"
  libbirch_line_(32);
  #line 32 "src/expression/MultivariateExpression.birch"
  this_()->d = libbirch::nil;
}

#line 4 "src/expression/MultivariateJoin.birch"
template<class Value>
#line 4 "src/expression/MultivariateJoin.birch"
birch::type::MultivariateJoin<Value>::MultivariateJoin(const libbirch::DefaultArray<libbirch::Lazy<libbirch::Shared<birch::type::Expression<Value>>>,1>& x, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_) :
    #line 4 "src/expression/MultivariateJoin.birch"
    super_type_(),
    #line 9 "src/expression/MultivariateJoin.birch"
    y(x) {
  //
}

#line 4 "src/expression/MultivariateJoin.birch"
template<class Value>
#line 11 "src/expression/MultivariateJoin.birch"
birch::type::Integer birch::type::MultivariateJoin<Value>::doDepth(const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_) {
  #line 11 "src/expression/MultivariateJoin.birch"
  libbirch_function_("doDepth", "src/expression/MultivariateJoin.birch", 11);
  #line 12 "src/expression/MultivariateJoin.birch"
  libbirch_line_(12);
  #line 12 "src/expression/MultivariateJoin.birch"
  auto depth = birch::type::Integer(0);
  #line 13 "src/expression/MultivariateJoin.birch"
  libbirch_line_(13);
  #line 13 "src/expression/MultivariateJoin.birch"
  for (auto i = birch::type::Integer(1); i <= this_()->length(handler_); ++i) {
    #line 14 "src/expression/MultivariateJoin.birch"
    libbirch_line_(14);
    #line 14 "src/expression/MultivariateJoin.birch"
    depth = birch::max(depth, this_()->y.get().get(libbirch::make_slice(i - 1))->depth(handler_), handler_);
  }
  #line 16 "src/expression/MultivariateJoin.birch"
  libbirch_line_(16);
  #line 16 "src/expression/MultivariateJoin.birch"
  return depth + birch::type::Integer(1);
}

#line 4 "src/expression/MultivariateJoin.birch"
template<class Value>
#line 19 "src/expression/MultivariateJoin.birch"
birch::type::Integer birch::type::MultivariateJoin<Value>::doRows(const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_) {
  #line 19 "src/expression/MultivariateJoin.birch"
  libbirch_function_("doRows", "src/expression/MultivariateJoin.birch", 19);
  #line 20 "src/expression/MultivariateJoin.birch"
  libbirch_line_(20);
  #line 20 "src/expression/MultivariateJoin.birch"
  return birch::length(this_()->y.get(), handler_);
}

#line 4 "src/expression/MultivariateJoin.birch"
template<class Value>
#line 23 "src/expression/MultivariateJoin.birch"
libbirch::DefaultArray<Value,1> birch::type::MultivariateJoin<Value>::doValue(const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_) {
  #line 23 "src/expression/MultivariateJoin.birch"
  libbirch_function_("doValue", "src/expression/MultivariateJoin.birch", 23);
  #line 24 "src/expression/MultivariateJoin.birch"
  libbirch_line_(24);
  #line 24 "src/expression/MultivariateJoin.birch"
  return birch::transform(this_()->y.get(), std::function<Value(libbirch::Lazy<libbirch::Shared<birch::type::Expression<Value>>>,const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_
)>([=](const libbirch::Lazy<libbirch::Shared<birch::type::Expression<Value>>>& x, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr) {
    #line 25 "src/expression/MultivariateJoin.birch"
    libbirch_line_(25);
    #line 25 "src/expression/MultivariateJoin.birch"
    return x->value(handler_);
  }), handler_);
}

#line 4 "src/expression/MultivariateJoin.birch"
template<class Value>
#line 29 "src/expression/MultivariateJoin.birch"
libbirch::DefaultArray<Value,1> birch::type::MultivariateJoin<Value>::doPilot(const birch::type::Integer& gen, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_) {
  #line 29 "src/expression/MultivariateJoin.birch"
  libbirch_function_("doPilot", "src/expression/MultivariateJoin.birch", 29);
  #line 30 "src/expression/MultivariateJoin.birch"
  libbirch_line_(30);
  #line 30 "src/expression/MultivariateJoin.birch"
  return birch::transform(this_()->y.get(), std::function<Value(libbirch::Lazy<libbirch::Shared<birch::type::Expression<Value>>>,const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_
)>([=](const libbirch::Lazy<libbirch::Shared<birch::type::Expression<Value>>>& x, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr) {
    #line 31 "src/expression/MultivariateJoin.birch"
    libbirch_line_(31);
    #line 31 "src/expression/MultivariateJoin.birch"
    return x->pilot(gen, handler_);
  }), handler_);
}

#line 4 "src/expression/MultivariateJoin.birch"
template<class Value>
#line 35 "src/expression/MultivariateJoin.birch"
libbirch::DefaultArray<Value,1> birch::type::MultivariateJoin<Value>::doGet(const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_) {
  #line 35 "src/expression/MultivariateJoin.birch"
  libbirch_function_("doGet", "src/expression/MultivariateJoin.birch", 35);
  #line 36 "src/expression/MultivariateJoin.birch"
  libbirch_line_(36);
  #line 36 "src/expression/MultivariateJoin.birch"
  return birch::transform(this_()->y.get(), std::function<Value(libbirch::Lazy<libbirch::Shared<birch::type::Expression<Value>>>,const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_
)>([=](const libbirch::Lazy<libbirch::Shared<birch::type::Expression<Value>>>& x, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr) {
    #line 37 "src/expression/MultivariateJoin.birch"
    libbirch_line_(37);
    #line 37 "src/expression/MultivariateJoin.birch"
    return x->get(handler_);
  }), handler_);
}

#line 4 "src/expression/MultivariateJoin.birch"
template<class Value>
#line 41 "src/expression/MultivariateJoin.birch"
libbirch::DefaultArray<Value,1> birch::type::MultivariateJoin<Value>::doMove(const birch::type::Integer& gen, const libbirch::Lazy<libbirch::Shared<birch::type::Kernel>>& _u0954, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_) {
  #line 41 "src/expression/MultivariateJoin.birch"
  libbirch_function_("doMove", "src/expression/MultivariateJoin.birch", 41);
  #line 42 "src/expression/MultivariateJoin.birch"
  libbirch_line_(42);
  #line 42 "src/expression/MultivariateJoin.birch"
  return birch::transform(this_()->y.get(), std::function<Value(libbirch::Lazy<libbirch::Shared<birch::type::Expression<Value>>>,const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_
)>([=](const libbirch::Lazy<libbirch::Shared<birch::type::Expression<Value>>>& x, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr) {
    #line 43 "src/expression/MultivariateJoin.birch"
    libbirch_line_(43);
    #line 43 "src/expression/MultivariateJoin.birch"
    return x->move(gen, _u0954, handler_);
  }), handler_);
}

#line 4 "src/expression/MultivariateJoin.birch"
template<class Value>
#line 47 "src/expression/MultivariateJoin.birch"
void birch::type::MultivariateJoin<Value>::doGrad(const birch::type::Integer& gen, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_) {
  #line 47 "src/expression/MultivariateJoin.birch"
  libbirch_function_("doGrad", "src/expression/MultivariateJoin.birch", 47);
  #line 48 "src/expression/MultivariateJoin.birch"
  libbirch_line_(48);
  #line 48 "src/expression/MultivariateJoin.birch"
  birch::for_each(this_()->y.get(), this_()->d.get(), std::function<void(libbirch::Lazy<libbirch::Shared<birch::type::Expression<Value>>>,Value,const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_
)>([=](const libbirch::Lazy<libbirch::Shared<birch::type::Expression<Value>>>& x, const Value& d, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr) {
    #line 48 "src/expression/MultivariateJoin.birch"
    libbirch_line_(48);
    #line 48 "src/expression/MultivariateJoin.birch"
    x->grad(gen, d, handler_);
  }), handler_);
}

#line 4 "src/expression/MultivariateJoin.birch"
template<class Value>
#line 51 "src/expression/MultivariateJoin.birch"
libbirch::Optional<libbirch::Lazy<libbirch::Shared<birch::type::Expression<birch::type::Real>>>> birch::type::MultivariateJoin<Value>::doPrior(const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_) {
  #line 51 "src/expression/MultivariateJoin.birch"
  libbirch_function_("doPrior", "src/expression/MultivariateJoin.birch", 51);
  #line 52 "src/expression/MultivariateJoin.birch"
  libbirch_line_(52);
  #line 52 "src/expression/MultivariateJoin.birch"
  libbirch::Optional<libbirch::Lazy<libbirch::Shared<birch::type::Expression<birch::type::Real>>>> p;
  #line 53 "src/expression/MultivariateJoin.birch"
  libbirch_line_(53);
  #line 53 "src/expression/MultivariateJoin.birch"
  auto L = this_()->length(handler_);
  #line 54 "src/expression/MultivariateJoin.birch"
  libbirch_line_(54);
  #line 54 "src/expression/MultivariateJoin.birch"
  for (auto i = birch::type::Integer(1); i <= L; ++i) {
    #line 55 "src/expression/MultivariateJoin.birch"
    libbirch_line_(55);
    #line 55 "src/expression/MultivariateJoin.birch"
    auto q = this_()->y.get().get(libbirch::make_slice(i - 1))->prior(handler_);
    #line 56 "src/expression/MultivariateJoin.birch"
    libbirch_line_(56);
    #line 56 "src/expression/MultivariateJoin.birch"
    if (q.query()) {
      #line 57 "src/expression/MultivariateJoin.birch"
      libbirch_line_(57);
      #line 57 "src/expression/MultivariateJoin.birch"
      if (p.query()) {
        #line 58 "src/expression/MultivariateJoin.birch"
        libbirch_line_(58);
        #line 58 "src/expression/MultivariateJoin.birch"
        p = p.get() + q.get();
      } else {
        #line 60 "src/expression/MultivariateJoin.birch"
        libbirch_line_(60);
        #line 60 "src/expression/MultivariateJoin.birch"
        p = q;
      }
    }
  }
  #line 64 "src/expression/MultivariateJoin.birch"
  libbirch_line_(64);
  #line 64 "src/expression/MultivariateJoin.birch"
  return p;
}

#line 4 "src/expression/MultivariateJoin.birch"
template<class Value>
#line 67 "src/expression/MultivariateJoin.birch"
birch::type::Real birch::type::MultivariateJoin<Value>::doCompare(const birch::type::Integer& gen, const libbirch::Lazy<libbirch::Shared<birch::type::DelayExpression>>& x, const libbirch::Lazy<libbirch::Shared<birch::type::Kernel>>& _u0954, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_) {
  #line 67 "src/expression/MultivariateJoin.birch"
  libbirch_function_("doCompare", "src/expression/MultivariateJoin.birch", 67);
  #line 69 "src/expression/MultivariateJoin.birch"
  libbirch_line_(69);
  #line 69 "src/expression/MultivariateJoin.birch"
  libbirch_assert_(this_()->rows(handler_) == x->rows(handler_));
  #line 70 "src/expression/MultivariateJoin.birch"
  libbirch_line_(70);
  #line 70 "src/expression/MultivariateJoin.birch"
  libbirch_assert_(this_()->columns(handler_) == x->columns(handler_));
  #line 72 "src/expression/MultivariateJoin.birch"
  libbirch_line_(72);
  #line 72 "src/expression/MultivariateJoin.birch"
  auto o = libbirch::cast<libbirch::Lazy<libbirch::Shared<birch::type::MultivariateJoin<Value>>>>(x).get();
  #line 73 "src/expression/MultivariateJoin.birch"
  libbirch_line_(73);
  #line 73 "src/expression/MultivariateJoin.birch"
  auto w = 0.0;
  #line 74 "src/expression/MultivariateJoin.birch"
  libbirch_line_(74);
  #line 74 "src/expression/MultivariateJoin.birch"
  auto R = this_()->rows(handler_);
  #line 75 "src/expression/MultivariateJoin.birch"
  libbirch_line_(75);
  #line 75 "src/expression/MultivariateJoin.birch"
  auto C = this_()->columns(handler_);
  #line 76 "src/expression/MultivariateJoin.birch"
  libbirch_line_(76);
  #line 76 "src/expression/MultivariateJoin.birch"
  for (auto i = birch::type::Integer(1); i <= R; ++i) {
    #line 77 "src/expression/MultivariateJoin.birch"
    libbirch_line_(77);
    #line 77 "src/expression/MultivariateJoin.birch"
    for (auto j = birch::type::Integer(1); j <= C; ++j) {
      #line 78 "src/expression/MultivariateJoin.birch"
      libbirch_line_(78);
      #line 78 "src/expression/MultivariateJoin.birch"
      w = w + this_()->y.get().get(libbirch::make_slice(i - 1, j - 1))->compare(gen, o->y.get().get(libbirch::make_slice(i - 1, j - 1)), _u0954, handler_);
    }
  }
  #line 81 "src/expression/MultivariateJoin.birch"
  libbirch_line_(81);
  #line 81 "src/expression/MultivariateJoin.birch"
  return w;
}

#line 4 "src/expression/MultivariateJoin.birch"
template<class Value>
#line 84 "src/expression/MultivariateJoin.birch"
void birch::type::MultivariateJoin<Value>::doCount(const birch::type::Integer& gen, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_) {
  #line 84 "src/expression/MultivariateJoin.birch"
  libbirch_function_("doCount", "src/expression/MultivariateJoin.birch", 84);
  #line 85 "src/expression/MultivariateJoin.birch"
  libbirch_line_(85);
  #line 85 "src/expression/MultivariateJoin.birch"
  birch::for_each(this_()->y.get(), std::function<void(libbirch::Lazy<libbirch::Shared<birch::type::Expression<Value>>>,const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_
)>([=](const libbirch::Lazy<libbirch::Shared<birch::type::Expression<Value>>>& x, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr) {
    #line 85 "src/expression/MultivariateJoin.birch"
    libbirch_line_(85);
    #line 85 "src/expression/MultivariateJoin.birch"
    x->count(gen, handler_);
  }), handler_);
}

#line 4 "src/expression/MultivariateJoin.birch"
template<class Value>
#line 88 "src/expression/MultivariateJoin.birch"
void birch::type::MultivariateJoin<Value>::doConstant(const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_) {
  #line 88 "src/expression/MultivariateJoin.birch"
  libbirch_function_("doConstant", "src/expression/MultivariateJoin.birch", 88);
  #line 89 "src/expression/MultivariateJoin.birch"
  libbirch_line_(89);
  #line 89 "src/expression/MultivariateJoin.birch"
  birch::for_each(this_()->y.get(), std::function<void(libbirch::Lazy<libbirch::Shared<birch::type::Expression<Value>>>,const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_
)>([=](const libbirch::Lazy<libbirch::Shared<birch::type::Expression<Value>>>& x, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr) {
    #line 89 "src/expression/MultivariateJoin.birch"
    libbirch_line_(89);
    #line 89 "src/expression/MultivariateJoin.birch"
    x->constant(handler_);
  }), handler_);
}

#line 4 "src/expression/MultivariateJoin.birch"
template<class Value>
#line 92 "src/expression/MultivariateJoin.birch"
void birch::type::MultivariateJoin<Value>::doDetach(const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_) {
  #line 92 "src/expression/MultivariateJoin.birch"
  libbirch_function_("doDetach", "src/expression/MultivariateJoin.birch", 92);
  #line 93 "src/expression/MultivariateJoin.birch"
  libbirch_line_(93);
  #line 93 "src/expression/MultivariateJoin.birch"
  this_()->y = libbirch::nil;
}

#line 4 "src/expression/MultivariateSolve.birch"
template<class Left,class LeftValue>
#line 4 "src/expression/MultivariateSolve.birch"
birch::type::MultivariateSolve<Left, LeftValue>::MultivariateSolve(const Left& y, const libbirch::Lazy<libbirch::Shared<birch::type::Expression<libbirch::DefaultArray<birch::type::Real,1>>>>& z, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_) :
    #line 4 "src/expression/MultivariateSolve.birch"
    super_type_(y, z) {
  //
}

#line 4 "src/expression/MultivariateSolve.birch"
template<class Left,class LeftValue>
#line 7 "src/expression/MultivariateSolve.birch"
birch::type::Integer birch::type::MultivariateSolve<Left, LeftValue>::doRows(const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_) {
  #line 7 "src/expression/MultivariateSolve.birch"
  libbirch_function_("doRows", "src/expression/MultivariateSolve.birch", 7);
  #line 8 "src/expression/MultivariateSolve.birch"
  libbirch_line_(8);
  #line 8 "src/expression/MultivariateSolve.birch"
  return this_()->z.get()->rows(handler_);
}

#line 4 "src/expression/MultivariateSolve.birch"
template<class Left,class LeftValue>
#line 11 "src/expression/MultivariateSolve.birch"
libbirch::DefaultArray<birch::type::Real,1> birch::type::MultivariateSolve<Left, LeftValue>::doEvaluate(const LeftValue& y, const libbirch::DefaultArray<birch::type::Real,1>& z, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_) {
  #line 11 "src/expression/MultivariateSolve.birch"
  libbirch_function_("doEvaluate", "src/expression/MultivariateSolve.birch", 11);
  #line 12 "src/expression/MultivariateSolve.birch"
  libbirch_line_(12);
  #line 12 "src/expression/MultivariateSolve.birch"
  return birch::solve(y, z, handler_);
}

#line 4 "src/expression/MultivariateSolve.birch"
template<class Left,class LeftValue>
#line 15 "src/expression/MultivariateSolve.birch"
libbirch::DefaultArray<birch::type::Real,2> birch::type::MultivariateSolve<Left, LeftValue>::doEvaluateGradLeft(const libbirch::DefaultArray<birch::type::Real,1>& d, const libbirch::DefaultArray<birch::type::Real,1>& x, const LeftValue& y, const libbirch::DefaultArray<birch::type::Real,1>& z, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_) {
  #line 15 "src/expression/MultivariateSolve.birch"
  libbirch_function_("doEvaluateGradLeft", "src/expression/MultivariateSolve.birch", 15);
  #line 17 "src/expression/MultivariateSolve.birch"
  libbirch_line_(17);
  #line 17 "src/expression/MultivariateSolve.birch"
  return birch::outer(-birch::solve(birch::transpose(y, handler_), d, handler_), birch::solve(y, z, handler_), handler_);
}

#line 4 "src/expression/MultivariateSolve.birch"
template<class Left,class LeftValue>
#line 20 "src/expression/MultivariateSolve.birch"
libbirch::DefaultArray<birch::type::Real,1> birch::type::MultivariateSolve<Left, LeftValue>::doEvaluateGradRight(const libbirch::DefaultArray<birch::type::Real,1>& d, const libbirch::DefaultArray<birch::type::Real,1>& x, const LeftValue& y, const libbirch::DefaultArray<birch::type::Real,1>& z, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_) {
  #line 20 "src/expression/MultivariateSolve.birch"
  libbirch_function_("doEvaluateGradRight", "src/expression/MultivariateSolve.birch", 20);
  #line 22 "src/expression/MultivariateSolve.birch"
  libbirch_line_(22);
  #line 22 "src/expression/MultivariateSolve.birch"
  return birch::solve(birch::transpose(y, handler_), d, handler_);
}

#line 12 "src/expression/MultivariateUnaryExpression.birch"
template<class Argument,class ArgumentValue,class ArgumentGradient,class Value>
#line 12 "src/expression/MultivariateUnaryExpression.birch"
birch::type::MultivariateUnaryExpression<Argument, ArgumentValue, ArgumentGradient, Value>::MultivariateUnaryExpression(const Argument& y, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_) :
    #line 12 "src/expression/MultivariateUnaryExpression.birch"
    super_type_(),
    #line 17 "src/expression/MultivariateUnaryExpression.birch"
    y(y) {
  //
}

#line 12 "src/expression/MultivariateUnaryExpression.birch"
template<class Argument,class ArgumentValue,class ArgumentGradient,class Value>
#line 30 "src/expression/MultivariateUnaryExpression.birch"
birch::type::Integer birch::type::MultivariateUnaryExpression<Argument, ArgumentValue, ArgumentGradient, Value>::doDepth(const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_) {
  #line 30 "src/expression/MultivariateUnaryExpression.birch"
  libbirch_function_("doDepth", "src/expression/MultivariateUnaryExpression.birch", 30);
  #line 31 "src/expression/MultivariateUnaryExpression.birch"
  libbirch_line_(31);
  #line 31 "src/expression/MultivariateUnaryExpression.birch"
  return this_()->y.get()->depth(handler_) + birch::type::Integer(1);
}

#line 12 "src/expression/MultivariateUnaryExpression.birch"
template<class Argument,class ArgumentValue,class ArgumentGradient,class Value>
#line 34 "src/expression/MultivariateUnaryExpression.birch"
Value birch::type::MultivariateUnaryExpression<Argument, ArgumentValue, ArgumentGradient, Value>::doValue(const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_) {
  #line 34 "src/expression/MultivariateUnaryExpression.birch"
  libbirch_function_("doValue", "src/expression/MultivariateUnaryExpression.birch", 34);
  #line 35 "src/expression/MultivariateUnaryExpression.birch"
  libbirch_line_(35);
  #line 35 "src/expression/MultivariateUnaryExpression.birch"
  return this_()->doEvaluate(this_()->y.get()->value(handler_), handler_);
}

#line 12 "src/expression/MultivariateUnaryExpression.birch"
template<class Argument,class ArgumentValue,class ArgumentGradient,class Value>
#line 38 "src/expression/MultivariateUnaryExpression.birch"
Value birch::type::MultivariateUnaryExpression<Argument, ArgumentValue, ArgumentGradient, Value>::doPilot(const birch::type::Integer& gen, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_) {
  #line 38 "src/expression/MultivariateUnaryExpression.birch"
  libbirch_function_("doPilot", "src/expression/MultivariateUnaryExpression.birch", 38);
  #line 39 "src/expression/MultivariateUnaryExpression.birch"
  libbirch_line_(39);
  #line 39 "src/expression/MultivariateUnaryExpression.birch"
  return this_()->doEvaluate(this_()->y.get()->pilot(gen, handler_), handler_);
}

#line 12 "src/expression/MultivariateUnaryExpression.birch"
template<class Argument,class ArgumentValue,class ArgumentGradient,class Value>
#line 42 "src/expression/MultivariateUnaryExpression.birch"
Value birch::type::MultivariateUnaryExpression<Argument, ArgumentValue, ArgumentGradient, Value>::doGet(const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_) {
  #line 42 "src/expression/MultivariateUnaryExpression.birch"
  libbirch_function_("doGet", "src/expression/MultivariateUnaryExpression.birch", 42);
  #line 43 "src/expression/MultivariateUnaryExpression.birch"
  libbirch_line_(43);
  #line 43 "src/expression/MultivariateUnaryExpression.birch"
  return this_()->doEvaluate(this_()->y.get()->get(handler_), handler_);
}

#line 12 "src/expression/MultivariateUnaryExpression.birch"
template<class Argument,class ArgumentValue,class ArgumentGradient,class Value>
#line 46 "src/expression/MultivariateUnaryExpression.birch"
Value birch::type::MultivariateUnaryExpression<Argument, ArgumentValue, ArgumentGradient, Value>::doMove(const birch::type::Integer& gen, const libbirch::Lazy<libbirch::Shared<birch::type::Kernel>>& _u0954, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_) {
  #line 46 "src/expression/MultivariateUnaryExpression.birch"
  libbirch_function_("doMove", "src/expression/MultivariateUnaryExpression.birch", 46);
  #line 47 "src/expression/MultivariateUnaryExpression.birch"
  libbirch_line_(47);
  #line 47 "src/expression/MultivariateUnaryExpression.birch"
  return this_()->doEvaluate(this_()->y.get()->move(gen, _u0954, handler_), handler_);
}

#line 12 "src/expression/MultivariateUnaryExpression.birch"
template<class Argument,class ArgumentValue,class ArgumentGradient,class Value>
#line 50 "src/expression/MultivariateUnaryExpression.birch"
void birch::type::MultivariateUnaryExpression<Argument, ArgumentValue, ArgumentGradient, Value>::doGrad(const birch::type::Integer& gen, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_) {
  #line 50 "src/expression/MultivariateUnaryExpression.birch"
  libbirch_function_("doGrad", "src/expression/MultivariateUnaryExpression.birch", 50);
  #line 51 "src/expression/MultivariateUnaryExpression.birch"
  libbirch_line_(51);
  #line 51 "src/expression/MultivariateUnaryExpression.birch"
  this_()->y.get()->grad(gen, this_()->doEvaluateGrad(this_()->d.get(), this_()->x.get(), this_()->y.get()->get(handler_), handler_), handler_);
}

#line 12 "src/expression/MultivariateUnaryExpression.birch"
template<class Argument,class ArgumentValue,class ArgumentGradient,class Value>
#line 54 "src/expression/MultivariateUnaryExpression.birch"
libbirch::Optional<libbirch::Lazy<libbirch::Shared<birch::type::Expression<birch::type::Real>>>> birch::type::MultivariateUnaryExpression<Argument, ArgumentValue, ArgumentGradient, Value>::doPrior(const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_) {
  #line 54 "src/expression/MultivariateUnaryExpression.birch"
  libbirch_function_("doPrior", "src/expression/MultivariateUnaryExpression.birch", 54);
  #line 55 "src/expression/MultivariateUnaryExpression.birch"
  libbirch_line_(55);
  #line 55 "src/expression/MultivariateUnaryExpression.birch"
  return this_()->y.get()->prior(handler_);
}

#line 12 "src/expression/MultivariateUnaryExpression.birch"
template<class Argument,class ArgumentValue,class ArgumentGradient,class Value>
#line 58 "src/expression/MultivariateUnaryExpression.birch"
birch::type::Real birch::type::MultivariateUnaryExpression<Argument, ArgumentValue, ArgumentGradient, Value>::doCompare(const birch::type::Integer& gen, const libbirch::Lazy<libbirch::Shared<birch::type::DelayExpression>>& x, const libbirch::Lazy<libbirch::Shared<birch::type::Kernel>>& _u0954, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_) {
  #line 58 "src/expression/MultivariateUnaryExpression.birch"
  libbirch_function_("doCompare", "src/expression/MultivariateUnaryExpression.birch", 58);
  #line 60 "src/expression/MultivariateUnaryExpression.birch"
  libbirch_line_(60);
  #line 60 "src/expression/MultivariateUnaryExpression.birch"
  auto o = libbirch::cast<libbirch::Lazy<libbirch::Shared<birch::type::MultivariateUnaryExpression<Argument, ArgumentValue, ArgumentGradient, Value>>>>(x).get();
  #line 62 "src/expression/MultivariateUnaryExpression.birch"
  libbirch_line_(62);
  #line 62 "src/expression/MultivariateUnaryExpression.birch"
  return this_()->y.get()->compare(gen, o->y.get(), _u0954, handler_);
}

#line 12 "src/expression/MultivariateUnaryExpression.birch"
template<class Argument,class ArgumentValue,class ArgumentGradient,class Value>
#line 65 "src/expression/MultivariateUnaryExpression.birch"
void birch::type::MultivariateUnaryExpression<Argument, ArgumentValue, ArgumentGradient, Value>::doConstant(const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_) {
  #line 65 "src/expression/MultivariateUnaryExpression.birch"
  libbirch_function_("doConstant", "src/expression/MultivariateUnaryExpression.birch", 65);
  #line 66 "src/expression/MultivariateUnaryExpression.birch"
  libbirch_line_(66);
  #line 66 "src/expression/MultivariateUnaryExpression.birch"
  this_()->y.get()->constant(handler_);
}

#line 12 "src/expression/MultivariateUnaryExpression.birch"
template<class Argument,class ArgumentValue,class ArgumentGradient,class Value>
#line 69 "src/expression/MultivariateUnaryExpression.birch"
void birch::type::MultivariateUnaryExpression<Argument, ArgumentValue, ArgumentGradient, Value>::doCount(const birch::type::Integer& gen, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_) {
  #line 69 "src/expression/MultivariateUnaryExpression.birch"
  libbirch_function_("doCount", "src/expression/MultivariateUnaryExpression.birch", 69);
  #line 70 "src/expression/MultivariateUnaryExpression.birch"
  libbirch_line_(70);
  #line 70 "src/expression/MultivariateUnaryExpression.birch"
  this_()->y.get()->count(gen, handler_);
}

#line 12 "src/expression/MultivariateUnaryExpression.birch"
template<class Argument,class ArgumentValue,class ArgumentGradient,class Value>
#line 73 "src/expression/MultivariateUnaryExpression.birch"
void birch::type::MultivariateUnaryExpression<Argument, ArgumentValue, ArgumentGradient, Value>::doDetach(const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_) {
  #line 73 "src/expression/MultivariateUnaryExpression.birch"
  libbirch_function_("doDetach", "src/expression/MultivariateUnaryExpression.birch", 73);
  #line 74 "src/expression/MultivariateUnaryExpression.birch"
  libbirch_line_(74);
  #line 74 "src/expression/MultivariateUnaryExpression.birch"
  this_()->y = libbirch::nil;
}

#line 13 "src/expression/Random.birch"
template<class Value>
#line 13 "src/expression/Random.birch"
birch::type::Random<Value>::Random(const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_) :
    #line 13 "src/expression/Random.birch"
    super_type_(libbirch::nil),
    #line 17 "src/expression/Random.birch"
    p(),
    #line 22 "src/expression/Random.birch"
    d() {
  //
}

#line 13 "src/expression/Random.birch"
template<class Value>
#line 27 "src/expression/Random.birch"
birch::type::Random<Value>& birch::type::Random<Value>::operator=(const Value& x) {
  #line 27 "src/expression/Random.birch"
  libbirch_function_("<assignment>", "src/expression/Random.birch", 27);
  #line 28 "src/expression/Random.birch"
  libbirch_line_(28);
  #line 28 "src/expression/Random.birch"
  libbirch_assert_(!this_()->x.query());
  #line 29 "src/expression/Random.birch"
  libbirch_line_(29);
  #line 29 "src/expression/Random.birch"
  libbirch_assert_(!this_()->p.query());
  #line 30 "src/expression/Random.birch"
  libbirch_line_(30);
  #line 30 "src/expression/Random.birch"
  this_()->x = x;
  #line 31 "src/expression/Random.birch"
  libbirch_line_(31);
  #line 31 "src/expression/Random.birch"
  this_()->constant();
  #line 27 "src/expression/Random.birch"
  return *this;
}

#line 13 "src/expression/Random.birch"
template<class Value>
#line 37 "src/expression/Random.birch"
birch::type::Random<Value>& birch::type::Random<Value>::operator=(const libbirch::Optional<Value>& x) {
  #line 37 "src/expression/Random.birch"
  libbirch_function_("<assignment>", "src/expression/Random.birch", 37);
  #line 38 "src/expression/Random.birch"
  libbirch_line_(38);
  #line 38 "src/expression/Random.birch"
  if (x.query()) {
    #line 39 "src/expression/Random.birch"
    libbirch_line_(39);
    #line 39 "src/expression/Random.birch"
    shared_from_this_() = x.get();
  }
  #line 37 "src/expression/Random.birch"
  return *this;
}

#line 13 "src/expression/Random.birch"
template<class Value>
#line 43 "src/expression/Random.birch"
libbirch::Optional<libbirch::Lazy<libbirch::Shared<birch::type::Distribution<Value>>>> birch::type::Random<Value>::distribution(const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_) {
  #line 43 "src/expression/Random.birch"
  libbirch_function_("distribution", "src/expression/Random.birch", 43);
  #line 44 "src/expression/Random.birch"
  libbirch_line_(44);
  #line 44 "src/expression/Random.birch"
  return this_()->p;
}

#line 13 "src/expression/Random.birch"
template<class Value>
#line 47 "src/expression/Random.birch"
birch::type::Boolean birch::type::Random<Value>::isRandom(const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_) {
  #line 47 "src/expression/Random.birch"
  libbirch_function_("isRandom", "src/expression/Random.birch", 47);
  #line 48 "src/expression/Random.birch"
  libbirch_line_(48);
  #line 48 "src/expression/Random.birch"
  return true;
}

#line 13 "src/expression/Random.birch"
template<class Value>
#line 54 "src/expression/Random.birch"
birch::type::Boolean birch::type::Random<Value>::hasDistribution(const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_) {
  #line 54 "src/expression/Random.birch"
  libbirch_function_("hasDistribution", "src/expression/Random.birch", 54);
  #line 55 "src/expression/Random.birch"
  libbirch_line_(55);
  #line 55 "src/expression/Random.birch"
  return this_()->p.query();
}

#line 13 "src/expression/Random.birch"
template<class Value>
#line 61 "src/expression/Random.birch"
libbirch::Lazy<libbirch::Shared<birch::type::Distribution<Value>>> birch::type::Random<Value>::getDistribution(const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_) {
  #line 61 "src/expression/Random.birch"
  libbirch_function_("getDistribution", "src/expression/Random.birch", 61);
  #line 62 "src/expression/Random.birch"
  libbirch_line_(62);
  #line 62 "src/expression/Random.birch"
  return this_()->p.get();
}

#line 13 "src/expression/Random.birch"
template<class Value>
#line 68 "src/expression/Random.birch"
birch::type::Boolean birch::type::Random<Value>::hasGradient(const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_) {
  #line 68 "src/expression/Random.birch"
  libbirch_function_("hasGradient", "src/expression/Random.birch", 68);
  #line 69 "src/expression/Random.birch"
  libbirch_line_(69);
  #line 69 "src/expression/Random.birch"
  return this_()->d.query();
}

#line 13 "src/expression/Random.birch"
template<class Value>
#line 76 "src/expression/Random.birch"
Value birch::type::Random<Value>::getGradient(const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_) {
  #line 76 "src/expression/Random.birch"
  libbirch_function_("getGradient", "src/expression/Random.birch", 76);
  #line 77 "src/expression/Random.birch"
  libbirch_line_(77);
  #line 77 "src/expression/Random.birch"
  return this_()->d.get();
}

#line 13 "src/expression/Random.birch"
template<class Value>
#line 87 "src/expression/Random.birch"
void birch::type::Random<Value>::assume(const libbirch::Lazy<libbirch::Shared<birch::type::Distribution<Value>>>& p, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_) {
  #line 87 "src/expression/Random.birch"
  libbirch_function_("assume", "src/expression/Random.birch", 87);
  #line 88 "src/expression/Random.birch"
  libbirch_line_(88);
  #line 88 "src/expression/Random.birch"
  libbirch_assert_(!this_()->p.query());
  #line 89 "src/expression/Random.birch"
  libbirch_line_(89);
  #line 89 "src/expression/Random.birch"
  libbirch_assert_(!this_()->x.query());
  #line 90 "src/expression/Random.birch"
  libbirch_line_(90);
  #line 90 "src/expression/Random.birch"
  p->setRandom(shared_from_this_(), handler_);
  #line 91 "src/expression/Random.birch"
  libbirch_line_(91);
  #line 91 "src/expression/Random.birch"
  this_()->p = p;
}

#line 13 "src/expression/Random.birch"
template<class Value>
#line 99 "src/expression/Random.birch"
void birch::type::Random<Value>::setPilot(const birch::type::Integer& gen, const Value& x, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_) {
  #line 99 "src/expression/Random.birch"
  libbirch_function_("setPilot", "src/expression/Random.birch", 99);
  #line 100 "src/expression/Random.birch"
  libbirch_line_(100);
  #line 100 "src/expression/Random.birch"
  libbirch_assert_(!this_()->p.query());
  #line 101 "src/expression/Random.birch"
  libbirch_line_(101);
  #line 101 "src/expression/Random.birch"
  libbirch_assert_(!this_()->x.query());
  #line 102 "src/expression/Random.birch"
  libbirch_line_(102);
  #line 102 "src/expression/Random.birch"
  libbirch_assert_(this_()->pilotCount == birch::type::Integer(0));
  #line 104 "src/expression/Random.birch"
  libbirch_line_(104);
  #line 104 "src/expression/Random.birch"
  this_()->x = x;
  #line 105 "src/expression/Random.birch"
  libbirch_line_(105);
  #line 105 "src/expression/Random.birch"
  this_()->generation = gen;
}

#line 13 "src/expression/Random.birch"
template<class Value>
#line 108 "src/expression/Random.birch"
birch::type::Integer birch::type::Random<Value>::doDepth(const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_) {
  #line 108 "src/expression/Random.birch"
  libbirch_function_("doDepth", "src/expression/Random.birch", 108);
  #line 109 "src/expression/Random.birch"
  libbirch_line_(109);
  #line 109 "src/expression/Random.birch"
  return birch::type::Integer(1);
}

#line 13 "src/expression/Random.birch"
template<class Value>
#line 112 "src/expression/Random.birch"
birch::type::Integer birch::type::Random<Value>::doRows(const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_) {
  #line 112 "src/expression/Random.birch"
  libbirch_function_("doRows", "src/expression/Random.birch", 112);
  #line 113 "src/expression/Random.birch"
  libbirch_line_(113);
  #line 113 "src/expression/Random.birch"
  return this_()->p.get()->rows(handler_);
}

#line 13 "src/expression/Random.birch"
template<class Value>
#line 116 "src/expression/Random.birch"
birch::type::Integer birch::type::Random<Value>::doColumns(const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_) {
  #line 116 "src/expression/Random.birch"
  libbirch_function_("doColumns", "src/expression/Random.birch", 116);
  #line 117 "src/expression/Random.birch"
  libbirch_line_(117);
  #line 117 "src/expression/Random.birch"
  return this_()->p.get()->columns(handler_);
}

#line 13 "src/expression/Random.birch"
template<class Value>
#line 120 "src/expression/Random.birch"
Value birch::type::Random<Value>::doValue(const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_) {
  #line 120 "src/expression/Random.birch"
  libbirch_function_("doValue", "src/expression/Random.birch", 120);
  #line 121 "src/expression/Random.birch"
  libbirch_line_(121);
  #line 121 "src/expression/Random.birch"
  libbirch_assert_(this_()->p.query());
  #line 122 "src/expression/Random.birch"
  libbirch_line_(122);
  #line 122 "src/expression/Random.birch"
  this_()->p.get()->prune(handler_);
  #line 123 "src/expression/Random.birch"
  libbirch_line_(123);
  #line 123 "src/expression/Random.birch"
  auto x = this_()->p.get()->simulate(handler_);
  #line 124 "src/expression/Random.birch"
  libbirch_line_(124);
  #line 124 "src/expression/Random.birch"
  this_()->p.get()->update(x, handler_);
  #line 125 "src/expression/Random.birch"
  libbirch_line_(125);
  #line 125 "src/expression/Random.birch"
  this_()->p.get()->unlink(handler_);
  #line 126 "src/expression/Random.birch"
  libbirch_line_(126);
  #line 126 "src/expression/Random.birch"
  this_()->p.get()->unsetRandom(shared_from_this_(), handler_);
  #line 127 "src/expression/Random.birch"
  libbirch_line_(127);
  #line 127 "src/expression/Random.birch"
  return x;
}

#line 13 "src/expression/Random.birch"
template<class Value>
#line 130 "src/expression/Random.birch"
Value birch::type::Random<Value>::doPilot(const birch::type::Integer& gen, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_) {
  #line 130 "src/expression/Random.birch"
  libbirch_function_("doPilot", "src/expression/Random.birch", 130);
  #line 131 "src/expression/Random.birch"
  libbirch_line_(131);
  #line 131 "src/expression/Random.birch"
  return this_()->doGet(handler_);
}

#line 13 "src/expression/Random.birch"
template<class Value>
#line 134 "src/expression/Random.birch"
Value birch::type::Random<Value>::doGet(const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_) {
  #line 134 "src/expression/Random.birch"
  libbirch_function_("doGet", "src/expression/Random.birch", 134);
  #line 135 "src/expression/Random.birch"
  libbirch_line_(135);
  #line 135 "src/expression/Random.birch"
  if (this_()->x.query()) {
    #line 137 "src/expression/Random.birch"
    libbirch_line_(137);
    #line 137 "src/expression/Random.birch"
    return this_()->x.get();
  } else {
    #line 140 "src/expression/Random.birch"
    libbirch_line_(140);
    #line 140 "src/expression/Random.birch"
    libbirch_assert_(this_()->p.query());
    #line 141 "src/expression/Random.birch"
    libbirch_line_(141);
    #line 141 "src/expression/Random.birch"
    if (this_()->p.get()->supportsLazy(handler_)) {
      #line 142 "src/expression/Random.birch"
      libbirch_line_(142);
      #line 142 "src/expression/Random.birch"
      this_()->p.get()->prune(handler_);
      #line 143 "src/expression/Random.birch"
      libbirch_line_(143);
      #line 143 "src/expression/Random.birch"
      auto x = this_()->p.get()->simulateLazy(handler_);
      #line 144 "src/expression/Random.birch"
      libbirch_line_(144);
      #line 144 "src/expression/Random.birch"
      libbirch_assert_(x.query());
      #line 145 "src/expression/Random.birch"
      libbirch_line_(145);
      #line 145 "src/expression/Random.birch"
      this_()->p.get()->updateLazy(shared_from_this_(), handler_);
      #line 146 "src/expression/Random.birch"
      libbirch_line_(146);
      #line 146 "src/expression/Random.birch"
      this_()->p.get()->unlink(handler_);
      #line 147 "src/expression/Random.birch"
      libbirch_line_(147);
      #line 147 "src/expression/Random.birch"
      this_()->p.get()->unsetRandom(shared_from_this_(), handler_);
      #line 148 "src/expression/Random.birch"
      libbirch_line_(148);
      #line 148 "src/expression/Random.birch"
      return x.get();
    } else {
      #line 150 "src/expression/Random.birch"
      libbirch_line_(150);
      #line 150 "src/expression/Random.birch"
      return this_()->doValue(handler_);
    }
  }
}

#line 13 "src/expression/Random.birch"
template<class Value>
#line 155 "src/expression/Random.birch"
Value birch::type::Random<Value>::doMove(const birch::type::Integer& gen, const libbirch::Lazy<libbirch::Shared<birch::type::Kernel>>& _u0954, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_) {
  #line 155 "src/expression/Random.birch"
  libbirch_function_("doMove", "src/expression/Random.birch", 155);
  #line 156 "src/expression/Random.birch"
  libbirch_line_(156);
  #line 156 "src/expression/Random.birch"
  return _u0954->move(shared_from_this_(), handler_);
}

#line 13 "src/expression/Random.birch"
template<class Value>
#line 159 "src/expression/Random.birch"
libbirch::Optional<libbirch::Lazy<libbirch::Shared<birch::type::Expression<birch::type::Real>>>> birch::type::Random<Value>::doPrior(const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_) {
  #line 159 "src/expression/Random.birch"
  libbirch_function_("doPrior", "src/expression/Random.birch", 159);
  #line 160 "src/expression/Random.birch"
  libbirch_line_(160);
  #line 160 "src/expression/Random.birch"
  if (this_()->p.query()) {
    #line 161 "src/expression/Random.birch"
    libbirch_line_(161);
    #line 161 "src/expression/Random.birch"
    auto p1 = this_()->p.get()->logpdfLazy(shared_from_this_(), handler_);
    #line 162 "src/expression/Random.birch"
    libbirch_line_(162);
    #line 162 "src/expression/Random.birch"
    this_()->p = libbirch::nil;
    #line 163 "src/expression/Random.birch"
    libbirch_line_(163);
    #line 163 "src/expression/Random.birch"
    if (p1.query()) {
      #line 164 "src/expression/Random.birch"
      libbirch_line_(164);
      #line 164 "src/expression/Random.birch"
      auto p2 = p1.get()->prior(handler_);
      #line 165 "src/expression/Random.birch"
      libbirch_line_(165);
      #line 165 "src/expression/Random.birch"
      if (p2.query()) {
        #line 166 "src/expression/Random.birch"
        libbirch_line_(166);
        #line 166 "src/expression/Random.birch"
        return p1.get() + p2.get();
      } else {
        #line 168 "src/expression/Random.birch"
        libbirch_line_(168);
        #line 168 "src/expression/Random.birch"
        return p1.get();
      }
    }
  }
  #line 172 "src/expression/Random.birch"
  libbirch_line_(172);
  #line 172 "src/expression/Random.birch"
  return libbirch::nil;
}

#line 13 "src/expression/Random.birch"
template<class Value>
#line 175 "src/expression/Random.birch"
birch::type::Real birch::type::Random<Value>::doCompare(const birch::type::Integer& gen, const libbirch::Lazy<libbirch::Shared<birch::type::DelayExpression>>& x, const libbirch::Lazy<libbirch::Shared<birch::type::Kernel>>& _u0954, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_) {
  #line 175 "src/expression/Random.birch"
  libbirch_function_("doCompare", "src/expression/Random.birch", 175);
  #line 177 "src/expression/Random.birch"
  libbirch_line_(177);
  #line 177 "src/expression/Random.birch"
  auto y = libbirch::cast<libbirch::Lazy<libbirch::Shared<birch::type::Random<Value>>>>(x).get();
  #line 178 "src/expression/Random.birch"
  libbirch_line_(178);
  #line 178 "src/expression/Random.birch"
  return _u0954->logpdf(y, shared_from_this_(), handler_) - _u0954->logpdf(shared_from_this_(), y, handler_);
}

#line 13 "src/expression/Random.birch"
template<class Value>
#line 181 "src/expression/Random.birch"
void birch::type::Random<Value>::doAccumulateGrad(const Value& d, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_) {
  #line 181 "src/expression/Random.birch"
  libbirch_function_("doAccumulateGrad", "src/expression/Random.birch", 181);
  #line 185 "src/expression/Random.birch"
  libbirch_line_(185);
  #line 185 "src/expression/Random.birch"
  if (this_()->d.query()) {
    #line 186 "src/expression/Random.birch"
    libbirch_line_(186);
    #line 186 "src/expression/Random.birch"
    this_()->d = this_()->d.get() + d;
  } else {
    #line 188 "src/expression/Random.birch"
    libbirch_line_(188);
    #line 188 "src/expression/Random.birch"
    this_()->d = d;
  }
}

#line 13 "src/expression/Random.birch"
template<class Value>
#line 192 "src/expression/Random.birch"
void birch::type::Random<Value>::doGrad(const birch::type::Integer& gen, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_) {
  #line 192 "src/expression/Random.birch"
  libbirch_function_("doGrad", "src/expression/Random.birch", 192);
}

#line 13 "src/expression/Random.birch"
template<class Value>
#line 196 "src/expression/Random.birch"
void birch::type::Random<Value>::doClearGrad(const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_) {
  #line 196 "src/expression/Random.birch"
  libbirch_function_("doClearGrad", "src/expression/Random.birch", 196);
  #line 197 "src/expression/Random.birch"
  libbirch_line_(197);
  #line 197 "src/expression/Random.birch"
  this_()->d = libbirch::nil;
}

#line 13 "src/expression/Random.birch"
template<class Value>
#line 200 "src/expression/Random.birch"
void birch::type::Random<Value>::doCount(const birch::type::Integer& gen, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_) {
  #line 200 "src/expression/Random.birch"
  libbirch_function_("doCount", "src/expression/Random.birch", 200);
}

#line 13 "src/expression/Random.birch"
template<class Value>
#line 204 "src/expression/Random.birch"
void birch::type::Random<Value>::doConstant(const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_) {
  #line 204 "src/expression/Random.birch"
  libbirch_function_("doConstant", "src/expression/Random.birch", 204);
}

#line 13 "src/expression/Random.birch"
template<class Value>
#line 208 "src/expression/Random.birch"
void birch::type::Random<Value>::doDetach(const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_) {
  #line 208 "src/expression/Random.birch"
  libbirch_function_("doDetach", "src/expression/Random.birch", 208);
  #line 209 "src/expression/Random.birch"
  libbirch_line_(209);
  #line 209 "src/expression/Random.birch"
  this_()->p = libbirch::nil;
}

#line 13 "src/expression/Random.birch"
template<class Value>
#line 212 "src/expression/Random.birch"
libbirch::Optional<libbirch::Lazy<libbirch::Shared<birch::type::Gaussian>>> birch::type::Random<Value>::graftGaussian(const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_) {
  #line 212 "src/expression/Random.birch"
  libbirch_function_("graftGaussian", "src/expression/Random.birch", 212);
  #line 213 "src/expression/Random.birch"
  libbirch_line_(213);
  #line 213 "src/expression/Random.birch"
  if (!this_()->hasValue(handler_)) {
    #line 214 "src/expression/Random.birch"
    libbirch_line_(214);
    #line 214 "src/expression/Random.birch"
    auto q = this_()->p.get()->graftGaussian(handler_);
    #line 215 "src/expression/Random.birch"
    libbirch_line_(215);
    #line 215 "src/expression/Random.birch"
    libbirch::optional_assign(this_()->p, libbirch::cast<libbirch::Lazy<libbirch::Shared<birch::type::Distribution<Value>>>>(q));
    #line 216 "src/expression/Random.birch"
    libbirch_line_(216);
    #line 216 "src/expression/Random.birch"
    return q;
  }
  #line 218 "src/expression/Random.birch"
  libbirch_line_(218);
  #line 218 "src/expression/Random.birch"
  return libbirch::nil;
}

#line 13 "src/expression/Random.birch"
template<class Value>
#line 221 "src/expression/Random.birch"
libbirch::Optional<libbirch::Lazy<libbirch::Shared<birch::type::Beta>>> birch::type::Random<Value>::graftBeta(const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_) {
  #line 221 "src/expression/Random.birch"
  libbirch_function_("graftBeta", "src/expression/Random.birch", 221);
  #line 222 "src/expression/Random.birch"
  libbirch_line_(222);
  #line 222 "src/expression/Random.birch"
  if (!this_()->hasValue(handler_)) {
    #line 223 "src/expression/Random.birch"
    libbirch_line_(223);
    #line 223 "src/expression/Random.birch"
    auto q = this_()->p.get()->graftBeta(handler_);
    #line 224 "src/expression/Random.birch"
    libbirch_line_(224);
    #line 224 "src/expression/Random.birch"
    libbirch::optional_assign(this_()->p, libbirch::cast<libbirch::Lazy<libbirch::Shared<birch::type::Distribution<Value>>>>(q));
    #line 225 "src/expression/Random.birch"
    libbirch_line_(225);
    #line 225 "src/expression/Random.birch"
    return q;
  }
  #line 227 "src/expression/Random.birch"
  libbirch_line_(227);
  #line 227 "src/expression/Random.birch"
  return libbirch::nil;
}

#line 13 "src/expression/Random.birch"
template<class Value>
#line 230 "src/expression/Random.birch"
libbirch::Optional<libbirch::Lazy<libbirch::Shared<birch::type::Gamma>>> birch::type::Random<Value>::graftGamma(const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_) {
  #line 230 "src/expression/Random.birch"
  libbirch_function_("graftGamma", "src/expression/Random.birch", 230);
  #line 231 "src/expression/Random.birch"
  libbirch_line_(231);
  #line 231 "src/expression/Random.birch"
  if (!this_()->hasValue(handler_)) {
    #line 232 "src/expression/Random.birch"
    libbirch_line_(232);
    #line 232 "src/expression/Random.birch"
    auto q = this_()->p.get()->graftGamma(handler_);
    #line 233 "src/expression/Random.birch"
    libbirch_line_(233);
    #line 233 "src/expression/Random.birch"
    libbirch::optional_assign(this_()->p, libbirch::cast<libbirch::Lazy<libbirch::Shared<birch::type::Distribution<Value>>>>(q));
    #line 234 "src/expression/Random.birch"
    libbirch_line_(234);
    #line 234 "src/expression/Random.birch"
    return q;
  }
  #line 236 "src/expression/Random.birch"
  libbirch_line_(236);
  #line 236 "src/expression/Random.birch"
  return libbirch::nil;
}

#line 13 "src/expression/Random.birch"
template<class Value>
#line 239 "src/expression/Random.birch"
libbirch::Optional<libbirch::Lazy<libbirch::Shared<birch::type::InverseGamma>>> birch::type::Random<Value>::graftInverseGamma(const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_) {
  #line 239 "src/expression/Random.birch"
  libbirch_function_("graftInverseGamma", "src/expression/Random.birch", 239);
  #line 240 "src/expression/Random.birch"
  libbirch_line_(240);
  #line 240 "src/expression/Random.birch"
  if (!this_()->hasValue(handler_)) {
    #line 241 "src/expression/Random.birch"
    libbirch_line_(241);
    #line 241 "src/expression/Random.birch"
    auto q = this_()->p.get()->graftInverseGamma(handler_);
    #line 242 "src/expression/Random.birch"
    libbirch_line_(242);
    #line 242 "src/expression/Random.birch"
    libbirch::optional_assign(this_()->p, libbirch::cast<libbirch::Lazy<libbirch::Shared<birch::type::Distribution<Value>>>>(q));
    #line 243 "src/expression/Random.birch"
    libbirch_line_(243);
    #line 243 "src/expression/Random.birch"
    return q;
  }
  #line 245 "src/expression/Random.birch"
  libbirch_line_(245);
  #line 245 "src/expression/Random.birch"
  return libbirch::nil;
}

#line 13 "src/expression/Random.birch"
template<class Value>
#line 248 "src/expression/Random.birch"
libbirch::Optional<libbirch::Lazy<libbirch::Shared<birch::type::InverseWishart>>> birch::type::Random<Value>::graftInverseWishart(const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_) {
  #line 248 "src/expression/Random.birch"
  libbirch_function_("graftInverseWishart", "src/expression/Random.birch", 248);
  #line 249 "src/expression/Random.birch"
  libbirch_line_(249);
  #line 249 "src/expression/Random.birch"
  if (!this_()->hasValue(handler_)) {
    #line 250 "src/expression/Random.birch"
    libbirch_line_(250);
    #line 250 "src/expression/Random.birch"
    auto q = this_()->p.get()->graftInverseWishart(handler_);
    #line 251 "src/expression/Random.birch"
    libbirch_line_(251);
    #line 251 "src/expression/Random.birch"
    libbirch::optional_assign(this_()->p, libbirch::cast<libbirch::Lazy<libbirch::Shared<birch::type::Distribution<Value>>>>(q));
    #line 252 "src/expression/Random.birch"
    libbirch_line_(252);
    #line 252 "src/expression/Random.birch"
    return q;
  }
  #line 254 "src/expression/Random.birch"
  libbirch_line_(254);
  #line 254 "src/expression/Random.birch"
  return libbirch::nil;
}

#line 13 "src/expression/Random.birch"
template<class Value>
#line 257 "src/expression/Random.birch"
libbirch::Optional<libbirch::Lazy<libbirch::Shared<birch::type::NormalInverseGamma>>> birch::type::Random<Value>::graftNormalInverseGamma(const libbirch::Lazy<libbirch::Shared<birch::type::Distribution<birch::type::Real>>>& compare, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_) {
  #line 257 "src/expression/Random.birch"
  libbirch_function_("graftNormalInverseGamma", "src/expression/Random.birch", 257);
  #line 258 "src/expression/Random.birch"
  libbirch_line_(258);
  #line 258 "src/expression/Random.birch"
  if (!this_()->hasValue(handler_)) {
    #line 259 "src/expression/Random.birch"
    libbirch_line_(259);
    #line 259 "src/expression/Random.birch"
    auto q = this_()->p.get()->graftNormalInverseGamma(compare, handler_);
    #line 260 "src/expression/Random.birch"
    libbirch_line_(260);
    #line 260 "src/expression/Random.birch"
    libbirch::optional_assign(this_()->p, libbirch::cast<libbirch::Lazy<libbirch::Shared<birch::type::Distribution<Value>>>>(q));
    #line 261 "src/expression/Random.birch"
    libbirch_line_(261);
    #line 261 "src/expression/Random.birch"
    return q;
  }
  #line 263 "src/expression/Random.birch"
  libbirch_line_(263);
  #line 263 "src/expression/Random.birch"
  return libbirch::nil;
}

#line 13 "src/expression/Random.birch"
template<class Value>
#line 266 "src/expression/Random.birch"
libbirch::Optional<libbirch::Lazy<libbirch::Shared<birch::type::Dirichlet>>> birch::type::Random<Value>::graftDirichlet(const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_) {
  #line 266 "src/expression/Random.birch"
  libbirch_function_("graftDirichlet", "src/expression/Random.birch", 266);
  #line 267 "src/expression/Random.birch"
  libbirch_line_(267);
  #line 267 "src/expression/Random.birch"
  if (!this_()->hasValue(handler_)) {
    #line 268 "src/expression/Random.birch"
    libbirch_line_(268);
    #line 268 "src/expression/Random.birch"
    auto q = this_()->p.get()->graftDirichlet(handler_);
    #line 269 "src/expression/Random.birch"
    libbirch_line_(269);
    #line 269 "src/expression/Random.birch"
    libbirch::optional_assign(this_()->p, libbirch::cast<libbirch::Lazy<libbirch::Shared<birch::type::Distribution<Value>>>>(q));
    #line 270 "src/expression/Random.birch"
    libbirch_line_(270);
    #line 270 "src/expression/Random.birch"
    return q;
  }
  #line 272 "src/expression/Random.birch"
  libbirch_line_(272);
  #line 272 "src/expression/Random.birch"
  return libbirch::nil;
}

#line 13 "src/expression/Random.birch"
template<class Value>
#line 275 "src/expression/Random.birch"
libbirch::Optional<libbirch::Lazy<libbirch::Shared<birch::type::Restaurant>>> birch::type::Random<Value>::graftRestaurant(const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_) {
  #line 275 "src/expression/Random.birch"
  libbirch_function_("graftRestaurant", "src/expression/Random.birch", 275);
  #line 276 "src/expression/Random.birch"
  libbirch_line_(276);
  #line 276 "src/expression/Random.birch"
  if (!this_()->hasValue(handler_)) {
    #line 277 "src/expression/Random.birch"
    libbirch_line_(277);
    #line 277 "src/expression/Random.birch"
    auto q = this_()->p.get()->graftRestaurant(handler_);
    #line 278 "src/expression/Random.birch"
    libbirch_line_(278);
    #line 278 "src/expression/Random.birch"
    libbirch::optional_assign(this_()->p, libbirch::cast<libbirch::Lazy<libbirch::Shared<birch::type::Distribution<Value>>>>(q));
    #line 279 "src/expression/Random.birch"
    libbirch_line_(279);
    #line 279 "src/expression/Random.birch"
    return q;
  }
  #line 281 "src/expression/Random.birch"
  libbirch_line_(281);
  #line 281 "src/expression/Random.birch"
  return libbirch::nil;
}

#line 13 "src/expression/Random.birch"
template<class Value>
#line 284 "src/expression/Random.birch"
libbirch::Optional<libbirch::Lazy<libbirch::Shared<birch::type::MultivariateGaussian>>> birch::type::Random<Value>::graftMultivariateGaussian(const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_) {
  #line 284 "src/expression/Random.birch"
  libbirch_function_("graftMultivariateGaussian", "src/expression/Random.birch", 284);
  #line 285 "src/expression/Random.birch"
  libbirch_line_(285);
  #line 285 "src/expression/Random.birch"
  if (!this_()->hasValue(handler_)) {
    #line 286 "src/expression/Random.birch"
    libbirch_line_(286);
    #line 286 "src/expression/Random.birch"
    auto q = this_()->p.get()->graftMultivariateGaussian(handler_);
    #line 287 "src/expression/Random.birch"
    libbirch_line_(287);
    #line 287 "src/expression/Random.birch"
    libbirch::optional_assign(this_()->p, libbirch::cast<libbirch::Lazy<libbirch::Shared<birch::type::Distribution<Value>>>>(q));
    #line 288 "src/expression/Random.birch"
    libbirch_line_(288);
    #line 288 "src/expression/Random.birch"
    return q;
  }
  #line 290 "src/expression/Random.birch"
  libbirch_line_(290);
  #line 290 "src/expression/Random.birch"
  return libbirch::nil;
}

#line 13 "src/expression/Random.birch"
template<class Value>
#line 293 "src/expression/Random.birch"
libbirch::Optional<libbirch::Lazy<libbirch::Shared<birch::type::MultivariateNormalInverseGamma>>> birch::type::Random<Value>::graftMultivariateNormalInverseGamma(const libbirch::Lazy<libbirch::Shared<birch::type::Distribution<birch::type::Real>>>& compare, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_) {
  #line 293 "src/expression/Random.birch"
  libbirch_function_("graftMultivariateNormalInverseGamma", "src/expression/Random.birch", 293);
  #line 295 "src/expression/Random.birch"
  libbirch_line_(295);
  #line 295 "src/expression/Random.birch"
  if (!this_()->hasValue(handler_)) {
    #line 296 "src/expression/Random.birch"
    libbirch_line_(296);
    #line 296 "src/expression/Random.birch"
    auto q = this_()->p.get()->graftMultivariateNormalInverseGamma(compare, handler_);
    #line 297 "src/expression/Random.birch"
    libbirch_line_(297);
    #line 297 "src/expression/Random.birch"
    libbirch::optional_assign(this_()->p, libbirch::cast<libbirch::Lazy<libbirch::Shared<birch::type::Distribution<Value>>>>(q));
    #line 298 "src/expression/Random.birch"
    libbirch_line_(298);
    #line 298 "src/expression/Random.birch"
    return q;
  }
  #line 300 "src/expression/Random.birch"
  libbirch_line_(300);
  #line 300 "src/expression/Random.birch"
  return libbirch::nil;
}

#line 13 "src/expression/Random.birch"
template<class Value>
#line 303 "src/expression/Random.birch"
libbirch::Optional<libbirch::Lazy<libbirch::Shared<birch::type::MatrixGaussian>>> birch::type::Random<Value>::graftMatrixGaussian(const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_) {
  #line 303 "src/expression/Random.birch"
  libbirch_function_("graftMatrixGaussian", "src/expression/Random.birch", 303);
  #line 304 "src/expression/Random.birch"
  libbirch_line_(304);
  #line 304 "src/expression/Random.birch"
  if (!this_()->hasValue(handler_)) {
    #line 305 "src/expression/Random.birch"
    libbirch_line_(305);
    #line 305 "src/expression/Random.birch"
    auto q = this_()->p.get()->graftMatrixGaussian(handler_);
    #line 306 "src/expression/Random.birch"
    libbirch_line_(306);
    #line 306 "src/expression/Random.birch"
    libbirch::optional_assign(this_()->p, libbirch::cast<libbirch::Lazy<libbirch::Shared<birch::type::Distribution<Value>>>>(q));
    #line 307 "src/expression/Random.birch"
    libbirch_line_(307);
    #line 307 "src/expression/Random.birch"
    return q;
  }
  #line 309 "src/expression/Random.birch"
  libbirch_line_(309);
  #line 309 "src/expression/Random.birch"
  return libbirch::nil;
}

#line 13 "src/expression/Random.birch"
template<class Value>
#line 312 "src/expression/Random.birch"
libbirch::Optional<libbirch::Lazy<libbirch::Shared<birch::type::MatrixNormalInverseWishart>>> birch::type::Random<Value>::graftMatrixNormalInverseWishart(const libbirch::Lazy<libbirch::Shared<birch::type::Distribution<birch::type::LLT>>>& compare, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_) {
  #line 312 "src/expression/Random.birch"
  libbirch_function_("graftMatrixNormalInverseWishart", "src/expression/Random.birch", 312);
  #line 314 "src/expression/Random.birch"
  libbirch_line_(314);
  #line 314 "src/expression/Random.birch"
  if (!this_()->hasValue(handler_)) {
    #line 315 "src/expression/Random.birch"
    libbirch_line_(315);
    #line 315 "src/expression/Random.birch"
    auto q = this_()->p.get()->graftMatrixNormalInverseWishart(compare, handler_);
    #line 316 "src/expression/Random.birch"
    libbirch_line_(316);
    #line 316 "src/expression/Random.birch"
    libbirch::optional_assign(this_()->p, libbirch::cast<libbirch::Lazy<libbirch::Shared<birch::type::Distribution<Value>>>>(q));
    #line 317 "src/expression/Random.birch"
    libbirch_line_(317);
    #line 317 "src/expression/Random.birch"
    return q;
  }
  #line 319 "src/expression/Random.birch"
  libbirch_line_(319);
  #line 319 "src/expression/Random.birch"
  return libbirch::nil;
}

#line 13 "src/expression/Random.birch"
template<class Value>
#line 322 "src/expression/Random.birch"
libbirch::Optional<libbirch::Lazy<libbirch::Shared<birch::type::Discrete>>> birch::type::Random<Value>::graftDiscrete(const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_) {
  #line 322 "src/expression/Random.birch"
  libbirch_function_("graftDiscrete", "src/expression/Random.birch", 322);
  #line 323 "src/expression/Random.birch"
  libbirch_line_(323);
  #line 323 "src/expression/Random.birch"
  if (!this_()->hasValue(handler_)) {
    #line 324 "src/expression/Random.birch"
    libbirch_line_(324);
    #line 324 "src/expression/Random.birch"
    auto q = this_()->p.get()->graftDiscrete(handler_);
    #line 325 "src/expression/Random.birch"
    libbirch_line_(325);
    #line 325 "src/expression/Random.birch"
    libbirch::optional_assign(this_()->p, libbirch::cast<libbirch::Lazy<libbirch::Shared<birch::type::Distribution<Value>>>>(q));
    #line 326 "src/expression/Random.birch"
    libbirch_line_(326);
    #line 326 "src/expression/Random.birch"
    return q;
  }
  #line 328 "src/expression/Random.birch"
  libbirch_line_(328);
  #line 328 "src/expression/Random.birch"
  return libbirch::nil;
}

#line 13 "src/expression/Random.birch"
template<class Value>
#line 331 "src/expression/Random.birch"
libbirch::Optional<libbirch::Lazy<libbirch::Shared<birch::type::BoundedDiscrete>>> birch::type::Random<Value>::graftBoundedDiscrete(const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_) {
  #line 331 "src/expression/Random.birch"
  libbirch_function_("graftBoundedDiscrete", "src/expression/Random.birch", 331);
  #line 332 "src/expression/Random.birch"
  libbirch_line_(332);
  #line 332 "src/expression/Random.birch"
  if (!this_()->hasValue(handler_)) {
    #line 333 "src/expression/Random.birch"
    libbirch_line_(333);
    #line 333 "src/expression/Random.birch"
    auto q = this_()->p.get()->graftBoundedDiscrete(handler_);
    #line 334 "src/expression/Random.birch"
    libbirch_line_(334);
    #line 334 "src/expression/Random.birch"
    libbirch::optional_assign(this_()->p, libbirch::cast<libbirch::Lazy<libbirch::Shared<birch::type::Distribution<Value>>>>(q));
    #line 335 "src/expression/Random.birch"
    libbirch_line_(335);
    #line 335 "src/expression/Random.birch"
    return q;
  }
  #line 337 "src/expression/Random.birch"
  libbirch_line_(337);
  #line 337 "src/expression/Random.birch"
  return libbirch::nil;
}

#line 13 "src/expression/Random.birch"
template<class Value>
#line 340 "src/expression/Random.birch"
void birch::type::Random<Value>::read(const libbirch::Lazy<libbirch::Shared<birch::type::Buffer>>& buffer, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_) {
  #line 340 "src/expression/Random.birch"
  libbirch_function_("read", "src/expression/Random.birch", 340);
  #line 341 "src/expression/Random.birch"
  libbirch_line_(341);
  #line 341 "src/expression/Random.birch"
  shared_from_this_() = buffer->get(this_()->x, handler_);
}

#line 13 "src/expression/Random.birch"
template<class Value>
#line 344 "src/expression/Random.birch"
void birch::type::Random<Value>::write(const libbirch::Lazy<libbirch::Shared<birch::type::Buffer>>& buffer, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_) {
  #line 344 "src/expression/Random.birch"
  libbirch_function_("write", "src/expression/Random.birch", 344);
  #line 345 "src/expression/Random.birch"
  libbirch_line_(345);
  #line 345 "src/expression/Random.birch"
  if (this_()->hasValue(handler_) || this_()->hasDistribution(handler_)) {
    #line 346 "src/expression/Random.birch"
    libbirch_line_(346);
    #line 346 "src/expression/Random.birch"
    buffer->set(this_()->value(handler_), handler_);
  } else {
    #line 348 "src/expression/Random.birch"
    libbirch_line_(348);
    #line 348 "src/expression/Random.birch"
    buffer->setNil(handler_);
  }
}

#line 18 "src/expression/ScalarBinaryExpression.birch"
template<class Left,class Right,class LeftValue,class RightValue,class LeftGradient,class RightGradient,class Value>
#line 18 "src/expression/ScalarBinaryExpression.birch"
birch::type::ScalarBinaryExpression<Left, Right, LeftValue, RightValue, LeftGradient, RightGradient, Value>::ScalarBinaryExpression(const Left& y, const Right& z, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_) :
    #line 18 "src/expression/ScalarBinaryExpression.birch"
    super_type_(),
    #line 24 "src/expression/ScalarBinaryExpression.birch"
    y(y),
    #line 29 "src/expression/ScalarBinaryExpression.birch"
    z(z) {
  //
}

#line 18 "src/expression/ScalarBinaryExpression.birch"
template<class Left,class Right,class LeftValue,class RightValue,class LeftGradient,class RightGradient,class Value>
#line 49 "src/expression/ScalarBinaryExpression.birch"
birch::type::Integer birch::type::ScalarBinaryExpression<Left, Right, LeftValue, RightValue, LeftGradient, RightGradient, Value>::doDepth(const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_) {
  #line 49 "src/expression/ScalarBinaryExpression.birch"
  libbirch_function_("doDepth", "src/expression/ScalarBinaryExpression.birch", 49);
  #line 50 "src/expression/ScalarBinaryExpression.birch"
  libbirch_line_(50);
  #line 50 "src/expression/ScalarBinaryExpression.birch"
  return birch::max(this_()->y.get()->depth(handler_), this_()->z.get()->depth(handler_), handler_) + birch::type::Integer(1);
}

#line 18 "src/expression/ScalarBinaryExpression.birch"
template<class Left,class Right,class LeftValue,class RightValue,class LeftGradient,class RightGradient,class Value>
#line 53 "src/expression/ScalarBinaryExpression.birch"
Value birch::type::ScalarBinaryExpression<Left, Right, LeftValue, RightValue, LeftGradient, RightGradient, Value>::doValue(const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_) {
  #line 53 "src/expression/ScalarBinaryExpression.birch"
  libbirch_function_("doValue", "src/expression/ScalarBinaryExpression.birch", 53);
  #line 54 "src/expression/ScalarBinaryExpression.birch"
  libbirch_line_(54);
  #line 54 "src/expression/ScalarBinaryExpression.birch"
  return this_()->doEvaluate(this_()->y.get()->value(handler_), this_()->z.get()->value(handler_), handler_);
}

#line 18 "src/expression/ScalarBinaryExpression.birch"
template<class Left,class Right,class LeftValue,class RightValue,class LeftGradient,class RightGradient,class Value>
#line 57 "src/expression/ScalarBinaryExpression.birch"
Value birch::type::ScalarBinaryExpression<Left, Right, LeftValue, RightValue, LeftGradient, RightGradient, Value>::doPilot(const birch::type::Integer& gen, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_) {
  #line 57 "src/expression/ScalarBinaryExpression.birch"
  libbirch_function_("doPilot", "src/expression/ScalarBinaryExpression.birch", 57);
  #line 58 "src/expression/ScalarBinaryExpression.birch"
  libbirch_line_(58);
  #line 58 "src/expression/ScalarBinaryExpression.birch"
  return this_()->doEvaluate(this_()->y.get()->pilot(gen, handler_), this_()->z.get()->pilot(gen, handler_), handler_);
}

#line 18 "src/expression/ScalarBinaryExpression.birch"
template<class Left,class Right,class LeftValue,class RightValue,class LeftGradient,class RightGradient,class Value>
#line 61 "src/expression/ScalarBinaryExpression.birch"
Value birch::type::ScalarBinaryExpression<Left, Right, LeftValue, RightValue, LeftGradient, RightGradient, Value>::doGet(const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_) {
  #line 61 "src/expression/ScalarBinaryExpression.birch"
  libbirch_function_("doGet", "src/expression/ScalarBinaryExpression.birch", 61);
  #line 62 "src/expression/ScalarBinaryExpression.birch"
  libbirch_line_(62);
  #line 62 "src/expression/ScalarBinaryExpression.birch"
  return this_()->doEvaluate(this_()->y.get()->get(handler_), this_()->z.get()->get(handler_), handler_);
}

#line 18 "src/expression/ScalarBinaryExpression.birch"
template<class Left,class Right,class LeftValue,class RightValue,class LeftGradient,class RightGradient,class Value>
#line 65 "src/expression/ScalarBinaryExpression.birch"
Value birch::type::ScalarBinaryExpression<Left, Right, LeftValue, RightValue, LeftGradient, RightGradient, Value>::doMove(const birch::type::Integer& gen, const libbirch::Lazy<libbirch::Shared<birch::type::Kernel>>& _u0954, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_) {
  #line 65 "src/expression/ScalarBinaryExpression.birch"
  libbirch_function_("doMove", "src/expression/ScalarBinaryExpression.birch", 65);
  #line 66 "src/expression/ScalarBinaryExpression.birch"
  libbirch_line_(66);
  #line 66 "src/expression/ScalarBinaryExpression.birch"
  return this_()->doEvaluate(this_()->y.get()->move(gen, _u0954, handler_), this_()->z.get()->move(gen, _u0954, handler_), handler_);
}

#line 18 "src/expression/ScalarBinaryExpression.birch"
template<class Left,class Right,class LeftValue,class RightValue,class LeftGradient,class RightGradient,class Value>
#line 69 "src/expression/ScalarBinaryExpression.birch"
void birch::type::ScalarBinaryExpression<Left, Right, LeftValue, RightValue, LeftGradient, RightGradient, Value>::doGrad(const birch::type::Integer& gen, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_) {
  #line 69 "src/expression/ScalarBinaryExpression.birch"
  libbirch_function_("doGrad", "src/expression/ScalarBinaryExpression.birch", 69);
  #line 70 "src/expression/ScalarBinaryExpression.birch"
  libbirch_line_(70);
  #line 70 "src/expression/ScalarBinaryExpression.birch"
  this_()->y.get()->grad(gen, this_()->doEvaluateGradLeft(this_()->d.get(), this_()->x.get(), this_()->y.get()->get(handler_), this_()->z.get()->get(handler_), handler_), handler_);
  #line 71 "src/expression/ScalarBinaryExpression.birch"
  libbirch_line_(71);
  #line 71 "src/expression/ScalarBinaryExpression.birch"
  this_()->z.get()->grad(gen, this_()->doEvaluateGradRight(this_()->d.get(), this_()->x.get(), this_()->y.get()->get(handler_), this_()->z.get()->get(handler_), handler_), handler_);
}

#line 18 "src/expression/ScalarBinaryExpression.birch"
template<class Left,class Right,class LeftValue,class RightValue,class LeftGradient,class RightGradient,class Value>
#line 74 "src/expression/ScalarBinaryExpression.birch"
libbirch::Optional<libbirch::Lazy<libbirch::Shared<birch::type::Expression<birch::type::Real>>>> birch::type::ScalarBinaryExpression<Left, Right, LeftValue, RightValue, LeftGradient, RightGradient, Value>::doPrior(const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_) {
  #line 74 "src/expression/ScalarBinaryExpression.birch"
  libbirch_function_("doPrior", "src/expression/ScalarBinaryExpression.birch", 74);
  #line 75 "src/expression/ScalarBinaryExpression.birch"
  libbirch_line_(75);
  #line 75 "src/expression/ScalarBinaryExpression.birch"
  auto l = this_()->y.get()->prior(handler_);
  #line 76 "src/expression/ScalarBinaryExpression.birch"
  libbirch_line_(76);
  #line 76 "src/expression/ScalarBinaryExpression.birch"
  auto r = this_()->z.get()->prior(handler_);
  #line 77 "src/expression/ScalarBinaryExpression.birch"
  libbirch_line_(77);
  #line 77 "src/expression/ScalarBinaryExpression.birch"
  if (l.query() && r.query()) {
    #line 78 "src/expression/ScalarBinaryExpression.birch"
    libbirch_line_(78);
    #line 78 "src/expression/ScalarBinaryExpression.birch"
    return l.get() + r.get();
  } else {
    #line 79 "src/expression/ScalarBinaryExpression.birch"
    libbirch_line_(79);
    #line 79 "src/expression/ScalarBinaryExpression.birch"
    if (l.query()) {
      #line 80 "src/expression/ScalarBinaryExpression.birch"
      libbirch_line_(80);
      #line 80 "src/expression/ScalarBinaryExpression.birch"
      return l.get();
    } else {
      #line 81 "src/expression/ScalarBinaryExpression.birch"
      libbirch_line_(81);
      #line 81 "src/expression/ScalarBinaryExpression.birch"
      if (r.query()) {
        #line 82 "src/expression/ScalarBinaryExpression.birch"
        libbirch_line_(82);
        #line 82 "src/expression/ScalarBinaryExpression.birch"
        return r.get();
      } else {
        #line 84 "src/expression/ScalarBinaryExpression.birch"
        libbirch_line_(84);
        #line 84 "src/expression/ScalarBinaryExpression.birch"
        return libbirch::nil;
      }
    }
  }
}

#line 18 "src/expression/ScalarBinaryExpression.birch"
template<class Left,class Right,class LeftValue,class RightValue,class LeftGradient,class RightGradient,class Value>
#line 88 "src/expression/ScalarBinaryExpression.birch"
birch::type::Real birch::type::ScalarBinaryExpression<Left, Right, LeftValue, RightValue, LeftGradient, RightGradient, Value>::doCompare(const birch::type::Integer& gen, const libbirch::Lazy<libbirch::Shared<birch::type::DelayExpression>>& x, const libbirch::Lazy<libbirch::Shared<birch::type::Kernel>>& _u0954, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_) {
  #line 88 "src/expression/ScalarBinaryExpression.birch"
  libbirch_function_("doCompare", "src/expression/ScalarBinaryExpression.birch", 88);
  #line 90 "src/expression/ScalarBinaryExpression.birch"
  libbirch_line_(90);
  #line 90 "src/expression/ScalarBinaryExpression.birch"
  auto o = libbirch::cast<libbirch::Lazy<libbirch::Shared<birch::type::ScalarBinaryExpression<Left, Right, LeftValue, RightValue, LeftGradient, RightGradient, Value>>>>(x).get();
  #line 92 "src/expression/ScalarBinaryExpression.birch"
  libbirch_line_(92);
  #line 92 "src/expression/ScalarBinaryExpression.birch"
  return this_()->y.get()->compare(gen, o->y.get(), _u0954, handler_) + this_()->z.get()->compare(gen, o->z.get(), _u0954, handler_);
}

#line 18 "src/expression/ScalarBinaryExpression.birch"
template<class Left,class Right,class LeftValue,class RightValue,class LeftGradient,class RightGradient,class Value>
#line 95 "src/expression/ScalarBinaryExpression.birch"
void birch::type::ScalarBinaryExpression<Left, Right, LeftValue, RightValue, LeftGradient, RightGradient, Value>::doConstant(const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_) {
  #line 95 "src/expression/ScalarBinaryExpression.birch"
  libbirch_function_("doConstant", "src/expression/ScalarBinaryExpression.birch", 95);
  #line 96 "src/expression/ScalarBinaryExpression.birch"
  libbirch_line_(96);
  #line 96 "src/expression/ScalarBinaryExpression.birch"
  this_()->y.get()->constant(handler_);
  #line 97 "src/expression/ScalarBinaryExpression.birch"
  libbirch_line_(97);
  #line 97 "src/expression/ScalarBinaryExpression.birch"
  this_()->z.get()->constant(handler_);
}

#line 18 "src/expression/ScalarBinaryExpression.birch"
template<class Left,class Right,class LeftValue,class RightValue,class LeftGradient,class RightGradient,class Value>
#line 100 "src/expression/ScalarBinaryExpression.birch"
void birch::type::ScalarBinaryExpression<Left, Right, LeftValue, RightValue, LeftGradient, RightGradient, Value>::doCount(const birch::type::Integer& gen, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_) {
  #line 100 "src/expression/ScalarBinaryExpression.birch"
  libbirch_function_("doCount", "src/expression/ScalarBinaryExpression.birch", 100);
  #line 101 "src/expression/ScalarBinaryExpression.birch"
  libbirch_line_(101);
  #line 101 "src/expression/ScalarBinaryExpression.birch"
  this_()->y.get()->count(gen, handler_);
  #line 102 "src/expression/ScalarBinaryExpression.birch"
  libbirch_line_(102);
  #line 102 "src/expression/ScalarBinaryExpression.birch"
  this_()->z.get()->count(gen, handler_);
}

#line 18 "src/expression/ScalarBinaryExpression.birch"
template<class Left,class Right,class LeftValue,class RightValue,class LeftGradient,class RightGradient,class Value>
#line 105 "src/expression/ScalarBinaryExpression.birch"
void birch::type::ScalarBinaryExpression<Left, Right, LeftValue, RightValue, LeftGradient, RightGradient, Value>::doDetach(const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_) {
  #line 105 "src/expression/ScalarBinaryExpression.birch"
  libbirch_function_("doDetach", "src/expression/ScalarBinaryExpression.birch", 105);
  #line 106 "src/expression/ScalarBinaryExpression.birch"
  libbirch_line_(106);
  #line 106 "src/expression/ScalarBinaryExpression.birch"
  this_()->y = libbirch::nil;
  #line 107 "src/expression/ScalarBinaryExpression.birch"
  libbirch_line_(107);
  #line 107 "src/expression/ScalarBinaryExpression.birch"
  this_()->z = libbirch::nil;
}

#line 6 "src/expression/ScalarExpression.birch"
template<class Value>
#line 6 "src/expression/ScalarExpression.birch"
birch::type::ScalarExpression<Value>::ScalarExpression(const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_) :
    #line 6 "src/expression/ScalarExpression.birch"
    super_type_(libbirch::nil),
    #line 10 "src/expression/ScalarExpression.birch"
    d() {
  //
}

#line 6 "src/expression/ScalarExpression.birch"
template<class Value>
#line 12 "src/expression/ScalarExpression.birch"
birch::type::Integer birch::type::ScalarExpression<Value>::doRows(const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_) {
  #line 12 "src/expression/ScalarExpression.birch"
  libbirch_function_("doRows", "src/expression/ScalarExpression.birch", 12);
  #line 13 "src/expression/ScalarExpression.birch"
  libbirch_line_(13);
  #line 13 "src/expression/ScalarExpression.birch"
  return birch::type::Integer(1);
}

#line 6 "src/expression/ScalarExpression.birch"
template<class Value>
#line 16 "src/expression/ScalarExpression.birch"
birch::type::Integer birch::type::ScalarExpression<Value>::doColumns(const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_) {
  #line 16 "src/expression/ScalarExpression.birch"
  libbirch_function_("doColumns", "src/expression/ScalarExpression.birch", 16);
  #line 17 "src/expression/ScalarExpression.birch"
  libbirch_line_(17);
  #line 17 "src/expression/ScalarExpression.birch"
  return birch::type::Integer(1);
}

#line 6 "src/expression/ScalarExpression.birch"
template<class Value>
#line 20 "src/expression/ScalarExpression.birch"
void birch::type::ScalarExpression<Value>::doAccumulateGrad(const birch::type::Real& d, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_) {
  #line 20 "src/expression/ScalarExpression.birch"
  libbirch_function_("doAccumulateGrad", "src/expression/ScalarExpression.birch", 20);
  #line 21 "src/expression/ScalarExpression.birch"
  libbirch_line_(21);
  #line 21 "src/expression/ScalarExpression.birch"
  if (this_()->d.query()) {
    #line 22 "src/expression/ScalarExpression.birch"
    libbirch_line_(22);
    #line 22 "src/expression/ScalarExpression.birch"
    this_()->d = this_()->d.get() + d;
  } else {
    #line 24 "src/expression/ScalarExpression.birch"
    libbirch_line_(24);
    #line 24 "src/expression/ScalarExpression.birch"
    this_()->d = d;
  }
}

#line 6 "src/expression/ScalarExpression.birch"
template<class Value>
#line 28 "src/expression/ScalarExpression.birch"
void birch::type::ScalarExpression<Value>::doClearGrad(const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_) {
  #line 28 "src/expression/ScalarExpression.birch"
  libbirch_function_("doClearGrad", "src/expression/ScalarExpression.birch", 28);
  #line 29 "src/expression/ScalarExpression.birch"
  libbirch_line_(29);
  #line 29 "src/expression/ScalarExpression.birch"
  this_()->d = libbirch::nil;
}

#line 4 "src/expression/ScalarMatrix.birch"
template<class Value>
#line 4 "src/expression/ScalarMatrix.birch"
birch::type::ScalarMatrix<Value>::ScalarMatrix(const libbirch::Lazy<libbirch::Shared<birch::type::Expression<libbirch::DefaultArray<Value,2>>>>& y, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_) :
    #line 4 "src/expression/ScalarMatrix.birch"
    super_type_(y) {
  //
}

#line 4 "src/expression/ScalarMatrix.birch"
template<class Value>
#line 7 "src/expression/ScalarMatrix.birch"
Value birch::type::ScalarMatrix<Value>::doEvaluate(const libbirch::DefaultArray<Value,2>& y, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_) {
  #line 7 "src/expression/ScalarMatrix.birch"
  libbirch_function_("doEvaluate", "src/expression/ScalarMatrix.birch", 7);
  #line 8 "src/expression/ScalarMatrix.birch"
  libbirch_line_(8);
  #line 8 "src/expression/ScalarMatrix.birch"
  return birch::scalar(y, handler_);
}

#line 4 "src/expression/ScalarMatrix.birch"
template<class Value>
#line 11 "src/expression/ScalarMatrix.birch"
libbirch::DefaultArray<birch::type::Real,2> birch::type::ScalarMatrix<Value>::doEvaluateGrad(const birch::type::Real& d, const Value& x, const libbirch::DefaultArray<Value,2>& y, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_) {
  #line 11 "src/expression/ScalarMatrix.birch"
  libbirch_function_("doEvaluateGrad", "src/expression/ScalarMatrix.birch", 11);
  #line 13 "src/expression/ScalarMatrix.birch"
  libbirch_line_(13);
  #line 13 "src/expression/ScalarMatrix.birch"
  return libbirch::make_array({ { d } });
}

#line 4 "src/expression/ScalarMultivariate.birch"
template<class Value>
#line 4 "src/expression/ScalarMultivariate.birch"
birch::type::ScalarMultivariate<Value>::ScalarMultivariate(const libbirch::Lazy<libbirch::Shared<birch::type::Expression<libbirch::DefaultArray<Value,1>>>>& y, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_) :
    #line 4 "src/expression/ScalarMultivariate.birch"
    super_type_(y) {
  //
}

#line 4 "src/expression/ScalarMultivariate.birch"
template<class Value>
#line 6 "src/expression/ScalarMultivariate.birch"
Value birch::type::ScalarMultivariate<Value>::doEvaluate(const libbirch::DefaultArray<Value,1>& y, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_) {
  #line 6 "src/expression/ScalarMultivariate.birch"
  libbirch_function_("doEvaluate", "src/expression/ScalarMultivariate.birch", 6);
  #line 7 "src/expression/ScalarMultivariate.birch"
  libbirch_line_(7);
  #line 7 "src/expression/ScalarMultivariate.birch"
  return birch::scalar(y, handler_);
}

#line 4 "src/expression/ScalarMultivariate.birch"
template<class Value>
#line 10 "src/expression/ScalarMultivariate.birch"
libbirch::DefaultArray<Value,1> birch::type::ScalarMultivariate<Value>::doEvaluateGrad(const birch::type::Real& d, const Value& x, const libbirch::DefaultArray<Value,1>& y, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_) {
  #line 10 "src/expression/ScalarMultivariate.birch"
  libbirch_function_("doEvaluateGrad", "src/expression/ScalarMultivariate.birch", 10);
  #line 11 "src/expression/ScalarMultivariate.birch"
  libbirch_line_(11);
  #line 11 "src/expression/ScalarMultivariate.birch"
  return libbirch::make_array({ d });
}

#line 12 "src/expression/ScalarUnaryExpression.birch"
template<class Argument,class ArgumentValue,class ArgumentGradient,class Value>
#line 12 "src/expression/ScalarUnaryExpression.birch"
birch::type::ScalarUnaryExpression<Argument, ArgumentValue, ArgumentGradient, Value>::ScalarUnaryExpression(const Argument& y, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_) :
    #line 12 "src/expression/ScalarUnaryExpression.birch"
    super_type_(),
    #line 17 "src/expression/ScalarUnaryExpression.birch"
    y(y) {
  //
}

#line 12 "src/expression/ScalarUnaryExpression.birch"
template<class Argument,class ArgumentValue,class ArgumentGradient,class Value>
#line 30 "src/expression/ScalarUnaryExpression.birch"
birch::type::Integer birch::type::ScalarUnaryExpression<Argument, ArgumentValue, ArgumentGradient, Value>::doDepth(const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_) {
  #line 30 "src/expression/ScalarUnaryExpression.birch"
  libbirch_function_("doDepth", "src/expression/ScalarUnaryExpression.birch", 30);
  #line 31 "src/expression/ScalarUnaryExpression.birch"
  libbirch_line_(31);
  #line 31 "src/expression/ScalarUnaryExpression.birch"
  return this_()->y.get()->depth(handler_) + birch::type::Integer(1);
}

#line 12 "src/expression/ScalarUnaryExpression.birch"
template<class Argument,class ArgumentValue,class ArgumentGradient,class Value>
#line 34 "src/expression/ScalarUnaryExpression.birch"
Value birch::type::ScalarUnaryExpression<Argument, ArgumentValue, ArgumentGradient, Value>::doValue(const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_) {
  #line 34 "src/expression/ScalarUnaryExpression.birch"
  libbirch_function_("doValue", "src/expression/ScalarUnaryExpression.birch", 34);
  #line 35 "src/expression/ScalarUnaryExpression.birch"
  libbirch_line_(35);
  #line 35 "src/expression/ScalarUnaryExpression.birch"
  return this_()->doEvaluate(this_()->y.get()->value(handler_), handler_);
}

#line 12 "src/expression/ScalarUnaryExpression.birch"
template<class Argument,class ArgumentValue,class ArgumentGradient,class Value>
#line 38 "src/expression/ScalarUnaryExpression.birch"
Value birch::type::ScalarUnaryExpression<Argument, ArgumentValue, ArgumentGradient, Value>::doPilot(const birch::type::Integer& gen, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_) {
  #line 38 "src/expression/ScalarUnaryExpression.birch"
  libbirch_function_("doPilot", "src/expression/ScalarUnaryExpression.birch", 38);
  #line 39 "src/expression/ScalarUnaryExpression.birch"
  libbirch_line_(39);
  #line 39 "src/expression/ScalarUnaryExpression.birch"
  return this_()->doEvaluate(this_()->y.get()->pilot(gen, handler_), handler_);
}

#line 12 "src/expression/ScalarUnaryExpression.birch"
template<class Argument,class ArgumentValue,class ArgumentGradient,class Value>
#line 42 "src/expression/ScalarUnaryExpression.birch"
Value birch::type::ScalarUnaryExpression<Argument, ArgumentValue, ArgumentGradient, Value>::doGet(const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_) {
  #line 42 "src/expression/ScalarUnaryExpression.birch"
  libbirch_function_("doGet", "src/expression/ScalarUnaryExpression.birch", 42);
  #line 43 "src/expression/ScalarUnaryExpression.birch"
  libbirch_line_(43);
  #line 43 "src/expression/ScalarUnaryExpression.birch"
  return this_()->doEvaluate(this_()->y.get()->get(handler_), handler_);
}

#line 12 "src/expression/ScalarUnaryExpression.birch"
template<class Argument,class ArgumentValue,class ArgumentGradient,class Value>
#line 46 "src/expression/ScalarUnaryExpression.birch"
Value birch::type::ScalarUnaryExpression<Argument, ArgumentValue, ArgumentGradient, Value>::doMove(const birch::type::Integer& gen, const libbirch::Lazy<libbirch::Shared<birch::type::Kernel>>& _u0954, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_) {
  #line 46 "src/expression/ScalarUnaryExpression.birch"
  libbirch_function_("doMove", "src/expression/ScalarUnaryExpression.birch", 46);
  #line 47 "src/expression/ScalarUnaryExpression.birch"
  libbirch_line_(47);
  #line 47 "src/expression/ScalarUnaryExpression.birch"
  return this_()->doEvaluate(this_()->y.get()->move(gen, _u0954, handler_), handler_);
}

#line 12 "src/expression/ScalarUnaryExpression.birch"
template<class Argument,class ArgumentValue,class ArgumentGradient,class Value>
#line 50 "src/expression/ScalarUnaryExpression.birch"
void birch::type::ScalarUnaryExpression<Argument, ArgumentValue, ArgumentGradient, Value>::doGrad(const birch::type::Integer& gen, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_) {
  #line 50 "src/expression/ScalarUnaryExpression.birch"
  libbirch_function_("doGrad", "src/expression/ScalarUnaryExpression.birch", 50);
  #line 51 "src/expression/ScalarUnaryExpression.birch"
  libbirch_line_(51);
  #line 51 "src/expression/ScalarUnaryExpression.birch"
  this_()->y.get()->grad(gen, this_()->doEvaluateGrad(this_()->d.get(), this_()->x.get(), this_()->y.get()->get(handler_), handler_), handler_);
}

#line 12 "src/expression/ScalarUnaryExpression.birch"
template<class Argument,class ArgumentValue,class ArgumentGradient,class Value>
#line 54 "src/expression/ScalarUnaryExpression.birch"
libbirch::Optional<libbirch::Lazy<libbirch::Shared<birch::type::Expression<birch::type::Real>>>> birch::type::ScalarUnaryExpression<Argument, ArgumentValue, ArgumentGradient, Value>::doPrior(const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_) {
  #line 54 "src/expression/ScalarUnaryExpression.birch"
  libbirch_function_("doPrior", "src/expression/ScalarUnaryExpression.birch", 54);
  #line 55 "src/expression/ScalarUnaryExpression.birch"
  libbirch_line_(55);
  #line 55 "src/expression/ScalarUnaryExpression.birch"
  return this_()->y.get()->prior(handler_);
}

#line 12 "src/expression/ScalarUnaryExpression.birch"
template<class Argument,class ArgumentValue,class ArgumentGradient,class Value>
#line 58 "src/expression/ScalarUnaryExpression.birch"
birch::type::Real birch::type::ScalarUnaryExpression<Argument, ArgumentValue, ArgumentGradient, Value>::doCompare(const birch::type::Integer& gen, const libbirch::Lazy<libbirch::Shared<birch::type::DelayExpression>>& x, const libbirch::Lazy<libbirch::Shared<birch::type::Kernel>>& _u0954, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_) {
  #line 58 "src/expression/ScalarUnaryExpression.birch"
  libbirch_function_("doCompare", "src/expression/ScalarUnaryExpression.birch", 58);
  #line 60 "src/expression/ScalarUnaryExpression.birch"
  libbirch_line_(60);
  #line 60 "src/expression/ScalarUnaryExpression.birch"
  auto o = libbirch::cast<libbirch::Lazy<libbirch::Shared<birch::type::ScalarUnaryExpression<Argument, ArgumentValue, ArgumentGradient, Value>>>>(x).get();
  #line 62 "src/expression/ScalarUnaryExpression.birch"
  libbirch_line_(62);
  #line 62 "src/expression/ScalarUnaryExpression.birch"
  return this_()->y.get()->compare(gen, o->y.get(), _u0954, handler_);
}

#line 12 "src/expression/ScalarUnaryExpression.birch"
template<class Argument,class ArgumentValue,class ArgumentGradient,class Value>
#line 65 "src/expression/ScalarUnaryExpression.birch"
void birch::type::ScalarUnaryExpression<Argument, ArgumentValue, ArgumentGradient, Value>::doConstant(const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_) {
  #line 65 "src/expression/ScalarUnaryExpression.birch"
  libbirch_function_("doConstant", "src/expression/ScalarUnaryExpression.birch", 65);
  #line 66 "src/expression/ScalarUnaryExpression.birch"
  libbirch_line_(66);
  #line 66 "src/expression/ScalarUnaryExpression.birch"
  this_()->y.get()->constant(handler_);
}

#line 12 "src/expression/ScalarUnaryExpression.birch"
template<class Argument,class ArgumentValue,class ArgumentGradient,class Value>
#line 69 "src/expression/ScalarUnaryExpression.birch"
void birch::type::ScalarUnaryExpression<Argument, ArgumentValue, ArgumentGradient, Value>::doCount(const birch::type::Integer& gen, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_) {
  #line 69 "src/expression/ScalarUnaryExpression.birch"
  libbirch_function_("doCount", "src/expression/ScalarUnaryExpression.birch", 69);
  #line 70 "src/expression/ScalarUnaryExpression.birch"
  libbirch_line_(70);
  #line 70 "src/expression/ScalarUnaryExpression.birch"
  this_()->y.get()->count(gen, handler_);
}

#line 12 "src/expression/ScalarUnaryExpression.birch"
template<class Argument,class ArgumentValue,class ArgumentGradient,class Value>
#line 73 "src/expression/ScalarUnaryExpression.birch"
void birch::type::ScalarUnaryExpression<Argument, ArgumentValue, ArgumentGradient, Value>::doDetach(const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_) {
  #line 73 "src/expression/ScalarUnaryExpression.birch"
  libbirch_function_("doDetach", "src/expression/ScalarUnaryExpression.birch", 73);
  #line 74 "src/expression/ScalarUnaryExpression.birch"
  libbirch_line_(74);
  #line 74 "src/expression/ScalarUnaryExpression.birch"
  this_()->y = libbirch::nil;
}

#line 4 "src/expression/Trace.birch"
template<class Argument,class ArgumentValue>
#line 4 "src/expression/Trace.birch"
birch::type::Trace<Argument, ArgumentValue>::Trace(const Argument& y, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_) :
    #line 4 "src/expression/Trace.birch"
    super_type_(y) {
  //
}

#line 4 "src/expression/Trace.birch"
template<class Argument,class ArgumentValue>
#line 6 "src/expression/Trace.birch"
birch::type::Real birch::type::Trace<Argument, ArgumentValue>::doEvaluate(const ArgumentValue& y, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_) {
  #line 6 "src/expression/Trace.birch"
  libbirch_function_("doEvaluate", "src/expression/Trace.birch", 6);
  #line 7 "src/expression/Trace.birch"
  libbirch_line_(7);
  #line 7 "src/expression/Trace.birch"
  return birch::trace(y, handler_);
}

#line 4 "src/expression/Trace.birch"
template<class Argument,class ArgumentValue>
#line 10 "src/expression/Trace.birch"
libbirch::DefaultArray<birch::type::Real,2> birch::type::Trace<Argument, ArgumentValue>::doEvaluateGrad(const birch::type::Real& d, const birch::type::Real& x, const ArgumentValue& y, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_) {
  #line 10 "src/expression/Trace.birch"
  libbirch_function_("doEvaluateGrad", "src/expression/Trace.birch", 10);
  #line 12 "src/expression/Trace.birch"
  libbirch_line_(12);
  #line 12 "src/expression/Trace.birch"
  return birch::diagonal(d, birch::rows(y, handler_), handler_);
}

#line 36 "src/handler/MoveHandler.birch"
template<class Value>
#line 36 "src/handler/MoveHandler.birch"
void birch::type::MoveHandler::doHandle(const libbirch::Lazy<libbirch::Shared<birch::type::SimulateEvent<Value>>>& event, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_) {
  #line 36 "src/handler/MoveHandler.birch"
  libbirch_function_("doHandle", "src/handler/MoveHandler.birch", 36);
  #line 37 "src/handler/MoveHandler.birch"
  libbirch_line_(37);
  #line 37 "src/handler/MoveHandler.birch"
  if (this_()->delayed) {
    #line 38 "src/handler/MoveHandler.birch"
    libbirch_line_(38);
    #line 38 "src/handler/MoveHandler.birch"
    event->p = event->p->graft(handler_);
  }
  #line 40 "src/handler/MoveHandler.birch"
  libbirch_line_(40);
  #line 40 "src/handler/MoveHandler.birch"
  event->x = event->p->value(handler_);
}

#line 43 "src/handler/MoveHandler.birch"
template<class Value>
#line 43 "src/handler/MoveHandler.birch"
void birch::type::MoveHandler::doHandle(const libbirch::Lazy<libbirch::Shared<birch::type::ObserveEvent<Value>>>& event, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_) {
  #line 43 "src/handler/MoveHandler.birch"
  libbirch_function_("doHandle", "src/handler/MoveHandler.birch", 43);
  #line 44 "src/handler/MoveHandler.birch"
  libbirch_line_(44);
  #line 44 "src/handler/MoveHandler.birch"
  if (this_()->delayed) {
    #line 45 "src/handler/MoveHandler.birch"
    libbirch_line_(45);
    #line 45 "src/handler/MoveHandler.birch"
    event->p = event->p->graft(handler_);
  }
  #line 47 "src/handler/MoveHandler.birch"
  libbirch_line_(47);
  #line 47 "src/handler/MoveHandler.birch"
  auto v = event->p->observeLazy(birch::box(event->x, handler_), handler_);
  #line 48 "src/handler/MoveHandler.birch"
  libbirch_line_(48);
  #line 48 "src/handler/MoveHandler.birch"
  if (v.query()) {
    #line 49 "src/handler/MoveHandler.birch"
    libbirch_line_(49);
    #line 49 "src/handler/MoveHandler.birch"
    if (this_()->z.query()) {
      #line 50 "src/handler/MoveHandler.birch"
      libbirch_line_(50);
      #line 50 "src/handler/MoveHandler.birch"
      this_()->z = this_()->z.get() + v.get();
    } else {
      #line 52 "src/handler/MoveHandler.birch"
      libbirch_line_(52);
      #line 52 "src/handler/MoveHandler.birch"
      this_()->z = v;
    }
  } else {
    #line 56 "src/handler/MoveHandler.birch"
    libbirch_line_(56);
    #line 56 "src/handler/MoveHandler.birch"
    this_()->w = this_()->w + event->p->observe(event->x, handler_);
  }
}

#line 60 "src/handler/MoveHandler.birch"
template<class Value>
#line 60 "src/handler/MoveHandler.birch"
void birch::type::MoveHandler::doHandle(const libbirch::Lazy<libbirch::Shared<birch::type::AssumeEvent<Value>>>& event, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_) {
  #line 60 "src/handler/MoveHandler.birch"
  libbirch_function_("doHandle", "src/handler/MoveHandler.birch", 60);
  #line 61 "src/handler/MoveHandler.birch"
  libbirch_line_(61);
  #line 61 "src/handler/MoveHandler.birch"
  if (this_()->delayed) {
    #line 62 "src/handler/MoveHandler.birch"
    libbirch_line_(62);
    #line 62 "src/handler/MoveHandler.birch"
    event->p = event->p->graft(handler_);
  }
  #line 64 "src/handler/MoveHandler.birch"
  libbirch_line_(64);
  #line 64 "src/handler/MoveHandler.birch"
  if (event->x->hasValue(handler_)) {
    #line 65 "src/handler/MoveHandler.birch"
    libbirch_line_(65);
    #line 65 "src/handler/MoveHandler.birch"
    auto v = event->p->observeLazy(event->x, handler_);
    #line 66 "src/handler/MoveHandler.birch"
    libbirch_line_(66);
    #line 66 "src/handler/MoveHandler.birch"
    if (v.query()) {
      #line 67 "src/handler/MoveHandler.birch"
      libbirch_line_(67);
      #line 67 "src/handler/MoveHandler.birch"
      if (this_()->z.query()) {
        #line 68 "src/handler/MoveHandler.birch"
        libbirch_line_(68);
        #line 68 "src/handler/MoveHandler.birch"
        this_()->z = this_()->z.get() + v.get();
      } else {
        #line 70 "src/handler/MoveHandler.birch"
        libbirch_line_(70);
        #line 70 "src/handler/MoveHandler.birch"
        this_()->z = v;
      }
    } else {
      #line 74 "src/handler/MoveHandler.birch"
      libbirch_line_(74);
      #line 74 "src/handler/MoveHandler.birch"
      this_()->w = this_()->w + event->p->observe(event->x->value(handler_), handler_);
    }
  } else {
    #line 77 "src/handler/MoveHandler.birch"
    libbirch_line_(77);
    #line 77 "src/handler/MoveHandler.birch"
    event->x->assume(event->p, handler_);
  }
}

#line 89 "src/handler/MoveHandler.birch"
template<class Value>
#line 89 "src/handler/MoveHandler.birch"
void birch::type::MoveHandler::doHandle(const libbirch::Lazy<libbirch::Shared<birch::type::SimulateRecord<Value>>>& record, const libbirch::Lazy<libbirch::Shared<birch::type::SimulateEvent<Value>>>& event, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_) {
  #line 89 "src/handler/MoveHandler.birch"
  libbirch_function_("doHandle", "src/handler/MoveHandler.birch", 89);
  #line 91 "src/handler/MoveHandler.birch"
  libbirch_line_(91);
  #line 91 "src/handler/MoveHandler.birch"
  if (this_()->delayed) {
    #line 92 "src/handler/MoveHandler.birch"
    libbirch_line_(92);
    #line 92 "src/handler/MoveHandler.birch"
    event->p = event->p->graft(handler_);
  }
  #line 94 "src/handler/MoveHandler.birch"
  libbirch_line_(94);
  #line 94 "src/handler/MoveHandler.birch"
  event->x = record->x;
}

#line 97 "src/handler/MoveHandler.birch"
template<class Value>
#line 97 "src/handler/MoveHandler.birch"
void birch::type::MoveHandler::doHandle(const libbirch::Lazy<libbirch::Shared<birch::type::ObserveRecord<Value>>>& record, const libbirch::Lazy<libbirch::Shared<birch::type::ObserveEvent<Value>>>& event, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_) {
  #line 97 "src/handler/MoveHandler.birch"
  libbirch_function_("doHandle", "src/handler/MoveHandler.birch", 97);
  #line 101 "src/handler/MoveHandler.birch"
  libbirch_line_(101);
  #line 101 "src/handler/MoveHandler.birch"
  libbirch_assert_(record->x == event->x);
  #line 102 "src/handler/MoveHandler.birch"
  libbirch_line_(102);
  #line 102 "src/handler/MoveHandler.birch"
  this_()->doHandle(event, handler_);
}

#line 105 "src/handler/MoveHandler.birch"
template<class Value>
#line 105 "src/handler/MoveHandler.birch"
void birch::type::MoveHandler::doHandle(const libbirch::Lazy<libbirch::Shared<birch::type::AssumeRecord<Value>>>& record, const libbirch::Lazy<libbirch::Shared<birch::type::AssumeEvent<Value>>>& event, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_) {
  #line 105 "src/handler/MoveHandler.birch"
  libbirch_function_("doHandle", "src/handler/MoveHandler.birch", 105);
  #line 107 "src/handler/MoveHandler.birch"
  libbirch_line_(107);
  #line 107 "src/handler/MoveHandler.birch"
  if (this_()->delayed) {
    #line 108 "src/handler/MoveHandler.birch"
    libbirch_line_(108);
    #line 108 "src/handler/MoveHandler.birch"
    event->p = event->p->graft(handler_);
  }
  #line 110 "src/handler/MoveHandler.birch"
  libbirch_line_(110);
  #line 110 "src/handler/MoveHandler.birch"
  if (event->x->hasValue(handler_)) {
    #line 114 "src/handler/MoveHandler.birch"
    libbirch_line_(114);
    #line 114 "src/handler/MoveHandler.birch"
    libbirch_assert_(record->x->hasValue(handler_) && record->x->value(handler_) == event->x->value(handler_));
    #line 115 "src/handler/MoveHandler.birch"
    libbirch_line_(115);
    #line 115 "src/handler/MoveHandler.birch"
    auto v = event->p->observeLazy(event->x, handler_);
    #line 116 "src/handler/MoveHandler.birch"
    libbirch_line_(116);
    #line 116 "src/handler/MoveHandler.birch"
    if (v.query()) {
      #line 117 "src/handler/MoveHandler.birch"
      libbirch_line_(117);
      #line 117 "src/handler/MoveHandler.birch"
      if (this_()->z.query()) {
        #line 118 "src/handler/MoveHandler.birch"
        libbirch_line_(118);
        #line 118 "src/handler/MoveHandler.birch"
        this_()->z = this_()->z.get() + v.get();
      } else {
        #line 120 "src/handler/MoveHandler.birch"
        libbirch_line_(120);
        #line 120 "src/handler/MoveHandler.birch"
        this_()->z = v;
      }
    } else {
      #line 124 "src/handler/MoveHandler.birch"
      libbirch_line_(124);
      #line 124 "src/handler/MoveHandler.birch"
      this_()->w = this_()->w + event->p->observe(event->x->value(handler_), handler_);
    }
  } else {
    #line 127 "src/handler/MoveHandler.birch"
    libbirch_line_(127);
    #line 127 "src/handler/MoveHandler.birch"
    event->x->assume(event->p, handler_);
    #line 128 "src/handler/MoveHandler.birch"
    libbirch_line_(128);
    #line 128 "src/handler/MoveHandler.birch"
    if (record->x->hasValue(handler_)) {
      #line 132 "src/handler/MoveHandler.birch"
      libbirch_line_(132);
      #line 132 "src/handler/MoveHandler.birch"
      event->x = record->x->value(handler_);
    }
  }
}

#line 31 "src/handler/PlayHandler.birch"
template<class Value>
#line 31 "src/handler/PlayHandler.birch"
void birch::type::PlayHandler::doHandle(const libbirch::Lazy<libbirch::Shared<birch::type::SimulateEvent<Value>>>& event, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_) {
  #line 31 "src/handler/PlayHandler.birch"
  libbirch_function_("doHandle", "src/handler/PlayHandler.birch", 31);
  #line 32 "src/handler/PlayHandler.birch"
  libbirch_line_(32);
  #line 32 "src/handler/PlayHandler.birch"
  if (this_()->delayed) {
    #line 33 "src/handler/PlayHandler.birch"
    libbirch_line_(33);
    #line 33 "src/handler/PlayHandler.birch"
    event->p = event->p->graft(handler_);
  }
  #line 35 "src/handler/PlayHandler.birch"
  libbirch_line_(35);
  #line 35 "src/handler/PlayHandler.birch"
  event->x = event->p->value(handler_);
}

#line 38 "src/handler/PlayHandler.birch"
template<class Value>
#line 38 "src/handler/PlayHandler.birch"
void birch::type::PlayHandler::doHandle(const libbirch::Lazy<libbirch::Shared<birch::type::ObserveEvent<Value>>>& event, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_) {
  #line 38 "src/handler/PlayHandler.birch"
  libbirch_function_("doHandle", "src/handler/PlayHandler.birch", 38);
  #line 39 "src/handler/PlayHandler.birch"
  libbirch_line_(39);
  #line 39 "src/handler/PlayHandler.birch"
  if (this_()->delayed) {
    #line 40 "src/handler/PlayHandler.birch"
    libbirch_line_(40);
    #line 40 "src/handler/PlayHandler.birch"
    event->p = event->p->graft(handler_);
  }
  #line 42 "src/handler/PlayHandler.birch"
  libbirch_line_(42);
  #line 42 "src/handler/PlayHandler.birch"
  this_()->w = this_()->w + event->p->observe(event->x, handler_);
}

#line 45 "src/handler/PlayHandler.birch"
template<class Value>
#line 45 "src/handler/PlayHandler.birch"
void birch::type::PlayHandler::doHandle(const libbirch::Lazy<libbirch::Shared<birch::type::AssumeEvent<Value>>>& event, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_) {
  #line 45 "src/handler/PlayHandler.birch"
  libbirch_function_("doHandle", "src/handler/PlayHandler.birch", 45);
  #line 46 "src/handler/PlayHandler.birch"
  libbirch_line_(46);
  #line 46 "src/handler/PlayHandler.birch"
  if (this_()->delayed) {
    #line 47 "src/handler/PlayHandler.birch"
    libbirch_line_(47);
    #line 47 "src/handler/PlayHandler.birch"
    event->p = event->p->graft(handler_);
  }
  #line 49 "src/handler/PlayHandler.birch"
  libbirch_line_(49);
  #line 49 "src/handler/PlayHandler.birch"
  if (event->x->hasValue(handler_)) {
    #line 50 "src/handler/PlayHandler.birch"
    libbirch_line_(50);
    #line 50 "src/handler/PlayHandler.birch"
    this_()->w = this_()->w + event->p->observe(event->x->value(handler_), handler_);
  } else {
    #line 52 "src/handler/PlayHandler.birch"
    libbirch_line_(52);
    #line 52 "src/handler/PlayHandler.birch"
    event->x->assume(event->p, handler_);
  }
}

#line 60 "src/handler/PlayHandler.birch"
template<class Value>
#line 60 "src/handler/PlayHandler.birch"
void birch::type::PlayHandler::doHandle(const libbirch::Lazy<libbirch::Shared<birch::type::SimulateRecord<Value>>>& record, const libbirch::Lazy<libbirch::Shared<birch::type::SimulateEvent<Value>>>& event, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_) {
  #line 60 "src/handler/PlayHandler.birch"
  libbirch_function_("doHandle", "src/handler/PlayHandler.birch", 60);
  #line 62 "src/handler/PlayHandler.birch"
  libbirch_line_(62);
  #line 62 "src/handler/PlayHandler.birch"
  if (this_()->delayed) {
    #line 63 "src/handler/PlayHandler.birch"
    libbirch_line_(63);
    #line 63 "src/handler/PlayHandler.birch"
    event->p = event->p->graft(handler_);
  }
  #line 65 "src/handler/PlayHandler.birch"
  libbirch_line_(65);
  #line 65 "src/handler/PlayHandler.birch"
  event->x = record->x;
}

#line 68 "src/handler/PlayHandler.birch"
template<class Value>
#line 68 "src/handler/PlayHandler.birch"
void birch::type::PlayHandler::doHandle(const libbirch::Lazy<libbirch::Shared<birch::type::ObserveRecord<Value>>>& record, const libbirch::Lazy<libbirch::Shared<birch::type::ObserveEvent<Value>>>& event, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_) {
  #line 68 "src/handler/PlayHandler.birch"
  libbirch_function_("doHandle", "src/handler/PlayHandler.birch", 68);
  #line 72 "src/handler/PlayHandler.birch"
  libbirch_line_(72);
  #line 72 "src/handler/PlayHandler.birch"
  libbirch_assert_(record->x == event->x);
  #line 73 "src/handler/PlayHandler.birch"
  libbirch_line_(73);
  #line 73 "src/handler/PlayHandler.birch"
  this_()->doHandle(event, handler_);
}

#line 76 "src/handler/PlayHandler.birch"
template<class Value>
#line 76 "src/handler/PlayHandler.birch"
void birch::type::PlayHandler::doHandle(const libbirch::Lazy<libbirch::Shared<birch::type::AssumeRecord<Value>>>& record, const libbirch::Lazy<libbirch::Shared<birch::type::AssumeEvent<Value>>>& event, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_) {
  #line 76 "src/handler/PlayHandler.birch"
  libbirch_function_("doHandle", "src/handler/PlayHandler.birch", 76);
  #line 78 "src/handler/PlayHandler.birch"
  libbirch_line_(78);
  #line 78 "src/handler/PlayHandler.birch"
  if (this_()->delayed) {
    #line 79 "src/handler/PlayHandler.birch"
    libbirch_line_(79);
    #line 79 "src/handler/PlayHandler.birch"
    event->p = event->p->graft(handler_);
  }
  #line 81 "src/handler/PlayHandler.birch"
  libbirch_line_(81);
  #line 81 "src/handler/PlayHandler.birch"
  if (event->x->hasValue(handler_)) {
    #line 85 "src/handler/PlayHandler.birch"
    libbirch_line_(85);
    #line 85 "src/handler/PlayHandler.birch"
    libbirch_assert_(record->x->hasValue(handler_) && record->x->value(handler_) == event->x->value(handler_));
    #line 86 "src/handler/PlayHandler.birch"
    libbirch_line_(86);
    #line 86 "src/handler/PlayHandler.birch"
    this_()->w = this_()->w + event->p->observe(event->x->value(handler_), handler_);
  } else {
    #line 88 "src/handler/PlayHandler.birch"
    libbirch_line_(88);
    #line 88 "src/handler/PlayHandler.birch"
    event->x->assume(event->p, handler_);
    #line 89 "src/handler/PlayHandler.birch"
    libbirch_line_(89);
    #line 89 "src/handler/PlayHandler.birch"
    if (record->x->hasValue(handler_)) {
      #line 93 "src/handler/PlayHandler.birch"
      libbirch_line_(93);
      #line 93 "src/handler/PlayHandler.birch"
      event->x = record->x->value(handler_);
    }
  }
}

#line 6 "src/iterator/ArrayIterator.birch"
template<class Type>
#line 6 "src/iterator/ArrayIterator.birch"
birch::type::ArrayIterator<Type>::ArrayIterator(const libbirch::Lazy<libbirch::Shared<birch::type::Array<Type>>>& o, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_) :
    #line 6 "src/iterator/ArrayIterator.birch"
    super_type_(),
    #line 10 "src/iterator/ArrayIterator.birch"
    o(o),
    #line 15 "src/iterator/ArrayIterator.birch"
    i(birch::type::Integer(0)) {
  //
}

#line 6 "src/iterator/ArrayIterator.birch"
template<class Type>
#line 20 "src/iterator/ArrayIterator.birch"
birch::type::Boolean birch::type::ArrayIterator<Type>::hasNext(const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_) {
  #line 20 "src/iterator/ArrayIterator.birch"
  libbirch_function_("hasNext", "src/iterator/ArrayIterator.birch", 20);
  #line 21 "src/iterator/ArrayIterator.birch"
  libbirch_line_(21);
  #line 21 "src/iterator/ArrayIterator.birch"
  return this_()->i < this_()->o->size(handler_);
}

#line 6 "src/iterator/ArrayIterator.birch"
template<class Type>
#line 27 "src/iterator/ArrayIterator.birch"
Type birch::type::ArrayIterator<Type>::next(const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_) {
  #line 27 "src/iterator/ArrayIterator.birch"
  libbirch_function_("next", "src/iterator/ArrayIterator.birch", 27);
  #line 28 "src/iterator/ArrayIterator.birch"
  libbirch_line_(28);
  #line 28 "src/iterator/ArrayIterator.birch"
  this_()->i = this_()->i + birch::type::Integer(1);
  #line 29 "src/iterator/ArrayIterator.birch"
  libbirch_line_(29);
  #line 29 "src/iterator/ArrayIterator.birch"
  return this_()->o->get(this_()->i, handler_);
}

#line 4 "src/iterator/EmptyIterator.birch"
template<class Type>
#line 4 "src/iterator/EmptyIterator.birch"
birch::type::EmptyIterator<Type>::EmptyIterator(const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_) :
    #line 4 "src/iterator/EmptyIterator.birch"
    super_type_() {
  //
}

#line 4 "src/iterator/EmptyIterator.birch"
template<class Type>
#line 8 "src/iterator/EmptyIterator.birch"
birch::type::Boolean birch::type::EmptyIterator<Type>::hasNext(const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_) {
  #line 8 "src/iterator/EmptyIterator.birch"
  libbirch_function_("hasNext", "src/iterator/EmptyIterator.birch", 8);
  #line 9 "src/iterator/EmptyIterator.birch"
  libbirch_line_(9);
  #line 9 "src/iterator/EmptyIterator.birch"
  return false;
}

#line 4 "src/iterator/EmptyIterator.birch"
template<class Type>
#line 15 "src/iterator/EmptyIterator.birch"
Type birch::type::EmptyIterator<Type>::next(const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_) {
  #line 15 "src/iterator/EmptyIterator.birch"
  libbirch_function_("next", "src/iterator/EmptyIterator.birch", 15);
  #line 16 "src/iterator/EmptyIterator.birch"
  libbirch_line_(16);
  #line 16 "src/iterator/EmptyIterator.birch"
  libbirch_assert_(false);
  #line 17 "src/iterator/EmptyIterator.birch"
  libbirch_line_(17);
  #line 17 "src/iterator/EmptyIterator.birch"
  return birch::construct<Type>(handler_);
}

#line 4 "src/iterator/Iterator.birch"
template<class Type>
#line 4 "src/iterator/Iterator.birch"
birch::type::Iterator<Type>::Iterator(const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_) :
    #line 4 "src/iterator/Iterator.birch"
    super_type_() {
  //
}

#line 6 "src/iterator/ListIterator.birch"
template<class Type>
#line 6 "src/iterator/ListIterator.birch"
birch::type::ListIterator<Type>::ListIterator(const libbirch::Optional<libbirch::Lazy<libbirch::Shared<birch::type::ListNode<Type>>>>& head, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_) :
    #line 6 "src/iterator/ListIterator.birch"
    super_type_(),
    #line 10 "src/iterator/ListIterator.birch"
    node(head) {
  //
}

#line 6 "src/iterator/ListIterator.birch"
template<class Type>
#line 15 "src/iterator/ListIterator.birch"
birch::type::Boolean birch::type::ListIterator<Type>::hasNext(const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_) {
  #line 15 "src/iterator/ListIterator.birch"
  libbirch_function_("hasNext", "src/iterator/ListIterator.birch", 15);
  #line 16 "src/iterator/ListIterator.birch"
  libbirch_line_(16);
  #line 16 "src/iterator/ListIterator.birch"
  return this_()->node.query();
}

#line 6 "src/iterator/ListIterator.birch"
template<class Type>
#line 22 "src/iterator/ListIterator.birch"
Type birch::type::ListIterator<Type>::next(const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_) {
  #line 22 "src/iterator/ListIterator.birch"
  libbirch_function_("next", "src/iterator/ListIterator.birch", 22);
  #line 23 "src/iterator/ListIterator.birch"
  libbirch_line_(23);
  #line 23 "src/iterator/ListIterator.birch"
  auto x = this_()->node.get()->x;
  #line 24 "src/iterator/ListIterator.birch"
  libbirch_line_(24);
  #line 24 "src/iterator/ListIterator.birch"
  this_()->node = this_()->node.get()->next;
  #line 25 "src/iterator/ListIterator.birch"
  libbirch_line_(25);
  #line 25 "src/iterator/ListIterator.birch"
  return x;
}

#line 7 "src/iterator/RaggedArrayElementIterator.birch"
template<class Type>
#line 7 "src/iterator/RaggedArrayElementIterator.birch"
birch::type::RaggedArrayElementIterator<Type>::RaggedArrayElementIterator(const libbirch::Lazy<libbirch::Shared<birch::type::RaggedArray<Type>>>& o, const birch::type::Integer& i, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_) :
    #line 7 "src/iterator/RaggedArrayElementIterator.birch"
    super_type_(),
    #line 12 "src/iterator/RaggedArrayElementIterator.birch"
    o(o),
    #line 17 "src/iterator/RaggedArrayElementIterator.birch"
    i(i),
    #line 22 "src/iterator/RaggedArrayElementIterator.birch"
    j(birch::type::Integer(0)) {
  //
}

#line 7 "src/iterator/RaggedArrayElementIterator.birch"
template<class Type>
#line 27 "src/iterator/RaggedArrayElementIterator.birch"
birch::type::Boolean birch::type::RaggedArrayElementIterator<Type>::hasNext(const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_) {
  #line 27 "src/iterator/RaggedArrayElementIterator.birch"
  libbirch_function_("hasNext", "src/iterator/RaggedArrayElementIterator.birch", 27);
  #line 28 "src/iterator/RaggedArrayElementIterator.birch"
  libbirch_line_(28);
  #line 28 "src/iterator/RaggedArrayElementIterator.birch"
  return this_()->j < this_()->o->size(this_()->i, handler_);
}

#line 7 "src/iterator/RaggedArrayElementIterator.birch"
template<class Type>
#line 34 "src/iterator/RaggedArrayElementIterator.birch"
Type birch::type::RaggedArrayElementIterator<Type>::next(const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_) {
  #line 34 "src/iterator/RaggedArrayElementIterator.birch"
  libbirch_function_("next", "src/iterator/RaggedArrayElementIterator.birch", 34);
  #line 35 "src/iterator/RaggedArrayElementIterator.birch"
  libbirch_line_(35);
  #line 35 "src/iterator/RaggedArrayElementIterator.birch"
  this_()->j = this_()->j + birch::type::Integer(1);
  #line 36 "src/iterator/RaggedArrayElementIterator.birch"
  libbirch_line_(36);
  #line 36 "src/iterator/RaggedArrayElementIterator.birch"
  return this_()->o->get(this_()->i, this_()->j, handler_);
}

#line 6 "src/iterator/RaggedArrayRowIterator.birch"
template<class Type>
#line 6 "src/iterator/RaggedArrayRowIterator.birch"
birch::type::RaggedArrayRowIterator<Type>::RaggedArrayRowIterator(const libbirch::Lazy<libbirch::Shared<birch::type::RaggedArray<Type>>>& o, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_) :
    #line 6 "src/iterator/RaggedArrayRowIterator.birch"
    super_type_(),
    #line 11 "src/iterator/RaggedArrayRowIterator.birch"
    o(o),
    #line 16 "src/iterator/RaggedArrayRowIterator.birch"
    i(birch::type::Integer(0)) {
  //
}

#line 6 "src/iterator/RaggedArrayRowIterator.birch"
template<class Type>
#line 21 "src/iterator/RaggedArrayRowIterator.birch"
birch::type::Boolean birch::type::RaggedArrayRowIterator<Type>::hasNext(const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_) {
  #line 21 "src/iterator/RaggedArrayRowIterator.birch"
  libbirch_function_("hasNext", "src/iterator/RaggedArrayRowIterator.birch", 21);
  #line 22 "src/iterator/RaggedArrayRowIterator.birch"
  libbirch_line_(22);
  #line 22 "src/iterator/RaggedArrayRowIterator.birch"
  return this_()->i < this_()->o->size(handler_);
}

#line 6 "src/iterator/RaggedArrayRowIterator.birch"
template<class Type>
#line 28 "src/iterator/RaggedArrayRowIterator.birch"
libbirch::DefaultArray<Type,1> birch::type::RaggedArrayRowIterator<Type>::next(const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_) {
  #line 28 "src/iterator/RaggedArrayRowIterator.birch"
  libbirch_function_("next", "src/iterator/RaggedArrayRowIterator.birch", 28);
  #line 29 "src/iterator/RaggedArrayRowIterator.birch"
  libbirch_line_(29);
  #line 29 "src/iterator/RaggedArrayRowIterator.birch"
  this_()->i = this_()->i + birch::type::Integer(1);
  #line 30 "src/iterator/RaggedArrayRowIterator.birch"
  libbirch_line_(30);
  #line 30 "src/iterator/RaggedArrayRowIterator.birch"
  return this_()->o->get(this_()->i, handler_);
}

#line 6 "src/iterator/StackIterator.birch"
template<class Type>
#line 6 "src/iterator/StackIterator.birch"
birch::type::StackIterator<Type>::StackIterator(const libbirch::Optional<libbirch::Lazy<libbirch::Shared<birch::type::StackNode<Type>>>>& head, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_) :
    #line 6 "src/iterator/StackIterator.birch"
    super_type_(),
    #line 10 "src/iterator/StackIterator.birch"
    node(head) {
  //
}

#line 6 "src/iterator/StackIterator.birch"
template<class Type>
#line 15 "src/iterator/StackIterator.birch"
birch::type::Boolean birch::type::StackIterator<Type>::hasNext(const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_) {
  #line 15 "src/iterator/StackIterator.birch"
  libbirch_function_("hasNext", "src/iterator/StackIterator.birch", 15);
  #line 16 "src/iterator/StackIterator.birch"
  libbirch_line_(16);
  #line 16 "src/iterator/StackIterator.birch"
  return this_()->node.query();
}

#line 6 "src/iterator/StackIterator.birch"
template<class Type>
#line 22 "src/iterator/StackIterator.birch"
Type birch::type::StackIterator<Type>::next(const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_) {
  #line 22 "src/iterator/StackIterator.birch"
  libbirch_function_("next", "src/iterator/StackIterator.birch", 22);
  #line 23 "src/iterator/StackIterator.birch"
  libbirch_line_(23);
  #line 23 "src/iterator/StackIterator.birch"
  auto x = this_()->node.get()->x;
  #line 24 "src/iterator/StackIterator.birch"
  libbirch_line_(24);
  #line 24 "src/iterator/StackIterator.birch"
  this_()->node = this_()->node.get()->next;
  #line 25 "src/iterator/StackIterator.birch"
  libbirch_line_(25);
  #line 25 "src/iterator/StackIterator.birch"
  return x;
}

#line 6 "src/iterator/TapeIterator.birch"
template<class Type>
#line 6 "src/iterator/TapeIterator.birch"
birch::type::TapeIterator<Type>::TapeIterator(const libbirch::Optional<libbirch::Lazy<libbirch::Shared<birch::type::TapeNode<Type>>>>& head, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_) :
    #line 6 "src/iterator/TapeIterator.birch"
    super_type_(),
    #line 10 "src/iterator/TapeIterator.birch"
    node(head) {
  //
}

#line 6 "src/iterator/TapeIterator.birch"
template<class Type>
#line 15 "src/iterator/TapeIterator.birch"
birch::type::Boolean birch::type::TapeIterator<Type>::hasNext(const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_) {
  #line 15 "src/iterator/TapeIterator.birch"
  libbirch_function_("hasNext", "src/iterator/TapeIterator.birch", 15);
  #line 16 "src/iterator/TapeIterator.birch"
  libbirch_line_(16);
  #line 16 "src/iterator/TapeIterator.birch"
  return this_()->node.query();
}

#line 6 "src/iterator/TapeIterator.birch"
template<class Type>
#line 22 "src/iterator/TapeIterator.birch"
Type birch::type::TapeIterator<Type>::next(const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_) {
  #line 22 "src/iterator/TapeIterator.birch"
  libbirch_function_("next", "src/iterator/TapeIterator.birch", 22);
  #line 23 "src/iterator/TapeIterator.birch"
  libbirch_line_(23);
  #line 23 "src/iterator/TapeIterator.birch"
  auto x = this_()->node.get()->x;
  #line 24 "src/iterator/TapeIterator.birch"
  libbirch_line_(24);
  #line 24 "src/iterator/TapeIterator.birch"
  this_()->node = this_()->node.get()->next;
  #line 25 "src/iterator/TapeIterator.birch"
  libbirch_line_(25);
  #line 25 "src/iterator/TapeIterator.birch"
  return x;
}

#line 41 "src/model/HiddenMarkovModel.birch"
template<class Parameter,class State,class Observation>
#line 41 "src/model/HiddenMarkovModel.birch"
birch::type::HiddenMarkovModel<Parameter, State, Observation>::HiddenMarkovModel(const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_) :
    #line 41 "src/model/HiddenMarkovModel.birch"
    super_type_(),
    #line 46 "src/model/HiddenMarkovModel.birch"
    y() {
  //
}

#line 41 "src/model/HiddenMarkovModel.birch"
template<class Parameter,class State,class Observation>
#line 48 "src/model/HiddenMarkovModel.birch"
birch::type::Integer birch::type::HiddenMarkovModel<Parameter, State, Observation>::size(const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_) {
  #line 48 "src/model/HiddenMarkovModel.birch"
  libbirch_function_("size", "src/model/HiddenMarkovModel.birch", 48);
  #line 49 "src/model/HiddenMarkovModel.birch"
  libbirch_line_(49);
  #line 49 "src/model/HiddenMarkovModel.birch"
  return birch::max(this_()->x->size(handler_), this_()->y->size(handler_), handler_);
}

#line 41 "src/model/HiddenMarkovModel.birch"
template<class Parameter,class State,class Observation>
#line 52 "src/model/HiddenMarkovModel.birch"
void birch::type::HiddenMarkovModel<Parameter, State, Observation>::simulate(const birch::type::Integer& t, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_) {
  #line 52 "src/model/HiddenMarkovModel.birch"
  libbirch_function_("simulate", "src/model/HiddenMarkovModel.birch", 52);
  #line 53 "src/model/HiddenMarkovModel.birch"
  libbirch_line_(53);
  #line 53 "src/model/HiddenMarkovModel.birch"
  this_()->super_type_::simulate(t, handler_);
  #line 54 "src/model/HiddenMarkovModel.birch"
  libbirch_line_(54);
  #line 54 "src/model/HiddenMarkovModel.birch"
  if (t > birch::type::Integer(1)) {
    #line 55 "src/model/HiddenMarkovModel.birch"
    libbirch_line_(55);
    #line 55 "src/model/HiddenMarkovModel.birch"
    this_()->y->forward(handler_);
  }
  #line 57 "src/model/HiddenMarkovModel.birch"
  libbirch_line_(57);
  #line 57 "src/model/HiddenMarkovModel.birch"
  this_()->observation(this_()->y->current(handler_), this_()->x->current(handler_), this_()->_u0952, handler_);
}

#line 41 "src/model/HiddenMarkovModel.birch"
template<class Parameter,class State,class Observation>
#line 67 "src/model/HiddenMarkovModel.birch"
void birch::type::HiddenMarkovModel<Parameter, State, Observation>::observation(const Observation& y, const State& x, const Parameter& _u0952, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_) {
  #line 67 "src/model/HiddenMarkovModel.birch"
  libbirch_function_("observation", "src/model/HiddenMarkovModel.birch", 67);
}

#line 41 "src/model/HiddenMarkovModel.birch"
template<class Parameter,class State,class Observation>
#line 71 "src/model/HiddenMarkovModel.birch"
void birch::type::HiddenMarkovModel<Parameter, State, Observation>::read(const libbirch::Lazy<libbirch::Shared<birch::type::Buffer>>& buffer, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_) {
  #line 71 "src/model/HiddenMarkovModel.birch"
  libbirch_function_("read", "src/model/HiddenMarkovModel.birch", 71);
  #line 72 "src/model/HiddenMarkovModel.birch"
  libbirch_line_(72);
  #line 72 "src/model/HiddenMarkovModel.birch"
  this_()->super_type_::read(buffer, handler_);
  #line 73 "src/model/HiddenMarkovModel.birch"
  libbirch_line_(73);
  #line 73 "src/model/HiddenMarkovModel.birch"
  buffer->get(birch::type::String("y"), this_()->y, handler_);
}

#line 41 "src/model/HiddenMarkovModel.birch"
template<class Parameter,class State,class Observation>
#line 76 "src/model/HiddenMarkovModel.birch"
void birch::type::HiddenMarkovModel<Parameter, State, Observation>::write(const libbirch::Lazy<libbirch::Shared<birch::type::Buffer>>& buffer, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_) {
  #line 76 "src/model/HiddenMarkovModel.birch"
  libbirch_function_("write", "src/model/HiddenMarkovModel.birch", 76);
  #line 77 "src/model/HiddenMarkovModel.birch"
  libbirch_line_(77);
  #line 77 "src/model/HiddenMarkovModel.birch"
  this_()->super_type_::write(buffer, handler_);
}

#line 29 "src/model/MarkovModel.birch"
template<class Parameter,class State>
#line 29 "src/model/MarkovModel.birch"
birch::type::MarkovModel<Parameter, State>::MarkovModel(const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_) :
    #line 29 "src/model/MarkovModel.birch"
    super_type_(),
    #line 33 "src/model/MarkovModel.birch"
    _u0952(),
    #line 38 "src/model/MarkovModel.birch"
    x() {
  //
}

#line 29 "src/model/MarkovModel.birch"
template<class Parameter,class State>
#line 40 "src/model/MarkovModel.birch"
birch::type::Integer birch::type::MarkovModel<Parameter, State>::size(const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_) {
  #line 40 "src/model/MarkovModel.birch"
  libbirch_function_("size", "src/model/MarkovModel.birch", 40);
  #line 41 "src/model/MarkovModel.birch"
  libbirch_line_(41);
  #line 41 "src/model/MarkovModel.birch"
  return this_()->x->size(handler_);
}

#line 29 "src/model/MarkovModel.birch"
template<class Parameter,class State>
#line 44 "src/model/MarkovModel.birch"
void birch::type::MarkovModel<Parameter, State>::simulate(const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_) {
  #line 44 "src/model/MarkovModel.birch"
  libbirch_function_("simulate", "src/model/MarkovModel.birch", 44);
  #line 45 "src/model/MarkovModel.birch"
  libbirch_line_(45);
  #line 45 "src/model/MarkovModel.birch"
  this_()->parameter(this_()->_u0952, handler_);
}

#line 29 "src/model/MarkovModel.birch"
template<class Parameter,class State>
#line 48 "src/model/MarkovModel.birch"
void birch::type::MarkovModel<Parameter, State>::simulate(const birch::type::Integer& t, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_) {
  #line 48 "src/model/MarkovModel.birch"
  libbirch_function_("simulate", "src/model/MarkovModel.birch", 48);
  #line 49 "src/model/MarkovModel.birch"
  libbirch_line_(49);
  #line 49 "src/model/MarkovModel.birch"
  if (t == birch::type::Integer(1)) {
    #line 50 "src/model/MarkovModel.birch"
    libbirch_line_(50);
    #line 50 "src/model/MarkovModel.birch"
    this_()->initial(this_()->x->current(handler_), this_()->_u0952, handler_);
  } else {
    #line 52 "src/model/MarkovModel.birch"
    libbirch_line_(52);
    #line 52 "src/model/MarkovModel.birch"
    this_()->x->forward(handler_);
    #line 53 "src/model/MarkovModel.birch"
    libbirch_line_(53);
    #line 53 "src/model/MarkovModel.birch"
    this_()->transition(this_()->x->current(handler_), this_()->x->previous(handler_), this_()->_u0952, handler_);
  }
}

#line 29 "src/model/MarkovModel.birch"
template<class Parameter,class State>
#line 62 "src/model/MarkovModel.birch"
void birch::type::MarkovModel<Parameter, State>::parameter(const Parameter& _u0952, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_) {
  #line 62 "src/model/MarkovModel.birch"
  libbirch_function_("parameter", "src/model/MarkovModel.birch", 62);
}

#line 29 "src/model/MarkovModel.birch"
template<class Parameter,class State>
#line 72 "src/model/MarkovModel.birch"
void birch::type::MarkovModel<Parameter, State>::initial(const State& x, const Parameter& _u0952, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_) {
  #line 72 "src/model/MarkovModel.birch"
  libbirch_function_("initial", "src/model/MarkovModel.birch", 72);
}

#line 29 "src/model/MarkovModel.birch"
template<class Parameter,class State>
#line 83 "src/model/MarkovModel.birch"
void birch::type::MarkovModel<Parameter, State>::transition(const State& x, const State& u, const Parameter& _u0952, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_) {
  #line 83 "src/model/MarkovModel.birch"
  libbirch_function_("transition", "src/model/MarkovModel.birch", 83);
}

#line 29 "src/model/MarkovModel.birch"
template<class Parameter,class State>
#line 87 "src/model/MarkovModel.birch"
void birch::type::MarkovModel<Parameter, State>::read(const libbirch::Lazy<libbirch::Shared<birch::type::Buffer>>& buffer, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_) {
  #line 87 "src/model/MarkovModel.birch"
  libbirch_function_("read", "src/model/MarkovModel.birch", 87);
  #line 88 "src/model/MarkovModel.birch"
  libbirch_line_(88);
  #line 88 "src/model/MarkovModel.birch"
  this_()->super_type_::read(buffer, handler_);
  #line 89 "src/model/MarkovModel.birch"
  libbirch_line_(89);
  #line 89 "src/model/MarkovModel.birch"
  buffer->get(birch::type::String("θ"), this_()->_u0952, handler_);
  #line 90 "src/model/MarkovModel.birch"
  libbirch_line_(90);
  #line 90 "src/model/MarkovModel.birch"
  buffer->get(birch::type::String("x"), this_()->x, handler_);
}

#line 29 "src/model/MarkovModel.birch"
template<class Parameter,class State>
#line 93 "src/model/MarkovModel.birch"
void birch::type::MarkovModel<Parameter, State>::write(const libbirch::Lazy<libbirch::Shared<birch::type::Buffer>>& buffer, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_) {
  #line 93 "src/model/MarkovModel.birch"
  libbirch_function_("write", "src/model/MarkovModel.birch", 93);
  #line 94 "src/model/MarkovModel.birch"
  libbirch_line_(94);
  #line 94 "src/model/MarkovModel.birch"
  this_()->super_type_::write(buffer, handler_);
  #line 95 "src/model/MarkovModel.birch"
  libbirch_line_(95);
  #line 95 "src/model/MarkovModel.birch"
  buffer->set(birch::type::String("θ"), this_()->_u0952, handler_);
  #line 96 "src/model/MarkovModel.birch"
  libbirch_line_(96);
  #line 96 "src/model/MarkovModel.birch"
  buffer->set(birch::type::String("x"), this_()->x, handler_);
}

#line 6 "src/record/AssumeRecord.birch"
template<class Value>
#line 6 "src/record/AssumeRecord.birch"
birch::type::AssumeRecord<Value>::AssumeRecord(const libbirch::Lazy<libbirch::Shared<birch::type::Random<Value>>>& x, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_) :
    #line 6 "src/record/AssumeRecord.birch"
    super_type_(),
    #line 10 "src/record/AssumeRecord.birch"
    x(x) {
  //
}

#line 6 "src/record/ObserveRecord.birch"
template<class Value>
#line 6 "src/record/ObserveRecord.birch"
birch::type::ObserveRecord<Value>::ObserveRecord(const Value& x, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_) :
    #line 6 "src/record/ObserveRecord.birch"
    super_type_(),
    #line 10 "src/record/ObserveRecord.birch"
    x(x) {
  //
}

#line 6 "src/record/SimulateRecord.birch"
template<class Value>
#line 6 "src/record/SimulateRecord.birch"
birch::type::SimulateRecord<Value>::SimulateRecord(const Value& x, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_) :
    #line 6 "src/record/SimulateRecord.birch"
    super_type_(),
    #line 10 "src/record/SimulateRecord.birch"
    x(x) {
  //
}

#line 1 "src/transform/TransformDot.birch"
template<class Value>
#line 1 "src/transform/TransformDot.birch"
birch::type::TransformDot<Value>::TransformDot(const libbirch::Lazy<libbirch::Shared<birch::type::Expression<libbirch::DefaultArray<birch::type::Real,1>>>>& a, const Value& x, const libbirch::Lazy<libbirch::Shared<birch::type::Expression<birch::type::Real>>>& c, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_) :
    #line 1 "src/transform/TransformDot.birch"
    super_type_(),
    #line 12 "src/transform/TransformDot.birch"
    a(a),
    #line 17 "src/transform/TransformDot.birch"
    x(x),
    #line 22 "src/transform/TransformDot.birch"
    c(c) {
  //
}

#line 1 "src/transform/TransformDot.birch"
template<class Value>
#line 24 "src/transform/TransformDot.birch"
void birch::type::TransformDot<Value>::multiply(const libbirch::Lazy<libbirch::Shared<birch::type::Expression<birch::type::Real>>>& y, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_) {
  #line 24 "src/transform/TransformDot.birch"
  libbirch_function_("multiply", "src/transform/TransformDot.birch", 24);
  #line 25 "src/transform/TransformDot.birch"
  libbirch_line_(25);
  #line 25 "src/transform/TransformDot.birch"
  this_()->a = this_()->a * y;
  #line 26 "src/transform/TransformDot.birch"
  libbirch_line_(26);
  #line 26 "src/transform/TransformDot.birch"
  this_()->c = this_()->c * y;
}

#line 1 "src/transform/TransformDot.birch"
template<class Value>
#line 29 "src/transform/TransformDot.birch"
void birch::type::TransformDot<Value>::divide(const libbirch::Lazy<libbirch::Shared<birch::type::Expression<birch::type::Real>>>& y, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_) {
  #line 29 "src/transform/TransformDot.birch"
  libbirch_function_("divide", "src/transform/TransformDot.birch", 29);
  #line 30 "src/transform/TransformDot.birch"
  libbirch_line_(30);
  #line 30 "src/transform/TransformDot.birch"
  this_()->a = this_()->a / y;
  #line 31 "src/transform/TransformDot.birch"
  libbirch_line_(31);
  #line 31 "src/transform/TransformDot.birch"
  this_()->c = this_()->c / y;
}

#line 1 "src/transform/TransformDot.birch"
template<class Value>
#line 34 "src/transform/TransformDot.birch"
void birch::type::TransformDot<Value>::add(const libbirch::Lazy<libbirch::Shared<birch::type::Expression<birch::type::Real>>>& y, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_) {
  #line 34 "src/transform/TransformDot.birch"
  libbirch_function_("add", "src/transform/TransformDot.birch", 34);
  #line 35 "src/transform/TransformDot.birch"
  libbirch_line_(35);
  #line 35 "src/transform/TransformDot.birch"
  this_()->c = this_()->c + y;
}

#line 1 "src/transform/TransformDot.birch"
template<class Value>
#line 38 "src/transform/TransformDot.birch"
void birch::type::TransformDot<Value>::subtract(const libbirch::Lazy<libbirch::Shared<birch::type::Expression<birch::type::Real>>>& y, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_) {
  #line 38 "src/transform/TransformDot.birch"
  libbirch_function_("subtract", "src/transform/TransformDot.birch", 38);
  #line 39 "src/transform/TransformDot.birch"
  libbirch_line_(39);
  #line 39 "src/transform/TransformDot.birch"
  this_()->c = this_()->c - y;
}

#line 1 "src/transform/TransformDot.birch"
template<class Value>
#line 42 "src/transform/TransformDot.birch"
void birch::type::TransformDot<Value>::negate(const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_) {
  #line 42 "src/transform/TransformDot.birch"
  libbirch_function_("negate", "src/transform/TransformDot.birch", 42);
  #line 43 "src/transform/TransformDot.birch"
  libbirch_line_(43);
  #line 43 "src/transform/TransformDot.birch"
  this_()->a = -this_()->a;
  #line 44 "src/transform/TransformDot.birch"
  libbirch_line_(44);
  #line 44 "src/transform/TransformDot.birch"
  this_()->c = -this_()->c;
}

#line 1 "src/transform/TransformDot.birch"
template<class Value>
#line 47 "src/transform/TransformDot.birch"
void birch::type::TransformDot<Value>::negateAndAdd(const libbirch::Lazy<libbirch::Shared<birch::type::Expression<birch::type::Real>>>& y, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_) {
  #line 47 "src/transform/TransformDot.birch"
  libbirch_function_("negateAndAdd", "src/transform/TransformDot.birch", 47);
  #line 48 "src/transform/TransformDot.birch"
  libbirch_line_(48);
  #line 48 "src/transform/TransformDot.birch"
  this_()->a = -this_()->a;
  #line 49 "src/transform/TransformDot.birch"
  libbirch_line_(49);
  #line 49 "src/transform/TransformDot.birch"
  this_()->c = y - this_()->c;
}

#line 1 "src/transform/TransformDotMultivariate.birch"
template<class Value>
#line 1 "src/transform/TransformDotMultivariate.birch"
birch::type::TransformDotMultivariate<Value>::TransformDotMultivariate(const libbirch::Lazy<libbirch::Shared<birch::type::Expression<libbirch::DefaultArray<birch::type::Real,1>>>>& a, const Value& X, const libbirch::Lazy<libbirch::Shared<birch::type::Expression<libbirch::DefaultArray<birch::type::Real,1>>>>& c, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_) :
    #line 1 "src/transform/TransformDotMultivariate.birch"
    super_type_(),
    #line 12 "src/transform/TransformDotMultivariate.birch"
    a(a),
    #line 17 "src/transform/TransformDotMultivariate.birch"
    X(X),
    #line 22 "src/transform/TransformDotMultivariate.birch"
    c(c) {
  //
}

#line 1 "src/transform/TransformDotMultivariate.birch"
template<class Value>
#line 24 "src/transform/TransformDotMultivariate.birch"
void birch::type::TransformDotMultivariate<Value>::multiply(const libbirch::Lazy<libbirch::Shared<birch::type::Expression<birch::type::Real>>>& y, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_) {
  #line 24 "src/transform/TransformDotMultivariate.birch"
  libbirch_function_("multiply", "src/transform/TransformDotMultivariate.birch", 24);
  #line 25 "src/transform/TransformDotMultivariate.birch"
  libbirch_line_(25);
  #line 25 "src/transform/TransformDotMultivariate.birch"
  this_()->a = this_()->a * y;
  #line 26 "src/transform/TransformDotMultivariate.birch"
  libbirch_line_(26);
  #line 26 "src/transform/TransformDotMultivariate.birch"
  this_()->c = this_()->c * y;
}

#line 1 "src/transform/TransformDotMultivariate.birch"
template<class Value>
#line 29 "src/transform/TransformDotMultivariate.birch"
void birch::type::TransformDotMultivariate<Value>::divide(const libbirch::Lazy<libbirch::Shared<birch::type::Expression<birch::type::Real>>>& y, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_) {
  #line 29 "src/transform/TransformDotMultivariate.birch"
  libbirch_function_("divide", "src/transform/TransformDotMultivariate.birch", 29);
  #line 30 "src/transform/TransformDotMultivariate.birch"
  libbirch_line_(30);
  #line 30 "src/transform/TransformDotMultivariate.birch"
  this_()->a = this_()->a / y;
  #line 31 "src/transform/TransformDotMultivariate.birch"
  libbirch_line_(31);
  #line 31 "src/transform/TransformDotMultivariate.birch"
  this_()->c = this_()->c / y;
}

#line 1 "src/transform/TransformDotMultivariate.birch"
template<class Value>
#line 34 "src/transform/TransformDotMultivariate.birch"
void birch::type::TransformDotMultivariate<Value>::add(const libbirch::Lazy<libbirch::Shared<birch::type::Expression<libbirch::DefaultArray<birch::type::Real,1>>>>& y, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_) {
  #line 34 "src/transform/TransformDotMultivariate.birch"
  libbirch_function_("add", "src/transform/TransformDotMultivariate.birch", 34);
  #line 35 "src/transform/TransformDotMultivariate.birch"
  libbirch_line_(35);
  #line 35 "src/transform/TransformDotMultivariate.birch"
  this_()->c = this_()->c + y;
}

#line 1 "src/transform/TransformDotMultivariate.birch"
template<class Value>
#line 38 "src/transform/TransformDotMultivariate.birch"
void birch::type::TransformDotMultivariate<Value>::subtract(const libbirch::Lazy<libbirch::Shared<birch::type::Expression<libbirch::DefaultArray<birch::type::Real,1>>>>& y, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_) {
  #line 38 "src/transform/TransformDotMultivariate.birch"
  libbirch_function_("subtract", "src/transform/TransformDotMultivariate.birch", 38);
  #line 39 "src/transform/TransformDotMultivariate.birch"
  libbirch_line_(39);
  #line 39 "src/transform/TransformDotMultivariate.birch"
  this_()->c = this_()->c - y;
}

#line 1 "src/transform/TransformDotMultivariate.birch"
template<class Value>
#line 42 "src/transform/TransformDotMultivariate.birch"
void birch::type::TransformDotMultivariate<Value>::negate(const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_) {
  #line 42 "src/transform/TransformDotMultivariate.birch"
  libbirch_function_("negate", "src/transform/TransformDotMultivariate.birch", 42);
  #line 43 "src/transform/TransformDotMultivariate.birch"
  libbirch_line_(43);
  #line 43 "src/transform/TransformDotMultivariate.birch"
  this_()->a = -this_()->a;
  #line 44 "src/transform/TransformDotMultivariate.birch"
  libbirch_line_(44);
  #line 44 "src/transform/TransformDotMultivariate.birch"
  this_()->c = -this_()->c;
}

#line 1 "src/transform/TransformDotMultivariate.birch"
template<class Value>
#line 47 "src/transform/TransformDotMultivariate.birch"
void birch::type::TransformDotMultivariate<Value>::negateAndAdd(const libbirch::Lazy<libbirch::Shared<birch::type::Expression<libbirch::DefaultArray<birch::type::Real,1>>>>& y, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_) {
  #line 47 "src/transform/TransformDotMultivariate.birch"
  libbirch_function_("negateAndAdd", "src/transform/TransformDotMultivariate.birch", 47);
  #line 48 "src/transform/TransformDotMultivariate.birch"
  libbirch_line_(48);
  #line 48 "src/transform/TransformDotMultivariate.birch"
  this_()->a = -this_()->a;
  #line 49 "src/transform/TransformDotMultivariate.birch"
  libbirch_line_(49);
  #line 49 "src/transform/TransformDotMultivariate.birch"
  this_()->c = y - this_()->c;
}

#line 1 "src/transform/TransformLinear.birch"
template<class Value>
#line 1 "src/transform/TransformLinear.birch"
birch::type::TransformLinear<Value>::TransformLinear(const libbirch::Lazy<libbirch::Shared<birch::type::Expression<birch::type::Real>>>& a, const Value& x, const libbirch::Lazy<libbirch::Shared<birch::type::Expression<birch::type::Real>>>& c, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_) :
    #line 1 "src/transform/TransformLinear.birch"
    super_type_(),
    #line 12 "src/transform/TransformLinear.birch"
    a(a),
    #line 17 "src/transform/TransformLinear.birch"
    x(x),
    #line 22 "src/transform/TransformLinear.birch"
    c(c) {
  //
}

#line 1 "src/transform/TransformLinear.birch"
template<class Value>
#line 24 "src/transform/TransformLinear.birch"
void birch::type::TransformLinear<Value>::multiply(const libbirch::Lazy<libbirch::Shared<birch::type::Expression<birch::type::Real>>>& y, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_) {
  #line 24 "src/transform/TransformLinear.birch"
  libbirch_function_("multiply", "src/transform/TransformLinear.birch", 24);
  #line 25 "src/transform/TransformLinear.birch"
  libbirch_line_(25);
  #line 25 "src/transform/TransformLinear.birch"
  this_()->a = y * this_()->a;
  #line 26 "src/transform/TransformLinear.birch"
  libbirch_line_(26);
  #line 26 "src/transform/TransformLinear.birch"
  this_()->c = y * this_()->c;
}

#line 1 "src/transform/TransformLinear.birch"
template<class Value>
#line 29 "src/transform/TransformLinear.birch"
void birch::type::TransformLinear<Value>::divide(const libbirch::Lazy<libbirch::Shared<birch::type::Expression<birch::type::Real>>>& y, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_) {
  #line 29 "src/transform/TransformLinear.birch"
  libbirch_function_("divide", "src/transform/TransformLinear.birch", 29);
  #line 30 "src/transform/TransformLinear.birch"
  libbirch_line_(30);
  #line 30 "src/transform/TransformLinear.birch"
  this_()->a = this_()->a / y;
  #line 31 "src/transform/TransformLinear.birch"
  libbirch_line_(31);
  #line 31 "src/transform/TransformLinear.birch"
  this_()->c = this_()->c / y;
}

#line 1 "src/transform/TransformLinear.birch"
template<class Value>
#line 34 "src/transform/TransformLinear.birch"
void birch::type::TransformLinear<Value>::add(const libbirch::Lazy<libbirch::Shared<birch::type::Expression<birch::type::Real>>>& y, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_) {
  #line 34 "src/transform/TransformLinear.birch"
  libbirch_function_("add", "src/transform/TransformLinear.birch", 34);
  #line 35 "src/transform/TransformLinear.birch"
  libbirch_line_(35);
  #line 35 "src/transform/TransformLinear.birch"
  this_()->c = this_()->c + y;
}

#line 1 "src/transform/TransformLinear.birch"
template<class Value>
#line 38 "src/transform/TransformLinear.birch"
void birch::type::TransformLinear<Value>::subtract(const libbirch::Lazy<libbirch::Shared<birch::type::Expression<birch::type::Real>>>& y, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_) {
  #line 38 "src/transform/TransformLinear.birch"
  libbirch_function_("subtract", "src/transform/TransformLinear.birch", 38);
  #line 39 "src/transform/TransformLinear.birch"
  libbirch_line_(39);
  #line 39 "src/transform/TransformLinear.birch"
  this_()->c = this_()->c - y;
}

#line 1 "src/transform/TransformLinear.birch"
template<class Value>
#line 42 "src/transform/TransformLinear.birch"
void birch::type::TransformLinear<Value>::negate(const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_) {
  #line 42 "src/transform/TransformLinear.birch"
  libbirch_function_("negate", "src/transform/TransformLinear.birch", 42);
  #line 43 "src/transform/TransformLinear.birch"
  libbirch_line_(43);
  #line 43 "src/transform/TransformLinear.birch"
  this_()->a = -this_()->a;
  #line 44 "src/transform/TransformLinear.birch"
  libbirch_line_(44);
  #line 44 "src/transform/TransformLinear.birch"
  this_()->c = -this_()->c;
}

#line 1 "src/transform/TransformLinear.birch"
template<class Value>
#line 47 "src/transform/TransformLinear.birch"
void birch::type::TransformLinear<Value>::negateAndAdd(const libbirch::Lazy<libbirch::Shared<birch::type::Expression<birch::type::Real>>>& y, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_) {
  #line 47 "src/transform/TransformLinear.birch"
  libbirch_function_("negateAndAdd", "src/transform/TransformLinear.birch", 47);
  #line 48 "src/transform/TransformLinear.birch"
  libbirch_line_(48);
  #line 48 "src/transform/TransformLinear.birch"
  this_()->a = -this_()->a;
  #line 49 "src/transform/TransformLinear.birch"
  libbirch_line_(49);
  #line 49 "src/transform/TransformLinear.birch"
  this_()->c = y - this_()->c;
}

#line 1 "src/transform/TransformLinearMatrix.birch"
template<class Value>
#line 1 "src/transform/TransformLinearMatrix.birch"
birch::type::TransformLinearMatrix<Value>::TransformLinearMatrix(const libbirch::Lazy<libbirch::Shared<birch::type::Expression<libbirch::DefaultArray<birch::type::Real,2>>>>& A, const Value& X, const libbirch::Lazy<libbirch::Shared<birch::type::Expression<libbirch::DefaultArray<birch::type::Real,2>>>>& C, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_) :
    #line 1 "src/transform/TransformLinearMatrix.birch"
    super_type_(),
    #line 12 "src/transform/TransformLinearMatrix.birch"
    A(A),
    #line 17 "src/transform/TransformLinearMatrix.birch"
    X(X),
    #line 22 "src/transform/TransformLinearMatrix.birch"
    C(C) {
  //
}

#line 1 "src/transform/TransformLinearMatrix.birch"
template<class Value>
#line 24 "src/transform/TransformLinearMatrix.birch"
birch::type::Integer birch::type::TransformLinearMatrix<Value>::rows(const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_) {
  #line 24 "src/transform/TransformLinearMatrix.birch"
  libbirch_function_("rows", "src/transform/TransformLinearMatrix.birch", 24);
  #line 25 "src/transform/TransformLinearMatrix.birch"
  libbirch_line_(25);
  #line 25 "src/transform/TransformLinearMatrix.birch"
  return this_()->C->rows(handler_);
}

#line 1 "src/transform/TransformLinearMatrix.birch"
template<class Value>
#line 28 "src/transform/TransformLinearMatrix.birch"
birch::type::Integer birch::type::TransformLinearMatrix<Value>::columns(const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_) {
  #line 28 "src/transform/TransformLinearMatrix.birch"
  libbirch_function_("columns", "src/transform/TransformLinearMatrix.birch", 28);
  #line 29 "src/transform/TransformLinearMatrix.birch"
  libbirch_line_(29);
  #line 29 "src/transform/TransformLinearMatrix.birch"
  return this_()->C->columns(handler_);
}

#line 1 "src/transform/TransformLinearMatrix.birch"
template<class Value>
#line 32 "src/transform/TransformLinearMatrix.birch"
void birch::type::TransformLinearMatrix<Value>::leftMultiply(const libbirch::Lazy<libbirch::Shared<birch::type::Expression<libbirch::DefaultArray<birch::type::Real,2>>>>& Y, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_) {
  #line 32 "src/transform/TransformLinearMatrix.birch"
  libbirch_function_("leftMultiply", "src/transform/TransformLinearMatrix.birch", 32);
  #line 33 "src/transform/TransformLinearMatrix.birch"
  libbirch_line_(33);
  #line 33 "src/transform/TransformLinearMatrix.birch"
  this_()->A = Y * this_()->A;
  #line 34 "src/transform/TransformLinearMatrix.birch"
  libbirch_line_(34);
  #line 34 "src/transform/TransformLinearMatrix.birch"
  this_()->C = Y * this_()->C;
}

#line 1 "src/transform/TransformLinearMatrix.birch"
template<class Value>
#line 37 "src/transform/TransformLinearMatrix.birch"
void birch::type::TransformLinearMatrix<Value>::leftMultiply(const libbirch::Lazy<libbirch::Shared<birch::type::Expression<birch::type::Real>>>& y, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_) {
  #line 37 "src/transform/TransformLinearMatrix.birch"
  libbirch_function_("leftMultiply", "src/transform/TransformLinearMatrix.birch", 37);
  #line 38 "src/transform/TransformLinearMatrix.birch"
  libbirch_line_(38);
  #line 38 "src/transform/TransformLinearMatrix.birch"
  this_()->A = y * this_()->A;
  #line 39 "src/transform/TransformLinearMatrix.birch"
  libbirch_line_(39);
  #line 39 "src/transform/TransformLinearMatrix.birch"
  this_()->C = y * this_()->C;
}

#line 1 "src/transform/TransformLinearMatrix.birch"
template<class Value>
#line 42 "src/transform/TransformLinearMatrix.birch"
void birch::type::TransformLinearMatrix<Value>::add(const libbirch::Lazy<libbirch::Shared<birch::type::Expression<libbirch::DefaultArray<birch::type::Real,2>>>>& Y, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_) {
  #line 42 "src/transform/TransformLinearMatrix.birch"
  libbirch_function_("add", "src/transform/TransformLinearMatrix.birch", 42);
  #line 43 "src/transform/TransformLinearMatrix.birch"
  libbirch_line_(43);
  #line 43 "src/transform/TransformLinearMatrix.birch"
  this_()->C = this_()->C + Y;
}

#line 1 "src/transform/TransformLinearMatrix.birch"
template<class Value>
#line 46 "src/transform/TransformLinearMatrix.birch"
void birch::type::TransformLinearMatrix<Value>::subtract(const libbirch::Lazy<libbirch::Shared<birch::type::Expression<libbirch::DefaultArray<birch::type::Real,2>>>>& Y, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_) {
  #line 46 "src/transform/TransformLinearMatrix.birch"
  libbirch_function_("subtract", "src/transform/TransformLinearMatrix.birch", 46);
  #line 47 "src/transform/TransformLinearMatrix.birch"
  libbirch_line_(47);
  #line 47 "src/transform/TransformLinearMatrix.birch"
  this_()->C = this_()->C - Y;
}

#line 1 "src/transform/TransformLinearMatrix.birch"
template<class Value>
#line 50 "src/transform/TransformLinearMatrix.birch"
void birch::type::TransformLinearMatrix<Value>::multiply(const libbirch::Lazy<libbirch::Shared<birch::type::Expression<birch::type::Real>>>& y, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_) {
  #line 50 "src/transform/TransformLinearMatrix.birch"
  libbirch_function_("multiply", "src/transform/TransformLinearMatrix.birch", 50);
  #line 51 "src/transform/TransformLinearMatrix.birch"
  libbirch_line_(51);
  #line 51 "src/transform/TransformLinearMatrix.birch"
  this_()->A = this_()->A * y;
  #line 52 "src/transform/TransformLinearMatrix.birch"
  libbirch_line_(52);
  #line 52 "src/transform/TransformLinearMatrix.birch"
  this_()->C = this_()->C * y;
}

#line 1 "src/transform/TransformLinearMatrix.birch"
template<class Value>
#line 55 "src/transform/TransformLinearMatrix.birch"
void birch::type::TransformLinearMatrix<Value>::divide(const libbirch::Lazy<libbirch::Shared<birch::type::Expression<birch::type::Real>>>& y, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_) {
  #line 55 "src/transform/TransformLinearMatrix.birch"
  libbirch_function_("divide", "src/transform/TransformLinearMatrix.birch", 55);
  #line 56 "src/transform/TransformLinearMatrix.birch"
  libbirch_line_(56);
  #line 56 "src/transform/TransformLinearMatrix.birch"
  this_()->A = this_()->A / y;
  #line 57 "src/transform/TransformLinearMatrix.birch"
  libbirch_line_(57);
  #line 57 "src/transform/TransformLinearMatrix.birch"
  this_()->C = this_()->C / y;
}

#line 1 "src/transform/TransformLinearMatrix.birch"
template<class Value>
#line 60 "src/transform/TransformLinearMatrix.birch"
void birch::type::TransformLinearMatrix<Value>::negate(const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_) {
  #line 60 "src/transform/TransformLinearMatrix.birch"
  libbirch_function_("negate", "src/transform/TransformLinearMatrix.birch", 60);
  #line 61 "src/transform/TransformLinearMatrix.birch"
  libbirch_line_(61);
  #line 61 "src/transform/TransformLinearMatrix.birch"
  this_()->A = -this_()->A;
  #line 62 "src/transform/TransformLinearMatrix.birch"
  libbirch_line_(62);
  #line 62 "src/transform/TransformLinearMatrix.birch"
  this_()->C = -this_()->C;
}

#line 1 "src/transform/TransformLinearMatrix.birch"
template<class Value>
#line 65 "src/transform/TransformLinearMatrix.birch"
void birch::type::TransformLinearMatrix<Value>::negateAndAdd(const libbirch::Lazy<libbirch::Shared<birch::type::Expression<libbirch::DefaultArray<birch::type::Real,2>>>>& Y, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_) {
  #line 65 "src/transform/TransformLinearMatrix.birch"
  libbirch_function_("negateAndAdd", "src/transform/TransformLinearMatrix.birch", 65);
  #line 66 "src/transform/TransformLinearMatrix.birch"
  libbirch_line_(66);
  #line 66 "src/transform/TransformLinearMatrix.birch"
  this_()->A = -this_()->A;
  #line 67 "src/transform/TransformLinearMatrix.birch"
  libbirch_line_(67);
  #line 67 "src/transform/TransformLinearMatrix.birch"
  this_()->C = Y - this_()->C;
}

#line 1 "src/transform/TransformLinearMultivariate.birch"
template<class Value>
#line 1 "src/transform/TransformLinearMultivariate.birch"
birch::type::TransformLinearMultivariate<Value>::TransformLinearMultivariate(const libbirch::Lazy<libbirch::Shared<birch::type::Expression<libbirch::DefaultArray<birch::type::Real,2>>>>& A, const Value& x, const libbirch::Lazy<libbirch::Shared<birch::type::Expression<libbirch::DefaultArray<birch::type::Real,1>>>>& c, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_) :
    #line 1 "src/transform/TransformLinearMultivariate.birch"
    super_type_(),
    #line 12 "src/transform/TransformLinearMultivariate.birch"
    A(A),
    #line 17 "src/transform/TransformLinearMultivariate.birch"
    x(x),
    #line 22 "src/transform/TransformLinearMultivariate.birch"
    c(c) {
  //
}

#line 1 "src/transform/TransformLinearMultivariate.birch"
template<class Value>
#line 24 "src/transform/TransformLinearMultivariate.birch"
birch::type::Integer birch::type::TransformLinearMultivariate<Value>::rows(const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_) {
  #line 24 "src/transform/TransformLinearMultivariate.birch"
  libbirch_function_("rows", "src/transform/TransformLinearMultivariate.birch", 24);
  #line 25 "src/transform/TransformLinearMultivariate.birch"
  libbirch_line_(25);
  #line 25 "src/transform/TransformLinearMultivariate.birch"
  return birch::rows(this_()->A, handler_);
}

#line 1 "src/transform/TransformLinearMultivariate.birch"
template<class Value>
#line 28 "src/transform/TransformLinearMultivariate.birch"
void birch::type::TransformLinearMultivariate<Value>::leftMultiply(const libbirch::Lazy<libbirch::Shared<birch::type::Expression<libbirch::DefaultArray<birch::type::Real,2>>>>& Y, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_) {
  #line 28 "src/transform/TransformLinearMultivariate.birch"
  libbirch_function_("leftMultiply", "src/transform/TransformLinearMultivariate.birch", 28);
  #line 29 "src/transform/TransformLinearMultivariate.birch"
  libbirch_line_(29);
  #line 29 "src/transform/TransformLinearMultivariate.birch"
  this_()->A = Y * this_()->A;
  #line 30 "src/transform/TransformLinearMultivariate.birch"
  libbirch_line_(30);
  #line 30 "src/transform/TransformLinearMultivariate.birch"
  this_()->c = Y * this_()->c;
}

#line 1 "src/transform/TransformLinearMultivariate.birch"
template<class Value>
#line 33 "src/transform/TransformLinearMultivariate.birch"
void birch::type::TransformLinearMultivariate<Value>::leftMultiply(const libbirch::Lazy<libbirch::Shared<birch::type::Expression<birch::type::Real>>>& y, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_) {
  #line 33 "src/transform/TransformLinearMultivariate.birch"
  libbirch_function_("leftMultiply", "src/transform/TransformLinearMultivariate.birch", 33);
  #line 34 "src/transform/TransformLinearMultivariate.birch"
  libbirch_line_(34);
  #line 34 "src/transform/TransformLinearMultivariate.birch"
  this_()->A = y * this_()->A;
  #line 35 "src/transform/TransformLinearMultivariate.birch"
  libbirch_line_(35);
  #line 35 "src/transform/TransformLinearMultivariate.birch"
  this_()->c = y * this_()->c;
}

#line 1 "src/transform/TransformLinearMultivariate.birch"
template<class Value>
#line 38 "src/transform/TransformLinearMultivariate.birch"
void birch::type::TransformLinearMultivariate<Value>::add(const libbirch::Lazy<libbirch::Shared<birch::type::Expression<libbirch::DefaultArray<birch::type::Real,1>>>>& y, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_) {
  #line 38 "src/transform/TransformLinearMultivariate.birch"
  libbirch_function_("add", "src/transform/TransformLinearMultivariate.birch", 38);
  #line 39 "src/transform/TransformLinearMultivariate.birch"
  libbirch_line_(39);
  #line 39 "src/transform/TransformLinearMultivariate.birch"
  this_()->c = this_()->c + y;
}

#line 1 "src/transform/TransformLinearMultivariate.birch"
template<class Value>
#line 42 "src/transform/TransformLinearMultivariate.birch"
void birch::type::TransformLinearMultivariate<Value>::subtract(const libbirch::Lazy<libbirch::Shared<birch::type::Expression<libbirch::DefaultArray<birch::type::Real,1>>>>& y, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_) {
  #line 42 "src/transform/TransformLinearMultivariate.birch"
  libbirch_function_("subtract", "src/transform/TransformLinearMultivariate.birch", 42);
  #line 43 "src/transform/TransformLinearMultivariate.birch"
  libbirch_line_(43);
  #line 43 "src/transform/TransformLinearMultivariate.birch"
  this_()->c = this_()->c - y;
}

#line 1 "src/transform/TransformLinearMultivariate.birch"
template<class Value>
#line 46 "src/transform/TransformLinearMultivariate.birch"
void birch::type::TransformLinearMultivariate<Value>::multiply(const libbirch::Lazy<libbirch::Shared<birch::type::Expression<birch::type::Real>>>& y, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_) {
  #line 46 "src/transform/TransformLinearMultivariate.birch"
  libbirch_function_("multiply", "src/transform/TransformLinearMultivariate.birch", 46);
  #line 47 "src/transform/TransformLinearMultivariate.birch"
  libbirch_line_(47);
  #line 47 "src/transform/TransformLinearMultivariate.birch"
  this_()->A = this_()->A * y;
  #line 48 "src/transform/TransformLinearMultivariate.birch"
  libbirch_line_(48);
  #line 48 "src/transform/TransformLinearMultivariate.birch"
  this_()->c = this_()->c * y;
}

#line 1 "src/transform/TransformLinearMultivariate.birch"
template<class Value>
#line 51 "src/transform/TransformLinearMultivariate.birch"
void birch::type::TransformLinearMultivariate<Value>::divide(const libbirch::Lazy<libbirch::Shared<birch::type::Expression<birch::type::Real>>>& y, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_) {
  #line 51 "src/transform/TransformLinearMultivariate.birch"
  libbirch_function_("divide", "src/transform/TransformLinearMultivariate.birch", 51);
  #line 52 "src/transform/TransformLinearMultivariate.birch"
  libbirch_line_(52);
  #line 52 "src/transform/TransformLinearMultivariate.birch"
  this_()->A = this_()->A / y;
  #line 53 "src/transform/TransformLinearMultivariate.birch"
  libbirch_line_(53);
  #line 53 "src/transform/TransformLinearMultivariate.birch"
  this_()->c = this_()->c / y;
}

#line 1 "src/transform/TransformLinearMultivariate.birch"
template<class Value>
#line 56 "src/transform/TransformLinearMultivariate.birch"
void birch::type::TransformLinearMultivariate<Value>::negate(const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_) {
  #line 56 "src/transform/TransformLinearMultivariate.birch"
  libbirch_function_("negate", "src/transform/TransformLinearMultivariate.birch", 56);
  #line 57 "src/transform/TransformLinearMultivariate.birch"
  libbirch_line_(57);
  #line 57 "src/transform/TransformLinearMultivariate.birch"
  this_()->A = -this_()->A;
  #line 58 "src/transform/TransformLinearMultivariate.birch"
  libbirch_line_(58);
  #line 58 "src/transform/TransformLinearMultivariate.birch"
  this_()->c = -this_()->c;
}

#line 1 "src/transform/TransformLinearMultivariate.birch"
template<class Value>
#line 61 "src/transform/TransformLinearMultivariate.birch"
void birch::type::TransformLinearMultivariate<Value>::negateAndAdd(const libbirch::Lazy<libbirch::Shared<birch::type::Expression<libbirch::DefaultArray<birch::type::Real,1>>>>& y, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_) {
  #line 61 "src/transform/TransformLinearMultivariate.birch"
  libbirch_function_("negateAndAdd", "src/transform/TransformLinearMultivariate.birch", 61);
  #line 62 "src/transform/TransformLinearMultivariate.birch"
  libbirch_line_(62);
  #line 62 "src/transform/TransformLinearMultivariate.birch"
  this_()->A = -this_()->A;
  #line 63 "src/transform/TransformLinearMultivariate.birch"
  libbirch_line_(63);
  #line 63 "src/transform/TransformLinearMultivariate.birch"
  this_()->c = y - this_()->c;
}

#line 50 "src/container/TapeNode.birch"
template<class Type>
#line 50 "src/container/TapeNode.birch"
libbirch::Lazy<libbirch::Shared<birch::type::TapeNode<Type>>> birch::TapeNode(const Type& x, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_) {
  #line 50 "src/container/TapeNode.birch"
  libbirch_function_("TapeNode", "src/container/TapeNode.birch", 50);
  #line 51 "src/container/TapeNode.birch"
  libbirch_line_(51);
  #line 51 "src/container/TapeNode.birch"
  libbirch::Lazy<libbirch::Shared<birch::type::TapeNode<Type>>> o(x);
  #line 52 "src/container/TapeNode.birch"
  libbirch_line_(52);
  #line 52 "src/container/TapeNode.birch"
  return o;
}

#line 58 "src/container/TapeNode.birch"
template<class Type>
#line 58 "src/container/TapeNode.birch"
libbirch::Lazy<libbirch::Shared<birch::type::TapeNode<Type>>> birch::TapeNode(const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_) {
  #line 58 "src/container/TapeNode.birch"
  libbirch_function_("TapeNode", "src/container/TapeNode.birch", 58);
  #line 59 "src/container/TapeNode.birch"
  libbirch_line_(59);
  #line 59 "src/container/TapeNode.birch"
  auto x = birch::make<Type>(handler_);
  #line 60 "src/container/TapeNode.birch"
  libbirch_line_(60);
  #line 60 "src/container/TapeNode.birch"
  if (!x.query()) {
    #line 61 "src/container/TapeNode.birch"
    libbirch_line_(61);
    #line 61 "src/container/TapeNode.birch"
    birch::error(birch::type::String("element type is not default-constructible"), handler_);
  }
  #line 63 "src/container/TapeNode.birch"
  libbirch_line_(63);
  #line 63 "src/container/TapeNode.birch"
  return birch::TapeNode<Type>(x.get(), handler_);
}

#line 1150 "src/data/Buffer.birch"
template<class Type>
#line 1150 "src/data/Buffer.birch"
libbirch::Lazy<libbirch::Shared<birch::type::Buffer>> birch::Buffer(const Type& root, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_) {
  #line 1150 "src/data/Buffer.birch"
  libbirch_function_("Buffer", "src/data/Buffer.birch", 1150);
  #line 1151 "src/data/Buffer.birch"
  libbirch_line_(1151);
  #line 1151 "src/data/Buffer.birch"
  libbirch::Lazy<libbirch::Shared<birch::type::Buffer>> o;
  #line 1152 "src/data/Buffer.birch"
  libbirch_line_(1152);
  #line 1152 "src/data/Buffer.birch"
  o->set(root, handler_);
  #line 1153 "src/data/Buffer.birch"
  libbirch_line_(1153);
  #line 1153 "src/data/Buffer.birch"
  return o;
}

#line 65 "src/event/AssumeEvent.birch"
template<class Value>
#line 65 "src/event/AssumeEvent.birch"
libbirch::Lazy<libbirch::Shared<birch::type::AssumeEvent<Value>>> birch::AssumeEvent(const libbirch::Lazy<libbirch::Shared<birch::type::Random<Value>>>& x, const libbirch::Lazy<libbirch::Shared<birch::type::Distribution<Value>>>& p, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_) {
  #line 65 "src/event/AssumeEvent.birch"
  libbirch_function_("AssumeEvent", "src/event/AssumeEvent.birch", 65);
  #line 67 "src/event/AssumeEvent.birch"
  libbirch_line_(67);
  #line 67 "src/event/AssumeEvent.birch"
  return birch::construct<libbirch::Lazy<libbirch::Shared<birch::type::AssumeEvent<Value>>>>(x, p, handler_);
}

#line 63 "src/event/ObserveEvent.birch"
template<class Value>
#line 63 "src/event/ObserveEvent.birch"
libbirch::Lazy<libbirch::Shared<birch::type::ObserveEvent<Value>>> birch::ObserveEvent(const Value& x, const libbirch::Lazy<libbirch::Shared<birch::type::Distribution<Value>>>& p, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_) {
  #line 63 "src/event/ObserveEvent.birch"
  libbirch_function_("ObserveEvent", "src/event/ObserveEvent.birch", 63);
  #line 65 "src/event/ObserveEvent.birch"
  libbirch_line_(65);
  #line 65 "src/event/ObserveEvent.birch"
  return birch::construct<libbirch::Lazy<libbirch::Shared<birch::type::ObserveEvent<Value>>>>(x, p, handler_);
}

#line 66 "src/event/SimulateEvent.birch"
template<class Value>
#line 66 "src/event/SimulateEvent.birch"
libbirch::Lazy<libbirch::Shared<birch::type::SimulateEvent<Value>>> birch::SimulateEvent(const libbirch::Lazy<libbirch::Shared<birch::type::Distribution<Value>>>& p, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_) {
  #line 66 "src/event/SimulateEvent.birch"
  libbirch_function_("SimulateEvent", "src/event/SimulateEvent.birch", 66);
  #line 67 "src/event/SimulateEvent.birch"
  libbirch_line_(67);
  #line 67 "src/event/SimulateEvent.birch"
  return birch::construct<libbirch::Lazy<libbirch::Shared<birch::type::SimulateEvent<Value>>>>(p, handler_);
}

#line 66 "src/expression/Boxed.birch"
template<class Value>
#line 66 "src/expression/Boxed.birch"
libbirch::Lazy<libbirch::Shared<birch::type::Expression<Value>>> birch::Boxed(const Value& x, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_) {
  #line 66 "src/expression/Boxed.birch"
  libbirch_function_("Boxed", "src/expression/Boxed.birch", 66);
  #line 67 "src/expression/Boxed.birch"
  libbirch_line_(67);
  #line 67 "src/expression/Boxed.birch"
  return birch::construct<libbirch::Lazy<libbirch::Shared<birch::type::Boxed<Value>>>>(x, handler_);
}

#line 73 "src/expression/Boxed.birch"
template<class Value>
#line 73 "src/expression/Boxed.birch"
libbirch::Lazy<libbirch::Shared<birch::type::Expression<Value>>> birch::box(const Value& x, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_) {
  #line 73 "src/expression/Boxed.birch"
  libbirch_function_("box", "src/expression/Boxed.birch", 73);
  #line 74 "src/expression/Boxed.birch"
  libbirch_line_(74);
  #line 74 "src/expression/Boxed.birch"
  return birch::Boxed(x, handler_);
}

#line 80 "src/expression/Boxed.birch"
template<class Value1,class Value2>
#line 80 "src/expression/Boxed.birch"
libbirch::Tuple<libbirch::Lazy<libbirch::Shared<birch::type::Expression<Value1>>>, libbirch::Lazy<libbirch::Shared<birch::type::Expression<Value2>>>> birch::box(const libbirch::Tuple<Value1, Value2>& x, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_) {
  #line 80 "src/expression/Boxed.birch"
  libbirch_function_("box", "src/expression/Boxed.birch", 80);
  #line 82 "src/expression/Boxed.birch"
  libbirch_line_(82);
  #line 82 "src/expression/Boxed.birch"
  libbirch::Optional<Value1> x1;
  #line 83 "src/expression/Boxed.birch"
  libbirch_line_(83);
  #line 83 "src/expression/Boxed.birch"
  libbirch::Optional<Value2> x2;
  #line 84 "src/expression/Boxed.birch"
  libbirch_line_(84);
  #line 84 "src/expression/Boxed.birch"
  libbirch::tie(x1, x2) = x;
  #line 85 "src/expression/Boxed.birch"
  libbirch_line_(85);
  #line 85 "src/expression/Boxed.birch"
  return libbirch::make_tuple(birch::box(x1.get(), handler_), birch::box(x2.get(), handler_));
}

#line 91 "src/expression/Boxed.birch"
template<class Value1,class Value2,class Value3>
#line 91 "src/expression/Boxed.birch"
libbirch::Tuple<libbirch::Lazy<libbirch::Shared<birch::type::Expression<Value1>>>, libbirch::Lazy<libbirch::Shared<birch::type::Expression<Value2>>>, libbirch::Lazy<libbirch::Shared<birch::type::Expression<Value3>>>> birch::box(const libbirch::Tuple<Value1, Value2, Value3>& x, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_) {
  #line 91 "src/expression/Boxed.birch"
  libbirch_function_("box", "src/expression/Boxed.birch", 91);
  #line 93 "src/expression/Boxed.birch"
  libbirch_line_(93);
  #line 93 "src/expression/Boxed.birch"
  libbirch::Optional<Value1> x1;
  #line 94 "src/expression/Boxed.birch"
  libbirch_line_(94);
  #line 94 "src/expression/Boxed.birch"
  libbirch::Optional<Value2> x2;
  #line 95 "src/expression/Boxed.birch"
  libbirch_line_(95);
  #line 95 "src/expression/Boxed.birch"
  libbirch::Optional<Value3> x3;
  #line 96 "src/expression/Boxed.birch"
  libbirch_line_(96);
  #line 96 "src/expression/Boxed.birch"
  libbirch::tie(x1, x2, x3) = x;
  #line 97 "src/expression/Boxed.birch"
  libbirch_line_(97);
  #line 97 "src/expression/Boxed.birch"
  return libbirch::make_tuple(birch::box(x1.get(), handler_), birch::box(x2.get(), handler_), birch::box(x3.get(), handler_));
}

#line 103 "src/expression/Boxed.birch"
template<class Value1,class Value2,class Value3,class Value4>
#line 103 "src/expression/Boxed.birch"
libbirch::Tuple<libbirch::Lazy<libbirch::Shared<birch::type::Expression<Value1>>>, libbirch::Lazy<libbirch::Shared<birch::type::Expression<Value2>>>, libbirch::Lazy<libbirch::Shared<birch::type::Expression<Value3>>>, libbirch::Lazy<libbirch::Shared<birch::type::Expression<Value4>>>> birch::box(const libbirch::Tuple<Value1, Value2, Value3, Value4>& x, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_) {
  #line 103 "src/expression/Boxed.birch"
  libbirch_function_("box", "src/expression/Boxed.birch", 103);
  #line 105 "src/expression/Boxed.birch"
  libbirch_line_(105);
  #line 105 "src/expression/Boxed.birch"
  libbirch::Optional<Value1> x1;
  #line 106 "src/expression/Boxed.birch"
  libbirch_line_(106);
  #line 106 "src/expression/Boxed.birch"
  libbirch::Optional<Value2> x2;
  #line 107 "src/expression/Boxed.birch"
  libbirch_line_(107);
  #line 107 "src/expression/Boxed.birch"
  libbirch::Optional<Value3> x3;
  #line 108 "src/expression/Boxed.birch"
  libbirch_line_(108);
  #line 108 "src/expression/Boxed.birch"
  libbirch::Optional<Value4> x4;
  #line 109 "src/expression/Boxed.birch"
  libbirch_line_(109);
  #line 109 "src/expression/Boxed.birch"
  libbirch::tie(x1, x2, x3, x4) = x;
  #line 110 "src/expression/Boxed.birch"
  libbirch_line_(110);
  #line 110 "src/expression/Boxed.birch"
  return libbirch::make_tuple(birch::box(x1.get(), handler_), birch::box(x2.get(), handler_), birch::box(x3.get(), handler_), birch::box(x4.get(), handler_));
}

#line 116 "src/expression/Boxed.birch"
template<class Value1,class Value2,class Value3,class Value4,class Value5>
#line 116 "src/expression/Boxed.birch"
libbirch::Tuple<libbirch::Lazy<libbirch::Shared<birch::type::Expression<Value1>>>, libbirch::Lazy<libbirch::Shared<birch::type::Expression<Value2>>>, libbirch::Lazy<libbirch::Shared<birch::type::Expression<Value3>>>, libbirch::Lazy<libbirch::Shared<birch::type::Expression<Value4>>>, libbirch::Lazy<libbirch::Shared<birch::type::Expression<Value5>>>> birch::box(const libbirch::Tuple<Value1, Value2, Value3, Value4, Value5>& x, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_) {
  #line 116 "src/expression/Boxed.birch"
  libbirch_function_("box", "src/expression/Boxed.birch", 116);
  #line 118 "src/expression/Boxed.birch"
  libbirch_line_(118);
  #line 118 "src/expression/Boxed.birch"
  libbirch::Optional<Value1> x1;
  #line 119 "src/expression/Boxed.birch"
  libbirch_line_(119);
  #line 119 "src/expression/Boxed.birch"
  libbirch::Optional<Value2> x2;
  #line 120 "src/expression/Boxed.birch"
  libbirch_line_(120);
  #line 120 "src/expression/Boxed.birch"
  libbirch::Optional<Value3> x3;
  #line 121 "src/expression/Boxed.birch"
  libbirch_line_(121);
  #line 121 "src/expression/Boxed.birch"
  libbirch::Optional<Value4> x4;
  #line 122 "src/expression/Boxed.birch"
  libbirch_line_(122);
  #line 122 "src/expression/Boxed.birch"
  libbirch::Optional<Value5> x5;
  #line 123 "src/expression/Boxed.birch"
  libbirch_line_(123);
  #line 123 "src/expression/Boxed.birch"
  libbirch::tie(x1, x2, x3, x4, x5) = x;
  #line 124 "src/expression/Boxed.birch"
  libbirch_line_(124);
  #line 124 "src/expression/Boxed.birch"
  return libbirch::make_tuple(birch::box(x1.get(), handler_), birch::box(x2.get(), handler_), birch::box(x3.get(), handler_), birch::box(x4.get(), handler_), birch::box(x5.get(), handler_));
}

#line 130 "src/expression/Boxed.birch"
template<class Value1,class Value2,class Value3,class Value4,class Value5,class Value6>
#line 130 "src/expression/Boxed.birch"
libbirch::Tuple<libbirch::Lazy<libbirch::Shared<birch::type::Expression<Value1>>>, libbirch::Lazy<libbirch::Shared<birch::type::Expression<Value2>>>, libbirch::Lazy<libbirch::Shared<birch::type::Expression<Value3>>>, libbirch::Lazy<libbirch::Shared<birch::type::Expression<Value4>>>, libbirch::Lazy<libbirch::Shared<birch::type::Expression<Value5>>>, libbirch::Lazy<libbirch::Shared<birch::type::Expression<Value6>>>> birch::box(const libbirch::Tuple<Value1, Value2, Value3, Value4, Value5, Value6>& x, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_) {
  #line 130 "src/expression/Boxed.birch"
  libbirch_function_("box", "src/expression/Boxed.birch", 130);
  #line 132 "src/expression/Boxed.birch"
  libbirch_line_(132);
  #line 132 "src/expression/Boxed.birch"
  libbirch::Optional<Value1> x1;
  #line 133 "src/expression/Boxed.birch"
  libbirch_line_(133);
  #line 133 "src/expression/Boxed.birch"
  libbirch::Optional<Value2> x2;
  #line 134 "src/expression/Boxed.birch"
  libbirch_line_(134);
  #line 134 "src/expression/Boxed.birch"
  libbirch::Optional<Value3> x3;
  #line 135 "src/expression/Boxed.birch"
  libbirch_line_(135);
  #line 135 "src/expression/Boxed.birch"
  libbirch::Optional<Value4> x4;
  #line 136 "src/expression/Boxed.birch"
  libbirch_line_(136);
  #line 136 "src/expression/Boxed.birch"
  libbirch::Optional<Value5> x5;
  #line 137 "src/expression/Boxed.birch"
  libbirch_line_(137);
  #line 137 "src/expression/Boxed.birch"
  libbirch::Optional<Value6> x6;
  #line 138 "src/expression/Boxed.birch"
  libbirch_line_(138);
  #line 138 "src/expression/Boxed.birch"
  libbirch::tie(x1, x2, x3, x4, x5, x6) = x;
  #line 139 "src/expression/Boxed.birch"
  libbirch_line_(139);
  #line 139 "src/expression/Boxed.birch"
  return libbirch::make_tuple(birch::box(x1.get(), handler_), birch::box(x2.get(), handler_), birch::box(x3.get(), handler_), birch::box(x4.get(), handler_), birch::box(x5.get(), handler_), birch::box(x6.get(), handler_));
}

#line 145 "src/expression/Boxed.birch"
template<class Value1,class Value2,class Value3,class Value4,class Value5,class Value6,class Value7>
#line 145 "src/expression/Boxed.birch"
libbirch::Tuple<libbirch::Lazy<libbirch::Shared<birch::type::Expression<Value1>>>, libbirch::Lazy<libbirch::Shared<birch::type::Expression<Value2>>>, libbirch::Lazy<libbirch::Shared<birch::type::Expression<Value3>>>, libbirch::Lazy<libbirch::Shared<birch::type::Expression<Value4>>>, libbirch::Lazy<libbirch::Shared<birch::type::Expression<Value5>>>, libbirch::Lazy<libbirch::Shared<birch::type::Expression<Value6>>>, libbirch::Lazy<libbirch::Shared<birch::type::Expression<Value7>>>> birch::box(const libbirch::Tuple<Value1, Value2, Value3, Value4, Value5, Value6, Value7>& x, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_) {
  #line 145 "src/expression/Boxed.birch"
  libbirch_function_("box", "src/expression/Boxed.birch", 145);
  #line 147 "src/expression/Boxed.birch"
  libbirch_line_(147);
  #line 147 "src/expression/Boxed.birch"
  libbirch::Optional<Value1> x1;
  #line 148 "src/expression/Boxed.birch"
  libbirch_line_(148);
  #line 148 "src/expression/Boxed.birch"
  libbirch::Optional<Value2> x2;
  #line 149 "src/expression/Boxed.birch"
  libbirch_line_(149);
  #line 149 "src/expression/Boxed.birch"
  libbirch::Optional<Value3> x3;
  #line 150 "src/expression/Boxed.birch"
  libbirch_line_(150);
  #line 150 "src/expression/Boxed.birch"
  libbirch::Optional<Value4> x4;
  #line 151 "src/expression/Boxed.birch"
  libbirch_line_(151);
  #line 151 "src/expression/Boxed.birch"
  libbirch::Optional<Value5> x5;
  #line 152 "src/expression/Boxed.birch"
  libbirch_line_(152);
  #line 152 "src/expression/Boxed.birch"
  libbirch::Optional<Value6> x6;
  #line 153 "src/expression/Boxed.birch"
  libbirch_line_(153);
  #line 153 "src/expression/Boxed.birch"
  libbirch::Optional<Value7> x7;
  #line 154 "src/expression/Boxed.birch"
  libbirch_line_(154);
  #line 154 "src/expression/Boxed.birch"
  libbirch::tie(x1, x2, x3, x4, x5, x6, x7) = x;
  #line 155 "src/expression/Boxed.birch"
  libbirch_line_(155);
  #line 155 "src/expression/Boxed.birch"
  return libbirch::make_tuple(birch::box(x1.get(), handler_), birch::box(x2.get(), handler_), birch::box(x3.get(), handler_), birch::box(x4.get(), handler_), birch::box(x5.get(), handler_), birch::box(x6.get(), handler_), birch::box(x7.get(), handler_));
}

#line 161 "src/expression/Boxed.birch"
template<class Value1,class Value2,class Value3,class Value4,class Value5,class Value6,class Value7,class Value8>
#line 161 "src/expression/Boxed.birch"
libbirch::Tuple<libbirch::Lazy<libbirch::Shared<birch::type::Expression<Value1>>>, libbirch::Lazy<libbirch::Shared<birch::type::Expression<Value2>>>, libbirch::Lazy<libbirch::Shared<birch::type::Expression<Value3>>>, libbirch::Lazy<libbirch::Shared<birch::type::Expression<Value4>>>, libbirch::Lazy<libbirch::Shared<birch::type::Expression<Value5>>>, libbirch::Lazy<libbirch::Shared<birch::type::Expression<Value6>>>, libbirch::Lazy<libbirch::Shared<birch::type::Expression<Value7>>>, libbirch::Lazy<libbirch::Shared<birch::type::Expression<Value8>>>> birch::box(const libbirch::Tuple<Value1, Value2, Value3, Value4, Value5, Value6, Value7, Value8>& x, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_) {
  #line 161 "src/expression/Boxed.birch"
  libbirch_function_("box", "src/expression/Boxed.birch", 161);
  #line 163 "src/expression/Boxed.birch"
  libbirch_line_(163);
  #line 163 "src/expression/Boxed.birch"
  libbirch::Optional<Value1> x1;
  #line 164 "src/expression/Boxed.birch"
  libbirch_line_(164);
  #line 164 "src/expression/Boxed.birch"
  libbirch::Optional<Value2> x2;
  #line 165 "src/expression/Boxed.birch"
  libbirch_line_(165);
  #line 165 "src/expression/Boxed.birch"
  libbirch::Optional<Value3> x3;
  #line 166 "src/expression/Boxed.birch"
  libbirch_line_(166);
  #line 166 "src/expression/Boxed.birch"
  libbirch::Optional<Value4> x4;
  #line 167 "src/expression/Boxed.birch"
  libbirch_line_(167);
  #line 167 "src/expression/Boxed.birch"
  libbirch::Optional<Value5> x5;
  #line 168 "src/expression/Boxed.birch"
  libbirch_line_(168);
  #line 168 "src/expression/Boxed.birch"
  libbirch::Optional<Value6> x6;
  #line 169 "src/expression/Boxed.birch"
  libbirch_line_(169);
  #line 169 "src/expression/Boxed.birch"
  libbirch::Optional<Value7> x7;
  #line 170 "src/expression/Boxed.birch"
  libbirch_line_(170);
  #line 170 "src/expression/Boxed.birch"
  libbirch::Optional<Value8> x8;
  #line 171 "src/expression/Boxed.birch"
  libbirch_line_(171);
  #line 171 "src/expression/Boxed.birch"
  libbirch::tie(x1, x2, x3, x4, x5, x6, x7, x8) = x;
  #line 172 "src/expression/Boxed.birch"
  libbirch_line_(172);
  #line 172 "src/expression/Boxed.birch"
  return libbirch::make_tuple(birch::box(x1.get(), handler_), birch::box(x2.get(), handler_), birch::box(x3.get(), handler_), birch::box(x4.get(), handler_), birch::box(x5.get(), handler_), birch::box(x6.get(), handler_), birch::box(x7.get(), handler_), birch::box(x8.get(), handler_));
}

#line 110 "src/expression/MatrixJoin.birch"
template<class Value>
#line 110 "src/expression/MatrixJoin.birch"
libbirch::Lazy<libbirch::Shared<birch::type::MatrixJoin<Value>>> birch::join(const libbirch::DefaultArray<libbirch::Lazy<libbirch::Shared<birch::type::Expression<Value>>>,2>& y, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_) {
  #line 110 "src/expression/MatrixJoin.birch"
  libbirch_function_("join", "src/expression/MatrixJoin.birch", 110);
  #line 111 "src/expression/MatrixJoin.birch"
  libbirch_line_(111);
  #line 111 "src/expression/MatrixJoin.birch"
  return birch::construct<libbirch::Lazy<libbirch::Shared<birch::type::MatrixJoin<Value>>>>(y, handler_);
}

#line 118 "src/expression/MatrixJoin.birch"
template<class Value>
#line 118 "src/expression/MatrixJoin.birch"
libbirch::DefaultArray<libbirch::Lazy<libbirch::Shared<birch::type::Expression<Value>>>,2> birch::split(const libbirch::Lazy<libbirch::Shared<birch::type::Expression<libbirch::DefaultArray<Value,2>>>>& y, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_) {
  #line 118 "src/expression/MatrixJoin.birch"
  libbirch_function_("split", "src/expression/MatrixJoin.birch", 118);
  #line 119 "src/expression/MatrixJoin.birch"
  libbirch_line_(119);
  #line 119 "src/expression/MatrixJoin.birch"
  auto z = birch::canonical(y, handler_);
  #line 125 "src/expression/MatrixJoin.birch"
  libbirch_line_(125);
  #line 125 "src/expression/MatrixJoin.birch"
  return birch::matrix(std::function<libbirch::Lazy<libbirch::Shared<birch::type::Expression<Value>>>(birch::type::Integer,birch::type::Integer,const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_
)>([=](const birch::type::Integer& i, const birch::type::Integer& j, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr) {
    #line 126 "src/expression/MatrixJoin.birch"
    libbirch_line_(126);
    #line 126 "src/expression/MatrixJoin.birch"
    return birch::construct<libbirch::Lazy<libbirch::Shared<birch::type::MatrixElement<Value>>>>(z, i, j, handler_);
  }), z->rows(handler_), z->columns(handler_), handler_);
}

#line 101 "src/expression/MultivariateJoin.birch"
template<class Value>
#line 101 "src/expression/MultivariateJoin.birch"
libbirch::Lazy<libbirch::Shared<birch::type::MultivariateJoin<Value>>> birch::join(const libbirch::DefaultArray<libbirch::Lazy<libbirch::Shared<birch::type::Expression<Value>>>,1>& y, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_) {
  #line 101 "src/expression/MultivariateJoin.birch"
  libbirch_function_("join", "src/expression/MultivariateJoin.birch", 101);
  #line 102 "src/expression/MultivariateJoin.birch"
  libbirch_line_(102);
  #line 102 "src/expression/MultivariateJoin.birch"
  return birch::construct<libbirch::Lazy<libbirch::Shared<birch::type::MultivariateJoin<Value>>>>(y, handler_);
}

#line 109 "src/expression/MultivariateJoin.birch"
template<class Value>
#line 109 "src/expression/MultivariateJoin.birch"
libbirch::DefaultArray<libbirch::Lazy<libbirch::Shared<birch::type::Expression<Value>>>,1> birch::split(const libbirch::Lazy<libbirch::Shared<birch::type::Expression<libbirch::DefaultArray<Value,1>>>>& y, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_) {
  #line 109 "src/expression/MultivariateJoin.birch"
  libbirch_function_("split", "src/expression/MultivariateJoin.birch", 109);
  #line 110 "src/expression/MultivariateJoin.birch"
  libbirch_line_(110);
  #line 110 "src/expression/MultivariateJoin.birch"
  auto z = birch::canonical(y, handler_);
  #line 116 "src/expression/MultivariateJoin.birch"
  libbirch_line_(116);
  #line 116 "src/expression/MultivariateJoin.birch"
  return birch::vector(std::function<libbirch::Lazy<libbirch::Shared<birch::type::Expression<Value>>>(birch::type::Integer,const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_
)>([=](const birch::type::Integer& i, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr) {
    #line 117 "src/expression/MultivariateJoin.birch"
    libbirch_line_(117);
    #line 117 "src/expression/MultivariateJoin.birch"
    return birch::construct<libbirch::Lazy<libbirch::Shared<birch::type::MultivariateElement<Value>>>>(z, i, handler_);
  }), z->length(handler_), handler_);
}

#line 356 "src/expression/Random.birch"
template<class Value>
#line 356 "src/expression/Random.birch"
libbirch::Lazy<libbirch::Shared<birch::type::Random<Value>>> birch::Random(const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_) {
  #line 356 "src/expression/Random.birch"
  libbirch_function_("Random", "src/expression/Random.birch", 356);
  #line 357 "src/expression/Random.birch"
  libbirch_line_(357);
  #line 357 "src/expression/Random.birch"
  libbirch::Lazy<libbirch::Shared<birch::type::Random<Value>>> o;
  #line 358 "src/expression/Random.birch"
  libbirch_line_(358);
  #line 358 "src/expression/Random.birch"
  return o;
}

#line 20 "src/expression/ScalarMatrix.birch"
template<class Value>
#line 20 "src/expression/ScalarMatrix.birch"
libbirch::Lazy<libbirch::Shared<birch::type::ScalarMatrix<Value>>> birch::scalar(const libbirch::Lazy<libbirch::Shared<birch::type::Expression<libbirch::DefaultArray<Value,2>>>>& y, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_) {
  #line 20 "src/expression/ScalarMatrix.birch"
  libbirch_function_("scalar", "src/expression/ScalarMatrix.birch", 20);
  #line 21 "src/expression/ScalarMatrix.birch"
  libbirch_line_(21);
  #line 21 "src/expression/ScalarMatrix.birch"
  return birch::construct<libbirch::Lazy<libbirch::Shared<birch::type::ScalarMatrix<Value>>>>(y, handler_);
}

#line 18 "src/expression/ScalarMultivariate.birch"
template<class Value>
#line 18 "src/expression/ScalarMultivariate.birch"
libbirch::Lazy<libbirch::Shared<birch::type::ScalarMultivariate<Value>>> birch::scalar(const libbirch::Lazy<libbirch::Shared<birch::type::Expression<libbirch::DefaultArray<Value,1>>>>& y, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_) {
  #line 18 "src/expression/ScalarMultivariate.birch"
  libbirch_function_("scalar", "src/expression/ScalarMultivariate.birch", 18);
  #line 19 "src/expression/ScalarMultivariate.birch"
  libbirch_line_(19);
  #line 19 "src/expression/ScalarMultivariate.birch"
  return birch::construct<libbirch::Lazy<libbirch::Shared<birch::type::ScalarMultivariate<Value>>>>(y, handler_);
}

#line 36 "src/iterator/ArrayIterator.birch"
template<class Type>
#line 36 "src/iterator/ArrayIterator.birch"
libbirch::Lazy<libbirch::Shared<birch::type::ArrayIterator<Type>>> birch::ArrayIterator(const libbirch::Lazy<libbirch::Shared<birch::type::Array<Type>>>& o, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_) {
  #line 36 "src/iterator/ArrayIterator.birch"
  libbirch_function_("ArrayIterator", "src/iterator/ArrayIterator.birch", 36);
  #line 37 "src/iterator/ArrayIterator.birch"
  libbirch_line_(37);
  #line 37 "src/iterator/ArrayIterator.birch"
  return birch::construct<libbirch::Lazy<libbirch::Shared<birch::type::ArrayIterator<Type>>>>(o, handler_);
}

#line 24 "src/iterator/EmptyIterator.birch"
template<class Type>
#line 24 "src/iterator/EmptyIterator.birch"
libbirch::Lazy<libbirch::Shared<birch::type::EmptyIterator<Type>>> birch::EmptyIterator(const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_) {
  #line 24 "src/iterator/EmptyIterator.birch"
  libbirch_function_("EmptyIterator", "src/iterator/EmptyIterator.birch", 24);
  #line 25 "src/iterator/EmptyIterator.birch"
  libbirch_line_(25);
  #line 25 "src/iterator/EmptyIterator.birch"
  return birch::construct<libbirch::Lazy<libbirch::Shared<birch::type::EmptyIterator<Type>>>>(handler_);
}

#line 32 "src/iterator/ListIterator.birch"
template<class Type>
#line 32 "src/iterator/ListIterator.birch"
libbirch::Lazy<libbirch::Shared<birch::type::ListIterator<Type>>> birch::ListIterator(const libbirch::Optional<libbirch::Lazy<libbirch::Shared<birch::type::ListNode<Type>>>>& head, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_) {
  #line 32 "src/iterator/ListIterator.birch"
  libbirch_function_("ListIterator", "src/iterator/ListIterator.birch", 32);
  #line 33 "src/iterator/ListIterator.birch"
  libbirch_line_(33);
  #line 33 "src/iterator/ListIterator.birch"
  return birch::construct<libbirch::Lazy<libbirch::Shared<birch::type::ListIterator<Type>>>>(head, handler_);
}

#line 43 "src/iterator/RaggedArrayElementIterator.birch"
template<class Type>
#line 43 "src/iterator/RaggedArrayElementIterator.birch"
libbirch::Lazy<libbirch::Shared<birch::type::RaggedArrayElementIterator<Type>>> birch::RaggedArrayElementIterator(const libbirch::Lazy<libbirch::Shared<birch::type::RaggedArray<Type>>>& o, const birch::type::Integer& i, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_) {
  #line 43 "src/iterator/RaggedArrayElementIterator.birch"
  libbirch_function_("RaggedArrayElementIterator", "src/iterator/RaggedArrayElementIterator.birch", 43);
  #line 45 "src/iterator/RaggedArrayElementIterator.birch"
  libbirch_line_(45);
  #line 45 "src/iterator/RaggedArrayElementIterator.birch"
  return birch::construct<libbirch::Lazy<libbirch::Shared<birch::type::RaggedArrayElementIterator<Type>>>>(o, i, handler_);
}

#line 37 "src/iterator/RaggedArrayRowIterator.birch"
template<class Type>
#line 37 "src/iterator/RaggedArrayRowIterator.birch"
libbirch::Lazy<libbirch::Shared<birch::type::RaggedArrayRowIterator<Type>>> birch::RaggedArrayRowIterator(const libbirch::Lazy<libbirch::Shared<birch::type::RaggedArray<Type>>>& o, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_) {
  #line 37 "src/iterator/RaggedArrayRowIterator.birch"
  libbirch_function_("RaggedArrayRowIterator", "src/iterator/RaggedArrayRowIterator.birch", 37);
  #line 39 "src/iterator/RaggedArrayRowIterator.birch"
  libbirch_line_(39);
  #line 39 "src/iterator/RaggedArrayRowIterator.birch"
  return birch::construct<libbirch::Lazy<libbirch::Shared<birch::type::RaggedArrayRowIterator<Type>>>>(o, handler_);
}

#line 32 "src/iterator/StackIterator.birch"
template<class Type>
#line 32 "src/iterator/StackIterator.birch"
libbirch::Lazy<libbirch::Shared<birch::type::StackIterator<Type>>> birch::StackIterator(const libbirch::Optional<libbirch::Lazy<libbirch::Shared<birch::type::StackNode<Type>>>>& head, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_) {
  #line 32 "src/iterator/StackIterator.birch"
  libbirch_function_("StackIterator", "src/iterator/StackIterator.birch", 32);
  #line 33 "src/iterator/StackIterator.birch"
  libbirch_line_(33);
  #line 33 "src/iterator/StackIterator.birch"
  return birch::construct<libbirch::Lazy<libbirch::Shared<birch::type::StackIterator<Type>>>>(head, handler_);
}

#line 32 "src/iterator/TapeIterator.birch"
template<class Type>
#line 32 "src/iterator/TapeIterator.birch"
libbirch::Lazy<libbirch::Shared<birch::type::TapeIterator<Type>>> birch::TapeIterator(const libbirch::Optional<libbirch::Lazy<libbirch::Shared<birch::type::TapeNode<Type>>>>& head, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_) {
  #line 32 "src/iterator/TapeIterator.birch"
  libbirch_function_("TapeIterator", "src/iterator/TapeIterator.birch", 32);
  #line 33 "src/iterator/TapeIterator.birch"
  libbirch_line_(33);
  #line 33 "src/iterator/TapeIterator.birch"
  return birch::construct<libbirch::Lazy<libbirch::Shared<birch::type::TapeIterator<Type>>>>(head, handler_);
}

#line 8 "src/math/iterator.birch"
template<class Type>
#line 8 "src/math/iterator.birch"
Type birch::reduce(const libbirch::Lazy<libbirch::Shared<birch::type::Iterator<Type>>>& iter, const Type& init, const std::function<Type(Type, Type, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>&)>& op, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_) {
  #line 8 "src/math/iterator.birch"
  libbirch_function_("reduce", "src/math/iterator.birch", 8);
  #line 10 "src/math/iterator.birch"
  libbirch_line_(10);
  #line 10 "src/math/iterator.birch"
  auto result = init;
  #line 11 "src/math/iterator.birch"
  libbirch_line_(11);
  #line 11 "src/math/iterator.birch"
  while (iter->hasNext(handler_)) {
    #line 12 "src/math/iterator.birch"
    libbirch_line_(12);
    #line 12 "src/math/iterator.birch"
    result = op(result, iter->next(handler_), handler_);
  }
  #line 14 "src/math/iterator.birch"
  libbirch_line_(14);
  #line 14 "src/math/iterator.birch"
  return result;
}

#line 20 "src/math/iterator.birch"
template<class Type>
#line 20 "src/math/iterator.birch"
Type birch::sum(const libbirch::Lazy<libbirch::Shared<birch::type::Iterator<Type>>>& iter, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_) {
  #line 20 "src/math/iterator.birch"
  libbirch_function_("sum", "src/math/iterator.birch", 20);
  #line 21 "src/math/iterator.birch"
  libbirch_line_(21);
  #line 21 "src/math/iterator.birch"
  libbirch_assert_(iter->hasNext(handler_));
  #line 22 "src/math/iterator.birch"
  libbirch_line_(22);
  #line 22 "src/math/iterator.birch"
  return birch::reduce(iter, iter->next(handler_), std::function<birch::type::Real(birch::type::Real,birch::type::Real,const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_
)>([=](const birch::type::Real& x, const birch::type::Real& y, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr) {
    #line 23 "src/math/iterator.birch"
    libbirch_line_(23);
    #line 23 "src/math/iterator.birch"
    return x + y;
  }), handler_);
}

#line 30 "src/math/iterator.birch"
template<class Type>
#line 30 "src/math/iterator.birch"
Type birch::product(const libbirch::Lazy<libbirch::Shared<birch::type::Iterator<Type>>>& iter, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_) {
  #line 30 "src/math/iterator.birch"
  libbirch_function_("product", "src/math/iterator.birch", 30);
  #line 31 "src/math/iterator.birch"
  libbirch_line_(31);
  #line 31 "src/math/iterator.birch"
  libbirch_assert_(iter->hasNext(handler_));
  #line 32 "src/math/iterator.birch"
  libbirch_line_(32);
  #line 32 "src/math/iterator.birch"
  return birch::reduce(iter, iter->next(handler_), std::function<birch::type::Real(birch::type::Real,birch::type::Real,const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_
)>([=](const birch::type::Real& x, const birch::type::Real& y, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr) {
    #line 33 "src/math/iterator.birch"
    libbirch_line_(33);
    #line 33 "src/math/iterator.birch"
    return x * y;
  }), handler_);
}

#line 40 "src/math/iterator.birch"
template<class Type>
#line 40 "src/math/iterator.birch"
Type birch::max(const libbirch::Lazy<libbirch::Shared<birch::type::Iterator<Type>>>& iter, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_) {
  #line 40 "src/math/iterator.birch"
  libbirch_function_("max", "src/math/iterator.birch", 40);
  #line 41 "src/math/iterator.birch"
  libbirch_line_(41);
  #line 41 "src/math/iterator.birch"
  libbirch_assert_(iter->hasNext(handler_));
  #line 42 "src/math/iterator.birch"
  libbirch_line_(42);
  #line 42 "src/math/iterator.birch"
  return birch::reduce(iter, iter->next(handler_), std::function<birch::type::Real(birch::type::Real,birch::type::Real,const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_
)>([=](const birch::type::Real& x, const birch::type::Real& y, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr) {
    #line 43 "src/math/iterator.birch"
    libbirch_line_(43);
    #line 43 "src/math/iterator.birch"
    return birch::max(x, y, handler_);
  }), handler_);
}

#line 50 "src/math/iterator.birch"
template<class Type>
#line 50 "src/math/iterator.birch"
Type birch::min(const libbirch::Lazy<libbirch::Shared<birch::type::Iterator<Type>>>& iter, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_) {
  #line 50 "src/math/iterator.birch"
  libbirch_function_("min", "src/math/iterator.birch", 50);
  #line 51 "src/math/iterator.birch"
  libbirch_line_(51);
  #line 51 "src/math/iterator.birch"
  libbirch_assert_(iter->hasNext(handler_));
  #line 52 "src/math/iterator.birch"
  libbirch_line_(52);
  #line 52 "src/math/iterator.birch"
  return birch::reduce(iter, iter->next(handler_), std::function<Type(Type,Type,const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_
)>([=](const Type& x, const Type& y, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr) {
    #line 53 "src/math/iterator.birch"
    libbirch_line_(53);
    #line 53 "src/math/iterator.birch"
    return birch::min(x, y, handler_);
  }), handler_);
}

#line 4 "src/math/matrix.birch"
template<class Value>
#line 4 "src/math/matrix.birch"
birch::type::Integer birch::length(const libbirch::DefaultArray<Value,2>& X, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_) {
  #line 4 "src/math/matrix.birch"
  libbirch_function_("length", "src/math/matrix.birch", 4);
  #line 5 "src/math/matrix.birch"

  return X.rows();
  }

#line 13 "src/math/matrix.birch"
template<class Value>
#line 13 "src/math/matrix.birch"
birch::type::Integer birch::rows(const libbirch::DefaultArray<Value,2>& X, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_) {
  #line 13 "src/math/matrix.birch"
  libbirch_function_("rows", "src/math/matrix.birch", 13);
  #line 14 "src/math/matrix.birch"

  return X.rows();
  }

#line 22 "src/math/matrix.birch"
template<class Value>
#line 22 "src/math/matrix.birch"
birch::type::Integer birch::columns(const libbirch::DefaultArray<Value,2>& X, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_) {
  #line 22 "src/math/matrix.birch"
  libbirch_function_("columns", "src/math/matrix.birch", 22);
  #line 23 "src/math/matrix.birch"

  return X.cols();
  }

#line 31 "src/math/matrix.birch"
template<class Type>
#line 31 "src/math/matrix.birch"
Type birch::scalar(const libbirch::DefaultArray<Type,2>& X, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_) {
  #line 31 "src/math/matrix.birch"
  libbirch_function_("scalar", "src/math/matrix.birch", 31);
  #line 32 "src/math/matrix.birch"
  libbirch_line_(32);
  #line 32 "src/math/matrix.birch"
  libbirch_assert_(birch::rows(X, handler_) == birch::type::Integer(1));
  #line 33 "src/math/matrix.birch"
  libbirch_line_(33);
  #line 33 "src/math/matrix.birch"
  libbirch_assert_(birch::columns(X, handler_) == birch::type::Integer(1));
  #line 34 "src/math/matrix.birch"
  libbirch_line_(34);
  #line 34 "src/math/matrix.birch"
  return X.get(libbirch::make_slice(birch::type::Integer(1) - 1, birch::type::Integer(1) - 1));
}

#line 40 "src/math/matrix.birch"
template<class Type>
#line 40 "src/math/matrix.birch"
libbirch::DefaultArray<Type,2> birch::row(const libbirch::DefaultArray<Type,1>& x, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_) {
  #line 40 "src/math/matrix.birch"
  libbirch_function_("row", "src/math/matrix.birch", 40);
  #line 41 "src/math/matrix.birch"
  libbirch_line_(41);
  #line 41 "src/math/matrix.birch"
  return birch::matrix(std::function<Type(birch::type::Integer,birch::type::Integer,const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_
)>([=](const birch::type::Integer& i, const birch::type::Integer& j, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr) {
    #line 41 "src/math/matrix.birch"
    libbirch_line_(41);
    #line 41 "src/math/matrix.birch"
    return x.get(libbirch::make_slice(j - 1));
  }), birch::type::Integer(1), birch::length(x, handler_), handler_);
}

#line 48 "src/math/matrix.birch"
template<class Type>
#line 48 "src/math/matrix.birch"
libbirch::DefaultArray<Type,1> birch::row(const libbirch::DefaultArray<Type,2>& X, const birch::type::Integer& i, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_) {
  #line 48 "src/math/matrix.birch"
  libbirch_function_("row", "src/math/matrix.birch", 48);
  #line 49 "src/math/matrix.birch"
  libbirch_line_(49);
  #line 49 "src/math/matrix.birch"
  return X.get(libbirch::make_slice(i - 1, libbirch::make_range(birch::type::Integer(1) - 1, birch::columns(X, handler_) - 1)));
}

#line 55 "src/math/matrix.birch"
template<class Type>
#line 55 "src/math/matrix.birch"
libbirch::DefaultArray<Type,2> birch::column(const libbirch::DefaultArray<Type,1>& x, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_) {
  #line 55 "src/math/matrix.birch"
  libbirch_function_("column", "src/math/matrix.birch", 55);
  #line 56 "src/math/matrix.birch"
  libbirch_line_(56);
  #line 56 "src/math/matrix.birch"
  return birch::matrix(std::function<Type(birch::type::Integer,birch::type::Integer,const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_
)>([=](const birch::type::Integer& i, const birch::type::Integer& j, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr) {
    #line 57 "src/math/matrix.birch"
    libbirch_line_(57);
    #line 57 "src/math/matrix.birch"
    return x.get(libbirch::make_slice(i - 1));
  }), birch::type::Integer(1), birch::length(x, handler_), handler_);
}

#line 64 "src/math/matrix.birch"
template<class Type>
#line 64 "src/math/matrix.birch"
libbirch::DefaultArray<Type,1> birch::column(const libbirch::DefaultArray<Type,2>& X, const birch::type::Integer& j, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_) {
  #line 64 "src/math/matrix.birch"
  libbirch_function_("column", "src/math/matrix.birch", 64);
  #line 65 "src/math/matrix.birch"
  libbirch_line_(65);
  #line 65 "src/math/matrix.birch"
  return X.get(libbirch::make_slice(libbirch::make_range(birch::type::Integer(1) - 1, birch::rows(X, handler_) - 1), j - 1));
}

#line 74 "src/math/matrix.birch"
template<class Type>
#line 74 "src/math/matrix.birch"
libbirch::DefaultArray<Type,1> birch::vec(const libbirch::DefaultArray<Type,2>& X, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_) {
  #line 74 "src/math/matrix.birch"
  libbirch_function_("vec", "src/math/matrix.birch", 74);
  #line 75 "src/math/matrix.birch"
  libbirch_line_(75);
  #line 75 "src/math/matrix.birch"
  auto R = birch::rows(X, handler_);
  #line 76 "src/math/matrix.birch"
  libbirch_line_(76);
  #line 76 "src/math/matrix.birch"
  auto C = birch::columns(X, handler_);
  #line 77 "src/math/matrix.birch"
  libbirch_line_(77);
  #line 77 "src/math/matrix.birch"
  return birch::vector(std::function<Type(birch::type::Integer,const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_
)>([=](const birch::type::Integer& i, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr) {
    #line 78 "src/math/matrix.birch"
    libbirch_line_(78);
    #line 78 "src/math/matrix.birch"
    return X.get(libbirch::make_slice(birch::mod(i - birch::type::Integer(1), R, handler_) + birch::type::Integer(1) - 1, (i - birch::type::Integer(1)) / R + birch::type::Integer(1) - 1));
  }), R * C, handler_);
}

#line 89 "src/math/matrix.birch"
template<class Type>
#line 89 "src/math/matrix.birch"
libbirch::DefaultArray<Type,2> birch::mat(const libbirch::DefaultArray<Type,1>& x, const birch::type::Integer& columns, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_) {
  #line 89 "src/math/matrix.birch"
  libbirch_function_("mat", "src/math/matrix.birch", 89);
  #line 90 "src/math/matrix.birch"
  libbirch_line_(90);
  #line 90 "src/math/matrix.birch"
  libbirch_assert_(birch::mod(birch::length(x, handler_), columns, handler_) == birch::type::Integer(0));
  #line 91 "src/math/matrix.birch"
  libbirch_line_(91);
  #line 91 "src/math/matrix.birch"
  auto R = birch::length(x, handler_) / columns;
  #line 92 "src/math/matrix.birch"
  libbirch_line_(92);
  #line 92 "src/math/matrix.birch"
  auto C = columns;
  #line 93 "src/math/matrix.birch"
  libbirch_line_(93);
  #line 93 "src/math/matrix.birch"
  return birch::matrix(std::function<Type(birch::type::Integer,birch::type::Integer,const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_
)>([=](const birch::type::Integer& i, const birch::type::Integer& j, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr) {
    #line 94 "src/math/matrix.birch"
    libbirch_line_(94);
    #line 94 "src/math/matrix.birch"
    return x.get(libbirch::make_slice((j - birch::type::Integer(1)) * R + i - 1));
  }), R, C, handler_);
}

#line 102 "src/math/matrix.birch"
template<class Type>
#line 102 "src/math/matrix.birch"
libbirch::DefaultArray<Type,2> birch::stack(const libbirch::DefaultArray<Type,2>& X, const libbirch::DefaultArray<Type,2>& Y, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_) {
  #line 102 "src/math/matrix.birch"
  libbirch_function_("stack", "src/math/matrix.birch", 102);
  #line 103 "src/math/matrix.birch"
  libbirch_line_(103);
  #line 103 "src/math/matrix.birch"
  libbirch_assert_(birch::columns(X, handler_) == birch::columns(Y, handler_));
  #line 105 "src/math/matrix.birch"
  libbirch_line_(105);
  #line 105 "src/math/matrix.birch"
  auto R1 = birch::rows(X, handler_);
  #line 106 "src/math/matrix.birch"
  libbirch_line_(106);
  #line 106 "src/math/matrix.birch"
  auto R2 = birch::rows(Y, handler_);
  #line 107 "src/math/matrix.birch"
  libbirch_line_(107);
  #line 107 "src/math/matrix.birch"
  auto C = birch::columns(X, handler_);
  #line 109 "src/math/matrix.birch"
  libbirch_line_(109);
  #line 109 "src/math/matrix.birch"
  return birch::matrix(std::function<Type(birch::type::Integer,birch::type::Integer,const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_
)>([=](const birch::type::Integer& i, const birch::type::Integer& j, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr) {
    #line 110 "src/math/matrix.birch"
    libbirch_line_(110);
    #line 110 "src/math/matrix.birch"
    if (i <= R1) {
      #line 111 "src/math/matrix.birch"
      libbirch_line_(111);
      #line 111 "src/math/matrix.birch"
      return X.get(libbirch::make_slice(i - 1, j - 1));
    } else {
      #line 113 "src/math/matrix.birch"
      libbirch_line_(113);
      #line 113 "src/math/matrix.birch"
      return Y.get(libbirch::make_slice(i - R1 - 1, j - 1));
    }
  }), R1 + R2, C, handler_);
}

#line 122 "src/math/matrix.birch"
template<class Type>
#line 122 "src/math/matrix.birch"
libbirch::DefaultArray<Type,2> birch::pack(const libbirch::DefaultArray<Type,2>& X, const libbirch::DefaultArray<Type,2>& Y, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_) {
  #line 122 "src/math/matrix.birch"
  libbirch_function_("pack", "src/math/matrix.birch", 122);
  #line 123 "src/math/matrix.birch"
  libbirch_line_(123);
  #line 123 "src/math/matrix.birch"
  libbirch_assert_(birch::rows(X, handler_) == birch::rows(Y, handler_));
  #line 125 "src/math/matrix.birch"
  libbirch_line_(125);
  #line 125 "src/math/matrix.birch"
  auto R = birch::rows(X, handler_);
  #line 126 "src/math/matrix.birch"
  libbirch_line_(126);
  #line 126 "src/math/matrix.birch"
  auto C1 = birch::columns(X, handler_);
  #line 127 "src/math/matrix.birch"
  libbirch_line_(127);
  #line 127 "src/math/matrix.birch"
  auto C2 = birch::columns(Y, handler_);
  #line 129 "src/math/matrix.birch"
  libbirch_line_(129);
  #line 129 "src/math/matrix.birch"
  return birch::matrix(std::function<Type(birch::type::Integer,birch::type::Integer,const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_
)>([=](const birch::type::Integer& i, const birch::type::Integer& j, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr) {
    #line 130 "src/math/matrix.birch"
    libbirch_line_(130);
    #line 130 "src/math/matrix.birch"
    if (j <= C1) {
      #line 131 "src/math/matrix.birch"
      libbirch_line_(131);
      #line 131 "src/math/matrix.birch"
      return X.get(libbirch::make_slice(i - 1, j - 1));
    } else {
      #line 133 "src/math/matrix.birch"
      libbirch_line_(133);
      #line 133 "src/math/matrix.birch"
      return Y.get(libbirch::make_slice(i - 1, j - C1 - 1));
    }
  }), R, C1 + C2, handler_);
}

#line 209 "src/math/matrix.birch"
template<class Type>
#line 209 "src/math/matrix.birch"
libbirch::DefaultArray<Type,2> birch::matrix(const std::function<Type(birch::type::Integer, birch::type::Integer, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>&)>& _u0955, const birch::type::Integer& rows, const birch::type::Integer& columns, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_) {
  #line 209 "src/math/matrix.birch"
  libbirch_function_("matrix", "src/math/matrix.birch", 209);
  #line 211 "src/math/matrix.birch"

  /* wrap _u0955 in another lambda function to translate 0-based serial (row-wise)
   * indices into 1-based row/column indices */
  return libbirch::make_array_from_lambda<Type>(libbirch::make_shape(rows,
      columns), [&](int64_t i) { return _u0955(i/columns + 1, i%columns + 1,
      handler_); });
  }

#line 227 "src/math/matrix.birch"
template<class Type>
#line 227 "src/math/matrix.birch"
libbirch::DefaultArray<Type,2> birch::matrix(const Type& x, const birch::type::Integer& rows, const birch::type::Integer& columns, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_) {
  #line 227 "src/math/matrix.birch"
  libbirch_function_("matrix", "src/math/matrix.birch", 227);
  #line 228 "src/math/matrix.birch"

  return libbirch::make_array<Type>(libbirch::make_shape(rows, columns), x);
  }

#line 236 "src/math/matrix.birch"
template<class Type>
#line 236 "src/math/matrix.birch"
libbirch::DefaultArray<birch::type::Boolean,2> birch::Boolean(const libbirch::DefaultArray<Type,2>& X, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_) {
  #line 236 "src/math/matrix.birch"
  libbirch_function_("Boolean", "src/math/matrix.birch", 236);
  #line 237 "src/math/matrix.birch"
  libbirch_line_(237);
  #line 237 "src/math/matrix.birch"
  return birch::matrix(std::function<birch::type::Boolean(birch::type::Integer,birch::type::Integer,const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_
)>([=](const birch::type::Integer& i, const birch::type::Integer& j, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr) {
    #line 238 "src/math/matrix.birch"
    libbirch_line_(238);
    #line 238 "src/math/matrix.birch"
    return birch::Boolean(X.get(libbirch::make_slice(i - 1, j - 1)), handler_);
  }), birch::rows(X, handler_), birch::columns(X, handler_), handler_);
}

#line 245 "src/math/matrix.birch"
template<class Type>
#line 245 "src/math/matrix.birch"
libbirch::DefaultArray<birch::type::Integer,2> birch::Integer(const libbirch::DefaultArray<Type,2>& X, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_) {
  #line 245 "src/math/matrix.birch"
  libbirch_function_("Integer", "src/math/matrix.birch", 245);
  #line 246 "src/math/matrix.birch"
  libbirch_line_(246);
  #line 246 "src/math/matrix.birch"
  return birch::matrix(std::function<birch::type::Integer(birch::type::Integer,birch::type::Integer,const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_
)>([=](const birch::type::Integer& i, const birch::type::Integer& j, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr) {
    #line 247 "src/math/matrix.birch"
    libbirch_line_(247);
    #line 247 "src/math/matrix.birch"
    return birch::Integer(X.get(libbirch::make_slice(i - 1, j - 1)), handler_);
  }), birch::rows(X, handler_), birch::columns(X, handler_), handler_);
}

#line 254 "src/math/matrix.birch"
template<class Type>
#line 254 "src/math/matrix.birch"
libbirch::DefaultArray<birch::type::Real,2> birch::Real(const libbirch::DefaultArray<Type,2>& X, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_) {
  #line 254 "src/math/matrix.birch"
  libbirch_function_("Real", "src/math/matrix.birch", 254);
  #line 255 "src/math/matrix.birch"
  libbirch_line_(255);
  #line 255 "src/math/matrix.birch"
  return birch::matrix(std::function<birch::type::Real(birch::type::Integer,birch::type::Integer,const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_
)>([=](const birch::type::Integer& i, const birch::type::Integer& j, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr) {
    #line 256 "src/math/matrix.birch"
    libbirch_line_(256);
    #line 256 "src/math/matrix.birch"
    return birch::Real(X.get(libbirch::make_slice(i - 1, j - 1)), handler_);
  }), birch::rows(X, handler_), birch::columns(X, handler_), handler_);
}

#line 9 "src/math/primitive.birch"
template<class Type>
#line 9 "src/math/primitive.birch"
void birch::for_each(const libbirch::DefaultArray<Type,1>& x, const std::function<void(Type, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>&)>& f, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_) {
  #line 9 "src/math/primitive.birch"
  libbirch_function_("for_each", "src/math/primitive.birch", 9);
  #line 10 "src/math/primitive.birch"
  libbirch_line_(10);
  #line 10 "src/math/primitive.birch"
  for (auto i = birch::type::Integer(1); i <= birch::length(x, handler_); ++i) {
    #line 11 "src/math/primitive.birch"
    libbirch_line_(11);
    #line 11 "src/math/primitive.birch"
    f(x.get(libbirch::make_slice(i - 1)), handler_);
  }
}

#line 23 "src/math/primitive.birch"
template<class Type>
#line 23 "src/math/primitive.birch"
void birch::for_each(const libbirch::DefaultArray<Type,2>& X, const std::function<void(Type, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>&)>& f, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_) {
  #line 23 "src/math/primitive.birch"
  libbirch_function_("for_each", "src/math/primitive.birch", 23);
  #line 24 "src/math/primitive.birch"
  libbirch_line_(24);
  #line 24 "src/math/primitive.birch"
  for (auto i = birch::type::Integer(1); i <= birch::rows(X, handler_); ++i) {
    #line 25 "src/math/primitive.birch"
    libbirch_line_(25);
    #line 25 "src/math/primitive.birch"
    for (auto j = birch::type::Integer(1); j <= birch::columns(X, handler_); ++j) {
      #line 26 "src/math/primitive.birch"
      libbirch_line_(26);
      #line 26 "src/math/primitive.birch"
      f(X.get(libbirch::make_slice(i - 1, j - 1)), handler_);
    }
  }
}

#line 38 "src/math/primitive.birch"
template<class Input1,class Input2>
#line 38 "src/math/primitive.birch"
void birch::for_each(const libbirch::DefaultArray<Input1,1>& x, const libbirch::DefaultArray<Input2,1>& y, const std::function<void(Input1, Input2, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>&)>& f, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_) {
  #line 38 "src/math/primitive.birch"
  libbirch_function_("for_each", "src/math/primitive.birch", 38);
  #line 40 "src/math/primitive.birch"
  libbirch_line_(40);
  #line 40 "src/math/primitive.birch"
  libbirch_assert_(birch::length(x, handler_) == birch::length(y, handler_));
  #line 41 "src/math/primitive.birch"
  libbirch_line_(41);
  #line 41 "src/math/primitive.birch"
  for (auto i = birch::type::Integer(1); i <= birch::length(x, handler_); ++i) {
    #line 42 "src/math/primitive.birch"
    libbirch_line_(42);
    #line 42 "src/math/primitive.birch"
    f(x.get(libbirch::make_slice(i - 1)), y.get(libbirch::make_slice(i - 1)), handler_);
  }
}

#line 53 "src/math/primitive.birch"
template<class Input1,class Input2>
#line 53 "src/math/primitive.birch"
void birch::for_each(const libbirch::DefaultArray<Input1,2>& X, const libbirch::DefaultArray<Input2,2>& Y, const std::function<void(Input1, Input2, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>&)>& f, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_) {
  #line 53 "src/math/primitive.birch"
  libbirch_function_("for_each", "src/math/primitive.birch", 53);
  #line 55 "src/math/primitive.birch"
  libbirch_line_(55);
  #line 55 "src/math/primitive.birch"
  libbirch_assert_(birch::rows(X, handler_) == birch::rows(Y, handler_));
  #line 56 "src/math/primitive.birch"
  libbirch_line_(56);
  #line 56 "src/math/primitive.birch"
  libbirch_assert_(birch::columns(X, handler_) == birch::columns(Y, handler_));
  #line 57 "src/math/primitive.birch"
  libbirch_line_(57);
  #line 57 "src/math/primitive.birch"
  for (auto i = birch::type::Integer(1); i <= birch::rows(X, handler_); ++i) {
    #line 58 "src/math/primitive.birch"
    libbirch_line_(58);
    #line 58 "src/math/primitive.birch"
    for (auto j = birch::type::Integer(1); j <= birch::columns(X, handler_); ++j) {
      #line 59 "src/math/primitive.birch"
      libbirch_line_(59);
      #line 59 "src/math/primitive.birch"
      f(X.get(libbirch::make_slice(i - 1, j - 1)), Y.get(libbirch::make_slice(i - 1, j - 1)), handler_);
    }
  }
}

#line 72 "src/math/primitive.birch"
template<class Input1,class Input2,class Input3>
#line 72 "src/math/primitive.birch"
void birch::for_each(const libbirch::DefaultArray<Input1,1>& x, const libbirch::DefaultArray<Input2,1>& y, const libbirch::DefaultArray<Input3,1>& z, const std::function<void(Input1, Input2, Input3, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>&)>& f, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_) {
  #line 72 "src/math/primitive.birch"
  libbirch_function_("for_each", "src/math/primitive.birch", 72);
  #line 74 "src/math/primitive.birch"
  libbirch_line_(74);
  #line 74 "src/math/primitive.birch"
  libbirch_assert_(birch::length(x, handler_) == birch::length(y, handler_));
  #line 75 "src/math/primitive.birch"
  libbirch_line_(75);
  #line 75 "src/math/primitive.birch"
  libbirch_assert_(birch::length(y, handler_) == birch::length(z, handler_));
  #line 76 "src/math/primitive.birch"
  libbirch_line_(76);
  #line 76 "src/math/primitive.birch"
  for (auto i = birch::type::Integer(1); i <= birch::length(x, handler_); ++i) {
    #line 77 "src/math/primitive.birch"
    libbirch_line_(77);
    #line 77 "src/math/primitive.birch"
    f(x.get(libbirch::make_slice(i - 1)), y.get(libbirch::make_slice(i - 1)), z.get(libbirch::make_slice(i - 1)), handler_);
  }
}

#line 89 "src/math/primitive.birch"
template<class Input1,class Input2,class Input3>
#line 89 "src/math/primitive.birch"
void birch::for_each(const libbirch::DefaultArray<Input1,2>& X, const libbirch::DefaultArray<Input2,2>& Y, const libbirch::DefaultArray<Input3,2>& Z, const std::function<void(Input1, Input2, Input3, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>&)>& f, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_) {
  #line 89 "src/math/primitive.birch"
  libbirch_function_("for_each", "src/math/primitive.birch", 89);
  #line 91 "src/math/primitive.birch"
  libbirch_line_(91);
  #line 91 "src/math/primitive.birch"
  libbirch_assert_(birch::rows(X, handler_) == birch::rows(Y, handler_));
  #line 92 "src/math/primitive.birch"
  libbirch_line_(92);
  #line 92 "src/math/primitive.birch"
  libbirch_assert_(birch::rows(Y, handler_) == birch::rows(Z, handler_));
  #line 93 "src/math/primitive.birch"
  libbirch_line_(93);
  #line 93 "src/math/primitive.birch"
  libbirch_assert_(birch::columns(X, handler_) == birch::columns(Y, handler_));
  #line 94 "src/math/primitive.birch"
  libbirch_line_(94);
  #line 94 "src/math/primitive.birch"
  libbirch_assert_(birch::columns(Y, handler_) == birch::columns(Z, handler_));
  #line 95 "src/math/primitive.birch"
  libbirch_line_(95);
  #line 95 "src/math/primitive.birch"
  for (auto i = birch::type::Integer(1); i <= birch::rows(X, handler_); ++i) {
    #line 96 "src/math/primitive.birch"
    libbirch_line_(96);
    #line 96 "src/math/primitive.birch"
    for (auto j = birch::type::Integer(1); j <= birch::columns(X, handler_); ++j) {
      #line 97 "src/math/primitive.birch"
      libbirch_line_(97);
      #line 97 "src/math/primitive.birch"
      f(X.get(libbirch::make_slice(i - 1, j - 1)), Y.get(libbirch::make_slice(i - 1, j - 1)), Z.get(libbirch::make_slice(i - 1, j - 1)), handler_);
    }
  }
}

#line 108 "src/math/primitive.birch"
template<class Input,class Output>
#line 108 "src/math/primitive.birch"
libbirch::DefaultArray<Output,1> birch::transform(const libbirch::DefaultArray<Input,1>& x, const std::function<Output(Input, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>&)>& f, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_) {
  #line 108 "src/math/primitive.birch"
  libbirch_function_("transform", "src/math/primitive.birch", 108);
  #line 110 "src/math/primitive.birch"
  libbirch_line_(110);
  #line 110 "src/math/primitive.birch"
  return birch::vector(std::function<Output(birch::type::Integer,const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_
)>([=](const birch::type::Integer& i, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr) {
    #line 111 "src/math/primitive.birch"
    libbirch_line_(111);
    #line 111 "src/math/primitive.birch"
    return f(x.get(libbirch::make_slice(i - 1)), handler_);
  }), birch::length(x, handler_), handler_);
}

#line 121 "src/math/primitive.birch"
template<class Input,class Output>
#line 121 "src/math/primitive.birch"
libbirch::DefaultArray<Output,2> birch::transform(const libbirch::DefaultArray<Input,2>& X, const std::function<Output(Input, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>&)>& f, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_) {
  #line 121 "src/math/primitive.birch"
  libbirch_function_("transform", "src/math/primitive.birch", 121);
  #line 123 "src/math/primitive.birch"
  libbirch_line_(123);
  #line 123 "src/math/primitive.birch"
  return birch::matrix(std::function<Output(birch::type::Integer,birch::type::Integer,const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_
)>([=](const birch::type::Integer& i, const birch::type::Integer& j, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr) {
    #line 124 "src/math/primitive.birch"
    libbirch_line_(124);
    #line 124 "src/math/primitive.birch"
    return f(X.get(libbirch::make_slice(i - 1, j - 1)), handler_);
  }), birch::rows(X, handler_), birch::columns(X, handler_), handler_);
}

#line 135 "src/math/primitive.birch"
template<class Input1,class Input2,class Output>
#line 135 "src/math/primitive.birch"
libbirch::DefaultArray<Output,1> birch::transform(const libbirch::DefaultArray<Input1,1>& x, const libbirch::DefaultArray<Input2,1>& y, const std::function<Output(Input1, Input1, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>&)>& f, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_) {
  #line 135 "src/math/primitive.birch"
  libbirch_function_("transform", "src/math/primitive.birch", 135);
  #line 137 "src/math/primitive.birch"
  libbirch_line_(137);
  #line 137 "src/math/primitive.birch"
  libbirch_assert_(birch::length(x, handler_) == birch::length(y, handler_));
  #line 138 "src/math/primitive.birch"
  libbirch_line_(138);
  #line 138 "src/math/primitive.birch"
  return birch::vector(std::function<Output(birch::type::Integer,const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_
)>([=](const birch::type::Integer& i, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr) {
    #line 139 "src/math/primitive.birch"
    libbirch_line_(139);
    #line 139 "src/math/primitive.birch"
    return f(x.get(libbirch::make_slice(i - 1)), y.get(libbirch::make_slice(i - 1)), handler_);
  }), birch::length(x, handler_), handler_);
}

#line 150 "src/math/primitive.birch"
template<class Input1,class Input2,class Output>
#line 150 "src/math/primitive.birch"
libbirch::DefaultArray<Output,2> birch::transform(const libbirch::DefaultArray<Input1,2>& X, const libbirch::DefaultArray<Input2,2>& Y, const std::function<Output(Input1, Input2, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>&)>& f, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_) {
  #line 150 "src/math/primitive.birch"
  libbirch_function_("transform", "src/math/primitive.birch", 150);
  #line 152 "src/math/primitive.birch"
  libbirch_line_(152);
  #line 152 "src/math/primitive.birch"
  libbirch_assert_(birch::rows(X, handler_) == birch::rows(Y, handler_));
  #line 153 "src/math/primitive.birch"
  libbirch_line_(153);
  #line 153 "src/math/primitive.birch"
  libbirch_assert_(birch::columns(X, handler_) == birch::columns(Y, handler_));
  #line 154 "src/math/primitive.birch"
  libbirch_line_(154);
  #line 154 "src/math/primitive.birch"
  return birch::matrix(std::function<Output(birch::type::Integer,birch::type::Integer,const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_
)>([=](const birch::type::Integer& i, const birch::type::Integer& j, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr) {
    #line 155 "src/math/primitive.birch"
    libbirch_line_(155);
    #line 155 "src/math/primitive.birch"
    return f(X.get(libbirch::make_slice(i - 1, j - 1)), Y.get(libbirch::make_slice(i - 1, j - 1)), handler_);
  }), birch::rows(X, handler_), birch::columns(X, handler_), handler_);
}

#line 167 "src/math/primitive.birch"
template<class Input1,class Input2,class Input3,class Output>
#line 167 "src/math/primitive.birch"
libbirch::DefaultArray<Output,1> birch::transform(const libbirch::DefaultArray<Input1,1>& x, const libbirch::DefaultArray<Input2,1>& y, const libbirch::DefaultArray<Input3,1>& z, const std::function<Output(Input1, Input2, Input3, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>&)>& f, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_) {
  #line 167 "src/math/primitive.birch"
  libbirch_function_("transform", "src/math/primitive.birch", 167);
  #line 169 "src/math/primitive.birch"
  libbirch_line_(169);
  #line 169 "src/math/primitive.birch"
  libbirch_assert_(birch::length(x, handler_) == birch::length(y, handler_));
  #line 170 "src/math/primitive.birch"
  libbirch_line_(170);
  #line 170 "src/math/primitive.birch"
  libbirch_assert_(birch::length(x, handler_) == birch::length(z, handler_));
  #line 171 "src/math/primitive.birch"
  libbirch_line_(171);
  #line 171 "src/math/primitive.birch"
  return birch::vector(std::function<Output(birch::type::Integer,const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_
)>([=](const birch::type::Integer& i, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr) {
    #line 172 "src/math/primitive.birch"
    libbirch_line_(172);
    #line 172 "src/math/primitive.birch"
    return f(x.get(libbirch::make_slice(i - 1)), y.get(libbirch::make_slice(i - 1)), z.get(libbirch::make_slice(i - 1)), handler_);
  }), birch::length(x, handler_), handler_);
}

#line 184 "src/math/primitive.birch"
template<class Input1,class Input2,class Input3,class Output>
#line 184 "src/math/primitive.birch"
libbirch::DefaultArray<Output,2> birch::transform(const libbirch::DefaultArray<Input1,2>& X, const libbirch::DefaultArray<Input2,2>& Y, const libbirch::DefaultArray<Input3,2>& Z, const std::function<Output(Input1, Input2, Input3, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>&)>& f, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_) {
  #line 184 "src/math/primitive.birch"
  libbirch_function_("transform", "src/math/primitive.birch", 184);
  #line 186 "src/math/primitive.birch"
  libbirch_line_(186);
  #line 186 "src/math/primitive.birch"
  libbirch_assert_(birch::rows(X, handler_) == birch::rows(Y, handler_));
  #line 187 "src/math/primitive.birch"
  libbirch_line_(187);
  #line 187 "src/math/primitive.birch"
  libbirch_assert_(birch::rows(X, handler_) == birch::rows(Z, handler_));
  #line 188 "src/math/primitive.birch"
  libbirch_line_(188);
  #line 188 "src/math/primitive.birch"
  libbirch_assert_(birch::columns(X, handler_) == birch::columns(Y, handler_));
  #line 189 "src/math/primitive.birch"
  libbirch_line_(189);
  #line 189 "src/math/primitive.birch"
  libbirch_assert_(birch::columns(Y, handler_) == birch::columns(Z, handler_));
  #line 190 "src/math/primitive.birch"
  libbirch_line_(190);
  #line 190 "src/math/primitive.birch"
  return birch::matrix(std::function<Output(birch::type::Integer,birch::type::Integer,const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_
)>([=](const birch::type::Integer& i, const birch::type::Integer& j, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr) {
    #line 191 "src/math/primitive.birch"
    libbirch_line_(191);
    #line 191 "src/math/primitive.birch"
    return f(X.get(libbirch::make_slice(i - 1, j - 1)), Y.get(libbirch::make_slice(i - 1, j - 1)), Z.get(libbirch::make_slice(i - 1, j - 1)), handler_);
  }), birch::rows(X, handler_), birch::columns(X, handler_), handler_);
}

#line 202 "src/math/primitive.birch"
template<class Type>
#line 202 "src/math/primitive.birch"
Type birch::reduce(const libbirch::DefaultArray<Type,1>& x, const Type& init, const std::function<Type(Type, Type, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>&)>& op, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_) {
  #line 202 "src/math/primitive.birch"
  libbirch_function_("reduce", "src/math/primitive.birch", 202);
  #line 204 "src/math/primitive.birch"
  libbirch_line_(204);
  #line 204 "src/math/primitive.birch"
  Type result;
  #line 205 "src/math/primitive.birch"

  x.pin();
  // result = return std::reduce(x.begin(), x.end(), init, op);
  // ^ C++17
  result = std::accumulate(x.begin(), x.end(), init,
      [&](auto x, auto y) { return op(x, y, handler_); });
  x.unpin();
  return result;
  }

#line 224 "src/math/primitive.birch"
template<class Input,class Output>
#line 224 "src/math/primitive.birch"
Output birch::transform_reduce(const libbirch::DefaultArray<Input,1>& x, const Output& init, const std::function<Output(Output, Output, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>&)>& op1, const std::function<Output(Input, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>&)>& op2, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_) {
  #line 224 "src/math/primitive.birch"
  libbirch_function_("transform_reduce", "src/math/primitive.birch", 224);
  #line 226 "src/math/primitive.birch"
  libbirch_line_(226);
  #line 226 "src/math/primitive.birch"
  auto y = init;
  #line 227 "src/math/primitive.birch"
  libbirch_line_(227);
  #line 227 "src/math/primitive.birch"
  for (auto n = birch::type::Integer(1); n <= birch::length(x, handler_); ++n) {
    #line 228 "src/math/primitive.birch"
    libbirch_line_(228);
    #line 228 "src/math/primitive.birch"
    y = op1(y, op2(x.get(libbirch::make_slice(n - 1)), handler_), handler_);
  }
  #line 230 "src/math/primitive.birch"
  libbirch_line_(230);
  #line 230 "src/math/primitive.birch"
  return y;
}

#line 242 "src/math/primitive.birch"
template<class Input1,class Input2,class Output>
#line 242 "src/math/primitive.birch"
Output birch::transform_reduce(const libbirch::DefaultArray<Input1,1>& x, const libbirch::DefaultArray<Input2,1>& y, const Output& init, const std::function<Output(Output, Output, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>&)>& op1, const std::function<Output(Input1, Input2, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>&)>& op2, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_) {
  #line 242 "src/math/primitive.birch"
  libbirch_function_("transform_reduce", "src/math/primitive.birch", 242);
  #line 245 "src/math/primitive.birch"
  libbirch_line_(245);
  #line 245 "src/math/primitive.birch"
  libbirch_assert_(birch::length(x, handler_) == birch::length(y, handler_));
  #line 246 "src/math/primitive.birch"
  libbirch_line_(246);
  #line 246 "src/math/primitive.birch"
  auto z = init;
  #line 247 "src/math/primitive.birch"
  libbirch_line_(247);
  #line 247 "src/math/primitive.birch"
  for (auto n = birch::type::Integer(1); n <= birch::length(x, handler_); ++n) {
    #line 248 "src/math/primitive.birch"
    libbirch_line_(248);
    #line 248 "src/math/primitive.birch"
    z = op1(z, op2(x.get(libbirch::make_slice(n - 1)), y.get(libbirch::make_slice(n - 1)), handler_), handler_);
  }
  #line 250 "src/math/primitive.birch"
  libbirch_line_(250);
  #line 250 "src/math/primitive.birch"
  return z;
}

#line 263 "src/math/primitive.birch"
template<class Input1,class Input2,class Input3,class Output>
#line 263 "src/math/primitive.birch"
Output birch::transform_reduce(const libbirch::DefaultArray<Input1,1>& x, const libbirch::DefaultArray<Input2,1>& y, const libbirch::DefaultArray<Input3,1>& z, const Output& init, const std::function<Output(Output, Output, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>&)>& op1, const std::function<Output(Input1, Input2, Input3, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>&)>& op2, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_) {
  #line 263 "src/math/primitive.birch"
  libbirch_function_("transform_reduce", "src/math/primitive.birch", 263);
  #line 266 "src/math/primitive.birch"
  libbirch_line_(266);
  #line 266 "src/math/primitive.birch"
  libbirch_assert_(birch::length(x, handler_) == birch::length(y, handler_));
  #line 267 "src/math/primitive.birch"
  libbirch_line_(267);
  #line 267 "src/math/primitive.birch"
  libbirch_assert_(birch::length(y, handler_) == birch::length(z, handler_));
  #line 268 "src/math/primitive.birch"
  libbirch_line_(268);
  #line 268 "src/math/primitive.birch"
  auto a = init;
  #line 269 "src/math/primitive.birch"
  libbirch_line_(269);
  #line 269 "src/math/primitive.birch"
  for (auto n = birch::type::Integer(1); n <= birch::length(x, handler_); ++n) {
    #line 270 "src/math/primitive.birch"
    libbirch_line_(270);
    #line 270 "src/math/primitive.birch"
    a = op1(a, op2(x.get(libbirch::make_slice(n - 1)), y.get(libbirch::make_slice(n - 1)), z.get(libbirch::make_slice(n - 1)), handler_), handler_);
  }
  #line 272 "src/math/primitive.birch"
  libbirch_line_(272);
  #line 272 "src/math/primitive.birch"
  return a;
}

#line 281 "src/math/primitive.birch"
template<class Type>
#line 281 "src/math/primitive.birch"
libbirch::DefaultArray<Type,1> birch::inclusive_scan(const libbirch::DefaultArray<Type,1>& x, const std::function<Type(Type, Type, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>&)>& op, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_) {
  #line 281 "src/math/primitive.birch"
  libbirch_function_("inclusive_scan", "src/math/primitive.birch", 281);
  #line 282 "src/math/primitive.birch"
  libbirch_line_(282);
  #line 282 "src/math/primitive.birch"
  libbirch::DefaultArray<Type,1> y(libbirch::make_shape(birch::length(x, handler_)));
  #line 283 "src/math/primitive.birch"

  x.pin();
  // std::inclusive_scan(x.begin(), x.end(), y.begin(), op);
  // ^ C++17
  std::partial_sum(x.begin(), x.end(), y.begin(),
      [&](auto x, auto y) { op(x, y, handler_); });
  x.unpin();
    #line 291 "src/math/primitive.birch"
  libbirch_line_(291);
  #line 291 "src/math/primitive.birch"
  return y;
}

#line 301 "src/math/primitive.birch"
template<class Type>
#line 301 "src/math/primitive.birch"
libbirch::DefaultArray<Type,1> birch::exclusive_scan(const libbirch::DefaultArray<Type,1>& x, const Type& init, const std::function<Type(Type, Type, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>&)>& op, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_) {
  #line 301 "src/math/primitive.birch"
  libbirch_function_("exclusive_scan", "src/math/primitive.birch", 301);
  #line 303 "src/math/primitive.birch"
  libbirch_line_(303);
  #line 303 "src/math/primitive.birch"
  libbirch_assert_(birch::length(x, handler_) > birch::type::Integer(0));
  #line 304 "src/math/primitive.birch"
  libbirch_line_(304);
  #line 304 "src/math/primitive.birch"
  libbirch::DefaultArray<Type,1> y(libbirch::make_shape(birch::length(x, handler_)));
  #line 309 "src/math/primitive.birch"
  libbirch_line_(309);
  #line 309 "src/math/primitive.birch"
  y.set(libbirch::make_slice(birch::type::Integer(1) - 1), init);
  #line 310 "src/math/primitive.birch"
  libbirch_line_(310);
  #line 310 "src/math/primitive.birch"
  for (auto i = birch::type::Integer(2); i <= birch::length(x, handler_); ++i) {
    #line 311 "src/math/primitive.birch"
    libbirch_line_(311);
    #line 311 "src/math/primitive.birch"
    y.set(libbirch::make_slice(i - 1), op(y.get(libbirch::make_slice(i - birch::type::Integer(1) - 1)), x.get(libbirch::make_slice(i - birch::type::Integer(1) - 1)), handler_));
  }
  #line 313 "src/math/primitive.birch"
  libbirch_line_(313);
  #line 313 "src/math/primitive.birch"
  return y;
}

#line 322 "src/math/primitive.birch"
template<class Type>
#line 322 "src/math/primitive.birch"
libbirch::DefaultArray<Type,1> birch::adjacent_difference(const libbirch::DefaultArray<Type,1>& x, const std::function<Type(Type, Type, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>&)>& op, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_) {
  #line 322 "src/math/primitive.birch"
  libbirch_function_("adjacent_difference", "src/math/primitive.birch", 322);
  #line 324 "src/math/primitive.birch"
  libbirch_line_(324);
  #line 324 "src/math/primitive.birch"
  libbirch::DefaultArray<Type,1> y(libbirch::make_shape(birch::length(x, handler_)));
  #line 325 "src/math/primitive.birch"

  x.pin();
  std::adjacent_difference(x.begin(), x.end(), y.begin(),
      [&](auto x, auto y) { return op(x, y, handler_); });
  x.unpin();
    #line 331 "src/math/primitive.birch"
  libbirch_line_(331);
  #line 331 "src/math/primitive.birch"
  return y;
}

#line 341 "src/math/primitive.birch"
template<class Type>
#line 341 "src/math/primitive.birch"
libbirch::DefaultArray<Type,1> birch::sort(const libbirch::DefaultArray<Type,1>& x, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_) {
  #line 341 "src/math/primitive.birch"
  libbirch_function_("sort", "src/math/primitive.birch", 341);
  #line 342 "src/math/primitive.birch"
  libbirch_line_(342);
  #line 342 "src/math/primitive.birch"
  auto y = x;
  #line 343 "src/math/primitive.birch"

  y.pinWrite();
  std::sort(y.begin(), y.end());
  y.unpin();
    #line 348 "src/math/primitive.birch"
  libbirch_line_(348);
  #line 348 "src/math/primitive.birch"
  return y;
}

#line 359 "src/math/primitive.birch"
template<class Type>
#line 359 "src/math/primitive.birch"
libbirch::DefaultArray<birch::type::Integer,1> birch::sort_index(const libbirch::DefaultArray<Type,1>& x, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_) {
  #line 359 "src/math/primitive.birch"
  libbirch_function_("sort_index", "src/math/primitive.birch", 359);
  #line 360 "src/math/primitive.birch"
  libbirch_line_(360);
  #line 360 "src/math/primitive.birch"
  auto a = birch::iota(birch::type::Integer(1), birch::length(x, handler_), handler_);
  #line 361 "src/math/primitive.birch"

  x.pin();
  std::sort(a.begin(), a.end(), [=](birch::type::Integer i, birch::type::Integer j) {
      return x(libbirch::make_slice(i - 1)) < x(libbirch::make_slice(j - 1));
    });
  x.unpin();
    #line 368 "src/math/primitive.birch"
  libbirch_line_(368);
  #line 368 "src/math/primitive.birch"
  return a;
}

#line 379 "src/math/primitive.birch"
template<class Type>
#line 379 "src/math/primitive.birch"
libbirch::DefaultArray<Type,1> birch::gather(const libbirch::DefaultArray<birch::type::Integer,1>& a, const libbirch::DefaultArray<Type,1>& x, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_) {
  #line 379 "src/math/primitive.birch"
  libbirch_function_("gather", "src/math/primitive.birch", 379);
  #line 380 "src/math/primitive.birch"
  libbirch_line_(380);
  #line 380 "src/math/primitive.birch"
  return birch::vector(std::function<Type(birch::type::Integer,const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_
)>([=](const birch::type::Integer& i, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr) {
    #line 380 "src/math/primitive.birch"
    libbirch_line_(380);
    #line 380 "src/math/primitive.birch"
    return x.get(libbirch::make_slice(a.get(libbirch::make_slice(i - 1)) - 1));
  }), birch::length(a, handler_), handler_);
}

#line 393 "src/math/primitive.birch"
template<class Type>
#line 393 "src/math/primitive.birch"
libbirch::DefaultArray<Type,1> birch::scatter(const libbirch::DefaultArray<birch::type::Integer,1>& a, const libbirch::DefaultArray<Type,1>& x, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_) {
  #line 393 "src/math/primitive.birch"
  libbirch_function_("scatter", "src/math/primitive.birch", 393);
  #line 394 "src/math/primitive.birch"
  libbirch_line_(394);
  #line 394 "src/math/primitive.birch"
  auto N = birch::length(a, handler_);
  #line 395 "src/math/primitive.birch"
  libbirch_line_(395);
  #line 395 "src/math/primitive.birch"
  libbirch::DefaultArray<Type,1> y(libbirch::make_shape(N));
  #line 396 "src/math/primitive.birch"
  libbirch_line_(396);
  #line 396 "src/math/primitive.birch"
  for (auto n = birch::type::Integer(1); n <= N; ++n) {
    #line 397 "src/math/primitive.birch"
    libbirch_line_(397);
    #line 397 "src/math/primitive.birch"
    y.set(libbirch::make_slice(a.get(libbirch::make_slice(n - 1)) - 1), x.get(libbirch::make_slice(n - 1)));
  }
  #line 399 "src/math/primitive.birch"
  libbirch_line_(399);
  #line 399 "src/math/primitive.birch"
  return y;
}

#line 312 "src/math/special.birch"
template<class Type>
#line 312 "src/math/special.birch"
Type birch::if_then_else(const birch::type::Boolean& cond, const Type& x, const Type& y, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_) {
  #line 312 "src/math/special.birch"
  libbirch_function_("if_then_else", "src/math/special.birch", 312);
  #line 313 "src/math/special.birch"
  libbirch_line_(313);
  #line 313 "src/math/special.birch"
  if (cond) {
    #line 314 "src/math/special.birch"
    libbirch_line_(314);
    #line 314 "src/math/special.birch"
    return x;
  } else {
    #line 316 "src/math/special.birch"
    libbirch_line_(316);
    #line 316 "src/math/special.birch"
    return y;
  }
}

#line 4 "src/math/vector.birch"
template<class Type>
#line 4 "src/math/vector.birch"
birch::type::Integer birch::length(const libbirch::DefaultArray<Type,1>& x, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_) {
  #line 4 "src/math/vector.birch"
  libbirch_function_("length", "src/math/vector.birch", 4);
  #line 5 "src/math/vector.birch"

  return x.rows();
  }

#line 13 "src/math/vector.birch"
template<class Type>
#line 13 "src/math/vector.birch"
birch::type::Integer birch::rows(const libbirch::DefaultArray<Type,1>& x, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_) {
  #line 13 "src/math/vector.birch"
  libbirch_function_("rows", "src/math/vector.birch", 13);
  #line 14 "src/math/vector.birch"

  return x.rows();
  }

#line 22 "src/math/vector.birch"
template<class Type>
#line 22 "src/math/vector.birch"
birch::type::Integer birch::columns(const libbirch::DefaultArray<Type,1>& x, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_) {
  #line 22 "src/math/vector.birch"
  libbirch_function_("columns", "src/math/vector.birch", 22);
  #line 23 "src/math/vector.birch"
  libbirch_line_(23);
  #line 23 "src/math/vector.birch"
  return birch::type::Integer(1);
}

#line 29 "src/math/vector.birch"
template<class Type>
#line 29 "src/math/vector.birch"
Type birch::scalar(const libbirch::DefaultArray<Type,1>& x, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_) {
  #line 29 "src/math/vector.birch"
  libbirch_function_("scalar", "src/math/vector.birch", 29);
  #line 30 "src/math/vector.birch"
  libbirch_line_(30);
  #line 30 "src/math/vector.birch"
  libbirch_assert_(birch::length(x, handler_) == birch::type::Integer(1));
  #line 31 "src/math/vector.birch"
  libbirch_line_(31);
  #line 31 "src/math/vector.birch"
  return x.get(libbirch::make_slice(birch::type::Integer(1) - 1));
}

#line 46 "src/math/vector.birch"
template<class Type>
#line 46 "src/math/vector.birch"
libbirch::DefaultArray<Type,1> birch::vector(const std::function<Type(birch::type::Integer, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>&)>& _u0955, const birch::type::Integer& length, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_) {
  #line 46 "src/math/vector.birch"
  libbirch_function_("vector", "src/math/vector.birch", 46);
  #line 47 "src/math/vector.birch"

  /* wrap _u0955 in another lambda function to translate 0-based indices into
   * 1-based indices */
  return libbirch::make_array_from_lambda<Type>(libbirch::make_shape(length),
        [&](int64_t i) { return _u0955(i + 1, handler_); });
  }

#line 58 "src/math/vector.birch"
template<class Type>
#line 58 "src/math/vector.birch"
libbirch::DefaultArray<Type,1> birch::vector(const Type& x, const birch::type::Integer& length, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_) {
  #line 58 "src/math/vector.birch"
  libbirch_function_("vector", "src/math/vector.birch", 58);
  #line 59 "src/math/vector.birch"

  return libbirch::make_array<Type>(libbirch::make_shape(length), x);
  }

#line 68 "src/math/vector.birch"
template<class Type>
#line 68 "src/math/vector.birch"
libbirch::DefaultArray<Type,1> birch::stack(const libbirch::DefaultArray<Type,1>& x, const libbirch::DefaultArray<Type,1>& y, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_) {
  #line 68 "src/math/vector.birch"
  libbirch_function_("stack", "src/math/vector.birch", 68);
  #line 69 "src/math/vector.birch"
  libbirch_line_(69);
  #line 69 "src/math/vector.birch"
  auto l1 = birch::length(x, handler_);
  #line 70 "src/math/vector.birch"
  libbirch_line_(70);
  #line 70 "src/math/vector.birch"
  auto l2 = birch::length(y, handler_);
  #line 71 "src/math/vector.birch"
  libbirch_line_(71);
  #line 71 "src/math/vector.birch"
  return birch::vector(std::function<Type(birch::type::Integer,const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_
)>([=](const birch::type::Integer& i, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr) {
    #line 72 "src/math/vector.birch"
    libbirch_line_(72);
    #line 72 "src/math/vector.birch"
    if (i <= l1) {
      #line 73 "src/math/vector.birch"
      libbirch_line_(73);
      #line 73 "src/math/vector.birch"
      return x.get(libbirch::make_slice(i - 1));
    } else {
      #line 75 "src/math/vector.birch"
      libbirch_line_(75);
      #line 75 "src/math/vector.birch"
      return y.get(libbirch::make_slice(i - 1));
    }
  }), l1 + l2, handler_);
}

#line 86 "src/math/vector.birch"
template<class Type>
#line 86 "src/math/vector.birch"
libbirch::DefaultArray<birch::type::Real,1> birch::iota(const Type& x, const birch::type::Integer& length, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_) {
  #line 86 "src/math/vector.birch"
  libbirch_function_("iota", "src/math/vector.birch", 86);
  #line 87 "src/math/vector.birch"
  libbirch_line_(87);
  #line 87 "src/math/vector.birch"
  return birch::vector(std::function<Type(birch::type::Integer,const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_
)>([=](const birch::type::Integer& i, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr) {
    #line 88 "src/math/vector.birch"
    libbirch_line_(88);
    #line 88 "src/math/vector.birch"
    return x + (i - birch::type::Integer(1));
  }), length, handler_);
}

#line 95 "src/math/vector.birch"
template<class Type>
#line 95 "src/math/vector.birch"
Type birch::sum(const libbirch::DefaultArray<Type,1>& x, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_) {
  #line 95 "src/math/vector.birch"
  libbirch_function_("sum", "src/math/vector.birch", 95);
  #line 96 "src/math/vector.birch"
  libbirch_line_(96);
  #line 96 "src/math/vector.birch"
  if (birch::length(x, handler_) == birch::type::Integer(0)) {
    #line 97 "src/math/vector.birch"
    libbirch_line_(97);
    #line 97 "src/math/vector.birch"
    return 0.0;
  } else {
    #line 98 "src/math/vector.birch"
    libbirch_line_(98);
    #line 98 "src/math/vector.birch"
    if (birch::length(x, handler_) == birch::type::Integer(1)) {
      #line 99 "src/math/vector.birch"
      libbirch_line_(99);
      #line 99 "src/math/vector.birch"
      return x.get(libbirch::make_slice(birch::type::Integer(1) - 1));
    } else {
      #line 101 "src/math/vector.birch"
      libbirch_line_(101);
      #line 101 "src/math/vector.birch"
      return birch::reduce(x.get(libbirch::make_slice(libbirch::make_range(birch::type::Integer(2) - 1, birch::length(x, handler_) - 1))), x.get(libbirch::make_slice(birch::type::Integer(1) - 1)), std::function<Type(Type,Type,const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_
)>([=](const Type& x, const Type& y, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr) {
        #line 102 "src/math/vector.birch"
        libbirch_line_(102);
        #line 102 "src/math/vector.birch"
        return x + y;
      }), handler_);
    }
  }
}

#line 110 "src/math/vector.birch"
template<class Type>
#line 110 "src/math/vector.birch"
Type birch::product(const libbirch::DefaultArray<Type,1>& x, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_) {
  #line 110 "src/math/vector.birch"
  libbirch_function_("product", "src/math/vector.birch", 110);
  #line 111 "src/math/vector.birch"
  libbirch_line_(111);
  #line 111 "src/math/vector.birch"
  libbirch_assert_(birch::length(x, handler_) > birch::type::Integer(0));
  #line 112 "src/math/vector.birch"
  libbirch_line_(112);
  #line 112 "src/math/vector.birch"
  if (birch::length(x, handler_) == birch::type::Integer(1)) {
    #line 113 "src/math/vector.birch"
    libbirch_line_(113);
    #line 113 "src/math/vector.birch"
    return x.get(libbirch::make_slice(birch::type::Integer(1) - 1));
  } else {
    #line 115 "src/math/vector.birch"
    libbirch_line_(115);
    #line 115 "src/math/vector.birch"
    return birch::reduce(x.get(libbirch::make_slice(libbirch::make_range(birch::type::Integer(2) - 1, birch::length(x, handler_) - 1))), x.get(libbirch::make_slice(birch::type::Integer(1) - 1)), std::function<Type(Type,Type,const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_
)>([=](const Type& x, const Type& y, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr) {
      #line 116 "src/math/vector.birch"
      libbirch_line_(116);
      #line 116 "src/math/vector.birch"
      return x * y;
    }), handler_);
  }
}

#line 124 "src/math/vector.birch"
template<class Type>
#line 124 "src/math/vector.birch"
Type birch::max(const libbirch::DefaultArray<Type,1>& x, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_) {
  #line 124 "src/math/vector.birch"
  libbirch_function_("max", "src/math/vector.birch", 124);
  #line 125 "src/math/vector.birch"
  libbirch_line_(125);
  #line 125 "src/math/vector.birch"
  libbirch_assert_(birch::length(x, handler_) > birch::type::Integer(0));
  #line 126 "src/math/vector.birch"
  libbirch_line_(126);
  #line 126 "src/math/vector.birch"
  if (birch::length(x, handler_) == birch::type::Integer(1)) {
    #line 127 "src/math/vector.birch"
    libbirch_line_(127);
    #line 127 "src/math/vector.birch"
    return x.get(libbirch::make_slice(birch::type::Integer(1) - 1));
  } else {
    #line 129 "src/math/vector.birch"
    libbirch_line_(129);
    #line 129 "src/math/vector.birch"
    return birch::reduce(x.get(libbirch::make_slice(libbirch::make_range(birch::type::Integer(2) - 1, birch::length(x, handler_) - 1))), x.get(libbirch::make_slice(birch::type::Integer(1) - 1)), std::function<Type(Type,Type,const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_
)>([=](const Type& x, const Type& y, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr) {
      #line 130 "src/math/vector.birch"
      libbirch_line_(130);
      #line 130 "src/math/vector.birch"
      return birch::max(x, y, handler_);
    }), handler_);
  }
}

#line 138 "src/math/vector.birch"
template<class Type>
#line 138 "src/math/vector.birch"
Type birch::min(const libbirch::DefaultArray<Type,1>& x, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_) {
  #line 138 "src/math/vector.birch"
  libbirch_function_("min", "src/math/vector.birch", 138);
  #line 139 "src/math/vector.birch"
  libbirch_line_(139);
  #line 139 "src/math/vector.birch"
  libbirch_assert_(birch::length(x, handler_) > birch::type::Integer(0));
  #line 140 "src/math/vector.birch"
  libbirch_line_(140);
  #line 140 "src/math/vector.birch"
  if (birch::length(x, handler_) == birch::type::Integer(1)) {
    #line 141 "src/math/vector.birch"
    libbirch_line_(141);
    #line 141 "src/math/vector.birch"
    return x.get(libbirch::make_slice(birch::type::Integer(1) - 1));
  } else {
    #line 143 "src/math/vector.birch"
    libbirch_line_(143);
    #line 143 "src/math/vector.birch"
    return birch::reduce(x.get(libbirch::make_slice(libbirch::make_range(birch::type::Integer(2) - 1, birch::length(x, handler_) - 1))), x.get(libbirch::make_slice(birch::type::Integer(1) - 1)), std::function<Type(Type,Type,const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_
)>([=](const Type& x, const Type& y, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr) {
      #line 144 "src/math/vector.birch"
      libbirch_line_(144);
      #line 144 "src/math/vector.birch"
      return birch::min(x, y, handler_);
    }), handler_);
  }
}

#line 152 "src/math/vector.birch"
template<class Type>
#line 152 "src/math/vector.birch"
libbirch::DefaultArray<Type,1> birch::inclusive_scan_sum(const libbirch::DefaultArray<Type,1>& x, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_) {
  #line 152 "src/math/vector.birch"
  libbirch_function_("inclusive_scan_sum", "src/math/vector.birch", 152);
  #line 153 "src/math/vector.birch"
  libbirch_line_(153);
  #line 153 "src/math/vector.birch"
  return birch::inclusive_scan(x, std::function<Type(Type,Type,const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_
)>([=](const Type& x, const Type& y, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr) {
    #line 153 "src/math/vector.birch"
    libbirch_line_(153);
    #line 153 "src/math/vector.birch"
    return x + y;
  }), handler_);
}

#line 159 "src/math/vector.birch"
template<class Type>
#line 159 "src/math/vector.birch"
libbirch::DefaultArray<Type,1> birch::exclusive_scan_sum(const libbirch::DefaultArray<Type,1>& x, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_) {
  #line 159 "src/math/vector.birch"
  libbirch_function_("exclusive_scan_sum", "src/math/vector.birch", 159);
  #line 160 "src/math/vector.birch"
  libbirch_line_(160);
  #line 160 "src/math/vector.birch"
  return birch::exclusive_scan(x, 0.0, std::function<Type(Type,Type,const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_
)>([=](const Type& x, const Type& y, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr) {
    #line 161 "src/math/vector.birch"
    libbirch_line_(161);
    #line 161 "src/math/vector.birch"
    return x + y;
  }), handler_);
}

#line 168 "src/math/vector.birch"
template<class Type>
#line 168 "src/math/vector.birch"
libbirch::DefaultArray<birch::type::Boolean,1> birch::Boolean(const libbirch::DefaultArray<Type,1>& x, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_) {
  #line 168 "src/math/vector.birch"
  libbirch_function_("Boolean", "src/math/vector.birch", 168);
  #line 169 "src/math/vector.birch"
  libbirch_line_(169);
  #line 169 "src/math/vector.birch"
  return birch::vector(std::function<birch::type::Boolean(birch::type::Integer,const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_
)>([=](const birch::type::Integer& i, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr) {
    #line 170 "src/math/vector.birch"
    libbirch_line_(170);
    #line 170 "src/math/vector.birch"
    return birch::Boolean(x.get(libbirch::make_slice(i - 1)), handler_);
  }), birch::length(x, handler_), handler_);
}

#line 177 "src/math/vector.birch"
template<class Type>
#line 177 "src/math/vector.birch"
libbirch::DefaultArray<birch::type::Integer,1> birch::Integer(const libbirch::DefaultArray<Type,1>& x, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_) {
  #line 177 "src/math/vector.birch"
  libbirch_function_("Integer", "src/math/vector.birch", 177);
  #line 178 "src/math/vector.birch"
  libbirch_line_(178);
  #line 178 "src/math/vector.birch"
  return birch::vector(std::function<birch::type::Integer(birch::type::Integer,const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_
)>([=](const birch::type::Integer& i, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr) {
    #line 179 "src/math/vector.birch"
    libbirch_line_(179);
    #line 179 "src/math/vector.birch"
    return birch::Integer(x.get(libbirch::make_slice(i - 1)), handler_);
  }), birch::length(x, handler_), handler_);
}

#line 186 "src/math/vector.birch"
template<class Type>
#line 186 "src/math/vector.birch"
libbirch::DefaultArray<birch::type::Real,1> birch::Real(const libbirch::DefaultArray<Type,1>& x, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_) {
  #line 186 "src/math/vector.birch"
  libbirch_function_("Real", "src/math/vector.birch", 186);
  #line 187 "src/math/vector.birch"
  libbirch_line_(187);
  #line 187 "src/math/vector.birch"
  return birch::vector(std::function<birch::type::Real(birch::type::Integer,const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_
)>([=](const birch::type::Integer& i, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_ = nullptr) {
    #line 188 "src/math/vector.birch"
    libbirch_line_(188);
    #line 188 "src/math/vector.birch"
    return birch::Real(x.get(libbirch::make_slice(i - 1)), handler_);
  }), birch::length(x, handler_), handler_);
}

#line 16 "src/record/AssumeRecord.birch"
template<class Value>
#line 16 "src/record/AssumeRecord.birch"
libbirch::Lazy<libbirch::Shared<birch::type::AssumeRecord<Value>>> birch::AssumeRecord(const libbirch::Lazy<libbirch::Shared<birch::type::Random<Value>>>& v, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_) {
  #line 16 "src/record/AssumeRecord.birch"
  libbirch_function_("AssumeRecord", "src/record/AssumeRecord.birch", 16);
  #line 17 "src/record/AssumeRecord.birch"
  libbirch_line_(17);
  #line 17 "src/record/AssumeRecord.birch"
  return birch::construct<libbirch::Lazy<libbirch::Shared<birch::type::AssumeRecord<Value>>>>(v, handler_);
}

#line 16 "src/record/ObserveRecord.birch"
template<class Value>
#line 16 "src/record/ObserveRecord.birch"
libbirch::Lazy<libbirch::Shared<birch::type::ObserveRecord<Value>>> birch::ObserveRecord(const Value& x, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_) {
  #line 16 "src/record/ObserveRecord.birch"
  libbirch_function_("ObserveRecord", "src/record/ObserveRecord.birch", 16);
  #line 17 "src/record/ObserveRecord.birch"
  libbirch_line_(17);
  #line 17 "src/record/ObserveRecord.birch"
  return birch::construct<libbirch::Lazy<libbirch::Shared<birch::type::ObserveRecord<Value>>>>(x, handler_);
}

#line 16 "src/record/SimulateRecord.birch"
template<class Value>
#line 16 "src/record/SimulateRecord.birch"
libbirch::Lazy<libbirch::Shared<birch::type::SimulateRecord<Value>>> birch::SimulateRecord(const Value& v, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_) {
  #line 16 "src/record/SimulateRecord.birch"
  libbirch_function_("SimulateRecord", "src/record/SimulateRecord.birch", 16);
  #line 17 "src/record/SimulateRecord.birch"
  libbirch_line_(17);
  #line 17 "src/record/SimulateRecord.birch"
  return birch::construct<libbirch::Lazy<libbirch::Shared<birch::type::SimulateRecord<Value>>>>(v, handler_);
}

#line 9 "src/test/test_conjugacy.birch"
template<class Conjugate>
#line 9 "src/test/test_conjugacy.birch"
void birch::test_conjugacy(const Conjugate& m, const birch::type::Integer& N, const birch::type::Integer& D, const birch::type::Boolean& lazy, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_) {
  #line 9 "src/test/test_conjugacy.birch"
  libbirch_function_("test_conjugacy", "src/test/test_conjugacy.birch", 9);
  #line 10 "src/test/test_conjugacy.birch"
  libbirch_line_(10);
  #line 10 "src/test/test_conjugacy.birch"
  auto forward = birch::PlayHandler(false, handler_);
  #line 11 "src/test/test_conjugacy.birch"
  libbirch_line_(11);
  #line 11 "src/test/test_conjugacy.birch"
  auto backward = birch::PlayHandler(true, handler_);
  #line 12 "src/test/test_conjugacy.birch"
  libbirch_line_(12);
  #line 12 "src/test/test_conjugacy.birch"
  m->initialize(handler_);
  #line 15 "src/test/test_conjugacy.birch"
  libbirch_line_(15);
  #line 15 "src/test/test_conjugacy.birch"
  libbirch::DefaultArray<birch::type::Real,2> X1(libbirch::make_shape(N, D));
  #line 16 "src/test/test_conjugacy.birch"
  libbirch_line_(16);
  #line 16 "src/test/test_conjugacy.birch"
  for (auto n = birch::type::Integer(1); n <= N; ++n) {
    #line 17 "src/test/test_conjugacy.birch"
    libbirch_line_(17);
    #line 17 "src/test/test_conjugacy.birch"
    auto m_prime_ = birch::clone(m, handler_);
    #line 18 "src/test/test_conjugacy.birch"
    libbirch_line_(18);
    #line 18 "src/test/test_conjugacy.birch"
    {
      auto handler_ = forward;
      #line 19 "src/test/test_conjugacy.birch"
      libbirch_line_(19);
      #line 19 "src/test/test_conjugacy.birch"
      m_prime_->simulate(handler_);
    }
    #line 21 "src/test/test_conjugacy.birch"
    libbirch_line_(21);
    #line 21 "src/test/test_conjugacy.birch"
    if (lazy) {
      #line 22 "src/test/test_conjugacy.birch"
      libbirch_line_(22);
      #line 22 "src/test/test_conjugacy.birch"
      X1.set(libbirch::make_slice(n - 1, libbirch::make_range(birch::type::Integer(1) - 1, D - 1)), m_prime_->forwardLazy(handler_));
    } else {
      #line 24 "src/test/test_conjugacy.birch"
      libbirch_line_(24);
      #line 24 "src/test/test_conjugacy.birch"
      X1.set(libbirch::make_slice(n - 1, libbirch::make_range(birch::type::Integer(1) - 1, D - 1)), m_prime_->forward(handler_));
    }
    #line 26 "src/test/test_conjugacy.birch"
    libbirch_line_(26);
    #line 26 "src/test/test_conjugacy.birch"
    if (birch::mod(n, birch::type::Integer(10000), handler_) == birch::type::Integer(0)) {
      #line 27 "src/test/test_conjugacy.birch"
      libbirch_line_(27);
      #line 27 "src/test/test_conjugacy.birch"
      birch::collect(handler_);
    }
  }
  #line 32 "src/test/test_conjugacy.birch"
  libbirch_line_(32);
  #line 32 "src/test/test_conjugacy.birch"
  libbirch::DefaultArray<birch::type::Real,2> X2(libbirch::make_shape(N, D));
  #line 33 "src/test/test_conjugacy.birch"
  libbirch_line_(33);
  #line 33 "src/test/test_conjugacy.birch"
  for (auto n = birch::type::Integer(1); n <= N; ++n) {
    #line 34 "src/test/test_conjugacy.birch"
    libbirch_line_(34);
    #line 34 "src/test/test_conjugacy.birch"
    auto m_prime_ = birch::clone(m, handler_);
    #line 35 "src/test/test_conjugacy.birch"
    libbirch_line_(35);
    #line 35 "src/test/test_conjugacy.birch"
    {
      auto handler_ = backward;
      #line 36 "src/test/test_conjugacy.birch"
      libbirch_line_(36);
      #line 36 "src/test/test_conjugacy.birch"
      m_prime_->simulate(handler_);
    }
    #line 38 "src/test/test_conjugacy.birch"
    libbirch_line_(38);
    #line 38 "src/test/test_conjugacy.birch"
    if (lazy) {
      #line 39 "src/test/test_conjugacy.birch"
      libbirch_line_(39);
      #line 39 "src/test/test_conjugacy.birch"
      X2.set(libbirch::make_slice(n - 1, libbirch::make_range(birch::type::Integer(1) - 1, D - 1)), m_prime_->backwardLazy(handler_));
    } else {
      #line 41 "src/test/test_conjugacy.birch"
      libbirch_line_(41);
      #line 41 "src/test/test_conjugacy.birch"
      X2.set(libbirch::make_slice(n - 1, libbirch::make_range(birch::type::Integer(1) - 1, D - 1)), m_prime_->backward(handler_));
    }
    #line 43 "src/test/test_conjugacy.birch"
    libbirch_line_(43);
    #line 43 "src/test/test_conjugacy.birch"
    if (birch::mod(n, birch::type::Integer(10000), handler_) == birch::type::Integer(0)) {
      #line 44 "src/test/test_conjugacy.birch"
      libbirch_line_(44);
      #line 44 "src/test/test_conjugacy.birch"
      birch::collect(handler_);
    }
  }
  #line 49 "src/test/test_conjugacy.birch"
  libbirch_line_(49);
  #line 49 "src/test/test_conjugacy.birch"
  if (!birch::pass(X1, X2, handler_)) {
    #line 50 "src/test/test_conjugacy.birch"
    libbirch_line_(50);
    #line 50 "src/test/test_conjugacy.birch"
    birch::exit(birch::type::Integer(1), handler_);
  }
}

#line 53 "src/transform/TransformDot.birch"
template<class Value>
#line 53 "src/transform/TransformDot.birch"
libbirch::Lazy<libbirch::Shared<birch::type::TransformDot<Value>>> birch::TransformDot(const libbirch::Lazy<libbirch::Shared<birch::type::Expression<libbirch::DefaultArray<birch::type::Real,1>>>>& a, const Value& x, const libbirch::Lazy<libbirch::Shared<birch::type::Expression<birch::type::Real>>>& c, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_) {
  #line 53 "src/transform/TransformDot.birch"
  libbirch_function_("TransformDot", "src/transform/TransformDot.birch", 53);
  #line 55 "src/transform/TransformDot.birch"
  libbirch_line_(55);
  #line 55 "src/transform/TransformDot.birch"
  return birch::construct<libbirch::Lazy<libbirch::Shared<birch::type::TransformDot<Value>>>>(a, x, c, handler_);
}

#line 58 "src/transform/TransformDot.birch"
template<class Value>
#line 58 "src/transform/TransformDot.birch"
libbirch::Lazy<libbirch::Shared<birch::type::TransformDot<Value>>> birch::TransformDot(const libbirch::Lazy<libbirch::Shared<birch::type::Expression<libbirch::DefaultArray<birch::type::Real,1>>>>& a, const Value& x, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_) {
  #line 58 "src/transform/TransformDot.birch"
  libbirch_function_("TransformDot", "src/transform/TransformDot.birch", 58);
  #line 60 "src/transform/TransformDot.birch"
  libbirch_line_(60);
  #line 60 "src/transform/TransformDot.birch"
  return birch::TransformDot<Value>(a, x, birch::box(0.0, handler_), handler_);
}

#line 53 "src/transform/TransformDotMultivariate.birch"
template<class Value>
#line 53 "src/transform/TransformDotMultivariate.birch"
libbirch::Lazy<libbirch::Shared<birch::type::TransformDotMultivariate<Value>>> birch::TransformDotMultivariate(const libbirch::Lazy<libbirch::Shared<birch::type::Expression<libbirch::DefaultArray<birch::type::Real,1>>>>& a, const Value& X, const libbirch::Lazy<libbirch::Shared<birch::type::Expression<libbirch::DefaultArray<birch::type::Real,1>>>>& c, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_) {
  #line 53 "src/transform/TransformDotMultivariate.birch"
  libbirch_function_("TransformDotMultivariate", "src/transform/TransformDotMultivariate.birch", 53);
  #line 55 "src/transform/TransformDotMultivariate.birch"
  libbirch_line_(55);
  #line 55 "src/transform/TransformDotMultivariate.birch"
  return birch::construct<libbirch::Lazy<libbirch::Shared<birch::type::TransformDotMultivariate<Value>>>>(a, X, c, handler_);
}

#line 58 "src/transform/TransformDotMultivariate.birch"
template<class Value>
#line 58 "src/transform/TransformDotMultivariate.birch"
libbirch::Lazy<libbirch::Shared<birch::type::TransformDotMultivariate<Value>>> birch::TransformDotMultivariate(const libbirch::Lazy<libbirch::Shared<birch::type::Expression<libbirch::DefaultArray<birch::type::Real,1>>>>& a, const Value& X, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_) {
  #line 58 "src/transform/TransformDotMultivariate.birch"
  libbirch_function_("TransformDotMultivariate", "src/transform/TransformDotMultivariate.birch", 58);
  #line 60 "src/transform/TransformDotMultivariate.birch"
  libbirch_line_(60);
  #line 60 "src/transform/TransformDotMultivariate.birch"
  return birch::TransformDotMultivariate<Value>(a, X, birch::box(birch::vector(0.0, X->columns(handler_), handler_), handler_), handler_);
}

#line 53 "src/transform/TransformLinear.birch"
template<class Value>
#line 53 "src/transform/TransformLinear.birch"
libbirch::Lazy<libbirch::Shared<birch::type::TransformLinear<Value>>> birch::TransformLinear(const libbirch::Lazy<libbirch::Shared<birch::type::Expression<birch::type::Real>>>& a, const Value& x, const libbirch::Lazy<libbirch::Shared<birch::type::Expression<birch::type::Real>>>& c, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_) {
  #line 53 "src/transform/TransformLinear.birch"
  libbirch_function_("TransformLinear", "src/transform/TransformLinear.birch", 53);
  #line 55 "src/transform/TransformLinear.birch"
  libbirch_line_(55);
  #line 55 "src/transform/TransformLinear.birch"
  return birch::construct<libbirch::Lazy<libbirch::Shared<birch::type::TransformLinear<Value>>>>(a, x, c, handler_);
}

#line 58 "src/transform/TransformLinear.birch"
template<class Value>
#line 58 "src/transform/TransformLinear.birch"
libbirch::Lazy<libbirch::Shared<birch::type::TransformLinear<Value>>> birch::TransformLinear(const libbirch::Lazy<libbirch::Shared<birch::type::Expression<birch::type::Real>>>& a, const Value& x, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_) {
  #line 58 "src/transform/TransformLinear.birch"
  libbirch_function_("TransformLinear", "src/transform/TransformLinear.birch", 58);
  #line 60 "src/transform/TransformLinear.birch"
  libbirch_line_(60);
  #line 60 "src/transform/TransformLinear.birch"
  return birch::TransformLinear<Value>(a, x, birch::box(0.0, handler_), handler_);
}

#line 71 "src/transform/TransformLinearMatrix.birch"
template<class Value>
#line 71 "src/transform/TransformLinearMatrix.birch"
libbirch::Lazy<libbirch::Shared<birch::type::TransformLinearMatrix<Value>>> birch::TransformLinearMatrix(const libbirch::Lazy<libbirch::Shared<birch::type::Expression<libbirch::DefaultArray<birch::type::Real,2>>>>& A, const Value& X, const libbirch::Lazy<libbirch::Shared<birch::type::Expression<libbirch::DefaultArray<birch::type::Real,2>>>>& C, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_) {
  #line 71 "src/transform/TransformLinearMatrix.birch"
  libbirch_function_("TransformLinearMatrix", "src/transform/TransformLinearMatrix.birch", 71);
  #line 73 "src/transform/TransformLinearMatrix.birch"
  libbirch_line_(73);
  #line 73 "src/transform/TransformLinearMatrix.birch"
  return birch::construct<libbirch::Lazy<libbirch::Shared<birch::type::TransformLinearMatrix<Value>>>>(A, X, C, handler_);
}

#line 76 "src/transform/TransformLinearMatrix.birch"
template<class Value>
#line 76 "src/transform/TransformLinearMatrix.birch"
libbirch::Lazy<libbirch::Shared<birch::type::TransformLinearMatrix<Value>>> birch::TransformLinearMatrix(const libbirch::Lazy<libbirch::Shared<birch::type::Expression<libbirch::DefaultArray<birch::type::Real,2>>>>& A, const Value& X, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_) {
  #line 76 "src/transform/TransformLinearMatrix.birch"
  libbirch_function_("TransformLinearMatrix", "src/transform/TransformLinearMatrix.birch", 76);
  #line 78 "src/transform/TransformLinearMatrix.birch"
  libbirch_line_(78);
  #line 78 "src/transform/TransformLinearMatrix.birch"
  return birch::TransformLinearMatrix<Value>(A, X, birch::box(birch::matrix(0.0, A->rows(handler_), X->columns(handler_), handler_), handler_), handler_);
}

#line 67 "src/transform/TransformLinearMultivariate.birch"
template<class Value>
#line 67 "src/transform/TransformLinearMultivariate.birch"
libbirch::Lazy<libbirch::Shared<birch::type::TransformLinearMultivariate<Value>>> birch::TransformLinearMultivariate(const libbirch::Lazy<libbirch::Shared<birch::type::Expression<libbirch::DefaultArray<birch::type::Real,2>>>>& A, const Value& x, const libbirch::Lazy<libbirch::Shared<birch::type::Expression<libbirch::DefaultArray<birch::type::Real,1>>>>& c, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_) {
  #line 67 "src/transform/TransformLinearMultivariate.birch"
  libbirch_function_("TransformLinearMultivariate", "src/transform/TransformLinearMultivariate.birch", 67);
  #line 70 "src/transform/TransformLinearMultivariate.birch"
  libbirch_line_(70);
  #line 70 "src/transform/TransformLinearMultivariate.birch"
  return birch::construct<libbirch::Lazy<libbirch::Shared<birch::type::TransformLinearMultivariate<Value>>>>(A, x, c, handler_);
}

#line 73 "src/transform/TransformLinearMultivariate.birch"
template<class Value>
#line 73 "src/transform/TransformLinearMultivariate.birch"
libbirch::Lazy<libbirch::Shared<birch::type::TransformLinearMultivariate<Value>>> birch::TransformLinearMultivariate(const libbirch::Lazy<libbirch::Shared<birch::type::Expression<libbirch::DefaultArray<birch::type::Real,2>>>>& A, const Value& x, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_) {
  #line 73 "src/transform/TransformLinearMultivariate.birch"
  libbirch_function_("TransformLinearMultivariate", "src/transform/TransformLinearMultivariate.birch", 73);
  #line 75 "src/transform/TransformLinearMultivariate.birch"
  libbirch_line_(75);
  #line 75 "src/transform/TransformLinearMultivariate.birch"
  return birch::TransformLinearMultivariate<Value>(A, x, birch::box(birch::vector(0.0, A->rows(handler_), handler_), handler_), handler_);
}

#line 4 "src/utility/clone.birch"
template<class Type>
#line 4 "src/utility/clone.birch"
Type birch::clone(const Type& o, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_) {
  #line 4 "src/utility/clone.birch"
  libbirch_function_("clone", "src/utility/clone.birch", 4);
  #line 5 "src/utility/clone.birch"

  return libbirch::clone(o);
  }

#line 15 "src/utility/clone.birch"
template<class Type>
#line 15 "src/utility/clone.birch"
libbirch::DefaultArray<Type,1> birch::clone(const libbirch::DefaultArray<Type,1>& o, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_) {
  #line 15 "src/utility/clone.birch"
  libbirch_function_("clone", "src/utility/clone.birch", 15);
  #line 20 "src/utility/clone.birch"

  auto l = [&](int64_t n) {
      return libbirch::clone(o.get(libbirch::make_slice(n)));
    };
  return libbirch::make_array_from_lambda<Type>(
      libbirch::make_shape(length(o)), l);
  }

#line 35 "src/utility/clone.birch"
template<class Type>
#line 35 "src/utility/clone.birch"
libbirch::DefaultArray<Type,1> birch::clone(const Type& o, const birch::type::Integer& length, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_) {
  #line 35 "src/utility/clone.birch"
  libbirch_function_("clone", "src/utility/clone.birch", 35);
  #line 40 "src/utility/clone.birch"

  auto l = [&](int64_t n) {
      return libbirch::clone(o);
    };
  return libbirch::make_array_from_lambda<Type>(
      libbirch::make_shape(length), l);
  }

#line 10 "src/utility/construct.birch"
template<class Type>
#line 10 "src/utility/construct.birch"
Type birch::construct(const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_) {
  #line 10 "src/utility/construct.birch"
  libbirch_function_("construct", "src/utility/construct.birch", 10);
  #line 11 "src/utility/construct.birch"

  return libbirch::make_pointer<Type>();
  }

#line 25 "src/utility/construct.birch"
template<class Type,class Arg1>
#line 25 "src/utility/construct.birch"
Type birch::construct(const Arg1& arg1, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_) {
  #line 25 "src/utility/construct.birch"
  libbirch_function_("construct", "src/utility/construct.birch", 25);
  #line 26 "src/utility/construct.birch"

  return libbirch::make_pointer<Type>(arg1);
  }

#line 40 "src/utility/construct.birch"
template<class Type,class Arg1,class Arg2>
#line 40 "src/utility/construct.birch"
Type birch::construct(const Arg1& arg1, const Arg2& arg2, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_) {
  #line 40 "src/utility/construct.birch"
  libbirch_function_("construct", "src/utility/construct.birch", 40);
  #line 41 "src/utility/construct.birch"

  return libbirch::make_pointer<Type>(arg1, arg2);
  }

#line 55 "src/utility/construct.birch"
template<class Type,class Arg1,class Arg2,class Arg3>
#line 55 "src/utility/construct.birch"
Type birch::construct(const Arg1& arg1, const Arg2& arg2, const Arg3& arg3, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_) {
  #line 55 "src/utility/construct.birch"
  libbirch_function_("construct", "src/utility/construct.birch", 55);
  #line 57 "src/utility/construct.birch"

  return libbirch::make_pointer<Type>(arg1, arg2, arg3);
  }

#line 71 "src/utility/construct.birch"
template<class Type,class Arg1,class Arg2,class Arg3,class Arg4>
#line 71 "src/utility/construct.birch"
Type birch::construct(const Arg1& arg1, const Arg2& arg2, const Arg3& arg3, const Arg4& arg4, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_) {
  #line 71 "src/utility/construct.birch"
  libbirch_function_("construct", "src/utility/construct.birch", 71);
  #line 73 "src/utility/construct.birch"

  return libbirch::make_pointer<Type>(arg1, arg2, arg3, arg4);
  }

#line 87 "src/utility/construct.birch"
template<class Type,class Arg1,class Arg2,class Arg3,class Arg4,class Arg5>
#line 87 "src/utility/construct.birch"
Type birch::construct(const Arg1& arg1, const Arg2& arg2, const Arg3& arg3, const Arg4& arg4, const Arg5& arg5, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_) {
  #line 87 "src/utility/construct.birch"
  libbirch_function_("construct", "src/utility/construct.birch", 87);
  #line 89 "src/utility/construct.birch"

  return libbirch::make_pointer<Type>(arg1, arg2, arg3, arg4, arg5);
  }

#line 103 "src/utility/construct.birch"
template<class Type,class Arg1,class Arg2,class Arg3,class Arg4,class Arg5,class Arg6>
#line 103 "src/utility/construct.birch"
Type birch::construct(const Arg1& arg1, const Arg2& arg2, const Arg3& arg3, const Arg4& arg4, const Arg5& arg5, const Arg6& arg6, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_) {
  #line 103 "src/utility/construct.birch"
  libbirch_function_("construct", "src/utility/construct.birch", 103);
  #line 105 "src/utility/construct.birch"

  return libbirch::make_pointer<Type>(arg1, arg2, arg3, arg4, arg5, arg6);
  }

#line 119 "src/utility/construct.birch"
template<class Type,class Arg1,class Arg2,class Arg3,class Arg4,class Arg5,class Arg6,class Arg7>
#line 119 "src/utility/construct.birch"
Type birch::construct(const Arg1& arg1, const Arg2& arg2, const Arg3& arg3, const Arg4& arg4, const Arg5& arg5, const Arg6& arg6, const Arg7& arg7, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_) {
  #line 119 "src/utility/construct.birch"
  libbirch_function_("construct", "src/utility/construct.birch", 119);
  #line 122 "src/utility/construct.birch"

  return libbirch::make_pointer<Type>(arg1, arg2, arg3, arg4, arg5, arg6,
      arg7);
  }

#line 137 "src/utility/construct.birch"
template<class Type,class Arg1,class Arg2,class Arg3,class Arg4,class Arg5,class Arg6,class Arg7,class Arg8>
#line 137 "src/utility/construct.birch"
Type birch::construct(const Arg1& arg1, const Arg2& arg2, const Arg3& arg3, const Arg4& arg4, const Arg5& arg5, const Arg6& arg6, const Arg7& arg7, const Arg8& arg8, const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_) {
  #line 137 "src/utility/construct.birch"
  libbirch_function_("construct", "src/utility/construct.birch", 137);
  #line 140 "src/utility/construct.birch"

  return libbirch::make_pointer<Type>(arg1, arg2, arg3, arg4, arg5, arg6,
      arg7, arg8);
  }

#line 12 "src/utility/make.birch"
template<class Type>
#line 12 "src/utility/make.birch"
libbirch::Optional<Type> birch::make(const libbirch::Lazy<libbirch::Shared<birch::type::Handler>>& handler_) {
  #line 12 "src/utility/make.birch"
  libbirch_function_("make", "src/utility/make.birch", 12);
  #line 13 "src/utility/make.birch"

  return libbirch::make<Type>();
  }

#endif
